prompt --application/set_environment
set define off verify off feedback off
whenever sqlerror exit sql.sqlcode rollback
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_050100 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2016.08.24'
,p_release=>'5.1.4.00.08'
,p_default_workspace_id=>2842970987618181
,p_default_application_id=>600
,p_default_owner=>'APEX_PLUGIN'
);
end;
/
prompt --application/shared_components/plugins/region_type/de_danielh_dropzone2
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(136310961796859786)
,p_plugin_type=>'REGION TYPE'
,p_name=>'DE.DANIELH.DROPZONE2'
,p_display_name=>'Dropzone 2'
,p_supported_ui_types=>'DESKTOP'
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#PLUGIN_FILES#js/dropzone#MIN#.js',
'#PLUGIN_FILES#js/apexdropzone#MIN#.js'))
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#PLUGIN_FILES#css/dropzone#MIN#.css',
'#PLUGIN_FILES#css/apexdropzone#MIN#.css'))
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*-------------------------------------',
' * Dropzone APEX Plugin',
' * Version: 2.4.1 (01.08.2018)',
' * Author:  Daniel Hochleitner',
' *-------------------------------------',
'*/',
'FUNCTION render_dropzone(p_region              IN apex_plugin.t_region,',
'                         p_plugin              IN apex_plugin.t_plugin,',
'                         p_is_printer_friendly IN BOOLEAN)',
'  RETURN apex_plugin.t_region_render_result IS',
'  --',
'  l_result apex_plugin.t_region_render_result;',
'  -- region attributes',
'  l_dz_style              p_region.attribute_07%TYPE := p_region.attribute_07;',
'  l_width                 p_region.attribute_08%TYPE := p_region.attribute_08;',
'  l_height                p_region.attribute_09%TYPE := p_region.attribute_09;',
'  l_max_filesize          NUMBER := p_region.attribute_10;',
'  l_max_files             NUMBER := p_region.attribute_11;',
'  l_accepted_files        p_region.attribute_13%TYPE := p_region.attribute_13;',
'  l_upload_mechanism      p_region.attribute_15%TYPE := p_region.attribute_15;',
'  l_dz_clickable          p_region.attribute_16%TYPE := p_region.attribute_16;',
'  l_show_file_preview     p_region.attribute_17%TYPE := p_region.attribute_17;',
'  l_copy_paste_support    p_region.attribute_18%TYPE := p_region.attribute_18;',
'  l_remove_uploaded_files p_region.attribute_19%TYPE := p_region.attribute_19;',
'  l_delete_files          p_region.attribute_20%TYPE := p_region.attribute_20;',
'  l_resize_images         p_region.attribute_22%TYPE := p_region.attribute_22;',
'  l_resize_width          p_region.attribute_23%TYPE := p_region.attribute_23;',
'  l_resize_height         p_region.attribute_24%TYPE := p_region.attribute_24;',
'  -- plugin attributes',
'  l_display_message            p_plugin.attribute_01%TYPE := p_plugin.attribute_01;',
'  l_fallback_message           p_plugin.attribute_02%TYPE := p_plugin.attribute_02;',
'  l_filetoobig_message         p_plugin.attribute_03%TYPE := p_plugin.attribute_03;',
'  l_maxfiles_message           p_plugin.attribute_04%TYPE := p_plugin.attribute_04;',
'  l_remove_file_message        p_plugin.attribute_05%TYPE := p_plugin.attribute_05;',
'  l_cancel_upload_message      p_plugin.attribute_06%TYPE := p_plugin.attribute_06;',
'  l_cancel_upl_confirm_message p_plugin.attribute_07%TYPE := p_plugin.attribute_07;',
'  l_invalid_filetype_message   p_plugin.attribute_08%TYPE := p_plugin.attribute_08;',
'  l_chunk_size                 p_plugin.attribute_09%TYPE := p_plugin.attribute_09;',
'  -- other variables',
'  l_region_id VARCHAR2(200);',
'  l_dz_class  VARCHAR2(50);',
'  -- js/css file vars',
'  l_filereader_js VARCHAR2(50);',
'  --',
'BEGIN',
'  -- Debug',
'  IF apex_application.g_debug THEN',
'    apex_plugin_util.debug_region(p_plugin => p_plugin,',
'                                  p_region => p_region);',
'    -- set js/css filenames',
'    l_filereader_js := ''filereader'';',
'  ELSE',
'    l_filereader_js := ''filereader.min'';',
'  END IF;',
'  -- set variables and defaults',
'  l_region_id  := apex_escape.html_attribute(p_region.static_id ||',
'                                             ''_dropzone'');',
'  l_max_files  := nvl(l_max_files,',
'                      256);',
'  l_chunk_size := nvl(l_chunk_size,',
'                      1048576);',
'  -- escape input',
'  l_width                      := apex_escape.html(l_width);',
'  l_height                     := apex_escape.html(l_height);',
'  l_display_message            := apex_escape.html(l_display_message);',
'  l_fallback_message           := apex_escape.html(l_fallback_message);',
'  l_filetoobig_message         := apex_escape.html(l_filetoobig_message);',
'  l_maxfiles_message           := apex_escape.html(l_maxfiles_message);',
'  l_remove_file_message        := apex_escape.html(l_remove_file_message);',
'  l_cancel_upload_message      := apex_escape.html(l_cancel_upload_message);',
'  l_cancel_upl_confirm_message := apex_escape.html(l_cancel_upl_confirm_message);',
'  l_invalid_filetype_message   := apex_escape.html(l_invalid_filetype_message);',
'  --',
'  -- add div for dropzone',
'  -- style 1 (grey border)',
'  -- style 2 (blue dashed border)',
'  -- style 3 (red dashed border)',
'  -- style 4 (grey background and grey dashed border)',
'  l_dz_class := ''dz-'' || lower(l_dz_style);',
'  --',
'  htp.p(''<div id="'' || l_region_id || ''" class="dropzone '' || l_dz_class ||',
'        ''" style="width:'' || l_width || '';height:'' || l_height ||',
'        '';"></div>'');',
'  --',
'  -- filereader lib for Copy&Paste support',
'  IF l_copy_paste_support = ''true'' THEN',
'    apex_javascript.add_library(p_name           => l_filereader_js,',
'                                p_directory      => p_plugin.file_prefix ||',
'                                                    ''js/'',',
'                                p_version        => NULL,',
'                                p_skip_extension => FALSE);',
'  END IF;',
'  --',
'  -- onload code',
'  apex_javascript.add_onload_code(p_code => ''apexDropzone.pluginHandler('' ||',
'                                            apex_javascript.add_value(p_region.static_id) || ''{'' ||',
'                                            apex_javascript.add_attribute(''ajaxIdentifier'',',
'                                                                          apex_plugin.get_ajax_identifier) ||',
'                                            apex_javascript.add_attribute(''maxFilesize'',',
'                                                                          l_max_filesize) ||',
'                                            apex_javascript.add_attribute(''maxFiles'',',
'                                                                          l_max_files) ||',
'                                            apex_javascript.add_attribute(''acceptedFiles'',',
'                                                                          l_accepted_files) ||',
'                                            apex_javascript.add_attribute(''uploadMechanism'',',
'                                                                          l_upload_mechanism) ||',
'                                            apex_javascript.add_attribute(''clickable'',',
'                                                                          l_dz_clickable) ||',
'                                            apex_javascript.add_attribute(''showFilePreview'',',
'                                                                          l_show_file_preview) ||',
'                                            apex_javascript.add_attribute(''supportCopyPaste'',',
'                                                                          l_copy_paste_support) ||',
'                                            apex_javascript.add_attribute(''removeAfterUpload'',',
'                                                                          l_remove_uploaded_files) ||',
'                                            apex_javascript.add_attribute(''deleteFiles'',',
'                                                                          l_delete_files) ||',
'                                            apex_javascript.add_attribute(''resizeImages'',',
'                                                                          l_resize_images) ||',
'                                            apex_javascript.add_attribute(''resizeWidth'',',
'                                                                          l_resize_width) ||',
'                                            apex_javascript.add_attribute(''resizeHeight'',',
'                                                                          l_resize_height) ||',
'                                            apex_javascript.add_attribute(''pluginPrefix'',',
'                                                                          p_plugin.file_prefix) ||',
'                                            apex_javascript.add_attribute(''chunkSize'',',
'                                                                          l_chunk_size) ||',
'                                            apex_javascript.add_attribute(''displayMessage'',',
'                                                                          l_display_message) ||',
'                                            apex_javascript.add_attribute(''fallbackMessage'',',
'                                                                          l_fallback_message) ||',
'                                            apex_javascript.add_attribute(''fileTooBigMessage'',',
'                                                                          l_filetoobig_message) ||',
'                                            apex_javascript.add_attribute(''maxFilesMessage'',',
'                                                                          l_maxfiles_message) ||',
'                                            apex_javascript.add_attribute(''removeFileMessage'',',
'                                                                          l_remove_file_message) ||',
'                                            apex_javascript.add_attribute(''cancelUploadMessage'',',
'                                                                          l_cancel_upload_message) ||',
'                                            apex_javascript.add_attribute(''cancelUploadConfirmMessage'',',
'                                                                          l_cancel_upl_confirm_message) ||',
'                                            apex_javascript.add_attribute(''invalidFileTypeMessage'',',
'                                                                          l_invalid_filetype_message,',
'                                                                          FALSE,',
'                                                                          FALSE) ||',
'                                            ''});'');',
'  --',
'  RETURN l_result;',
'  --',
'END render_dropzone;',
'--',
'--',
'-- AJAX function',
'--',
'--',
'FUNCTION ajax_dropzone(p_region IN apex_plugin.t_region,',
'                       p_plugin IN apex_plugin.t_plugin)',
'  RETURN apex_plugin.t_region_ajax_result IS',
'  --',
'  l_result apex_plugin.t_region_ajax_result;',
'  -- region attributes',
'  l_storage_type     p_region.attribute_01%TYPE := p_region.attribute_01;',
'  l_table_coll_name  p_region.attribute_02%TYPE := p_region.attribute_02;',
'  l_filename_column  p_region.attribute_03%TYPE := p_region.attribute_03;',
'  l_mimetype_column  p_region.attribute_04%TYPE := p_region.attribute_04;',
'  l_blob_column      p_region.attribute_05%TYPE := p_region.attribute_05;',
'  l_date_column      p_region.attribute_06%TYPE := p_region.attribute_06;',
'  l_pk_column        p_region.attribute_21%TYPE := p_region.attribute_21;',
'  l_upload_mechanism p_region.attribute_15%TYPE := p_region.attribute_15;',
'  l_delete_files     p_region.attribute_20%TYPE := p_region.attribute_20;',
'  -- other variables',
'  l_type                VARCHAR2(50);',
'  l_chunked_temp_coll   VARCHAR2(100);',
'  l_blob                BLOB := empty_blob();',
'  l_filename            VARCHAR2(200);',
'  l_mime_type           VARCHAR2(100);',
'  l_delete_id           NUMBER;',
'  l_current_chunk_count NUMBER;',
'  l_total_chunk_count   NUMBER;',
'  --',
'  -- Helper Functions',
'  --',
'',
'  --',
'  -- Write Error JSON',
'  PROCEDURE write_htp_error(p_message IN VARCHAR2,',
'                            p_id      IN VARCHAR2 := NULL) IS',
'  BEGIN',
'    htp.init;',
'    htp.p(''{ "status": "error", "message": "'' ||',
'          apex_escape.json(p_message) || ''", "code": "'' ||',
'          apex_escape.json(SQLERRM) || ''", "id": "'' ||',
'          apex_escape.json(p_id) || ''" }'');',
'  END write_htp_error;',
'  --',
'  -- Write Success JSON',
'  PROCEDURE write_htp_success(p_message IN VARCHAR2,',
'                              p_id      IN VARCHAR2 := NULL) IS',
'  BEGIN',
'    htp.init;',
'    htp.p(''{ "status": "success", "message": "'' ||',
'          apex_escape.json(p_message) || ''", "code": "", "id": "'' ||',
'          apex_escape.json(p_id) || ''" }'');',
'  END write_htp_success;',
'  --',
'  -- Sleep/Pause for given seconds',
'  PROCEDURE sleep(p_seconds IN NUMBER) AS',
'    l_now      TIMESTAMP := systimestamp;',
'    l_end_time TIMESTAMP;',
'  BEGIN',
'    l_end_time := l_now + numtodsinterval(p_seconds,',
'                                          ''second'');',
'  ',
'    WHILE (l_end_time > l_now) LOOP',
'      l_now := systimestamp;',
'    END LOOP;',
'  END sleep;',
'  --',
'  -- base64 array (f01 30k) to blob',
'  FUNCTION base64array_to_blob(p_f01_array IN apex_application.g_f01%TYPE)',
'    RETURN BLOB IS',
'    l_token VARCHAR2(32000);',
'    l_blob  BLOB := empty_blob();',
'  BEGIN',
'    -- build BLOB from f01 30k Array (base64 encoded)',
'    dbms_lob.createtemporary(l_blob,',
'                             FALSE,',
'                             dbms_lob.session);',
'    FOR i IN 1 .. p_f01_array.count LOOP',
'      l_token := p_f01_array(i);',
'      IF length(l_token) > 0 THEN',
'        dbms_lob.append(l_blob,',
'                        to_blob(utl_encode.base64_decode(utl_raw.cast_to_raw(l_token))));',
'      END IF;',
'    END LOOP;',
'    --',
'    RETURN l_blob;',
'    --',
'  END;',
'  --',
'  -- Chunked File Processing',
'  FUNCTION process_chunked_file(p_table_coll_name     IN VARCHAR2,',
'                                p_filename            IN VARCHAR2,',
'                                p_mime_type           IN VARCHAR2,',
'                                p_current_chunk_count IN NUMBER,',
'                                p_total_chunk_count   IN NUMBER,',
'                                p_chunk_f01_array     IN apex_application.g_f01%TYPE)',
'    RETURN BLOB IS',
'    --',
'    l_chunked_temp_coll VARCHAR2(100);',
'    l_chunk_blob        BLOB := empty_blob();',
'    l_blob              BLOB := empty_blob();',
'    l_chunk_length      NUMBER := 0;',
'    -- cursor for file chunks',
'    CURSOR l_cur_chunk_files IS',
'      SELECT apex_collections.blob001 AS chunk_blob,',
'             apex_collections.n003    AS blob_size',
'        FROM apex_collections',
'       WHERE apex_collections.collection_name = l_chunked_temp_coll',
'         AND apex_collections.c001 = p_filename',
'         AND apex_collections.n002 = p_total_chunk_count',
'       ORDER BY apex_collections.n001;',
'    --',
'  BEGIN',
'    l_chunked_temp_coll := upper(p_table_coll_name) || ''_TEMP'';',
'    -- create chunk collection',
'    IF NOT',
'        apex_collection.collection_exists(p_collection_name => l_chunked_temp_coll) THEN',
'      apex_collection.create_collection(p_collection_name => l_chunked_temp_coll);',
'    END IF;',
'    -- build BLOB from f01 30k Array (base64 encoded chunk)',
'    l_chunk_blob   := base64array_to_blob(p_f01_array => p_chunk_f01_array);',
'    l_chunk_length := dbms_lob.getlength(l_chunk_blob);',
'    --',
'    IF p_total_chunk_count > 1 THEN',
'      --',
'      apex_collection.add_member(p_collection_name => l_chunked_temp_coll,',
'                                 p_c001            => p_filename, -- filename',
'                                 p_c002            => p_mime_type, -- mime_type',
'                                 p_n001            => p_current_chunk_count, -- current count from JS loop',
'                                 p_n002            => p_total_chunk_count, -- total count of all chunks',
'                                 p_n003            => l_chunk_length, -- size of base64 BLOB file chunk',
'                                 p_blob001         => l_chunk_blob); -- BLOB base64 file chunk content',
'    ELSE',
'      l_blob := l_chunk_blob;',
'    END IF;',
'    -- last file chunk peace + chunk count > 1',
'    IF p_current_chunk_count = p_total_chunk_count AND',
'       p_total_chunk_count > 1 THEN',
'      --',
'      dbms_lob.createtemporary(l_blob,',
'                               FALSE,',
'                               dbms_lob.session);',
'      -- loop over all file chunks and build final file',
'      FOR l_rec_chunk_files IN l_cur_chunk_files LOOP',
'        IF l_rec_chunk_files.blob_size IS NOT NULL THEN',
'          dbms_lob.append(l_blob,',
'                          l_rec_chunk_files.chunk_blob);',
'        END IF;',
'      END LOOP;',
'      -- delete all chunks for specific file from collection',
'      FOR l_rec_del_coll IN (SELECT seq_id',
'                               FROM apex_collections',
'                              WHERE apex_collections.collection_name =',
'                                    l_chunked_temp_coll',
'                                AND apex_collections.c001 = p_filename',
'                                AND apex_collections.n002 =',
'                                    p_total_chunk_count) LOOP',
'        apex_collection.delete_member(p_collection_name => l_chunked_temp_coll,',
'                                      p_seq             => l_rec_del_coll.seq_id);',
'      END LOOP;',
'      --',
'    END IF;',
'    -- status return json',
'    write_htp_success(''File Chunk '' || p_current_chunk_count || '' of '' ||',
'                      p_total_chunk_count || '' for '' || p_filename ||',
'                      '' successfully saved to Temp. APEX Collection '' ||',
'                      l_chunked_temp_coll);',
'    --',
'    RETURN l_blob;',
'    --',
'  EXCEPTION',
'    WHEN OTHERS THEN',
'      -- status return json',
'      write_htp_error(''File Chunk '' || p_current_chunk_count || '' of '' ||',
'                      p_total_chunk_count || '' for '' || p_filename ||',
'                      '' NOT saved to Temp. APEX Collection '' ||',
'                      l_chunked_temp_coll);',
'      RAISE;',
'  END process_chunked_file;',
'  --',
'  -- FormData File Processing',
'  FUNCTION process_normal_file(p_filename       IN VARCHAR2,',
'                               p_apex_file_name IN VARCHAR2) RETURN BLOB IS',
'    l_blob BLOB := empty_blob();',
'    CURSOR l_cur_file IS',
'      SELECT aaf.blob_content',
'        FROM apex_application_files aaf',
'       WHERE aaf.name = p_apex_file_name;',
'  BEGIN',
'    OPEN l_cur_file;',
'    FETCH l_cur_file',
'      INTO l_blob;',
'    CLOSE l_cur_file;',
'    --',
'    DELETE FROM apex_application_files aaf',
'     WHERE aaf.name = p_apex_file_name;',
'    --',
'    RETURN l_blob;',
'  EXCEPTION',
'    WHEN OTHERS THEN',
'      -- status return json',
'      write_htp_error(''File Upload could not be processed for '' ||',
'                      p_filename);',
'      RAISE;',
'  END process_normal_file;',
'  --',
'  -- Save File to Collection / Table',
'  PROCEDURE save_file(p_storage_type    IN VARCHAR2,',
'                      p_table_coll_name IN VARCHAR2,',
'                      p_filename        IN VARCHAR2,',
'                      p_mime_type       IN VARCHAR2,',
'                      p_blob            IN OUT NOCOPY BLOB,',
'                      p_pk_column       IN VARCHAR2 := NULL,',
'                      p_filename_column IN VARCHAR2 := NULL,',
'                      p_mimetype_column IN VARCHAR2 := NULL,',
'                      p_blob_column     IN VARCHAR2 := NULL,',
'                      p_date_column     IN VARCHAR2 := NULL) IS',
'    --',
'    l_random_file_id NUMBER;',
'    l_insert_sql     VARCHAR2(32767);',
'    l_insert_id      NUMBER;',
'    l_blob_length    NUMBER := 0;',
'    --',
'  BEGIN',
'    --',
'    l_blob_length := nvl(dbms_lob.getlength(p_blob),',
'                         0);',
'    -- only process if BLOB has data',
'    IF l_blob_length > 0 THEN',
'      -- Save to APEX Collection',
'      IF p_storage_type = ''COLLECTION'' THEN',
'        BEGIN',
'          -- random file id',
'          l_random_file_id := round(dbms_random.value(100000,',
'                                                      99999999));',
'          -- check if collection exist',
'          IF NOT',
'              apex_collection.collection_exists(p_collection_name => p_table_coll_name) THEN',
'            apex_collection.create_collection(p_table_coll_name);',
'          END IF;',
'          -- add collection member',
'          l_insert_id := apex_collection.add_member(p_collection_name => p_table_coll_name,',
'                                                    p_c001            => p_filename, -- filename',
'                                                    p_c002            => p_mime_type, -- mime_type',
'                                                    p_d001            => SYSDATE, -- date created',
'                                                    p_n001            => l_random_file_id, -- random file id',
'                                                    p_blob001         => p_blob); -- BLOB file content',
'          -- status return json',
'          write_htp_success(p_message => ''File '' || p_filename ||',
'                                         '' successfully saved to APEX Collection '' ||',
'                                         p_table_coll_name,',
'                            p_id      => l_insert_id);',
'          --',
'        EXCEPTION',
'          WHEN OTHERS THEN',
'            -- status return json',
'            write_htp_error(''File '' || p_filename ||',
'                            '' NOT saved to APEX Collection '' ||',
'                            p_table_coll_name);',
'            RAISE;',
'        END;',
'        --',
'        -- Save to custom Table',
'      ELSIF p_storage_type = ''TABLE'' THEN',
'        BEGIN',
'          -- dynamic insert statement',
'          -- without optional date column',
'          IF p_date_column IS NULL THEN',
'            l_insert_sql := ''INSERT INTO '' ||',
'                            dbms_assert.sql_object_name(p_table_coll_name) || ''( '' ||',
'                            dbms_assert.simple_sql_name(p_filename_column) || '', '' ||',
'                            dbms_assert.simple_sql_name(p_mimetype_column) || '', '' ||',
'                            dbms_assert.simple_sql_name(p_blob_column) ||',
'                            '') VALUES (:filename_value,:mimetype_value,:blob_value) RETURNING '' ||',
'                            dbms_assert.simple_sql_name(p_pk_column) ||',
'                            '' INTO :pk_value'';',
'            -- execute insert',
'            EXECUTE IMMEDIATE l_insert_sql',
'              USING p_filename, p_mime_type, p_blob',
'              RETURNING INTO l_insert_id;',
'            -- with optional date column',
'          ELSE',
'            l_insert_sql := ''INSERT INTO '' ||',
'                            dbms_assert.sql_object_name(p_table_coll_name) || ''( '' ||',
'                            dbms_assert.simple_sql_name(p_filename_column) || '', '' ||',
'                            dbms_assert.simple_sql_name(p_mimetype_column) || '', '' ||',
'                            dbms_assert.simple_sql_name(p_blob_column) || '', '' ||',
'                            dbms_assert.simple_sql_name(p_date_column) ||',
'                            '') VALUES (:filename_value,:mimetype_value,:blob_value,:date_value) RETURNING '' ||',
'                            dbms_assert.simple_sql_name(p_pk_column) ||',
'                            '' INTO :pk_value'';',
'            -- execute insert',
'            EXECUTE IMMEDIATE l_insert_sql',
'              USING p_filename, p_mime_type, p_blob, SYSDATE',
'              RETURNING INTO l_insert_id;',
'          END IF;',
'          -- status return json',
'          write_htp_success(p_message => ''File '' || p_filename ||',
'                                         '' successfully saved to Custom Table '' ||',
'                                         p_table_coll_name,',
'                            p_id      => l_insert_id);',
'          --',
'        EXCEPTION',
'          WHEN OTHERS THEN',
'            -- status return json',
'            write_htp_error(''File '' || p_filename ||',
'                            '' NOT saved to Custom Table '' ||',
'                            p_table_coll_name);',
'            RAISE;',
'        END;',
'        --',
'      END IF;',
'      -- sleep 0.75 sec',
'      sleep(p_seconds => 75 / 100);',
'      --',
'    END IF;',
'    --',
'  EXCEPTION',
'    WHEN OTHERS THEN',
'      -- sleep 0.75 sec',
'      sleep(p_seconds => 75 / 100);',
'      RAISE;',
'  END save_file;',
'  --',
'  -- Delete File from Collection / Table',
'  PROCEDURE delete_file(p_storage_type    IN VARCHAR2,',
'                        p_table_coll_name IN VARCHAR2,',
'                        p_delete_id       IN NUMBER,',
'                        p_filename        IN VARCHAR2,',
'                        p_pk_column       IN VARCHAR2 := NULL) IS',
'    --',
'    l_delete_sql VARCHAR2(32767);',
'    --',
'  BEGIN',
'    -- Delete from APEX Collection',
'    IF p_storage_type = ''COLLECTION'' THEN',
'      --',
'      BEGIN',
'        -- check if collection exist',
'        IF apex_collection.collection_exists(p_collection_name => p_table_coll_name) THEN',
'          -- delete collection member (only if Seq-ID not null)',
'          IF p_delete_id IS NOT NULL THEN',
'            apex_collection.delete_member(p_collection_name => p_table_coll_name,',
'                                          p_seq             => p_delete_id);',
'            -- status return json',
'            write_htp_success(''File '' || p_filename ||',
'                              '' successfully deleted from APEX Collection '' ||',
'                              p_table_coll_name);',
'          ELSE',
'            -- status return json',
'            write_htp_error(''File-ID missing for File '' || p_filename ||',
'                            ''. NOT deleted from APEX Collection '' ||',
'                            p_table_coll_name);',
'          END IF;',
'        ELSE',
'          -- status return json',
'          write_htp_error(''APEX Collection '' || p_table_coll_name ||',
'                          '' missing for File '' || p_filename);',
'        END IF;',
'        --',
'      EXCEPTION',
'        WHEN OTHERS THEN',
'          -- status return json',
'          write_htp_error(''File '' || p_filename ||',
'                          '' NOT deleted from APEX Collection '' ||',
'                          p_table_coll_name);',
'          RAISE;',
'      END;',
'      --',
'      -- Delete from custom Table',
'    ELSIF p_storage_type = ''TABLE'' THEN',
'      BEGIN',
'        -- dynamic delete statement',
'        IF p_delete_id IS NOT NULL THEN',
'          l_delete_sql := ''DELETE FROM '' ||',
'                          dbms_assert.sql_object_name(p_table_coll_name) ||',
'                          '' WHERE '' ||',
'                          dbms_assert.simple_sql_name(p_pk_column) ||',
'                          '' = :pk_value'';',
'          -- execute delete',
'          EXECUTE IMMEDIATE l_delete_sql',
'            USING p_delete_id;',
'          -- status return json',
'          write_htp_success(''File '' || p_filename ||',
'                            '' successfully deleted from Custom Table '' ||',
'                            p_table_coll_name);',
'        ELSE',
'          -- status return json',
'          write_htp_error(''File-ID missing for File '' || p_filename ||',
'                          ''. NOT deleted from Custom Table '' ||',
'                          p_table_coll_name);',
'        END IF;',
'        --',
'      EXCEPTION',
'        WHEN OTHERS THEN',
'          -- status return json',
'          write_htp_error(''File '' || p_filename ||',
'                          '' NOT deleted from Custom Table '' ||',
'                          p_table_coll_name);',
'          RAISE;',
'      END;',
'    END IF;',
'  END delete_file;',
'  --',
'BEGIN',
'  --',
'  -- Debug Info',
'  apex_debug.info(''Dropzone AJAX Parameter x01: '' ||',
'                  apex_application.g_x01);',
'  apex_debug.info(''Dropzone AJAX Parameter x02: '' ||',
'                  apex_application.g_x02);',
'  apex_debug.info(''Dropzone AJAX Parameter x03: '' ||',
'                  apex_application.g_x03);',
'  apex_debug.info(''Dropzone AJAX Parameter x04: '' ||',
'                  apex_application.g_x04);',
'  apex_debug.info(''Dropzone AJAX Parameter x05: '' ||',
'                  apex_application.g_x05);',
'  --',
'  -- replace substitution strings',
'  l_table_coll_name := apex_plugin_util.replace_substitutions(p_value => l_table_coll_name);',
'  l_filename_column := apex_plugin_util.replace_substitutions(p_value => l_filename_column);',
'  l_mimetype_column := apex_plugin_util.replace_substitutions(p_value => l_mimetype_column);',
'  l_blob_column     := apex_plugin_util.replace_substitutions(p_value => l_blob_column);',
'  l_date_column     := apex_plugin_util.replace_substitutions(p_value => l_date_column);',
'  l_pk_column       := apex_plugin_util.replace_substitutions(p_value => l_pk_column);',
'  -- set general vars',
'  l_type            := nvl(apex_application.g_x01,',
'                           ''UPLOAD'');',
'  l_table_coll_name := upper(l_table_coll_name);',
'  --',
'  --',
'  -- Upload',
'  --',
'  IF l_type = ''UPLOAD'' THEN',
'    -- get defaults from AJAX Process',
'    l_filename  := apex_application.g_x02;',
'    l_mime_type := nvl(apex_application.g_x03,',
'                       ''application/octet-stream'');',
'    --',
'    -- Chunked 1MB file upload / chunks in temp collection (multiple server requests (per file chunk))',
'    IF l_upload_mechanism = ''CHUNKED'' THEN',
'      BEGIN',
'        -- get defaults from AJAX Process',
'        l_current_chunk_count := to_number(apex_application.g_x04);',
'        l_total_chunk_count   := to_number(apex_application.g_x05);',
'        --',
'        l_blob := process_chunked_file(p_table_coll_name     => l_table_coll_name,',
'                                       p_filename            => l_filename,',
'                                       p_mime_type           => l_mime_type,',
'                                       p_current_chunk_count => l_current_chunk_count,',
'                                       p_total_chunk_count   => l_total_chunk_count,',
'                                       p_chunk_f01_array     => apex_application.g_f01);',
'      EXCEPTION',
'        WHEN OTHERS THEN',
'          RETURN NULL;',
'      END;',
'      --',
'      -- formdata file upload',
'    ELSIF l_upload_mechanism = ''NORMAL'' THEN',
'      BEGIN',
'        l_blob := process_normal_file(p_filename       => l_filename,',
'                                      p_apex_file_name => apex_application.g_f01(1));',
'      EXCEPTION',
'        WHEN OTHERS THEN',
'          RETURN NULL;',
'      END;',
'    END IF;',
'    --',
'    -- Save final File',
'    BEGIN',
'      save_file(p_storage_type    => l_storage_type,',
'                p_table_coll_name => l_table_coll_name,',
'                p_filename        => l_filename,',
'                p_mime_type       => l_mime_type,',
'                p_blob            => l_blob,',
'                p_pk_column       => l_pk_column,',
'                p_filename_column => l_filename_column,',
'                p_mimetype_column => l_mimetype_column,',
'                p_blob_column     => l_blob_column,',
'                p_date_column     => l_date_column);',
'    EXCEPTION',
'      WHEN OTHERS THEN',
'        RETURN NULL;',
'    END;',
'  END IF;',
'  --',
'  -- Delete File',
'  --',
'  IF l_type = ''DELETE'' AND l_delete_files = ''true'' THEN',
'    l_filename  := apex_application.g_x02;',
'    l_delete_id := to_number(apex_application.g_x03);',
'    --',
'    BEGIN',
'      delete_file(p_storage_type    => l_storage_type,',
'                  p_table_coll_name => l_table_coll_name,',
'                  p_delete_id       => l_delete_id,',
'                  p_filename        => l_filename,',
'                  p_pk_column       => l_pk_column);',
'    EXCEPTION',
'      WHEN OTHERS THEN',
'        RETURN NULL;',
'    END;',
'  END IF;',
'  --',
'  RETURN l_result;',
'  --',
'EXCEPTION',
'  WHEN OTHERS THEN',
'    -- status return json',
'    write_htp_error(''General Error occured in Dropzone AJAX Function'');',
'    RETURN NULL;',
'END ajax_dropzone;'))
,p_api_version=>1
,p_render_function=>'render_dropzone'
,p_ajax_function=>'ajax_dropzone'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Dropzone is a region type plugin that allows you to provide nice looking drag’n’drop file uploads. It is based on JS Framework dropzone.js.'
,p_version_identifier=>'2.4.1'
,p_about_url=>'https://github.com/Dani3lSun/apex-plugin-dropzone'
,p_files_version=>1414
);
end;
/
begin
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136373031498822823)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Display Message'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Drop files here or click to upload.'
,p_is_translatable=>true
,p_help_text=>'Message that is displayed inside of the Dropzone Region'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136373865307826748)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Fallback Message'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Your browser does not support drag''n''drop file uploads.'
,p_is_translatable=>true
,p_help_text=>'Message that is displayed when your Browser doesn´t support HTML5 Drag & Drop File Uploads'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136374320793832027)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'File too Big Message'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'File is too big ({{filesize}}MiB). Max filesize: {{maxFilesize}}MiB.'
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Message that is displayed per File, if the File is bigger than you allowed in the settings.<br>',
'You can use Placeholders like:<br>',
'{{filesize}} for the Filesize<br>',
'{{maxFilesize}} for the max. allowed Filesize'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136374826835834437)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'max. Files Message'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'You can not upload more than {{maxFiles}} files.'
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Message that is displayed per File, if the uploaded Files exceed the max. Files settings.<br>',
'You can use Placeholders like:<br>',
'{{maxFiles}} for the max. allowed Files'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136375346937836729)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Remove File Message'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Remove file'
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Message that is displayed below a single File to remove the File.<br>',
'Only possible if "Delete Files" is set.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136375876160839531)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Cancel Upload Message'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Cancel upload'
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Message that is displayed below a single File to Cancel Uploading during the actual Upload Process.<br>',
'Only possible if "Delete Files" is set.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136376310041842498)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Cancel Upload Confirm Message'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Are you sure you want to cancel this upload?'
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Message that is displayed in the Confirm Dialog if you clicked the Upload Cancel Link.<br>',
'Only possible if "Delete Files" is set.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136376889840846218)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Invalid File Type Message'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'You can not upload files of this type.'
,p_is_translatable=>true
,p_help_text=>'Message that is displayed per File, if the File´s Mime-Type is in the Exclude List.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(81266287492138158)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Chunk Size (in KB)'
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'1048576'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This is the default chunk size if you choose the Chunked upload mechanism. The file is split into pieces of that size. Each piece is sent to the server separately.<br>',
'Thus the files are base64 encoded, there is a little overhead in the file size, so please consider a plus of about 10-15% in file size.<br>',
'Default is 1MB = 1048576 KB.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136378105370922737)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Storage Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'COLLECTION'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'SELECT c001    AS filename,',
'       c002    AS mime_type,',
'       d001    AS date_created,',
'       n001    AS file_id,',
'       blob001 AS file_content',
'  FROM apex_collections',
' WHERE collection_name = ''DROPZONE_UPLOAD'';',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose where the uploaded files are saved.<br>',
'You can either save your files to a APEX Collection or to a Custom Table.<br><br>',
'<strong>APEX Collection</strong><br>',
'The APEX collection way should be the easiest. You only have to enter a Collection Name. After that you can Select the files from APEX_COLLECTIONS View.<br><br>',
'Default Collection "DROPZONE_UPLOAD".<br>',
'Column c001 => filename<br>',
'Column c002 => mime_type<br>',
'Column d001 => date created<br>',
'Column n001 => random file id<br>',
'Column blob001 => BLOB of file<br><br>',
'<strong>Custom Table</strong><br>',
'A Table must have Columns for Filename, Mime Type and the File Content (BLOB). The Primary Key (PK) must be processed with a Before Insert Trigger. Optionally the table can have a date column to save the upload date.<br>',
'If your table has other required columns you have to insert these values via Database Trigger or something like that.'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(136378610283923777)
,p_plugin_attribute_id=>wwv_flow_api.id(136378105370922737)
,p_display_sequence=>10
,p_display_value=>'APEX Collection'
,p_return_value=>'COLLECTION'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(136379072998925076)
,p_plugin_attribute_id=>wwv_flow_api.id(136378105370922737)
,p_display_sequence=>20
,p_display_value=>'Custom Table'
,p_return_value=>'TABLE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136372454005805126)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Collection / Table Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'DROPZONE_UPLOAD'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(136378105370922737)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'COLLECTION,TABLE'
,p_help_text=>'Name of the APEX Collection or of your Custom Table'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136382269650943192)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Filename Column'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(136378105370922737)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>'Column of your custom Table which holds the information for the Filename'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136382754155946895)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Mime Type Column'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(136378105370922737)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>'Column of your custom Table which holds the information for the File Mime-Type'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136383281947956680)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'BLOB Column'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(136378105370922737)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>'Column of your custom Table which holds the information for the File Content (BLOB)'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136383770254960168)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Date Column'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(136378105370922737)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>'Column of your custom Table which holds the information for the File Upload Date'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136323388362859791)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Dropzone Style'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STYLE1'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'UI Style of your Dropzone Region<br>',
'- Grey Border<br>',
'- Blue Dashed Border<br>',
'- Red Dashed Border<br>',
'- Grey Dashed Border/Background'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(136323787004859791)
,p_plugin_attribute_id=>wwv_flow_api.id(136323388362859791)
,p_display_sequence=>10
,p_display_value=>'Grey Border'
,p_return_value=>'STYLE1'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(136324302174859791)
,p_plugin_attribute_id=>wwv_flow_api.id(136323388362859791)
,p_display_sequence=>20
,p_display_value=>'Blue Dashed Border'
,p_return_value=>'STYLE2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(136511784051684955)
,p_plugin_attribute_id=>wwv_flow_api.id(136323388362859791)
,p_display_sequence=>30
,p_display_value=>'Red Dashed Border'
,p_return_value=>'STYLE3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(136728633382856635)
,p_plugin_attribute_id=>wwv_flow_api.id(136323388362859791)
,p_display_sequence=>40
,p_display_value=>'Grey Dashed Border/Background'
,p_return_value=>'STYLE4'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136311129209859788)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Width'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'700px'
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'700px<br>',
'100%'))
,p_help_text=>'Enter the default width of your Dropzone Region. Valid values are px and % data.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136311587089859788)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Height'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'400px'
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'400px<br>',
'500px'))
,p_help_text=>'Enter the default height of Dropzone Region. Valid values in px.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136312340197859788)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'max. Filesize in MB'
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'2'
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'1<br>',
'2<br>',
'3.5'))
,p_help_text=>'max. File Size (Float Number) that is allowed per file. If a file is larger, it will be removed.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136318914821859789)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'max. Files'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Maximum number of allowed files that can be uploaded at once.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136321554670859791)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Parallel Uploads [NOT USED]'
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'1'
,p_max_length=>1
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(136378105370922737)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'NEVER'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Number of parallel Upload Streams to the server.<br>',
'Choose a value between 1 and 2. 1 works most reliable!'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136317741879859789)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>'Accepted File Types'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'image/*,application/pdf,.psd'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If you only want that users can upload Files of declared types.<br>',
'Default: all file types are allowed<br>',
'Valid values: comma separated list of Mime-Types (with Wildcard support) or File endings: image/*,application/pdf,.psd'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136321105715859790)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Wait Time (ms) [NOT USED]'
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'700'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(136378105370922737)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'NEVER'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Wait time between several uploaded files in milliseconds.<br>',
'In some environments Dropzone is faster than storing files in Database.<br>',
'Default: 700ms'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136396730349039142)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>65
,p_prompt=>'Upload Mechanism'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NORMAL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><strong>Normal:</strong> Files are directly uploaded to the DB using a multipart/form-data POST (FormData) request. This method needs no conversion (decode, encode) of strings, thus the final BLOB is already there and can be used.</p>',
'<p><strong>Chunked:</strong> Files are split into chunks (default: 1MB), then each chunk is encoded into base64. This encoded string is then uploaded to the DB, the DB decodes the encoded chunks and builds a final BLOB out of it.</p>',
'<p>Both methods should work with all web server combinations. Thus no conversion is needed for "normal" uploads, this method is 2x as fast as "chunked". If, somehow, your web server configuration allows no large multipart/form-data requests, go with '
||'the "chunked" method.<p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(136397266879051298)
,p_plugin_attribute_id=>wwv_flow_api.id(136396730349039142)
,p_display_sequence=>10
,p_display_value=>'Normal'
,p_return_value=>'NORMAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(136397653321052575)
,p_plugin_attribute_id=>wwv_flow_api.id(136396730349039142)
,p_display_sequence=>20
,p_display_value=>'Chunked'
,p_return_value=>'CHUNKED'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136312757390859788)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>160
,p_prompt=>'Clickable'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'true'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'If true, the Dropzone Region will be clickable, if false nothing will be clickable and only Drag & Drop is possible.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(136313142868859788)
,p_plugin_attribute_id=>wwv_flow_api.id(136312757390859788)
,p_display_sequence=>10
,p_display_value=>'True'
,p_return_value=>'true'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(136313681853859788)
,p_plugin_attribute_id=>wwv_flow_api.id(136312757390859788)
,p_display_sequence=>20
,p_display_value=>'False'
,p_return_value=>'false'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136321990264859791)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>170
,p_prompt=>'Show File Previews'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'true'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Show Preview Images for common File types when adding files.<br>',
'Images got displayed with real content.<br>',
'If you want to add more images or others just Copy/Upload the PNG Files to "img" directory. Naming: <file-extension>.png'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(136322365682859791)
,p_plugin_attribute_id=>wwv_flow_api.id(136321990264859791)
,p_display_sequence=>10
,p_display_value=>'True'
,p_return_value=>'true'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(136322820894859791)
,p_plugin_attribute_id=>wwv_flow_api.id(136321990264859791)
,p_display_sequence=>20
,p_display_value=>'False'
,p_return_value=>'false'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136319722966859790)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>180
,p_prompt=>'Copy & Paste Support'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'false'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'1) Open Image File<br>',
'2) Copy File (Strg+C or Cmd+C)<br>',
'3) Paste it to the page which contains the Dropzone Region in your Browser (Strg+V or Cmd+V)'))
,p_help_text=>'Adds support for Copy & Paste of Images in modern Browsers (like Chrome or Firefox > 50).<br>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(136320151655859790)
,p_plugin_attribute_id=>wwv_flow_api.id(136319722966859790)
,p_display_sequence=>10
,p_display_value=>'True'
,p_return_value=>'true'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(136320702298859790)
,p_plugin_attribute_id=>wwv_flow_api.id(136319722966859790)
,p_display_sequence=>20
,p_display_value=>'False'
,p_return_value=>'false'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136316323799859789)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>190
,p_prompt=>'Remove Files after Upload'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'false'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'If true, clears all Files from Dropzone Region after uploading has finished.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(136316733164859789)
,p_plugin_attribute_id=>wwv_flow_api.id(136316323799859789)
,p_display_sequence=>10
,p_display_value=>'True'
,p_return_value=>'true'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(136317279708859789)
,p_plugin_attribute_id=>wwv_flow_api.id(136316323799859789)
,p_display_sequence=>20
,p_display_value=>'False'
,p_return_value=>'false'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136326508352859792)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>67
,p_prompt=>'Delete Files'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'false'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Possibility for end users to delete each file that was uploaded to the server.<br>',
'Only if no Page Refresh has occurred.'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(136326964024859792)
,p_plugin_attribute_id=>wwv_flow_api.id(136326508352859792)
,p_display_sequence=>10
,p_display_value=>'True'
,p_return_value=>'true'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(136327478677859792)
,p_plugin_attribute_id=>wwv_flow_api.id(136326508352859792)
,p_display_sequence=>20
,p_display_value=>'False'
,p_return_value=>'false'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(136736151856133069)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>55
,p_prompt=>'PK Column'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(136378105370922737)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>'Primary Key (PK) Column of your custom file Table'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(81234328010866918)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>22
,p_display_sequence=>200
,p_prompt=>'Image Resizing'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'false'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If true, images are resized to a specified size. This happens on client side before uploading the file to server. Saving upload bandwidth and reducing upload time.<br>',
'Please set at least one resize attribute, e.g. Resize Width or Resize Height.'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(81235143689867435)
,p_plugin_attribute_id=>wwv_flow_api.id(81234328010866918)
,p_display_sequence=>10
,p_display_value=>'True'
,p_return_value=>'true'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(81235557928868084)
,p_plugin_attribute_id=>wwv_flow_api.id(81234328010866918)
,p_display_sequence=>20
,p_display_value=>'False'
,p_return_value=>'false'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(81236335729873339)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>23
,p_display_sequence=>230
,p_prompt=>'Resize Width'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(81234328010866918)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'true'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If set, images will be resized to these dimensions before being uploaded. If only one, resize Width or resize Height is provided, the original aspect ratio of the file will be preserved.<br>',
'Please provide a width in pixels.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(81237080022875540)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>24
,p_display_sequence=>240
,p_prompt=>'Resize Height'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(81234328010866918)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'true'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If set, images will be resized to these dimensions before being uploaded. If only one, resize Width or resize Height is provided, the original aspect ratio of the file will be preserved.<br>',
'Please provide a height in pixels.'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(136330935434859793)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_name=>'dropzone-added-file'
,p_display_name=>'Dropzone File added'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(136331373469859793)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_name=>'dropzone-delete-error'
,p_display_name=>'Dropzone File Delete Error (AJAX)'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(136331735618859793)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_name=>'dropzone-delete-success'
,p_display_name=>'Dropzone File Delete Success (AJAX)'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(136476667754541850)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_name=>'dropzone-deleted-file'
,p_display_name=>'Dropzone File deleted'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(136733618617900997)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_name=>'dropzone-drag-over'
,p_display_name=>'Dropzone Dragging File over Region'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(136733273361900997)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_name=>'dropzone-file-error'
,p_display_name=>'Dropzone File Error'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(136332153815859794)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_name=>'dropzone-maxfiles-exceeded'
,p_display_name=>'Dropzone max Files exceeded'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(136476952902541851)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_name=>'dropzone-totalupload-progress'
,p_display_name=>'Dropzone Total Upload Progress'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(136477789431541851)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_name=>'dropzone-upload-chunk-error'
,p_display_name=>'Dropzone Chunked File Upload Error (AJAX)'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(136477360978541851)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_name=>'dropzone-upload-chunk-success'
,p_display_name=>'Dropzone Chunked File Upload Success (AJAX)'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(136332600151859794)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_name=>'dropzone-upload-complete'
,p_display_name=>'Dropzone Upload completed'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(136332924541859795)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_name=>'dropzone-upload-error'
,p_display_name=>'Dropzone File Upload Error (AJAX)'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(136333381663859795)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_name=>'dropzone-upload-success'
,p_display_name=>'Dropzone File Upload Success (AJAX)'
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2F2A0A415045582044726F707A6F6E65204353530A417574686F723A2044616E69656C20486F63686C6569746E65720A56657273696F6E3A20322E342E310A2A2F0A0A2E647A2D6D657373616765207B0A20202020666F6E742D73697A653A20312E3465';
wwv_flow_api.g_varchar2_table(2) := '6D3B0A20202020666F6E742D7765696768743A203430303B0A7D0A0A2E64726F707A6F6E65202E647A2D707265766965772E647A2D696D6167652D70726576696577207B0A202020206261636B67726F756E643A206E6F6E653B0A7D0A0A2E647A2D7374';
wwv_flow_api.g_varchar2_table(3) := '796C6531207B0A20202020626F726465723A2035707820736F6C696420677265793B0A202020206261636B67726F756E643A2077686974653B0A202020206F766572666C6F773A206175746F3B0A7D0A0A2E647A2D7374796C6532207B0A20202020626F';
wwv_flow_api.g_varchar2_table(4) := '726465723A203370782064617368656420233030383746373B0A20202020626F726465722D7261646975733A203570783B0A202020206261636B67726F756E643A2077686974653B0A202020206F766572666C6F773A206175746F3B0A7D0A0A2E647A2D';
wwv_flow_api.g_varchar2_table(5) := '7374796C6533207B0A20202020626F726465723A203370782064617368656420236666303032363B0A20202020626F726465722D7261646975733A203570783B0A202020206261636B67726F756E643A2077686974653B0A202020206F766572666C6F77';
wwv_flow_api.g_varchar2_table(6) := '3A206175746F3B0A7D0A0A2E647A2D7374796C6534207B0A20202020626F726465723A203270782064617368656420233845384539333B0A20202020626F726465722D7261646975733A20313070783B0A202020206261636B67726F756E642D636F6C6F';
wwv_flow_api.g_varchar2_table(7) := '723A207267626128302C20302C20302C20302E31293B0A20202020636F6C6F723A20233730373037303B0A202020206F766572666C6F773A206175746F3B0A7D0A';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72338199194797125)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'css/apexdropzone.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2E647A2D6D6573736167657B666F6E742D73697A653A312E34656D3B666F6E742D7765696768743A3430307D2E64726F707A6F6E65202E647A2D707265766965772E647A2D696D6167652D707265766965777B6261636B67726F756E643A3020307D2E64';
wwv_flow_api.g_varchar2_table(2) := '7A2D7374796C65312C2E647A2D7374796C65322C2E647A2D7374796C65337B626F726465723A35707820736F6C696420677261793B6261636B67726F756E643A236666663B6F766572666C6F773A6175746F7D2E647A2D7374796C65322C2E647A2D7374';
wwv_flow_api.g_varchar2_table(3) := '796C65337B626F726465723A3370782064617368656420233030383766373B626F726465722D7261646975733A3570787D2E647A2D7374796C65337B626F726465723A3370782064617368656420236666303032367D2E647A2D7374796C65347B626F72';
wwv_flow_api.g_varchar2_table(4) := '6465723A3270782064617368656420233865386539333B626F726465722D7261646975733A313070783B6261636B67726F756E642D636F6C6F723A7267626128302C302C302C2E31293B636F6C6F723A233730373037303B6F766572666C6F773A617574';
wwv_flow_api.g_varchar2_table(5) := '6F7D';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72338535324797126)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'css/apexdropzone.min.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2F2A0A202A20546865204D4954204C6963656E73650A202A20436F70797269676874202863292032303132204D6174696173204D656E6F203C6D40746961732E6D653E0A202A2F0A402D7765626B69742D6B65796672616D65732070617373696E672D74';
wwv_flow_api.g_varchar2_table(2) := '68726F756768207B0A20203025207B0A202020206F7061636974793A20303B0A202020202D7765626B69742D7472616E73666F726D3A207472616E736C617465592834307078293B0A202020202D6D6F7A2D7472616E73666F726D3A207472616E736C61';
wwv_flow_api.g_varchar2_table(3) := '7465592834307078293B0A202020202D6D732D7472616E73666F726D3A207472616E736C617465592834307078293B0A202020202D6F2D7472616E73666F726D3A207472616E736C617465592834307078293B0A202020207472616E73666F726D3A2074';
wwv_flow_api.g_varchar2_table(4) := '72616E736C617465592834307078293B207D0A20203330252C20373025207B0A202020206F7061636974793A20313B0A202020202D7765626B69742D7472616E73666F726D3A207472616E736C6174655928307078293B0A202020202D6D6F7A2D747261';
wwv_flow_api.g_varchar2_table(5) := '6E73666F726D3A207472616E736C6174655928307078293B0A202020202D6D732D7472616E73666F726D3A207472616E736C6174655928307078293B0A202020202D6F2D7472616E73666F726D3A207472616E736C6174655928307078293B0A20202020';
wwv_flow_api.g_varchar2_table(6) := '7472616E73666F726D3A207472616E736C6174655928307078293B207D0A202031303025207B0A202020206F7061636974793A20303B0A202020202D7765626B69742D7472616E73666F726D3A207472616E736C61746559282D34307078293B0A202020';
wwv_flow_api.g_varchar2_table(7) := '202D6D6F7A2D7472616E73666F726D3A207472616E736C61746559282D34307078293B0A202020202D6D732D7472616E73666F726D3A207472616E736C61746559282D34307078293B0A202020202D6F2D7472616E73666F726D3A207472616E736C6174';
wwv_flow_api.g_varchar2_table(8) := '6559282D34307078293B0A202020207472616E73666F726D3A207472616E736C61746559282D34307078293B207D207D0A402D6D6F7A2D6B65796672616D65732070617373696E672D7468726F756768207B0A20203025207B0A202020206F7061636974';
wwv_flow_api.g_varchar2_table(9) := '793A20303B0A202020202D7765626B69742D7472616E73666F726D3A207472616E736C617465592834307078293B0A202020202D6D6F7A2D7472616E73666F726D3A207472616E736C617465592834307078293B0A202020202D6D732D7472616E73666F';
wwv_flow_api.g_varchar2_table(10) := '726D3A207472616E736C617465592834307078293B0A202020202D6F2D7472616E73666F726D3A207472616E736C617465592834307078293B0A202020207472616E73666F726D3A207472616E736C617465592834307078293B207D0A20203330252C20';
wwv_flow_api.g_varchar2_table(11) := '373025207B0A202020206F7061636974793A20313B0A202020202D7765626B69742D7472616E73666F726D3A207472616E736C6174655928307078293B0A202020202D6D6F7A2D7472616E73666F726D3A207472616E736C6174655928307078293B0A20';
wwv_flow_api.g_varchar2_table(12) := '2020202D6D732D7472616E73666F726D3A207472616E736C6174655928307078293B0A202020202D6F2D7472616E73666F726D3A207472616E736C6174655928307078293B0A202020207472616E73666F726D3A207472616E736C617465592830707829';
wwv_flow_api.g_varchar2_table(13) := '3B207D0A202031303025207B0A202020206F7061636974793A20303B0A202020202D7765626B69742D7472616E73666F726D3A207472616E736C61746559282D34307078293B0A202020202D6D6F7A2D7472616E73666F726D3A207472616E736C617465';
wwv_flow_api.g_varchar2_table(14) := '59282D34307078293B0A202020202D6D732D7472616E73666F726D3A207472616E736C61746559282D34307078293B0A202020202D6F2D7472616E73666F726D3A207472616E736C61746559282D34307078293B0A202020207472616E73666F726D3A20';
wwv_flow_api.g_varchar2_table(15) := '7472616E736C61746559282D34307078293B207D207D0A406B65796672616D65732070617373696E672D7468726F756768207B0A20203025207B0A202020206F7061636974793A20303B0A202020202D7765626B69742D7472616E73666F726D3A207472';
wwv_flow_api.g_varchar2_table(16) := '616E736C617465592834307078293B0A202020202D6D6F7A2D7472616E73666F726D3A207472616E736C617465592834307078293B0A202020202D6D732D7472616E73666F726D3A207472616E736C617465592834307078293B0A202020202D6F2D7472';
wwv_flow_api.g_varchar2_table(17) := '616E73666F726D3A207472616E736C617465592834307078293B0A202020207472616E73666F726D3A207472616E736C617465592834307078293B207D0A20203330252C20373025207B0A202020206F7061636974793A20313B0A202020202D7765626B';
wwv_flow_api.g_varchar2_table(18) := '69742D7472616E73666F726D3A207472616E736C6174655928307078293B0A202020202D6D6F7A2D7472616E73666F726D3A207472616E736C6174655928307078293B0A202020202D6D732D7472616E73666F726D3A207472616E736C61746559283070';
wwv_flow_api.g_varchar2_table(19) := '78293B0A202020202D6F2D7472616E73666F726D3A207472616E736C6174655928307078293B0A202020207472616E73666F726D3A207472616E736C6174655928307078293B207D0A202031303025207B0A202020206F7061636974793A20303B0A2020';
wwv_flow_api.g_varchar2_table(20) := '20202D7765626B69742D7472616E73666F726D3A207472616E736C61746559282D34307078293B0A202020202D6D6F7A2D7472616E73666F726D3A207472616E736C61746559282D34307078293B0A202020202D6D732D7472616E73666F726D3A207472';
wwv_flow_api.g_varchar2_table(21) := '616E736C61746559282D34307078293B0A202020202D6F2D7472616E73666F726D3A207472616E736C61746559282D34307078293B0A202020207472616E73666F726D3A207472616E736C61746559282D34307078293B207D207D0A402D7765626B6974';
wwv_flow_api.g_varchar2_table(22) := '2D6B65796672616D657320736C6964652D696E207B0A20203025207B0A202020206F7061636974793A20303B0A202020202D7765626B69742D7472616E73666F726D3A207472616E736C617465592834307078293B0A202020202D6D6F7A2D7472616E73';
wwv_flow_api.g_varchar2_table(23) := '666F726D3A207472616E736C617465592834307078293B0A202020202D6D732D7472616E73666F726D3A207472616E736C617465592834307078293B0A202020202D6F2D7472616E73666F726D3A207472616E736C617465592834307078293B0A202020';
wwv_flow_api.g_varchar2_table(24) := '207472616E73666F726D3A207472616E736C617465592834307078293B207D0A2020333025207B0A202020206F7061636974793A20313B0A202020202D7765626B69742D7472616E73666F726D3A207472616E736C6174655928307078293B0A20202020';
wwv_flow_api.g_varchar2_table(25) := '2D6D6F7A2D7472616E73666F726D3A207472616E736C6174655928307078293B0A202020202D6D732D7472616E73666F726D3A207472616E736C6174655928307078293B0A202020202D6F2D7472616E73666F726D3A207472616E736C61746559283070';
wwv_flow_api.g_varchar2_table(26) := '78293B0A202020207472616E73666F726D3A207472616E736C6174655928307078293B207D207D0A402D6D6F7A2D6B65796672616D657320736C6964652D696E207B0A20203025207B0A202020206F7061636974793A20303B0A202020202D7765626B69';
wwv_flow_api.g_varchar2_table(27) := '742D7472616E73666F726D3A207472616E736C617465592834307078293B0A202020202D6D6F7A2D7472616E73666F726D3A207472616E736C617465592834307078293B0A202020202D6D732D7472616E73666F726D3A207472616E736C617465592834';
wwv_flow_api.g_varchar2_table(28) := '307078293B0A202020202D6F2D7472616E73666F726D3A207472616E736C617465592834307078293B0A202020207472616E73666F726D3A207472616E736C617465592834307078293B207D0A2020333025207B0A202020206F7061636974793A20313B';
wwv_flow_api.g_varchar2_table(29) := '0A202020202D7765626B69742D7472616E73666F726D3A207472616E736C6174655928307078293B0A202020202D6D6F7A2D7472616E73666F726D3A207472616E736C6174655928307078293B0A202020202D6D732D7472616E73666F726D3A20747261';
wwv_flow_api.g_varchar2_table(30) := '6E736C6174655928307078293B0A202020202D6F2D7472616E73666F726D3A207472616E736C6174655928307078293B0A202020207472616E73666F726D3A207472616E736C6174655928307078293B207D207D0A406B65796672616D657320736C6964';
wwv_flow_api.g_varchar2_table(31) := '652D696E207B0A20203025207B0A202020206F7061636974793A20303B0A202020202D7765626B69742D7472616E73666F726D3A207472616E736C617465592834307078293B0A202020202D6D6F7A2D7472616E73666F726D3A207472616E736C617465';
wwv_flow_api.g_varchar2_table(32) := '592834307078293B0A202020202D6D732D7472616E73666F726D3A207472616E736C617465592834307078293B0A202020202D6F2D7472616E73666F726D3A207472616E736C617465592834307078293B0A202020207472616E73666F726D3A20747261';
wwv_flow_api.g_varchar2_table(33) := '6E736C617465592834307078293B207D0A2020333025207B0A202020206F7061636974793A20313B0A202020202D7765626B69742D7472616E73666F726D3A207472616E736C6174655928307078293B0A202020202D6D6F7A2D7472616E73666F726D3A';
wwv_flow_api.g_varchar2_table(34) := '207472616E736C6174655928307078293B0A202020202D6D732D7472616E73666F726D3A207472616E736C6174655928307078293B0A202020202D6F2D7472616E73666F726D3A207472616E736C6174655928307078293B0A202020207472616E73666F';
wwv_flow_api.g_varchar2_table(35) := '726D3A207472616E736C6174655928307078293B207D207D0A402D7765626B69742D6B65796672616D65732070756C7365207B0A20203025207B0A202020202D7765626B69742D7472616E73666F726D3A207363616C652831293B0A202020202D6D6F7A';
wwv_flow_api.g_varchar2_table(36) := '2D7472616E73666F726D3A207363616C652831293B0A202020202D6D732D7472616E73666F726D3A207363616C652831293B0A202020202D6F2D7472616E73666F726D3A207363616C652831293B0A202020207472616E73666F726D3A207363616C6528';
wwv_flow_api.g_varchar2_table(37) := '31293B207D0A2020313025207B0A202020202D7765626B69742D7472616E73666F726D3A207363616C6528312E31293B0A202020202D6D6F7A2D7472616E73666F726D3A207363616C6528312E31293B0A202020202D6D732D7472616E73666F726D3A20';
wwv_flow_api.g_varchar2_table(38) := '7363616C6528312E31293B0A202020202D6F2D7472616E73666F726D3A207363616C6528312E31293B0A202020207472616E73666F726D3A207363616C6528312E31293B207D0A2020323025207B0A202020202D7765626B69742D7472616E73666F726D';
wwv_flow_api.g_varchar2_table(39) := '3A207363616C652831293B0A202020202D6D6F7A2D7472616E73666F726D3A207363616C652831293B0A202020202D6D732D7472616E73666F726D3A207363616C652831293B0A202020202D6F2D7472616E73666F726D3A207363616C652831293B0A20';
wwv_flow_api.g_varchar2_table(40) := '2020207472616E73666F726D3A207363616C652831293B207D207D0A402D6D6F7A2D6B65796672616D65732070756C7365207B0A20203025207B0A202020202D7765626B69742D7472616E73666F726D3A207363616C652831293B0A202020202D6D6F7A';
wwv_flow_api.g_varchar2_table(41) := '2D7472616E73666F726D3A207363616C652831293B0A202020202D6D732D7472616E73666F726D3A207363616C652831293B0A202020202D6F2D7472616E73666F726D3A207363616C652831293B0A202020207472616E73666F726D3A207363616C6528';
wwv_flow_api.g_varchar2_table(42) := '31293B207D0A2020313025207B0A202020202D7765626B69742D7472616E73666F726D3A207363616C6528312E31293B0A202020202D6D6F7A2D7472616E73666F726D3A207363616C6528312E31293B0A202020202D6D732D7472616E73666F726D3A20';
wwv_flow_api.g_varchar2_table(43) := '7363616C6528312E31293B0A202020202D6F2D7472616E73666F726D3A207363616C6528312E31293B0A202020207472616E73666F726D3A207363616C6528312E31293B207D0A2020323025207B0A202020202D7765626B69742D7472616E73666F726D';
wwv_flow_api.g_varchar2_table(44) := '3A207363616C652831293B0A202020202D6D6F7A2D7472616E73666F726D3A207363616C652831293B0A202020202D6D732D7472616E73666F726D3A207363616C652831293B0A202020202D6F2D7472616E73666F726D3A207363616C652831293B0A20';
wwv_flow_api.g_varchar2_table(45) := '2020207472616E73666F726D3A207363616C652831293B207D207D0A406B65796672616D65732070756C7365207B0A20203025207B0A202020202D7765626B69742D7472616E73666F726D3A207363616C652831293B0A202020202D6D6F7A2D7472616E';
wwv_flow_api.g_varchar2_table(46) := '73666F726D3A207363616C652831293B0A202020202D6D732D7472616E73666F726D3A207363616C652831293B0A202020202D6F2D7472616E73666F726D3A207363616C652831293B0A202020207472616E73666F726D3A207363616C652831293B207D';
wwv_flow_api.g_varchar2_table(47) := '0A2020313025207B0A202020202D7765626B69742D7472616E73666F726D3A207363616C6528312E31293B0A202020202D6D6F7A2D7472616E73666F726D3A207363616C6528312E31293B0A202020202D6D732D7472616E73666F726D3A207363616C65';
wwv_flow_api.g_varchar2_table(48) := '28312E31293B0A202020202D6F2D7472616E73666F726D3A207363616C6528312E31293B0A202020207472616E73666F726D3A207363616C6528312E31293B207D0A2020323025207B0A202020202D7765626B69742D7472616E73666F726D3A20736361';
wwv_flow_api.g_varchar2_table(49) := '6C652831293B0A202020202D6D6F7A2D7472616E73666F726D3A207363616C652831293B0A202020202D6D732D7472616E73666F726D3A207363616C652831293B0A202020202D6F2D7472616E73666F726D3A207363616C652831293B0A202020207472';
wwv_flow_api.g_varchar2_table(50) := '616E73666F726D3A207363616C652831293B207D207D0A2E64726F707A6F6E652C202E64726F707A6F6E65202A207B0A2020626F782D73697A696E673A20626F726465722D626F783B207D0A0A2E64726F707A6F6E65207B0A20206D696E2D6865696768';
wwv_flow_api.g_varchar2_table(51) := '743A2031353070783B0A2020626F726465723A2032707820736F6C6964207267626128302C20302C20302C20302E33293B0A20206261636B67726F756E643A2077686974653B0A202070616464696E673A203230707820323070783B207D0A20202E6472';
wwv_flow_api.g_varchar2_table(52) := '6F707A6F6E652E647A2D636C69636B61626C65207B0A20202020637572736F723A20706F696E7465723B207D0A202020202E64726F707A6F6E652E647A2D636C69636B61626C65202A207B0A202020202020637572736F723A2064656661756C743B207D';
wwv_flow_api.g_varchar2_table(53) := '0A202020202E64726F707A6F6E652E647A2D636C69636B61626C65202E647A2D6D6573736167652C202E64726F707A6F6E652E647A2D636C69636B61626C65202E647A2D6D657373616765202A207B0A202020202020637572736F723A20706F696E7465';
wwv_flow_api.g_varchar2_table(54) := '723B207D0A20202E64726F707A6F6E652E647A2D73746172746564202E647A2D6D657373616765207B0A20202020646973706C61793A206E6F6E653B207D0A20202E64726F707A6F6E652E647A2D647261672D686F766572207B0A20202020626F726465';
wwv_flow_api.g_varchar2_table(55) := '722D7374796C653A20736F6C69643B207D0A202020202E64726F707A6F6E652E647A2D647261672D686F766572202E647A2D6D657373616765207B0A2020202020206F7061636974793A20302E353B207D0A20202E64726F707A6F6E65202E647A2D6D65';
wwv_flow_api.g_varchar2_table(56) := '7373616765207B0A20202020746578742D616C69676E3A2063656E7465723B0A202020206D617267696E3A2032656D20303B207D0A20202E64726F707A6F6E65202E647A2D70726576696577207B0A20202020706F736974696F6E3A2072656C61746976';
wwv_flow_api.g_varchar2_table(57) := '653B0A20202020646973706C61793A20696E6C696E652D626C6F636B3B0A20202020766572746963616C2D616C69676E3A20746F703B0A202020206D617267696E3A20313670783B0A202020206D696E2D6865696768743A2031303070783B207D0A2020';
wwv_flow_api.g_varchar2_table(58) := '20202E64726F707A6F6E65202E647A2D707265766965773A686F766572207B0A2020202020207A2D696E6465783A20313030303B207D0A2020202020202E64726F707A6F6E65202E647A2D707265766965773A686F766572202E647A2D64657461696C73';
wwv_flow_api.g_varchar2_table(59) := '207B0A20202020202020206F7061636974793A20313B207D0A202020202E64726F707A6F6E65202E647A2D707265766965772E647A2D66696C652D70726576696577202E647A2D696D616765207B0A202020202020626F726465722D7261646975733A20';
wwv_flow_api.g_varchar2_table(60) := '323070783B0A2020202020206261636B67726F756E643A20233939393B0A2020202020206261636B67726F756E643A206C696E6561722D6772616469656E7428746F20626F74746F6D2C20236565652C2023646464293B207D0A202020202E64726F707A';
wwv_flow_api.g_varchar2_table(61) := '6F6E65202E647A2D707265766965772E647A2D66696C652D70726576696577202E647A2D64657461696C73207B0A2020202020206F7061636974793A20313B207D0A202020202E64726F707A6F6E65202E647A2D707265766965772E647A2D696D616765';
wwv_flow_api.g_varchar2_table(62) := '2D70726576696577207B0A2020202020206261636B67726F756E643A2077686974653B207D0A2020202020202E64726F707A6F6E65202E647A2D707265766965772E647A2D696D6167652D70726576696577202E647A2D64657461696C73207B0A202020';
wwv_flow_api.g_varchar2_table(63) := '20202020202D7765626B69742D7472616E736974696F6E3A206F70616369747920302E3273206C696E6561723B0A20202020202020202D6D6F7A2D7472616E736974696F6E3A206F70616369747920302E3273206C696E6561723B0A2020202020202020';
wwv_flow_api.g_varchar2_table(64) := '2D6D732D7472616E736974696F6E3A206F70616369747920302E3273206C696E6561723B0A20202020202020202D6F2D7472616E736974696F6E3A206F70616369747920302E3273206C696E6561723B0A20202020202020207472616E736974696F6E3A';
wwv_flow_api.g_varchar2_table(65) := '206F70616369747920302E3273206C696E6561723B207D0A202020202E64726F707A6F6E65202E647A2D70726576696577202E647A2D72656D6F7665207B0A202020202020666F6E742D73697A653A20313470783B0A202020202020746578742D616C69';
wwv_flow_api.g_varchar2_table(66) := '676E3A2063656E7465723B0A202020202020646973706C61793A20626C6F636B3B0A202020202020637572736F723A20706F696E7465723B0A202020202020626F726465723A206E6F6E653B207D0A2020202020202E64726F707A6F6E65202E647A2D70';
wwv_flow_api.g_varchar2_table(67) := '726576696577202E647A2D72656D6F76653A686F766572207B0A2020202020202020746578742D6465636F726174696F6E3A20756E6465726C696E653B207D0A202020202E64726F707A6F6E65202E647A2D707265766965773A686F766572202E647A2D';
wwv_flow_api.g_varchar2_table(68) := '64657461696C73207B0A2020202020206F7061636974793A20313B207D0A202020202E64726F707A6F6E65202E647A2D70726576696577202E647A2D64657461696C73207B0A2020202020207A2D696E6465783A2032303B0A202020202020706F736974';
wwv_flow_api.g_varchar2_table(69) := '696F6E3A206162736F6C7574653B0A202020202020746F703A20303B0A2020202020206C6566743A20303B0A2020202020206F7061636974793A20303B0A202020202020666F6E742D73697A653A20313370783B0A2020202020206D696E2D7769647468';
wwv_flow_api.g_varchar2_table(70) := '3A20313030253B0A2020202020206D61782D77696474683A20313030253B0A20202020202070616464696E673A2032656D2031656D3B0A202020202020746578742D616C69676E3A2063656E7465723B0A202020202020636F6C6F723A20726762612830';
wwv_flow_api.g_varchar2_table(71) := '2C20302C20302C20302E39293B0A2020202020206C696E652D6865696768743A20313530253B207D0A2020202020202E64726F707A6F6E65202E647A2D70726576696577202E647A2D64657461696C73202E647A2D73697A65207B0A2020202020202020';
wwv_flow_api.g_varchar2_table(72) := '6D617267696E2D626F74746F6D3A2031656D3B0A2020202020202020666F6E742D73697A653A20313670783B207D0A2020202020202E64726F707A6F6E65202E647A2D70726576696577202E647A2D64657461696C73202E647A2D66696C656E616D6520';
wwv_flow_api.g_varchar2_table(73) := '7B0A202020202020202077686974652D73706163653A206E6F777261703B207D0A20202020202020202E64726F707A6F6E65202E647A2D70726576696577202E647A2D64657461696C73202E647A2D66696C656E616D653A686F766572207370616E207B';
wwv_flow_api.g_varchar2_table(74) := '0A20202020202020202020626F726465723A2031707820736F6C69642072676261283230302C203230302C203230302C20302E38293B0A202020202020202020206261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235';
wwv_flow_api.g_varchar2_table(75) := '352C20302E38293B207D0A20202020202020202E64726F707A6F6E65202E647A2D70726576696577202E647A2D64657461696C73202E647A2D66696C656E616D653A6E6F74283A686F76657229207B0A202020202020202020206F766572666C6F773A20';
wwv_flow_api.g_varchar2_table(76) := '68696464656E3B0A20202020202020202020746578742D6F766572666C6F773A20656C6C69707369733B207D0A202020202020202020202E64726F707A6F6E65202E647A2D70726576696577202E647A2D64657461696C73202E647A2D66696C656E616D';
wwv_flow_api.g_varchar2_table(77) := '653A6E6F74283A686F76657229207370616E207B0A202020202020202020202020626F726465723A2031707820736F6C6964207472616E73706172656E743B207D0A2020202020202E64726F707A6F6E65202E647A2D70726576696577202E647A2D6465';
wwv_flow_api.g_varchar2_table(78) := '7461696C73202E647A2D66696C656E616D65207370616E2C202E64726F707A6F6E65202E647A2D70726576696577202E647A2D64657461696C73202E647A2D73697A65207370616E207B0A20202020202020206261636B67726F756E642D636F6C6F723A';
wwv_flow_api.g_varchar2_table(79) := '2072676261283235352C203235352C203235352C20302E34293B0A202020202020202070616464696E673A203020302E34656D3B0A2020202020202020626F726465722D7261646975733A203370783B207D0A202020202E64726F707A6F6E65202E647A';
wwv_flow_api.g_varchar2_table(80) := '2D707265766965773A686F766572202E647A2D696D61676520696D67207B0A2020202020202D7765626B69742D7472616E73666F726D3A207363616C6528312E30352C20312E3035293B0A2020202020202D6D6F7A2D7472616E73666F726D3A20736361';
wwv_flow_api.g_varchar2_table(81) := '6C6528312E30352C20312E3035293B0A2020202020202D6D732D7472616E73666F726D3A207363616C6528312E30352C20312E3035293B0A2020202020202D6F2D7472616E73666F726D3A207363616C6528312E30352C20312E3035293B0A2020202020';
wwv_flow_api.g_varchar2_table(82) := '207472616E73666F726D3A207363616C6528312E30352C20312E3035293B0A2020202020202D7765626B69742D66696C7465723A20626C757228387078293B0A20202020202066696C7465723A20626C757228387078293B207D0A202020202E64726F70';
wwv_flow_api.g_varchar2_table(83) := '7A6F6E65202E647A2D70726576696577202E647A2D696D616765207B0A202020202020626F726465722D7261646975733A20323070783B0A2020202020206F766572666C6F773A2068696464656E3B0A20202020202077696474683A2031323070783B0A';
wwv_flow_api.g_varchar2_table(84) := '2020202020206865696768743A2031323070783B0A202020202020706F736974696F6E3A2072656C61746976653B0A202020202020646973706C61793A20626C6F636B3B0A2020202020207A2D696E6465783A2031303B207D0A2020202020202E64726F';
wwv_flow_api.g_varchar2_table(85) := '707A6F6E65202E647A2D70726576696577202E647A2D696D61676520696D67207B0A2020202020202020646973706C61793A20626C6F636B3B207D0A202020202E64726F707A6F6E65202E647A2D707265766965772E647A2D73756363657373202E647A';
wwv_flow_api.g_varchar2_table(86) := '2D737563636573732D6D61726B207B0A2020202020202D7765626B69742D616E696D6174696F6E3A2070617373696E672D7468726F7567682033732063756269632D62657A69657228302E37372C20302C20302E3137352C2031293B0A2020202020202D';
wwv_flow_api.g_varchar2_table(87) := '6D6F7A2D616E696D6174696F6E3A2070617373696E672D7468726F7567682033732063756269632D62657A69657228302E37372C20302C20302E3137352C2031293B0A2020202020202D6D732D616E696D6174696F6E3A2070617373696E672D7468726F';
wwv_flow_api.g_varchar2_table(88) := '7567682033732063756269632D62657A69657228302E37372C20302C20302E3137352C2031293B0A2020202020202D6F2D616E696D6174696F6E3A2070617373696E672D7468726F7567682033732063756269632D62657A69657228302E37372C20302C';
wwv_flow_api.g_varchar2_table(89) := '20302E3137352C2031293B0A202020202020616E696D6174696F6E3A2070617373696E672D7468726F7567682033732063756269632D62657A69657228302E37372C20302C20302E3137352C2031293B207D0A202020202E64726F707A6F6E65202E647A';
wwv_flow_api.g_varchar2_table(90) := '2D707265766965772E647A2D6572726F72202E647A2D6572726F722D6D61726B207B0A2020202020206F7061636974793A20313B0A2020202020202D7765626B69742D616E696D6174696F6E3A20736C6964652D696E2033732063756269632D62657A69';
wwv_flow_api.g_varchar2_table(91) := '657228302E37372C20302C20302E3137352C2031293B0A2020202020202D6D6F7A2D616E696D6174696F6E3A20736C6964652D696E2033732063756269632D62657A69657228302E37372C20302C20302E3137352C2031293B0A2020202020202D6D732D';
wwv_flow_api.g_varchar2_table(92) := '616E696D6174696F6E3A20736C6964652D696E2033732063756269632D62657A69657228302E37372C20302C20302E3137352C2031293B0A2020202020202D6F2D616E696D6174696F6E3A20736C6964652D696E2033732063756269632D62657A696572';
wwv_flow_api.g_varchar2_table(93) := '28302E37372C20302C20302E3137352C2031293B0A202020202020616E696D6174696F6E3A20736C6964652D696E2033732063756269632D62657A69657228302E37372C20302C20302E3137352C2031293B207D0A202020202E64726F707A6F6E65202E';
wwv_flow_api.g_varchar2_table(94) := '647A2D70726576696577202E647A2D737563636573732D6D61726B2C202E64726F707A6F6E65202E647A2D70726576696577202E647A2D6572726F722D6D61726B207B0A202020202020706F696E7465722D6576656E74733A206E6F6E653B0A20202020';
wwv_flow_api.g_varchar2_table(95) := '20206F7061636974793A20303B0A2020202020207A2D696E6465783A203530303B0A202020202020706F736974696F6E3A206162736F6C7574653B0A202020202020646973706C61793A20626C6F636B3B0A202020202020746F703A203530253B0A2020';
wwv_flow_api.g_varchar2_table(96) := '202020206C6566743A203530253B0A2020202020206D617267696E2D6C6566743A202D323770783B0A2020202020206D617267696E2D746F703A202D323770783B207D0A2020202020202E64726F707A6F6E65202E647A2D70726576696577202E647A2D';
wwv_flow_api.g_varchar2_table(97) := '737563636573732D6D61726B207376672C202E64726F707A6F6E65202E647A2D70726576696577202E647A2D6572726F722D6D61726B20737667207B0A2020202020202020646973706C61793A20626C6F636B3B0A202020202020202077696474683A20';
wwv_flow_api.g_varchar2_table(98) := '353470783B0A20202020202020206865696768743A20353470783B207D0A202020202E64726F707A6F6E65202E647A2D707265766965772E647A2D70726F63657373696E67202E647A2D70726F6772657373207B0A2020202020206F7061636974793A20';
wwv_flow_api.g_varchar2_table(99) := '313B0A2020202020202D7765626B69742D7472616E736974696F6E3A20616C6C20302E3273206C696E6561723B0A2020202020202D6D6F7A2D7472616E736974696F6E3A20616C6C20302E3273206C696E6561723B0A2020202020202D6D732D7472616E';
wwv_flow_api.g_varchar2_table(100) := '736974696F6E3A20616C6C20302E3273206C696E6561723B0A2020202020202D6F2D7472616E736974696F6E3A20616C6C20302E3273206C696E6561723B0A2020202020207472616E736974696F6E3A20616C6C20302E3273206C696E6561723B207D0A';
wwv_flow_api.g_varchar2_table(101) := '202020202E64726F707A6F6E65202E647A2D707265766965772E647A2D636F6D706C657465202E647A2D70726F6772657373207B0A2020202020206F7061636974793A20303B0A2020202020202D7765626B69742D7472616E736974696F6E3A206F7061';
wwv_flow_api.g_varchar2_table(102) := '6369747920302E347320656173652D696E3B0A2020202020202D6D6F7A2D7472616E736974696F6E3A206F70616369747920302E347320656173652D696E3B0A2020202020202D6D732D7472616E736974696F6E3A206F70616369747920302E34732065';
wwv_flow_api.g_varchar2_table(103) := '6173652D696E3B0A2020202020202D6F2D7472616E736974696F6E3A206F70616369747920302E347320656173652D696E3B0A2020202020207472616E736974696F6E3A206F70616369747920302E347320656173652D696E3B207D0A202020202E6472';
wwv_flow_api.g_varchar2_table(104) := '6F707A6F6E65202E647A2D707265766965773A6E6F74282E647A2D70726F63657373696E6729202E647A2D70726F6772657373207B0A2020202020202D7765626B69742D616E696D6174696F6E3A2070756C7365203673206561736520696E66696E6974';
wwv_flow_api.g_varchar2_table(105) := '653B0A2020202020202D6D6F7A2D616E696D6174696F6E3A2070756C7365203673206561736520696E66696E6974653B0A2020202020202D6D732D616E696D6174696F6E3A2070756C7365203673206561736520696E66696E6974653B0A202020202020';
wwv_flow_api.g_varchar2_table(106) := '2D6F2D616E696D6174696F6E3A2070756C7365203673206561736520696E66696E6974653B0A202020202020616E696D6174696F6E3A2070756C7365203673206561736520696E66696E6974653B207D0A202020202E64726F707A6F6E65202E647A2D70';
wwv_flow_api.g_varchar2_table(107) := '726576696577202E647A2D70726F6772657373207B0A2020202020206F7061636974793A20313B0A2020202020207A2D696E6465783A20313030303B0A202020202020706F696E7465722D6576656E74733A206E6F6E653B0A202020202020706F736974';
wwv_flow_api.g_varchar2_table(108) := '696F6E3A206162736F6C7574653B0A2020202020206865696768743A20313670783B0A2020202020206C6566743A203530253B0A202020202020746F703A203530253B0A2020202020206D617267696E2D746F703A202D3870783B0A2020202020207769';
wwv_flow_api.g_varchar2_table(109) := '6474683A20383070783B0A2020202020206D617267696E2D6C6566743A202D343070783B0A2020202020206261636B67726F756E643A2072676261283235352C203235352C203235352C20302E39293B0A2020202020202D7765626B69742D7472616E73';
wwv_flow_api.g_varchar2_table(110) := '666F726D3A207363616C652831293B0A202020202020626F726465722D7261646975733A203870783B0A2020202020206F766572666C6F773A2068696464656E3B207D0A2020202020202E64726F707A6F6E65202E647A2D70726576696577202E647A2D';
wwv_flow_api.g_varchar2_table(111) := '70726F6772657373202E647A2D75706C6F6164207B0A20202020202020206261636B67726F756E643A20233333333B0A20202020202020206261636B67726F756E643A206C696E6561722D6772616469656E7428746F20626F74746F6D2C20233636362C';
wwv_flow_api.g_varchar2_table(112) := '2023343434293B0A2020202020202020706F736974696F6E3A206162736F6C7574653B0A2020202020202020746F703A20303B0A20202020202020206C6566743A20303B0A2020202020202020626F74746F6D3A20303B0A202020202020202077696474';
wwv_flow_api.g_varchar2_table(113) := '683A20303B0A20202020202020202D7765626B69742D7472616E736974696F6E3A207769647468203330306D7320656173652D696E2D6F75743B0A20202020202020202D6D6F7A2D7472616E736974696F6E3A207769647468203330306D732065617365';
wwv_flow_api.g_varchar2_table(114) := '2D696E2D6F75743B0A20202020202020202D6D732D7472616E736974696F6E3A207769647468203330306D7320656173652D696E2D6F75743B0A20202020202020202D6F2D7472616E736974696F6E3A207769647468203330306D7320656173652D696E';
wwv_flow_api.g_varchar2_table(115) := '2D6F75743B0A20202020202020207472616E736974696F6E3A207769647468203330306D7320656173652D696E2D6F75743B207D0A202020202E64726F707A6F6E65202E647A2D707265766965772E647A2D6572726F72202E647A2D6572726F722D6D65';
wwv_flow_api.g_varchar2_table(116) := '7373616765207B0A202020202020646973706C61793A20626C6F636B3B207D0A202020202E64726F707A6F6E65202E647A2D707265766965772E647A2D6572726F723A686F766572202E647A2D6572726F722D6D657373616765207B0A2020202020206F';
wwv_flow_api.g_varchar2_table(117) := '7061636974793A20313B0A202020202020706F696E7465722D6576656E74733A206175746F3B207D0A202020202E64726F707A6F6E65202E647A2D70726576696577202E647A2D6572726F722D6D657373616765207B0A202020202020706F696E746572';
wwv_flow_api.g_varchar2_table(118) := '2D6576656E74733A206E6F6E653B0A2020202020207A2D696E6465783A20313030303B0A202020202020706F736974696F6E3A206162736F6C7574653B0A202020202020646973706C61793A20626C6F636B3B0A202020202020646973706C61793A206E';
wwv_flow_api.g_varchar2_table(119) := '6F6E653B0A2020202020206F7061636974793A20303B0A2020202020202D7765626B69742D7472616E736974696F6E3A206F70616369747920302E337320656173653B0A2020202020202D6D6F7A2D7472616E736974696F6E3A206F7061636974792030';
wwv_flow_api.g_varchar2_table(120) := '2E337320656173653B0A2020202020202D6D732D7472616E736974696F6E3A206F70616369747920302E337320656173653B0A2020202020202D6F2D7472616E736974696F6E3A206F70616369747920302E337320656173653B0A202020202020747261';
wwv_flow_api.g_varchar2_table(121) := '6E736974696F6E3A206F70616369747920302E337320656173653B0A202020202020626F726465722D7261646975733A203870783B0A202020202020666F6E742D73697A653A20313370783B0A202020202020746F703A2031333070783B0A2020202020';
wwv_flow_api.g_varchar2_table(122) := '206C6566743A202D313070783B0A20202020202077696474683A2031343070783B0A2020202020206261636B67726F756E643A20236265323632363B0A2020202020206261636B67726F756E643A206C696E6561722D6772616469656E7428746F20626F';
wwv_flow_api.g_varchar2_table(123) := '74746F6D2C20236265323632362C2023613932323232293B0A20202020202070616464696E673A20302E35656D20312E32656D3B0A202020202020636F6C6F723A2077686974653B207D0A2020202020202E64726F707A6F6E65202E647A2D7072657669';
wwv_flow_api.g_varchar2_table(124) := '6577202E647A2D6572726F722D6D6573736167653A6166746572207B0A2020202020202020636F6E74656E743A2027273B0A2020202020202020706F736974696F6E3A206162736F6C7574653B0A2020202020202020746F703A202D3670783B0A202020';
wwv_flow_api.g_varchar2_table(125) := '20202020206C6566743A20363470783B0A202020202020202077696474683A20303B0A20202020202020206865696768743A20303B0A2020202020202020626F726465722D6C6566743A2036707820736F6C6964207472616E73706172656E743B0A2020';
wwv_flow_api.g_varchar2_table(126) := '202020202020626F726465722D72696768743A2036707820736F6C6964207472616E73706172656E743B0A2020202020202020626F726465722D626F74746F6D3A2036707820736F6C696420236265323632363B207D0A';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72338869719797127)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'css/dropzone.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '402D7765626B69742D6B65796672616D65732070617373696E672D7468726F7567687B30257B6F7061636974793A303B2D7765626B69742D7472616E73666F726D3A7472616E736C617465592834307078293B2D6D6F7A2D7472616E73666F726D3A7472';
wwv_flow_api.g_varchar2_table(2) := '616E736C617465592834307078293B2D6D732D7472616E73666F726D3A7472616E736C617465592834307078293B2D6F2D7472616E73666F726D3A7472616E736C617465592834307078293B7472616E73666F726D3A7472616E736C6174655928343070';
wwv_flow_api.g_varchar2_table(3) := '78297D3330252C3730257B6F7061636974793A313B2D7765626B69742D7472616E73666F726D3A7472616E736C617465592830293B2D6D6F7A2D7472616E73666F726D3A7472616E736C617465592830293B2D6D732D7472616E73666F726D3A7472616E';
wwv_flow_api.g_varchar2_table(4) := '736C617465592830293B2D6F2D7472616E73666F726D3A7472616E736C617465592830293B7472616E73666F726D3A7472616E736C617465592830297D746F7B6F7061636974793A303B2D7765626B69742D7472616E73666F726D3A7472616E736C6174';
wwv_flow_api.g_varchar2_table(5) := '6559282D34307078293B2D6D6F7A2D7472616E73666F726D3A7472616E736C61746559282D34307078293B2D6D732D7472616E73666F726D3A7472616E736C61746559282D34307078293B2D6F2D7472616E73666F726D3A7472616E736C61746559282D';
wwv_flow_api.g_varchar2_table(6) := '34307078293B7472616E73666F726D3A7472616E736C61746559282D34307078297D7D402D6D6F7A2D6B65796672616D65732070617373696E672D7468726F7567687B30257B6F7061636974793A303B2D7765626B69742D7472616E73666F726D3A7472';
wwv_flow_api.g_varchar2_table(7) := '616E736C617465592834307078293B2D6D6F7A2D7472616E73666F726D3A7472616E736C617465592834307078293B2D6D732D7472616E73666F726D3A7472616E736C617465592834307078293B2D6F2D7472616E73666F726D3A7472616E736C617465';
wwv_flow_api.g_varchar2_table(8) := '592834307078293B7472616E73666F726D3A7472616E736C617465592834307078297D3330252C3730257B6F7061636974793A313B2D7765626B69742D7472616E73666F726D3A7472616E736C617465592830293B2D6D6F7A2D7472616E73666F726D3A';
wwv_flow_api.g_varchar2_table(9) := '7472616E736C617465592830293B2D6D732D7472616E73666F726D3A7472616E736C617465592830293B2D6F2D7472616E73666F726D3A7472616E736C617465592830293B7472616E73666F726D3A7472616E736C617465592830297D746F7B6F706163';
wwv_flow_api.g_varchar2_table(10) := '6974793A303B2D7765626B69742D7472616E73666F726D3A7472616E736C61746559282D34307078293B2D6D6F7A2D7472616E73666F726D3A7472616E736C61746559282D34307078293B2D6D732D7472616E73666F726D3A7472616E736C6174655928';
wwv_flow_api.g_varchar2_table(11) := '2D34307078293B2D6F2D7472616E73666F726D3A7472616E736C61746559282D34307078293B7472616E73666F726D3A7472616E736C61746559282D34307078297D7D406B65796672616D65732070617373696E672D7468726F7567687B30257B6F7061';
wwv_flow_api.g_varchar2_table(12) := '636974793A303B2D7765626B69742D7472616E73666F726D3A7472616E736C617465592834307078293B2D6D6F7A2D7472616E73666F726D3A7472616E736C617465592834307078293B2D6D732D7472616E73666F726D3A7472616E736C617465592834';
wwv_flow_api.g_varchar2_table(13) := '307078293B2D6F2D7472616E73666F726D3A7472616E736C617465592834307078293B7472616E73666F726D3A7472616E736C617465592834307078297D3330252C3730257B6F7061636974793A313B2D7765626B69742D7472616E73666F726D3A7472';
wwv_flow_api.g_varchar2_table(14) := '616E736C617465592830293B2D6D6F7A2D7472616E73666F726D3A7472616E736C617465592830293B2D6D732D7472616E73666F726D3A7472616E736C617465592830293B2D6F2D7472616E73666F726D3A7472616E736C617465592830293B7472616E';
wwv_flow_api.g_varchar2_table(15) := '73666F726D3A7472616E736C617465592830297D746F7B6F7061636974793A303B2D7765626B69742D7472616E73666F726D3A7472616E736C61746559282D34307078293B2D6D6F7A2D7472616E73666F726D3A7472616E736C61746559282D34307078';
wwv_flow_api.g_varchar2_table(16) := '293B2D6D732D7472616E73666F726D3A7472616E736C61746559282D34307078293B2D6F2D7472616E73666F726D3A7472616E736C61746559282D34307078293B7472616E73666F726D3A7472616E736C61746559282D34307078297D7D402D7765626B';
wwv_flow_api.g_varchar2_table(17) := '69742D6B65796672616D657320736C6964652D696E7B30257B6F7061636974793A303B2D7765626B69742D7472616E73666F726D3A7472616E736C617465592834307078293B2D6D6F7A2D7472616E73666F726D3A7472616E736C617465592834307078';
wwv_flow_api.g_varchar2_table(18) := '293B2D6D732D7472616E73666F726D3A7472616E736C617465592834307078293B2D6F2D7472616E73666F726D3A7472616E736C617465592834307078293B7472616E73666F726D3A7472616E736C617465592834307078297D3330257B6F7061636974';
wwv_flow_api.g_varchar2_table(19) := '793A313B2D7765626B69742D7472616E73666F726D3A7472616E736C617465592830293B2D6D6F7A2D7472616E73666F726D3A7472616E736C617465592830293B2D6D732D7472616E73666F726D3A7472616E736C617465592830293B2D6F2D7472616E';
wwv_flow_api.g_varchar2_table(20) := '73666F726D3A7472616E736C617465592830293B7472616E73666F726D3A7472616E736C617465592830297D7D402D6D6F7A2D6B65796672616D657320736C6964652D696E7B30257B6F7061636974793A303B2D7765626B69742D7472616E73666F726D';
wwv_flow_api.g_varchar2_table(21) := '3A7472616E736C617465592834307078293B2D6D6F7A2D7472616E73666F726D3A7472616E736C617465592834307078293B2D6D732D7472616E73666F726D3A7472616E736C617465592834307078293B2D6F2D7472616E73666F726D3A7472616E736C';
wwv_flow_api.g_varchar2_table(22) := '617465592834307078293B7472616E73666F726D3A7472616E736C617465592834307078297D3330257B6F7061636974793A313B2D7765626B69742D7472616E73666F726D3A7472616E736C617465592830293B2D6D6F7A2D7472616E73666F726D3A74';
wwv_flow_api.g_varchar2_table(23) := '72616E736C617465592830293B2D6D732D7472616E73666F726D3A7472616E736C617465592830293B2D6F2D7472616E73666F726D3A7472616E736C617465592830293B7472616E73666F726D3A7472616E736C617465592830297D7D406B6579667261';
wwv_flow_api.g_varchar2_table(24) := '6D657320736C6964652D696E7B30257B6F7061636974793A303B2D7765626B69742D7472616E73666F726D3A7472616E736C617465592834307078293B2D6D6F7A2D7472616E73666F726D3A7472616E736C617465592834307078293B2D6D732D747261';
wwv_flow_api.g_varchar2_table(25) := '6E73666F726D3A7472616E736C617465592834307078293B2D6F2D7472616E73666F726D3A7472616E736C617465592834307078293B7472616E73666F726D3A7472616E736C617465592834307078297D3330257B6F7061636974793A313B2D7765626B';
wwv_flow_api.g_varchar2_table(26) := '69742D7472616E73666F726D3A7472616E736C617465592830293B2D6D6F7A2D7472616E73666F726D3A7472616E736C617465592830293B2D6D732D7472616E73666F726D3A7472616E736C617465592830293B2D6F2D7472616E73666F726D3A747261';
wwv_flow_api.g_varchar2_table(27) := '6E736C617465592830293B7472616E73666F726D3A7472616E736C617465592830297D7D402D7765626B69742D6B65796672616D65732070756C73657B30252C3230257B2D7765626B69742D7472616E73666F726D3A7363616C652831293B2D6D6F7A2D';
wwv_flow_api.g_varchar2_table(28) := '7472616E73666F726D3A7363616C652831293B2D6D732D7472616E73666F726D3A7363616C652831293B2D6F2D7472616E73666F726D3A7363616C652831293B7472616E73666F726D3A7363616C652831297D3130257B2D7765626B69742D7472616E73';
wwv_flow_api.g_varchar2_table(29) := '666F726D3A7363616C6528312E31293B2D6D6F7A2D7472616E73666F726D3A7363616C6528312E31293B2D6D732D7472616E73666F726D3A7363616C6528312E31293B2D6F2D7472616E73666F726D3A7363616C6528312E31293B7472616E73666F726D';
wwv_flow_api.g_varchar2_table(30) := '3A7363616C6528312E31297D7D402D6D6F7A2D6B65796672616D65732070756C73657B30252C3230257B2D7765626B69742D7472616E73666F726D3A7363616C652831293B2D6D6F7A2D7472616E73666F726D3A7363616C652831293B2D6D732D747261';
wwv_flow_api.g_varchar2_table(31) := '6E73666F726D3A7363616C652831293B2D6F2D7472616E73666F726D3A7363616C652831293B7472616E73666F726D3A7363616C652831297D3130257B2D7765626B69742D7472616E73666F726D3A7363616C6528312E31293B2D6D6F7A2D7472616E73';
wwv_flow_api.g_varchar2_table(32) := '666F726D3A7363616C6528312E31293B2D6D732D7472616E73666F726D3A7363616C6528312E31293B2D6F2D7472616E73666F726D3A7363616C6528312E31293B7472616E73666F726D3A7363616C6528312E31297D7D406B65796672616D6573207075';
wwv_flow_api.g_varchar2_table(33) := '6C73657B30252C3230257B2D7765626B69742D7472616E73666F726D3A7363616C652831293B2D6D6F7A2D7472616E73666F726D3A7363616C652831293B2D6D732D7472616E73666F726D3A7363616C652831293B2D6F2D7472616E73666F726D3A7363';
wwv_flow_api.g_varchar2_table(34) := '616C652831293B7472616E73666F726D3A7363616C652831297D3130257B2D7765626B69742D7472616E73666F726D3A7363616C6528312E31293B2D6D6F7A2D7472616E73666F726D3A7363616C6528312E31293B2D6D732D7472616E73666F726D3A73';
wwv_flow_api.g_varchar2_table(35) := '63616C6528312E31293B2D6F2D7472616E73666F726D3A7363616C6528312E31293B7472616E73666F726D3A7363616C6528312E31297D7D2E64726F707A6F6E652C2E64726F707A6F6E65202A7B626F782D73697A696E673A626F726465722D626F787D';
wwv_flow_api.g_varchar2_table(36) := '2E64726F707A6F6E657B6D696E2D6865696768743A31353070783B626F726465723A32707820736F6C6964207267626128302C302C302C2E33293B6261636B67726F756E643A236666663B70616464696E673A323070787D2E64726F707A6F6E652E647A';
wwv_flow_api.g_varchar2_table(37) := '2D636C69636B61626C652C2E64726F707A6F6E652E647A2D636C69636B61626C65202E647A2D6D6573736167652C2E64726F707A6F6E652E647A2D636C69636B61626C65202E647A2D6D657373616765202A7B637572736F723A706F696E7465727D2E64';
wwv_flow_api.g_varchar2_table(38) := '726F707A6F6E652E647A2D636C69636B61626C65202A7B637572736F723A64656661756C747D2E64726F707A6F6E652E647A2D73746172746564202E647A2D6D6573736167657B646973706C61793A6E6F6E657D2E64726F707A6F6E652E647A2D647261';
wwv_flow_api.g_varchar2_table(39) := '672D686F7665727B626F726465722D7374796C653A736F6C69647D2E64726F707A6F6E652E647A2D647261672D686F766572202E647A2D6D6573736167657B6F7061636974793A2E357D2E64726F707A6F6E65202E647A2D6D6573736167657B74657874';
wwv_flow_api.g_varchar2_table(40) := '2D616C69676E3A63656E7465723B6D617267696E3A32656D20307D2E64726F707A6F6E65202E647A2D707265766965777B706F736974696F6E3A72656C61746976653B646973706C61793A696E6C696E652D626C6F636B3B766572746963616C2D616C69';
wwv_flow_api.g_varchar2_table(41) := '676E3A746F703B6D617267696E3A313670783B6D696E2D6865696768743A31303070787D2E64726F707A6F6E65202E647A2D707265766965773A686F7665727B7A2D696E6465783A313030307D2E64726F707A6F6E65202E647A2D707265766965772E64';
wwv_flow_api.g_varchar2_table(42) := '7A2D66696C652D70726576696577202E647A2D696D6167657B626F726465722D7261646975733A323070783B6261636B67726F756E643A233939393B6261636B67726F756E643A6C696E6561722D6772616469656E7428746F20626F74746F6D2C236565';
wwv_flow_api.g_varchar2_table(43) := '652C23646464297D2E64726F707A6F6E65202E647A2D707265766965772E647A2D66696C652D70726576696577202E647A2D64657461696C737B6F7061636974793A317D2E64726F707A6F6E65202E647A2D707265766965772E647A2D696D6167652D70';
wwv_flow_api.g_varchar2_table(44) := '7265766965777B6261636B67726F756E643A236666667D2E64726F707A6F6E65202E647A2D707265766965772E647A2D696D6167652D70726576696577202E647A2D64657461696C737B2D7765626B69742D7472616E736974696F6E3A6F706163697479';
wwv_flow_api.g_varchar2_table(45) := '202E3273206C696E6561723B2D6D6F7A2D7472616E736974696F6E3A6F706163697479202E3273206C696E6561723B2D6D732D7472616E736974696F6E3A6F706163697479202E3273206C696E6561723B2D6F2D7472616E736974696F6E3A6F70616369';
wwv_flow_api.g_varchar2_table(46) := '7479202E3273206C696E6561723B7472616E736974696F6E3A6F706163697479202E3273206C696E6561727D2E64726F707A6F6E65202E647A2D70726576696577202E647A2D72656D6F76657B666F6E742D73697A653A313470783B746578742D616C69';
wwv_flow_api.g_varchar2_table(47) := '676E3A63656E7465723B646973706C61793A626C6F636B3B637572736F723A706F696E7465723B626F726465723A6E6F6E657D2E64726F707A6F6E65202E647A2D70726576696577202E647A2D72656D6F76653A686F7665727B746578742D6465636F72';
wwv_flow_api.g_varchar2_table(48) := '6174696F6E3A756E6465726C696E657D2E64726F707A6F6E65202E647A2D707265766965773A686F766572202E647A2D64657461696C737B6F7061636974793A317D2E64726F707A6F6E65202E647A2D70726576696577202E647A2D64657461696C737B';
wwv_flow_api.g_varchar2_table(49) := '7A2D696E6465783A32303B706F736974696F6E3A6162736F6C7574653B746F703A303B6C6566743A303B6F7061636974793A303B666F6E742D73697A653A313370783B6D696E2D77696474683A313030253B6D61782D77696474683A313030253B706164';
wwv_flow_api.g_varchar2_table(50) := '64696E673A32656D2031656D3B746578742D616C69676E3A63656E7465723B636F6C6F723A7267626128302C302C302C2E39293B6C696E652D6865696768743A313530257D2E64726F707A6F6E65202E647A2D70726576696577202E647A2D6465746169';
wwv_flow_api.g_varchar2_table(51) := '6C73202E647A2D73697A657B6D617267696E2D626F74746F6D3A31656D3B666F6E742D73697A653A313670787D2E64726F707A6F6E65202E647A2D70726576696577202E647A2D64657461696C73202E647A2D66696C656E616D657B77686974652D7370';
wwv_flow_api.g_varchar2_table(52) := '6163653A6E6F777261707D2E64726F707A6F6E65202E647A2D70726576696577202E647A2D64657461696C73202E647A2D66696C656E616D653A686F766572207370616E7B626F726465723A31707820736F6C69642072676261283230302C3230302C32';
wwv_flow_api.g_varchar2_table(53) := '30302C2E38293B6261636B67726F756E642D636F6C6F723A72676261283235352C3235352C3235352C2E38297D2E64726F707A6F6E65202E647A2D70726576696577202E647A2D64657461696C73202E647A2D66696C656E616D653A6E6F74283A686F76';
wwv_flow_api.g_varchar2_table(54) := '6572297B6F766572666C6F773A68696464656E3B746578742D6F766572666C6F773A656C6C69707369737D2E64726F707A6F6E65202E647A2D70726576696577202E647A2D64657461696C73202E647A2D66696C656E616D653A6E6F74283A686F766572';
wwv_flow_api.g_varchar2_table(55) := '29207370616E7B626F726465723A31707820736F6C6964207472616E73706172656E747D2E64726F707A6F6E65202E647A2D70726576696577202E647A2D64657461696C73202E647A2D66696C656E616D65207370616E2C2E64726F707A6F6E65202E64';
wwv_flow_api.g_varchar2_table(56) := '7A2D70726576696577202E647A2D64657461696C73202E647A2D73697A65207370616E7B6261636B67726F756E642D636F6C6F723A72676261283235352C3235352C3235352C2E34293B70616464696E673A30202E34656D3B626F726465722D72616469';
wwv_flow_api.g_varchar2_table(57) := '75733A3370787D2E64726F707A6F6E65202E647A2D707265766965773A686F766572202E647A2D696D61676520696D677B2D7765626B69742D7472616E73666F726D3A7363616C6528312E30352C312E3035293B2D6D6F7A2D7472616E73666F726D3A73';
wwv_flow_api.g_varchar2_table(58) := '63616C6528312E30352C312E3035293B2D6D732D7472616E73666F726D3A7363616C6528312E30352C312E3035293B2D6F2D7472616E73666F726D3A7363616C6528312E30352C312E3035293B7472616E73666F726D3A7363616C6528312E30352C312E';
wwv_flow_api.g_varchar2_table(59) := '3035293B2D7765626B69742D66696C7465723A626C757228387078293B66696C7465723A626C757228387078297D2E64726F707A6F6E65202E647A2D70726576696577202E647A2D696D6167657B626F726465722D7261646975733A323070783B6F7665';
wwv_flow_api.g_varchar2_table(60) := '72666C6F773A68696464656E3B77696474683A31323070783B6865696768743A31323070783B706F736974696F6E3A72656C61746976653B646973706C61793A626C6F636B3B7A2D696E6465783A31307D2E64726F707A6F6E65202E647A2D7072657669';
wwv_flow_api.g_varchar2_table(61) := '6577202E647A2D696D61676520696D677B646973706C61793A626C6F636B7D2E64726F707A6F6E65202E647A2D707265766965772E647A2D73756363657373202E647A2D737563636573732D6D61726B7B2D7765626B69742D616E696D6174696F6E3A70';
wwv_flow_api.g_varchar2_table(62) := '617373696E672D7468726F7567682033732063756269632D62657A696572282E37372C302C2E3137352C31293B2D6D6F7A2D616E696D6174696F6E3A70617373696E672D7468726F7567682033732063756269632D62657A696572282E37372C302C2E31';
wwv_flow_api.g_varchar2_table(63) := '37352C31293B2D6D732D616E696D6174696F6E3A70617373696E672D7468726F7567682033732063756269632D62657A696572282E37372C302C2E3137352C31293B2D6F2D616E696D6174696F6E3A70617373696E672D7468726F756768203373206375';
wwv_flow_api.g_varchar2_table(64) := '6269632D62657A696572282E37372C302C2E3137352C31293B616E696D6174696F6E3A70617373696E672D7468726F7567682033732063756269632D62657A696572282E37372C302C2E3137352C31297D2E64726F707A6F6E65202E647A2D7072657669';
wwv_flow_api.g_varchar2_table(65) := '65772E647A2D6572726F72202E647A2D6572726F722D6D61726B7B6F7061636974793A313B2D7765626B69742D616E696D6174696F6E3A736C6964652D696E2033732063756269632D62657A696572282E37372C302C2E3137352C31293B2D6D6F7A2D61';
wwv_flow_api.g_varchar2_table(66) := '6E696D6174696F6E3A736C6964652D696E2033732063756269632D62657A696572282E37372C302C2E3137352C31293B2D6D732D616E696D6174696F6E3A736C6964652D696E2033732063756269632D62657A696572282E37372C302C2E3137352C3129';
wwv_flow_api.g_varchar2_table(67) := '3B2D6F2D616E696D6174696F6E3A736C6964652D696E2033732063756269632D62657A696572282E37372C302C2E3137352C31293B616E696D6174696F6E3A736C6964652D696E2033732063756269632D62657A696572282E37372C302C2E3137352C31';
wwv_flow_api.g_varchar2_table(68) := '297D2E64726F707A6F6E65202E647A2D70726576696577202E647A2D6572726F722D6D61726B2C2E64726F707A6F6E65202E647A2D70726576696577202E647A2D737563636573732D6D61726B7B706F696E7465722D6576656E74733A6E6F6E653B6F70';
wwv_flow_api.g_varchar2_table(69) := '61636974793A303B7A2D696E6465783A3530303B706F736974696F6E3A6162736F6C7574653B646973706C61793A626C6F636B3B746F703A3530253B6C6566743A3530253B6D617267696E2D6C6566743A2D323770783B6D617267696E2D746F703A2D32';
wwv_flow_api.g_varchar2_table(70) := '3770787D2E64726F707A6F6E65202E647A2D70726576696577202E647A2D6572726F722D6D61726B207376672C2E64726F707A6F6E65202E647A2D70726576696577202E647A2D737563636573732D6D61726B207376677B646973706C61793A626C6F63';
wwv_flow_api.g_varchar2_table(71) := '6B3B77696474683A353470783B6865696768743A353470787D2E64726F707A6F6E65202E647A2D707265766965772E647A2D70726F63657373696E67202E647A2D70726F67726573737B6F7061636974793A313B2D7765626B69742D7472616E73697469';
wwv_flow_api.g_varchar2_table(72) := '6F6E3A616C6C202E3273206C696E6561723B2D6D6F7A2D7472616E736974696F6E3A616C6C202E3273206C696E6561723B2D6D732D7472616E736974696F6E3A616C6C202E3273206C696E6561723B2D6F2D7472616E736974696F6E3A616C6C202E3273';
wwv_flow_api.g_varchar2_table(73) := '206C696E6561723B7472616E736974696F6E3A616C6C202E3273206C696E6561727D2E64726F707A6F6E65202E647A2D707265766965772E647A2D636F6D706C657465202E647A2D70726F67726573737B6F7061636974793A303B2D7765626B69742D74';
wwv_flow_api.g_varchar2_table(74) := '72616E736974696F6E3A6F706163697479202E347320656173652D696E3B2D6D6F7A2D7472616E736974696F6E3A6F706163697479202E347320656173652D696E3B2D6D732D7472616E736974696F6E3A6F706163697479202E347320656173652D696E';
wwv_flow_api.g_varchar2_table(75) := '3B2D6F2D7472616E736974696F6E3A6F706163697479202E347320656173652D696E3B7472616E736974696F6E3A6F706163697479202E347320656173652D696E7D2E64726F707A6F6E65202E647A2D707265766965773A6E6F74282E647A2D70726F63';
wwv_flow_api.g_varchar2_table(76) := '657373696E6729202E647A2D70726F67726573737B2D7765626B69742D616E696D6174696F6E3A70756C7365203673206561736520696E66696E6974653B2D6D6F7A2D616E696D6174696F6E3A70756C7365203673206561736520696E66696E6974653B';
wwv_flow_api.g_varchar2_table(77) := '2D6D732D616E696D6174696F6E3A70756C7365203673206561736520696E66696E6974653B2D6F2D616E696D6174696F6E3A70756C7365203673206561736520696E66696E6974653B616E696D6174696F6E3A70756C7365203673206561736520696E66';
wwv_flow_api.g_varchar2_table(78) := '696E6974657D2E64726F707A6F6E65202E647A2D70726576696577202E647A2D70726F67726573737B6F7061636974793A313B7A2D696E6465783A313030303B706F696E7465722D6576656E74733A6E6F6E653B706F736974696F6E3A6162736F6C7574';
wwv_flow_api.g_varchar2_table(79) := '653B6865696768743A313670783B6C6566743A3530253B746F703A3530253B6D617267696E2D746F703A2D3870783B77696474683A383070783B6D617267696E2D6C6566743A2D343070783B6261636B67726F756E643A72676261283235352C3235352C';
wwv_flow_api.g_varchar2_table(80) := '3235352C2E39293B2D7765626B69742D7472616E73666F726D3A7363616C652831293B626F726465722D7261646975733A3870783B6F766572666C6F773A68696464656E7D2E64726F707A6F6E65202E647A2D70726576696577202E647A2D70726F6772';
wwv_flow_api.g_varchar2_table(81) := '657373202E647A2D75706C6F61647B6261636B67726F756E643A233333333B6261636B67726F756E643A6C696E6561722D6772616469656E7428746F20626F74746F6D2C233636362C23343434293B706F736974696F6E3A6162736F6C7574653B746F70';
wwv_flow_api.g_varchar2_table(82) := '3A303B6C6566743A303B626F74746F6D3A303B77696474683A303B2D7765626B69742D7472616E736974696F6E3A7769647468203330306D7320656173652D696E2D6F75743B2D6D6F7A2D7472616E736974696F6E3A7769647468203330306D73206561';
wwv_flow_api.g_varchar2_table(83) := '73652D696E2D6F75743B2D6D732D7472616E736974696F6E3A7769647468203330306D7320656173652D696E2D6F75743B2D6F2D7472616E736974696F6E3A7769647468203330306D7320656173652D696E2D6F75743B7472616E736974696F6E3A7769';
wwv_flow_api.g_varchar2_table(84) := '647468203330306D7320656173652D696E2D6F75747D2E64726F707A6F6E65202E647A2D707265766965772E647A2D6572726F72202E647A2D6572726F722D6D6573736167657B646973706C61793A626C6F636B7D2E64726F707A6F6E65202E647A2D70';
wwv_flow_api.g_varchar2_table(85) := '7265766965772E647A2D6572726F723A686F766572202E647A2D6572726F722D6D6573736167657B6F7061636974793A313B706F696E7465722D6576656E74733A6175746F7D2E64726F707A6F6E65202E647A2D70726576696577202E647A2D6572726F';
wwv_flow_api.g_varchar2_table(86) := '722D6D6573736167657B706F696E7465722D6576656E74733A6E6F6E653B7A2D696E6465783A313030303B706F736974696F6E3A6162736F6C7574653B646973706C61793A6E6F6E653B6F7061636974793A303B2D7765626B69742D7472616E73697469';
wwv_flow_api.g_varchar2_table(87) := '6F6E3A6F706163697479202E337320656173653B2D6D6F7A2D7472616E736974696F6E3A6F706163697479202E337320656173653B2D6D732D7472616E736974696F6E3A6F706163697479202E337320656173653B2D6F2D7472616E736974696F6E3A6F';
wwv_flow_api.g_varchar2_table(88) := '706163697479202E337320656173653B7472616E736974696F6E3A6F706163697479202E337320656173653B626F726465722D7261646975733A3870783B666F6E742D73697A653A313370783B746F703A31333070783B6C6566743A2D313070783B7769';
wwv_flow_api.g_varchar2_table(89) := '6474683A31343070783B6261636B67726F756E643A236265323632363B6261636B67726F756E643A6C696E6561722D6772616469656E7428746F20626F74746F6D2C236265323632362C23613932323232293B70616464696E673A2E35656D20312E3265';
wwv_flow_api.g_varchar2_table(90) := '6D3B636F6C6F723A236666667D2E64726F707A6F6E65202E647A2D70726576696577202E647A2D6572726F722D6D6573736167653A61667465727B636F6E74656E743A27273B706F736974696F6E3A6162736F6C7574653B746F703A2D3670783B6C6566';
wwv_flow_api.g_varchar2_table(91) := '743A363470783B77696474683A303B6865696768743A303B626F726465722D6C6566743A36707820736F6C6964207472616E73706172656E743B626F726465722D72696768743A36707820736F6C6964207472616E73706172656E743B626F726465722D';
wwv_flow_api.g_varchar2_table(92) := '626F74746F6D3A36707820736F6C696420236265323632367D';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72339293396797130)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'css/dropzone.min.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D000017BC494441547801ED9D5B901CD759C74F77CF6D6FD24AB22CCB96AFB19064C92476B093D8C1C4384528538400962131553CC10355F0C60355141105';
wwv_flow_api.g_varchar2_table(7) := 'B64C5195D75049A84A417C292B50C5CD246553244A0281F8266C0512701CCB966D599275D9D5EEECCE7437BFFFE9E99D9ED9DBECCC99D999D59CD26C779F3EFD9DEF7CFFEF76CE996919E3A0C4B1F11C90595712F1A143FE461847B3103B064642F13C13';
wwv_flow_api.g_varchar2_table(8) := '8B70FC6F9FB9D384DE27399B34711C19DF6FEEAF7FAEC59F894BC69F386346AEFBA277FB1FBE1EC70703638E44E978FA87D9F639E908E006708F3EF40002FB92D954D86CD959A0AC138B7FFB5C3A7D728131A856616D9B31D18EAF994AEE77BC0FFDFE6B';
wwv_flow_api.g_varchar2_table(9) := 'F1BF1ECA998F1D0A370AC8D9D1AE598CD278CF3B12C6477F63A7F1A267CC6469BF395FAE80A76F9DB6704DF16DA5A7E6F6CDD7CD1CA6F7559F3DCFB64BEBD3E3425B41381F99DCF6593371E384A984DF355EFC69EFB63FF8F14602B9331F7A2495647C13';
wwv_flow_api.g_varchar2_table(10) := '12DE632ECE49D0025774171F55B7D267B9E7D2FAE667B3F5D9F36CBBB43E3DEA9E3D8F51392F6735A3529D369B473E0CEF8FC5C7FEFC46EFDE4355F38D43C14688C99D017C70BFEC029145580316212B4DFF26B69BD4F4E5798D5FE3117739BF3063CC44';
wwv_flow_api.g_varchar2_table(11) := 'E92E13563714C89D017CE478E278235F79B4D22D8BF7C0FCB1EA69FF200778BF580E01F923A65A7D3C7EFEF0CDD692CD5364D7B2F6C12C9D019C5AB0C69E403C185248FC4EE2572CC738631F0C3D809C02E44DB86BCF3C1EBFF827BB3DEFC1D07CE38F71';
wwv_flow_api.g_varchar2_table(12) := 'D7830972670037C339287ADECCA7C20B1ACA3FC9C333176765C9779838F758DD928F0CA425BB05B819F041B9F6B060B968CF936D2B090364EBAEEFE02C71D7B2642390D570708A3B80076AD84D00A5165CAFAE833C8E257BE6C9F8B947F65A773D6031D9';
wwv_flow_api.g_varchar2_table(13) := '1DC0695CAB0B6970CEEC4ADC220D4D409EB696FC4156E59EA8833C38EEDA1DC08BE43338F8DA04716976259FC45D8F173F308820BB0358021A342B4EF9B53138BD588474DD92057280253FFF67FBACBB3ED2FF96EC0EE065E5B34860FD53B1E075164E96';
wwv_flow_api.g_varchar2_table(14) := 'E32DB164B9EB314036E153F1B1870F780F9278F539C8EE005E4E34FD5CDFA0942D829CCC930F98084B1E0090DD012CF9AC2AA33E43BB81DF06B49763B49E5D8F950E982A207F2FB5E407FB729EEC0EE096E4B39CDC7A5CDF19AFBE9D29CB92270059D9F5';
wwv_flow_api.g_varchar2_table(15) := '0B8FBEDF7BF008EE1A90F9E2408F47B36277EE9869B08615FB5CFF9BCDBCAE75F122DD319B2E57CD26403631967CF8360BF22DC7BD7E02D91DC0B28ACE2C63FD805F7A1EBC1A3F529380B5EB2A96BC0FAB7E3C7EA9FF40760770B355AC269E7EB8DFA090';
wwv_flow_api.g_varchar2_table(16) := '0D17AD7297807CD15AF25E136640FE2CFADE07EEDA1DC06DC9A7553976BB5D47CC6BE53AB5E4BD78B127E2170FDFE1798722D30720BB0358180C8A15A77836F0DB70B1568D4A2C59EE7ABCB40790D96AEC0F90DD02BC56B1AC57FB662C176F36B4C35962';
wwv_flow_api.g_varchar2_table(17) := 'C972D7E3A59BF986CB63FD00F2E50970337C76A9B2B9B2ADEBBABB1E2FEEC6921F8BBFF7A777AEA7BB760770B355B4259F757AC85AB0B3BE139035851A2FED36B98079F2231F592F90DD019CC6356772EA21213B4D72DA5F129305F258E9269293C7D70B';
wwv_flow_api.g_varchar2_table(18) := '6477003B954F8F89AD75A1A335F6EA208F976E582F90DD01ACE10C9A15A7FCBA8BC1CDD02F06F9B9473F6ADDB5C4D58379B23B805361350FB19FAF257E5B164ED20A97C74690FD1877FDE83DDE21E6C99438EEEEDAB53B805D8AA457B41A94B247208F95';
wwv_flow_api.g_varchar2_table(19) := 'AE05D6AFD441FE2CDFC8ED1EC8FC74C351917CBA2A23477C66C934F0DB8076B695AB73F516189B5D17AF35D3735F898F3DF2103FCDFC160863C97C335BAB5F8E8B3B0BEEBA7C1C8E7C495E1BD076D85903A9DA146A8E2914208764D72F3D7C2F20C3D1A1';
wwv_flow_api.g_varchar2_table(20) := 'AE58B23B801BC6D1E7178BB014E24BA2DE8D8124205F9AAB304FDEC53743B0E4C33FCB57EF61C0BDBB760B70CF64E458EE76A16311EA8E3B69204767FCB2719A9FDA8E97AEE667CAC4E487EFEB8625BB0358F2E9A98C1A04D6DE45AA909A26F1AFA170A9';
wwv_flow_api.g_varchar2_table(21) := '2A5B9DDECA5E67CED347D3A36C71A9671190A594B4B3BF75AA815CDCC90F2AFEAAF2C2E18FCB92158B5D255EEE0016EB96FD06310DC805629572667F60261BAB7D1614377B9D39573B95F4A8F64B3D4B07B6E5423B9AF1583E49BC4A57E73C2CF9F9C33F';
wwv_flow_api.g_varchar2_table(22) := '9FD0026407F36477005BAEF467004A8322EAA7AF7EC4871C37E0BD2201F96CAF3FB9C0CCCCCF9BB1D11D7CEFFACBF1B1CF25203357C6DA6BEAD39E5CDD4D93DAEB7F7D9E42649A9A78801A47B34179FA5419E39D76BF24BDB6E1C553663A1F043BE62B95';
wwv_flow_api.g_varchar2_table(23) := 'CF9D7FFAB7FF77F2FE2FBC6A8E1C44F3F8425F9BE5F20418612566C1B760E3D9A25FB9144CCD847118C69ECFEF841B0CBC2658B55FAA3E95FB4AF7B3F7B2E7E9B33A26F5711ECD0B3D3FD8E7F9B95D54BF6AEC6FB017DE95917DA4A57377008BC3412AF0';
wwv_flow_api.g_varchar2_table(24) := 'AB6487CCD52B1682BCAC798A9F05472C3504BAB7C458561BE24AF7B3F7B2E70DDDD069A1E09BF94A588D2ACC951D1477004B224B49C50193DD22A164C782CCA190F7CC84BE5A35139A9071E807FF3D198E3AA921CE2142C1927786E413688EA4AFC96853';
wwv_flow_api.g_varchar2_table(25) := '089767929511562DA3955FF600D91B1F093CC0F510B4AD537D573F82B7D60758D7A0AE337830FB9A8C7A75CB67EE00166B3D51F996C7B6F686F05F94258F04F6257DB2EE9E962EF4E70EE02E30D753E1663A5B5790337CB8387507B00B6EFA88C64601D9';
wwv_flow_api.g_varchar2_table(26) := '1DC072D18B22481F21D6062BC5428FDD7517E4E70EE00DE4A217748131F5D492BB204377002F4865E39DF4DC921D8AD02DC05DD04087636D9F942C1977BD693460A938993BB74FACB74FBA037803C6E0062800B9C076CF440DE4684094D91DC01AF0800C';
wwv_flow_api.g_varchar2_table(27) := 'BA01B8355ED8152F40CE21B94100D91DC0125417B2C035CABFFBCD33963C0820BB05B8FBE2ED9B1E64C98AC9FD0EF210E07655064BCE1393FB1DE421C0ED025C7BAEDF411E02DC21C07A7C016436FA7ABE41B10AFF4380571150ABB7F38AC9EC420580DC';
wwv_flow_api.g_varchar2_table(28) := '4FD9F510E056115CAD9D62720D64BE42D73796EC0EE0CB618AD40AC84ABCFAC892DD01AC450E7D86A5AF2CD91DC0027668C5897A67DCF57AC764B7000FADB72E810CC88AC9EB95780D01AE43E2FE2C0372BE1590BBE001DD023C8CC18B95642D2077417E';
wwv_flow_api.g_varchar2_table(29) := '6E01EE82062E96D800D6005CAE36856AC9921D0ED12DC00E19DB70A46A20EB2BB9BD04D92DC05D70311B0A68E4631743D885EA15C86E01DE5068746930B2E4DA2E542F40760BF03006B7A615FCC0AD5720BB05B8B5E10D5BC910322017F839A39D2753EF';
wwv_flow_api.g_varchar2_table(30) := 'DA468600AF97BA65409E18F5ED17FA62E76FC9D27FA5EAAAB8563D577CF5331D642650E5AE27467CBBAFDCF13B1B9AC6EB0EE06106DD24DAD62EEDCF57D3C46B8CEC1AB05D2E6BBA037868C1AD21BA5C2B2C591B13FADEB540AE56966BB8B67A77BFF05F';
wwv_flow_api.g_varchar2_table(31) := '5BBFC3D6CD129081C80B6A0A85BB2E15DB7EEF4A036577000F5D748360DBBE408E0159F54831DF3689EC83EE5C7496EAF0BC3309C85836BE8B4E5D4236B82F55D78A2CD3E7D4364B4FD7ADDE53DB954A33DD95DAAE704F64F4C9B2B542F3D56EB973D1AB';
wwv_flow_api.g_varchar2_table(32) := 'F5B4A6FB3816DED5694B7672A8B7D1A9C4526F4D1A5713AAA4A436D0F2C86054ECF75A53E971CFA6B11C63BDB5281BF7D426C7CB0773ABF4021F96473D9BF6C7699F943E0418100560789AE3FC6231792304A92DD42B4609E8E54096B0692300A319E85D';
wwv_flow_api.g_varchar2_table(33) := '48E8525B2F7A967652266F13AB02A5E4DA36808F689AD7EDF09C2DCDFD88BE14B1C86194237CA92FAB7CB547FAE0D067004BA85308CA3751E9561315AF32710EC17B052B38AF7AC1F8E5378C3FF7DF8940FDCD88B0F97D61352BD23321B4A23318E29526';
wwv_flow_api.g_varchar2_table(34) := '1AF980890ADBEBF4046C54367E75CA7895F78C3F7F82EB4B8035064DEE61D1717E27EDF727D7CD60A91BDA78F125E3554FC1C6EBF0348EF26DE586BC4B2B1EA699A8FB6B7700372BF89A794D2C261CBDDDCC6FBFD75447AF3171306A621FD76ADD2B2F93';
wwv_flow_api.g_varchar2_table(35) := '8AAA0071D1E42FFE8F299C791A604E02C8243DA5AE5552878E3ED5B700E72A53DDFA0BA6B2699F0947A42CD0B3D6AA369438B434BD70CE0473A74DF1F451134C1DE5711407C598DFF22B666EFBDDB59700A780A98F5AC1357BE10C3C5D30C1EC9B267FFE';
wwv_flow_api.g_varchar2_table(36) := 'DF51C0E335901512C457C782497B6BEBE80E60ABD16DF15013028288CE9970E280295F7107624905C351310E30627089F29B4D75EC1A00BBC68CBCF997C69B7F0B4026A0214B965061247C1B3A1F33E51DF79BEAF80D280AEED35AA5DE6EA62266F5FE31';
wwv_flow_api.g_varchar2_table(37) := 'CE78B1AC2988E64E403A65820BFF083D294D050B9E3061697BD2D2C6D994276EDB220A2AE2F1000A719B1979E7EB2677FE9FA181E7B1FCAC11E494A4A5DBF99F9A2A774EC852681EFF9AC9F25E6E2544124C54C132CE99A0FC8EF12B8A8358B02CAE3ACB';
wwv_flow_api.g_varchar2_table(38) := '6984306F3173577E8A73C5690951E052C2774D65CBA7CCA5EB7FD354266F4129F25859194B255EEBEDB2C2A206AE70B1AF1126F1F242E8D8442B1589B469DEF87AB6AACFACA523BE6C3BDB36F12A963E34AA63D79A995DBF8C72FD347CBC0771D15AA350';
wwv_flow_api.g_varchar2_table(39) := 'D6D89C0E562CEE2C78C56E5AB929175800C48AC94FBF86BB7B198BFA3142555C2C9ACAE6DBCDDCB60F6271B441C8316EBB32B1DB148B3762C56F52BF1597FD86A96EFE849945C851715BA20C508D83A205273F75029A6F514FD225B0B1ECA8B0D55A6958';
wwv_flow_api.g_varchar2_table(40) := 'DA463FC4ED0577CFA95508DE482B5BE7DC8BE64CE1BDE750B88B3C5BE23942C0D8F5F65C3CF9D54B26A4DFB92B7EC68C5E7A01054963FA4AC920FD74B1F409C0F24B7C826D2677F13F4CEEC2B78D3F7B8C3A2CC0265833363646F93FC2726F4DEAB1E2D8';
wwv_flow_api.g_varchar2_table(41) := 'CFE1B2B79A00803DB2E498FFF0B37CD5FD807B0520225C9E974204336F99D2A967A0FD5DDA9DA35E562F53015032E0A8B08B38FD53D039CBB5DCB3942D5BF02C28948745174F3F6DFC4BDF2671DB651BCC6FFB55337BF527ACB2E8BEBC4C75642740BF8F';
wwv_flow_api.g_varchar2_table(42) := '7E0159899763B79BE56CB573770077EC5A204002E497FF2F718108D026443537E7CD63D1B86B630470523CC545AC2A11E00CE0939C8D5F0788D45112704F9AD1D7BF6C82E9675120FE6B048F2CD99B4808008675C3B3AF98A2922325573E805882CDA824';
wwv_flow_api.g_varchar2_table(43) := 'D7B1A643FE76681063AB274DE1ECDF9AEAA63D667EF200CF3106E50AB931E2376D3465B2F3EE8E8593F0DBC65F770037CBA30D66ACE5D8690A02C1BD79E93C5753A71C563182D5A40B155894326A7F5EA0CFF13EE0EB70CFFB103E43225EC6B85B2F9CB5';
wwv_flow_api.g_varchar2_table(44) := '966BC1CDEF41FEC4691B3B6BCCE91AF7CF1E4E0D0C00B7FF6F866267F38004121F3DE3F1DE6E8E5EFE5AF83C0B0F8AB76ACF7DF167DBC8DDABAE990E553D2CEE00D6F83B2E085600E096E302D324BB5011E042B79138DD45CC7D9F15A062A717CD120F53';
wwv_flow_api.g_varchar2_table(45) := '978B9C8BD7E31699834AC0FA30BDCA4DBD69DDB22C3771B19A175F844BB9E06686014E450A262B5FB2082C9E95E50BB8AA5C3AFBB7397904D1A38E586D502C2D9224D3BBE67E68D6C3E20E608D5D9F760BA02456F7AE09473F6CCABB7EDD844C5FE486A3';
wwv_flow_api.g_varchar2_table(46) := 'DC888D7102CE4301FCD933A678E63B267FEEEB0818B7CA9C372A6851821525E6CA89A5F266ED9937B062AC0B77EAE111226BE5775AD70F2CB09B085F49547A9E9BFA3ECFBDCC2864C54D45F829E98B48D44229E35992BF4F13166EE25CC0F321CC04CC8B';
wwv_flow_api.g_varchar2_table(47) := 'FDB9377858DEA106FC22856AA29D5E7622C39446E6E80E6011ED585925B432B225431DD901C09308926B91B6C01146CBA74CF1DD674DFEEC53B42321B23153716F225110DB0E465006BF8A15C5C463B9EDF03CAB63BBCCECCEFB6857B2C9900555166735';
wwv_flow_api.g_varchar2_table(48) := '93238F8DBE491FD3DFE2BC66D149EF56D144A7B2E56E8C7C2F0A374A167D0D00EF23D11B833FF5A3E5D3C8E42F7C1F805F4DF85BEB6247C732B40C2FFC710B70C7DA27023581DBF966C55AACB2E538603E0B782119F2ECCE5FC26AF69AE2A9BF23FE6129';
wwv_flow_api.g_varchar2_table(49) := 'CAB4172C4E346A5292ABB6E071A85969B29205BD5A1B9BA8D97B29F3E951CF640AD6A9A95179C7C7A9A48D9D42213E7995488B308415C242E1DC2BACB2FD53C213B17AE5F5F20CFD2E9DBA05B813EDE359B95FE36F619EF92E56FA4D6B25B2889818ACA5';
wwv_flow_api.g_varchar2_table(50) := 'CBB07405E655B4AEB83CF2518E9BCCC889CF330F7E1B4113172DA010D251FF7B0A8024E02BE6EA7F580959B898071E94C85ABA94494C03927DACF66CAA200D4217F09A7665DC6EDA8F6893B917DF3B6E8A6F3FC97C9CC42FD0748BF12C49AB8170572FDC';
wwv_flow_api.g_varchar2_table(51) := '02BC8CF2B73602095A00E3EE1050F1D497903BF3556B9D581C73DCD99DBFC654E8276BEE30C7D4642F89D4BDA6F0F65F33EF3D6FEB63B262CF3EE7A3103BA0A7792874824D2C72FCC88C9EF89BC495134BC3D19BB0C8BB6B315956090B76FB70098E6D3D';
wwv_flow_api.g_varchar2_table(52) := 'FF6F5605B72F0BC6A2B528A3152E7FEE2C6EF9251667FE857AA64676B74BE0AE7F7107B0154EA703521C54ECE3185CC5514413ADF1669F37A57772261CBF2189CD58601C703D7623CD77DBA4265949629E2ACBE2531D27B32EED21A61EC50BFC04609C35';
wwv_flow_api.g_varchar2_table(53) := 'B9738F41933EAA478DB7F5B03157DE550335E9879B4B1665E1A23FF2160B1DE40136AE93B8F99553789013780492AF400AA50CBC3FC0D540DC01BCB27C96145A6325602A21D2169F5D7020234E4C2A99E2B0F0E155CFE10A65D5023E298A7DC6BF8EE4EB';
wwv_flow_api.g_varchar2_table(54) := '8764BFEF00280B0C7659719EAC79D2CCB1E130C2E28937779CEDE11B5880D8C37D36F1C9AC63EDE3AAD4F528B95EF4578343E988B5C1D4F3AC64FD0360EE4EEAEC5E308B1E79C2879D3EF50FB81A863B8045ADED8284D99B8D4A371257B79840EBB8951F';
wwv_flow_api.g_varchar2_table(55) := '404D498AF69510300B0AD5EDBF87F5224C049D044DC4CE7EAEDDB0AF9EC145BEC892E3CD890BD6B221EDE627F723F8DF25A67F0D17FD5F28C8BBD004AC902CD7FB394B47FFF9684B05C58A056481A9164AE82943D6D4C81EB5DEDC7FA54F00868D88694C';
wwv_flow_api.g_varchar2_table(56) := 'F11AD6757F1120EE63CFF715623116AB64882CBA4ABC9C671B518993D67CED2E114959300D50B27CF67EF3E79F3585893DECE17E883A6872DF4387E7B7BE1F57BE0BC539894BBD6093B9D81F81E6D500AC9090006C8116D87507B11831C55816593C8F04';
wwv_flow_api.g_varchar2_table(57) := '4E8B1E7D5EFA04604909C1620D517E92E4478BFF375B206C3CC5E54636234E16FC65B172CD8573C7D898388A0290B16A4AC29266892C5673D4F9ADB7729DB4F742FE373332714DB1128B138809B05E28CB4B1628341593E258574B1F692CD7510B23C9B3';
wwv_flow_api.g_varchar2_table(58) := 'E2551AB09216A84D7F14B7002786D0D9C8909B9DC6B01CC97F1559A7555B1E14784A620AE75E36A5934F60CD2C3D0A60BBD0C0C2083B4B236F7C81F9F103666EEB6DC46156B104903C01474B1B0A764AC6D1026AFBE1CEDC7B7CB383298EA73EB4E08222';
wwv_flow_api.g_varchar2_table(59) := 'B11B659FA38D1FA5F36D1703A58B1E14B700B7ADD4580731CD9F3BC1EECC8BA63A71131E76DC5A695606DA3C08CA9A92BCC232E533B870E2A99D92D462B2B257ED0B574F03FEE7598766FD7AF20EEB11A2E224F4984259B72A80A449244D95F3F47BCEE4';
wwv_flow_api.g_varchar2_table(60) := '2E9DA0FD0B84871F4283E5CF10F78E3BCFCD6A8E2D8B67AECBCA985DB19275D7DC7A96BF7E3C770B70DB8A0D4064A33E0B162327FF02AB63AB904F14B0888FDB54D1428257390318AF713C9958590A6E836415B30188B89CBBF82CF3E4EF40EF5AE8F1C9';
wwv_flow_api.g_varchar2_table(61) := '6DC622450F70B1687D9FCAAB9CA6DF9380A7E42B5134EBEEF10A8573DF24177891FABA427824738985D376008A5B803B1AB0AC0476B016BF4CE25466D1DF5A5BEAA62550EE2BB90988A5760200984B16E2AA1648B4FFCBDAB63C8399C3321BE8A5DA08E0';
wwv_flow_api.g_varchar2_table(62) := 'F6ABAF28855D54513FF208C46FE6CD72F949517BE2B6DD6D4A79AADD727D48597340D72DC06DBBE8CC4804A07685ECF4233B52114F3B10084A8ED2EBCCF3F654F5029FA3C06337CABA590B70B6ADDAA51F405D58A0501D7D5B65523CCE96E5942ADBA6C3';
wwv_flow_api.g_varchar2_table(63) := 'F35AF71D52B18FBB05388B47DBDC21404B27157C4A4895E9A7F95EDA267B541B95E5E8E95EEA6653C6D367744F45F7D336B6A2FB7F52561CF5E416E066F9B4C56496C852A3CDDE6FA5836CFBA5E88946B64D2B34BBD8C6312B6E83C972F2EBA23C362469';
wwv_flow_api.g_varchar2_table(64) := '8772740BB063EDDB90E0B5322887727407B043A65A91C1B04D6B127007B043B7D21AEBC356AD48C01DC0ADF4366CD37309B8057868C56E007428C7CE003E72BC1E79B5695BBF7233D0211563B2326E431E9D017C707FA26B7E94C0AB45F961E94C02A908';
wwv_flow_api.g_varchar2_table(65) := '25539554C66D52ED6CA123D5AEC8D77E9C7EA1A5C5265972CA669B6C5DA68F497676E78A3F92A94A2AE33645D219C00B9D7A3F6235E807665371BF395FD64F06EA8B43D973B56FBE5EA0D16727ABF1B9D2FD95EE2D37CCE499081906C890EF2B49A69483';
wwv_flow_api.g_varchar2_table(66) := 'CB3DD05A7D4751133DF3F4352575151F7DE80176D1BF6826F8A69B4A47942D85CBEB8F9522439E9A3FCF46CB6F79F73CF95509202BE37604D2310C5906E2A39FB913C83F095BECAEB31DE47716E2DB19D0403E13B1A1E1E96B251EE0C67FEFDDF3F87F6A';
wwv_flow_api.g_varchar2_table(67) := '1C59D9AEEBB8C4C8BA32B0013B7725D3FF078232BE989D36CB510000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72339765904797130)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/3gp.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D000012E9494441547801ED9D79901CF575C75F77CF4CCFEC4AAB9500DD27E8F40A21B0454050294550292A7629C6854419A8E20F13FE48218E0042492595';
wwv_flow_api.g_varchar2_table(7) := '059C4ACA392A7F3855A910572594240C323948203E0338B1A11C631BAC45E858A10B74AD9695F69AABBBF37D6FE637EA99D5AEE6F8CD4CF7EEB434FBEBE9F99DEFF3DEFB5D3D3D447A0E434F36CDCBA5BBBBDB44E9A16F47A9046B6E9007A1201304443B';
wwv_flow_api.g_varchar2_table(8) := 'BE76DFCDA6616DF1C8EDC45B97886516D0C3F3503F2F6E45637D6DED6D2FFCF15FFFDDB157B66EB5B6EDDD8BEBB9F604B4E61555AB26C045701FBAFF1E838C17E2768CE1C2146ACABAAC46B056555B8A6824189BD1181976FCBB86EBFCFE9FFCD5373F86';
wwv_flow_api.g_varchar2_table(9) := '2547F07290B54429AB22018E54AD7CA449798D77FEE8E107E639AEF183B6B8DD359C4C66F0A1C919D702C02FB3CBE573B96BFE34EA5CC553215FCF9F1B306237128B8FB677764E771DE75DC734BEDAFD177F7B743241AEC987EECD4B31E378D7C223AF1A';
wwv_flow_api.g_varchar2_table(10) := '4DA5F88A09099A9EE7E5433EAFED95CBAF388FCB5DBB5C392A9E0A390E71DDC4F88D0857D8719DA144227E8BE17ABB9F7FEAA965009CC5CBCAC5E118E13D6A02DCD5D5C5C600C95B8687AE98DD322C574EF0271FAAF7410A79D850F0EE16E01BA3A3492F';
wwv_flow_api.g_varchar2_table(11) := '61DB1B3D3303C88F4C1AC83501EEE9E91117EF1A8E87138829B49A6E42538D6432E9C46DFB56D7B4F674EF7C62395BF22BAF6CCD5B7B38DB56136065C1ECE75840E114016A6D90C7EE867D4C3295723096B8C5F4DC3DCF3FFDE88A6DDBF63ADDDD9B42EB';
wwv_flow_api.g_varchar2_table(12) := 'AE6B02EC071A5EBAA29DAAFA62ADA3A329B6E40D9E69ECCE59F25BA1B5646D80A533F6130FD3392C58AA8B91214213160D770DC8317B035B3243664B0EA3BBD60658994098B816EA5A183D145A2196CCEE9A211BAEFB72F7938FAC16C85BC3D5276B033C';
wwv_flow_api.g_varchar2_table(13) := '292C386FC879F005C8185DDF6459D64BDD7F08C87BC365C9DA001774BF6016213A196BC1AAF205C8B66DAFB79C3C6476D7B0642875E09BAD0DB092482843D507175BB06ACA58C84F6EFF1C5BF2B61040D60638D42E5AA11C3F14C829F4C96CC98669BEFC';
wwv_flow_api.g_varchar2_table(14) := '674F3DBA76AF82ECF13240300F6D8083D9BC4A6B3521A7DC62082027E2F65AD7345EEA5690B76DE3A5D90913575A135DF1B5010E64EB2A96D215FD9058324FA160C96B8D1040D606F88AA2A958D8CD4850969AE6E7C9492761C7D65A80FCDC33DB6F6077';
wwv_flow_api.g_varchar2_table(15) := 'FDECB3CF1A58DED426531D12D05699B244A3A3C6F5C8A3308A2E5B4D596E663295CEB2257BAEF1EDE7FE60FB8D80EBF2FA7C90206B035CB668EA01A8D63C0BA3E80A32E2C56BCFB3B018924DC4E3ABB1A1B6E7B99DDB6F644B0E12646D80436DC105AE15';
wwv_flow_api.g_varchar2_table(16) := 'B6A214B263ECE97EFAF19B18326719044BD60638D4165C005C452B4A209B86B7E7B9271FDBC0EE3A0890B5012EC828D427155AB06AAB0F3276A15679160506B236C0558A4689A8B96161905543357C90B176BD9C2CDA1D044BD606B80AE75683343527AD';
wwv_flow_api.g_varchar2_table(17) := '669075B92AF820C3925730E4AFEFD87E7333DDB536C053DE8215701F64DB8EAD703D4CA19E7AFCD66641D606787258B0A656E421A7304F8EC7ED659E89815793206B033C392C58632B0A960CC8766C296E3D6D0A646D8095870A6558E8833559B01282CF';
wwv_flow_api.g_varchar2_table(18) := '92E1AE9792E1BEF4F5671EBBBD91EE5A1B60CDA251220A7FE8871CB797A04FDED3FDCC63BFD928C872677FF8A5A8AB051A5DB4BF4A7EC8766C512A95D9D5FDE4630F00F28FF3DB8CA602EE4FA6E35C1BE03A8946471B2BC883FD509D5A2290C9E28117DC';
wwv_flow_api.g_varchar2_table(19) := '3520A777C15D3F80CB80CC55ECAE0BE4968B2EC25F27B8AA0CFE660F362804722CB6C8F568F7B33B1EFD2DDEB68005F34B1B0F55A4F60C55C6E10C1B3092C85B723A9DCEC0921782F9AEE7773EBE19F2F2FEB40E905B8059130B4B9575B660A5F5F21D3D';
wwv_flow_api.g_varchar2_table(20) := '8AC09219F27CCFF576C192EF40E9DA2D591BE006894689486F58AF6952492D19A0BA84132E35924A02722C360FCC5F7C7EE71377E27386ECEA72D7DA00176AAE5A10A6505930BBCF3A1E02D59F3F5BB241D1545A065EB0647737BEF0761747D105591B60';
wwv_flow_api.g_varchar2_table(21) := '7FBD43750E3B320CD365B67871C8DF346CD8CBCC956581711ACB9AB3C932FFE9CF773E51800C59D6A474537A9AC450BDAC632587879230E2219F076D8A8E8E8ED090699A7386B3CEDF3CFDF08387FEF21FFEB9772B6EAE5777885453296D80C3EAA21D27';
wwv_flow_api.g_varchar2_table(22) := '6B6746325636EBF074B4266BA90640711A2F8A2A3850BC35B82577213EEBE5EF60037071B40ADE6903DC64C954D0E4E2A810A61131CCA8113528EB3898A6E6282B85E576F1B90A39B5FF9CDF8F77A8782AE478FE7395EED235031EDA24075A87FE38AB3E';
wwv_flow_api.g_varchar2_table(23) := 'AF25D4065809A496CA342BADC74F6581BBB64C4B20F3CD542C743E54BB54E8BF261126F8A3D2A870BCB4BECFB1F681DB04B8EFC897AC1E93314131137EA46D90A504326169C1FD90AB6FE02676236A592C5D79CFD79AF02A92927A4C46D1C50ADE68035C';
wwv_flow_api.g_varchar2_table(24) := '4199818E6AE2095F802C75F45956A0EB3C51E5B4019E0CC250825290D97CC3DE2E6D809570264B3859206B03CCDA3ED90E3FE4B0B64D1BE0B0BBB2F1002AC8FC7918DBA80DF078029A0CD715E4307AA916E03235D00F394C96AC0D7018B5BB4CB685680C';
wwv_flow_api.g_varchar2_table(25) := '398229549846D7DA008749AB0BC4AA38099B256B035C85AC429B244C90B5019E0A2EDAAF910A320B30C8DE4B1BE02037D20F46E77918FA646D80750A2E4C79294B0EEAC0AB0558833609E48885E71007CF5D6B033CD5FAE052BDE0FDE4082007CD92B501';
wwv_flow_api.g_varchar2_table(26) := '2E6DF0547CCF90A301B3E41660CD9A18344BD606782A8EA2C7D30D65C94170D7DA004FF53EB8147650206B03DCB2E052C478986500FA646D805B163C16305F517D320BBA1946A00DF0E59BD7BACA1268A6256B03DC0CED0C93FAF0ADCECD98426903DC72';
wwv_flow_api.g_varchar2_table(27) := 'D15756B7026408AB5106A10D70A32A7C6531063B8640C64D032CF846C84C1BE0960597AF58054B6E00646D80CB6F5E2B264BA051905B809BA86F05C875EC93B5016E447FD24416752BBAD027D7A98FD306B84EF5AB9B608394B182CCA17C415963E5B401';
wwv_flow_api.g_varchar2_table(28) := '6E59706D547290F1934CB83557A72CB5016E59706D8039B5B26430D67668FB86BFB61A4DF18C1832DF5CCF5FF4D77168B3601D9569E59193806C506812460BB02641EACC46671F1C4A178D672C57254F19A52265B5E9B95095475515283391C62E98B401';
wwv_flow_api.g_varchar2_table(29) := 'AE4EE465B6B8245A34668BA0CB2D93058627E950369391BB1E239C5EAE95643CC15B15DFC966C8C3E3965081096207E7236D801BD35C4C215C872E9C3B4D4E360D195FAE8761ECC5B5618BC5AF76D3B4CEABC8C5F9C5BE3362C59558A3CA2331BD93A2B1';
wwv_flow_api.g_varchar2_table(30) := '584D5EA091F8B5016E44A53DCF252B12A5256BD6518485ECCACF0396F2BC5495BC893348178A71FED4A76462843A6FE9B5A21C0557ADCC53859C83FF9CDF220F2E7FA0EF1C8D0E0F111E3978A99C009F8506305B607A64883AE62EA42FDE7B3FCDBCEA2A';
wwv_flow_api.g_varchar2_table(31) := 'CA64B21378CABC15C3622DDCAB9C4A26E9956FFD3DB5B54FA32DF73D48916894DC82AB5556AF9C7E3E6D1E1C2B8205C5C8A4D3F4E61BAFD17B6F7D9FA6CFBC5A9426C06CA56AE1010C93721D97CC488466CC9C05C0574B9F3A1E617E4E2FFF6738112B42';
wwv_flow_api.g_varchar2_table(32) := 'A95492A2D118DCAB4D9DB366899BC5230311A51826F7D69CA74ACF525280B90F6F9F369D9C4C2A67E19256294530518706B0882FCF825D33BF5CBCC6EB47F9B9930C900F17EEBCEFEC19EA3B759296AD592BD7408DC9E541E52F21E022186826932EE4CF';
wwv_flow_api.g_varchar2_table(33) := '65B1C527474769A0BF8FACA82D7A90FF934B1CD0BFA101CCFD5F2412A3349EB97B60DF07347D462700C245170996D771F10F40162E5D064BBD8A1C9C737F79ACF730F59D3C4AB3172EA1431FF6C06D47720039BD50E5900771501EFC5BB07809B54FEFC0';
wwv_flow_api.g_varchar2_table(34) := '602E2B5E835DF4C10FF7D1C15FFD9CDAA6CF1025282A3AA06FB401AEB7A312570B4B1C1D1AA4FF7AF94501E1B75EF91C2E9847C88B57AFA57B7FEF1101CBD7870707E9A30F7E49B1443B9D39718CF6BEF0CD1C20D10EFC411CCE8BDD7FFF274769D3571E';
wwv_flow_api.g_varchar2_table(35) := 'A0C5D75E2706CAE96370EBC73FEEA51FFCCBB7D10FA7A8AD2391EBBF030AD55F2D6D808B2DC95F449DCED9DA0AA68732306562254B2787A96BC3AD34EB9A6BE4C9B111403B75F2381DFD681FD96DD3C43AD380E4AF2F438CDA713A77BC97567DE136BA65';
wwv_flow_api.g_varchar2_table(36) := 'D366198CF1C02C66DB7471E0337AF3F57FA7F39F9EA01957CF15CF51A75669CF561B60ED351B2F43808DC6E2E24E0B7D20C85AE823472E5EA0259FBB9156755D2F83A8742A252E965DF2F0403F4D9F758DE41A0768642387B2FC91C18B34FFBA3574D73D';
wwv_flow_api.g_varchar2_table(37) := '5FA539F317C8A89B95C3858B7EF7C76FD2BE77DEA60EC0E57E5F34C9AF21E3D53500D7C331992B11948BBE975794B87F9417DEF3946778E01CAD5C77135D3D7B8E8CB07960D47FEE1C1DDAF73E14202673608EC76979449CC5B4870127478631051BA44D';
wwv_flow_api.g_varchar2_table(38) := '5FBA9B965EB79C5831043C00EFFFF5FBF4BF6FFC2B253A66CA5E2DCFA78BCCBFA46E417BAB0D70BDFBE022C1C1FCB8CF547D300F985280D4397B3EAD5CBB8EE26D6D3282E65D99A3BD87E8CCB15EB2D1FFE2F789848DA4C5192F7AF06AD8E0F933B4F177';
wwv_flow_api.g_varchar2_table(39) := 'BE42376CF80D298647DF763C0ED77E827EF4DAAB9401703BD1066BC6B40A7986E9D006B899CD36F1A4F6E10BFDB462DDE731FA5D2C7019FAF0D0101DECF94006463CFFCD59DFA59A721C5EF65C8D7EF7B6CD778A62B0F572BFCB03B3B7BFF7069D3CB49F';
wwv_flow_api.g_varchar2_table(40) := 'DAB1C4C99E224C96AB94501BE0865AB0AA3DDC2B4F5FD2C9518A63856AF5BAF5340D531B76BF51C0630B3CBA3F37B86238EC76F9E090FBECE10B03346BCE7CDAFCA52F8B5BE741155FE7A9D27BEFFC847EF93656AC66CD46024C9DF00AE3A10D70331ACF';
wwv_flow_api.g_varchar2_table(41) := 'B84CAC528D5CFC0CEBD3D7D312F49F0C8FDD6806907B3FFA502CD46E6B17ABE6EB0217F079BAC37DF9E62F6FA5652B57117E4B509A1003E0C348F7D67F7C87A270EB9168A490B6196DACB5CC500366D79CC58A13835BB3FEF3B2B0C1A062982FF76353E0';
wwv_flow_api.g_varchar2_table(42) := '10DCB389CD09EE6BD92A79F42B9B040887CE9FA55BEFDA42EBB9DF8552F0A209F7BB674F9FA2FFFECF7FA3A1CFFA29816549D96254FD6ECE01D42AF386A6D706F852CFD698FAB3259AD8441819BC40F396ADA4E5ABD60848A1882A1C3FD24B9F1E394809';
wwv_flow_api.g_varchar2_table(43) := 'B86C0F6BD872A0920CFB62FF59CC7737D2ED77FCB640E579710CF3E0E4C808FDF4CD1FD2910FDEC3806D9EA46325E28D0E7959109782DD9866D65C8AB67970A3959B2D51A63C80B36A3DA64673E6CA6E4F04D3A161AC761DC6B2627A741803A459E4C0AA';
wwv_flow_api.g_varchar2_table(44) := '79F3C062778EF96EE73573E98E2D77633164767EBE9BEB777FF57FEFD24F5E7F951233664A5EECC2C5ADFBC4CCE5F2B5B01CDA2CB8910D16EB8525A6B02F3B1383A4955DEB643991A737BC7374FAD34FE8C8FE5F537C5A87B85F563EB6DC3476945CB8F4';
wwv_flow_api.g_varchar2_table(45) := '3BEFBE97962E5F291099150FD43E3E74907EF8EA4BE200F8C7A9B2A9115830E6D77C0787BC306746C8EE3C4C87360B6EA44EABC1520A16BAEEB64DB460D162CA40F8B2678BADBC8F0F1EA0FE5327A873CE0299DEB07BE55170263942B77F11F3DD2FDC2C';
wwv_flow_api.g_varchar2_table(46) := '73625E95E234594C81E28904FDEE830FCB7662E98859140AAE9A2DFABD9FFE0FEDFFF93B70FDD870E07E3DE08736C08D6A676E141CC5D46844161F565F7F83C01945FF19C76244DFD9D3B27225832B40E1F92BFFA25912CAD0096BBFF1968D32CF4D61BE';
wwv_flow_api.g_varchar2_table(47) := 'CB0B213C3766A39CBB70112D5CB214E7A516CA236F568408142143470F1F14D7DFD6D189311BAB7569FC4649A2BC72B4016E543373FD9F07F73C48D76FDC442BD67489FBB56181BC767CF2D8513A7EA087DA67A0EFCDF7A12C0A76B509CC95A77574C86D';
wwv_flow_api.g_varchar2_table(48) := '3F315C2BED4BF97EADD283B734F8E02D4409C74691EB41FDA30D70A35C342F2DB25546B0E93E67C1221AC5FEF0452C58F0BA731A0B15FBDFFF854C9D78B0A5A6500C87E7CBBCE478EEF46999FAB05B2E059CB3C6B12DC9B968F9D148B91F2BB7E11F0ED2';
wwv_flow_api.g_varchar2_table(49) := 'DA0037AAB9AA7FB4618D1FFEE2677418735DB6540698C588FAC2F93EB97B92954001E4BE92B703794AF5FACBBB441972F98C85399E25E69CB147830303D2FFCAAED2789103745D1BE046B649813BF7C909812A83284064C8BC296060E084FB638BD68E39';
wwv_flow_api.g_varchar2_table(50) := '0D8FB24F1F3F22D32BB9E76AC24AFB553687171A43B1789BB8F87AF6BDFE9227AC62191F8612B06A17EF10F16A13779D3CDDE1503614E4828A752964C87CBB8D28481552E4247C5FF6D881D8A532749C95EF57AE5C5AA801B39B75B2954D55E456D92BCB';
wwv_flow_api.g_varchar2_table(51) := '65D2C4D0B6D0A153EB268D7403D0106D80ABF07801687E30ABA05396DA00B72C589FB2E894A536C0FA9AD7CA49A704B401D6E956743670AAE7A50DB04EB732D5A1E834166D8075566AAA03D6692C3501EEE9E991BAE07E43B9A76DAA83D1D57E36169629';
wwv_flow_api.g_varchar2_table(52) := '1F4AC6B97795FFAD097057579718AEE959064ED4C64BE5B568A518230196295F54321E13A1CC0B35AD6429ED720DC783A660815036D50A41D1627099159A301A37B9DABEA096B45C2995BE349CB0C2F90FCB4D23377DF22E33D6E820534EAD645C4E3197';
wwv_flow_api.g_varchar2_table(53) := '8B5313E0ADC8712F5E51CB38E2B8C681846D770D2793F8D22ECB835B5587A3966C6B49CB4D51E94BC3729A394E1AA6C81FE5F5D6850CAD9164EA40D4F28E70B64AC67C5ECDA18AAD262D574AD6F839F18E87EEBF07505F88DBB14E7ECF8055E5F97DD08E';
wwv_flow_api.g_varchar2_table(54) := 'A0D54D7C1F84944CA52EA06E0F7DE31F777F8765E697713532AC09706905767CEDBE9B4DC3DAE2910BC86665BB00D5D47E52A571F1884A73C0F58CD7BEF1AD177F562ADB6637B566456976030258BE1699FE3F81A0AD660428E6470000000049454E44AE';
wwv_flow_api.g_varchar2_table(55) := '426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72340069419797131)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/7z.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D00001343494441547801ED9D7B6C1CC77DC77FBB4BDE1D5F12F5A2249A92288A922591F22B961BBB4150B84851208081161181D801FA878DA0086A5B6E64';
wwv_flow_api.g_varchar2_table(7) := 'C529FA60E4142DD2070AB4FD276ED1249564C774FE488002458D38A983384EEC00AD1B5956AD975529962C4A941452BCE3DDEEF6FB9DBD39EE9177D4F16EEE6E97E20AA7D9DB9D999DF97DE6F798D9BDA58899CD32534DF36A191D1DB571F5D8F763AE04';
wwv_flow_api.g_varchar2_table(8) := '6BEE900FA1A0122422071F7FF401DB721EF1C5EBC6574F84328BE8E6FB689F9F725A13E3ED1DED2FFCF1DFFCE3072FEFDBE78C8C8DE178D09F88B67C51CDAA097011DC271EFB8C25D60BA9648270A10A35555D512738AAAABD8A1A91606CB526C44EA6FE';
wwv_flow_api.g_varchar2_table(9) := 'DDF2DC2FFCC95FFFC31968720B3E2EAA56592A6A488433552B1FD5A5FC8877FFE8F39FDBE87AD6ABEDA9E4D0543A9DC5499B15D702202CB352F5943A162EA3F7753E9DF2787EDF82127B2D89D47447777797E7BA6FBAB6F5D9D1BFFCBBB34B09724D3674';
wwv_flow_api.g_varchar2_table(10) := '2C2FC5ACEB0FC022DF399DC9F0880D09DABEEFE753EED7F609EA2BAEA3D4B152D7D1F974CA3CC2B629E5B75AD860D77327DBDA521FB73CFFC8F3070E6C05E01C3E4E908739E2BBD50478686888CA00C93B960F574CB30CCD553BF82F9FEAEF514A193614';
wwv_flow_api.g_varchar2_table(11) := 'ACBB03F8D6F474DA6F4B261FF2EDEC92825C13E063C78E2913EF59AE8F1D8829B623DDC648B5D2E9B49B4A261FF4ECECD1D1E79E19A426BFFCF2BEBCB6C7B36F3501D61A4C3B4701C5530468B5253ECD0D6D4C3A9371114B7CDCF6BDA3CF3FFBD4F69191';
wwv_flow_api.g_varchar2_table(12) := '3137CEE6BA26C061A0F1A5AB46A76EBED2D6E9E90C3579AF6F5B47E2AEC9C6002B671C261EA77D68B06A2E2243A436341AE61A9013C9BD614D8EA3B9360658AB409CB816DA5A881E0ABD509A4C734DC89E65BD34FAC53FD849738DA9A13A57281BF11D63';
wwv_flow_api.g_varchar2_table(13) := '80978406E71539CFAC0019D1F57D8EE3BC38FA65401E03E418055EC60017C67EC44774C9E6CDD7609DAD0039994CDEE3B879C8794DC6A08E7CB78D01D6128965AA7D70B106EBAE1441B65D1BE6FAC9DDD4E411986B78ED4843360638D6265AA32C9F2AC8';
wwv_flow_api.g_varchar2_table(14) := '19FAE464EA6ECBB1BFFDE7079E1A1E03E4B11142E6324034376380A3D9BDC5B66A414EC1620820C3270F7BB6F5E228202B4D1E19892C6463801714CD62E5DCB4FCB7B4434A933985824F1EB6F290A9C92311856C0CF02D45D334688BB97045C3343F4F4E';
wwv_flow_api.g_varchar2_table(15) := '439313C30E201FFAD293776BC858F53226D3C5B4BC5C5E638DA94834E55AD1ECE38540A9E2614AB9D9E9CC4C8E9AEC7BD64B87FEF0C97B0999EBF351826C0C70C5A26936CC52D72F44D1A54E9639C6C56BDF77B018926B4BA576E286DAD143CF450FB231';
wwv_flow_api.g_varchar2_table(16) := 'C0B1D6E002C345F6622E64D73A3AFAECFEFBA8C9AC320A9A6C0C70AC35B800B88A5ECC816C5BDE8B87BEF8F45EC0E5B35D4D876C0C704146B1DE59A406EBBE8620639EBCC377E46854201B035CA568B4889A9B1682AC1A9AA1204BE09393C94171E44814';
wwv_flow_api.g_varchar2_table(17) := '201B035C8571AB419A868B561364956A029F58CA075E78BA743B217FF5E0330F34D35C1B037CDB6BB0065E30D79C4225B67BE2BE74E8C0FE079B05D918E0A5A1C1867A91879CC13C194F866CF56DFF68B3201B03BC3434D8602F429A0C73DD8F474F8F1E';
wwv_flow_api.g_varchar2_table(18) := 'FA72E335D918606DA16299167CB0210DD642086932CC753F1EC07EF1AB5F7AFA138D34D7C6001B168D1651FCD322C8C92DAE2F84FCC94641564FF6C75F8AA67A60D044879B14820C73DD07DF7CF8D0B3CF3CF6A7A3A33FCADF4BB635F0703113FBC600D7';
wwv_flow_api.g_varchar2_table(19) := '493426FAB8883A6887EAD41305591C065E30D79B901E81267F0E875F57D60F77A1EA0179D94417E1AF135C7D8DFC3C59414E2436799E1C1D3DB0FF615CD5075C7E8CF1D097345EA1AE389E69032289BC26CFCCCC6493A9C41DB6EDFFEBF3CFED7F18F2F2';
wwv_flow_api.g_varchar2_table(20) := 'FFAC0E909701732416962AEBACC17AD4ABDFE8490B34390B73DDEB7BFEE1AF1C7CEA37EBA1C9C6003748345A4466D37A4D93E6B49200F521ECF0AA2D99B482BC11CCBFF595834F7F0AE769AABD7D78DB80CE5B4B6A0C70A1E5B5B4A65965B506D37CD671';
wwv_flow_api.g_varchar2_table(21) := '5350C3F553932D69CD075EBDB8F861FCE0EDB79985F7944DF8646380C3ED8ED53EF4C8B26CFC3A05B2B62CA6FCA561C33E76702D676626378365CD1E71EC6FFCC573CF28C8D464C8B2A641775B4F9308D5CFB94E7A6A320D259E0C59D0A68CD1E99B3269';
wwv_flow_api.g_varchar2_table(22) := 'DBCEFAA95CEE6F9FFDFCEFBDFF575FFFE629986A5B3F21524DA38C018EAB8976DD5C327B33EBE4722E7F5A5893B65403A0B88CDF8A26B81878BBF0486E1FCE9DE26FB001B838DB22BE1903DC64C92CA2CBC559214CABC5B25BAD564B72AE8BDBB901653D';
wwv_flow_api.g_varchar2_table(23) := '60D92FEEEB94A5C3FBFC5E6ED3F974CA7CE17D5D6EF698050B6D8B8B5187F7C3E4F4F95A526380B5406A694CB3CAFA7C2B0BCCB5633B0A72D8F1E97EE9946D0CEF2FD4669D4FA7E5CA86CE7BD877D4DB4CF257D1AFC958E83A0B9D3316647114C67863F3';
wwv_flow_api.g_varchar2_table(24) := 'F19323CB6A751C86D278A98C5236759CE71AF82912A37E4D46D1C1457C31067811D78C74561B6FF802E492A634D20D2FD33863804366A6CCA5E2737829413606383EF82A6BE952816C0C309DD452DBC290E3DA3763809792890EC3D490792C8E7D340638';
wwv_flow_api.g_varchar2_table(25) := '2C94A5B6AF21C7D14A2D03AE70348621C749938D018EE3E8AE906D211B21B7C46C0A650C709C46758158153B71D3646380AB90556C8BC409B231C0B783890E8F480D99028CB2F5320638CA9D0C8331B91F079F6C0CB049C1C5A92EADC9B460511CE4CB80';
wwv_flow_api.g_varchar2_table(26) := '0D8C2605B9C5C17B88A307D918E0DBCD07CF1D17BC9FDC02C851D3646380E776F876FC4EC8AD11D3E465C0864762D434D918E028061886D9555C9DD6E428986B63806F771F3C977E54201B03BCACC17311E3659611F0C9C6002F6BF07CC03CA27D3205DD';
wwv_flow_api.g_varchar2_table(27) := '0C253006B874F7968F5202CDD46463809B313AE3347CF83399664CA18C015E36D1B71E6E05C81056A314C218E04635F8D6628C760E05190F0D50F08D909931C0CB1A5CF9C02A687203201B035C79F7967352028D82BC0CB889E3AD00B98E3ED918E046F8';
wwv_flow_api.g_varchar2_table(28) := '9326B2A8DBA50B3EB94E3ECE18E03AB5AF6E828D52C51A3253F50365838D33067859836BA31240C69F64C2A3B92665690CF0B206D70698A5B52683B1B1CDD82FFC8DB5E836AF8890F9703D7FE86F6233A6C1261AB35C4720017583C2903096011B12A4C9';
wwv_flow_api.g_varchar2_table(29) := '6A4CFAE02563A2F1DEE59232569169C933B307CB959DCD31BB57497DB3B9ABDB33E882C518E0D2E2ADAE83D5946A6969151BBE4BB78342F27D4F72D96CB0E85B4A6AFCF3DD28C3B22AFF0217D6C5DD5C563CBC6E0911D102B9A373CA18E0A67617C2BE39';
wwv_flow_api.g_varchar2_table(30) := '794332F85878CF1437CF73A535D9266D5D2BC102C7F40BB042B267DE6C262D372E5FC469C05E009AD27274B2ADAB5B12C994CA1FAA2AB2BBC60037B387D4A8D5EB7BA56BE7B0D25AAA31B519AF289489CB97D43105B9A0DF416BF1BE31E958D12D770CEC';
wwv_flow_api.g_varchar2_table(31) := '50703544958D2396E6209F6AF8D7AF8ECBD4F56BAAFE66F6B9D26BC71630613830AD999B93926CEB904FFDCE3E19D8B15332D0486EADAD09B90110FFF6D2613973FCBFA5B37BAD7839BC3C2E6F6AF04E48999C1897A1BD0FC9C39F7E441C0C08CFC52BD0';
wwv_flow_api.g_varchar2_table(32) := '0A5A1C32F6D46E65197CF9F1F75F95FFFCEEB765E5DA0DE2C10560F4542AEBA6E48B2D6072E2AA4F7AEA5732307C8F82DBBD7A8D6467320A920D202BBBBB65DBEE6139F9CEDBCA64AB5522BC475F410448373B23A9B67659BD662D064B0B5F2138ABC90A';
wwv_flow_api.g_varchar2_table(33) := '5C301A38986C2730F36D1D1DAA1C070ADF96166DBC622EC86AE8F084542DBE7670262BD4C4C15D4342C14FC107E38C824458A9B636E91FDC212BD7AC97F4F414F274490E80F3D8541D34D39974BA08700B607380CCE22349BCF0B0A19D3473B1586A3045';
wwv_flow_api.g_varchar2_table(34) := '4D933A3D7543566FEC93CD03836AF5C7CDD98297782A4DA44652F3D6F7DE217D807CFCAD372405C0DA9706E20B022B6A67003438FAE185F372E3DA04AE41F1F04D96D060046A043C7EF14349B677AA633C1EF5CD18E04676959028DC6C7A5AFAEFDC253D';
wwv_flow_api.g_varchar2_table(35) := '1B364A0EFE95502F018E07C81BFB36898B631D9D9DB26DD7B01C7FFB0D7C87C663607010146D683CEB63BD0CD8FEEBA73F911F7CE7B0ACDAD0A706CBAC262BFBA022F379751455189D2FC19CC2407B02B367A0A25B55416D52E6398369504AB6ED1C9254';
wwv_flow_api.g_varchar2_table(36) := '7BBB02412D3CFFC159B970EE6CC1973238DAB26D5056F5F4AA2951104D2F7C116505E09F69E63D98F02075D580E1E089D3660C70233BCD6029039FDAB3A95F366D1D50FE9170B3998C9CF9DFF7E4E4F163823F5BA34C2C357BDDFA0DB265C72EA5F15CFC';
wwv_flow_api.g_varchar2_table(37) := '2836D3255ACE489A7367E5AD833FACC05C364C36AD449CB6D801A646723AC3087800F35E46C059AC5651F0D7E137CF9F7A5FCE9D382ED727AEAAC89726971A3E88689AE69953A560E1A33CA6442221DD3D1BA50B517857F72A4CB15649D7AA35D20E73AF';
wwv_flow_api.g_varchar2_table(38) := 'FC6E23FD51F9665674C6D8706C489FE92701298BA89701D3B69DBBA5153032D05C4640172F5C902B17CF23BACE60FFBCAC836F56DA8A729BFAB7CADADECD72F5A30FA5AD156FCE9FB7C1FF62F58B03E8FE4F7C5286EFBB5F055EAA5F28DF8232573EBA24';
wwv_flow_api.g_varchar2_table(39) := 'DF3BF20D99BC3E218954DB7C5F3EAFCEE61F3006B8213E98A613DB4CFAA66CD9B5477A376F867FF494F666B319F8DE33EABC83458EFF3B735A76EEB94BAD33D34CAF5ABB4EB6623A75E9DC294C973A15481516AB1230C6A10E74AF5A2D162C03D4559DE5';
wwv_flow_api.g_varchar2_table(40) := 'FFAD004CCDD7411A0D7770365F4144136326BA119DA580957906B0C1DD7B64C5CA6E0046F40CAD9EB87245DEFDF95B7213DA35833F5FF2EEDB6FCAD5F1F1C02C23304A24936ABEDC9248AA604945E265A0F01CEFC9529BF951FBEA3B47013F8DE86D99C6';
wwv_flow_api.g_varchar2_table(41) := '2DF2B0310D5EE475179F5D99674BB2D369E50FB92C49B0D44E6ADAF5890915F1F60FDDABA0646E4E293FCC79B08209C8776CDE221BFB07E5E207A755041ED6DABCB22A1F3B7EF923CCB1A78A4D349645AFE038A36ADB0EE6D88BEF44E34BC40730694071';
wwv_flow_api.g_varchar2_table(42) := '66D25332B8E75E2C60F42AF34C7884CCEF8F7E61BF5A90A092713AD3CE65450E006CFCBE02C1D2E0D05D08C27E211DD0FEE22913A75FB410AEFCECF51F16E6C1FCAED7B0689669CB5BE0F7198DC76133069886AB6E1BC0AAE8194110A3D8ED437B941FD5';
wwv_flow_api.g_varchar2_table(43) := 'F078AC13B70557C27716AC271AC4F9ABCEE3210FFDE8C09D3BE5275CB224F8B00A871ACFFA187079F81B28B3F35ED58840AB713E2E5B3C7CB0521C9867DC295A8DD5A5CD58B85066372F6846B80E961BA96DBCC3A33ED8A74606C1112A405E2E606CE8ED';
wwv_flow_api.g_varchar2_table(44) := '93BEEDBB70176A4AD5510A94F2C130C3DA070769F0101C074D9C36631A5CD74EE7358DB706EFFEF5DF9035EB7A0A8112619C3F7B462EFEF28282A9E6A9680C8F67B1D8B1168B1C9C22F13BE1747475C9F6E1BBE4D43B3FCF3779BEEDE140C8A67F25EE4C';
wwv_flow_api.g_varchar2_table(45) := '5A0D1A6D16A8B75C45133B51D7EE9AACDC18E0F96232D74CFA3E152D23D0E19DA32496286730D7A576A6A7A7E58DEFFF87BC76E4EF65DDE03D6A0ECCB6382D09B97AE1947CECB77E57461EFF7D98F01558109951D134EF307562E1E2EA2FCF01BC6E27D7';
wwv_flow_api.g_varchar2_table(46) := 'B7835B89F7FCDA83B215A65CDF6C600E1A0BDE651AFFE8A2BCF6DD57D4AA192D871E50BA96A8A5C600D7B363D43E4E7DD66FDEAA22619A6025581CBF76F58A9C7BFF3DC0BD57DD0E74530CAA30CD8179EE19D88D95AD136A81A26BC50A55865ABCB6A707';
wwv_flow_api.g_varchar2_table(47) := '4B97BBE5DC3B6FA8BCF4CF163EF4B7BC562FA2EDBEFEAD01550656F9308B03EAC2B96EF921B4983E5A2C6832C947788BBE0F86C0B9D13C0F3FF0905A57E69FA04BA6524AA3689A2F5F382B6D9D00887F04CB7747924B22D52E93572FAB1B103C9EC2EA13';
wwv_flow_api.g_varchar2_table(48) := 'A7560CC6863EB6177F79745AF9592E4D269209B52AC69531CE7B39800274F9340F3248A20D353CDE8C697080215CB5997DD64BF3CC87E7F884C6C49571F856AE3D630E8C35E893EFFE023982AB17DDC2538030A5C1837727DFFD1F3CF171A77A7A23875B';
wwv_flow_api.g_varchar2_table(49) := '8604DA86F5E99EEDF763D9F11ACCEE25E55BD552657E40855BAFCD304DF2B52B9715FC5BAD6787CB3773DF18E07A8D692D5C6AE39BAFBD2A6FBDFE03150D33B2E514880FC17576AF510B10730549601C18E74F9E9057FEE5EB4A433908822997276D78E0';
wwv_flow_api.g_varchar2_table(50) := 'EEEC7BC7640C7E35D8D88BF24355056E58F77673AE5A1E8DC35CD818E0B9C235F99D82A5302F9E3B8DBB48590588E0A945C9F60EB51C59CE17B22C7DEC25AC536B0DF531BFE5531CBC6191816F3FFFFE6534772E5CFD5DA78127E65D2B3EE4C77AEBB5F1';
wwv_flow_api.g_varchar2_table(51) := '8AA6B65800D69D2510FA52FA412D5E4223B0C2019D39947220B4435BC944955529822A045C04D6D18D9B0BA1FC6577594E2D7ED4772E5C515BCA36B2F844AC00D3BCBAF8CCDB6E2911C20C962CE79655C154997373F3C6F1BBB128FA96328EA37496409B';
wwv_flow_api.g_varchar2_table(52) := '8D0136E93796805C6BEA8249591A03BCACC135312D2A6C5296C60017B570F94B6424600CB049B31219E92C818618036CD2AC2C01B9D6D40593CA620CB0C946D5249D2550D8A4B2D404F8D8B163AA2DC1FD9BFCDAFC121070B3BB4065D1B3762DE36ADB54';
wwv_flow_api.g_varchar2_table(53) := '13E0A1A121A5B8B6EFF09794F1788EB45A4935B81C65CA4B6A19577BF99A56B2F4E8F22CD7C748C12AA0BAB55648165C3FACA6C5EC72B5BEA096B26CAB2E3F37ADA41F9596517729B1C60E5152A6AC5ACBB892CB94CA5313E07DA8710C9F56C73AED7AD6';
wwv_flow_api.g_varchar2_table(54) := '89B66472682A9D563FC0554F2096BA62ADC728AC6AB75ACAF29ABAFCDCB492F69429438A3C951FB71E64E8DC4C674EB43AFE6956AB65CCFD6A367DD96ACAB2516AFD9E850F3EF1D86700F5855432D1CDEF04AC1BCFEF51DBA2D63665FB20A47426731D6D';
wwv_flow_api.g_varchar2_table(55) := '7BE26BFF74E415CA2C2CE36A645813E0B90D38F8F8A30FD896F30896F601D92E7157A09A26DE2E653C3C87625FF37CEB7B5FFBE76FFD6CAE6C9B2D859A074AB33B10C1EB1B91E9FF03C8B29D294F2532BB0000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72340484409797132)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/ae.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D0000119B494441547801ED9D4D8C1CC515C7ABBA677766BFBCEBB50D31060218B08D6D30041C99444908424A0E4151C25A8990924B2E91724814620C4262';
wwv_flow_api.g_varchar2_table(7) := '95534EB9E5048AF20136617340E1028A60D741209143A44008E1C310071B12F062AFF76B6667BA2BFF7F75F76CCF78773D335D33D3353325CF7677755575F5FBD57BF5AAAABB2D8481A09490068A696B116A72D2E984FBA81662A63AA2DE630A454AA198';
wwv_flow_api.g_varchar2_table(8) := 'EFECB31307B177AF506A0C5B5F0847FFABB7CC9AD3E30ABC44BD81599452BEAF54CECD0C9C1D18B8EC3179F7E42975D384ABD4941FDD4FBDE5A6317D22CD8BC39D7D66E23E507E7C6CA47F94370A21A53F284F28679328CAF1E7D0207F3870D72FFEADA6';
wwv_flow_api.g_varchar2_table(9) := '2733E22B935EA7404E84413D3DE1CAC353DE27CF7D6BBB5370FF3C3E9ADD3B7BBE5084C16E40AF5ADC1E149B60C977FB4797378D6E1F592979AFE47D79FFE60E839C08C454C8C42F88EB9450BBCECFAF4075355C969BEE9F54121627035B2D8A457F2137';
wwv_flow_api.g_varchar2_table(10) := '3270674EAA27974F3C72ADBC6BB224662661AEEDF72D12019E98D8ABFB5EE9B9D00674C5813DE05F2B7EBABA52BA689CB230BFAC72C3D93B855AE928C889004F4DBDA1659471A10EF05B34578DBCC5E636C1E5E06C31B7F6A0F3F3792F373C708890F32F';
wwv_flow_api.g_varchar2_table(11) := '1DBD8E9A3C63B92627021C6930256413DD781BD4A6464AE538180AC006E51708397748F9EAF8DC899FDD7017CDB578DADA215422C0045B19B4425746A5F0285E4BC2861607033DA5FD8600F250EE60BF729ECC4F1FBD5ECAC39EAD9A6C18700A69D65025';
wwv_flow_api.g_varchar2_table(12) := '28AE76A7B0216FC8049A3CBF0C4DCEDE0157EC1821DBAAC95D0F98DAAC35B8B22138F419F30B052F37A4211FCFBF78641735594C4D5865AEBB1E3055566B7025601E513632BF08C8C3D9DB7D473C55987E6837C7FD62CA9E3EB9EB01AFA3C111EE003234';
wwv_flow_api.g_varchar2_table(13) := '796038774049FF7800D91E4DEE6AC0DAC1A29AB20F5E3F94216787B21AF2FC89237B024D4EBFB9360C782339AD2FC1769D897BD397A8430019E69A90334AFEA130FDF0BE55C89C064867300C38B5F75921FD7833ACA3C665C8E893F72B5982B97E20847C';
wwv_flow_api.g_varchar2_table(14) := '188E573A211B061C175D854C537510875A678D03C898F1CA0EE5F6F9D2493D64C380E3A24B15D38ACAD409B5222F0E1CE184335E21E485BF3C7033CDF5D4D46167120F0E546768E771AA2AD32A41C49B21F7EB36AF98F182417630842A615A739FEBBB4F';
wwv_flow_api.g_varchar2_table(15) := '2D9E387AEB61407EF4A637249F0E69D5BD5CEA3A862B9250372E55DB269C678D2FE145AF7955895C681A2E26430039BBC7F1D5B11540D68E578A201B061CD78D35E5D2619131C823D9DD5E1CF2A3C09F024D360CD83E0D2EB7B806AA1EAC345E04F9F8CA';
wwv_flow_api.g_varchar2_table(16) := 'F491DBA59CF4450A201B066C8706C759966B5CDE2923BFE48E46AB0BAB80BCCB13F2F8E2CCD13BD200D930E04BCA241509AA59D6ED64457701B8441B8410F23CFAE491ECF5AE504FA6017257028E90704B056CC4C9D26594E106E568DC3270BC30E37583';
wwv_flow_api.g_varchar2_table(17) := '03C84B2F1C39D84E4DEE7AC064D4B0066BCAC19F55D6A126730805C832238F2FCD3C74A85D90BB1E70220D8E01AEDC8D411ECC5E27857FAC5D90BB1E30C198D0E04AC03C8A411ECA5E530199D76CD110AAAB016B0758A3D870B990B41A0C559095777C79';
wwv_flow_api.g_varchar2_table(18) := 'FAC12FCA490CA1105A01D930E048640DCAA3C5D956FB4D4ABB59178F411ECE7D16F3D8C7965F78F04BAD829CF8E5B34AB16897A5322A8547BADF0DEB5586DCD4AAC7200F65AFCA2FAE3C519C79E87EF995C997D83DA847B97C1168B5697175A50697A142';
wwv_flow_api.g_varchar2_table(19) := '9A4D53DC8B48C521F75F55121EDEA08026EBA74926C1B9390B148601C74577D11DA626A27550AB6F390679307B155EB085B93EFA55C4A24ACD816C1870F50DA5F378CD66D832EA21E4A5952256A176888CFAFDF289E641360CB8655232DA72F430694DEA';
wwv_flow_api.g_varchar2_table(20) := '462F132B8C904506EBC9C5DC60F60A5CFF89E5178FDCDD0C4D360CB8A5528A09ACB1DD7273643F181E70C355A2BA7F35E40B93E8B2B10F612940CE170706B3DB852B7FB73073E41E42A6C3F534DEBD469AC4C130E0B2C81257AC5505E826C907E6286E7E';
wwv_flow_api.g_varchar2_table(21) := '8E0217E69FBA7F35E40B930417D137A8AFD2A79F0C8126BB423E81D764BEC6537C3AC4C438D930602D2E5DF534FF899AA1AE2DB4D7910EBECBE108D7757DBC65C8370D5BF3E3B5712DE94A7765B9B882C77F2EC380E937C5571ED190395666A34B224BC3';
wwv_flow_api.g_varchar2_table(22) := 'E3E02455695D5E4A8C9009D5F356DC0BF39FE67D2517E8CCAE25CF28FD5A358CCE45DBEA34EBC5335D742EDA8A0B6AA12FE35E5E982BFEF23F4F7DFF9DABBFF3DB935378174A08BC2ED360E84AC0ABB28268FD42B658CCBB78125679BE90784D38EA2357';
wwv_flow_api.g_varchar2_table(23) := '9371AF4CA132BA7CB4D1F9F8B9F87E39331B1B9A97527D38EDA1127B1C2773254E9F0CDEC18E3E9611CB50E36ED702D672861A43B032D72FFB28E085BC2F7CC439863BAE1A5900B014FD1947144A5EC9F33DBC789E3C742D608A8E2E0EBD651FCAD30FDD';
wwv_flow_api.g_varchar2_table(24) := '19C223CF65C83C17CA978D8161AD63DD50706EA36D2D79990665E0DB5DF0A751B3E85AD1673278BE91D0A6B6DA48559B938790D9F1D299C9428F877370B920611FE65A77C8E139EDECB083AE3A8EE237DA46E736CACB34808ADAF022AB21FE998CD5D8DA';
wwv_flow_api.g_varchar2_table(25) := 'F7BA1E705C5410B2C866A400646DA679DCD2105ECFE4650D033659B5968AB67C31DE41DB20C755B75CA3643B860137A186C9EEAFA1DC6D85DC508DD7CF6418B0FD1A1C894A4386E3D50E736D524D0C033659B548D4EDDBB6BC4FD6FA413FCE5C300CD85C';
wwv_flow_api.g_varchar2_table(26) := 'C5D252524B3559EB8749BCC197640CCAD26CE50C562C51515A93DB64AE13551C990D6B706799E8B8706D856C1870676A7004BA1A32A7358D06D3E5A172860177AE064720E390316DBCF6C24494B8DE6D13C4671870BD776467FA32E401AC219B865C3151';
wwv_flow_api.g_varchar2_table(27) := '995C3E3DC00DCA9090FBB12C306C12B236D166ED740F708380998D288C43EE697002224DC8AA217381C28426A77F1CDC04095A50A459736DD6D3EA9968430DC89C26F7FA604348CC17A335D994B93654BD9E061B1264544C0479A4E13EB967A22359A676';
wwv_flow_api.g_varchar2_table(28) := '4BC87DD0E4C620F74C746AC1C62BA621639C5C3FE49E06C7E598EA7DEA625993F1A611A1D7124C22EEF5C1B5483C419AB2B9C6837C994B410E1B408DEDA0A65AF500D724A6648922C87CFC6743C8A1EAF6343899BCDB92BB66C89800ED69705B1025BF68';
wwv_flow_api.g_varchar2_table(29) := '35E4B5D7934DEAAFF1F5E0E442E8F412E290FBD0275740D6AA5BF966435279F4FAE0A4126C203FA1F671A9117D7205E450797B26BA01A1A6290B391222875011646A7633424F839B21D51ACBD4E69A932115DE75AF0FAE517C7624E3472BF13FA86BC834';
wwv_flow_api.g_varchar2_table(30) := 'DB7809DCE8927F4F83DBDC0E22739D09CD356157385E09EBD7039C5080A6B2D35C73128473D774BC4C85AE7EC3DF94104D95A3FBE4703DB98437D04D841E601352345886D6647C62A0CF3183A667A20DC2315594C91193996662EACE8C95B39E88361A82';
wwv_flow_api.g_varchar2_table(31) := 'AC9727AAD44679A334E9DB76206080927DF855DD9A429FA68A20500D92C73064B21F3F1A341E57C15C372F92A63C544921E5B5ADA97A70414BE731C97B0EA923771470650E6EEA16C4451059580857E14372A58F7198471C45126F04CC9B4551C82B595E';
wwv_flow_api.g_varchar2_table(32) := 'FC1C0E531E3A0C30344FAD0891BB1AAF1CDC8A7DC0D10150FD2521F26770C4B8484311AFF0BD310700073E0788D896F304397583F00B42143E445694ADB53C3A97FE6D87008656D1247BCBE0D1279C9DDF1572CB6E6825C090253DD2C2BCF0DEFCB510F3';
wwv_flow_api.g_varchar2_table(33) := '7F07C8CD8804589AE5D22C3EABB347B8BBBE27C4F0E5388616C735957997CF0AEF9F8F09B1F42EF28E226FC39F8E6C798BE810C0941B019F1562F41EC0DD25E4D0D610300853EB06C7851C3F20D4DC2B803486F4248F1F351E8D420C6E1172F832218A68';
wwv_flow_api.g_varchar2_table(34) := '24652D45C3C139FCB71988431ADD289807BB96840E011C9A5A985F67FC6628E690D6580D821CF5E0322B1C68B5771A5AEA434B1DF4C93A101888F9D04A0F4E18013BE86B19C740AE3CB75A1863AD09908CED81DA45ED9D43DF7BA3909B77061AA99D2980';
wwv_flow_api.g_varchar2_table(35) := '619F4A6004347285909B6E06B0051C933CCEBB23D82C0AFF8369A13E7E2DD05E9A65E6C14F7DF20F9C9B81F25EC0B981A03CE4B4257400608A1AAB30DE392147016F647BA0712EE02C9DD53F0D931F9FEC1F86F9BE05E96196E96CD17B760603C0EF3D2C';
wwv_flow_api.g_varchar2_table(36) := 'FC8F5E0EE2357CECF2E8A357857FF2E7003C8FB4D47AE4B328580E9866149A062F57BA43E863F706E6D9A70305C0E74EE2F70EF6A9AD0CF8CAE8E61BE0615F8D3C1C1269FB1D6C9D2B71487B5C1518E7C0ACC7D3562549F3A1E58029779A678C7907770B';
wwv_flow_api.g_varchar2_table(37) := '39766D008240BD15C0FD9750B330BBD8D790D1974A78CA720C43280F6365ED4C05F02541969DAB1832C4E973B1289B762D071C68A0528B8006E76A681BC0C151A2E7BB3C2BD4C2BBF09AFF86F98B1026FBE3CC00CC344CB9CE4AE72928438F8723C7AA82';
wwv_flow_api.g_varchar2_table(38) := '6068CA2BE2EC39B01870E45C016E661BCC33C6BD80A7B8CC060D56731FC0933E2D54E114F64F8108CD7910B4A60FEC426358440401E35736E361A2F286E7CA07D6ED580C98B246F5696A876E8283758DF67025BFC74FF37CE17DF4B32BE88AC7853A8F7E';
wwv_flow_api.g_varchar2_table(39) := '586B36CED14C73CCBBF936F85898E458CB2C5B8771FD0A5B0C1855E73423863A72F37E8C60C603882ECCF3D227429D7D15A7CF40A30B18EACC04DE3467A868A6312529B7C0218363169401155D55F0F5A565E1194B0147E619E3D9FE1D8005F38CB1AB0A';
wwv_flow_api.g_varchar2_table(40) := 'E791393CC247F9851CF9029CAAFD38D70FC0584C8805397A35347F3FF886FDB3C56638765B17ED5A3A9315D050FEBC70463E8FC98B1D5A33F9FF2009FC672572D395C2DDFF9355F34BF07DD0563D230519E058E6C6D03060A62FBC84882B2E124CA74458';
wwv_flow_api.g_varchar2_table(41) := '0898B694635FF4AF30B9721CE639BB49830D1C62C0CB8E6175884B83B140B87A7C8C386DA6FBB563263FE0D425273E208A751D2D4B0D1DEECACE9AB32FE57463EE1A40BA31B80D6D9EA1D9E88383FF51035ACBB8E847E78BE7D80A741CF6F4D4E56D681C';
wwv_flow_api.g_varchar2_table(42) := '9FE200E7D61C26218BC51DB4851A0C500484F55D390AED1DFE4CA8996CAB181E9D7B1F66F734201366E839D1A2437BE52087533B910C69790CCD975B0EE0D980694C459E12D2E3EC562C301FE254F14D0CC5389BC56BE0DA168D9B2C034CE78ADA8B755E';
wwv_flow_api.g_varchar2_table(43) := '97131670A0FA3097CC15A00CD676B1F54F3D2FFC333F05BCAF231D16F9F53008794AEF0B31FE6DAC2DFC3834E9981071737A782587F609B9ED47C2D9B63780C706C480CB393BBE8C86B143F81F3E8F29ECFF21020B0E16CD475B069852875AF998A018D8';
wwv_flow_api.g_varchar2_table(44) := '194C4D46261820F5E2C2FC5B807E0FE061515FC2B1A216EAFE15FB8B58B05FF82F4CFB18AC3186572438B815E5DC229CEDB743BBAFC5531F5895D280710EE7E5564C880CA13FFFF8654C9C9C0ACA8C1A008B4E79A0CDB128A0BA00A3F0EC94DC7A087D28';
wwv_flow_api.g_varchar2_table(45) := 'BC676A28B598C3A4F93378FAE26D98533A58D042ADBD384FC8D03C85A737FC73808C7899411E6E0978DB81302D12F2B11D5A036EF9D34B8D919808DDAE6099061330578E46F5C486C2A334FA111BF6B79CBD9A7D1DE731F941B07C5243930514ED3C71D1';
wwv_flow_api.g_varchar2_table(46) := '202BD4A7AF61660BA63D83A53FAD895861CA207F712EE8BB7D98EEC89B663E1722C2BCB6603C2DC1BA8E583AC15B06988B03E84FE1F1FAA7D1277EF86200490305D8022633E80CE9192EAA2D43B485463B184E2DBC2DBCD77F857D686985C344ED8CD232';
wwv_flow_api.g_varchar2_table(47) := '1F03E3D05808B788C6E4C0CC5BF43C16EFC032C0A8B1D62E089E0FC0692DA5F9A43906786724D85680E36D868179A9B54BEF601B5B492244B20D351A3B388860635F973D8C2DAF6557B00F70245F3EDDA8051EC1C056438B8EA384555BE6C960DE3A201A';
wwv_flow_api.g_varchar2_table(48) := 'DB329DA6CC9D5808E3B45588455BB26B2F609A4A0DB45E49B321B03F8D34B4DEFC76A5B7CFE618916F77C0A5A8BA14B091566245213DC056606ABC923DC08DCBCE8A9C3DC056606ABC923DC08DCBCE8A9C8601730CDA0B69924022C053536F94C71BD801';
wwv_flow_api.g_varchar2_table(49) := 'DDF2619AEED1AABA544B302EE3466E2411E08989BD5A654B5EF082658F7123086279B49604569032E59948C6B15475ED269AC98A5A97723DD4CAC157F8749D5843FCB8A96E8F75D5AD1B13F34B860C2A90A910918C1B154622C013E155F10584F74441BE';
wwv_flow_api.g_varchar2_table(50) := '3536D2BF77F67C014FBDF1440F6EDD5094F021437776AEF09653824C112219D75D5698211105B43689051ADDE6669F99B80F3B8FA382FCC6417949B5D18A755BBE6899F9FCFCCA1CA0FC60CB37A7FE4819C465DC884C1201AEAEC0D967270E02F7BDA815';
wwv_flow_api.g_varchar2_table(51) := '9E8971B02E8790A897D72574F61F2D25FC91909494E7B1FDD3D66F4CFD95379D14AE31C1B122C60AEB15A425604AA6FF070930D174CF82409C0000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72340943264797134)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/ai.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D00001A22494441547801ED5D798C1C557AFFAAAB7BBA7BBAE7F03DB619DF6363F005C60663EE05DBB08B954DD64E94B0EC4A59254AB44A94448BB48784B5';
wwv_flow_api.g_varchar2_table(7) := '602CB1BB5112925D299B3F3604EC5D26221257D80404018C6DCE051F1890011B33BEEDB967FAA8AEFC7EAFBA7A6A7AAE3E5E4F770FF346DD75BDE37BDFEFBBDE57D535223A8A2D868E6ECADAC78E1D3E9908F3C862A23FEB38FF43DB36C4306C365CFDE2';
wwv_flow_api.g_varchar2_table(8) := '7DEB6DF16DC561239895AA64D84171CA32241436CCF3D36B6A7FF9DCC61F1DDF76C51366ABBD9D74ABF9E4CF8CCA6B519CE679C05DF5C27DDF307CC62FCDBA50A39AA6515CD7B9B18A3814368E61DB62A175444CA94BFA9E1731FFE2F90DDFFFEC969776';
wwv_flow_api.g_varchar2_table(9) := 'F85FBE65873551402E8C3B69EE6F7B0212BF7DBBB5F6951FCC4E26ADFFF537D65E996CEF49E0B2CF617CE100A487486F86EB67B873835B39476E3D778BB30017F41929B153117FA06F6AB4AE2E95B0F6899DF8E3E737EC9850200388C24BABB4AAC65632';
wwv_flow_api.g_varchar2_table(10) := 'B1083BCBACCE3E308FE0F2637BB6DC2FE6E3F6E7ED63B873DEEBEEBE5BCFDDE2BC817D3816D0A95C14C0EDAE69A8DD20BEC0E39B0E3CB0F0E55B77246F79798739117C324128BC6CBB92AA20366C33B482BE1847FCAA864F1A62D866121DEFECB3FD91D0';
wwv_flow_api.g_varchar2_table(11) := 'F53EDB37A1402E0EE0D6C3CAC41B760AF127C2167544C8ABA7A40D372268DB4876F55B81BAF00682FCD537772D9A089A5C1CC0690D762C1D3458E973F580EBA1541921EA74A2ABCFF247431B2C2BB5E78EFD0FB410E46DF244D52EA18A03D8C32158B941';
wwv_flow_api.g_varchar2_table(12) := '47557540DB43E174E2075793D79BD0E4CDAFEF5AD26A6CB7AAD5276B04B87AD557C10BF94CDB201580253AA1C975A17588B57713E46AD5648D0057BF067B66A040A64F5620FB527BB6BCF9C0326A72B5996B8D0057A106BB24D340538307FB1507E46E80';
wwv_flow_api.g_varchar2_table(13) := '1C0D5D635BBE5F6F7AEBA1CB074086BE5741D1087055CC7730242EC9E9F8DF3DF454227F8C24400E44436BCCA4BD2703726BAB8ABC3D752B725723C01539BFD189725576F4F8DF0119E6DA24C896BDE7F67D0F2C67066F5B1580AC1160975BA3F3B4A2AE';
wwv_flow_api.g_varchar2_table(14) := '7A5516E48F3283B4B98E596624B4C62FC66F36BDB973453580AC11E08A822E3762BC88026C2FDEC374005E39C9107F5D78A599923D9BF6563EC81A011E833DC370ACECA7BC248FAEC12EA999E81A9ABCC2F07941DE5E913E5923C05E7570F95145DBB135';
wwv_flow_api.g_varchar2_table(15) := 'D89D4C06E4409D03F296FD3B57B56E6F854F06C87C70A0828A4662BCEA504133CC85143793954B5DA78E0F8B241FA2EB24418668FFFACED77F7C9502F90AE4E72B08648D0057B1060FBF0E1E15EEB4C29B0AE46868B96D98BBEF7C7D57C581AC11E02AD6';
wwv_flow_api.g_varchar2_table(16) := 'E0349405CC804D4C64BC92C8785D6E23AD79E79B0EC83BEEC7950AD0648D0057A1067B49C6BEF77054F5752F3A0DF8E880D2640532EE426DD9FBE3753B8C1DA94A005923C0EEACAB68EB5559EC7B0F739A051BB820BB9A1C0D2D139FB97BCBDE5D1501B2';
wwv_flow_api.g_varchar2_table(17) := '4680F3664F4E3C1C974AF9075903640D4CDBD164C75C2F31CCD4E395A0C91A01CEDBC00D30A9DC7BE9204B0319199091D66C314C13F7931F5C5F4E73AD11E00151D6C0A8F1EDA2180D1E4A69C6272319D282C7D5F66C39F0D0867281AC11E02AD4609764';
wwv_flow_api.g_varchar2_table(18) := '7D1AECC24D6937933D88AE23A14578DE6B77B940D60870156AB04B72FA76A18B8EA6AD17E405E5025923C09AD8329EDD7835D8DDD73BBE07E4E00249D97BB6EC7FF0069A6B35CC38AC9335025C1A0EE9E577566FAE06A74F976806699063493C19321F8F';
wwv_flow_api.g_varchar2_table(19) := '17EFDEB4F7C19B900419179035029CC5BC6A38F4220A18B2F0D6398334C8F0C9B5C1669F693CB6F9C043372A90EFBFDFDE6197EE068546804BC81E9DACF6F6E52519607BF1F656D3B4EF80DC0D4D8E049BF1E3B7C737BD014DC60F067648E940D6087089';
wwv_flow_api.g_varchar2_table(20) := 'D9A389CB237603F67BF11EB15E7117D24B2807649F4573FDC06D0EC8D0E31268B246808B9B79595A7B65B2F41AEC4E11201B5842C512F0C9737DA6F91F771ED80590A5249AFCE506D855592E93C64783D320F3915BC39FE8E94FC05CCFB1EDD4635B5EDF';
wwv_flow_api.g_varchar2_table(21) := 'F9955268B246805D6EB9825A05DBB406AB5F34646B30AFE5F3E174C7AA2FCE9B101C676FF327982EC8B3C5673CBA69FFCE3B94266319B5ED896DFCD563D14523C09C5D7516A5BCFCF2263C28AFF97C38F5B1EAF3C7316E3DB5039D1509249DC06B0E9E05';
wwv_flow_api.g_varchar2_table(22) := '7A6CF31BBBB6F0129F0ED1713F5923C00EC5D5F60D50A14ABE9401561BA6812D9EC6C9E5E3CBB1DE587DB11F9F615A7DB178201A9C69DAF6AFEE7AFB6105B25A467985AE00E616FF1296CCA08E70660E2B7D070687A026ED94D9DDD3D30FB3D95D7692BB';
wwv_flow_api.g_varchar2_table(23) := '7ABB7D7EDF2C2B61FDFDDAE7BEF7F1DB77FDE4D8B6D66D3EBC4981AF1329A86804B8CA4C34E4912219B7AD603C9130A52F89F7EEA418E10EBF206665778ADE7D97EDDE73DE7D5EF71E7BF7DDB6E93AE83E8060DA820559EEF31997E1F4B156F51B6CE755';
wwv_flow_api.g_varchar2_table(24) := '19DEEAB9EE6B049894575971B4D8901A7F4001DB970488388937520CA0C939651F7BCFB9D7DCADF75AF63E8F59DCBA83B70CC10CBF5FECA495B413368829BE680418D4555B71F94B54030C4710B82A909126A62667CA707373CF656FD9C83D97BDEF76E8';
wwv_flow_api.g_varchar2_table(25) := '5E1FBCC58878F18F6D626B38AF8741FDF46B32DC96F96E3506595E86E44B4619EB3B643B778403E06D085692CE39A5164FCE79063AE3F001DC8A1A1776C595CC6B320AE39146800B23A0A25A91B3D4E450C031D3EA7D5A154561DEC468047890DCE54D48';
wwv_flow_api.g_varchar2_table(26) := '45359840206B04B8A2202A9E980902B24680ABD4078F260A35604FD835D7A355ACDC6B1A019E4026DAC5CBF5C90A649C2CB54F2E010B3502EC7265826D07810C2B550210321C2B81119C0438C3DD517686805C22944BD0AD46804B207EA3F07CDC2F6540';
wwv_flow_api.g_varchar2_table(27) := '466E8899AE5298EB12B05023C02510BF7147718C013320BB8197E6396BEE8EB3D108F018CC99289709821F6CCB44D71A51A96C0D2E0175952C145C272B90B12D85B9D634778D1AAC5192354DAEA4DD70BA0A648D3EB9042CD4087049D959999D67402E91';
wwv_flow_api.g_varchar2_table(28) := '4FD630EB49808B65E220908B34D725F0721A012E0175C5327FBCDA6740D668AE35D1AE11604D14556B37199069AE8BD4648D3C9804582333551A5377E055247D1A01A6084F960CC8B59511786904F84BEC83B3E59AB2CE6448BE2097404734025C02EAB2';
wwv_flow_api.g_varchar2_table(29) := '19574DC785805C021DD1087009A8AB264087A3D50BB2095697410734023CDC0C27CF2950DDDC351F881D2DAD590201D0087009A89B28F2A13419E03277AD3479045E95C0086A04B804D44D1480398F5C41D63C678D008F20959A09AEEAEEF85E1D9AE9B1';
wwv_flow_api.g_varchar2_table(30) := '3459E32435023CA9C163E2E2B2C83F02C825D0118D008F39BDC90A2E07A8C9C381EC0A805B4FC37612600D4CCCBB0B02394E3E5923C025B02F7973AECA1A0C01593FFD1A012E817DD13FDFCAEB7110C8E0A1663DD108B066CA2A0F8AD251E40599BE79B4';
wwv_flow_api.g_varchar2_table(31) := '64489E5468FC01F8A406E7C9FBC1D5DD25145E3620491C24F4288C468007D33B79942707A81F194D062CA13CDB8F507D12E0111853B6D30499E94C4D8FAC6BF4C16563C9041C588F7926632A5A83394DBC95640880EABF430E393BF804DB0D6D3950C78D';
wwv_flow_api.g_varchar2_table(32) := '18F8924A777FE0AAB397DDC748E30E4727FB64FDC24AA1ED868EA611E0D1D83974E0B1CEB0B71A30286CE0DF31E38F70B9DB5EDB92843A1EDA0BDBD12CD51B01BC33878CE21997612E8D78C70ACE27F189DB29B545A541B5D8368AB1BD7DC4C4923ED477';
wwv_flow_api.g_varchar2_table(33) := '7B631BF618C2FF990DF10D3D3872C637405F4A482763276F7D1C8E6BD108B0BE69904984F5125E15F556B213473CC3FE9D6D8B59AB986FE1D83B2AAF92CD712C33F65A1DA8CE17C4B9EDB03BA8F864AA2F20CD468DD4F9FCAA4D3F00A4D611D47EB47DD7';
wwv_flow_api.g_varchar2_table(34) := 'EA421F2E4436EA05A5C517422D8EE45043213C69C5A42DD58B331C8B1F1512CB0A3382379B19A8EF9CC566DC8B4680F5D14E0653FA9BC0CC9B43B3C124532C30DA076625B03D1ABF289DA984629EC36A676C6A2EC1ADF599724F709E447C35AA9D63841D';
wwv_flow_api.g_varchar2_table(35) := 'E1202CFCEB83F01CB77AE4B5443B962471596246651A00EF47FF78FB9D34A0EDBDA199D04E3FDEA864E326904F4E27BBE4A344A704B1CFDEF0F634B9682764993F2A5FAB69564458A8EBC7755A8883B1F3D2918A2B0D27E4E528150930B5E25D30FF1733';
wwv_flow_api.g_varchar2_table(36) := '37CA9D4DEB945625C17432998C7DF28BBDF2B7E75E91B500858C737D650882F03BAB5BBE5E335BBE3BFF2E69AE9D21312B9EF185AE3050C7E2A9A45C4AF6C8F9FE76F95DE7A7F2AFEDEFC9DB56AF6C30EBE45568FF37C34DF237F3BF263382F59240DD1A';
wwv_flow_api.g_varchar2_table(37) := '33202F9D7E57EE697B46D660DC08803F61F5491442F1BDE62DB2A671B11A8B2086CCA01CB878545EFBFC3965AAA3B0473150C971C7BB5414C00480DA7106266F79A05EAE99B2542E8BCC943840E2356A628DE9976BA72E93C885FDD0424B6A01AAA31DB6';
wwv_flow_api.g_varchar2_table(38) := 'F2BD84BB061A3C3DD4204DE1A9D28FB6EA4DB21ECE42C9D09F2D9719339134B265DDF4E572CDC51679E4E4FFC8FB716834C60902B819E14699159C02614848D0AC912981281A5AD05CFE37775B4EA6FAE49F2084D7CF5821615C8F5B49A9F507A5ADEF82';
wwv_flow_api.g_varchar2_table(39) := 'BC7AE903F90002B31E663A5E267039E58A5A2691E94190F419FCD9D6E862991D9E86370BF64B0F3E712B21BDD8F626FAA19933E54F6AE7CB9154BF029D9AE16A27C1A149ED4FC6513FA6DAF7614BA013290B6059F089D079D489A10EFBAD8539BE69E62A';
wwv_flow_api.g_varchar2_table(40) := 'F9EBE6CD32C34486211553AFEE663B8EEF6E63009AFD33A8DA07FFFCAD688BDC050B53036DEE887563DC949C8F75C8A3C75F909F5D7A031626AC02B87299E78A0398BE37060D1130705DFD6269A88928204C68690C3ED387F3A8228D3551B9BEBE05A8F2';
wwv_flow_api.g_varchar2_table(41) := '7D9D4E74CDC9780BCD393F6C1384796DEBBD20FF05D3FE74DB3E79F9CC7B72B2F71CF20918117E9DE05B00FEAA292DF2478D2B45001EFD3DC7651DA72F539DC34BA5E534046B0104E19BB36F94B97003FDB0381C8375F79E3B243FBCF8A6ACF24F43B0E6';
wwv_flow_api.g_varchar2_table(42) := '5326BA1CA6D9E58546133DA0436EE7F96CE947B92CD997EC962DC126595AD7AC189484B6F558FDF245DF796989CE55AA8A57EDCA8A8605B2EC6CBDB4C33FD6A35D7621352A9C82A6FA014A1B00FDD689FF84CD8286A2FED6E00CB96FDE57E5AAA92DAA1E';
wwv_flow_api.g_varchar2_table(43) := 'FD6C2D7CE7151857CE8694B65398A8E92CEC4B056BD0D28FE17B1F69BA5DD64E5D2A095800D6A881893E78E913F969DB8B2ACB184564DE0901A4D096B36834D1C54EC4599ED03CDE5CB758F9CF2418E407A3CEF55F927D085AE80B9DF784DAD09CE97277';
wwv_flow_api.g_varchar2_table(44) := '649162B61FDAE644CAC3B1926B683E0A85A9FA6AE57200BC0E9FA7BA3F9267CEBE255DC93E25000490A51ED6411044C53176769F1C5BAC4EF9767489DC357B1DFC349657100CFADF53F0BBBFFAE225793D7E5E057FDDB044E50697F3D10830BB2BAC280D';
wwv_flow_api.g_varchar2_table(45) := '003BDBB1A410F8AD35F58B24E20F2BB30944E544CF5979FCE27BD21EEF562697BE2EEAAF956B1B60A6A1E1F4B9238A57FA02C162D2844B986900786660AAB4253A14C0045F692AEA52DB8380C6EB3795F6828E24C014ACC1EF9D7D93CC094F973E98769A';
wwv_flow_api.g_varchar2_table(46) := '666E9F3975407EDE7948AEF337AA255E619CD0DFAA4200B6C17C530E21EABC277C992C8ECEC14C099A4FF9B7A3DD27E5ADFEE372BCE78CD23382411F79797DB36CAC9921A720184C8C0C5BD22696FDF5A583AB1EAC5DCFC2CF4E47841B812FA5805090D8';
wwv_flow_api.g_varchar2_table(47) := '39FD71CC467F3C56A3D1EDA7AFC182EC9C71B35C0DB3CEE0CCF5F1FBCE1F91BF3AFB8A5C812516931AF837012351332C89A53CA91160C7C415422CB347640AEC9F6CA85B2433428D6AED19C092E82CD6A9EFF49E04AF6D39D4754201407099F898159A2A';
wwv_flow_api.g_varchar2_table(48) := '9BEB9660B9D2AB962E238D4DA854FF30AF872144AF22B9D10C0DDE347D8D34046A9599A539852D90D3FD175099C90CBC799D53626314AEC36721AADFDA742D96617E8C6FC17D98F241C77179047E97951B9928C11C485FA594A1D149C19415362906575C';
wwv_flow_api.g_varchar2_table(49) := 'CBB621125DEA6F9015F50B9028A851CBA1206E9B9D80D61E41E66A66609ABCDD735C7E0F66BA293C45994BAE39D7362C16B978006B4D0BC1CDE0E9288AD2C2300D42B36BD626C744FB231867BEB4C00230B8A2C9AF0D8411C85D9057DA8F82034E049E09';
wwv_flow_api.g_varchar2_table(50) := 'AC708675AE4060178249A69607E87FB1EEFDBFF387E4B7BD9FC8ADC1663967C72AC2EF7A211CCC11EF95BCF70BD760260E4E60E9F1DDE82259106D52DA61E257F25CF7BED1FE911C8A9F81296D903DDD1FCB3D9D27B03E9EAA7C264DE792BAB97277688E';
wwv_flow_api.g_varchar2_table(51) := '3CDD7F466E86800C2E4E98441017469AE4CF229B95D1A5E6D11727B134628900DC4E045BCFC28FFEA2FB181C31B257CAA20CEEAD0F42C87635D054B625C8D74D5926D7B5BF2FEF238DB914FEB91B635592066B34D1839991CB114582E0F6723D0B4D5B8F';
wwv_flow_api.g_varchar2_table(52) := 'B5EF54A606A11964DE2568EB692C9BAE0FCF93BBC373E5AAE04CF91C26940907FC671265A6A7051BE4B63A045BC82A397E73E8C8D444AE51C358067129C4DC360BC7E05A9799A7DDC75F547E743D9751288EF6D2F23A824B7F7BB0FD1339020163DA92D7';
wwv_flow_api.g_varchar2_table(53) := 'F12FE964D5D4C5F277B36F930B98431FC065264EF974D54BF9BF346A70FE9321938260F03BC83BDF0813BC1C6693512C724E4A8BA3FE90FCE5BCCD8A61D40A328EA038112F8F536A89B2BA6191C8F95AE949679AB229A11E3328EA8110102EFAD37E0466';
wwv_flow_api.g_varchar2_table(54) := '5DF15E39D6D3264F9D7F571EEBFD5456FA22C84A017CA5BD699793DE5040FA127DF2E4B9B765098240265B98E10AE16ED44D3357CBAEDE53F2FD73AFCAF5F0ED5C19739CC29C5636F5C51D6B0438FFE990F16C1503B36F8ACC9766E49D995162D065A508';
wwv_flow_api.g_varchar2_table(55) := '5E10A635A266E8328CACE3DA935B02CDF6F323B3E4DEDA79B2BBF784CC224099E2309A26F5A38E13D27A6AAF639AD1AE0D96E13DAC590F252E01890072C6F52AADA8D216594192D30B6F22D4C8BF77BC255F39B35CBEDE7C03840D193608553D9674BF3F';
wwv_flow_api.g_varchar2_table(56) := '67A31C06C88FF57C2A1B038D4872C0CA28EA32C494654723C08E29CB7516ACCDBC733BB50EB960064B758C68911F66A19FA4F974EEBD0EF44DA6393E300940905786B6D1ACDF80D4E5A3F09F3EF4E516D50A6052FBB986FEC9C5D7006610E3319B65C842';
wwv_flow_api.g_varchar2_table(57) := '68DF7AFF14759D372E587FA0357B718496633A4B337834B4FFE733AF22D37699AC9EB2582CC4090CBA289CDF997B9B1CF8E437F219325DCD587E75C36C973BD9A1116097ADB96DA915BC197E0481CBD6D02C598688960101A36ADEC939D57F513E84D6D1';
wwv_flow_api.g_varchar2_table(58) := '5C329F4CE693DD5CEE84113DAF68643224A8821DDEE9B9B26EBEAC0C34C8412C8154D6CA25036328E060DA17D43441C303B8B9E057C908DEBBE59D9E142A3850BA8DDC2D5B0E14E55B1148BD8131F6B4BD2A736AA7C9B49A7A001C13FC2F2B95F6FC61EF';
wwv_flow_api.g_varchar2_table(59) := 'CDF2ED2F9E9559760051BD4FDD262CFCD19D81B10BDDD308F0F02C1A89304AB68A5421E51BA30BB1F499A6822BC50C80F2CEA58FE50F3F7B1CDA1606F7D37E915BE4A50559AC034BFF54564E598436FCB783B8F5070DBA0366FEE08593C3263D28389FC1';
wwv_flow_api.g_varchar2_table(60) := '6C064010ACBFB35E4DC39A3BE5041CB717FD75F28F9D8765F5E979F207CD374150FD6AB91582C06D6ABA467ED0734A1EBAF4966C0860390721E20A3FF73146E25861E7A934E35E949642BAF93484E03198D5F50B250CD34A7F46D3DC95E89523486A30C6';
wwv_flow_api.g_varchar2_table(61) := 'BE114B9F55464856238F7C0DC05EC3A5107CF6D1AECF959FA6A96500C584C5D5750BD146DD0C54A0137846BA34AF2A30C3550A10993DB67F24304E3BB5553DA221FA6320360FE6FD1FCEBE26871059071055334FCDA0AB211091ED736F94DBF124CA3EA4';
wwv_flow_api.g_varchar2_table(62) := '4299A12B67D108F0607336DAA4C85CFE1DC38D853F8F2C909530B70C584200B9169133EFA9EEEFFD1CA087C156242CC13C9A5D6A4218E69530BDD3F5A9F4C234D621C0A15044B196BDAA71895C8E844307CE33200AA23F9A6FE68B997D6221E84E71B7E9';
wwv_flow_api.g_varchar2_table(63) := '43EF867E1B7F7415AA3DB6A4CD595ED96A59B700A6FA7D00F8384CF519DC0C61FCC031293C57362E901FE14ED5D5786881091CC61AA38CE61D59FB7E594C34CD33334F04AA39345DBAC184EE9ED34ACB6A120179AFFD98FC16D9AB55606A0F821F02EB6A';
wwv_flow_api.g_varchar2_table(64) := '9189FF3837077EF48DBE3655AF05C10E1322642EFDE98650931C8E5F503E9CDACD4776188D9F89774A58C1E6F8E4918C26C7A14BE88375F90271400C113B1325149273093C84C71426E8615076154CF5CFBB3E94154890DCDEB416D2832735A9E110A619';
wwv_flow_api.g_varchar2_table(65) := 'F0CF77D62F939D17DF91E9E9446A3940D60870EEE4538B08EF0A44B3AF751D93231F9F42448C604AC9BFC86930723940546B5FD475FD17B59E8FA3CE80467500B89F7EFE3C6E18D466DAB2DE29B4A5A9FFD9F1679D07E6D09EDAD881C87609FAA429651F';
wwv_flow_api.g_varchar2_table(66) := '6E9F6892293CC7C76849D7C7B10BF2F0A74FA9753A41276D1792BD72A5B22A58DAA10FDEE0B80275FFE5DC7E79A1E343351EC591C15B2D68EC427CC0BE186B702EE5281A01CE9D7C8A02A7CBCCD3D17807829F73E933ECC39685D0DC290083ABDD6CB6B8';
wwv_flow_api.g_varchar2_table(67) := '621444DB83F14B722AD3D6B9B20C0CE52335FFDD7F5A3D21E98C644B1334AF09FDB296DB0747CB2EBC46BA7AA0B54FF53982E7F6D10C9AA603383768227D7CD08F8FD83E098BE2F4EC529C527E9A4F6AB2FE686366D3906FEDA1ED07CE94056077784E9C';
wwv_flow_api.g_varchar2_table(68) := 'CF2637716DCA022E50D029F17CCCCE65957371F037DB5E063017A0012D02B59B5B3EF64A66AE4250667AAEB14FE7D98BC1FD0C77C4BEB9845B0BEB408D67E177365D3C479019485D8747679DC2D19D36318C99FDEC76BAD2181BA7FD189572BA5C568039';
wwv_flow_api.g_varchar2_table(69) := '0D3280CF40674A5AD4739922CD642C5DDF6DEFB6EBA7DE8C70CDAD3BD2967DB029EF1F7BFBE079B77FB72D8F293809EF1CD21787ABEFB61BAFAD4680B3A79EFB140A6D395ABBD1AEE54A59AE7DE45A2FD77175D62BCB3249E70426665F59A6A788496A04';
wwv_flow_api.g_varchar2_table(70) := 'B892E5B8080E95A5A93E5E6A04B82C9C981C740C0E6804589F591983E6C9CB79704023C0FACC4A1EF44FD0AAFA944523C0FA889AA0A8E5312D7DCA521CC0AD87D394F03742C6E899893CA6F7A5AE4A8E22D5C9148A2A191E3B87F97E1707F0B62B95DADA';
wwv_flow_api.g_varchar2_table(71) := '067E2C64E32EC0A412E7CBFFA1F5C943806C5BFC27C528691EABFD02BE8A4B74A4A5CBB0F1AC83E143A690D4395F05D032D9847933C53EC3364C3E6782524E0DDE26DB140DA63FF009763E34EBF9F485CAAD23C7674C7E72E201F9455E610BDE291EDAF2';
wwv_flow_api.g_varchar2_table(72) := '519AA7E0B0C363C5E802BED23EB480966C42B36CC0F7A2AC7AE9BE6F1829E3DFCC7AFCB49E4525E9D3F6469DA8B4AF0AA34D692E72F35DFD1D3EC3FECEBBB73E8CDFBAA278785C08078B03388B80D52FDEB71E774EB702F346189BE16FBA1642E5446FE3';
wwv_flow_api.g_varchar2_table(73) := 'C89A0F58B68B917CFAFDDB7E7A404DB94870F5B16D327ED6C74BB7274D3CFD7F31219B1D2979A2980000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72341360387797135)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/apk.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D000018D7494441547801ED5D096C5CC779FEDFBEBD48EE92147553F769DD962CC932E3A3965AEB7052A30D42A10DDC16492FA4418120685D342862C68E6D';
wwv_flow_api.g_varchar2_table(7) := 'C4299AA2405A374D81228E8E8A69D2C46EEAC68D6CABB664C5924FC9B163CBBA651D144589CB3DB8C7EBF7CDDB473E1EA2C8DD59EE5B8A43ECBE6B66DECCFFFDDF3FFFFCF3F6514447B2C4D0514D59EB6869F1C958E8473F21FAFB1D8FFCD0B20C310C8B';
wwv_flow_api.g_varchar2_table(8) := '056FFDF943B75BE27B0087F51056CECBB0A3C5B9AC21E12AC36C9B14ACFE979FDEF937279B97ED315BADED6CB7EACFC885E1BD12C531CF05EEAA171EFA8C9133BE6BD686EB54378DE2AA1E9EA8884361F7312C4BB2285D23A64433BEE744CC2F3CD7F4D7';
wwv_flow_api.g_varchar2_table(9) := '27EE7DA1C5FFE2BD2DD9B1027261D2C94BBF790F347EFBF6ECDA7D5F999EC9649FF7D7572FCF7474A571D9670BBE7000F2B7C86F06AB67B0737D4BD9474E3E678BB30017ED337262E56AFC814443241ACD65720724677C76AC810C200A4FADD2AA0A6733';
wwv_flow_api.g_varchar2_table(10) := 'E9F9D8B9257B2D01E1115C7E2CD796FBC57C9CFADC750C76CE7DDDD977F2395B9C37B08F8105ED5443542E9D8D056BAB9AC497DBB1F9E0A3F35EDCD892B9F7C516732C8CC904A1F0D4BC9C5410CBF061D45263318E689B2BE1938718B6998DEEBE96B0FC';
wwv_flow_api.g_varchar2_table(11) := '35E14FF82CDF9802B938805B8F2A136F5839F89F705B8A32F85495D14F79C30D0FDA32329DC96C201A6EF2896FC7B6438F2E20939B654F457BD7C5019C67B06DE9C060C5E7D10749C31D951122A7D30439126EB2D2BE5DF7BDFAE8A256637BB692412E0E';
wwv_flow_api.g_varchar2_table(12) := 'E03E92AD40FA3AEDA7EDA172DAFE8391BE06906BABD69B866FC796FD4F2CAC649035025CB9F455F0423FF336483960E96B892CC6E4F58699DB59C9206B04B8F219ECEA810239134B2A907D3E6BF7D6D7BE714B25325923C015C860A7C934D064B063B2ED';
wwv_flow_api.g_varchar2_table(13) := '2D6563106433125A6B6533BB37EF7F7C492FC8E07B05248D0057447FFB42E23439EFFF3B87AE4C3D20C3F15A6DFAAC5D9B0FE5416E6D559EB72BAF27773502ECC9FE0DDD2887B243FBFF3D209B04396BEDFAE4816F2C6504AFB90240D608B023ADA165EA';
wwv_flow_api.g_varchar2_table(14) := 'A9AB6ECAA2F943F4A017E49AF0EA8C64F66C7EEDB1159500B246803D05DDF01AE3461460BBF11EA4021B643B18B2C2CCC9AECDAF38206FF7ACB9D608F00DC43388C4CA7ECADDE4A119EC34D5F6AE01B259135E61F800B262722BCCB53741D608B09B0E8E';
wwv_flow_api.g_varchar2_table(15) := '3C2A687B63063B9D412413DEB58BC95B0E3E726BEBF6D66C8B7CCD103E38E0A1A4B1316E3A78A887C3698A13C91A4E5EE641C40B93241FA65019C5E49CB97BDBFE47D6B4182DB9E66588CF7B08648D00573083079F070F09779EF02641F647C34B2CC3DC';
wwv_flow_api.g_varchar2_table(16) := 'B96DFF136BC8642F81AC11E00A66701ECA027AC0222E9011D63CF0D86DCA5C3F8C2B1E60B246802B90C1EE2663DF7D38247D9D8B76813E2063257CD7D6579E584F73DDF270F941D608B0D3EB0ADABA298B7DF7E1B07AC1026E903B931944BC16E3C9909D';
wwv_flow_api.g_varchar2_table(17) := '5E015923C02316CFB064382A9946EA64B91BD5DB6D3E0464623D9963F242AC42EDD8FACA236567B24680476CE0DC622AEF7EDEC9D2D0080532A6501984351719A6B963CB6B5FBFBD9CE65A23C0BDAAAC4150A35B45310C1ED8D25E906B0072D6D8BDF5E0';
wwv_flow_api.g_varchar2_table(18) := 'E34DE5025923C015C860A7C9FA18ECC06D83DC05735D139E87E7BD76960B648D005720839D26E7970B1D74346D59BB99B1419EEB0659D53F4A53288D006B12CB6856E366B0B3AFF7FE2E90430479D796838FDF8DF9716EB440D608706924A457DEFD6A73';
wwv_flow_api.g_varchar2_table(19) := '189C3F5DA21EE4414ED15CCFC168B063F32B5FBF67B440D608703FE155C2A11B51C0D00F6F9D3DC8838C31B93A34CB671ADFEF61F2C30F5B2D56E9162834025C42F1E814B5BB2E779301B61B6F77364DFB36C8313239340B3F7EDB71FF2FC064FC60A045';
wwv_flow_api.g_varchar2_table(20) := '4A07B246804B2C1E4D52BE6E3510BF1BEFEBE62BEE82ED5DE741CEE58C9DDB0E3EBAC906193C2E019335025C5CCFCB52DAAD93A567B0D3C5FC142A95C6983CC3B2CCA7B71D7C02200B98AC1FE49B1B6087B29C268D0E837B4116C39FEE4A02E460A36559';
wwv_flow_api.g_varchar2_table(21) := '4F6FDDFFD8AF9702648D003BD272FA5001DB3C83D52F1AFA3398D746F261776F945FEC3721D883BDC59F6002643239D8283EE37B9B5F7DEC3E05321F1CD8D3CC5F3D169D3402CCDE556652E4E5973BE0417D1DC9875DBF517EFE38C6C9A776D4EF6C0319';
wwv_flow_api.g_varchar2_table(22) := '8EC99150A3CF921D5B7EF1C4565EE29AB28EF5648D00DB2DAEB46F800A2AF97206F8649878098581A77186F3C1EF598695EF4675B11E9F6166E3A96EFC7475B26959FF76FFE12715C86AAEEC56BA02845BFC4B587A6E6A2B67CFA1D7776070086AC6CA99';
wwv_flow_api.g_varchar2_table(23) := 'B1AEAE24CC66ACEC4DEE8CC77C7EDFD46C3AFB776B7FFA971F1CBEFF9BC79A5B9B7D7893025F275250D20870859968E82355B2DBCA86BAD369531219BC7727071AE3EC605D6166E7BC7BDF11BBFB9C7B9FD7DDC7EE7DA76C3E0FAA0FC099CEC2322CF5F9';
wwv_flow_api.g_varchar2_table(24) := '8C99387DAC55FD06DB7E55863BFB70F73502CC9657588244C1624382FE80023691018838893752F4A2C93EF53F769F73AE395BF7B5FEFB3C6672F2F6DDD20533FC7EB132D98C95B6D098E2934680D1BA4A4B8E7C896A80EE081C570532D602C8E49E3458';
wwv_flow_api.g_varchar2_table(25) := 'DF9C73FDB72CE49CEBBFEF54E85CEFBBC51DF1E21FCBC4D6B05F0F83FCF9D764382547BAD5E864B90532D2669431BFDD6C5846083500D9866125C9EA9C9A3CD9E7796D143E805BB5C6815D49A5E7351985C94823C08535C053A5285932391CB0CDB47A9F';
wwv_flow_api.g_varchar2_table(26) := '96A75A38E2C66804B88FDE8DB8219E2A308640D608B0A7202ABE316304648D0057E8183C942A04219E2AC75C0F95D1BBD734023C864CB4839733262B9071B2D463720944A81160472A636CDB076458A91280D023B11218C171807BA43BC4CE00904B8472';
wwv_flow_api.g_varchar2_table(27) := '09AAD5087009D46F08998FFA250ADF0F71552136C4485729CC750944A811E012A8DFA8A3388C1BD2BBEE71BC34F7597375EC8D468087219CB1908520940A646F33B804ADF3AA42F401191C2985B9D6D4778D0C2E817DD1D4C99254D303B2C631B90422D4';
wwv_flow_api.g_varchar2_table(28) := '087049C4E8ED4A7B407682212540A848098C035CA400D5BCB8674C2ED25C976094D30870095A57ACF047AB7C0F93359A6B4D6DD708B0A616556A353D20D35C17C9648D32180758A3307BCDB57798AC1160EF39183AB11B765D0E93ABBDE1786904F8261E';
wwv_flow_api.g_varchar2_table(29) := '83FBA34F9019D61C29C825E08846804BD0BAFE82ABA4E342402E014734025C82D65512A083B5D50DB209519781031A011EAC87E3E714A86A150A63321F881D2AAC590205D00870095A3756F4433119E072154A31F93AB22A8111D40870095A375600663F';
wwv_flow_api.g_varchar2_table(30) := '860BB2E63E6B04F83A5AA9B9C1155D1D5F9E44337D23266BECA44680C7197C435C1C11F9AF03720938A211E01B766F3C832301327930901D0570F269D88E03AC418823AE82408ED298AC11E012D897114BAEC20A0C00597FFB35025C02FBA2BFBFDEABB1';
wwv_flow_api.g_varchar2_table(31) := '0FC890A1669E68045873CBBC0745E95AE4069963F350C19011B602EB5ABAD238838B92A43385C2CB06248383B41EC26804B8A8EE8D17263F7A980C58C27A44320EB01E39EAAB8520339CA9E991758D63B0BE3E8ED7A4C73C538E15C560BCA1648093A9FE';
wwv_flow_api.g_varchar2_table(32) := '1DE80834827530F1E5946EAF8143206D24CFB9AF30B75386396E9446DA9EC1EB73B76CF01CC33DAB11607D5AD7BFF1ACD90FB1470D3F0C17DF8742206C2124ACACA400C18D4442904CE4AA411D786792028DA0E245A0EA9D2BBCC63ABA912F893A9978DF';
wwv_flow_api.g_varchar2_table(33) := '10EE586538AF8DE419F79D9C637BCB76C551368DAD3B17EB2A57D2087069BA44D151F814FAEBD94E489DB0F05EBC2232CB5725537CC12185CA9C0496601ECDC6A533975265ED2F1B1C7BDF9069BE103E412880AD54A790F7422E91CFDF7BDFFC897EE70D';
wwv_flow_api.g_varchar2_table(34) := '996F5649BD11908C4740D60870DF2EEB3AA29380D70D4AB5CF2FBF8FFF6B51E50B4816C73EF5A6234B8EA53BE45C3621D5F86FCDB6991D78E76AB0F01D00DB05B0EE094E9655E1293229582B51330CCBE083F264E45A262117BBAFCA91549B5C42BE5AB0';
wwv_flow_api.g_varchar2_table(35) := 'B60B4AB53650273303B3943A29B653B91C9CF35B3297ED613B8FA7AFCA79B42784F6D82A38B03DA379C6D300537E349107B3D7E4AB75EBE4F7666D92B01990742E8B5537FC9F667C5EBE74447EF7CC4F64AD590381F2AF6F62F957B331D91C9A249F9DB8';
wwv_flow_api.g_varchar2_table(36) := '5E56D6CD9349E13A0942514C9F6D987300260390B3A8F758ECBCFCEBB917645FFCAC9CB252F2A5094DF2C9C63B14FB998FAFD0EA73131CE6601902B0107128C6F74EEF95C7DA0FCB067FAD24AFAB727DDB58CA238F030C5650481062D384253227324DB1';
wwv_flow_api.g_varchar2_table(37) := '57091A52099A41593361A16CBA3851DE049317C25C53A8540CA6B0528E987C3EB240FE6CD666595C3B1BBFFC04D301540F1BEDAC28159410400FF9C332F772837CBFEBB81A0E6AFD3532B56A22F2E7D4BD0930CBBA138F03B0305DD9A4D498215CCA2A46';
wwv_flow_api.g_varchar2_table(38) := 'F75104778151DCF7F43489CED01B10DA6F8767CA8248A3A4B2DDD2954E4877362DF14C4AED37846A6573ED626987590C905DF91404B8C77349B92F3849BE387B8BAC9C305F01C672991C95C6E08B4825994B2B25A21346D8C862755DA909F2E07A2293C4';
wwv_flow_api.g_varchar2_table(39) := '27A53E496CC958E6EDFBC1BB4CF3E7F24DF0C4C6D30C3601420E206DAA5BACCC2A2546D34C60B865AA06E3D6D402BCB603CA83A5D1B53D66918B708E9A276E9445D19992CA7403AC8C8460E2AFA6E372A8FD7D39D9751EACCC4A184E551D146555ED5C89';
wwv_flow_api.g_varchar2_table(40) := '86226023BC66309689C300EFC53AC95E8EB3EF5D3B2531D44113AF4006E07E8CD9895CB77C9CEA80F204918F57CA9F3402ACB743042A06F688592DB7D6CD5763660EEC4A0390F76267E4969A46BC5A929326917991E9F23B55336577E28CDCE18F4A0A20';
wwv_flow_api.g_varchar2_table(41) := 'C4904F7C61591A9DA5004AA1AEA0E99704ACC09E33FBE4CB17F6A2244BE7DB0D1037C301BB23324F4EA42ECB1278C3EFD16BCF27729640C760519E3EB74FFEA1E31D591D884A22AF08CCC6DA82F8BE1565BB159FF385CBB8D10870AF792CB63F1439BDD0';
wwv_flow_api.g_varchar2_table(42) := 'D7339DF2A7D15B644ECD54E06033280E73F972DB5199196A901AB097267522D87757ED42D9DD750C53AA288CB3E0EDDE595982E94A2D846DCF70E1E9E28F2C3E103B01CFA85B36851A15106425E7AF3FEB6E979FB5B7C9528CE50D60356838B02B38C531';
wwv_flow_api.g_varchar2_table(43) := '1CEFFC55CE9E0212E7D4CBFAB1A51204F019A4E4C0BA46E18C4680F5B556A98A327119B9B36E91D40523CAC1F1C3249E4FB6CB773ADE927B1A964A63F524353E86E16CADAC9D27814B1169077051384B61CB276700425736056133F040F39A9568A04ABE';
wwv_flow_api.g_varchar2_table(44) := 'D0B851CE9EEA94BDA94B321B604E06981194B90B1FCEB719A8E0388B22031287F930F255C33A4CC29CD9CD54824AEB9155F71B50B42C27EC81AC2CB71EFCA61452004CFB18538E95810659563B078C30156B380E7ED079564E26CFC9FB9D6714604E2DB3';
wwv_flow_api.g_varchar2_table(45) := '6BA6C8E7ABE7C82F31DFA583C5796C0C63F047F1F30A2C8EA59C3FF3A5DBEB26DE22FFB4E841F9D6D44D320F66F6304CF1E14C0CF3DE8C5204DBF0A36636A65F22EEEDB8473C73595ECA5C9503F0DEEDCF150462BAECB1BA5F99721E6A64F020D228A867';
wwv_flow_api.g_varchar2_table(46) := '968401C6895C5CBE52B75CB194D31002148307FD46E70930CB94376227656B774C6A0335F07A333201818B0D30D3FFDCF9AE0252D10FCECE7FB5BF25B7372C112A400EEBAC1CC34D28C0C2E80C9C9B2ABF115F23AFC1E1FA51FB9BF20C146709185D0BD3';
wwv_flow_api.g_varchar2_table(47) := 'DEBF3724334D7310D3A14F4F5E277747172ABF80D6C19926BD1F3F27BB3A8E08FEB1068618D313D12C8D000F62CF0A0098EC49010401A0EBEB164AD45F0DA66694303F8E5D967792E765B2BF5E8E242FCAD9789B4C9C502771005F1508CBB2E86C5901D6';
wwv_flow_api.g_varchar2_table(48) := '9F81599E8EF9E87A3868BBE2A76421820F9F9B739F4CC77C96CA90C1B89D84B3E5C73DE6C3419B5B334D9A262E938D175E93AFB5BD8AFBA5A511E6D79D68E2690108F0DD9357F65500001AF407E515045D9E82F31541BE6A043E18AE2C77D268A28BEF0C';
wwv_flow_api.g_varchar2_table(49) := 'D91086E61FC29C765B683AA6373394D34286705C7BBBE323793E795A2E41015E4A9E95373B8E294747BDA01D73DB193593656BCD5C390DF6D34C73F45D6746E4D12B87E5C90F7F28872EBF0F60E94D23A0810FC75902CDA9121DB9CFCDDD224FCDD826F4';
wwv_flow_api.g_varchar2_table(50) := '9D6350042A9963A7D93BA787544286389D0F1D2BEEF3BC3DB97260754A38C7A3BFD5C8E0E21B4F7170D5C8C2D8B91126706AB841099FE699818653A976D9106E943900ED04C6CCB3DD1DD2851832BD6932B30EE67A1DE7C457DF52CE12E1A1C3B41EF99F';
wwv_flow_api.g_varchar2_table(51) := '8A7D20FFF1E129F9F3FA5572F7C4E5CA444F80F346E561E83301D6D359DB327DBDFC55EA8A7CF9E2CBF90E71F5CA4E8E8D4AE35ECE395E611D0C9CA8102A8E9D7C76A9F27E7B06600A8CACEB8017CCB9EF6ACC7DABFDF052C1383294ECD83EE34EF974AE';
wwv_flow_api.g_varchar2_table(52) := '498501C93E136147B28702A6031682F95C8C79EFA6E014F9BFEE2BB20E61C674FE1A418EC1F47EF5F27E1130FA8B9145F2A9C96B656DC362A986392768643395E52E28C0AF5D39222F254EA07E072EDB0F6030E3F9F387E54CFC820A90A831186D67A0E3';
wwv_flow_api.g_varchar2_table(53) := '38162AEAD14EFC9FABFCF8EB942D1FC81A012EAE33B679F6C39BED943F88CC57C10B8E7B3C4F4E708A34BB7A0AF66C46F16EBC9246002397378C9C1373EA744F64AEECBD7C1E4A5123EFC21A2C86B3C5A90D6254D284313A0E30BF7DEDA87CBBF3A87C27';
wwv_flow_api.g_varchar2_table(54) := 'B14D7E0B8A5305F6322C49C56980C3B62038415E8AFF4ADD8FF0F05E049B2C7DAEE35DD9D10E45415D4EC40B2E18022B504C28270A7966AAA411608AA0F0A4808370299A2698E749A1BA9E691005EB87D342962A41F6DC06FF2805C0717ECB7154CD73FD';
wwv_flow_api.g_varchar2_table(55) := '55B29A661A2B3A9C936E094D951FA52E401362B206512EAC21A979F203FEE9F26C779BFCC9F9BDB2A67E81ACAC9F8F58372267B8072D06170F98FAF78A846EF447646A68862C37A31802EC5651E138274EE29E4C3CF642D20870E1DDA110AB606ACF200C';
wwv_flow_api.g_varchar2_table(56) := 'B834502F2B30F7E5B220C75D0AFA6ABA4B8E741C57E69AA690ACA6421050327B59DD5CA5105C8CA0F344E7EC5300F6D9D4797964CE03F220CEEFB870407E08C78C11281B36C49BC1EE3FAE5B8DB13BA2A640EC01EBA52588634CB68FD5A6CF571A205E00';
wwv_flow_api.g_varchar2_table(57) := 'DBE7F832EA69124709BC02AABBB11A012EBC7B048CC18D5310F897A28BD4FC94A6921F3F00667063EBF19D000442C73C5581044633DC4846FF64DE8372DFF475827F2DA9A640D3E09CDD159D2FCFC68F8169F5B2B47E9E0A98FC61EC9C9C4C5C922B992E';
wwv_flow_api.g_varchar2_table(58) := '35A6CF40B873ED844532ADAA418530D903FC5B39B998BC22EF765F56B16C9B9F6E91E5F749651600BA85F77C907A359FD20870612DA3F6738AE13C07755B749E0A4DD2B9A203C571F1979DA780239EAEF04F50DC55112908388C31EFD5CC15398AEB9F98';
wwv_flow_api.g_varchar2_table(59) := 'BC4245BC686639275E199D8315A66A449C92B88325B3AA27CB4C4CA3582F994F58C876CE85D359AE3A5B528330E61598F2E7DBDE842FD0A59489F7A2023A8E9CF29871AC527E631F78F39B33094DA9B0DE527834CF8710FEBB1F5320322A024F96E04603';
wwv_flow_api.g_varchar2_table(60) := 'D5720DCB726FC400308E193CE05D788D290873CDA5B9C3F1D3D29EBA261100C440041DAA1560ED83D5F314709CF732111C5E8B629C8EF21E003987F93381E6B2631BEAF8C1E97DF2F895B764039D2594669894CB892138611C3642D857F7475D5E66AEEA';
wwv_flow_api.g_varchar2_table(61) := '30BE3432B8B0EE72CCB3DD929C2C0A4F528ECA89AE0B6ACA42A1BF7BF5841C46F46A3AC287DD6013B9660714EC27181741E007313D79BDE343F1038014C64E3385D83554614178B23C73F1900A734E851966583348D3CE84E6B2C50C7C74246272026BC3';
wwv_flow_api.g_varchar2_table(62) := 'FF03E6FE7DE77BB21C4A632B914F2E83C9A760D619A66428A313419818C674864BFB063554AD9EFBD20870610CA690F9E8EB328CAD471317E49B1FFD187EB42D3A0AF412049C8279E693937C1C87E032714B0FB606820E40F8FF787E9FFC67DBEBEA1AC1';
wwv_flow_api.g_varchar2_table(63) := 'E5925D7B262EFF0DF0FFBDF34369C23359F331F5A9C7DCD8F19039F76D47C0E47DACFF3E8395A51CE6C9AB60F68328CBF5E465983BFFF8CADBB2BFF323653978672E2D9E495F9315584DE2FDBD9E34025C5C57B9FE7B12C2FE5F3A372A519C963482B953';
wwv_flow_api.g_varchar2_table(64) := '6056AFA73E3CCFB2A751761FD6736D5EB2024BE642296EC37A701BC6F13D0978D0F193BC802CB692C066F340B19196A001A03146C5E90E2D0B170C3E42BD3FEFA9D7CEBF0C716A2AC1F5DAA4EE51D497BE9A3D0330DD9E0804BA01734CB29363B33D15B2';
wwv_flow_api.g_varchar2_table(65) := '053E94BCC8A389508469887C3998313F4D3AD93C1D8FC7CEC0711617ED3F5EB55581F7E223AFBC460B6143682B00E3DF0DA8772AEA7512CB737ECD7BE6D5C4B9A471ABAF66CF00CC2E5168EE47601C890DA7BBFC45029FD552294F00A75C3CBFCECB63FB';
wwv_flow_api.g_varchar2_table(66) := '635F71E0564A81F25428A70CEBE13E19CD254677B2EB709FF1EEBE4680DDA229BCC385D632543967DC66AB883D817527BBECF56BB8FE15772DDEDC2FFB34C99B622977ABFA2A6031ADD1087025EB7931222C45597DB2D40870293A3A5E67B112D008B03E';
wwv_flow_api.g_varchar2_table(67) := 'B3526CA7C6CBF74A4023C0FACC4A6FF36ED63D7D64D108B0BE46DDACB0F6F65B1F598A03B8F568BE255C63C513C7FADAD5DBD79B6D8F32541373CA14A947C6F6E148BF8B03B879B9A2AD65E01FEA5AF8F1C63889472AFF81F92943806C65F94F8A91F232';
wwv_flow_api.g_varchar2_table(68) := '56FB057C1517E8C86B97616169DEF0217EC0D6D95F05B465BC888AC128842DC3CCD9742927839BA5598162FA035C6EF995598BA72DECD53F441D8DF1CFB064C0082D65852D64A764485952A6488E8C95A00BF82A6ED4A45936F86B1F91552F3CF4193C32';
wwv_flow_api.g_varchar2_table(69) := 'F35DB316EF4760522B364A1BD5A1F7BE3CD6363B202ED9CEE4559F61FDD11B1B9FFC8192994BC685C8B038807947570356EDFD8B0D62F97F1398D783D1BDEF5228A4653753195BD77C106587189967DEDEF4B70755F75DB22DAF38C6FD67FDF2D724D3FF';
wwv_flow_api.g_varchar2_table(70) := '07664C396839AAA2220000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72341699031797136)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/asf.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D0000164D494441547801ED9D6B6C1CD775C7CFEC83BBCBB7484A942892E24BA4244A7E5556A3182D90B4055C14753FB4528BC4683E240DFA21B1AD5856E4';
wwv_flow_api.g_varchar2_table(7) := 'C24058A90FA0ADF3A528FA48D2A68D25595682A0285A04699BA64691C4A95D3BB668499648897AD892F810DFDCD7ECF6FFBFB3B31CAD4891CBBDCB9DA1380239B3B3F7797EF79C7BEEB9C391889EC3D0534CE94AE9EBEBF3A176CFF72357820577280DA1';
wwv_flow_api.g_varchar2_table(8) := 'A0109C448E7CF653FB7C86FFA9B4A46AF131254299B9F448A7D1BE74D81F2C1B29AF28FFDA4B2FFFD5D06B070EF80F9E3983FB567F5CDAF2BC9A55106027DCA3BFF7F46FA6D3E96F8443A11AB6C0580565E0A85A6907D48804635FB04C8C50F87BBE60E0';
wwv_flow_api.g_varchar2_table(9) := 'F75FFAE39787A0C901FC98285A25C1D9D3C74AE5A33A9D19F1E61F7CFEE92D662AFDEFE5E148EF4C349AC0973E165C0800A754172A67A17BCE3CF6B59DCE3EF37EE6DA8012A70265E1B98ADADAAA9469FEC830039F7AE9E5B505B9201B7A262345332DED';
wwv_flow_api.g_varchar2_table(10) := 'B8EC998BC578C70709FAA0CD9933AF0BFBB1CABBBB8C85EE2D548F9DCE3E338DB06D4AF98D001B6CA6CCE94824FC71D39F3C79FCF017DAA1C149FCF8AD344CE1DDA320C0BDBDBD540648C8E74B632AA65986E6AA0BFCCA9CEDCF6E3AD36DC85A773FE01B';
wwv_flow_api.g_varchar2_table(11) := '7373D1742414FA78DAE73F71FCF0E13503B920C0FDFDFD1494A40C338D0B88899F3C7960808A118D46CD7038B43FED4B9CE83B7AA8632D687241806D0DA69DA3803C89968D36244D73431B138BC64C388AFB8D9479EA4F8F1EEA22E4D75E3B9031E9DEEB';
wwv_flow_api.g_varchar2_table(12) := '6141809DDDF52E5DF462DEF66434396646C2E17D8974EA2434B9EBE0C133A657E7646D80ADC9D889DC43D7D060D55A788638FBA0D146740E9A5C167ADC9781EC554DD606786D6870B61716E49805D948A54EF5BDF8A56E6A3296869E32D7DA00AF090DCE';
wwv_flow_api.g_varchar2_table(13) := '2872C6F6289051408677BDD730CDD37D2F7E6107225DA697E6646D80B363DF439639DBD4EC1C7C4F2F9C901FF19B7E68322067341983FA9E0CD9325D72A10DB04BFAB3B266D873F0DD1A6C9795851C0A8514E43F79F179A5C96760AEDD0E591B604F9B68';
wwv_flow_api.g_varchar2_table(14) := '1BE5E267053906731D0A953D629AC9D37D879FD94D737D9090D30C03B8F3D006D89DDDCBB755F7E5642DA16271400E3DE4F719A708F90C211F3CE85AC8DA00DF5734F9CAB964E997B4434A93A3088600F26EC30390B5015E52342583964FC5CB1AA6D612';
wwv_flow_api.g_varchar2_table(15) := '0A614D78D7BB11FC3A75ECCB87F6D89A8CF5B23699E6D3F2C5D26A6BCCB244B3582B4A7D3FEB452F7B9802B2616009958C8443BB259D3A7DEC4B5F7C9490199F7713646D80972D9A52C35CA8FEAC17BDD0978BDEE3B6A39F9011BBDE99F61B278F1D751F';
wwv_flow_api.g_varchar2_table(16) := '646D803DADC1598679F6823B1419C8885DEF489BF39059A41B34591B604F6B7016F00A7A91035952BE537D470EED055C3EDB5572C8DA006765E4E98B3C35D8EEAB0332CC758F21A953C79E7FF6713740D6067885A2B14554DA73D6C92AA0190EC8F0AEBB';
wwv_flow_api.g_varchar2_table(17) := 'C42F27DC00591BE01518B702A4A939EBCA9CAC7B1BE1800C4DDEAE201F2DAD266B03FCC06BB08DDB011961CDED7832F7D563879FDB5F2A73AD0DF0DAD0604DBDC8408EC5E2C948A8AC23ED4B9F2C15646D80D786066BEC455693E3582797B5E1A1DF93C7';
wwv_flow_api.g_varchar2_table(18) := '5E5C7D4DD606D8B6509E3C67E7604D1A6C0BC1A1C930D76D6202F20BCF3DB19AE65A1B60CDA2B145E4FD732E64237DEA8FBEFCEC2FAE1664F564BFF7A5A8AB071A4DB4B34977436EC1DCFC4ADFF3CF3E0DC8AF67F6927D367067361DD7DA001749343AFA';
wwv_flow_api.g_varchar2_table(19) := '984719B44345EA89822C7E3A5E30D759C8B80DC86C625F5120AF9BE8BBF01709AE5D07FFB207B16B05B9ACACC58760C81F1E79E6138C684383F9A38D875DA5F602ED82BD795E054F22A3C9F1783C014D6E06F3578E1F7DEE939057FA2B4580BC0E982331';
wwv_flow_api.g_varchar2_table(20) := '1BAA2CB206DBA35EFD8D9E04A0C984DC944EA55F8126FF126AD7AEC9DA00AF92686C11E93D176B9994D34A02B46FE182E63A108B2AC85BC0FC9FFA0E7FF197F13D21A774996B6D80B32DB77BE0A5B3ADC1349F453C145467F9ACCF9060C6F16AF2F97C27';
wwv_flow_api.g_varchar2_table(21) := '8EBFF0CC934CA20BB236C0CE767BEA1A7A6418BE9492B561F0CCBF345CB51F9F55973F1E4FC6F1A7AB9BC4E7FB26FEAA310B19B22C68D03DD0CB24424D274D7F74663A0A259E7658D0928CD1B95999861637CE24CDAFBEF0F9CF5CFCF3BFFBC7810378EE';
wwv_flow_api.g_varchar2_table(22) := '9ACF7AADB441DA007BD544E321F6506236E14F264D2E470BD296954298CF970EA2092606DE4E3C92DB8CFB03FC1B6C009E4F92E79536C025964C9EDD9E4F0E611A01C317348286244D137E8F45D91EB0EC17AFED33733AAFF979B1C34E679F99CE796DE7';
wwv_flow_api.g_varchar2_table(23) := '9BBF6788DFE71313A30EEF8749DADF1772D606D81648218D2955DE34B0622E8470FD0A321FA6A2D079D8FDB2CFCE7B2AC17D7ED979ECF362791DDFA770ED576F33C9D46CBF26E33ED5DCF72B6D4E962D90FBD6E6DE2FD97C037F8E6204FD7EBAD20604AD';
wwv_flow_api.g_varchar2_table(24) := 'EEF1FE2AFFDC2525FB351977DDCCE38336C079D4E9EAA43EBCE10B901734A5AE6EF8228DD306D8616616A9CA3BB7D712646D80BD836F792D5D2B90B501E644B5D60E2764AFF64D1BE0B564A29D306DC8BCE7C53E6A03EC14CA5ABBB621D34A790DF23AE0';
wwv_flow_api.g_varchar2_table(25) := '658E46AF42D606782DCEC1B9ECBD08591B60AF99AE5C78CBFDEC35C8DA002F57406B219D97206B03FC209868E7E0B42153806EB65EDA00BBB9934E303AAF0939E0F2B0A636C03A05E7A5B26C4D76EB126A1DB086D1644376A3B9D606F8419B8373C78532';
wwv_flow_api.g_varchar2_table(26) := 'D701F7ED4269039CDBE107F1331F1A0802B29B34791DB0E69148C8011769B236C00FA217BDD8D8B035D90D8E9736C00FFA1C9C0BDB2D90B5015ED7E05CC4FCFFFDAC39B9949AAC0DF0BA06DF0B98776CC8DA04BD70358BDE2D55BD8B36682D7E61432E85';
wwv_flow_api.g_varchar2_table(27) := '266B03BC6EA2EF3F34F96732A558426903BC6EA2EF0F98DF66214358ABA510DA00AF56839716A3BB5328C8D8A0A0E0574366DA00AF6BF0F2075656935701B236C0CBEFDE7A4A4A60B520AF032EE178CB422EE29CAC0DF06ACC27256451B4AAB3737291E6';
wwv_flow_api.g_varchar2_table(28) := '386D808BD4BEA209D64D05DB9079567FA0ACB171DA00AF6B7061542CC8F8DF7AF018904E596A03BCAEC18501666E5B93C158DBA1ED2FFCB5B5E8012F8890F9201FFFD05FC7A14D83753466BD0C4B028C5DEBD2BC75C02E1C553AE7605D036555C584772C';
wwv_flow_api.g_varchar2_table(29) := '2F589FF24273BEC94DABA6377AAB4B1CB9F996488E573EA0CCA58B5DAA18F5BDA6625459DA002F2CF265F527CF44D895292B530E895D270582570F492A99A0A7A2CA23201FE6B24020987DDFC642E9EEA91CF98C9C7C9902B3653BF3B04CB623954C4ACA';
wwv_flow_api.g_varchar2_table(30) := 'C49B8F9631789CF98B7DAD0DB025D6623797EFEF4CC9C4F04D319371C892330C5F8294965045B584CB2BD5F794B80FAF448AE3D5717353E34803FD82E099375C5923A148B9CA734F6B0917EFA94AC4A23239720BFFA9A899A98345A087F87EFEE035CB44';
wwv_flow_api.g_varchar2_table(31) := '1E7C17AEAC96B27064E172E733ADFA9536C0ABD17202A2305B77EE81168700006FB4C2670EAEA9F13B32796744FCD0581E26B4B976D36669E9DE05A1231D7810DEE4D8884C232DB5FB9E832F21832696035653FB769546D5C18404CC426CC6998F6AE0E0';
wwv_flow_api.g_varchar2_table(32) := 'E6D4D8984C4FA25C0C2C371D9E014C387393E3D2B5E731F9B5DFFEB444CACB05AF1F547069B22F9D7F5FBEFBF77F2D18024A93C6466E4AEFBEFDF2895FFD750906CBF082B3A49421DD85B3EFC93F7FF36FC12B0480010B7E86880F16616A624C9E78F229';
wwv_flow_api.g_varchar2_table(33) := 'D9FBC42F5877A1A18944426667A6A5BAB616A5331001ADC5BF14BEE39BE95218403FF9EF1FC80FBFFBAA54D7374A0A9AEF96C31380A9252021C9784C7A1E7A549A9A5BF85109961765A190B47775CBD6CE1E1978F74D0957544AA02C2CB76F5C577370FD';
wwv_flow_api.g_varchar2_table(34) := 'A64689232F01B76FEF960DD0ECB1DB3761D283AA1CC250A61969CAAB6AA4A3BB47366DDE8C3C713C851194E15B3715B4FA8D9B2C25A645409B689EF976BC142C4939EA341371DC770B5AAB1DDE5826419809087F4363936CEBDA0ECD4DCA1CE6D70400C4';
wwv_flow_api.g_varchar2_table(35) := '623199999E8659AD94AEDE3D92C4FC89573D4A454DAD5C7EEF2D19BC784162D1398923DDECCC0CD255C9B69E5D1283465A3032A0A0CDB3B010CD5D3BA4B6BE5EA2D1A8445107210F5C3827A3B76F2BA01C28FC2EC69F39948BCFACCF9E2EDC8517BE88DB';
wwv_flow_api.g_varchar2_table(36) := '1AB4507BA8C1D1E949E9EC7D581AA84538180C48C274E2F5BBEA33B5B8B5A3536A37370B5E0F0C0DC61C0D0DBB3A704999D860D09A9B43E130D27559315F681E8A519C99D64C44A5A5B34BAAAAAA95C5A0074E7837862ECBFB6FBF296FFDF87F64666A0A';
wwv_flow_api.g_varchar2_table(37) := '261F9E3932B2CE3BA323F2C6EBFF857A2E4AA4AAD602AD5AE48E5FDA00DBBE87EE6E519034813C6FDFB547088830F8731326985A46C8D4A04D9BB7485B4F2FE6EA3B2A3D3DE681FE9FC9041C2095067938776E69698503D6046F3986E6E20E5F420A4D8C';
wwv_flow_api.g_varchar2_table(38) := '20FDD6D63609021CAD44201090F1B15105EFADFFFC57F9DEE96FC9E4C4B8E57CA12C3A6AA3C3C3F29DBFF9AA5C7AEF6DCB8B473BDC7468035CACA9874BA1D8EC8C6C6EEB92E6B636253BC2A6E373FEBD7700604C02D0287EAE84E675ECD88534D4EE3896';
wwv_flow_api.g_varchar2_table(39) := '2E55726B68406E5C1D825B84BB6AB09852BBA14E5ABB7AA0E953EA9E1F7F4B34070BD1B8AD5336629028478A83017533EFF0F521A9D8D000E7AD5CA5578DC8FC62996168AE0F8381CE171238BF2EF9B536C0C5EA0905189D9A90ED7B1E55606C6D9E9A9C';
wwv_flow_api.g_varchar2_table(40) := '909FFDE875B97DF32300814585E6F821E496F676D9D8D286F5EFA4F29EE9D10E620EE59C498D637E7AE0DBE06C99496A300ED4119F9B916698EE9ADA0D62228F1F69E398CF99378E399C6B5C6EE5A9CAAC5C99AC780D3183295C9317CB8C39EACBF7D2D5';
wwv_flow_api.g_varchar2_table(41) := '80093789F52CBDE2CE1D3B31AF9659E619BDBCF5E10DB97AF60D353FD28152F010CD6A80C7DC06272A3A33A9E44D333D78EE5D19C75CC9250D4D3BCD75134C71E5868DAA7CAE7D83A1B034B77748381251733BADC2D8C8B00C7D704ECDE7249BC2B22C17';
wwv_flow_api.g_varchar2_table(42) := '22B55645B0506E2EFC7C611423BD36C0C518BC9C1BE7A0BDAD3DBB65F356BCE15E994D681B80D2A9814AC9F5C14B7207F3A46DA6B95C69EFDEA980718E65746B0426F6FAD0952C1B42AE6FD8285B11CC48C4E009C31BAE6F6A95CD4D5B5124359173B5A8';
wwv_flow_api.g_varchar2_table(43) := '3CC337AECE47A816B3BE2E33CBCE81A20DF0627D775696EF35E5169F9D96EE3D0F4B5575B532AFD4BE6998E7AB973E90BA966E19BBF59132D359270ADF6FDDD6268DAD9D6A70103C07DF2002215CD6301DCD74455595B475EF5061C9787416B0BB64437D';
wwv_flow_api.g_varchar2_table(44) := '03B4D154F3691466F9F207E72581730081122B78B1502F17BA976F4F8B975E1B60DD1A4C4DE2DC57036FB70D410C3FD6A904C3F9726870402EBEFD63285A4A6E0EF4CBC5FEB36AADCB7993E6B67EE34665A61300C76813E3C497CF9F5526D79E87E92137';
wwv_flow_api.g_varchar2_table(45) := 'B775A89027E3DA2D1D9D2A5841EF99C10DAE7B872E9E974088732FB57A31EF5877CFF5C2D606586BB32033C67467C6C7A47337D6BE8D9BD5DCA9E66478C7A3B76FC1AB46E4AABD5B5A773D26D31377A0D59359331DC666423BA25104CB41128A54C8D8CD';
wwv_flow_api.g_varchar2_table(46) := '1B72EDCA65809A6FE9A62D5BA4AE71ABFABEA9659B72D2D4120C899876F4C36B122AAF005B861EDDADA9F3BDBAFBCA9DA14AC8524586A0355D58FB324AA5B4176D8742CA238831EF796CAFD22CFCBF7F3863A902A8DC32E42020C4ADADDB640BCCEEB50B';
wwv_flow_api.g_varchar2_table(47) := 'FDB00258FA60BE1E38D72F0FFDDCE32A40C1F2AA11EDA2E7ECC332A9A191316478E2B0027388785DA1798E47E188D5C36C2FA6BD14A655DFDD6275CF276D80B58D6FC0A1C0E7A6A7A4B16DBBB4C08CD2FB8DC374F2E01CBA1171620B24126780D2DBE6FC';
wwv_flow_api.g_varchar2_table(48) := '697BDEB575F5D20E6FFA4AFF3BEA7E08CED710608F0EDF9666CCD1CA14C32B6FEDDA0E47AC5C2AB06656DE34EE71ED7BF5D279385715A8919B0B56A045D599D3517ECC2E9FD01CB71DDA4CB4BEBE711903C09363D205F35CD700C7079A652F6FE834518D';
wwv_flow_api.g_varchar2_table(49) := '798FF3AB754EA9A813D7C13C089A1B0B6D58EB56D4D6C14CCF2202562EE3D847BE0AAF9B65F1E0EF2DCDADD85CD8A13497F798F73ACDF347D7D5F28C4B20063EAC0339723AAA3EF257CEFD4C86929FB469B0AE9ED0A161142A14A9948E9E9D6A5D9A80F6';
wwv_flow_api.g_varchar2_table(50) := 'D274727381DB7DDC68E06782A256113211701DCB5835A35A29986EC26BEAE8B67698B05CE2B26B00DEF4C38F7F4C2215154A63EBE039D76C407003603940186BBE02E7CA44196AE9853AF9D61C46BDF82E2CB5B7ECE82C07C4C4F00DA96AD862ADD39320';
wwv_flow_api.g_varchar2_table(51) := '4DABE292431B601D5D2230468526476F4B2B36EA9B10335600A99188247D78EDAA7CFB6B7F29E3B73F944835A0602050DB996F6AE486FCCEA1AF48C3277F4599719AECEA9A1A044876C9A5777EAA008600F92AE08DC0496BC3A6024D32411388D27A0C2E';
wwv_flow_api.g_varchar2_table(52) := '6E0D324DA8A22A8B283A372D1F7BF237A41BBB55D58874312DDBC5FC8C7F7FE6C87139F7EEDB72EECD9F58F1E8453DEE6C91AB76A1CD44EB68B1328518293144A13A76EE564E10B5970737D519AC9845E0A376730B766E6AA4BCA60E71E01AA96E68C4B9';
wwv_flow_api.g_varchar2_table(53) := '4EED1CCD60EEA67673A78967EE1C55D6D6ABC7774218241C3C43039794D6B35C3A7336B0642209F33CA83C6E0648E85C11641CBB539DB0260FEFDDA7E66A0E1E1EB414B57575F2E8CFEFC7DABB1D3B5E13D67CACBE75C72F6D800B9D82A88574AE62F060';
wwv_flow_api.g_varchar2_table(54) := 'EB9BB649CFEE87108CA8560E56044B95244CE510F6762141653A293E3A5C6A8D8A6B6AF4B5810BD8BE1B553B4EDCCAE39AB71566BB13716CB5B1E0F7A93C83E7FBD52E143D6F863F698ACBA1C9B3D8D4B87CE19C824E736D9B63D53780667D4C5B86AD48';
wwv_flow_api.g_varchar2_table(55) := '3E45C23AD4437D6813070232B883AAA315AE32D15CCAD0216AE2D2053086B1911043C09F5B848C3D5F1FBCA842905C1AA56126695A29546A2B4DF8C4F02DB539CF5DA5A49950CE11B59861493FC03096CCB9FDC6E54B78C4E79C82CF0D7D96415857A0D9';
wwv_flow_api.g_varchar2_table(56) := 'AC83FBBA8C5CD9B89877F2CE1D1531A359B6E77E3528019D5640ADC3013E9BC921E4525E6A036C0B63A59DB1E7B430E6BE89D161F9B7D32794AC2844429A85E99DC5961E41AAB021E1F25067D66E202851296FFCE0FBF2FEFFFD547D26386A717476161E';
wwv_flow_api.g_varchar2_table(57) := '7195CA47581C10DFFFCEAB52515DA3CC33CB60FD3330FF74E4B81F4CB36D1FE1F22AF9DF1FFE879CC51CCBF6CC1F56BDFC3C83F029AD8815D29C4F51EA2B6D80B5748430611AE7A6A7B1A4C163ABF84CC15343F88406E12E7E587967B14DC8E590C29FC9';
wwv_flow_api.g_varchar2_table(58) := '1B44B891D0EC838E1907D10822556A9B0F5FB02EEE28F127570DE97D8F63EEE6C68332C5AA201BAE750EA26D8C59E7E65549F3FCE51C427966BD27B9BB002B8B4BAD0BE099AA3A089382CF586298E5A5B4C382148219C6407048C95A473BA351788E1AE1';
wwv_flow_api.g_varchar2_table(59) := '4B6E43AAF22916D6B5681D30E10018862FE02CD7294D65D2599886430D4E0DE5B0087701CE760A30116058C9416D37F1B3D4A106CBD2C9B2C52CB7DC6C06975C68F3A2758E3A97C8664D34431B603DC6694DC8B4E04EE894A536C0EB1A5C30D76C013A65';
wwv_flow_api.g_varchar2_table(60) := 'A90D70B675EB17AE928036C03ACD8AAB24E4F1C66803ACD3AC785CA605375FA7B26803ACB351054BC8E305E854968200F7F7F7ABB670C58A8B75C69A0616056947016C19AFB4E88200F7F6F62AA8BEB4DFC0059F6D593F344980326551B68C575A6C4191';
wwv_flow_api.g_varchar2_table(61) := '2C7B74A50C338D9182409DFAEB9CEC49E9F54A5BB6503E7679A583A890BC6C8B9D3FF7BC503B73EF2D370F1F188114D5732390298BB1659C5BE4723F1704F8006A39839FA0DF183453C6854828D43B138DAAE767E69F635A6E5396998EC25AE951485ED6';
wwv_flow_api.g_varchar2_table(62) := '69E7CF3D2FA73D8BE421457E9519B729C8D03F1B8D5D08FAD3832CD69631AF5772D8D5AE242F1BA5F60398F9C8E73EFD5B28ECEBE150A8869F09D86E3C3FBBED705BDB94ED8390A2B1F804AE3FF7675F3FF16DCACC29E395C8B020C0B90D38F2D9DFDDE7';
wwv_flow_api.g_varchar2_table(63) := '33D24F61ABA016CF5BE411CA5F49D3D75A9E141EE9F38DE399847FF98B7FF8D61BB9B22D756F0B1E28A5EE800BEBD722D3FF07693871DB203007480000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72342096716797137)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/avi.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D000017BD494441547801ED9D7B901CC57DC77B6676F74ED29DEED05B02BD40C84212D10303922B10300139C4761287532A7FD849AA9C0AE661CAF61FA994';
wwv_flow_api.g_varchar2_table(7) := '2BE12A7FA452F9C3E5AAFC93045712179644385CB81C972DE24A425279120A211EB225901048484212A7C79DEEB5BB33F97C7B76EE76F76EEFF66E671FA7DB86B999E9E9FE75F7F7DBBF5FFFBA7B76644C1C21089C38C4D453467777E09AEBA01DC51826';
wwv_flow_api.g_varchar2_table(8) := '8A23A67D2F501C2750BE3D0747EE3226FB796382CE2030BE6B5CA3FFAB167C24CF50BEEAE707416B5BCA5C5C758379A67BA7F37ED7E6C0EB09023F6A4FD5EA5D43C195695E1EB90FBD34F0881338DF49B6B776D4B0FE151595A55B76A48C59DC923998F4';
wwv_flow_api.g_varchar2_table(9) := '135FF9F60EE764F7BF0689EEFB4CF67A21B92282BB9EA7C7EF75B27B0E062B8D19FE69AAA365CBF095A1344267A85715F135ADCCD4D1C9F8C6EF98EF0EDEB834D5EEA733FF930912BFFD57D719C91512D16341F5FDC19B31CB9F48F7A50DC65A321BFE40';
wwv_flow_api.g_varchar2_table(10) := '79D5B9ED1095CD64FA5B3A13BB3C27B3EF89C3C1FAEEFB9D4CF7CBC6BB1EC6E48A08DED2D565C75ECF710496C662FBD75E870086F10D783D5A53633C3AA53374396352ED894F05FEF545724504BFDDD323024DD6C36541852DC19672C5367618AB6640C5';
wwv_flow_api.g_varchar2_table(11) := 'C32165F86A26DBB230B13B30997D4FBE19DC224DEED2B359EC5D574470A4C1392A1D80686C56F36A677BE6D87DE0B8AEFC2AC792DC96D8ED673307FEE0D0D0AD3D8E93BDEFE59767ADB9AE88E0317CA2AB22D8A2E8063C1775C5B0E2F21F18682CC9ED89';
wwv_flow_api.g_varchar2_table(12) := '3B138EB7EFB1B7830D2FDF7FFFACD5E498096E4026CBAA52388F0FC2F97C01C94E3AB35F244B9367A3B99EB30417DA9A712B71A324A7DA1277BA99CC734FBC3ABC6936923C67092E30D1B995B82265B7248FF467B2907C4790700F3CF1C6EC2379CE125C';
wwv_flow_api.g_varchar2_table(13) := 'A0C1A5BD64E163C764A650DB035F2407B34A93E72CC1568323359E588335F1530835B9CF6A3224E35DBF36BCD99AEB9EC69F42C54C70849805A6F1FF14A8F104D5D5F38864343967AEB77BAEF30F5F3D1C6CD5326D172407A52DC004426B1B1533C15321';
wwv_flow_api.g_varchar2_table(14) := '56DBC64D565AD9351D4B68CDF5089ADCD29EDCEA0799038F1E1EB624EF6D609263267832481BEBD90C6D4D68AE59F14AB625B6BA81D3F024CF5982C71473DA1D2F9C424993DB925B13817BE0C9D746B6C95CEFEDE971ED8B03D31659BD0C7396E0020D9E';
wwv_flow_api.g_varchar2_table(15) := 'FE180AC981CB989CC1BBDECA9B0DCF3DFAFAC88E9EBD7BB36F6F364E23911C33C105B055AF5BC62DB994173D4939B9D758BCE1BE4C8631799367CCFE272DC90E24F7340CC931135C81E19B04CC467D446BB5C6E9B1766D49E60DA2FD8F1F1ED9294D364F';
wwv_flow_api.g_varchar2_table(16) := '1BD3089A1C33C1B3548367DA83D83DB3243B21C92934D9E0783D7668E4CE6EC7F11B81E498099E3D1A1C4B4DF582431EC9235693131B89DDDF2824C74CF04C55A1F6F90A6CCDF49DACB10A5B92ED2B2BEC26E73479617283EB38FB1A81E4394BF018435C';
wwv_flow_api.g_varchar2_table(17) := 'CDC0C92ACC1FDEA1B996646932F3E45BA5C98CC977D7D35CCF5982017F2C54A2C16352ECB2E628C978D78CC91B0CF3E4C75F4BEFAE17C97396E002135DA9064724E77A4D01C96DDEFAC00DF63FFE467D489EB304479CD8735C1A9C27749464164358F15A';
wwv_flow_api.g_varchar2_table(18) := '67FC00C72BFDA95A6BF2DC263852E3B834388F60ED4259929927DB152F48E6EDE2FD4F1E4EDF6349266D2DE6C931131C2196DFD206BECE99D4AAD43027BB90646F2D3F7CDAC7987C6F7737F3644277C08FDEAA1862165E4DC4E245A196351D25598ED702';
wwv_flow_api.g_varchar2_table(19) := '6FB5719DEF45243F8D6B564D926326385E12AA29ADD6B6C692CC3C99FDE41CC9C1F770BCEEC56C07DD552479CE125C4B0D8E3AAA48E6BF704C5E905C6D7C67FF1387D39F36552479CE125CA0C10537111D553B87245FCBA4536DDE8D38F0CF5693E49809';
wwv_flow_api.g_varchar2_table(20) := 'AE2D52F15130EEBDE8F8444F2C49062481772D925789E4C70FA71FA88626C74C703D0CDFC40896153BD61FED2FD06C1EC5D9833FFAAD55D987F24D915E9223D95AD68C485E00C9BE79F6F137D30F5A92D989EA7AFE79B6982B0F3113ACDACFCA20B32982';
wwv_flow_api.g_varchar2_table(21) := 'C2B3AEED4F61B928FB5C469E700C0E652AB9FDDF2447FAD3EC2727569A8CD9F7D8E1F4677864B4A71CC73C39668285CC6C08631D11350A780DD667F7C7789EEB3B2EFB05353D7875CF73BDCC803FC24F5797F25BEBBFFFDACF034BB29D2B57B8CA56F947';
wwv_flow_api.g_varchar2_table(22) := '5866039FE3EAA88EC84F09F9C9E87026F07A7BAF0D19E3F7DBED7BA595A995E65A7BAA8828447151475647C98BB3F994368A8BF215C7F13C2A23FFDCEBF47B89E4F2F4F0F0B77EFDC71FBDF38387971FD77BD77C47219B2F693AD77394E010227ED06C86';
wwv_flow_api.g_varchar2_table(23) := 'B3A6E5DC50E09981FEC0F7B34C4B65D4C6347C3A60569616D29D20C91B2159D7756E43D64D1CC7B7749920FC50C6CCA4CF6182432D63D075BCD4BC243F1D35CE603FDCB28268499E19A015E5F2B12AA994C96646320EBF91A948562EF31C26580844A6D4';
wwv_flow_api.g_varchar2_table(24) := '0F9C648B85241882641F8B58074DC67CF0E92EDF932EE7BE0F63A2CF64E4F89AF62966276BDAE5374006B0D4E08B3303C98ED3DA862ABB0E9F499305AFE981BFA71E17869CEA157D26237A5AF6B949703E54383CD264675E3BBF29041A3940B50C55282E';
wwv_flow_api.g_varchar2_table(25) := '6682AB50C35A02ACB2EA4D72D4DE5846E0DCE7832299959FC72C4CE5B2EA28A15E24E7C317937714B306D79194B88BAE17C931B7A349F06480D69AE42A8C704D82272358CF6A4972BE899EAA5E653E8F99E02A74C1321B52D564B522B90AF0C54C7015BA';
wwv_flow_api.g_varchar2_table(26) := '6055999B86F05A905C05F86226B80A5D701A1C543DE93892ED8B91F1155B05F86272C6A33656A10B46A21BE59C2359D509B4766D9735636A77BE98C69C07370A0B55AE478126F3E205F7B18798542F66131D7B331B57A02539955BD614C93198EB2AF493';
wwv_flow_api.g_varchar2_table(27) := '26C19574A1029251B96A687225F5236F93E00A010CE7C9394DF62AD4E4FC31B8D27AE5F237098E03C848935BB50B254D9EA1B96E9AE838D8A8928C88646D357A8D63AE9B1A1C27DF11C9D2E44ACD75739A14273331CACA91EC368826373538466E474541';
wwv_flow_api.g_varchar2_table(28) := 'B249A44C48F20CE7C9CD79F0289C8D79318EE4321CAFA617DD985C96AC5501C91578D7250B98FA41D3444F8D516529A64372739A5419D675CB3D4AF2C2DC14AA0C731D53659B1A1C1390538AB12427738E57EDCC7593E02999893141812627C7AF78E53B';
wwv_flow_api.g_varchar2_table(29) := '59CD79708CC0D75254812617919C3F0637A749B56425E6B2B4569D88CC751EC94D0D8E19E8BA8983C9C93459F56A6A70DDD889AFE07124E7D9E8E6181C1FCE75959467AE1D4FE63A47725383EB4A4B8C85CB5C8763B27ED5E830368F921C432931F59318';
wwv_flow_api.g_varchar2_table(30) := '6A32A745E448661FD949B0D598C53E67466241A449702C30C621A4D0F1F2D34D82E340B5F1646808D66B3FF3C24F4A545AC1E64A56A5085625BF584EC722B9614CB49A94F31F4B360C236643742E99B0E8C144B225632A39C5F926CB539C56556804ED69';
wwv_flow_api.g_varchar2_table(31) := '18825B414F9F97D12C41400AB02844F7DA83D117C1323CD473C54F169446204BB6CEA379B84F7333C231998C161E0AA0289FCA1FD24D5ED02DEF6C18A595AC28ADCE92AFE9EC6465F0B8AAA1AE040B04012FE0DE07890B5C0828C51707260FA69D671D64';
wwv_flow_api.g_varchar2_table(32) := '58C021D004E06441B2B3A47907D9573927C9A4B2D48956C3CA4212E87EA220F967C8779E04EA7892D3C1791588492EB7F610B9EA70EF91B68FB3EAAF4EA88EB091876D939441B2AA87BA121C11200077CD0B4C1B80082CFB15C1BCA68B1069DC55C0FE20';
wwv_flow_api.g_varchar2_table(33) := 'ED9857703057937925B5577A9184887141F1927DEF82C0CC27BD8057990A67461C731152443A22C605A5DDD61A980ECAD073C91F42E0C961C7CAD1BDC855BD54DFFB7365A83E0A2D1474967A9EA1BE0925AE53A81BC1C22145C32F01DA72C0F8D2DAACB9';
wwv_flow_api.g_varchar2_table(34) := 'A5D3378319877FD2A00874124B830640FD32009FEC73CC3F7FEC9AFF1B70CC1A5A30117E92FD2E7ECA176E08CC976ECE98B6646046B2A1EC841B98D72F7AE6E9139E59443A919EE3C55E8B2469E3DE9BB2E6F6C5BE49932FE905E6CC35D7FCC5B184398B';
wwv_flow_api.g_varchar2_table(35) := 'DC0EB14B9A13D4E96B2B7CF3D935594B649AF6B492B6977A7EE778C21C193666853AEE5C2458C04A03745E84B62C430B068810C10AF9C4F12D3A22C2CF856E5BE2989D4B7DF3FDF73DD3D3EB9A3545002A1F5F05341739EE5AE49BB50B419DEB0CA640CF';
wwv_flow_api.g_varchar2_table(36) := '52A4DFBA386BB69F75CD213A892C81EA11055D8A901B98A92C9BAF8E1140B031C3084D20288D1499E26310FDCBD4790F1DE1A6369FEF5E4A5BC3CF99FDD7479EF9DF7EC72CA27192A74365D73A08DBBA0435568D560574163883A02A0DD631CC218DB387';
wwv_flow_api.g_varchar2_table(37) := 'FDE81C24703F44BC4CF6860EDFFCD6FAACD90D011FA14532B55190599665F8253ACD06C8CD70DD8FA98CF25FE3BA9D417D5767604EF02C2FAB15A17BD58B0F95DABAA84C1DC3D42F4BEAF924B8CA330D29D272917B158D1DE2B9B4FF3FCF78E64FE97CEA';
wwv_flow_api.g_varchar2_table(38) := '64AD085267292EC31654833F7533D16A5B7EA3F944B31D2F056C4BCE1CFEF739D7A421775E2230EBDA03B3E906DF244990065C01BE6A816FEEC1843EDFEF999539B0D459C0DD1C23CD6F2EC12AD0015492488FAC85CA6D41E66686848D94A1B155E324A7';
wwv_flow_api.g_varchar2_table(39) := 'D1A05CB224AA175F7F0DCF0CB61EDD51D6E434899FC234EFC09264A9A3C2028681937DAE3970CA338C026605E80E720E9FDA2435FF233C1B2484300858AB818C5DDF4613BE7C8A710FC09EFA79C2BC7A5ED4F19C5A2B9DBE952D33BA847B8DD192A006C9';
wwv_flow_api.g_varchar2_table(40) := 'BB56DC363A843A47163244DEF1AB6821C42B28AF34EF17DB02738AB852CE9695AAC290AE933AC25BA8E40398E687D05EC997CC56C8BC8CE3F6229AFBD235C7ACE6BE784A2529B50EC2A3418245D1D645572279231AF1E994319B30A7AFE291BE7E09330B';
wwv_flow_api.g_varchar2_table(41) := '532252665A90CB2C5E214E0D513E117596B87BD15C69BDD2EA188184572E78A60F123CD44BA42F44F61D68F159322AAFD28D0F7AA28026F377006D5D4C3FEBCA9966591259158DEFFF4687FCCE45D76CA5BEEA70A5655A8135F9D3400417C22B027B1973';
wwv_flow_api.g_varchar2_table(42) := '353F3E2BADE3F1CD689BC0147029CCF835C07DF30A5ACC334D5522408F737117C4C971CB408808FD78C8313FC1213B8D76C9F48A8024F19F602CBF3B15D83135B40FC5B893D886F07C91BA3C8A59DEB94C637B18270FFBCD8F3DF3CC69CFACA27EEA645A';
wwv_flow_api.g_varchar2_table(43) := '688C72E604D4E5D440048B9EB190A0661B206817C7EDCC91FF9669C8EEE5727144329E2DE04A63FEF1926BD6630E35BE7232FD68E6362E36E340692C97A3A3A0B1F1E0A03147AFBAE40DC1D7A39598DADD68FA71889BD84C870254AEACC00ED23FBC9ACF';
wwv_flow_api.g_varchar2_table(44) := 'C4235BBE804CF4E97ED7ECC3346B616431F1C36469146085498C2187660512D5EBE5EDDE0890DFB80DC41029301760F6AC8305B16799DAFC1472BFFB916B9682A4C024A59DBAFC0CD5D90BB91A5F551B69F620F2DE46D315DE620E7D69C8354B5A430DD4';
wwv_flow_api.g_varchar2_table(45) := 'FC783BE983DED00356AAE25648863A8ABE11FEB95559EAC69408EB212B7209EFF9471F78E687C8DD89C91F626C0F4BB2C5D5FD4FCC0457DE340B26B0C869694BA16A0A802B73A8E98EA621BD98DB4B8CC95AB61CE07E21C58A6499DD01CE3B70AE3A70BE';
wwv_flow_api.g_varchar2_table(46) := '9447DA7E0E0D3B8A69DE854CAD447DC8F58AF98CCB7486141D4753A9DD2C3D9D667C5E469AFC39B18A57C842DC122CC9320E3B27274ECEDE892BAEF9EB0BAED9443E8AB7CE9CEAD22821E6BAA88995077513694CFE3CD881288D75296ABC7D49D63CB525';
wwv_flow_api.g_varchar2_table(47) := '63FEE4D68C598506F642FC3C327DCCF9EE96C06C8430116BCD33F1472F3BE6BB90AACEF013BCF343AC82C9F3B56331793495BA7B61608E722DE7AE54B0D333F245E3BD1CB535EDBEF9228B295AEF169831035AAA2A65C7D3EFE20C93A053663172AE1210';
wwv_flow_api.g_varchar2_table(48) := '798E65C157F148355ECA3477E2086DC2942ECE394E2270D78AACD5EA3F7A57EB4BC64E773EBB28302B71C67CF289402DA07C38E89887C9A779E90688B880F6F7B1D8D1894995966BFE7A3B4ED90ACAD39C58F90AEC74AE4EBD98F623975DB38731D8CEAB';
wwv_flow_api.g_varchar2_table(49) := 'C9BB148DFE0D96598F316CBC41396BB108EA488D4274CC0497C9E224C94494C0FB184DFB33C6B63730A39BA9E51180FF3A047F05AD5D81C649BB5B5884D05AF1C3170273A0972547DCE05F204D3B84451EAE887A70956FEE635142C4D9E91567590269B8';
wwv_flow_api.g_varchar2_table(50) := 'CA53FC3A347837641D86242D5D2A3E0ABA26899D03FF808591D5F8073B9766C31537EAB10E8BF13B90FCCD7712764344BB5D536D4546B2AB7D6E948E9683306CAE0015C99B20EA5E34620BC7AF727C8B79F011A63A2EDA1B3A3E8E1DABD7CFF7CDBB68E6';
wwv_flow_api.g_varchar2_table(51) := '7608BA05B095379FBC5510B21E02D7E02DAFD51907AC95CE409FB1412B51D2C43B3A02F3219122732C84779A5127C8731ECD7F8E8E77113F40CE9FFC02FDFB1D5A1BFFFD9559F32E265C9D4853AEFC4E3226AFB6570D44F07838046D54C1E8A9882D0E36';
wwv_flow_api.g_varchar2_table(52) := '0E276807E4693C8DB45779356E2BC80113E9F6B064B171802CE51549AD5ABA644E7C0BDADB074958EFA280A74DFEE5A4FB4B3CF27FF9D0C3E1C393A6104D9F5274BA0759FCF82216E4089D4D53AE09AA5A24B3FAB70D64A2C7E0D095083986B61CC2446F';
wwv_flow_api.g_varchar2_table(53) := 'E5FA2D40FC3A5B7F5A8FD6322351164091730EB36A4410E3E87CCED1EAD23580FE19AB57035A6DC29C93D4E691172C6237927EA9CC3DE954A634FC93DCFF88254D2D35AA8CB1109629EBB005520F9CF3F0BE03D6A2B3D6C3D658BF9471FE91B519737430';
wwv_flow_api.g_varchar2_table(54) := '614EE1916BCCD772A564D72B3410C1219C02435312AD317FF5C62C5B749861B463312A751BE42E870079B34AA77DDDF34C815EC4F17954E6178F56415AAA67A7D984F8631CB0FFC0A9FA242DBD423CB323BBD7AB5DA4176E31E65720847F90CACEBDE5C0';
wwv_flow_api.g_varchar2_table(55) := '6D438B9FBDCA8A14E94262542F5DC948938EBA697FF7433AC5F75923D79C585327BB0306C9EA34BF8B13F64DF682AF5186769334ED0A6521A6C6A1AE040BBA28482BA37153042E01ECCFE1B828081C79D23A6B2D5A4E915690B4F97F90E5C157F8A7251F';
wwv_flow_api.g_varchar2_table(56) := '5DE99B4E3A853449CF355FD6E6C27988D8C3F82DCD5B9493B58673806538C2F37BD0B479A02033CB3F706736320E6F3D8B55088BA64EA1E646F523AB75A0B47AF602F9B7B2E0F205B62D553F79FCFA574C772DF7CDEFF5F9E60F71C81E50D9E49138D5BF';
wwv_flow_api.g_varchar2_table(57) := 'D6816AC519F2299B5CAE52AAC16062CF5A156A01091DBAD65B116D90A863018736D2B575A7B152DAF9014B8FCF9F48983F6735EBD770A276E04D2F642AE59146AB53D2281128F9F368A5CE025A658AEC65C4BDC5DCF822E67D3EE935966ADCBC150DBE0F';
wwv_flow_api.g_varchar2_table(58) := '47ED188CD87A509E9CA9F0904F80494786805BC79F6731D56F30AFD6F6A33A9DBA432773F1AEF519F30D869433C8515A955B8F10B30697DF0CA514E87AB546E78F007A01808B1869813A809C9AFCA0F156BB41EF40DCBF03EA21F2AC20FFFA56D2723E85';
wwv_flow_api.g_varchar2_table(59) := 'B9D64B0322EC246BCE4790B78878698FCAE0D2CAD514462FC3BD8FACD7F1CAE763FEADD9A75C69FF0AE4B5F3FC3CF2B5EAA5A55379D01AEB31E8D601D37AF30DC41DC512BC881569A773C982C812A81C117E179DEE158609ED09EBCD4EAA5673A26326B8';
wwv_flow_api.g_varchar2_table(60) := '88111A542A08048D4D7A535280FF1D8BF5F3004A665A28E8797E50BC36122EE0789D0229AD5CAD02E02C449C62CEFC37B9C50E750A91A4372E2E434C2769F2E7A4922BC2A5ADFC0AC8F49CF56C67515976EC265E5EF4DD2073004FB91D0D55E790160E73';
wwv_flow_api.g_varchar2_table(61) := 'D1CFB3C82288E475A43B442738C77E7527D7926DA749C8511EBDFD2182A30E46544D43CC044FAFEEB4DB9A4B9D8F329E0A08F8B05A562C099C2C607A174AE39F088AD68C2FA3F527B09B922350E5816BB1415A582A28ADA6499761E4240449BE0E8DDDD1';
wwv_flow_api.g_varchar2_table(62) := 'ABB95AB7BEC6BDE2951E05B52FDBE95E21225EDAF91ED660105F40E65F4175535D17D12095A3FCF50831139C6BDD345A12355C9BE893F051205124487BA2D244F68DB444F792A7B3C057BAC9821E4BC3DA8B50503E69A28896898F42B1CCA81CD57B09F5';
wwv_flow_api.g_varchar2_table(63) := '77D43BF3823A9AD5E8BCB85A5F1635ADD2E2A7407412F102753AB9F370B7F9A431C5F9F3D3942A5A04147704E5D351FC6C22798A53B91A068AC344E98BD354FB3E66822B6B5265B943526602D864E54EF62CBFAC72D3E5E7A9C575B956B1CCBA4CD08DCB';
wwv_flow_api.g_varchar2_table(64) := 'CCD94C561D046226B851FB7175C09B0D526326783634796ED5B149F075CE7793E026C1D341A0E9644D07AD89D3C68B61451AFC764F4FBE5715BE663171AD9BB1E522C07A78FE84BE08E372A58CA6AB88E02D5D5DB6BB7959D58AB5012DC2E6533E5A4CF3';
wwv_flow_api.g_varchar2_table(65) := 'A22C04845D0EC31CA626C2B8ACFC1324AA68A123EA5DBE9BF09D80F520558EBFA27A82B29A51532120EC8421286683F022C278AAACA59E5744303FC1B2729D60E43D56928F26DB935B86AF443FA62C556433BE14027AE721D59EF446AEF8475DD73F11A6';
wwv_flow_api.g_varchar2_table(66) := '0B312E9567AAF8CA0CAA5E7370D861273CF4E381471CCF7D26D9D6D23955A1CDE7A51148F70D5D099CE0CBFFB467FE0B36551EC6A573957E5219C1929B57813D0707EE6210FE3C919DD0CE8BC8150DF1A56B7D9D3DF1794B5FEF1A80DD65361C7FF8D267';
wwv_flow_api.g_varchar2_table(67) := '52AFD826E6615BDF26AB22CD102F023161FAFF7D57A68883B426F30000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72342557963797143)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/bak.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D00001782494441547801ED5D5B901CD5793EA77B66F67E9184EE128895D005C91612480924B18DC1167625380FACAAEC4A5E5249D90848555EF3106F2A55';
wwv_flow_api.g_varchar2_table(7) := '899F5C79209732A4ECA22C89F29A94E3C45824AE82AAC484082CB12210A9045842486885B4D2DE2F33D39DEF3BDD67A66776677766FB74CFACB68F34D3DDE7FCE73FE77CDFF9FF73E99E5E214C04D79526D4D453475F9F6B89DBA01DE518A6CA236ABE26';
wwv_flow_api.g_varchar2_table(8) := '2852BACC77E8C4C44121E4E342B8DDAE2B1C4B5882FF230B0E342F523FEBE7B86E737B465CDFB0423CD7B75F5EECBDD7B5FB5DD7D1ED89ACDE312A0E67790172BFFCF2C413D2B69E4BB73775C758FF5045E5D12DBB3242AC6ACA9D4867524FFEED2E79A1';
wwv_flow_api.g_varchar2_table(9) := 'EF5537D5F70591BF5D480E4570EF8FD0E30FCBFCA113E3EB85B0FF23D3D5B47B7A782A0BA58BB4AB507CD5941975943947385DADD6E4C6D5990E279B7B23E7A6BEFE8FFB6E2F924312D1AF40751CD903B7BC233B9A1570D6D4D9F01F182F3BB71AA2F2B9';
wwv_flow_api.g_varchar2_table(10) := 'DC585377EA376D993BFAF4807B77DFC332D7F79AB06F87313914C1BB7B7BD5D86B4B49B03816AB6F75EE01E8C537E079A1A6703DE89472EA564E643A520FB9CEED45722882DFEDEF2781226F63CA021356042BCA19DBD8A1584D1715F78694E9915CBEA9';
wwv_flow_api.g_varchar2_table(11) := '33F5A02B72479F79C7DD4A4BEE65DA129E5D8722585BB04FA504108DCD6AA076AA6716AF5D69599C574945727BEA41279F3BFECDD353F7F44B995FCA248722B8888F3E2B834D4737E0B1AC2B7A15E7FC01038D22B923752025EDA347DE75B72D65920D13';
wwv_flow_api.g_varchar2_table(12) := 'DC804C5655256F1DEF7AEBF91292653677ECC8AF962EC9CB96E0525F336B27CE23793497C7C4EB8065E75E7C72C0DDB1142D79D9125CE2A2FD9DB83263273672C623F97ECBCDBDF8F499E99D4B8DE4654B708905579E252B923926C392EF731DEBF8D367';
wwv_flow_api.g_varchar2_table(13) := 'DC2545F2B2255859B036E3B92D980B3F06E5AE9525B793E4DCF123EF4CEF5296DCDFF84B28C3046BC414308DFF5562C6735497E99A64BAEB315832481679F9A33F1D70F7709BB6B7C149364CF04288CD01629DA2AAAE695150B96B5A7253477A8FE3E68E';
wwv_flow_api.g_varchar2_table(14) := '7F6B60BA40B25BD9CDD7A9855EB18609AE6B5B6A2A7C91BEC673D71893D3EDA93D962B0B241F86253722C9CB96E0A261D6D42F285C584235B5A7F7A45CEBF8374FCDECA5BB3EDCDF6FA907076A56195D86654B708905D7EE5E41B26B614CCEA53B527B52';
wwv_flow_api.g_varchar2_table(15) := '362CF9ED997DFD870FE7DFBD57C84622D930C125B045D72D4D6BAE348B9EA71CFF31161B6372AEA93DB5CB16E2D8338A64D950241B263884E39B07CC464D426BB9C769639D9CC3C46B279E203AF6D45B33FBE9AEC5B78568044B364CF012B5E0C5F620DC';
wwv_flow_api.g_varchar2_table(16) := '3D53244B900C4BCE80649192C78E9C9E39D027A5D308241B2678E958B0919AF201074D322C794659726A07621B8664C3042FD614E2CF57E26B6A9F64152BAC48568FACE06EB2E7AE339DE96D9694471BC192972DC1458670B6884956697EEF0A96AB48A6';
wwv_flow_api.g_varchar2_table(17) := '25639D7C0F49C6C4EB603DDDF5B225B8C44587B1E012A68B96CCD9354976A475FCA953D907EB45F2B225B8C44587B5E07948CEB4D93DAEE51E7BEA4C7D485EB604977062D082B5DE82BB56EBE4F416E1D487E4E54DB03663C316AC4886EE02C9D8F1CAB4';
wwv_flow_api.g_varchar2_table(18) := '83E4BC7BFCC8DBD9DF56EE1A4271AC930D13AC11D3FDB8C18F2503B1E1BAFABA15C95C4291E48EF45D7884FC18C6E4CFF5F5619D8CD0E7E2476F1106C3CAA344CC2C0A71D6B440323743DAECCD78D4FE879AE46F63251D25C98609364B4294DAE2F6358A';
wwv_flow_api.g_varchar2_table(19) := '64AC9339BBCEB48264CB5524C3A2DDBE08495EB604C769C1BAA39264FCF3DC755B1A246333E4EDECC35C874745F2B225B8C4824B2E341D911D3D92C773D94CBBBD09173F7C7A20FBC5A848364C70BC4899A360D673D1E654CFAD890E2485891749DEE038';
wwv_flow_api.g_varchar2_table(20) := '82EEFA912848364C703D1CDFDC0856155BEC8FEA17682A0FE3D4075FFCAD55D51FE65B409E9A0BBAD5AD464532EE27AF87BB7EE19953D94715C9B813656AE2659860D67E4906BA4D12E41D79AE7E0A8B93AA8F55E4F1C6605F272F54A969B5848225E72D';
wwv_flow_api.g_varchar2_table(21) := '71F4C840F63122D84792F9DE909021B482D2F289CC5208C58E883BF6AE6D49073706846D5BD83AC6FD82583F7874CF96766EC29969EE48ADC16FAD7FF067675D8F64AE9543EEB2857F09CB52E073561DD911F15342FC64743AE7DA4343E353423863EAF6';
wwv_flow_api.g_varchar2_table(22) := '3D65E96A69B9CA9F3242071DA73B323B4A204EE5A3AC8ED3F9CAE390AECB081E87E4989D4AAFCD4E4F7FF7F75F1E3CFF93AFAEFD80CF5DE33D0AF9A0A65ACE9729C11E44F841B398CE8BA6AB53AE2D26C65CC7C963594AA756B4F05AC00C270BD2A59B16';
wwv_flow_api.g_varchar2_table(23) := 'AECC5B96DC055D9BF0F96077AF70BD17652C4EFB3226D8B3320CBAD2CEB4A4F1D3512127C7C02D761015C98B0334542E075E259311F9DC4C4EE23732A174F9999731C14440BB52C795E92605893B391A20395E4B86FBC0ABBB1C9BB6ECBF1F46E8D764F8';
wwv_flow_api.g_varchar2_table(24) := '7CD57C303CC9AAB9FC06C8002C39F862320392A56CE980295B12AF49A3078FF583F91E7B9C177CD32B7B4D864EADFA98101C840A131E5A3248C6EF17000D27407186088A334C7004358C136096556F92757B8D8CC0FC9D8DD150F43046D5C6ADAC5E2407';
wwv_flow_api.g_varchar2_table(25) := 'E133343B324C70DC4C44585EBD4836DCA484E0F9008D9BE40846B884E0F908665A9C24075DF442F5AA32DD30C11174C12A1B12A9585C2447009F618223E88291325783F238488E003EC30447D0056BE02072D15924AB0723CD151B017C8626E3BA8D1174';
wwv_flow_api.g_varchar2_table(26) := '41ADBA518E3EC9AC8ECBBD6B07377AD49D2703150CC2D798EB60038D5C0A2A4A2C19BFEDE70D0AD3C190E91976D1A65BD9C0FA14C9197F5B136C98203902179D101CA60FCD22390286C2D40F7913824302E8AD937D4BB643BAEBE0181CB65E7EFE846013';
wwv_flow_api.g_varchar2_table(27) := '406A4B6EE65DA810EE3A020790106C8260EAD024F356A34D9223606B11754D085E046815B3689269C961DD75B24CAA08737D137C92AD06B1E4C482A3E80E74CFA98CF048E6C46B11EE3A590747C18C419DB348AE62332499451B24200E55252487985D87';
wwv_flow_api.g_varchar2_table(28) := 'A86BE2A243805755D602C99DFEEC7A1E4B5E84275FA80E09C10B2164225D919CF6C7E4782D3921D80481D5E82858B25E27CF63C9D5E8AB522621B84AA08C881548A6BB4ECFBE41119C6425EB602390C7AFA4C45D97911C1C83936552FCDC182B91B71653';
wwv_flow_api.g_varchar2_table(29) := '7A4C0E909C58B03188EBAC084CCE67C9AC5D62C175E6C844F1B3480EF8E8640C36817003E808B86BA9265E3EC9890537003946AA4077ED8DC9FC55A3C4D8BCA8BDEB0A7531D44F2A684FA2AB44C02719F791650AEBE43CFC736EA6CABCF38B2504CF8F4F';
wwv_flow_api.g_varchar2_table(30) := '8CA9A5132F279B101C23F83116C521988FFDB478AF94085B72B2931516C148F293E5AC11CD7575D16C863F67ACD818382E15F4712EC14A7A9867BE7C5A57A5FC4C2FB780F964B5BE6ACBD5F2511EEB4630814A03898CDF3A5E070341D260F22D60395C70';
wwv_flow_api.g_varchar2_table(31) := '7B7E2EC29A11C957D37059A9F3F148F9E979F22159958179ABC8300302CB64D07A989FE5F39A1F9645D2B51C4E0B81BF60611DB884CDFBF998C87CF50A752398200D03B94B6401612E1028D3864F174E3AF06981D04C19E004FA23207A0D7A9A08B0AF8B';
wwv_flow_api.g_varchar2_table(32) := '722B70BD1E4FCC90FCB93A0765912C469178011F8815EAC134967F1704482A033BD90594358E630A7194290F2D885811A86F164224DC57512E1EF975DD0826589B61BE07D2C517BD96B7360FD02720773527C5FF61524990EE418D59695A153F24E8408B';
wwv_flow_api.g_varchar2_table(33) := '2B3A71C26B06B541046112F7D1B454D6A42CDC4B2E7C93405AE85A28BCBF092708DEB75716CF2F213F3B22ADB305191E4159B4762DA732F95F2C7712650E42FEFC0CF2E17C2774331F3B1CEB1F772056B106828A768BEBF87A62555E7C75134ED078C611';
wwv_flow_api.g_varchar2_table(34) := '802070046C0A608D64A5189C90E2E49025FEF596541642ABBE86B49520F60FEECC8B1D2B1C31898E80375C2982D3B62B4600F23F7D9012AF0C4B7117FC30AD49075D8F1B28F88F36E4C5C31BF322A75E8DE549B043B083BDF07E4ABC8432DB70BD15E47E';
wwv_flow_api.g_varchar2_table(35) := '6B5B4EAC6C764536CF77E479B205B53899419E61CC8FAE4F4A3170D3123FC56712F5A455D392E30EB1125C0002AD9CC245074A5FDD0A44708EB7F829C07CCC140E9427C90472F74A21F6AF96E2DE4F6CF10F1FDBCA5D329DF2047C4D9B2B26C0A02698C7';
wwv_flow_api.g_varchar2_table(36) := '5520647F9723FE65D856E46A52998FE3FF5520BE35E38ACFAC72C43AE49FC4355E34ABCAB4214C825BD15126F17EB266E4A1E5DED1EA8A558A60BC538B850702EBCA80D7B8AB8EBA7FB523EEBB6E8BEF5DB4C4203A293B25B88E35C44A70B065B4902C00';
wwv_flow_api.g_varchar2_table(37) := '9C82D511184D2489D1B8E97791E5800AE308EC5760AD376199DF1FB404578A8C9F82354DC26A68C1D4CBC00ED39272C5F66E57ECB82AC40D907707AC9D2E59EB1FC4F9E3EDAE580BD2C6A03387FAE075822AAF269843094122992487F56547C8B24E8863';
wwv_flow_api.g_varchar2_table(38) := '79AC3383EE5CAC2F433BBCC6EF6C80300692BF822761D99C27F8C94A26EAAFBA118CB62A400810701504146F7E15AFC3422F8DC325626C5E8971F1B3B0AE1560929D610256D08AF8DF589D173FBF61898F302E93341B56C7CEA0273ED44D7D7C13E1C676';
wwv_flow_api.g_varchar2_table(39) := '47EC8575BE74538A559065E081636517CADED3E58A0E58315D2E99C77F91425E459A7F4D7D0C4C637D559D21C3E3851129FE176E388DEB4ED46D2BF4AD81E7600763476886D0FDB0E4C73016BC883A6F01E2D4A375526F9401D5AA4F602319D850CF3DBB';
wwv_flow_api.g_varchar2_table(40) := 'CA827E09109EFCC8167F7FD916BF773E257E7C212546619D0490169383BB5C81C9D95AB8CEE1024A9E1720E013E824373031A247A08BED00E8F7C14D93308E8F2497724338DF8D0EB415698C631D6E4E8314E4D79688E85981452A6F8313D6E7E2A825BE';
wwv_flow_api.g_varchar2_table(41) := 'F1A12DFEE6A22DFE1CE3F577DE4B89F318B3D949580E3B263DC95E789209E4A5F522FAF627B8D842DA991708582788DB068BEA0131F7E3FA674312C073F2E48D8D16329204CE90B96CF20261F70027F89FE2F5DE2493FA28B2BDDB11DBA16F1469045D91';
wwv_flow_api.g_varchar2_table(42) := '89F3FB7CF7CC6B12F129CAA19B6619889A27E85417FAD049D043D640EF1A90FA3C2674FF39682B6FE47911AF0E9D6813BD0DD7C7AC133F7184BA59B06E21E6A2857612B66900FC3E5CDB105CE65B20F20016C204072FFC556E97E2E7862DF16BB8EB6E9C';
wwv_flow_api.g_varchar2_table(43) := '431CC1D3C1FC74D337A7A418473AC1E7CC783D5CF43E907913C2B4564EF0BAD1F23DB0AA565817C318E4AF62A64EEBE5383C7FA01025BC99742BCE69B11DE89CFB30EEB2A37813B6A2160E211C7FBDFA16E3A33EAB1FC17ECB82B642CCE87E7F17BB053D';
wwv_flow_api.g_varchar2_table(44) := '709F7FB9C6115FDF92135D2098210300CF61BC7BE98A25F0D25FCF1A558A974EEBCD80C1AB58A25CC1384E9E689D2471EF0A5A9B6741DCA8A07BEE817B6699FCA2FC27C8C7A1002F6D565A2B7F79DE848E96A25C7EB19C6974A6D3E89C5DF0164DA8871B';
wwv_flow_api.g_varchar2_table(45) := 'D0C349D988DFC1A877A1122A975D5B8AE149560DD50E8892085A5A06E07EEDAEBCF8CAE6BC3A2731CDA821FF2EC52D4CA84E5D4F891F5CB2C45558DB0658CAC765FBF1C4336571B9838D118C839FBDC31B7B09C93D20F35E14C0E50A09DED7E18AD5FE64';
wwv_flow_api.g_varchar2_table(46) := '88FAE915C639D693188FF679902CFA1DCE09CE72328536E08F3E882F613DF51026551C77D55A195AE8963F4607E2B0B289ED419CEA58F394602AC930C13554BB20EA81450B20D1045D8DB76821DFC9CDB19168D0850EC2F5D20593573596157478701038';
wwv_flow_api.g_varchar2_table(47) := '5A295DE17F83E0C730695A09C0D979B8147AA0D315CF5E9362335AFD196C8C34D35F43F930E4DEC4D8B91DAE5CA9A4A2050245D831D641EF77B159D38C8ED5854EB71BE3FD1694C33295F780357F3C6689D730795C0BE5D4CF89565CC130C15520E3B7AC';
wwv_flow_api.g_varchar2_table(48) := 'E8BD9847C1AA5214A1FE3509E78E541E606DC218FA8DF6ACF8DC3A4B1CC3ACF517B038569E3983A572AC6E469EEF03D43FC16755735E11C1B8BD00FF12D6CF8FC23DDF0D1274CE2BE3B6786E548A6761D5EC4F8A771C2B05EFCF0D7B04D2337026CEE0CD';
wwv_flow_api.g_varchar2_table(49) := '9C41AEBFE4E2928EBB693FBB648B9318DFEF4485E32457D549D5CCD85791A885540625D9D36D58C00C80F9D5A796B882B190D64597BDADD31177027824037C297A70FD875B31913A2BC54F400A67A6415DAA519C59C06DD24DEFC41D075A3D03497D046B';
wwv_flow_api.g_varchar2_table(50) := 'EABDD0C74D137632BAD8F3B05E472DC51081FFB314AADCB3BF28AA4865E5FCAC8C539D122797D1C1FE0DE43E7FCD52AE991A7C87C4D35882610BAEA1CE3EE874D00485B3572E515EBD668BEF0090BDB0B20BB8DE8741F12FB0FFFB00265CF81B7F6AB363';
wwv_flow_api.g_varchar2_table(51) := '639B23BE88EB67476CB17F8E22A98FB782DE84957F01D372BA675A36B7343F8F0EB21D0467480AC2309654A7214752E931542CEBE6252B99D95F14F0FA013767B2183E18B8EBC59DAE515C7F880D901368C7AB187BB70165F6395AAF2749E97842FD080E';
wwv_flow_api.g_varchar2_table(52) := 'B44FC34580BBE04AEFC6AC793BC6B31E00F61AC6C75F605DB913636607E2E8C2395292B42DB0DEE00D04AD92967927D2DE805BBC082BA72C09E30CF92076C6D6F3DA0F97C72DF1E61876B9E83E115D0D016A7881203BE559CCEA5FBE62E38E11FE061386';
wwv_flow_api.g_varchar2_table(53) := '92EBF01C1F6099348049E12694B70B75A6DE7A90CB26D69DE022D41A726F0C54760DC6F1476E007A11798F006F32547C6AA99416EA6C47149725EF8000CEA69B00369F4EDD858EA29630D0CACD90B3B7B0E509F4D795AA2856A6C219C53916DFC0C4EFAF';
wwv_flow_api.g_varchar2_table(54) := '31ACACC3AC99F7823B91C035F64110CBDEA23B608DEA2B945A7B74DD092E369C63A214231887DFC7C484409D0701BF8575F1A36B61BDBE85794D841C2CE41C88D9AE5A30BB9B205959D0FF607C3D84317D33F6A4897837F4A9193B3ACDAD694BBC8574CE';
wwv_flow_api.g_varchar2_table(55) := '6EB9ED395BCB42806269078F7310C3C946780CE6A7A5F2436269E9C5F62DA42B9AF4BA13AC41D53B550FC1DA9EC552A98D16014BE02CB5071BF824857BCBB43EDE23A665327059343BC03A11D94D370D0BE378B8B1DD73A9749774AD0C97E0BE7F0937CE';
wwv_flow_api.g_varchar2_table(56) := 'A7363E816B9D5395275AE1DBEB94BCA7BC921E0252FC683DFA5821732CD175255803C296728245B21E5A97170FFA4DE70C953360A691186E7AF0AFEE9EC41DA71320F8011043E2D939B42E5A0D6057D6C32E0011711AB2BCA3D382FCEC242C87B718DF83';
wwv_flow_api.g_varchar2_table(57) := '7BBE8CCEC2A744A8871E04C92A6F411F8BC447074FBF278FBF1BAACA651941192DDB0847C3041396EA020923794D7071C049014590B475510BB511786E3F32704D79723025BE87A50727C1BC014F423823A6659319E6E7CD7C4C8E55DA46B0FCFA8825BE';
wwv_flow_api.g_varchar2_table(58) := '0637BD1DE32F49CFA0D59731B17A03EEB90711248DF229741ED647EB65D9AA8379AABDBC48A70C3B093B601A65C3F81B36182618AD9E270453B9417F0BCB09CE62B555309DA00603AFA780A09AEDE2CED209581DB95C83AF71581F09BE0637DC85E5C834';
wwv_flow_api.g_varchar2_table(59) := '9628DCD4BF09BDABA08C63612BAE7F0D7F7D0A3B49AD98F8501F3BC100AEDF433E3EF2C39D31CA0F23FF15D4871D445BF2282C9D8FEB9068DEA4E03E37AD9F5E8504F3D624277465D586C6C60886095EB899048E6115C079ED86146746BC2AE89CC0AA24';
wwv_flow_api.g_varchar2_table(60) := '4C21C31080E7BE33F77AB9FCE16DC2499CB741073DC10BB87FDC8AFBC7D4CDFC4390DD0439AE4B79BD01E7FF7CD516FF8567BA9045C95D870C6FF8339D0FC451FE756C8C9C1BC7EF8310C78068710D5EE30E64E212EE32CEFF0EF7A84936D3283782CEB7';
wwv_flow_api.g_varchar2_table(61) := '16E9BC6EC46098E0EA9B4817F729883B0FEB2250950209A1457112C375252D901328E6611AC37958D104D8A56512682E53B8F9CF737E989F4F465E8095EB40723989633A03496347A2B5EB8EC2F81590D14F517259750693325A3C35312FEF6AB1A3693D';
wwv_flow_api.g_varchar2_table(62) := '886AA860986036BBBA404068895CFE5413083A2D8DF9CA4B21F9DCB2D481964BF7ACE5784EC2799341075A3EE375A07ECAB44146E7639A5AEEF842EC947CC436985EAEC7176D9843A0C926EA44F8AB0F04950FA2551B086C105C9D8F931C8EE33A94CBF1';
wwv_flow_api.g_varchar2_table(63) := 'BABCAC723D5A86840543508E49EC64C1104C0FC637CAB961826B6F6EED39E686AE1A3D2664AAD131770DEB130BE7663294756F93AA135D8B42C030C14BAD7F2F0AB32595C930C14BAAEDCBA2B209C1B739CD09C109C1B520904CB26A416B6E59B31886B2';
wwv_flow_api.g_varchar2_table(64) := 'E077FBFB83B32ADC850F5ECE5DFD24760104886180E3328C17C83C3B3914C1BB7B7B5555ECBC6216F7CE7099703C1BE56A63889D8FA18FA9D01857ABA25C2ED44687EE5D793CC26FF1F915EFB6109FA709F4C1F22293EB8A08E81BD9A09998524E635C31';
wwv_flow_api.g_varchar2_table(65) := 'CF0209A10816A257A9B7AC960FB1E9782EDD91DE3D3DCCA79893B01804F8BC41A6236DCF0C3BE72CAB19983278187BE7B57F87E3828F40784F818B2FBF32F18474E5F3E98EE6AEDAAB91E4D0086447A7865DE9FEF1BF1F6AFDB18A0B60AC656A39862398';
wwv_flow_api.g_varchar2_table(66) := '25052A70E8C4CC41DCA3791C0371B774F11433EFBE276141041C4085590CC092B7F040D14F5F792C7352650A60BBA09248055891249845C010A6FF0F29BA4435A8E815B50000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72342960847797144)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/bmp.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D0000185F494441547801ED5D5B931C4576CEAAEAFB656E124208B421B03017B1B2600561B1EB352CEB6B3878F05A7AD80847F8C10F7EF486631F1CE10866';
wwv_flow_api.g_varchar2_table(7) := '1F162D01DE3F606F84C3018865F083BD76D8E10D07B0B180F15E840402049210370192469AE9EE99BE5697BF2FB3B2ABBAA747D397ECDB68522A555556E6C9CCF39D73F2E4C9EA92100692E709CB0099919298F7E6EDCD308E5626F60D8CE779169247C2';
wwv_flow_api.g_varchar2_table(8) := 'AF9EFECE039E6B3D8A9C19DCD6FB26DEDA5B93F796A8A3EF09C78A5D9E8E65FEE1EEDBFEEE43CF7BDE11E248DDB2841C8FC9E646452BD24FC361705F79E7BBDFF2EAF51F4DCD24A6C99D35E0AEC9F05B6E6565B89C26D4AE4C6B1EC9B5D6D579E1B22CD3';
wwv_flow_api.g_varchar2_table(9) := 'B8C7851713B54AF42B6F5F78EAAF2CEBC8872FBE381FF1BC7977B3801C6609D9D155F2BCC38E652DB83F7BFBAF6F722CE7A73373A97D4B8B2B55CF12B6056E938F9A9FEB37A44BB16975EDE1ACEAEB73809D2EAD4BB63E59BF6E50535DC1EC785E3D1A49';
wwv_flow_api.g_varchar2_table(10) := '14A7D373D96AA5F6AAE3D5BE4D4D26C80F3DB43940B6BB42B4A5F0C282CA8858F6AD98BFEEC82D1585025780AE0790BDA633F3D61EAAACCAD7F55ACF41BD669ADDD4D565297CBCA6EC79B0609EA8566B8599D9D483AE1579F6DDF34FDEFAF0C3F3B5975E';
wwv_flow_api.g_varchar2_table(11) := '9A7736C39CCC81F69C0E1FDE476510F5BA650B4BCEC5D43C306E120EBFABC272683096978A5E762AF160D5AB3FB39940EE0BE0858553D2F23A8E0DC525C23DCBCAE82AD6A9C3021EB467E57225776A2A71A8EAD59E39F9E1D1DB368326F705B0D660A283';
wwv_flow_api.g_varchar2_table(12) := 'B94FB9D2A383AAE396617A83040ED0A1B2A5D720AC5CBEE866A79287ACBA75ECD4C747F71264219E970210549A9CABBE000E0F934ED1A42870ABA5D1732DCE36CDB5D2E4E403F59AF52C418677EDBEF4D2F726724E3606705829C2C04FC2353598FDF4CF';
wwv_flow_api.g_varchar2_table(13) := '74C2ACE51C353971BF04F94C589327468E25EB8D013C29DADB4EE0B406879E4990A9C91264DB3AF6CED9C77F939AACCCF5E4806C0C60AE3F2735690D6EE97F18E48335DBFEF1C90F1EBF3300197EE5042463004FCE0C2CBDE62668DA68B07E2E41CE17A4';
wwv_flow_api.g_varchar2_table(14) := '261FB084732C007961221C2F63004F92FE36A91E9649EB68700364ED7865B3F103B604F9295F93C71F646300AFD50BCD9F313F77C68186266700B225DC1F9F38F3FD7B68AE17C47883DCD9F03AC2A8492F3AAA31B242BD991BB584CAD35CC7F7DB91C831';
wwv_flow_api.g_varchar2_table(15) := '827C64CC413608F0C8E0EABEE1DE653170BCB2F17B2CDB0E405E38329673B231807BE759F7F8F45DA3370DD6CD36409E9A4A4A90DF3CF7FDFD478E2CB80B00797E7EDE184F7583FD9CC7AA33FD0CA4ABBA2DD2780D2F7A3DB232B209EFBA4690B15FF1DC';
wwv_flow_api.g_varchar2_table(16) := '1BEF1FBD9720DF7DF7296B9C403606707F4AB11E1F8790BFB117DDB6137E58D34130A48660C85D4E443C7BEAFCF881DCD71B1DE191B72845F8D1F85D531A7587FB1371BCAD249CDC3234793A79672E5724C8DFDEB7E76F8F7BDE3E509EA7C986088D2EF5';
wwv_flow_api.g_varchar2_table(17) := '37BC50BF272A92A5C165FFFB61BF325B01C853C93B5DCF3AF6E6D9270E5AD67CFDB1C700F188E7646300072A11427D4C2F615E83D40F07024109819CB84358F5636F9D3D7AFF3880DCCFF002264DD815CC6A53EAC1C96AAAEFDF3440CE4E27F7E2C5A067';
wwv_flow_api.g_varchar2_table(18) := 'C601646300B7F0AC1D03C6366F83506537FD6E809CCE266E97207F345A4D360670375C18B7B28634580F4B829C87774D90F19EF87327CF3F7E6854E6DA18C013E5646928FCB3410DD6941B2067B289DBF042D0B327CF3F3912908D01BC49B70B3560BD9C';
wwv_flow_api.g_varchar2_table(19) := '1B2067B3893DC2734702B23180C38E692FDC18669D267FA1C7404787FD95201710F122C836407EE3EC0FBE4673CDFAFC3D5487747A2E66B081498238C42F831C08510D5FF28D2F8720634EDEE3D8D6B327CFFDE0EB3200F23D6CB20E186483C36BD28BF0';
wwv_flow_api.g_varchar2_table(20) := '00C7EF7AF8B22841A6E385FDE4DD50EBA71B208BC7F04AF6E034D920C013B4E53F1A596CCCC9994C0C207B12646442DC0607B23180C9B3D1F06DFC0CC4357AA440CE976BE94C62377EF0F3CC5BE79F7858813C3F104D3606F004E9EF35F83F944712E495';
wwv_flow_api.g_varchar2_table(21) := '42B99AC9246E01DF9EC606C537D452CDBC261B03983FF49CD46438D0D1091BC02C2B52C897AAD0E45D754F3C7DE2EC138F0C42938D013CB9F0CAA905E651E1C2933CF00FF31A07F3C3F7ADD7FAB93E879FFB7968493623FFE10F6D8588C0F1A226DFE438';
wwv_flow_api.g_varchar2_table(22) := 'DE3FE3076FDFA4267319F5FCF387F1B581FE9331802732920510FC44B30900D50F24C979DE371DEDF2C265F4737D6EF30C2D90A4A48B1313DB8DE6F358424193F183B7674E7D70F40FF9806F8798D86A340630FACA7E4D46D2C0D2818564E2E5397C9703';
wwv_flow_api.g_varchar2_table(23) := '3BF78E5DB72D1BBF5C1FE261A32DDB71560BE54A369BDC81CEFCD3BB1FFF5082CCB532B4BD2FC61A7BA3633290F57B0996D14C1254D7AB3905A8505D7885518F61B9902F4422CE8DF89CC40FFFE797DF7DFF91834F9E5D58380C255CC06FA27A4BC600EE';
wwv_flow_api.g_varchar2_table(24) := '4BCC7AEB7B5FB5547F31E179B578C92D3BAB2B2EBE214345E613AA78F81C6EAADDB37679E13AFA7ABD727EBE27A230282E2CC85D903E78D8E2ACFA0DB6FFAD0C4DA68BB33180BB68733C8A023F5F8BAD78221AB5B0282DAED6F0390AD8440932BBA9C4A0';
wwv_flow_api.g_varchar2_table(25) := 'B9C33A4F9FC3E5C279CDB5D49D7EAECFBA8CBA677F62D188A856DC9AA879F8E179FFC918C093E86411473215A07AD118DD1147ACAED4844790F9F633158B89FC6F73CD2C050D0B7597D6D4558460443C7ACF70BD143DFD998CEEA807A58D395993B45D18';
wwv_flow_api.g_varchar2_table(26) := '0C1F9C548CE5FAC58AC41C2B99A2325B16184D174C1D78D6EE1A7482FC2EAFD7D4F5DB901213929AF06732C2FDEEF4DA18C094C8894F1844346E0B802CF8667B63713CEC811964A63180031B366C6E186E6F5C4036342C830087EC8AA1CE8D8CCCA84136';
wwv_flow_api.g_varchar2_table(27) := 'C84A83006F1A1D567205906334D7E9119BEB3EA5DC18C0143A8382D7E7B0CC54A7874DEF7A92413606F026D3DF4042A8C9130CB23180E1E5074CD964573200019053D25CE387FECC9890640CE0CD0BAF42529BEB543A8225D4E4806C0CE0498C6475AB84';
wwv_flow_api.g_varchar2_table(28) := '6B4046C46B20C9205963006F3E17AB3D74043922CD3534D91990261B348706016ECF904D990B90E95D4B733D28900D31CE18C00685CED0D0064B66289A6C6008C60036D097C92341731D8526A70668AEFBE48A3180AF0727AB2DAF4373325EF919BB2594';
wwv_flow_api.g_varchar2_table(29) := '31802775BBB02D68DD66724E862627B1841A37908D01DC2D4F365B79B9841A4390B700362869E308B2318061A5B61238306E201B03F87A5B265D4B9AC7096463005F6BC0D7E3330D328321A374BCB6001EA0F41164AE9347E95D6F013C4080495A6B325F';
wwv_flow_api.g_varchar2_table(30) := '1AE858930D3A345B000F18E000644BBE19D211C8061D9A2D808700701864BE3420411ED45663CB788C017CDD862A5B187AADDB3A3E9E14895AF2CD102782B0E610403606F0751DAABC16AAA167FAA732C304D918C0A1716C5D6EC0012AEEB040DE027803';
wwv_flow_api.g_varchar2_table(31) := '3006F1983E5413C8584AF145BE866F358E5EB4C13E0D82A76347730DC8989309BA04B98174FFDD36A6C106FBD4FFA826848204998E5744395E3CD31133998C01BCA5C1BDC1D270BC006E1A4B28CECD26BD6B633F00DFD2E0DE00D6B518F172A8C991A870';
wwv_flow_api.g_varchar2_table(32) := '6B75E196CDA88C31807547B7CEBD7340C5AE11F1CA44452D66C6566F01DC3B1E03A92935D9C1171C92FE371CFA6CC5D81CDC673FB6AAFB1CE05447904DA531D7603DD276337CBB673A6F23F6B4A3B75E9D41D05CAF2D95DF4DEFAE4D091EFA46053A7DDE';
wwv_flow_api.g_varchar2_table(33) := '291B3AA3476A1CA6837F959151B16E95AF18C07C7CBE4CFED7659CAF182CA559DB883DA4C4F2A4A58FF5EAD8A0B6D12723353D4D733D5A686E04C918C06687A5BA55F74A305745B08540302980D535A0B46238120001912080E6D69770AEC9FBA08E2ECD';
wwv_flow_api.g_varchar2_table(34) := '3300B322781EC51907E43B109070395E634D8AB63DF441258E50F7C3CF42192984E887CDBE487AFC289D12385D6A94676300F73F080D9E03C6AECA2362CF8978F44B22EACC0AC74E81810E58EC02C8A2A8D5F3A252BB8C720509129F25A27B24A315682D';
wwv_flow_api.g_varchar2_table(35) := '22E751DB5D942FA17E1EC7B2ACE75869D449C8EB30302C1B75B6A1DDAC3F34DD3F7DAB34D7F3CAA095437F96F0C046F929790ED3F26B8CE43426009379CA14530BC9D8E9E4432293D82B12916D2262C7A5E6E11F2811E0C347E03CCF05C04BE262FEE762';
wwv_flow_api.g_varchar2_table(36) := 'A9F8B24846EF12BB661EC5793B185E8602825E8BC229E128899A5B10E5DA55B152392F56CAEF009CAB0066DAEF8302D2ABAF8AD9CC37C5B6F4BD20833F1010D53E71D28441D1AB88AA9B17E5EA25912B9E12ABD5F7508C5685A67DF49A3C06006B70C1AC';
wwv_flow_api.g_varchar2_table(37) := '7A4164E307C48EA9DF15E9F8CD521BC94C32974C9609203B96836751118B4C8B5CE9ACA8AF2EE33E22E2911968F1360056F219CC3A1A0C55DD27825C9874F7B700F24171B9F0BF225F3A8E1F76A71BF5F83C8AFB38E8498B4080F1541D9A96A6BF4B78C9';
wwv_flow_api.g_varchar2_table(38) := 'DBC54C6A9FB8947F4D5C597959B66AA19FEDDBD7F5077F1E0380B5E616C44CF210B4F0F7C1D459C4646B001CF31F34D191F32599AB99ACEAD4BDAAD466CE831400B75E01B834996540C1F9D696C087D958A7B0F033901414270950EE10A9D84EF1F9F2AC';
wwv_flow_api.g_varchar2_table(39) := 'B8B2FA22B2D328AEE9AB3E48E1F20156A0F93083BE143E5813B645E1DA39FDB0B4104BC5D7D06F9AEB760216EED160AFC700607CD217F361367140821B03B835573936364C333EBE2A562B1761022FC31C16A586459C349879033478CA07507D6D974C96';
wwv_flow_api.g_varchar2_table(40) := '0700B2ED08EA2C8952F5A2643135DEB113D0F2694C01190806E66308441D14A3CE34807908C25110CBC5D73125CC2AAE4308480F284A41AB43702E177E254DB2B21873229BFC0DD44F4B81ACB9ABF27A367D40E4CB6FCAF9DEB692A0C5EF8AB6F80483C5';
wwv_flow_api.g_varchar2_table(41) := 'B541DD18C00D13DA20BDD105253B0226AC8029DBC58EEC43D0DC39804BAF19DA654701D01571A9F00B98E1935208A4E649CD7400EE4E9189DD2E2AEE1580AC350534E55FEEADE2C3A2954FC4274BCF4980C8687ACE71D49B4DDD2B66D277A35E0C005741';
wwv_flow_api.g_varchar2_table(42) := 'BB24CDFDF6CC21D43907A073281B660DE8C1DCD2625C5D7D0D65DE41FF66807B45CC55BE21764DFF9EB40614186A34A78EA83307E1FA184321C0A34BCA161968BFFB5776D834CD65150ED57D2213DF0D4657644F086EA9BA283EB9FA13CC69FF0A8DB928';
wwv_flow_api.g_varchar2_table(43) := '358EA698A90EC6162B6701FE7F8A42F93480CA0057986FCA4C2829F3092D95A61CCE55FD0ACA9F00E84F8B2F967F2EF3B9B461AAD7AB30D537C107D8877C0A594B92E125187E2B856346024C539E2B9E104558170A946E9ED3032D469046A3BD6C3F2CA6';
wwv_flow_api.g_varchar2_table(44) := '417F067E455650238A60D414CC33FEAB5D98546A2F1943CFF452FE75B15C7A0D9A70A3CF3CD6512C64F8817FB9E6D549B2D0E7A37F92E6959ACBFFFEC2B6E210263557BA5E0EC2F15F30F33BC45CFACB5C78413C5CF4252E92B15B845D6459CEE39A926E';
wwv_flow_api.g_varchar2_table(45) := '85CD2AB3ADE678AEC3118C41311EBA7F34FFB40A417DF67B2DAD80EAE0AE8C6970775D5483A5F6D26426B0B4A1F3C344861531E7E661961D2B0BB6C08CC38CAA798C73AD2B81E59247B19B4350C0B79C643E41A569970704C2032DD22580CBC5B7000484';
wwv_flow_api.g_varchar2_table(46) := '8A96C10F00D313A7D0D5F1BC09141F40176B74FA0C5C5AB93832F1BBA43FE0C229D4E073DEAFBA8B184B2CE81BAE46918C69B0CFE22EC6C01A2A981041108340688696B0A6ACD6C920062014E3DA11E6BC8FEDF1768FFC3C25485A937CB1420DD6C11C5F';
wwv_flow_api.g_varchar2_table(47) := 'FB0273780E6BE71BD13EA70788131C26E51851A89034799EE929476EC18572D8D2B15BC5B6CC7D10888434F1F4CAB936BFBAFA6BDF3ACDA06C302EDC0C3D19035831AFD3FEB3B4E498648E5A7AD09151F9F4A2C9701BC0071C5E4B5BB5196AD9BF0CE528';
wwv_flow_api.g_varchar2_table(48) := '99D1208548B02D46B538F7069FF04771863271C8399DE5490C369E168340DE3CFBC7B8F638CBE21E5E3E40A770F2BA5ACB89CF965FC43CFF26EE19015356896446958C01DCDB00A85BCDC100A55DDD3026849E7F19CA59BF5BB210D10378A10AF23385BE';
wwv_flow_api.g_varchar2_table(49) := '4315AECC2C0A029744AA0EA70A3A768C8197C552E96DB1B8F23A3CECF741919E3369731C4DE286FBE12663737088475D8C80706A13A6184DE7859AA202F7A4DA27839A3A16D022388E9DC1F22681360220EA9893A9D9DABB46079B922B3D72986F801D7C';
wwv_flow_api.g_varchar2_table(50) := 'B3D203B09F42734FA21E1D2F6D0182F69A880CF1C69806773714724D39473577058CAA49EF5969AF05A7650E8C9F8166AC203F05F657C0B8B02C6AAEB3D550CBFE6528A78995A4AFE7633A6D89C82E1173E850C1BB96743CCCC94BF0E2F30009E697E892';
wwv_flow_api.g_varchar2_table(51) := '18D497010F19E858F915429CAB8880DD2352F15DC8AB2130924690066B61F80C170BFF21FBA4FA1B084E5347867813E6DA109B6553E49C036FF3328E82642019CAF92C89F528BD537AA92C67432B5479D6E1A1B6FC70811A8A8912728D3B1FF84946A240';
wwv_flow_api.g_varchar2_table(52) := '8154A895048EBB3FF49467535F568245806520A3060FFE738056407E8CBDD16414C0D0DEA5D5FF139FE57E243EBEFA02B4F633D041B084FE029677374CFDB6984ADC8FFA39D4236BD9D7D1A61101AC18472696DDCF1128F8C207988E0F3522216EC87E15';
wwv_flow_api.g_varchar2_table(53) := '1B0EFBA1511F43A3A8E5049281116EF915A597CD6D3F05A0CFC4167ED28432C8C1A511975A8C9A55DD0B12BC1BA7FE04EBEF3DB23D8A09012AD7AE20C4F82E883148D1C21A7F5EE6122BE6EC459FCF888BB99F61B9B40A67308673496AF28EECD710C9BA';
wwv_flow_api.g_varchar2_table(54) := '197421B42DFE85DFCBA19E5A46D17BDB81AC77428348506BE290F615B1BC7AAA11E4903A0990B901B07BF64FB15DF747601C971B8C48ADE2CC756C0211A7FD62E7D4B710AEBC0BF9082D860069F405CDD0FFA560D0EB8D627F792A7148EC9EFB73B13DF3';
wwv_flow_api.g_varchar2_table(55) := '15E4731EC5320CE05208AEAE9C4404ED03393733BF29F9C2439F8107F7AA73A55FA3CEDBB26DB6EF62EDCC5DB0EDE9AFA32A6D0B975ACD4E6413CD21DC8C680EE6C8B416A744AE7C1CA6EF76B13D7B1F9C520626A8AD42860E6FC1B2A4583D88F52536E8';
wwv_flow_api.g_varchar2_table(56) := '914F534A0DE766433492119F2DBD2CB5256C0E8905353D8DA8D4EEB9BF202980807A4E0A819539E909CB6813B45BEE5481E6959513F0825F8626D303A6DC37C484D59B6E495B0A05E6EAC59557B16FBD5BAEA5A9C5FCDF96E6D2FBE1709D8500FC02C2C2';
wwv_flow_api.g_varchar2_table(57) := '8D0B5F3A24A1E1FE630CE0EEBBCD41133068314CE717F9FF06E3B3623A753BB49A66189B00FEDC96897F4908FA3C7EA26E5063D4C63F354DC5A89557AB664E3E8BF9FBC3BA1ECF1412C6BC69DA2336C2986867B1F086F83CF7EFA05702E069A9A1121498';
wwv_flow_api.g_varchar2_table(58) := '65D25414F5194FD0750660388F9760AA170BC7E1643D02E188807659064BB6671FC4E6FF19DC733ECFA065AE16869F8C99E8DEBBEE820129CC8D97B009F02FE272FE38185D915A4A078660F25E6D18A8FD5F6A10012043E59B1B28A3EEF13FA4C0DC522B';
wwv_flow_api.g_varchar2_table(59) := '1978A0B6530FC3078195010AE4AF562E884F977E2A2E2CBF8039942F0D6870F110B5B8DC611F1CF80AEAAC5EEA93D3319FF30F347E093B4CF9D2077E9F95F73D9DDC2B7664FE00741808A1A91E8D168F5083C9449D304782B9F4A82F2C3F0F661DC00ED3';
wwv_flow_api.g_varchar2_table(60) := '3E78D33BA456AB485750965A5242ACB7082F76A57C06CCC75B176062054E12FEE74E683ED7B14A76092E592B418660507B2BF2759D8F50F7341CAB4F512721DB0F6B19DBAC218C29F7933965802EF77BD98E72EC38BB238205E1E42ED5E5023746D2E88B';
wwv_flow_api.g_varchar2_table(61) := '0A5BD2F14AC56FC254B21B343E421FAE1D95D3A3337D1E1380392C82CC987405EF58BD22E7E598B3131EEB76308D5B74D4469A57EEDF16E05D5F02C317518FA616FBC8D0C00BCBFF064632C840ED6A4E0A609A7DBCD007C74E073368669508D0D4EB5AAC';
wwv_flow_api.g_varchar2_table(62) := '9F12578BBFC43CFAB64F4F015A7397F18C5AAAFC049A6A1B61C995F27BE2C3C58B5258D84F6D016A785F8BC10F5D1E17434DC6002603FB4F9C93954924D094FC52F59C4F36603E81903163193552F32FB5AF5CFB0C02A283164A6B759F646D4E9E10083A';
wwv_flow_api.g_varchar2_table(63) := '5CC14B76044347D37469B480B235043D2ADE259457B4A44966944DD2D165290CB01670AE2AD8B7D6ED2B7E70F9C5F2BA8FBACEF0CEC600D6ECEFBFEB8AD90A68359FB5810ACD68B62B4DE23D2D00B8D94117A43EA39CD6DAF675541F18CAD489F5747B3A';
wwv_flow_api.g_varchar2_table(64) := '4FF703A2C3F7B99A48B52BAFEB0DE76C0C60E5699AE8B4E650AB56E97CCD60A523CD1CD5CFAED58F703D4D73BDF22CCB7E749ABA29DB29CDFECA190398E6CB6C6AA5A781D1ADB43ED7F91B9D7BADB711DDF17C6E6C9944F6B742309E43BEBE7A650C60EA';
wwv_flow_api.g_varchar2_table(65) := 'C5F5A51B932128C600DED2DEF104DC18C05B067A93036CDEC91A4F864D5AAF8C6970108A9F34168C577F4D4F757D01BCB070AAE1574183F97EF956EA9303E46138A610E6712FA4FB02F8F0E17D52E05CB78E401D76424D8B5F2F239AF03A8A87F8411E78';
wwv_flow_api.g_varchar2_table(66) := 'CAA1681EF73AACBE021D5ABAB079EE39F8E3EF9D52933721D44AB77A63746775C134C9436A8B8B3F6C4BF3B8B776FBFC6DD2E1C3AAD9942DCE952D717A6A26B96F6971A54E84B5D3C55EEAE185CFBD7678BD7AADEDAC574EE7775B5ED5E3087A4DEDEB06';
wwv_flow_api.g_varchar2_table(67) := 'FDC0A605B6A1C043E7EAE2EA7BE4295BD23C36DB6A87D4206ED85841B7905E79F76FFE0C7AFB8FD9E904BF85D01CF4D0C8F241BBA4C71E8CB6592A5827FC2C4CA3DFBA9AAEA62947831BDDE7D633CB85F3743D9EBBADABDBC6595FE6964BDC8FFCCBAFDE';
wwv_flow_api.g_varchar2_table(68) := 'F9F72F4892211E879BEAF45AB3A7D3F26BCA85417EF5F4771EF05CE751CCC67C4B4E4D226B6A6C65B472C0970B1B6EEA123E29FC93DFD9F7D4EB2C13E66D6B9DA1DEC331E85B5086DAE10968CC144FFF1F784191EA5BE77E630000000049454E44AE4260';
wwv_flow_api.g_varchar2_table(69) := '82';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72343314124797146)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/cdr.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D00001830494441547801ED9DFB8F5CE579C7DF33676E7BB5B1F1150CC6E006622780A983A085B42591DA484D7F284621B4F985A8AAF21F44AA1457299050';
wwv_flow_api.g_varchar2_table(7) := '29A92A3552437F681A4C6836115555B5416D9AC4019472336E429310301073F37DB1D77B9999734E3FDFF7CCD93933BB6BCFCE79777666BDAF76E65CDEDBF33EDFE7F6BEEF99B3C6384851643C07CD2C6B13D1FEFDB995308E56266606464CF13C13A9E1';
wwv_flow_api.g_varchar2_table(8) := 'E8E0A73FC2D527395B6BA22834B95C6B7FBD732DFA4C5436B9919366E0AA47BC3D7FF16614EDF38D190B93F1F40EB19D539209E06670EFBB1B86FD83192DAEB1E4CCB6AC138B7FE7543AAD394B18ADD6206DBD31C1E6274D187DCEDBFBF923D10FF6E7CD';
wwv_flow_api.g_varchar2_table(9) := 'EFEC0F560AC8E9D12E9A8D9278CF1B0BA2837FB2C578E17F9AB5E55D667CBA0A9E396BB4856B826F3B3DB5966FBD6EA530C9D7FDF479BA5C723F39CE961584D5D0E4D74F99D11D23A65AFB1FB23EE5DDFCF9375612C8D96CE858C2C968071CFE80393B23';
wwv_flow_api.g_varchar2_table(10) := '460B5CB53BF7A87B17FA2C542FB9DF5A377D3F7D9E2E97DC4F8ECAB3E791442E6F4750A94D98D1C15BA1FD4074F8AFAFF17E777FCDFC70BFBF127C723680F7ED925EC0B2106D4023C4B2E43BD6DDF84E4F9E43AF4D1E7E97F3B353911929DF6E82DA81E8';
wwv_flow_api.g_varchar2_table(11) := 'B98776AC1490B3013CF672CCA430A7385AE156CCB3BEFAB6329A13F5E6EC7400C8B7A1E38F4587BEB8D3826CBE4D746DB5BDAF4695109B0DE04483D55A0C71D26E6F1F63BB93A211639C43383D803C07C8A30398EBFC010BB2774F607EF89798EBFE0439';
wwv_flow_api.g_varchar2_table(12) := '1BC02916D9D37E51E084CEE428F78284F2277EC85C4B93F75A905F78E8BA5893C7FA5293DD02DC0A78BF5C7B6830B8E262A4DB0AC21273BD9733CCF5C33B3D69B211C82AD83FC91DC07D35EC1680120D6EDC6E803C8C2687C13F47CF3F787D0C727FF964';
wwv_flow_api.g_varchar2_table(13) := '7700CFF16B0D6EF5FC995D899B23A131C813F2C9E59B5995FB5603E4FE31D7EE009EC39F9E87B541E0C26657FC89CDF570E9A67E04D91DC06257BF697142AFF5C1C94503F7FA5943932DC8DEE3D14B5FDA65CDF558EF6BB23B8017E4CF1C86F5CE8D59AB';
wwv_flow_api.g_varchar2_table(14) := '337BB2106DB126CB5C0F976F6423E5F1E8F003BBBD7B08BC7A1C6477002FC49A5EBEDF24946D82AC79F25079B709F1C9B320DFD3B3532877008B3F17E5518FA1DD446F13DA0B111A9BEB04E45A02F2189ADC9B20BB03B82DFE2CC4B72EDFCF466BCECE94';
wwv_flow_api.g_varchar2_table(15) := '05F288D5E4C7A3430FDCE4DD5307990707BA3C9A0B76E78E98266DB8609FCB9FD94AEBC251F4FCB46AC54BBA3C315DC327EFB2E6FAB9876EB6207FF0654F4F87CC5FB1FB77DD1122ADC8A619DD1F7DD2E3FCF3E02477FE63BCACE9B3765D639E7C3D803F';
wwv_flow_api.g_varchar2_table(16) := '16BDD47B20BB03B8552BE6674B6FDD6D12C8A68B76E9D4A87D76A1629003403EFCF01EABC95F40DE7B4093DD01DC117FDAE5E35297CB44BC56AE1B9A1C04F8E487F67ADEFED0F400C8EE001606FDA2C5099E4DF4365D2C56A21A9A3C52DE89AB6283A237';
wwv_flow_api.g_varchar2_table(17) := '40760BF062D9B25CE55BB19CBBD9D00965B126CB5C0F97AFE30917F693971FE44B13E056F8EC5265EBCD8EAE1BE67AB8146BF2E1076F5D4E73ED0EE056ADE8883FCB54C96AB0B3BE5320A3C9018B212F3E78DB7281EC0EE0C4AF39E353171BB2D324A7FD';
wwv_flow_api.g_varchar2_table(18) := 'C520DB7972E91A8293C7960B6477003BE54F971B5BEC42477BE4C58157BC18B2DD82FCEC5FDDDE6D4D7607B086D36F5A9CD0EBCE07B742DF0079A8B4DDE47DE6C90FDE614116BBBA304F760770C2ACD621F6F2B5D86FD3EC4972C3E53106F9FC8CA2EBAB';
wwv_flow_api.g_varchar2_table(19) := '4D4074FDE297EEF4F6334F2645D1D22E6BBA03D8254BBAD556935076016499EBA1F236607D9415AF3B6290BFC013B94B0772FCD30D170C157F9694472E886C69A389DE26B45B0A3AB9546F7EBC4151DA6626660E44CF3EF8A7FC34F347208C26F364B656';
wwv_flow_api.g_varchar2_table(20) := 'BF1C27771ABCE4FC7138F279696D42DB61674D4DC5D1F5F94AD50C03729EE8FA85877E0F90A168FF9268B23B809BC6D1E31773B014E2F3A2BE140351EF79737E0690CB5BB17ADF8C0E0B6411E01E64B700778D478EF96E173AE6A0EEB8937473FA198C97';
wwv_flow_api.g_varchar2_table(21) := 'C75C57F1C95B4D00C82F3E70D75280EC0E60F1A79B3C4AF3ABD3F34420354DE2AF2971A95BF6769295BE4E9D275593A37471BEBA30C8B61497B3BF7542930572692B6BD7DF8C0E7DF9E30259BE38FAB6DE36903DB90358A45BF2B313D5FD1660AB8433FD';
wwv_flow_api.g_varchar2_table(22) := '0333E958FD332BB8E9EBD4B9CA292547959FAF2E1DD892B3E52846B542A4E87A64604B140507F0C9BF6FDBE2112017F36477005BAAF4D507A94910F5D3D75CC88718D7E7BD223EF16C773F5E2EEF9BC94AC51B1EDC60FCDC3F4687BF1283CC5C196DAF8B';
wwv_flow_api.g_varchar2_table(23) := '4F677C75374DEAACFFE5A905CB3435F100350AA7FCE98963D328EF84FB25E9450EEF9C99C8FBFEA64AB5FA95F17FFFB35FADFDC4D75F3363FB903C1EE8EB305D9A00C3AC582D78722E9A2AE5AAE7FD73934114049197E377C24D0A5E67ACCACF773FE1FB';
wwv_flow_api.g_varchar2_table(24) := '85F2D379E9F3A4AE8EBA1F9AA84038107839FF06B4FA4A6EBD66EC6FB067DF95A1A28B4AEE001685FD94A057C10E7350AF54F40BD2E673FC2C3864A9C157DE3C63B9D8102F949FCE4B9FA7BBC159986231672AD5A0165659DA7490DC012C8ECCC7150744';
wwv_flow_api.g_varchar2_table(25) := '2E55130A762CC81C8A05CF8CE8D1AAC9C0048C433FF8575E360FD806E5A93EE83244C0E27786146268C692D764B4D1D47C452ECD202BC5897A442BBBEC15F39E373CE07B80EBC168299ABDAFBC25FBA4FA006BF5D994F6A55F93D194D3DE853B80459AA4';
wwv_flow_api.g_varchar2_table(26) := 'B1CF53499A3CE0DB97F4590DEEE67896807FEE005E02E2BAC9DB745FCB0A729A1007E7EE0076404C2F35B15240760770ECB17A09A3CCB4948A5D36D7733C70E621F08B1A57690599E8599630A6AE6AF212F0D01DC0B35C597927D2E4D1419F55C4FAD4A9';
wwv_flow_api.g_varchar2_table(27) := '8F86E816E02590C09EE025E3B2F3E43E04D91DC02BD00737099740CEE393EB20877D22CCEE00D680FB64D04DC02DF222D1E43C9CEB0790DD012C462D4114B848FE2F7DF19426F703C86E015E7AF6F64C0FD264055EBD0EF22AC09D8A0C9A5CC027F73AC8';
wwv_flow_api.g_varchar2_table(28) := 'AB00770A70BD5EAF83BC0A704680557D166436FABABE417111FA5701BE0883DACD2EC827B30BE503722F45D7AB00B78BE0C5CAC927D741E611BA9ED16477005F0A53A4764056E0D5439AEC0E602D72E8B39A9A3479B9CDB53B8005ECAA16C7E2DD62AE97';
wwv_flow_api.g_varchar2_table(29) := '1364B700AF6A6F83033D02F22AC00D48DC9FA5402EB4135D2F8105740BF0AA0F9E2B248B017909F8E716E02590C0B91CEBC33B0097AF4FA1DAD2648743740BB043C2565C537590F5486E3741760BF0129898150534FCB18B21EC42750B64B700AF283496';
wwv_flow_api.g_varchar2_table(30) := '6830D2E4FA2E543740760BF0AA0F6E4F2AF8815BB740760B707BC35B2D254548815CE4E78C763184FBAE756415E0E512B714C8238339FB405FE4FC2D59FA57AAAE926BD17345572FB703CF04AACCF5C840CEEE2B677E6743CB78DD01BC1A41B7B0B6BD4B';
wwv_flow_api.g_varchar2_table(31) := 'FBF3D524F01A22BA066C976BD7EE005ED5E0F6105DA8149AAC8705F4DCB540AE55172AB8B8FBEE7EE1BFB87E574BB772400A222BA82914E6BA5CEAF8BD2B4D2DBB0378D5443731B6E30BF8E813550F940A1D3791AEE8CE44A75B5D3DCFC601298B2313DD';
wwv_flow_api.g_varchar2_table(32) := '87006BF4F3998B85EE27BC4EF23BA9AB3692FA497BC971A1FB49FE228F32D50EE31977267A91E3587C71319228847778DA649F4F4DC08223C9FB0123BD7D283DA15419718C7AB62ED7E909A7AD2739A78EAD9BB4C92D9B74DD49BFF5EACB7CE80380530C';
wwv_flow_api.g_varchar2_table(33) := '0E678C094E03C4540BDB0420E5BC2233FBD1F838AB711A220086E7F98C73DE1ABCD4D5C51BA2D83075EBD7B63EF53C7C6158A1DA49BAA07F2B2C8910A4FB5D1397B5F528D623A9C7011623156CA095D5A300503261897F2A56DA62C2FC5AAECBE451269C';
wwv_flow_api.g_varchar2_table(34) := '36B9DA39E3554E985CF55D6E01A2DE3DA9BA1286E0040ABCD98403B79AB078B9897CC0147080ED0593C6ABBE6F7295B78D573B15D7E1DB6AADDAAEBE433F4513966FA0EE6613E511A054BF1EFDE62AC752FDA2ED3D04B23B8013C1B7CC71F10573A591C1';
wwv_flow_api.g_varchar2_table(35) := '591A9B36C1E8C74C75ED5E531BDA66C2C2A8897290EE89992400F5C21A9F19533C73C8948EF1EA3FC946340118BEA95E7E9FA9AEB9D104039B00B74C5DD58BCDB217220CD4CF55C64DF9D8F74D7EFC7B60BB9E7B4439E119138C7CD454D6DD6E02F59B1F';
wwv_flow_api.g_varchar2_table(36) := 'AEF7ABBA24DBAF8444FDBE684AC7BF1BD713DD4D6EC2965E962F77005B86BA1A431D5C342ACAAF37339B3E0B93F7A0419841994831D6FAD1BA54A18D113C0F0A1BD0C673A67872C87833AFA3E93BCCF4967BA97B9305D63E8D9EAE476B91DE1F88B607A5';
wwv_flow_api.g_varchar2_table(37) := '75A670EE75933F33C9DDCBC8386B2A1BEE35D39B3E86D558A792FC25BEBD21CD112FA68DCA975B0B523C59C20A48A8B02CD06869E57B51497C7498DC012CA21AE3CE40A24688F90CCEF07EC12D66EACAFB4DE5B20FD9C6BD005F88664439012AD2136E08';
wwv_flow_api.g_varchar2_table(38) := '745E4D67B518CDAB075A339BEF313397DFCA35AFAAAB61AAD1785BAFAE790296D78FD20E59024FF5ACD53861AA97FDA199DAFA07BC1E744D5C97BED46F5C5674F0F2BBC482880EFAA6017B5F653A4E4E78D8E8DD2DC08D763B3C13832029428B7203667A';
wwv_flow_api.g_varchar2_table(39) := 'EB67D0BE1B015BE617A65A608BD69CFA53F27B67281BA09DC356BB6B4357708E16118805C37722181FB67478C134E01401B18629FD5F933FF72A65A6C1A880B91FC6FC5E65AAC3D7D03E7D876711ACEDA6B2FEB700771470A5D180495E7EF22D5318FFA9';
wwv_flow_api.g_varchar2_table(40) := 'ED9FC258974113943760FE6FA008C8D8285D5AEE18253B8ACEBE7A0C6031864F70CA5430CB3302081FE98555801340A1299D7ADE144FFCB7C9CDBCC67D2263F93AAF040023A636BC07508884B9170CED3421FE565A6D7D3500944EBD60CA6F7D8DF64F53';
wwv_flow_api.g_varchar2_table(41) := '467E58C1182CC0E7D686F7D2BE04CCC7245317B31B9B593497BEF3E78F9AC1371F31B9C9E728231F9BB45B36C553EA577E5BF515D875689EA9ED3AB90338ABD0C21CAB65F8DDB0BC1BCDDD8B92002AA63531C7A5E34F99F2BB7F0F2EF2739A96887C3E32';
wwv_flow_api.g_varchar2_table(42) := 'CDC1BBA670E609EE13E5125587F99106AFECD48797B94F1D35A67288975FDD8179CD03A88000280425FFFE9360BB8136D14C7F8DA5A5F10BB21C5A4BA43DF90CED6F211F1F4DBDD8AC4F1BFF3CA02B2A47C814E94BC07A25D5C34107E44878B32440B0FF';
wwv_flow_api.g_varchar2_table(43) := 'B282E02618D9634D5FEC136914F35838FB9A29BDF7A805D314B60306407A043368AFC931EDC9038EBF99EB0134681ACD65CE6A358AFAF2AF98D4CA7AA2E1B59F019B37118853DCC35F5B0D06305B573EB6105B06AC463C27467231ED32E1958D9F239F69';
wwv_flow_api.g_varchar2_table(44) := '558D2915426493ED7B13CD4BA0B232216ED2E5B754C04DCAAAC19AB644F2B3C3A63678355A225F5AB19A666076F1CCF330F63DFCDE550882161C5AB4C4F256810F661933EBA3ADF2DB913F4879695B40BB5798C9ABEF37C5D337E14B9F46A35FA61D08B7';
wwv_flow_api.g_varchar2_table(45) := '8B2332AD34826590F9D7B4292C6176550237217F3BB5F51398FEEDA670EA294CF60B5892F76C792B54F56997ADD0435FEE0016833B16605514C0E7016443633A64FD6B01669F068C37E0F40070241DCD275144CB12127FA3C94FFC04ADBFCDCCACBF997B';
wwv_flow_api.g_varchar2_table(46) := '0C1380E56303409BDAF2715CC02DE4FFC2144E3F6D7CF9D5489600FFCDC7AB1CB5F3E9DAD09575419B01E4380E98597F8BA98C7EC01426EEC2253C67F2670FC6D6C09A6DD124C19B8F366EB7933AE6E1FC8DBB0358ED6718973587169C11AB75965C0D16';
wwv_flow_api.g_varchar2_table(47) := '9F98AB9D8789EF735E5FD858703A5267B04C378154F9DD31AB79D5D19D00E803309AAC681C7720A0838DBF6D2A6B771324FDA6299D78020BC172A48042C88AA79E40D098836FBC9DAAB407C03660C3F746F90122F4DD46ED16CEEE6561E5DF623FEC6BBE';
wwv_flow_api.g_varchar2_table(48) := '2CAF9701A52C3CB44C6BFE72E783D56E8671E9A5EA92FEC86E0AA4814C1A6E31C9BABD60227002A8DCF42B44BE5F33E5E33F664AC5F447F3604CBF4010D0720121F3DCE92D7799A96D7F4E247C0582C1FC9B299ACA28A01B3CFA04D3A3B76D4FAAAB80CF';
wwv_flow_api.g_varchar2_table(49) := 'CEB759BD52A036B3EEC36672FBFDA6B6E62EEA222016605BBC27BEDC029C49FA241DD2322D54F0B1490D6A9A02C315C4D8604919ED7444840CC85EF598291FFDAA197AFDEBA67CE2197CF33180A1292274DB9280260AAFACFB9099DE7CB7B5185EA84591';
wwv_flow_api.g_varchar2_table(50) := '41B2074CE1E4A366F0C857CDE03BFFC1FCF9086565AA11122C8B2C428E28BF36B09939FB1F11FDEFB29623D254298BB45BCADC7CB905388306DB39A822E290E9885D5C60809ADE10E06889322C6D83670AAE12705B3A4B22E6590DAA9B4AF9554CA73FF1';
wwv_flow_api.g_varchar2_table(51) := '0C407FD90C1DF95B33F02EF3E88A34150FA5952C80528055C5B7068337D127799AF6C825F85B29FB9629BEF777D47D188DFE0E4B9A47C8A75EDD65E4D0E6DAC016163C6EA31DA26CEB87DDB2B653B8DD5121BE27BC5F3435AA88C63187F46AEC08C17C99';
wwv_flow_api.g_varchar2_table(52) := '6B01ACE837E27EE5B23DE4A3C9E139982BED9219573D0D818F9D7F028AC0529216CAA72773E53C53197F8B35DBA5B7BF68067FFD98F1674ED256BD1DF5836F0D4B57DA3E3CFAB17D0848CDB9F3DB31E993A670E21133F8C6DF98E2F8FFD541269FBA023B';
wwv_flow_api.g_varchar2_table(53) := '6455CB3087B6FD5ABA5A84D012D6DD2F71C74DCA3C16018AD9640EEB4FB04AA5050E0B0EF7D1622D075636DE47FE29CCEEEB1C65C6C9137305245328CD6FE3675D88B50B002AF0AA6F90CF9C55F4D15E5400C0C22E3615BE41A4FC12F76216D83978A295';
wwv_flow_api.g_varchar2_table(54) := 'F92B009B2952F0366D4AD86C654C330B20A55B8C37F53C3B474F02384BA0F5FA2A6385C58E01BA7A24B98DA2B30E4A3E36B70E5FF713029BDB00F57A30247AB55A5C30539BD9D921282A9EFA115AFE1A7944D6D262FC73C43E7175742F20948988C738BF';
wwv_flow_api.g_varchar2_table(55) := 'C5D4467EC3944EFE1881791AB04E5096A992345FD3B19216535818A9FB4AFD8759FBBF74AAACA469176AEB1FB3BAF57384E07B547B876244E0D66288C6114CF94E8E5A0D6B48B68DD043D6AE3DDC425D283859D6D44300CBDC625E5974F0AA6F01D20FD8';
wwv_flow_api.g_varchar2_table(56) := 'BF65635F0BFEC1543DB8299B69A636D266054BDA8715C05A2B0E8B6B59C8D8CA02C49B68D7376867803930200F5F8BCFFC28A6F91D226956AF10226DDAD7466E4008AEB5D6C1066F68BBA663FED4ABE45FC6CAD5B5CC77AF670FFA46EEBD8D393F06D068';
wwv_flow_api.g_varchar2_table(57) := '2C015630780D347CD05A9878DA051B11007F0A419069CF6BBAC4587A20F510C00937600C4F5FE4C79F34E5E2C678CB8E5524AFA6E547F9541FCDDB683F490D7B1470EC36C5735584451A17542DF033EB6FE4FE6E6B0DAC66D95DA9B8AC22613BCFC5DC17';
wwv_flow_api.g_varchar2_table(58) := 'D869F2A60E9A70CDBD260798417E0821D8C9E7BAB86F59184CB26202B593D013E6D97018FFB929BCFF1482C5932631417C4B689737B905B861AD328C4AFE0B334A60533CF12DABBDD39BEEB24F6358860938CC769CD20C44937952C3FAC104081F10F524';
wwv_flow_api.g_varchar2_table(59) := '00D320EBCFF385B81AF976F9513E198D942F2D9F780ECDFF17BAC0BC5A10C9C304E7F88981FC6CA44D7C45F532C9B67D0E9ABE0174E1FD574CF99DEFDA1530ED4CC5DA9BA62DEE7639BEDD02EC644C6A4451A9E6A91EEBBEDF6629F11536E0EF30D5911D';
wwv_flow_api.g_varchar2_table(60) := '767D588CAD873D31CF003DC7931CF97367D0A417B957E0FC672C706C891FB529E0A32D407171B5ABC0CDAF9DC6AC1E675DFA10207D1FACE837BF03737E84C7770E5A331CE829122C483C9D527DEA02B282407FE634FDBCC2DAF67FF104C99BC8A54C336D';
wwv_flow_api.g_varchar2_table(61) := 'F450720BB0130D16770432A65A7351960D73533F33A5A99FF29F39AFC4E45E8D5F8691F5858AD8144F02F07198FC6B34F33C79C36C18FCCA0C1CFD05E5F9EFE9AC50457922E0FA0285DD5EC4DFE65804C95500463B4B76FB51D32FB43BE0B19FE3FFC43A';
wwv_flow_api.g_varchar2_table(62) := 'F5E5D4DF6623EA78B1057649FBD1780F7F9E63CD5AF182DDD1B26BD162402C7A9CF444720BB0D321D541D67CD2D7E63B2B4E00E203085E989E92191E0CB53C45E3B55062E7C8646B3D9AED408160665EE55C75D4A63EAAA0A43A94F399522542A5A304CB';
wwv_flow_api.g_varchar2_table(63) := 'B0E9501B377EF53DCE938029A9ABFAB04E7589FAE3F2E932646749097959DAA8D7750BB0C6EF34250CC5E76A4EECB11160C11107D25C50B9A473F9707DC8B77BC5F8493B95B9501D819F0800A7B6AEFAC33C1BF69D67FB549E52D29F8EAAA79820E99FD3';
wwv_flow_api.g_varchar2_table(64) := 'AC494DA58797A13DB7003B226AEE7812462620B43253802A8980741E5A6569D2BDF47D956DAD335F7ED29FCAA7F3D3755BF3749D2139E6A15B80D33CC830C6F9ABA61B5F880BE9326A257DDD6E9D74EF17AB9FCE4FD7CB70EEB8C9C49165A0285575211E';
wwv_flow_api.g_varchar2_table(65) := 'A68AAC9EB6C101877C740BB063E96B83152BB388433EBA03D821512B13B5E519953B801D9A95E561C5CAECD51DC02B933F7D3F2AB700AF6AB11B8170C8C76C008FBDDCF0BC7A9EB571E566A0ABAD1893E67107FCC806F0BE5DB1ACE5C218DED4E67707B4';
wwv_flow_api.g_varchar2_table(66) := 'AC56110712ED154F95121EDB8BC57F655BE848A42BE7B3191BE8991511284D4EC85C3C4597720DF14E4AA2C74442FD709994F0B843BE6403785FBDD79A799DBDD25F9AD1D22E333E0DD8DC4FCC75FA5CC55BAFEB4DF4DCE162745E28FF42790B0D34AE13';
wwv_flow_api.g_varchar2_table(67) := 'C2431F1EFE12061EB145131E2F54EF22F713182E526CFE6CE4CC630F5CA499E8E0A7EE66CFF41133C2B3334A995AB62D5C5A5F968B0CF92C3F6334DE67BD3B0F7C470C48F3B813866486214D4074F0D31F01F24F42D65A28E3F79AD95C7C2703EACB3A21';
wwv_flow_api.g_varchar2_table(68) := '9B179E1ECFF4D89F8CFED5BBFDB167358E346F97755C2264590958819DBBE2E9FF03E2F202B47F58F1590000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72343760460797147)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/css.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D0000179B494441547801ED9D796C1CD77DC7DFCCEC2E0F911465EBB66E89BA68F848EA2B879D38419CB6809B2261DA022E82022D1A4B4ED1042D10207F84';
wwv_flow_api.g_varchar2_table(7) := '458AB608901645FB478B14890BDB925B35698C06A91D038D0D44F1A5C8925CA93E245B726449967551A278EDEE4C3FDF373BDC254551DCDDD9DDA1B8CF1ECECC9BF77EF3E6FB7DBFE3BD373B32268E14044E1C621A29A3BF3F70CD75F01C93314C4DCE28';
wwv_flow_api.g_varchar2_table(8) := 'FB5CA0384EA07A0F3C3D74A731CE83C604DD41607CD7B846FFD72CF948AE50BEDAE707416B47C69C59BEC07CB7FF43CEB1BEAD81B72B08FCE8796AD6EE3A0AAE4EF34AC8FDCC33435F708CFBDD74474B771DDB5FD5ADF274CBF9696316B6E49E49BBF96D';
wwv_flow_api.g_varchar2_table(9) := '7F774BEBDBFD3F0B52FD9F30F9EB85E4AA08EEFB777AFC179DFC034F07CB8C197D3633BFA5777460248BD00AF5AA2ABECAAA4C1B9D1C5A3CBFCD1DBE6971A6333F967B291FA47EF79F6E778E5E4F245749C42E0BAAEF0FAFC32C6FCA5ECA1A8CB564267E';
wwv_flow_api.g_varchar2_table(10) := '43791D1318EBA2F2D9DC60EBFCD45D9E937BE291FDC1DAFE4F3AB9FEE78C773DF8E4AA08EEEDEBB3BED7731C5902F962FBD71EEB28C1DB784B8DF1E894CEC840CE643A531F09FCDC130F1F185927923F711D905C15C10777ED128926EF11B2A0C296604B';
wwv_flow_api.g_varchar2_table(11) := 'B972939D8ACDB4471687D18BB97C4B57EA1ED7F776FCF1AB233DCF41729FACD12C8EAEAB2238D2E0029598BC226CC9A637342D511B6975E0B8AEE22A67F49225F9AE94E33D219277394E7E366B725504470015F756A18BA7093E9AD415C38687F183CC75';
wwv_flow_api.g_varchar2_table(12) := 'BEA533758748DE7630D8309B3539668213CCE8B44D0BC7F141389E7709251C6BAE21D9C9E6766CDF37B2519A3C1BCDF59C2578A2ADB962260E7B1D929CE948DD1118EFC947F68C6E9E8D24CF59822798E8C24CDC2425B7248FE1935B3B53B7072977E723';
wwv_flow_api.g_varchar2_table(13) := '07825947F29C257882065F3D4A2E6A7267EA368650B38EE4394BB0D5E0488DA7D6600DFC94C63519732D929FDCBE2FE8B5E67A57F2875031131C2136C9D825F574821A4FD1485D8F4866642573CD64C8AD8EC93DF927FB839B354DDB07C9C1D52DC01442';
wwv_flow_api.g_varchar2_table(14) := 'EB9B1533C1D742ACBE0F37DDDD66DCD262C15093990C4977A66EF683DCCE2FEF1FB5247F31C124C74CF0749026EB5A85B6A6487247EA66377076469A9C5492E72CC145C52CBBE385819766BC3AD237E7FDECBF6D7B75EC36996B916C5F1C285B64ED2ACC';
wwv_flow_api.g_varchar2_table(15) := '5982276870F93ED44E868C0DE6722D5DE9AD4C8CECFCF2BEB1DB45F2C1ADC64912C931133C01B6DA75CBB8255F2D8A9EFE3E2E4FEB31779D6BE94C6FF68CD9F19502C9E69BC62485E49809AEC2F04D0F6622AFF2B49AE31C27993788763CFCCBB10FF73B';
wwv_flow_api.g_varchar2_table(16) := '8E9F1492632678966A70A5DD87D5B371922FE6721934D9F1CC4E7CF21D4921396682678F06C7D252BDE01091EC186F0C925B3BD33DE4EE480AC931135CA92AD4BFDE045B537E90556CB025D9AE2FB39A8CB9962677A53710853D910492E72CC1458638AA';
wwv_flow_api.g_varchar2_table(17) := '2CC82A8A2898037696646972BA23D5E338AE7CF2DD8D34D77396E002272149D5687091663BAD394E32D175A6C3DBE07AEE8EED7BB3F7348AE4394BF004135DAD0647244FD6E490E4B5811BECD87EA03124CF5982234EEC3E2E0D2E113AAEC99A0CE948AF';
wwv_flow_api.g_varchar2_table(18) := '09FC80C02BFB917A6BF2DC263852E3B834B88460AD4259921927DB192F48E6ADC49D98EB7B2DC994ADC76448CC044788953E69828F0B26B5262D2C35D705921927AF6205F9094B723F9321A4FE801FBDD530C52CBC9688C58B423D5BCABDEC8C17EBC904';
wwv_flow_api.g_varchar2_table(19) := '5EA915BC6AFF7844F23709CD6A4972CC04C74B422DA5D5DBD6589235192292DBBD95BC26F0F8C37BB3F7F1A390A0BF8624CF5982EBA9C1514715C9FCE78D5DCE6533F3D22B79D77EC723FBB3F79B1A923C67099EA0C1134E223A6AB657DF4A8524A79613';
wwv_flow_api.g_varchar2_table(20) := 'C03F564B926326B8BE48C547C115EF45C7277A6A4945923B3C4BF2F6FDD94FD542936326B811866F6A0467945BEC8F41E1E53A3B1B658FF53BABB236EE78ADF292AE7BDA7236F04A3184C25C43B26F1EDBB62FFB194B32CB8DFAEDF58C9EE11A856226B8';
wwv_flow_api.g_varchar2_table(21) := '88D835EE9BB4CBF28D023EDCEB588B08656D33A813FAE0825C9DD8BBA6ED38B933B58C50FBF16DFBB39F15387A3B248E7172CC040B99D9908A1D115003CF757CBD83E379AEEFB8AC17D475E3D53DCFF17243FE183F5D5DC46FAD1FFDEAEB8125B95F63E5';
wwv_flow_api.g_varchar2_table(22) := '2A67D9AAFF08CB6CE0F38A36AA23F25342C2D8D15CE09D3B7779C4187FD02EDFABAC4CA8B4D7DA53654429CA8B3AB23A4A499EADA7B2515E546F721ED7A37B94EECF39835E2ABD243B3AFAB79FFBC9FB6FFDE837961CD17BD77C47215F2AA99CE3394A70';
wwv_flow_api.g_varchar2_table(23) := '0891BEE1309A372DA746F077438381EFE71996CAA81535BC1C30AB2B0BE94E90E697CA79D775B6206B05DB91DE3E13841FCAA84CFA1C2638D4329CAEE365DAD2FC74D438C38370CB0CA225B93240ABAAE56355321993CF8DE51C7E235395AC42E5394CB0';
wwv_flow_api.g_varchar2_table(24) := '10884CA91F38E9160B493002C93E16B1019A8CF9E0D35DBE275D66A86CDB137D26C39E54F027E620AB821634BC0A58CAF912CC40B2E3B476A0CAAEC367D264C1EBBA11EFA9C785A9A07A933E93115D9DF1BE49702954043CD264A7AD93DF14028D02A07A';
wwv_flow_api.g_varchar2_table(25) := 'A61ADC2E66826BD0C27A02AC7B359AE4E87963F1C0E107CB229131EC8B162606618D13D128924BE18B293A8A59831BC749EC776E14C9313F4893E0E900AD37C935F0704D82A72358D7EA4972A989BE56BB66783D66826BD00567F820352D562F926B005F';
wwv_flow_api.g_varchar2_table(26) := 'CC04D7A00BD694B93284D783E41AC01733C135E882657050F3A2B526B906F0C54C700DBA60CD592BF3061348664D5E73D771A552F892390E8EEB49132E6702C90C58398F3D35C7C1B1435A9E404B72A630AD199326D7A09FC46CA2CBC368D6979E40728D';
wwv_flow_api.g_varchar2_table(27) := '34B94A909A04570960384E2E68B257A52697FAE06ADB55A8DF24380E20234D6ED52A9434B9C2C0AB69A2E360A346322292ED526372CC755383E3E43B22B91D4DAED65C378749713213A32C919CCA18579AEC355E939B1A1C23B7E3A220D98C935C61E045';
wwv_flow_api.g_varchar2_table(28) := 'DF882335098E03C5A9644C2079868157338A9E0AC904E7554272CC8FD3D4E09801BD42DC38C95D059F3CCD10AA394CBA02BED99161494E1378CD80E4989FA8A9C131037A5571E32447D1F5349A7C5521E55F68125C3E6695D79860AEF997A927CF789506';
wwv_flow_api.g_varchar2_table(29) := '59CD7170E53837B4E6044D9E4472A90F6E0E931A4A53753797E6A6E49365AE4B486E6A7075B826A7364C4EA7C96A685383934357C52DB982E4121BDDF4C115C39AAC8A25E6DAB1E6BA4072538393C553E5AD91B90E7DB27ED5E8E09BE37CC72BA67E52F9';
wwv_flow_api.g_varchar2_table(30) := 'E3356B0A8102C9AC3E392902AF3CF63937160B344D826381310E2113032F3FDB24380E549327432E58AFFDB4859F94A8B681CD99AC6A11AC497DB19C8D45F2AC31D1D10002433621295F9BF2275F53C1A89E8E4BAF4F951FC95259A5ABC90CAF16FF565A';
wwv_flow_api.g_varchar2_table(31) := 'AF28A17647892758E0C9CCB480B6F69AA22F2547792242FD3D5772213A4C713153A8533ABDAF3AAAAB72A385C2ADBA079B86A7FA0E5A9E7D748D62572455930C5B8FBDCE554FED18D349025262098EC013B1594E8E13589E8121FB1D1ACEA3EB22AD9D32';
wwv_flow_api.g_varchar2_table(32) := '4B41BA9D4DF9DAF4602277900247F82AD210999CDA0EA2BD36955B401DD5D5BCC261FE8C90A97B0EB35F42FE62DEB829AD47319B5497CBB613A8DE053244B4EA2DE6C292ABD40B6BD7EF6F2209167869C09226BD896A4A3BEF6A0DCC9A56636EC804661E';
wwv_flow_api.g_varchar2_table(33) := 'AD16E8C39077918BA7471DF30EDB28E7225575C7387E8D6B2B29FBA98EC02C6B094C1743CC16C0E77B63E632A45FC83AE6381F313C3CE658426E69D77793C2EB92738132EF724D792253ED8A92CEA5A9690E3E4EDBE6B1D7B93E7235C4BD8FD19EE8BCB4';
wwv_flow_api.g_varchar2_table(34) := '5E54BF5EFBC4112C30A4419700E95D00FEADAEC0DCB7D037EBE7FB660124A5D18CC297C2ACF6642997E3935607CF39E67BEF7AE65CCEB11A7F1141DB17F9E66EB695F302C3B7EC4C0A12AC09E61E795B8F4E42F9678E7B66F705C7FCFEDABC593ECF3743';
wwv_flow_api.g_varchar2_table(35) := '10DF960ACC8921D7FCC35B9E393442070029995D91AD366638388AE67EBE33300FADCFD179F459C4B0DE8BEF7BE63BC73C437FB2E5648154AF112951040B38917B1662A5417FB12A6F3EBE346F16B6F1893FCEF91E1DDF272BC224ED9146B6A77DC876CD';
wwv_flow_api.g_varchar2_table(36) := 'A293C6EC4123B7E074BFBE82BACBF3A613E02557DF35B320DB3F64504F690984DE72D931DF3A95325FE1BE8BD0E211544FB2DB33BED9D2E19ADDC38E598C1055D1EDB5977F1E66DF4BC75BD3A58FC28AC4C05E3F338A4B41562FE8AA5C744B8AD73D151E';
wwv_flow_api.g_varchar2_table(37) := 'B3EEF7BDE286E0607BBBCC621BADFAFABA9C79704DDE2C06F02CE40CA355D2BA94A7AFC4869BC7DEA36C8EFC31EA09CCA31C3FB42C6F3EBD322477040DE5CB8F36F811397C7C14792151425E32D503DEC79CEF39EB9AF368AB2CC2454C738A6F0D6FC182';
wwv_flow_api.g_varchar2_table(38) := 'C8C72BD8C278D8CE22173040BDCDA8E81ACCBF4CFE20E5F374C0772FBAE6E7E75CD341597552896F644A8406838F0D8AE4432F73FC35692EDAA7884AE652A6552656A0BF03801F40827CAC7C71373E7905B37B2D1C5FA2CAEFD021EE59E2A3D981B94C5D';
wwv_flow_api.g_varchar2_table(39) := '69A2D2FF61C2FFF7BC6BF304FC3CE4AD809C2D0B7CFB513BA9E56B971CF3EBF8CE9B3AB008902C57B0A613F790F1CC293A40AB64D158EDCE72FF3B30FDCBB000F6DFCC2193CF4C9B77075DF33A32149C29706B744A04C1E0687BFB2110D986CFFC281A28';
wwv_flow_api.g_varchar2_table(40) := '1087214C04C93CBF76C6333F39E19A5701F09CB410A0DBC8EF02C83B216105C49EC707DE87C9EC847469A1862C29883E40DDBFC197FE0FC02F218F0F43DB88771975EFC7BC76688F597F61C831C72079F9BCF09E92B104B95BD9DE3CEF981B680B456DF0';
wwv_flow_api.g_varchar2_table(41) := '24F3BC19FFBB80C06F8C726AE71096E2D0806BCDF3879017F96C8A362C359C60696FE477B760F2EE5B129AD648736586F79C86A0C329F30AD3B31B4158E515E4284A7D0FCD7A14D3BAEC3C41195AF539C815B192CBCEFE39890F7D0AF23ECDEC5F37F565';
wwv_flow_api.g_varchar2_table(42) := '6E65CE15C8FD10ADEE829CE5E4BF4C071341B711D4B5E00A44B0347D2B1DE807E73D1BCD6B283440075B41F91EF233B44FEE2343B9E374BE7D171DB39032882CB641ED6850523B1A9ED4080525F7A04DABD00AF9321194016481F63D22D2D720F73E085A';
wwv_flow_api.g_varchar2_table(43) := '04B01A92C84F4B7B6FA28BCA178A388D454720250C78428003CE6F87B0BF5AEA9B43DCE36D3A845C81ACC28DD4D940DDF9C89239ED61BF1782CEE002E4DBE55B65A6D7E38797739F11EAD9E113F91B89E865E295A20E25F7B15711377265619290788CC6';
wwv_flow_api.g_varchar2_table(44) := '2635C09A3280ECC1A77558F31A022B80F7A39DCFA37DB7418400D6D857E069533D4D4C68AF806829328E12115F864469BE8896962F6AF3CD977A72E69F37E4CDBD74A0B3E489E88BC8E27F6B76254FC4BC88B6CB4CEBDEEA040AC23474EA25929769B79A';
wwv_flow_api.g_varchar2_table(45) := 'CF7E2B6DBD91BC2C6E21CDBD14641D1CA073505E9D4F1D86EA0D4F3113CC939791545A1A2293B914706F60C2201C0E85BEF3323EEDED41822CCA295FA0692FE04A374E21DE316B90F11CE50F9CF52C412D9C8BA83148D024C7276FCA993FDB9A35DFDE98';
wwv_flow_api.g_varchar2_table(46) := '337D37F896B0D308952CB545A6FF24041DBAE0DAF1B1823B99E92E2C472F1D430B78EA60DDE46F44AB355656042F6D7F9F4EF8AAFC37C79295944473E24C82AABCA406886081D60109166CCEF5AFA00C03FE59F937CA4C2759D7C0D9063A1AD2FC2B1317';
wwv_flow_api.g_varchar2_table(47) := 'F2DB0A6FE54BD589343492B67523EC6EC6D6DB36E7CCB736E4AC669EC07453DAFECB179B68C72B1075064D56542CB2A4A19B701F9AD69486AEC7DF2ABAD67DAD96E352DEBEE49A5730CF8A9E93105CD1349B846F8CA9B2BE2B72A4A532B34AD15F99585D';
wwv_flow_api.g_varchar2_table(48) := '1390D74A2A23606F00E013A8DA5F1394FDF868CA7C0051FCD380966891A1E195C6C5EDDCF05E86625FDB94331FC3DC8A64C9905FFE05758ECA4C732E8034B9227FDB83DFDD4B3999673B3EA7C3284A1FE47E079909BBCCFD6505542F2929668205517949';
wwv_flow_api.g_varchar2_table(49) := '644A7B64FEC6D00425FD15B9AD90D08D19C45DCEC8ECA95E44F208447C83E0ECDB87D2E6D9E329F32B8235012F8DD60DA4D1A310BDB1DB370F31A1B2947B293A96FF94AF3D5030D332BF0AFAE43EB628A8A2DE26CC75075A6C8330AE9FC23CEFC135AC56';
wwv_flow_api.g_varchar2_table(50) := '59EE91A444931A9B2CE8007E1E6406C524C9FA5B4095C95ECD18D4120CB66A2CBBF1A4E3688B1E449D45042AD2DE0C69BF20E8DA76C433FD0753E647EF78E6C465777C4E5A01937CEC3AC6CEF733E1A1285B9DA407212F134D7F0071D64C53AE958E2662';
wwv_flow_api.g_varchar2_table(51) := '1575AF672FB3AFB2AA7F84E8F945C6D8D2FE2499674111E1A2E3BA2701242D90593B05D332A7024C045BEDC0B4DE7A2373C5F8CD63F8E34E5AAB6942355A1BFCD9090B4D78882CFEB7CB829AD1D2704624ACA0D0AF41CA5108F8031623FEFE8D94390679';
wwv_flow_api.g_varchar2_table(52) := 'D24C0D6F14252B1853472296B2F18026345EA0BCFCAAE6BF554EC25732C3F5DBF3033BF9A199AE14F52E617A0E103DC3BFBDA7DA90A4249C1A9AA4C1224D81D421001D0030F93599680545EB8856FF6855CE4E273EC724BE96E244A6360567BF82F817A8';
wwv_flow_api.g_varchar2_table(53) := 'A3D523F1B00CD3D905A97BC8D3BCB692C85E05C95F60D6E91F9991FAD9A930CA5647A29AADA7450B7534C9557911B69FB243C8574709CD346375C6D49AFC5007946F3F8996BF4CBB15C1533471A9E1040B1101B31A809E27B07913DF278D11F8029B9DF9';
wwv_flow_api.g_varchar2_table(54) := 'D832DF7C8771EC97BAC3C5050D65DE632368B5130EDF6012E3ABABF3CC1507A6173FF9E744C77FBAD83728A139807DDF0DD93FA7733CC54AD387E9496BD144C95527D25E640DD208054936E2264F84BD0471A7A3689A6B1A16DDC2F04AA0A97DB2368799';
wwv_flow_api.g_varchar2_table(55) := 'F95207D3448BC6DC9297A4242BD7D0244034C9C0AA9C5DD1F9F109CFACD5CC51BB6F340E5630A4F1E8DD90D8434074121F3A5CF0D53291F3991859894F3C0F9B3B99AB16F8B72ECCDB45848FD2598EE3834FD113345E5560B419D9BD90A4A40EA4F5E54B';
wwv_flow_api.g_varchar2_table(56) := 'C83B423994DC067C6A8FDCC15E8813816B90AF244BB388485AF5E49B2F70CF57B9AEA9493D874A699FA4D470820586405170B286D6FC37FEF1A6A39EF9BDF5CC1411B96AB92F8BA995C6DC88895DD496B74046206A9D57E3D433EC05B0B451131B0AD06E';
wwv_flow_api.g_varchar2_table(57) := 'C19CF6DEA8F3505BD551E46FE577259345223BE375E89C679EA5336CE2FE22574956843507B38FE1CF3D4B591BE69A644BEB95B43B4164FE12D1F32AE424517BD54E75F81853E1E92B90289DD2B61A20BFFF816B1E7D33658EA01D9A726C47F3E497C375';
wwv_flow_api.g_varchar2_table(58) := '5FB41102A34D802B60D2A6FA22266D2737F09364A4A0621EA655DAAB2192F2A47D92A989905FF2F6C5F7194E697E3A9A6254F345A666A55E9499C6CF2A8A6EA5BE568DDAE5A0496F125CED46FBA5ED05776FF393F40738E34CD2C5CA926A0A243568251A';
wwv_flow_api.g_varchar2_table(59) := 'F11873D0AF03EC67593ED49AED22E67DA3992E4BA4CA83B3CCEB0548D09CF520C4BFCE82F2F3EFA54C0F439F2ECC773B1153D42A91AF3A9A373E33CCD223759EA23369B17F31372E1DE2E81E22FC18D754AE03DFADBA223E83A3BE804F7F05ADDF8A4C95';
wwv_flow_api.g_varchar2_table(60) := '4D6A8A99609EBE8A24221470C1AF594FCBF42ED42B0C6D369EC27CB6B1180061ADBA28A240555399A798CA3C4CB9F7395E0021EF41DE5F32DE5D9B71CD3AC63D0BA5B9C8F2D05645C243107692326F51E730C78BA86317E769BAEE1FA5E849B48CF89F68';
wwv_flow_api.g_varchar2_table(61) := 'F96E9615755D1643EE42D1FC29E468822432EB51DD24ED6326B8FA471388D26401AC253A69D569FCF0E101A26620860F0B746412DB39EF24733E15754D431DEDF556E341A266D5914CE5459A16D55127B25173C426654A93B23564D20C9756A99424479A';
wwv_flow_api.g_varchar2_table(62) := 'AC75E1F9EA6C094F31131C8250ED334B8AC0D53857186A0D78219BB447F9DA54C66EFCD15EA047A4EBD51ABD23BD5865A7A8230D545260546A96C3DC897FD52944A65EBF2D4D6A83EA6B9FE434A9D9D53635DEC7B5C4D12491A7E3022FB691BA93BD1B7F';
wwv_flow_api.g_varchar2_table(63) := 'ECBEE47A6432A7AAA3CA113193AFEBDAE4A43222599D6D722A6DCFE46B49398F99E0F81FB954E214185B1C4BCB28A3F47CA675AE4548A9CC6B954DD275B99418D3D5E08CF1164D5165211033C1B3B59F9785D9AC2A1C33C1B3EAD9E744639B045FE73437';
wwv_flow_api.g_varchar2_table(64) := '096E125C0E02CD20AB1CB4A62E1B2F865569F0C15DBB4AA3AAF0270553B7BA993B530434615EC2F1248C672A65BC5C5504F7F6F5D9A67879B58AE1A7A68D4A291FBF4DF360460808BB0286054C4D84F18CEA4F51A8AA898EA877F96ECA7702E687C27941';
wwv_flow_api.g_varchar2_table(65) := 'FD4CBEA40F4E71D766D6D408E8356C6108CDF9203C88309EBAC2B573AB22D8983E7B0727187B8769F837D29DE9DED101BD8ED64C9520C062979FE94C7B6303FE1BAEDBFA762823C4B81279AA531D17817DE5D076B9079E1EFD3C0BE8FF92EE68E9AEB431';
wwv_flow_api.g_varchar2_table(66) := 'CD7A2C3D5E1A19089CE00F7FFA40FB7F583C4A30AE049FEA08D61D4B1AF0C0D34377D2671E24B39BE5D7C22FAB2B69D6DCAAE3F39A09510CF1907301DBFC5F3FFDCDF6972C0225D836161135A499E24520264CFF1F84BAA30859208E650000000049454E';
wwv_flow_api.g_varchar2_table(67) := '44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72344100805797148)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/csv.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D000019DE494441547801ED9D79B01C477DC77B6676DFBE4387ADC3C2B2651D96B0A4279FE0933818086027C449194B24247F50A95425842255896D2055A9';
wwv_flow_api.g_varchar2_table(7) := 'B252954AF2478EAA5402A120A91460D9E8093049088EA10AC70EC680C132B68C8D2DEBB0751FD6F1EE9D239F6FCFCEBE7DAB776FEFBEB7D276D5BC99E9E9FEF5AF7FDFDFEFD7BFEE9E9D678C839424C67340665649245BB7FA8969FE7E540BB1666004AE';
wwv_flow_api.g_varchar2_table(8) := 'E7196463CCF0E73E745364A2BB13CFBBC8C449ECFBD5CDCD957B184B12388CDB4DDBFCE366D1155FE8F8F0DFED4BB66F0ECCE69E38EBCF5CE1B6163E6A02B812DCFE7FB9EB5E2F315F6CEF6C5B6819AA89722D5D9A6A5D184C8AC6E4169BB06DD9636152';
wwv_flow_api.g_varchar2_table(9) := 'F8A38E2D7FB9074BCE9907B746E70BC835C1208DF7B6F444C9E73F78E95092FB4E615EBE7BF0EC1052F3E6ACED8EC00F847131F6DB970CB42D5E393F2C863FCC85C16F79BFFD377B93EF01F21DE707C83501D1D3938A6B20F6D7E0F0AE2AF6816D0AAEE8';
wwv_flow_api.g_varchar2_table(10) := 'CEF123F1187173EA41588C7A73F33B6E0E73E143C9F6FB577BEFD91A9A27B606E7436C5113C09BBBBBEDD8EBC5565898844D3A35C191B16B027CB517F60E24B9CEF6DB42CF1B01F92F9A1FE49A00EED9B5CB629AF88CBE925209E114E7E6F89B98588CFA';
wwv_flow_api.g_varchar2_table(11) := '84895ED83F18E5BA0AB786BEB72DD9FE99B5DE562CB967BBDFCC965C13C0990597A0B4283707AC955C2202CF4B7C9FA9002A1AF60D4558F22DA11F6D1BDCF1C03A6FCB96E88926B6E49A00AE1493AE9BD080D32E80AC267A7820C903900700B97023BE1B';
wwv_flow_api.g_varchar2_table(12) := '77FD99B5EF69624B760A702AADE6FBCB44BEB4548333B6C16166C9851B433362C9A66773D3B9EB16C0209A942CB842354B968CBBEEC29263F3C8D08EFBD66B4AD86C20B70006D5110BAE80389DE6117801F2BCC20D7EE23F9C3421C82D80330B1E856DF9';
wwv_flow_api.g_varchar2_table(13) := '66C4923B0BD7854D08720B60B0B4165CC6F49C8B14645932201763EF91A1EDF76D6C1677ED1460BBEA718E7C9A246362E6CB20E7BBDAAFF58DFFD5E4EBF76F1A0199287C8E26A700CFD95E4E45F893335F0699C06B53187B0F0F9541DE42743D3741760A';
wwv_flow_api.g_varchar2_table(14) := 'F054E4D8E4654A20B3E2D551D8E487731FE416C0D3D73864C63C395DD6DCE445DE23C9D73F7DADDC754FCF167F2B2F0E4C9F64FD6ACC2966EAD7CD89298F310F9EB8025328866C9F295498EF2A7417A3E891E11D7F7AFD16407E70E32E4F6F874C46A051';
wwv_flow_api.g_varchar2_table(15) := 'CF9D3232719CD2A82E4DBF9D71E6C1131262AF91513B0958BB06E4F6F526F1B709646BC9730864A7004F1EA74C28B3267C3806C88F3C70832CD93C08FC73C0929D02DCAC166C356B06CCA7552A40EE6C5FEFE5BC8787BF76DF8D9EB7D5EE43CE36C84E01';
wwv_flow_api.g_varchar2_table(16) := '6E6A0B9E01F3AA320A64C6E45C67DBDB4DEC6D1B7E0490B702F283B36BC94E016E421F9B1AEFB99B0D53EECA885E8CB2E4B55EE03F64419E654B6E010C943309B2C6D68012C8D6920BEB4C8025EFB8FF666BC954980D77DD02588277BA0A350272BEB37D';
wwv_flow_api.g_varchar2_table(17) := 'AD9F780F17B7DF7FEB6C81DC0238B3E0B14D7286B92320079D85D5BC4DB06DB6406E01ECDC82339D180199C59055029957721B6EC92D80C1C38EC133982665508E7F1E0D323F9778B8D8F3C0ED8D74D74E01AE8B8CC6975E933C19011977BD92BB878A5F';
wwv_flow_api.g_varchar2_table(18) := 'BDEF971B05B27DB3DF95A446A60CAE283690CEC8A4B60E8D8E80CC4B032BA281A1AF60C9BFE36DDEFA94023C0CC3CF0077DDB853805D33777ED1AB00B9A36D45B17FF8A1E2D73EFDBB0C0F4FEA5DCEC46CAD0BC84E5DF4F905483D7A5302796038CC77B6';
wwv_flow_api.g_varchar2_table(19) := 'AD3071ACE8FABDE426FCA231A9C73CB905708663C3028832C845DCF56558F0978B5FAF003971BBD5E814E086C92803C5D1D92E7434348000647ED9C87E7291C06B392F0D7CB9D8F3A9F7594B3658B243909D02DC50193902D7E8C767FA65439576EA76D2';
wwv_flow_api.g_varchar2_table(20) := '83025919B1935D8F7706543DCAFE20AE2417F60D16838EB6E53CFA5271FBA7DE2F90B513B55D5F1B70909C026CB977C054634920022D554ADCA51FB0A87D29EBA40705B23253A903B22A9EFED1855E1AF0BC7CC8986C2DD94BBE52DCFEC09D7AA23D6517';
wwv_flow_api.g_varchar2_table(21) := '63B253802DF7E26E8EA7518A682D26E0BB1CBC0CEB73F6593D6EE0E1DBB6BC201E2C0E075DED97B00BF5EFC937FFDC82ACA953A5D2CD44AC17E434498A289FEC036A120E067D678F0DF21BF6DE9207B52E342D335AA4595EA6C85294CABC4C71B2BCCADA';
wwv_flow_api.g_varchar2_table(22) := '9579D9F5A83395BDD3A6379F0B960D0D17FFFEC83F7EE4D5657FFCD5DDFA2D9431BC2132C37441029CC90A888D89060AC9506FD03B64920857CDCF842DC05999469D4B60E739B3A2E96FE04B1897D3F66EF392BEA250FA56C60C98B960011EB11ECFEBC8';
wwv_flow_api.g_varchar2_table(23) := 'E7F28AB37A87F9BD3FE214C8A350AEBCCFAEC73B57839095537E763DCE591EA02DF0CD701885711486D5A466727FC1022C616572268E4E0A39DD190B72540259022FA7F4717A9B5D8F772E572A5D64E5749B5D8F71262B66D00DB4FB91CBA7D0649FC9A8';
wwv_flow_api.g_varchar2_table(24) := '2639D57BA741D6541B9D4BE5AC9C896E15CC1402CF9B872D23142F8E8142516F038FB102AAAACF644C5B74173CC0951293C5CA92E717F89603C823F0C6A7CCB21DB5EC14E0D99087233994C95890835904D9B1109D02EC58F9CA426FF4C5AC82EC58884E';
wwv_flow_api.g_varchar2_table(25) := '016E3410F56C6F14C8486956DCB5830EB6009E40886590DB18931B05F25C76D113C8AA691FCD0AC80EA5E5D4821D2B9FC36ED646AA9941760AB0E3F8A036541CD76E18C88E85E814E0F3D582335D190532406859D379724CD329C08E95CFB9EC5C102C83';
wwv_flow_api.g_varchar2_table(26) := 'CC62480EE9398FAE1D0BD129C02E04D80C34CA20135DB337E01E64874268013C43610AE436AD78954076E6AEE7B28B9EA1AC9AB65A25C87571D70E24D3B2E01A855809B2DCB5334BAE91AFAC7A0BE04C12359C2B419625D704722BC8AA01893A56AD06D9';
wwv_flow_api.g_varchar2_table(27) := '79743D43DE5B163C43C18D55AD12E419BB6B1171985A003B14A64895419EE93CB9E5A21D2352077216645E09D19B21B33D4F6E59701D0016C96A906B0ABC6AE0B105700DC29BAC6A25C83547D7933536CEF316C0E308C655F608C8BE5DBB6EB425B70076';
wwv_flow_api.g_varchar2_table(28) := '85E4047452908D5950683CC82D802700C6E523819C47DAF31B0C720B6097284E42ABD29205F698EE5A851CA616C00E8539155295963C26C8AD79F054C438B7CBE843D2A9BBF6EC799425B72C786E833715EE64A4A9256B31C41F0D72CB82A722C2E62853';
wwv_flow_api.g_varchar2_table(29) := 'EDAEEBB141D11A8367591746DCB52C991F33B65CF42C23E2B87979E411903526671F9270D350CB82DDC8B1262A19C85ACED4068502B0B05813C972E50BFA17FE6529CC818B91C00B90DBF88C43CE8DAF6E013C07C0AD6641964C70ED243922E384971691';
wwv_flow_api.g_varchar2_table(30) := '920464BB8E3CB499250BA60B93868B382DF9ADF2574B4ABD3FE734112D4B801A95EE4E74B3FC73888D6458FE2AEAA98EBDADC853694B6B3C7A94ADEEE784E5479A7775353B00FB6D08264F1FAA8455D9AB44DFBE517CC937C0121D5C8E058CDF4EBE3EEB';
wwv_flow_api.g_varchar2_table(31) := '3806AD4CB8E57A02099AF160654B55D7A283630B0AA3E95A5EA85FA655AA16636B89ECAD1A64E8A88F81FA9925B54FD978988CEAF25919B7E75900988E0D1D01B763F444C0A8A3D5E090EF7772CCA708E7001055C60A4665558743C00FEE85D6196ED595';
wwv_flow_api.g_varchar2_table(32) := '8C8E9E03A407482A63F4C9298D469C3D68162E2DDD67E5B92D27CA09CCC17DD03D5DA22B5AF0900818AE2D2D9D49F9E5C6E416F04C6DA85D25E88A9FF02CBEF6CD344B7D4D50AC60093F89589696293DA9E7A9F10023F064E1263AB9900E8F2560F26240';
wwv_flow_api.g_varchar2_table(33) := '097B8D37741441BFC1710221AE28098667D6A239FB79932CBA9567288105321370263281A03C1D123AE08583C6EBDDC3AD40AB2EAF62CAE7138717DF0478F346E85A32884B16AB245AF0EFF51F426151567912791BDB1660460328D262F8BB3E6D47747D';
wwv_flow_api.g_varchar2_table(34) := 'F2D5FED9DDD455D131DA27DB656A1CC012488C9627FD26DA748F89565C6F3C3BD993E02B3AAA8E4B18C501E30D9E315EDF5BC63BBEDBF807BECFB71C7F08C8570228563874C824F3AF34E14D1F038C15086E083AB4A124C50972D43D8E1CC9EBB828A549';
wwv_flow_api.g_varchar2_table(35) := '9EE93F65F2DFFF27E39D7C1E5A8BC917284AD4F1B1F881BD2659F65E13DEF27B26E95A045DAC1637EB1F7EC524F9824996AC262F0539C9E54DB07FA7C93DF35754073C142E555A6885274CF8CE4F9A78F58D6979F591EF40042F7FCF043B9FA66D2CDFA2';
wwv_flow_api.g_varchar2_table(36) := 'AC0ED72F350EE0CC8AD0F2A4F362AC78295EAD640DEADF286B56A71188051E2B19BED178A7EE30C1EEFF43405FC23A004D60FA3993CC5B6CE285B83C146214C0F976FE83334A3270CA440B708B9912752D34F1B26B4D70F47184BC947650A6D49CD236A3';
wwv_flow_api.g_varchar2_table(37) := '033CDF64A2A5AB00965841DE04CB0B7EFE5DF8E837C5955824ED5A90DB0A26E2DEDFFB6EE3BFB1C398CE6E68507EE075935CF66B265A73134A48DB521294C33F79C0F86FA2A472F7D603C8ADD7373510E01268020E6BF386198FD471253A2B6B18497C46';
wwv_flow_api.g_varchar2_table(38) := '59566C3FD748BD5C01A15F89A52E47312E33B99F7C160B667C93900440349CD2B320429FBA4920775834FEBE6711F2DB4CD2C190407BD60A2F793B34B16AB95BD1B0E335E523786A5B65E22578099AF5066803BEBC3347A1F3BFC63BF1A8892FBB0650AF';
wwv_flow_api.g_varchar2_table(39) := '335E51FCF305D38E0526BE12800F7C0B32A5FEE029A2F577DA679686DAA07CB0F351E31DFAA231F33E00FDCC738CF4BA1E57EA5D831282CF9200D5676B14FD2ACA645C0ADE78C1047B9F33C19BBB4C70E43563FA4E023AFA679F03E0503FF76D265CFF6E';
wwv_flow_api.g_varchar2_table(40) := '135DFD3128F521B43E13FC0297B7EF39AC0AFA72C11AE738076FBE6882579F30FEA19FE2964F03B89EA94DDFC48B5600FA0600EDE55E0A01390545C5A328D0F556912C1DF149FBDEC937196B0F5066A9095EF90EC09F31499BC65CD5F34C7CE97A8E3B8D';
wwv_flow_api.g_varchar2_table(41) := '1926781C3E68E295F79A6839F44517859652F9875E36C1EBDFC0CAEF204F0FEC43CEF54DF46A9692ED1F96C6B8E5F79D32B91FFC0363E67E5C19AE5BA0765D8EA06E33E1BA5FC2A55F64C76BAF88C5E07A95E71FF8B0F10E3F6982E7FE807A7F6DE2B7AD';
wwv_flow_api.g_varchar2_table(42) := 'A3235222B95CB0DCF323133CFF71E86D34FEF1BB4DBC74A572F9082543441743C452ACF0D48F787EB10549CF4C7898FC6EFBDC7A06C0F322BCC0C11753F00A57E262BF65823D3798B0FB57A807BD62D1C41A26D6C88ABF8607B8CC446F7F1FD63B9F67F0';
wwv_flow_api.g_varchar2_table(43) := '8B07F051D6DC0B8FA240A78D695770593134596EEBF7875ECD8504DA114152D86FADCA1B3868BCA380F7CC274CFE992F01A0AC19D00150024F3A179A68F5EDDCE312FDAB38088EAA93E6A0398D8958CFC1E7530F200B16C02849BC6C7D5A434301409998';
wwv_flow_api.g_varchar2_table(44) := 'F6838B508475586707ED84B64DAFF784F18FECA4ACE8295AA7D8CBFF69C75359A60D1CA91F5D8E625CFC2E135FFE41948D2120920B4EBD56F0DAD3B8E6FF8695E5D457BED5EEB4FD3AFF9D658053015841E4898C15F4C8A20A044D1DAB7167371BFF953F';
wwv_flow_api.g_varchar2_table(45) := '33B95718FF00D6BA603E03ABF2F1D2353CD75879128071CBD549AE57C0E52F01A067ED389A9643B8E4278B57E22500596E5A0B2FC5B770DBD758F76DEB9580F78FEFC5D2B1E06CAEDB760963F153B8FF27A99BF2E4696CC72BC4EBEE246ABE255510660C';
wwv_flow_api.g_varchar2_table(46) := '1A5254DF7FA907DE89C8ED5C3DE5BF9ADD7ADDCF32C015DD52C0A32047818ACE9A47CA320BB7197FF7E3CC1D4FE0CE3320F9207FFB7C848A4584C72032964590A78505595DDF4B80CCB82ED064559C63A2DB78F17500CB74CB03E0F020A063858A7AA544';
wwv_flow_api.g_varchar2_table(47) := '2881A760F0E02E9E310FD7C28B7853049D5B6AFCD7BE6982C3BFB0E3ABE879BC5815AEB9C54458AF9DFE69EC26B2CFBD24DE511029AE5D0CA9E873032E9D023C969827EE43550D599D0090E5E95A6E13CBF1FAF6222401993ECEE6B949C722049B668FF9';
wwv_flow_api.g_varchar2_table(48) := '3703D4EBC04DEF24D2EEB34AA28F4127852EE6BB1B113A0B2A369ACEE315AE4271E6A5C300D6E79D3D6EFCA3B867AF0B60A55CF0ABB2F9C5F044D0F43201970DE070DF72BD5DCCAB0B7822DAE59F0330477E9E5880C0CACE79C5E144CC8ED9839A339D02';
wwv_flow_api.g_varchar2_table(49) := '2C78A69726ABA1E7B018F733863265B196CA38AC39B3049E6B4FB34A635DDA7646536729100780F8C77E62FC5344B9AA27E0B1C478C91A8602401E3A8CBB5F9FBA6D59A8E8A360FEB13D2CAEBC443B0A8C32704493EBB6554C9D1E2D45F01223ED69CA06';
wwv_flow_api.g_varchar2_table(50) := 'D0D635A390C12E02AB88683FA715311463149FDC36203905585D9F5E9A4A0D091B36ED86424A9DFF72940A5C02B57856D2C9AE752E1D72AFFDAF1AEFC82FD27A960CFF9F81059278D1B53CFB3EE7ABB97F1BCFA9433026F7EA1FC2B5868CF15A0FCFD69A';
wwv_flow_api.g_varchar2_table(51) := '33F2A2AD31D52A4CCA57F92F34349C246D0BA827D055C9325A2ED2A80BA700D7A50B1250B0C04E9552219584A5287588F9ED848DF2B0648D1A43FD83CFE1097A2D2872D386458A64E946C64C8A2DC13D77321C284AD7F879FA2891FCF394C5E556EE5649';
wwv_flow_api.g_varchar2_table(52) := 'D904D6F01E13AFFD888956DD406559377C95E6D91E0B2F5A618BAEFE0DA64597A1244C8F26DB3DAB13E24E019E3E8F63A183A0048A84A62DBB22C1D5451BD2E0470D587CB130960DBDDE4394A96EB59AA62A909802F9C79F33FE5B0453B23A3B5D626D79';
wwv_flow_api.g_varchar2_table(53) := 'F12AC0586DCF5A4E4C032CB03AF63A63B0DCB3822394C9266869BD79081A8B6E37E1860F60A59D764A25D0B5E2A5152BB97F45D6D1A5573127BE1780191A2C0D315BE2A744B1DEA75906B8A27BB212B93C9D25446D28685E1CFED4446BDF6F62A62176AA';
wwv_flow_api.g_varchar2_table(54) := '6403318ABCC5EA52DF6ECA5D55414497990001BAECD6C90B3AEC16A0360DCA168735C60B70D32B3ECAF992B42AE06BD52C75CF6F512F73CF909615B2BE4D1060A2EE7B19C3AF40D106ED986B50B8E0A5FF49158800CD8EC7001DADBF03EF7007160FF896';
wwv_flow_api.g_varchar2_table(55) := '9F6A0514CFF54B7307603B3D42785AF0289E626AF3330079D644D77C9645FB9B910082D198CB1AB31D1FF7FF389D4A1121A763DC1842B2631FF9F206568158C0384434CD2E959DEEC88A71CBF1AA77A52B4FBA6779D43B7DD878C768DF5F443DDAB52E38';
wwv_flow_api.g_varchar2_table(56) := '73CDFB29CF52241B09D6DAD5AC02B2E37B4DF0C227D874803E4BAF5A62D5344BE37AD47D0FB428A759810539534255AE6F9A6580B38EEACC1CD368038131B07D894996DF6DC277FDAB096FB887290D5317ED3C61711A1F7DD699FD7DDF263A26281A621A';
wwv_flow_api.g_varchar2_table(57) := '53C4D2AB9284EC0D6573DFD243C672FF0453177675E4A63D8DE35AD5BA7403513196AA7119A5F08FEEC63D33FFCD0370165CD9B56A868BF9579B70D3AFA63CD9A553A6536C416ADD5B1B49FE5EA64EC7F7C1A7A27158A60DED38C5AB71D543FB6144226F';
wwv_flow_api.g_varchar2_table(58) := '9CD8E1623613E396B5A28B4D78DB671010D18E02957C871D7363F663E5D064098A56B5C4E81F7DCDE4766E431FD8EB5D78AD89377ED9C4CBBB2945BDCC62916CB4F676AC731B8B248FE1CAF741F322AC8A691542F60FBFCC6600AB584200376AF77DB152';
wwv_flow_api.g_varchar2_table(59) := '0BFA602FCF01373E43F955F0948EA9E9AB36A74DDCFD2726BE640D3C69D143632A1F5A39B0CBF8FBBFC12FBC7F9355AF1FB0ADF93463F4E50C1F5A4021E062CE1D6EBCCBE40F3D83D2119567AB62D4AE776A9C2A499859CA8228E569B98FB5DF6805DB70';
wwv_flow_api.g_varchar2_table(60) := 'ABDE61A22BAE2338617746E00A70AD0903ACDD5C3FF873937FFAF3A5A54301960748568F56F08688929D9260855862B4FC2A36256E83367350BD3A2305B063BC7676589BD602850092FB153FB25E94CB3F7508F74CF41C30268B3F6998EA0EBC8A22FDBA';
wwv_flow_api.g_varchar2_table(61) := '09AFBC5543B0E5DB6E2468ADFAD5EFA66D2876685B6D82D7BE8122EEB18B1DAA6D371D96AC34F1862D2818532FEBF22D613DAE6B720AB0FA3D7E52875482431B071634A2589D012A95A49E973A2E774C542B57A755ACDC8B8F9BDC937FCBD4E529568B2E';
wwv_flow_api.g_varchar2_table(62) := '858C5CBA8A539E712D61CF78E4C072B46091DA3FE752BB2A8F9BF64EEE24183A0018521CD5E3D59F022E1A5A9EA2E75E00667124DD2F860ED39C64E13B4DF88E8F9A8460CC52C32A65C1FE1BB8FC03586FFB3A4067A8C833F74519E4B2354C6865CC7A09';
wwv_flow_api.g_varchar2_table(63) := 'BC52B8E1BDB8EA4FE27D0E5A9EC54EBD9353173DA14E5AF7A91200D67B1C2B3C908EAB12970D64B2AE722F6BC2B23DB611FDE3AF6371CC5F8F01AC7674DAAF4805AF377E59D0F7CE1C01DF34A0B10B222223770B70FE5956A814B4694DDB7A0D064945D3';
wwv_flow_api.g_varchar2_table(64) := '44B4FE7E5E0458B034CD57F02677CA1CD93FF0D3B41D2988023F6BDD7D6CF413E8B533449CD8473EE5F38CBDBD27D98F7E8CF229D87688D1985D586B6384402F07B08DA9F801D5812756CF2EBF86F9F877D23ED839B5D4A57EC929C013B30A68EA90D769';
wwv_flow_api.g_varchar2_table(65) := '821777A482B1A08FD1390976F82CE3D57102A8231480CD36AC5663A89E29698D7A887DE41FFF5B9A6FE799998A496970BF80EBF5333DD1DB1B957BB0F925AC113F8E1BFD595A4E2ED3962730EB4729D8D32DBF5CA765C91C4B9D475E30FE13AF95F2D50F';
wwv_flow_api.g_varchar2_table(66) := '8E61DE19D34B77F228E2CB2A2AE5E5AAB90F9EFD3CFA242512C3E2893AEAB3E6D65AD34E1FE861DD925380A7C625BADC2B2BE8A3780648754D091080EC6ED2AA54600250D38CAC8E84290B3EF53272523E75CA02135D8186552AA011ADF2332EB9F7349F';
wwv_flow_api.g_varchar2_table(67) := '3DF15C295FE5A1AFD76CB5EE6CCB53BFDC16E5CF00AE7D3D17F06CA2BC8F3750F94ADAF61920C2BBA7B741FBF69223FA3AB06EBD8FA580CF5A2F59754E4E015617A694344E795A21B2AA7D6E15816713CFE50E2DB0CAC8F2D3A7D662F466646619A56C7B';
wwv_flow_api.g_varchar2_table(68) := 'CAACC94E73AADB110080DF8EE589A6F8B0E53997CB57B6252B66E1A5AD82E751F42B1BCEAE5587F1378F0264FDB475E88FF53659B9FA9E9D025C2DC67159B7D12EDA3C5E3A8750A5B0AB2A09904C80958F2C8D09EAC9C2A53C592AB739561DE5A9BC3C45';
wwv_flow_api.g_varchar2_table(69) := '294D583E2B23DE2AFA39294F19717767A7008F259AF1599D5EE9F1E9E8C94C694DB75EBDCB4FDCCB993CD5C0E52C9595DA19C516A15A25E014E0E9EA77ADCCB7EA4F2E01A7004FDE5CAB44A325D002B8D1126F707B2D801B2CF04637E714E05690553B7C';
wwv_flow_api.g_varchar2_table(70) := 'AE655813C03DBB7655C65513BF1E557BDF2F080A95025587AB643C6D19D404F0E6EEEE74EA1E5B6CEDDBACD3E6A055619404320BE6457A8B7526E35185A67153D34247A65D89EF25EC9166EB49E231E3731AACB48A4A6E568892253295443219CF543AB5';
wwv_flow_api.g_varchar2_table(71) := '59F0E6B4D9C48F5FF77CEF957C9716E2ED6E36EB7A5ADB6B1DD39341124B8692650732A5AED95C92B1AE6792AA5DFEB468A06D1EEBE756D3FAFFF9AE7BFDC0FB42A1435B25A49A284F8B8DF3A370C9E70DF60F9FC639FF7EE71F7E7B873A5629E39974B4';
wwv_flow_api.g_varchar2_table(72) := '66182A19E8FFDC876EF24C7477E279FC0E3389F57A552B4D2E01BDDFC00FD871CAC9293E16F11F6D1FFFAF1FA956A56C27A752C71262A48EE42F48D2AE64FAFF8340993CB1094FC60000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72344504057797149)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/divx.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D000012FD494441547801ED9DDB8F1CC515C6ABBA6766D7F6EEDA066C7C23DCEC0036C1E004271081E210200A128922D6CA1F8004B17194487989F2C0BEE4';
wwv_flow_api.g_varchar2_table(7) := '958724429178084AF025DE48B92021441470943C04212E2658011C309738BE80C1C6EBDD9D9D99AE7C5F75D774CFEC6DA6BB7AA6C7D305BD7DAB73BAFAFCEA9CAAAEEA690B612329256DA8E9A68EB131E5888BE03E9A6D58683ED0F63E8D22A5A2DCBDCF';
wwv_flow_api.g_varchar2_table(8) := '4E6E1742DE2F845AA194F01CE108FE9F5AF2A039A67E96CF536A70A8243E5EB7523C31B64DBE3FBA59B9E34A79E67E522B77071527F3BC08DC7B9E997C40BACE13C5A181151D2C7FA24BD5502D971785B874B0FAAC14855DBFDC2A8F8DBDA00A635F13B5';
wwv_flow_api.g_varchar2_table(9) := '8B057222C0A30751E377CADABDCFAAB54294FF525A3EB0A57C6EBA02A531FD2A11AFB68451465985172F5FE24CAD5F5D1AAECD545FACA9C2F77E758B7CEF62829C10C4B836AAE74D5D83B07C5DE57C4520585367E61738AF144AE826AA56A94E0C2E2F7C';
wwv_flow_api.g_varchar2_table(10) := 'D995D5BD8F1C56578FED90D5B143C2BD18DAE44480B78C8EEAB6D7959291806DB1FEABB7B995E1A55E52215C544A39FD595595860BB72BEFE2829C08F091F171421435175D16B8B006AC91F368B653584C858223E2A0F4E5CFAAB58191C26D4255F7ED3A';
wwv_flow_api.g_varchar2_table(11) := 'A236D29347F5B9DE7D4A4804D878708012212F345BB6F1FAA1255246251D87FD2A593E5FAD95460A5F9195EABE875E9DDE342E65ED6B870EF56CB84E043862A03AE3D9C7B279A4A92AEA48248019A595E573F0E4E1C2AD05E9EEA5271FDAB1A3673DD932';
wwv_flow_api.g_varchar2_table(12) := 'E06CC25CBC54FE733C0231B9C39583700DC8514FEEC570DDB7807D9735E867B5B175C8A521EDC9071E79BD7C3DC375AF41EE5BC00D213A188933B883B5863C833619E17A9BF29CFDBD08B96F013778F0FC63D0A1270F176EF621AB9EF2E4BE05AC3DD8B8';
wwv_flow_api.g_varchar2_table(13) := 'F1DC1ECC073FA6BA27235CDFAC6A95037B5E519B75B81EE7E3D5ACF01E04806CAC2C033616CBC6CD2D5A8A06379E2337CF1BC8E85DCF4CF011AAB85539D5DFFDE0B0BA91C3B4A380AC320CD932E0C52C368711BB74A8E5928619692B3983C190E270E146';
wwv_flow_api.g_varchar2_table(14) := '4F55F73F7CB8AC21EFCC3064CB80BB442BC66563C61A3F5C13F250E14647399987DCB78043C76CBB76F81D2FF6AE01D955F2C09E37D45686EB9DE3E3CED8D858A66C9AA9C2B46DEA04020D1EDC7E1B0AC8CA419B5C1D182E6EF1AA95030FBF3673CBF8CE';
wwv_flow_api.g_varchar2_table(15) := '9DB5239B1F95FAED900465B3296A197083D96C96335D5DF3F5A217B86AF01A8B8BB16B42BEDE1562DF1E0D5902F27866205B069C20F02D60CCAC9EC2DD728CD3C52C94868C3788F6ED3E3CB38D9E2C1E15220B9E6C19708F7A70DC1A84D9330D59FA904B';
wwv_flow_api.g_varchar2_table(16) := 'F0644C58ECDFF5EACCAD63527A59806C1970EF78B09592F2058708643C42C1930B9FC7D17D59816C19705C57E8BC5C43AC69BF931516584346AC66B8369E3C52DCE848B9370B90FB167048085B313A598DF2FE9E814C4FC673F22642DEF39ADADECD70DD';
wwv_flow_api.g_varchar2_table(17) := 'B78001234C493C38D4A28735EB90D1BB26644F540EEC7EA5725BB720F72DE086109DD4830DE4A0D6442197868A572B47EDDBFD7A7720F72D60C344AF6D7970446914F2C050F12AE17507727F03366E6CCB832380390B55878C112F783221EFFFFECB953B';
wwv_flow_api.g_varchar2_table(18) := '74B846DE4E3C275B066C2C16BDD30C6F072135951206BA35640C8670581390AF745C0C86BC52B9736C0CCFC948630A3F7A4B3159569EA6C5EC5AA19325AD4346C70B2F0D6CC0ABF64FED390C4F06E447D1354B13B265C07621A4A9ADD3B14643C67332DE';
wwv_flow_api.g_varchar2_table(19) := 'F1AA9696BA57E0978D7BD1F1BA133F0A51632942EE5BC09DF46053510919FFF9E17A59F10AE1897D8F1CAE7C9DCFE16941EE5BC00D1EDCB06370A4B6F6215FA85610AED7A303FFDB34215B06DC594BD943D0F117E718400AE87801B2BBCEF3C453E878DD';
wwv_flow_api.g_varchar2_table(20) := '9586275B06DC8DC0970073581FF52FD0B4261ED30BFEF0B7562D2F945B243F35D775EBA9460D196F86AC158EFCCDEE57A7EFD6903113357AF020A6989327CB8059FA9E4C0C9B04E4AFB9AD7F0A8B8D96D72DC8F86D70A0933BFAAA45FF11CA5D2764E1A9';
wwv_flow_api.g_varchar2_table(21) := '5D872BDFA40539A76CE339D932605AA6175258113163AF5C477A981810AEEB78D2C1A4504717474957BAD5496F6660D85D8DDF5A3FF9A3379586AC9F95138EB225FF084B2FF09C554656447C8A003F192D5795FBC92717A685F026F4F43DF332D4D27375';
wwv_flow_api.g_varchar2_table(22) := '3CE50193CC315391595122C7B41CF39A6346AEF918CE9B6B44D79FC809B750BCBC522E3FF69D674E1DFDE3B72E7F87EF5DE33B0AB5A8A676B6FB14B06F22FE98B05C130327A7952B262794E7D5F058CAA0167A783BC64C9617D0A52AE28D909AE3C81BA0';
wwv_flow_api.g_varchar2_table(23) := '6B039677B68C0AE57F28239EF63E06EC7B191A5DE9969614153C564E4D802D461035E478064D24E521AA944AA2569DA94A7C4B2291AE40B88F01D30226947A4A1607B449D434207B88885DF064840F0C70792E7D194F51BA3CE633197A27C61FCB9DAC18';
wwv_flow_api.g_varchar2_table(24) := '25E8BA086CC9C6179D194096727008AEEC487C268D11BCA30BFA7BAC717E0A5CAFE93319E66CCBEB1C70D454E8F0D093E59261FCA610A66107A8932985CB59069C42093B69605EABDB90CDFD5A6981F9DB57AB298C3056D5765A59B72047CD67A9776419';
wwv_flow_api.g_varchar2_table(25) := '70A749A478BD6E41B67C4B39E0850CDA69C829B47039E08500F35C27214743F462E56AF1BC65C02954C1166F24D56C9D829C82F92C034EA10AA64AAE0DE59D809C82F92C034EA10AB6C120F5ACB320EB1723ED5D3605F359EA8C9B7B4CA10A1AD5595907';
wwv_flow_api.g_varchar2_table(26) := '90591CC5B16B3DAC69E9BEA36AB2F91C9C150A2997A3C193F1E205F6AD274BAE6739445BBFCDEC2AD4904BC1B026215B08D729D4931C70922AD400192E97862727291F6473C0090DE83F27079EEC26F4E4681B9CB45C817C0ED886218D270F72168A9E1C';
wwv_flow_api.g_varchar2_table(27) := '335CE721DA068D947418C89C6A74B313AE730FB6C9DB40A627270DD7F963924D32167505909D8C7872EEC116D9D65501B22894840F3966C72B7F0EAE9B339B1B0D905BEC78E5BDE86CB29CB7547120CFAB2CDE893C44C7B35BEB5275C82341EF7A8147A8';
wwv_flow_api.g_varchar2_table(28) := 'FC31A975BB662AA7865C449BDC0264CB05CF3DD8B241E75557876C9E9317F0E47995B47F2207DCBECDE24B34846BFCCBD4CD235ED14E56FE1C1CDFCE5D956CF0E426C8D136387F4CEA2AA66417A7E716D826335C4720E71E9CCCAED99106C9853C9905CD';
wwv_flow_api.g_varchar2_table(29) := '3D383BB862976416E4488CCEDBE0D866CD9660245C4B1DAE03C8B907678B53FCD2305CFB6D327FD528D136DB7C33C4523D897F7BB9242D1040C63CB22CA0E355437CAECE58314D0ED88A196D2869EC7879951CB00DAB664F079B60BEF6B3C4FFA444D202';
wwv_flow_api.g_varchar2_table(30) := 'E62359492D988A3C2957AC68CE6C88E62D06FDC9796F14414D27B39E37234E34EBA34C9A720B95A593E732079820185606617DAEB94F1051D8669FC3F5FC42580D27CDD0FD5CD0285BC209F44FEBFA98BF8C1351BD38342B0D408E46623EEAA6DCF46242';
wwv_flow_api.g_varchar2_table(31) := 'C893959429C0B41B5E701133D838868EE405AC8BB0EA5CF62C21DF08CE0D6359829A40101C1BA82033361B122BCA699C3C013AFC46112B04E5D6E362DC9F4B3F1550CF09C89D6A92DB00AB99CAC77C594E99024CA311EE1036EE5EA2B4D71186FEAA60C4';
wwv_flow_api.g_varchar2_table(32) := '8A1C0062BEB370DFE35529FE45B2D8DF88BB1986ACF14C0262E2E9CD834A7C15E7914DC39906B4F767A4D6C3EBCE95181D6E82DCF226B96365A975CE273797AE6E1DCB0C601A7E09881C058D6F03EE839BAA62C5003F3528F1A5DDD9E6A902D004F29E03';
wwv_flow_api.g_varchar2_table(33) := 'A4D35352BC714E8AE7CF39E26DF44DAEC55DE1B48649BD9F6267F73A4F6C5F551315E82BBA4A9C9A94E2B1A305F10E60AD0429C23489E0AA10C46F07C5031B3CB1F5D250EEF4A4237EF666419CC4B5479AE48C7C96D699024C906760D84184CECB00F912';
wwv_flow_api.g_varchar2_table(34) := '2CD330243EFE1A0CEE18D2FE6797D7C092F46E7AF9ED007D17003F7DDC157F06ECAB70670CBF15C02D23DF8A9212AB972A3183CC25E8A74C118008524708AC9B13CFAD44255B05B98A91C3E706A917C59AD51434CB67613F3380690C86DEA558D3B0D308';
wwv_flow_api.g_varchar2_table(35) := 'BD53B02201E313BBDAA8AE430AE693CE52D4008F79593196A351FED2EA9AD8300420C75CF1E4474E1D32C5F0D151E89300E5C39D862783950ED7BCF65C899E4C39962594F3CBC9732C4DD653A600D325182A693C7AADAB17290A38C0907A12E11159B487';
wwv_flow_api.g_varchar2_table(36) := '2F2DF81E3E0CCFAC0296EFE952AC5DE6899DD728F169A5289EA627C35B098295803AF577A18335952D06A9598E958D49CB717331053A77F7FE640B706007DF66FC4CA41F9A1DB8E0BFCF3AE2A7EF14C46580CD4ED852B4A3372074EEB8DC13375DE6E9B0';
wwv_flow_api.g_varchar2_table(37) := 'CB703C5991E2721CBF6F7D4DBC7CA1A03B624B7D26D06EE0040770A1FAA9051984720D3C1B761654D0B5937496ECA406836127D8A779194ECF122016F69EFF83CED1AFCF38E2C76F17C40B6877D9A616909122559CBF76B927EE18F1C487D80E21060A8D';
wwv_flow_api.g_varchar2_table(38) := 'E296EF3CAE5CCB17482D63B6008724FC1B8EECB3637305C2EDA5EC8021EEACC3F2450CD74E01E0E31FBAE22D7878015E4D912A3EDA3A545462D3B0D2032653A8147E64350ACDBA55BB9AFC7EFBDFAA5416F2650BB071146399609F2B76C026B17014A90C';
wwv_flow_api.g_varchar2_table(39) := '607C8EA5376FC4F0D4EB987879F96347B0E3442FD69D27ACD7A017BE1615E213C8F888B0A1935907BB8BAE4C7EBFF75E0F2D8BCA753F8365C0C610316FCC38CA5CE238C7C272A137B2F303E7D5C17625B68FA113761EA00B68AF099879F868C467D5FF26';
wwv_flow_api.g_varchar2_table(40) := '2C5643716CEA6A509CCE8E65C0B06A0AC9D7EAFF35F6E59A47CC152FE0718ABD698235E718D61B873A4D6EB36EB7B0BEFEF0AAEDCA773EBF65C0C6FC69DC48447764D35C89600D5C738CD910C523C9089A75E4544B9B7D1FA2E37A4660DD79EC1E3D6CAE';
wwv_flow_api.g_varchar2_table(41) := '60D604C850BD129DAA123A596CAB596BB9BE80018A0BC87099C91C5CA69F56D97A0E6E0611ECFB2B3E17FBE1976BF35844585338B0092358231CF4C03FB5C0F699E04F618CFA14E8AFC63E65C2D01A28C611FF78B8D6D966FD09F3FBA7C27D236F44C233';
wwv_flow_api.g_varchar2_table(42) := 'E64877D79643B4CD9B094D4523122FDB53F692B9708A903347EC41DF8EDEF2360C7670C48B43972ED61C5E7C6F428A3320CDA9417A74736245A04E74B4F59C2F6B3B17B6DDF8BF0E1F9B41F21F9338C2C632309F91D1E5422ECA652965CB831B2CD34804';
wwv_flow_api.g_varchar2_table(43) := 'FFF08D0EB74B90074EAA073D5E82777E03CFC20F5D5913578D702201272056444FFABDCF1CF14F0C55AE016CB6CDB312F2E9912F54008E8CB1629804711D0142319EE41E9B004C31A2007CB6D6E3E64628903795C31CEEF63AC38009CBB75A605AF11136';
wwv_flow_api.g_varchar2_table(44) := '08B804209BD0E67E176179C71A4FDC7089A7B3720A9133515300FDF753AE78795A8A4DB8C3E338DE98A017D431AA29CEE0045E5415D17718A15EF085025ED74FE116F7CBF0E0B338CBE94DBE60104DCBB063DE1C891EEFD67686011302CC82A5068FD9BC';
wwv_flow_api.g_varchar2_table(45) := '5289F1EBABDA1B190E39C9B01AA1992356159CA737122EFFD1D67F1C2F88BDA71DF139EE23B113E6278C74012CF551EE87D7D4C42E9C64A866627DA2B7D30B0F9D72C4CF3178E2A7408E2364B8EE4F36D6EAB358468E3AC8FAF9938EF8D3A78E58836B87';
wwv_flow_api.g_varchar2_table(46) := 'D70DD474619539C011936A83D3E8F4CC359840588F992293684C866DBE104020CB008C9E4BB88F7FE092332624FC112FEA647E8657EAA3E15919BE70A987FAC3334CFE16FFB22D7FF73C66AF70392DC77394C332088B6D5D65E47061E4E0002967AA58BA';
wwv_flow_api.g_varchar2_table(47) := 'A398933E8EB0C0A154E6EF76B20C38F91DE19F01D58F3925348403FAB18700CDF367682E9A564F27E20E089986FDDB0957ECC33C30C4C44A00E46B3DCC47A09CDCA73E56866829B9CD3CFA282A40B053CFC4E68072AC24D114CAE168446164339ABD6BDB';
wwv_flow_api.g_varchar2_table(48) := '9601FBA68A733794E410E32A6CB00373028F385CFBAFEC44FD0CF6443E768ACA783D878F426F061DAA97D0E65E09B0F45CC2C54AFF637188E4E20C669F8E633E99D180F20CC558E9644AED1F478502CDB3E8857308F423E83C7E2190436EE635721466BF';
wwv_flow_api.g_varchar2_table(49) := '9A729C67A6077F8632518EC7B2902C038E7F57341C5F9663BBC9F7A47E81F7A5F80843E875AF0A36798C930D9FC273F9B6E447D8E660C675B81BEA319E4B8333AD00B03FFCCF117F45BB6C8EF138F34693B9148F7F0C50DBA0EFE071473C8376B51539EA';
wwv_flow_api.g_varchar2_table(50) := 'A2DC06DC038A9589641970B27BA211D981A2E71EC6E4016CE57B61935A0260C864DE655856E12ED8C9618F963A783E9AE8C91FE09DAD09BC9CD57C2E9ACF6C13342B05DFCDE61B947C7D773139533928C75778B99F856419F0626658F896296D20AF41C9';
wwv_flow_api.g_varchar2_table(51) := '5AD1C6FCECCC98F7A1E792A1B139ABC4D0D96A6213C0B67B39E42E8921D78648AB458A95CF32E0E4F59686A11686D95613651633286145073316D36D74C6955B4C7FA7CE5B06BC98995BBF2D7B9AC26BC6D519572EBC72F7B610806CA636DCCEE665735D';
wwv_flow_api.g_varchar2_table(52) := 'F35AC032E05EAEEBF3DAA8A74F5806DCD3B6B8280B9F03BE28B1863795030E6D71516E59069C77B292D712BB364C04F8C8F878B457C539B5E4F7D7EF1AA283E4B045938DDBB64E22C05B46477575736B9AAC3FEA9E336E1B425D80B6D3331E18A2F56D2A';
wwv_flow_api.g_varchar2_table(53) := '8C8DEB79DADC4834D0616A574D2985D914FF95467F7AD46E9C69F3A67A363B6DE74F4329DA94F7616C1CF79E12011662545F17BFFE7B17C3FD6F15878B5BCAE7F8BE449EE25800D3D15E69B8E8CE9CF3DE729C41D894C9B7B1BFDDFEDF642CF88A043D17';
wwv_flow_api.g_varchar2_table(54) := 'E99E67261F90AEF34471686045FBC5C8258C052AE7A7CF29A91E7CEEDEA5BFD7C722363679DA592703CC2B450A70EFB393DB31EC7F3F0EAED06FB038899AF876EEA3A7F37A1E5E01C25B3FB0DD59C4E6A79FBB6FE98BFA8622B6EDEE0DB22079B26B014B';
wwv_flow_api.g_varchar2_table(55) := '36FD3FD5DF5DA88C0D16B00000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72344916606797151)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/dll.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D000017E5494441547801ED9D796C1CD77DC7DFCCEC2E49891475529628D9962DC9B22457B65B1F09D24476EAA3296A047028B468913F8A184D2CBB4091B6';
wwv_flow_api.g_varchar2_table(7) := 'FF9A05DAFE19A045DB1875D3A6A9252B66AE3687E5A468DC22B5DDC0B123C772235FF2254BB2649D14AFDD9DE9E7FB661F39A4487AB93B7B50DC27CDCECC3B7EEFBDDFF777BC6366684C1A218ABC34C83492467F7FE49B4BA01F537998991A31E77B31C5';
wwv_flow_api.g_varchar2_table(8) := 'F32295BB6BFFD8CDC614EF31265A1A4526F48D6FF4BF6621847285F4D5BE308ADA3B73E6E4DA65E691FE1BBDB7FAB646C1401485AE3F356B771D0957A7790970EF7C72E8335EE4FD63B6ABBDBB8EEDAFAAAA2262D99D3566457B61BF670AF7FFED8E8EC3';
wwv_flow_api.g_varchar2_table(9) := 'FD3F8E32FD3B4DF15201B92A80FB1E47E27779C5BBF6476B8C19FD51AEBB6DDBE8D9913C442BD4ABAAF09A5361DAE815D0E2EE0E7FB8B727D715E60BCF16C2CCEF3E7C83F7E6A5047295400C58A686E1F05598E56BF2E7F306632D9A4D7FA0BC9E898C75';
wwv_flow_api.g_varchar2_table(10) := '51C57C61B06D49E6D6C02BEC79E040B4A1FF36AFD0FF94092E059F5C15C0DBFAFAACEF0D3C4F9640BED8FEDA6B5D35F131DE52630284D21B395788725D998F46E1A5057255001F1C181088A618306441852DC01672C5367798686644C3B138B47EF45CA1';
wwv_flow_api.g_varchar2_table(11) := '88267F248C0A7BEFFF59B4519ADC67D3E6EF2CA12A809D0697A0C4E44DB0ADB9E18D4D4BA28D91E7FB1A5779A3E70BC576CCB51714F6FEE10B239B063CAFB8F3A9A7E6ADB9AE0AE00483C631BE38AE3963A688A2B544069869AD377A164DEECADC94F182';
wwv_flow_api.g_varchar2_table(12) := '3DF71F8C363E75DB6DF356935306B839C1FCF056C5F3780CB17047954BE61A90BDFC8426CF4773BD60018E55D6417F918F1D0739D7693579DF03CF8D6E91B99E6F202F58802799E8D24A9C83BB74B6208FE19331D7374619FFB1075E9C7F202F58802769';
wwv_flow_api.g_varchar2_table(13) := 'F0CC6BD0139ADC95B93E0A057234AF3479C1026C35D8A9F1F41AAC899FC2B82663AEAF8F8AF97D0F3E3FBAD59AEB014DAF2E32EF2503D01CA79401761C6B8ECE7D682B26A9F134B995EE4066743D365828E6966477147DFFEB7F7420DAAE65DA3E408E9A';
wwv_flow_api.g_varchar2_table(14) := '18E49401FE308E4DC3C4064595DDD2898CE29537A6C590AECC7616431EFBFC81510BF2AE26063965801B845605D556686B62730DC8D9CECC763FF29A1EE4050BF08462CE593AE2819746D79DD9ED41E4E193A31D32D7BB0606FCFEFEFEA6E269533566CE';
wwv_flow_api.g_varchar2_table(15) := 'ACAEA2C0240D9EBB0F05E4C8C72717DABAB2DB423FBFEFF33F1FBB6160D7AEE2C1AD0F79F6E9902ADA9666D194019EC4B634DB595B5A338DA267A9B5F4184BC0DAB540DE1218B3F7410BB207C8034D0372CA005761F8666166B326D15BAD7106EC425990';
wwv_flow_api.g_varchar2_table(16) := '798268EFEE0363374A93CD43C6348326A70CF03CD5E04A2588DD330BB217839C4393D9B078ECFE17C66EEAF7BCB019404E19E0F9A3C1A9B4540F382440660A8526673613BBB759404E19E04A55A1FEE526D99AB90FB2261A6C41C656CB5C3B4D5E92DDE8';
wwv_flow_api.g_varchar2_table(17) := '7BDE9E660079C1023C811057150CB226978FEF1CC8D264E6C99BA4C9F8E45B1A69AE172CC0307F2254A3C11354ECB2E638C88CAEF1C91B4DE43FB6FBF9FC471A05F28205789289AE56831DC825A999047267B021F2A3BDBB5F6C0CC80B166087893DA7A5';
wwv_flow_api.g_varchar2_table(18) := 'C109A2E3206B31A4337BA509057254774D5ED8003B354E4B8313006B17CA82CC3C592B5E390B72F1B1070FE47FDD9A6BF2D6639E9C32C08E63C99E36F175C9A4D6A48525DA93410EAEE0C5A73DF8E48FF7F7334F26F447BCF456C39032F15A722C5D2ED4';
wwv_flow_api.g_varchar2_table(19) := 'B3A5E3206BE0B538586F7CEF51ABC980FC1043B35A829C32C0E982504B6AF5B6351664E6C93CE36541E6CDC63D0CBC3ECE4B21517F0D415EB000D753839DA00A64FEC53E797176BD09BDBD0F1CC8DFAE7978AD405EB0004FD2E049370E8E9A9D63902F14';
wwv_flow_api.g_varchar2_table(20) := 'F2B9CEA09701FCBFD612E49401AE2FA7D283A0EE0FCEC98064185D0BE4B50279F781FC276BA1C92903DC08C35705CC13F268DF40B39414670F7EF4AE55D987CA7D487E5176B4B576ED405E1CAC6517EA6BBB5FC8DF61416627AAEFF1C7D962AE3EA40CB0';
wwv_flow_api.g_varchar2_table(21) := '5A3F2F83CCA6008ACFBAB6AFC27251F6B98C32B10F8E692ABBFD6FB2F13C19903DEFD1FB0FE4EF26C9684F398D7972CA008B33F3214C08226A1405BE17B2FB6382C00F3D9F4DA1BA1E3CBA17F02EE35038D6D615F4F0AEF557FFF8979105D9CE95AB5C65';
wwv_flow_api.g_varchar2_table(22) := 'ABFE232CF301CF8BDA2841E45304BC323A5A888253A72E8C18130EDAED7BE595A995E65A7BAA08175C9C1364094A22CE96535E17E7CA4D8D23DDD5913C9FF206834C76757E74F44B9FFEC1F157BFF3A9D5AFEBB96BBEA3504C529ACBF502053866915E26';
wwv_flow_api.g_varchar2_table(23) := '1C2D9AB6632351608606A3302C322D95519BD0F0B930B3BABC80EE45597C31CFD57BD7426B1DC7EBDBFA4C147F28A332EA0B18E058CB70BA5E90EBC84668AC373C08B6AC205A902B636855A542AC4A2E678A85B182C7B724AAA2552ABC800116079C290D';
wwv_flow_api.g_varchar2_table(24) := '232FDB6659128D007288456C8026633E58E00A03E932036CDB1EF7990C7B53C14FCA83AC0A5AD0F022F052CE97C10C207B5E7B27AAEC7B7C264D16BCAE07E33D495C1C4AAA37E533192EB5EC730BE024AB18F04893BD8E2EDE2984351A00D533D4A0BA94';
wwv_flow_api.g_varchar2_table(25) := '01AE410BEBC960D5D568905D7F53F1C07AF735D530616152255B6F628D0239C9BE94464729035C6F246A585FA3404EB94B2D80676368BD41AE81876B013C1BC04AAB27C84913FD61ED2A333D65806B20826576A4A6D9EA05720DD89732C03510C19A2237';
wwv_flow_api.g_varchar2_table(26) := '07E2F500B906EC4B19E01A88E01C30A879D68B40B60F46A6576D0DD897D260DCF5B10622E84837CBB904B29A1369EDDA2E6BA6D4EF2499E69C07370B0A356EC7244DE6C10BEE530F29A95ECA263AF56E362F410B72AEB4AC29905330D735909316C0D588';
wwv_flow_api.g_varchar2_table(27) := 'D0249051B95A687235EDA36C0BE02A1918CF934B9A1C54A9C9491F5C6DBB4AE55B00A7C148A7C9EDDA8592265768AE5B263A0D346A44C381ACADC6A079CC754B83D3C4DB812C4DAED65CB7A64969229322AD12C87E9368724B8353C4769C14209B4CCEC4';
wwv_flow_api.g_varchar2_table(28) := '205738F06ACD83C7D9D99C1793402E73E0D51A4537279633B6AA12906724565942CB4457C6B7F24B8D83BCA434BA9E650AD59A2695CFD7A6CA6941CEE293CB0039E586B734386586CE486E1C64374F9E4593672432F78416C073E759E52526996BFE32F5';
wwv_flow_api.g_varchar2_table(29) := 'D415AFE420AB350FAE9CCF0D2D394993A7809CF4C1AD69524361AAAE72696E463E59E63A01724B83ABE36BF39406C9D934590D6D6970F3C055714B2E023961A35B3EB862B63657C184B9F6ACB92E81DCD2E0E6C2A9F2D6C85CC73E596F357AF8E6349F0C';
wwv_flow_api.g_varchar2_table(30) := '49494E2AEF5EABA4385002997D642FC3C0AB887D2E8CA5C29A16C0A9B0310D2293075E61BE05701A5C6D3E1A72C17AECA723FEA444B50D6CAD6455CBC19A9417CAF9542837858956774A63C7193B8501B3C19D67CC384342927E92868B4FC6CD4062DAE8';
wwv_flow_api.g_varchar2_table(31) := '99CA2B5E87E8564A7BDA0AE718D95080C50099907638A0B36356B20F628EE2B534AFAF8115B971CBF4E5304E65952FC78F3AEB68E9AC3A7588DE58896E3934C96EE9F0AC86C952C0D1104D05D170873CA9DADCA8D05080C598029D7F9B41E339CE62D674';
wwv_flow_api.g_varchar2_table(32) := 'BC90375A425A27053A38B771681D204F662E670CA2256055CF19A4E308480AC86450F91E32AC062DD5AF74659989AED2444F4239CA8DDAFE017495DF099ED2956F11916BB869E7D07D2342C3001643046E079DDFD91E592638062519A1C51E31D20254F0';
wwv_flow_api.g_varchar2_table(33) := 'CC2F60A8E236D1F22ECA2A8DFFD30222104E03EC218E1D3963EE591C991EEA5A42597D8C6A88F893A8D81BC39E797AC4332B89EB254DED22E9229AAA4702238D7C09172981B8097A57B41BB33C1799457AFC8A3CC3143E473B8F43F3F098670A742C435E';
wwv_flow_api.g_varchar2_table(34) := 'A5D53B340C6075F8048CB81A06DDB7A96056731E2D7AFC39838B599087418330EC1CCC7A7FC8332F9DF3CC7F9EF5CD2198BC911E48301C2062A24888F96F90DECBBAC19F5F169AEB978766CD22042913990C82A13C026A8C82A700E2FFCEF8E689F77DF3';
wwv_flow_api.g_varchar2_table(35) := '13E84B78C418AA1C07597405EE39F21FA5C2BEA591F9D8CAD06CE80A4D775B64B280EB40145D819AA73F2F7CE09B47DE0ECC30F7B23E6A673D43C3001683650E73307B25E0AE82F9637046DF00153393DF04D3BDFD229918C4CD4701FA9300FCBDF702F3';
wwv_flow_api.g_varchar2_table(36) := 'ED339EB99A5EC81F3A9005EEEB807B7B57647EEFF2A2D902B8ED019F19A36C51DF1AB315C442B088B2CBDB01AA3B34D72DF7CD66C0D80328EB0418341DC802F724157412FF97D0BCF5B2A2590EB01248BE93C777D3C8ACC0BDA54FBE8E8ED05A8945477C';
wwv_flow_api.g_varchar2_table(37) := '2C906716D357590765A9576818C0E2B1CCA4F83242E747E0241F06B59D9786051CE29498A18F3817F9F09C98238676636E7FADA768D6A33DAB0F67CC97D1BCCDF444B404C46B807BF7122CC3C68205AE00FDE13C9F0B8666D677DF93D3572A23A3B45168';
wwv_flow_api.g_varchar2_table(38) := 'ABCE0D4B42F3D98D68A397315F39E19BABA0A966487864EA5770FFC5AB0AE6A6D52171B1C5E1F392B1F62240BAB64185005D5A2C0B21C1523F94AC733D43C3004E763880D1024E800B0499E1F72EC480B471BF08B3BABC03DF899F93D99330E8FBCE97A1';
wwv_flow_api.g_varchar2_table(39) := 'F5F76E2898136359F34D34793BC0BF0BB8BF8245F82CF157A19502568C6FA3A762F6EB68FE517CAE2CC16A7CA78464316912AE21F2CA9ADCBBA168DE1BF5CC0F71059B30F1E7010A19300F5E5930B7A0B912B621DA91A56D39DA7696BC472FF8E603CE72';
wwv_flow_api.g_varchar2_table(40) := '279DD05B8676AF63D551A6DB09B2FA5CEFD0308025CD0A3AC77A8A66719D41C35E3D1398FB5E0BCCB5B44E1AD985766C01CCDBD09C1DF8BD1C4C1323055E0FC0DFB3AE689E1DCC58FFC83BF766D7DAD06C5C1AF22D68C0E55E7EF703FCECF7DFC998274E';
wwv_flow_api.g_varchar2_table(41) := '0284B48A78BE4A69EEC07C7F1A93BB7631F9016D88326BB8FEEDB545F3DC858C1984C0498EFBA8FB160E7DC2324F79B541349E7F3F30DFC755BC84409E269F4C7A07C772EABC0517B11C81514664CF0A15A7BA0619938684C9D22C56E9888334EE5D9835';
wwv_flow_api.g_varchar2_table(42) := 'CC21D3F81A9AF155FCE29FBC92313F3E12C0A828D60AF24913655AEF04D0FFE0B3DEBFD119991D2B30A1542021C821301700ED9B6F66CC17DE457BD1704DBB505E3344FA9F1EF5CDBEC38139431D39E7A789DFB22C349F80EEB3E4DF84E5F8C41A3E2C4D';
wwv_flow_api.g_varchar2_table(43) := 'FA186932E76AEF33C77CF367873266DF69CF0A0DCA6E1673A84D6F314EF80784E92B807F0EC1D15489A2750F0D0378724F05F704E40267071AB28C6315C75A34F97A544003992F31087A9511AF345D0332994B0D94B6E073156EC02CAF406BE45BADD9A7';
wwv_flow_api.g_varchar2_table(44) := '872F211CFF8C4FDD49BECB4141533331BC87FB3BA0FBB553BEF90579444F650AD0943BD80A4D69F0ADDD111A0E4DE249B675BF79CE377FF7A6C0A34E68A89D1A44897637D79A6E5D4B5D5D146804B09619FCD09C660802270648ADD195163E34CAD63C77';
wwv_flow_api.g_varchar2_table(45) := 'B87416D3DE41A39E3D11A049F86898276D11D89ADF1A18BA16932D4DD3804CE932BB3F074059038D8005981648942EDF2A5046391FC4375FC0E48B56917B955D8F5BD008EB6AAC82CCBC8B97657801EDFC2E667F33750E914D6D145D1D6AF748E95A5327';
wwv_flow_api.g_varchar2_table(46) := 'FE372CA40C30BDAA384C66831AA6181DBA86A716CC65DC1C6610366C075A44129447039EBB19D874A24DBAD7C83500AC732C64BC0B1032C92E38BA3A4B9C04E651F268F0A66BF542DADC998DCCEDD0D380497915CFDFEB308308C22F077DB3953AE5736D';
wwv_flow_api.g_varchar2_table(47) := 'BCCA4C39B8ADFBBC577526837897625017CB0B624A25410DBE8059D4D44AD31CCB5DE204884CAEE6BB2E28EF30FE57AB601AACA97513A9EE1A4BA07CE49109B699444019B95D85E62E414B5D90099755388E25D1204D82C769C6305BDA8C85524C4819E0';
wwv_flow_api.g_varchar2_table(48) := '24FB666FE5C51D9FB96C3245D702C42F41E5D23430D3B5005070F153AF6DE2941F15517E69FD7828D1515D9A3B2783EEC6819D9C94CCD614D729037C316C33F5722E7C715455064533DD685407DA6A171094C8A1458513D8CBBCB4308EB220C87776D34B';
wwv_flow_api.g_varchar2_table(49) := 'F9469577B45C1E9D45B31D24E57F93A188A69E2751236717944323732D7AC8EFCA7234734819E04ABB2A2E394EC56731D21DD24EC56AC0729AEBCD2C4EB4C3602D3B2A5E839F334C4BF633D5916F5639315E4B884BF0A1BD0CC098418D07A52BB8B35DF4';
wwv_flow_api.g_varchar2_table(50) := 'C0CFB623389AE7AAAC84E734FEFB65FCED790E1744B30B9A9B18551FA45E997EE1EF68299FAEDD7DA319DCB0FA275826962443CC1AED0481A10555530F8D76B504F9AB4C626F66B12383FF15B09A93CA1FBF314801D24F3258922F8DA73BCC79F1C9DA68';
wwv_flow_api.g_varchar2_table(51) := 'B0236AF22F223FFFAD6068FB51A35DE5BD8E79B406551A212BAF2CC1DBAC4E694D5B9B111202E5539DD2E01B996BDF84401C237D0974247CA2AB43D76ABFDDD6A41C451A16D49E868418C6E9ABB6DA0357EC1489F351B4F25BA8E05A18BA9BE5C2F5AC10';
wwv_flow_api.g_varchar2_table(52) := '0900699A46CAC75845FADFB331875FE4AC91B346D5A2238DBC0E30FE6055687E44BC005150FD27A1BB7FD498CF21305A21537E01290005AA76AD145EE6AC654C37C296E5D884407C9115B0C3E47F1E1A9A86C9D4ABFC08D76F51CF33D437449C04B551A1';
wwv_flow_api.g_varchar2_table(53) := '6100C7AC9BBEDBF0CF1C2549CCD15FB8DF84F9FCAB9ED0FCC535F142BF4AC9E76AB950DAFB5FC702F334EBCB9F42BBF7339FD5428846D8D23869642782D18760FCFDBAD02CE7FA08481CE5D0FEED5FF786E677587B5E8AD91D83960591720758F8F86F04';
wwv_flow_api.g_varchar2_table(54) := '6727F1DA9A7C83850D0993DAADBAA5A5B7F516CD3FB1D5790F0B211236D17D8F34BC85B98EF9783F4BA65F6019B58B718004A011CC6EA47009A78B82CCEB66B4E3A9ADF1FC54206955496BCEB1098D17F43528921EFECFD18CF997E3BED9C0BDFCA1F68D';
wwv_flow_api.g_varchar2_table(55) := 'BFCD72A6B4BC9735654D93B4C9B09205E25DEC04DDDAC3B409ED54D03EAEF22D06004D7D14F81B685640BEC512A66661CBE0905CC3F7A07939BE5F73E211684A70B4D5F93140D4B2E6B1211653C8272ADA605886DFEFC54F1F61CEFE6FB44F8643C2A3F1';
wwv_flow_api.g_varchar2_table(56) := '443D43C300563F6396C6A654E65171D28ED5AC2069F13F0E712E993E8120262D068461AE7FC23AEFDFB05C68D79661B6569436A0A14F9C67A789F5E5DFDF180B860019057869FC3580E182284BA0942E5FDE06D0EF9CF7CD1EB6209F03982BE18E7CF43A';
wwv_flow_api.g_varchar2_table(57) := 'CEDF61B76AED9B19D387907451BFDAA24D0709600FC2B37A51D1B65F34E3BE401309D192A94095F672AA7B4819E0F2BB2046D8810B672DF26B3024C415AFE028C5F7B136EB037232A3AF61326596F7B00FAC624B014ECB830AA2A9A73C1E65297134CC98';
wwv_flow_api.g_varchar2_table(58) := '7BAF28DACD8836F248EBB4DD98AC4302B308C034157A9132FBDECA9827F1B9574003FCEC00494CEA05A12FB3B9305ACC98DF5A5F34BD9D216D8E05329E9A4DD0553BECF880F4785FBBD41FDAA666BAFA95AFD6416D4F3194DF74E9917D708D8B63767F36';
wwv_flow_api.g_varchar2_table(59) := '36A5D20805C708694301A72C0D3C4EBE4380FB0C03A9E730B397C340F95181EB6A1628445980BECE1AF4AB68E26FE2BFB7A3B93D58066D4CB820CD3A87ED3C76213007C8FB5D36240E333012B8AA5F6D145DAAB63EB717C20F23542FE39BEF60D0760DAE';
wwv_flow_api.g_varchar2_table(60) := '6415AE4334956F3C3F17E7A17B7AC4373F3D19EF26E9013C974ED6BA854477D3A8536C292F68B17F295A718411C9C3AF65C6E793AEB4034C20C84C9EC18C1E87D327E0D20A12F50487F224C15559C53990F528CF2BCC8D7FC60ED416B4EF5A4C690F3E54';
wwv_flow_api.g_varchar2_table(61) := '16434F5C6879F228E92F23389A0EADA43D5760E2D5B62418A26941E62CEB20F3FDF45B81B9063FBD9945EE1EC6087AA040412E4673F1F7E8D7AB08E129AEB5D0A2419968D63B949A55EF6AE3FA641E651A5F8261288E0567BA964823C5A0C51CAB68B11D';
wwv_flow_api.g_varchar2_table(62) := '1D4F0121598E6CE3E6750DF95790F73802F2CA5984855AD469A22CC3B5392F00049CEA90C0284D349241F70299AC663D79B50325100F698A446EB5D1D5ABB3F68535CF166DF553341B11D4D71483BA567E50A7ED2085569453521A201FAB6547E59FAD8C';
wwv_flow_api.g_varchar2_table(63) := '4BD35C5ACCD77EED4A0E379823CA96772E415AABBCB3D1551A596C3E0983363756298E48C5BB20FF2B415070D620BEABFF6FCA0027BB597E67DC00A99C12B301305D79E597C996604C575600A8D5D3A54D474F71CA2B6D56D9E9CA097085D2C9E68963EA';
wwv_flow_api.g_varchar2_table(64) := 'FF9B32C0EAEEDC4365A5CAAF2749DF313D593A999E8C9FED3A59663A9A2A9BCC331BAD5AA6394B92521D33753525F22D3273E640CA003783CCCE99079774819401BEA479352F3BD702785EC2567EA35B0097CFAB79993365805B83ACEAA5205D1E5605F0';
wwv_flow_api.g_varchar2_table(65) := 'C18181E4A82ADE14ADBE870B9B82564912184FE1F19C795315C0DBFAFA6C5382A25AC5B44F33FC24E4736ECE022F20DE957858E2A9713CAE9433552D7438E90AFD4CE845ACEBC46B767AEC21218395366D0196D3FB77F13258C4FB5796878EC79572A32A';
wwv_flow_api.g_varchar2_table(66) := '807910C6D6EB456387597D3D94EDCA6E1B3DABB7855AA1120EB0C115E6BAB2C1D8D9F090EFB7BF11D388795C093D95A90E8B8826D9D70B8CB9F307439FF102FF916C67DBD24A1BD32AC746CAF991B391177DEE87772DFA86E54782C795F0A73A805563A2';
wwv_flow_api.g_varchar2_table(67) := '0177ED1FBA1999B987C8A53CAD121ABF2A175F497FE6659990D72619C5C02CEF0C7B5FFFFEE4DDB99FDA8E2478DBD88EA921AD902E0752E2E9FF03C80596F00A505AD10000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72345354554797152)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/doc.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D00001F5C494441547801ED5D7B7494C775BFFB92B4AB958484100890010BF33010F308D818E367ECE31C1BD96E4C9CC4499393D875D2A68D7BD2366D7A7A';
wwv_flow_api.g_varchar2_table(7) := '106D4EFB47929EA4E73439A9DD26354610E4E3244E9BE6E5F81530E665631B30D818302F092424ADDEDA577FBFF9BE913EAD5642DA9D855DB203BBF33D66EEDCB9BF7BEFDC99F9F4AD8889148FBB4C90B9AC34EAEBDD1297DCEF478210D3EF10C175B9E2';
wwv_flow_api.g_varchar2_table(8) := 'A4BB7AC793ABA251A973B95C93E2128BB9131A13E195183EFA0E8F1393B3CC44EF8F56575FB7DB7211CB782C1E93A222B7BB25E82F7CE217CB1F3EB13EBECDD328EB63BA3F899CE5E2B9372DA61DE05EBFFD8907633179D2575A5CA668A6AF3A69B1369E';
wwv_flow_api.g_varchar2_table(9) := 'CA541F2F54D31B8DAFB8FFF52D5F6A747DFCF8AD2FD47B5F8CC7A3570AC86901BC5E1ADD8D22D1152F6FAA96787FBD6F524959B8BD330CF3702B6747BB26D0CABEED63642A39EF259649764F2B8CA6A5E98C5537B1CCF0B2AE583C1E8B7ABDBDEE60F1DD';
wwv_flow_api.g_varchar2_table(10) := 'F170A401207FEAA7CB3E0990E58A0159FB4A2D8A89E54097C927FD5703C5F9915037C124B8A43B3CD7D72CFF3CFC9E2EABCB8C963BCBB18CB39CF338B19C3ED7B95596702B058F47225DBEB2E06A00BE79DDFE6D735EBCAD3E72EB8B2F7AE40A882DD202';
wwv_flow_api.g_varchar2_table(11) := 'B871FD41654F7177D4257117C76264CA6629BCECFF905F114F1CC1D540A83BEE2B09DCE88E466C906F03C81B731EE4B40096C66B09A2B8621EC69F760C9AE84359225B1379556C23EA8ABBC2A19EA8B7A4783541BE7FCFD65A5A3287A15CB6E4F400B62D';
wwv_flow_api.g_varchar2_table(12) := '183EDA9293C256619EAD8826F065F10A88E32E3744812CDCD90D9003AB63EEE8967B5FDF7C0D02AF682E839C1EC0B261B8C072095B27E76AAC8576327E00CCB4645F4970A53BEEDE5CB777DBDC5C06394D809D52CAE1637B1E6F4F8D18BC01E46E80EC5F';
wwv_flow_api.g_varchar2_table(13) := '29AE6843DDDE4D390BB239806DEBCD49231E192D5B2077C2928304D9B3B56EFFA6F9B968C9E60056E32FBD5C0E266DC1C359B7DC7517DD756085443D5BD7ED6958906B209B0338274DD74674A4056BA82D9069C92581A558E1DC926B209B03588B249772';
wwv_flow_api.g_varchar2_table(14) := '4C80554A6EC1BA274320072D90EFD9BB75A1B2E4C6EC9F42990398B2CA35FF8C858E71260B64BA6B80EC71C57EFCC0FEAD8B1B3F8E295496836C0E604A6ADCF21AA758335D6C620A3964C9258125B1586CCB3D3900B23980092E049653184F9C597B0A85';
wwv_flow_api.g_varchar2_table(15) := '15AFE2C0627724FB41360730AD01029B985164DA443342DFCD6D8E3002AF8292C0622F2CF9DE7D9BAE1B74D77C70208B923966266E0DD92386D1A3E8E43C62C50B9B2AEE70574FC41B0C2CF688774BDDEE2DCB14C8D7627D3E8B404E13E08D4302A0E9E6';
wwv_flow_api.g_varchar2_table(16) := 'AAF98E1D450FF5D171047DA64A7B60C9116F897F21206FA87B23FB404E13E00D435D6677F9C985A41551E7A9F36C811CEA89F84A030B241A6F58B767D3725A72FD06C8260B2C394D801D92A1B0D217988360060FB5225A8F92A5DB1077C0952563316481';
wwv_flow_api.g_varchar2_table(17) := 'CBEDD9B2EEF5A757D6BB5CB17A607CB9414EEB919D1192D1821B71235B2F1863D8B264B86B58F23C6C393600E44FD5BB3EBDBB3E1E77D7F34992FAFA644F10665C30E62C38E3AC66B081890659C959B12C99EE3A583CD785ADC675BB2EBF25E701265829';
wwv_flow_api.g_varchar2_table(18) := '0459C93186B3D6EE3A18B8C6E5756FBEFF8DCDABEA5DF597CD5D1B07D898D31B458219B96CC682356B8320630A750D1E25DE7AEFBE86D5970B64E300E74A9CA5D150B9390BD66415C811354F2E9E0321375C2E908D03AC7B9853B9590BD65D57819705B2';
wwv_flow_api.g_varchar2_table(19) := '7F3641BE6FD7A61B2FB5259B0338177DF3F8B60B3560A9E436C8BD116FB17FB6783D0DF7EDDDB296202B6297609E6C0EE05C9A076BA8C6BF5DA86BA4925B2077F7463C41FFACB82BBEB96EDFE69BF5B4A93E9ED9B56B7300B3EBB966C5972E60705A720D';
wwv_flow_api.g_varchar2_table(20) := '04F5F47DFBB7AC25C8F5B2219E4990CD01CC2E40603985F1A5657618C8F108FE4C6657C32D9CA26512647300D31AD0854B67147419399754741DEDEE0D7B83FE1A97571AD6ED6DB83D93209B0338E7640D862F8F367205DC6B833C1D61C0A675FB9D20C7';
wwv_flow_api.g_varchar2_table(21) := '8D629226B18DC361BD3C021BCEC344CEB48BCECC34692C4E14C8912E5872B17FBA2B2A9BEEDDB7E50ECB920563B23990D30478C35027282C2DB0A1ABD97D34384DC2019473987EF284F7556E77431F0FE63C40D274EC53AB0E4E743955865FF6F695558E';
wwv_flow_api.g_varchar2_table(22) := 'D2F246BA7B14C8F80BB74DEBF63C7D9702193B51EBB76DF3B046BA294D801DCD3B3BE3B89C1B877094FCEFB464A5B0F852B9DD0B7D3C98F300494FB7EC53AB0E4E743955865FF6BB4C743955C2E50B77619E1C0C548BDBFD74DDDE86BB59927BCA26B61A';
wwv_flow_api.g_varchar2_table(23) := 'CD014CAE8618E759F626CB82147F8415EF1489112397C71D73B9F997868E0FA2DC61E76E3CADA3AEE93CF1BEE37CD4BA2833780F7FE2E67679A23DBD0305C1C01497C7F5A307F66F5320ABB9B253E95290A8D9FDE01418B82C55A88800194296482CE6E9';
wwv_flow_api.g_varchar2_table(24) := 'EEEAED7349ACCB817B025B768584ABD6A9BEA7F3C442A35D6739DCA37BA776217775F674B9BC9EA9D181C8BFDEF8FC0FDEDD71C76347F9DC355F93914875BCE77F9800DBB2A5E8C3F178613812F6484F3F5E0CC447E9707174A4C72BD7899703C8F178DC';
wwv_flow_api.g_varchar2_table(25) := '079EA250BC856E976B26881CD56F51983841AB86718029B49C4996F1B8A4D0E75356D4D36F59945BF78248EBE364BDD2F775EE2C93EC5AB2FB43E5D44B127C5EC10B6122D0B688B374AAC76902BC7144BB43EC8EB8957D17881D198EE11B8295008E35C8';
wwv_flow_api.g_varchar2_table(26) := '749B174B839DB5CB0E9EB3E245EA0F961D2A877820062F82E8998DDB4174E381A10217E327C9FD3483AC0D4948E6D825253EB86606333E8F4BFC059033FEC562D65B47787DB40F5174DE6394EC3C1FEB38B12ECAC6D4EB4212F05CBF88AA90724A136047';
wwv_flow_api.g_varchar2_table(27) := 'BB097C39EEE4CE2145494BF617E231397448CF6F73A7072338350730859396AE8DE0EDF25DB88240360730E1B812AC58ABD51502B23980092E2CF84AC2580A2EADBB1E4F5CA7F56FBCB93980E99E396C8DB7E55C28C7CE5C424BCEC4906F0EE05C002C55';
wwv_flow_api.g_varchar2_table(28) := '1E95251721F082B8328142AA7C8DA35E9A006F1CDEC41565BE8EAEB15F0439C0E83AB7404E13E00D4352E0E07B450DC0435D5347B45C1F161F720CE434017608815ACECF959CD8BF8C836C5688E60026B057B2056BC5A5FCBD99B464B342340BB016C21F';
wwv_flow_api.g_varchar2_table(29) := '42CEE83A07DC751EE05495916372462D3955C686D7CB033C5C1E133FCB7290F3004F1CD2913534C81E8833CBE6C9798047C295DA1546D7DC85CA3290F300A706E7C85A7A0A9565209B03D86C743F5280B970250B413607303B974FD6624F16B96B7300E7';
wwv_flow_api.g_varchar2_table(30) := 'C11D9280B664CE932FF3989C07780816B34704390BA26BE300E78762879E4C10E4ECDEF0B7FB951F8A1D00F35081CC654DEC275FC45D67620A6DDC8213BA973F552003652F44EDBF38C8A6059607D8B44447A3474BF641DCE3B0E4D148A4723D0F702A52';
wwv_flow_api.g_varchar2_table(31) := '4BB58EFA456A827CE9A2EB3CC0A982954A3D46A06A4CE67EF2A571D7798053012ADD3A97D0928D039C9F268D037D0A4981AC2D193942E8FC34691CB2CB99228320EB31193F368EBF3E33FDD893390BCE9BEEC4754B83CCF931032FAE7C116483C91CC066';
wwv_flow_api.g_varchar2_table(32) := 'F932D8C52C27A50D83F3E4621B64832B1EE600D68C66B93CB3963D1A88B6640F2C396CE40FFCD51B29CCF4396FC1E9CBD1097209A6512A6D488B2E1649F329AB24A0412E30E35CCD50714828EFA91DC248E5900234E80D8D5B3079D320F3D8E2D5C9B1B3';
wwv_flow_api.g_varchar2_table(33) := '07D6315F89C1A4EBA993097C59AF4FB7EA6B1ABA6D9EEB6B1320A9F8268DC4FA9A2E69D13AAC735D52E723EBB1BC4EC9EA0C6B27158635F184DC38C09A3E3B5100F11462F64E7E87BAAE4B30C7BB4E7087E14404916314C7046BBC6E8565118E48317E7B';
wwv_flow_api.g_varchar2_table(34) := '9D79148DA8974E9206DA259D01D0ED57AD8F0F68F2C944DE0BEC9587A823AAD574D9766F3C265E94F3A37D5267DBBAAFBDA813B1CF49CF99589EF4D9778D659FE233A6DFADE32C9ED6714600A69028F0F378D5D361BEEE49BD835377C5E6574B1242AC45';
wwv_flow_api.g_varchar2_table(35) := '87CB5D1E051405D807C1F1D56E0935EC8A43CA42602328FB4EB45F9A62495E06075A8BF052E62AB74FC210E68043A083C41C0704AD08AD7A51EF02F8DE1F0DA331CDA8A3200E4BD1F642D06D05A7EF44500E755462791C2F73170078BC490F1779875498';
wwv_flow_api.g_varchar2_table(36) := '532E47A303724AC965A84E2D6855B93D4AC151C458CA08C0D4E77E74749ECF2FB7792932AB83C3B8468FF15228E9C20F0B9D8D0DC85E80148AF4410A1EB9D153A004DD9704100A8A4CD37276A23CCBDC5350220B0A4BA5D2EB97A0C787B582B874408867';
wwv_flow_api.g_varchar2_table(37) := '07BA64677F87BC10E9910F812695A877149AE4910AD30AC1BF151990799E42F9BCBF52A617144B39FA5088BA612853572C2C6DE15E3911EE96B7C23DB2C41B903B8BFCF0143185317F419AE50EE37E17948E1E8CAA479990F71EF0B6D2572CF78326BD16';
wwv_flow_api.g_varchar2_table(38) := 'FF15807673B44F8E447AC56F974366249903D8564666743F3B63FDF2B9D25A5957B55059042D4D8FB59A7376AE0F420845FAA563A0473EE86B97ED9D67E587BDAD3207C2BE0A5A4D00B5F633C72BE994EBDB01817CA668B2DC533E47169654490580F0B9';
wwv_flow_api.g_varchar2_table(39) := 'BD680B2FE6C53FB6D707A04EF775C8AEF653F29F1DC7E520405F08A0E9B29D34297CF2FC32146611EE7F6BF27C59513A5D6AFC9324E02DC45EBD47B97CBC6A50D18D2A9EFB646BD3DBD23CD02D5FAA592565BE22E98F46309525C422CFE2DEE3AD476435';
wwv_flow_api.g_varchar2_table(40) := 'E869FA1F4039164009FF6AE64A9913982CBDE0A7083C77227FEACC1BB20DCA78ABD70725B4AC1D59DAC91CC094989D14D6104629845355543A0830BBCE7147277D648904560FEBB9B57FAE7CB4E3943C71FE90EC8685D0F23420049796B23B1E916F56CC';
wwv_flow_api.g_varchar2_table(41) := '53CA33C35F0600DC128527A0E5EA540450D8FE347FA92C289926D7954E93EF9DDD2FCFF787640968D25DB334854FBA2F4361BE1098229F9DBA44AE45D900CA3045D11E8165A217C6AB67C503EBAE2C2A91A5C1A9F247A776CA27FA3B655EE95419804B67';
wwv_flow_api.g_varchar2_table(42) := 'C94278915B2AAE96DB42A7E41894660E6871D8391E8FCAD726CD92EB26CD548A188DFBA5004AFC7EEBFBF2DB9E73B20460D3DAD99C92211B4D3399033891117038004DA796D2AA2238E6F84A2BE35B5E99D4377A33808EC720002F5CD574004650AE82F5';
wwv_flow_api.g_varchar2_table(43) := '7CE7F41EF9352C70310444D1513976C30ABE37E55AF958F587A454594D58062211D0F5C07AB0608F7F5A3803B028D6A195AC9E3C07801749FCE44ED90DD73D1B8225C8CA72313C3C1E9C2E8FCDFCB0CC2E9EAC78ED03DF4C05A84BBA5A31499B1F82A990';
wwv_flow_api.g_varchar2_table(44) := '00803F6C7E4BF13DA3A84C7A502F8CBECE029DBAD299F297AD87E56A943F03E5BDAFA04C6E995CABEA87067AE11D0AE458778B3CD1B45F764199EF80EBEE843C6CF1A056FA297300833702EA01B8CCE9E628FC235DE72414EE83E03CE287F08218A7A714';
wwv_flow_api.g_varchar2_table(45) := '0695D6D3C585A351A5104BA1E57F0A419D3AF92AC6A7B0CC84553C8F31AABE6C8E3C50BD444A609D3D70EDA45D847BED1C17BB2F480B045508DA74AF33F0E158DD07E1FAF096FCC565D5F2679165F2E5933B20C8A84C46FBBF07409FF54F963F99B942AE';
wwv_flow_api.g_varchar2_table(46) := '06283D70EB04B310F7187435F575CA5928591BCAB12F65B0DE69B0DE4A7826022F70B94F6148B9FDC2097960FA122813023AD0A60758533E5BD6769C94D300FD1C687E0C565D132887724414CF8CB2775C388EFA2D720BC6F22E28395E1D8DABE6524601';
wwv_flow_api.g_varchar2_table(47) := '26A78A59E572106CA0033F6D3E24FF143A8140AA487C00671AAC6A75F154B9B3F21A584F85D27E355E430874659FEEBA5ABE78FEA01442DA1FF105E581A9D7CA24D4A1A550E0B4FA83A126D9D4F496BC0241B7A10D3AD75A94F9638CA51FA99AA72C7800';
wwv_flow_api.g_varchar2_table(48) := '20BBA130CB40F391D01CF9EA8523F261803F17CAF199AA4532A7B872105C2A4C0794F0859677E5E76DC7E40894E63C40A3B294A1CD05BE80AC09564B083C2C07A0AD1832365D784F96C0B52FC4704025A515D7062B655DE90CF99B9683F2B9E26A595331';
wwv_flow_api.g_varchar2_table(49) := '474D28A8E854F803A1B3F204C669FC4CA99213158B51B62534332073083293B45F1C831AC1267882CED3828E4140CFC33A1E6F3920DF38B15D0E779E53AED68A44A3CACA574EAA91BBE0BADE84F57E0CE3D72C5A00C0627374CBC77A5AE51B70BBFF163A';
wwv_flow_api.g_varchar2_table(50) := '89313C2AE5B8CE97C6BE0C37FCC933BBE59596A3CA22394C50E81C9BD756CC92EB61897B30EE3E5432433E54361D6378140A68592EC1DD7CFA7579F8CC1EF90902BF1EDCAB24B8A0CBC8782BAEFD79CB21D9DAF1819A2B5FED2E94E70742F2EB96F7A413';
wwv_flow_api.g_varchar2_table(51) := '5E85D6AFAC18E0AF05CF02656630380D563F8021866E9F6DFCEFF923B23DDC2535B07646F73A16519D435B2692398095A926B094003A4FE93ECB602153D1C95A746C095CEDEDDEA06C4190D1002BBC80689A0260A2D0A7615C5B822910A74FD795542B50';
wwv_flow_api.g_varchar2_table(52) := '09042DA017AEFB37B0B29FC172EFC254A90A7403285782CF4D709D9CF63CD5F28E34C3CDB23C1303B1E970DD4B419769152C2CE82B54F1028335BAE5575A8FCA5F63EC5C0625B81974AA3C5ED0F248109F196883533F4EE5E829589E63F90A80F84D44EA';
wwv_flow_api.g_varchar2_table(53) := '6F779C513106C1A232734CFFF6E479B0EEE96ACC56F1073CD7BEF693528FF23778FC08C086E20690339ACC019C00A672334940A79BEEC087AB40DDF88400225EDC2B2B20C8ADDDCD6A8CE6B84A722CCBB1B61A16BC0A1F8E7D56822B0378ADFD5DF2DBCE';
wwv_flow_api.g_varchar2_table(54) := '33321FC255F4408BC1581FC4DE0E0FB11C20FC1451F3510432648554A91C41D09C0FA5990D006BFCE5FCD50615E4312E20CDDFB49F4061974C810572C183AB5204919F1ED0E558497A7A958EA37629EAB2ECB32D87E53C6814422918581621AFAB5A8069';
wwv_flow_api.g_varchar2_table(55) := '5C40597521689EEDED90CDF000EC4D11FAA157BC9288CBEA6E1ADFE6001E27777A2ECC9C8D73D588E0F8611DA760914D7D21A5F96E749C2409B61FD1E60258282D9B5316D6E5BDF39883BE03D75D620B492B06AD870AA25C1E00398F698CAA075A1CFF7C';
wwv_flow_api.g_varchar2_table(56) := '28CF717C6941508A0136175CAC1A2E0454213904F73E1FE322A7367CAB30F9243D4D93E79CCEE81D5BB6C33EAC85A2FD7BD759D989808B8B1DEC03199D8620926D92BF3EF4F177ADEF49038696E550B05ED53688652891573389BD77262D11E7B524C75A';
wwv_flow_api.g_varchar2_table(57) := '2F2C46B00285318CD3260A4DCF3F397E5601082B12B789A0623B22DBF72148066BC993759DAE9CDE4097629B8C566702645A18DDB69EBA7580E6715862103409A205FC48EA89DDA3AB66AA8512FE57EB3BF241CF05F06BF50A3FFCA1E8D3EB1CE93A2FDF';
wwv_flow_api.g_varchar2_table(58) := '4160B50CDE452B88553333DFE600A6D4345AE435F17C9CFC134C05AEA33CC1F124889A9678F16495495696D70A4193ED69C635CB7AFDF8E2F4879720252ECA14AA1E6875B2CA5059499FC34035DC34972C875A1E4EC7E4993980C9D5F03E8D8B4F6D09DC';
wwv_flow_api.g_varchar2_table(59) := '4912089BEBBE1402173E6855140CDD5A07A24FE7AE0EEF95C2C5CD421DFC72CA986D716EAA5DBE2A88E211586927C648352503E3143F79298665D5C0BA35006311D6AD326758C89DAB53F83C3A7511A2FD0A3506B33E972F99B8DA363738451E9BB2109B';
wwv_flow_api.g_varchar2_table(60) := '305828414A0A8026AC4AA4F795947E7A24EDDA1AB93188B11F0487DB67ED1036C7242E4ED082D59C10D7B948710E0BF71FE0C3A0C51A7F2D30B840C2008BC11A2DDC0A7D869C87729B00ABB2B0448D7F6A1C46B901CC5B9B10AD73819FEE9B63A3754FA4';
wwv_flow_api.g_varchar2_table(61) := '1A81DC7CCC73DFC5305188F6B921C0C46FFD512E1DE76C5327064BAF467B65E3A4D9B2AA7C96CD27FB17C37A7848292B95D683B66EC47CF82B989EBD82E1807DB75AD094900F91755C4CED3073008FC20FFA87C4050AECB7A227E518B3DCE8E10108E741';
wwv_flow_api.g_varchar2_table(62) := '4C59A8E174C9942BDDE73904486F2212DE0740B85A65D5B7A63B9500F80E4C9D0E01A820CA16812E3BC405894900F6109620EF4570760D161CD82CAD9402EE0CF7CBBEBE3639090187144DA814AE739ECCB5F3DBB0C4188662119C0AF0472069A1A44BB7';
wwv_flow_api.g_varchar2_table(63) := '5E020FA3D7C5A95401B4CD2DC03B0B4AA56ECA02B524DA6FCF779B01EE4F9A0F4A37EE73DECED53A6E8C3C884D98B9F0166D68877220C8067105352B5D7280959B85757017A91D96F402A2E0E7C39DF2E5921AAC522D42548B8D00DC2310B440AE52FD1E';
wwv_flow_api.g_varchar2_table(64) := 'D6DB04811DEC6C560111DD2DC108604E7A3756C0EE2E2A975F62A1815318D6A182FC0A5B842D38FB02DC613540A3F5538404F23822D8DF0D74CA3E08FD6877AB4513F7E8AE19EDDE31E51AF9BB4973E425F075004AC00D0E4E650838A742BFC3CAD62B50';
wwv_flow_api.g_varchar2_table(65) := '2AFE1E1EC75BDE3F81B61F01B8B550502A07BD02F9D885F9EED731A77E07BCABA81A746228CB0D8DC72BE6CA1B50422A4BA652E6001EE177AC2EE8C8B11D0208606C7CB8A8427E3075A97CE5AA1B06D76969699C1A9DEC69939F5C382AA5100037D77FD1';
wwv_flow_api.g_varchar2_table(66) := '7E4CCD313946B30C41E312637DCD6AF98BD2ABA40D345F83CB7D1782BDBFB04C9E997EBDDC54594B581578ACD785B5E65F61212380FA780A595EC26A542BA65B9CB7922657C9AAE0191EC5C6C3F7C1D74AB8F7D350945DA0FB3680F1A1DC63585AFD11EE';
wwv_flow_api.g_varchar2_table(67) := '7D1A4AC0E1610794E06BA535CAF55231C3186B39DF3D8E48FA67EDC7E13A62F27F68B30D8AC1A91E15D88FFB7754CE9587B00EBE1BCAC245193DC4800D6329736BD1094A49E6A9D5744D7761D98E810777962AE1AE389652F8FD102213E7A65CD16AC4CA';
wwv_flow_api.g_varchar2_table(68) := '56035CE9CD189B69994FF55E90D558DEFBC48CA56A3990DB8B5C9FE226C25761A5EB2150EE02717D7A2A76A4ACF19CBB5AD86CC035FAF7EDD89AFB4EE769590A01CF46DDEF6271E57A5CABAB5EACCA7089919B015331163F84766EC278D982850BAEAAD1';
wwv_flow_api.g_varchar2_table(69) := '020BB15F5B8D4592C9E0F9652C83BE7EFE6DB919AEF90158EF64F485EDD31513C41700EA73F014376023E1BFBB9AE456EC4BDF36659E5238F2C48D87872B17C88F4FBF867934940777F8D811326329730083458EA36A7A0086196030789A5F325501AD7B';
wwv_flow_api.g_varchar2_table(70) := 'C0FE50780497DACDB92E171B7E7C66BFFC03B4FF06355FB4547A0540F917CC312BB12A7467D57CF1E31E053A108D41B801A5285A3EDA1A1924D19A80ADBCDA7A5CBED5FCA658211076BAD0F60270F55D6C664C4660456BF760D7898AC3C89D4A518BA5C6';
wwv_flow_api.g_varchar2_table(71) := '5A78099D94A2E2847F61C27156F0F92C5C2DFB45D03804F9F1E0FADBD84868C48A582D94A204FD6AC550F41C1638B864495E19DC715EBCBCBC46BE1E3A2DFFDC714C6EC7664AB76EC8506ED6455B3858ACE19841125D1F17DFD507C704D9465EE57C5C8B';
wwv_flow_api.g_varchar2_table(72) := '965C80F1B413EE7347EB31F9F6F1EDF2B76D47E57A5C6780C3E5478EA08C38CB70FEF7675F9767CFBC292D70AD74E5DCFDE178470173FA63E5D8ACC06A149FC8E8C238F74BEC626D38BD4BCE42212A4197632A9F16A9C27133AEFD2336167ED174003B44';
wwv_flow_api.g_varchar2_table(73) := 'FDA0E953CAC3EE90960AB8EC9CCAC8E405881C7B1F2B9D2D1F9DBA502DA9D23D738FBA17657F0B305F411CC0392F57B9A89CFFD1D322BBDA4E282566AC41439D8621E0A1698BA5AEB05CDE63DBA041C33095CC5A303946B2A6276E69C3D8720AEBAEEC38';
wwv_flow_api.g_varchar2_table(74) := '35DBBE6D1552E5AC71B41B3B2BC77BDBE58DAE66F99F9E66791BDABD06D6495FC5F55FA51438E331A3E30EB8B3CF6393FD2BDDE7E42370F7736161748F6AFEAC6A714E1A9366B85606542F41A8DF875B9E0C7A3510B47ED68BDACD633E1AD48436BF7876';
wwv_flow_api.g_varchar2_table(75) := '9F3C4A57AA76AD2A86D1445195386DEB04DD53880F76E2F1A29BCA66A2ADA8BC87608D5E8373EE439D4DF21CDAE37227DBE04E1195B30AC7CFB5BDAF1E06E0D0C488DA87A1AA1060AF094EC3BD776536CA0CFE36268ED34D89329F183DFED63C7E5CF986';
wwv_flow_api.g_varchar2_table(76) := '579F5C8380F825FCF6AD27168DC6D02937E7B79500690A2C888D24534ABACF1004D60CCDDD4B77075016C1A22A21188269C5BDC359221D52E402FF6BB0BC0A007E3B1FBAC3A71CD6C325480E077CCEEB5D8C7FBF4774FD01DA588EA71C3995D2E03AA992';
wwv_flow_api.g_varchar2_table(77) := '261F0D64C0B4170F00CE40FB37629D7A1EACAB1CF36CFDA4082DB91D748F22AADF0DDA41D45986F198411CBD8CB55FE5923370C717A030DC8CD0FDD632E0C3883558CCA9806CD463C228C0F9361FE63B16E989793C5EB72B8A0D658FDCB273F523DB61CE';
wwv_flow_api.g_varchar2_table(78) := '4AC64E7E27726CD682ED96D929AE0F9F01707CAE8A40B1F3BAB37631750D3F058988D62D2BE94EA1CDB47E6A3C5332EDE3352E07D2366E81F043B09E1701E233FDEDAA8E55CBAA5F8632B330A6CF4639D24D062E2B9126EFD1CA6E4659EE44BD80B97763';
wwv_flow_api.g_varchar2_table(79) := '129A2C5F01BAD341977CBF88BDE1D3500CEC49A97E92B7D9B857464563613BF198D65C04B91C80829C85820450879C86F05D8BF2E5A84766A0038A27BB6A5A9959801D88B043DCE559C2BF941B33A1120662FC60AE12323BEC2093B426EF730CE5948BFB';
wwv_flow_api.g_varchar2_table(80) := 'B48B2018063D83D30C5CA75BE787D7F4437B63D1E53D7A0DE604A71C7CB30FE487AE978996CAFB048A5758BEC6E59339BC681551CC3312A6453B932EC27C06DC788D5D85E74C2CCF3E91B6C9641660479FC8382D974C8F9D203E146179FD19BBBC75570B';
wwv_flow_api.g_varchar2_table(81) := '8642E67F5D97395BB4FE4A824743F7D4C9185F9A261582C94993E7049A77ACBBD67DF62FAC2F5885F8ADEAAA83842F16D5F49DB7ACB66C0E3423CE02291E9B05188C25F296789E8CCFF19449568FD79C759DC24FBC375AFD64D7C7A2998CAEB37C327A89';
wwv_flow_api.g_varchar2_table(82) := 'D7462B4FFE47BB974863BCE7663D02382493F994A6040C0AD12CC0503FD31A98A6A872AAFAA0EC060FD267DF1CC0365306952FFDDEE518854CC8CE1CC099E02EC700CA4676CD019C8DBDCBF394EEB46BE37011E6AD78B83C5239A30C0DCA313D0B6EBCD6';
wwv_flow_api.g_varchar2_table(83) := '1A79B9CBC7451983C1412AB2B922EA68195A3BA7228D8DFA4A4ADD4B0FE0F50795AEC5DD510B5E839A97526FAE844AB60C954CD91F5BC6A9762D2D80D7DB16EC8A7960BD588FC27FAC3A92C5FC27051928D9A965BD785CC994F86A2F9922C2E9AD64ADB7';
wwv_flow_api.g_varchar2_table(84) := '5AC503ADEF63E7F6B0B7B47851B8BDD35A12D68E455B35CF79ECCC13997696E53D5D5E974B3CD7D775597DEE6C3BD9B12E9F8C17DD46222FBA0EF364F5F47D7D4F9763CEA4E95A6743E7FABA95C720430F6478187B51EFABA2B68C75B589E6BAFB13AD67';
wwv_flow_api.g_varchar2_table(85) := '9587A261BB5089E2FA979F78107B754F82C1B2119D498DFA1F562D1BE848A8BB036EF091D7D63CFA8C128043C6A908243D80D9A28381D53B9E5C859DCC3A3CB93809CF0E725F1829611418D470BD8166E7FABAE648A98D223064313C55E5C6A86B0B4A29';
wwv_flow_api.g_varchar2_table(86) := 'D960799B8ECA745DE7351CEBF6F5E5C4737D9DB9E6D1796D347E9D659C7507CBF32FA348D2EDC6E34DED7819C5CF77AE7DEC3555CD21DB443297F69C8CE49359091892E9FF03A6656305C15E826E0000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72345765775797154)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/docx.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D000016F1494441547801ED5DD98F1CC77DAE3EE6DA8B4B521245EA3049DDA2021FB204C809122BF28383007E32F9903CE7216F318C3C0409A00D029B6284';
wwv_flow_api.g_varchar2_table(7) := '387F805E8240241D6D90870079081C438A11C9881358162D2AA42C1EE225DEDC9D9DDDB9FAC8F755754DF7CCCE9233D3B5333DCBA9C56CF55457FDAAEAF7FDAEAAEAED15C2400A436119203352120BE182BD15E6D1C9C4D4C0846168218524FCC1E9EFBD';
wwv_flow_api.g_varchar2_table(8) := '1CFAD67750328FAF416AE29DA335F9DD1201C65E74ACFCCD6DF999B79EDFFF579F87E13B8E108702CB12723E26BB1B152D374DC749707F76F2FBDF8506BC35375F9C2777D681BBAE20EAB99395C97A9A50B73A9D6524D7D9569725EBB24EEB3B4C4F9817';
wwv_flow_api.g_varchar2_table(9) := '5E23F7E2FF9D3BFCA79675E8FCBBEF2EB861B8E06F1590932C213BFA4A6178D0B1AC45FF679FFCD96EC7727E32BF63EAC0D2ADD5666809DB02B7C947CDCF8D3BD2B5D8B5BA0E91ABF63A8FB1D3B575CDCE3B1BB78D5BAA2B989D300C726EB1BA6D7AC76C';
wwv_flow_api.g_varchar2_table(10) := 'B3E9FFDC0D833F7A6EDF5F4890BFF9CDAD01B2DD17A21D951717A38240EC0726CF9497AA42812B403704C8615BCEB2F51F555795EB769D79DCAE9D663F6D755D0A1FAF297B212C58289A4DAF323F5F7AC513D6D153E7DFDCF7EAAB0BDE7BEF2D385BC127';
wwv_flow_api.g_varchar2_table(11) := '73A203A783070F5019C031C70AF18344CD03E3C6E1130D55580E0DC6F252359C9D2B7EA319065B0AE454002F2E9E9496D7716C282E111E585646D730A00E0B44D0A1552ED77C80FC0A41FEF585BF7D829A2CC43BF2DEE80698AEE754006B0DE610E0FB54';
wwv_flow_api.g_varchar2_table(12) := '289D6E3C43690DD31B2770008219DA2A6A00C85509B2F083E31F9EF99BA71078F9422C8E2DC8A9008EB94487C69FF1489D9646FA5A800E25A67F8E402EBDE4DAB9A3272F1E7E729C413606705229C603E67894D4604AA7CC1952B4402EBE1478D6B17690';
wwv_flow_api.g_varchar2_table(13) := 'C7468EE5048D013C2EDA1BC31A5F7589962390A54F26C83F3E75F6C8334A93C7CB271B0398EBCF714D91E6760E3F09F28B4D2BFCF189733F7C76DCCCB53180C7C703CBA8B90DCC2E1AACEF2741FE8A259CE3E306B23180C7497FDBDC0996491B68701BC8';
wwv_flow_api.g_varchar2_table(14) := '2B5C42CD16BE6203E45F9F3FF21C3579710CA26B6300AFD70BCD9F8CE7BD7180B5AC954ACD9F01C808B7FFE9930B6FBE70680C40EE6D7A3D61D4A6173DB51859A5C1CC8DCD58BBBC2203AFDFF283E0F8479FFD20F3201B04786470F5DFF1E0B218FBE4D9';
wwv_flow_api.g_varchar2_table(15) := 'C20B966DC7202F1ECAE46688318007E759FFF8A46E319806EB6E6390E74A2FD8AE7DFC9767DFF8F2A1438BFE22405E585830C653DD619A3C5383493391BEDA7648E35DA2E88DC81264BB52A979B3B3A51772B638FEABF387BF4A909F7FFEA49525908D01';
wwv_flow_api.g_varchar2_table(16) := '9C4E2936E2E310CAEF1D456F3408EE7F392BCB04B9F89C1D8A6327330872AA273A9233EF508AE4ADEC5D531AF580D3893897FF4E1920CF6D2B3D8B838A631FFDE6077FFCE5A7FEF297617800941768B22142A34BE9A69718F758ED64697039FE34EC5766';
wwv_flow_api.g_varchar2_table(17) := '8BC7E05293E7E64ACFDAAE73ECE333875FB2AC85E0F5D701F1887DB23180639548A09ED14BF8DC38A5E1402C282D4DC679F2333818CF0CC869A6173369CCAEA0716D698020ABAD7DF4456A32CDF5ECB6E29338933A9A054D36067007CFBA3120B365F7D8';
wwv_flow_api.g_varchar2_table(18) := 'AAEC67DC2D90A7678B4F11E45F9D3DF2F228CDB53180FBE142D6EA1AD2603D2DE593CB358F20E369A6E327CEFFF09551816C0CE0B10AB23414516E508335E516C83333453C716A1F3B71FECD91806C0CE02D7A5CA8011B246F818C75F25E11FA2301D918';
wwv_flow_api.g_varchar2_table(19) := 'C0C9C074106E0CB34D5BBC30F846472F439620AB1DAFE25E2BF08E9F3CF3C6EFD05CB331FF1EAA172269EA18EC609C204EB0CC20071254939772C78B20CFCC95BE14D8D6B11367DFF85DB901F2D77CD06F73413638BD36BD484E307BD7C39745B5AD89C0';
wwv_flow_api.g_varchar2_table(20) := '6B66A6F018D4FAED16C8E2753C92BD79201B04788C8EFC47238BCA27AF10E43C400E25C82884B86D1EC8C60026CF46C3B7EC1988BB8C2802B9EE4DCF141FB36C71F4E3F3475E55202F6C8A261B03788CF4F72EFC1FCA2D09F26AA5DEC412EA51F0ED6D9C';
wwv_flow_api.g_varchar2_table(21) := '42FDBE5AAA99D7646300CB27C787C21FF39D18DEE8E865803076965B59A935A1C97B8250BCFDD19923AF6D86261B03789CCD33C60EF3A87061263FF8C5B2D687E5C9EF9DD7FABECE93F7A332802ABB91BFF887B642B8785A939ABCDB71C27F3CF1F9E16F';
wwv_flow_api.g_varchar2_table(22) := '5193B98C7AE79D8378DB40FA640CE0B1DCC9020851A2D924CACC642CC18BB60FCB3BCB92DFF57D9D77B9871E147DDC8B12FBCDAD20F0A2265B8175F4E4B9C3DFE63D3E1D62E2A8D118C08A2D7ADC19CF35B00C60219978780EEFE5C0A1AE6363996AE32F';
wwv_flow_api.g_varchar2_table(23) := 'D787F8B1D197ED386B957A038FFF3C84C1FCC3A98B3F922073AD0C6D8FC56100B61A7BA26380BE47D7042CA39924A87EE83915A85020C2CAE806A47A5EAEAC545CD7D9D56C783FFAE9FFFEF96F5EFBFA9B6716170F420917F127AC83256300A712B3C1C6';
wwv_flow_api.g_varchar2_table(24) := '9EAA951A2F1C5EE8156A7EDD595BF5C320A022F30E553C9927BBEA76AF5B59B28DBEDEA85E541E8A1C0C8A0F0BF21CA40F11B638A3FE065BBF2B43D3E93D370670EF5D66A426F08BB4D82A1473390B8BD2EA9A270284B40A648E538941FB887599CE93F5';
wwv_flow_api.g_varchar2_table(25) := '9265EDADD4377D5FE7BA8EFACEF1E473AE68367C4F7821DE2E903E1903781C832C2A2B990A50C35C9EE18823D6563D1112643E184BC56222FFBB5CB34841C34AFDA5756D1521189190D133422F454FBF26A33FEA716D6341D6381D17C6D307271563B97E';
wwv_flow_api.g_varchar2_table(26) := 'B1DCBC6395A6A8CC9605463304531FDCEB760D3A71799FD7EBDA467D488949484DF23519C971F77A6D0C604AE4D8274C2257B00540167C67476B713CEC891964A63180631B366C6E18EE2F2B201B9A9641801376C5D0E0464666D4201B64A54180B78C0E';
wwv_flow_api.g_varchar2_table(27) := '2BB902C8799AEBE9119BEB94526E0C600A9D41C14B392D33CD196133BA1E67908D01BCC5F43796106AF218836C0C6044F93153B6D895DC8000C853D25CE30FFD593026C918C05B175E85A436D753D32E965000199B21E3908C013C8E3B59FD02D406B2B3';
wwv_flow_api.g_varchar2_table(28) := '899A6C50768C01BCF542ACEEF01364579AEB489337C35C1B34870601EECE902D590A90195D4FCD00E4CDD46403CC3306B041A13330ADCD272135192FE7903E39C3201B0378F3599AC11E68AE09F2547635D918C0F74390D555C4123E198FFC646E09650C';
wwv_flow_api.g_varchar2_table(29) := 'E0713D2EEC0A5ABF85F4C9D0E41296505903D918C0FDF264ABD5974BA80C823C01D8A0A46511646300C34A4D12389035908D017CBF2D93EE26CD5902D918C0779BF0FD784F83CC75F22803AF09C09B287D0499EBE45146D7138037116092D69ACC87067A';
wwv_flow_api.g_varchar2_table(30) := 'D6648301CD04E04D063806D9924F86F404B2C1806602F010004E82CC870624C8433A4F3606F07DBB55D98780047879929BB3E493218E3B9C87068C017C5F6F55F608B2FE539961826C0CE01EE738A9060ED03A0F0BE409C0231039C6506D206329C507F9';
wwv_flow_api.g_varchar2_table(31) := '5AB15516A36883631A01CB87DFE53A90E19309BA04B98574FA7119D36083634A3FAB31A1204166E0E5AAC08B39033193C918C0130D1E0C9656E00570A7B184A26F36F948AEB13F009F68F06000EB56DCF172A8C96E4EF85E20FCBA19953106B01EE8241F';
wwv_flow_api.g_varchar2_table(32) := '9C036AEF1A3B5E3339E1E5CDD8EA09C083E3B1292DA5263B788343297A8743CA5E8CF9E094E398348F38405747904DA50C6B70AFB3BC97F7EF46E76E6DD2D6BF1BEDDE604B4F21EEC718C0DDD81277D3CF1529D9580FDECB44B11E77C099D35F315FCF1A';
wwv_flow_api.g_varchar2_table(33) := '4B708A4943C5167CAF18EBAF4FEBEBB326DF68D4AD3E3768493FEE57D136E33FD78FAEFF126300C753EC7F10ED2DB8ABD3C41BE89651AC41EBC65C076FC871A52058560E39DA49E0C8DC78345E50C6F7263E0499746CFC3BA369B44D828EE228F9E12A36';
wwv_flow_api.g_varchar2_table(34) := '1C6A929EEE5FD527AB92E3E04B5A7C8C93F4559F2172DB2AE153ECA81B111F41660C60536327D31C7B5A14EC4780930625068C4CE6B61E852008D7841FAC082FB82D01B1ED59E49C92CF5AB2AC98DB0B86E7501F20901EDE2FD644FD00EDD71F900422EF';
wwv_flow_api.g_varchar2_table(35) := '3C84FE67D05A0B4A289AFE2DD4AF4B7A7A9E1426D2CDBBFB5BF42DCBC158CAF2B39EB66E39DC3C63003B606459CCE60F8887E75E03A38BF80EF3287703928C21C078195CB006E65744AD7943AC363E136B8D4F25F88E3D87BC81B78C36C583B3BF27668B';
wwv_flow_api.g_varchar2_table(36) := 'FBB0430440010005E3CAF27F8872F517A03F07A20492DB8435E142401EDEF68702FF5601820340519F027575F93DB1B4F63EE4630ADF296CDC715A11D3C5AF893DF3DF06C079D00DA455B85EFE2F716BF5A7A03D2BDBE2D74853A600A6D42BCD288A426E';
wwv_flow_api.g_varchar2_table(37) := '079854928028F34A203A93D26C82DDF0BF2A566A67C5CDCA7F02F04B68BB0D20DD924015DDED0090EDA1D5006D2AF7A858AEBEDF2246F31E845551709F02B88FA3EFED0A609A733B27A60B7BC512EA2B10191B9056208AB9DD622AFFB02CB7E12E9AC12A';
wwv_flow_api.g_varchar2_table(38) := '846E05BD7898098449FAEE563723B9C814C0CAE32A90A9415253A429A5DF84BF4DF84DD6A5366ACD2900C4C2CC8BA2947B585C59FA37B1D6FC4CB6AFD43F1375EF79005E008834FF3900B95D38F0C37407A449734EC04AB9C724A04D7F55D1651F04D2DD';
wwv_flow_api.g_varchar2_table(39) := '09ED9E077815409E079D26C653029D1DB8F684EFD7F094465154EB5745B5715ED64153D95A69BCFA368ADFDD238D518C047D521F35C864BCFA3098C23B241B5F883BAB9FC0547E0AF37A0E8CBC264120706CE50735C9F899E2E362F7FC1FC03752B3A0D9';
wwv_flow_api.g_varchar2_table(40) := 'DE3569CAA580A0076A6B21B71340C38C23F892C1190023E04568A363911E6C06FAD402958746E79C07418FC11A05D08320CC00E09D513D35C6BA771B7D2DA15D1175A8E5C9D88154879F8C69B0D282F413888CAE2204B4358B6EAF7ED8F26D347F0CC44A';
wwv_flow_api.g_varchar2_table(41) := 'B9BD62E7CCD7C54CF14BA88F373E33AA05D0F4A13BA75E115FC054D7BD2BA2DEBC85BA0FA20EC10985EB4C41001E14CDFA4D2039037F5A06588FB4EA8010AAB22E124CBB0B5751CCED81909D6281EC27E70074771642A57C6F008B536D7E81A87A0DF577';
wwv_flow_api.g_varchar2_table(42) := 'A05E37974282C34DC634D844D448864AA62678A07775A8112122599A471FFEB2E15F1377AAEF890BB7DF86569F92DA26CD2D40669A2D3D0150F6090FF5AA4D6A3BCD31408B002BB8BBD1570335096453029877A8D5CA57377DF8D28816B5BF0480659086';
wwv_flow_api.g_varchar2_table(43) := 'E899E0E5A1D13946DBB0125CAE79FE1AFAB9026ACA4AAC9F094735FC640C601343D7DADAA2850206D04CD45A1B5A8BF7C1E23305D3380306EF8209BE2AAE95FF5DD41A3750C60008112E985E70E74529FFB86CBBD6B808D319AF6D0948D17D0035B97CA2';
wwv_flow_api.g_varchar2_table(44) := '997600E023F0A325D407C488C0950B8050C0A453EB8BB0000CDC788F4017D09E01987A12C382A5B823C7624913DF29A6721823F9952980C99636905110B38AA611EF7286FF53D129731FE67627A2E6CF45B9762662A0D252B9468519E5DAB8D6BC80E5D4';
wwv_flow_api.g_varchar2_table(45) := '0A88731385EB630B7EF8010006138BC897015429B74B8249409BD0C695DAA7D2DC6BADA7C0708D1CC27AA035007F48D6579D86D0DE1B72BD9C25FFCBB11903380622E2F380591B1DBE8D795DA208E80FCD29A71000C46B6A6903EDD262415FCBE0A9E9DF';
wwv_flow_api.g_varchar2_table(46) := 'C0FD1BB2156E4AA1C93BDB1038613914AEC01FEF92805353999A7E59ACD43F46CE7FE3C0BE42192553CBB99C72619AF3009CE5740B8CF86B8D2BF8A6AC81EE1F15469E8C01DCA679034E6B3D0DE5D1D6977776C07FAEB116994F5D1B6DE5D22A87720440';
wwv_flow_api.g_varchar2_table(47) := '88C269BAE5EBFAE987196839BB505681363E8A8089FE940053582810E760766F0334152CD12270DDCB5D325A0DFA6B06588CB6E5660B82399A7A8E784B02DCC9F241BE93BD1A1ED91E0C573FF7A646D32A999B547A00C0F616769AD660A6BDA00A42CAA7';
wwv_flow_api.g_varchar2_table(48) := '72972C2F9739396C7CEC86A6E76527521B610D026876AD7115B95A1AF1A6F6C3D47C0A888A9495FFAD7B5FA01F6CCC4402218965E097310D4EF235CDBCFAA7C31658FAC09FDA58132B062B2D22A00CA2B8F95F4730D6F0B84665D4AC348F1B1539E751AC';
wwv_flow_api.g_varchar2_table(49) := '7F1F9243A6B96DC057D79A97516F5654BDCB323AA6F030E5DD6DD0DC3D72FDCB408BE2C838A0D6BC0E33BD8C7E2824D4F83631C5F7D12563009B981269B4D3E966A215A00A486E0772F99347C4BC5B32B8B53B85254EC35B6E01EC07776464AC4C28198E';
wwv_flow_api.g_varchar2_table(50) := '3D29EC684DE59F0468DB4087C1970058B700F275E15AF3108ACB9286BC016BE24280A6F3FB6504AD2D06D7DDD5C625B4C67A18263A4BE659CD92BF339494064730238B4D34A08186A9A00A4B266C1992A19E7F13203D8D0385FD92C96CD1F28BD8E86062';
wwv_flow_api.g_varchar2_table(51) := '3D025F8566AA5324D209A0BDD368F734A2691CEFD11DC0A4579B57A18D65B924F3FC25007E0D75A351C1A74F17F64130B85E560156D3C36187F4BFD45E550F179949C676B24CCD48411B332A821AAC0B2270D4E1BB2F373D2A58DE3C8D93A76FC975AF1F';
wwv_flow_api.g_varchar2_table(52) := 'F94B0A42A57E1126F61CC0566B5BAE79ABCD8B088856A5A96580E402E0E9C2A372E834B95C4AD51A97655F3C63E6726C0DD1314FA26C1B27467832BD94DF054DE62188DAC1AA79D078987FF6A3AC8A1EB1298EA4A3630CE0189274038A74451169234A13';
wwv_flow_api.g_varchar2_table(53) := '4AA632CF41FB76C25C3E21B72AA70A7B003E8007D3A98D75F8DADBABFF0360AAF83E0FC6D38CE700C4756C5BDE86306C4719F79F8BC276C9027664E17E196D112CC13AB08CEBDD1A8482C79205B9E74D3FBC1DE5CAD0F3F0A28A408C0F09B8F60368A376';
wwv_flow_api.g_varchar2_table(54) := 'D1709199640C605372DBA6C1F802CC24A83BA6BF863DE627A499E6D661CE9905503C52CC83C188742370B924BA5EFE40AC621DABCE64D532874B261FA74134C1B3A57D12006A3AC1A4B925A0B5E64D683177C4705800F06CEC4A714BB4DEBC238582BB6A';
wwv_flow_api.g_varchar2_table(55) := '7CA0402EA7F0C597DB9397152DDC5174D40CB282B031804D4C48B199AC46E29A941F682DBC2A4CE91E00ACCCA9EE8B1AE4070D00C1774516A5065E2FBF8F438977210834CDF4B5D42AE68AF16B088802B491FBCA941E50E735B7206BF4BF7223432D8194';
wwv_flow_api.g_varchar2_table(56) := '502C2BA128EE8DC615B5013DA5F197326B9E3139F97C0BF30C259A4675D04EBF2702155C513B24F0899112580170B8765D59E361FF7F6307EA43B42F0034CA2EC125B06CC9E347172062E90393CB356D6CD60BD2AC330863A20156BD513004CCB0F2CB2E';
wwv_flow_api.g_varchar2_table(57) := '9F3009B859425A0EDADC96669F4787AA0F593D53BF32A5C1529B2073D4229A4B7548CFA72394F611260517D80FEDF57CD4F3F0B84EFD1C3EA701DC1282A119D4E17245831BF39BBEDBC3531E7CF283347D682D133739560122FDAF0A96B42851BB0BD0E0';
wwv_flow_api.g_varchar2_table(58) := '0BA07F290ACEA8FD601BB4BF523F83D65C1EA9A85C12CBD8AF8C014CBF378DC8F51C8E01DF918CA326297863CEB18C4787D4C400018E3C1182DFE4698FD2A4F5E04A20A0758C7EAF977F226E557E0E2A917F96605741AB8AFE79E0CFF64C5C72E5D1CFB2';
wwv_flow_api.g_varchar2_table(59) := 'B874E75F70CDC89AE3519B257CC08EA75AA49DD5640C602DF369274AF3C7E8B7EE639342325341A60D2DE94BC0E5392283A4825CB3AA5202A3F5BCFB4848BF09C01A08A61450AC474DC53FC0923B519DED947835FCABD26A44BDCB3150BB952B3035FBCE';
wwv_flow_api.g_varchar2_table(60) := 'BED37F370670A796A5191A99C6DDA9DE1299AB021FC5FC7B8F446A29345E27B6A030DD4D136D9C416350BA4994EB7E3B8A33F4D518C08A41A66646666B33B911CDA4D690F19DCCDFA81DCBDB4D6A92D2C6ADDADB6C5C2F5B778C01AC03A1E14DAF1F4087';
wwv_flow_api.g_varchar2_table(61) := '37AAACF5A4D6010646452DE84D130C743621D133078C01DCAF91EC7984938AA938600CE089F6A6C261D31A1B037862A0370DA354848D013CFC202BD5BCEF9BC6C600E6326962A6D3CB8D691EA6027871F1646BAD020D0E5B5FD2CFF3BEA5401E265525C9';
wwv_flow_api.g_varchar2_table(62) := 'E34198920AE083070F4881F3FD00C7F0A1254FF70619C5A44D8B038A873C6BC6311A92E671AB429F17A9363AB474E15C3674F0C38370FC50934D5B9A3EA7B519D5956E0D46B9B7B6609AE421B5C5C70FFBD23C1EACDF94E7C1070FAA6EA76C71B66E89D3';
wwv_flow_api.g_varchar2_table(63) := '73F3A5034BB7560322AC832E8E524F2F990F3AE08DDA75F6B3513D5DDE6F7DD58E331834756F1B8F03071E38DE020F9DA5DB6BA7C953F6A4796CB6D71EA941DCF098318685F4FEA9EF7F17D95B7373C5793DE816198D6CABA0E342CF5D37ECCC593D5996';
wwv_flow_api.g_varchar2_table(64) := '6C9EB6ADA6AB69F23B931E7367DE794F568E7EF5DB56F78D5C5F96CBB52550FB93DF7EF6EFFE9954933C8E7AE92BD3ECE9AB51B27272001F9CFEDECBA1EF7C07DE987FB8A39C48B2F2E4BA2B0722B9B011A62E598EFFAFDF78E6EF7FC18A49DE766D38AC';
wwv_flow_api.g_varchar2_table(65) := '42B8DED48232ACB18E4B3FA678FAFFE3880F711CA5E3570000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72346071615797155)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/dw.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D00001962494441547801ED5D6B6C1CD7753E7766B90F5214A9F7D3D6C37A58925DD972053F1A1B4D8D1A2E50A3681B1930D202355004E8AF02FD653B16C2';
wwv_flow_api.g_varchar2_table(7) := '2628FAAFBFFAA34D5DCBB66A2AB1D2A06DD2C249D3A468ECBA758CC47122BBB6AC17F5A22C5212253E968F99E9F79DBBB3DC5D52A4B83B3BBB4BCD15766767E63ECF77BE73CEBD773812892005129808AA696815414F8F1388B4FC382A8598AABCB0D073';
wwv_flow_api.g_varchar2_table(8) := '826BC4403622A3CF7EF54123C1534120DD38F59D8556166F7E1F7DCF4A3A3720AB36FE9DE9F9E299E0C01B6E70F4801F8E27DEEED4A7B59A34B61CDCAF7DC104FE4BD94CAE4B08774D35D767B0336AF57D91F60EC97776BD29A9B63FC9F53C731A4C4E49';
wwv_flow_api.g_varchar2_table(9) := 'CF57BCC502726D0C3E70D491A3E2055FFA8B75E313533D996C47573E3F320941363979156A239EEF9B943B9676973F3931397164ECB943CF989E6701B2A4829E6051805C131047812ED3D8B8B7156679E7E4F8284F59A70316DB6378DE74477A1651059F';
wwv_flow_api.g_varchar2_table(10) := 'F4BCE16C6EC943E23AAF8FBDF8DA16D3D333253D7FEE2E86D8A226800FECD9A3BE17A699C2324804985F7A5EFC1D5E6BAA633130748320306363C392CDB43F227EB0A840AE09E0A3C78E29A28141008AE8AA15DC2E35B034015C9C1A877DCFE747BD6CAE';
wwv_flow_api.g_varchar2_table(11) := 'FDE120F07B879E7B699B32F98DA3185C4B0E4D875913C02183B52640AC74D69316FAA2D53141E01878151318829CCB763C947652BD432F1EDA6E9E7EDAFBCF1636D735015C09632B3238544E41D080FE531E263F462677EC4FFBEEEBF9E70E6FFB3C7D72';
wwv_flow_api.g_varchar2_table(12) := '8B323952802B016F95739018C607F082C2E8B3C308C2829CDB1F38412F4126935B11E40460200A374C744BF5711AE46C6EBFEF7ADFBCFEFCA1BB5B11E40460C05A647029C42193C7D527EF4B3BCE91F116043901B8C8E072740B67948F065E994CFB7D41';
wwv_flow_api.g_varchar2_table(13) := '29C858E46985E83A019808AA0F9E15605EB42083C904D9739C6F8C3FFFF26E73143E9920630E7DD3924D70235280CBBC58130C6E615D98B3F745907399F6BDBEE37E73FC85D7EE51909F6E6E902305B8A955795EB4E7ED7D11E46CB6FD1E04DC475A01E4';
wwv_flow_api.g_varchar2_table(14) := '48019E5786AD9FC1828C7932CCF53D7E0B809C00BC70A5B353282E6B6672CAE4898387F7D25C1F85B9EEC183030BAFB27E259AAA33F51BE6DC35CF320F9EBB00022F786C273F9E9FCAC05C7B9EF78D91E75EBDFF6980FC9563BB0D9F0E99AF82B8EE47DA';
wwv_flow_api.g_varchar2_table(15) := '9139C394B84654453B379907CF5913CA20F60E5CAC5D4F6159F36EC70D7A270EBE7ABF32B989408E14E079C3943945D682371564B120673BEEF6BCA077E48597F791C91C4D33303952805B95C156B516DE7B2D5101B263DC2323070FEDC756239E076A3C';
wwv_flow_api.g_varchar2_table(16) := 'C89102DCDA0C5E78EF59A20CE47198EB6CFB0EC7737A479E6B0E902305D832A1F5BEAB08B28A832CAA451993DBB73978FCA719404E000654D5045945840B3F66303993DBEE384EEFE8F3AF3DD848739D000C802C832B215BD8F90C268F8FC15CE7B6E169';
wwv_flow_api.g_varchar2_table(17) := 'A623A3CFBFFA70A3404E00068EF36C362C0C69E60ECD3541CEE4B6A0FEDED1838D013901187844C1E0195A500A7236B7D97800F9CB2F3F123793138049B8B9B70B676077CB178A20E769AE37E331ECDEB1E70F3F1A27C89102BCF099E42D8B2A868C75EA';
wwv_flow_api.g_varchar2_table(18) := 'BD828C152F35D7D94DE2F8AF8F7DF995C7E202B9B63F5DA9107B31D0A8B8DE1AA7C5596DF4DD2D32597DF21D00FB1F260F1EFEA2E9F9C31FF38101A89613021E75E391021C75E716557D33412693FF007F0DF25F78F407CB9AF501395213BDA800A9C760';
wwv_flow_api.g_varchar2_table(19) := '2A4086F7EFC5DF42FD062E07F88BC6A01E6BD709C04520EBE4838BF5177E4C833C8929D406C4F087EB0972A400C724A24A91D57C6EA749314610045924055F3C994DE7D62BC82FBCF2B865720F981C44864B641551CA318AA86650A72B805A7267B7F0E0';
wwv_flow_api.g_varchar2_table(20) := '3B9574FA63AFAA8FD4EBF697BD1FFE0E8F2CC77F61F9F0F7F491B7C2B2F8CDC9592A9FB720E33D0987F32F1CFE4DC830303DC67F036F1B409E9A53A400B3F3AD9728524E85296FBE8EC22AAA3D5AAAF17BFABCF2B7BD3B7D3F2C5F9A8FD79883ED147FDB';
wwv_flow_api.g_varchar2_table(21) := '1F46DA3885CA6572EB7CF15ECFBF78E84966E49E72143E3952807508EC5D93A7324534F89342C7F1F907A48EEBFA068BC70DF8B8E393E313B95CC72A58EE57267B7A15644E9DA874B588F3B69C26516204D9019FFC8909373F3498F7C50CE3AF48C9AA58';
wwv_flow_api.g_varchar2_table(22) := '13FB11F6674C6438E5B86B46A626FFEAD297BE767CCDD70F9EE0C3F57C4D46B59DBA2D010E85A5EF079A9CCC986B03EEE8D454E0E14D05043D147A98AFDEC7627B81B441F53C58945DD0BE8D68F784ECF93028BC29A3AA6EDCB60087AC019E26E7A4DB8C';
wwv_flow_api.g_varchar2_table(23) := '7165D89BC41B1CF87291F06E5532ADBA108D71DA7165C29B9AC20B80A6AAAEA8A4E06D0B306510C248479701C07C1896207BE22BC864569C09FD01AE818B50CC84C084AFC9A8B61F910659D576A291E5083267260C66328E6B96B86D7899833110346FC5';
wwv_flow_api.g_varchar2_table(24) := 'FA8142D9EE689FEC57D96B324AAEDFEACFDB1EE0524191B100593ADDB60283E3E670696FA2F91D29C0AD2F0E1B5D2F2690230578867D89460963AF6531313952806347A28E0D4E839C86B9E68BFB5AD33E2500CFA1241664A7A57D7202F01C00F3D634C8';
wwv_flow_api.g_varchar2_table(25) := 'ADC9E448016E4D23360FC2652033BA6E2D731D29C08B25C89A0DF26926B7D6142A5280172B8343C0A741A6B9C646450B045E9102BC98193C03E4545A527C816993831C29C0A11016FB51990C70B9E2E53639C809C0556A23414E9780DCACE63A01B84A80';
wwv_flow_api.g_varchar2_table(26) := '59AC14E46635D709C035005C0932CD75B3313901B846802B4126939B09E404E008009E0DE46689AE13802302B812E46631D709C011025C0972AA09963513802306B80CE414E6C900B9913E3901B80E0057824C26370AE404E03A013C03E40645D709C075';
wwv_flow_api.g_varchar2_table(27) := '04B814E4A558D66CC4142A01B8CE008720F361DC46809C001C03C0A5207383224E262700C7047008323728C864323A8EC02B013846804390092E991C07C809C03103CCE6F822E9B8404E006E00C07CF2855B8D71809C00DC0080C3262B41AEC706450270';
wwv_flow_api.g_varchar2_table(28) := '28ED061D2BCDB5BEA525C2BE24004728CC6AAAA2B92E03D989F641BE04E06A5089B84C0832E7C761741DC99FF7A39FE11F9247DCE5A4BA854AA03CF04ACB44F5EF5D296B3A01B84C1CCD7082B7A381C999885E769798E866C0B4A20F8CA6272BAE557B1A';
wwv_flow_api.g_varchar2_table(29) := '3F836F394C84D1A2DD9A2BCDA86B9E3233F2A3727DF7DC2C8D2C242F8B73CEA35FB3F421ACEB666DB1689D52FC00A7D124DE2A670552312A024A41512078F54DF1C38B95C2611DA992EEB3AC8778748A316945629D6E217FD886E6C78DA99BBC63AC0D75';
wwv_flow_api.g_varchar2_table(30) := 'B30CCB322FFB33394B5EF6957D4BC118BAF8F05C3F85722C1CDA490FF7D8C718538984626A756058641C8252C030E0CA44E0D278A551065DE387BF29DC52C150E0633062D76FD8D2AC8B793AD2224BF0A9AC9675E611975E47DB2120CCDF8EF78E756666';
wwv_flow_api.g_varchar2_table(31) := 'E667FD57476D1B2CCBBCEC475776A6A2B5E13AD3E884C88D71F4B3A271D6C54B6D407909DA623D155958BC5E293E802958082BD8B94E244B10A8C91C7D98709F0327A3202C730D021E1C11BC154CA41B82A57042A0513458D529B203756962DD10E0D088';
wwv_flow_api.g_varchar2_table(32) := '98CB009D4C2A4D1EEAE8CA49B06DCDB462219091E131319F5DB716A52C3FBCE056BC367209DAC59BAB5419C15ED37FCDF68F0AC50F197E3D8F0F805DD329C17D6B2558B1548225ED0012A245593306E08747C50C5E1773EE8A55B42C5F68C7C1D63FC503';
wwv_flow_api.g_varchar2_table(33) := '305940D6E6D232F5FBBF2EC1C6B5307760A0B2B8629064EAD838DE1C09B0AE5C17E7E479313F3D21E60284BB7A094C211800E0838776CAD4538FD93AF8FAB0745ADC5F1E97D44B6FE21AEA74C914028F93C131F19E7840BCCFEFB7D7D04690C1037127CF';
wwv_flow_api.g_varchar2_table(34) := '49EA6FBE63CD3A99C87213603ACA7ABFFB98785B378A199FD4BCCEA9F3D2F6F7FF66CD743B948D4AD33F2CC1A615E2FFCE6EF177DC09A55B2E410EF7D836158EED534126A7500F94B67F50523F7A0FE33925B294CA733390D99168523C00B3AF1C0CFA1D';
wwv_flow_api.g_varchar2_table(35) := '2CEB127FD532089271220782EB65E3E409AEAB6904031ED82DE6D7F64AEAADF7C5F9C1075630608EB90AE166B312740174D605C1FA77AE53669B8B50866EB084205061C01802E0AF5E01300120859E498B077FED6E5C21E6FFCE8B2CEBB0DD1999809559';
wwv_flow_api.g_varchar2_table(36) := '2F3E943058B94C020023501E39DE2772051685669AF50E8E8AFFC45E997A7CBF041BD6A812708C8696A9743C1C222C96BF6C2958BE529C33E7C5FD8F0FD13FB0DC473DB3A6820C66BDB7B08BF101CC8122A92683A1CA605E80B60764A5266402AB0D4121';
wwv_flow_api.g_varchar2_table(37) := '93F03BC86624D8BE5926D7AD921414C3FDF6DB1AD09813FDE29CBB285EFB1698C13C640AA1B403F0F5CBC59CB82CB21C7579F8E401D846300B60997CA15D324B814F4BB0798D98F74E8BAC60DBE8C40818BB6105004B8B1985F9259860B1FBE1A969C60D';
wwv_flow_api.g_varchar2_table(38) := 'E5C53BF0884C3DF1882A988135321C13C6A16351661640629DB45468D380C91A04AA0BE1FDFAA7F8002E8C25E05A2B06683C98300EF4C6A8B867FBED5D46AE00D4EF863FEBEA14431F46761A08BD2307B63C0800C6C4FDC777207808EC127CDACE2D106C';
wwv_flow_api.g_varchar2_table(39) := 'CADA8276F8D9B5CB2D10A1791E06C0DBD76B7D7C3921DEE45A942A41F437AE16871130594D201827AC411D8C139002D4ED0C0D8B390FA561A00470FD27F7C9D46F7D4EFBA44AA08A68158266DF5C1A5437A3EE844AB7AC13D663A5B53674051AE9A3AD18';
wwv_flow_api.g_varchar2_table(40) := '52EC00EBB00ACA1BE0B581EEC05569FBEB7FB28CCAB5813929B0107E6DFF2EF1F6ED920002A2E693F9F46FDEA3FBC4F9C529F8B13E71FAFAD547AAA22038A35F0DD6C10C133032549903EC360360329220B2ED82F99734F3AF847986B9E41488BE338BF6';
wwv_flow_api.g_varchar2_table(41) := '510781253399C75CBE0280AF6A541DDCB709CC7DC8820BCB115A20E7F40549FDFBFF8AF3F35336F062B0C8F63913609D5BD6887FEF56F8612865170346F42586143BC033C644A6C104AA8FA619BB8EC8F6FC3571DE3E2EE69941997A124C4150A32083CD';
wwv_flow_api.g_varchar2_table(42) := 'FEEAE5E23FB84BDCB74E8A39F319F20FAB4F37790894D6617937CC33FCA9064B007A65074CF46A0B2AA7308868058AA01F7426E846D4BB69A5984F2EC2C4E37C25AD07FC654830FAD50B602FA3735818EFD1BDDA072A9CB647869F3A276D2FFFAB980FCE';
wwv_flow_api.g_varchar2_table(43) := '89AC42DB1DA8DF294CD708641E26FC67A7C5FDA00F3104C0EDCED9F1CE1046F417208178130954966832391DE134A81347061F9872C88A9CB8877F2CEECF3F4676489BF9A80C30EB64A4AC5B22A66F400C2C00EC2EF2D89A83E55D6060979D8E8C4F8139';
wwv_flow_api.g_varchar2_table(44) := 'AB35B0D336C128E733B07170C8B215E0059D50803BA1009C8E8D42D1E8AFBB11B8B12DE4A78B70CE007C4C85826DAB11AC6DB24DB12C00A782A5DE7C472D8ADC05EBC17130A6207BD967BA1D8E6B15EAE49CBB729E5C268CE84F289958937D9F7A499314';
wwv_flow_api.g_varchar2_table(45) := '24CDA37E10849079004641CFE0AD543FF95085A8C10BF3E2A3206E4424DE7F0373CB4BD6DC51A0600BE7A0C16ADCA39F0360FEB60DB806C614CA3A7D1701F2A03016308862039860FA6135EBC81FAC41E40C5F4E8BA2B1C210DA80A5D076B7204A676CC0';
wwv_flow_api.g_varchar2_table(46) := 'C08BEDE1E39CB920CEFF1C17D904CB41B7308C60EB321654F8E1A2CE67607E3FE6DA9770BC8697F673DE4C6562F91852A4261AE29F37CD9A8763D50F8556A8824063AE684E5FB60023F00A5380F9B47481E958CD72CE5ED2289A26D7D0EFC14F071BE057';
wwv_flow_api.g_varchar2_table(47) := '2944FA744E9DC822360C369A8F4E038CB5220F586521C382B5C84FE66125CA5F8FDF6DA88BCA4286AAFF85DFA41F4500A7BE99D31B068A880DD8BE8C00D4E5500A0460C1AE0DE2DFB3C5B297E69940B26D2A18834A2881F3C1A7623E865508176FC281D5';
wwv_flow_api.g_varchar2_table(48) := 'E11829C0213673F513466FAEDBE5F7201C4E3F8A8CE15DC849EB00085CF6337D50806B37C4DFB05AA741410600739E0D06CA6A44AF0CA268C22160737D449C4FFB05FFB58A9D3271B509D9821530EBEB318D3A3B04F6034444BA1A60012005F0065887B6';
wwv_flow_api.g_varchar2_table(49) := '82A5502A067034FD08D40C950875AAD9A5590643FDBB3620DA7F084A82730DDC909F20536118B8611E9E421CE0BE735257D76E3E172E1745B567683DBA0459CD9B60F8E6CD539681C2294D38D51AC8A276080CCB870626571359C2FB0418EBD2FE26F85F';
wwv_flow_api.g_varchar2_table(50) := '329F8B0FB8AED317984B73017EF8EA7580042029F8A54BECF46A0D8E08BAB40128852AD7193094CA126E2694F507D7D5F4173A8866749A55980FD3AD5011B47DCD17E6C731A61429C0184AB489539F6E04415C49A2800A49170C46C0AA0E9855F834877E';
wwv_flow_api.g_varchar2_table(51) := '38F48BC8475083B560E526AC30E510E0A028CDB7CD87B9F500FC2A9542A74B9C5E61C103A699D174B01451300AA8FFC552A9E983FFE5548779C3681F39EC7FC103F1E9D2244144235C9B860936135896445E3D7271830A82FB5A46C7313D96704CF53A46';
wwv_flow_api.g_varchar2_table(52) := '6AA26FA5936A5E67CBC831EBC70E9EC18F390F93F9880D6C54482C47F30AF6190630DC0DE2140420182C80081643B80AA64B983B105CDD81CD05CC6DD5C4D3D49F38AFCCE6CE9273A65FBC5FD969DB24D3D662EE7B17A273B64B2501839D4B88D22F0DC1';
wwv_flow_api.g_varchar2_table(53) := 'FFA21D6C1A982B500CFA7946C76C07269EE58AE67879BB38C74E49DB387C32FD2D94D0DFBD55BC07F65805D17153029153416B9EED2B768067EB84B2839BA66400171B2070DD4D8260BDFDBBEDA242B839013668E43C00DFB701D321FA4BFA61B0CD87A9';
wwv_flow_api.g_varchar2_table(54) := 'D5952F08DEBF7BB3F8589E24823493CE9521CDA74A8168D9F4213853A500C361A635EF4E2817C146292A85C1428A606D5A37397034170610A8E11CAB6DBAA60D65D345941D58EEFCA41F011D9649FB06ED94096D9A9F5E93E02F513F016652F6DA9F717D';
wwv_flow_api.g_varchar2_table(55) := '43AA4D90188C306AE68701CD1944AD5813F6FEE871F1776DB12B5000369C77BA3FC3B4045328151894802C23DB2C32180F04E983BDE1722747E8F4938D98AA30B00A83B3ABB010CA70B01166DD5F8FE912D94586728BEFAC9D1E291B3350A4131711555F';
wwv_flow_api.g_varchar2_table(56) := 'D532AC93AE821B18DE6F3F6C95F234CC3EA26DB90B81DDB655127C6E556141C55AA51889CBEE698A9DC185A1DAD669A97861125F5C004863256A05FCE7BEAD58ADBA07267407188A2E12789A3C30860B1FE6FDD376F100669260C91580710E66FA7E2C54';
wwv_flow_api.g_varchar2_table(57) := 'D057227173414D27AA553672B182FE50171F00164CBC83ED3B7FD30665305949B7A01D421ECB78280D01631FA948586173DFFF18CAB3D65A1AB21C79BDFB7689FCA923EEF7DF15731CACA7756130760147B6C7DF0D4AB1036CA565474BC133E29DFCB3DF';
wwv_flow_api.g_varchar2_table(58) := 'B397012283A26065B7063BBA76CCCD064C2F287CF7D8A7E2FEF37F5B50614AF5E1003292E6102697AC0BB02DA77E929B058C90215C830D0DE73404CF489868710A73154BA2D8E4E076A4328B0AC40FCD28DDC045AE9281F1F4BFEA7701122273F787EF0B';
wwv_flow_api.g_varchar2_table(59) := '57B3BC7BB763AA056B43A581124EFDEA1E28CB3A9483BBB80160A97C5847E7B6A3028CBE6843BA9D48AD8B07F1D801C6FF4065854841324A4660E4DF0BA69624EEA96AA40C70340A86B0DC0F3E91D4911F58A1E3E90C1560582687E9D2B94171B004E971';
wwv_flow_api.g_varchar2_table(60) := 'DF957553C03CD2FF623993F7351A66FB64B92A054C30C1D03D650045A183715C67D6F92F1FC3E1DA71B8BCD80EA5C1A33CA9A33F44BFB0EB75D71DEA8B0D2C0CFFF752AE9373CF57237AF68D0A436509F7A00B8AAA0B2F53EC48FD13553AB23467977193';
wwv_flow_api.g_varchar2_table(61) := 'F77570DCF50123757A42138C3B7609537320280293393502C00E98D4F6BDB7A5EDEBDFD100868FDE14C1A5E9E3922404CF273E74EA4321AAB9E51175707101ACD2C77F38DD81C035E1B77376005B8137ACD5607FD0175DA61C05BB39FF254034B1541426';
wwv_flow_api.g_varchar2_table(62) := '2A0D1E1FA2196E7BF9BB927AF7173A1D52AB83F28CE0756FB8301E02ABF36CD64DCB84BA9C01F613EBE79DE85B58AFADBD2EDF9132784EAB43C6404E8603E4D61DB5BAC24E29C8141297143915C2169CF3CB53585E84FF044B6519C0D5BDD41259504834';
wwv_flow_api.g_varchar2_table(63) := 'D700CEF9F49C385B365A60382F66448EFA9C8FFB6C530546E91F03D1B70E8DE93DBF13D137A374D4C59530F7E459F84F047A9C8655824036637BD19C1990D4DF7E579C87EF167FEF76046808AA10C5739A55643C058271AA3FBF86C78F4E613CEF1F1773';
wwv_flow_api.g_varchar2_table(64) := '0A960353AA1963291956543F2305B8A0E733FB46D6D0FFC124A7BEF5231B59560A8EA55801236A4C5F0C842FD8ACC763FE16582D4F3F364B5266E5C479EFB8B49D8432140057534C8519842FE58E4EC85E1E09362DC4F77F22E9773F42A5B8C6F669BEF9';
wwv_flow_api.g_varchar2_table(65) := '301E7DBFFA5FB4494B519A0AEDE95AF8F7F028D15B1F61FD1B9B14789A443AB1D9C1655424551A3C15622E43592F82B57C889055D1ECB34EB657E71429C073F6B520247316BE902CE4402B07C86BCC472113A495D072B290010A81AF147469839C4373F5';
wwv_flow_api.g_varchar2_table(66) := 'E824D841005917EBE7918FD312D0CAF6F86C17F69FE512767B989897657593DE82A4D767FBE218A800FC70B1859B22980B6B1BEC3F53D80F0675FCF0E9501E69056653705B2AD2EF48012E0C6BEE0E9249F36644060A8002526051E55CE0B2456455A5E8';
wwv_flow_api.g_varchar2_table(67) := '9E6548641CEF57265E2398D8752A4B6C3B0CACCA6E549C848A4A905907EB63591E99384EF63B1C2FC753E9623463FDBE669146F58D85E39AB3060A7BBE146A77A970E62BC3FB2CB7D0E89442E7A79A1402C7691451E479788DF5B1DAB06EF66D3E256599';
wwv_flow_api.g_varchar2_table(68) := '8853A400978EADA67E36401091F5F766BAD2A031C13145976E36B6E85A486A5AA80422053832062F741449FE9B4A2052806FDA4A72A3611248006E98E8E3693801381E3937AC9548014E82ACDA718C5A8635017CF4D8B1E9B80A0BC9D327B50FF476ADA1';
wwv_flow_api.g_varchar2_table(69) := '52866532AE422835017C60CF1E55386CEF719F407702ABE84352A44402218355A6B81ECAB824CB827ED6B4D0116A171E500BF0A01A131BE717B665F05DA98EBC9BA4B924606508E951A6CC18CA78AE4273DDAB8DC17240EBCE65DC9358A8F9B82D83CD01';
wwv_flow_api.g_varchar2_table(70) := '2CCEE987FF7F72F83B39DEB22C2843CA9232A5300F1464CCDFD5A49A380645435FAC651E7DB6E70B26302F6533393C908CAED45473354369F1320599E5C7C786600EFFB8FD50CFB738A252195733C29A6128EDC0E8B35F7D10CEF829586AFC2596F83599';
wwv_flow_api.g_varchar2_table(71) := '876A46D3A265486F24076CB9E67AEEBFA45F7BF15D5E28952DCF1B96D8918635BE481B8E4AA6FF0F7876019225278BB70000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72346480960797157)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/dwg.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D00001568494441547801ED9D598C1CC779C7ABBA676766B9BB5C8A94C443A4451D1445938A65391244253064090E04C33694404BDB72003F242FC95B8088';
wwv_flow_api.g_varchar2_table(7) := '920303DAC73CE5C10960380E82248E48451B18B6150776048AA425C8811D381222C2272552072971B924977BCDD995FFFFEBAEDE9E3DE7A89DE9D99D0267BBBBBAAEF97EF57DF555554F532907C118A51D14D3D122CCE8A8B71EBEC74221661646347A4D';
wwv_flow_api.g_varchar2_table(8) := 'A168AD0CF35D7E71E4019C7D5E19B305C740294FFE355A66DDE95103AB6834308B3126088CC9FB99FECBFDFD377F4B3F3A7ADE7C74C437662CB0DFA7D172D398BE25CD4BC29DF8EEC813A0FC0F5B86B2C3FCA21052FA83A92AE36D5665BDF587E8907FD6';
wwv_flow_api.g_varchar2_table(9) := 'FFA9BF3E674E8E66D4C3A3D5F502B9250CE685115F1F19AB8EFFF08F767A45FFA5ADC3B98313D78A6518EC26F4AACDFDC1B00B56023F3B3CB77978E750A91CFC04909F5C6F905B02311631098AEA76A3CCFE6B5325A8AEC065B9E9FE68A3617132B0D5AA';
wwv_flow_api.g_varchar2_table(10) := '5C0EA6F39BF3879536CFCD9DFEDA6DFA53A315756A14E6BAFB7D8B96008F8C1C94B157577D680386E2D01EF06F577CA4B95AFBE89CBA303567F283B9879429AD2BC82D011E1B3B2332CAF85007F82DC25590B7D9DCB6501D9C2DE6F6D07A402E54F383FD';
wwv_flow_api.g_varchar2_table(11) := '8709B970E2A93B4493D50B5DED5DB704D86A3025D44D74937D504C8DD6C6F33015800D2A4C1372FE70E07BC7274F3FB54FEB2355D5C5905B024CB0B54114BA362A8557C9561236B4389CE819F11B0472FF60FEFEACF19E2B9C7CE6CE6E86EC18700A69D6';
wwv_flow_api.g_varchar2_table(12) := 'D12428AEB85338903764024D9E9A8326E7EE872B76AC9B216F78C0D466D1E0DA8EE0D1672C4C17ABF981DCFD8132CF175E3EBA5F34796CA4ABC6E40D0F982A2B1A5C0B9857948D2ECC14ABFD43B94F049E7ABE78F2AB7773DEAFC6BAC7F1DAF08097D160';
wwv_flow_api.g_varchar2_table(13) := '8B3B840C4DC6987CAFD1C1F110321CAF2ED1E40D0D581C2CAA29C7E0E5430C3937900B219F3E7A20D4E4F49B6BC7805792D3F212ECD49DA437BD4A1B42C830D702D9E87F2B9EFCAB43F390B90C90CEE018706ABF678DF493DDB08116CF431ECCDD139AEB';
wwv_flow_api.g_varchar2_table(14) := 'BF8C201F81E3954EC88E0127455723D3545D24A136D8E2103256BC7203D94381F63026A71BB263C049D1A58A694D631A845A9317179EF2A215AF81BC409E7EF9E98FD15C8F8D1DF146F1E0C0C20C9DBC4E5563DA25886437E479C3E6152B5E30C81EA650';
wwv_flow_api.g_varchar2_table(15) := '152C6B1ECA78EAF8CCE9673E7E04909FFDE819CDA743DAF55D56ABC771435AD48DD55ABB06F7D9E255BCE8256BD5C885AEE16331A4921BCC1DF00273AC04C8A2C92982EC187052379694CB3A8B9C879C1FCADD5D05E499134FDD474D56CF027F0A34D931';
wwv_flow_api.g_varchar2_table(16) := 'E0EED3E0B8C735D1F470A7B116B2EF7BC7664E3D73BFD6A3411A203B06DC1D1A9C6419B7383E8991AF7A2268A5B079C830D7FBB1B99C1AC88E01AF2A93542458C8B26127CB7E0BC025DA304490A7E878E5EEF495792E0D9ABC21015B243C52019B71B2A4';
wwv_flow_api.g_varchar2_table(17) := '8C186E588EE0D691E33590DB47C8B33F3EFA4027CDF586074C464D6BB0500EFFCCB38E341953282C6BEED3817A7EF6D4570F770AF28607DC92062700D79ECE43CE0FE46FD32A38D629C81B1E30C1B8D0E05AC0BC4A42CEED25E4B2D564D6D9A629D48606';
wwv_flow_api.g_varchar2_table(18) := '2C0EB0A05871BB90B49A0CB5902BA67ABCFCEAD3BFAF47318542680764C780ADC89A94479BB3CD8F9B94F65A559E803C98BFB55C56C7E74E3CFDC976416EF9C767B5621197A5362A855732EE46ED8A21AF69D3E721F70FE67617664AFF0A73FD65FDF0E8';
wwv_flow_api.g_varchar2_table(19) := '2B1C1ECCB3DCBE08B5DAB5B836A406C75021CD3553DC45A4E621E707B27B2AAA8A5F504093E5699251705E9B0D0AC78093A25BF40D5313D13EA80BBF7202F2A6DC1EF4AE6373A79F7904B168D2DA40760C78E1174AE7F592DDB06DD423C8B3A5321EC9BD';
wwv_flow_api.g_varchar2_table(20) := '0536E4DB6B09D931E0B649C969CF9169D292D49D5693288C905506FBC9E5FCA6DC2E81FCF2D147D742931D036EAB9412026BEE34EE8E1C07A30B1EB84BD4F0A78E7C5112291BE7109601E44239DF9FDDA57CFD2F8553473F4DC874B85EC06FAF91A6E5E0';
wwv_flow_api.g_varchar2_table(21) := '18702CB2961BD6AE02A44BF281398A9BAFA340C5FCD3F0A78E7C5192B012F982524BDFDC4CA9424D0E94E66FA11EE32DEE29BB98273B062CE292A6A7F98FED86D25A68AFA73DBC97C353BEEF07F895217F69D89E0FEB665DBEF64B73E5121EAEBF0913A6';
wwv_flow_api.g_varchar2_table(22) := '7F2ABFF63581CCB9323B5D2BB2743C0F6EA529EDCB4B891132A156AB25FFFAD4954260F4349DD9A5E469D32FD5427BCF1E17A6592E9EE9EC3D7B54D7CD745FC6DF5E9C2CFFCD3BCF7FE5371FF9E23F9F1DC32F2894C213224D860D09785E56106D50CC95';
wwv_flow_api.g_varchar2_table(23) := 'CB051F4FC29A2A6C247E266CC7C8F9643C8B29D446C7572BDD4FDE4B9EC799D9D9D0BD8CE9C3ED2A1A71C0F332BB71FB6CF81B6CFBB28C44863A4F372C609133D41882D5F9ACEEA380A70B810A10E7391EB8EA6401C05A65F18866B152AD54836AA5DE7C';
wwv_flow_api.g_varchar2_table(24) := '2BA5DBB0802914BA38F49603284F16BA3380479E63C8BC17498E9D8161A96BE928B8B7D2B19EBC4C8332F0EE2EF8D36899ADCBBE2683F79B091DEAABCD34756DF21032075E3A3339E8F1601E2E17241CC05CCB801CDD13678703F4826B1BBFD2D1DE5B29';
wwv_flow_api.g_varchar2_table(25) := '2FD3002A5AC34AE643F23519F3B1F59F6D78C0495141C82A97D10A90C54CF3BAAD21AACF65B58E01BB6C5A5B451B57C66FD031C849D58D5BD4DA8963C06BD0C2D6BE5F53B93B0AB9A9162F9FC931E0EED7602B2A810CC7AB13E6DAA59A3806ECB26956D4';
wwv_flow_api.g_varchar2_table(26) := '9D3BB67D4C16FDA01FE72E3806ECAE616929A9AD9A2CFAE1126FF8261987B274DB38870D6BA928D1E40E99EB961A8ECC8E35787D99E8A470BB15B263C0EB53832DE88590B9ACE934B82E0F8D730C78FD6AB00569210F613104CBC64B6F4CD8C48D1ED740';
wwv_flow_api.g_varchar2_table(27) := '7C8E0137FA8DBA333D2173ED7AB01F7BC8AE21D72C54B62E9F1EE026652890B12DE014B29868B776BA07B849C0CC461459D7907B1ADC029135C82A90B941E1C25CA77F1EBC0612EC8222DD9A6BB79E56CF443BEA40EE34B937063B42E2BE18D16457E6DA';
wwv_flow_api.g_varchar2_table(28) := '51F37A1AEC4890B6180B79A8E931B967A2AD2C537B24E43E687273907B263AB560930D13C898420964FC0885D7F5859E06D727A714A42253D1642C6BFA0D407689B83706AF714788CD35D7AE57831C6979DDCA5E47DB7B80EB1052AB492C643EFEB322E4';
wwv_flow_api.g_varchar2_table(29) := '48757B1ADCAAC43B90BF6EC85800ED69700700B9A87221E4A5F7935DEAAFF3FD60176258DF652421F7614CAE812CAA5BFBCB8656A5D11B835B956013F909B58FBB5018936B2047CADB33D14D08354D59C891103985B290A9D96B117A1ABC1652ADB34C31';
wwv_flow_api.g_varchar2_table(30) := 'D75C0CA9F1AE7B63709DE2EB8E647C6925FE0775814CB38D1F813BDDF2EF697087FB8135D799C85C13768DE3D562FB7A805B14A0ABEC34D75C04E1DA351D2F576143FFC2DF95105D95236372B49F5CC12FD05D841E60175274588668325E31D0E7B941D3';
wwv_flow_api.g_varchar2_table(31) := '33D10EE1B82ACAE58CC94D3771F5CD1695D3E857B5538C46F2D93C8B2A4F4424CB4BA65F2E3E91B5C3A729054CC1C1B8E81C3E4981AE202D83B70E99729840F721DF2A5FCD708CC3FBC50CDF31C6FA96AA278AD759DCA7B1E3B5FD30BDFDA02C5B3762D3';
wwv_flow_api.g_varchar2_table(32) := '14569142279A4A0142981458F922CEF9BAA8D54612E4F18695F287C20657AE62917772997C51F9BA1F7906900747825A0408E9D851182AD7A2F242C7872530845D026D93BA51560A430A014770FD41A536ED8314D9C4D53C4A88BA0C08A50F9116E7FDB7';
wwv_flow_api.g_varchar2_table(33) := '631D700BA02D932F40A7A94E213D3A50F12C20236D661BD2539B990765106EE53A2E27F056963BD1964F289DDF8A7403302A6853800E589956A67845A9B977C3B4A2E9163F8A49414819606A0DCC7219021B7A4CF9773F09E10274A588784E0E97121E60';
wwv_flow_api.g_varchar2_table(34) := 'E0D574E6C2CF54F0DBAF230DFE63DFDD7FA2F4CEFB00B1B4B48809BE3C0338D794997C47994B3F566AF617807733D2A383E11D96AA3C8EBA77296FE7934ADF78109D661BFA1A4C35DBC1FB28C3B0A304E814D31754F5EDEF2975EDA75147A1D549474819';
wwv_flow_api.g_varchar2_table(35) := '600805C233C1ACF2FCBCD2033742C830BB0218422560CB185CE549368ED11EFE13B9DC665C9688177986951EBC29CC476D5C18381741B4BC43F8E67B94D9F17115BCF51F00FD03683EDECF5DB9A4D4E021E5DFF5C74A6FDB8FF22126760AC9375F9E669C';
wwv_flow_api.g_varchar2_table(36) := '0FE83968F525BCA17FE247008C7A5314D207180435CD23CCA52917C01B4D246040948F68322428A0091C02A7E02D796A17351779251F851D7582882A2298065A4640284FDF70BBF2EE7A0251D0EAF11795DE744879FBBEAC34E08765CD8590D9066A2D4D';
wwv_flow_api.g_varchar2_table(37) := '79729E5AC535E36DDB58674A420A011315DF2308707C2BA8054B2D9DFE409959984E45338983D5286AFDF573E80C30E7063008D97E98AF8CB1F2C2EB187367A061FDD0EE5D4A0FDF1A6A1F3B03E2F5E00EE5DDF288AA8EFFA3D237FD9EF2B6DD05B81867';
wwv_flow_api.g_varchar2_table(38) := '791F5A6ACAB3D0F0FF433DE743987E0EA3C9103A07347C0063B31776CA94708D9B914AC002D73651B41317D04273E90D159CFD5B4082E926644E7342D2E135BC688208351A51D46A82465C70FE3BCA4CBD06DF0960BDACD27BBEA0FCDBFE20820C90A847';
wwv_flow_api.g_varchar2_table(39) := '0FDD02D09FC6076938DED20A44E082732F2973EE9B4807CB22B5620CA6B395BB43E92DBF83F11CCE18C7F045DE38DBD1B9904AC0A10021149E240320180850D3B1110DB680696A1101988C5E1C108B2991F67702E80D807156A977C79481F3A4B7DE0566';
wwv_flow_api.g_varchar2_table(40) := '1CBB5159060E5E1E69A0E5C81016C37269CE277FAD4CE582D2FD0F495562A6E9499760553E3C8F72E18973DA65BDF0C58DE8484C2A01C790E293A46C18197D287C09F81AF1746A61AF889288F70B334AEDCDDE0A0E05650A5361BF6079CC86F2F8DE6855';
wwv_flow_api.g_varchar2_table(41) := 'C5981FE9A98CD330C7DEDECFA163C0F99AFE79A8A9DE26294B7970AAB8C822F3752924AA301D8754028EC5C49364F0FB00075EAE8F450D9A5E3A49021B9A5CC5D88B8DD465B7CBC50B463A3A4895CB2803E3671690244415E1604A5820997A1B653D0880';
wwv_flow_api.g_varchar2_table(42) := '1806380EF3FDC2371D507EEE2F5470F1BF3154BC8AB9EFAF51751EE56CC611E9E8ECA530A41270AD9C22ED023CBDE37795BFF56E08341226C767403785AB9803BFA0D4F5FFC52D8C9D8B02D26161C354DE91ACC64C2B6FC7134A6FDE8DF84AA4BC28B370';
wwv_flow_api.g_varchar2_table(43) := '0D0B1F30B9E357E04C7D1263EB5E808E3A05DFF78FF4FED01F2AB3EB21158CC3E1FAE01434FA0D74801BF0016CD1E274814E25E058443CB11FEA661EE35C3F3C561B641E8A71936326E6CDC614A1D81C3F13413A411E0B168F2AB3158B1F5889F2063F82';
wwv_flow_api.g_varchar2_table(44) := 'C58B0338071498630D13CC698E1907ACF287C8DCA782DF8C296FFF97001516C34E832AF0A8E1D9D319F387762AB31DF3E7F75E51E6BDEF203F3C741F63B098EBF81B241AD299D3540286BE0957512D5EC40182B3DA2B71D1B5C42D2554C4C124EBECA0D2';
wwv_flow_api.g_varchar2_table(45) := 'B73D861C288CA65D162E704EED2464C405177FAE82F75FC43D2CAC600830132FA9EA9B93187B1F0FA74C7D9139E77C9763341DBA81ED580C795C059BB6A343FC3DE2314C706D3B4590530938E629279630FCDC598C9D45AC215BA0A2C1A1895658A49031';
wwv_flow_api.g_varchar2_table(46) := '51C6E54409D46042A5964A3E5CC771983F57E6E00573FAF56D682FA73AB01006D3A30CBCE9EBAFABE0CD33F0B61F517AFB03B2202256C460CC25E80AD3C101DB7D18D3EFCB2A38F70D5405B31F76CF44233A779A4AC0B12EC6271010D79B3FF899AA9EFD';
wwv_flow_api.g_varchar2_table(47) := '3B38CC9C07731A4327CB06AC4865B6601A4A139B08844AC7AA04184C0FB82680A92D03ECCC381CA6FF8169FE2FC4239DC08553458F9C9D403620CAE80098438FFFA752C30FC2D43F0CD8F7860E1AA74F5C6583B3E66DBF0FE960F60BE7918F9E353DF1E4';
wwv_flow_api.g_varchar2_table(48) := '1748B4A98DA7A904BCF4F7A726631C262C6AA980B38021486A29163E643E1B17803C30C7666E121A0A400558002C5C980AAC40F122AEDF02736AE12E68389C336B5AB98BC4B19C1FD693DD8B7B007FF515155CFD91D2D37FAEFC3B3E8BA11A632E57BAF8';
wwv_flow_api.g_varchar2_table(49) := 'FC14D6C275FF6E15CCBE893660C12325A18B005362C497C15F9848BB102182A4D9853681C5E269122231D53113AF6125EB3856B21E9472C2BD6058824CB4C4C8FCD2712092FE5BD101DE83D6A313103EE6CEB2CBD50F0DE5C2C6F96FA860DB3DF0C43F86';
wwv_flow_api.g_varchar2_table(50) := 'B2A9A92C12F5A033D5ACC285773AFAB78B00931EA62A0ADAA5E0F0701CAC59AA042878BF48B53850BB733B942E7F06C0E0898BA642EBC41A40332530273A4A30A5BC3D5F41BAAC0ADEF901A641AFC30C631D9A756313C4607F580F3F86E11E7371760806';
wwv_flow_api.g_varchar2_table(51) := '6685C3663826A72CA41230C4BC1814057CF3BD98E27C1D37698EA3C0B112736135770540BE87A1EF17A136D9FB7224389AD2597C6076979BAFB2DCEA343AC30DD878B80F206FC77EF1798CD5EF2BCD0510042F7F23A658F760AA04278CE6992D653ED4AF';
wwv_flow_api.g_varchar2_table(52) := '66DF460274A01ADF80B93A17520938D44240213C6A153505FF3D991EE22ED09E505ABC259A837B7D39985F98D30B27900EE32C03F330BF2D837134A332768735306A718048B87A058DD483DBE5138EB330E10C1CAB39CD621AD6D1870EC3CD8C8B3F8159';
wwv_flow_api.g_varchar2_table(53) := '3F87F11AED930D8795EA9092DAF227858031CE72EECAE53F0A93D31BC2E4D6218F022C920DAF19EC51CEA155DC01E2C601D3F2286328F327134ACE457F0CCD3E97286915B8B04188B61D523EAE397F16D0F0EC8BD7313D3AA1CC45CCA1653709F7A5413D';
wwv_flow_api.g_varchar2_table(54) := 'C08B842B1110A8C6AE8CA9C29CCEC0A129C3E3A5294C9AE5644E010088B3972078C2BD059A3481BDE30B212082E21E32EFC986C47290198FC50BEC299B8BAFD26084DACB3D5F769038A003721709F599A90B480BE7EDCA29DCE58209D351D3D301170D81';
wwv_flow_api.g_varchar2_table(55) := '4B9AAA00C1E0B11B95D90E01FE5655CF7C13B2A23345AD584E6821180158820394DBA78277A14D174F46F9A0B9845BE21489CE19B46FD980B2D8B9264E2A73F55530DB0B670A636D1F3614B83FCCC0B96FF93AD642DE471BDF46D9E8803EBC717902335D';
wwv_flow_api.g_varchar2_table(56) := '70D9DC9401669320646A1A97FD66E0305143052EE2E323D3D940F0484301733F96C722B4770EF9652A159527F7007BD580F4DC21E2FC78E697B0046FA0451C32608E51BF3C87C572F970203B0C9FE19236A60F2EBF6A0A01B3591114AE24C55009D2428E';
wwv_flow_api.g_varchar2_table(57) := 'D22CBC67A73F7C748790E2F4C827F798AFCEC08D033EBA4BAC91A316DA10FCA5A366EB967293EDAAB3FC36254B29607EFB26A088D0287C98E1154DB1245CE10FEBC6382BC1C2B4C9798F40F96158783F8C4DCBDF1403EEB48808CE060BD35EF398BC9F8C';
wwv_flow_api.g_varchar2_table(58) := '4FD7793D8352BA5ADC6B4D4312E8016E485CDD97B807B8FB9835D4E21EE086C4D57D897B80BB8F59432D760C78296FB3A1F6F4123B96404B80C7C6CEC473059C806E7CE9B8991BA7B885124CCAB81929B4047864E4A0A86CA56A7448B7C7B81908711ED1';
wwv_flow_api.g_varchar2_table(59) := '1211A9A24C196F651CA769F0A4A5850EDBBB8C5F45AB3CBC854FDAC416E2C3C3C2FED860EB365E72BEC91001073F7CDF9D9571B3A26809F04854AB57516FA98CFED596A1ECC1896B453E5783D083DB3014FC6E1632F4AF4C167FE5E52053042BE386CB8A';
wwv_flow_api.g_varchar2_table(60) := '32B44401BD8DBFD5923E77E9BB234FE0358BDF1A1ECCF29995703DBED9566DC07CA1E6E22D1053A54940F9D36D8F8FFD3BC590947133626909F0C2065C7E71E401E0FE3C5A850794B9878721BEA551BE99AFD46579B81B2ADB9D9094D6D760F8BE7FE3E7';
wwv_flow_api.g_varchar2_table(61) := 'C67ECAD856E1B20C27810D715250AF905802AE64FAFFB1F36DC4065DFDFE0000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72346910935797160)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/eps.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D00001215494441547801ED9D596C1C451AC7AB7A1C7B9C3821E14E488040B21B703836282159969BE5568410B6B22C525E40681F7908710069CD03025EF6';
wwv_flow_api.g_varchar2_table(7) := '095E20126421175E212E0112020208582E0901E1100A04C4BD0939ECC4E774EDFF5F35DFB83D6EC773F4CCF478BAA47677D7DDDFAFBEAFAE9EB6521138A3948E209B9A6661BABBBDA9F01CF9422C1B0C85824C70526A4F47C70AE579AB9531B3E1EBE717';
wwv_flow_api.g_varchar2_table(8) := '16A77BD4D9F78D49A75A5BF7B4CE9FFF68EB7DF77D673A3A52AAA7C797E789537D4BAD4B59808370F7AE5973933166E3ECE6E6A35899B2322EF5698A4DE7FBCA6F6B538373E6BC9C4AA7FFD1DADDBD1B9ADCA4BABB33530572591CD8E2754F4FE67FB7DC';
wwv_flow_api.g_varchar2_table(9) := '32D71B1E7EE5E89696F6BD8383C390B357ACACAB1E5FC3F08C8CF8A959B3FA67CC9D3B733893F92F2AFDB7D6071E985290CB02D193A5E20F0D9D06EDFDE3FEA121FA30CFF81FC66858A0265678D8F7FBA6B7B6AE449FB2B9FF9E7B16EAEEEE1168718A16';
wwv_flow_api.g_varchar2_table(10) := '8AE1F5ECCA02DCD1DE6EFB5E0D61A1CF655F4CC7535D1CAC241E2085C6A90FF5F7ABE92D2D7F1E1919995290CB02DCB373A765DAA435084356829898EBCB59391C1A18C8B4B5B4AC02E42D07BABA16594D7EEAA9BA1E5D97055834982CEBC99C59B3C34A';
wwv_flow_api.g_varchar2_table(11) := '671B246C8FF1706D7071687030D3964EAF4C29B5E5C0BA758B75676766471D9BEBB2005346F5E8ACD909549C263A7B4B79D05C6766A4D3CB53A9D4E60168F2A5EC93EB54931B12708EAD71BA4C0DA61FC6123C7B1C4F58C82D2DCB47A0C9844C4DAE47C8';
wwv_flow_api.g_varchar2_table(12) := '8D0D386BA2031A2CEC1D6498EB19846CCCF6831B362CB1903B3AEAAA4F6E6CC0791A2C74B36767AE09399D5EE6F9FE560B19F3FE7AD2E4C6069C2519A2C1C23A08F95CDC38C834D775A2C90960A0943E58A8E69D472137379F8BD1F5D6DE0D1BCEE40A9E';
wwv_flow_api.g_varchar2_table(13) := '853C3A40CB4B168FDB0470611C7290A703320663DB7BEFBA6BA985DCD9E91DC10214967B05633524E0DC3CB838C1E62063E0B554A34FAE07C80D095826BDC5F1B5B11D64AC78D50BE486049CD3E0D29656DD142A00B96FFDFA73ACB9BEF75EAC6E76C74A';
wwv_flow_api.g_varchar2_table(14) := 'A6B1AA4C091A5552929C0667A74925F4A19C0B7B58D61CA126638973DBA1AEAE3F81AEFF4FACCFF3ED90922A568144B1A948059EADE02C27194587E6833458BC362942C606C5126C356EB19031BAE6264C5C20278043F115E8190679DDBA659D9C42C1C5';
wwv_flow_api.g_varchar2_table(15) := '017202B8409661D16C5F9E0F3995DA0A4D5E4E731D07C80D09B8CC41568E35FBF27190D3E93F64CD752C203724E00806596320DB1BD1E48101F6C98B007E335E1AA839E486043C4AC7A1069B9C52E7C28ABCC8D7648CAE17635973F3E1BBEF5E21E6BA16';
wwv_flow_api.g_varchar2_table(16) := '53A8C6065CFA34691CFE9C55104D7653A8C5FEC8C836EC42ADB25328A4AAF6C0ABB101673145A1C163880721A7D30BB158BDE5701632E3551372029802AFC48E5010724BCBA9F815454D2027800138720DA69AD28D87BCB57FFDFABF489F5C0D4D4E003B';
wwv_flow_api.g_varchar2_table(17) := '1495FB3B16F22919ADB7F6AE5F7F51B520DB37FB2BF774F1CC9923DEDCA0A81A551C0B79FEE1C1C127FB376CF83B20BFC5EE01F5F10478D4D569480DAE2A5C2116808C5F502CC818B3D96A32A768DDDDA652E6BA2101E726BDA56D170AB2E2CF01C8339A';
wwv_flow_api.g_varchar2_table(18) := '9B17E0764B6F57D76568701583DC9080731A9C9D07174FAA8C14848CDF431D1A1A1AC662C849B879A2BF82901B12703E9E8A4C93F20B197B4FC84DD86A24E479D87A7AB2EFCE3B2F8767E49A9C0086A4A15439ABCD8B4A1DCC5AF266B1B86BC20FDE0879';
wwv_flow_api.g_varchar2_table(19) := '2EBE8CF06F40FE2B2173C0F514BF3610814B005388D9850E08DFDA4FAA57250E662BF9B2583B4FD67A5AF6CD907980FC645F57D7D50CE29E721403AF86044C2D0A38A33DCFC7A1F063331FBF32E48F0CF96BC3DC21F77296B089EE83FE722D67C99FF7E2';
wwv_flow_api.g_varchar2_table(20) := '8773AA7F787808BFA0381EF5787CA0BBDB42A626B3D105EA5AF46543CE83293142F600D51F1E4EF5EEDB37803DDCBEB22459B4E8C72738684CDFB4A6A613068786FEF5FDDAB55F9FBC69D3AE1EFC82021F86B16F888C4F31B94F430216B14085941A1C6C';
wwv_flow_api.g_varchar2_table(21) := 'C90C0CA47A331983B9A9868659F81287676910E217BC976B394B1C39E7FBE7DF07E3A1AB9886FB0CB4F80C34BEF9B8DE657F83DD231FCB90D8859F1B16B0081AE651A7D10FE2A4FA3219C5F76C6AD56FB1C135C3AA0C663223191C85639C3866C302A648';
wwv_flow_api.g_varchar2_table(22) := '0432A09A660877462A3506725E5F3DB114230A417DF061279562A3C3D4CDE62A9FC928B5885A35D652EB1B793A4286E33C49B740B06DA9948650F815370655F5601D3891CAD6C9562CF8990CEB51E49F86071C941775069015205B33ED742818A33AD751';
wwv_flow_api.g_varchar2_table(23) := '969B00CE631617C879D52AF936011C22BA9A42860589D22580279066CD20E7F5C11354AF60EF04F01144552BC82C372A97009E4492B5823C49B50A0E4E001720AA7A869C002E0030A3540D7232C82A904805A2E543E6B266E42EBB821555BE8906172949';
wwv_flow_api.g_varchar2_table(24) := '813C138B215CE7E57DA42ED1E048C559526684CAB56BAE78F1B58BC8219754ABF044890687CB6552DF8A414E4CF4A4B2AF5A848A418EF009120D2E539891434EFAE03289542079A49013135D014211641919E4448323A051A12C22831C61FD923E384261';
wwv_flow_api.g_varchar2_table(25) := '322B81CC79721CA65009E088010B64BCC5A7E20039015C01C071829C00AE10E07190A1D134DF85B828DFE948001722F132E210AA35D778DF19FF21AE20C885368442AA95002E444A65C611C86D05424E34B84C81D722793190130DAE05A108CACC871CBA';
wwv_flow_api.g_varchar2_table(26) := '9F9CAC644520E91A661184CCBE791C64F82526BA8680A2289A5009977DF238C8D0E0C4444721E51AE6410DCDD7E41C54808FD225A3E828A559645E02796681A3EB22B3B7D113C0A5482DC23434D79C1F1332CD357F361AA50E27802384554A5662AE0999';
wwv_flow_api.g_varchar2_table(27) := 'EF78F13C6EE0554AC6D93409E032841765529A6BBEA5C90D0A6A7254AEA17FE11F9510A3CA47FA648EAE477044E112C0514831C23CAC264383A745B4E0114D3389F00193ACA27DCF3ADE1A5C4C2B967E2B2C8D8485B59EB0F88CC734138585E52369260A';
wwv_flow_api.g_varchar2_table(28) := 'AB917F3C0153B0186CA869F86CD4648296F0E16107A4A565344D300C9F48721F12CC9334CB6882180426D330AF117CC5283F2C2F69EE9669F87D1CA6E399F73171F104CC01467FBF523FFD34B9C00886023DF65827D21F7E70F7CC43847DDC710E964014';
wwv_flow_api.g_varchar2_table(29) := 'E133CEC1834AEDDBC7CFDE395F823DFA680C67673A7F864B1862B08F1C838F65B3F13437BB746C2C52AE9453C373FC0053601432819D7186832510F305457F01C9C6408D3BF34C276049436113FAC0C0584D655E43434A9D78A252679FED349871098AC0';
wwv_flow_api.g_varchar2_table(30) := '99DF69A72975D4512E3FC647DDF001ABB175923A30AF9F7F0E2F87696BE4E20798A61982D2975FAEBC6BAE71D0089C20294C716C0804428D41B8BF7DBB32BB77ABD4CD373B4D2250E68574FE6BAF29F3C4134ACD99E3E0D09F9A397BB6F2D6AE557AD122';
wwv_flow_api.g_varchar2_table(31) := '07860D0466D67FE619E5BFF5964ADD7EBBD24B973A0D0D961DAC03B5379D566AEF5E9579FC71A53EFA48A9934EE227125D5912B746E7F80126380A67C60CA5A9C5D428F66DF98029300226146A0FE099871E52A6B353790446C1331C7DB277FEF92A0360';
wwv_flow_api.g_varchar2_table(32) := 'EAC71F1D648601B0BEFE7AE5517BD96FB3110194F9F453653EFE58E9B636ABBD9AE69D6141CD0DC2625EADAD0846E3435D0DEAC22FD7C6C5C5A726418950C328546A61F020300A3278301DEFA9C9DF7FAF7C7CB8D3ECDAE5E0B21FEFEB531A66D8BBF042';
wwv_flow_api.g_varchar2_table(33) := 'A50E1D725A053F9A5FEF820B6C0331D466E461D000FCA79F56E6B3CF5C17112C9BD76C78F97590F2598718BAF869B0088C9A4C4DE041E070E6DB6F95E9EDCDDDE74C34351C7D2635527DFEB9F2DF7F5FA5D8B7D274320C5AAECF3B4FA9D75FB7A6948D46';
wwv_flow_api.g_varchar2_table(34) := '5F7699D2279F6CB55FD34A307F68AE79FB6D67B265702575407DA89DE6EBAF5DE3A33FA166AD84DABF5F29D44D737046AD8E898B27E0A0702844C286D0FC575E51FEB3CF2A3D77EEA826495CC6E180089A6C5E784199F676A57158C080ACD12FEA8B2F56';
wwv_flow_api.g_varchar2_table(35) := 'FE830F2A7DE9A5CA5BB9D2693D359326168DC7473A6BAE690D82905807FAC122F8EC676921D07F8F89C37A10FAAC59AE4CD627060E35AA23476D617F4BE1D384CB59FA489EA14106DA6C0756070EB83E9CFED0526FD932A54F3D55E98B2E527ADE3C6772';
wwv_flow_api.g_varchar2_table(36) := 'A9BD30DDFE1B6F28F3C927CE34B38C3040042D65F22C07F3973AC44C9CF50138286C6A099DF8F14CEDCA9A716AAC5EB04099975E727D29E3320D0140F33507611C19331D0F84F95F7C61B55ECF9FEFA011E4444ED2F12C8ED71CEC49DDC43F06E7F89B68';
wwv_flow_api.g_varchar2_table(37) := '0A49CC344CA9D53C2E44D04FFCD9CF1E3EECC4492DE76816D0FD175F54FAF4D3953EE104D7D7028277C9256E84CC348CB7678FF25F7E5919A4D7CCF748DA4B90EC638F3FDE9DA9C174F497015910BC0BADE9DFBA02EC5D7BAD52181C594D11C098E270FE';
wwv_flow_api.g_varchar2_table(38) := 'EB3FFAA833B99CF2508B01C1BCFBAEF257AC50A9ABF13F2EB223737DCC314E4B0902F1CC071F2883C1975EB870142EF30E3AC6054C8DA95BEAD65B5D7A6AABC443C3F1918FBF71A39BDA31AD8405F3A9C175FC0153B81416046AE7A4722F42E44899DA43';
wwv_flow_api.g_varchar2_table(39) := '47ED9570A4E1F4C860D1C26045CC2E666441D9B8D070F3CD37765A64F365193C1827CC310C8DC45A102943E2C112680CD272F510FF189CD10CEBC851B03CA83D72881F1F8310828E26948328C6C9778CCBBEBB9851AF942D67A903CFF4CB2F3FBFCC1ADC';
wwv_flow_api.g_varchar2_table(40) := 'C75F8329B4ACF0383AB65A4281D29F07FB51AE35D3D10CD34FC27FFF5D7930A99AE657FACBACA9B62617832AEF861B54E6FEFB952668A69BC8B10E34E92C8B7949198C0F136D7EF945A9E9D3274A5D33FFF803A668284C8C82FDE79F0F9F0753F83C3892';
wwv_flow_api.g_varchar2_table(41) := 'A5F0D92F7FF79D5DCBD6CB97E7D233CCFCFAABED9FAD39A7C93DE71CE55D779D5D7FD6DC5CE0E02BDFB1D11022163F320F3F1C3E0F46F97690C6B831724768B231AAA55405C2D304C8BE367804B59690B9CE8C2911372B34173F38322620AC36F99C3E71';
wwv_flow_api.g_varchar2_table(42) := 'A992F1E0CF70EF8A2B943EE514A5386FA6FF4490E82FE506AFA5EF67238B99AB2FC014A0CC79696AE5A050A97959019BDF7E53DE8D372A4E91ECFC97FE00623712366D52E6CB2F47CD312C0335D75BBD5A294C9972263E0C14F3A13561B972963AB0E1F1';
wwv_flow_api.g_varchar2_table(43) := '8899AB2FC01420D7A2396AE646020F997F72218353246C18686AE4AA554E1BE9CF7E1A7DA48FE910FFF994BF63879DFFDA01181B06B45673E9122B5C764F9703B3302DA61FAD01372DA45CA9876C44C40C707DF4C13481D018EFCA2B9521386A0D9D40A0';
wwv_flow_api.g_varchar2_table(44) := '59459FEB73CF178325CE97ED562361302E1A8679EF3DA576EE547AF162A53EFCD06D09CA9C9AA61AF3660FF3651F712C40E6298E9A8B3C34165ABCDB6E73D6821A2CE5239EE6C20AF682CD73CFB93571A60D844B56D53EC71370D6A45A01514859C07655';
wwv_flow_api.g_varchar2_table(45) := '4A041B8CC37D5C6A2F767AF41D77286FC912679AA9F118D9DA8D84575F751ACE7933F2E45A3537F3B9CA6557B1D0103C6C4E183422FFB1C7EC72A72D9F654B1D009D7164549F3B931AB45E73558C3B4AECF763E2E269A209869A475349703C782D5029BC';
wwv_flow_api.g_varchar2_table(46) := 'A076C0DFD044A2DFF5AEBACA2D23322E569EECE8FB9D77DC1EB1CC79F97200B6067D6832F3E40A95CD1BFE766006536DA743C1B2593E8F60D9C13A04AF5DAC58FC8D9F0653503085EC6BEDDC92A692FDA8686E98D81887735EBE9D018D33D8F8B7031E6A';
wwv_flow_api.g_varchar2_table(47) := 'F6EEDDCABCF9A6DBA7651EEC73014A336CC70E653847E6DA321B08077038F459672985654E0EBA0CDFB362F99339D481A374CD461123173FC014265ED531E8CF32584A1CA3B5618213AD667F4BD0D8ECB770E94FA0006FFB542E42306FFA1332B51903AF';
wwv_flow_api.g_varchar2_table(48) := 'CC238FB86B31C5CC8303274C9B7CF6A77C498061933996C54D7FD908992C7E95C2E307980F4EF3CC3929B5A710D3C738D41C9EA9894CCF6B8221585A84B07C089365701D9980089F8D8069784818FD2773CC9F69B27DFC64D1AB151E4FC01416FB3B8229';
wwv_flow_api.g_varchar2_table(49) := 'C411806820DFB41098E2CF3E3DCC311EB7FF38280AA6617C1E7CF18E9A2E616179881FCB629A42B45DD254E11C4FC07C700AB590BE4FE28A96152B6081992F6C01C6F03A76B04B53C009DC29F028513FC2D4001CB554A6507E09E0290433EC5112C06152';
wwv_flow_api.g_varchar2_table(50) := '99427E09E0290433EC5112C0615299427E09E0290433EC51CA02DCB373676E89071798B826AE5C09E4049ACD2828E352F22E0B70477BBB853A628CC605B67412C6A54008A6B13F438507654A7F9171304E31D765AD6449EBC25B12781F06CE2D38907242';
wwv_flow_api.g_varchar2_table(51) := 'BA180AA3714545284B2B4391F16894E2AECA02DC912DCB6B6EFE063B345FCD6E6E6EDF3B3858C0D64B71956CA0D83E6498FA7D70F02B2B533CB8C8B85419E49BFCA2F24113A3CEDA96B677CD9A9BA0C31B5141FB3A43591917558BA911594CDEFEA1A103';
wwv_flow_api.g_varchar2_table(52) := '5AEB5B8FD9B6ED3F7CB2A08C4B79D2B239042BB0A7A36305B6DD5603FB6C98EC44938B21A2B50799E18D01FDFCB1DBB6E105B2F2E11653FC11E312F211232481454B202A99FE1F043029823CDF88DD0000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72347362123797162)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/exe.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D0000116F494441547801ED9DC96F1C551AC05F753B6D3B7136F684040824100888000ACB08909801890B9CE22830485CE6327F401207228D3920711AC189';
wwv_flow_api.g_varchar2_table(7) := '038334CC9045F120D0488811730031428346EC1020ECFB9A903D76DBEE7AF3FD5ED5D72EB7BBED5EAABBABDDF5A4F2ABAAB7D6F77BDFF7B6EAB23131386B8C1743366DCDC20E0F67E6C373940AB1613008453211CF98438383D79B4CE66E63ED32B9EB97';
wwv_flow_api.g_varchar2_table(8) := '1696A46BA9B3EF5BDB97EDEF3FD4BF6AD513FD0F3FFC951D1CCC9A91115F9F2749F5ADB72E0D018EC23DBC75EB666BED5F96E5724BA94C4319D7FB34B5A6F37DE30F0C98FCF2E5FFCAF6F5FDB17F78F84BD1E41E333C5C982F901BE2408BF746460ABFDC';
wwv_flow_api.g_varchar2_table(9) := '77DF8ACCC4C4BFCFE8EDDD70389F9F1039676A9575CBE37B62782627FDEC9225A38B56AC589C2F145EEB31E69EFE471E9957901B02311252F1C7C72F16EDBDECE8F83877C833F987B59E5820616ACC84EF9F1CE8EFBF51FA94DDA3BB76ADF1868727458B';
wwv_flow_api.g_varchar2_table(10) := 'B35828C23BD935047870C306D7F77A222CE973E98B71781D7150497980AC344EEFD4E8A859D8DBFB9BC9C9C97905B921C023070E38A63D9E278445568A18CC9DE59C1C4E8D8D1506FAFA6EF205F2D8AE5D97384DDEBFBFA347D70D01560D866527993367';
wwv_flow_api.g_varchar2_table(11) := '76A874D820C5F6D88C9C5B3901F242812C9ABCF7D8B66DEBBC2D5B0A2F77B0B96E083032EA44E7CC4EA4E298E8F0127960AE0B8BFAFA3665B3D9DD6343436B6FA34FEE504DEE4AC045B636D06534987B3296C0CF309E70907B7B374D1AB307C868722742';
wwv_flow_api.g_varchar2_table(12) := 'EE6EC0A1898E68B0B20F20E7F3854502B960CCBEE33B77AE779007073BAA4FEE6EC0251AAC74433F30D7025946D7D7657C7FAF832CF3FE4ED2E4EE061C922CA3C1CABA0859FAE48D45C898EB0ED1E414B0A0D43E58A996F8D3211BB337BF7DFBE5ACE039';
wwv_flow_api.g_varchar2_table(13) := 'C85303B49264C9B84C0157C7610A722EB7713C93D97FE28107AE7490B76CC9CC6201AACBBD89B1BA1270711E5C9B6003C82C86F4F65EE9499FDC0990BB12B04E7A6BE3EB6207A36B812CA3EB8E80DC95808B1A5CDFD2EA0CC82777ECB8DA99EB871E92D5';
wwv_flow_api.g_varchar2_table(14) := 'CDE144C9345195A943A3EA4A52D4E0709A54471FCA5C38732A9F9F4493658973DFA9A1A16B84AEFF27599FE7ED90BA2AD6844489A948139EADEA2CE7184597CD47D2C8E2B5CD0259FAE4F5B2D5B8C74196D1359B3049819C022E8BAFCA9BE5206FDB76ED';
wwv_flow_api.g_varchar2_table(15) := '16A650E2920039055C25CB72D15C5F5E0A399BDD2B9ABC09739D04C85D09B8C1415691357DF90CC87D7D9786E63A1190BB12700C83AC6990DD856AF2D8187DF25A01BFFB580234B92B014FD109500B9BA25217C36A3C29D564195DAFCB0AE4D3DBB75FAF';
wwv_flow_api.g_varchar2_table(16) := 'E6BA1D53A8EE065CFF346906FEA255504D0EA650EB7C9942C92ED44D6E0A25A95A3DF0EA6EC021A63834781AF128E4BEBE35B258BDE774089978AD849C0246E0CDD8118A42EEEDBD487E45D116C82960011CBB06A3A6B89990F78EEED871B3F6C9ADD0E4';
wwv_flow_api.g_varchar2_table(17) := '147080A2797FA743BEB0E0797B4FECD8716BAB20BB37FB9BF774C9CC99116F7150D48A2A4E87BCEA743EFFF4E8CE9DBF17C8FFA17B90FA641478DCD5E94A0D6E295C2516812CEF78AD2E58BBDB693253B4E161DB2C73DD95808B93DEFAB60B1559ED7E04';
wwv_flow_api.g_varchar2_table(18) := 'F2A25C6EB55CEE393134F45B69704D83DC95808B1A1CCE836B27D5400A20CBEFA14E8D8F4FC862C8F972F1F7D12642EE4AC0A5789A324D2A2D64FA35907B64AB11C82B65EBE9E993DBB7FF4E6EC6AEC9296091B42855D16A73D2AC83AC356F8A95AB1EF9';
wwv_flow_api.g_varchar2_table(19) := '2D149057C89711FE2690EF003203AEFD7C6D200697024688E1428708DFD94FD4AB1907D96ABE14EBE6C99EB7207C3364A5407EFAE4D0D09D04B1A71CC7C0AB2B01A3451167BD4CC697C3C88FCD7CF995213F32E4D786C543AFD5D7B04AD7D1FB7AAEBEE6';
wwv_flow_api.g_varchar2_table(20) := 'CFB5DE133F3B3A31312E2FD79F23F5F8EBD8F0B0838C26D3E82275ADF9B42BE7C1480CC81981EA4F4C644F1C3932267BB8271B9264CDA29F99E0B8B52717F4F49C9B1F1FFFF3D7F7DFFFC9054F3DF5D988FC82423E0CE3DE10999962EE3B5D0958C5222A';
wwv_flow_api.g_varchar2_table(21) := '644C3EDF5B181BCB9E2814ACCC4D3DD130075FE3E06B83D07BD16B3D575FE3A85F7ABFF43A1A4FBA8A05725D102DBE5C1ADF2A39FFCCFD067B443F96A1B1ABF7BB16B00A5ACCA3D727FDA078E664A16078CFA65DFD160D2E2756453E08335990A37A8C95';
wwv_flow_api.g_varchar2_table(22) := '63762D6044A29005AACD89701765B3D32097F4D595A5185388D4473EEC64B2343A99BAB95CF53319F516D1AEC65A6F7D634F076471CC93BC5E11EC4036EB8950F88A1B412D3DA80313A9B04EAE62D1CF64B81B35FEE97AC05179A13302D9086467A6031D';
wwv_flow_api.g_varchar2_table(23) := '8AC668CD799CE5A6804B9825057249B5EABE4C0197115D5B218B0589D3A5802B48B36D904BFAE00AD5ABFA760A781651B50B32E5C6E552C07348B25D90E7A856D5C129E02A44D5C99053C05500264ACB20A783AC2A8934215A296496356377E10A565CF9';
wwv_flow_api.g_varchar2_table(24) := 'A61A5CA324A39059E7E53A56976A70ACE2AC2BB328645EBB881D725DB52A9F28D5E0F27299F32E50D9A060593356C8A9899E53F62D8BD034C8313E41AAC10D0A3376C8691FDC209126248F15726AA29B4028862C63839C6A700C349A94456C9063AC5FDA';
wwv_flow_api.g_varchar2_table(25) := '07C7284CB252C88BE31E5DD759CF14709D829B2D1990E52D3E9304C829E0D94835109614C829E00620CE95741A64D168AEAB7171BED39102AE46E20DC4294296F79DE53FC45505B9DA86504DB552C0D548A9C1380A79A04AC8A9063728F07624AF0572AA';
wwv_flow_api.g_varchar2_table(26) := 'C1ED20144399A590CBEE27A72B593148BA8D59442133959A0159EEA526BA8D80E2281AA8C0A54F9E0159343835D17148B98D79A0A1A59A5C842AE0E374E9283A4E69D69897425E5CE5E8BAC6EC5DF414703D528B310DE69AF9319031D7FC6C344E1D4E01';
wwv_flow_api.g_varchar2_table(27) := 'C708AB9EACD45C0399D77FF0670CBCEAC9384C93026E40787126C55CF396261B1468725CAEAB7FE11F9710E3CA47FB6446D79372C4E152C0714831C63C9C268B062F8869C1239E6612E303A659C5FB9E75B235B8D6561CEDBB4AD346C3A2ADA8341E6195';
wwv_flow_api.g_varchar2_table(28) := 'E2C6912E9A470BCE930B18C1F748F516F0E92871E54004210110C22726E42B53F2CD3019A8B87480D2741AA6F0B84F3F97CB053ED784919EB8959CA6EBED9D2AB79A7495F26BF2FDE40246F8274E1873F468200205532A10152E8DE18C338CE9EB33E6F4';
wwv_flow_api.g_varchar2_table(29) := '6963BEFF3EF82891A63BF34CF9C28A4051E0E40FC89F7E0A7C1A0570172D3266D9B2001E1F35D2F45A2EE988F7EDB7C68C8F078D69523E69353010A4D37809F1930B18A19D7FBE31575D15884AC1A8C055E354A3103AB06810679D65CCFAF58166929A38';
wwv_flow_api.g_varchar2_table(30) := '3FFE281F2B3C39758FFC172F3666DDBA290D061E71880B5CAEB55CF2D1C684D65F7B6DD0602897C675EA94313FFC30BD5191A6CD2E998011EC2FBF98CCE6CDC6BBF9E6404408B29CC001811917ADF59F7DD6F80F3E68328F3D663277DE19985FC2E5F09F';
wwv_flow_api.g_varchar2_table(31) := '79C6D8175E30064D06C8B163AE0165EFB9C79873CF356674D498FE7E6345F3FD279F948F087E163414B4541B15E51F3E6CCCADB79AECBDF706D6828622C0EDEBAF1BFFF1C7034D261EE526C0250F30C294C322D8254B8C8736E2101861518DD2FB68141A';
wwv_flow_api.g_varchar2_table(32) := '24809CD91433EBD261926918A4250C93ACB0482330292773CE39815997F89E1CF6D24B8DFFF6DBC63BFBECA932D5840BD0CC1557186FF56A6380CB7DC9D7FFF557638F1C311EDDC46C7DB87B98D6FD491EE010A087E0803C3616484335186D554884105F';
wwv_flow_api.g_varchar2_table(33) := '0F951B82271D60F55018C4E15CFA4CFBD557C6BEF9A631975C1258877CDE995DEFE28B8DB770211F2A0D006AD9F4EDD218BC0B2F7479586954C4B3DF7C63EC7FFF6B3C4CBE36C2681DB55E6DF09307580503344C1DA039E7BEC0B29F7C622CE694FB3800';
wwv_flow_api.g_varchar2_table(34) := '029D7B984FD578C2350E69A3E69DFC24CCC324939FF4DBDE8A15411E62BEBD0B2E08FAFF9F7F0E066E00C6518668AF39EF3C57272F1CE163D6CDE79F1BB37CF9742B11A46AEBDFE40146F851C7358700C29C169E7BCE98575E09FA4D15BCC6C7C48A7975';
wwv_flow_api.g_varchar2_table(35) := '6659D311163DD7B8A4952EC01C3C68ECD75F078009E33E5ABA76ADB15F7C1100A671705F4CAF77D965C6231D6698BE5CA0DB0F3F3456FA740FF0580E6DA45A561B7DA979073940A1C5986ECCAC1E089B43C2DD37A0E77A2400000C0D967ED37EFC710006';
wwv_flow_api.g_varchar2_table(36) := '8D0422A656003B50E48B25C017B3EE61CE8987E5A0D1C960D0BEFBAEF118BC9167C25C6701068C0C8E3CE6A9CC57F5600ECA396617C157A341341601E4C9BCD97EF081B1870E051A0924CCF49A354E939D594653E97F2FBAC8784CDD2803E83436E9C7B1';
wwv_flow_api.g_varchar2_table(37) := '0266E9D200703565B7B011741660A0C8E2877DE79D602183C5063930B14634B1D85713AF1A074C1A8B68B0CB8334001270CEDC02997E17CB20A6D79967FAD970C06605BA33CF58141A01E013E6A4561DE054E8A235993BEE3076D326E32150042FD5CFC8';
wwv_flow_api.g_varchar2_table(38) := '39FDA57DF555B9256F4454A345C45133CD740933BD71633077C64C0B784F164198DF329A6740E5FA77A65700C54C639E753A455ED594DB62717706608482560AC8CC0D374C89887B085584EDBFF186B12FBE381556CD19E9C5794C9930D3320A77F35BB4';
wwv_flow_api.g_varchar2_table(39) := '56FA67FA5B4B7FCCA2888CAC5D1809C241971B847DFAA9314C9B009C40D759261A01225CFABF727E08AC929C039C91501A07E61633CD689AFE541B8DF8DEAA55C6C88286FDEE3BA7BD6EF10490523E73607BE04030A8A33E73941D29B5A5A79D0798D12C';
wwv_flow_api.g_varchar2_table(40) := '0B10F8622ADD881A93C935D067718273A60318AB57F4ED0C965811C3FC62A66564CC7489152F679ED9C8D006207364FBD65BC16A178D2481E699874D9E89AE2428E009C8C24B2F059B0A02A5A83568148B0D4C6358ECA8E454CBF0151471E5DC9351B07D';
wwv_flow_api.g_varchar2_table(41) := 'FF7D636FBFDDAD54590063A659D5BAFAEA60F14335551A8595B56A349E7067052A95D9E6FBC9035C4E20C010C096690903A9471F35DE8D37065A2B615604EED68D57AE0C3489F8A58E86C3C08C86C279340E5A2C661A0D76D0C42CEB400D33EDDD728B31';
wwv_flow_api.g_varchar2_table(42) := 'AC4B334AA61EA2EDFE7BEFB929565235571F3F7980A382D75A86BE13BA2C457A77DD152C4902469C33BD9CEB34A59C15A07130D5C194132F5A0EF1597B9670FBD147C65C734D708DE9C54C4B63429B5D1A1A08DB894CD5D85808EB105631719ED43661AE';
wwv_flow_api.g_varchar2_table(43) := '1C9CB08A4E2F113AA35CFA610E9606B54F9E25AD33C3A4D3FE3AEA878D839D2056A5DCA207E6581A82C7CE147BCB5CE324AE2FEBD70EB2F6C9414822FF264F83671193D3D4D27085AA3EE1AA9DDCE35CFCCC6DB719CB26BD82D2380CA864A3C0DFBF3FD8';
wwv_flow_api.g_varchar2_table(44) := 'CB95698FFDF2CBA0CF25BDC4F758DC203EE6593626DC420B1A1F2D2BB84ADCDFE40156C12B1CAE3930B198D6D99CA6254E241D603C5995E23F8C2AF062384B95F4CD986E59C460A1C4AD4E5D779DD35E3780A22EA1738339198CB9A5C9B9EAA389DAE827';
wwv_flow_api.g_varchar2_table(45) := 'CF44AB20319B089ED17278B019EFB4280A322A3C40900E2D65C5297A6883217E347DF45CD2323562FAE3B61E31C194493EF4C1246520C6489D7BD1B42E34797F92A7C14E8A326D41B89843DE734290000AFB5CB70F5B4EB86814A653DEABB20C8480409F';
wwv_flow_api.g_varchar2_table(46) := 'AD9A5B2A7FF21080D13ED7A59732AD8C92DD39797260CA8F1F0FE6BE6C2C84F52CCD3269D7C9048C40A5DFF35F7ED918DEB850C0DC97F55FF7B21CE7A50E9832CAE62D8D027BB995C046D311879D2200E2B00094FDFCF3C6BCF65A900765611518D0F112';
wwv_flow_api.g_varchar2_table(47) := '00BB57C4EB00974CC0080E8102939D227568316BC38495D360E211269A567C339234B3B9508B9DB6120F98740DBC5DC95B9A38F2E03E8D00B81DE4920B18C1D3EFB1CF1B75684E25B8C4232CD2674693963D5778AA915C2BF4B0DF75E9F43E56A2835C72';
wwv_flow_api.g_varchar2_table(48) := '012344B486A35607A04641D45B76AD756D72FCC48EA29BFCDC5D937D0A789EA34E01A780E7B904E6F9E3A51A9C029EE71298E78F976A700AB8B204460E1C282E13B13C5039661A52AD048A020D1344655C6D1ED1780D69F0E0860D0EEAA4B59E9CF099B6';
wwv_flow_api.g_varchar2_table(49) := '68DEE9791D1260BB12874CF155C69CD7E31A5AC9D2D625BF07924D54712CE7059A9C92AE8746B048EA64E8642A672AE3FAB26BF0ADCAC1B0D44C2EF7B96C981F5C96CB6D389CCFD7B1B6586FF5E75D3A5F649815191E743295C75319D7FBA4A526BFA67C';
wwv_flow_api.g_varchar2_table(50) := '30CB9281D3D6C35BB76E162D7E62692E276F9163AF53578B041022323B323E7E4C5E2EFCC399FBF6FD83F45119735DAB6B9843B402870607AF973DD8BB05BBBC836A534DAE8586E7C90B5FF6A86CAEFCF3AC9191FF91342ADB5AB28A3D2E15893DD32ECF';
wwv_flow_api.g_varchar2_table(51) := '302E99FE1F472AC582179D317D0000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72347683875797163)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/flv.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D00001506494441547801ED5D5B8C1BD7793E67865C7277B9D2C69613D9916C4B7112C7729BC48593E68AA6058A220FE94BE41A41F256E421401FFB102040';
wwv_flow_api.g_varchar2_table(7) := 'B6682D056991E722068A028E5D215BA0055AB40F7D682A142DEC5A4E85424D1347B6E458AA5D29B62EBB4B2E39977EDF7F66C821F7C6CB4F726697073B9C9933E7F29FFFFB6FE7CC658D5148716CAC4233536D225E59F1F6C3387A99383230648AB52666';
wwv_flow_api.g_varchar2_table(8) := 'C3F1F9AF7C02675FC2D1B289E3C8785E6F7FF939277D26AE1A6FE9A6997FF059FBC4B7AEC6F169DF98D5281D4F7E881D9E92D2F055C19E2E709FFE32F4F859B3545E9636DBA2C303C17F94AE14EBB609439B01485B30262AFF5A7CF14FBF61ED1FBE1EFF';
wwv_flow_api.g_varchar2_table(9) := 'F34A298E57C2FD027276B4033391126FED6A189FFFEAFDC646FF6496ABA7CCAD460B787A62B4896B8A6F3F3DF596EF3DEFA530BDCEFCEC71B65C9A9FEEDB6509612B32A57BEB66E9E49209821771E969FBF16F5E21C8E637F607C8A3D9D0D59493F14970';
wwv_flow_api.g_varchar2_table(10) := 'F8C3E6CE26194D70D9EED63DF376DB76AA97E6F7D6CDE6678FB3E5D2FC74CF6B721C53E49C056B056BE6D0C22741FBF3D0E413F60B2B81F9D18ABF1F7CF268009F3E45BD00CB22680334822C4B7F9DEEBA9C5C1EA7F45AF85D1CDFA9C766A9FA691306FB';
wwv_flow_api.g_varchar2_table(11) := '0AE4D1005EBDE40C6FE4318EA64716BC0BF343F1849A2279A4DEDC698400F953260C5F882F9C7D4434D9FC10D1B5687B61869525743480530D668B0EE26CDBF93D7676C7D915A112287B104E0B20EF0AC8BF0EB85F887FFCC71FB4F6A9D0FCE88F60AE8B';
wwv_flow_api.g_varchar2_table(12) := '09F26800F742581405EEA593EE05128A3FF283E69A9AFCA4894BCF773479B5909AAC0B702FE04539B7B4D3D4604BDD6610969AEB2771044DFEAED364439059B038490FE0420DBB07A054833BD91D906BD4E4E85CFCF29947C55C17CC27EB019CFAB50E93';
wwv_flow_api.g_varchar2_table(13) := '8A73242B715B24D481BC469F5C7902AB727FD501B938E65A0FE02DFC290EBE12206E4F2EF9E3CC75ADF2B12282AC07301954342D4EE9151F9C9E6C41BAA3C902B23D17BFF49D5362AE57F3AFC97A00EFC89F2D0CCB4F46DBEAB40F76A2CD6932CD75ADFA';
wwv_flow_api.g_varchar2_table(14) := '51538ECFC5179F79DC3E852954CE41D6037827D6E439BF4B28FB0499F3E45AF57113C127B7417E2AB753283D80C99F3D799433B4BBE8ED427B27423BD1F522400E529057A1C9F904590FE0BEF8B313DF269C3F1AAD9ECC94DD8AD7E326F4E0939FF9987D';
wwv_flow_api.g_varchar2_table(15) := '2A01190F0E4C7834BB76A7474C9736ECDAE7F42FF6D23AE8E20557BCA8CB6B8D002B5EA78C0F4DFE8FB31F17901FBB64F974C8F407E928D023845A319A664C8F27DBCF8377A7C72D6BFA58BB0ECCA1EAA300FC85F83FF307B21EC0BD5AB13B7BF271B54B';
wwv_flow_api.g_varchar2_table(16) := '20BB4EFAA58FA3F67117CA811C02E48BDF7D4234F9DB90F71C68B21EC043F1A75F3E8EBBDC48C473E5BAA3C961782EFEF1D927AD5D894C0E40D603981814458B533CBBE8ED3A1954A23A9ABC54FD205C156E50E403645D800765CBB4CAF762B9F566C330';
wwv_flow_api.g_varchar2_table(17) := '94394DA6B9AE551FC1132ECFE701E48309702F7CB254D99B39D479C75CD72A4E932F9EF9E434CDB51EC0BD5A31147FA654493458ADEF0CC8D0E41053A857CE7C6A5A20EB019CFA35353E4DB0219926A9F6E740E63CB9563981E0E4856981AC07B02A7F26';
wwv_flow_api.g_varchar2_table(18) := 'DCD8A00B1DFD91E7022F01B9FAB080FCD29F7C7AD29AAC07308753342D4EE9D5F3C1BDD077405EAC3C6C7C1F3728CE7C4E4026BB26304FD603386556EF10F37C4EF64B6A1FA4199A7B07F2FA2697351F3421CDF5773E6F57304F46C26B327A186C43F558';
wwv_flow_api.g_varchar2_table(19) := '1BDFA6BF7C657509E50440A6B95EAC1E03AC3FE880FC6D3C913B3E90477AF9AC0B2DF267AC3CEAEA4DE7A48BDE2EB475DAEF6E85BDF97283A256396ED63601F299AFE1D5CC7F01C27CFEDE4B4D7777B5D1CEF43478ECFC196DA05DB5B7A5B50BEDAEE28A';
wwv_flow_api.g_varchar2_table(20) := '272EBA5E6FB6105D1F97C0EBC2D9DF04C8A068652C9AAC07B02217C6DED4162C89F8B6A88F8314F65E32EB9B2DB358790056EFB9F822412601FA20EB023C311E29F35D163AB6A0AEDC49B639BE06631390AB0F981020BFF2CC6F8D03643D80C99F49F228';
wwv_flow_api.g_varchar2_table(21) := 'CBAF618F5381E434097F5D09A7CC92ECF452F63C739C564DF7D4C5EDEA8241D2922B27EF3A0164BC4F4D4D36DE73F1CB677F9B20D317C73FE4D706464F7A009374217F74A226DF02D84AE1CCBE60461D4BB6B6E066CF33C72CC794EE597EBBBAE8404AB6';
wwv_flow_api.g_varchar2_table(22) := 'CBA118AA955DE055BDDF7888AE2F9CFD1D690B8F0069CC93F50016AAF85380D425887CF5D58BB021C6F5F15D111FF1EC8437BFE49B8D66D3D416EEC3E33F7F195FFC9E03197365687B223EC3F1556F9A345CFFD3A90596716A62016A1CD5FDC6DADB0D28';
wwv_flow_api.g_varchar2_table(23) := 'EF9AFE92F480C3BB6BD64ABEFFBE66ABF5BD5BFFF0F55797BFF8FDCB66F534240F0FF40D990E26C06096530B3C3917D72B5E6BDDBFBB11C661185B0FEF09772978C25896DF2E3FE5FB6ED7B3D7B2C7695DEE991F99B88C7020B49EFF11EB95B020622E1B';
wwv_flow_api.g_varchar2_table(24) := '7907BBFDAD0C161D28E9014C0A8B94402F831DCC416D65CE2F539BEFE2B5E0080B883EAF6D3396BD86B8DBF5ECB5EC71B61B380B3337E799662B0CA216963615921EC0E4C8765C5120725C4D30D81190B19B2B5BB3C447AB364213621C7CE19FD746F380';
wwv_flow_api.g_varchar2_table(25) := '7D509EE9035D461030F7CD90B2836635FD4C461F4D6D57E4600659194E24112DEDB29D2B595B9BF72DC0B56034154DF2796D6C5BA60F60CD3EBBD2E9EC6732BAAEF477A2073049A334163C55A8C9F3BE7CA44F347892E31903FFF4001E037193E46DB6AF';
wwv_flow_api.g_varchar2_table(26) := 'A9829C2544E1580F600562F2D4C47E01590F60E7B1F284D1C8B454E6266CAEB778E0918780376AB4D23E32D16D96604C13D5E431F0500FE03657F6DF0135F9D0828F55C464EA54A021EA023C0609CC052F312E99271710643D80F7A10FEE122E825C824F';
wwv_flow_api.g_varchar2_table(27) := '4E408E0A22CC7A0073C00519741770039EA49A5C02E78A00B21EC064D418A2C001F93FFEE2194D2E02C8BA008F9FBDB9E9819ACCC02BEF20CF001E5664A0C965F8E4BC833C03785880937A6D90710F288F3E7906F08800B37A99E61A3728F0E08DBBC5A8';
wwv_flow_api.g_varchar2_table(28) := 'D0A656133380353849739D80ECE74C9367006B00CC363220E74993F5003E0853A4BD84210DBC60AEF3A2C97A0063700761A1632F8C793D35D7D4E469075E7A007364332D2617B698EB6982AC0BB01BDEEC374720CF001EA7386602AF723FE67A0C165017';
wwv_flow_api.g_varchar2_table(29) := '60FAE159EAE6C020208F817FBA008F4102BBB955D03300574AE6C97D69B2E230750156246CDF359580CC47722709B22EC0633031FB0A68F047A650B80B3529907501DE57688C6930D4E4E42ED42440D60578E683FB930ABCE03629907501EE6F78B35254';
wwv_flow_api.g_varchar2_table(30) := '840CC873789D51164390AFAD233380A7256E199097163C79A02F966FDFE912A407B0B6E8E98E339FAD81670495E67A69DE93274446FE6643CF48F5009E45D03DACEDEF545E5F4D03AF4544D7005B73ED5A0FE09906F787E84EA5A0C9BCC5C8E7AE0972D0';
wwv_flow_api.g_varchar2_table(31) := 'DAA9E060F97A6FF80FD6EFAC742F07A820B4829C42C15C572B437F77A5AB653D806726BA8BB1439F808F3EA2EAF94A79E826B215F54C74B6D5D9F1681CA0B21C2C13AD611E760B12B66B7F90F2BB951D106B36C56D3B92066C8AC5F54CF4109DEF5D85A3';
wwv_flow_api.g_varchar2_table(32) := '8491B173186FF2B5C14CA52C5B5952CE63F82E84A6FCD7829DEBB81A532576E01ADA876194EBAE9DB43C27A69D567082848FA7D98EF9747DB26DFACCDEB22C3FDD947380012E81096FE08365646216B46EC6115249DE02EA8428DF00BF591F201110EF1E';
wwv_flow_api.g_varchar2_table(33) := 'EC1D889D9A0404F5821BD86DE0B8048828202CFF1EECC99EA45DA984F271D3D8E07F33F9C8F30E639BCFE449E15CFCE41860323330B1B768E2CAC96D98DDCBBF04ACC80165BC0A0A50039D90784D8002700474A9CAF609A667A2EA4750CC09860801416C';
wwv_flow_api.g_varchar2_table(34) := 'BD856F296DE27A462850DED1F348D28E03DF06EF00F47792B2BD744DF75C0F60F2573391B1E14D132D3C66EAC77ECF44E543C686D0626A659756A59D82005C2BDFBA68E252CDB4963E84F29B00A464BCB061E6DFF881F1D75F8425BE1715F81139686974';
wwv_flow_api.g_varchar2_table(35) := 'DB44109EFAB1AF9A701EDFE60EEB009AF94D337FED6F4DE9F63FA2FCFB509682C2DD1D131CFE8C693CF0BBEE9C34B2ECF5BF37A577FF0606E038F26969F293F400A63067ADD9C863A4868159D0C4B072AF89E696A151D0406AA474C4CE12A972DF240498';
wwv_flow_api.g_varchar2_table(36) := '6553BE0D80A0F961F5882B4F0D85990EE78F03E07F4DEA266DC4EB269AFF0084E104846201E56BD27EECF9265C3C0180D107B51C4262220287AFE02D3E628285FB210C4D13FB15E36FDE84F6BEEB68493F9D97D285DC81932A0F1DB706A661C70ADA5A2C';
wwv_flow_api.g_varchar2_table(37) := 'E615FE149A68A18536C0062DB351FA194772031BFB155F8B030051BAFB13E3356F4B39DB5A976B51F5FD28E7C017DF4AE1B1109EF987B08796B7D65C3FC106EAB52020F7437B8FA02EB45A023094F70F41D0EEC1759870D2019A4AEB6F1ABFFE5FE0247C';
wwv_flow_api.g_varchar2_table(38) := '3C85611470517BD4EA6C229BF43438DBAADA3101046834CBB2F9D052BCE4557FDBF88DFF43344BFFC8C472F8A5466D5C81565D8359DE3061E95E045B10066820355A8221B102F4B77568ED11132EC0AC8A86A29C2C0C3BBF1D568EC02D1C355EE3A76819';
wwv_flow_api.g_varchar2_table(39) := '34C02FC7E587C49A487734E538F01A6F43B17F09F0214012496397A3947380339C4ABF2B287EF692A95CFFB3C4E7B10C4121C834A51B00BA66BCCD77000640253811BE225BB90780E1A3EA8D9F210F8900CF9D8206DF87E3B43ECA0A980134F530EA3C64';
wwv_flow_api.g_varchar2_table(40) := '3C6A27DB87C647734751E7308406C116844B341802E58237081B8589F57394E88C74D224C745B0191193A1B2C17CD23CC68C7A2B328DF1EB8C9A9147CDC73E2A2D0940A265CCA73F9D3F6142046FF2CE27CD6EEBAEF042FE85835FC5F563A84FB38EF621';
wwv_flow_api.g_varchar2_table(41) := '4021CC7CE461CE2C3EDF8359BF0D01B88C3298268990E8B052B3153D809D95D4A46DE7B6689A394FE5D4869B5DC4DE6DB14C77EA30D56F88AF144D03F3637F0E01D571B409499439720DE6F961D4038030CD1EFC7CA97E0DD7122D8460840B00D8077811';
wwv_flow_api.g_varchar2_table(42) := 'FC3080163F4E732ED622869BB8095FFF1ADA58421EADC024A51CDDF591F4009EE0D8249A0E5EC26C075ACA2DBC8ED9C99B387EDB2D88D843087C2E43C3EE087802080092C0891A18ADC39F1E9568D8F10800431B4B777E920805B51E1A2B7E18C1567417';
wwv_flow_api.g_varchar2_table(43) := '02F21E9C239062A25580D9F7377E81BEE17F65258C00E72FE9F9606AF058B538912068636BE903C61CFB73F8412E313281B900D006B7310FFE37F8C65BC636116C357E0950DFEB8AD0C462BA152332B6E1FFC0BF7E161B7CB47CE21DE6B67103D1F70563';
wwv_flow_api.g_varchar2_table(44) := '8F7C161FC4E2948C3E7719651E34DEC67904641F75E5690D00B00DD6214457D136023F9E6B8D5DAB9D64D47A00B3C1716AB1B48D15693038C0BCB575E8643204748BBC081134A3EBD2DD4B20E3758078070040AB0F7F0805A8910CB40070E93E63375F81';
wwv_flow_api.g_varchar2_table(45) := 'F93D01BFCCE54524CC69FDC65BF0A7FF8E08FC6BB8F68068709CF8E1D23B04FBBD28BF88BEF02F963CCFF89886F975046C1E84417CBA6B6AE45F651E62E48A4959FA76A28C3712A839E0AEECE55CA64CCC2387B8878FDCB82A916EC70FCF03E4A3285233';
wwv_flow_api.g_varchar2_table(46) := 'C1E243D8BBF21EB5B10161082F60CFE00C7E98532608061748E8E723FCD350FA714900D9C7F4C8B67E81328801C4FFBA4B79FBD5055859FA766216E7B65C27A619954507EEA1855C3674CC86C946E0E341C3BC66E287A979008891703C77D2996E0A2403';
wwv_flow_api.g_varchar2_table(47) := 'ACCD7761A2AFE2F894CCA3BD005328828F3A51155A3FF761679EB1202277B5D03F83382E5D4A943D5EDFB4131BFACAD735D1E3D460301BDC14C657DEFD6FF8DA97612A13132B3E18778242AC460537012E961CB93AD5BC0A4DBB01934BADA5F4E1813698';
wwv_flow_api.g_varchar2_table(48) := 'E970F1576072111D1318FC396D0460FEC3108AD764152C2A2F4178DC7C385CF855A92785E96F319DF2375E43738CE05D1B7D717B0A85F40076FC1BFF1000147D6BE9C61F605DE333497F21788F8D0CF709264D298C53740B656146A3C78023CEE9AB1174';
wwv_flow_api.g_varchar2_table(49) := '05D1E328E3864E0B4053CE1B0FA604809B88BE211466912B53A882E02D587A14F3654CCB2864ECBF498D7F15C79C43E7337A16E2F1A30730C63EA9147B55DC0CFA2202A6A3E271810EBAA684612FF358824DFF3A279AC6654B2E7430180ACB874D8C07CD';
wwv_flow_api.g_varchar2_table(50) := 'A53CB451FC6FFD759C5700E61CB4F61682B5374D134220D1310423A89D8479AFA08C4BFEC675594C313E23F4090E3C256080BD1EC003743A7A51301537E82D57AE24A500A72D036C6A346EC4FBF5571393EB56AC6244CE21E7C209305CD2F4367F8EB2B8';
wwv_flow_api.g_varchar2_table(51) := '2E8252429D2BB296CD5B949CEF86152C6726A2445F2FFE972B6912CC2120CB71A2281734A53E21DDF70E0342004DB7C13500F6162E269A46D32CDA4821C07FA1AA531B711DFEDCDD985886F98599DE84C9A659673D59EDA245404016AC89D018CBD5ABA4';
wwv_flow_api.g_varchar2_table(52) := '4D1CE535E51C608247266636F179FD309665002656ADB8E2C4885B12351B1BFF27346F1688FFA5368A4FA6D6E3BE30A63F0CBCC40A5073592701D3E3F2E4E6152997E6B986F3F9AB0B703F7C1F880F30BDF0A5314C6A8C1BFFB2A7F6091834CB7B251084';
wwv_flow_api.g_varchar2_table(53) := '756A9A692E6644FE7CD20EDAC22286877BBFFEC6CF5026BD59C001606D1A0197046710029A74D76F157B9AEFEBB224EA0239F501EF35A081AFEBFA602A9C5A2238F095B8B14E6D62A064306D21936D700BD718F4ECC5605CC74D08AF71C594D72E63EDF9';
wwv_flow_api.g_varchar2_table(54) := 'FD6D4DE6D31F25E479CD375006D3AAF6BD5CF68BFF62B8FE735CBF8235EB9ACCB1599EF3ECD21AEE0F4BDF1C6C3F42A6C690A11AD205782F7E0F4222A3612C03D21C2E5CFD0B30953E901DC0B4065860E013147B020C0024326E9AEAB5E704EC4E1D9AE8';
wwv_flow_api.g_varchar2_table(55) := '35B401167029B3DD16FBBD0742F52AFAFDBED44FFB6584EEC93C1B53A6B640E030C7491760ED8102541BE1319D4D9858F183894F965B84FD687042104CADD7846995C8373533D454B4C1B6DAE0A6E501387CBDB7F93AF68C92937E1935F3B6645BD892F2';
wwv_flow_api.g_varchar2_table(56) := 'DA3B4545D10538E59DDA800902358C1A934D348DDC0648BC670BA0BBB124271940F526F60B90ED72EF059C7702AE6D2EEA64A5F2A4D09A2EC08A92D7191B1BD5986B029881E8D3EAB73392BE8E06A271EF16E97CF492BA06EB915698969479A80BB0B2F4';
wwv_flow_api.g_varchar2_table(57) := '1506146D4215F9A80BB0B2F469F3AD30ED29F2510F6045A20A03440108D50358D1AC14806F8521510FE0C20CF96011AA0BF04C8B75A447918FA301BC7AA9E379F90676E74C67A0B3568CC9F278087E8C06F0E9534ED6BCC8C12BCF4D0D41C5AC4A8703A9';
wwv_flow_api.g_varchar2_table(58) := 'F692A74C298F3B25063A1A6D252B95AEC883F6E2FB6C3168C22F3439257320620E7C61F24E9EFBC20F79CA94F27848E68C0670BB53FB1A166E7F6A0E554E995B0D3CFA8F0BA9B9CE1EB37CEF79BB8D9C1DEC45E76ED777BBB6D3305D9D083CF4C143DE93';
wwv_flow_api.g_varchar2_table(59) := '044F914EEF54A1BFFC1486FE4AF794829C59DE1367767CFEE92F6381FE59B384F73D98466A595A38583FC2450CF90E5E9930F6F7EDE79FFF6B3220CBE3611832320C5902E2F35FF90420FF12C85A0665B8DF369A8B1F664085ACC3F7A3ACDCBEC2930CE1';
wwv_flow_api.g_varchar2_table(60) := 'DFD9CF9D7B91E3C8F276AAE322215325601F76AEC5D3FF07BBABC7E7ADBF6CA10000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72348097039797165)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/fw.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D000011BB494441547801ED9D5B8C5D551980D7DA673A97DE6805C1D6969B16A8838A62894520410C313CF489A98DC1A8898991071E4C286363E2F8404242';
wwv_flow_api.g_varchar2_table(7) := 'F0DD4B0C187A81213C60424C80901040484808842A049002820A2DF43265AE672FFF6FADFD9FD973E64C7B2EFBCCD967CE5EC99EB5F7BAEDB5FF6FFDFFBAEDB3C7980C9C33C666504C478B706363D14A788E6A21B60C06A14821E219737464E41A1345BB';
wwv_flow_api.g_varchar2_table(8) := '8C731B2434AEBE599EAEA5CE71ECDC606968E8E8D0962D7F1CBAFBEE77DDC848C98C8FC7FA3C79AA6FB3756909701AEE477BF6DC1A39F7A70DFDFDE75099960A6EF6691ACD17C7265EBBD64C6FDCF8B79231BF18BAE79E23A2C97D666CACBC5220B7C481';
wwv_flow_api.g_varchar2_table(9) := '166FC7C7CB1FDF76DB263B3BFBC4B90303C3C7A6A76745CE51A3B25EF6F4560CCFDC5C5C5ABF7E72CDA64DEB66E3F8EFD2407FB8D220B704623CA112CFCC5C2A2DE5B2E33333845066FE0FE7AC58A03E2A2C7027560F0EEE943E65FFE4AF7F7D891D1B9B';
wwv_flow_api.g_varchar2_table(10) := '132D2E61A188EF66D712E091E161DFF7DA20AC2891065E571C54521EA0E4A4FEA72727DDEA81816BE7E6E65614E496008F1F3EEC99F659EBE4C4F9E156773677E4604F4F4D95D7A2C902F9F89D777EC96BF2C30F77F5E8BA25C0AAC130ED2673E6CD0E95';
wwv_flow_api.g_varchar2_table(11) := '66FCEF3DEB223977D22F031973DD572A1D3C71E79DDBECEEDD65D3C5905B02ECA5D3857F02D6F98A63A293ABA0C99393E53583833B4AA5D2FEA9D1D12F7733E49E045C41EB822E8BE2FA13194BE047A2D9F4C9E53503033BE68C39D0CD907B1B7062A253';
wwv_flow_api.g_varchar2_table(12) := '1AACEC03E4E969857C686AEFDECBBD268F8C74559FDCDB80AB3458E9267E30D701F2D573D61E3AF9AB5F5DC1BCBF9BFAE4DE069C90ACA1C1CA7A1EF2E0E055511C1F9C063203AF2ED1E402B0A0D43E58A956F90B204B9F7CF0D4DEBDDBBD2603797E8056';
wwv_flow_api.g_varchar2_table(13) := '952D1F9705E0FA385420AFEEEFBFCA46D143A7F6EDBBD243DEBD3BD7907B1270651E5C1F5C4D55812CA3EBAF5A31D7DD00B92701EBA457C935E007C8B2182290AFEC06C83D09B8A2C1C934A901C0240D53A814E4897DFBBE86B91E17733D262F0E34585E';
wwv_flow_api.g_varchar2_table(14) := '5B93E7AA326D7DD254E1150D4EA6494D0C94980B47A7A7A7E7D0647975E0D0E9D1D16FEC16C8BF91F579DE0E49DDAEA3A7B9A94827A570965174CDAA491E59BC76A504F276D96A3C0064AFC939825C00AE89AFCEC014E4B50303572864349912F2A0C905';
wwv_flow_api.g_varchar2_table(15) := 'E03A59D64AE6FBF22AC81276F0C4E8E80ED96AF4EFA4751A724F026E719055614D5F5E0D5976A12E17A162AE7301B927016730C85A00D95FA8264F4DCD89B9FEB280DF9F074DEE49C0F374026A615351EA4A5C83278B347960609BBCA9B9FFC4DEBDD7A8';
wwv_flow_api.g_varchar2_table(16) := 'B9EEC414AAB701373F4D5A84BF62155493C3146A5B5F141D945DA89D40FE8DE45AEE3EB9B7012798B2D0E005C45390E545BE4B65B1FAC0670964D22D27E40230026FC78E500AB22C865C2CBFA2E808E402B000CE5C835153DC62C8074FDE75D775DA272F';
wwv_flow_api.g_varchar2_table(17) := '87261780038AF6FD5D08F9A252141D3875D75D372C1764FF667FFB9E2E9F2533E2AD0C8A96A38A0B216FFD6C66E641817C9B407E86EE41EA1329F0ACABD393809715AE12AB822C6BD801B2B54066C1A42D907BD244A3C1DE35B75DA8B91BF7D390FBFBB7';
wwv_flow_api.g_varchar2_table(18) := 'CACBF6FB27F7EDBB51829DFC16CAB5A34FEE49C0150D4EE6C18D936A210790E5F750A7676666650AB5A51CC70F4E8E8E7E5702DB02B9270157E369CB34A9FA260BAF81DC27667A56A6509B65EBE9C189BD7B6F6A07E402B048DA9BC80400E6BB5D07456B';
wwv_flow_api.g_varchar2_table(19) := 'D9DC56AEFAE4B75040DE245F46F8CBC4E8E8F780CC80EB61BE3690812B0023C464A14384EFED27EAD58E8362B55C6EEBE7C9D6AE4A5E1AD82CF5D82F90BF4F147BCA59F4C93D09182D4A3927AFC1C67218F9B1592C031F7E64C8AF0D2B875EABAF714B5D';
wwv_flow_api.g_varchar2_table(20) := 'A7C3F55C7D2D9F6B0D13BF34393B3BB36668E87CA9C7FD5363631E329A4CA34BD5B5E1D39E9D26013912A8F1EC6CE9D4A79F4EC9EEFC444B926C58F48B339C746E62555FDF05D33333BF7BEFC73F7EF3C2071E787B5C5EAE970FC3F8374416E7387B484F';
wwv_flow_api.g_varchar2_table(21) := '0256B1880A19333D3D509E9A2A9D2A975D594CB56858D8C4D744E2033EADF5E96B3D573F95CD9F5687575F6B7AC2C544AF92BF65D1E2EDD2F8B6C8F9DBFE37D8E3FAB10C1235E67A16B00A5ACCA31D947E503C33512E1BDEB3E954BF4583EB17AB325D2E';
wwv_flow_api.g_varchar2_table(22) := 'CF95E5680C65EDD43D0B1871286481EAFA45B86B4AA50590D35A5B5B7CD9864A7DE4C34EA644A363750BA79FC968F64E9D6AACCDD637F37CDE340A6B11A71D10C1AE2D95AC0885AFB811B5AC07751033ED6FAA0F9AFE4C868635E2F73CE0B4B0D019816C';
wwv_flow_api.g_varchar2_table(23) := '04B237D34187D22996E73CCBFB1680AB98E5057255B59ABE2C00D7105D47218B05C9D21580979066C72057F5C14B54AFEEE002F01944D529C8DC372B57003E8B243B05F92CD5AA3BBA005C87A8BA197201B80EC0245936C8C520AB4E226D48560D9965CD';
wwv_flow_api.g_varchar2_table(24) := 'CC5DB2829555B985063728C93464D679B9CED4151A9CA9389B2A2C0D99D72E3287DC54AD6A672A34B8B65CCE1A0A54362858D6CC147261A2CF2AFB654BD036C8193E41A1C12D0A3373C8451FDC22913664CF147261A2DB4028832233835C68700634DA54';
wwv_flow_api.g_varchar2_table(25) := '44669033AC5FD10767284C8A52C8EBB21E5D3759CF027093823B533620CB5B7C260F900BC06722D5425C5E2017805B8078B6AC0B208B46735D8FCBF29D8E02703D126F214D05B2BCEF2CFF21AE2EC8F536847AAA5500AE474A2DA651C86BEB845C68708B';
wwv_flow_api.g_varchar2_table(26) := '02EF44F64620171ADC094219DCB31A72CDFDE462252B034977B0883464A6528B204B5861A23B08288B5B0315B8F4C98B208B0617263A0B2977B00C34B45A932B50057C96AE18456729CD06CB52C8EBEA1C5D3758BC4F5E006E466A19E6C15C333F0632E6';
wwv_flow_api.g_varchar2_table(27) := '9A9F8D66A9C305E00C613553949A6B20F3FA0FFEA28157330527790AC02D082FCBAC986BDED26483024DCECAF5F42FFCB3126256E5689FCCE87A4E8E2C5C01380B29665886D764D1E055192D7864D34C327CC0A2A86CDFB3EE6E0DD6565EDD676938AD25';
wwv_flow_api.g_varchar2_table(28) := '1D970EAFD59234EDD9D255E7D57CD5E139B8EE4EC00090C188E993EA235CBE4DA350B8D683F039F91A91C6F5F7877C7AAD00484FD8CC4C286BA9749A5E7DF2C9A797CCECAC86E4CEEF2EC04050B0C0F8E823633EFB2C0855E2E8BFF8DE9577F8EBD619B3';
wwv_flow_api.g_varchar2_table(29) := '660D9FB40BE0347D7A00A39056C937C8CE3D37349A5AE942A9E11EC9B96F58AB571BB361C3424BA1F139F0BB0730708180B6FCFBDFF2399C0163B66D3376F3E6206011B4870BF88909E34E9C30E6FDF78DF9F863638080B60F0F8773341B075CCA05389A';
wwv_flow_api.g_varchar2_table(30) := 'FEE187C64C4D2D4E974AEBEF411E1CF96860FFFD6FD0646D5C2136177FBB073066F3D34F3D087BCB2DC67EF39BC65E78A131E79C632CF0D06C042CF01CB0007DEA94895F7DD5B8871EF280A31FFC20E4211EA7DA4B6391B4E5071E30E6C5174DF4CB5F1A';
wwv_flow_api.g_varchar2_table(31) := '7BC9257CE630A409A917FE05B2E473478E98F8F7BF37E6D83163D6AE0D0D2547A0BB03309AFBBFFF1973D14526BAF55663BFFE7563D7AF0F1A441F88B0116AE2CB5938FFE217E51F2158537EE411AFF9564CB0FDFCE783155008683380A50159808985B0';
wwv_flow_api.g_varchar2_table(32) := '1B3786740A5835368D987C8383C61C3F1E1A17D75A663A5D87CFF30D18C1021733BB7DBB29FDF4A7C65E76591024C2C7A1D929B83E4C058DA6EA0088301A036198619C86A9AF90287B72D238B102BEB168BF1F72CDFFAD057E3E361767F9068CE915D369';
wwv_flow_api.g_varchar2_table(33) := 'BEF00553FAC94F8C15C8DEF40209F002C649FFE7E8933FF9240814E032E8B19FFB9CB15BB78674A41568F1F3CF1B2B8D25A22FA66C1C65BCF59671FFF887710CAE1830E1042ADF90C677274F867BD00008032C07F7FAE083D088284F1B482821177F93A7';
wwv_flow_api.g_varchar2_table(34) := 'CC455D165602AD42600238FAF9CF8DBDFCF279B80856342C7EEE39133FF144187431D841E8089A411566F6DBDF3696734CB06863FC873F98E8E69B8DB9E28A0580E3D75E33EEB7BF35E62B5F09FDA86AA696278D28BEEFBEA0F9944703A37E387C0EEE41';
wwv_flow_api.g_varchar2_table(35) := '7D73E6F20B58403919D5DAEBAE33F6AAAB82105573451BCB8F3FEE07379669900CB4FC1407E12264CCB2E475070F1A47DCD050E82F13D87CB637C11370A0A5175C103456E1A6411146991CD44101130EDCC49AA4B3E4E53CBF80012520A31D3BC2800AE1';
wwv_flow_api.g_varchar2_table(36) := '621EE5F023E33FFFD95831DD7EAE8BC0150C69D070E6C084938FBE17938B764BFC02B84282A98F3D1324CA64844C1A1A0BE5A9A39EE96B0DCF899F4FC00854064276D3A630AD11381E165A7DFAB4899F7DD63880217431D58C649D3406FA4CD129F93630';
wwv_flow_api.g_varchar2_table(37) := '7FC5910FC7685734D9098C4A5C88F17F7DEA6A485A062988937EDEC9FCDAD247D36888A79E5CAB79469B73E6F2075805479FCA881913AC0E8132983A7224089A34A25156A64ED179E7F9298EFF24BFC2111FCDC4D43BE9AF2BA655CB3B93AFB0802BD3AB';
wwv_flow_api.g_varchar2_table(38) := 'E88E3B7C03F18D8630AC815808F7D24BC6C85CDB7713D58DE44CE52F535CFE00F3E068221A49FF8976283084CEA89A552ACC30E732988AAEBFDE581626D0661A81C2219F68AF934154F99967C2C205F15A5E2264F42ED1F92444232446A0F9F9F34D37CD';
wwv_flow_api.g_varchar2_table(39) := 'C7619631D732702BCB0247FCD4537ED4DE50039A2FADAD67F904CC23AB960024ED102E8014227168931EA4278DA6235E819247CF094F5C4DB8954889A54CAD07657060FE09E39C7BE1E7D0E5133010D010D162AF1569C131C861344C9C0A956549B9D67E';
wwv_flow_api.g_varchar2_table(40) := 'B8028372D2A0D3E5A4CE41B32464054883A33CBDE69CFB120E6CAE73E8F20718018AB02C0323D677D32081250B182C7C987FFE33F4CFD20FC73265F2E1F4C9D2674737DCE0076895BCDA101A050034FA70D9B48831F1DC1F98EAD307BFFE7A18CD33626F';
wwv_flow_api.g_varchar2_table(41) := 'F63E8DD6AB81F4F9034CE511209A2AAB44EC0AF915A944735883B6575F6DE2279F34F6CA2B7D63708F3DE647B6AC48D96BAF35E65BDF9A37A92961F89DA0A520A8094EA5F7A784B392258B244E363BECF9E7076B411DA55BF0BB590C04D1E4A5CAAE2E73';
wwv_flow_api.g_varchar2_table(42) := '19AFF30B98C111539337DF3486552C34072D91C155B473A771BB7619279B0856B60CCDC517FBC194DDB2C518194D7B41D7309918D15A3DA537AE35D25738D0BFCB2A97C524D3F0A41EBEB19040E7D939844BF5A479E6D461A6C51C3BE6BCAC1123649C08';
wwv_flow_api.g_varchar2_table(43) := 'D40AC4D28F7E64A2DB6F0F73DCF7DE33E69D77FC68D9F78B3406718B7A451A8BCCA3173901E730F94B9959E0D355B049819F3ED0E49CC2E539F3A9C1D40C61CB14C81C3E6CE2A79F362599EBFA050B840C64D9E82FEDDE6D9C9864475F4DB880053E879F';
wwv_flow_api.g_varchar2_table(44) := 'DE2078E02403A1E8DE7BC346030D80F0243E626F594CB05FD7A6B1683EEAA12EC710B58AB5FCFC02A6B668870CA8DCA38F9AB2C02E311765040D4C0E31E356360E2CE980487FC981D9A4810091D138878447D2377B938E16ABE6493E7BE9A57EFFD7BDFC';
wwv_flow_api.g_varchar2_table(45) := 'B2712C5A2860F2930E3FEDBA0876BE01030DD32C831877FFFDA62C03AEE8C61BC3A8159040A45F44E01CC0E040435908C1C9C89A95AC050D803885A4E9F59A3C34085D60C1E73AED54FBD361393DCF3760840E44842CE7EEC00153967DDBE83BDF099AC8';
wwv_flow_api.g_varchar2_table(46) := '1B1ABA940928D28BF05933F623DFFFFCC7F7CBEE85173C7477F468B0009489233D8D285915735805B997E30503CAA5AF65B04717A0E9D37E08CDF5DF7C035661020408B2A56764D9317EE51563E4751C5EE1F1AFE0306746A381255098CEF88D783497E5';
wwv_flow_api.g_varchar2_table(47) := '4C5EEF116031EF66A966A6B128681A802C8FFA749489A6522EF36BCED164EED1452EFF80112600808CB099876296D9741080F20F9E7DBCBEEDE8FF6B27F3531A04531A1A02F94977E4C8BC494F43021E669DDD29FC77DF9D4F471C8D82BE9F72BACC7507';
wwv_flow_api.g_varchar2_table(48) := '60848A7011367081C0369D5CFBED3FC2135759CCD0F4340CE2B9D617F552E97D364D8B7612974E471CE6BFCB3457E5D13D80B5C6081C6173708E539F7360E01422711AAFF9428AA5FFD69B6EE9127213D37D80119D0253312A4CBDAE95261DD743E7D2A9';
wwv_flow_api.g_varchar2_table(49) := '156E254BA000BC92E9CAB315800BC02B5C022BFCF10A0D2E00AF7009ACF0C76B4983C70F1F4E26A232739199E70A97D5B23C5E45A0C9DDD2326EA6022D011E191EF650E79CB3AC155516179AA94991C74BC02FB5CA1932254065EC239BF8D3D24287B62E';
wwv_flow_api.g_varchar2_table(50) := 'F9AD8F6CE1880B0B10402FB4B90918C82D111CB2F4A72AE3E68A6BF18D8E91E4AE517FFFBFECECEC1B1BFAFB878F4D4F276B85CD56A9A7F3C522C3D227D3D36F205324A1326E562AD526BFA172A489A1B3BEA51DDBB3E756D1E13F4905E5E708BE4F6EA8';
wwv_flow_api.g_varchar2_table(51) := 'AC5E4F9C68AE393E337342364C7E76EEA1438F2093B48C9B91514B80AB2B707464E41AD9D2DB25D83788B12934B91122D6CAEF75DC7191DD5FCF3B74E8C56AD9365254E66969659917DAE3056625D3FF03FB2A8C7D598864BA0000000049454E44AE4260';
wwv_flow_api.g_varchar2_table(52) := '82';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72348484444797167)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/gif.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D0000149D494441547801ED9D7B7054D77DC77F7B57FBD00B84106F1C1E860102C4011B6CE2C4C6184F53A7C11EA790DA7593B67132D319DBD88D4D68A733';
wwv_flow_api.g_varchar2_table(7) := '554D67DA49A79DFED3E94CD3CCA4310FC7A4766A371E4FF09340FDC0260F2C8C8D0D9800060C42023D76A5DDBDFD7E7F77CF6A250BB1D29ED5DE2BE90EAB73F7DE73CE3DE7F7F9FD7EE777CEBD7B11B1B385EC5453BE5A1A1B1B1D5C3DF0FDE82BC1A23B';
wwv_flow_api.g_varchar2_table(8) := 'E44228A80489C8A66FDDB3D20985D7B992A9C3D78C0865E6D3CD75D13E371E8E44CF555557FDE06FFEF9DF3E7A72FDFAF0869D3B71DCEB8F4F5B3EA8661505381FEEE66FDFFB35D7757F188FC5C6B305A16130066AD5503BA01A09C64E242AA158FCF98C';
wwv_flow_api.g_varchar2_table(9) := '13FA8BC67FFCD763B0E40A7CD2A85AB3200DF43654F968A7B31A9FFEEBEFDC3B2D9D717755C52B17B72712DD38E9B0E26200E44BB5BF7AFA3B965FC6EC9B7C26E5F1EC7E08469CA988C63BABEBEA6A53E9F4EBAE13BA7BA4412ECA87EECC4AB13BEDCEC5';
wwv_flow_api.g_varchar2_table(10) := 'EE82CE6492471C48D081356753EE17F7F1EAEB5D477FC7FABB8EC96752E611B64D8D3F54C106A733E9B6EACAF80DA18CBB6DCB23F7CF8105A7F0097B799823B85B5180172F5E4C6380E4C321174331DD322C5777F0279B9AEF7E4A193678DE1D7B61C00F';
wwv_flow_api.g_varchar2_table(11) := '757426A43216FB82EB844714E4A200373535A98BCF84D22E7620A6E0693A2C9A9BCA219148A4E3F1D82A85FCE80357D3929F7C727DD6DA83D7B75CC786DA7463C1F473905300F1667B1E1297EE863E2691487A90C5D9B1E5D107E76FD8B0331D64C84559';
wwv_flow_api.g_varchar2_table(12) := '70BE620497AE6AA769BE5A6BA213902B632B10746D6BDCFCF0BC2043B606D8F374F9C803B40F0BD6D6223244EAC01779961C8DAD70DCCCF62043B606D8984080B0F63435173DE47AE1597212964CC899CC135B366D5CA096BC3E5863B235C023C282B386';
wwv_flow_api.g_varchar2_table(13) := '9C25DF033916BB16C79E68FCABFB1762A52B5063B235C039DDEFB18BE0EC7DDA824DDB739063B1D8E7C3E9F00E85CCC00B960CA5F67DB7AD01361209646AC6E0DE166CBAF229C85B363DB48896BC330090AD010EB48B36282F9F2AE424C6645A32FAFA93';
wwv_flow_api.g_varchar2_table(14) := 'C6471E5C42C81B08D9E532803F376B80FDD9BDC1B66A404EEA92130CBC62D1A56127B483907712F2860DBE856C0DF080A219AC9CCB96FF8A7E482D998B21B0E425A10040B606F88AA2291BB4C15CB82035CDCE9313E9CA5874092DF9B1BF7CE01A63C958';
wwv_flow_api.g_varchar2_table(15) := 'DEB426D3C1B4FC7279AD35A620D15CAE15E53E9E8BA20B5653CACD4924BB52B464A97008791921737DDE4F90AD012E5834E586D9DFF57351747F272F738C8BD7AE1BC6989CC2430E8B70436DFB639BFD07D91AE0405B708EE1207B9107B9321E5FE8A643';
wwv_flow_api.g_varchar2_table(16) := 'DB1B1F7D68392D9955FAC192AD010EB405E7000FA1177D203B2177FB63DFDDB80270F96C57D9215B039C9351A0770669C1A6AF7990E1AE17B861F10D646B8087281A23A2F2A6B920AB88662864D131194F86CCC37322DBFC60C9D6000FC1B915214DCB45';
wwv_flow_api.g_varchar2_table(17) := '871264F5D7043EB1D41378CD27E4C64D0FAC2CA7BBB60678D45BB0019EE7AE63B1E87C074F863CF6C843ABCA05D91AE09161C1967A91859CC43C19CB9A735D07815799205B033C322CD8622F7296AC9067E3D1D3B240B606D878A840A6B931D892051B21';
wwv_flow_api.g_varchar2_table(18) := 'E45932DCF56C096576FCFDF7367E7138DDB535C09645634414FC341F723C362BE36231E47B1B6F1A2EC8FA647FF0A568AB07165D747E93F221C7A2572593DD5B1BBFBBF15E40DE9DBD97EC18E0F9C56CEC5B035C22D1D8E8E320EAA01F2A514F14B28419';
wwv_flow_api.g_varchar2_table(19) := '78C15D0372D756B8EB7B711890D9C4C692401E73D1BDF09708AEB946769EAC90A3D1AB32AE6CFBBB4D0FDEC2DB16B0607EACF13097B45EA1A93898E9304412594BEEEAEAEA8625CF04F3AD5B363FB406F272FFB60490C7005313734B9525B660A3F5B464';
wwv_flow_api.g_varchar2_table(20) := '910A5832214F7733EE5658F2AD3868DD92AD011E26D11811D94D4B354DEAD34A023487B0C3AB562413801C8D4E03F31F6FD9FCF05A9C27E4CC7ABC6DC0E42D26B50638D7F2625A53AEB2C682E93E4BB829D4FCFA69C9218924BB34F0822567B6E1076F5F';
wwv_flow_api.g_varchar2_table(21) := '6616DE53B631265B039CDFEE40EDC38E42212743B6F830E52F0D87EDE378D70A8371177EBA3A59C2CE8FFE61F3C30A99960C5916A574A37A9A44A86E2A1D4EB4B72560C46D791EB42C3ADAD9216D8EE34C694FA5FFE5D1EF7CF3F03FFDC77F7D0857ED98';
wwv_flow_api.g_varchar2_table(22) := '274486D2286B8083EAA2D3E954ACBBA33B9C4AA5391D2DCA5A8602A07719378226A4A1788BF048EE4C9CFB90BFC106E0DED906F1CD1AE0324B66105DEE9D15C20C55849C48281212BC8805B7733DCA4661D92FEE9B94A5F3F7F9FD729BC96752E6CBDF37';
wwv_flow_api.g_varchar2_table(23) := 'E57A8EE17D128E2369681DC6E394395F4C6A0DB01148318D295759976F6581BB0E3B61859C3FF0997E99946DCCDF1FA8CD269F492F5736EF3CD63EF09800C78EEC55CC6B3206BACE40E7AC0559D4C2006F6C7E080FB18722E130A58B97CAA8B1E9719E1B';
wwv_flow_api.g_varchar2_table(24) := 'C64F2F319AD764F43A38882FD6000FE29ABECEEAE00D5F80DCAF2BF575C32FD3386B80F3DCCC652E159CC32309B235C0C1C157584B470A646B8039488DB42D1F7250FB660DF04872D1F9300D641E0B621FAD01CE17CA48DB379083E8A5C60017A88DF990';
wwv_flow_api.g_varchar2_table(25) := '8364C9D6000751BB0B649BCB46C815019B4259031C24ADCE111BC24ED02CD91AE021C82AB0458204D91AE0D1E0A2F335D240A600FDECBDAC01F67327F3C1D8DC0FC2986C0DB04DC105A92E63C9F4607E54F231C016B449215784F5B5F17E836C0DF0681B';
wwv_flow_api.g_varchar2_table(26) := '83FBEA05EF275700B2DF2CD91AE0BE1D1E8DDF0939E2334B1E036C5913FD66C9D600FB6DECB1CC6D50D5194BF683BBB60678B48FC17D35C02F90AD011EB3E0BE88F1324B1F8CC9D6008F59F0A701F388199329E872188135C0FD776FEC2825504E4BB606';
wwv_flow_api.g_varchar2_table(27) := 'B81CDA1924F5E1A3CEE5984259033CE6A2AFAC6E39C810D670198435C0C3D5E02B8BD1DF3914321E1AA0E0874366D6008F5970E18A95B3E461806C0D70E1DD1BCB49090C17E431C065D4B71CE4128EC9D6000FC77852461625BB746E4C2ED118670D7089';
wwv_flow_api.g_varchar2_table(28) := 'DA5732C1FAA9620399A9FE40D962E3AC011EB3E0E2A87890F15F32E1D15C9BB2B40678CC828B03CCD2C692C1D8DA66ED17FED65A34CA2B22643E5CCF1FFADBD8AC59B08DC68CD5E149406F505812C618604B82B4598DCD3178C4B868BC775965AC9168BE';
wwv_flow_api.g_varchar2_table(29) := 'B471DC08ACEF3953263F7BA1FB7DEB2AB45C21F92C0EC1620DB01162211DB096472F8A579861CCAA087B5D2134038EB30EBCC58E7FC4CDA425A3AF494221E409E18D3A1551BC966A901B854F954977A7B44ED6EDE7CD1AE0E1EE26213A001B06D8EEAE84';
wwv_flow_api.g_varchar2_table(30) := 'B4B7344B0A29682A821EA1EB2B0A25565D2BD178A51E0EE15D54A9AEA45C3C775A956130D6C8EBB27CD5B83AA9884473CAD4733D7FED59033CDCDDAA8844A43B999496332725565523D3E6CC93FAC953A566DC78896541760362477B9B5C6A6991731F9F';
wwv_flow_api.g_varchar2_table(31) := '908E8BAD12ADAC524BAE1A374EA6CF9DAF5313B578A3A1C615193DE993521932998CB49C3B2B780522948C223485865B0A57BE5EB000538E1038ADB6ED42B3842315B2F2B6AFCA82A5D7C894E933A4BAA6160F9F57E0BC37C52088542A050BEF924BAD2D';
wwv_flow_api.g_varchar2_table(32) := '7260FF3ED9F7F22F24D17651162E5F29B7DD71179EB67014588FABCD5E2407CD23CFBF193783FA23924C74CA0BCF3C2DBFDAFD82D44D9A8A37D3597929DD95690D2147B00043CA74CB17CF9F9519F316C8EAAFDC29572F5824553535EA9809D48CBF2A0B';
wwv_flow_api.g_varchar2_table(33) := '585B14BC42350205982E9D78DBE71BBB9E03F0A4C461C913EA27AABB6539BED7B7F7C6829E7B37C7F17A410F7032816BD6C2CD77F2791C11FDCF644D2E7FA581024CB86D17CEC9BC6BAE93DBD7DF2D333E330B56E54A175C355D67046E5B5D28C7C9AC9C';
wwv_flow_api.g_varchar2_table(34) := '75E90FDFBBBBBB25850FCFF31CED54C7536FC71BBAB3657848F3B01C94016F6457D854846834231D6D6DD2DA7C4E22F12A9A75B6943F93C0007610F5765E6AC5583B1F70EF9199B3672B58BCB813428FAA9B3D73EAA49CC6A70D632D11456331A91D5F27';
wwv_flow_api.g_varchar2_table(35) := '13264E9429D3A64301181465144CEBF973F2FEC126C1EB7BB5AC2A84210F25A0B5729B396BB6545657F305A139053AD4F45B39FC9BB7A57AFC4494F5B1F9A2FDD60097528F39D549A7607D8071CB57EF9219B366611C4CA805C600B1EDD245D9B767B7EC';
wwv_flow_api.g_varchar2_table(36) := 'DFFBAAB47E7246A36AC20963BC8CC4E2327EE22459F8F9EB146E45342EE1684C8E1F7E578E1D7A472D93794DA044FB66E0D47CEA98ACDDF0A7326BDE3CEF2CAC99E3FBD10FDE975D3FDD010FE0A2FEB0066C9AC1A77FAC01560B285127E966DB9B2FC8F2';
wwv_flow_api.g_varchar2_table(37) := '9B6F93F90B3FABD6440B8BC072DBDB2EC90BCFFE4C5E7D6AAB54D53568941CC1F8CA8D79A818674F7C24A73FFA502A6BC62B745A312D32DDDDD5ABC574D911C0FFE4F807B2F80B6BE4FA9BD7481C1139FE8714F512179ACFCB8BCF3E2DAD8801C63720B8';
wwv_flow_api.g_varchar2_table(38) := '42DD7EDFAC012E5547754C050C8EBF0BAF5986E0A852C7537E279003FBDF9257FEFB71A99F3957E170310364D11CA85C85A373D538A6518C743388A809971B23ED4814D15776635D9CD7722A3573C152F9F2D7BE2E0D53A648B2B353F3720C7FFD9597E4';
wwv_flow_api.g_varchar2_table(39) := 'D0BEBD523779062CD7BF91B3E91353DF036624DB856949FDD4193275065F82EE05470CA85A3055FAF56B7B243EAE1E1616038C0E9D0211A6AE603194E2D801D674EFDCA7CB8E5656AB7230E8D20D701DB85FCE6BBB131DB266DDB775EC65F0C6EB53190E';
wwv_flow_api.g_varchar2_table(40) := 'BCFD96ECF9F9D352533FD92BC2311AE7FCBE59035CAA3198169C46243BA161B24E6D6869BAE1784B73B39CF9DD31A9C6AA52275C752DA63D37ACFD7DA9AEADF5AC1C7934B796F1409DFCE8A8BCBBFF0DB556850E505CEAA4425C3A7F46D67EFD9BB26439';
wwv_flow_api.g_varchar2_table(41) := 'C76BCC7EE00DE8314E1C3B2A2FFE0F5EAB8FFA18A8E9BC17FB41D8AC012E657729D0EADA710872E096215542276846CB5DB0DA9A090DD286690B57B3567E69B54C9C344912B07A46DECC6B365AFDAFDE7C5D7EB3F7250F304C9B0E9B8B17CDA74FC8D21B';
wwv_flow_api.g_varchar2_table(42) := 'D7C80D1877197D33886300C70592979F7B46CE1E3F2AE37CBEA861FA999F5ABB5DA896925FB3B57D4E5918B156A895A969B16E00CE2D6C1038501126F3799F88A65E56EF0604AD921FB33112E6B8DBD6725E265F354756DFBE0E53AA060C09098D9869C1';
wwv_flow_api.g_varchar2_table(43) := '6FFEF25539B0F765B8E649280B75C8AFC054E4E3D41AE0D2F59137151C9DF3EA9C532D120B1948ABAA6B704728A6D1325D2CAD9ACB921C3BF9E1BE51029E338068D3FC4E45E84A766A5DB7DEB95E66CDBD5ACBE000C047E4BD777E2BBBFFF7298923FA66';
wwv_flow_api.g_varchar2_table(44) := '50A7019C5EBF74BDB55DB335176DBB61B9FA6071E17004AEF282AE2BF3698714AD10E9F80913748E7BF1C2792C3AD463FAF289BC04775A09F009B8EE5AB8F5EB6FBA45F3714D9A651870112E1738B023ED5819BB75FD3764E9B26B7555CC8CBBA74F9E90';
wwv_flow_api.g_varchar2_table(45) := '179F794A03B7DAFA066F158C8503B659035CAAAEAB1BC558D87CF634C6DC8B5287408A1BAD697CDD0459B86C853CFFF8BFCBCC45CB100177CA1BCFFF4C5797DACF9F92599F5B25CBAE5F958DA07B7C33AD9F8B19ADB85DB864D56A59B57A0DA26B46E19D';
wwv_flow_api.g_varchar2_table(46) := 'B81315D73B507B763D2F27DE6F92BA299C12619A86F13C9FAF2E5F6A44E06FE2D600F788CF7287616511AC3E5DFCE4B4FCEEE8115D7FA6F5D122190C5D77E397E4D87B07E5BD7DBBA57EC65C9938738EBAD7F649D3A576029481568B3A34CD362D8C71B7';
wwv_flow_api.g_varchar2_table(47) := 'BDB55926CD9C25B77CE50EDC74684050D6A1E5E8D2DFFEBF3DF2C62F9E952A7805AE45133095C2F491CACC089CC7FCBEF97E0CA63BE54A1697170FEC7B4D5A5B2E28084223E4C953A7C99D7FF2E772E3BABBD5ED5E40347CFEE471397FFCB08255579C47';
wwv_flow_api.g_varchar2_table(48) := '815078BB904B926BEFD8209F9933579280C8319CF3DDC3EF36C94B4F3FA1632E5F7096C218EDEA224937FE1BBC6E2C96605CE70A169526009B350B2EA52E73C9B1AA76BC1C79E7D7B2FFB5BD72F3EFDD0EAB8EEA122265CCBB4A7FB0E11EB9EE8B37E12E';
wwv_flow_api.g_varchar2_table(49) := '4FB31E679034B161121E0018A7F359650128B45042BBED8FFE4C962C5BEE05613846B8298063E076D77DF7EB8D052A57FEA68119F3618164DF2F5F9143984FD7D4D57BC1577E461FED5B035CCA3E7956EC481C9019D5F2A98D6B57DDA88B102662AEACAA';
wwv_flow_api.g_varchar2_table(50) := '96790B3E9B8D9ACD98090B040C5A3A2D99D0994E9E355F3E77ED0A559204A6443CC6089D3CA92CB4EABE70E9E2A9689C3377C1E23F38745092F0040CC0A041A5EC7E51755B03DC5BD78B6A53BF85F5E602C64E2E5B3EB7FD47BA0041C89CB752F86940EC';
wwv_flow_api.g_varchar2_table(51) := 'C6CD03BA607E180DB34DDE9A7354EBEC686F97B3B89DC8952F3E24C06912C7F1BE6329EF31F7DD4238C6C30CFA14FEA7B3F42DE28BEFD60097D2451B4971813F8AA5432E44ECDAF9B81C39D4244B57DC8075E339980AD5AB4533AF7743C1B3B84B58C2BC';
wwv_flow_api.g_varchar2_table(52) := 'D4DA2A673E3E251F1C7C470EBEF51A9EDD9A26E7CE9C5625300F01986B0C9452C9A8149C5F7776B44B05D6B595FA4085CA7CCE1AE06151E8ACA5463195A1BBFDF0C07E1D97EBA74C9786195729E42884CEE08816CCE5C68BB821D17CE694B4F03E311EB5';
wwv_flow_api.g_varchar2_table(53) := 'E1037A6D587EFCF94FB6691D46190AE3C005162CA800F425047BD57513D5731456B63CB9AC011EAEE6ABFBD531352CE3264EC673515DBAC071FEE3130876701709E3A96EEA52B1A0018BE37224ADADB2B60EA7107DC3959F3E7EC49BFEE44F6E7B75822A';
wwv_flow_api.g_varchar2_table(54) := '9BEF97BCEF74D16C039FCEE40305A5B0609BC61238C0644001D38AD259975985A04B87CD2C544244269D0A690A4E1C37A90026606354AE63EF20A4E921D6DA717D06658328DC4B7906FE92AF5603E7BCF2D94002D66E65A5C04508171F8545A4463A049A';
wwv_flow_api.g_varchar2_table(55) := 'BDB96F40308F97CF5B09BBB278829FC31A6023D76117895AAAB9AA17E99A6F263550CDF7D1945A5BC92A8DB31A4D287AFA6A5396D60097CD827BE43262F66CCAD21AE01123DD11D6116B806DBA951126E3B276C71A609B6EA5AC12F1C1C56D1A8B35C036';
wwv_flow_api.g_varchar2_table(56) := '1BE5031997B509368DA528C04D4D4DDA163E028E9D31C696D48282348FD51B190FB5EAA2002F5EBC58A13A6E38849D9E471E86DA9AB172390950A6FC62649C3B31C89DA2163A8C76654269179AC285429A712E51BB1E648306CCCE2EAB4A0D98ABFF93C5';
wwv_flow_api.g_varchar2_table(57) := '94658DA67CDFB4FFABF53E5A681998882EA522A14C59899171EF0A0BFF5614E0F5B80E9EF797483874249D09BD57198B2D6E4F24F86B6AFC63AF4AB015536D3165D91553BE6F5A48372F538614792AABB719C830DCD199783F129623ACD6C898FB43D9CC';
wwv_flow_api.g_varchar2_table(58) := '658752968DE2D2AFB66DD37D7FFC8780FA83782CCA5B360AD8347E489597B890DFDAA6BE0F7D4E2493AD68DB7DDFFFCF6D3FA508B09F93F150445214E0BE0DD8F4AD6FAC7442EE3A2CF303B2C35F858C6D054B2083BBD84E4BC60D3DF3FD1FFEF84D162B';
wwv_flow_api.g_varchar2_table(59) := '166EC1972E2063D18A52C035465B162B32FD7FAB897B28B8218F360000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72348872133797168)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/gz.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D000015F6494441547801ED9D6B901CD575C74F4FCFECCEBE57ABF703047A20092104086416530A129290805079B0FA902F8913571EE547AAE20A552176B1';
wwv_flow_api.g_varchar2_table(7) := 'B1C072912A2AD8E5CA075C29E202C9D1265F6C3024C22063F4964C904D49982084D06B05ABC7BE77677A3AFFFFEDB9B3BDAB7DCDCCED9DEEF5DEAAD97ECCEDDBF79EDF3DE79E7B6E4FAF8889E48A65A2989296D1DC1C93C9D08E21428C0F39CEFFD0752D';
wwv_flow_api.g_varchar2_table(8) := 'B12C9717AEFEF9136B5D893D86C37A082B1366ECA871C6B1245961D99FCF28AB7CE1675FFCE6274DB7EEB65BDC6DACB76A4FFEC208DF15C5699E0FEE9D6F3DF1782663FDD0AE4DD6A9665AC5153D3E51914361F7B15C571C5C5D25B6D4A463AF8BD87FF3';
wwv_flow_api.g_varchar2_table(9) := '7AE33F9C7EE0ADE6F8DE079A9DC902B930E964A5DFB41B3D7EDB3667CDDB4FCE4DA79D3DF1FACA95E9AB5D297C1DF3045F3880EC2DB29BE1CA19EEDCE0ABBC239D4F6F711670513F2B236EA62A9EE869A8AEA9C9A49C03E2A6FEE4F5C6E6490519200A4F';
wwv_flow_api.g_varchar2_table(10) := '2DD2A22E76D2A945D859E6B4F7407884CB8FEBDB72BF988F2ECF5FC670E7FCDFEB7D9D4F6F71DEC23E0616D4530D5180DB595657D928B1C4CB9B0F6DBF79EFFAE6F4037B9BEDC930261342E1A9692555415C2B86514B8DC538A26D8EC2278B18B69995EE';
wwv_flow_api.g_varchar2_table(11) := '6FEF71E355C9FB626E6C52412E0E70CBFBCAC45B6E06FE27DC96A20C3EBBCAC4A7ACE18607ED5AE98E5E275153D148C85BF76D5F4C4D6E92DD91F6AE8B039CD560CFD24183953E4F3C2403775446883A9DEAE871E2D5C9463716DBB5E9E0F6A52DD63627';
wwv_flow_api.g_varchar2_table(12) := 'CA908B033C48B211545F5D7FDA1E764ECF7FF034B9B6E21E1B9AFCD0FE1D4B0839AA63B241C0D1555F8517FD336B839403966A8726D724EF81AFBD9390A36AAE0D028EBE06FB5AA020734C569063995D5B8E6C5F1645736D10700435585799069A1AAC4D';
wwv_flow_api.g_varchar2_table(13) := 'B6B7F52077027275F26ED789FD78F3D1EF2C1F800C7D8F4032083812ED1D8C445739EBFFEB435F26CAC74A0372A23A79879D7677E520B7B428CFDB973794BB060187B27DA3574AABECE8FEBF0719E6DA2664C7DDB5F1C0F6158CE0354500B241C05A5AA3';
wwv_flow_api.g_varchar2_table(14) := 'CB3454DFFA5516D51FA5055973DDE7D855C93BE262FDC7E623CFDC1605C80601870ADDF82AE3270AD87EDEC31400592118C231B9A662959D915D9BF7851FB241C0638867188995FC94BFCAA36BB0AE2AE5A5E6C9D0E4DBAC981FF2B6508EC90601FBD541';
wwv_flow_api.g_varchar2_table(15) := 'CB2342DBB13558372637854AD47890B71C7CE6F6966D2D189301990F0E842819AC8C5F1D42D4C2F1544547B2C693D7CB13C3242906739D266474ED1F6FDDFFED3B15E45B119F0F1164838023ACC1C3CF8347C59D55785B41AE4EAE702D7BE7D6FD3B4207';
wwv_flow_api.g_varchar2_table(16) := 'D920E0086B701665012DE02536225E6944BC96BB086B6E3DE2416E7E0ADF8440930D028EA006FBAB8C7DFFE1A8EAABBFF42EE0A3034A93156427B3EBE1434FDFDD6C3567C200D92060DDEA086DFD2A8B7DFFE1B85AC10B3464ADC9D5C96578366DD796C3';
wwv_flow_api.g_varchar2_table(17) := '3BEE0903648380F316CFB864382199F277B206AA35D06C4F933D73BDC4CA645EDEB2EFDB25876C1070DE066E4048A5DECB3A5906AA91838CB0E652CBB6B19EFCF4DA526AB241C0035DD980A026B6886234F8FA9AE6C664044396E271B55D5B0E7DA7B154';
wwv_flow_api.g_varchar2_table(18) := '900D028EA006EB2A9BD3608D9BBDDD4E77C1BBAE4E2EC2F35E3B4B05D920E0086AB0AE7276B950D331B4F520231882A7356F2A156483800D8965228BF16BB0DE377BFF014D26E48CBB6BCBC1A7EFA7B956B7998079B241C0C148C8ACBC8794A635387B3A';
wwv_flow_api.g_varchar2_table(19) := 'A0160C40AE4E2EC4E3C53B37EF7B7A1D82201302D920E021C28BC2A19F28300CE16DB20503902BCB6F88D9D64B39C84F3DE536BBC12D5018041CA0784C8ADA5F96BFCA80EDE7EDCF6668DF83DCD98731D907193F186896E0201B041CB0780C4979C46220';
wwv_flow_api.g_varchar2_table(20) := '7E3FEF11F315F745760AA521E3B9EB83CFACE7AF429A057A1C80261B045C5CCB4B72B5BF4F06AFC1BA891EE4AEBE143479010E5EDA7A68C706F4AE4034F9771BB056594E9326468307208B154F75F512F23CD7CDBCB465FF330F06A1C906016B69E93644';
wwv_flow_api.g_varchar2_table(21) := '609BD560F58B86A11ACCEFF2F9B0B963E517EF4D08DE60EFF227981AF25C89593F7AE8C88E8D4A93318D6ADADDC45F3D169D0C0266EBA29994F2F28F3FE0C1FE9ACF874D1F2B3F7F1CA3F3A91DE8AC4822ED395EF32CC7E16FA1B6F02B3E1D62623DD920';
wwv_flow_api.g_varchar2_table(22) := '60AFC651FB0BA850A558C682A82DDBC2164FE38CE7131B67BEB1CA623931CB767AFAFA13D515B36CDB7DF1E163CF2AC86AAEECEF740508B7F897B0E46EEA75CEDC61D87760700835ED66ECCEAEAE5E98CDCE9257B9A3BB33168FCD7652CE736B7EF6F71F';
wwv_flow_api.g_varchar2_table(23) := '1E7BF89F3F6A6A698AE14D0A7C9D4841C920E0889968F44776C97ED729EF4FA56CE949E3BD3B19A831CE0ED71466D6E7FDFB5AECFE73FE7D7EEF3FF6EFEB6BB379507C02CEB4030BB22216B316E0F4472DEA37D8DEAB32FCD9C7BB6F10306B1EB1048942';
wwv_flow_api.g_varchar2_table(24) := '8B2D298B2714D89E3420E224DE483140936D1A7AEC3FA7BFD35BFF7743F779CCA4F30EDED205B3E27171D34EDA4DB9A84CF1C92060D42E6A49CB9754137447E0B82AC8081353937369B8B6E97343B7BC489F1BBAAF0BD4DF0FDEE28E78F18F6B636B79AF';
wwv_flow_api.g_varchar2_table(25) := '8741FEEC6B32F495F96E0D3A597E81E45B8D12E6F7AAEDAD082720DB24AC24B53AA3264FDE793A3A13F0016E551B8D5D4925F79A8CC264641070611508D555942C353999F0CCB47A9F56A86A9877650C021ED4EFF2AE48A82E9844900D020E15A2E22B33';
wwv_flow_api.g_varchar2_table(26) := '49201B041CD13178B4AE5006F15468733D5AC6F07E6710F02432D19A971E9315649C0C7A4C0E408406016BA94CB2ED20C8B0520140C8492C002338053827DD5176AE831C10E5008A35083880EE378ACC27FCAB1C64C48618E90AC25C072042838003E87E';
wwv_flow_api.g_varchar2_table(27) := '134E718C1BE6206BC7CB709B0D17C7D618043C867026CBD7841087D872DEB5412AE1D6E0006A17E64EC179B2828C6D10E6DA50DB0D6AB0C19E6CA8718116C3E62AC806C7E40044681070A0E20C67E139C8018DC9065A3D05B858210E825CA4B90E609433';
wwv_flow_api.g_varchar2_table(28) := '083880DA152BFC89BA3E07D9A0B936547783800DD528AAC5E420D35C17A9C906653005D8A0305518D3B4E35564FD0C0266179E4A39C895E170BC0C02FE1D1E8387F66BF6750643F2851C808E18041C40ED860A2E4AC785400E40470C020EA07651023A5C';
wwv_flow_api.g_varchar2_table(29) := '5DFD906D88BA043A6010F0702D9C3AA7A0EAD8351F881D2DAC19400730083880DA4D96FEA134197019BB569A3C82AC02308206010750BBC90298ED182F64C36D360878845E69B8C2912E8EEFD5A1991E4B930D36D220E0290D1E938B16517C04C801E888';
wwv_flow_api.g_varchar2_table(30) := '41C063366F2A839600357938C8BA03E87C06B653800D0831EF22087282C664838003B02F794B2E62175C07D97CFD0D020EC0BE986F6FF84A1C04193234AC2706011BAE59F8500457233F648ECDA30543F2AC85C11F804F69709EB21F9C5D4FA1F0B20149';
wwv_flow_api.g_varchar2_table(31) := 'E3206546610C021E5CDFA9A33C2540FDC86932B024F3BC7E84EC538047104CC94E1332C399861E59373806974C2493F0C666CC330533293498E2C0FBCC1468BE74527B03DE79EF3B9EE37F95D489DFE18D27FA30EFADFA0F95795F35DE0B06EA39DE2B46';
wwv_flow_api.g_varchar2_table(32) := 'CA671070E1C21AA972639DD700CB002E69C5955173002D93F5426378978A0691C2F93E37A3A0F23ABC3749AA708DF7DE139ED1421D6E5F9FF3B6EC4CDDAE232C535F35565D4BF5BD41C013DB546A5F395E7B548E7FE2DB9E49C931A70BAA3AD2ABA52C99';
wwv_flow_api.g_varchar2_table(33) := '192B93F9B17225671B58AE20EFB1F4B53CE5CE367A9017DB9552870E920E39648380F3945581D9295EA66A0897608FA63B607BCBE58F9273E5A6F2066948544B7516640FBEBF96EE91B654BB1CEF6F935FA5BB64254053931702D083C979EA8D49AED278';
wwv_flow_api.g_varchar2_table(34) := 'C0D37D34A7B0D8D1EFCBC22E35975601AF3F9453A9ABD2EAF4AA0EA6EBE4D52C5C7F23059882A45798B46C3990C6AB256371F956C317A471DA325958395BEACAAAF0AC5B1C2B72DE9B78330091CEA4A51FA0DBFA3AE4EDCF8FCBF7DB8EC8C7995E79BC76';
wwv_flow_api.g_varchar2_table(35) := 'B97C69E166E48D89837C9AED887890811D81E577A5FBE4C54FF7C877AFBC2BF726EAA507E63AAC29328035DC32203E986E87C6CE97BF9CB75E564F5B2CB5892A058840B5B34581139A6B7384B6E486AAD900D3239FB41D82779592EA78526656D4FB005F';
wwv_flow_api.g_varchar2_table(36) := '8F589DC96A30F739B62700B8DBE993FA78150A4FAB319EF70A6B8A0C606A2EE11E763AE4CBD54BE4EB0B1F9125B5F3A15519E983C009B1CC4614085B82E631DFCEAC7C6A8049392968721AF1034BBA494B995CB5E1EE90C4337CB99D2BFD69BA529E33C5';
wwv_flow_api.g_varchar2_table(37) := '721D74988E54B79CEFBF8A2C09A15317E61419C084FBBF996EF9438C9B5FBFE911B9A56681F4A6FB311E3A9284D01DF8C7A73B2FCAE9EE8B72B9BF538DAD498CB733CA6A6476729A2C8006B3037413885526E731861E6BFBADD260821B186B01135AEB59';
wwv_flow_api.g_varchar2_table(38) := '034B6EA95D20B5F10A987A07DACB77965A72A4EDA47CBFE343596D5723A2C81863789341C0C1F46496CA294D37CC613FC6CBBF9EBF4196D4CC971E682D0D7245BC5CAE00E86B170E4B4BDBAFE497F08C7BDC94A79A188B6F8696AD4CD4C9E6BAE5E24073';
wwv_flow_api.g_varchar2_table(39) := '6F8173168FD9F28BAE33F2DAA9D3287920F15E9C5655E23EC7526DF22F7336CBCABA854A47A9C534CFBFB9FAB1FCD3B9FF915A1CD383EF452DFC650C94168E3D83808369264D33A735BF71BAE5C96977C91DD3968A036DE278580E8DBA96EA927FFF648F';
wwv_flow_api.g_varchar2_table(40) := 'FCE3677B41A74A6E85D656E03C531A79DAA1DBAFF45D92572E5D9425B10A4C6D6C49E3BDBD7DD0FC0E7C3CF3EBD59D47B3D0218EF55F92BFA85D25BF3FE70B5285B1BAD7E95756A2B5F78ABC70F60D792F754D1AD16938170EA6D5AAFA46FE18046CA43E';
wwv_flow_api.g_varchar2_table(41) := 'D715428DEA879608B4E58B0D2B9473D48FF1348E636AF02F2FFD5AC1BD333E1DD3A3B8CAEBD00AA3A472FC990B8D9D1F4BF2C5DF0A881E33CB01FAC66C47E04D595625F29E4E77CB868A1BE42B0BB7C8FCCA19D29DEEC55BBA6DE98363F693F307E4858E';
wwv_flow_api.g_varchar2_table(42) := '93B2365E2FBD30CDD4F829C0945E11891A7C3ED32FEBCB1A6451D51C5512B52E0E389FF55E959FB6BD0BCD4D4A0D8E5B337DF241A607E699E3A2167D1643D61B9E060DBD095A4E3C5D30FBCC9541169ADB4B983E9D467CEAF9790FCA528CBDD45C3A6936';
wwv_flow_api.g_varchar2_table(43) := '4D7AEBAFE56F3F7B475662DC65E9EC28FA0EAA5221FD6350832948F3891A7C1120B6964D934A984B2F28E1DD8780F7F7B6C2D9A992D3007BAB5D235F9DD92875F14A68ECC01446D78C5A7FA2EB9CBCDC7E421A3816A36CCE601380CF71FE183CF4EFCDD9';
wwv_flow_api.g_varchar2_table(44) := '24F7CFBC0D9DC4554341452229BF6D3F2BCF9F7B432A70AE868E5A044CB32661107030FD59950A8D9C817927830C7ACCE4B62DD529A7DC7E5917AB96F710D1DA8468D6A373D6CAECCAE978717B2F7E876DC369CAFA5B004827696FEBBBF2DD6BEFC974E0';
wwv_flow_api.g_varchar2_table(45) := '555129E82363D2EFA42ECB57EB30EECEBD572AE0957723984107EE3202243F3AFB96BCD1D78AA0461D4C7378831A1AAA7FCBF61B4A5A4F0C1537A81857CA300E529B75E2DDB874407CFA2CBF4F002AC74CEF8333CC08CD53661B5BBF05A099AE215C44C5';
wwv_flow_api.g_varchar2_table(46) := '7EAF7C96FCD9FCF532A7A2011E7ABFEA0C29C0A477FEDCD5E37257BC0653222C64A0387D3FEC863E19041C4C5BBD6E6349179C1C86147522CC5ABB02D395B8123CE7B10E00F4010E3FBD18B7FBE08CF11A42A5D74DA0BA3CEE57A0235C463E5EFB8D791B';
wwv_flow_api.g_varchar2_table(47) := '6539A6447D985B1360C28ECB51CC779F6CFD05C6EC244CB8AD1CB828C1A5AC0C9A682D7AB35B0504202EA53A545C998106CF4C8BCC2CAF93B5309B1F61316105A6481F63FAB2F3CC9B084C544A1716026ACBAAE51198DC19C8C79834E12840809DC07B34';
wwv_flow_api.g_varchar2_table(48) := 'B091935885FADE9C8D72FFAC553846EC1A5A5B8571F763044DFEF5DC9BF2191CAF25F15AE9540E19EFEDA5A88036083898261326831527FB2FCB5504346626EB9584B9A2331DFB5BEB57C8372EBC261BCB17481B021CDFBA72D033C94EA72CA9BC5936CC';
wwv_flow_api.g_varchar2_table(49) := 'BA4B8DB55A77D5C5E8244918FC7DCE35F95ADD6DF2D8BC4661D48B53228EBBED0845B69C7B47FEABFB8CDC9F98260CA93092E64FDE0CDA7F269CFB0601EBBE6DB6A134CAD331053A8AD0E2898E4F6531E2CF3178C3D4483A435B67DF2D873A4ECBEECE13';
wwv_flow_api.g_varchar2_table(50) := 'B22C315DD62566C0F4C6E52C347329C64DB05449C5A4B1A72DC20174800D6533E54F176C50A14CC22D83134693BEE7C25179AAED00BCF22AE9C4D0D003C05C9FD22D6491F408E8A4853D19041C4C53A929EA590D40FBEFCBC7E5DE192B64763996E830CE';
wwv_flow_api.g_varchar2_table(51) := 'A600F9C6CA59F2E4A23F90A5E767C8CEF693F276EA0AEC30B40D0017964F5720FC35535060BE335833FEBBF99B6445ED8D6ACC6607A0D77DE4F207F2A5D63751862D9D28E78CCF34132721334EB6180715D80E780538086132083898DE4C81723D670D16';
wwv_flow_api.g_varchar2_table(52) := 'E85FEC3A25F75D3C26DB6E7C408529E94CD1722E456CFA2B8B1E95473BEF96CF3137E6427F39B47176C574A9C738CC85022696E5396A69F9C1ACCD721FE6BB5C54E0876BC8EC309C43BFBAF08F55F974C47462EBE8A8318ECD55A99FB61E96E719D542E0';
wwv_flow_api.g_varchar2_table(53) := '83263CACC920E0609AA8040B41D36B5E8E58F237E1D536246A64E3DC352AF0C168133F3558F159DDB044C1A237CD857C5E4B686915F48829134CD3BABC6C96AC9BB90AE32E82169C2F23AF07DE550B19CBA1D583C6EC6CD3F47A303DF477AF7E2872AD57';
wwv_flow_api.g_varchar2_table(54) := 'E270C0F88448589341C003BD3D88C6528B3967ED8370BF76F6556986E7BC69F61A8C9F0D00C41F0338C21835B1D20C6770CC1AC5A1995C94E0DA309DA7D3DDADB204632B1F12E09C99E3383D737FA2377D5D527938E746A974BF551A7CDD75D784E08441';
wwv_flow_api.g_varchar2_table(55) := 'C0C13696A5D314F2E1B93644AFFEEAC21EF9F3F653F250C32AAC0DDF203392756A214219E32C0082BA8AD5A62BFD1D72A6AB558E5CFB3F79E9DAFB723BE2DA9FF67CAEA64434B704CCF21536752D8E86690ECB63348DF36B3EEB85FF24891A69D821A039';
wwv_flow_api.g_varchar2_table(56) := '4C150C020EBEA194792FA2C7D3B1605F8B40C4BF757D84CF29590760B797CF94B9895A29B7CB15302E29F662CDF80234FD04A6587BE1850BB47F2E9CAB0B885C3DF7C92B5860B81E90C7957F3D234DF46C9937FBE616D601672E605E4E2F3BECA14B8380';
wwv_flow_api.g_varchar2_table(57) := '87E93E019CA2807B00390163DC88F1AF031A7804018EB7F1D4646E15495102164526A6A250CB60A6EB314EF35437AE79B5E762D639F2908EBFAA1EEE5B6049AA60FE6931F22D61EC7BF11E6652E400B3D91C67F93CB27A5C0742BE2356A93C5C8E9CD43B';
wwv_flow_api.g_varchar2_table(58) := '0F81978FC2578B0A30BD7CFA82DA1787495E0DAFDCC6B63051F28101AC36E16AF370D94273A54612B05F047C1880C226748AC5FBCB1C70BC144E6F7AA3BF633E4225EC02E9AAB2BDF2D46EA8FF18046CAED7E523310D8ED7109C5F837539843A345D7F66';
wwv_flow_api.g_varchar2_table(59) := '688EC9713C38C05A549B0A337645DD72848BA30FCF9C2C0D028EBE5847E82F25386D4E96060197400E53B71C530206019B332B63D67A2AC3B8256010B039B332EEDA4FDA8CE694C5206073959AB4DCC6DD3073CA521CE096F7B335E10FAFF1789BB97A8D';
wwv_flow_api.g_varchar2_table(60) := '5B14932E2365A8E2E1D91FB3E7645C584B8B03DCB452A9AD6B613DC7C57ACD94121746C17F156508C8AEC33532A4AC8CD57E017F8A0B74647B97E562A5D48A21C6C0DA797F0AA8CBD4252A4EA308BB96CDDF5B209552839BA449D5C18E274E61E703BB16';
wwv_flow_api.g_varchar2_table(61) := '0FB170B1453DC962613BF5195B069417E5842D64A76448597A3285843D192B4117F0A7B8519366D9528F96CBED6F3DF1B895B17E68D762619629BB408E9D02AA351197646DE144DC6A3CF750860F8F1475F45E732DF7CBC7D73FFB9FEA329F8CC753CCD0';
wwv_flow_api.g_varchar2_table(62) := '3CC54BDF5781D53F7F622DC2FE8F81793DC6E370FF7076A8244A79ECF5B5184479D54A647EF2DEBA670FABEAF8645BCAEA71E428BEA394B605E1BBBB2199FE3FE86AB6C90C1686510000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72349300162797170)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/gz2.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D0000187D494441547801ED5DEB8F24D575BF55D5AFE9E99E9D65C1B0BC0C0B18CCA298D8C10E444A6C2345892C3952E45D45CA8724523EE5532C2B912245';
wwv_flow_api.g_varchar2_table(7) := '62ACC88680E27FC0F91009D8258C3F44F9904879C82891B11C11F3CA1208FB823560CC3E667A7A1EDD5D8FFC7EF7D6ADAAAEAE9EE9EEBAFD9A9DBBDB5D55F771EEB9E777CEB9E7DEAAAE11C2400A026119203355122BC18ABD1FC69116626E608220B090';
wwv_flow_api.g_varchar2_table(8) := '02127EF99D6F7E31F0ACAF236719977E6EE2696E4D5E5BC207EF15C72A5D3E54AA7DFFC1637FF95E10BCE80871D2B72C21C763B2BB69D12AE4E93809EE8FDEFED637025FFC6D7DB97288347BC0EDC9087B4E8B32598F65BCCEAA93CE23B9745B9D97ACDB';
wwv_flow_api.g_varchar2_table(9) := '450F057E49F89DE217DEBEF8CC9F58D6C90B3FFCE14A210856BCFD0272522414C75029084E3896B5EABDF2D69F1E6D59CEBF2EDF503DBE7665B31358C2B6206DCA55CBB37F47BA16BB56E7018EAABD3EC6D8E9DABA66BAA47FDBB8A53A83DB0902BF5828';
wwv_flow_api.g_varchar2_table(10) := '6F2F2F1EA9B7DAEE4F8A22F8BDCFDEFD171709F297BFBC3F40B687423455797555656CF9E21830B9BFB1B62D14B8027403801C741D99D7FB517555BE6E973EC6EDBA690ED356D7A5F2F19CBA17C05A85D5EEB8CDC3CBD52FB9C27A1E967CF757BEB2E2BE';
wwv_flow_api.g_varchar2_table(11) := 'F4D28AB31FE6640E74E474E2C4711A0324E65801FE21D1F220B879F82856C1B34D87B1BEBE1DD4972A8F7502775F819C0BE0D5D533D2F33A8E0DC325C223EBCAF41AFAB063E828E3894663C7AB2F2D3CDA09BC53672E3D792F2D59881765D9F418CCD773';
wwv_flow_api.g_varchar2_table(12) := '2E80B5059305CC7D2A94CEC7CF445AC3F5C60912806206B68A1A24C84B87167ED577AD53AF9EFBABFB1078792FBDF46DB86BE8F01CA65C0027C72B9D73326386CFD39E46CEB5001D9E9AF333DD352DF991825D7C3EB6E4D5B9B4646300278D6286B1CD64';
wwv_flow_api.g_varchar2_table(13) := '8D16CC900BFF390C0972A341902B8FD092DF3AF7B4B464210832ABCD4F3206F05C8D3A854F066821C89893EB95473CC77FE18D0BDF7D80EE7ADEE664630073FD39AF495A702FF30AE40D09F2E7B1B43F1D833C3FEEDA18C09C83E725A55531C382F55062';
wwv_flow_api.g_varchar2_table(14) := '4B5EAA3C6C0967EE403606705A685A42B378EC52452C93FA58B0665D82BC812554AD5E06C8F60BAFBDFBD471BAEB553927CF76746D0C60159F6899CCD1713009B096D5A4BB5EAA7CCE295A2FBCF5FE330F9D9C0390071BDE407875D9C5402DA656693477';
wwv_flow_api.g_varchar2_table(15) := '2341969B21F5F2439EEF9F7EFDEC7714C8AB276776096510E0A9C1357CC7A3EB623C27D7CA0F59B67DFA755AF2C9556F7546413606F0E8321B1E9FDC2D46B360DD6D1C5D2F2D3C64F9DE0BAF5EF8CEC31AE49595156332D51DE639CE143379063254DB94';
wwv_flow_api.g_varchar2_table(16) := '36EE1245F7234B90ED6673C75DAA578E3B5842BD76F1C95F26C80F3E78C69A25908D019CCF28FAC97102F97B47D1FD98E0FE97D35807C84B0B0F38813875660641CEF5444772E429A34816CDDE39B551339C4FC5798754817C68E1016C6F9E7AEBE2D3BF';
wwv_flow_api.g_varchar2_table(17) := 'FFE05D7FFED320380ECA2B36AC192A34BD946F7809BEE76A274B834BFEF3885FB9AD18645832A2EB17FEE7DC938F58D68AFFC4138078CA73B23180639348A03EA3A79873E3944702B1A24420D70F55EEC38DF153B302729EE1C5429AB333B8D5AE344290';
wwv_flow_api.g_varchar2_table(18) := 'D5D53EBC48827C2FEE493D3F0B201B033825B32C01CC6CDE1E5B95C3F01D81BC5857967CE6C2335F9AA6BB3606F0305298B5BA862C580F4B828CBD6BB7B654B9D717DEE9372E7EF7D169816C0CE0B90AB23414E1D1A0056BCA31C8F5CADD7820E8D41B17';
wwv_flow_api.g_varchar2_table(19) := '9F990AC8C600DEA7B70B3560A31C2390F1D0C05D020FF2BD79F6A9C7266DC9C6004E06A6A34863926DBAE285D1373A06615982DC84BBAED7CB77E169ECD36F9C7FEAD709321BF3F7508310C953C76007F304714264062590A09A3CA573739A8D16E7E43B';
wwv_flow_api.g_varchar2_table(20) := '51F03C41961B20DFC64DD631836C70785D76911CE0EC9D4F5E1725C80CBCE0AE6F87593F17812C9EC013B9E3B3648300CFD12DFFE9E8A29A9337105DD74A77E09751CFE119AFDF4026D46D7C201B0398329B8EDC66CF41ECC2919A939BADCE62AD72076E';
wwv_flow_api.g_varchar2_table(21) := '48F106C557C709B23180E7C87E7791FF448A600756611320D76BE55BF18389676390578CBB6B6300CFD9F3E05D481ADEE8E8A29D7DC107F5AC4293965C07C8C27AF6F5F7FEFA71B51E370BB23180E7D93D8377588E828207F9C117F3A20FF393D7E9735D';
wwv_flow_api.g_varchar2_table(22) := 'AE8FC9F2300FA0CA6EE4177F682B4401D175A7BA58BED5F68367DF3CFFE46F12642EA35E7CF104DE36903F1903782E77B2004298383712651E642CC193AE0FF3D379C96B5DAE8F1965E841D1475998185D17F1B4A65BAB578E829DE7CE5C78F2B758C6A7';
wwv_flow_api.g_varchar2_table(23) := '434CDC6A3406B0128BE67BC68F1A5806B0D04C3C3C87F77260B1EAD8BE6DD9F8E5FA043F36FAB21D67ABD96A2F2D556F02337FF7F6A5EF4990B95686B5C7EA3082588D3DD13142DFD36B0291D14D12542F709DE6C6C68E2F82E6F418523D379A1B4DA7E0';
wwv_flow_api.g_varchar2_table(24) := 'DCDC69BBDFFBF757FEECDDC77FE59973ABAB276084ABF84DD468C918C0B9D46C34DE73B552FC62C20BDCF28ED772B636BDC0F769C82CA189278FC9AEB2CAB2F2926DF479BF7A617E208A70281E3CC867A17DB7A3D539F51BECF05D199ACC104763000FD1';
wwv_flow_api.g_varchar2_table(25) := 'E76C54057EA1155BE54AB1C837396C6DB922F0E11325C86453A94137C33A4F1F93F59279DDADD4952ED7475D475D939F52B1203A6DCF156E80B70BE44FC6009EC7208B3852A83E66BA62C9165551105B9B1D05321F8CA5613151FE19E7CC52D0B0D270A9';
wwv_flow_api.g_varchar2_table(26) := 'A7AD22042712307A46E8A5E8E9D7640C473DAE6D2CC89AA7DB85F1F021492558AE5F2C806C2D5469CC9605413304531F94659D834E9C3FE4794FDBB00FA93109AD49BE2623C9F7A0E7C600A646CE7BA23517CBB600C882EFEC8816C7931E9841611A0338';
wwv_flow_api.g_varchar2_table(27) := 'F661939686E1FE66056443C3320870C2AF18626E6A6434C88B53B26483A23408F0BEB161A55700B984C06B615A201BD26E630053E90C2A9EA1E1E52323972D730EB23180F799FD469A31EF201B0318517E2494FD76A241AE4A778D575B32634E923180F7';
wwv_flow_api.g_varchar2_table(28) := '2FBC0A49625AE066C862014B28808C1DAF7948C6009EC79DACA10102A672C78B203B63B46483BA630CE0FD176265C3DF63C9E370D706DDA14180B305B22F73B525D7C66CC90684670C60834A676058E327212DB918CEC9E374D73987620CE09C7CCC6773';
wwv_flow_api.g_varchar2_table(29) := '587281205767D7928D017C5D0459596A4890C3E81A8FFCCCDC12CA18C0F37ABB300BB3A1F33827C39217105DCF1AC8C6001E5A28FBAC01E7E45904F90060838A368B201B03180A7C9020815903D918C0D7DB3269376D9E25908D01BCDB80AFC7320D32F7';
wwv_flow_api.g_varchar2_table(30) := 'AEA719781D003C46ED23C85C274F33BA3E00788C0093B4B6643E1932B0251B0C680E001E33C031C8967CFC6720900D063407004F00E024C87C6840823CA1FBC9C600BE6EB72A8750101F2F4F2A142D3C3400900B937968C018C0D7F556E58020EB9FCA4C';
wwv_flow_api.g_varchar2_table(31) := '126463000F38C6836A9000BDF3A4403E00780A2AC718AA0B642CA5F8205F145BCD62146D90A729887CF25DF6808C3999A04B9023A4F3F365CC820DF2947F5473424182CCC0ABA0022F1E1988994CC6003EB0E0D16089022F80BB88E89A73B3C947728DFD';
wwv_flow_api.g_varchar2_table(32) := '00FCC082470358B7E28E97434B2E1485E7E235E22D3326630C60CDE8C1717409A8BD6BEC78D58AC22D99F1D507008F8EC7585A4A4B76F0068785F01D0E397B313607E7E4E3A07928014E7504D9541AB3056771BAD76C9D6E93AC9F2E1B460C9ACE6E3474';
wwv_flow_api.g_varchar2_table(33) := '9DBDE8F6A3916E9F552F5DA7B7AFBD6BF4B6E997630CE0ECA1D0CDC4EC06F2CF8CEDF64E2F6E7892A5641BD6E7C741EEE8AF6F0C240DD229E0C52B705C3D0C73379DE59CFBE2FE71914AE431DB7DC6ED5513552F490BAF5B937DA4488EF1D218C0C96190';
wwv_flow_api.g_varchar2_table(34) := '5F292E7F1D671D7CB05303C1D956199F051667242C0F3078CFDF40195F11C5D9C307180B6853C126C00E5CD776D88EBDF5201496250F713D0B34149D4DAC35770012E99306EB1054FC0D51AB8AFE28927EB4F96216F018705CBA2D4EC3FAAA7D29BA7631';
wwv_flow_api.g_varchar2_table(35) := 'FE00E3D77D59566997F1938EF9640CE0246B0497D65629DE8901952114026503BC2DE1FAD7C2AADD2A41706D51C28BC06E465D5A08DA20C705E0AEB7268ACE0DA2602F8132059B146EB2E7EC73DA9CEB35406B1D743E053A3550D0964A5EB955E88A8E77';
wwv_flow_api.g_varchar2_table(36) := '05B91A905E5A4A498BA25CB80F7AA11584F5D4585C6F1DE03771C56B2B1E7F3816CFDF4E8CBF97FE38728C034C60FD6053149C1BC5D1A5DF160BE55B01EC0E84BA20D6B7DF151FAEBD28C7416D56AE97970558D5A628176F11B71DFE1D512A1CC6750BBF';
wwv_flow_api.g_varchar2_table(37) := 'C32D892BCD9F8A9F37FE5EDCB8F0557163ED11090C15065A20E9F4609DC49EE748B65D1097375E111F3756C5A7EA5F13476A9F034F2D94900600B61C09F0C78D97C4B5ADFF148E7D18F974D73AA9BEC8E3D2C2A3E2E8F2E328D0AF59627B822DC42F1A2F';
wwv_flow_api.g_varchar2_table(38) := '8B2B9BFF167A0247DCB2F435512DDF8CB1749057141BADF318FF2AFA22FB9C6E420665EBF17C190558B20BC1E3A58F18BE036B5C8616DF203C0F003B55B1D5FE381C056B8600C9339EC382218472611940A30D0028D865581CAC2DE840E88B329F2E9296';
wwv_flow_api.g_varchar2_table(39) := 'A4AC84E4623ABC5249094E8BCF01DD82B388766D49AF523C1202ACEB53098AA25EF90C94F027B23FE5AA69E54C04D3057F0500FC80582829D054992AE7EB0F1DBB8A0B2A861A5FB97008E33F0280DB927ECBBD1236D19C8597633C180558F1499747A163';
wwv_flow_api.g_varchar2_table(40) := '370620E90FB5DC0FDA0A0FF92EECF4A820C4541B0ACA07B83184BD826139410F094BCBB0A575B095AEAF8FD8EB457D7A94C882A990680FBF03E06E8182DD21B63B1744C15A466B4D97945A28BB4D544B47A5C2928EEE93F1021D0A9540E64986D11AE355';
wwv_flow_api.g_varchar2_table(41) := '7D4141E175E4F8516392C928C00A08084C9E10660C5C0E9E026014AC5C592CF8F450D126ACA7DAB20DF3CA62A7F39158DB7A27049333B19A3B29F0A253073CB030B8FA8ED784A7F8B90447F547175A10DBED8F702CE2435E143F723E97F101DC25FC26BD';
wwv_flow_api.g_varchar2_table(42) := '47B5748FD8EABC2BE92B003918D404788BA57B317D1C4A94A146A84CF205A6449989FA84F3680C96A7FA8CC62F6B4DE4CB18C0DA462828BEC0B1378599F2100A022248832D851E35565716A2DBF5EDFF168D9DD75002616199E2619E77907FE7913F84EB';
wwv_flow_api.g_varchar2_table(43) := '5E8655B511F794C48E7B597C8079DEF51BB23C901139E658A800C21E4959BD448596DB81423444C981B502101B7141ADFC69B1B65D47590BA0A8889816CE08BC56B9474E23B45E17F33153C921E03A609359A92F0C9863C650BBC796AA36A64B6D52B9C9';
wwv_flow_api.g_varchar2_table(44) := '4750C981EC424E0624CAB295859005FD2195EC44774940285C7EE4399760E96D1F5C47E5B03A7D8EC02041389438720830DDA8E221809B3E0A4BBE1DEDB68189120FC12E176F8775DF22695041DAEE9AA44D4B5599EA306BDFC6004E0E2C1B2635C7FA58';
wwv_flow_api.g_varchar2_table(45) := 'F678013F4D19393332A535FA41031F085A5A784C4DD3A29BE51A5A7E6CAE69ABF25C0B58D7E3F2C5916B5ED495F5541B153475D36520E87A9BA28DE50DE76D2A0303A36AE9182A7253422902D7B2B5D27D722A20839C4B773ABF401D398128A21103711F';
wwv_flow_api.g_varchar2_table(46) := 'BD670355EA6D9623C7988B260F9AFD1446923D6A3D5D60A5788FBC966BDDD0AA388F79FE1108976B60EA5C4C213A43FBC0C20BBB19F8609297AE97414D58A1AB1EAD1DAE99F3A672D1842A69C16CC6B9D981056FC90F5DB3E411D1740D7F47F2DA165CAF';
wwv_flow_api.g_varchar2_table(47) := '74D3785F2594A986BF12ABE7DBB6DBC03CFF3344D49F9174D400E5F71E5F11977BD433576C0C60B2DE9F7D46AF6DB158BE4D1CBBF18F62EEA91151230ADC964AE013B8505DB4D2A846098B911928EDAE90B8D6755981E7C9C42B2A1CD7A2BE68627D7AC4';
wwv_flow_api.g_varchar2_table(48) := 'FF3CAE8BC8F564345D4134BDD97E1BED105D17EFC6E7E6904000703F84D55F91F563FE93F467E7DC18C0B100D3C28C07CB75A4E364EFE3EA5ACAD208764C5197ED76CCAA1DE90E1ACAF38C4A74D35BEDB370B99761B977CAE553A95087321E9300737BB4';
wwv_flow_api.g_varchar2_table(49) := '5EBE5FAEE3D93F973ECDD65958B78A8C230DCDA0ADF8ED5BA08AC7FC3D863998CE2F2BA9DC7899A2972BF111A8CA86F0C6514A9CAAB2A864B093AEF65D1784868AC4A5D58762B3F53E08D28D230FA0D34D7373857BD835FC7DE7D83DAFA3EEFFE21A11F6';
wwv_flow_api.g_varchar2_table(50) := '6E8C46ECA53A8DF2277362CC82F71E06F7A2B7C536E62F9988A56E24CF95B0B916A5D0D57664AF107AEC21A4A149A55BF4D44F56402302C7889C6EFA06EF97B07B861D2F582777AB4A0EDC3294AE52BC296C05F7DCFA00EEF912CA8F45ECABC23407E9EB';
wwv_flow_api.g_varchar2_table(51) := '64C7933B37063005A985D9EB5D0344B645D1689F171F5C3B2D05C3808B826422A01E6E042C2000BBE386DF45B085AD4A0438B24C7E777FE97E9215BAF2C2EACCD362E6790F5FB211E7E245B97BB5DDFE0481531DBCA82DCD6AE9D388C4CBB064AE9FF137';
wwv_flow_api.g_varchar2_table(52) := '96B09CDA689D0BF94EF5984D3CE4647A076300770D414B35CC94971000AD92775C78CD8D0315E1527478060977994ACE36EAA41A771156177BD7C86884ACAC762A72AE82AF2B9873DFC37EF49D5004055EAD724C06522A5CB344CBBD26E76B46D583A758';
wwv_flow_api.g_varchar2_table(53) := '1154748259113B415C63AB78439793BB2C0E07EF29ABA6518023F634CF618FEA9283C2B0705789F56C81DB887297899685A508FEA88DDA4AEC6533450E54464BD9ED1437A4D88475B6BD87E1419611F5736BF276304720C83BDDF325CCD797C167797706';
wwv_flow_api.g_varchar2_table(54) := 'BA3A8AA422E9703A608ECF3A5D9B2F9483F990C8184532DD35AE1E11A85239B7C2352BED6550830F072A07CBCD85DE94CE4B5FF7B6C8CEE9DF8E0F232C2292BE883D6BDEF1A2B709E41DA802DC3315D3A57BDE391B12A6D8FA53DBAD48592FB74D31662B';
wwv_flow_api.g_varchar2_table(55) := 'F989E9F50B53B347B57BAE310B960AB96B5FE10064C57EAAA09CD8AE6450D8AFF59EED621926AA124CDC4DC25CDBF13F8115BF8779987BCEDCD9C27A1CEE1A7F6A4EECB42F639E3E8FBEE979F4932509327D4F15B73EFA60B076C7E13F404D32128E028A';
wwv_flow_api.g_varchar2_table(56) := '2463102CC7AE6EFE58B4FD8BB8567BE67D490E51600C60F619093E12244FA88FF88781F05F77628B645E5C4FD5CE6AD3DD028413B4410BD73AC567AA0DEF72293ED43664F8D77C7575F05FC43CFC2EF699BF20EFE3D2DB70C9442EB88C72BDAB986296C2';
wwv_flow_api.g_varchar2_table(57) := '3E485DD1214DBDC492C43476726C2C238F9EDCEA3C5C5D9655F41769738385372F1ADB6F09FC1D4514F1B1A624F7BAF6F047A3009359CEAEEA48E5E7361F9F43F261213CA23BC9B7665E1FC9B86ACB1BEF8CB8E9BE1CB6950FE1C50363AD4891704EE190';
wwv_flow_api.g_varchar2_table(58) := '36AD4DF5C58D145583DF7082717D0021375B4097418E5A93AB272B3865D85822D14DF3762397498C9EB1B30DE16FC1B2FF4F7248C01555B5EB461E83E87620C5090E4326C99B5C2DD82AFE40A12CE2314A5239D8868DCC27A3004B5182510A8E026BBB57';
wwv_flow_api.g_varchar2_table(59) := 'C50E5C9F8B1BFFAE5F4100B3861168784229A0A65208B51E6D75AE60ACBC398E477620BC0E6EFB110C9528289D7886BB3AB0AAED4E1DD6C5C782CAB8BE26FB663FA4ABEAABA3DA7B6E00C44F401F0F12804F3EAB451749D06C46F3B8E9D1D8791B00DF84';
wwv_flow_api.g_varchar2_table(60) := '7C750F9B5B93DB9DF7C10F832BF24DF7DD92B726A904D2D249CBE75FA825AD90373CC1B10385E5EE17F362DE711926F248A573B147409A7CAA54C943D7C877340AB01A16B7F0CA58336E898FD6FF19CC737F9702C646076FC141102AD1B698D88AF75BAB';
wwv_flow_api.g_varchar2_table(61) := '8850AFE05EEE3F4483A448BC600B6DB4556AA5508FF750893E6EFC8BF864834B2EBA53EE79B72070376CA3ED57B5E3139A57B77E847BCBAF863C85F4A54B2474F40275D1DC79134A7009D468ADDC9EDC025DDC6F9663619D05D1EA7C282E5DFD01EAE828';
wwv_flow_api.g_varchar2_table(62) := '9B81D8865C252885F431FE7F4A8C5F92EAF90A3993FC7B50661B8F36F1B749EAA1BE9EEA43671803988CEA444173D3BEED7DAC842DAF0172E8B274BDE4916B4F3E95D1723F421BDED45716482B5600276BF35CD943DBFB24D5076F2B9665FBDE16169468';
wwv_flow_api.g_varchar2_table(63) := '4DB40375AB8FE554C0247D5A2DDD7DABF3815402C29EE69B4A0AFF843A3F937594629316798D45DAF6F06409C6A2AD57CB4871AE7C81E691E327DF057811F5D8B02EC9778CB9C9472714774C8400D162C8B81E981A92B6DCB8AE3E536DB81E4EB661FD98';
wwv_flow_api.g_varchar2_table(64) := '82AEAB8FB4265D5F099A75FBF741104457949AA64F40E19AAD9AEE02C75E9AB4520B73B6563455B99B96DC10C158064BEC437F066DB33765630067CF1BD9EBDADDD91AB64D5C9FE2D93BB196DA22ED5F77903A6CDD5F9114EDBDCAB33830072EA9EB0931';
wwv_flow_api.g_varchar2_table(65) := 'ABA7A1F2687D0769F624600C60ED5C666F88D73747C600A6FD1ED8F0EC29933180079BFF664F00FB9D236300EF16E9EE7721CEF2F88C017C1064CD26CCC600E632E9C04DE707D9B40C7301BCBA7A268AAB60C1993F29CB3FE4EB8B02059A3495A48C4791';
wwv_flow_api.g_varchar2_table(66) := '442E804F9C382E15CEF37C3C8412A8BB6FA37071D0269280BAA9843D72C894995AC65185214F72ED6469EDB26DFC2298F8823BFC93B75D87E4630EAA2BDB1A8DD1C1DAC25AA40C692D1EFEB12F2DE3D1FA55F7B6466D0BED524DDDC0BFE058CE3B4BCB0B';
wwv_flow_api.g_varchar2_table(67) := 'C7D7AE6C026BBDBDAE626B3DBCE471E44EFB34A43486A13F6C7DD52D7B183565B78DF9C01E386E894186CEDAD5AD77AAB638CF9EB48CCDF63A2035A81BF6F9C116D27F9CF9D6371C477C7F69A9B2AC998EC868C94719A9133D76DD307D64F5645EB279DE';
wwv_flow_api.g_varchar2_table(68) := 'B69AAEA6C96B26CD73FA982E9395C3AF61DBEABE71D4A78DF59D75F4FDC7BFF6C0DFFC805493324E7635E8B916CFA0F57BEA251978F99D6F7E31F09CAFC35BF3B9143589F4B438C8484B20D40B1B61EA9AE5D8FFF8D8FD4FFF17EB24659B6E33D16B3EC4';
wwv_flow_api.g_varchar2_table(69) := '31D10EAF83CE4CC9F4FF0172BC5A423CD47D510000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72349679541797172)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/html.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D000016BD494441547801ED9D69905CD575C7CFEBBD7B16EDFB2EB1088945486C021C6227D8C4A9723E244C52897192AAA4B2B952E514FE909014522555AE';
wwv_flow_api.g_varchar2_table(7) := '0201E5042239540A8B4560261F52E5AA7C2005242E1B433008630B348034DA17B48E66A69799EEF7F2FF9FD7AF97996E8DA6FB76F7EB513F987EAFEFBBEBF9DD73EEB9F7BE7E123170388E6319C8A6A5596CDBB62D800AB47D3B260AB1EE06112E0E8719';
wwv_flow_api.g_varchar2_table(8) := 'EF7CF2913B0239E76B6239B31D5BEC0045E6DBC3B11DDB8A0582E1B38968EFB37FF0CD870FBFFAEAABC1071FECB32D4BB43DBEADFA342A169A46DC49514BE1FEDB638FFCB693B5FFBDAB2B36CB8178007D527CDF056845C3625B812DCF3FFBF85FF6F5F5';
wwv_flow_api.g_varchar2_table(9) := '0D4293438E6CCBA1F63302725D80FBFBFBA9A3B9EF3DF5774B9C717B7B4F4F62D6F0C8E838C2104EC0949177C6659905AC74AF34ACB48378E1CC83D73C26E6EBC5293DBB318B71CBD258E8A07628E4A412DD5D0F64C7E5E5E7763EF57B7FFC17DF3A2484';
wwv_flow_api.g_varchar2_table(10) := 'FC2820CF004DAE0BB0F4F7BBA2B6AD35B6E55C3F3A9AE27742C79F07C23BF356E9F5C4EFDEBD8967C6E3E185BBDFCABF7BF7269E27C6F5EE7BE1026D75AC5C3637D2DD15BF736434F91234F9EBDFF8D36F0F8A00B2D3FE9009A3E6E3A38D1B55628E930D';
wwv_flow_api.g_varchar2_table(11) := 'A0B35BB0CBC88B1FEDF057A86D8043CD6832E524E2B1BB65CC22E43530D5D9EDDBB70579AF6601F920615D1ABC6FDF3E6DBC6D071C25DC86A2E0300C6BAF9093A9742E91486C4DA5527B5E78E6C9871EFAABBFF96CC3860D840CC7CB75247DC06C5A55A8';
wwv_flow_api.g_varchar2_table(12) := '4B8337E63538AC45A2A74FB280D3AA4B0B235B9C0A08B535994A0172FC2EC772F63CF7DDC7AE85E395DBBE7D7BDB6A725D1A5C4E8496B93CA46DBED10C033020B3C3DB30D7B9443C7E7B52522F41937FBF9D35B92E0D2E07D8B6EA4B97C1AB3CCF9489AB';
wwv_flow_api.g_varchar2_table(13) := 'C980AC9ABCCBD564CE1ADA6D4C3608B85DD51738273B52259063B7079DE02BCFFDCB8EF534D7ED06D920604F09CAF5DACFDF0A352E6A706975F390E178C5E29B43417979CFF7DA0FB241C0EDA7C1851A4FD6600F744193E3F1F8A65C2ED076900D02F664';
wwv_flow_api.g_varchar2_table(14) := 'D23EE72934D86B484193E3F1E8A66CCE7AE5C55D3B36B48BB9360818E22A48CC938DBFCF050D9EBA9A05C8580CB9C5B6AD1F3CBFF3F11BDB01B241C090D2342436B54C7D17A30472FC4671022FB70364B380DB4C836BE84279C89C27C700D92A81DCE7CB';
wwv_flow_api.g_varchar2_table(15) := '299459C0335B83BDFE50D064385EAAC92FEC7AE296BEBEFE5C7F5F5F20FFE08017B7E5678380DB986E752FBA1A20CA2D904AA5B358F1BAD1CEC92BBB773E716B5F7F7F6EC3867D969F201B04DC7E4E56815EE57970E176950BF6E820D6AEB35D89F87AB1';
wwv_flow_api.g_varchar2_table(16) := '658F4286266FC0268C5F201B048CF6B6B11257813855B00B39992C407EE1E9C73653931F454A3F403608B88D35782A8C97BFCF5D8A6032494D8EAD77ACE0CB2F3EB3E376A8B0CD64AD866C10305A73F569B0871E9061AE01195B8DD761F3780F21036ECB';
wwv_flow_api.g_varchar2_table(17) := '219B05EC35B7DDCED377B22AB530AFC949385EB16B1C2BF0D2733E80DC014C54B5395997819CCAC6E2D16B4380BC7BE79377B452930D026E63FB6C46833DE0AAC929986B42B66CE795DD4F3FBEB555900D026EBF65AC428DCD69F004C8E96C3C115B2381';
wwv_flow_api.g_varchar2_table(18) := 'C09EDDBB9E6A09648380BDB6B5CFB96073CC6AB0270075BC52492E86C4565BB6DD12C8060117C4E535D0F7E7066AB0D776173256BCE23185FCF2F3CFECB8B799E6DA20E0F69B0737A94BB298602AAD9057C1A1DBF3FDA777FC4AB3201B7CAA12CD6892C4';
wwv_flow_api.g_varchar2_table(19) := '3CF568A3B30B999A1C8FAD00EC1701F9EB7FF4CD877F947F888F9B143A6736DD26B3800B36CF743567447E45730DC8C93C643CAA4BC86C6043209B05DCD1E0A97A621E3256BCA8C999B1975E7AE6896F00F29B2EE36DC6219B053C55F33AF7290140B630';
wwv_flow_api.g_varchar2_table(20) := '2667C661AE97A753E9179FDFF9D44396F5AD371CE751DE370AD92CE07635D19C26F1F772CD3B585808FBC9E3F0AE97BA63F213806CBDCE2A3878DB80B759516F950C7AD1A8735365546FD34B9E11ACB2D031557FC54F4FB512C57895AE4AEA595E8E0B39';
wwv_flow_api.g_varchar2_table(21) := 'AD90970403F2FCEE7F7DEAD711DB215C422E4959F3A5914CDCD2D1B862FB6AAE506B127A3F11F5CE6E2DA6EAAF1C507914E355BA72F3D2CFC90B2A4C10C6AF19B33168B225367F0BF500E312323CEBBAF9D49D8156DCFB28B6CF0BF1FD1990B0F113E0CF';
wwv_flow_api.g_varchar2_table(22) := '4361A5710E04F04B43FCF1EC5D7BDF79F6AEBD7B539DBDF895D2222CA0E50483E9B1CC181EFF592801EBFB7B767D572173EA04E7AB2EA99A1D837D8FB3BC82846ADBD9602A399CC65465A4FC6EC9378AB89A75BADC3D6671B9FBDEBDFC39353A3C120C06';
wwv_flow_api.g_varchar2_table(23) := '1765C7B34FFEF33FFEFDA77FFD0FFF74A0BFEF4128617FAEA436D3BABCAA015352783B41343B960966C67218526DD7D9E29C854E97772E132949E789E865693CAF1794869526AE9096B7A9A6280F77C3B8C6BB410237A032CB71E780BE4521FFAA8CD29C';
wwv_flow_api.g_varchar2_table(24) := 'AEF4DA206036BA1D0FCB0A87C2610855C6C6B2902F84ADEF7FCAC398D42C2F207FD6133EBCB3C790011A562A132F207FE689F1F17A043D701D0A85643C97CB0277D60DACEFD32060D6B45D0FC709C18D9548300FD9568D9A0C6842FB26F0D2BB95C22624';
wwv_flow_api.g_varchar2_table(25) := 'AB164F470CC709220B2F17F15E9351298B2B0933EB645D49893E8C43A5E55F3010B4225066C817BB7BF8E9773EBC99E70259586B1EDE6B326A159B41C0C5AAD55A193FA40B42932391B03B26826CEB0EBE6EACFEC3206008A395F2A85F16851C68AEFD01';
wwv_flow_api.g_varchar2_table(26) := 'B950A59A2F0C02461D668612AB300939EA0B4DAE99AD26340B788668B027529A6B420E700AD37473ED8EC15E5D6A3D9B053C8334D81368EBC664DF8DC19E4866DEB9A0C97C9D5FD335B93E799AD5E01966A24B45AB9A1C86B96E33C80601C33ECF40135D';
wwv_flow_api.g_varchar2_table(27) := '09B2D546900D029E39D3A452A813AFD55C43931B05D9B411340818A298E11AECC1F62037C25C9B16A159C09E04AE8273714C0E34C8F1F2E334E92A005BDA441772A8418E57679A542AEB965D1735D9E414CADC48DC31D106BA8642E68A17F691CDCC93CD';
wwv_flow_api.g_varchar2_table(28) := '8DC41DC00600338B20E046228D32D7B557B203B876D94D4AE942F6D7624807F0244CF505F80D7207707D3C2BA6F613E40EE08A88EA0FF40BE40EE0FA5956CD8190753FD998775DB5A8AA373A80AB8AC6CC0D4E9D5CEFDAD4146A7AF5EA009E9EBC6A8AED';
wwv_flow_api.g_varchar2_table(29) := '6A32A750CD87DC015C13B2E9276A952677004F9F55CD295AA1C91DC035E3AA2D213539AA2B5ECD31D71DC0B571AA2B950BD9E4DA75F5EA740057974D43EFF06181EA53A8CE6E524385DFACCCAB43E66E5267C3BF591C1A5A4E75C89D0DFF860ABE999997';
wwv_flow_api.g_varchar2_table(30) := '4166C1BA1DDCD1E0663268785945C8A06BF0E1FA8E93D57074575E401132B19831D1067FE16FEE31932B17C9CC8BE9AD7865B36674CF206073AEFDCCC3368D16C13C07F0BE9078C80C6033B94CA3FE9DA85348400DA163C840E3A52E5314D7B2DBDED389';
wwv_flow_api.g_varchar2_table(31) := '6C2F6D83776685F8CAA1CB1E9E9352291EEF550A2FCDB05A7A846B5DA64A5F9A574DD796A159B04F01F3954678211884E99AFD729C7C79590E8E6685F7672BBC80049056212A10370F7611AF6330AD6357489FEF4A16D2B30EF4668B75402D0816612C5F';
wwv_flow_api.g_varchar2_table(32) := '3DDD8683AEA9779425F2A1065B323E9696EC781A152D47EBD6DC91702426C150145FF3F014AC05B02108DF964C7A5472D9B1624355EDDCAF04170A47917EF23CD30AA063A0CC2CCA671D0AF9177342BA8844A209FDF199822EB9E7C74BDF01C68BDEA4AB';
wwv_flow_api.g_varchar2_table(33) := '778EC4123D50124FFB8AA2A316A64787259D1A76B50CB75C308EA4929754B37A662F90DE390B24DEDD83A729628C2159001F4BA764747848462E9D4307C816349AB90700778C60334949F4CC91798B574A77EF6CC08C6B39E3E870C9E14B3274FE7319BE';
wwv_flow_api.g_varchar2_table(34) := '78463B4824D6054B50F35B06596CC30F83802B69DB74EB6F29840D5BEE93EB6FDC2C78E19BAB44804AD884CB69C4FE0F7F261FBEFD9A44E3DD0A86F0C6332959B87C9DACBEF62659B064B97475F74253C378209D5A2962C32C132AFF3E3F7954DEFFC96B';
wwv_flow_api.g_varchar2_table(35) := '827743224E44EFA7D139E25DB364FDA6BB65D9AA6BA477F65C748EA89A7B187735CBE3E3E332820E72EAE820DE31F83E609FCA77446631B9336AC62DFE3008B8DE06728C8398A011F144970AB808988AE9020EC20CC770DF067C6A5D767C0CA2B5E5E6BB';
wwv_flow_api.g_varchar2_table(36) := 'EE976B37DE2A3DB3E66827E0184B73ED1D18D5F19AC030CC3BCD735022B138B4F9023A4D0C9A3F248B975F23B7DCF94559B46CA5760CC7E658CBF46EBB38AE47A231D5EA858B97C9D255EBE4C3FFFB911CF9F4E71285B5C15B9E0B71BD32FD703608B8DE';
wwv_flow_api.g_varchar2_table(37) := 'E650902E640AD6CEE5300E021E859CD760759E108B611C6FA9B97CAFE4967B7F43AEDBB859C164A16559A40BE09D8F21C45127293F469315C7CDF131AC12218C1D240353BF74D5F572E7AFFEA6CC5DB0081D262B6399B4DEE37B23999407AD47363B2E36';
wwv_flow_api.g_varchar2_table(38) := 'F346BE8B96AE449AAFAA3338B8FF3D8941FBD929FC76F808304403698623713979E4800A6EE98A35D098396AAA29ECE1A10B72E2E841397DFC908E813908FCD67B1E90F537DDA69D602C0D30794D4BA79372F6F40919BD7451C1D0314B7475CB9CF90BF5';
wwv_flow_api.g_varchar2_table(39) := '859F74B2388E2F58B256B6DCF36599B760B16460E609340C278C96E1F489A372E9E279AD57372CC3BC858BD5028CE35E06E339CDF8A6BBBE887A9D9773A78EA8B9A6656187F4CBE12FC0904A0826F4E8815FCAA92303F2A5DFFA4308711E00B9DA360C58';
wwv_flow_api.g_varchar2_table(40) := 'EFFECF0F1502A73A2BD6DD84B17A0BE419805666003DA49AC64EF0F107EFC8999387110E68D02C8EDDF49EE72F59054D5D022D4DA1138531E6DE05C8CB00379D871BD18EF4CBF77E22873FFB05AC414659053156AF5C77A3DC7CFB1774186007A0A6CF99';
wwv_flow_api.g_varchar2_table(41) := 'B7506ED8B455DEFAEF63DA11594E25E7B055C07D07986694A693D3206FDEEA0987CE0E35319D1A95682C813177B38ED78443CDA5B93E7AF013F9E9EBFF2923F074C398CE50E00CE7ABD3D3A9111D334F1E1E80866664F18A6B65F9EA6B140887857024A2';
wwv_flow_api.g_varchar2_table(42) := '79EF7DFB4DD9BFF77FA191B3345FA8A43A711FFDEC0D401C973BEFFB2AC6636AF9B80E018B97AF9285CBD6C98943FBD503B7615926D6DD6B43B3CFBE5CAA249000DE3247C1961EAE171D140A70DEA215321FCE4E0E63350F3A504317CECA076FBFA1D398';
wwv_flow_api.g_varchar2_table(43) := '6E4C9538C5A1E65153E92D4731ADA1A7CC6915B56CD1F235EA6DD3B36647E01BED8E0E7E2A073F7A17A0E6C14BEFD2B474ECE8B1C7317D1ADCFFBE9CC010C24EC8FAB0FC44570F9CB3D5C8130B28F8F30B5CCAC59780297CD76199ECB4E4E0245188F317';
wwv_flow_api.g_varchar2_table(44) := '2F9728BC5A3A4D84430D3C716450CE9E1C94AE9EB9EA65D30BA743A682473CFD4E9D437A5A029A6A77712407902149635C253C3A78EC10EAA1635ECE3238DEB3A3F0DE494C93E87071C58B5E3FD37228A187CE3178E6029ECC839D68DA87EA6DF1A3989E';
wwv_flow_api.g_varchar2_table(45) := '6100460DEC9D335F054BB0D4268EC1E73F3F0178984EE581970BDA7D5B3FAD022184A1DD74BA9825D3B093D0711ABE784ED397165A960FB476F8D205D7D3C6D88FA47A4431EDE20A173B000833D762162DBC32ABC10AC5506BAAC887D31E6A0CE7A42A78';
wwv_flow_api.g_varchar2_table(46) := '028540A965E954523D5E56A37255DC50020D434369D6751AC5D8F89FD3322E51EA3A74A566301A1D3A3868EC5005F008A783476BA01DAC4AE995B26C749859C055A0D4DE880A191228B48DC275E1B8B9332685EB1EBC77F9432102CC94112B6693CF9DE9';
wwv_flow_api.g_varchar2_table(47) := '9901BFB2EC7CF97A573F2A266E6AA059C0DA6093F5AF90615E5B39B6D2ABE641D0DC24A75683BC7E9FAA16F48669DE19DF25C4F96F44C7518ED1150F6568637C8EE918EDFA096E1DB88CA9E3323A9F82AE50F58A793638D02C60E3959DAC06BA2E8C3194';
wwv_flow_api.g_varchar2_table(48) := '0E1141E8788B718F539C39F317B9C8A9E5045DD068B762EE7774069852CE61B930420E9A27604763588A9C3557F3ADDA14E4C9450F8EB95A7EBE83707818C34605FD8182D9AF9A49F36E18046CB6CBBAE3DB843CC1DBF55C1DB978EE739DA2780E15C7E5';
wwv_flow_api.g_varchar2_table(49) := 'A52BD74AEFDCC5921C1D828661A300C2560D0504E6C738EEF406FF840E56BA2E9E3FA39B10CC8353A5683C214B56AC435C78E5E844DE4604BB0057BE5C8F3D284B57ACD5F19B532475F0A0BD5A1F9C5906C8378FE0142519046CBA5193F3A3661014FFCE';
wwv_flow_api.g_varchar2_table(50) := '9E3C82DDA0117D7D11DB48F33817CB8DB7DCF56BBAD4387CE134C2DCB56C9A73C2E042C7C8D059C466DE8E9C3A3EA89E33A1A8590698956BAF9335376C11A66727700F076BD623323A7446EF2DC346839A77C4E783092358613B750CCBABE8046A127C04';
wwv_flow_api.g_varchar2_table(51) := 'D8772B5984E7CD3F09460546294399F93D931CE652979C3F731CEBD283BAAD6859FC07AD38260764EDF51BD55C0F7CF82EA64DC7D46C52A3B8E0D13D6B1E1637D6CA5C98F2819FBF2DC7073FC6BAF6666C31DE80CEC0CD842C56C6BAE5D6AD5FD2F1FCC8';
wwv_flow_api.g_varchar2_table(52) := 'A7BF00D8512D9BFBD3D7DDBC5536DEBA5557D1B81EED7ACDB61C3BFC99AE4547E33DD07C6F5CCFF78D169F7C07780C6BC76BD66F96156BD7EB5847CD23749EB99870F7577E578E1D1C9003FBDE51480BB1F7CB0D840CC6539B2B52D0A8D5D76C90055808';
wwv_flow_api.g_varchar2_table(53) := 'A109E6DC960A1B0C872401785C3BE6C6FEE0C087923E75186BD66FEB2E522FC65E6E36D012CC4239B7DD73BFACB9EE2698FB11942FBAE2C58EC1C50CC2659D38EE73D163FFDEB7A0C97CC530E6C530ED9AA0C560BDE27D041852C4FF59383F8B96AFC6F6';
wwv_flow_api.g_varchar2_table(54) := 'DF2680C8E8D8A880012F814D7C8667E0D01CFCF85DEC161D15AE1BDFFE85AFE80600E7A65CADA2F9ECC2D31CDD3DB3D04E9A63648C339D2C8E99C9E4888EA7D4CA53473F91BD3F7D536EBBF77EAC80CD82C6670030A3E32F77B34A0FE6ED6D6AD0E33E73';
wwv_flow_api.g_varchar2_table(55) := 'FAB8BCF7E3D7D4EC4713BDBAAAE527B8ACBB59C09387CD52F94CE39AB0E9D8842458E0830B84952E4244B0E17078E0035D46BCF98EFB64FEA2A53AD5A1B6F34FC45DA7D6829916171C27B94F4CB34DF09168179ECE785735973B45F3B07C6905229A27B5';
wwv_flow_api.g_varchar2_table(56) := 'B9F4E06A17BD67861F3E308075EFD7B16375486230CD7E7D74C72C604AB0E60302E7BFB40E13CB4769D4C355486E86EA6001084D700A1A48D04446C847B0AD77F1DC6959BB7E13BCE035D0E6B90A829AEF1D5C42E43359673F3F29270E1F80E91DD6BC90';
wwv_flow_api.g_varchar2_table(57) := '052027E4D0C05EB978F6A4ACBD61B32C8105611EDC31F20E6AFFE8C8B06E681C1BFC049B0E1FC0691B76E1569B377B895B78360B984A51D7E140A87198DFF7E5F8A101E444B3EA195855608459EAF810AC7ABE80480D1A193A271FBCF59A7C0233DB3B67';
wwv_flow_api.g_varchar2_table(58) := '217683F0C01CC64B6FFCE612646AE41236F0CFAA474C4DA6B926788E9DCCE3D28533B2F7C7FF259FF4CEC5746B51FEB9AE889A76CE9B47B1063D74FEB4A4E1E8D169E30E933A8275B5B9B189CD023650576A26FEC1667DF2D1453B3953C2D1F9266F417B';
wwv_flow_api.g_varchar2_table(59) := '30798226BB4F38727C3E3DF2A90B9FEA492566C7434FE126052D00D37BA65EB5BC240FCE7F53A397D061F024079EF5F2EA400B12B0DCB47C068BE91A09B77C7040356A3CCC022E5AC41AABE326E32600172A5C320CF328B9D7DE9C95DF0A00B0D900A9AB';
wwv_flow_api.g_varchar2_table(60) := '0570044B96B4F83ACEBA51740456DE5CE1E21662A9B9712BCE7194E36C1026DB896A06EC177A6847D0682E583EDEEB95EDC630FB39F9A9EDDAF2370BB85466B5D54753A9F05580D3CC0434F04FB62B6837A50B8E94F85F017AC9D83CB10496ED54C8C3ED';
wwv_flow_api.g_varchar2_table(61) := '54884DE29A3E9FF7C40C7CF6DD2C603FB4B90C5E851E5776BF0A8DB23813F228BB5725BD8F820D2E55A2551364E1A3765EB555310BD80F1A7CD5A2ACDC70B3802B97D1096DA1043A805B28FC6614DD01DC0C294FBB0C73CE8C59C0E6EA356D91CC98042A';
wwv_flow_api.g_varchar2_table(62) := '4373CE4C5D80F7EDDBA73571575D2C2E28758E7A25A0322CBEA3C39371ADD9D60578E3C68DDADF02011BD5722CAE01748E3A259097A12B53114FC6B5E65AD742C786BC06DB76C0C1FC1F4B40AC9DFB516B85AEF2745848E39A1B74C58645C4E1C9B856B9';
wwv_flow_api.g_varchar2_table(63) := 'D4A5C1F2E0835A6E206C1D04E081AEAE38BF73859ECFAD74FEA62503576E9421654999AA70F332D6EB1A3EEA1A35D1DBB006EFF6B45D3BFEF6772CC77AB62B119D4D1DD6C5F91A2A74B526A1E672157434991EC2B6F89FFCF9C3DFF90FCAA254C6B5C8A6';
wwv_flow_api.g_varchar2_table(64) := '2EC0132BB0F3C947EE08E49CAFC1C2CCC6868D8D8D99CE710512D0670BF1E346B8311781F4877FF6EDEFBC3351B657904DE3A2B097352EF7AB33675332FD7F5B1C411543A1D9FF0000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72350111031797174)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/ico.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D00001745494441547801ED5DDB6F5CC7799FB367AFDC0B49DD255FE49B64595412BBBE046A1AC78EDBC67D318A22D24380BCF5A57D6A10F4214001B30F89';
wwv_flow_api.g_varchar2_table(7) := 'A2A8CD3FD0A028025B72C5162890A64511384ED5D88D0B3996A528B663EB2ED9A2648AE472977B3DE7F4F79BD9E11E2E9712B967C83D87E210BB73CE5CBE99F97EF37DF3CD37670F8530103C4F5806C8F495C4A8371A5B0BE3E8646260603CCFB3103C12';
wwv_flow_api.g_varchar2_table(8) := '7EEBC36F3DE339D64B4819C2AD1B9878676F4DDE5BC245DFD3B695FC6C3099FB87BD0FFDCD25CF3B6E0B71D0B52C21C763B2B97ED18A0769D80FEE89B3DFFEBAE78A1F1586D283E4CE02701724B45AEE64A5BF9C26D4AD4C671AC975D6D569FEB22C3377';
wwv_flow_api.g_varchar2_table(9) := '8F0B2F299AF5C493EF5E38F4179675F0E21B6F8CC63D6FD4592B20FB5942762C2B78DE01DBB2C69C13BFFDABEDB665FF6C68C3C0C8D444B9E159226681DBE4A3E6E7E20DE9526C5A5D7B88557D1DB7B1D3A575C9CE9CC5EBB66BAA2BA81DCF7313F17465';
wwv_flow_api.g_varchar2_table(10) := '30BB21DFA83BFFDB14EE379E78F03B12E4E79E5B1B20C796856847E1B1319510B7620F62FD7AB43855110A5C01BA1E40F6E6C54C5BF8516555BAAED719B7EBCDA7B99CBABA2C271FAF39F73C68304F341ACDD2D070667FDCB25EFDE0E291079F7F7EB4F9';
wwv_flow_api.g_varchar2_table(11) := '8B5F8CDA6B614DE6407B0E070E8C501884EB5A3161C9B5989207C645E1D3EAAAB06C2A8CE9A98A97CFA77FBFE1B96B0AE440008F8D9D959AD7B663105C22DCF35CE95F4557360D0BDAB38AC5AA5328A4F713E4331FFDE0614AB210C7655EFF3A18ACE540';
wwv_flow_api.g_varchar2_table(12) := '006B096617B0F629533A587F56A536546F3B2865EDC594D56015672A4EBE90DA2F6CF7D8BBE77EB00B869723C45864410E04709B4B5CD0F8178DD0A969F45A0B218E515D4B491ECC3C1D8FB9AF9EBD72E89128836C0C60BF504403E6762F01B8EC7E2BA6';
wwv_flow_api.g_varchar2_table(13) := '11664D1729C9E9A7DDA675743EC89199C77280C6008E8AF4B6616D5F69096EA7484B5B4A320C2F82FCDA7BE70F3FAA24395A6BB23180B9FF8C6AD012DCD17F29C9C5992A25F9C998E5BD76FAC2F7F6444D5D1B03383A2B300DC2F9A18B04EB020A6458D7';
wwv_flow_api.g_varchar2_table(14) := '00F9714BD8C7A206B231803B99A63914C678DE72826DD22212ACBB2E419E21C8F9D4E331807CE6E2E1C7A222C9C6005E28179A3F218F97C60196B2664A5527079085E7FDF36F2F1FD94790C742BE855ADAF09684D13CB958528DBE15EA4DDDA82D945A93';
wwv_flow_api.g_varchar2_table(15) := '3FE7B8EEB1F73EFEEEBE832107D920C07D836BF90DF73E17DB6B723EB5CF8AC5DA208F1D0CA533C418C0BDF36CF9F804AED19B04EB66DB20173212E433E78F7CFEE0C131670C208F8E8E1AE3A96E30481CAACE0419C8B2EA76CCC6DB58D18B9125C8B152';
wwv_flow_api.g_varchar2_table(16) := 'A9DA2C0C66F609CB79EDD4C5434F10E4BD7BCF5A6102D918C0C18462313EAE42FA9DADE8C53A41FF973D335D6D620BF598ED89A367430872A0273AFC23EF100A7F56F8AE391B7587834D716EFFED22408624EF29162B04F91B230F7CE75DCF1B01E551AA';
wwv_flow_api.g_varchar2_table(17) := '6C755ED5272E041B9EAFD391F2646970D9FF20EC576A0B8FA429492E14327B5CCF3AF69B73879EB6AC51F7E59701719FD7646300B745C2877A482FB1E6B643100EB427CA9C24435D3F8A83F1A3610139C8F0DA4C8AD815246E5EE8C1C89A57BF75232599';
wwv_flow_api.g_varchar2_table(18) := 'EA3A3F987E04C715AF860164630077F0AC1B03429B760757E572FA3D0772369FDE45904F9D3FFC4C3FD5B5318097C385B0953524C17A586A4D2E569B04194F331D3B7DF17BFBFB05B2318023656469285AB14109D694E740CEE5D20FE161D2A3A72F1EE9';
wwv_flow_api.g_varchar2_table(19) := '0BC8C6005EA3C7851AB05EE23990F1D0C003C273FA02B23180FD86692FDC58CD3AF3EC85DE1D1D4BE9B204991E2F826CB9CD63672F7DFF0FA8AE5999BF875A0A9120650C361025887D2C33C8011F55FFA5F47811E45C21B313CF901F3D7DFEFBCF4A07C8';
wwv_flow_api.g_varchar2_table(20) := 'DFE2907585413638BC7972E11F60F8AE577F2E2AB7260C2F9C27DF07B17E650E64F1321EC95E3949360870848EFCFB3317E7D6E45C2E09903D09321231DD560E6463009367FDE15BF814C46D7AA4409EA935B3B9F47D780AFBD5DF5C3CFCBC0279744524';
wwv_flow_api.g_varchar2_table(21) := 'D918C01192DFDBF07F55B224C8E552AD812DD4BDE0DB2B38A0F8AADAAA9997646300F3879E510D861D1D4B61039865C54B33D506247987EB8957DE3B77F885959064630047175EB9B4403D2A5C18C90FBE9836F761BAFFBEF35AE7EBD89FDF4A434BB219';
wwv_flow_api.g_varchar2_table(22) := 'F9C51FDA0A11C7D39A94E4EDB6EDFDF8CCF9EFFE112599DBA8E3C70FE06D03C183318023E9C90208AD40B50900D50F24C979DECFFB744BF397D1F93AEE9287164852D245C4C076133333706B4292F14BD657CE5E38F42233F8748889A3466300A3AFEC57';
wwv_flow_api.g_varchar2_table(23) := '34820696062C66261E9EC37B3970A86BC7DC9815C32FD757F113435B31DB9E2DD5EAF97C660B3AF34F1F5CF9A104997B65487B20C61A7BA2231AC8B67A0996514D1254C76BDA2588902BBC52BFC7502CCD94ECB8BDB5516FFEF0F5937FFDD10B4F1D3937';
wwv_flow_api.g_varchar2_table(24) := '3676004238869FB0F6168C011C689AF5D6F740B5547FB1E079CD54D5A9D9B365C773E16622E8146BA59174EC6F4AA7E99879FA5AC7FEF2FE6B9DAF639DD7BAF744020AC58106790CB30F16B638A77E83DD7A57862EBE8CD818C0CB68331C45DB526CA5D2';
wwv_flow_api.g_varchar2_table(25) := '8984854D696516AF618149AB406637BB4D5B9DA6637F397F5AB761EA7C1DEB32EA9E5A2599880BBC10A6299A1EDE2E103C1803388A461685954C05A85E224973C416B3E5A6F008321F8CA5603190FF5DAE99A4A061A1E5850575152128118FD6334C2F45';
wwv_flow_api.g_varchar2_table(26) := '4FBF266379D4DBA58D1959513A2E6C0F1F9C548CE5FEC58A276D2B334061B62C309A2698FA20AFDB35E8B4D39779BDA06EAB0D39637CB3C6FF9A0C7FBF977A6D0C60CEC8C8070C22918A09802CF8CE8EB9CDF16A0FCC20338D01DCD661ABCD0DC3ED8505';
wwv_flow_api.g_varchar2_table(27) := '6443C33208B04FAF18EA5CDFC8F41B6483AC3408F09A916135AF007292EA3ADB67751D70961B039893CEE0C40B382C33D56961D3BA8E32C8C6005E63F2DB9E2194E408836C0C6058F96DA6ACB12BE98000C803525DE387FE4C88483006F0DA855721A9D5';
wwv_flow_api.g_varchar2_table(28) := 'F540368E2D547440360670143D59CB15C20520C3E3B522C120596300AF3D13AB3B7404392ED53524D95E214936A80E0D02DC9D216B321520D3BA96EA7AA54036C43863001B9C748686B6B2645645920D0CC118C006FA123D1254D70948F2C00AAAEB805C';
wwv_flow_api.g_varchar2_table(29) := '3106F0DD606475E5B56F4DC6233FA1DB42190338AAC7855D415B6E22D7644872065BA8B0816C0CE0E5F264AD95975BA81082BC0EB0C1991646908D010C2DB51EC081B0816C0CE0BB6D9B74BBD91C26908D017CBB01DF8D791A643A43FA6978AD03BC82B3';
wwv_flow_api.g_varchar2_table(30) := '8F20739FDC4FEB7A1DE0150498A4B524F3A181254BB24183661DE01506B80DB2259F0C5912C8060D9A75805701603FC87C684082BC52478D1DE33106F05DEBAAEC60E8ED6E5DBC3C299EB0E49321761C6ECD5500D918C077B5ABF276A8FAF2F44F655613';
wwv_flow_api.g_varchar2_table(31) := '646300FBC6B17E79070E5070570BE47580EF00C64A64D3869A0732B6527C906FCEB60AA3156DB04F2BC1D3D0D15C0032D664822E419E433A78B78D49B0C13E051F55442848906978C595E1C5988698C9600CE07509EE0D9639C30BE066B185E2DA6CD2BA';
wwv_flow_api.g_varchar2_table(32) := '36F603F07509EE0D605D8B1E2F9B921C4F08A7E90AA76646648C01AC3BBA1EF7CE01E5BB86C72B9710CDA4195DBD0E70EF78AC484D29C936DEE09069BDC321602BC6D6E080FD58AFDEE200973A826C2A845882EF34CA6EABBEAEB3DCBC4E76924E278DDB';
wwv_flow_api.g_varchar2_table(33) := 'D1EEAC1FECBEB3E520D48C01AC871FA433FEBA9660D7165330F47CF3DD60BA550588AA032B742E5D51546E54A6735DBBD33BC5628056B5ABE868DA8AEDAA5DD2310983EAE74A7C1B03D8F4701DBC78CEF56A2D666B20D90AAF63F897440378438E7E5F27';
wwv_flow_api.g_varchar2_table(34) := '8701D67BB3506F551F9F14382A01305B29D44BF9F2F5A5A2899719CA3649871341F996F8ADDBC549502C8BBB04F2F81A2B3F7D4D2B5CB13180CD0D4B312D69EF00333360A15F5A5A0CF55CD1706F018C3A981D47AC804DD89B4532BE4B24EC0280CC200F';
wwv_flow_api.g_varchar2_table(35) := '2E4000E1B815D170A645DDB981B255A4EB89C15E93661C13A381778F4D0ADBCA8A74E221D0D928E2124CE48906EACF887AF326685C4359177D2BA01E259D1AC1F4F4064943216400D3275B073849B1A5F082C8E35F0EB96E1D43D50C8434416A1DB72A3E';
wwv_flow_api.g_varchar2_table(36) := '9DFE0F51AABD0FE6D74422362C8606BE28CB27E3C3607EC20722A6085E1AE77A8EA836C6C578F167A2D2B8D29264052E27085B18CA7C490C66464426B915E00EA00C2602DE8007CF83A4D1704AA25CBB22A666DF15E5FAFBC887345B646178410E11C064';
wwv_flow_api.g_varchar2_table(37) := '36E50931DC3B497B1092B41100D790EA07382E253266A5114F895CEA09B17DF045914BEF44294A1B249E66A8AE82DA312F298148D8593159DE2466EB1F233FCD1CD02F89B83D2CB6E6BF2686B27B25B0C80009AA68D527BCE617E9296886BC18486E1385';
wwv_flow_api.g_varchar2_table(38) := 'CC23E2E6CCDB62A2FC73D99665714B134E904304B00F1172986B2024CFF1014C86E35FC5219D125503309B01EE9F4886B39C54BF00032FF39412CB729478FDEE49D253461257D518D6EC32686C10F70CFD1934C01E09A86A0F5EA5182685EC0741A66671';
wwv_flow_api.g_varchar2_table(39) := '501EEB3B68A7A0BE770C7D15BFF44F01E89FCA7C6598B52684AC178EAF10014C86D0A0A14AB4C4ADF229D17466A5DAB56369094C0C125AAE5D1533D58F45AD795D0C67F64BC92528048FAABDE996C5ADCA8790D24FE444605A325E10D9D4FD006618F401';
wwv_flow_api.g_varchar2_table(40) := '382597EB37C0DF5A78510C671FC3446AB468401A81EC6C7D1C2A9D6B362612D6DB81D47668953CEE1B5283B04F5BF3FB45A339292667FF1B136203FA7F270B7DF5413706F09C3A0B3406B5C692C444F9BF00E20D00731F0C9F012C830010EFC628D52E8B';
wwv_flow_api.g_varchar2_table(41) := '4FA67F0CA66F46DE4312308215839A643C5E7C537C56FA7750E0D014C3A9BAE3F626914D3E02236902C0A650B68C09F265803B02350DC9E60481D47249B839F30E26D82F31C1A64143F5299D78406C835D90C37FA9235D4E2A1BEBF4A6DC17B11E7F0423';
wwv_flow_api.g_varchar2_table(42) := '6C42AEC9425AD79DDA0855FA14D486CF40E36A2B61801018CA4010D4BE96775AF5290987B716F9493098655AB9522D3744A57E09CCE7BABA19936013CA6C44D92C247B524C557E8549330E6A2EF206A1963F8F382DA592C61255FA67A577C4F5E9E3B098';
wwv_flow_api.g_varchar2_table(43) := 'C7D90B7CA89E5D51AAFE5A5C9BFC37D01F07904A2E68BC65925B4421FD05D0E0D68A213CE0B237C600263193816A94EF705E18904306634DA4C4127A4E2E4A202DDF4DF967C1F43D90A84F915F41AE2BA5DBB6F2003B2F4B73AF9C4EEC84C1B41D12ABA4';
wwv_flow_api.g_varchar2_table(44) := '9C3467EBD7C544E904CAC0A8B23931608DE343830E2F621795E639B974703D66DFF4B23090A496C9E1BE21E9E32B34A11B0743D139AAFCEE6A9FFB62AEA13548D3755C6B66E3A5FCF81BCAEC163B377C536CCABE28A5D4718B308E4AC8A16382C355DA20';
wwv_flow_api.g_varchar2_table(45) := '9DD8867CEEB30130D6624A75B976092A7C1C13A100B068BD137C5AD3048EB53328F331CA140130F7D28A562A3E040B1B16BFDC63B7DB9095FAFCA5748D814E68256A809424D15DD1A954A9BAB1952A564F8BA1FA5EACC53BB05E56010AC18AC97BAACE6A';
wwv_flow_api.g_varchar2_table(46) := 'E349315DF900FBD65F433563EF1BCB4969A73A4E626B4429E4FA4BE9E5DACB355F6EB3E6D4ACBF171821406D626B566F16A525ADC71CC7F64B4E0A71157D0F97CC18EB8D9F15A6406ED3994F9D20D055596B5E85C3838E8B9B6030DC907070508A1DE91C';
wwv_flow_api.g_varchar2_table(47) := '1172CFBA6DF02BE2814DDF141BB37F48452E259F1344BA1CE51240E0D4B6AAE9AA75B4ED9AD43D20944CC52335906C6581B7F3A4652EF7C2D42EE10AC600363D2C2D1D8AEEFC3BAEAB0CF424CDC0F8B93C711C52FABEB26CB966C21AD64053AA33892DE2';
wwv_flow_api.g_varchar2_table(48) := '9EE1AF614BF412208262C57AADD7F74ECA9230CBE88B053128CF65EA0BC6FA7A4185BE26444C456B5EA913234A140D277AA62EDFBA843DF3E358833F07157DAF48C469505162E9A0A8613224C4E6FC53A286BDEDCDD24FA514AA47550179CB218217FACB';
wwv_flow_api.g_varchar2_table(49) := '0638399414B7DB232DFE715F6DC76871338FD38552CD7FE641BF787B5DD635FB1D1B0378BE120D3EACF9F2B090BA622D2C59184136D6564AE554E54DACCB27A19A778BE181A7A4778A0E09E58B6EC0D24D61DFFB053826FE07EBE82D74129A006B39553E';
wwv_flow_api.g_varchar2_table(50) := '557C2ABE1920F98D24F6822DE9DE707B45830A4618EAE849D0848F9A6E536EDDDA65711982105A154DE669062E649A025C1E0F0260B5A58233037B5E6E69CAB5B3E2EAE43F8AF1E913C2712A804C9D1E1114FAB8E9F4A8343E816437649E7469A24C2E75';
wwv_flow_api.g_varchar2_table(51) := '3FC0DB04692C830E8F15157B783CC836B8D7A5B384563327142707FB56C36469B8CA81C236D4A40801BA732308475F3A7A4185B85820136370416E057F9B92B96A4B43D62601D236F03E2F6E947E2266A192D5898FA2C5B597AAB8523F0F754D50A8C400';
wwv_flow_api.g_varchar2_table(52) := '0BC01E8035BE31FB2C209AC53EFA1652550F6858D59D4FB0963F2C36E67E0F75B0AD82EAA7EB94275BA5DA79D4C73220FF17CEE2BD5E6C342B996E4C459B1B9696CE3224898E0A0695C62B32B6E9DE8084C1A991FD0A986DC1B5F80600B826412258947C';
wwv_flow_api.g_varchar2_table(53) := '5ABAD9E43E1C2566514B1965BA3EA5AC0E47080D339E0ECD01062B7C53FE6914832F7CF62DE97EE412C0B3E541F8BDB7E49F9347899C0C2CC3E3C499EA357CDE538E0E5F3B6C2B0CC118C06D08820C4B79A4AC982D36E7FE142EC0DD60229CFF30828002';
wwv_flow_api.g_varchar2_table(54) := '40736048ED12F70EFD25D6D1FF83AACD41A24600D20E185A9F4222C7013EFF0521A57B18A74CBB452AB101F5E8E4202436F6C6132DBF710E347E05B5BC530C0EEC96FB6817070E5CB3B714F68B7CE661D08314A3EDB89D91C026B1F6125CA6F161845A73';
wwv_flow_api.g_varchar2_table(55) := '0A061B7CD6EE34EE87D182F28AC9C642F2650CE0E0E3A10EA0D1A4A46D78600400ED92274A12201A43002A8B539D7462100EFE73523D92D9746A0CE043E6731230D83478206152DA60F2D288E2931DB766DF413C238DA526D4F0A7D3FF2941CDA5EF477A';
wwv_flow_api.g_varchar2_table(56) := '5D59C3A897C5A4C926EF91B4F8C57EC9FD35FA11B707708A5414D78B6F407A4FA1FE204A840F5CF63B4400B33BAD20F53D152D9EBD924F6728FDC0FF45A65C84EA9ED7F2140992C76941BF715C5AB254E5705D026C1B69F8F7B1B09A67C48DE22FE1D93A';
wwv_flow_api.g_varchar2_table(57) := '893A590006D50BEBBBD2B820AE4CFE2B4E8AFE589E2BD37DC949A2A55E7749CA3F2609A12ED7AEE1D4EA0468BD2D69A832ECB4193DD66E33F85588006E812699E4019049791EEB602DD5D6B4DA87C6A1122B00A08EA7334E4A00538961B9D65A980C0C9A';
wwv_flow_api.g_varchar2_table(58) := 'CD94DE5AB3240F11A6664FC1183A833C9C40490F969C1290BE3C54F16558DDC744A1FA14D6DA3DD010388982FB51B74B9A94FE59F469A67A016BF749D0BD22EBAAD6142D960B5B0811C0648D7A0283EAF0C6CCEB38BA4B415E6834A9A06444ED5B9B3C44';
wwv_flow_api.g_varchar2_table(59) := 'C0DA373BF93B6C7D3603E00D6078567AB1242580CB63C3BAF319D4A93AB857BE686E7DFC80C0ED0990F9B4C6ADF2EB52C253F1EDB0C4492F2D41E624930FEDE1218306E8494B5C3E74275BC297EE21EFC3158C012CB5AA91B12966D59D9B72CDF54B916E';
wwv_flow_api.g_varchar2_table(60) := '8369EA1158A85A30BFDAB82AAAE2125AF7AB493D1DF8C80EBD4F5C2799E6075777989632D42FCA71BB338B037CB5A66AE05AB4A0EE63AD272D55BEBF3D4D2B5CB13180352B4C0D8F5B1320731B72346AB826A7A1A6F9001D99CDA0635EB33E3F4C23B00C';
wwv_flow_api.g_varchar2_table(61) := '8BD1243D3E6FCD76E9B2649D6EB448471B548BD14291900463006BA780B9716940EE44915B203FA3F5B51F205EEBF4C5E8319FE5FCF4741D4D6B297416A3DF9F746300FB55E9EA0E4583A05B25089DA1B34C67BEFFDE5FB693963FCF5F27BCD7C67CD17A';
wwv_flow_api.g_varchar2_table(62) := '8E8777A87767CF8C01CCB91DBDF9BDF641370670A7325BFBAC8BC6088D013CDFE28CC6E0EF865E1A03B87F46D6DD0053EF63340630B749EB6ABA7720744DD33C0C04F0D8D8D939BB0A128C5F14AD87A01C200FFDA2E2E7712FB403017CE0C0889C708EE3';
wwv_flow_api.g_varchar2_table(63) := 'E29C07673DA6A75F2F238A781DFD301F79CAA1681EF73AAC408E0E3DBB70BCE6D9F8E3538AF8A324AF41A8956CF5C6E8A5D505D3240F292D0EFED896E6716FED063C0F3E7040353B1013E76B96F8B0309419999A28BB44581B5DECA51E9E3FEEB5C38BD5';
wwv_flow_api.g_varchar2_table(64) := 'EB6C67B1723A7DB9E5553D8EA0D7D0BD6EBB1FF0ABE3180D3CB42727667F479EB225CD63B3AD2E911AA61B1E8942B710DEFCE0DB5F87DCFE283F98E6B1CD7CA787469619DD821E7B7BB4F36705EBF8F3FC3482D6D574354D391ADCE83E77C62CE74FD3F5';
wwv_flow_api.g_varchar2_table(65) := '182FB7AE6E1BB1BE2C4E57A741FFCFBFB4E7EFFF4592F4F1D8DFD452AF357B965A7E41393FC86F7DF8AD673CC77E09ABF1100AAA4564418DF5844E0EB4E6450C66EA145E29FC932F8FFCDDDB2CE3E76D679D55BDC7D21B78A2AC6A8723D098299EFE3F7A';
wwv_flow_api.g_varchar2_table(66) := 'B2C95F9ED1F6280000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72350470390797176)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/iso.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D00001634494441547801ED5D598C1CD775BDAFAA7A7A162E23EEC39D322951226992A14486422C281412DB80A30490C84450FC11241F4910079029290112';
wwv_flow_api.g_varchar2_table(7) := '4093AF18081C20090C27503EB2988B666809919D188A0344B2E138326C5A8E4451A24851B2499A147772969EE9EA7A39E75555774F4FCFD6FDA6BB7A580FACA9E5AD75CF3DF7DD77ABBA286221692DCA42334D6D42F7F63A5A5AFF3E2A85583730045729';
wwv_flow_api.g_varchar2_table(8) := '816C4486BEFAB9DD4A0A8F69A5BA25D081E354769794730C4C6B8C306897B6F95764D1DA173A1EFFF247BA6FBF2BFBFB83F87E9232DA7AC65117C063C0FDFBCF3EE1887A21DB91E93603AAABE57A6E69BA7531409D17F1168B9F59F16AC175FEB0FDF12F';
wwv_flow_api.g_varchar2_table(9) := '7D00267BF27C6F61AE805C170CD47875A0BFA0FFE1D33D23DAFB76765E664BEEF608A4A612CBDD12FC8030C8074EFB92E1B6C5EBE6FB79FF0DCF777F4B3DF9A50FF57F03E447E606C87501D1DF1F8A6B3870EE86C1BB373F086C4370D96EC237AD30E37A';
wwv_flow_api.g_varchar2_table(10) := 'BC033F5F18F0E677ECF13DFF90EE7B6683FAE55E5F5EEB75E7826F5117C0FBB76C3173AF0A8CB0400993B86B812D1EAEB8B0D5CA1F18D65E67FB43BE5287725F7FFA6E03F25FB43EC87501DC7FE284C1543B8A40C3B70A116EA5BF5A020ED7819BA8FCA1';
wwv_flow_api.g_varchar2_table(11) := '5CC1EBCAEE7503EF70EED8B39B542F98DCDFE7B43293EB0238667004A841B995C00DC70A1128A51D074B01A8A83F380290DBF780D6870CC8070E14A485995C17C09560B62081C35B00B25CE8C102511E0079B8E075661F24C8BAEF4F37B63293AD025C09';
wwv_flow_api.g_varchar2_table(12) := '78AB9C63211F856A608C8D7318311920FB4EE1B0A6B92693FBF7B79CB94E0106A23A62709942464C86B9EEC83E98D7FAC5916307377349D86A20A70003D51283CB200E977970BC460A99AEF69D8E768EE8160439053866F0186C8B272526776677F82D08';
wwv_flow_api.g_varchar2_table(13) := '720A30B0340C2E623AEE2004194C86E3B5C3177574E4D89F6C6915736D156013F518279F16B930F9E04B2077B46F772438AA5F7A666B096478E1094D56014EEC5D4E47F8530F3E0219C1908EEC563F5047468A201F80779D4C90AD023C1D39B67819C80B';
wwv_flow_api.g_varchar2_table(14) := '4B2846BC00B2F2930F720AF0CC35AE0872A62BBBD529A8A3A37DCFEE08CD35988C170766DEE4ECD548D46066EF36276FB9CA3A78F20A71306468C447EC7A8B287D64F4D817771A90EF3FA19204B2558027F753A69259F3F22758074F3520C84EBB885DFB';
wwv_flow_api.g_varchar2_table(15) := '58276F16ED1C8E41EE4F10C856019EDA4F994A66AD96CFE7671520F71DDC758011AFE7919300736D15E05665B051AB1A061F562903B9134C56CE91D1AF1F7C50A95EF31CB2D9205B05B8A5195CC3E059650CC89893E1786D92401D1E3D0A907B01F2F3CD';
wwv_flow_api.g_varchar2_table(16) := '65B255805BCDC0C6E3ADC1C98AAB96BD673B86C91B95EB1C32203799C929C080AA4627AB0872E9200299DE752798EC2A3C6A7C668F61320A35C35CA70053F056A3502590339DED1B0B5A1DC9F73DB3B75920A70003E0291E3694083AEDA312C86E677603';
wwv_flow_api.g_varchar2_table(17) := 'DE2638DC2C905380AD3338D68212C870BCD61B90FBBFF850A3999C020C3C0C836B5826C5504EBCAF04D93D92EF7FF6538D04D92AC0B322A389A5D7223965207766D762D087F32F1E7CB851209B37FB6D49AA86A5A4ADAEEB6FA7B4A8ADBFAD712D944086';
wwv_flow_api.g_varchar2_table(18) := '77BDBA303CF23530F929B5BFF7BB74F0400C27067C5CD53A2F5805B8CEB1CCF1EA63405E931F1C3994EF7BF6F3981E5EE7BB9C5A7A670564AB267A8E2364E1F68A20E7339D6D6BD020BDEB7DB8AAF18B4690D9FEA3C614E018B686391004593C7F78348F';
wwv_flow_api.g_varchar2_table(19) := '478D2BC1E07FCDBF14812CF641B60A70C364148362696F021D8D752042908746F25827AF540580DCFFDCA386C99641B60A70636564095DFEF88CBF6CA8D04E9E4EB9A1405C86A3898F27DA2370CDACF00F7AC591E70FE6F26E47DB4A91004C7EEE570832';
wwv_flow_api.g_varchar2_table(20) := '9F44F5F16B0316925580CDE82D0CAAB14D40040C5552DCD10F58D83F9575CA0D05E232D3A90364593CFCC3036816FE65F2C3A3885DB7F788AFE9787D86397CA66C23766D1560337A8E2EE1698C221AC6B8F82E87238E83BDE3E8466E0EFAC3E606B9FCA8';
wwv_flow_api.g_varchar2_table(21) := '37AF7D299E42FD93FEB73F372073E954AE74B588F58E5C26511169931D80AAFD9C3B78FB720EBF611F882CA831A16199B1228DAFC58A4C4529BF162B4E7CADBC76F9B5F878CC1E95D54D19C878EEF291D1FC5F5FFADBDF7C7FF91FBF7886BF8512C11B22';
wwv_flow_api.g_varchar2_table(22) := '35A63B12E058568058A4309CD52303EEC088E8024C357E266C008ECB346A1F819DC11E1F8071EEC39B21ABD1F71979875F5188BE9551C360EE58804BEC51AA23E365E8670D8CE2F7FE1027411E8372F9797C3CD1BE1284B81CAFC7C713EC6901DA5C4746';
wwv_flow_api.g_varchar2_table(23) := 'FD821F147CBFB2A95ACEEF588029AC58CEF0A375D6E39918900B11C814783185D9E1697C3CD1BE58293A88CBF1343EAEB2C7A50093AECBA71F5E268426FE4C466593D33DB7EA644DB7D32495337286774B6726EB2A35AF8DEE96A8200014F47A1BB85573';
wwv_flow_api.g_varchar2_table(24) := 'A82A3E933163D1DDF100974B8C8C05C8323F8B6F39007908BCF12966B6A59EAD02DC0C79589243B199A6836C59885601B6AC7C45A137FAA0A9205B16A255801B0DC46CF637066448A929E6DAC20DA6004F22C422C86D98931B0572924DF424B26AD9ACA6';
wwv_flow_api.g_varchar2_table(25) := '806C515A56196C59F92CDE667D4DB532C85601B6EC1FD4878AE5DA0D03D9B210AD023C57191CEBCA189001C4AC385E9685681560CBCA17CB3551FB22C80886206C6C62D756076859885601B67AA3096EAC0832BC6B0F129C15265BBAFF14E01A054990DB';
wwv_flow_api.g_varchar2_table(26) := '18D604C856999C64135DA3AC5AB65A39C8496572CAE03AD5AB1C64AB4CAE735C71F514E0581275ECCB412693F9D240CD2975B26A16DDAC56AC0439298E57CA608BB097835CB3B9AE87FD55EE2505B88A50EAB9540419EBE49A1CAFD444D723FEC6D43520';
wwv_flow_api.g_varchar2_table(27) := 'E39510BE195233932D0D3565B025415636530E72DD8E5765E333384F019E81B0665A340920A700CF14B519968F415E9075CC9C5CD7126A867DB3780A700D429B6915829C81A49B01720AF04CD1AAB17C0CF2FC06333905B846C06AA9169AEB90C9647455';
wwv_flow_api.g_varchar2_table(28) := '73CD4216530AB045614EA7A972265705395D074F478CC92EC30F49135CAE93C7819C3238D9E04D67742469C86406439CB120A70C9E8E085BA34CA5B99E8D0714E91CDC645D28996B32193F664C4D749311B1DC3D2D720964CEC9F18724EC749432D88E1C';
wwv_flow_api.g_varchar2_table(29) := 'EB6A25069931EBD8F1F2F3753559AC7C47FFC2BF2885041C941C2F80DC86CF3878766C750A7002C0AD1C02990CE7DA4AB2D48C95B1A48D441220772D5968691106E396CBDD4BF33DCF29168C9AAE4B459A4E3DAE50CBFBAA68223C45DFA6FB29C650B56E';
wwv_flow_api.g_varchar2_table(30) := '632FB606C04E3B04CA4F3752B721540DFD0E46C3E371F2421996753AB02700AC1325D6D1FC3AD124C0385964532C65F5E2FAF15EE3BB64F1168F29CE4BD83EE100134C3031F72100BD05D171B800C85D8658DF221C5782C073805B0090F9B3C8CEE13C83';
wwv_flow_api.g_varchar2_table(31) := '8D1F8A435B9955C8EEC27115761BC5615FE750FCFA2420630CEE026CF3C3B6A82B46D9B04F604A36C06489E3895EB417D88291049B1F391AB9216AE87C783C46A8C8D300176575F7A3A8DB8673B44126C3ECAA41D4C9DFC439AD4179623EFB7245DFB50B';
wwv_flow_api.g_varchar2_table(32) := '8A00F0783E8EE950A002142C7F5DD4F0472243EFA2AF35F80DCB5294A765A0E210F1E4A4E4024C10FC417CA16CB9F8BB7F07825F8D73829711E7A3E3E2BDF19700044C326051B0103E011D3A25C1E63F127FFB63E17901E69CDF5F0078EEA9D7C53DFE65';
wwv_flow_api.g_varchar2_table(33) := '00B21CF5A80C513D9A647F4074DB12F17FE12909966F1295475FC6C4B3695A862805007E7410CA725D9C2B67C5F9F0DBA26EBD8D36313EF3FE4459D9B84E13F7C905D898CC8855F3164BB0102CA1D0336DA23ABB2174FA991066C44E336F1686A1008BA5';
wwv_flow_api.g_varchar2_table(34) := 'B07AA7048BC12C460B080E49E501FC353BC43D89EBA360B107969271C4C37C140B7D4159F4BC45A2172E83211829015C64250AC7EDE15AB06E87A8753BC5FB71BF38E7FE1D6B1B806C988C361392A0C6094E8665106A3E276A94DBB0D9C4A7F0CB866E84';
wwv_flow_api.g_varchar2_table(35) := '8EB976E4BCE8257B45135C00A446C034B0DED4CDC11A2C582AC18A3D00FE4A74D3403EB6A89143A6F2AC17F663FAE339E6746EC63C4323141447614C4CC1CAFBC4DFF56468DA472F4159A048466B4C76D3FF9449A9E963A93200D20B0960E2A3CAC6CC6A';
wwv_flow_api.g_varchar2_table(36) := '98DA31E01A16238FE656DF92A067A7E8AE45E6DB8434CBC6E132E021C6DBD609407684F5636F3AEAA28889E92BEC4367DA45DDBE0C86BE22DEF19725F3D67F887B0EE638F20D0838952158BC56820DFBA0381791C70663AD31A36FEA9F049BE80AB95402';
wwv_flow_api.g_varchar2_table(37) := '11671B7982BD707CA46B1B188AFF6D1DE65871EE05D39C6B3F0500EB60DA71AB107EB07C2398BC4DD4C04F716D61DC4A154CD030944A0D5C13F7C77F0645B90DB3BE56DC4C377C82E7C4BFF761E81914C1809DC114D2236EDB2A94C334E162A9152B50A9';
wwv_flow_api.g_varchar2_table(38) := '87A61C41F55B3DE1D3DE74B4F2172458FA80048B2064384264BA1ABE0527E80D98EBA1F01C5F18D5F3319FF7D04CC39C1AA6816D54126ED5122D47FBFD985F778A746C8413F713B4F97D987DB689BCB89E8B31B891A79F2006B73EC0005705989331F705';
wwv_flow_api.g_varchar2_table(39) := '3DDB45772E047BB16421C0B72E897BF615716E63CE35CE1800F6B230D3DBC2756C80720483167542ABCA7CB01FCB357160293C289099FFF9DF3C942A19AFDB87F3C67255D7D9D5B467F6AFB518C0315D62C180BD14FAE81598DDED6679535CE3C2447319';
wwv_flow_api.g_varchar2_table(40) := '23D75E1575F523C3EAD8E3D64BD6C3297A002C664023124165D371175C16E54E633B838F49BF83AB7978CF7B309F83AD70E0B4EBC1E9822376F543645D06C088BA99E55709FCB8A966ECA96ED6D24432B2D6411963C236C121765AB82C7AD97E04375618';
wwv_flow_api.g_varchar2_table(41) := 'F61AA10F2118F1310181CC2F9D10B5E921AC55BBCC87A07557B704AB768B7BF95B6190625CBBA61A8042E370B4F40AACA9611574C70209D6EE91C2DDBBC33CCEC158B639E74E8873F6551CC37B2FDAFB390870436FC92C8DA09F85210816CB9F9EAD088A';
wwv_flow_api.g_varchar2_table(42) := 'CC0B9751D94E716E5CC27F7201E6757D0AEC3A096FF82AE6E80566D944272CE8B95FDC77D6A23E963B1EC3971509269D4B2CAEA747F73D1D6682ADC6B346DF7CEF4233E872F17DF17EF435043EC070B30EC6726A2285A9E8A211A7564DF4EC33B8BC071C';
wwv_flow_api.g_varchar2_table(43) := '736ECCC33C77EF9060D927202F5EC32DD13C5F785BD4B53E734D5D3D2CEE05B0D9984E5E0AE08CAD06E070B6F270B64C34AC8AB8A9446EC6CCEB642F83258A269BD7E15D7B6F7E4332AFFD152CC5F700EE4A5CCFA39186AA7995418FBD6415E0D9B9B509';
wwv_flow_api.g_varchar2_table(44) := '5A25285C8AE8212C8D10B942108301080D40D4F06D30EA63CCB3BF8E38F636EC7F43E4F6050427868DE7CBEFF51330BD0AF370E162E80857EBC638668530A8113B64500E8DC817031DCEF91FC23ABC12811B853DC7CAB7E96756E7603B77037698843D19';
wwv_flow_api.g_varchar2_table(45) := 'E72232143B42113B14AF1360C48F6916839E2D66AE1446A0141806A6F9DB01EAB65F0BEB92715CD2A01DFEE70C868134D32BEEC5C3A59D508C41E4558882C56882AF9D13F7F477A0107761EE05E31126E51A3B58B24EF20F7F4132DF9F8F65D3515CBF07';
wwv_flow_api.g_varchar2_table(46) := '8E1CBCF984A58ABB6AE6E82051058F9860063075E64910F6D9C5000F8183D87921D3F83FCEF0111D820F7AD9AF223CB91EE7041D79DC432982457478CA129B67B89100B32DEC199C0896EFC5C38B97CD3C5E563A2CC3A5D620021D3F398888D54DCCEB7F';
wwv_flow_api.g_varchar2_table(47) := '23F9DD084B2222C6F0A75E8007213B1F97CC8DD35892BD87F532CC34E77413391BDB5AB3CEAC9AE8FA6E02E88C6299913B1F820096A8A11F8029884C75606D4BE08820F62A8767C3FE0D23C8A007F36FD75D8655261FA0907986FD647ABC616D4AE7CA84';
wwv_flow_api.g_varchar2_table(48) := '2FD9128321EDF3C2D0A51078307F5C8222705DDBB50FE1CF47C479EF1FC1E6FF31FD1244821C40B90A9F7C1235C15E826BD6C154A264A4043018A0D13961A062F94310DA009CA3FFC535086FFDD352D8F84B06307AB4141EE75175ED0C84790D4F7EB6C2';
wwv_flow_api.g_varchar2_table(49) := '3C6F0663711BCCA71384C778EECF4F213F2C6F185B64B6278595288F6088B1026D08312E63E81266FAC69BB8BEBC0A2A00AB0013CEF0A35A2AEE897E63DA092CA359189C14D6EF12E7E74F8973EA2B500644BC12F444A9C90043789CFB0A9CBBE02C6DDC';
wwv_flow_api.g_varchar2_table(50) := '0790EF4180E29C6149B0640D9CA765666D4BA0B8BE75AF5C1475E947C88777BB04ECE5736246AEC06E8627DD4BA7C57BEDF3384720C2BDCB280AFE472494412C59AE893C7A4CFC4FEC41693C28208BD1BE5EF180A8CB87D004C09928714AC8C052DCFCA1';
wwv_flow_api.g_varchar2_table(51) := '7827FF4BF2BFF8DB662A609043B7CF97C2FD9F86377D1CB1EBB398567AD0DF30DA6BBE816CFE08381F9A7917731AE74E30C3DFB8C76CC142062E603A09049FEC80BDEEFBAF634D7B126C5D01F6C24386990DD98DF992ECBEFC7E380F777C126596019435';
wwv_flow_api.g_varchar2_table(52) := 'D856607E841324F0B42F9E44792814E7497ADD6DED602462CD948479F506E331669DFB680B27F7B04E66A538675E12E7676F81BC213FF888B1B0748304F73D01602F86E032C266FC868934A631D7AD020C71D490683F51D3683B8E01A679DE0A936B62CA';
wwv_flow_api.g_varchar2_table(53) := '0C2E641181F273E2BEFD9FE29C86438470A0EEDE25C19AED0011ECE45A15C10D2E8F9C8FDFC6798F61B301D1AC71D12EE74630DAB9F47F2228C736594F321D30DBF7895EFABB30B958537BEDB88636395F9BB6B18F13974A1ED6C3F9ABE2BDF30D133CD1';
wwv_flow_api.g_varchar2_table(54) := '1D787180112DD4F3373F22C1A62FC0978005321AC37B6B6E0A55D0D2186ABB1D7ABF1010778357E0AD62E953D47EB498BB2DEEF50BE29EF92E98730C790086E679C12AC3383E0E34261AA038171092BC8180466609CC2F1C1E13F4E7A8C844EC5D28C1ED';
wwv_flow_api.g_varchar2_table(55) := '53E29E7F0BFFC527A2517C8180CB30CCD7BA7B3DFA07BB073E16751D0AC507FA8837F31C1D62C3184D7B680B8F05D5A5D7C47B779B14EE79D8F4CFA59BB1065016E7FC7A28011F2FCE43BFF02F4C7DEC9A90AC023C7306437034870418C0B9275F46E8EF';
wwv_flow_api.g_varchar2_table(56) := '243CD6A590274D2EE63D042C9CEB6F618AFEC008D62C9FC02275ED9464BEF377A80F134E01D2E4E6AEE31C46890AC2768B82653F2867965E0571DFFC1771DF5D5C56177558D75988B0E33F0318CCDFF1B8F28368876D82D5A6AFC8DA788B30DE1761AABF';
wwv_flow_api.g_varchar2_table(57) := '178E9F79C65AB05BF46FC6108D0D979A95AC025CFB4D5068F0907360CFCF4E409030851496111A84E576C371D9806BE8C1E4B12C965403F0968D2964CF68C30563CC6BB193A81AFB194678720073B56125CB62F316A229CCF3B7388793FD0095AFDB3A9D';
wwv_flow_api.g_varchar2_table(58) := 'C883192EAE6D39082A25C605E6ABABC771CEC4EB1C374D3B9C3B133829573253A8E17FAC02CC5BAC3D51C80088739C611FCE8D5029682413968C05863C320A512C5386CE10CB52210CCBC22AD5FF46FDF06D0ED60BB5266C9F40F37D6BFA03C536D1E7B8';
wwv_flow_api.g_varchar2_table(59) := '650FEF147DD1BCF3F9B069874D710C71F9B8EDEAA368D455AB00F396EA4A069C32B36604C7F35858E52A846B7C073AEED4ECCBF32719895104B06D4C8AEA1A458A1A9DB4CD184C2EF1A23469F9B85063F756019EA678A7718791808B25276A79A2EBC58A';
wwv_flow_api.g_varchar2_table(60) := '931C4C5677B2BCCA266752B6B2EEEC9F47F6CF4E4795B0D869356DA51E09580538D9BA5C8F985AB7AE55805B570C7377E429C073175B736729C029C0D39740EA644D5F561395B42DC3BA18DC7FE244B95FC5686F9AEA9440A50C2B643CE3D6EB0278FF96';
wwv_flow_api.g_varchar2_table(61) := '2D46E15460B035AF3BCD78046985311288191CC95462198F29348393BA021DB176E12D438D873371C08E638CC73983A1A44529372344CA1232A5446219D72A9DFA18BC3FEC563BC107CA51EF65BA10800F03C90C1AA7DB8C65A003CA90B2EC804C29DDFD';
wwv_flow_api.g_varchar2_table(62) := '918C795C4BAA34F9336A03DAA6105F379A36F495CF3EE1B8EA856C077E5FC95457CB331AC6DC281CD9BCDCD0E84D4C78BFD7F9FBDFC2C36F52BA24E35A6EB46E18CA0730F4D5CFED5652784C2B851FFFE880AF22A7696A099817461DF056EB1B78ABEC95';
wwv_flow_api.g_varchar2_table(63) := 'B63FF8E60F58AB5CB653B7328B253890596CFE8E6CDA964CFF1F8932F39E2771DDBA0000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72350886691797178)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/jar.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D000017E5494441547801ED5D696C5CD775BE6F166E3343522BB55AA62CC9B2E4D8965C5B56632BB25BD45D90C4B2C2A888DBA068FBA729DAA24551A0E80F';
wwv_flow_api.g_varchar2_table(7) := '134580F6971BA440D0D428102411659B6D6354492105ADB5D8922D59B6A1B48921A8B6166B5F289233DC667BFDBEFBDE1DBE19CD90B39C21DF50BCD070DEBBCBB9E79EEF9E73CF3DF7CD935212C9B62D0932B34AA3B737A0E6C2380A84182AB8AFFC9642';
wwv_flow_api.g_varchar2_table(8) := 'B12C9B0DB71F3DF0246EBF642BBBD3B2ADAC0A544E6EA65A90BFACB25B9A03815B8B236DAFFEFBD6CF5FE8D9B429D86FDB59339E99E2A59EFDD4A6791E70B71D3AF89540C07A35188B762A05BCADDA48D773D0867616176DB6AD3AB2D98360F91BFFF6C4';
wwv_flow_api.g_varchar2_table(9) := '339FEE3C74287478E7CECC5C01B9260DEEE9EF0FF42B9579E6E881E569A57A431DED9DA9C1A1148415507EC697F6862A8C7F9950702C108B3E9F4DA5FA5EF8E8DDDF7E73CBF6F31A64DB9E13208B18D1543ABBD656D686F4701CCA6B135CD2F5EF47F347';
wwv_flow_api.g_varchar2_table(10) := '136363825B0AE026C21DEDDB02D9F4DE9ED347BA0F3FFB6C7AE7E1C3C1B9B026D704707F4F8F5E7B6D0BC2CA1258C88CD7945A237C34BF7610405BC9E1B81D8E447F3993B4F6EE7EFFEDB57305E49A0086892690CA0A06A1C030CC10181C2C66354622AB';
wwv_flow_api.g_varchar2_table(11) := '5883C1B8F6A053F17826DC1EDB0EB7B16FF77B47D613E41E5AA206F6AE6B02D868B0465343CC3F0D90CC1C9C64D6B6021005AC4F2A9EC88463B16D7638B89720F75B56A691CD754D00E741698C725EA64F6F26817518D4F312A8D37F00CAA9E1E14C381A';
wwv_flow_api.g_varchar2_table(12) := '798220F77C707C5D236BB21CC05A5434D10D98F43E1EBCEB6FED4B0064986B809C51D9BEDD1FBDA735B947F5379CB91606B8C14CB4998B7A8DCDE39D0EA30372049A9C4EBEBEFBD4A18DFDD657338D06B230C0B07246687EFE3626DA306B34389F6707E4';
wwv_flow_api.g_varchar2_table(13) := '04D6E4F6D816A542FB769F3AEE82DC388E9730C04672F992F2DD5D0E589733D74B2EC23DE5A33539148D3E86988E0BB2D5309A2C0CB0919CEF20CD67C820892D924E6E2CBD04F7394D26C8B6CABCB6FBE45B9BB5B94624CFEF5B2859804B48285FBA3EBA';
wwv_flow_api.g_varchar2_table(14) := 'D33199B2F8713499E63A1A7DD40E845FDBF5FEB187FBBF8A35D9E720CB025C96AC7C54A9B209E980CC604834FA30947E5F23802C0EB0B17E3E82519215C75C6B90230039EB7B906501D6A14A4979D6995675B331A0702EAAC39A5180ACB2AFBD70F2D063';
wwv_flow_api.g_varchar2_table(15) := '3973CD07077C948499C9DB4BFA689825583126BAB4175DBC21235E043931920EB747370702D842BD7F648B0679D3264BF908645980213023B3E292F159AED160D78BAE883B808CB10611BB4E8763D18D0866F7F911E49A0EFCEF128811D85D053ECBE02C';
wwv_flow_api.g_varchar2_table(16) := '24AF05B3D16497CB2D48F059A51CC800BBEFC553475FEAFFA51D1FF66202F4F224AAB7970F8ECC5A12D7E0591B49251D4B4D44ECA3F3408E463702F37D2F9E3CF6442F3CB0DE975FC6732EB3BB26CB022C25B84AC0AAA6AED1DC5AF9E53EDA05196C0493';
wwv_flow_api.g_varchar2_table(17) := 'F138CDF50615C8F4BD78F2B02F409635D11865AD32AB06AF8ADB18260DD0DAC9329915529B0C96E078C20AE2C99074532CB62E3592D80B905F8226BF3F9BE65A1860E7B8B04A5155285981EA86D16A9CACE2DD6B905DC76B7D2A11EFDB7DEAEDDF01C827';
wwv_flow_api.g_varchar2_table(18) := '660B6461801B649B44CD35E012285783BD59C5F12B2B17CF89D3F1D2E67A5D2A3EB26FD787C7A8C9EFCE06C8C2003B8EA990A0CA926655950C83C6447B0E1B4C515574271BE1A15C0B20639F1C8B74A712893E80FCB5D90059D6C9CA538BC9D1FAEE2A07';
wwv_flow_api.g_varchar2_table(19) := 'ACCB59A5818E320684890290A1C90C8644A3F7E3096C82BC1D20C3BB068119F2AE850136922B4302B359C5A869DE71A1FCF3A00419C374408E1064C4AE4FBDF374AFE5EC8D7B67006459801B04DFDCDC9AF480916550CF954A5D38208F4093239135969D';
wwv_flow_api.g_varchar2_table(20) := 'C53EF9C80E06407AD143AF5DDF7DB22CC0522299293A3337212735391A5D8538F60F27417ED9A6F355AF218B13AE9B1ED44B0239BA7547DBF1AE1D4D5E9D03190E5E2F7CD37A812C0B70431F17CEC8D4D49A9C4C24D2A1481B41EEDB75E2C873AA8E20CB';
wwv_flow_api.g_varchar2_table(21) := '025C18BDCF69874F2FF29436EFA69E0CEB60487A643485E7AE575AC1C00F767D70AC6E20CB014CF9CC988C84E46F945636D0510E73EC39842D540A8ED70A385E3F7CE1E4D15FA98726CB014C968DC0CA19A21FEA9809A97F33E7DD26A1805B28EF87FC7A';
wwv_flow_api.g_varchar2_table(22) := 'EF0BAFA72A37654605D8D69156283532920A4522CBF1FCC0F7777FF8F6AF6A90B157EE79E30DFCEAB1F6240730793102AB9DAF19A2906398AFA14064C2BC6B0433955B28EF871C79EF0BAFA72A37650EA80E1DE639F76144BA100C89ACC0CB23F6EEFAE0';
wwv_flow_api.g_varchar2_table(23) := 'ED5F67019F0E910886C802DC281AECC515B006A031C42B100C66AD000250A53E7086F2CA4ADD17E6935E611EEF755EC00E0402C1F4E858B2291A5D1AB4ACEFF59C3EAE41E65E1956A326A98AC7A26BE286537726129904C8043595CD06E389D171A5B209';
wwv_flow_api.g_varchar2_table(24) := 'A3608E293223E16CF05E9341EFBDB966BEB76EE1BD9955A6BEA9EB7ED36CC713894028D8954E265F79EE3F7F74F6ADDFDCF589794D06A9559384016EA0E342C899A24EDA767332950ADA6363B6CA66F17207E4668DF0A713A9A957F8CD7626AF140D6F39';
wwv_flow_api.g_varchar2_table(25) := 'AED12F300EE319A00CACC44301DB5E85969FE4FD06BB14A929F285016E90E3422310C8155A6CA9A6E630CCA502C8C0059941D995CB7437DD37D5C36A0AE19D21E974CAB6F15E9BDA931CC09C9048FC32464867F8F90F19D57C5377C29AEF1CC8B4DFD325';
wwv_flow_api.g_varchar2_table(26) := '4E8672EA15A353A42D6D07AC4710DF5628EC42E3BE26A3188972F2E400D6F2284328E57035937534CB7064083441C6B73D0E4DC66BD2CA028F40559B0ADAB2C7BB6C87FBA29B6ABBB88B5EB5849C76350CB6B68E655A53E004B9A5156B22445300804C27';
wwv_flow_api.g_varchar2_table(27) := '5350A9437FB2003738BE8EE8671364790B280BF01493B3B18A5C905B6749930585250EB0FC1C141C6D45A4007208E67A0641AED65F9B6A58B20073AB31556F0D57E6823C436B721D9660FC764634CD2D781DD1604C74BC6650932521910398D8CE457CB5';
wwv_flow_api.g_varchar2_table(28) := 'B431B01936D75220CB01CCC577EE2CC045E4DB989A2C073045326735D8C5DBEC93EB66AEE505280BF09CD6600FC87533D7F202940518329067D115ACAFBEBCE69AAF9B96D73CA9E10A033CD7B64953883967AE5BF8A4806F411606D8BF33790AA8AA2F22';
wwv_flow_api.g_varchar2_table(29) := 'C8DA5C4B812C2F3F6180EF1513ED9D130045EF932540965FE08401BE874C741EC692207B09D77E2D0CB0BC89A97D883344C1A76BB230C0F7A289F64CA0DC9ACC53287F385EE200DFC33AEC224D731D7263D7B30FB230C0F24E82473F1AE7529BEB6A4096';
wwv_flow_api.g_varchar2_table(30) := '570F6180E5196C1C540B38AD06E43A1C080B037C8FAFC10518EB0817CD751BD6E4E0F4E6BA1EF64F1CE0791D2E40593B5EAEB99E06649B75859338C0C2FCCD0D72042E580EC8F23A2C0EB03C8B7303637D961A2A0764D9F18A032C6F6464073CABD4F89B';
wwv_flow_api.g_varchar2_table(31) := 'A7B234598E4B7180E5589B8394B47903C82535595E3D84019E37D0654D4B6A723190FDBF4D6AB05F179685461D2A510F2AF0AE6BE1405C83E58D4C2DC3F379DB4290F5EF9265791606781EDE8AE1F1986B2B347D30A452FAC20057DAFD7C7DE747C99E35';
wwv_flow_api.g_varchar2_table(32) := '591864B9DF07BB58CDBB59554E5A986B1BE006426D4AA5F14BE154AA4A42F9CDC43578DE48E70BB8A23B1DF182996EC5E33FFC20F5EABFD5FF11D7E0EA59996FA9256040C6368AA957FFADFE8FB006CF1BE8EAA1705BEA2D54CD5472048435B87EFBE0C2';
wwv_flow_api.g_varchar2_table(33) := 'FF3E8C72F04EA7C2F2DC083D17A6BEF9F61495BCE49263961DAF3678F30B7929496C9A821C5FB98B691A94512C0CB0F354A5207F5AB858955404511E0A988225FD095C4CB8A2677E14E5419478DF38896C9D589F1380EF254AC3049AF7134DC5A701B509';
wwv_flow_api.g_varchar2_table(34) := '349BDC8ADCD1900E6FF9E12BB59852C84F15EDD9292FF72FFB744996DB64DA7AC2001BB14CDB6F5915488DE04D0094E319C0E221BF0E2F49598A0FB3D2F87318E559BCECB1A48820B9B598044BF01E9B08DA1194245A1713286936A384EF331AC4DB763E';
wwv_flow_api.g_varchar2_table(35) := 'CA649CC893AECD5226B725BE1E06CD185FDAE2C3240C706ED82243A5C8F04230D50EE1FD4173AB6A0640D450BEBBEC5A3AA52EE2C3EB16E47FBDB54D0397417DE679130FD2C700FE956C46FD37B61FD954523D82539D050066DC0332A1639FADA0770DA0';
wwv_flow_api.g_varchar2_table(36) := '7E8CFA1B50EFF75A236A4553B3EAC4AF185AC10BA7D128CA86D26975239954A79313EA3AEE97B965DEBE2BB9CEE7BA9296A5EB0A032CCB227E57AF3E81E0BE0C01FFC97D6BD5C2709336B12100F35F372EAB3FBD7E592D409DC7C3CDEA1BABBAD5EAB6A8';
wwv_flow_api.g_varchar2_table(37) := '1A8326E3E5A2F923A6B602E0214C88DB13E3EA67C3836ADFD0803A9B4DAB758150CED47329A0400EA1DE7680F9AD454BD5A3ED0BD42A4C9E36FC7A81FDE265A198124A7122A5A1DD13E8EF1ADEAB75F0E655F53DD05D0D90A1EF35A402DE6BA0C4A6C200';
wwv_flow_api.g_varchar2_table(38) := '3B2BA0148BC4E916C4D902A12DC17B3216418B28D4309E39EE0835A96148BA19E54DA8B8B8B945750188516855D079EF634E8FC9154159E5E63CBE70897A6270407DE7CA05756C624C3D009033A841BE8F02B03F8F75AA3DCB56A9F5B10ED58AED0A2D40';
wwv_flow_api.g_varchar2_table(39) := '161F6F625D1B8FE0049A9AD4CA48545D1D1B5517076FAB35AE16E7D7F6B62C7DCD36CEF4295DA7D2126180A5A07586419922AEA3B5653C9D516381343438ABB53809CD660AA34B0A7F1C2695DAAB3558BF53946BA8C30FDF43C937D825A1B114622B26C8';
wwv_flow_api.g_varchar2_table(40) := '538BBBA09196BA78E1AC8A63D2D05C1FCAA4D437172C512FADEE56CB31A1F0265A358E09438B1006706CCBBEB804F025BF9A3AE9A26FF225038FC33388892461801D2D10E10C44880F61E49029E42040A090796DCC30C5CAE4943BF9CD00F0C268429D86';
wwv_flow_api.g_varchar2_table(41) := '1966FD0E98DB072231B5B22DA2B5711C13A1053EF7E6CE856ACFD022F517B7AEA9C55859FFBA63A1FADDD56B55574B8BB6046CDB022D1D0380E78687D4C5B1119570018F20ACB8184BC332580D5A97264C803C2F10779526075AF62A9784017686283907';
wwv_flow_api.g_varchar2_table(42) := 'F36919633B29006FB9160D340CAFC7579700C6D7AE5CD0DE6F37007F186BE85FAE5AABB62E58A4420083DAD904F0B6628D5537AEA8A75ADAD49EE5AB016EAB1AC11A4CB89A51FED9E888DA7FED92FAC9F01D7506E05ED55346A9959876780FBFDA8C6563';
wwv_flow_api.g_varchar2_table(43) := '0726C64D385A6BD10F23C86C5B4D22FFDEF15443A3B08D30C0D2EC15D189722638EA04202A6E5F820024068DDF0FA0D603C88D5857DBB0AED23B679D0E00CFDF11BDB060B15A1BEDD04E137B6D86F77C116DBE75FEACFAA7F8A05A87FBFB4067AD6B45B8';
wwv_flow_api.g_varchar2_table(44) := '9F4E6092BC8EB5F7F5F151F539D020E0DC6397C362211093F7B2321406B8B6A14D0E728A2B0879DA842AACD60C30189A6887F01F81077E0BDB23AEDD112BAC4160A0228DE8C5F370D01EED58A0CDEC482AAD357B1466F93FAE7EA6C1FD02DA72BDE6DE19';
wwv_flow_api.g_varchar2_table(45) := 'EFD8D71383F751905F8E1EC601365E2CAEF8FF0294C1DD34ECCBCA501860791373973420486FCABF734BDC4CBA54D4E00938403F8379DD81353804B0E9151B20B81EAF87995D0AD3CC40099BD2849F890FA9FDD8F65073F1B670BDCFFD1F686C5E626543';
wwv_flow_api.g_varchar2_table(46) := '08970F61422D40DB825A794DA6BAF1909AAA5A4565B20063C00563AE88996A2A17150A3269424F033C3EFBD4042DED8659FE8D455D2A826F6EB5E894B1CE79ACD55DC88B718F8D7AF4BCE9299F8793F673B4DF80FB5BA8FF39045AFE0C6B2DB7647ACB84';
wwv_flow_api.g_varchar2_table(47) := '6F264E16D2E2B83FC4A4383012578BAB04B91EB29305B8A8B4B51CE4FEB8829D8A2001580AB3FBCA92150020AB03249BA2ED6A7D7BA70687E55C876F21E8F1E33BB7D4735897E979A760BEB9A562CC791811AF01D4E31EFC7F61AEBF080DFF229CB05638';
wwv_flow_api.g_varchar2_table(48) := '5E9C185CBFC90A41E1B5FEF7D939F56DACD75D68C37C7E663BC9025CE71169F2102E53C9AE20756A6837820F6B10D9623DAE978C42397B55ECADB16D1A8576FEF4DA65F57A62587DB97391A6481FDDACA2D44CD30B0F350822F7C261D0C1144099B327D6';
wwv_flow_api.g_varchar2_table(49) := '17BA17CEEE925C39D566E1AF2CC075D060BA497789CD93E1E27D97E8B8676E768F7B3454F84380A89DD710BDFA29C29C7F77E3AAF6A0E9209918B65E9FD1690BD65E6A33F7E131404AAD653085FC18139F83D45565D2F65B9203D81D5CAD181B1969E1E1';
wwv_flow_api.g_varchar2_table(50) := '660412E3210365A813BFF1C9DD9A0BB7985FCC627469844E1368300C49701230BBE746E3EAE0C04DF55DAC953B00E279D4B906EF9AE534BF8C59731D5E89D71572EB130781F5C8FF05D6E4BD17FE4FAFC109D4DD80C0C9B3CB566A078C3C93BF1C8F64C2';
wwv_flow_api.g_varchar2_table(51) := '27490E6057D07AB0350CAE05F05050D42A9E1211A1C530A92DF47E355D3834B8486A8F76D2A4E6BA446108807C8CB5F0C7D7AEE83598DB97EBF0A23F4630E25D80C9F3DDA701AEDE4681D639ACC5090437A25897499B6BF40358B39F4694EA3B709C7E0B';
wwv_flow_api.g_varchar2_table(52) := '5EF60594FFE8F60D67F6E0FAAFB05EEF5CB602BC62BD65A3BC446114E6E55598B11B39805D9639B44A134541D34773F811D6C6767CAF0148431022FFF7930D584F5B014806DAC57A13C8BF0CB0BA5C3D2E14254DEB1D1CE37D73E8B66ECF1F5F239CA11E';
wwv_flow_api.g_varchar2_table(53) := '0418CF00446AE81840C17F3EA536C16C9F42A0E232821ACB01283D62EE951702D43D5DABD47B3829FA0926C0761C6EFC1AF2684D4E824E3B6896C6B09023745E46AA4676D39115079843AB8451D627133485CB20B4DF8763741EE0BD09A132FD0D4E7E1E';
wwv_flow_api.g_varchar2_table(54) := '47948934A9598CF90E420B7F81EDCD5208FB6609293741E33F8FAD0FFEC3497D4ECC6004D748EE8D691D488FCE5317EA1D4A27D5BBF0A63722D8C1F35E4EA00C26D663086BFE03EABD71FD927A1313E032EAE904138DFF7810DA0B2AA0757722F562F977';
wwv_flow_api.g_varchar2_table(55) := 'D7F4E6B0055B4A2671802B658E8362206100425D6D85D48B5D2BF5B1E01F618D64ACB81BA692C784299BFA0D4D0700E750F6164284DDB8BE8A76C544498F78904002287AC68E27AC49E40991A1C52DB00EFF82A3BE47063AD517962E5721B44BC15A8460';
wwv_flow_api.g_varchar2_table(56) := '2F1E5FB858DD070BB2077DDEC1C44B6196B481AF55C8A3774EAE349C68338975318E9CBE67FAAF38C0D5CE409A506A5904C27B10FBD53510A0DE9040D05C6F2932EE5D072626D47E78BF1791FF1026C4B80B3CD7417EB881A1A6535B69CEC98FF9E0322F';
wwv_flow_api.g_varchar2_table(57) := '319FC0B7C3E40EE028F11FAF5CD4EBF056588D50D6D56468EB92269C3523D0414F9B9C1058F2934219FBE37D187C3B274AD56B61B5B2CB1B54C10D652097306A0EBCD2C48165D0900FCDF19ADB100A8F6B21B72734B711385AD4A0372E9F57FF0CC7E729';
wwv_flow_api.g_varchar2_table(58) := '1CD253D8097C38086A3B0F089AA1D53CE2A3B0C98BE6670AC9B12D1FDBB91FF43E00FDBFBDF0893A78F5921A8623D58209455A5CFBC90B83263C57267F34E1ECB30D7DF20104064D3EE3FF9806B09974BFFAAAFC3FD5B4998EBAAC06636C53C8B2282FAC';
wwv_flow_api.g_varchar2_table(59) := '4F7079E2C36DCD7508EA7E385A5CDFCC80075213EA7C22AE0EE0DCF6151CDB3D0AF028471ECD2DC705D7D4AB106E10021F83B7DC82ED108FEFF4E048C7102ACA81C333417E10609D05B07F7CE99CFA3ACE927760ED5F83ED101D2E0DB46EEF10A336DF1E';
wwv_flow_api.g_varchar2_table(60) := '1F5703C971F529783B86FA27E0176C030D991F9D9460B6C26C598031760EBF129059974F37F2C1BA7168C57761268FC3E1E1F357A49404D81701D63BF074195BDE0E0152EBB876F269CBD530AF3791FF6D8042078982A7973C040BD08C3AA4C1475AA7E3';
wwv_flow_api.g_varchar2_table(61) := '89E504F93E68630213EDEF3191BE0F4BF124C07D109F45E08781124E3C6A301F0DBA0467EF0C26DF3B9850F404B6A02D1FD833EBB2EE7E96FFC8025CC3603831E86CFD1C42D31E7401229B00240313141EC16531D73F82498D3981E8D41D10E12F7A26F0';
wwv_flow_api.g_varchar2_table(62) := 'A1667702906991455D930CC86D68BB3318564300FA242CCA9BA00DFCF269E1BE150D9683AFADE827826F7AE8E4A58075437E56BE65011618191F3D5D014D30BE3149D2D962A243E4953373794F8D5E8335B41B1934C7C047AFDD9C089526D2E466880B44';
wwv_flow_api.g_varchar2_table(63) := '0CA07584026A1D68B267F6651279625D7E08EC985BCA7B3F255980BD12A8729446B8048D89248D708D407541C11F82EFCA587FD72268D3D6D034FD9A7CF2C409E81C39388C98B202B666FD56166081511A125EE1514A26BF94C4A62B2FD56EAA7C2F4D67';
wwv_flow_api.g_varchar2_table(64) := 'A2E5D7F696E797F8E7CE284AED1C159340ED54E729D428013980399D1B614AD728B0466B2E07B01EB9E378349A10FCC2AFA31FB25A220CF0A49FE317A135121F5CE5A49330C0F560517AC87EA7272B4339805D274BD6C0F81D0C59FEB4EC64F1D53182AA';
wwv_flow_api.g_varchar2_table(65) := 'B9ECE9EF9FC4939101441884F9AB9AB7466CA865C7280DA3356ECA93B1C9ACE0BB260DEEEFE9D19CD8998C86978CCDBB591548BFA0AA969D1B8AD33245B9917141D5B26F6B02D8CC2E3C354164117002DECE034A047EFE53A90C9C436D82676B99E2C2C8';
wwv_flow_api.g_varchar2_table(66) := '9899D5249148562A14F814673F6742EDB1CDA9C121E7747ED27857C3D7BDD786EA605959C830981E1A3A13824C2584501B0C367E066DF1085CA96D870E7E054FACBD1A8E453B3563B55196185B63D1D052C4C1C5707CC80EA83F3CB1E3F97FD503F0C8B8';
wwv_flow_api.g_varchar2_table(67) := '9A01D50E838781ED470F3C89DB2FC156775AB6E53C02590D57F75A1B04DE6193F198BE3588538CFDEF3DF7FC090970E5C44890E793AC048464FAFF46A2BED28CF7B2740000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72351316374797180)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/jpg.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D00001426494441547801ED9D6D7054D779C79F7B77572BAD561218221B1B30603004E3DAE0C1041CC74ED2B89916E1A463B9693BD32F699BC9F45BDB9974';
wwv_flow_api.g_varchar2_table(7) := '3AD341CC341FFA25FD9099745A7BA69E021241C9B4339DB4F587DAC46D48EC80B09CE249B021C438263601845E562FBB7B6FFFFF73EF59DD5D4948BBF7ECEA5EB1C7DEBD2FE7E59EF3FC9EE79CE79CB35C899808AE6B99286659CBE8EBB3C595F8B7A342';
wwv_flow_api.g_varchar2_table(8) := '88E11B44B896E5B2DCFDA75F7CBC5894439665AD72C571EC8A8789F08E838F8EE1796508A6A9367EA1BCFABEFF2C8B2C5DC775A4B5D5B67F9D6D4BBFF01F7BFEF017BDEEC9C4A0F43ABA3D95358BE3753254A50370F7FDE085E71C475E4C75B677A932C3';
wwv_flow_api.g_varchar2_table(9) := 'AB4EA8AA2D2533D52709D54C16DDC7BE706EE0AB83D6F3979F7EB52F79CA758B2B057228C0BD32680F8A141F7BEDE83A71A7FB52AB3ABAF22363799887AD3A3BDA35412BFBF6CF71502118579966BE38AD30BA2C5DCEEDF256A6294F6B39AEEB1493C949';
wwv_flow_api.g_varchar2_table(10) := '3BDBFE79375FE807E43FF8B7DDBF0FC8B26220EBBE528BA2BA23E832A4647A0B286E2F8C4E1026E1B2DCF2A3BEE7F5CFE5713AAD4EB3D031988E6982E982E795E9F4B53E7A69895B29B85B288CA7BAB2FB01FC78CFF0C9CDA73EDD5778FAD4A984AC00DF';
wwv_flow_api.g_varchar2_table(11) := '2214E0C1DEB7953DB976D112D7E2588C83B2590A2FFA1FD65724E1C2B99A199D70531D990376B1E043FE34201F893DE45080657027218AE524E87FFA3E68651FCA14510DACABAA36BC2ED7CA8FE68AC98EF6FD84FC8533271EA02573188AB3258703EC5B';
wwv_flow_api.g_varchar2_table(12) := '30FA684F4E8AAD621E55A215F5F2EA0AC4AE65431438E4C7261464C72E0E1C3C777C1B1CAF629C2187032C87CB051627B6C19AABB116DA49FF0198F3A313C5544776AFEDDAC70F9D3DB935CE9043020E4A29C6E7FE3CDE9F1AD179F321B7ED15ABD81F67';
wwv_flow_api.g_varchar2_table(13) := 'C8E600FBD61B4B239EEB2D7B90C772C55496900B270E0D9FDC1E474B3607588DBFECE56218B4059757DDEBAEC701B923F398140B277ACEF4EF881B6473806369BA3ED1B916AC517B90E15DA7B29947B1C2391037C8E6006B91C4E98809B00AF35BB06E89';
wwv_flow_api.g_varchar2_table(14) := 'D75DD39209392103CF0E1DDBA92C7930FA5328738029ABB8F5CF58E85862F02C9990DB338F3AAEFDED2F0E9FD835F83CA65011876C0E3025B564792D51ACF54E569D429620B7746676398E33F03B31806C0E30E14260B1625C7D653DC85CF16ACFECB20B';
wwv_flow_api.g_varchar2_table(15) := 'D1876C0E30AD0102ABCE28EA6DA27529DFE636471E53A8968ECCAEA4E30E1C1C3AF148A9BBE60F072214CC55A67A6B888E1816F6A2E7AF2356BCB0A962E7C7738564B66D97ED3A270EFD7860B782BC13EBF311821C12F0915901D074E36ABEB7F7A267DB';
wwv_flow_api.g_varchar2_table(16) := '1838833E53A513B0E442AA33B303C8FB0FBD193DC821011F9E6D329BCB4F1C8256447DACBDCE1EE4511F72D1EDEF3973740F2DB9EF306413014B0E093820190A2BBCC00205D6F1542BA2F753B2B00FE20EB867C91D991D969D18E839776C6F9F65397D60';
wwv_flow_api.g_varchar2_table(17) := 'BCDC90CD01A698B4E0C28AAC61F98D55D8B36476D71D9907B1EBD8EF41EE5B76C86601370C8CE10755EB64CDFF78CF92D95D67DBB75AD86AEC798396BCBC909B8009AB06276B7EC6E8C374779DCD6CB39256FFB36706F62D2764E3808D757A0B48B02EB7';
wwv_flow_api.g_varchar2_table(18) := 'CD58B0AE5A09721296EC6283E2E050FFFEE5826C1C705CFC2C4D431DCD59B02E56412E78F3E4CD1072FF7241360E58B7305647B316AC9BAE1C2F1FF226427EF68DA3071A6DC9E600C7B16F5EDA76A10656CBD1873C5948B6B76D9264A2FFD9E181270999';
wwv_flow_api.g_varchar2_table(19) := '85F535609E6C0E709CE6C11AD5D2B70B758E5A8E1EE489C94222DB76BF5B748F1F1A3AFE29D075FA505A9F5BDFB56B7380D9F4B85971E31C86A0256F80A08ECD423EECD613B239C06C0204162BC68DAD6C3964D73AD633D4FF14A7687D523FC8E600D31A';
wwv_flow_api.g_varchar2_table(20) := 'D084C61905BB8CD805E55D172726F3D885DA0071F5F79CEDFF4C3D219B031C3B59A3C2CBA38D5C014F1608B9BDED5EB801477B86839031733618421676A4BC2ACB23B0F23A5473C54E93A13ED324AFECF9BFF9E459C845397A7068E0B39E250BC6647390';
wwv_flow_api.g_varchar2_table(21) := '43023E3C5B7D56590B6CF66EB4CF4AD3249C4039CBF493178C5747BF19FABC74E409822EC7BFF4F2E042A75369F8E56F5F79E97CC83965C9F8176E477BCE1C7B4641C64E54EFC99309E6081B42020E3C3ED898C0ED789CA2A3E4FF414B560A8B2F75F45B';
wwv_flow_api.g_varchar2_table(22) := 'A1CF4B479E20E8E9967FE9E5C1854EA7D2F0CB7F97894EA75258A9FC38E6C9D9CC3AB1ED6387CEF67F9E29B9A76C62ABD11C60D66AB6E2BC8A6EF02C48D58F58F14E11878CAC84ED5836FFA561E0032FB7ECDAC6AF75D43D7DAC8C0F5C2F9817694A71F8';
wwv_flow_api.g_varchar2_table(23) := '276EB69528E626675AB2998F5909EBA52F0E9F549039570E3B7C847A854374092E52332A222043C852709CC4C4F8E49425CE78807B45017E868ABBDEA58ED3C7CA440BDD673AC4B17BA776E1688DE5C6AD64E2EEE24CE11B07FEFB1FDF39FDD9AF5CE4EF';
wwv_flow_api.g_varchar2_table(24) := 'AEF99A8CCA52977A7D6702F6654BD1E75D379D2FE413929BC68B81F8533ADC5C98F452E55A7D3A40765D37853A15A1781FB72D6B3D0AB9A8DFA2507D815E0EE38029B4D804CF782C49A752CA8A72D39E45D9BA1524ADCFE76B958ED7C7609AF9EECD173F';
wwv_flow_api.g_varchar2_table(25) := '9B4EBD24219514BC10A6006D2B0453D77A1E12F09139CF9DADEE9CA8E8DD203B5618239D40B092C1B986ACBA4D5C2F85AF4E54D6F8DB65F49FAB92CCA6833FE0A01781F7CC87FB4EF4E0F9D904C8566D08E9641DAEF679D14BAFC487AE991E742A69495B';
wwv_flow_api.g_varchar2_table(26) := '0BE48CFF1C8731DE7DC6CDF7A98CA7973C5FBAF9EE55E6451A47BD2EA48267EF43549B9A4348C081E756D42B10139F533A3CB4E4B6345EB88406E9F96D7C5A30A7A6E60053CF42E9DA9CBA2DDF8D1504D91C60E2580956ACD56A85403607987061C12B89';
wwv_flow_api.g_varchar2_table(27) := 'B1B434B6BBA66B653A9803CCEE19155C29BDB412341BD3404BAEC7906F0EB069D58B5279CA925BE178415CF5A050C7B686047CA4BC6A2BCA7C034D63BB083943EF3A5E9043023E3C2B058E1F751843661FB0CC676A0A85C58798410E093820746AF94AB5';
wwv_flow_api.g_varchar2_table(28) := '60DD4CB62F556FC86685680E3085B0922D380839594FC866856816B016C29D70A4771D83EEBA09B85665E4985C574BAEB562E5F99A80CBE551FD55C4213701578F746E0E0D390171466C9EDC043C17576D77E85D73172A62909B806BC33937979E42450C';
wwv_flow_api.g_varchar2_table(29) := 'B239C066BDFBB9028CC39D08423607D8ECFC3C0E38E7AF63C4209B033C7F73EFCCBB1A32E7C9CB3C263701D74B05093902DEB571C0CDA138A03155428EF686BFDF2EB6A91902122841C67EF222DD753DA6D0C62D38D0B4E6A99680820C51B72D0E596731';
wwv_flow_api.g_varchar2_table(30) := '756C023625C9C5CA21E414C49D692CE426E0C5C0988C577F919A901BE75D37019B04B85859F440AB1893172B6E29F14DC04B9192E9340DB464E3809BD3A425680385A420F397211C9371840BDD9C262D4176B1495282ACC764FCB171FCEB33D33F7B3267';
wwv_flow_api.g_varchar2_table(31) := 'C14DD3AD5EB73464CE8FE97871E58B900D067380CDD6CB6013235E94368C2450B4FB900DAE789803AC2B1A717946B67A34106DC91C93F346FE81BF7A23859936372D38BC1C83903BE07CA9703854B9F8ED6733444A021A728B99CED54C290109357BEA80';
wwv_flow_api.g_varchar2_table(32) := '30AA3C55B2E397C1DED0B805B36ECB0999CF57EF2554B5F06AB39016EBB4DE4B39666978F7BDEB85F2CEA63677E6D516E51914A071C0E69A5B7D4914502BA4D3823FD34DC80457C471D2C5CB6B0272633A861695D643E8C073D5F7F18E2AE59C30CF14F2';
wwv_flow_api.g_varchar2_table(33) := 'F22D640665CE47372CAC28C0F03DE5B29397F7F88A292E0B71BA61D9F2989D9214AE098C012FC58212587203E9868B792F9D1755F6BD1A791F40DE24D26AF865096270B1A2004F03E8E3A97639986CC57A01FE062CC04CBA45B998CF49CE294A02D7844B';
wwv_flow_api.g_varchar2_table(34) := 'ABFC41615AB627D2F2E5B6B5B2AE252B5D891669B5135244BE7128C9CDFC945C9A1993770A53EAF559B4F3384236077819FB302DFC2180F9DA5DBBE4C9B55B651AE72D76523E9C1E97BF7FFF0D7979EAA6ECB2D37215F74701EBEBABB7CA13AB36CAFAB6';
wwv_flow_api.g_varchar2_table(35) := '559249B6003EFEEE331480A10005284021C600F7E56B17E49B372ECA5AC4D392393B5DC6A6AAFA55F3650EF032A977F9635D599D6A93BBDB3A65125D6F2B0073FC546332128E035A1AE3F337EF79543EB9668B645369F4E2187BF161D0E0D415FAFBBB5B';
wwv_flow_api.g_varchar2_table(36) := '3BE5BDDC4DB975E35DE984FDA63132176266C7E6002B112DF79705CB2D48AE3023D300EC261C99E211FFCDE0F3212CF36FBB1F96CF756F57D63A857474C4525004BA6179C751F79535A3290E2D195D3CC1335DB932D5B1AD061F641CB0B6823A36FF3645';
wwv_flow_api.g_varchar2_table(37) := '73DCB5FDEE965DAEF74900CE2D80FFDDF635CA72391653093CB0AEFC64F403790B1F5A7D1269B3A956D9D8B65A7676AE4359098CDBDEEB2CEBDDB652F9A593DB34758951C60153F90CD66F89CD08260BA8BF7FAA0EB0C487336BA413F0F2E8AA9378990A';
wwv_flow_api.g_varchar2_table(38) := 'C7DC7323EFCB9F5FF9A10CE5275171D49CDD358E9BE13D3F9FBD07DEB72DEBE17CE1F5AF6ACA157C92E973D653C94E55D84CE9E6002F2FD545A4E149AC0B5EB30D117A57DEF1FDA951198203F6747A159C288274258FEEFA3A94E0EF46AFC8035652BA01';
wwv_flow_api.g_varchar2_table(39) := '98AFAE6CD87CD8A02CCD2DD418D4BA4568D510ED498CD31FBE3998E3A99A46A1A44FACDA207F7DD77639058FF9EDE294E48091DDF4BD89943C956895B59C3AD5F0C4A8643107D8A0D6D54538E86A2F4CDE94498CBD1C83E978713A740F3CE5AF6EDC27DF';
wwv_flow_api.g_varchar2_table(40) := '59BF4F7EBB6D8DFC1496FBFDE2B48C60CCE6C2883901D5A5558B166AAEFE91B560BF62F0945F9DBC2EE76EFD52395F2974C7F49267007415A656BFD5BD43FE66F353F2ED0DFBE52F3BEE955F20EE3D583C1D34EA6E649BB708627380236BC1DE7AF4BDB0';
wwv_flow_api.g_varchar2_table(41) := '607AC3DFFAF02772F6E615AC60DA9246374C6BCEC35AB9B0B1A625239FC222C95F6CFAA4BC048B7E04AB623F73E06DC718B239C054F188AA39FF1CD5289CA7B5B0E2F358B6FCAB2BA7E57B57CFCBB5E90965CD04CD29D50C40CF60AA944DA6E537BB1F94';
wwv_flow_api.g_varchar2_table(42) := 'C3F73F219F83F3F56E00F2220613B9687380D9B4A85A31EA45DDC35F58918D98FEDC04C42F5D3D2B5FFFF96BF2F2473F952B58ADE2984CD00CB4682E943C8479F09FAE7B44EE631EB7A0769F1AA2C3061F6216B0124FE3BE827250CB8DB0420B1F2F2016';
wwv_flow_api.g_varchar2_table(43) := '60E93573EAC39D26CFB912590D4B3E80CD8563B96BF2DCFBAFCBD77EFE7DF9EED5B7E4EAE428E6C79C12D9CACB26E8873AEF9167DABBE53CBA70065DBABAA8D797414369487D4DCB816009AC1D20383E72318232D98639ABB642A6A17BC4B175028B1C59';
wwv_flow_api.g_varchar2_table(44) := '8CB55C8BBE0968699C2791672FBAE227936DF2E6CCB87CF9EA907CE3BD1F2A6B661C7317E16871C36253EB2A5C631302CAC298A062A988087FC51230E18E40F8AF1626650CF0B85AF3A3420E4E5146EEF361D0A2F997CD382DFA085B830CF723BE0BDDF0';
wwv_flow_api.g_varchar2_table(45) := '2BF909EC05731F187BC348B313DB8B075B3AE55BB72ECBFFDCBCAC40EAA91441A70199C1FBC9B241F352A5D6F7CBDC4A567DEB59567A0E701F69E990CFC002FF2B775D5EC122C51E5CFFD1C73E2EEB30AF65D7CA654842FE002B55EF625E7B151B097BD1';
wwv_flow_api.g_varchar2_table(46) := 'D5FE59D77DF2CAF58BF2D2F855F93F28C86C70E52EEC0B6F6CED52AB5D7A41845A305E9C51C9D41F626984FD1AEC22620598B6C32E6718007BB119F07BEB7E43BE8471730280D7B676C826AC35832B003BCAEAC601F6CCD80772150AC16EB9055DEF1EAC';
wwv_flow_api.g_varchar2_table(47) := '5C6DCF76CB33E3D7E432163E7E3533A1163C3AB127FC30D69E7762CC25542E8270BB7114D6FFCEE40D05982B5CDC95AABB0D1B7C40AC0053CADE680B15877576A7B3B2011BF61C2B1938DEAA8D04804C02CE9B372ECBBFC252F7E0FC5DC4111AA7425DD8';
wwv_flow_api.g_varchar2_table(48) := '70D8BD7A833C0C6BE6353D683A57EC8A8B500E9691C675029FB32357E47BB95FCB6EC4D1B0F831287F567B6E88AC051BACD8DC56EB3BDE43E8E9B20B6677CC9FD930D0A9CAC03B26EE7300F34FBF7A4B3955DB706F14D31E76DB749AA8249E22C041431C';
wwv_flow_api.g_varchar2_table(49) := 'AD9E6BD30EE072EC4D635382FBCAA7AF5F927FC0C20857BCDA3155E2CE72DDE17A0DE1B79160D6821BD07A8A98A3E47574CBD76772B2B6A5BD6455B4C65F4EDD9237B11C79F4FA05198633B5C56E51BFC1DA9948CA99896BB2E5A30BB22DBB1656DC0665';
wwv_flow_api.g_varchar2_table(50) := '800F4EBAD00F569D8A32969F960F316E9F4119FF327249AE4131380F26DC3806B380EB2C0316CF9FC13E082B3C8D6E73FCF2FFCA967407BAD394B2B211403F3F3D2ADFC56733C011AEF77B0E912EAC3D0FCF8CCAAB1FFC5876C39BDE0E87AA1BBB45ADB0';
wwv_flow_api.g_varchar2_table(51) := '605A36BBF9098CD957B0D2358C69D31B70C07660DAB51E6573DCE5B31BA0BFC675C82C60E3D59B5B2005CD6E741A40FE190B1533B98F7087A2F7B4AB1B5DF7E35080561CA70360D86D13721A1DF85BB0ECFF04449D27989F8ED466A43B806E9A1B0D2C83';
wwv_flow_api.g_varchar2_table(52) := 'A53714AED7143C357C300BB84152202C7AC59F00049E7BF6E539609CCAF0D71753F38061DA76C0DB8ACF03380FE625427AE87A618056ABE1E2766C8359C00635EF7612A51E118E06C06B3E5AF9C37E1D16D235826360BC4EE3E577D5C63ECBD541C7EBEB';
wwv_flow_api.g_varchar2_table(53) := '861D0D3ED82C6054CC60DD96244FE2F299AAF48B3D3F18AFF3E9230B08C6AB021BF8558F67EB1EC94C3320A9A0B0CC147AE79452925DE9247CDBCD02860AD6430BC337331E259464573A095F6F7380FD4A1954BEF0AD8B5909F5909D39C0F5A85DCC0045';
wwv_flow_api.g_varchar2_table(54) := 'B1BAE60047B175CD3A95A67D358AE24879BEA61597CBA3962BCAD0A01CC359F0E04E6FE4C5DE39BCAB06ADC4D722B518E5D10E1665CA3038A8EF78D7557E8703DCFBB6D235D72E7A780D6A5E95ED5839C97D192A99B255BE8C6B6D6028C0BDBE055B4E02';
wwv_flow_api.g_varchar2_table(55) := 'D68BAD18FC8F9FA8B28ACD4F0D3250B2830C294B2553F2D5BD648D84C3AD64F57A4FCD4BF15252123F4B76B63F941F19E3AF5D6627C43C676047A3EFEBA38A087C05D3F27665BACAEB405695565FEB4E2D983E781E2CFB76F7994E97A5F3E87B95F974BC';
wwv_flow_api.g_varchar2_table(56) := '6EA74EC72343657A7D5D7E7420C344FEE6D8857C267D49E5F365ACCE6BF80A56BFFAEC50346CA8B28AB2EFB5179EC3BEDB8BA860D79CC6545FF29D97C3075D189DB8050BFEE3D79FF893EF282104645C8B50C201E6130315D87FFAC5C78B45396459D62A';
wwv_flow_api.g_varchar2_table(57) := 'FE3EC2EBFF2B4681928673599F71FE51DFD735526AC30720E8B8D2F96DF2062DA2949E273AE8BCFADA3F069FC15B95D7C1E4BA8EC17B0BD5379886E73A6F29BD7EC5936DE3172A23B614FFFD474F7EE575952D20DBCA621A7BCD8A348359091892E9FF03';
wwv_flow_api.g_varchar2_table(58) := '1CBBE6525E24301C0000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72351707250797182)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/js.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D00001960494441547801ED9D598C1D557AC74FDDBAF776B7DD9B5730DE8DCDD86E03B6593C10C12C114B226548A231C963A424330C8689A2288FC9F44B1E';
wwv_flow_api.g_varchar2_table(7) := 'F2121E1245488C2244C066E8044D26126232A31922CD12C0D8B4B18D59BC806D16EF6DB7DBDD7D97CAFF77EA9EEEEAD57DEFADBBB4FB1EA8AEAA53E77CE73BDFFF5BCE52B76C4C1C2908BC38C8D492467777903037403FC6CB30393EA3E87B84E27901F5';
wwv_flow_api.g_varchar2_table(8) := '1E797DE05E63BC6F1913740681C9274CC2F07FC5525E944BA40F7FF920686E4D9B73B72C30CF756FF73ED9B939F07B8220EFFA5331BEAB48B83CCB8B80FBF06B03DFF6FCC473A9D6A6CE2AF25F565339A96547CA98454DD99FA613B9279FB9A3F958F72F';
wwv_flow_api.g_varchar2_table(9) := '8364F7D74DEE4601B92C8077BE228D7FDCCB3DF2FAD565C6F83F4B7734750DF50D6644B444BB2A0BAFA22A8B472F2B2BEE68495C5BBE34DD961BCEBE990B927FFAEC36EFC48D04729940F458A1E6F3DE3AB9E5AF64AE648C9C3534EBFE90F17A26303644';
wwv_flow_api.g_varchar2_table(10) := 'E532D9FEE68EE40EDFCBBEF4546FB0B6FB1B5EB6FB0DE3DF0831B92C80BB76EEB4B1D7F73C3C01B1D8FEB5D75CD5F131C2A95C8F94D21BBC9C0DD26DC9FB837CF6A5EFBD3DB80E90BF7E03805C16C0877A7A00D1E47C0D5964C216600B39B9F59D46D90C';
wwv_flow_api.g_varchar2_table(11) := 'C4B83C8EB81FBA9CCD35B527EF4BA4FCDD4F1E0AD6BF219077DA67B377965016C0CE820B50CAE58D8AADBEE10D5D4B84C7C04B2418577943572CC83BBC4C76F777F70F6EE8F1BCDC6CB6E4B2008E086804E38979F599334E15AD27328259DC7A437D02B9';
wwv_flow_api.g_varchar2_table(12) := '2D794FD2F35F9AED961C33C0F509E6F5B90AE7F172C4E02E532EB86B818C257F7F7F602D7936BAEB390B7068B20EFA09317604E4746BF29E9C977DF9A9BD431B71D7B30DE4390BF018175D5889737017CE16E46162725B727B904CEC79EAC0EC0379CE02';
wwv_flow_api.g_varchar2_table(13) := '3CC682A75E831EB5E4B6E4D6200FC8C1ACB2E4390BB0B56067C6935B30133FD28825CB5D6F0D72D9979F3E146CB6EEBA87E9D504F75E7000F5718A196027B1FAE8DC75B91863C69394E6B90359A3EBE1FE6C2EDD9EBC33C8647FF4FDDE600BCBB43B0572';
wwv_flow_api.g_varchar2_table(14) := '50C720C70CF0F5243689106B9435634E470B222B6F588B21A9B6E4967C90DDF344EF9005F9F13A063966806B845609CD96E86B42770DC8ADC92D89C0AB7B90E72CC0A38659B47684032F46D7ADA92D7EE0BDFCF4C1E04EDCF5E33D3D09FBE240D1242B57';
wwv_flow_api.g_varchar2_table(15) := '61CE023CC6828B8FA109AD791193B34D6DA9AE7C36F3F213EF0E6FEB79FCF1DCA1CDC6AB27906306788CD82AA79671539E6A143D5D3BDA16556F7DAD5D03F246DF98DD4F5B903D81DC533720C70C70198E6F3A61D6E933F596354E5FBB501664BD41B47B';
wwv_flow_api.g_varchar2_table(16) := '57EFF0762CD9FCC0987AB0E498019EA5165CAA0269F7CC82EC8520A765C9DAB0D8F3E4FEE17BBA3D2F5F0F20C70CF0ECB1E05838E5058708C89A42C99293B7297777BD801C33C0A59A42F5EB8DF135C50FB24619B620CB57E3AE9D25B7A7D6273CEFA57A';
wwv_flow_api.g_varchar2_table(17) := '0079CE023C8A90AE4A1964450914DC8103194BD63C790396BC6BEFF08E5ABAEB390B70019310A6722C380AB4DCC208C81A5D2B26AF37DA85DAB52F735FAD409EB3008F71D1E55AB003B9A03563406EF5D7068960F7AE03B50179CE02EC30B1E7B82C3842';
wwv_flow_api.g_varchar2_table(18) := '74046416435A536B4CBE3620CF6D809D19C765C11180D985B2206B9ECC8A573A0479CFF7DEC93C60DDB5CA56639E1C33C04E62D19ED6F175C1A55684C302ED7120AF4EF81A78EDCB3CD8DDAD79B25277A01FBD5530C54CBC92128B570AD5E4740464065E';
wwv_flow_api.g_varchar2_table(19) := 'ADC9157AD5FEC5A77B65C902F9079A495712E498018E17844A52ABB6AFB1206B9EAC77BCB2E979FE4AFDB2F1250DBC1ED48F4282EE0A823C6701AEA6053B450564FD17C6E4F9A995266F763FD59BF926F3F04A813C67011E63C1636E1C1C153B87205FCD';
wwv_flow_api.g_varchar2_table(20) := '66E4AE976B00FFEF9504396680AB2BA9F820A8FA8B733890A446D702D9BF259F372FEEEACDFC6E252C3966806BE1F8CA8079541FED2FD02C25F2ECA13FFCD66AC607F5AE531ECA23B4ED56A305B9A935B94CBB502FECDA3FF89005593B513B5F79455BCC';
wwv_flow_api.g_varchar2_table(21) := 'E5A7980186FB5999709B00149EB9B63F85D5C58CCF33A813C6E0024D6E6CABA9709EECDF623CFFC5277B338F2241F694E39827C70C3092990D695411B5631FF8092FAFDD1FE3FB89BC97D0A650550FBDBAE77B7E76203FACADC6A5FAADF5F37F7D24B020';
wwv_flow_api.g_varchar2_table(22) := 'DBB97299AB6CE57F846536E03981471451EFDCE827A343D9C0BF70E1EAA031F97EBB7D4F595C2D966BFD29192EB93CA7C8284A24CFD6A3ACCB73F5C6E7E9B96B237ABEE0F5FBC9D44D99A1A17FFAC3D7BEFCE8C7BF7FD351DEBBD6771472514AC55CCF51';
wwv_flow_api.g_varchar2_table(23) := '804311F163C2A19C69FA6230F0CD407F90CFE7342DC5A98D5A7831C22CAFAC40F7829462712E91F03689D60A1D47BB769A20FC504669D4E730C0A19529E87A7EBA2515C862BD6BFDC2562B8816E4D2045A56ADBCBC4A3A6D72D9E1ACA76F499445AB5079';
wwv_flow_api.g_varchar2_table(24) := '0E038C049C2BCD075EAAC98A241814C87979C41A58B2DC8716B8F23EB6AC5994E5C77D26C3DE94F027E64156091CD4BC8A6449F0D56046207B5E73AB4C39E1E9336978F0AA1E1AEFA171612A98DEB8CF64B8A7333E37008E8A4A031E2CD96B69D36F0A25';
wwv_flow_api.g_varchar2_table(25) := '1A0640D54C15682E66802BC06135054C5BB506D9F5379608CC6F5F634DA31E2656B2D526562B90A3E28B69741433C0D546A282EDD50AE498BBD400783A81561BE40A44B806C0D301CCB36A821C75D1D7E36B86CF6306B8022A38C38E54B458B540AE80F8';
wwv_flow_api.g_varchar2_table(26) := '6206B8022A5851E48A205E0D902B20BE9801AE800A168141C58B4E00D9BE18195FB315105F4C8371D7C70AA8A0235D2FE702C8B013B0766D973563EA77944C7DCE83EB05850AF331C692F5E285EE634F31995ECC2E3AF66ED62F410B72BAB0AC09C831B8';
wwv_flow_api.g_varchar2_table(27) := 'EB0AE84903E07254680CC832B94A587239FCA96E03E0320518CE930B96EC9769C9D1185C2E5F85FA0D80E310A4B3E46676A1B0E412DD75C345C7814685683890D96AF4EBC75D372C384EBC1DC85872B9EEBA314D8A1399186915404ED48925372C38466C';
wwv_flow_api.g_varchar2_table(28) := '47480964934C9B10E412075E8D79F08838EBF3620CC8331C783546D1F589E5945C9502F294C44A7BD070D1A5C96DE6B546406E2F8CAEA7994235A64933976B5D95B420A71493670072CC8C372C3866814E496E0464374F9EC692A72452FC8306C0C5CBAC';
wwv_flow_api.g_varchar2_table(29) := 'F41A63DCB5FE65EAF12B5ED14156631E5CBA9C6B5A738C258F03391A831BD3A49AC2545EE3586E92988CBB8E80DCB0E0F2E45A3FB585E474960CA30D0BAE1FB84AE66402C8111FDD88C1258BB5BE2A46DCB567DD7501E48605D7174EA57383BB0E6332BF';
wwv_flow_api.g_varchar2_table(30) := '6AF4149BE37C3324263D29BD7B8D9A48A000B2F691BDA4065E39F9E7EC702CA269001C8B18E3203276E095CF34008E43AAF5478310CC6B3F2DE12725CA65B0B19255AE042B521F9433B150AE898B86FDC258714C27E4A48846D74DE5D48FB61B6DCBE547';
wwv_flow_api.g_varchar2_table(31) := 'F3A28C4CD6E64CF82DB55EB4ED72AEAB0A309DC565B4483208C709950EF0DDB1AC328674F06CBAD4A402491D4C235DA27EAE50DFE545CFAE28F5344EB589E57EF29565F4DE85BD1E56065F1D23CF25CAA49491D6D995E7195132A38C6859F25D9AAA1E7D';
wwv_flow_api.g_varchar2_table(32) := '649A3B553D573F8E735501065C04724CBDBBA633DF0B7289FCE592F222159A6E9F852A9FABFE17CC2C0AF539517FB1EA2E150DDAD1ED48E29A8E0252BFEA1D1382FAAC9D1530CF284F9B0BF57C990A36EB0CD0E4411BF0CFABCE291DD070F92B54B14DC7';
wwv_flow_api.g_varchar2_table(33) := '78855071DB3EF5FAF4F0131DAEAF28E12A3D689FA21E75E34C5505180B6D55C71E6909420B8CF444D9E69CC2CEC98C67B050043F5942F3BB9A03F3A03847D02E51FF8A047972D8B30247B8D0E080DE3515EE15FD55AAF78DD6C0DCD214984E9924800DE9';
wwv_flow_api.g_varchar2_table(34) := 'D94599E327839E79EB9A673DC9AD2A0728280E606F52F9FB950798B405DDCFD4D67931040DEEA3893258EA0AB98B7BE68F7ECC96FCB3E2E3D475FA19A555CEB558AE4EB2562041DEAECE7E677DD6B4A9E359DDE35A71B5E964608E5C48987F389AB482C1';
wwv_flow_api.g_varchar2_table(35) := '8D03A64E36511FEB5B940ACC13B7E6CCAAD6BCC9E4F4940285FA1FF525CC33AA8FA274A802E000EE1911D257AFCCD34BF366C7A2BC592980E78B4E5265103856052F97873C73F472C2FCE26CC2FC579F67D6EA79B30A7CACFA8F7504E6B155C01B265FFF';
wwv_flow_api.g_varchar2_table(36) := 'B8EC9B5FFAE6EF4FF8D622C915199B6089032FF39D9B73E6816539CBAB2F5AC3CAFBD171DFFCF69C67364906284F2553D500064834BA59425B3C2F301DE9409D0E01D677E6942F2D5F9837DBBF08CCAB12EE1614A0D07927B0B312CE4302E72B0BF266BE';
wwv_flow_api.g_varchar2_table(37) := '1422AB4FFF390569524FCE0F06B23AE517BE0A9C56C5D30267ADDAFA738173D792BC69D33564ED77CE0AF4B1404F7C753609FCB6BCE95A24E19FF2CDB39FFB462C59777A62409E456D2E94F718966235EB7AA3F8587F3A61CE653DD3A9FA2814BCA23403';
wwv_flow_api.g_varchar2_table(38) := 'BA5E219EBA4460A9FA3BACBEA6D5C7D3FD9EF958B416A8A048573CC14B75923A8CCBC35A0625F46B7251D72498411DFA20A8B92277375F02D9D69937175586CE232C5DDAB3B51D656C5D1058977855F5872468EA8FD2B11FACB3E501EDACDA592740FF66';
wwv_flow_api.g_varchar2_table(39) := '7DCE7C6D794E564BDBAAA703C5F025F0842C9133EDC013E0DDA410F2C7EB72E6AF56E4CC253D98A7B2BF1230472EEAEBB47A7E4D1E62406517C86D6F97C211D3A396A2EFE49933CABB4BDE0A85A0ACEDB3DA3D78C137FF2D809748219045A55394AFCAB6';
wwv_flow_api.g_varchar2_table(40) := 'A54E3BB0001A770588D191301ABEA15D6E34ED9B8B121056810B5371734585BB24D0F57AAECF390B207D6D50CF10A68AD93CF2490CBE88ABB8E5EFAEC999AD4B72262B60708F226DD32901F6D9D584B9A676162816AF165DBC4A5695509E1659E8EFC9EA';
wwv_flow_api.g_varchar2_table(41) := 'CF2A2EFFDB19312B5A1F28046C93174889067CB74A6136B5CB139D0F63B38A585EE9E8391D5DA24919EEA983221F9277D29B5996EF1B0B602BD6F08FFA6B13EEE392AC212797BA48E0E1AA9749EBEF567C7D5EF178918482D000F17381F39884B958D6C5';
wwv_flow_api.g_varchar2_table(42) := '272411569F8058A27A94194DB270E5103777DD24972F4072022DA3FA4D0521FFF233DFBCFA79C20E7444C6C6E97B65897FB23A6B367486DC61E9C4E98765F97B2F7BE60D0DBEDED5F92101BEB4251FBA6929E41AB9F43BA535FD2234AF00BC2285592FD3';
wwv_flow_api.g_varchar2_table(43) := '592F7E9352BA61B59F92A738732D61DE148D6528B713C228E315B942C6D549133A14C64F04796928B440063AEDB2A2DB35A00135629A6466633183A53BE4BEB1AC40E683955D56BDA404174D78878BA2B34EE0DCBF3467CB036EE83102F386C07D4A839C';
wwv_flow_api.g_varchar2_table(44) := 'F70414EEAB5907D6F88FE73DF3AF1F27CDA92B2118B870DCF58AB6C07C6D61A8440704F2A77A8EC25187E326C5D76D3A4E0A608C15819E537BDBA488372BDF71C7F9A8AC77BF06724CAD5CBEB22B9AAA07B084124D7CA91E41E1A64E292661BD082C298E';
wwv_flow_api.g_varchar2_table(45) := 'D0FCBBB5147B41424BEB1E77BD5DB16CADF2A903FA6725EC21814CF950586103B8E7FD2A7F9F80592EAB7474B1A0535712E685D31AF5AACC6D72CBF35597392F73D23F12D23F1478BF953BC6E2A0CB202FAD7A1B3BF2668DB4E1B8BCC2A14B611C4661F0';
wwv_flow_api.g_varchar2_table(46) := '0CEDA2B359562C2F6DF940C18E09E03BC46B3B5E4965284B1CDEAFBA28147D5091AA24355DA514A230D258E868C3CC0F3535B9AC7928D69853CF6F9E9F37DBE4A64FEB3A29B19DD07987AC7AA1048612609147640D9C9D353998794E5A2D57DF2250F44F';
wwv_flow_api.g_varchar2_table(47) := 'D684236DE51D91800FAB1D0638CC8B19D54B17CC80AEA9B649D2E8559CC5A3301A27137A8B648D6BE4591056AF5CEC79593F0A6315406EFA5629D36D6A0B9AE4B100C25802E54081191B7C29257E5B0AB654CF1C8F2257F104CF3126F566C6496AAC84C5';
wwv_flow_api.g_varchar2_table(48) := '7DA4CE9FEC4FD87969C65A45E8A67165FD7293CB044897DC33D314D215C5EDB70516D6323EE1D671EF4B65F1CC5589759463F46BA73A7A4C110ED7799E8BA45D453B2105B828378A8BE61066A65DEE7E89009CAFFBC302F7B840E61940E964C70DDBD4DE';
wwv_flow_api.g_varchar2_table(49) := '051566856EABAE974BC17846A2AD0FA538EF8BF63C00B6B9D5F9E3FA18536BAE4B3323474771856724DDF72F69054A0282025679AB2C00B7FC6B3DFBAA62D96A5989A37E4ACAF09BABA11B1DDF524EA53A94D92E40501E00020C2C09C5204DD669C0626A';
wwv_flow_api.g_varchar2_table(50) := '75518A601750C2A24243F35F29186300165FFA4470BC9B66BAB459E1E0AA687C2197B04DBC2E10EF8407FAC27861BFFA37AFD0363C552B4DD6D732DA06B299A6B0ACB5145579471A7E4196635D9FAC98C1CB9D12DA15C5BDBB15033B9D7B96D00E4B58C4';
wwv_flow_api.g_varchar2_table(51) := '59843731C9729539D6BAC3B6A2DC4D760D39F2A3CFB8037C3C010B275871AF62F519791D78254C30F0C325335FBEAC721B157F59B841A9F0229F694AF68E947261CCD29ED8F78939313789888A4BC462D6A77F258B3CA918C587D6B302AF55310F41B185';
wwv_flow_api.g_varchar2_table(52) := '739BE22F02837A9FE2E35B72CFEB0B4D8D8F6774489F273383123CA0508C011D80B7CAAA49CA1EF106DC530645C3BD7708108073897CE6CACCC3519C76DD33028FBA69146D959471B55CF95AB5C1D489F6E08D83D87F54DEA345CC61BDA3D45D2B953B23';
wwv_flow_api.g_varchar2_table(53) := '8FEA2475389A14C5741BAE3C11970EC85271D34C4D10188C11C7FE56F3D29B35C841D0FCCB28C4EAFF93F52C9E8273DC328B23E7E40D985F43CB5A9F1464B5BC42C14B5B569CA0790EF64CAFD648A13A358277E050BF4FAB6CEC600130BC9E57B983F238';
wwv_flow_api.g_varchar2_table(54) := 'ACA01162184D2F11ED0D2D1AEDEBCC5C3DAFBE01F265B9E77D2A8B75531F807559B5348598AAD6BE6D0821927A359A3EC708D5BA37ADEFCA2D3FA05528AC9958C8DAF5E18B5AC4D099E9CDC4140A151361EAC562880318616FD4406D9D26ABC4518042E0';
wwv_flow_api.g_varchar2_table(55) := '9069D2358A7150F95B150E585E4439502AD2970309F3A980C24593D7A1E38073D3E295F93B6BE39B64B9D49F276D61F4CE3228E38577E59D3AA1A5C32995255C853F750130B1EA7649BB57A09CD008154130E0B28B1E5AAC672ECC3FE5C8E8166B58A57B';
wwv_flow_api.g_varchar2_table(56) := '809B4C58D05A275AFB99CE68AE4C0C0414064EAB34F8F933AD4CFD5AC01FD588564D581A4C6FFEF39A317FA9E7BFA3D52FA63780867562A5BD522ACAA054B87162E941F1724C6DC003072C6E5028D9288FC3350925C12B7D2AEBB7EE9982554E8E972A37';
wwv_flow_api.g_varchar2_table(57) := '3BB6394041686CA81F2EB83E00C4EA16CA65DA78A62A2764354C5316C0F5A4C20AE7A66CA8FF46E0EE3B97B06BCB5827F353E87C5300BFBC366736C94AD9CE3BAD3685A1F9BBC579B34BDB98EC263155833C6BE31F8B9F5F28861212E009F7CF028973D3';
wwv_flow_api.g_varchar2_table(58) := '2C60A008D421F6AED0FC9DFE30A767BCC0E206A36F7850735575CF6ACE861ECE354A883114260C2C9610F6C92A1E9225AFD1A814A1111F112CF3D8F7B49B7359520260E1326582EA6A81BCE70BDFDC268BDAB22867720282CD8616E53FBA3267B6C8339C';
wwv_flow_api.g_varchar2_table(59) := '533BB8D21629D14A0143EC65B301EF314F032656CB7EA26DC3930ADCAC64A12424B16316E9CF018D8E59C0B8556E194B676381227670A7E79F6AD08857C2A5937856B8B4F7D5F82351552FD1393AC9000621D86544DD93CFAA122B4C7B25D4638AC55801';
wwv_flow_api.g_varchar2_table(60) := '89334B7DE7948FDBD53F5B353258B1032195A1A85B92841A56D62E5A9FC80D3F7FCC37C76485FAC7EB343A667D19AAC6AC95B5DDA3CDF81DB7E4CC9D8B73DA49428942DED864B8A481D5ABC793E6C772B12B89A9AAC34102E845A2C5683AE435848D3EC1';
wwv_flow_api.g_varchar2_table(61) := '13772C77329DC34360F1F4232C654954ED8F9A8E33A91753253D42002C01DA8503B93FA63EC43BEBFA54AF45D7B8CD835A861C94C5B64AD04D2AC3C1B4E48004CAEA961336B1195A6C0152862D39E0860B6225AFE7FCAFACEC5F3E4C9ABD677C2B642C13';
wwv_flow_api.g_varchar2_table(62) := '1EF00E6C21DA6D449DA9C37C9601DE7159DE0B1F25CD0FCF24CC72B58190D00B00E250488D8CA6E195AD43FA12BA750685D63D4B519D7BA67E2D924410679A5A471120AB410312E667725BAD5A36A234A366BB4FAB6BDEC4582F21ED53ACFDAAB60B59BD';
wwv_flow_api.g_varchar2_table(63) := '622181BA7B750F68AC36B11D07E36734D039A5112A1BF5CDCA38235A4C4F8877D4018835729BAC7A1D17C87FA0387B975ED959A6B56E5E1942B14894ED971B3EABEDBCF715065ED72B3B4CC5568B263A039D42515D85092503FCF7A44087E15521859D31';
wwv_flow_api.g_varchar2_table(64) := 'FE6349F5C079DF7C20AF4338A16CAD52CC0023AAC9131ADCA9CE1E53A7FF59C266C04302B4B30208CB641D9777A9CEEBFE59B9D68E027794F95C2E933569DC2F2093F69C4A98F9DAD7C53300169B065813734E5CA2FE1FB16476A49E51D9751A786DD600';
wwv_flow_api.g_varchar2_table(65) := '6BB9A6606C4678B266E6DE6745FF8846D2EF4B69B03A5EBAA3FE64E0D23C7C2C103FBCAE03AFED7AC10B3ED0049E9F97C2A84B96575C3A79B54831033C7D170095E9C6BBB20E044752E8D3EAD1A8359147B94F25F07E8D42110C8262943D7E247A54605C';
wwv_flow_api.g_varchar2_table(66) := '153DCAA340008BA2302D2AC85AB9617CE7ED10B605798DF5E7F210033AA00B7DEA5A3E7443BCC5D3A054581ECFA74BD038215EF927A69D470068FAC45C1B3E6A996206787A71D05940BA59ADBA92E421CCF10940164632271338EE8FB73EA80E3D007123';
wwv_flow_api.g_varchar2_table(67) := 'DD4855FB0C8B038C85D0D50108D4737501071A583E033EAE396692B064F88826E8A038B54E31038CB8A64F9440D8D1349920C7833E99C0F1028C5A5D9A8C4EF4194527038F7CE7D2293F1D1D9E8F4FE37975CF8BA5E3EAC5798E19E099756926A5665206';
wwv_flow_api.g_varchar2_table(68) := '41CCB49C139A2B1FD10BF7A8685AAEA2A3E9EEEBE98CD78A314D26B618C93748152D819801AE675D2E5A363744859801BE2164724375A201F00D05E7C4CE34009E28931B2A2766801B83ACF2B5235E199605F0A19E9EE8A82ADC592FBF87739B825B862B';
wwv_flow_api.g_varchar2_table(69) := '48619C8C8B964D590077EDDC69D5CDCFC195A6916EAFAC68361A15AC049062418605991A27E3522554D64287D3AE9C7E2C9460D51EE6D8AD1BDDC32F95AFB9590FD9854B73013245084EC6A50AA42C808DD969DBD5CB65C7B4D2FB41AA2DD535D4C73B86';
wwv_flow_api.g_varchar2_table(70) := '8D548A04B45B9A4FB7A5FCE1BEFC078944B3644A0A651C5E17FFB73C2C78E118CB557AF8B5816F7B7EE2B9546B5367F16C346A380964AE0CF6055EF017FFF3C8BCFFB0791119BB32C59CCB039896220C3CF2FAC0BD0AC5DF5266A760D72FB5CB0AF1C5F4';
wwv_flow_api.g_varchar2_table(71) := '635697CDEBC5308D62242CEF92363F7FF2D347D36FD90E45645BDB0EC24823C52B819864FAFFC8629CCDF62C637B0000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72352098809797184)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/mov.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D000018A7494441547801ED5DE98F1CC775AF3EE6DADDD95D92224589120F59B4299289143BA2E5584AA408098C18703E242410241FF325DF62040E102080';
wwv_flow_api.g_varchar2_table(7) := '5608225A56E27F200910C41629730D2470802486635B1162478EAD8394A8C3140F9192C36397DCDD99D99DABBBF3FB55754DF7CCCE70E7A89D63B945CE747775D5ABAAF77BEFD5AB573DBD42184841202C0364064A622698B137C2381A99D83330411058';
wwv_flow_api.g_varchar2_table(8) := '480109FFF8FD2F1F093CEB4BC899C6A5DF33F1C6DE9ABCB6848FBEA71D2B3937959CF8BB830FFCE5874170CA11E2986F59428EC7647383A2E5F6D2701CDC1FBDFB95DF0B7CFF1F26A7D353E4CE2A705765842D37B2325E4E136A56A6318FE41AEBEABC78';
wwv_flow_api.g_varchar2_table(9) := '5996A95DC3F40449E197139F79F7E2F13FB1AC63977EF8C319370866BC8D02729C2564474729088E3A9635EBBDF2CE9FDEE358CEF7A6B78E1D5A982F54024BD816B84D3E6A7EB66E489762D3EA3CC051D5D7C7083B5D5A976CBCD3BA6E54539DC1EC0481';
wwv_flow_api.g_varchar2_table(10) := '9F70D32B53E35BB39572F55557047FF0D0BEBF90203FF9E4C600D9EE08D186C2B3B32AC3B5EC7D98BF3EB5B4B02214B8027403801CD41D99B7FAA3CAAA7C5DAFF118D5ABA7D9495D5D96C2C773CA5E000B16884AA59A9FDE32F65855582FBE77E9857D4F';
wwv_flow_api.g_varchar2_table(11) := '3D35537DF9E5196723CCC91C68D7E9E8D1435406E1FB960D5BC7B9989A07C68DC227ECAAB01C1A8C855BCB223B99FEB54AE06F28907B027876F6ACB4BC8E6343718970D7B232B88A3E75586AB4585A2A7A00F973E5C03BF1DA07C71FA4260B710ADE3586';
wwv_flow_api.g_varchar2_table(12) := '37A2A92780B50673EC98FB942B3D028C80E98D123800C10C6CE535584B4B2BDED464E6B1A4639D78E3FC5FED87E3E5BDFCF2B330D7A309724F00475CE284C67FA3911A2D8D9C6B013A2C35E7676B11206727338FBA76E2C5B357B426CF8EA4261B0338AE';
wwv_flow_api.g_varchar2_table(13) := '14A30173D44B6A30A513FF390C09323519E6FA51BF6A9D20C8D4642108F2C8C8B11CA0318047457B2358A3B326A0852017BD896CFA51AF6A7DEBCCC5E70E2890476B4E360630D79FA39AA406AFEEBC0439972B7A9393E94F63697F32027974CCB5318047';
wwv_flow_api.g_varchar2_table(14) := '67065676388E67130DD6B76B9A0C73FD88259C9103D918C0A3A4BF75D30996492D34B80EE41C9750D9D42336407EFDDC730769AE67E59C3CDCDEB5318057EB85E6CF901FDBE3004B5934D71300D975AC6FBD73F985C3C74600E4F686D71646757AD1568D';
wwv_flow_api.g_varchar2_table(15) := '8115EACEDC48909738274F650E7BBE7FF2F4077F3DF4201B0478607075DE70F7B218CDC9D9D461CBB62390678F0DE53AD918C0DDF3AC737C7AAED19D06EB6623902733876DD73DF9F685AF3E7CECD82CD6C9CF5A333333C678AA1BECE538549DE965201D';
wwv_flow_api.g_varchar2_table(16) := 'D56D90C6DB78D1ADC812643B9F2F56E1781DF6ADE0A5372F1DFF15CB9AF10F1E3C3B54201B03B837A568C5C73EE4AFED45B7EA04E35F4E6EB1589D9CCC1CB00371E22C40A6260F13C83D3DD1111F798352C46F0DDF39A55177B83711E7F2DF5922C85399';
wwv_flow_api.g_varchar2_table(17) := '03086F9E387DEE6B7FF8F0FE3F7F3D080E81F28C0D930D111A5CEA6D78B17E8F54244B83CBFEF7C27E65B6B80DAE4086265BAE7FF2EDF3C71FA5B97EE619403CE039D918C0914AC4501FD253CCB951EA850391A0C4404E7F121BE3278605E45E86173169';
wwv_flow_api.g_varchar2_table(18) := 'C4CEA07175A90B27ABAE7E785103393B957E107B522F0E03C8C6006EE05933060C6DDE1AA1CA4EFA5D03793C9BDE4F90CF5E79FEC820CDB531803BE1C2B09535A4C17A581264C4AEAB04D9AF062F9DB9F4DCE70605B2318047CAC9D2508447831AAC29D7';
wwv_flow_api.g_varchar2_table(19) := '40C67EF23E3C1074E2CCA5170602B2318037E876A106AC9B630DE46C36BD57E041BE41806C0CE0B863DA0D37FA59A7CE5FE83ED0D14E9725C82AE295DE6B05D593A72F3CF704CD352BF3F750ED10E9A58CC1064609E218CB0C722046357E2A235E79CCC9';
wwv_flow_api.g_varchar2_table(20) := '13D9CC1E3C1972E2CC85AFFEBA0C803C8B4DD67506D9E0F0EAF4223EC0E13BEFBF2CCA88171D2F3C19721FD4FA9B672F7FED0915E57A064FE4AE9F261B0B5512C5FEF3AD4BD9198C2CC6E6E4D4FD30DB2F4293FF0899AF006168321655A1E9EE72544DAB';
wwv_flow_api.g_varchar2_table(21) := '19D360F26C307C6B3AAE61CD5420E74AD5F189F4FDF0DE4F9CBE74FC379109DD9859174D3606F008E9EFA0C1972017F2A50A9650BB1C617D03BB50009906D0BCB93606F0883D0F5E07B2E140471DED16173076969BCF152BE3E3A97BC1BB6F9C3EFFFCD3';
wwv_flow_api.g_varchar2_table(22) := 'EBA1C9C6001E65F38CBE731A948907F9C117F36A1FE6C7AF1BCFF57D7D8CDF0FF300AA6C467EF187B642B8B95C49828CDFEFFDD35B179EFF2D6A32E7E253A78EE26D03BD2763008F64240B208489669328F3207D099ED47D98DF9817BFD6F7F5B1C93DB4';
wwv_flow_api.g_varchar2_table(23) := 'A0E8E35E98D86E024F6B32AC792FF0FFE6D98BC7BFC07B7C70C0C456A33180155B74BF87FCA881A56F03C9C4C373782F0736751DDBB72D1BBF5CEFE3C7465BB6E32CE74BE56C36B3039DF9C7F7AE7C5D82CC6514B43D12872ED86A7499D445FB83A90296';
wwv_flow_api.g_varchar2_table(24) := 'D14C12542FA83A79A8902F82FC603A13B5BA94CFE51DD7B91BAF93F8FAF77FF695734FFFEA0BE767678F4209F9405F77C918C03D8959777DEFA996EA2F26BCA09A2A7A2567B9E0E11D325464DEA18AC78FF1A69ADD6B9617AFA3CF5B950BF303918041F1';
wwv_flow_api.g_varchar2_table(25) := '60411E82F4DD875AE7D56FB0C3776568321D1C8D01DC419BC35114F8855A6CA5D2898485B7502C2F5745E0C3264A90D94D2506F51DD679FA182F17CFABAFA5AEF47D7DD465D435FB934CB8A252F6AAA21AE0ED02BD2763008FA293451CC9541F335D2269';
wwv_flow_api.g_varchar2_table(26) := '8B31E18AE5424581CC0763A9584CE47F937366296858A8B3B4AAAE22042312D07B86EBA5E8E9D76474463D2A6DCCC91AA5EDC268F8E0A4622CD72F1640B632635466CB02A3E982A90FEE353B079D28BFC3F35575C336A4C4C4A426FE9A8C78BFDB3D3706';
wwv_flow_api.g_varchar2_table(27) := '302572D413B53991B20540167C67476D71DCEF811964A63180231BD66F6E186E6F584036342C8300C7EC8AA1CE0D8C8C06797C409A6C90950601DE303AACE40A2027E178650605B221E936063085CEA0E0191A5E6F64E4B265C4413606F006D3DF9A648C';
wwv_flow_api.g_varchar2_table(28) := '3AC8C60086975F63CA463BD1208F49736D0FCEBBEE82B1C600DEB8F02AAE126497C19071174B28808C88D7282463008F6224AB6380E85D6B909D75D46483B2630CE08DE76235877F952633C37432680E0D026C7A94434C4F6BF204CCF57A6AB201161803';
wwv_flow_api.g_varchar2_table(29) := 'D8A0D01918D6FA93909A9C08E7E42106D918C0EBCFD2216C019AEC12E4B1E1D5646300DF114E56331923C8A1E385477E866E09650CE051DD2E6C8659C7799C93A1C9192CA1860D64630077CC940D568173F23082BC09B041411B46908D010C01DE4CE0C0';
wwv_flow_api.g_varchar2_table(30) := 'B0816C0CE03B6D99743B691E26908D017CBB01DF89F734C88C5D0FD2F1DA04781DA58F20739D3C48EF7A13E0750498A4B526F3C990B635D9A043B309F03A031C816CC9C77FDA02D9A043B309701F006E0A729FF6938D017CC7862A3B1090002F4FC28F64';
wwv_flow_api.g_varchar2_table(31) := 'F0D000CCB5DB9F87068C017C47872ADB0519A657395EFD03D918C0ED8E71B31C7E0B25BDEBFE80BC09F000248E3E541DC8584AF1673235DF6A18BD68837D1A00CBFBDFE42A903127137409720DE9DEFB654C830DF6A9F7518D080509321C2FD755E69A47';
wwv_flow_api.g_varchar2_table(32) := '5FBEC5D2DC008C01BCA9C1DD81A27FA34C70C7E15DBBF0B24D3E926BEC07E09B1ADC1DC0BA16BD6B879AEC2644B5EA0BBF6446658C01AC3BBA79EC9E03B525D404404E9AB1D59B00778FC7BAD4949AECE00D0E99F01D0E3DB6626C0EEEB11F9BD5430E70';
wwv_flow_api.g_varchar2_table(33) := 'AA23C8A6D2906870AB11B53BB3B75BBF55B94676B6D3AEA6D55896F98D798DF46F7FDD5BED7ADAC600D6C3AD27DFCE950D76347F2D6320F8FEAFB5E6220649398CD56C69ACAFCAAD65B4F04A34F94A1DB6DB0A2CDD264B4423D7E1DAA8DDD57D6A872326';
wwv_flow_api.g_varchar2_table(34) := 'CB1803B8DBA10441096F9B5B0EC7A4A928A6D9D638DE82C3B9286262FDE0B1A48000787E0ED97CAD14C15365F98D77E6E093C4994A5E5080F92B85576C4BD3D5E78008ED592289A3AED7F89239BE9C056DCA17E35540837D60144A1FF9EB43F45B0A5D63';
wwv_flow_api.g_varchar2_table(35) := 'DDB0E93E1E8C01DC4D9FC918C79E1229677758BD9EE115EF1616FE2B607673AD23B8D4FE7462AF0492D79126E33585FE5208BE229F74EE467BE3121005AE1628DCC7C447CDF3216C557F019F39D01C9342125911825B96E552EE2E9174B70BD799805825';
wwv_flow_api.g_varchar2_table(36) := '914741CB8B52F53A3E57704D019BC0F75A1648F56DBDBE0704B0D29820581153638F89EDD9C7258324573852DCB601DCF5DCAB62BEF05D5C8EABCC5A011642680F004EA47E49DC3BFD45009706F3A9C50A34DB76C55CEEA7622EFF5DE4B9101221EE9AF8';
wwv_flow_api.g_varchar2_table(37) := '0D3195F914406CFE123902ECF9CBA25C5D12CBE58FC4D2CA1BA2ECDD00ED2C1B94E026DD9DA0F3B8184BDE0770290078A57738C5906ED55B16F9D287E8F77F8B52E523A9CD91A59064FAFA352080D59069EAA851E9C456308F32AF3498BAE4DA293199D9';
wwv_flow_api.g_varchar2_table(38) := '2F1696FF479A706A9332C30410C179393F0B3191FE2440BE17A0D59B43029C7094B62AC803917426453AB90D8241D3DA2CB17D944E09313D7600C270505C5BFA9E2894DF0390E368A3243289FBC4B6F147001CB4167DE66B0F398E00ED733A4840A333C9';
wwv_flow_api.g_varchar2_table(39) := '1D10809DE2A385EF8862E5A2AC3B284D1E18C064AF624E055A53924C9200D31C836115302C93B84B9ADF7CE90D1426C0844A81C0B934E1DC0570EF971A59050DFCC99AF03E4AA13E354A3B3EACEBC1BC7A5E51E6EBB66C590774C357DED10A1030CB7221';
wwv_flow_api.g_varchar2_table(40) := '600F4000BF282EDF2CC0EC7E1CB68F36D047D2AF780509BA8D79DBB5C7D033186ABF8CBA0E046FAFD8917D527C74EBFF5096799CD3FB6FAE0706B0868ADAA8E658E65013422D02B3A80D13A97D3079A77145B0F45C0C56061508C01E08C076C958052435';
wwv_flow_api.g_varchar2_table(41) := '4A9589682AAB00E2F21E992FA0FD36CC76D9CB89C5E5770052459AF87462A7184FDD038D73655ED5F7C418ACC396B123E2EAD2B7514FD15A295F154BC58B30E31F02503A8836FAB95F6C9B7804661B9A0E90497322B55BA4DCDD28F7AE706A4E1B8AF731';
wwv_flow_api.g_varchar2_table(42) := '190398D2DB7D8AEA56BC2598BF9470A5C6DA60F81E00BD0D4ECF2200E25C4C2100D8D492D427A4E6C8B94F329A4231899EB4D214B6830FFE5BB683F9328F79FEDF44054E950387881EF4DDD9DF1177653F837317EDC0EC43E0C653BBD0CE34FA80B9B972';
wwv_flow_api.g_varchar2_table(43) := '091A7D19A6F74390A1D025E4315F7A0D42920AEB3AA8E64B93EDDA74B4A2F175CFA3EE6A6A95E8AE76AC56640A63996B9DEA71EB23D845B3E7F9453098FBA355CC67DBA1A57BC0B032A8B120E7DF3280DC0EC6EFC6B5B2051580E54173E8F41094A6A92E';
wwv_flow_api.g_varchar2_table(44) := '9B17E8B59506C53179AC787362AEF05F006F5E6A316950586849E8EDF3AA529D87F37405D7132261C38B06F04967A704B458B98E237D01D527D6450D9219583206705723201F645227F44695177B0B2CE23CE74B0D9D483DA0342A74AC9479DE279D3332';
wwv_flow_api.g_varchar2_table(45) := '9D1A5DAADC90CCD5265A53AE3FD61A0C9B25C0F082E5874ED97698D70284ACFEE5EF5CD3F2A3E666BEDE7042B6E9055886613D5CF1AE814602C2883FBB106A3EE7655AA332964D6A2DDFD0767DC7D6EDCA9889EEA6874AD1945AD1C4E34DE7D2E12A414B';
wwv_flow_api.g_varchar2_table(46) := 'B269824AA66091044D756D6DA63967BBB8FF0969CAD96E054B93029626E9C4DDB23CF374527A1ABFD2E738A203044D9A741C3D4C03096707DACAC40A61528043E707B42A9CBF95F9779D69F48C01118825009FCEFC323E07244D7AD814BC5B85B731CF5F';
wwv_flow_api.g_varchar2_table(47) := '4519D26B356DD43565FCC218C075D6AF8D6ED6319E38E27915BCA71927169625E7610A3F2D52892DC8A633B51DCB8EBD6271E5676013D88A80C538D6A12A5930A937C40ACCA6657D5E3238BCB1FA505322DD3AA04574CB6724CCA669F5A54345C74D2DBB';
wwv_flow_api.g_varchar2_table(48) := '18A172601D6E62FE9D07FD14F2393D6C11BBA67F170245D3EC01E03484222DDBD36BE19B85B7C4CDC22B4A08608D08F8209231806BBC6B73142C2FFF721058A013359AD25F8423B35CB9265258B3E20F2980812938540FC2737D130C5E06D89F4514695A';
wwv_flow_api.g_varchar2_table(49) := 'F22CB0AAF0B22F490788F32F2D413C45D4EB73A9B50E3475EBD8E372F9E440CB32C95D7269444DE534C0BE10D0C5E23BD0EE0240DC8249029A0CD053EE36E91F7089C7E4FB74FCE8432C21B8F213043ABE4F0381362679579619C49731803BED3C61889B';
wwv_flow_api.g_varchar2_table(50) := '68555F690C438585D245041A1E04D31468E358EF26C0E092F771689E55AC984E59BEF43EAAB7DAB0502E8FA41F624FCBCF793BE966C5CEA9A7E52DCEDD0A587AE9F0802154148EF9FC69B1B0F2534C1F34B3AC288BCBFA6ACD4C60F10B423B21B59EA14B';
wwv_flow_api.g_varchar2_table(51) := '46E668716EE47E208AD5CBA8CB357C585155EFDBB731803BED7E73CD0215DCE0D2235F3A0707E508CC20224F0083C7746237D884B5299C19055B208AE51BD0F89FE3DEFE8E98C8FED2917310F15249E9BEF4C221540C39DE2C9CC132EA3F0026A3540885';
wwv_flow_api.g_varchar2_table(52) := '725904E789F3F17CE1755894F3C883978D506626798FEC23D7BB8E9312E98987319564C5955BA764B8530948FF35598F2E1C64F787E680DD9E9EF4A1882893BCC039D49A5EAA34D308281058B29E8C1B4FED956693CB16266A9032CF0BA0022F17FF1A53';
wwv_flow_api.g_varchar2_table(53) := 'AB7E715947E02A58923111A80021CC2A363738A72FAEBC2D72A537510A5E33C0D56696DAEA01E0B9FC7F228F4B20E585D37CEFC87E416C05B0A45DC51F4E99C8EC115B4A9F4590E49F313E5A9CFECFC5C60046EF8D251B4CAD06F330D317A499E6928300';
wwv_flow_api.g_varchar2_table(54) := '6410DF657C994C2613CB58CE144A1FE05A39386B7640491465088202E7A97A4B5C5DFC01E657B5EEE63C5BF16EE23307529CA3397F1294B8E6717381BB60DC80A0F8285B50C652E97AEEDF615D180DBB5F0A016F51B3E50E16844979E1AB851044D62D0D';
wwv_flow_api.g_varchar2_table(55) := '25C0641A4D5ABE7C0E201C914C53DEF40EE1BB5BC10CC5A4E5F23539C7310A4501583B69E672AEE792AC2C72C5D7A0C53765248B803166CC650F1D294553D325AC886FC3E356FBCC142A651F089C43074C6E352A8BA0EFC9DD2669D661DED7EEA0F112C6';
wwv_flow_api.g_varchar2_table(56) := '00D6AC33D14332928E491901FEE5D2C700788724CBE5085D298243C0F3D0708FFBC530CF6D25E5B64B0A14123A562E362CB87D44A70A7F740CB91C09BFEB77A7E855BBCE56EC461D94BB4B15FF1ACAA938911416043DA6334FC9259D120CC5110A915C43';
wwv_flow_api.g_varchar2_table(57) := '0F045E6E941A4A5D49E76DA4825AE123D89F83099E1E7F081A92C635E73C6819DED75CAED0D33E074148010C8631DB48AB3A0920011CEB078136C5AB0A813005AA846552167BCFBF2DAD4AAE48EB7213F9088FE25F3A718FD88A6DC4843BA9FA89FE5350';
wwv_flow_api.g_varchar2_table(58) := 'B8AFCC87169449BFCD80DBE87E37458C01DC69E372A892976432AEB0341116A34A8A093C528B9769A6116860C09F0C53898CFB05188C98B03509C7886B51D2E07DD654FFA2F2BA9ACE0FDB91E5D989F8272CDBE4C0E593836DC1E9B11D5897AB6D4A15BE';
wwv_flow_api.g_varchar2_table(59) := '64340BCB2AF806520831D733F091C38ED3C2CA6BD2ECAF9ECB9B34B00E5903039863511BE69CBFB8F47000283D5676498145E789A1BE42E90AF657EF4739E54CD1FBCD97CE4BED71E02C292708861274B8E96E4350E87593E1845CE9244D32D6ABF466A1';
wwv_flow_api.g_varchar2_table(60) := 'AC3CB23D7593A53A49D059008A87856A9564C8130243A09972C54BE2170BD8A9F2AEA31DB50B562BDCC79381012C7546AE370B7259E2533BC0F08AB780E1F32E1D219EB9586FBE2BC6D3BB959620A75C5D0CCD33820FA8271D226E382086CD3A1ECC6905';
wwv_flow_api.g_varchar2_table(61) := '0056B1DFCBF9512546991610D2BC0EC140940A6D95E0312BAD6799DB814C6B9282A5B885F8F219B999CFA59A7CA08F0DCAC41F8E95C50A3C736AEECDE557D1DEB510DCDBD1D6F5D7E7382080D5802D68C052F12D98DB8B602F010593B0C6A48A59F8AB80';
wwv_flow_api.g_varchar2_table(62) := '0C2C704DBC22F7605F422E9FB084BE12406C0CA8F9B782393903E62F4263BE030A6A3D4C5A5CF63030A15B9BCBBF82E0C5FF466D611DCB39949ABD16C02CC39DAEAB4BFF22DCC256190F970FDCD152A0B607A1A97A8B10B2AB00760E346991B85ED75E38';
wwv_flow_api.g_varchar2_table(63) := '4E07908C01DC8D8C3276CB475E2B9ED23C093200518FBA2AD52050F44ACB601CCD2013BD5F157C501C936560B64B553E1E83F5A6AC43ADA399E663B02A95D10E9D2A7D5F81C090A42E11166C7160BB01A6920A1EC42BA32D2514BA2E39004AEC3FE669E5';
wwv_flow_api.g_varchar2_table(64) := 'D9D77BE22DC8AE6BB63180F5303BED2D19E2C0FC45898CAA977A0260319E1B062A14631BCAE01E7E9B572BC3FEC4972BA42F8542C69479C5B4BA2D95DFFA5B090CE671FEDD51593F5E96ADF2C3BE0D1E5CF6CC18C0D4BEEE12EBB5C38C7A409BB7159569';
wwv_flow_api.g_varchar2_table(65) := 'DE9BE87EF3FAEDE4EABE6A91D6470D388F3AAF1D7AEB5BC618C0D49F3B23358EB351941AEF0F962BDAC5ECB9175A7E7B26B449C028078C014CB91D2ED935CAA79125660CE0464335B21CD9601D3706F06A8F7283716A4487630CE03BC7C91A2DA48D01CC';
wwv_flow_api.g_varchar2_table(66) := '65D2A699EE1D7CD33CEC09E0D9D9B335BF0A1A5CDB6DED7D98772E053234AE2A711E77C3959E003E7AF4901438CFF31939B6E4EE5B37BDD8AC53E380E22142B8E02933358F6B053A3CE929D0A1A50B0F89070EFE71FB0FFFA8C9A62D4D87C35A8FE24AB7';
wwv_flow_api.g_varchar2_table(67) := 'BAA3DC5E5D304DF290DAE2E11FDBD23CEEAEDD1E4395478FAA66C76C71A16489F727A7338716E60B3E11D64E177BA987173F76DBE156F51ADB69554EE7775A5ED5E308BA4DCDEB46FDC06E1A82E7E0A1736B7EF9E7E4295BD23C36DB6A9BD4206ED81092';
wwv_flow_api.g_varchar2_table(68) := '5177F1A3F7FEECF7A1B77F9F9D4AF36778F5410F8D6C2BBA7AECD168EBA582F5E2F7E2747AADABE96A9ABC66D27D6E3C36DE9385C3AF4EEBEAB671D4A74B8B45FC4E56FCF1E70FFCEDB74935CEE37853ED9E6BF6B45B7E55B978077EFCFE978F049EF325';
wwv_flow_api.g_varchar2_table(69) := 'CCC6F85D895093C8AA1A9B198D1C08E5C2869BBA809F68FDEB1387FEE6272C13E76D639DBE5E63EAED5950FADAE11168CC144FFF1F5DAF78485617DCE40000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72352550815797186)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/mp3.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D00001775494441547801ED5DE9B31DC755EF9EB9DB5BF52C6BB164CBB18C9DC8925D5EC081985840C04516CA7C891C08FE4215F0812F7CE2035554451458';
wwv_flow_api.g_varchar2_table(7) := '86A2CA7F00FEC0E2483179A1421196AA3815DB0A50AEC4B1AD103B5139418A712459EBD3DBEF3233FC7EA767EE9D9977EFBB5BDFEDBDDBF5E6CE4C4FF7E9D3E777CEE9D33DCB53CA420A02A52D90192889E0F871672BF4232DC4AE81A150B456010907A7';
wwv_flow_api.g_varchar2_table(8) := '3FFF519C3D89A3391504BE729C747BC3734EFE545050CECC553571E7F3FA913FFD49101C73959AF7A3FE0C0FB39D7392E9BC2AC49300F7773EAB74F0BC9AC9CE09CDAAEAF040F0EFA6298B75AB8C816605AC4D2AE5BB3F1B9CF9EB3FD4FA8FCF052F1FCF';
wwv_flow_api.g_varchar2_table(9) := '04C1716FAB801CEF6DDB42A4C66B3DEF05A79FDEA7B4FF929A2B1C510BEB65E0E988D326AE11BEADB4942E9F3E4F73185D677EFC385E2ECA8FF6D5B284B0E4ABCCEE353573704695BDD7A0A0BFAD1FFE93F30459FDF2D600B93B1F3A1F4932B81B471F56';
wwv_flow_api.g_varchar2_table(10) := '8B450A9AE092EEC63DF336DB1AD58BF2D375E3F9F1E378B9283FDAF39A1C0750390D0F06E4CB9565B563E217707812967C50FFCAF18A7AE5B8BB15C6E4EE003E7684760191F91C858DD56AB159DAEB906FB060F12A1AE32E8E17D7023553784C79952D05';
wwv_flow_api.g_varchar2_table(11) := '727700CFBF2D2252BEC3389A23B2E03D323FA29EF2E3907BB5B8EE01E48F01E453C1779FBD472C597D19D135AD7D345377004716CCBE1B8847430AC6EF181F231CC3193BC05003C825820C77ADD5A9E0CD3FBF57EBA73CF5CA9FC15D8F26C8DD019C8673';
wwv_flow_api.g_varchar2_table(12) := '54F43CCD6740D703D439CC10F6C5355AF2A32AC89CAC59F2FC485AB25D80D3808FCAB9860503570C31B46DC61291BB7E1447354B560499054727D90378A4BA9D0228B2E05A760DE4695AB2FB62F0FA8943E2AE476C4CB6077034AED584343A47B212B741';
wwv_flow_api.g_varchar2_table(13) := '430DC8CB32263F8255B92FD5401E1D776D0FE00DF2191D7C2540ACCF2EE563DCF574FEA15104D91EC014D0A85971C4AF8CC1D1C906A46B962C20EB1783374E1C16773D3FFC966C0FE086F2D920B0E1C9A87A9DEA4123DE8C25D35D4F171E5481FEC7E0CC';
wwv_flow_api.g_varchar2_table(14) := '33F7EBA730851A7290ED01DC4834C39C9F50CA1641E63C79B6703F1677BE5403F9A9A19D42D90398F2692AA321433BC16F02ED468CD6A2EB29805C89409E87250F27C8F6006E493E8DE4D6E7FCEE787564A62C2B5E00D9733026FFE583FAA910643C38D0';
wwv_flow_api.g_varchar2_table(15) := 'E7DE6CDA9C3D6612D6B0699B83BF98E6B5DDC58BE88ED9F27A052B5E477063FCC5E03BCF3E2C201F7E5BF3E990C177D270608F115A457796313899D49F0737E3876AE262EDBA8231F910ACFA54F0D6F0816C0FE0B4553413CF305C4F2864E2A455EE0CC8';
wwv_flow_api.g_varchar2_table(16) := '8B21C81E407EFD9947C492BF007D1F024BB6077047F269558EBD2ED715F35CB9AE59B28BC0EBCD671FD5FAB8AF8600647B00138351B1E208CF04BF89937635AA66C9D3850F63A8C20D8AE100D92EC0ED8A6550E5D3586EBCD9D00967C692E9AEA70BF760';
wwv_flow_api.g_varchar2_table(17) := '31E4E43080BC3D014EC3274B95E9CC8ECE6BEE7A3A7FAF58F2EB277E7E90EEDA1EC069ABE8483E03AA24166CADED18C8B064DE857AE3C4C70605B23D80A371CD9A9CFA4848A64956DB3320739E3C9D3F88E0E4D4A040B607B055F9F49958BB0B1DADB167';
wwv_flow_api.g_varchar2_table(18) := '022F01B9709780FCEDBF78ACDF966C0F607667D4AC38E2D7DE189C86BE06F254FE2E9571F1B4E689C705648AAB0FF3647B0047C24A777198CF297E49D58328C3E6DE80BC526474FD213CF775126BD747F571CC9391F09A8C3D0CEA70DD53E275DA1BAEAC';
wwv_flow_api.g_varchar2_table(19) := '8452F60164BAEBA9C201C0FAC51AC85FC013B9BD03B9AB97CF1268513E3D9551A2353B27097E1368DBA19FA4C2D65C6502AF036AB948909FC6AB99A781305FE47322D79DACD6DD993D0BEEB97CBAEB68A2765D5E1368278A5B3C09A36BBAEBFC013C68CF';
wwv_flow_api.g_varchar2_table(20) := '37283E0190C1D1F19E58B23D802D4AA1E7A4366049C4EBA2DE0B560032DE875A2996E1AE6F87D77B21384390C9807D90ED02DC37195996BB2C746C40DD72237172E19B8DCB78D576AAB05F7900F98D677EB51720DB0398F2E9A78CE2F2EAF43852484E93';
wwv_flow_api.g_varchar2_table(21) := 'F09748386596644797E2E7B1E3A86AB4A72DD6AB0B010925534EDE75CAA815829CDF8F172A5E08DEFCAB270832C7E2E0CBFCDA40F7C91EC0645DD8EF9EA9FE538058A99CF117CC708E5CD9AA8A1B3F8F1DB31C53B467F97A75D18094AC96433154CB0666';
wwv_flow_api.g_varchar2_table(22) := '31645F10787C17EA93420B8F00D99827DB0358B8E2CF08A48422F2D557C7C78618D7C577455CC4B3FDDDB49B71D56AA9A4A727772BD7F9BBE0CC730664CC9561EDA1FA7426577BD3A4CEDA1F4C2D888C53130D50037FCD5D5FFE601DC6BB6C7F49BACDEE';
wwv_flow_api.g_varchar2_table(23) := '2DA9E58CEBEE2D95CBCF2DFCFB1FBC3BF7E9BFF9B19A3F06CDC3037D1DA6ED09308465CC024FC1066B79A7BCE22EAD7A81E705DAC17BC209030F05CBF2F5F223B96F763D7E2D7E1CD5E59EF9BE0AB208073CEDB8F769277307B27EACE41DECEAB73258B4';
wwv_flow_api.g_varchar2_table(24) := 'AD640F6072384A09FC32D8C11C54E7736E96D6BC84D7827D2C20BABC56A72FCDBAB8D9F5F8B5F871BC190C162A977354A9EC55FC32E6CA16923D8029917A52B1C064AF4830D81190B1CB65B59AE1A355AB9EF2D00FBEF0DF97EEB0911071EC7C2898F966';
wwv_flow_api.g_varchar2_table(25) := '48D640331F7D26A343216CCF202B26AC30A2A55FD600594F4FB81AE06A085AF298DFD38DF0866D00EB10EA1A83C7E29FC9A865B77C640F60B2D617956FB96FED1704FF795AF2842B1FE9A375F735F5A03D7B00F780B9BE0A37D6D840418EF161E3D01EC0';
wwv_flow_api.g_varchar2_table(26) := '36B819221A5B05647B00D3456F18418608B10E58C9E7FAECAE7B203F7B006F21175DD505F4A9AF96DC0319DA03B82A95AD77404B9E1D54E0D5A538ED02DC030DECB27F76AAA35F39823CE962A9D8CC9DED10EE3D157B006FC13138217E829CC1981C82EC';
wwv_flow_api.g_varchar2_table(27) := '8F8832DB03981D1E914E27806BF34456BC007206921B0590ED014C41F5200A6C53FEBD2F1EB3E45100D92EC0BD17EFD0B4404BE6983CEC208F01EE546560C9598CC9C30EF218E04E010EEB0D3BC86380BB0498D5AB20E3465FDF6F5034E17F0C701301B5';
wwv_flow_api.g_varchar2_table(28) := '7A39CB31198B212E401EA6E87A0C70AB08362BC7313904198FD00D8D25DB03783B4C915A019981D71059B23D80B9C8C16D9C86CA92ED014C60C7566CD43BE6AE073D26DB05786CBD3509C440E6983CA8C06B0C700D12FB473190B3AD80DC030F6817E0F1';
wwv_flow_api.g_varchar2_table(29) := '18BC5149DA01B907F2B30B700F3470A3C4463007C065C229544B966CB18B7601B6C8D896231582CC4772FB09B25D807BE062B614D0908F2C86E02E54BF40B60BF09642A3479DA1258777A1FA01B25D80C763706B5A8117DCFA05B25D805BEBDEB8140D21';
wwv_flow_api.g_varchar2_table(30) := '06722E9A4221DFB68D8C011E94BAC540E6837C7CA02F906FDFD965C81EC0B655CF6E3F87931A644650E9AE67261CB9AFDCF5371B523DB507F038824E89B6B553797D350ABCA6105D036C9BCB9AF6001E5B706B88362A054BE68D09BA6B825C29372AD85E';
wwv_flow_api.g_varchar2_table(31) := 'BEBD37FCDB6B775C3A2D011A08BD20C09D85BB2EE43BFEEE4A82B23D80C72E3A21D88E4F2047171F0999C8673B2611AF68CF45C7A98E8FBB93008D656BB9E846E6DFEAC0DEA83EE51CA7B159B93826F13AF1FC66C769FA1DD061156E6952CD9A6E70DD9E';
wwv_flow_api.g_varchar2_table(32) := '8B6ED040F36C171FF8CB2460601DF64F0754638E459B090AD7740EE5C3AF1186A54D7D7E89283696E92CCAB9096A520EA56A09D14EC03A9C946EBC5A2B173F62394448A01F25D37E2BFC47357AB31F30C000C75FC1276D16C2DE4540122E2477278456C0';
wwv_flow_api.g_varchar2_table(33) := '01855D2FA114C1F0AE42194A28C07FEF6B12261B38DD816D0A1914379277036D2DE3A0363245E5A50CBEF2AB14DA7326C37659AFD9E7AA4270D9BE77C9F0237C205FF8CF8346D83E8EFA9D060B30C009B27B5490398C7EC78540B103E4D22503082C3C79';
wwv_flow_api.g_varchar2_table(34) := '9D620AC1C535BFF0004099405E5C1160D195EBB2455F090D7277ABC09DA9432BCC82C7D0FE12EA00A8CA45D0BC051B94A421C83170E145FC899F0BADD8F0A1CB1F28ED41A1F81DCC01257B00D74CA185AE180055B0A4CA3B3EA9D6F7FE1A2C90C28A40C6';
wwv_flow_api.g_varchar2_table(35) := 'B21D8452B8FC8ACA5DFEA2B104B1CDE83A9B80D0FC6BCA9B795CADDDF139000780C5B59AE60327A3F257BEA5F21F9C4206AC527BAAB8E733AA34F700406C10C1A0BEAEAC28B7B4A0DC95732A7BF35B50B2F7D0FE2ED088F3C736784EE0B0F76FAAD2DEDF';
wwv_flow_api.g_varchar2_table(36) := '55EBBB3F1EF6C35C9FF8E9575566E13F1AD46799DE277B00A7FBBF29EFB43E54082AB0DE69E54DEC86D049809A4FF0F1D546B7A0CAB34754F6FA2E60B30421C192C40DF33A048BBAF8519599075479FA4ED4E7B8491A4C5010001C6466711CE507CACBED';
wwv_flow_api.g_varchar2_table(37) := '505E816D11609625AD7832ED5790AF6F01DD5B1E52850BFFACDCE5D7D03EAC5952D4064E38E696DF87921D55EB7B1E07ED3DE015AE1A6D9B3EC0D50BCFA6664BBF31F22D956F52C81EC06C282DAF268D1B2B2C2BA7B20E4150B8EC1DC1C367E6B079137B';
wwv_flow_api.g_varchar2_table(38) := 'E1F60E2B77F11BC8A6AB648ACA2CC1BD1F5095E9BB05304D1A3286864A12A06BBE199723C6287CEDAD85009316BE36EB70DC6522F30096811DDAA6829466F18F44DDCFA9C9F30BCA597F37E4215418B864E52D4289F6A8E2DE4F293FB753392528229328';
wwv_flow_api.g_varchar2_table(39) := '10F8A0120A4F26BBA5DFB665B83955BB006FDE56F2AA740460613196EED8C4C0140AB6F023927E6E16001E52EED2ABC807585500512F5853DEE421558112980F4ED25DB26E0818C73D19FBA810DC90248FD12EC67E8CDD0E5C71FEC65B00BC04202741EF';
wwv_flow_api.g_varchar2_table(40) := '7655993A20E0D2CAE915785EDAF90955F8E93B201301C6F60174B0A0CABB7E5F1441AE85CAC2FF008F46C22D6C9BED0F200D0EE0A8B3D27FFE4020D839E50508B820AE9B165699FE1995CBE27F5754AEA0C89CA9452B03409599C328370520E0542B8C8E';
wwv_flow_api.g_varchar2_table(41) := 'F165FE2C5C696C2C8E9A49EC393C380EDA5AC218FDF78AC190726F05CD825ABFED698CD5BF0805C886D68C6160FA2ED0DD87366EA0CC34484149BC8BCA9BFAB82AEE7A0CA77928CB22F2A1380CF6D015A86DA2C9419D50D5EC242A6C1749C401CB754ACB';
wwv_flow_api.g_varchar2_table(42) := 'E246035A22ACA832791B5CF52180B61A5207CBB0DE207BA7B867912684E994179503176C5C6E33E186CCD2536844D50EA76318AFCBE755EECABF2A77ED32F2E809701D1EC5CFCE409176E318F419D173AA8531B9B8E75332EE2A2898BB7A1EDB05B17E14';
wwv_flow_api.g_varchar2_table(43) := 'EC421276ABDA03B8CB3E51E309AAF6569453BC06D9723CC4588820AC32731FCE31E6C9C20785BE0A777A5879F930BAA580D730B5C1BEBD2909010660D838E6AAEC3DF006982B573896E25A94184CC96678A26B2EEDFC8C2ACF41F1C027A3EEFCD5D3E01D';
wwv_flow_api.g_varchar2_table(44) := '7100E818EB8DD58FE80C606F0FE0AEFAC3CAD010028C602983298A44BAB43024065241E676148100191503EC32DD33226D9C20485B469D1FC9B1D1B356B58DE5C2719F633FE7BF7A4AC663E10757495F80C3820CBE7B87E6AF2B7FF25155DCFD389402ED';
wwv_flow_api.g_varchar2_table(45) := 'C3CBE4AE7D57656EBE64F8219D214AF600A6AC5A956B3D01605C34FFBE48ABCCF2F7E1AA6F42801807214046D3B458151421D05544AC07655CA4F0F947EB755719E5A2BC306114A35E33262F6494633156B794CF0589ABA05556E59D4F487B2688C275B8';
wwv_flow_api.g_varchar2_table(46) := '6AB7780597003E173C30DFE67CDA9BD883F300BCBE07B7FE4FA88BB197CC545387C2E8B05AB5D9D481DD202BDEBF54430D4F6375C44D3B7900F63F329E717E2C531608B5327B5865165F06180B086E7E5DF9798C9B04136E39B3FCAE044032FEB6242034';
wwv_flow_api.g_varchar2_table(47) := '2AEE7F52956F7D12E016617D5350A2BB546907A6465414AF8C3C4E85D65576E10CCE6FA23D28C02DBF89C59223386690B6A80A57BE89C590B32AC8DF6FF8C1AF49EC1837DA10F72D3196D411D4EA36D905B8C53E2498AED6A1D071C2E0AAF2BE80569AE3';
wwv_flow_api.g_varchar2_table(48) := 'D88B73E497E1A6F3D9FD4A17DF11B00307C287E028E4CCD2191CD616FA13F41B9C684C797C2C7CACED7F1225E83D0004C6628EFB9C1E0519AE21630DECCA77B01AF54D1429C1353F84058D5F02F0B056D4CF5D7F2B5CA9BA13E788EC63091471166DB10B';
wwv_flow_api.g_varchar2_table(49) := '7D3EB4E7A2C93815B5DB2491ED3400FE1E82971BB0268CCB04A3B00B6EF123F8E70AF722B23E8056D018FEE89E9DD5FF4639DC54A082344AF14B6C03E79CAF0698E20860A1C2C80A980B0B2EAFA8C2A55755FEE20BB05E8CBFEE1C5CF36F8087DB50D157';
wwv_flow_api.g_varchar2_table(50) := 'D9A5732A7FE96FE141E8E2AF41291079A7C65FED6348F1307F961B1C8D18EB6DFEE02D38DD3F0AC9B955396BDF43E08465402C2D0A1800C29BBA47DC27174024CAC602456609C11585A88FA62925CFD3CA079035D79ECB6BA69C586E11AE7E4DB9EB9754';
wwv_flow_api.g_varchar2_table(51) := 'F6062C970B2C1ACB8DDA47C4FC842A61F9924A24F5FC35B8EB4FC3D2390F873B47F4ECE7380707FF48A08E3A0F81FFE7302BB8ACB28BFF25FD300B31716D33CDF7EAD71EC014605A88ED705DAD0BE786E85457DE83159FC578771FCEE12E21D8CAD41DCA';
wwv_flow_api.g_varchar2_table(52) := 'C961DECAA90D1217171890297D07CE28B41605075A1C67DDE2076AE2C2D760A18CCEC1808FB9348229B9C1C0C592CCBE30FF06823A28175C33C76BA6F2EC218CD71C8B6B6DF28609C1372980423CAC7C2866EEC61900FC2AB2E930399444654CC95EFEDA';
wwv_flow_api.g_varchar2_table(53) := '03B8D6CFF6F88D80ADD64706AD40EFC4223FDC74F1285C3256B2249ADE17CE7D4D13EEDA0558DB0F21372C57C604DD9C0134460B06B099C5AF03ADF70C0D198761B12EBC86A268688D04033C211690A04BB498F501160095C43EE0102A088059C7744A16';
wwv_flow_api.g_varchar2_table(54) := '6B38BF661C31A0640FE04E3B10CA2894494885D39139B8B6B3B86DF71300BC5FF265AC8415713AC5F5E3CCD259C81F8B129A015144A815460C00021A56C4F01C232C7A127BB42B001124064D51B90959A9CA5D9F01802C136B43C0854700E0DEC4ED70D3';
wwv_flow_api.g_varchar2_table(55) := 'B35590332BE7E18956655E8F0E8595E29563747A74387880A38EC5FA2D7359BA614C55B28BEFC0D53D08EB010072770812E53A72F1BA899E1DAC0DCB224444A89D3D1AE5DC1A0B283A2000A1B55649844CA18DDCF597302EBF54BD620E781D9137E6E6E4';
wwv_flow_api.g_varchar2_table(56) := '6FF5437F84E95B6D1CCE5FFD4FDCEEFC0AAE2130A34790FF2E4BE5E95FB21B4577C43785CC4E73A3C042A1320FEBBDEECA5B70C35C84E0A5DAF5CCCAFF0164BA6744CF89BAA8C7BAB1B22810A6585BD532A1954A03D171543EB6C734882E3DB9212863A4';
wwv_flow_api.g_varchar2_table(57) := 'EC231F4197E907DB30EDF0268842042EAB723152FD3CB46BC1947FAB49CAE287EBC00844F84F0339B7E55D1C5ED2B426588E2EFD0881D4392C4D1E841198A549CE41334B3F401DDC7470B9F64BCB83AEB23E0332FC7758A129C158C81476429B6DA106C7';
wwv_flow_api.g_varchar2_table(58) := '5333976E9161AE8573DC8D1430AC661E1864D086A143DAE7FCDC94135E1C46FCCC238FFD4F7601DEC400925D23B0C80198BA824878EDA2683F235BA78439A50828AC8125C0ECE29BB8E17010A0703910E2C3FC98F364F310000587C8140B11CEFA658C74';
wwv_flow_api.g_varchar2_table(59) := '98DD22D2F501A0C6AD471371A33180E396AF61DE7C1116C5BB4E3959823496BE11386928F1430FB3112479D448BC016E7894AEE24617FA42CB051FF2248AD0D8582F41BA872776010E8DA539BF6141DC5BCDDE7C0D41085C6D68B75C6BAE8E57BCC98F5B';
wwv_flow_api.g_varchar2_table(60) := '79CEEADB78AA020B096209B80CCBD565B86D0646526616D39BAB6AE2FD7F08CB100C46C98BD8432944F15C95BFFC6F2A77F565E4B17D64A2AEB858A1CB3ACD92104A15423D2E6DC22DE72F7D156D50094DFFF8D09F72780F3BEC6FAA663F4EED02DC2EC7';
wwv_flow_api.g_varchar2_table(61) := '983E686F01605D086B42108C88E509C95098B03C593E2C9E839C6819485C9694B19727ACC3E5CC0AC6E4FF0DCBB02EF2E5F157BA479374E90268711E1B5E173A5CC8A8075C54AB95BDA9EF94DE47B3504AA3518647B6D12EC060DD56B20B70DB72223800';
wwv_flow_api.g_varchar2_table(62) := '2074BDA653EC5DDCA5B10C5C68F43447B5E721D872CE32685CE3B92DEE494212AD326699A2145828A9A6745BD50B9D1D38A41D1702FB5165A6759A24D141B57A0DD805B823A658290E563D365B29C37A10E8A63CA400AFD754577971C5EC90D0A6FCB74F';
wwv_flow_api.g_varchar2_table(63) := '93D185BD14575E7B54B71725CB32B40BB065EDDB5EC8C67A6B518E7601B6AC7DB12E6FAF438B72B407B045A6B6179ABDEDAD3D802DBA95DE76797B51B707F0F692DBC8F4D62EC0632BB603BC45397607F0FCDBB59197F7F86A67763A3AA6A2545CC61DC8';
wwv_flow_api.g_varchar2_table(64) := 'A33B808F1D31BAE6F8065EB945D70117E32A350944D64B99324532AE9568EBA8BB95AC48BB7C07D68B177C03F0845F5872C4665BCC6CFBC2941D8D84772E2853A648C61D0AA73B808F45AD6AACF2EBB36A367F442DACE3C62EF223771D3F66F1F4794462';
wwv_flow_api.g_varchar2_table(65) := 'D8F6CDF8DCECFA66D71AF5D3D4F121431732C4B34894295255C68D2A6E9E1FC1B079A90657A1671A6BFB644D05A77FEBB3B829F0BC9AC999773CBBA2DCA0C1AD9C2D52440717F1CE8ED2BFA78F9EFC0ABB1B977127DDEF1A863803C1E9CF7F1490E35581';
wwv_flow_api.g_varchar2_table(66) := '600E9CF97C766A9C5A90009E6681DC202C8D8F8304FFA21F3BF56DD68ACBB6052ABD2B42467A477D7B52B625D3FF07930EAAE44A05C1600000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72352902705797188)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/mp4.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D00001A89494441547801ED9D6B8C5DD575C7F739E7DE99F1781EB6317EE217189B601E06624C90A08404531235E5438CFAA155A5B4522906D4AA5F8A2A85';
wwv_flow_api.g_varchar2_table(7) := 'E9977EA99A7CA8545542955A1ADB8449D3D2A68850D1405A219112FC2026D80662C7F8895F638FC7F3B8F79EFE7FFBDC3DF7CC9D8767EEDD77E60E73379C7BCED98FB5D75EFFB5D65E7B9F33C7C6F848711CF820339334BABAE2D07C0EC6512EC34C79C6';
wwv_flow_api.g_varchar2_table(8) := '94EF114A10C4B47BF4B5BE7B8D09BE614CBC208E4D2134A1E1FF9AA5822857481FFE0A71DCD2D664CEAE58685EE8BA3B38BAFDD638EA8EE3821B4FCDF89E46C2D5595E0ADC6DAFF67D3388C217B26DCD0BA691FFAABACA4B2D3BB3C62C6ECEFD381BE69F';
wwv_flow_api.g_varchar2_table(9) := 'FAEE1D2D9F74FD24CE743D64F29F1790AB0278FBCBD2F82782FCA3AF5D596E4CF45F4D9DCD9B067AFA8744B442BBAA0AAF2935168F414E56DC392FBCBA7249537B7E30F74E3ECEFCCEDFDF151CF93C815C2510DD56A8854270A3DCF2C6A1CB4346CE1A9A';
wwv_flow_api.g_varchar2_table(10) := '757FC87803131B3B45E58772BD2D9D99AD5190DBF9F4BE785DD797835CD79B26FA3CCCC95501BC69FB763BF746418027602EB6BFF69AAB3A3E863995EB915206FD977271537BE6FEB890DBF9C7FBFB6F04E4873E07205705F081EE6E4034F948218B4CD8';
wwv_flow_api.g_varchar2_table(11) := '026C2127B7BE53894D7BA508DA04039772F9E68ECC97C242B4EB8FF6F4DFFCA640DE8E379AC5D17555003B0B2E42299757125B7DC39BB816C7A3B88E833024AE0A062E5B90B766826827207707417E365B7255003B0195CED6A04BB7757C55A68A09E349';
wwv_flow_api.g_varchar2_table(12) := 'FC10F4F708E4F6CC16407EEA40BC7E365BB26780EB18D109594BD6F171B29E0F154A24EE5A200743B95DCF7E105B4B9E8DEE7ACE023CD2D78CDA8993BF4E406E6ACB6CC90DE6BEFFF4BB03B7E0AE671BC87316E0112EBAB8135766E416E441CDC92DED99';
wwv_flow_api.g_varchar2_table(13) := 'BBE24CB8FBE9FDF1AC0379CE023CC282C78F924B96DC9ED9AC25D4AC0379CE026C2DD899F1D816CCC28F346CC972D780FCD28EBD039BACBBEEAEFF259467809DC4CA9C5DBDDE8E30E33198A4DC81AC9515EE5A9B217706267CE9D97DF16D6CD36E17C8F1';
wwv_flow_api.g_varchar2_table(14) := 'F81E600CA2D39BE519E06B496C7A0737516F93E6B45431B1646D8664DB33B715E2DCEE27F70D58909FA863903D033C9148EBABAC425F5302B92D735B1807BB9FAD7390E72CC025C39CB2E22581173B5E6DD9DBF271F8D2537B0637E3AEB164FBE2C09449';
wwv_flow_api.g_varchar2_table(15) := 'D6AEC19C057884054F7D0EB59B2183BDB99C76BC36696364F7937B07EF02E403B79AA09E40F60CF008B1D54E2D7D531E2F8A9EB89F50A38DB4772D90B3B744C6EC7A6618E4EEBA01D933C05538BE89855997A51A2D7B9C919E425990F506D1AE1DFB06EF';
wwv_flow_api.g_varchar2_table(16) := 'EE7EE289BC79DE987AB064CF00CF520BAE547DF4F4CC821C242037C992F5461773F296AE2028D403C89E019E3D16EC85535E7048813C284B6EE9C8DEACDC5DF502B267802B3585E96F37C2D74C3DC82A316C41B6CF97F534B968C91DD9F58AC276D603C8';
wwv_flow_api.g_varchar2_table(17) := '7316E01242BAAA2CC82A9128BA039D2CC85872B62D632D5973F2D69974D77316E022260948D558700966BBAD390CB2A26BCDC9EB4D1CEEDEF1DED097660AE4390BF008175DAD053B90CB2D1990DBA2757118EFDAB17F66409EB3003B4CECD99705A7880E';
wwv_flow_api.g_varchar2_table(18) := '5B329B216DD9B5A6102BF01ABA7FBA2D796E03ECCCD89705A700E629940559EB6476BC9A04B2DE2EDEF5CCBEA1072CC8AA3B1DEB64CF003B89A5475AC7D745975A130ED3EE7A18E4688DFEF069A7E6E407BBBAB44E56EA8AF5476F354C9E89D752627EA5';
wwv_flow_api.g_varchar2_table(19) := '309D9CAA2FBBE3A5E7C9B9A6F9D12A1306DFB3962C909F5768564B903D03EC17845A529B6E5F6341D63AD981ACBF6CDCA9C0EB41B9EDB8AB8620CF5980A7D3829DA202B2FE4BE6E4F9D955A610EC7A7ADFD0C3A68620CF59804758F0881B0747CDCE09C8';
wwv_flow_api.g_varchar2_table(20) := '5772435A42AD5400FFCFB504D933C0D32B297F108C7A2FDA1FE9B129E140328AAE01790520EFD837F4955A58B2678067C2F18D2DC149E596F4312EBE5C6777A3EC357F6735A5433D5EAB3ED4E9937A49E095803C3F5AA1BF8E7A71C79EA1472CC87A12B5';
wwv_flow_api.g_varchar2_table(21) := 'FDE597F588B9FAE419E092C4AA676D5A29E036117C72E69A8708533A26D126998313BA54B7FF9B6CB24E16C841F0BDA7F60DFDA68A0CCF947DAC933D038C6466432A29A2D62F71140605DEC189A2B010847A5E30AD875EDD8B8228D757186C6E8F96E86F';
wwv_flow_api.g_varchar2_table(22) := 'ADFFF14F3F8C2DC876AD5CE52E5BF51F61990D788EE21145D49F12EA4F4607727174FEFC957E630ABDF6F13D7571A158AFF5A764B8E4F29C22A328A93CDB8EBA2ECFB52BCF53B9EB237D3E1FF44699ECD2A18181EF3CFEEAE9C3FFF6B5A51FF3DEB5BEA3';
wwv_flow_api.g_varchar2_table(23) := '904F539ACAF51C05381111DF7018C89BE653FD7164FA7AE34221AF65294EAD64E15311667575057A10673517E7C330F88268DDA0E3E34DDB4D9C7C28A332EA7318E0C4CA34E90651D3BCACFE74D404577B85AD76102DC89509B4AA56057995A62693D79F';
wwv_flow_api.g_varchar2_table(24) := '3306FA1B99AA68151BCF6180918073A58538C8365B91C4FD02B9208F3803962CF7A10DAE42842D6B1565F9719FC9B03715FC780EB22AE060C69B48964CBE0A66047210B4B4C994C3409F49C3834FEBA1780F8D4B52D1F4CA3E93E14A277D6E009C169502';
wwv_flow_api.g_varchar2_table(25) := '1E2C3998D7AEBF2994680880A633D5A03BCF00D780C3E914307DCD34C86EBC5E66E0E483658EA48773C9C37820367324660AE4B4F83C45479E2D78E630F1DEF34C81EC79200D802712E874835C8319AE01F0440053369D20A75DF4B5F89A64B967806BA0';
wwv_flow_api.g_varchar2_table(26) := '82931C484DAB4D17C835109F67806BA08235456E0AC4A703E41A88CF33C03550C1296050F3AAA340B62F46FAEBB606E2F3148CBB31D640051DE97A391741869D98BD6BBBADE969DC6932F5B90EAE17146ACCC7084BD68B17BAF79E3C999E6717ED7D98F5';
wwv_flow_api.g_varchar2_table(27) := '4BD082DC54DCD604640FEEBA067AD200B81A151A01B24CAE16965C0D7F6ADB00B84A0126EBE4A22547555A727A0EAE96AF62FB06C03E04E92CB985A750587285EEBAE1A27DA051231A0E64FBA8B17EDC75C3827DE2ED406E952557EBAE1BCB249FC878A4';
wwv_flow_api.g_varchar2_table(28) := '05C899261362C9D1CC5B72C3823D623B4C4A209B61902B0CBCA41B3E5203601F521C8BC6089027197835A2E8B12459C7799580EC79380D0BF62CD051E48641EE28CEC9132CA11ACBA451E29B1D1916E4AC02AF4980EC79440D0BF62CD071C90D83ECA2EB';
wwv_flow_api.g_varchar2_table(29) := '092C795C22532F68003C759955DE6284BBD6BF4C5DBEE3950EB21AEBE0CAE53CA32D47587219C8E939B8B14C9A5198AAEB1CCBCD3027E3AE5320372CB83AB9D64F6B21399125C368C382EB07AE8A39190572CA4737E6E08AC55A5F0D53EE3AB0EEBA0872';
wwv_flow_api.g_varchar2_table(30) := 'C382EB0BA7CAB9C15D2773327FD518686EF6F96688273DA97C788D9648A008B29E3E0519055E79F9E7DCA017D13400F622461F4446065E85A106C03EA45A7F34988279ED675EF249896A196CEC64552BC19AB407E5212F946BEAA261B318138E6276329A';
wwv_flow_api.g_varchar2_table(31) := '35517B393466AEE134515D57C9D5776797EFCE93A1E1EA96F7EFF2D3E7F4D8D37DA6F3A99F2E4BB7F7715D33801944B338CFE860B9E71283E1B65F3F6CB78F3738EAC05C932AB836BA1DBE1E5405968A9471B4E8479F4EB17D714F7B97DC3D5F13CBA9C0';
wwv_flow_api.g_varchar2_table(32) := '7D558C7C127551B8C9D0706DE87B400DDDBD6E8713F4C88777C6C03D6375F994D11FF743FA71FCE8D67BAA19C00CE0A4A4705223CB16A5C00901B7EA62B5DE64E17B410CB23C91A76273551707450330ADA2288F3268DFA09FF95C2821A08FE5D12EA810';
wwv_flow_api.g_varchar2_table(33) := 'A152279DB89FA76381CA3AD4A645076D102E89BEE8E388FABAACF358346CC5E24F5E759689C675BC8D932AE05A5D5845D127AFCC7975C2F81933C9955387EB85BAB85E34904FB10AD5BC26EF003BE619D4ED2DB179503DA0BD2E81099AFFC940601014F5';
wwv_flow_api.g_varchar2_table(34) := 'CB137510788706FFB579B115008050D7D13F3918987302842F0E02C803F36333AF081C75D2090F3220263E1391C3438139A30075A368B7EB804FFA4259BE227E9BA1A17BFB25C33491D435F42FAAEF4F450B5E496A62AD152FF26B959D52C6962663EE13';
wwv_flow_api.g_varchar2_table(35) := 'CDC5CDB1E9901C0092FE7AC5478FF83F3160CC219DE96F9ECAD272B2443DFCF807588CC230D6F4272B0AE69E25797D2E509924E54592C8A046B2EB93C8BC7C2E34AB8A0AA0A2E184203E90909E5B5A308FDD90B7969E2F8E9EAF1B611DAF1C8DCC8B6742';
wwv_flow_api.g_varchar2_table(36) := '6BD91B9A62F3AD1BF3E686B682E9CF49E8A5EE86690EA9FD2501725E5FA53C703134FF793E34C7D5C74DDA57785F807F55403C7973CE2C9642A5690C13D0053C423AD23F2CBBF76C68FEF2938C59287EC843C9FAD5C721D1DC26657B7871C16CE888CDF5';
wwv_flow_api.g_varchar2_table(37) := 'A2D794894D46F5F4BF0591B10C09E4ABE2F5E34B81F9E1F1C8ECEB0FCC12555073AFC93FC045F6B08A05D2DC25AD084CAF924A007C38551F72B520DFB328303B25642C93813B806554A64F0258A98BCD8B0A66657BC10C316ADB3E511014A84D12A30F12';
wwv_flow_api.g_varchar2_table(38) := 'C2BB4E002D555F7DEACB019C9426BF28C54A68E8F6AEEB0BE66EF5FD0F4722F36B791212960BB8F07B55FD45E29336097C9CF9D4335F1B4EC0EA9475E2E2F10EB8FC8B1A489F6A3D27A57E7879DE2C17C8192982BEA137220681121FD1CB6B7C4BE717CC';
wwv_flow_api.g_varchar2_table(39) := '424DFC3F93A2FFE04A60C7EC2776A697247907D81146C883452D1D90C000185132E0260DEE4669F76629C031B9A84E0D98843CB15EACE0F1CED82C6F9545CAEAF4C1D0C48A5581791BA518D287E8B8A6294050078B001CFAE6A09CE4FA860FFA6851FF5B';
wwv_flow_api.g_varchar2_table(40) := '96269EE13B1F45E66DF5413E964BFB04E0843ED69A709E40AC1B5B97B3F4D05A6EAF2E7052CFADCE9B8756E64DAB2C765019F09E515FD060DCA5242594340A6A878CF22A2346A845AA19C048211134169B6831C038A1E3BAEE15C8EF9C09CC420921B196';
wwv_flow_api.g_varchar2_table(41) := '4468E7D4767367411EA03464C48C7BB7ED8BB4C9E34074AE2FBEFBDC2C7AC77A03F3BEAC140BEB900B5FD71E9B15B22AEEFB0562B308DD2A0FB1EDBAC0FC8BDC3D741D0D7DB3D97A85D37D8139D507148992D0966BF8382CD7BA4067ACF89C80FA7381FB';
wwv_flow_api.g_varchar2_table(42) := 'D555284D6CAE00ACCA9AB3B1B9280F71F452644E5D0DA49489B7E950FE2229F72AED4AA200587AAFA52CE29E53ED00461236E1D69240E6BC067BBD5C29820284DB17164CEB67E1709449A4DC232D2038B959E03745B1E6AAC05C94DFC2857668BE24A9F9';
wwv_flow_api.g_varchar2_table(43) := 'B015D90C97593C330D1CBF129A3F930BC60057A8AFB512EA539AA7376B6E44F839093B2BFA9B16A8C2B1E4DED1823FACEEC085C87CFB5791D16C622363DCA71B1667007E5F997F705DC15A2EFCE345B2CA4759F67E1699573E8DCCCFE57ECFAA3F824B86';
wwv_flow_api.g_varchar2_table(44) := 'D0A1F2761D5B35FD6C688BCD0529C48DBA270083AE4EDE52ED001EE6920BB1ADD3670A703A35C2ACED35B1AA2FCA920F4ABB170904067F5400FF6E47C1AC50C0441BE6DB330A4096AB1EAED659D1B5248080111A34E6EB7AB784BCE64464362C9052C985';
wwv_flow_api.g_varchar2_table(45) := '0EC92D5207EB66BE77C27574E9875997803087F05560EBA80DDE8688FD82785D2FA61F5E266F233A800BC828C7BB6722F3571F65CC1E0570B76ABCCB555F45B063AD1E457E591EA6FDA2E207952D130FC414D4F19944BA466998D3E402AD3E2BA02E69CE';
wwv_flow_api.g_varchar2_table(46) := '0528E6A445B2E67B35D71E911071910890B9EC0E595587AC1861301F9E9635C22807799349F4DAA40608BC4DC27B48F4CE6959C29C47FF3621505D634DE574933A891250DD1EFAE10C4D96359F8AEFFB65856BA5908C07E089988FF786E69FE4F63F10B8';
wwv_flow_api.g_varchar2_table(47) := '0F689A21C6607CB4E58C722C114F374B39589BA3C4B54A35B760AC80E813ADBE28708F5E56342BEBE46BBDB8E04DB2A825A73462A50B12D83DB284F51258466E16219F91751FD35CB805E9282FFDC55DDB68821F2B3835610D7C408A72CF7CE63B91280A';
wwv_flow_api.g_varchar2_table(48) := '94534E801FD2F188E817B32D45EA64C533AE1D0F40F0A76A1624EAF5491371D91BE562DBC5B30BFA68B75F96F99678BE43006295ACBF71D1C2D426DA73207C460EEDC5BAB8D6068BAA4E39790618B64726F16E47E3BEAFBDF742A8B5310026F5562BF8D9';
wwv_flow_api.g_varchar2_table(49) := 'AAA5C9210189101E91C096158321A479B827341764797880A9FCFB1480FB4B812A1D320B75DCA4913EB22C6FE60BB09C940BC1AA3B734240F06D75843C9C749D579D3B35B7FEB5F823514C7DF8E855FD9D5A03BF2585BD4E5307AE9E600B85E8939B3EA2';
wwv_flow_api.g_varchar2_table(50) := '000FFA582BBB598F4989372AA6706B7915D964E9A90EF4DE9252FC4A31CA42F189E2F84A9E01460CC594BA4C4494B8CC3705D8E372D544B40891B5F256B9E47F955056492AB7CB65B733194BA47D1AE95E6D4A202884E8E8B82EC63BE32A17CBFDFFC58A';
wwv_flow_api.g_varchar2_table(51) := 'BC759D0B05EA46D15D2F413B57DAAA3CA68CB7B561017AD077894BFA62ADBB50FCB9645DB04064C3649ECC91E06BBE2468EBAB1A117C1FD62ABE5BD408908F0BC52D8AD61FD2860D4B27129E49F1BD5D1EB5C8A59F95721F965BFFA916D24BE5A5E4D9AD';
wwv_flow_api.g_varchar2_table(52) := '75DBCA55FE7806B8248CB1D0C03DBEAA40EB991E002E588B746E3AF8343437E19EB53C62A9413AAD25CA4F2F07669BF2269B101E16BA469E60551B4E5596A47E71F9E493009780E80DED20BD7129341B2405E67F97DC25ABE3A44552821258706CA6A27C';
wwv_flow_api.g_varchar2_table(53) := '953A4F94D46085208FA07CD70E0E50503C84FE25F0612F84A2D9408ECE5C87F6D2B54C2856FBEB19E0899943A319CC1EB9E92DDA86746E9139F951B9E9B50A4812F7ACC10B10B6F1FE57EEF9B7D4302583498D19509B511404AB13ED71A1A80AF33AE0FE';
wwv_flow_api.g_varchar2_table(54) := 'ADA2EA55B2C4F363E80F409EEF0FED3A16A049C0CD9AF58A94E3B2AC18E098DF49D4C7C259FE75685EC8A9AEED5365CCCFFD429A251F794E511CC090205F24BC27CF00A7F81BC56D92C172E167B29ADFD6DCC7FC8B26B7CB15DE2737DD29CB9A2F974520';
wwv_flow_api.g_varchar2_table(55) := 'D52B011E903BD7BFD069AD04014C263941112D5F295A2CF371BF847B45BEEFA85CE17F6BEDFD2329CF1A818192C9A98C4CAA0F907BCE45E679AD8379EAC376A47BFA84D5329FF238945581EB931D295CF64A4D0FD24B0B380AF4A6F6CC8FF566AD974021';
wwv_flow_api.g_varchar2_table(56) := 'B668AB9438C4D12BD93B6C40CD5FAA1DC063F008EBD74B500724E8439A5B57B72BBA90DE2ACBDCA14D0F96359299F66A6373524BA37D9A97ED4E85F2263D6EC091051D14FDD764A5D615AAF959754510B35F7D2FD0FD468D1CF709F8F43F5EC275C337D6';
wwv_flow_api.g_varchar2_table(57) := '89C59168C352E79CE65ABC01168A55926FA79C45B159735A7DAA83D58A277EA271FC8D142A2164CC8B8A3FBE686F186D791A2BAFBCCEE4EF6B077051186956C8622980D0F65C0CCC7DCB023D3490F0947F9396462437377D24EB3D2840D6CA0200622AFE';
wwv_flow_api.g_varchar2_table(58) := '0B77C992ECDBDAC487F82DA2C14017E9F64E5D0006D603DD6B8953CEC57A10DAC33FCA00A780CDFEF1FB8A111E56B0B654FBE639791DE6793653BEA500EFF7B416EE9542AD55639E5AA10027D469B21C4AF70CE5DA24F8AE4D4AF39FEA816C04FD9E5CE5';
wwv_flow_api.g_varchar2_table(59) := '091D5F58943739CD696D12005602383DF26FBF5020862274E81E618E432E4579E425DEE0EB42079AADBA663D0A3008197027434FD5CC491D7228F625056165DB41077071BFFF23EBDCA6980280511CBB05AAFEB6296AEED6F995D3A1D92305E089D825D1';
wwv_flow_api.g_varchar2_table(60) := '39A576C40725C7AE8C11DCD0ABBF543B80C7E1130123F023726FBF94156FD004E702149A1041E39ED9BF5D2A011EB7E63BF5010382FE3142FB4E39820760756B531A5CFA1C95548125DC264D1BDFBF25D970716D503656033DE2FF470AD276CAF5FEFBC9';
wwv_flow_api.g_varchar2_table(61) := 'D0ACD306F33A79A13E5931DB9BAD92EC363D80B84D4BA4931A0B411989070DABB52676530779CEF527355C4F94549F6A07B0F884713710378731EB12A4F0A0E83DCD93BFA1E77C0B6469041F086E50823DAC206C8F5CEC7DB26A1E1D925C7B4B938C1432';
wwv_flow_api.g_varchar2_table(62) := '5C02E8F0A160877200250F91718C975C59BA0F2C719922FB955ACE25AD930E194F336B5759E55BDA6F5EA34EDE1580BBB4F1F1FBEB73F6A503D6BB047958EA6A6D65AED61FF6A33024FBE850D73C59622C281FF3363221D84B2CDB56F5F2E319E0440870';
wwv_flow_api.g_varchar2_table(63) := '86B0D8F56916F30C8DC1720F5EDCB33F8B951EBB1C9AE57A364B2E8BFE338AAEF709782D8935E858EF4825CB11961FD0822E22B782D235588A947DDAC473DEBC484127AB6B15A7F54077A313BCE0B22D0DD1A71FFAC093B8F6E542B716A742CA71DBEB24';
wwv_flow_api.g_varchar2_table(64) := 'C51F5ED026C7A18C79428F0C37F0944C968AB7726B6FBC142927F0B96E515F0882B19CD298D91C618591B7D2B155BDFC7806B8240ADE503CAB2089C7764E9B2F481AAD0C5207E59F0A8CFF5320B44451250FBF791180E877AF06CC12665083E53516DE61';
wwv_flow_api.g_varchar2_table(65) := '624BB1450B4F6B656ACF6E1234588B02D02959542433B84ABE848585011AF20288B1928AAC803B757155FD9FBCCA5B2205FB8A11BB5224D736B94BC06F52A76C9FF28A0E411820AD91247FACB8E1C3AB19F398DCF25DDAE6E40D139E32E199E09B041D9E';
wwv_flow_api.g_varchar2_table(66) := '47F70C86E69C2270A6A9B7358713E12F553D3C19758A8E8B265525CF00B35393B81D9E92749FD052456B400400D317C4F5422BF544280CE87501FC0B45A2B82A5707F7C83204A1F3F6E55E0532C73FCCD83A8C1659B14459002D353AAF20ED05BDE3D51C';
wwv_flow_api.g_varchar2_table(67) := 'B22C4AFABF2CA59087B7164EB006EDF2441ECF6897AB0FDE2CF93BBDDD910D121AAE41793BFAA65B94EA8CDAF054C8BD3EBB561D9ED718BFAB8727ABB505BA41EBE1D5029800927535BE8C77B150CE63527640E5053DFD6B89F6EDCA72FE7CDC7B06B8A4';
wwv_flow_api.g_varchar2_table(68) := 'F11AB7392201F44AD3110882C152008E6B0EAC0F2BF8B9AC1325208FA899371CB92631375D925B3B2640251B27770B2E1B0DD443DB3F90353087D12FF5105A9BE8E83461A25FFAC072F68B0F5C2E345CFF6335A60CC1A160B4E51E3A80CEABB4E45F56C6';
wwv_flow_api.g_varchar2_table(69) := '3B9A82DE907252064D12BCA2783CA1E2582F42D0A02DC6A14BAFC933C025F61834F3ECA252965DF6305897B8664DB832C5051688105C727596AB4E8AD4085AE42F56B9BAB3C2E69EF90FA0AF95A80BAF28DBD2B23E266A4B1BB709423DE890B066F8E804';
wwv_flow_api.g_varchar2_table(70) := '689DE11FE0A84F1D7BE8C7D58786F3002AF69E52A2F5419B6194120266002EB941A5EF1100037469AC3A14B3CC49A7F27A58403A9597A7CBC6BA1EAB8FB1EAA5F3C6EA83BC342DEE5D3DC7A2031C5AE972EE7D27CF00BBA194D81C9D532A73573EEA4C86';
wwv_flow_api.g_varchar2_table(71) := '86EB6FBCB30F1A8E769A9603D695714E97A7F37D5FE34D3CA6B186E2917C83D49425E019E0E9D2CB298F73CE36F00CF09C9563DD0EBC0170DD42E387B106C07EE458B7543C03DC08B2AA47DAAF0CAB02F84077773AAA4A9EAB553FC2B94D813DF014C665';
wwv_flow_api.g_varchar2_table(72) := '329EB26CAA0278D3F6ED9695286F77E6F5A441B769C8A7CCCE1C6F80EC8A322CCAD43819572A99AA363A9C76E5E338D6D397E44943B2A79ED2C14A599B83ED901D000B6664CA859331D795A4AA003666BBED330CE34FB4037B30DB9EDD34D0E31E6D57C2';
wwv_flow_api.g_varchar2_table(73) := 'CEDC6EA367DB85A6F66C34D8533818862D9229299171723DF5DFEA1C2A6F7963B94ADB5EEDFB6610852F64DB9AD9636FA40A253074B9BF47EF84FFE1EB8FB6FEC09248C9B81292D5014C8F29061E7DADEF5E4DC2DF50E602C1AEB7D0AA9AE22B19CFAC6C';
wwv_flow_api.g_varchar2_table(74) := '53D0DB0E8A6224ACE0A27CF37FBCFEF5D677EC4052B29DD981C14823F995802799FE3FA4BDB17359DB587D0000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72353343329797191)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/mpeg.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000001B569545874584D4C3A636F6D2E61646F62652E786D7000000000003C3F787061636B657420626567696E3D22EFBBBF222069643D2257354D304D704365686948';
wwv_flow_api.g_varchar2_table(2) := '7A7265537A4E54637A6B633964223F3E0A3C783A786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E352E30223E0A203C7264663A52444620786D6C6E733A7264663D22';
wwv_flow_api.g_varchar2_table(3) := '687474703A2F2F7777772E77332E6F72672F313939392F30322F32322D7264662D73796E7461782D6E7323223E0A20203C7264663A4465736372697074696F6E207264663A61626F75743D22220A20202020786D6C6E733A786D703D22687474703A2F2F';
wwv_flow_api.g_varchar2_table(4) := '6E732E61646F62652E636F6D2F7861702F312E302F220A20202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F220A202020786D703A43726561746F72546F6F6C3D2241646F626520496D6167';
wwv_flow_api.g_varchar2_table(5) := '655265616479220A202020746966663A4F7269656E746174696F6E3D2231222F3E0A203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A3C3F787061636B657420656E643D2272223F3EAFC2E87B000001866943435073524742204945433631';
wwv_flow_api.g_varchar2_table(6) := '3936362D322E31000028917591BB4B03411087BF248AA2110B5358081E122C24118D22DAF9407C201262045F4D725E1221678EBB0B229616B6292C7C6063101B6BEDC47F401004B512C1562C146C44CEB9448888996577BFFDEDCCECEE2C7817B2AA6ED5';
wwv_flow_api.g_varchar2_table(7) := 'F480BE6E9BB1895165617149A97BC2431301DAE948A89631128DCE50D53EEEC45BEC36ECE6AAEEF7AF35AE6A960A9E7AE161D5306DE149E1D90DDB70794F38A06612ABC267C221532E28FCE0EAC932BFB89C2EB1D7CD1930E3B131E180B092FEC5C95FAC';
wwv_flow_api.g_varchar2_table(8) := '664C5DB85F38A867F3EACF7DDC97F8B5F5F9395797DE86458C09465198629C3106E86548C601C244E8961555E223A5F8597212ABCA68B089C91A6932D88444CD4B764DE694E89AB4AC7888B97FF0B7B656AA2F523EC13F0DB5CF8EF3DE057587F0B5E338';
wwv_flow_api.g_varchar2_table(9) := '9FC78EF355049FD4E56AB7129FDB85C157D10B152D7804CDDB707E59D19227705180D6472361264A924FBA379582B753685A84961B68582ED7ED679FE23DC4B760E61AF60FA053FC9B57BE010C5B673DECD09369000000097048597300000B1300000B13';
wwv_flow_api.g_varchar2_table(10) := '01009A9C1800000EC649444154789CED9D7F901C6599C7BFCFDBDDD3B3B3BBC9262424010304924B42220430D18078207775FC925261F74ECE5F7F58A548A15584A0525639565996963F4BEB440A2D3DCD2661672FFEF6ACA3140AB510E58E1C71C11894';
wwv_flow_api.g_varchar2_table(11) := '102284CDAF4D76677766FAEDF7F18F99D999EEF9B13DD33D333DBBFDA9EA9DAEDE7E9FF7EDFEF6F3F4F3BEDDF30E1000CCA020EC74124E2605A3FB8FC38DEF03620611810120F7E0ADDB6CD8B731D100142B21FC37B035088059B15271C4FA4F60E9050F';
wwv_flow_api.g_varchar2_table(12) := 'F7DCFEA597786450C3604A158F673EE04BE07271A7BF79D31DC4F4AD78C258ECDF723B20802D403F0732B6E217BAAEDD45EFF8DC617E2CA9E3BAA43D5F44F627F0C8A04643299B1FFA975559D61F35FB8C4D99C9AC0550687DB7041194A5447CD94C6CE9';
wwv_flow_api.g_varchar2_table(13) := '05FD52DA4FEA52BB93DE35BF44F625442A95FF9C51E26256BCDE4A5B2888DB050B13083A0048A9A6F4FE9EED5297C33C72DF1ABA3E29F178529B0FB9852F8107376D620020C5040215CE0675C7526C2E3480494ECDB09E885F2D894A227FBAFB45F6E7C1';
wwv_flow_api.g_varchar2_table(14) := '636304002C88013075E1A96028001060909CCED87AAFB95D120DF30F765E42C9A4446A4474B3C881787001EACE1B96008858080233914C676DBD37BE5D5AD89319DEB98E8686EC6E1639D064A82BCF000030E7D329820040329DB1F53E73AB666298473E';
wwv_flow_api.g_varchar2_table(15) := 'BEB69B45EE826CB7F5101183000233502672C2DC2A61EFEE669123810170D1834B08A018AECDAD92D45E1EB97F7D5EE4C1AE12391218250F7691F7E4E9ACADF7C6AE92C47BB3A33B36D050AAAB448E0446C183AB5308D7595B4F985B048B3DDC65224702';
wwv_flow_api.g_varchar2_table(16) := 'A3E0C1B5297972C2DC2259ECC9EEBB7F63B7881CA8C0DDD94D2A50BFF10E9149AA11DE77DFE692C8352340C789BA4945E66E7C41E48C6DF4C5374B457BB2B3220F8556E42844374621BBCED87A8FB99964F8458E046E9CBCC8D319DBE835370B457B727B';
wwv_flow_api.g_varchar2_table(17) := 'EFBD9C8652762A352438990CD5390D55633A45957EF05C0806849CCE4A3D616E265DDB931BBDF78AA1A1948D4BC7284C224749166AF683EB970111C09A4C67A59E303782C5EEDCE8BD5750C8448E922C5F9444367AE31BC062776EEFCE2B692865E353F9';
wwv_flow_api.g_varchar2_table(18) := 'F7BC3ADDC2C8838B34D1F87C91329113F10DA461776EEF8EAD444905745EE4C8838B34D178824BE4E9ACD47BCDF5D0282F7232A93AEDC91D0F2161A089246B96D275E1F0E4B5A489E130787224309A4BB26A599AF5E484B98E34319C1BB97F1B253B2772';
wwv_flow_api.g_varchar2_table(19) := '2430EA3E6C6802A7C820DE6B8DDCB7BD5322470263CE870D4D592C8A6C24CC350CDADD2991238111B407172913B9D7BCA853224702A3E0C12DE9E3B94426DA638D7CECCDED1439EA07B71C47B8BE9084DA6D3DB2E32DED12590FD258D7F7835B76853A12';
wwv_flow_api.g_varchar2_table(20) := 'AFD5F64C769795DAF9EF3498FC35331303A22878D0042A70443DCA44EE89ADB632B961EBBF76BC9B889E600618C996881CDD83DB4A41E4999C34E2B1D550B4DB1AB9EFAD44607C2AC9AD08D791C045DA96401001D0E44CCED213F1F389E8FBD6BE329139';
wwv_flow_api.g_varchar2_table(21) := '5891A3240B856E527B1308024197D3594B4B98E7C1C62E2B75FF0DF9AFAB062B72F4B0010AA8D24D622F0B97D6BD944161C4BBF08700D6653A63E93DE62A027FCF1AD9F1CF4460A2A41A1919D48238BAC883F3D33910C839D788A7EFA05269DD4B1914EC';
wwv_flow_api.g_varchar2_table(22) := '3B1E501019722627B584791E91D8658DECBC11008686527610F7E405E9C18E0B91C0449A22121042532404B77311423009D254C6CA69BDF1734913DFE51F7DF24600A06452F97DEF7A417693F25D5E86200196192D3D793CA398A68ACF0C79769F6AE54A';
wwv_flow_api.g_varchar2_table(23) := '1732BBB6B16BBF6A65DD76663F19A0339832746D4536677DF9B5AFFDEBA1151F79E42F480D0A2065377BAC0B52E0220C01D8332667A7B4A92CD86626419DB9D514C43608B089C44690781D80BFE0B94D0CA49AB6BB60052E790F518FA11B448CA91C4331';
wwv_flow_api.g_varchar2_table(24) := '20DC2E38A7FBA1BADB36589601C434819CB4A5B2A50CE23817ACC040E9FC2A804D3D1F7827CB4466F7CEEEF55A9FD52AF2509600A5983510916EE4A5294E93D12C0B7EA0A398DD32834C8DA83F462400520A046EEF522DA1724D93D1300B5EE0721880A9';
wwv_flow_api.g_varchar2_table(25) := '11FA4DCA7B70A76EC60112F5835D745CE480EB5B90FDE0B9E8A8C861F6E0F9844364D1A1701D0091C075981539D64691C31CA2E7231D113940A224CB03DD2C72946479A46D228739C9EAA20BBB291C2213A05A71C061BE07CF670F2E529E5DEBADF0E430';
wwv_flow_api.g_varchar2_table(26) := '7BF042A1DC9335D1224F0E8848E026C93FF9C98BAC0729729843F442C32D7218B3EB48609F948B1CC6701D091C008186EB28C90A27610DD791C0011248B88E92AC70332B72B3FDE42844871F0610137991B50E87EB48E016E116B953D97524700B291739';
wwv_flow_api.g_varchar2_table(27) := 'D0C1900688046E3145911799A223224702B701066008A0BF03224702B789BC27B75FE448E036521479912960D41239EA077737E5E1BAAAC8513FB8FB51288A4C9522471EDCFD14BFF46608AAF4E4C883E70FEE70DD8A11AF48E00E530AD70286A0C0458E';
wwv_flow_api.g_varchar2_table(28) := '04EE3004F73DB9E9C9E7AB12091C028A22EB658997B482B1BDA0BFE11F264A8917D01F13C8E9C1F871247008D1056006145BA3101D42184040113A30810B535D94D623C2415021DABFA8B13E68175D0B5A7A11283100E831F0A92350C75F008F3F079E39';
wwv_flow_api.g_varchar2_table(29) := 'E9AD214BD682FA57D6DE816D70FA2478F26F8095F6DC3C5AB41A3470612DA3406E1A9C99003213E0EC19805B32BF77C3042B703379819180F1E67BA0ADDD0E6886F37F176F9B5DE5C9E3B07EFD30D491DFD635A7BFFE366897DEE0A96ACE4D83A74EC27E';
wwv_flow_api.g_varchar2_table(30) := 'FE57B09FFB1160676BEEAB5D721DF437FE9B27BB0083B33350479E817C7A187CE6258FE58227D010DD70A1813530DFF95568EBDF5229AE7BDFFEE588DDFC09E86FFA1040814CC40A8A252096AE8671CDFB600E7D03D4FFBA40EC02043213D0D65D03F38E';
wwv_flow_api.g_varchar2_table(31) := 'AF40ACDC1290DDC6F12DF0CC8337974FB8EABDE25557C0BCFD8BA025E737508AA06F791B626FFF32C81C68B4CAFA9617AF44EC1D9F07F52C0BD42E0C13C64D0F80FA56056BD723AD48B23CD46AC0F8C7BB01235EF93F2B03F5EA9F60FFF93750270E0376';
wwv_flow_api.g_varchar2_table(32) := 'E58C7E62C55A685BDFEBAD2E56E0F469707A029C4DD7BD37526200DA55EFF6781028D83D0D9E390BC8DAE19DCC5E6897DFE1D96E907424C9D2B7BC0B34E0BAA259C17A7217EC0329A7087A1CC6B51FCD87F1721B1B6F80FDEC0FC0675FAE5B17A74F23BB';
wwv_flow_api.g_varchar2_table(33) := 'ABFC622020D6071AB810C61BEE84B8E07297DDEB61FFFF2878F268FD836046F6FBAE8B813488E51BA15FFB4188E5173BED6EB80EF2770F0176AEBEDD8009C2831B0AD1D4B70AFA956F776EB42DE47EF619D8CF3E52E9613203EBB1CF433EB5C7B95DD3A1';
wwv_flow_api.g_varchar2_table(34) := '6F7B7F13CD652037091EFF23723F7F00D66FBE536977EB7B9AB00B806DA8F13F22B7EFA350A75C178811072D0AEA1EEF9DB60F7468EBFE09D04DC736FBE01350479FAA5B4E3E330C769D346DED1B41E7ACF7D51E7B6C1FF8F4DF5C6DBC1A9438B779A3AC';
wwv_flow_api.g_varchar2_table(35) := 'A05EFC43C566EA3FAF799B4DD2FE9F3B3D7FB37383B2219F79C4434986DCFF43D7368258B9C95F835841FEEFA8CBACA8D3E7F5863AF142E546C3ACDCD662DA2B30098895EB1C9BD42BCFE7071D3C601FFA1FC0760EE2D1A23A831A1E51C70F566CF36B57';
wwv_flow_api.g_varchar2_table(36) := 'ACBCB4621B1FFFB32F9B4DB5A39D95517C494578E6C9E3DE0DB00D4E9F76DA5CB4C277BB78EA58C536EA6F3E44D3D275D0D65DE3AC239B069F9D23716B014164D18539B53D105F525938ED6D087276FFE909D0A2D2C9A7FEE50D95AF8A9D0567D320B3D7';
wwv_flow_api.g_varchar2_table(37) := 'BB5D026879DE4B491840EF32505F7ED1D65F073213CE769F7C199D98682AA86E52E16781EA43F1C59505A71AF060003C75CA693308810160FA0C502E70DF5C031E04F3F62F7834CE90077ED274D3FCE03B44F7DCF5F3D9CB72EEEBB38AA3373AECA8B9AE';
wwv_flow_api.g_varchar2_table(38) := 'C9563DBB0A302192FB7F0AF5E2E381D96B84A03C5801739F6B9E3852B18DFA1AF340EA5DEAB43979A2A1F2354938A30B4F3676EBA80A2BD8079F807CEA61FFB69A24D0103DE74E33A7002BE318A29C3B143AA15EE77D9CCF3616E2ABA2C51CF75F00E0C9';
wwv_flow_api.g_varchar2_table(39) := 'F1B9CB950FCA585970762A3F1C9A498327C721F78F82CF1CF6DF3E1F04FBCACE9CE192A1CE1E87386775A9C8E206B260BD0754E169AF792F5F03EAAD6CC39C023323F3D0DB7CD7DD6A82EA26790AD140E589132BFF01B46C83A74AB4CDEF04C8D9643E1B';
wwv_flow_api.g_varchar2_table(40) := '80C04B2EAAD8C6675EF16D370CB4A21F5C375CF36B959D7DFD4A0F0FD2B518F4CB6EAEA84ABD7AA091B65545BFEC369759069FFAAB6FBB61A0ED4395F2C068C56085B6E60DD0D6DF5ABB106930AEB927FF2A4F19F60BBF039FAC1C856A0471DE5688F39D';
wwv_flow_api.g_varchar2_table(41) := 'A34EEAE80170BA72F0A31B69FF5B953203F9B4EBB7F888605C7F17F4ABEF06F41EE7BF12CB11BBE5B3D02E7DABB38C2D217FFF9FCDB5418F83165F08FDEABB11BBE593954D1CFB4573764348A04996D7711AFB4F3F817ED92D156F73E897DD0CFDF53742';
wwv_flow_api.g_varchar2_table(42) := '9D3A0A2E2463E5A356E5C8E77F39E7B36020DFAD32DF5F7A98419A5EFD458362DB5E7A06EAF0131E8F24FC7466427056B01EFB3A383D51C5888038E702686BAEAA29AE7AF520EC3F7CCF63A30814EF9B5DEA89CB5327211FFF0AE6D3DCF51D9BD25F8D1F';
wwv_flow_api.g_varchar2_table(43) := '402E750FD4CBCF36500143FEDF0F91FBF14E70B6CAC5D12CCC90638F223BF261CFAFE7760B1DFDEA0A674E21F7B307A06DB913FAE5B7807A2AC7AA0B7B82278EC1FAEDB7A15E7E3298CA950D9E3A053E730CF2E9DD50AF3570A17511810ADCDCB030C3DE';
wwv_flow_api.g_varchar2_table(44) := '3F0C7BFF3028712EE8DC0D10CB2E01F52D879A380A1E3F0475E2792037E5C99ADC3F0AFBD0E3F56B4C1F074FBE02B0F71FD6B60F3D0A756CCCF3FE61A1234956CDF2D3E3E0C3E3BE921C3E7B047CB672CCDB2F3C75ACEA73E3B013FDEACA3C27FADDA479';
wwv_flow_api.g_varchar2_table(45) := '4EE4C1F39CE8FBC1F39C48E0794E24F03C274AB24246D0E7D097C0A9B1B1F2BC8AA324CB3FEE73E83AC70DE34BE0C14D9BF2AFCB2A26001496DF0AEA6666A7ACCC9FD3D973DC2CBE46B28A57976E684A4A2EEACB685FB47644101F656BD1EE4B367F1219';
wwv_flow_api.g_varchar2_table(46) := 'CC8218E8B4070FE63F732C5F04E8A0D16BA0F0AA61AB16762DB5FEE7C54623F5B5F298CA165646AF011274B047A8BF969FE366F175753083A830B5E2F47FDC7487D0E861B3C718F06FB95A658E8FBA50ADFA2B6CD4B346CEB556271885A664A6736798F0';
wwv_flow_api.g_varchar2_table(47) := '81C487FE7B14709EE366F0DD6C87C80FDEBA8D60DFC6440350AC44B09D30727DD66C528D7572AD7B0DD12D9CAE3B8F52000409629ED0A0FD3876D74F7F0FF8171708E8BA0CA2218D5098F8A582F2AFD1346BA3597B4113D439FD3BEA99B40CDFCF8F7B00';
wwv_flow_api.g_varchar2_table(48) := '00000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72353700036797193)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/odp.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000001B569545874584D4C3A636F6D2E61646F62652E786D7000000000003C3F787061636B657420626567696E3D22EFBBBF222069643D2257354D304D704365686948';
wwv_flow_api.g_varchar2_table(2) := '7A7265537A4E54637A6B633964223F3E0A3C783A786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E352E30223E0A203C7264663A52444620786D6C6E733A7264663D22';
wwv_flow_api.g_varchar2_table(3) := '687474703A2F2F7777772E77332E6F72672F313939392F30322F32322D7264662D73796E7461782D6E7323223E0A20203C7264663A4465736372697074696F6E207264663A61626F75743D22220A20202020786D6C6E733A786D703D22687474703A2F2F';
wwv_flow_api.g_varchar2_table(4) := '6E732E61646F62652E636F6D2F7861702F312E302F220A20202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F220A202020786D703A43726561746F72546F6F6C3D2241646F626520496D6167';
wwv_flow_api.g_varchar2_table(5) := '655265616479220A202020746966663A4F7269656E746174696F6E3D2231222F3E0A203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A3C3F787061636B657420656E643D2272223F3EAFC2E87B000001866943435073524742204945433631';
wwv_flow_api.g_varchar2_table(6) := '3936362D322E31000028917591BB4B03411087BF248AA2110B5358081E122C24118D22DAF9407C201262045F4D725E1221678EBB0B229616B6292C7C6063101B6BEDC47F401004B512C1562C146C44CEB9448888996577BFFDEDCCECEE2C7817B2AA6ED5';
wwv_flow_api.g_varchar2_table(7) := 'F480BE6E9BB1895165617149A97BC2431301DAE948A89631128DCE50D53EEEC45BEC36ECE6AAEEF7AF35AE6A960A9E7AE161D5306DE149E1D90DDB70794F38A06612ABC267C221532E28FCE0EAC932BFB89C2EB1D7CD1930E3B131E180B092FEC5C95FAC';
wwv_flow_api.g_varchar2_table(8) := '664C5DB85F38A867F3EACF7DDC97F8B5F5F9395797DE86458C09465198629C3106E86548C601C244E8961555E223A5F8597212ABCA68B089C91A6932D88444CD4B764DE694E89AB4AC7888B97FF0B7B656AA2F523EC13F0DB5CF8EF3DE057587F0B5E338';
wwv_flow_api.g_varchar2_table(9) := '9FC78EF355049FD4E56AB7129FDB85C157D10B152D7804CDDB707E59D19227705180D6472361264A924FBA379582B753685A84961B68582ED7ED679FE23DC4B760E61AF60FA053FC9B57BE010C5B673DECD09369000000097048597300000B1300000B13';
wwv_flow_api.g_varchar2_table(10) := '01009A9C18000013BE49444154789CED5D7B701CC599FF7DB3B3EFD55A0F5BB22D5B3296651B61B08DF113434CA020392C037748C181A3AE0A92BB4AAAB84B2E75F70F8997ABA4AEEEAA924BA50A02315448B0659FC51D04921497E4306F30D8B2657236';
wwv_flow_api.g_varchar2_table(11) := '36D89665D9921F7AADF6216977A6EF8FD9C7CCECEC7366B5BBDAFDA94633D3DDD3D3DDBFFEBE7E7C3DBD8011608C0C89A790F0783830947E3E54D09F21C608440C00367FF0FC0641C00E22AA6610452E213007408C9C11B94E15265BFF647EAA7BE2C0C0';
wwv_flow_api.g_varchar2_table(12) := '4426C266E3B86B2EBB75F7EF6F7EF87C073B60EA468718CDCF6C00AFEB6919B91BDFD9FDA02862B7D9EDAC066044D5C93B44003C037881AD6BEF3DF0AD6EEA3CB7EDA0877F8B3161B690AC8BE00E7473DD80B0EE9DE71680238FB9BAAA3A343611020307';
wwv_flow_api.g_varchar2_table(13) := '02C080D81950922EF75387D1F223D97372A47A561D46199644C64481E7839CCBF915713ABCEFFEA3FB1E7A75EDCEBE6D07316B48D627C1DDD2C90CD35206B622ECF52342AEA483A3A46849B3DA8FB2F4D38A2BD53BB5DD790060A1B0CF52EDDA383DEEDB';
wwv_flow_api.g_varchar2_table(14) := 'DBDE7BE091D757779E9B2D24EB22B8BBE3040300C609046622108111884A4241032002034C0C60D35E3F335739B68427027BDB7B0F3C3C5B484EEC076583EE360200124D0C14ED8396525930404A3607C628E40D087C9563330942D78E232F2D7BEB0E4F';
wwv_flow_api.g_varchar2_table(15) := 'B803DD5C298F12F4111C916098219513034A45782548696520461C0710A3D0444030BB1D9B407CD7F6A37B5BBBA953D8F6D653A65225591FC1D8A5BC2DC92240641CCF00461C000A8DFB0573957D3DC7B8BD3B8E1C286949D649F02C41B48D9574100702';
wwv_flow_api.g_varchar2_table(16) := '85BC01C15C655F0F0AC524B91449368E60529C4A0B89A4C5497639D7730CFBDB0F77AD2C45928D2398294EA505ED5EB244B22F2098AB9C3713877DA548B2E1125C92484E96D4267B0382D9E558538A2497771BCC22829B7A9C1B976497630D38ECBFAF67';
wwv_flow_api.g_varchar2_table(17) := '4F5B37750A1DDDC54FB2B12ABAD4F43365CC8D24C9BE80607139568B8CFBCF077AF7AFEAEE2C7E928D95E0A2CD6612645721E324BB1DAB4451DC776F09906C6C1BCC4A8CE3EC131B6B9379A76315172E7E928D55D1547A5A3A0770E040A1898060A972AC';
wwv_flow_api.g_varchar2_table(18) := 'E245B66F7BCFFED531923D9EA2EAD7547AD140F62B52183846E042BE409877D957714CDCBFE3937D6BBB3B3B858EB6362A26927526E4A9F8652976B2A2C8C15A14B19899421381B0D9ED58098E75ED38567C241B37174D281D2966AA73EE9048F6464816';
wwv_flow_api.g_varchar2_table(19) := '5857FBE1976EEEEEEC143CBB76A118482ECF6152CCF86F4882091491E42AC74AE24CFBDA8FEE59EF21123DBB507092F5ADE850A354243806C3122C57D7CB4313FEAEF6A37BBEEEA1473EF130C679000E1E8FD60AC2BCA3E02AA42860CCF04692646F206C';
wwv_flow_api.g_varchar2_table(20) := '76399711E3F6B67F5C7849AE100CE4D4C94A16534C5DBB1CADC4737BEF3FB67783873C0523D9F017969C96068C5EB81F239977395A4511FBB7F7746D2E14C986BFAC54FA590A18BFA88E4030857D8130EF725EC7015D8522B9A2A2817C7D7A43409464FB';
wwv_flow_api.g_varchar2_table(21) := '9242915CDE335999990BF520427230CCBBEC4B08D8D77EAC6BAB87223DEA1920B93CC7C151646E2ED4F516444836BBECCD24A26B47CFDEDBA3C3260FCB2FC91573E1CC202EC94EFB6280F64449F66017CB27C91573E1CCBE2D916422964F922BE6C29945';
wwv_flow_api.g_varchar2_table(22) := 'A4771D23B9ABFD48D797F3497279F7A20B531B090493E00F867897BD91082FB5F7CA49668672629CB910283DF18D7D923AE32B3188017CD8170CF14EFB420AB33DDB7BF6DD29910C43492E4F736114B161126360AAFAC922FEF2D101531F4C190F4BF36C';
wwv_flow_api.g_varchar2_table(23) := 'D47C15FD8E02E0C3FE40887739167060BFBEAF67EF5D20621E22B1E3C0019311592CEF61520C442002C92599246745C525F541B1C763FEA99E45247EC55BC81C19272F64A0BD3B8E747D0500BA3B3B0523C6C9E5394C8A7DE54F20E21871241200327122';
wwv_flow_api.g_varchar2_table(24) := '71C41407A9EE392EE2C669F865FAACDC8F63C49149084C4E9B5D8E7AE2F0E203BD12C9F07844BDCD87B1F6E05201011045504840382498FC216192001F63C9C679EA3D21B4FC928549F32C63510DC0C81FF491CDD2204C8B3FDEF2FE739F7F70EBDF9EE9';
wwv_flow_api.g_varchar2_table(25) := 'E896B6C9C82A7F32941FC1512E8840A2885070CA1A92CA414421751063603C6F21411088A3364EA44500CE447751C81586135CF45A3A267004D82CD2E2B9E9302F255C6BC7975439D2DA2546ED97E1B38C49CDB68507138470085C38DBAC694127C14F25';
wwv_flow_api.g_varchar2_table(26) := 'B8A4CB56514041B25532364C85244792ABCD343989659654F740C6CFCACE442442642630508C98C83619B9C2D82FFC4B09F2C2B55908169EC018453A35F1EB54873A1C327846FD6CECCC48648C141506886F939123CADB5C28EFFFD8AD80D51C1FBF160D';
wwv_flow_api.g_varchar2_table(27) := 'F40951651C2C27D96605AC16C9A1A07991BF3CB119CC06E5390E5643AEAEED16C05668928D2BC8F23617CA214FB84D4EF2CC1A8D8D46C55CA8464C5D4749C68C652A1FAF296F73A1168A40928D44799B0B534153924B2F83E56D2E4C0545EFBA90245786';
wwv_flow_api.g_varchar2_table(28) := '49F943C148AE0C93660E0521B9188749B31945A3AEB34785E04C51A2245708CE069A245351935C21385BA849B65BE226C6224485E05C2027D96A96882E52922B04E78A1221B9BCEDC17A5102241BB726AB78F2A401BDB52F45E6E4515BCDD279725ABE5A';
wwv_flow_api.g_varchar2_table(29) := 'B2A098A5AB2A8D2E58797C696A7291915C026D70C2E704191C33951E15F2A2AEF5CD4517E9B2D9C2ABB6CC205F5E0BDDEA5A3B4431CD45436F535CAA26A924E9CE529267B1C1BF548955433FC946A308089E0DC4CA21CB4F110CA10A48F06C915A2D50FC';
wwv_flow_api.g_varchar2_table(30) := '9429C979E2BD4004CF5662E520C509406A92F354240520B81CC88D2257756D9C38CFF066A4E5446E1449D4B586158A34AE8A674D5604C9EB5E39921B8586BAB6C8488E40BBEC8A651C9C92BF7226370A8D3288920CE4AD776DF8AF8F5690252C66E9CB46';
wwv_flow_api.g_varchar2_table(31) := 'CACF6721C64D552615D28AF4C6216F8811FFE02DFAD96A28E7AD389222CF125C213725A27C33A654D7526146B829B24E5605E940DAB70480E7E2AADA0C6C7CEF8522DB270BC9BAFA156402CAC3D72145664D2A1768577E16F53250368C229894D715E9D5';
wwv_flow_api.g_varchar2_table(32) := '05494A380068EC3FAA8B236325B822BEC6A00825D890786A792BB6CD5988FBEB96A2CD5E0DBE0816ADA5829D33E116D73C3C38AF055FAE6EC4329B1B66CAB42832CF9B9ECE96EE71F0C6F75E208071F1D9B8CC136E23131E6FBC116DEE7A343B6A506775';
wwv_flow_api.g_varchar2_table(33) := '2AFC43A2804B412FCEF8AEE1E7FD3DB830ED4F19DF93D76DC2BD0BAF4FEACF18E00B4F616C3A88D1E92046A603787BB80FFF33DA9FB1F2D9E8AAC7CEC6556872D660BECD0D4E550945C6707AE22A7ED97F046F8F0F66186B52E8161CA3263A482AA1CC75';
wwv_flow_api.g_varchar2_table(34) := 'F46A672D9E5CBE0D8B1DD549C39839139A9D356876D660535D339E3FF709F65D3995725BD054158C08709B6D709B6D6872D60000EE685886C7FCA3F8C1A98338191C4B99E67F6A5E8F0716DD98B20A734458E9AEC7BFADFA2A8E8D5EC43F7EF6BFF08BC9';
wwv_flow_api.g_varchar2_table(35) := '7625544D7CE4010551D15FAB6FC5D337ED4849AE1A0EDE82275A6FC5CFDBEE418DC992FE812CB0D85983A7576FC72DAE7949C33CB6E006FC651A72D55853D388EFB76CC93E4106726E04C1041689278384ADB0CFC1B75BB680E794AF16988873BE611CBC';
wwv_flow_api.g_varchar2_table(36) := 'FC055E19F8143D230318990E243CBFA6A6114F34AFCB2861226338EDBD82D3DE2B38E71BC650D00B6F68126131F1975E1D260BBED3B219A62414DEBB606582DB95C909BC79F973FCE2EC4778F3F2E7B83AE94B08B3AD7E19EEAF5B9A517A29E1423F8C50';
wwv_flow_api.g_varchar2_table(37) := 'D104A9A2A44D164F84275B6F878553EE563F1018C3BF9C7A0BC703230A771308DF5EB41A0F35AD55B475F7CC5F89D72E9FC651FF70CAF70585101EFDF4B709EE0E8EC7C3F357E2AF1A6F44B5C51E736F71CDC5CE86E5D873F99422FC4AFB1C2CB4CF51B8';
wwv_flow_api.g_varchar2_table(38) := 'FDF0E49BF8ED485F42DC0FD5B7E21F5A6F53B86DAD6BC2ABC36753A61590ED65AA21281BDF7B813BB4F5B1AC7F83D818098EFF575EA9F037F3DBD05AA55483A7BC57F068EF6B09E4028000869F0D1CC30F4EFC51E1CE11E1BB2D5B72AEE801318CDD97FE';
wwv_flow_api.g_varchar2_table(39) := '8CC77B7F834941D93E3EDABC0EB5BC55E1B6ADA649713F3CE5C7EF34C80580FD573EC7E989AB0A37759ED34296317B70AC28C6C194897AFED2BC4455F5CCB98F1148DA0991F0A7B1011C19B9A0706BAD9A87BBAA176595483506A603E81EE855B8B9CD36';
wwv_flow_api.g_varchar2_table(40) := 'DC5DAB2434A84A5F9DD5893B53BCBBEB422F5EBED08B97CE1FC12FCE1EC2FE0BBD059BFA31AE179D2607F5BC0DCBAAE62ADC8E8C5CC021DF958C5EB0BBBF07EB6A172BDC5A9CB5F8E3D840560955E3C54BFF87BF56B5E98D36B7E2FEF844621A7F78C3DD';
wwv_flow_api.g_varchar2_table(41) := '7874E22A0E5E3983D7AF9DC1B5F054CCEF8DD17EBC31DA9F610AF2DB93368A60962E8D6BAAE625D48213DECCC805805EFF30A68430ACA6789217DBDD299EC80C7E310C6F68126EB32DE6B6C056A508F3696004E7FD236876D62ADC9757CDC3F2AA79786C';
wwv_flow_api.g_varchar2_table(42) := 'E906F48E5EC4DBD7FAF08791F31813A675A7CB28CCD8F7C135B2028CE2D2D444C6D13300D7A694131D0B6D73B4036709756F7DBE8AE03063F8FE67071114429ACFF3C4615DED627C77F96D787DC34E3C73FDDDD859BF1CD5060FE7728111044B46AE3412';
wwv_flow_api.g_varchar2_table(43) := '5CC327123C309939C10070754A390C59608004038915A75E4530009C9E1CC7AE137FC250D09B322E3367C2CDB58BF0F7AD5BF1AB35F761A93531AE44E4AF85368A60F5550248635E59D0B9D0CCCC19F2E3600833E5E8C361B26816F93BDE413C74F415BC';
wwv_flow_api.g_varchar2_table(44) := '78EE139CF3A51EA2014083AD0ACFDCB41D37396AD3865540562C417B75D64323398C52D1220096AA22F607C713DC166B484A2AD4DB5C8AFB74D29429E65A1C8AFBAB53BEA47575920978F6D2A7D8D9FB1B7CFD70375EEC3B8CE36397302D6AAFA7AAB6D8';
wwv_flow_api.g_varchar2_table(45) := 'F1EF37DC034BC64608680A742E6360C0984E568C589642223F0F24CEF3366641300109C6884B93C6105C6B51C63B9461BC67A726F0ECC5E3C0C5E3B073266C76CFC7F68615D8327789225CB5C58EF6BAEBF05FD7CE1892DE6C605C2F3A0DCE4E79111645';
wwv_flow_api.g_varchar2_table(46) := 'C514E58A2C260056396A61E594C91DD0D00AD9822752CC6601C06030DE37B073262CB156A1C1E2C03C8B03751607F60D9DC4B8AAC3151405BC3976116F8E5DC403C34BF1CF2BB629FC57B8E602254C30105BC9A1CD7598310C4D7AB1486660D850D78C75';
wwv_flow_api.g_varchar2_table(47) := 'AEB938E2BB9636F26F36DD9CE0763EA09FE06D731A134C7E0332096E73D4E0E9D53B14FE57A6FCF8EF1464BD7AED2CFE6EE946CC31C72B4E9DAA1948896232361CDAFA1883D406A7C51B43CA395E02F0AD251BD21AC96F732FC0FA3AE5ECD295C909FC21';
wwv_flow_api.g_varchar2_table(48) := 'E3C9046D9840F8C692F50A379131BC2D8BF7986F18DED0A422CC571B96A7ECF73A381E4E9372BA733C3C9924B406E291EBEA6001C676B2D2E2C5A11309BDCF1BE6CCC70BABFE02CD5697E6338F34ACC08F6EB83BC1FD99B387D24E71A642B3D5857F6DBD';
wwv_flow_api.g_varchar2_table(49) := '1DCD11BB70141F0DF7E18C6CF82680E1CF2AC3FD8DD50BF0C4E2B59A24F344D8D5726B82B5EC9C7F34F3C4A92438D70E16606C1B9C56B18419C34FCF7C889FAEDEAE289CE5EE7AFC72CDFD383E3E882F7CC318990EA0C5598B1555F3B04CA39D3E3C7221';
wwv_flow_api.g_varchar2_table(50) := 'A3A940AB89C78F966D8DDDF36442156F4595D98AEB9C7509240484693CD7DF9310CFAB839F61F3DC258A99B89D4D6BB1A17631DEBD7A0E039313B0701C16DADCB8AB7E19E6ABC6E7FEF0145EB9FA45DAF4C65064E6422022C199EC5070C8770507FA8FA1';
wwv_flow_api.g_varchar2_table(51) := 'B3698D221F0EDE824D75CDD854D79CF2F9A1A0173F3EFB514689E289C39D0DCB330ACB00FCE4F47B38A5D1717BC73B8803FDBDF85AD31A857B8B6B2E5A5C7313C2ABF1EBF33DF0A5D4369A852602C0C5A6B5BAD4F48CF5A2E5F88F0B3D383C3E88EFB56E';
wwv_flow_api.g_varchar2_table(52) := '45438643250686DF5F3A899F9C3F9C62094C6E38313E84A7FB3E4ED9D9FBD985A368B4BBB155C322960C0CC0CB177AF1ABA19306A43237E483E098DD3A15DEF50EA2E7E82BF84EF32DD852B704B556ED5E66481470DE3F8A67FB3EC67BDE2143123B2586';
wwv_flow_api.g_varchar2_table(53) := '313CE5C7B5293F5E1BFC0CBF1BE94B5B4305307CEFF45BD83C7812DF6CBE05D7CF69481AD6179E429F6F042FF4F7E0C389CBD927D0C05EB43E6DCF18072271D387CFDFCAC2789B78938909624604AB5163B2A0CD598B56470DAACD76F405C67032308C33';
wwv_flow_api.g_varchar2_table(54) := '935E84339CD25C60B6A35A65AC57E36A2888E1F094EE326CB238719DDD8D46AB1B0B6D2E8C87A77026308ACFFCA3B8144A5C6A941C8A995E91E34D1C0B0902F1B8E3A3CD8FBF1B2DE35CD369F84E770C2CABA5B3518C0AD378DF3B84F77548E9602888C1';
wwv_flow_api.g_varchar2_table(55) := '5030E7E7B341FFB41FFDD37E00BA97C626422A3EDD4324200FBFBA929FCF98672B9445950F9B92E19FAEB0E84505699058462CB957CEC88704579016DA0CE663D9ACE12B3A32320E973592974B716F46AA99BA0AC94ACCCACD482B244B284C39CCD0CFCB';
wwv_flow_api.g_varchar2_table(56) := '9633C959EECB60F0360EFAC6C1DD6D52CB1B02C0A55EB2134F753974C37430142D9EE87A82EE6E5D05A68FE08E13D247A39C4060A68CBE6E981D44E7512345A2669C201550A48C73852E15DD119160124D0CC4181803B19892497330D9510A50A4372F07';
wwv_flow_api.g_varchar2_table(57) := '3130E9F71D1823D1C4807819E70A7D6D7087740A41380BD029DEED0408221844207230D9BDFA1C3B987430C6A4957B9A85980D122B13931324BB4FE52E5D47D20716F94B920755FED4FEC9EEE56782C8BB9D00E85408D6B3F232CE157A8D0D042206001B';
wwv_flow_api.g_varchar2_table(58) := 'DFD9FD20387A9E773BE764664F5241048068992226D8F1F28FFA4B67C84E8AED230892619A222ED17BC8578C49578AD5FA2C1246BE311908208A5DC63CF2D1BA44CA2CECF58F83D8E3876EFDC6CB927BBC8C7381FEA4CA12B0F983E73708027610513583';
wwv_flow_api.g_varchar2_table(59) := '284AEA41A52462A52C46FC22678A7C482E95A7090C3C103908663098212DA3E2C118071017336C50842D820086300861308481D8B58098348B0CE0E434CAD98F6B0B49133120F66C34D1DA9D493905A9BE278B3E1BF317210220701C636CCC64C26B1F6E';
wwv_flow_api.g_varchar2_table(60) := '79FC6375D9E60A63EAA201098922B2A34CF488926C8E1CD17B13E21F9D4749112191118E1CD3B2EBB02C5C54BFC88F584E64E784E621B2C07066605099FE3FD28B7B4C172EB3D50000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72354070930797195)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/ods.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000001B569545874584D4C3A636F6D2E61646F62652E786D7000000000003C3F787061636B657420626567696E3D22EFBBBF222069643D2257354D304D704365686948';
wwv_flow_api.g_varchar2_table(2) := '7A7265537A4E54637A6B633964223F3E0A3C783A786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E352E30223E0A203C7264663A52444620786D6C6E733A7264663D22';
wwv_flow_api.g_varchar2_table(3) := '687474703A2F2F7777772E77332E6F72672F313939392F30322F32322D7264662D73796E7461782D6E7323223E0A20203C7264663A4465736372697074696F6E207264663A61626F75743D22220A20202020786D6C6E733A786D703D22687474703A2F2F';
wwv_flow_api.g_varchar2_table(4) := '6E732E61646F62652E636F6D2F7861702F312E302F220A20202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F220A202020786D703A43726561746F72546F6F6C3D2241646F626520496D6167';
wwv_flow_api.g_varchar2_table(5) := '655265616479220A202020746966663A4F7269656E746174696F6E3D2231222F3E0A203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A3C3F787061636B657420656E643D2272223F3EAFC2E87B000001866943435073524742204945433631';
wwv_flow_api.g_varchar2_table(6) := '3936362D322E31000028917591BB4B03411087BF248AA2110B5358081E122C24118D22DAF9407C201262045F4D725E1221678EBB0B229616B6292C7C6063101B6BEDC47F401004B512C1562C146C44CEB9448888996577BFFDEDCCECEE2C7817B2AA6ED5';
wwv_flow_api.g_varchar2_table(7) := 'F480BE6E9BB1895165617149A97BC2431301DAE948A89631128DCE50D53EEEC45BEC36ECE6AAEEF7AF35AE6A960A9E7AE161D5306DE149E1D90DDB70794F38A06612ABC267C221532E28FCE0EAC932BFB89C2EB1D7CD1930E3B131E180B092FEC5C95FAC';
wwv_flow_api.g_varchar2_table(8) := '664C5DB85F38A867F3EACF7DDC97F8B5F5F9395797DE86458C09465198629C3106E86548C601C244E8961555E223A5F8597212ABCA68B089C91A6932D88444CD4B764DE694E89AB4AC7888B97FF0B7B656AA2F523EC13F0DB5CF8EF3DE057587F0B5E338';
wwv_flow_api.g_varchar2_table(9) := '9FC78EF355049FD4E56AB7129FDB85C157D10B152D7804CDDB707E59D19227705180D6472361264A924FBA379582B753685A84961B68582ED7ED679FE23DC4B760E61AF60FA053FC9B57BE010C5B673DECD09369000000097048597300000B1300000B13';
wwv_flow_api.g_varchar2_table(10) := '01009A9C1800000ED549444154789CED9D6B8C1BD775C7FFE7CE83CB5D72D7F2CA5ABD65B9B2E2489B5816A0C80FC4889A3AABF843E00FDE4D84F853D047A0479B36058A2240CC2F09101408D2C245DD241F9AD85AA9660B172912486EDABA4D0BA4492C';
wwv_flow_api.g_varchar2_table(11) := '65954A88E22892D6962DC9D25A5AEE8B9C997BF261482E871CEE929C4B7248CE1FE02E777678E6F2FEEE39F7DC3B7766001562262576DAA8548A45377C8F72E9812D3013881800C64EE53E02389F02F81E6648010188C047A82E8986ED33434AE6BE8489';
wwv_flow_api.g_varchar2_table(12) := '5B1BD7E05BA9BD74757C176B696659F83EDDA0602DB604EE274E2F3C4B4CDF36927D434A4AD602390C0C19C0709F7D8A601F7EE1E1F8E5D47FB29EFA189C6E811C08F0F82BACA527C8193BC51B80ECBF9943B1DDD9BB4B1635D76F958800B21972282E16';
wwv_flow_api.g_varchar2_table(13) := '37AD3393D2B27F6C4BFDD08B8FD0956E821C10441A0020E5E203007FC0CA582086C8DB0DF58B0102BB5D9463D973B141FD518DECE347A7787BEA00D9A9D7A175439F1C08F0EEF17106008D880010880082FB3EE4AF6249018D18B4346BB399D41F67D95D';
wwv_flow_api.g_varchar2_table(14) := '9003013E9F4E1300381A33000611D021418D4BDE3120C0A0ECACEDC406F5C724DB9387DFE01DA903648F031D9D5D2BF1E0BC08DC217451917C30090122A66CC676FA06F54749B327FFE8ECD2836922E763AFBFDEB19EAC3819EA9C3A286B8A6EC1990400';
wwv_flow_api.g_varchar2_table(15) := 'CADEB59D5852DFA79376FCF079DEF1FA81031DEBC9A1CF765B23375B66020310A07CB84EEAFBC85AF6E44E84DCB380BD942AA015219B097D9F4EDAC9A33FCB3ED489907B16B02744FB8F77050894CBD84E2CA9EF655D9C387AAEF320F72C600F9DEAB096';
wwv_flow_api.g_varchar2_table(16) := '3D39A9EF61294E1C3DC71D05B9670173F107AA7970E1FF454F3613FA1E76AC93C7CE6477A5899CF174F8212B06DC39C32400AB27FD8465C800E5E66CC71C341E7684F8C73F9EE2D1F4840B99430CB9678749359774794717B29B5D8F4AB64F7C7E2A3B9A';
wwv_flow_api.g_varchar2_table(17) := '9E206722C4907B3B44D72F375CCFDA8E91D0470553E821F72CE00024DCC42B633BB18431AA319D3C76861F7621A7452A950A559D86AA30AD94C783EBF73C0162919BB3ED58D2D82D8575F2F33FCF3D929E9870CEEF7A9E52290E4DBDF67692555003E77D';
wwv_flow_api.g_varchar2_table(18) := 'F32B1DB46CC6B66349E3210D983CF6F3DC23E90972CEEF4A870672CF26592A44EE1CA7969D75214B60F2C8546E6F7A62C2C1F3F9755E6D56E4C141C4EC422617B299341E02D389C36773FB5244320C907BD683959494C80339376BDBB1A4BE9380C9B040';
wwv_flow_api.g_varchar2_table(19) := '6E7B086997022659CBCA2F72F078F2A0B143101D0F03E49E05EC51D0C57554FC55F46423A13F486E9FBCBF9D907B16708D271BEA538927E732B66D268D1D6071E2C819EBB17641EE59C0359C2EAC5FE59E9CB16D33A16D67C19347CEB50772CF02F6A809';
wwv_flow_api.g_varchar2_table(20) := '538C45C873B61D4B18F743F2E49173DC72C8BD0D78B5D385016D17C6C9B939DB3613C6FD90CE896353D647534412680DE4DE1E07377354571AAE8B90B56D1274FCC819EBC9542A0F999B0B391A07B7E6582EE48C6D9B03DA16087AF9D894F5D1548AE4F3';
wwv_flow_api.g_varchar2_table(21) := '00371372CF86E856C71A4FE235A06D91CCC78F9CB39E24224E351172CF026E47ACC95F2EE386EB01630B244D1E9DB27E174D84DCB380B9EA1F4D970B79DEB6CC84B689995E6A26E4DE4EB28A6AF94A0C02A0E7E66CCB4C681B99E9A52353D6C79B01B967';
wwv_flow_api.g_varchar2_table(22) := '932C001557A015B73100E63A5F357CA6701CF73D7101F280B6114CDF3D72D67A0A449C2292E3AFBCA2A9F88A9107BB722F25652EB9F895EA7CD5F099C271DCF7C87FCAC80FA13682E8E5C353D64100484F4C382AC6C93DEAC1CB0D9118AC099282089A26';
wwv_flow_api.g_varchar2_table(23) := '2409E2D6BE0493469ABD2073B1A4B64E23FA873FFD251F0480548A64D059B6E03761E948B90B9E8510C8DAACCDCCCC2F01728E0B0D9439EF65E511A9B0AD50E7ECDDC69CFFD74A9F45C9BE65BF67684ED38D112B9BFDFA333FB8F1E6BF3C3D72693C0D91';
wwv_flow_api.g_varchar2_table(24) := '069C46BF698F02764560641DC4AE2FB186853996D2212281F6743504101B607284A00F02D80CE0D2EE71703A80D51E06EC7A14814833E306138116E7009600B569F42819C234E1D8399B58DA2A4CF6306060396C4A26230600E0A539403A79C82D1E2013';
wwv_flow_api.g_varchar2_table(25) := '4966A9B9C9978BA6709B8C46D5B3131DCB22D79199898C18515F8240822025B9DB5BF7E2D2F178DEF5CA6E9351B722C0A562061931503C09085118AFB6F0F8EA4D46E3E072B51B72414A7AE09E1D07AFA276412EAD3E45D95114A2AB292C9E1C5011E095';
wwv_flow_api.g_varchar2_table(26) := 'D46AC8E1EF83BB50AD84DC841E2E4AB26A51AB2087DF83BB24C9F2532B20471EDC665540968AEDAB3507289FAAEC620F2E280F190078B130ADA9E87B979A09E738B847E4F164AD39E13A1A07B759CC20C32C81AC205C873FC9EA317920EBA19C0C890007';
wwv_flow_api.g_varchar2_table(27) := '5529642DA027873F8BEE511520F7153CB941C851880EB13C9E1C9E701D0156A9524F0E1AAEA361524895872C42E2C911E0668819D00B901BF4E4681C1C727920D7987845597487A911C88A15016EB68A900757871C0D933A54CC806ED40659B122C0AD52';
wwv_flow_api.g_varchar2_table(28) := '11726BC37504B895F2846BA3127274BAB00BE4F1E432C8A57D70344CEA60B1F4871C7970B78856F66420F2E0AE5005E492181D797097A8245C5329E4907970DE8E7BF71845367B4454844CF1244837949EA050B5AAD2051C8E53A01DA83C644D07E949C0';
wwv_flow_api.g_varchar2_table(29) := 'B1013BA7C47260C063A716498297EFE914F96F83F2265ED20A0960001A0003F94BE5230514C35DF6138F2931A7A20F16C430018039EA83D58801584A2C05027CFBBA43703D584D738BA45C8100DFBD2D05DCF01C77B744213A6C0AD407DBB67BAF4580E2';
wwv_flow_api.g_varchar2_table(30) := '2A0A4300EE31086B4D20AE112ECD4BCC377C8FB7484040C0568E4B3D981A716002F07B23024F8C68F8D05A810163B90B6700B71719D7E6186FCD497CEF2D07D38BAB1FE485FD261246F5544002C8E41877B2EE6B260BFCEF4D07BF9EAF6EFB994D1A9ED9';
wwv_flow_api.g_varchar2_table(31) := '1E3C279DCE487C794A4DFF5A8B1A2EF1D8A945726C040AD1C326E18BBB75EC5DE77FE75C02B0364E581B273C7C9FC0535B751CBF6821FD96B3E291D6F51306CD5572BD01EFFF3FB353C7D47B12DF386FE17AB6D27AD200D60F04CF1FE7EDD6E6A0C1B268';
wwv_flow_api.g_varchar2_table(32) := 'F74EA8061A48B29E1816F8BB27CCAA70FD14D380CFED32F0F57D26B6C6D5561401D8739FC05F3F666274B07B0602410093941070A38059CF0737F511FE7C8F59D5CB66738C2BB3128B5526DC3F78AFC0971F31A13781C3508CF08551135A97300ED4A9B8';
wwv_flow_api.g_varchar2_table(33) := '4F5685568F1D02F067A306E2659F900CBC7AC9C6BFBEED14432401D8D64FF8F4761D07367B3D7D739270689B8697AEAC9E855D7C5FE24B6FE44004F409C2A0012475C2700C787AAB8EDDC3DE76BE3949F8F4560D9357976D9F9C76F0EA5BFEC7FA8B0F19';
wwv_flow_api.g_varchar2_table(34) := 'D837B25C3E0630FEC325DF7D5BBDAE52C54C56E11EE935697C8B5651A1B339C6D7CE5A78E38EF7EB33802B0B8CAF9DB770F696833FF9B009ADE4A3CFEE30F0C3EB12EF2EADDCF74B06E6F26C3260BC972B5807FEFD660E4FAE15F8CBBDA6E742FD677F47';
wwv_flow_api.g_varchar2_table(35) := 'C7E977256EE7DCFD2C597DEA41961FBEE478ED56C03EB808B666C04F6FAB6C53AFBC6957C02DD76B3724FEE36D6FCC8E69C01FEC0CDE46FFFB96C47F5DF312E9370887EE57F2D884B62A18E0E581514DE9F303035491895E9F67BC7AADB6E6FEDD4B0EB2';
wwv_flow_api.g_varchar2_table(36) := '65BB3EB446CD19CF6FFECA865DD6C6B6263AFF74B98A6F205123E0FDC39587FBD13B0E9C1A4757EFE518BFB8E525BCA68FD0AFC0D1662CC6FB65A17E5D7FE7675A410033B91E2C51E3CCF85A9FA1CDBB354C5C94EABDB2FD096E6450A19932C0C37182E8';
wwv_flow_api.g_varchar2_table(37) := '70C6813C580848B8AB876A3A7939E833BBF4CE427D806FF834886D036A42E9EDB2090E43001B629D4DB8E19A397D30CEF9E7EE5A00FCC704654A1895DB6EF8CC1AADA4199FFD37280AA5777C6C6FEDF0301DA8E96B3A245CEFCD035EB932EEFAF8F9705D';
wwv_flow_api.g_varchar2_table(38) := '5324C01A1F8FF203D388067C664E164232DC695481001B2615FADF45940E9AAAE81D9FC9FC4DFDF51561C4A71F9F5EE124413DBAB7AFD2F6E5F9D65FF2A9528100EB7A61E9012FD6B2FFB44F65ADAF734EF93E9FFD2F35097026C79855B43EB95D0A0478';
wwv_flow_api.g_varchar2_table(39) := '68581492AC3CE095615DF101F1E888A8799664480776DDEB2DF2BCC5C5D9A62022006BFABCDB6ED699E1875181000FAFD718EE63D7B2B5EC3FBDC858B0BD95B67D48606C7D6D03D9E71ED03DE78B01603AA306C2273768E82FEB83DF551419DA2915E30B';
wwv_flow_api.g_varchar2_table(40) := '87C91D26913B995BB5562403FFFCEBCA98F7DC4E1D9B7DFABF527D7850606CAB775A9201BCF466F0186A0AE0D08395539EA7DFEEF00C0BEA66B22C005CCB94F4C96907D3196F5FBC364EF89BC74D3C3552591C02F0D96D1ABEBADF8459E6E83FBAE6E0CC';
wwv_flow_api.g_varchar2_table(41) := '2A73D82B89007C7C9DC00B8F9A157DFBA53B123F7DBFB3132C40C1D9A4D307E3FCD46B85C1047B1FCEE9238781172FD8F8CA7ED3B35BBF41F8E21E139F5B624C6718371725360E086C1B24DFE537F316E3C58BB579EF034302DF7C7C793C6608C2800124';
wwv_flow_api.g_varchar2_table(42) := '0CFF99AA9C03FCED05F5CB6AFC9E49DA6CA9BA74C56DEA35DE18FBCC1D89977F69E1D04E037A99D3AEE923ACE923AC145C3239C60BBFB03063D5565D310DD89AAC2D58390CFCFD790B1714F5EDED962AC05CF67E55D2C7AF3AF8D96D892F8C1AD83E547B';
wwv_flow_api.g_varchar2_table(43) := '4FF1D31B0EBE71C156923997EBCC4D07DFFE958DDF3429B96A479369EBD3472FCE318EFE5F0ECFDDAFE3B1F5021B0604623E09F582C5B836CFF8FE5507A7AEAB497C1C09BC9F65CC2C316E2D315E7BDBC18F673ABFCF2D57DB9FD9E030F09DCB36BE7319';
wwv_flow_api.g_varchar2_table(44) := '10046CE923EC481246E2846BF38C8B19C68D2CD7D5FAFFF07FB2A0D5A64D6DAE5C89D1A0FEEAFF2D1817C23923A21870B01A930C5C5D645C0D38C170C70A5E967A34E700359FD46EB1A2E72675B9A2E72675B9220FEE7275FEAAB2482B2A02DCE58A0077';
wwv_flow_api.g_varchar2_table(45) := 'B9A2242B74525B8781009F4FA74BB32A56F690C65E1679EF655356C7752B10E0DDE3E30C009A43EEF5495CD319C348D54440A10EF3755AACE346156826ABD0BAA4D025B1CD600618DCD8B5FEAB6AB5A653CF311B6986CDEF7F189CBFCB1D3BF95B1605F5';
wwv_flow_api.g_varchar2_table(46) := 'E0805395E30000E2DC65405C3492C6EEEC5D472A76E282B95A2B78B5FD829C966D2A642648336968B9BBF2A2107DBF71B78E07B2198C0533E517BFE3133F58789634F12D2311BB27904D8FFDE28FCACDA85678AAFEAD4AEC5531BD8AB9156C2B929559BA';
wwv_flow_api.g_varchar2_table(47) := 'CBC4BFFFDA58FF3F01F0D471230A5EDC92028C9D5AF808409F02F81E624888405D3CF9BC5F111D50715EDACF66B9AD6AD737B38FDDD26DCA24A5041104407700ED7BA70F9A3F718F160C2EA0AA3D2A28482D1A3BB5E85BDED307E30D1DBBC45E35C00DDB';
wwv_flow_api.g_varchar2_table(48) := '0E2C4575FA5B023B9446F3557C080000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72354551185797198)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/odt.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000001B569545874584D4C3A636F6D2E61646F62652E786D7000000000003C3F787061636B657420626567696E3D22EFBBBF222069643D2257354D304D704365686948';
wwv_flow_api.g_varchar2_table(2) := '7A7265537A4E54637A6B633964223F3E0A3C783A786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E352E30223E0A203C7264663A52444620786D6C6E733A7264663D22';
wwv_flow_api.g_varchar2_table(3) := '687474703A2F2F7777772E77332E6F72672F313939392F30322F32322D7264662D73796E7461782D6E7323223E0A20203C7264663A4465736372697074696F6E207264663A61626F75743D22220A20202020786D6C6E733A786D703D22687474703A2F2F';
wwv_flow_api.g_varchar2_table(4) := '6E732E61646F62652E636F6D2F7861702F312E302F220A20202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F220A202020786D703A43726561746F72546F6F6C3D2241646F626520496D6167';
wwv_flow_api.g_varchar2_table(5) := '655265616479220A202020746966663A4F7269656E746174696F6E3D2231222F3E0A203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A3C3F787061636B657420656E643D2272223F3EAFC2E87B000001856943435073524742204945433631';
wwv_flow_api.g_varchar2_table(6) := '3936362D322E31000028917591BF4B425114C73F6A51A411914343838134844659486DA58415226206F663D1973F02ADC77B4A446343AB83433F6849A2A5B9B6E81F0882A09A22688D86829688D7791A1891E772EFFDDCEF3DE7DC7BCF056B22AF14F496';
wwv_flow_api.g_varchar2_table(7) := '6128AC17B55828E04A2C2EB9DA9EB060A79B7E1C494557A7A2D1304DEDE34EBCC56EBD66AEE67EFF9A7D35AD2B6069179E5454AD283C231CD92CAA26EF093B955C7255F84CD8A3C905851F4C3D55E71793B335B69A399D5A3C1614760ABBB2BF38F58B95';
wwv_flow_api.g_varchar2_table(8) := '9C56101E137617F225E5E73EE64B1CE9F585795397DE874E8C10015CCC324D103F234CC8E8C78B8F2159D124DE578B8FB021B18A8C2A5B68AC912547118FA825C99E9639237A5A5A5E3CC4CC3FF85B5B3D33EAAB9FE09883D667C3781F84B643F8DA358C';
wwv_flow_api.g_varchar2_table(9) := 'CF63C3F8AA824DEA725569C46F5460FC55F47243731F41D70E9C5F36B4D4095C94A1F7514D6AC99A64936ECD64E0ED143A17A1E7063A96EB75FBD9A77A0FF16D085FC3FE010C887FD7CA37D50B67246E1BC0F9000000097048597300000B1300000B1301';
wwv_flow_api.g_varchar2_table(10) := '009A9C1800000AA149444154789CED9D7D6C24651DC7BFBF6776DB99ED0917135F380111383DDB23820A087F9818124583FCE3757D39CE40D480483418D02090DB8B2618AED78AB4D72347D2BBEB757BB93544F41F42D4789018D098A849358880622241';
wwv_flow_api.g_varchar2_table(11) := 'C0E3AEDD99E976667EFEB13BDB6D6FDB7D9967765EF6F924DBCDEECEF3CC33CF677FCF3CCF33B34F01093033C9C8274A0A85820090F8E3584FE003626622220680C7C7EFBFC675F966106F650F9E10C10B181EECB147BAD0B26FE606CF3BBCFBAE7BFE75';
wwv_flow_api.g_varchar2_table(12) := 'F2E4496D7434EF1181A32E9D2C32411237CA3D3476DF2ED7F51E1FCAE9E73303440908066680B270893E3E7770E2CE7C3EFF72A150C8300A2E211D9203092E954A0280FBD8C40F2E80CB85776CC99DBFB8545E0120AA8D0363F51958DB6034FB8CD73DAF';
wwv_flow_api.g_varchar2_table(13) := 'DF164DB6DF286DA39FA6652166F63219B686B60C7D66C5718B33D3135FBAED9B77FF13854286F716DC34447220C128950000DE0A5F4A840F95CB160088EAC3AF9BC63A5A5F5FCD3E6B964E56DA737C6500C071DCA52D43C6B54B6573EED8E1FDB77CF51B';
wwv_flow_api.g_varchar2_table(14) := 'F7BE021432CC7B5DBF854A2A8104FF756484512A41088FC0442001301112D259210020D6989997CA2672867EBD695A737307276ED97DE7DD2F03C83073A2250712BCB0B04000E0798205D5D4260CAEB6DC02004CCB7673B9DC75A66517670E3DBCE7B63B';
wwv_flow_api.g_varchar2_table(15) := 'BEF7E2F0F0B0C6CC5E522507EAE78E8C8C30006401009CE0331631118199C9B42C7728A75FAB79DADCCC230F6FCFE7F3EEBE7DFBB4A40E05839D83D7400969989BC04C20F223D92B9B969B338CAB4D5873B353E35FD9F3ADEFFE23A9912C71A49AA8E35E';
wwv_flow_api.g_varchar2_table(16) := '4B4D1A8118D53A21D3AA4A0671F1E8E4810FE6F379B7542A89A445B244C1893AEEB59C2BAD2ED930F4AB49E0C4CCA3633B9228B9AF23B85EE2E6CD6E4DB2EDE60CE3AA8C86F9E263C993DCD7115C2FF1C6B21A22D9B8D27545E224C77AB6386C5A44B04F';
wwv_flow_api.g_varchar2_table(17) := '3D927563F04AC7A313C5C9F191A44896DB4427AC95EEC08C00409665BB39DDF88823F8C4B1E9FD3B9320596E04C7F630A5D0D0BBD67782C57C1224CB159CB008EE82868E97BE134CF3338F8E5F51959C8FA56415C19D53976C18C64E4DE31373531357E6';
wwv_flow_api.g_varchar2_table(18) := 'F325B794CF8BDA8D03B1A1AF7BD1753A8F3CFF9CECE40C63D881377F74FAC055F952C91D1E5EA03849EEEB4E569DEEA61F0500CDB42C672867EC8087E2D1E90357E5F325772FEAB700458EDC084E7010770901D04CD3AC4B3E7270EC63542878403C24AB';
wwv_flow_api.g_varchar2_table(19) := '080E0E81A82659DFA141CC1F9F1ABBBA1013C9AA9325879A64CB310C7DBB072AC64572E44D482C9033BCA947722EA75FCE24E6666220590906BAED6435CDA92AD976746370BB46549C3978E013514A56C324405604FB10089A556DAE2FD780E2D1C9FDD7';
wwv_flow_api.g_varchar2_table(20) := '4525595D2E046446703D47106996693B86A17F0042148F1E9A8844725F37D16D5C2E0C963D41B34CDBC919FA25E479C5D9A903D7F75A725F37D12146703D671034CBB21D43D72F61C2FC91C9B14FF652725F8F837BF49524009A65DB8EA1EB170BC25C2F';
wwv_flow_api.g_varchar2_table(21) := '254BBCAB12490CE25E51956CD98E6118175AB67DFCC8E4D82DB7DE75CF33B52B50C2172E1BB9821316C13D66B5B936F48B4CDB3E7EECE0F81E223AC5CC4048925504F7969A64CBC919C645A66D158F4D4FEC21A2DF842559AE60453B548750B6BD92D38D';
wwv_flow_api.g_varchar2_table(22) := '6DB66DCFAE4A06808254C9EA8E0E20AC61D266100819CBB657745DDF46ECCD1E9F3C700311B85028304BEC78F5F5E5C256C3A456DF57AE6DC10DEF6C9AB6713F0C027CC983DB3C81D92353E39F06C0542878274747B59607D0067D3D4C5AC58FE0B591DC';
wwv_flow_api.g_varchar2_table(23) := 'EAFB4AB52DA8E19D4DD39EDB5210806CADE37501818FCF4E8DDF0800F952C9953184EAFBCB85046212C2232210098F846022C1246A0F6A784D4D3E6BF5BC59DAFA6B4DB397972B4339E35D1038523CF4C88D005028143CE660B5DAD79D2C2282E7399A65';
wwv_flow_api.g_varchar2_table(24) := '2EDACCBCB4F186D8B875DAECB376D3D69EADF2E292A669EF71569CF19FFEF08117BFFDE08F5E2AE5470550725B1F4D73FA5A3000303B834E65595BAEB80CF6A8F63B6180A8B648CBFA006A30C258B75DC39A21EDA6AD1602545D10240B6697487C98C117';
wwv_flow_api.g_varchar2_table(25) := '0278C95F45A15BE4FE3E3891106533D92C9140A5E2809921847F2CCD3A8EB4F6991AB7A386F562DA4CCB00FCFD3190C964B0E2BA0E819DE0C7265570627B580098339A000632A85456C0B5886AA397B5F679A3F7DA4C4B04CF63D61AF7EC2F93D12D7D7D';
wwv_flow_api.g_varchar2_table(26) := 'B9D08719C40CD284A0816C960022CF63F2DFEFE563D56675610C7F998C6EE9EBCB85CDD0348181812CEAE7E2C85891928B1A073721A3090CC6427270FA7E1CBC115A4A24ABB9E84DF0258B482467A5E4A222B805D19D9363770E4E2FF54816C96BAE5513';
wwv_flow_api.g_varchar2_table(27) := 'DD269A2630904D9EE4BEBE5CD829BE644A9064354CEA104D13180C51B2EC1C5527AB0B7CC96134D7B2AB5075B2BA64F59C2C426AAEE3384CEA33AA92332175BCD430291684D3BB96F765518225E04F86C86BAEE59D899560496842606020ACE6BA7B9460';
wwv_flow_api.g_varchar2_table(28) := '895425C76B324409964CDC242BC1211027C94A7048C445B2121C229AF0AF42853519D21A25386444BD771D8D6425B8075423391AC94A708F882A9295E01E1245242BC13D46F458B2121C01A287BD6B25382284A04D24ABAB49A96063C90475C13F256C2C';
wwv_flow_api.g_varchar2_table(29) := '595DF04F0D6B2403B5CBC12A8253C5AAE4DAEA00B2F295969322308D912CAB89564B38C40C7FC6CB71E4C49E5AC2216E304390809191235835D1718300802535D04A704C21497D682538F528C129270CC1AA3B1D237A364C7AEF8597E2F35FFC5AA03DFC';
wwv_flow_api.g_varchar2_table(30) := 'BCF818DE78EDD5FAEBDC96F3B0FBF6EFD75F9F9CF909CEFCEF8D35692E1FFE283EF5D92F0000CCF222E60EFDB8EBFDBFEFFDDBF1B95DB7769DDEE7D4534FE0EF0B7F0C9C4F3BF4749844E7ACDD189C567952C33644C11B2C29C710423D6C843A07A79CC8';
wwv_flow_api.g_varchar2_table(31) := '569B3D3CFE40C773AE719A4A61CFC3E3130F7697567259362332C1CC2C7552BDD73010F9AF16DA4135D12947094E394A70CA510BA1A59C309651529A634464FF9C72EB3BDFDD762FDA3297B06C9B5D162A1C8808DB2EBEACE374674EBF85F2E2DB2194A8';
wwv_flow_api.g_varchar2_table(32) := '3991FD73CAFC6DDF697BDBE74E3D85BFFCE1992E0A141E44849BF29D4FBD3EFFCCD3F8F3EF7F2BBF401BA03A592927B27BB216CFBEDD76135D59B6BB2950E8BCFE9F7F779CA6BC782684926C4C64F764CD1FDE9FE8992CCFF3F064713AEA62B44435D129';
wwv_flow_api.g_varchar2_table(33) := '47094E394A70CA51335929472D089E725404A71C750E8E29B27ED910D95465140C0EEAB8E1A62FB7BDBD6599F8DDAF9F6CFA9910A2A3BC1AA95496F1ECD34F6CBA8DAC5F364476B1210AB44C0697EDB8A2EDED97CE9ED95030808EF26AC432CB78F6E9AE';
wwv_flow_api.g_varchar2_table(34) := '92768CEA64A59C9E45F0D9D36FE0D95FFD42EAEE2ACBF69A3CADF2E239DBBCFEDAAB5DEF77A55259F3FAF45BFF95720CEE8AAC336C6B7A760E36CB8BF8DB9F9E93BA3B67A5D232CFB3A7DFC4D9D36F4AD99FB97446FA31848DEA45A71C2538E528C1B124';
wwv_flow_api.g_varchar2_table(35) := 'AEABECC47C9894085617CA924220C10B0B0B04F8B32EC46A982481756B74F875DC2D81048F8C8C300008E111C094E01B34E243AD0EAB75BA5AC7DD126898345CFB7611653C8F3DAEDE8253FD1324DF3E8699190C62F68881D53AEE9660E7E0D1D16AA904';
wwv_flow_api.g_varchar2_table(36) := 'BF42841786860C00F0AA0F528F8E1ED57A1B1A3240841744965E6EACE36E09F4ED606622AA7ED30E8DDDB78B980E0FE506B73287F36BFE34C3CC2002CAA67D86095FBFE39E877E567BBF5EC7DD10D8426301A6C7EFBF46B87C3388B7B2074FA841585B78';
wwv_flow_api.g_varchar2_table(37) := '1E4002024C6F03FCCBDBEF7DE87920B85C69B0EA3F4B8799A5D4E9FF0107BF4399F7D864E00000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72354947394797200)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/other.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D0000126A494441547801ED9D69881D5516C74F55757A493A9AB827C62512B7243A1A8CD188A38E0CCC0783A226342888E2A7F9E2A7980561FA838220CC57';
wwv_flow_api.g_varchar2_table(7) := 'C1111C9774627A401D114619253AA0382EB8C585211AF72D314B77D2EBAB3BFFFFBD755EAAABDF4BBFA55EBFEA7E75A1BA5EDDBAF7D47DE777CFB9E7DEAA572D924232225E0A629A2AC2F4F6FAB3E17B24955837182A0542B013D9D7D3B3468C59879C05';
wwv_flow_api.g_varchar2_table(8) := 'D887C98B65E9186D0E43633A83AEAE7D5D4B96FCADEBA187BE36EBD707D2DF1FEAF7C9527B6B6D4B5D80E370F7F7F4DC6E8C797C617BFB89A45D97E05ABF4DB5F5C250C2EE6E1959B8F05F415BDB9FBB1E7CF02B58729BF4F616660BE4BA38B0C77BFDFD';
wwv_flow_api.g_varchar2_table(9) := '852377DEB9686874F4DF2777762EDF3F3232063DFBD5EA7ADACB7B703CE3E36170C20943DD8B16CD1F2914DE0E447ABA1E7E78EF6C825C1788FE88CAE0E8E879F878C1C1D151E65066F637633C789A363678340C07E77575ADC198B26DE88107967ABDBD';
wwv_flow_api.g_varchar2_table(10) := 'E3B0E2801E8AE76772AA0BF0FA152BE88DC583B230EE722CB687CC9A091B1B892F106068F18E0C0D99B91D1D6BC7C7C76715E4BA00F7EFDE6D99B6791E0843578A98986756A21EBC23C3C385EE8E8EABC3F1F1BEE1CD9B97594BDEB9734647D77501560B';
wwv_flow_api.g_varchar2_table(11) := '26CB99E4CEACDB61A3A30E09DF637C7C36F8706464A430B7B3F3AA8248DFA18D1BCFF7366C28EC9AC1EEBA2EC0D4D14C4CD6EDC41A4E171D1D3A4B1E1A22E4D541106CA325DFC03179865A724B022EB235CE9669C1CC432CC1BDCF78026372615E47C7EA';
wwv_flow_api.g_varchar2_table(12) := 'F19825CF44C8AD0D3872D1310B56F60E32DC352107BEBFE3F0962D17D15DCBFAF5336A4C6E6DC0090B56BAD1DEB96B42EEEC5CE587E1760B19F3FE9964C9AD0D382259C28295751CF265387090679025E7808152C760A59AD81F83DCDE7E996FCC8E812D';
wwv_flow_api.g_varchar2_table(13) := '5B967305CFBAEB63015AA25A360E73C095713806B9A3E37708C69E1DD8BA75A585BC61039817A3F0CAA44D63A996045C9C0757A76807198B2108BC567A18936702E49604AC93DEEAF8DAD22EBA9E41905B1270D1826B5B5A4D42DE7160E3C6CBE8AEFBE1';
wwv_flow_api.g_varchar2_table(14) := 'AE7BF1E0400D1DA7615532D598867DCB84E0A20547D3A41AC6509D278FC35DAF680B82ED47366FBE7C0320FF05EBF37C3A2471C9A61D66A6214DD3002E3C45145DAE693E9E5A09B0763D8E1B1417E156631F215B4BCE10E41C70397C95E4A3674C82BC75';
wwv_flow_api.g_varchar2_table(15) := 'EB2A5A32AB67C19273C095802C53C62D602720170A3B60C9AB71ABD13E93D66CC82D09B8CE20AB889B63F924C89D9DE747EE3A13905B12700A41D604C8F660A2BB5E06F0DB0E65C0925B12F0313A0E758D4156510C3F242D19D1F5F9506EDFD12D5BD634';
wwv_flow_api.g_varchar2_table(16) := 'D35DB736E0DAA74913E0F2A0E8159296ECEE425DDD2CC8AD0D38C29486054F201E838C27439662B19A96DC14C8396090A961A16302CF920731C870D7E7E257147D87376D5A3BDD969C03069DD42D58892720E3C990BEA12D5BAE9D4EC8396085D1A87D0C';
wwv_flow_api.g_varchar2_table(17) := 'F2DCF6F673F870FDC0A64DBF9F2EC8F6C9FE467DB7ACCA65C45B0C8AA6A39131C870D7671D1D197906967C0720FF87C303DAE32BF0B49BD392163CAD7095580C327E417156C1986D031B375E876C839FC99846AD78B524603B67A5E26BBB5DA8C8AADF47';
wwv_flow_api.g_varchar2_table(18) := '9061C163B4642F08FA06366FFE033A5CC320B724E0A20547F3E0EA49D551C39AACB4E12E14212F465B9E1E6A20E496049CC4D3906952F222138FD9C78A9011783D3D78FFFD3736C29273C0D0B4332A4780EEBB511B45AB6C5E16476DF8C1DB18A2EBC5E2';
wwv_flow_api.g_varchar2_table(19) := 'FB4F0F6EDDFA474266C0B5936F1B4821E580A9C4E8A94828DF8ECA34AF466C14AB727959F62C6C738E8C8EF2C99045260CB70D6EDEFC279EE23DE53402AF96044C2B8A25E3F97E884DF063B310BF32E48F0CF96BC3E2A6C7BAD773E58EE3F9FA59F72A9F';
wwv_flow_api.g_varchar2_table(20) := 'C79A877D30343636DADDD9792ADAF1F7E1DE5E0B9996CC4E176B6BD51F5B721E4C8D11B20FA8E1D8583070E0C030C6C1C1BA3459B5EA2757388C36CC0982D3474647FFFACD5D77FDEFEC279FDCD38FDF42E1C530F60991C935A6CE6949C0AA169890C8C8';
wwv_flow_api.g_varchar2_table(21) := '48476178381828140CE6A61E2CCCDDFAD342D86B87D0ACF8B17ED6BD96D17D323F791C2F87A1620E8E0BB0E28BD1F996E0F31EFB1BEC7E7D598696AE7CDFB28055D1708F5E27C641EC64B0501058B27DC148E52A4CAF243B5C3BBC0A5E08335EC09686E4';
wwv_flow_api.g_varchar2_table(22) := '96054CE529644035ED50EEBC209800393156A7A1EFE3CA407BF0622709D8E93075B365F53519C7AD789C932D1964C5F541C8485C0FF63AA0D8EE20F0A0140F8AE6A969DDD8064EA4A236D986C55F936133AAFCD3F280E3FAA2CD00B200B275D3CE86E225';
wwv_flow_api.g_varchar2_table(23) := 'A6E7739AD7CD012798650572A259351FE6804BA8AEA990E141D24C39E032DA6C1AE4C4185CA6791567E7808FA3AA6641E675D34A39E02934D92CC85334ABE2D339E00A54359321E7802B00CC22D306390FB22A24D2806249C85CD64C3D452B5869C9CD2D';
wwv_flow_api.g_varchar2_table(24) := 'B84A4D2AE4F9580CE13A2F8F534DB905A7AACE9A84112AD7AEB9E2C5C72E52875C53AB4A57CA2DB8B45EA6CC6D18E4DC454FA9FB692BD030C8297E83DC82EB5466EA90F331B84E220DA89E2AE4DC453780500A2253839C5B700A341A242235C829B62F1F';
wwv_flow_api.g_varchar2_table(25) := '83535426452964CE93B33085CA01A70C5821E3293EC902E41C7003006709720EB8418027418645D37D5792D27CA623075C89C6EB2843A8D65DE37967FC87B88A2057DA112A69560EB8122DD559462177570839B7E03A15DE8CEAD540CE2DB8198452B866';
wwv_flow_api.g_varchar2_table(26) := '1272C9FBC9F94A560A9A6EA28838648ECD9320232F77D14D0494C6A509957039264F820C0BCE5D741A5A6EA20C5A68D2928B50013ECD9447D1696AB34A590A797E85D17595E26DF11C702D5A4BB10EDD35E7C7844C77CD9F8DA669C339E01461D5224ADD';
wwv_flow_api.g_varchar2_table(27) := '3521F3192FEE27055EB5088EEAE480EB505E9A55E9AEF994266F50D092D34A2DFD0BFFB49498961C1D93195D8F634B23E580D3D0628A32AC25C382E7A4B4E0914E3749F10BE6A2D27DCE3A7B165C4DCF2D3756A52123D9D3AA91C9BAE5DA9694DBE0E36C';
wwv_flow_api.g_varchar2_table(28) := '01A612DBD0A439785DD4F114CA7378E591DDF839AE4C1EB33EE59492C1B2CCE7C677DAE8C6E3B89CB8E299DFD1E1CE9792992C3B3626328EB7209593172FDFE0CFD902CCC0626040E4C001BE86AEF457A7D23A3B45E6CE15E9EA72E5A85005C47AAC7F18';
wwv_flow_api.g_varchar2_table(29) := 'EF8D3B9E8CF676579FB2F899292EC7E53848CCFFF9670B8DEFB23A6E8CCB762C5820326F5EE90EA672A7699F2DC0ECF5679E2972E9A5CEB2E24A20582A8F963B38E814FEF5D74E91A79C72EC1C2DF2BCF3444E3C71B20C954719434322BFFD26F2CB2F62';
wwv_flow_api.g_varchar2_table(30) := '20CF63F9934F7672E2D6C7B284B56C19DE6015E07D4B91A597DA533E3BD5FEFD6E2BD7C1B41DD3B0CF0660756550B8B76183F8D75EEBACA99402A8D8A347C51C3C28E6FBEFC5BCF9A6C8071F889C769A53EEBE7DE2DF7DB778AB56898C8E9692E0200E0F';
wwv_flow_api.g_varchar2_table(31) := '5B6F61E57CF38D9877DF15F9E4130799DE819001540E1D126FF972F1EFB8C3818EC32F251D4383D9B54BC2A79E1239E10427839DAE49291B80A32F6F4646C49F3F5FBC534F2DED2E598E8091BC73CF1559B952CCE5974BF8F2CB625E784164E1420706D6';
wwv_flow_api.g_varchar2_table(32) := '6865405E711C8CEA697DCAE039EB6ED119CC35D748F8CE3B629E7BCEB977C2611D02851BF7E825BABBDDB17A132B24FAC3B2CC276096A35BD7A4E7F4781AF799028CFF6120868AA175C5C7435A925A39DD9E0658F8EC2D5922FE2DB74808971BBEF8A278';
wwv_flow_api.g_varchar2_table(33) := '1C5369B99441C04CACC3A04B65704FABD26B2028F3CE3E5B8233CE9070D122099F78C241E658CA84EB19C8F3288375541EF79A4A75203DD7C47DA600D362F85250AB40EEA95028367CFF7D375E32A83AFD74A1F57AFC4C65C35D7B279D24FE75D759776D';
wwv_flow_api.g_varchar2_table(34) := '7EFCD1B9452A9F1B3B0764983D7B841EC26384CD4E000B653D5B861D82B2106CF9575DE5AEF9E8A3AE83B03C123B5F112CDAC6EB985F7F9D1CADB3937EF79D0BE058B189D6CBCB670B30A16AA26200C840F9E1ABAF8AD9B9D38E853CEDDD7CB304EBD6B9';
wwv_flow_api.g_varchar2_table(35) := '489A7068D1B03CB9E41211B8EBA2A5AA0C44E685679E11D9BD5B84EE9FB030667B575C21FEDAB5E231B82260CAC274C85FBD5ACCA79F8AA12C4E8F98282B06CBA0D3151E7944BC0B2F74755D29F797DF83811913EB3431C57C4C135B51EED29172ACDB85';
wwv_flow_api.g_varchar2_table(36) := '2B66646C1860F5F549B877AF03C5BA2C0710161423EC5209000D23676E08C4E4A38F2404A00282218348DA4E9508869019070032F786D33676B4844CFB3658CAE218CD8D1D44F7EC701949D9B2E012BD5D5DB6C7B92AC74A5A2A8120BA8D276BFBB4CC72';
wwv_flow_api.g_varchar2_table(37) := '092EDD63100668760E0D68EC10E6D967EDB81BDC7AAB73B70485E42D5E2C72D6597825F71E0B38E65BDC795CCB63E4AE11B7CD8DFE10701323E77853B26DC168A9B5148037541A374E8F6829EA02F96D3826B27330B02A9758874197BA625A1F3A8D0788';
wwv_flow_api.g_varchar2_table(38) := 'E6ADB7C4FCF083056C2D957068C5EC4CF018F410932C18B2381D128EF91C73B1194CB77441C40E13253A6CB9E6352A3F53166C5FB11FFFA6D1984CB76C2D096ED86095CABFED36B1D32475852C87952BC3858F0B2E283DEEB14C7CE375E88ED9517EFA49';
wwv_flow_api.g_varchar2_table(39) := '0C366FE952144139C8B5411CA36876048042AE4B848632DEC5178B0FEBF73846B303A053F8E830067379F3FAEB2E2854EBA6CC26A54C01B6AB44AA082A054A63D4EB5F79A518BA4BC0F0E13AA95C8FF3540262944B057FFEB9C8871F5A8BE4F1944995CE';
wwv_flow_api.g_varchar2_table(40) := '489B10754AA5F974F7941DB95A4AB4F023D93E3B12374D2C8761801174E1BDF74468CD1C0EE8399A98320578820553D1B45058887FFDF5CE2A991701B58AE3B8CC8585CF3E93900B1D5C6020F44A00C7954EB90A56F3292382AB5913F62CCFCEC1725A97';
wwv_flow_api.g_varchar2_table(41) := 'C7DCF4784285E61C640A70593004A9CA5485D2C2384786D586DBB73B8B61D084E5CB8A92CAE1984C6FC0CE41309ACFF19C11395D702960B44C2D8B0B3246B07365CA63C72855A7A286A55B285380AD0B8C7F3F55F891234E6950A85DE9824B3558D03780';
wwv_flow_api.g_varchar2_table(42) := '6B5E79C505575C4A84F54E92A1F20883897B6E84406FC029D34517B9808AE7994FAF00B81C97ED188D7600FD31A0380E31CD325C03E718CE3A94C98519DEC56284AFEEB9C9A03305D82A898A64528541D105406400C5F930156F23D5BD7BED1CD5C3F2A2';
wwv_flow_api.g_varchar2_table(43) := '70458A16A5CAD4BD93E4FED203D0EAB931D12BB0A360CA15DC7BAF9BF2D0FA58179B9D1B7FFBADB36EB6455324DBE0FAE17DF78987356CBB52C6F3A86F630346DF94CF21A6545B54D634ECB30538AE0C2A958A8692CCC71F8BC1A284DC7083034FABE152';
wwv_flow_api.g_varchar2_table(44) := '23AD964A241802D41407A2793A4DE2184DF78B699181A5F9F7DCE320113C032D5A35CEF39A9C6F7B8CA461A1446CAD3892E72142F66EBC51E49C736CE72A9EA335B33D51FBF5F2CDDA670B70120C8EE972ED02C54D37B95B82541E95A88AA4E6E21DA3D4';
wwv_flow_api.g_varchar2_table(45) := '31F3D81108967BBA4FDC020C109D7B6BD63888844B39B03C43F7BB6B97B3DE28682B02A42C2642C72A97C77A89F1D815C8C6DF6C014EEA840A277428D0601CB6CA2460A6245497EBFE6A47611900F510400577DD25A6A7C78E9376550C0199BDD9C03204';
wwv_flow_api.g_varchar2_table(46) := '4F0FA0D39CE79F77C3005D2D1732CA243BDE6B3B745FA66CB3B2B305984A221CDD682511AC62F0548922B53EF7B45844C2BC696F6544F2ACC2D5F278770972CD575F49013735E4EDB79DB760DD28B11D769E1ED5B7EDAAA42D2AA049FB4C01E66A901D03';
wwv_flow_api.g_varchar2_table(47) := '19A030613CB4D606EBB20AAE40A113641086D6E1E7088E95CDFC2810E2EA98C1D31CE14B2FD9BB48F661811848FEEB59DB0E968FF2796F38440781944CA74C01E6B29F5536DD22C73E063C9C76C0855A05B3034C91ECD221970B5546A9F29443571F2D6F';
wwv_flow_api.g_varchar2_table(48) := '867C5487AB4FC8B73710789E201178D9FBC70CBAF8D01DEF412B783ECAC3602F3A2E75992CE46503B02A09D31DF3DA6B6EA98F79B432BA49CE55B9181173999394A732704B9196286FBCE102B149059141D7CCB9356E5CF0094C5CC98DC774D5F10898D7';
wwv_flow_api.g_varchar2_table(49) := 'C3F86D5DF7638FB929965E87735DDE4DA2AC0CA76C00560571AA42985CC7255C2A9379B4142E22A872B57CA93DCB738102E369D13D27CB5136832A7A083C0060AD94564BAFC173DC34B11CD7AABFF8626287E18D04AE7255D22695D5847DB60053597483';
wwv_flow_api.g_varchar2_table(50) := '5C36E467854C4BAA54912C47E5732A74BC3A2A5BDDB55EAF1404762E2EA6C413EB71CB78CA16602A2B0DC54D2523093E69B549682C9F71579C6CB21E670FB0B6AC91FBB80B6EE47532201B034C9E66B30672C0B3992EBE5B0E38073CCB3530CBBF5E6EC1';
wwv_flow_api.g_varchar2_table(51) := '39E059AE8159FEF5EAB2E0FEDDBB8B4B3EF880C9629EEAD54051A191A0B88E6B915D17E0F52B5658A8E3C678F8C0A7CF6B69435E27A601BD3D4A9D325B751C2B52D5C7BA163AB477E171573C0D87E416104839275D1586626167224E975687AAE362892A';
wwv_flow_api.g_varchar2_table(52) := '3FD405787D74313CD1FFA53736F6C582F6F615FB4746B2BF405BA592A6B178081D06D0E117FE9C395FF2BAAAE35ADB9074F955C94117B34BF6ACB4BFA7E77674BCC7D140BCEC82FE3A4FD568405DDEC1D1D14378F2E4DE9377ECF807EBC7755C8D3C2D5B';
wwv_flow_api.g_varchar2_table(53) := '378778037EEAE959D366CC3A605F00979D5BB26AB992BDE7F1B19583B83DFACF53FAFAFECB2A71DD5622A26165D89086096F51C169E9F4FF59D235BB4A09F1090000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72355323974797202)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/pdf.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D00001587494441547801ED9D796C1CD77DC7DFECC1BD4851872DEBB22D5B522A938E2AD591AF206980028DDB3FF25744148D5D34408BA66950208553204D';
wwv_flow_api.g_varchar2_table(7) := '0BCB688100B10EA4912C050E20DBB22843EC1F050A140DDAA6767A048A732875A944D66D49B62E4B9444EEC13DA6DFEF6FF6EDCE927B70771F7767A87DC27266E75DBFF7FBBCDFEF1D333B52CA40B06DDB32504C578BD8BE7D7B0002F8BE1D3395D87683';
wwv_flow_api.g_varchar2_table(8) := '0817C166C1DFDBF58DC7F379FB73CAB217DB05550850659E0D76C12E58D140307C3D1E59F4CA17BEF2FCF923478E04B76D1B29589692F67856F426040B359176565237DCFD3BBEFEF97CBEF0BD443C3A68433D803E2BBDE72E88A06195B7AC4F1C7A79F7';
wwv_flow_api.g_varchar2_table(9) := '97474646CEC09243B6DA9E87F40B02725B80C7C6C668A3F9EFEEFEAB952A6F6F1FE88F0FDE999CCAE21AAE133075A48F38ADF080D5E2DCD7DC1D445F67193C679859AE4EE33E3A29CB692BF258E8A08550C84E25FA139FCDE6F2A307F6EDFEBD2FFEE957';
wwv_flow_api.g_varchar2_table(10) := 'CF29427E0190178025B705588D8D89060B59FB6128E3D7A6A652FC4EE8F86810FAC828F7F9CCEF3A6EE691E918F475E75BE5771D37F33833AD8ED7D795B43F97CB4FF627624F4C4E250FBDFECA4BCFFEC11F7FEDAC52806CBF00C8CEF053CAE1B393B600';
wwv_flow_api.g_varchar2_table(11) := '1F1F1EB609391028A0AF03B145AEE29BDDE6E759958890961D8425DB80ABE2B1E8D3C964EA10DCF5B35FF8F257CF407040B67D0DB92DC0E3E3E3A2A3422160071CC49E85594B300EC3F0F6F43A2A994AE7E3F1F853388E1ED8FFADE7BEF8A5BF3C393434';
wwv_flow_api.g_varchar2_table(12) := 'C40E8089973F2D591A56ABF18DAE0FD38211C292104BA5591EB051095E89B7B8145000692553A93C268A4F040BC14307BEFDAD0D9878E55F7CF14542F685579AA9D1B62CB8B230B4DF972A402B088F238B63C985A9642A1F8FC5B62655EAD0C1BDBB7EFF';
wwv_flow_api.g_varchar2_table(13) := 'B93FFB8B537EB5E4B62CB812B06FCD17601DF70BCA6C047522964CC8B834FADA9E9D1FA32573D5E0374B3608D8AFE65BB4E0CADE5A821C8B45B762EEF8E681EFECD8E847C80601FBCF824B12579F40152163E2158B6D0905D5E1D1EFFA0FB241C0FEB3E0';
wwv_flow_api.g_varchar2_table(14) := '92C4B527502E4B8E6DCEE703BE836C1070A58FF3C3B70616AC9B50B2E4682CB23957B0DE1CDDB36BD82FEEDA2060A8ABA431AD1B6F1F4B16DC584C819CE23A391AFBF55CC07EF3F57D2F3DEA07C80601434B4D68ACB14E3D97A268C95C42451F5576E0B0';
wwv_flow_api.g_varchar2_table(15) := '1F209B05EC330B6EA10B152173E245C8D6E103DFD9F571C792473CB984320B78615BB0EE0F25C8B158ECD160D07EF3D0DEDD9B4746C6F263232381E283033A6DD78F0601FB986EED59742D40021963720E4BA8A19C2A1C7E6DDFCE2D236363F9A1A171CB';
wwv_flow_api.g_varchar2_table(16) := '4B900D02F6DF24AB44AFFA3AB8145DE384BA0B62EF3A9788C736AA821A15C8B0E41710E115C80601C3827D6CC4352036BACC160793C96409F2AB2FEF780C265C60462F403608D8C716DC0863FD78DEA828428E6E0CAAC0E137F6EED80AB89E806C1030B4';
wwv_flow_api.g_varchar2_table(17) := '70F759B0465F849CCA61EF7A434159A35E816C16B06EAEDF8ECD4FB2AAB5B064C9F17874BD6D050E1DF08025F70013556B93AC3A90D3396C6B6E085AD6E88197773ED94D776D10B08FFDB3190BD6C061C92A984A8ABB5E1F54985DEF79E9A96E413608D8';
wwv_flow_api.g_varchar2_table(18) := '7FDB582589CD59B00BB205C8698EC90FE1A9C4D1D7F6EFEE0A64838075DBFC732CF91CB316AC1550B4646E8644D75A85C2E8C1BD3B9FEEB4251B045C52976EA0E78FF368C1BAED0E64EC78C5A2D1B578F2EBF0AB7B767CBA93900D02F6DF3AB8435D92D5';
wwv_flow_api.g_varchar2_table(19) := '04536981FC001E2F3ED449C8069FAA44333AA4316D1E3E3A3A9069C9B1D81AC07E03909FFDC3AF3CFFC3E2437CBC49211B23A6DB641670C9E799167341945776D7B1E8FD49407EFDE55DCFE179ECB701990D9C17C86601F72CB8514F2C424EF12E1420A7';
wwv_flow_api.g_varchar2_table(20) := '465FDFB79B907F305F90CD026ED4BC5E3C3500C85842A5D3593CFEB32A9D4E1F2C4366F476A3966C709205D9FCEAA2E76799445AB5022D3944C8D168749565170EBEB167E76FF1D733188B6DFC31C6C5584132C3F2998B2EF5C71A1B1DA5F81A98EC628F';
wwv_flow_api.g_varchar2_table(21) := '2EA7AB76E6CAECAEC79629691172645521A00EBEBA77D76F23B5CDDB8D47B66DC32658FBC1206034AEDCBEF625EB6809FA8765FAE854DEA8BFD20C19CAE9AA9D3965C9DFD99E8219C27C32043B5E2B61C06FE0B750CF302D9F0E8135B7CDA7ED024470FD';
wwv_flow_api.g_varchar2_table(22) := 'A7DC3E7DC5F34740C28D1FFCC019FED1B2700C04F04B437C78D4E7FA3B8FFA5CC7353AEAF4D5F2EAB8403098CE64A6F164C8BDF865D4ABA3FBBF2D90B974C204BB2DADDED5932C422D1472D833BE93C62C76B2666FA48A6B79A77A712CB05EBC8E2B1E53';
wwv_flow_api.g_varchar2_table(23) := '53772683C1E07DB96C6ED7DFFFED5F9FFCF3BFF9BBD36323DB608463F99AB23588B8AB015337B69D8BE4A633C1CC741E432A0D597E270C30D0BABCA485DA7707922E129153773ADD0BDCD71AE46534CD94F5F2A7D6F24681C02310660D624EEBB728B84B';
wwv_flow_api.g_varchar2_table(24) := '69E6DC20E0998A68468C6EA6B5AC70281C86EB55D3D339E8D7C6CD1FDD161CF56949447DA1789403FEE8A3E6CF0B72AD941127FA42F1C803D3EBFA701E0A8554369FCF0177CE9DB3D573838029A95F836D8782F0847D2140CE0A645A548947AD66CDE025';
wwv_flow_api.g_varchar2_table(25) := 'C9AA5DAB96BF4A3A5459C0A01B74D7AC5F9351AD88B95C333BC99A4B8D1E4C430FC94F10A6DB07630659DCDDB3E59A8EEBD45173D72FC6D0AFC968556D060197456B55182FE40BC292FBFAC2CE9808AADD0B7CDD58FBC1206028A39BFA685F17A512E8AE';
wwv_flow_api.g_varchar2_table(26) := '239E805C12A9E513838021C3C2306251262D792140360B788158B036170D39C0254CC7DDB5F3722A2D4BAB47B3801790056B85766F4CF6DC18AC55B2F08E254BE6EBFC3A6EC9EDE9D3AC052F3017ED56AD5872382C9B207E826C1030FCF30274D1D5205B';
wwv_flow_api.g_varchar2_table(27) := '3EB264838017CE32C90D75E6B9B86B58F27C4136ED040D02862A16B8056BD81A32F7AC4DBB6BD32A340B586BE02E3896C7E48071C88EFABCB84CBA0BC0BA9BE8400ECDD3C4ABB74C72EBBA6BE7654B36E9AECD8DC43D176DA06B0864EC5D07F0FF089919';
wwv_flow_api.g_varchar2_table(28) := '93CD8DC43DC00600B308DC6AC45DA8F972D7AD0BD903DCBAEE66E574207B6B33A4077816A6F62E780D720F707B3CABE6F612E41EE0AA88DABFE815C83DC0EDB3AC590221F3A10173B3EB9A55D58CE801AEA91A331184EBCCAE4D2DA19A93AB07B8397DB5';
wwv_flow_api.g_varchar2_table(29) := '94DAB1642EA13A0FB907B82564CD67EA9625F70037CFAAE51CDDB0E41EE09671B59691961C911DAFCEB8EB1EE0D638B595CB81DC99D9750F705BA85ACFCC87056A2FA17A77935AD7AC8772D686CCBB49BD1BFE1E42D5BA28B521F76EF8B7AE558FE5AC80';
wwv_flow_api.g_varchar2_table(30) := '4CD9E47670CF823D86A93D71CA9041D7E0C3F5BD49567B5C8CE62E432616332EDAE02FFCCD3D6662546B3E2B4CEF78E572666CCF206073537B9F31312B2EDC7300EF0B8985CC0036538AD926DEDDA58923B40D3968BCD4C54BDAE413896E474F9FC0EFFA';
wwv_flow_api.g_varchar2_table(31) := '28B2F2E52875822EA394A7417A16D5300FE46AE49F9C6AEACB5647EC195196A155B08700F3AD36C1A0D3DF4A70A87C7CB4DA786EDB05BCCE8A677C7FB68EC129BFC1B5F111561D245501EF10AB332BC5DBEC54D00AA21E762E3CDB8C7F853CDF3BC6DC0C';
wwv_flow_api.g_varchar2_table(32) := '960AE0D5463A8E35966324817C17B9584F9DBA9CD49DFDEB110BB6542E9755D9CCEDBAAD0F04822A180AE3D3877BAB21BC738890CBEACE65332A3B9D2E960160001E8EC4246D395D6515D94C5AE5B2CCE3A0B350475F5F0C3F2E733A0ADE84A732A93BD2';
wwv_flow_api.g_varchar2_table(33) := 'B16676285D927492605885C2902B88CE02B9F881003A49D78E9E006CC3CAA2B17EB5F4DED5A2088D8C5FB4C55061B9DCB4CA24EFA8D4D42D8989200F213AD69357B1C422B574F91A412EF9604D53776E026046D249E1AE3F74CD89454B5534DE2F40082A';
wwv_flow_api.g_varchar2_table(34) := '9FCBA9E4E44D393269B82FAA0697AD402701B82AD6C9BAF3D92C3AC1A4C855405B22B181627A7A82EE423608B8B58610502633A91ED8B0496D79F233A20FBCA3CAE9FC2ED2749DD9E969954A4EAA5B37AEAB0B677EA52E5F780F5613C5DBE1C250EEA45A';
wwv_flow_api.g_varchar2_table(35) := 'FFE8E36A78CB5302822E3F979D56EFFCE7F7D5A533E3A274C260601C4114F239B57EF831B56168B3CA025218163879FBA6FAF1DBFFAC3EBA72413AC53D2B1E505B3FFD8C8A44632A0FD72D46592197927AD2A929757BE286BA74EEA4BA74F6B8C25B4D21';
wwv_flow_api.g_varchar2_table(36) := '5BA468F9526D57FE1804EC6A75934DA1A2FB2251B568F152015C726F2CB2D86FB4F510CE9A07D7A9B5EB1F5127C67FA6C67FF2166039561C89C6D520CA280024971AD3D3198126AE5C4C9A82B150A6C719BC422C9E50834B9649DABEBE88000C62CC1519';
wwv_flow_api.g_varchar2_table(37) := '70C7876E776070B18AC5122A0739597F29B00C298F625A6AD5030F8B5C674E3CA47E71F4070AEFC0EC3A6483804BCD6EFA84568CD7338A92995903E6A29F1F418234B43AB1225C1B185CA2367DE29370A55935FECE5B626D4E1969A4E3FB2603B0F80CCE';
wwv_flow_api.g_varchar2_table(38) := 'F17F81BAA1147B8C60C275E69FC6384CEFC08AD829583FF3301B870F96C309600EEE9BD72BE58237406F29208E19A2E830439B9F10397FFEDFFF22324B1BAAB8F7A615D542064F0096192C0052110C7829B31C2F9D3FAD6E5EBF827130A212038BD4F295';
wwv_flow_api.g_varchar2_table(39) := 'F78B02394E66D229D507B7B961688BBA08777DF5E249E4C7FFDE8B0F67D82CCB992839336329B0CA1F762EE6615A0D8EF6C84EA53B81C4231D5EF52B802F5F3AAFAE7D7841AC3396E857CB57AC11F9D8F9A633191581375AB771930C23572F9E56118CF1';
wwv_flow_api.g_varchar2_table(40) := 'E232AAD43FDF973C01D8C1E93455D6A4004CCBBB70E6847AF7E8F73111BA4714B47ADD90DAFAA9CFAAFE458B31EE65C5EA1303836AF9EA87D4A5D3C71C8B2B5A0A01E940F7593FB852BB4E751E76C0922B866C972F9E5347FFED881A58B24264B86FCD3A';
wwv_flow_api.g_varchar2_table(41) := '8CD3BFA3962D5F2172714540D7BF7CD583EACAC553258FD40DC8E545A36E4DD78EB335CB2547B82F2E96427AA7DEFD91BA78EE1470D17D021A6006B0EE4DF42F92EFC256B32C16E7B85A58332CD0F9387969B1FCCEA06BD6C7462AA04587230959AE71D9';
wwv_flow_api.g_varchar2_table(42) := '76FEC44FD5B993E332F3D6EE9865F70F2C16EF202EBF61276B546B6BF19EB060C7196A32E586504984CC4F2484490E964953B76FC9B846700442D88C7760395704198BC357CEA4B98E0D600CE578CA1484C0F1BA80F238AECFAEB92C43B5331987511E3B';
wwv_flow_api.g_varchar2_table(43) := '49240CB9B0F69EBA3321D6DB178D2A5B66DBD8B8E1064951CE6AE574E29A470053EDFC5406BA6BBD4344505424C73C02E28447BF6290132482723A4AB11CE4A591F70F2E55F7AE5E8F654E1C6539AE969D81B0B963C5E58F587E65D595DF668826D2B23E';
wwv_flow_api.g_varchar2_table(44) := '64E41A7B3A93844BEE17A0CE048D51059927C8F750B1B75596DA916F6601CF50C4DC5B50CD866C99E1726383EB49C25DB5F611598A1024156861376B3A9552131F5DC139AC98158A0CCE184EABDDFCE46FAA4D8F7FAAA695D2CA68CD0CD5A49088197F64';
wwv_flow_api.g_varchar2_table(45) := '9297BC0D371DC70C3BA5EE59F9B0BA7FDD46C81996D93827632C9372B1E369B73DA3988E7C350B78AE1A9AD53452296776D6BC96BA6FCD83CA7AEA1928322AE3D96AAC7FB956CEC29A698554E4D5CB17B1E1711233D54140777A58717816F718C15625BF';
wwv_flow_api.g_varchar2_table(46) := 'D70A8E9768D033919F453015D32F5BBE526D7AFA7765ED1E4B0CA0D3AD534B96DD2B2E9AF570C3E4434CC43E7CFF14AC1A8FDE688118D9E1601670033D356A1BF970CCD26BD787360C63E36048F4A36F44702942B0DC80B871EDB2FABF777E28E36C107B';
wwv_flow_api.g_varchar2_table(47) := 'C17AA6EB16832F2C6399554600A146170A6AF54593687A0D27DD9AB5EB153B1BA1EB1B11B4588EC97863BCBA7DEB867AF727FF85F9C20DECA0259C5974FD1AE62DD62C60B6B8A5503D23DD2777A418B472436167BFF8830B67D5B11FFDBBBA7AE9B48A26';
wwv_flow_api.g_varchar2_table(48) := '065512CA2C057090C90D80DCBAF991EC2851F9844C446583B26539C3F1B399C0CE46B7CBE0C8658B7BE6987EEDF207EA173F7E4B5D38FD2ED6E91CF79B29D97C5AB3805B96CFD10215EF0EDC61926D46688996CB1DA5A9C9DB70C967D5995FFE0C370526';
wwv_flow_api.g_varchar2_table(49) := 'E09A072A2D8465203D5D782E9751FF7BF46DF53E941D75A5631CC7C6423EAB7EE393CFA88F7DFC3129DF5D77BD73CA417968C2DC66953D72EC855FF9E07D751A72DDBE711596AB3B4D77091B043C834E3D0DCD8A2BE7A545C82C1793A893C78FA98B67DF';
wwv_flow_api.g_varchar2_table(50) := '939D2CCE56F11F47A9C989EB989D4E62FC4B94E032FDAC20A0B9F59856A949DC7DC2FF5AC73D6A810FEB23186E53CAF6E3ACCC332E8878948BEE3EA0CE9FFE1540FE1C32C464DC4D63193639F1116E8460E285BB4F518CCBE2FA6714D38DAF06019BEBA9';
wwv_flow_api.g_varchar2_table(51) := 'DA85DEC4187BF2D85B2A31B85C7443D718C48C3A3EB04C40555762912C73E094637318F77743D8EE74D2039400A69BE5D6A6B3D7DD48F9BA7594EDD6CDEBEABD63FFA1FA17AF946C9CAD87708F3A3EB044BE5797AB510DF3136F10B0790169218B96AE52';
wwv_flow_api.g_varchar2_table(52) := 'B1FE4171D532DEC10AB9869D6B601EBA632A5D6E17E23B035DBF7CC7A82C06DAA04057B7118FB268E96A01AA871096E525B0BA391E01ACED438BE51C0986BB575C773A302AE3AB7F9B5D968CED9A50F14B196AF9AC7A79CE5577A90499AF908BB1732BA7';
wwv_flow_api.g_varchar2_table(53) := '5E1DF311E711C0500E2C8BD626568A96EAA32C71A83BB786AB6942D2203F6E154ADE5259F595AFEB748EB042A9C855192DBEF8D1699DEA5161492E9E78339805ECD24B33CDA5522D59DBF2FF6684DEA02F5A09C748813587C2988E63213719F40D7F96C1';
wwv_flow_api.g_varchar2_table(54) := 'F1B6B20C4748F98B3C7A4DCD7BBA5C5BF3E91067D2C68E0259909FE32B77A9E88E65DC86AC4E479883605D4E6216704B1D9937E7836A3A9D94477104364C83CACCE01A1FAE13A3AAAB28961152693CCE3371F39A5831C1E4B047CD250DCB2F97E1981D3B';
wwv_flow_api.g_varchar2_table(55) := '11D324B1BC99B8714D76C79C477670D300B36B42A6F7E01EF82DCC90FB52B88920800352CFDCE4AA2B744722CD02768CA329C1695DDC10B87CE1947AFBC695525E5A4F1AFBD0BCA9DF68FC75CA886173E1386EC49F1796821185A4B06EE69395EE32989E';
wwv_flow_api.g_varchar2_table(56) := '000398619F3AFE53DC77FEA558398172B32235751B161B115926AE5F56FFF3AFFF88CE8012D93EA46147921D2A2EBB3C1ECC026EB1B154F67426858D0B3E2D590EF2182AAD6F0E8165F0C9463E45A9032113142DB55A20507680C95BD7E13378FBD1012F';
wwv_flow_api.g_varchar2_table(57) := '7910C7400BBE79FD03E900BA0CBA710E07F319CCFCF4CCF483EF8E4E5A6A375D5E24C6DFC4EA42A06E4C985CBEB561B901283E8271B4B28CFA56C6B1956BE4A279E2807A5D96C9CE410FE3942926ECC4D3C5CC6330F3EB60D380DB6AB306DA86D6044E73';
wwv_flow_api.g_varchar2_table(58) := '42C804CCAEBFAEE6D8EBD750DD77B5DA1A6D7CADE6EFE533AE01B3809B331EE38DE915385B036601F72C78B686BB7CC52CE02E37A657FD6C0DF400CFD6C982BAD203EC499CE6263366019B93CB936AEF8850A243739399B6008F8F8F8B24CEAE8B35B71B';
wwv_flow_api.g_varchar2_table(59) := 'AB1DD1928F2B118D96DFD1A175DC6A8BDA023C3C3C2CFD2D1028402CDB9AE7CD9D56DBE8AF7C452FE8E85429ADE3561BD1D686EA50D1822D2B845F6CCA8D58C821987BCEBA3522D858931D71EC96C22322681DB7561C7F09DD4ED8B64D72DB01FB2CF6E6';
wwv_flow_api.g_varchar2_table(60) := '4F2412317EE7BE1E3E56EFD3940E1CBD5187D465206C9D11E516752CE72DFC696B34476FC30D19A7A7EDDFF1F5CF5BB6F54A221E594C1BE69D9A5E98BB0668B954D954327D0B0F80FED1979EFFE63F30B75BC7732FAD9CB26D0A6E01F6EDFAC6E381BCFD';
wwv_flow_api.g_varchar2_table(61) := '3965D98B7143A650E32E5DB9F6DE996880F732787B1AD3980920FDA73FF9DA378F32C2ADDBAEAA8A9DAFAB022CC0CA09D744B3FE1F5B70E49C36E8BBC80000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72355667852797205)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/php.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D00001AD5494441547801ED5D6B905CC5753EF3D8DDD9D9D9D50A565AAD1E08BD90908441422024B07898AAE08A24DB896563208EAB4C9C32958AFD87FCC9';
wwv_flow_api.g_varchar2_table(7) := '0FAD92949394CB548A246553E20715A195A235159B388E7F244660830081900AF332252908A1F76BDF3B3B8F9BEFEB7B7BE6CE63E7757B7666A46D69E6F6EDEED37DFA7CE79C7EDDBD2362225896CF443535ADA3B7D72F96347E3FB284E8BD4304D7E7B3';
wwv_flow_api.g_varchar2_table(8) := '58EF86D79EBD339190AD3E9FAFD39264D29FD598085392F8E81CC6B383BB4CB9F993D1EA74A72D1FB1B49256524221BFFF42A4B565E72FD73EFAC9366B5FA05FB625757FB2396BC4FBA027A65DE0AE7F65E7579349D9D9D4D1D6A9EAF4AE3A9E582B8598';
wwv_flow_api.g_varchar2_table(9) := 'EA13846A0613D6ED5B8EEC7BA2DFF7B5E3F7BDD41BDC6F5989AB05644F006F937E7FBF48E2F6579EE911BFAFB7A9B3BD3376652806F3F02B6747BB26D0CABE9D382E2AB8F3B2CBE4CBD30AA3EBD2F514A2CD2E9359D697B4AC6422181CF347DA1E4A4EC4';
wwv_flow_api.g_varchar2_table(10) := 'F77CF99D3D0FFF6CCD37FEEFBE97E4AA01D913C00274199A24B0182E6F797C708460125CDB076B50F4D52E6E7FEBB4EC2B73B3D3F4BD3BCFAEC5FECE97EF4E73D365A6ABFE5BB1F870736764FDC4C0F06E58F263FF792B2DF9EA00D913C0FDDBDE57F664';
wwv_flow_api.g_varchar2_table(11) := 'F9133EB1021C8B458DC86988DC30D45F9CFC8A04F0B1260647ACA6F6F0C6F8D028417EF46A01D9B6B44A45DFBF52D9832F09195156EA2EDB87565AF954D09157C536665D962F36389A08B68737F81289BEAD6FEF5ABAFFFEDE388721E64D0537D568C31B';
wwv_flow_api.g_varchar2_table(12) := 'C08E05C347DB7252D836922C6C5E01B1E5F34314B8C48646134D1DE1BBC417ECDBFCCEEE65987825EEDBBF23D0A8207B0358B6672A5D2361EBE65C5928B4133023D9171B184934B5B7DEE1B7FCBBB7BEBDAFA12DD923C06E293570DC59C7AB61868B74CC';
wwv_flow_api.g_varchar2_table(13) := '26E8AE093262294B6E44776D0E60C77A1BD28873C7D834C8913658B2ECDDF256DF0ABAEB4603D91CC06AFCE550DC80415B7026EB36C8C3B4E4B6B570DE7B1A1164730037A4E93A88E65AB0869AF2B1DD75247C5B23826C0E602D9246BA5A8EBFC96FC1BA';
wwv_flow_api.g_varchar2_table(14) := '27694B06C818A1F77EE9D0F32B95BBEEAFFF2594398029AB46F3CFD8E82831D8960C77DD1C09DF9AB4FCFFFE95237B57F77F0D63729D836C0E604AAA64799528D66A172B4F21D3207784572793C93D7FD800209B0398E042600D8571F9CCDA2073C7AB2D';
wwv_flow_api.g_varchar2_table(15) := 'BCDA1FAF7F90CD014C6B80C0CA338A6A9B6855EAF773A5CC1DAFE6F6F0EA60D2DAB3F9D0DE5B53EE9A0F0ED45130C74CF9D6503F62987C169D9F479C986177DA1F1B1E8D0723ADABFD5672EFD6837BD6289057627FBE8E40F608F08EB40068BA8D6ABE85';
wwv_flow_api.g_varchar2_table(16) := '67D1E93EBA62D067AA7400961CC7DEF50A40DEB7F570FD81EC11E0EDE92EB3BBFC3442D08AA8AF95F36C833CE8809CB0FAB6BCB56B2D2DB9773B64530796EC11609764282CEF02735558C5A85644FB5132AF0D61E7DAB1E4F6F00A9F3FB067CB3BCFDFD1';
wwv_flow_api.g_varchar2_table(17) := 'EBF3257B8171AD41F674E09F23192DB89C8C7A4D30C6B06DC9B6BBBE293634D207901FE9F53D76B0D7B2FCBD3CC0E8EDCDF70461D50563CE82ABCE6A151B287792959F15DB92E9AE236D4B7D386ADCF266ED2D791A608255C1242B3FC670D6DA5D47C2CB';
wwv_flow_api.g_varchar2_table(18) := '7C41FFEE2F1FDE7D67AFAFB766EEDA38C0C69CDE2412AC4AB2190BD6ACA5400E02643C4ABC77F3A1BE0DB502D938C08D32CFD268A8AB390BD6D52A90E36A9DDCB60842EEAB15C8C601D63D6CA8AB590BD65D57132F1BE4D61B6B05B239801BD13797765C';
wwv_flow_api.g_varchar2_table(19) := 'A801ABE4EA803CC61DAF1B71B367CBE1BE7BE8AE556553B04E36077023AD833554A51F176A8A4AAE29909B22AD0B7D49E9DB7A68F726BD6CEAB5AABB776D0E6076BDD1AC78EA260C2990836DAD0B20A8E735C8BDB2DDAA26C8E600661720B086C2786A99';
wwv_flow_api.g_varchar2_table(20) := 'CD0F322678D504D91CC0B4067461EA8C822EA3E18233BBC6986C5B72DF96B7FB1EE03ABC5A209B03B8E1640D866BA38D0AE4C4C8580C13AF799806ECDA72C40DB26514138F95EDC884B53602CBE4A19C3BEDA2ABB34C2AC4098F3982F16180DCD63AD717';
wwv_flow_api.g_varchar2_table(21) := 'B79EDF7C68CF176C4B168CC9E640F608F0F67427282C2DB0746A7DC752CB244420F10CFDE40DF3D5D5E9868EA7AE8C20E87A9C5B9B0637BA9C2AC32FE7F8CA2E476905E323A3B0E4700FFEC2EDDFBE7468F7830A649C446DDBB72F400AAFC123C0AEE6DD';
wwv_flow_api.g_varchar2_table(22) := '9D71253746148E92FFDD96AC14165FEAEAF442C753574610F472CBB9B56970A3CBA932FC72FE4A519753257C4DB064AE93E7E28FE0F0B7507D0FB124CF944D1C359A03985CA519E75DFD06DB8214303E1F9EBEF1FB920A8B803F8938EFD31F4C8032EEFD';
wwv_flow_api.g_varchar2_table(23) := '28AFD2F4353BDF753F292DCAA4F254FB81C4E8F84453243C1B0FD73FF7952336C86AADEC56BA0A246AF63CB802066A424234710AE08B25241E4B0446628971240D5B74B5799594895A2BB239D679FA3A597E763AEF41A3DA242DCC7B646CD8176AEE4E4C';
wwv_flow_api.g_varchar2_table(24) := '247FB4F1D5673E7EEDEE3F3FCAE7AEF99A0C16A8245C7B001327CA932E1920C7C6A22D318C8548E1F6A19234AE531F00B4150C36E38FCF13F0182BE14BE68389A3FA2D0A9532641CE0DA49A844119041053222A16622EA938978D0863695E954A6B561B2';
wwv_flow_api.g_varchar2_table(25) := 'BA75BEBEBACBE54BCB97EF9403C01CCA7DCD41B11289784CFC7177E94AE31E01DE91D36EB16EE510D42221852322A1165AB32551D83191A794536E93050B8454679D72A97BD29448AB6954D3D8A94E5A789B00DE2FA09B755E93A16FCBBD7A9C646D2FB7';
wwv_flow_api.g_varchar2_table(26) := 'BDFA294FF96BE1869A7DD21CC45B4630CBB52735E9B84ECB77258AEE74CE92DDF785E29A3675B5F85A276E8220B89443BF26A342C97904D8D5AA8B27576A7D4735C8E4B21596DC82978DD07A097CDD046F46640E600AA5AE045322426E90E9AE5B9AED8E';
wwv_flow_api.g_varchar2_table(27) := 'D4B42FEEC67794D891FCC5CC01CCFA1BD18A35DF9429F96F05C0987C296D75CB99E5A62C9813A43980C91304628EB52993A6DD909B71029C0279EA5076B360AAF7E600762C60EAC4614A0459F5E80EA44046BE4ECB2A6AFAB61ACD9803D8746F6B559FDB';
wwv_flow_api.g_varchar2_table(28) := '8C522043F49C7C3560F008F08ECC2E37A60C32FBA0EF745F522023A30141F608F0762D0E7BF0756B7F3AA73163EC4B5D80EC92710592F408B0AB450A430BC495DCD0D19A81EC166496972C53A0E60066C35793056B41D604647382340BB016CAD576AD09';
wwv_flow_api.g_varchar2_table(29) := 'C86684380D70A9726C5090A7012E156096CB0B3212EB78763D0D703900E703995B9BFA88B1DCBAA6A0FC34C09508D96DC93C81E25AB94E419E06B8128049D320209B03981DBED64203806C0E60F7DAFC5A02DAADD875E8AECD017C2D815AA8AF7506F234';
wwv_flow_api.g_varchar2_table(30) := 'C085C02A374F7B31A3206F2F978B8CF2C601767BAC8C96AE851B77E72B00D94D9E16D78E74B482987180B51257C0CBD5475226C8D5909D7180AF3E943CF6A84C903DB696433E0D708E480C266893AC21C8D3001BC433A72A0EAAA582ACCBE554E22D611A';
wwv_flow_api.g_varchar2_table(31) := '606FF22B4EED9E3915B26477B9E2B5965C621AE09245E5B1A0B6D04220A79AD085530915478C035C2545ACB883754398EDAEF39C42A565978E49F62FBC96D921E3009BD3BD327BD208C5DDB835E3144A83ECF09E5F763B3CF5CC1CC06EE63DB1740D116B';
wwv_flow_api.g_varchar2_table(32) := '90D9E52A3D34600EE0FCEA770DA155615715C8EA6F94D333EE0AABCA4796FA3BE37C9965A54D5B7059E252856914941B275EB460BC33C47498B660D3122DA73E824B9009AEDB5DA716CFAC6C3BBF2A0EE600AE98856B9C507B3E5E8380433DFA83388CDA';
wwv_flow_api.g_varchar2_table(33) := '44300EB0E6D70473D75A1DEA3D78B46883C1DC18EC3045FECA05D97EFD79614A5DA7BE66CB20FDA3445A42F871C1EC4259F72CA9DE61987AC0AA380DABB0E9ECCADC6DB8D3C9E764BCDA94B9DFA4A701974D985B552AC538C0A99A4B88B043145004AF77';
wwv_flow_api.g_varchar2_table(34) := '0BA0571476AE507C788195257CA7501C63555C89372D03D6C1973AB6A10EFE54B75D874D336AE1A535C8CBADD306A90939ADA0B3834D33061A4E7526A36159BE7CA9592181976B8127F2C0401A3FD2799D407A4C71C39C3283AEB04CB27CC56B06B00697';
wwv_flow_api.g_varchar2_table(35) := 'A0BD941887C4018523B47C8C2EF105A40B9F367F4062A09970C44A70C7717FC05D07EE05C0AD0F342BF0F30146BA2B56425E8D4FD8ED3A346BFD4DD2023EB269C86F0BA00B22EF72322E871378ED1269F2059459851721B583D78A423EEDAAA822FB0D6F';
wwv_flow_api.g_varchar2_table(36) := '15927A23A3DD10DC1080F85668A684FD41650D4AFD75D5901FED630C409C4C4CC8AFE363584A44E53600D701B0A3C8A3A57482F6DB2DED00262009284A13EABC9C8CC97B132388B3939980517E51D0DD807A36853A95AAD0FAA368E7686C540693090532';
wwv_flow_api.g_varchar2_table(37) := 'AD9F1092575AFA5980FA01EA5D02BA3F0D5D2F739BDB64663024AD0092963C6AC565201E9573B131393C312C17704FA59C440D506BF583390B2E43EBD8615AC34908607D5358BE3B7F9D2C08CD90282CC379515446CF2720F02BF171391F1D9623C36764';
wwv_flow_api.g_varchar2_table(38) := 'D7E0A7721482BE1982A6F53FDE3A539E98B74E663587650C20B400F051E43FF7D93BF283C113B22910526E5E8345C05F4F46E507ED73E5B1F9B743292C69064817A110FFFCE941D93976411E007004BA09D6C8F2FBA15CEB83ADF2D4CC25B2A6A347E6B5';
wwv_flow_api.g_varchar2_table(39) := 'CE90B6600B2C3A2001804F45643D71284914EFA93B131D925F5CF8BDF40F9D922EC7926B01B43980CBE49EFA304C6BF3FBA5AB2522DD00781CA06880B5BE5070AC7A3E7278BD63E60DB26E609EFCCBE9C3720242A72B0D01D059A176990D8B1A8792D0E2';
wwv_flow_api.g_varchar2_table(40) := 'BA91F647DD2BE5F5B18B7214CA71A3BF5946D5886C8F951C12225090D9A10E65F52D70CD7E00152218C8631D0180CBEB6FA044DF8BCC9587BB57C9B2C82C09838E5CD16A6D1BC70581BC5B50077F53ABCC6B9B29C7C72ECBDF4319AFC7FBBDA9049C3FE8';
wwv_flow_api.g_varchar2_table(41) := '7ED914D5FF36077005BC72B242218DC3EAC6E08279C56B7695A0295C8A4F4F9D26001C431B847B4FD762A4FBE4AF4FBE01F94EA83A483F96689268025E00B4BC2E6FEF96C7BB56C823A70FC91C5856B323645511E863B0D0318CC19CC4D97C4C28B0F554';
wwv_flow_api.g_varchar2_table(42) := '9623E8AB89A8FC6DE7627974DE6DD203258C83661C6D51199AA00C848CB4040EEF08C61531DC4FA0FD18DA74D4C96EB2D46F76DC50300E70391ACA973453201496FED0551E1BB92887874EC3FDF96506DCE0D2B62E25DC242C8B4086B00BB0A673BEFCF1';
wwv_flow_api.g_varchar2_table(43) := 'E02979E3FCBBCAD26821FCD8F5384287A0EFED5A224F0E9F951F0E9D54AE9A22D7F2E38C37000F4240342D958305A87CFF03709F6C9F2F7F326FADCC8187188532D072438126801C97E343E7E4C4D81519024F54C830D26761C8E9865798854F33BC082B';
wwv_flow_api.g_varchar2_table(44) := '637BA5C825552615F18EB271804BED0C59CFEC07292D05D089D1CBF2CD530761BE4DD2035BDDD81C9127E7DF21AB31F6597E2C3F60191C675745668B5CF02B0B627DAC8181F552E01CBBAF83C0B7C1B51E18BB24A700D83CD4499019548B8A8820D8D4C0';
wwv_flow_api.g_varchar2_table(45) := '1A15F8E422868BFB9BDAE4D19ECF0130821B45BD3E6901889F8D0DC8CFCFBE2FBF84D2BCC74995433B07BCCE8382AE6C8AC8A68E79720A13AD9BC127276BF412C5826A9A858A172D56552ADF1CC09968A51A281899A42304477C4D7227961A8CBF307A4E';
wwv_flow_api.g_varchar2_table(46) := '565DF85816C192C38120DC244406C3EBC2984B2588C3B255407D6483F7B66780AB866B5F0157FD9DAEE5F2CD33876536A4D74C627770F1C1A6190E02E09D70EF8BDAAE57EE96455AD036C17DEAC401F9C9F0295984717D212659CB40C47C2EDF86A054FB';
wwv_flow_api.g_varchar2_table(47) := 'C62FC9AEE8655907DE66C2AB70702187258BA8E482A8B448C8EA6991D285B25D422A54AC943CBAC999709D9CC1CE8005DC120CCB27B11119852B24706C8A32E0048DD6A6EF69854158D0105CE90723E7D518CBB19A651F98B54CBE1FE991D7943BCDE202';
wwv_flow_api.g_varchar2_table(48) := '05B44C556928C52658FE9A1973C103975E984DA35ECE115E84E5FE0433E37B836DB208F3012EF39432E19BF11E58F8DD98816F04B8F80D889CF57456CB55BFADAD054FD63D0806EFD7576E6D1CD6FA2E5CEB172134CE96D3608A8C40E0787B36DCBA0DB2';
wwv_flow_api.g_varchar2_table(49) := 'AE2E08E0F75F3AAEDEE8BE66E6024CA4A2321333DB87BB57CB6FE1AAB951614FA41C0A54CA7A19D4D604ACF74EACCDBBB0B6E6B8AFD201DED1D10BD28F59F1E7C00B95F01CEAF91DCAE60FB6CAAC846270CDAEEBCF5FB67AA9E60036D803BAD818403D00';
wwv_flow_api.g_varchar2_table(50) := '2B80E393E500E7A1EB164B04132ECE62295CFEBEC2494C70042073CB5107A6737C1EC2D268F7D9DFC9A248975A0E71567B7347B7FC05DCEEB7CE1E5188A6A96C6A7641593094666173BB9AB1DB63A75D92EDBD817AEF09B4C839B4BBB6A543BED7311FED';
wwv_flow_api.g_varchar2_table(51) := 'D91B2CA4B5C5C05935E2207B73E88CECC7BA9A20B3168362D25D2E78350770B6B40A363B79262D86B3D07F9CB54ACD643B612DB7600C5D82F52777A928F030803F3D3E28FB073EC5180CEB00E0EEC0329D00E11F2E7D2C5FB8785C1E9CBD5C29059D295D';
wwv_flow_api.g_varchar2_table(52) := 'F55F8E9C95A7AF1CC748ECD0B92E6AB2056B0D053152B35E20C26C2E8586E109B846E6D0F13E3669BE8E65D3E69E5512013F9CF8A9259D4DA2EA265F132793F263B4B72140807D53BE1636073055D3B37A420010E05258DD624CA8581DDD2D779268B974';
wwv_flow_api.g_varchar2_table(53) := 'ABDC641882A07F71EE0379119B184D98E850F8196D2B3E206958F233E7DE93C5E1EB6559FB2CB536BE1EBB5DDF80AB7E1AE3284121866A06848B3B28705D09ACD23EBAB001677B54106E8BF2C3C0AAA884E9909E9DDB698AB174F614C4CC4DB2C82C7BE8';
wwv_flow_api.g_varchar2_table(54) := '31A8891204D68AC90AD795B6F02048CC60B9563D05CBDD73EAB0FCD5C58F64392D07ED29ABCB6A97600491FF6B4CCE7E0A9007B187CD4919156565C71CF9A7AE9B651863A862D9C5B71DC5E4880AE504C2A2D6B950266A84FEF91D82C90D15CED4A370D9';
wwv_flow_api.g_varchar2_table(55) := 'DC8CA1B2319F5E44C533344FD758E46A500FCC5970119E4BCDA61B8B2612B02E7B5381FBBBDC5F1EC6D877141B20FF75F9B83C8731ED0E085B2DA72040D2D848B95BB1DDE1038156F9BB811372DBA56EF983D92B20F4A4DA777E68D64DF2E695130A20CE';
wwv_flow_api.g_varchar2_table(56) := 'BC5381260D01D34B50198250326E8410F82EAC8717426978C8712BAEEF62C2F63CF6AE79507219E597C353DC8FE180CAC999377E74CBE62D5D396225A0676B598ACA4BA4CE00B6606541796FE0B4FCECFC876AD94198CF02DCF760890771D2C3B3E3CFE3';
wwv_flow_api.g_varchar2_table(57) := 'F080FBBA04BF60403E956019687E7CEE7D5906B7BF146339B728B979B1E1BA4558C670F798FA614B55B97B00FEFBE88002398CB198AD307D1100DCDCDA25FF3AFC997CB1A95D8E81AF172E7F8C5C28487C48BE9F5C2EF7628C675D64CD9F0354117E0B76';
wwv_flow_api.g_varchar2_table(58) := 'A6B2CCDA029C23005BD01701E40F078EE106EC61F6C9F3D9A510FAE7719AC331651C22E748C7F462819B0F3DB0B6FF8D0DCB0B58C33E11BA4BCD8E699DDD38E42070EE7153CD9AE11D7E337E591E19BFA2267CB4438ED79D98CD3F82038CD7B089F1DFB1';
wwv_flow_api.g_varchar2_table(59) := '419C37B7CA83D8B56A078FFF015E66A09DC281FC4E2DC8B5057892BE72D9B104825B086B56C2855068AD7C4282C0524CC5A1B545CDF1993B493CFCFF1BB8EA5B2FC25577AF80FBC419317FDE2E4B49144BB0F833185B5FB9FC89DCDC3E47ADBF39CE26D0';
wwv_flow_api.g_varchar2_table(60) := 'FA2DD8FC787AC146D90B8FC049DEA738D1EAA0DA2570568DBAECFA26E998CD52F16F8FE4EE066A0BF02428D1AA8EC262AEC369049FA020407A36380989BB4F3971BAF3106AB81175ED3C9F76D5EAF40AA5DD75A269044B6EC130F0D4954F646D7B0F0E2C';
wwv_flow_api.g_varchar2_table(61) := '9662B2C727493026A31E6E9E2C08CF94AF8F62D3646214E949A5044CE38E97DA2A455BEC073FE9E08EA75373626E867232CB4BA82DC0E82FBBAC669D4A185C8AE839B13D2AF25B6F1FE474CD9117295807FFA9D9AB8A650A9363F90D70A1BF9A1892BBE0';
wwv_flow_api.g_varchar2_table(62) := 'AABF0B57CD7D6D1E48100345ABC1C095EEBF1DA93FC2B93397663C870EE05C378A9DAB4422A9F6C16763A7CB5E9B633987F2248F617DCC349E84713E416F940E442E93AF749E2B56421157E982516D18050B959C592663DA3279ACC623386EE6733B92E7';
wwv_flow_api.g_varchar2_table(63) := 'B6A50842293ADAE41602EBE0A13DE9F9A1A531B00C3F74EDFCACC3F8DA3BF889BC7AF118965141055E0B3621B8FBC58F3D33E7FE9925F351DF87F151E9C5B9F3AFCE7E80C771C6C127F69FF1E190C1651115CB8F0FC77402DB8C79031582E0F20991CFF0';
wwv_flow_api.g_varchar2_table(64) := '644727C0B7A1B567E360A370501D2B5CA4D45CB3165C06631476073A3E01A19C861028583E8D118250CFE399A62E2512DBB226EB0CAD95758CC2759E8A0EAAC300A68D43D883493E4C87A3448798ACD18AC348C32F31CBAE0B1FAA99340FF1E9AA5B01CA';
wwv_flow_api.g_varchar2_table(65) := '451CEF8D82074D1705F56228C40900FB9D536FC9B771FEBCA97381DC88D9F475D83051CB21D4A9039746973041BC046079A6FDDBC1CFD4132537016CF2912EA929AA7F2D03923CCCF0B7E6F173E4771D78F66E78A6977DC1402009FF854A8B7A06364C2B';
wwv_flow_api.g_varchar2_table(66) := 'A0B5CEC3EC3484318E4B165AE3659CF89C8150B37793B239601D7C702F0C373817336C6E8AD86E5AE42C9464006029D7E922240D3F7C5C682EB633E7602B947550C1A86CA730691A8582683A8282A305944FC821B8E759E093E7D3CBF1E9629B00CFE623';
wwv_flow_api.g_varchar2_table(67) := 'A14EBB4EA2DD8F30637F19FC735BF3367A15C5978B8949A2682BE90F06FC561C3F311B907B5FDFF0F8AB70114AC69390144D366BC1459B4B17A0E0B4505F87F55D8230F81405AD6C3E7AD709D08A693CAD82408C009057A257D4091467DD7C92721EEAC8';
wwv_flow_api.g_varchar2_table(68) := '2758D210907608FD38407819EBEB08BD0740A637980B17CB3A753996E5B22C4C89C3950F00E837308EFF1CEBE47460299B5BC23D1F75AF433D6DD839A3ABE750C4122587621D2FB9223E516A3294D50B5B24B4D28538DC5F94969112080553AC3AE61308';
wwv_flow_api.g_varchar2_table(69) := '6EFE2FF5413D9C3A281FD273B331BB0E7DCF3C3E98D70311B0BC43AA144C838B64159847C5E3956BDE19F8DC8438CBD16330D89341BB1EC639731F4BE5A92235F9320B70859AC7AD3F47164A0814243FA5049663B3B4B272EB50ED66353259DB9A1F4DA3';
wwv_flow_api.g_varchar2_table(70) := 'CBE9740D3441D78CE8BCAC268ADF564C985BB55980C15825BC554293DD954AEAF04A43C5E2C71D2AA953D37BA1D575645F8B4E86B2090ADE671A51C1A2D399B91248294B2A925BA6DC14B3004305ABA185E576AA51CBA764978A78EF8939801DA60C2A9F';
wwv_flow_api.g_varchar2_table(71) := 'F7DE35580DD5909D3980ABC15D8301548FEC9A03B81E7B37CD53F11DA7C232DA91993D6DC599F2A8E48E323428476F16DCBFD21E79F960148F7C0C4E0E2A91CD5541A365A81FB7EEEFD7291575CF1BC0DBDE57BA66F91336BC0635AFA2DE5C0D448E0C95';
wwv_flow_api.g_varchar2_table(72) := '4CD91F47C69576CD13C0DB1C0BF62503B05E6CE6E23FDE144316A73F15C840C90E32A42C954C89AFF6921522EC6D276B9BDD2A8EC08FE124F5A36047DBAAD895219ED8A517C48C33D0D1E8747D5519AE2F7759266797CBBE7791AAB2FA5E3B35777977DC';
wwv_flow_api.g_varchar2_table(73) := '5D77A17496D375691A9D964DA7F3753F75395E19B2CBEBFBCC6B12320C40861FE13D05C7149D236315AFE0CBCD7EF9E45034ECF0934559FFCACEAFE27CEF59303823A733E5D77CED513840C707470660C18FBF71F79FFD5409C125E34A84E20D60B6E862';
wwv_flow_api.g_varchar2_table(74) := '60C36BCFDE89479AB7E2C1B34E3C3C93B4FD7FD62890D2706ECB33CFB9EA74CD91521B3680A0F352F102B46E8B48956744074DABEF9DABBB0D2665DFBB8B6B1EDD6993F1EB2EC3B8A64D95D7AF7AF2E3C110EB0A4E245F3CB0F1F13715994BB6D9D54CED';
wwv_flow_api.g_varchar2_table(75) := '3D19990E66256048A6FF0F0692B978568E39080000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72356043932797207)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/png.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D000013A8494441547801ED9D7B8C1DD75DC77F6766EE6377BD8E63A7B14DEB47623B76B0A14D82DD1A2AA044508AAA4A88DA552142FC81AA4642FC51C701';
wwv_flow_api.g_varchar2_table(7) := '21A46C25FEE01F1EAA280505A14013C7DD0D8156A0A23455DBD0AA51910291EA3426D879D42471E2B7D7BB77EF9D3B87EFF7CCCC7DCCDEBB7B1FE7DE3B773D47BE3BAF737E73E6F739BFDFF99D330F8B58485A8BB22066A422F4CC8CA365FCAF23A9C4BE';
wwv_flow_api.g_varchar2_table(8) := 'C110AE5202DD8894BFF4F14355A97E422BB541021D384EF27469D946C5B4460D83A2E4A72FC8C6ED8F4EFCC69FBDAE678FB872642E88AF272DB5EDA71E7D016E84BBF0371FFBA4D2EAEF8A93B95B4C85FA92DCCF25755A1615D415116F93F8F9CDFFEE79';
wwv_flow_api.g_varchar2_table(9) := 'EE83EAD7FFF435FDAD194F7E71A6BA5620F785812D5E1D9DABEABFFDE8D625ED7DA3B02EB7BF747D095A53A9B5DD3A7E200C2A8153BC6D31BF71FBB4EF57BFEFF9EE6FAA4FAF2DC87D81989B0BD5B5183877C2E1EDADDC00DB102EE5A6FCA7157A5C8F57';
wwv_flow_api.g_varchar2_table(10) := 'E0FBC1BC373D71D8F7FC27F4EC4377A88FCCF8F2ED19772DC4167D013EB27FBFE97B556094059330898B31F8C5D51517BE5AF9F38BDA9B2CFEACAF541DF2E7C71F725F80E74E9D324CB5A3081AB15548789CFE6A09585D0761A2F2174A556FAA70D840FE';
wwv_flow_api.g_varchar2_table(11) := 'E7E3BBD40C2C796ED619674BEE0B706CC1115043799CE08675850A94D28E83A1009AA87F6309908B87FD8A3C597AE2F81E75F468759C21F7053809730C0D38BC049035033D65E206408625AF2B1C740B0277FD87BBC719B255C049E0E3B28D81BC99AAA1';
wwv_flow_api.g_varchar2_table(12) := '0DA3CED4490879B270D097EA8971869C01064D1D5B70BD45422FB1BB0664159CD4B30FEF0D2DF9C858F5C919609A6B64C175BE662DB4E405F6C9F9FB7CA54F2E3D756C1FC7FD32373E9033C060692C384137DA0C2133F09A2C7CC0D1CE937ACC20678041';
wwv_flow_api.g_varchar2_table(13) := 'D258706BC0DC5BB76440F60179E9E987EF1E174BB60AD8CC7AB45754BA8FAC5CF926C8CA0F66F5D30F1DA84346149ED26415706AAFB213E5AF5EF90872A99A5B573CE0070A961C433E8AC02B9D90AD02EE448F639E07FA62748D71F244E180F2D30F3903';
wwv_flow_api.g_varchar2_table(14) := 'DC7D8B0B21635A33375538E0C092CB273FF77EBAEBB93958321E1CE85EE4E04AA4AA3283BBCC9525B71807AF5C008117BA6CC75F58F2115D1F509EFB64F9A9CFDD739443A89F3CA5D204D92AE095E394D57436BAE36DC6C12B5608F71AD16B6B1773D784';
wwv_flow_api.g_varchar2_table(15) := '7CB768E704219BC02B4590AD025E3D4E5951676378B00E393755DC67209F3C7EAF81FC08F0A7C05D5B053CAE166C5A560F950F8B34409E2CEE53AE9C289F3C7650A919731F72D490AD021E6B0BEEA1F22CD204997DF25461AFB82A843C03C88F8CD692AD';
wwv_flow_api.g_varchar2_table(16) := '021E431F1B1AEFF29B0D1D5F4ABD5D3459F26EE53A4FA4C19233C040D94B90D5BA054490C3E87A8F813CFBF0213C193232779D010629BBB350CD900577A12AB30F1D1E15E40C706CC1AD4DB2C7BD75C8B9C9C21D789AE0C4A8206780AD5B70DC261A204F';
wwv_flow_api.g_varchar2_table(17) := '15768E0A7206183C4C1FDCC3302946D97E9980ACD49395D93FF8F030DDB555C003D1517BED8DC99106C893851DCA094E54BE72ECE78705D93CD96F4B53F521832D894394531FD40EE0A475C898D6DC565D5C7ABC3277FCB7D49199FF608007C37062E0B6';
wwv_flow_api.g_varchar2_table(18) := '4F6E15B0EDCAAD2D790D9027F2DB2AA5F213957F3AF600BA87E7F82CA796998140B6EAA2D71690415C4D0479B1ECE78AF96D1298E8FA97B057CB23337A10D39A19E098E3D002084216D75F2C57F02ED47B61C15FAE3CFD501DB2B67B3FD92AE0A1E92886';
wwv_flow_api.g_varchar2_table(19) := '626969263A861B4098371B713FB9E24E167E42AA823EF9E1FB8D250B2CD92264AB8087AB234B74F9F2199F8B4EB44E6EAEFA4386380F6B13AFB75BE29D4B1E8AFF405DDAC3E33F153CFEB31587FEB1327BEC97099977A266F9B5010BC92A60537B0B951A';
wwv_flow_api.g_varchar2_table(20) := 'AE08A880371BA86EF3024B787636D6557FC810E761A978BDDD12647928FCC3153E34A0540EEEDAA7252BE53C5E993DFEAB3CC2A7436CF4C956019BDAB376294F4D0DD1588C8BEF7238E238583A8E1EE6CF31E7536E50AA94DDA9E2EDB841F198FEEA1F1B';
wwv_flow_api.g_varchar2_table(21) := 'C81C3A3536BA5ED47A530E93D810E9931D40D57EC9BD71FDDD12DE619F8F3CA871A1619E6695C6FBE286CC86D2B82F6E38F1BEC6D28DFBE2F5A6250AABAB329FF3DCCD4BE5CA9F9FFFC2A75ED9FCFB5F39C3D76444F0AC578FE9A6041CEB0A8845AA8B05';
wwv_flow_api.g_varchar2_table(22) := 'BD34EFCE2F89AEC255E335610338CE33AC65043B87253E00E3DC8D2F61BC0FE73E232FF12B0AD1B7327AA8CC4D0BB86E3D4A4DE4BC1CE3ACF932DEF7873A09B98972E376BCDE6E998410E7E3FE78BDCD921E20EF3A52F6AB7E50F5FDA4A85EB66F5AC054';
wwv_flow_api.g_varchar2_table(23) := '56AC67C4D1BAE0714BE47A03642ABC96C2C3E166BCDE6E592B14ADC4F9B819AFB7586257804ED7E5DD0F2F17A2893F939114D9E9B6D520ABD393A6299FD133A25B06330557A9E93CC32D514100148C7A87F86B1550253E93D1B5EA6E7AC08D1AA3C502B2';
wwv_flow_api.g_varchar2_table(24) := '4C17F02D079087C2879F62CBB67466AB8047A10F4B7AA889193964CB4AB40AD872E3AB297DD82B23856C598956010F1BC420CFD704195A1A89BBB6708119E0159458839C479F3C2CC86976D12BE86A6C0F8D04B2456D59B560CB8DCFE265F6276A9C215B';
wwv_flow_api.g_varchar2_table(25) := '056C393EE88F8AE5D243836C59895601AF550B8EDB4A136480E0B4A6F56459A655C0961B9F75DDD91058838CC9100FDAB31E5D5B56A255C03614380E326A90115DE3DEC0602CD9922232C03D2A9290F39CD604645AB235779D6617DDA3AEC6B65812B275';
wwv_flow_api.g_varchar2_table(26) := '776D41339905F7A9C446C86974D719E03E01B37823E4BEDD751664592032001149C86971D799055B84DD08B967774D21165306D8A23229AA06B9D77172E6A22D1319803803198F84F0C9105AF228DD7566C103004C9149C8D6C6C95DD63703DCA5C2BAC9';
wwv_flow_api.g_varchar2_table(27) := 'DE08B9EFE8BA9B1337E4CD0037286310AB31E4F505C7EE8C578795CD0077A8A87EB211720E9A9E1E01E40C703FE4BA281B5AF2F0216780BB80D46FD61832DD352DBA65E0C54C165306D8A2323B11D5E8AE5B42CEC6C19DA831DD79F865D2B04F56CB2D39';
wwv_flow_api.g_varchar2_table(28) := 'B3E074C3EBA47634D2D09239199270D7990577A2C2F1C89374D78398F1CAFAE011B785BABBA625E365C6CC458F9888E5D3D323D721B34F8E3F2461E7449905DBD1635F5262C89CCEE40D0A0660F82FE6ADA49BFA0D7F2B1AB424A41E7801721E9F71F0EC';
wwv_flow_api.g_varchar2_table(29) := 'F8EA0CB0254036C5D092115C5B4996C458A94B2624D2006DD7928796945A302E71B570D27CD3931A693770EC474607652318CB16A65EEDEAB42CF7C077A413B0530037568D6DB94DD2F83658FC33F962A5B20C1C9391C1CF3DB691611A10BFAF83AF1551';
wwv_flow_api.g_varchar2_table(30) := '8E49910CA788F3AF5036CABD7C81F21A3283251C626C1CD76979CE61ED4911E0080C15543A87CF815D6E0F59E50170BD88879F3B112A5597239D012E81955E878CAB2BC84023726E818C69C800D01834C197DE40D92BEDCBB6A44398682C6A12F3905B20';
wwv_flow_api.g_varchar2_table(31) := '1B754C01E414018EC0389EE85BEF8392A0786359092B20800030CB17452D9C058CB7F10EC99DC80F58017A2E968172F5C60F011E94DD5606AC6CE95DC83803199710D5EC0E1B0B3F3CBBF110CA4EB52EDB122E77A25EFC0013EAA06EA081FA37BA6C206D';
wwv_flow_api.g_varchar2_table(32) := '05F775202580A11C270768D744E7B78A7FEF03126CDE2DAA0208541A53639F1CC0524AD7C5B97149D4F9D3E2BEF675914528756227F6BF257AFD1EF10FFE8E041BB789F2DBC8A80244E99AA8F98BE2BCF543717EFC0D91F997456F3A2CFECFFC369690D5';
wwv_flow_api.g_varchar2_table(33) := '5896755829D1F3B8B0DAC52B92FBC163A2DE7C56A4B80DF5A6674934D295E4583E9612C0BC2A2881D6C60F84AEDB28FA96DBA11BC269A11CC2565BE100F135DE1DF748B0ED1EF15E785CD4A51721077D27BDC0F4A650866924ED64BC17F9F1A5B39DF788';
wwv_flow_api.g_varchar2_table(34) := 'B3FD3EF19EFF22C2D7EB38FF2609D6BF07EB89F327EBD2D8E808D82B207440FDB9D425732DED42009C782829458079BD04018557A09C7249147E0630ADD809BF8F8DAF659B7DAAC2810440BB39A9021097DEF7FE0290BF8FFDFB0087E517EB9028C3850C';
wwv_flow_api.g_varchar2_table(35) := '143132D838FCA8DFF626A4BAEB43A2AABEB82FFE03DC2CFB52FE0B903DF420FC149EC4E7C4194C06170D895F673109C78DF06833258B94018EB4C208964068CDB9823857DF16E78D17A0785849715A824D3BD04FBE2FCC0C2BA3F2AB5BEF1267D7AF8977';
wwv_flow_api.g_varchar2_table(36) := 'FE7100BC1F655D289F9F7DA48CBC38177F2CCE395838E516D74BF09E3B446FD81ACA648302D0EAF6F78BBAF073E2BEF1DFA29616EA8D2380679908CF1B46F73C351AE2E573E25C7BD7342E133DA39119B7BF8800D1DD802C2847C1234CE9044C4B60A2DB';
wwv_flow_api.g_varchar2_table(37) := '23A4F9CBE2FDE79FA04F7C0701D56E00DA8C7EF2B3E2EFFA2038E2126079922F4A70FB2ED1C5BB912F0416F6DB900519CE95B7E1823F0537FA53D85E0717BE57FC439F09A1A281D09A757E120D67A778DFFD233CB00E402E226D5AEED21B12DCF969093E';
wwv_flow_api.g_varchar2_table(38) := 'FC1994A7270134D4CD3DFBBCB82FFC9EC8141A94863B378940D18872048C7A8D38C5FE65B4D58878B6AD04DD720ED6E6DD89DF4691CB73E2BEF45544C09761A56CA3A1005D98123DB107564965272C87969B3B88F25BF0BB0DC1D963E2BEFC0C2C755E34';
wwv_flow_api.g_varchar2_table(39) := '1B094152D204874EB7A18B8065D25557D1583864E37A32B10156112D57713EE6F3D125709DFB5392A89D14A71812968CB2F1D318FAA8C95F41B48C61D222A2EE758061120011B619D3B652306570EC0BD78D21989AFC0594C730A904C070D9B5C47E35BF';
wwv_flow_api.g_varchar2_table(40) := '01FD31FA6733F402D8604768CDB54CD10ACF97DF1BE6D3184B1BCB463D8CE5860D265964D8DBE9B0E098E3B2AB6F5012AD023FC531F0D21928753D3EF2BCAEC15A2004C31A55C198D6CC82258551F1E813E98E69654B2FA2FC06E3964DDF1E6737C1192C';
wwv_flow_api.g_varchar2_table(41) := 'D65827AC92E70B60A5A63F8D33454B93E7629407F98CF56219773189ECA3D8B40AB801475FD7B24C0E958B7E50CA3FC238F375C0BD55AA777D54F4D44613F9864329C4BBD72F88DC78162E96B35B09290C944A88B0CBE720E37F4426EF9560D747E092D7';
wwv_flow_api.g_varchar2_table(42) := '43062272BA7036A0ABE7C37379683C9C893243A315D4C4C664F2A081C5CBBEAEDE6E61D4CE5E6A6B88AB9D22C1A226870A031842A8EE7F1016027739B10111F01E09B6DC65A267EED305B8EDC5AB88B47F803C3819DD39ADC808A20C0C77302EAEFEF417';
wwv_flow_api.g_varchar2_table(43) := 'B00F41521132B6ECC364CAAEB081F01CC575A2AE315A7F1E65A116CA605FDED39CF46A173CBCE356012738757E1535A261919A1C00A675E9F5B7236A4604CCC4E10FFA498E596971842B8880DDD3CF01CEBF01DE07B11FC74C8260FE838C60D376CC6C3D';
wwv_flow_api.g_varchar2_table(44) := '60F66A8E87D17F1A19D8C3E08CC196F7D2B3E2BCFD0CA62D77002E5DEDF827AB80139C3AD74E8D6858A4490E5D2D03230E59988CEBC57C31C69CD8C0BCEF25F14E7F0713147F8D40081170801B0C49F7BC920CBAE56BE7C53BF58CB83F7A14EE7F335A04';
wwv_flow_api.g_varchar2_table(45) := '6A60FADC155CB3A94CFAFF58053C90CBA5B2396F5C66A043A6D5708E7AE986389730D170F63BE2BC09CBE51D1C46D01CDE249391518695420692627F8CB132236875E13571CF7C53D43BDF4444BC2D74CDC6033435B3A4C4B1D94E3760581E67A1DC775E';
wwv_flow_api.g_varchar2_table(46) := '8585FE0B40C36D2218524B885CE75FC704C84BD8866517766209FACBC0701FFEE572E29EFB5F717FF835E4C325B39140869A7F1541D92940BD15AE7D17A03152A77B5F1B70D90AD301B89D3E8D6B859BC4B4A173F6AF3075F826607E2004E162C2A38831';
wwv_flow_api.g_varchar2_table(47) := '28DCB7B94DC8694C4E582C4B20CC468120CC7DE5F370ED795C35CA11B487D9A609CC6C3182AEF5B9ED2AB34CF058EC68A59114551CCA8EFA4F5977186E751EAE1850028C4FB99FFDA4996142BED5B8A0CFD6D3F7A31160F8C3FE9C1132C7B194A179E362';
wwv_flow_api.g_varchar2_table(48) := '350129524B1755490760B06A9FA87864A862F2BF0AC07C9CC60C5FE2002802B3A20C8AA08C6B58617E80E5C301B45C93D6265C5E5A3A0027F56BAC13408C85D1CAB0CE408993F85C9A7543A6FEA7AD8C580E65102833B691519796588B84C7F5321D3BE4';
wwv_flow_api.g_varchar2_table(49) := '99C463F17AB42B450BAB807BBECC5A41AEE0D50D0FFD246E137292C32CB96D529431CC16ED4B2E70900D806570E35DF32D6B0F56EF6158C506D375224094E3840764F266BE4994C5B968DED8378D26DC9DB6BF560147EDBCFB6B34464030541822DCEBEF';
wwv_flow_api.g_varchar2_table(50) := 'E05E2B6E08F0863F67A9B06D8CC41C67BE36A73096CE19280CABAE9F8738DC9FC5FD628D5B89328F694C3EAC67AC1F323A4E3C1FCA576E601AF32D706E686CA52B808C71734F0DA7E30AF495D12AE06ED4D65C6B1063A0E36246A9B220DE7F7D19D6C2F9';
wwv_flow_api.g_varchar2_table(51) := 'E4C872A05C931CEE6B17104532F094A42AF1FEF1DF87C1542CA37C1DDBD3216006566D5B4963CD7045CC8BB96FE7C229C93DF7973818F7DB58350FEBED88EAD4582E3DEB5601F77D59B42E0051D75E8115D2F5519950B083E9483EDEDAAAEF4D9E94AE14';
wwv_flow_api.g_varchar2_table(52) := '91B5BAF232642152AEC940F46C6E20F4D00C29B38249918BFF0779687471E263BB0CFA6E963EB89DE78CF5D1D192107318E332208A832B5A616D7E793529004819F94D09196828C672572BDFEA3864F2E643610B6446C7D94E8CBC4EBD412BB983DF67D5';
wwv_flow_api.g_varchar2_table(53) := '827BB08DD657489884CB6416B156C35D1DFDB521A3E944A8081F816DBA48D6AB87BA35C91DEC8655C0762FD586341B321A01D896D7287B30EB0D1143FF27686ADCFD8BCB2458D08055C0E3D7BE2D6830E522AC024EF9B5DE94D5CB00AF71EC19E00C70E7';
wwv_flow_api.g_varchar2_table(54) := '1AC882ACCE75D52EA76D1DF665C173A74E35C655BA71A3DD0564FB57D6405287091DAF5CB8C5D1BE001FD9BFDF34381518B6E605BC16E7C87675A181D882239D4AACE32E443465ED6BA2236E5D5ECE0D7C5F37CE3DC5F56C3A59B6B1AA064225E25134ED';
wwv_flow_api.g_varchar2_table(55) := 'F021339158C7AB966C93A13F0B3E124A2D6BFF554CD99DCE4D61BE36BC77C619F9ECD7B50E74401D2A479D9E7082B3D4EE9148C75CEF25255D7E573260B20AF3FAA6A52D7CF1639F745CF56861820F4D21F525B9AB6AAC8DCC91CF2B2D94AFA2C3FBDDC9';
wwv_flow_api.g_varchar2_table(56) := 'CF7EFD295E58A38E7BB9D0BE31345660E14B1F3FA4A4FA09BC418F774374507BF9BD979ADD4465F840A838B05BADAFB8E27E2DFFE0BFE21D9CFEE15A5321215B139609321AB0A5D3FF07FE45F428F0E564A70000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72356393914797210)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/ppt.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000001B569545874584D4C3A636F6D2E61646F62652E786D7000000000003C3F787061636B657420626567696E3D22EFBBBF222069643D2257354D304D704365686948';
wwv_flow_api.g_varchar2_table(2) := '7A7265537A4E54637A6B633964223F3E0A3C783A786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E352E30223E0A203C7264663A52444620786D6C6E733A7264663D22';
wwv_flow_api.g_varchar2_table(3) := '687474703A2F2F7777772E77332E6F72672F313939392F30322F32322D7264662D73796E7461782D6E7323223E0A20203C7264663A4465736372697074696F6E207264663A61626F75743D22220A20202020786D6C6E733A786D703D22687474703A2F2F';
wwv_flow_api.g_varchar2_table(4) := '6E732E61646F62652E636F6D2F7861702F312E302F220A20202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F220A202020786D703A43726561746F72546F6F6C3D2241646F626520496D6167';
wwv_flow_api.g_varchar2_table(5) := '655265616479220A202020746966663A4F7269656E746174696F6E3D2231222F3E0A203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A3C3F787061636B657420656E643D2272223F3EAFC2E87B000001866943435073524742204945433631';
wwv_flow_api.g_varchar2_table(6) := '3936362D322E31000028917591BB4B03411087BF248AA2110B5358081E122C24118D22DAF9407C201262045F4D725E1221678EBB0B229616B6292C7C6063101B6BEDC47F401004B512C1562C146C44CEB9448888996577BFFDEDCCECEE2C7817B2AA6ED5';
wwv_flow_api.g_varchar2_table(7) := 'F480BE6E9BB1895165617149A97BC2431301DAE948A89631128DCE50D53EEEC45BEC36ECE6AAEEF7AF35AE6A960A9E7AE161D5306DE149E1D90DDB70794F38A06612ABC267C221532E28FCE0EAC932BFB89C2EB1D7CD1930E3B131E180B092FEC5C95FAC';
wwv_flow_api.g_varchar2_table(8) := '664C5DB85F38A867F3EACF7DDC97F8B5F5F9395797DE86458C09465198629C3106E86548C601C244E8961555E223A5F8597212ABCA68B089C91A6932D88444CD4B764DE694E89AB4AC7888B97FF0B7B656AA2F523EC13F0DB5CF8EF3DE057587F0B5E338';
wwv_flow_api.g_varchar2_table(9) := '9FC78EF355049FD4E56AB7129FDB85C157D10B152D7804CDDB707E59D19227705180D6472361264A924FBA379582B753685A84961B68582ED7ED679FE23DC4B760E61AF60FA053FC9B57BE010C5B673DECD09369000000097048597300000B1300000B13';
wwv_flow_api.g_varchar2_table(10) := '01009A9C1800000E7349444154789CED9D6B901C5515C7FFE7F6EDE9DD996C126220041208420821AB64838924C1775992540AE5B1EB03B594C2075FFC4008FAC1C7F8C5D2F251A5555694A02292073B01C442850279A80906829486C50459DC40E49104';
wwv_flow_api.g_varchar2_table(11) := '934DF631337DEF3D7E98999DE9D999DDD9999E999EDDFE55CDCEECEDBEA74FDF7F9FDBE776F7DC017C8019E4879D66C2F1B860B4FE7E1453F30E318388C00090DEBA698D86BE9A89E6C2B011A27607EB8300980D1BD38648C771CC3B6F5BFB753F3CCCBD';
wwv_flow_api.g_varchar2_table(12) := 'DD16BA1326B73FD3819A042E1477E4671BAE27A63BDAA2F69CDA2D370202D805E4DBA0220B1E92D2BA99AEF9EE003F1E97787F5C4F17916B13B8B7DBA29E84E69F7F64618AE523CE2C7B45F274CA0528B0B19B8708C635A26DFE6864DE791D4AE9A7A4B2';
wwv_flow_api.g_varchar2_table(13) := '3E459F9C5E22D724442291791F35E2ED6C78993BEC222B6E0BBC98409000A09419921DED6B9554DBB9F7D60BE803718527E2D674C82D6A12B87BC50A0600324C2050B635A8355E397761014C6A689465B46D9D22CA8BFCEDD617B9B608EEEB230060410C';
wwv_flow_api.g_varchar2_table(14) := '80A9059B8261004080416A24A965CC59AB88B6F3FD5B2EA4785C21D12B5A59645F22380BB5E6094B00442C048199480DA7B48CB5AD552E7626B76F594A3D3DBA9545F635196AC9160000E64C3A451000480D27B59CE5ACB61C6CE7DEAF5DD4CA22B740B6';
wwv_flow_api.g_varchar2_table(15) := '5B7F888841008119281039EAAC56D03B5A59E45060009C8BE03C02C875D7CE6A456617F7DEB62C2372774B891C0A8C7C04179189E4919496B1C8E58A78576AF7E64BA827D152228702231BC1A5C976D7292DA3CE4AC16227B798C8A1C0C8467079F2911C';
wwv_flow_api.g_varchar2_table(16) := '75562A163B53F7DDB6BC5544F655E0D61C266599D8798FC8A44C2FDF776B675EE4B23D40D30987493926773E2B7252DBB3DA3A95A19DA931917B022B72D8454F8D6C769DD4B2DDE924157C914381A74E46E491A4B6634EA730B433BDEB96CBA827A11389';
wwv_flow_api.g_varchar2_table(17) := '1EC1F178A0DA3450CE348B12E3E0C9100C0835925232EA7492B476A677DFD2D5D393D0B8B48F8224729864A1EC3878E23A2002D852C32925A3CE72B0D891DE7D4B17054CE430C9AA89BCC876ACED12B0D891DEB56515F52434BE9579CEABD91E86119CA3';
wwv_flow_api.g_varchar2_table(18) := '0AE733550A448EB65D421676A4776D5E4D143740F3450E23384715CE138A441E4929197396C1A28CC8F1B869762437BD0B090255245963E48F0B4F245F4496D81E84480E0546754956394B63911C75969225B6A77B6F5B43F1E6891C0A8C096F36548157';
wwv_flow_api.g_varchar2_table(19) := '6410EF727B6F5DDB2C91438131E9CD86AA2CE644B6A3CE050CDAD12C914381E17704E7281039E62C6996C8A1C0C846705DC678452213ED747BBF7A6523450EC7C175C7D35D9F4FC2EC70EFD9FCDE46892CFD34D6F2E3E0BA1DA19EC46BB11E4DDDED26B6';
wwv_flow_api.g_varchar2_table(20) := 'DC40DDF1BF303331207282FB8DAF02874C4481C8ED91C56E32BDDDBD77F3A789E8CFCC00235E1791C3737043C98A3C9A56765B64310CED707B6FFD201118DF8A733DBAEB50E01C0D4B208800586A34EDCA68DBB944F41BF7BE0291D95F91C3240BD96152';
wwv_flow_api.g_varchar2_table(21) := '6313080241AA91946B459D73A071B79BB8ED4399AFABFA2B7278B3010628314CE24A5E9CFF5C491D64AF7867FF10C0520D275DD9EE2C24F05D6EEFE60F138189E2A6B7B7DBF263EFC208CE4CE74020EF5C23157D0795F29F2BA983AC7DCF0D0A225B8DA6';
wwv_flow_api.g_varchar2_table(22) := '951575CE211277BBBD5BAE02809E9E84F6E39C3C2323D873201298C832440242588684E046BE84104C822C9374D356ACED2CB2C49DFCC0D7AF02008AC74DADCF5DCFC8615266C8CB1024C02A690D9F3E96344C43B97B863CB64EA97AF903998BCAB868BD';
wwv_flow_api.g_varchar2_table(23) := '52758BED8CBD33408318B2A5B52095767FF4E64F3EFEEF055FB9A71F896E012474B5FB3A2305CEC110801E753835640DA5C09A990435E7549315DB26401389E520B108403F5E58C140A26ABB3356E07CF410B5DBD226620CA5198601511C8293861F4A87';
wwv_flow_api.g_varchar2_table(24) := 'ED14EB3280882590565A19AD941FFB39630506F2ED6B007664A6E33D5D203217AF5CFCB9DC7BA90D5550970063982D1091B433D2E4A6C9A896197FA12397DD32831C8BA8234224003206046EECAB544255344DC69499F10217C2001C8BD0E15026829B75';
wwv_flow_api.g_varchar2_table(25) := '32F691701C5C44D345F6797B33721C3C194D1539C8113C9DF0882C9AD45DFB4028F0048C891C69A0C841EEA2A7234D11D947C224AB025A59E430C9AA9086891CE424AB850EECAAF0884C80A9C70E07F91C3C9D23384761762DEB11C9418EE0994261245B';
wwv_flow_api.g_varchar2_table(26) := 'A24E91EC13A1C05592B9F3931159FA297290BBE89946B1C841CCAE43816BA450E42076D7A1C03EE06B771D2659C124A8DD7528B08FF8D25D874956B01913B9DA7172D845071F0610111991AD2677D7A1C075A258E46665D7A1C075A450645F2F864C8150';
wwv_flow_api.g_varchar2_table(27) := 'E03A931379B6239A22722870036000B6003A9A2072287083C84472E3450E056E203991673B02763991C371706B53D85D9714391C07B73E06399169BCC86104B73EB92FBDD982C6477218C1D387E2EEBA1E57BC42819B4CBEBB16B005F92E722870932114';
wwv_flow_api.g_varchar2_table(28) := '9F93AB9E7CBE24A1C0012027B22C48BC94EB8FED19FD0DFF20914FBC808E88405AFA13C7A1C001440AC0F1A96F0DBBE800C2007CEAA17D13383BD545FE734830F055E090E0E1AFC001799230248F5F4956D908A6D98B41B3CF29BD50A7C1C94160F42438';
wwv_flow_api.g_varchar2_table(29) := '3508F0C433F6D119178262F34B2F54A9ACAD13E0F42980CB4C9E6EC72016744EB89D093106E6B567406775822231EFA2FF3E537EBBC286386795A788474F82DF3A54BD2F1550B3C0A35B3712A3FCCFD258975C05B9EA63155862707A14E6957F403D7337';
wwv_flow_api.g_varchar2_table(30) := '787060DC1AB2AB07D6C55756608AC1E91198FE7D50CF6E070FBF31B688E62C4664D3372BF0A70C6E12C95F5C0771F60AD8EB3EEB5DF4E4EDD0FF7AA06435ABF33AD8EB3EE35DFFD11F43D759E07A2459559BA04814D6456B11B9EEFBA0F9CB6B30452027';
wwv_flow_api.g_varchar2_table(31) := '06EBD20F2272ED0F401D8B6AF2AC14FAC06EF089D73C6572750F6047C7AF1CE9805C758DA7C8BCF122F44B8FF8EE5731814CB228124564E33700D95EBBADD819B0377C03BEE781ACE1EEFDA5775BD1B9905D9F1AB7AA5C7503A86D56415D86BBE70E3422';
wwv_flow_api.g_varchar2_table(32) := '69F1E31C5C3827F6A4F0E09B306F1CCACCA62D1D90DD068ACD03CDF3461945E7C05ABE09FA40F99956CD5BAF808F0F646DB5656CCD3E0B346781673D316F11C492F7C10C3C012407A10FFD79BCB1480CD605971718D7D0FFDE33DE7F95CEAFF2EA53D087';
wwv_flow_api.g_varchar2_table(33) := '9F83757ED758997CE746E8BE07C74E0B34EB6CC8CE8F786CE817FF0A3ED65776BFFCA4E157B2CCD197E03EFEBDA25282B56C23EC2B6F04ECB6B1526BE97B2616F895E7A0F6DD5E64CA82F58EEB615F710320F2B3E25B17BF1F66E009F0D0EB25B60FD0BC';
wwv_flow_api.g_varchar2_table(34) := '8BBD026BB7E47AC5A8BDDB602DFA0960659B523A90EFFE1CDCC7BE9BF977CDE70019C957709350FB7E31A95DBF08C8952C863EF47BE8979FF694D2AC3219F384A634F43FEF8179EDA0D756C799B538587E738387A10E3CE429B3965E099ABF1CF4B665B0';
wwv_flow_api.g_varchar2_table(35) := '967A9342F5DC03E0916375F1A514011138831ED8E7F99FA2B301AAEEB729F4E1FD5E5BB1B955FB3519EAD9BBC023270B3646B0D7DE08FB8ACF677F4527039F3A06F58F5D75F3A314811298DABD22F0C8A949C7C6E56DCDF1DA1A3E51B55F93E20E433DBD';
wwv_flow_api.g_varchar2_table(36) := 'D35324CEBD1462F13BBCABEDFB0DA0D368247E089C9D53BB46848475E13AAFE1B75EA9CE966C8758F22E7F6C55883EF87B98A32F975D6E5E3B08D3FF585D7D28855F4956F66781A602819C3940C742D0AC05909D1B20CE5DE159C3BC3550B9ADF679795B';
wwv_flow_api.g_varchar2_table(37) := '5DD7421465E5E678F9C6F70786DAB30D916BBE83712DC106EEDE6D68C6B5DC9A056EBFF90F3CB2750380CADCB796AE8775D18328FE05A1716805DD5F62385380ECFA28E4CAAB27B5C5A9619881F1431EBF316FFE13E6C80B108BBC07AAEEFF1BF8F8C132';
wwv_flow_api.g_varchar2_table(38) := 'B5EA8B5FE760034C218269F2A1B3BBF72EF0B1177CB0C5701FFF2978E8F54ABDAB1A9AB30462E1B271E5E2ACA580E5D47DFBA5F04B60FFFA1E9586FAFBFDD07DF7D66C8A532370F7FC1A66E0491F1C9B1CB9FE0BF9F1700134FB4CC8559F6E880FC5F87B';
wwv_flow_api.g_varchar2_table(39) := 'A1A392107653E0E4A9CC6763C0A9212039044E0D814F1F837EFEB7158F13393D02A48633FF68054E0D83934340EA34F8E4EB507DF703A953D5EDCB1411E7BF07D6792BCB2E97976D823EF830F8F49186F833B65D9FEC54DC45EB81FD70FFF41D5F36AAFB';
wwv_flow_api.g_varchar2_table(40) := '1E197F25AB19081BF6BACF7B8A38350CB2DBF257D3640472FD17E13E54C39DAC6A5CAB83CD1977DB5F5EF68971D7BFD5FE0454DFA39E326BC9E510E75570BBD3470275A1A315A1D88271F7BBF9C47FA19FBF0F6AFF9DE0E469CF327BFD8D80B01BE65F28';
wwv_flow_api.g_varchar2_table(41) := '708DC82B6EF2DC20010077EFAF3257E052A7A0F6EFF62CA3390B20577EB261FE851382D78058D8056BA9F7EA9B3EFC1CCCAB4FE5FFEFBB1FE67FDEC44A767D0C34EBECC6F8E8A7B119F5682509C8F53779CBB482DABBCD5BC61AAAE8C100D80EE4BA2FD5';
wwv_flow_api.g_varchar2_table(42) := 'D7BF2C61045789B5FCA310F39778CAD4F30F83070F8F5BD71CD9073DF0776FFDB7AF8158F4EE7ABA08203C075787331B72CDC73D453C7A0AEAD9BBCA56514FDD0168EF2FC6DAEB6F02447D9FB9F0D57AA92EDA0CFC0DEE68FE5E299F78B56AFBFAC5C760';
wwv_flow_api.g_varchar2_table(43) := '8EBD94B775D4C72712878FC2DD7367C1C6CAFF7C2F45CF847AD67BA58D8FF703E9A1B27578F030D28FFC10D4E11D4E51743E78E88D32B56AC757814B75D1E6E801E0E8015FEC9B23FB8023FB265FB10A387572C2C7833CEB9EE8873ED13FE56D9881896F';
wwv_flow_api.g_varchar2_table(44) := '9ED48330C99AE68449D634278CE0694E98454F734281A739A1C0D39C30C90A187EB7614D0227FAFA0AF3AAF2DF210DA998E2362C6AE3295393C0DD2B56641E97354C002828BF15D4CA8C4D599969D3B136AE969AAE64E58E2E695B4629CEE9CB685C6FED';
wwv_flow_api.g_varchar2_table(45) := 'E9416AA85B8E461FB2994664300B62A0D911DC9D794FB3FA0F4087EC988DEC1C06F57A71D1ABDCB24A6C4C657BF5DCA782171B3B6683041D6A17E6E5C236AE969A8E0E661065A7561CF9E986EB8545DB9C767B6EED964B6DCCF33621659F831F6763226B';
wwv_flow_api.g_varchar2_table(46) := 'E4FD54EF0423EB4A72243DC8849BA25FFEE36EC0DBC6D550B3DB1E91B76E5A43D05733D15C1836C2DF411815BD9775A9CC672AFA5C69175DC7E9BA331803409020E69316ACDF456E7EF069A07671019F8E4B3F1C990AA35B3796F4BBFDE63F54EC43391B';
wwv_flow_api.g_varchar2_table(47) := 'D5DAF31BBFDAF4FFAA6C9F4E7AA475B50000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72356841569797213)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/pptx.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D000012D8494441547801ED9DFD8F1DD579C79F33735F76BDAF36367EC3F8055C6CEC2A351412D284B48D303428A4AAB296D256EA2F542D0622F51F08FB0F';
wwv_flow_api.g_varchar2_table(7) := '34ADF24B22A14888609B7A2325212D25ADDAA008A515694C4C441A4801139B97E097B0DED7BB77664EBFDF3333BB73EFBEF8DE9D33F7DEF1BD076667E6CC39CF9C793EE779CEDBDCB1888DA0B5B221A69D32C6C7B523D7C173D4EBB0501FD1F43995A294';
wwv_flow_api.g_varchar2_table(8) := '66BEFB5F98BD5B443D24A247B596C01147F87F662180E475CA67F902ADFB064B7269C7467972FC0EF5CED8EDDA9DD03A889F27B372B750703ACB4BC03DFAFCEC1795EB3C591C2C8FB6B0FCA96EE5A35A8E94446E287B2F1483C223FF78449D1BFFA12E8C';
wwv_flow_api.g_varchar2_table(9) := 'FFA1F8D70BE45480C74EA3C61F53FEFD2FCC6C1771FFBD34523E54999CAF42E83AED2A15AFA632A38CCA0B2418D9E0CCEDDC521A0AAADE7F7BBAF0A56F5C6790538298304A0D02B54F94FC4E75AA2A70D694D9F11B8C9795DB3451BEE74D97470B9F7095';
wwv_flow_api.g_varchar2_table(10) := '77E2B1B37AEFF81F296FFC4571AF87363915E0436363A6ED759552508603B746B551711DBF2D9614AE079552CD7FE44969A8F0491D5C5F9053017E6D628220C577D16541CFCA0036C819DBD961A9981A050F9B94CA55CF2F0F17EED1E29D78FCE7FA165A';
wwv_flow_api.g_varchar2_table(11) := 'F218AFE5B8779D0A706CC1114A5A7167534D94CED4CCA573AD1C3A20AD0CE4C1C23D81EF9DFA9B57E6F74F28E5E719722AC04BFA898FEAD4164777E0BEAE2A860567FF014D8C813C54B8ABA0DC13C75FD3B7E619B265C01D48B2A12285E3781D8EE76B20';
wwv_flow_api.g_varchar2_table(12) := 'ABAA77F2F84FF30BB96B01D7FA9A65337121E429CF47C7EB2EC7F59E7DE4ACBE2D8F96DCB5806B5C7434135767ECD48D5A0821DFE968EFD9C75EAD1CC81BE4AE055C63C1ABF7920D64B6C9B0E4DFD38173EAB15775AE20772D6063C1B119AF6CC11CF831';
wwv_flow_api.g_varchar2_table(13) := '18776D2C799090BD53C77F5E39682C79A2F387509601C71A338AE9FC3F3566BC4271793D864C773D0D4B0664F1D5E92F9FD587394D3BD6E1902D03BE96C65650629BA21A2EE95242E3AE69C9E5A1E2E1407BA7FEF66C6511B25EDDCDB7E909C3DB5A06DC';
wwv_flow_api.g_varchar2_table(14) := 'D66769EAE6EBF435A1BB469B5C1C2C1C76B45A847C0C96DC8990BB16F0926136552F98787108551E2C1E2E68E7D4E367163E46777D6C62C2312F0E342D32BB0C5D0BB8C6829B77AF80AC1DB4C91E7AD787031796FCB3852313C78EF9AFDD2EAA93205B06';
wwv_flow_api.g_varchar2_table(15) := '5CA3B6ECAAA56DC9ABF5A2D7B84FF41A8B5B99F2BCF260E1A02B72F2710359751464CB805338BE3594D9A997F0B49CE374314EF6D0F13A8037884E3EFA3F0B77D05DCB13229D60C99601E7D482D75B83B07A66202B4086259700590AEAE4F15716EE1A57';
wwv_flow_api.g_varchar2_table(16) := '2AE804C89601E7C782AD94942F38C49061C90BC6920BB721B663205B06BC5E53687DBE1A5FD37C276BA9C006B2798505ABC9A1BB2E0D176F75943AD10996DCB5809708E1681D9DACDAFCE1192CD740A625639CBC9F90D1F1BABB9DEEBA6B01D7B8E83416';
wwv_flow_api.g_varchar2_table(17) := '9C240DB7B008196D3221A3E3F5ECA367AAF7B40B72D702AE71D1692D38861CD59A24E4D26071AF76F4C9475F6D0FE4AE051C33317B5B169C109A848C19AF3D12B4077277038ECDD89605270073156A113267BC08D9D7A78EFFACFA29E3AE91B615E364CB';
wwv_flow_api.g_varchar2_table(18) := '80638D259FB4838F23979A490923D906328750665AB3B81BAF909F449B7CEFF838C6C908E37C9F3CC3605978961AB3AB855696741132274306DC5D78D5FE99C7CF563F4DC84F60249D2564CB80ED42C8525AAB7D8D818C7132D693BDD20677177ED97802';
wwv_flow_api.g_varchar2_table(19) := '1DAF7B61D17A3C43C85D0BB895161C575442C67FA1BB1E28EE92404E3E76B6FAC71C876705B96B01D75870CD498C23B37D0879C6ABE2F59F9DE8C07F2B4BC89601B75653F6102C7B2FDA9EE89525D18114D0F10264774710C833E8787D360B4BB60CB81D';
wwv_flow_api.g_varchar2_table(20) := '8E6F650D3614BB541FCD2FD04C1EC6990D7FF85BAB8637E6BB467A4A5E946D961A0D64AC276F17473DFDE82BF3F719C858891A3B7D1A4BCCE98365C02C7D2E03DD2601857B1E9B9FC2E2A0E17D0379C2363892C91373D7A21942C19245159E397EB6FA00';
wwv_flow_api.g_varchar2_table(21) := '35C8B7436C8C932D03A666F210962A2256ECB5EBA8000B03E2BA4EA01CAC17B474C3AB7BAE72BDD960A13CE4DE88DF5A3FF577BFD406B2192BA79C654BFF11963CF05C56465644FC94103F19AD78DABD7265665E249836CBF74C4B574BCB35FE94117188';
wwv_flow_api.g_varchar2_table(22) := 'E3E28ACC8A928833F998368E8BF3D5C7E17A7C8FE4FE8A9A760BC5ADD54AE5AB7FFAFC6F7EF5DDCF6D7D93EF5DE33B0A7E525233C75D0A3854117ED02C155FCA1FCC6B5766A77510F81896D2A92D597833CA4C9716D0952E8A56BEE3A883907513B6370F';
wwv_flow_api.g_varchar2_table(23) := '8D890E3F94B13EE95D0C38B43234BACA2DF517F1D3515173D3608B194403797D0A4D952B80572995C4F7163C85DFC8A4921565EE62C0D440EC4A03AD8A65A3123D379580DC5A4B86FBC004175EC235050BD1C49FC9887835BDB3DCC96AFAFE1D9001EA64';
wwv_flow_api.g_varchar2_table(24) := 'E38BCE0C202BD53F045376143E93460FDED20DFD3DD6B83044A657F7998CF86AC3FB1EE0A4AAD0E1A12503327EBF00D5B003D4CA90C1ED2C03CEA084AD5430EFD56EC8F1F35A6981F93B1BAB61C9C35815DB6A61ED829C549FA5DE9165C0AD2691E1FDDA';
wwv_flow_api.g_varchar2_table(25) := '05D9F223F500AFA5D05643CEA085EB015E0B30AFB51272D2455FAB5C0D5EB70C38832AD8E083649AAC559033509F65C01954C14CC93521BC159033509F65C01954C12618649E741964F362A4BDDB66A03E4B9DF1F81933A882B1E84ED94790591CCDB9EB';
wwv_flow_api.g_varchar2_table(26) := '000B3D66E5C9420193EAEBCC71B08587CC83881A4BC68B175CA0B01D2C999E65176DFB293B589E815C8AA63541C306E40C5C740F709A3AB40C720684D2940F797B80532A301C274796ECA674D7C936386DB9A2FC3DC03614195B721F57A152B8EB0C1C40';
wwv_flow_api.g_varchar2_table(27) := '0FB00DC0941143E652A34BC819D05A47597B80D7A1B455B3C49069C969DD756F98B4AA9ADB7B2182EC748825F72C388BEA40F75C284908991DAF75B8EBDE38380B3216652E83DCC06448AF176D11402B44D5404ED1BB4E51D69E8B4EA1BC86B22E421E8E';
wwv_flow_api.g_varchar2_table(28) := '7AD76B58F23A3CF9B5CAD0037C2D0DD9B86E2017A336B9B596DC036C03602332162D391E27AF61C98DC86B304D0F70838AB2926C1132DD7571F90245B293D51B075B5179EB85D4B8EB3AC8C936B8374C6A3D1B6B77E4D262216E9313907B166C4DC56D16';
wwv_flow_api.g_varchar2_table(29) := '04926B59324BD7B3E03633B271FB6590133EBAD706DBD07007C848B86B653A5E11E49E0577001C2B45A0BB0EDB64FEAA51A16D5ED7DCF52A65B1544F5691DE8B6E50031164AC23AB02C6C93EFCB3B7D060DEB593F500AFAD9F165EADED7805D51EE0162A';
wwv_flow_api.g_varchar2_table(30) := 'BF85B76213CCD77EFAC34F4AA4BD736F262BAD0633C94FCA552B9273EBA2A982A8BFB9AA22E0F44C88F7AB26C48558567DDAF83E8CAFBFB696BC4EB9965BC07DD0363F47C3A1647D200846F3EB613E0EE221E54A80988E6EAC8C8BDC7309805B9C96713C';
wwv_flow_api.g_varchar2_table(31) := 'A63D792BDC0BD11D1D7209987AFE35A85D028922B45FAF779EB305DB886BC320D48F8DD016702106C7343C6645A9E2E47C248F714CCB40B84CD78FC8ED911C9EE729E40E30154CC5DFBD41CB6004AE5EE1B46AC2BC0413FEBF052517D0213D8057A346B0';
wwv_flow_api.g_varchar2_table(32) := '112665E0101F78153907D39CC3FEE37D5A76F7896C2A6919E0458479E4BF0AF01F5694BC816D01E44B48CBFC7909B902CCC24E41C9A3052D7FB9DB975B870359F0F9ADBA50DD49C57B4837057897E795FC72D2917FB9ECC8BB80B51DF0988EDBDBB8FE99';
wwv_flow_api.g_varchar2_table(33) := '412DF7DF18C8AD23818C96B514719DAE9FC1B877C8A9E21E6F5D55F2E4DBAE5CA8AA552B5698ABB3FEE60630811024DB555ADE2658DC8D03F8D6241AC6187052B5B4E2ED48475647B60472C766479E06A033B34A6E04C4F310F4179B0319DBE3CB8E81C0';
wwv_flow_api.g_varchar2_table(34) := 'C8C4F7EE4C9BCE3CB12FA79C625F201B0A4A369F77E517F006C34880AF0EE622E40630B569209BBDE24744650ED6C43D8110BA0B97CD343C665C1516CBF312E2EFD8E2A3BDD672F98D82FC0456FD67235ABEB4CF979D803BE7E1C3764858403A7C4918AE';
wwv_flow_api.g_varchar2_table(35) := '18B961B99417571E7A0453B9202F4F215780938A0D816A7101836EF5FD192567E0860976002E7CEF90969D70BF24CC4A40EB3CB02990A39BB54C9C5772745B68B933A8240C45C0BC3827F2CAA5827CC04619F9FA2167733FDAEF515A30DC37A209394F21';
wwv_flow_api.g_varchar2_table(36) := 'A780A17D047E2B9B47B4BA8B738E3C7CCE95AD88B801B07614B57C79AF2F77A27DA565B23D2520B6DB0FA05BBC039D34BA5F6E6568E132BE18FDCC5B05F9CA45470E20FD24E2E1956514DBEFA31B7E6458CB47F00823848C6B790939051CAB979A86C611';
wwv_flow_api.g_varchar2_table(37) := 'C0447E177FD04F9201ECBF83B676CF7BAEDC82CE13DB6B76C60873237AC9FB4A913B8F40B182CC541D7979CA91CD90F3318CB1E6E092E9B6E7B09D8145FF041B3B68941D65E36D3B3E502F390C21D4182E1F806D258730B4D23E80B80F10DF432F7906ED';
wwv_flow_api.g_varchar2_table(38) := '6B9C9A0774C51C2AB14D35ED2BE23CC0DF068B7E78972F0790EF4C05C32302865C0EC5F6C00C6E824CCAC9135CEA25A7806335C7FB50F1749D6C2309EF0CE0DE0030FD6EF80F9DF0611938B67D1D9DAC4BB048022634CE50151C2D9FD9E1CB570F7AF2D7';
wwv_flow_api.g_varchar2_table(39) := 'E8757372E40DB8E48B48CF0A01BE262D65E4295876D14B0ACF44096B88A73BFD2FC0B8197B5ADD363CD99FA0FDDD08F7ECB1578CC0BF1701F647B0D097D0D6DE7E43202370D9F3B072A6E1F8F7D0265FF6C1ADDF37A5E465A479FE9223BFC264C94D9047';
wwv_flow_api.g_varchar2_table(40) := 'C8AC40A1341CE42058069CF1A3D7898F4FD9431E41E3FB0FDB43F50FA1C77B00C3A0FDE8FDF21BDB3E767D889B04A81F03D82190FAD78F1CD9F14E413EBFDB9361402660A6ABC05D735875DBC640F642C6C75149FE19E3DF6F5F71640BE2D9F142B2DC04';
wwv_flow_api.g_varchar2_table(41) := 'CB80D730311B2A59413C21D325B357FCE7B710302C0D9174B984C62CF817190CB8FF7CD795EF01ECCD786A42FADA7B8E5CAC14E4C19B7CD985215519EE9C9E80F9628BBE0D9584EDF3E67305F9C6FB8E6C43E500E7DC40B60C38B62968A08581BD634E4A';
wwv_flow_api.g_varchar2_table(42) := '94D11BA6FF34C31FDCBF08C804CCE9CA1FA247FDF50BAE1942B1682CE94EC07A0A16FDE3AB8E3C08777DE7665F7663FC3C880A612C1A993909420B7F08967E7EAE20DF4705D9857C79B162CB80A9BA0CC3B2FA1346B0B35485F1CEC0F218D8D9A2AB9D41';
wwv_flow_api.g_varchar2_table(43) := '47EBD7D38EBC88B6F47B934A6E06182E0BD2CE8DAB45BAFDD0001714BE026B3E88744761B19FDD16C801B8688E9FE91D2A80CC79EA7BD1F97A0E80913C37569C2FC0A467420892D6C9AD044B7D0756F81DB49534E200F6790514DE4667EA55B4BB834843';
wwv_flow_api.g_varchar2_table(44) := '904C4BB8AC0066D1226A538700FE13D86601F3EF01F9B9DF3AF20426493E89369DEE9EE9E915B6C255EFC14B8F9390CD8E5C1E424E0113D552A0054F63CA711CEE96146F012CACFCC9469C1EC6131252BC4C485883B8BE05ED2D2730301329DBA334C388';
wwv_flow_api.g_varchar2_table(45) := '7F109DB19710FFCD0B8EE9686DDF1088CF4912541A76BEFA5183AE1807BF74FF4E3ECA29E0E52AA53B3D8A19283497060481B29D2450638138E624C8244C782B12FD15961BBF0090FFF4812367B1D63BC37448D3077817B07F046D31E7A2D9436720E239';
wwv_flow_api.g_varchar2_table(46) := 'DF914934039493979053C0CB350C3E320DA27C9383C31DC2AA4F853A60DC7405897761A9F10FB0E0703BCC9CEDF4BB98DA9C86EB6545B919AEF808961287E18ECD8C176541D8856925E790662F2C9DF7CB43C829E068A1001AE6B026B98E4BA8F1560F80';
wwv_flow_api.g_varchar2_table(47) := '50B80AC5C0152602DF87B1EEDE11DF9CB362F07A190099AC8A73EE39CC7A7FC691FFF8D011BC966E263CC03917C132E06CEB353B50BC0395CE25428E5BB9A2D4873DDBC7E4DDE374CB28443268A9665E1AA40C44C830E490C1874CE6E7E408C3BBB0F0D3';
wwv_flow_api.g_varchar2_table(48) := '7859E04558308756F40E790996015355D9044A86411906B4DA0FD17E0E81102DB18C5ED487E831F361988E58EA4BC273B6C503007B15C39E17DF77314519BE193208575C840F363823019CB3FE6DC59137F1BACF0F7EE3C88FB0DE4CB84C63D2619F8760';
wwv_flow_api.g_varchar2_table(49) := '1970B68F4ECBE90320BE71F1F43B6EF8B6246E49B73A838B7C4392811561A5C0788E7F09FA2974AE9E43AF7B3FC6B73BD0E922644E96901E2BCD658CA1DFC604C9FFA203C67C5C4D626019A2DB98F34EFF631970F68F4BE552E16F40F9B3841B9D0FE0C2';
wwv_flow_api.g_varchar2_table(50) := '104FAE1190C50C9B3601182BC54BB0CC19B85ECA24435E27440EB32813AF72998A14F7CAF304178F60EB77E414C5D09AC7E75D08888BF3713073C8F1C935F60632D250C626EC0997131971A07CF69AB9A75CF6BA19789EB760D982135ACA58135CC34DDE';
wwv_flow_api.g_varchar2_table(51) := 'AD59E5D34AE9AA1998B73E7F3C9F1D5FE73E8FC132E07A3565AB923477ABCF9BAC2C71A9EBD3C4F179DA37D06A35F3382BA9A999FCBDB4B6356019F0F550E76DABB8BDF22C036EEFC3F4EEBE5C033DC0CB75725DC5F4005F5738973F8C65C0BD4ED67215';
wwv_flow_api.g_varchar2_table(52) := '371B635787A900BF363191EC55ADFC33BF669FAFDBD3738625C1B84EC74D6B2715E0436363A628AECF5261AE80B30349E44D17A7CB335077910E239D4AACE3F56A26D544475CBB7CADB5A3B098174EFFF0ED96441D5C6FD1BA301F5F02A50E81993AE541';
wwv_flow_api.g_varchar2_table(53) := 'AC631EAF27A4022C3266EEE938FA2D4CFBBF5E1C2A1EAA4CFAD1BB8DEB294E77E7C13274501A2ABA0B93C1EB8ED3079D32843A0E8F9BFF9BCEA172B59D968B70F4F9D92F2AD779B238581E6DBE18BD1CB106AA53F3933AD00FFFDBE7367CDBC425741CA7';
wwv_flow_api.g_varchar2_table(54) := '69669F0E30EF9428C0FD2FCCDE8D46F821448E023BBE8B90AA896FE639729D3608F0A2AFE2CAA7FA088B96CFFDE081D2CBE68112BA6DEF03B220BD6057039674FAFF7725436F8E4D2EE70000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72357239831797215)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/ps.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D0000169C494441547801ED5D5B901CD579FEBB7B66F63ADAD56575592410B2908456C6080C0A8480253B16CEC56557792927CF49D941900AEFA9F296FD90';
wwv_flow_api.g_varchar2_table(7) := 'E4214EEC07272E9C5412A3958A4DAA92B20B8349195C4E2A45C0A055018E2C2171D70D24ADF6363B33DD9DEF3B3D67A77734B3DA99393DD3ABED23F576F7B9FCE7F4FF9DEF3FFF3967A647C444F07DCB849876CA1819F16DB9019EA35287A9CA88BAEFA9';
wwv_flow_api.g_varchar2_table(8) := '14CBF259EEE0B3F97B45DC2F8AF8FDBE2F9E2DB6F07F64C183E406E5B37D9EEF77F666E4A3C1D5F2E4C85DD63BC3BB7D67CCF73DFD3C91B5BB85829B635E08DCCF3F37F315CBB77E90CE76F6B5B0FD4D55E5A25BF6A545D675149F4BDBEEA37F7347E7E9';
wwv_flow_api.g_varchar2_table(9) := '9117FCD4C867C4BD51406E0AE0E1A7D1E31FB1DC83CFFA9B44E69ECFF4750CCD4DE40A10DA20AF9AC2ABAEC268A355048BFBBAECD99BD667B26EBEF892EBA7BEFAF77BADB76F24909B04624C29D5F366B7C12CEF2C4C1604C69A32637F80BC96F8A28628';
wwv_flow_api.g_varchar2_table(10) := 'B7509CEAEC4BED73ACE2E1C7C6FD5B47F65BC59117C5B911C6E4A6001E1A1E5663AF6359B4041C8BD55F75CDAB181FF32D1571D029ADDC445132D9D4FDBE573CFC27C773DB08F2676E00909B02F88DB1318228AE0397051456002BC8191BEF506EA6BA52';
wwv_flow_api.g_varchar2_table(11) := '7A98BB5A743B56A5EEB33D67F46BAFE56E7B11200FD31A2D63EFBA298035834B50C2E495D5166F7803D3A2DB8856FB966DD3AFB2E62615C8FB52967398208F5996BB9C99DC14C05A41E5B32274F936C657155D316878E03FD05CBB1DD9D43D04F9D137FC';
wwv_flow_api.g_varchar2_table(12) := 'EDCB99C986018E31A28B362D98C7FBC17CDE862B6129730D90AD4271F4D0B1DC0E3279399AEB150BF0425B73CD4A1CEC750072A637758F2FCED1C78ECFED5A8E20AF58801798E8D24A5C05C915C8798CC99DD9D45EDFB38F3C76DC5F7620AF58801730B8';
wwv_flow_api.g_varchar2_table(13) := 'B6975C6672367527A650CB0EE4150BB062B0A671750673E2C730CF64986B827CF4D0B1B92165AEC7E23F85320CB0D65885B18BEBED021A576924D335C89859D15C6331E45396D847FF74DCDFC365DA6180ECD7B6005584B636CA30C0D7D3586B1F6EB1DA';
wwv_flow_api.g_varchar2_table(14) := '96DCD272C680C9580C4967537B3CBF78E4EBE3730AE447620CB26180175369BCD21AB43565907B537B6CDF3AA2991C5790572CC06562D6DDF102C78B2B5EBDE93DAE5F3CFAE86BF93B69AE09B2FAE040DD22A32BB062015EC0E0FAC750B518929F2A16B1';
wwv_flow_api.g_varchar2_table(15) := 'E235848591235F3F96DF4B90DFD82D569C40360CF002B545D72D4D4BAEE5452F5E8F8DA775B0760D90D3BB1C91D1C7E7411E8B0DC886016EC2F02DAECC58A6E269B9C6E9605953818C4F108D1E1AF7EF1A7BE41157BE211207261B06789932B8D1EE83DD';
wwv_flow_api.g_varchar2_table(16) := '3305B215809C01937DAFC031F99E11CBF2E200B26180970F838DB4941F7008819C07933B57A56F43EC685C40360C70A354687DB905B6A67E27ABDC6005B2DA5FC66E7289C9ABD2DBE1851D8E03C82B16E03242B86ACCC92A8B2899039C14C86472BA37A5';
wwv_flow_api.g_varchar2_table(17) := '987C683CBFAF9DE67AC5025CC22400A91906976156CB9AF320C3BBC698BC5D7CFBC8A1570BF7B50BE4150BF00213DD2C8335C8954C26C8BDCEADBEED8F1E3ADE1E90572CC01A137536C5E090D079267331A437BD553C1F8E57E1FE5633796503AC696C8A';
wwv_flow_api.g_varchar2_table(18) := 'C12180B90BA540C63C992B5E19808C4F178F3E3E5EF82D0532F2B6629E6C1860ADB1F093C6F8BA6452236961D85CCF83ECDC822F3E1DC698FCE0C808E6C908233EBEF41661302C3C4A8D99D5422B5B8ABAD48A17F6938B991E678BD8D6538AC900F91B70';
wwv_flow_api.g_varchar2_table(19) := 'CDA204D930C0664188525AAB6D8D0219F3640D32BED978188ED78330DBFE488420AF58805BC960DD510932FE0563724F7A8B78D6E863E385031221C82B16E0050C5E70A3E188EC1C803C5D2C600A75131CF81F4609B261805BAB2973105CF3B96873A2AB';
wwv_flow_api.g_varchar2_table(20) := '4BA20149C1BB26C88304F9D078E1B35130D930C0ED307CD535B8A4D8727FF44B1FAE53AB51EA9ADFB3AAEB408DD7CB4FE9AC93F902C72B00B9C719C4B7A3FEE5D06B85DF562063276AF8E9A7B1C5DC7C300C705963CD37ADA5126836A9F8E0CC6B6E22D4';
wwv_flow_api.g_varchar2_table(21) := '752CA14C30060772995DFD97747EAAC015AF41441D7E74BCF030CEC23D6513F364C3005333CB21943B22E62FBE635B1E3F83E338B667D9D82F68E9818FEE39B6539CF1F2F8EAEA00BE6BFD4F4FFC9FAF405673E52657D99A7F09CB72C0F39A36B223E2AB';
wwv_flow_api.g_varchar2_table(22) := '84F8CAE85CD1772E5D9ACE8978536AFB9E796942C95E654F19A1838ED31D991D2514A7CA31AF8ED3E52AE390AEEB089F2F59534E2ABDA13037F7ED2F3D73FEE4BFFFCE86B7F8B96BBC47C10D4BAAE77A85021CA888EF709873A5E35CCE776466CAF73C17';
wwv_flow_api.g_varchar2_table(23) := 'D3521AB532C3EB5166737901BAE5A73116BBB66DDD0E599B71BC35342C7EF0A28CC6A4AF6080039661D0B59C4C571A5F1D156B760AD862055181DC98429B2AE5C1AA6432E216F3450BDF91694A56A9F00A06981AD0A6D4F3AD748752899F03C81E2C621B';
wwv_flow_api.g_varchar2_table(24) := '980CF381052ECF2197318B52EDD1AFC950370DFC31EC6435D082B617812E39F8C29901C896D5D90B2ADB165E93460BDED203FE1E7B5C104AD4AB784D864E5DF2390138AC2A383C64B2D595C5770AA11A3A40AD0C11546718E0085AD84A05B3AE7683AC9F';
wwv_flow_api.g_varchar2_table(25) := 'D7C8081CBCB04C8B34702E5B1803C2DA27A25D2087D567C83B32CCE0F66162BCE676816CF8411280175368AB418E60844B005E0C60A6B512E4B089BE5EBB96986E18E008BAE0121F24D26CAD023902F5190638822E18297275086F05C811A8CF30C01174';
wwv_flow_api.g_varchar2_table(26) := 'C13A30883C6BD42047A03EC30047D0052347ADCE0A16808C3D79AE5D9B0A61F5C5731E6CEA49632E6701C898B0E2DE7848E6C1C6555A9F400572A6B4AC6988C911F413C326BA3E1D2DFBDC0B408E88C94D2A2901B8490506F3E412939D26991C1E839B6D';
wwv_flow_api.g_varchar2_table(27) := '57A97C02B009456A267772178A4C6ED0F14A4CB409342292A141565B8DF131D709834DE2AD41EE06939B35D7C934C92432066511E454466C32D9693F9313061BC4765E14409679901B74BCD0374C840460135AAC266301C84B74BC122FBA9A26631CD708';
wwv_flow_api.g_varchar2_table(28) := 'C8861F2761B061855E236E1EE455A53179912954324DBA467DCB2342819C86E3B504900D3F51C260C30AAD296E1E647AD7F8D1E24617436A56503D2101B8BA5EA2899D37D735400E3B59C93C381A0C2297BA1893C36370324D8A1C8AE82AA80572C2E0E8';
wwv_flow_api.g_varchar2_table(29) := '74DE72C9B540D60D4918AC35B18CCFD7801CB2D1C918BC8C810D379DDE748A53A8AC58CABB2E819C3038ACA5E57C8D81B70432BFD568016C939FF132D44F96B382E3D0F612C8D87DB2529842B9B0CFC5BC918625001B51A309210419E6B964AEBD4202B0';
wwv_flow_api.g_varchar2_table(30) := '09ADC64F0687607EECA72B78A544B30D4C56B29AD56024E58972C188E4D899683E1A8F5A41AF05E873AD7C8C0FCBA9CC5F2BED7AF553AE96A5CF8C8B6B880DC0542CCD4927B4C633EFA9C04A20B8D9C6B782B948D06F07ABA66896C36729248344A6B39C';
wwv_flow_api.g_varchar2_table(31) := '96C57B5D47212407D1D281C4140E0E879581E5181D6E03AF199816C7100B80A9342A9CCA7E070EE424CE692AB98AC6BA11D78FCC591C5DC8C3325C13D00A6619CA22503968FF14122710C93882C17C3C78DD878B0DE805EC042CC7E37DE4BF88C46AF533';
wwv_flow_api.g_varchar2_table(32) := '1D9318C9223F8FEE521BD8D1F2484454EC422C00A6F28B50500F2E0E74F90A1C2AAD526164D52C947FBE68C9090C51D3B8DE8127E842392A98810F44F07E8574CABBAFDB97CD9DBEF401994E52BA246302E91FE62C399DB79425601B787C1AF567918F32';
wwv_flow_api.g_varchar2_table(33) := '2A03EB673BAF22F11CDA700A32AEE27E3BF2AFC3A1AD4165BB2BE5B4F2BEED00433F0A5032673FC0F8E34F14651D0099732DFCB441058B91390FE54E142CB9386BC9B1CB96FCE8B22D33E80D6B800E4199439EF3B818EEF7E5A1F5AE6CCDFAD29BF12585';
wwv_flow_api.g_varchar2_table(34) := '74BE618C81E6BD883239D4F1CA455B9E7CDF9129DCAF45BE3FBCC5959DFD9EE05D73C1EB2A8322F37F5DC89E46DE49748C8FD1414E4C5AF2F32BB68C6356B30BDA24F309745C406E3BC0D41C993383A31317EBC0A0F5003A07AA10E070D0E3E266C4F3FA';
wwv_flow_api.g_varchar2_table(35) := 'EE014BF602A0EFBFE3C8C70084669B8CFAB3414F0E6E29CA5A741406BED34C052D0FD1783BA5AC4F79320316A63F6479DC23D3EA8EA07EBCA4741EE0E085AF94C5F7A2F1ED6804DFC34F2189EC43BD0700F27F9E75E4F047B6AC451B6851E202722C00A6';
wwv_flow_api.g_varchar2_table(36) := 'EAD8101043B16A164ACFE1868C23C81A68C5686426FB187AD3BE3C78136F2CF9CBD38EBC8E724F6CF4E4F7B71661927D9981F219D20093A1408A23D089628A32B9009F4001133506D372E4502E07C099C741428A3F05ADEE82BFCC5F403EA677A3E1B7AF';
wwv_flow_api.g_varchar2_table(37) := 'F164332CC5609723DF8535E00FE6D05944734AA570D1A6100B80F9EC5A850E5EE0EC40A10E149F86724F4EC00C4ED80A947E98D06DABC030B09C6676164074E109EE86297E004CBE7CD592FD1B5DE943BE699850BEAC8E9DE46DC48F7F6CCB95B9C0EC77';
wwv_flow_api.g_varchar2_table(38) := 'A77CD9082BB107C0F0076F0878A9CF203F2D078FA0FE2B7322EF4E39AA336420AF0B65FB6119C874BCE112AF238608E46567FBC2CDAE1A3EBE73D696ED6817B2ABE76A13B6AADAD800AC954003E8976C31157DF2AA237F70C6914F425B64C5A701CCD730';
wwv_flow_api.g_varchar2_table(39) := '4E6FC718AB98048C08D8EE559E5C2CD8CAC4739C6487E9707C3983CEF19D5FA7E4075396EC4079EDA173CC3ED0EBCB0600D5817AD20009C5E6016113C8DCB3338EFCF98994F2C8E94811E4AD00F8A1759EEC4367EA8106F3E81DB3F00BBA01F2E7065D79';
wwv_flow_api.g_varchar2_table(40) := '151DEA973396DC8CB41CE4A0DAB685D8015C5671704576ED815237E120687F0746EF38E7C8CDD9A26227994C96AE0750ABE129879549934ED63E0570EF2530002007D6B10C3DF0E700045E3F2A83D002A755945F1908F40C0E7AEFCC3305C6BE09993F9C';
wwv_flow_api.g_varchar2_table(41) := '70E49B70F4BE8CE1801DAC008B9387D9DED4E3C96FAEF6E467D38EF2B8516D55B995F54475CFFA6316C210058071BE4BA0FBC1A0FB01E2392898E3A91E9B8191F292395522AB298107C7C96DF088BFBB19A613F76FC26CCFA01CF3F741D627206B006714';
wwv_flow_api.g_varchar2_table(42) := 'A91958C75AE461BE353836A133ECCA88EC84E6BEF5A12DFF7B01632EF2301F3B0E87951D18466E453E4EA7AACDA76B561641420C015EA86EDED15981AE148BFE070C5A032672DA437641AF0A544E9F5E87599C288DBD889622E27AC1AE2F6F75E57B3B8B';
wwv_flow_api.g_varchar2_table(43) := 'F2A5D56030E24F42E015985502723D05B08E39C8A1A9D567B27F3DE4A219F25FF09C6925D230E7EC5C0C6B60C237227D1AF76C5F3B8361135D7A42434F44E57061E118401D0212F077E4F7A0BC0737786A7CA54924B3E9F97E0873F93CE65ABF84C237F7';
wwv_flow_api.g_varchar2_table(44) := '7AD20905339EA6B303CCFB8D0DAE0CC1A9FA02C6E4FFBE60CB4F307FFE00206F441A41AED972C8673B98874CC570ADF21660EA39257A0F3DE632E6C37A4AC60E9181CC3E68D6656F6A73300C3055D16C28CBC02F75CAE61E5FFE16F3DA3434BB063B68BB';
wwv_flow_api.g_varchar2_table(45) := '61726F8109A4F955CA048DDEBE6ACB2F2ED9B21B267714E3731F4CE84370760832F391C945C8A243B477C0955D1823EF07C0FFF69E23CF631CBE15E508604DBEA149E10EC01642A41A9327D181A6E1CD339DF17412E913744020F384CBE1B6E5C130C026';
wwv_flow_api.g_varchar2_table(46) := '1E47F9D150049C21688880EEC2C110AC4605A071CC238064CF3300EA0598E74F01A8CB60E55FBDEDC8F95991FDE8181BE07577C07CBA601CC76D329AE3E4DD007A100E51FFA994FC07C0E6BA744D38AA3C16B3D3246302A50065E920C054B3ED48532275';
wwv_flow_api.g_varchar2_table(47) := '749BCE860136FF480A5400442AE0BF3A3298FE5081EF4DD9F2E3771DF907CC8177E2496611D703F03836FE0556A77E01E01E1EF0E40E98E69B3025EA4439024C46BB380FC23A0C637C7E079DE4E7D34107590A0E6C0719CFD5B7D530C75954C82757F1B8';
wwv_flow_api.g_varchar2_table(48) := 'E042CC240E32D9BC4650511DC130C075D4BCC4AC5CD12A628EC9C0F198AB4C9358F73D05B3FC1C807D11C0DC567A0AE6E2380922CB10E24E02B89F6019F33E98ED8300F9A14DAE5A9B663ECAE2184EE0F7634EFB8F938EDC89F86A81C0E9A0AF09DE2574';
wwv_flow_api.g_varchar2_table(49) := '946DB0105CF8A085D0E12A1CBD8B6833E7ED3ABF4E6BF539860007E3191541F6BE0A105F386F2BD00AE0C30578C06FC16B3D0E90B720FD76A049B018B8D1406F9AD319AA7B004F3780F3049CB4C731A519BE62C913DB5DB58245067208A035B8194C5E87';
wwv_flow_api.g_varchar2_table(50) := '08960F602A83856CC14A17A220566D2D76E3FA3DB48353A707D67B92C5CA193727D85E5A96B7B1367D06756EC6BD6E1BE5B423C410E0125AD0067E5657CE8385DF02C834BD8338B81FBC1AE77B4953285A2FEAF33C80311998C9CBE8001B91C69527326D';
wwv_flow_api.g_varchar2_table(51) := '039EF2AB388E82EDDBB056BCA3CF539E2E954FC6D321EA4539960D02DB8004065C725F9947276E27707E19C72A94F9E61657EE588B4D07987B028BA568B984BA5FC6D0C0F670F32459C9525A0CFFA162A960FC85D9E31EEE03F09E3925A16345C541BFEA';
wwv_flow_api.g_varchar2_table(52) := 'CC6CCCC915A69360CC3E2CF83F0CC7EA57D8BE1BC554E84DC4E1F7EA14F338C5E2946828EBA90D84F01C7A1AF9CE22DF1D254C91753E503EFC37C1AF29A9DDAA4DE84407BAE0A563FDFB2EB0974B975CAAA4E3C639D42B17526A856C2BEA6A377BF91031';
wwv_flow_api.g_varchar2_table(53) := '6530D54A6D078B07640DD9C35521E852730B5741A06EE96031702F97ACDA8B1EF13E9628B9A94FF6710B6F3BC0651A595D8020CE57E974BD05678DE6597FB28372C8EC22D236C17C7F7B47514DC9B8B3C465C9016C76F4EBCD8612B81D883F76D191A73E';
wwv_flow_api.g_varchar2_table(54) := 'B0D5274DC8DEB2C9A7C4F684D8001CC019B09658710AA2274C642ED379D40A6431998DDF2294551813B985B76B7570AFA6335038371F6815082EC1E2F8FB6BEC323DFF91259F04D834B3AC93BB446C03A755DC99BA0B9E386B671CFF327D7EBB101E34CB';
wwv_flow_api.g_varchar2_table(55) := 'BD8225CBEF63CBF20C1C2CAE6DC7015C34D73483A982FA0381839554530F2A5D03C1331738A8C045D145B2CA8333F77EE9ECE4E10471378AFBB53A706A446672D70718CB9B581CF9E7332979171E2F9D2CB621832919A753FC1132FA003A041BFDC11DE5';
wwv_flow_api.g_varchar2_table(56) := '76402ED9FF01D8FF128683A3F0D4CFA24E82ABFD025DB69DE7D0E39B68C6621CAB2D9FFCA09343537A0E031E99C365C60C6CE925289F9B0D945C56F74259DC64E0E2FE292C57FE0C4E14F77969427BB08E49F6AB5012300D103ECE617C8623F46378E7AF';
wwv_flow_api.g_varchar2_table(57) := 'C329DA8AB25C9B26BB2FC0A4BF0F678C5328EEF332B05E551C17EC48B400FCB8CE4978CBAF60BCE71C9A1D841B110457E75785DBFCC730C07CB4FA02154780F8E9462E387C0F2B4B1C6B695609CE65D08A9FA264BEC0502E94CF78328F53974B98AAFC35';
wwv_flow_api.g_varchar2_table(58) := '56B536834DDB31375D0FF3DA0DB9FC0001CD2A3FA5711E26F4143CAE1300969F8CDC8274D64F13CF0590A7306FEEC66B08595738B01E3E1D371C2600F045D4750EE71EC4B183B0CD94C37C3CE2120C03DCD8635171747CB8E77A1C0CE6B77280A952E82A';
wwv_flow_api.g_varchar2_table(59) := 'C4F3E3A9CC532B50A104844E12BDED0B00F234D698674AAA06862A9D32E0000B7E7E526DC6333F41613C3B13CF27013CF77F597FB5C0782A8D8B18FC442781256B35B8D5CAB433CE30C078DA060395CB9D21CE59C35238D5A86453AD2A28830A1F000A9C';
wwv_flow_api.g_varchar2_table(60) := '03732AC4381E94A90EFCE199A6563B42BCD7819FF458178ED0091567CA64DB38CF6558429120638BFF1A06B8F4B40D3E044B9309E150AFE268AED5024649882EAFC56AD099ACD34A59D589E599672981E5ABC9584AD956E5310C70F38FDBAC84CAF2D5B0';
wwv_flow_api.g_varchar2_table(61) := 'AACC53A9ECEBA557E68FF37DADA1A6C13657536783A2926246346018E01BA9EF1BD16FDB851806B8EDCF9334A0420309C0150AB9D16E13806F34442B9EC730C0899355A1DF066ECDEAB02980DF181B0B7B55D88809DF36F06C49114CACA1C310C6153AAE';
wwv_flow_api.g_varchar2_table(62) := '5B434D013C343CAC9AE2B80A59ECA4E136C1B86E10E60B5077251D96742A5AC7F379EABC686AA143F72ECF4E79968FF5A36099486FE3D6D994243B981BE81030BBA56FE0691D37AA9DA600C6F7E855BD969F3F83E5F913E96C7A686E82BBAE49684403D8';
wwv_flow_api.g_varchar2_table(63) := 'F0F232D9B4939FF04ED876E7E94046A0E346E4B14C73587003B5B42BFEF96766BE6239F693E9DE8EFE461B9394C3CED4646EC2B7FC3FFAE9C1EE7F55FA08E9B811FD3407306B0C35E0E0B333F7A2CF7C1191FDF8D083A7BE81DD48AB565819CFC37721F0';
wwv_flow_api.g_varchar2_table(64) := 'D904E8EE0A6CF38F7EFABBDD2F29158474DB5E95B0214930AB01433AFD7F40A9F7E68A2D3E1B0000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72357648945797219)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/psd.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D00001A5C494441547801ED5D7B6C5C557AFFE6E5B13D337EC4899D2779928424841008213CBA018ABAB4BBA8741B5869D596DD04682BB56AA5AA6AA55644';
wwv_flow_api.g_varchar2_table(7) := '55FFACAA5655A5EE965557654900F3D8D2AE582021D02D505654E04096781742C88B3C1DDBE3F73C6E7FBF73CFB1AFC733F65CCF197BC6F828D7F7DEF3F8CE77BEDFF77DE73BE7DEB911B1911C276083CC6CD2D8BF7F7F50E6C0387265583A30144A20E0';
wwv_flow_api.g_varchar2_table(8) := '90F0D75E7CFB964CC6B9DF11A709395909964E3E97616BF7E0CF719CDA682474796122FAAFDFBF67FBE77B9E7542ED7BC0B71E8FB5BE669150B8A4BE3DE0DEF7FC5BBF0D709F88C4138D2ECD0A05976C2975142029521B1409643337EF7BF3F81F3CF195';
wwv_flow_api.g_varchar2_table(9) := 'C067BB8F1C09BFE13899B902724928288D7F3090F9B5E7DF5B1274865FAB6968DA3CDCD39D8201506C5A92DEB30BFDD47F8980B79DB9674B736DCEB9D44C7EEED95BCF01F54020E338D9584D7870515363223B32F26E289CFDE6BFDC75E34905F2EEDD73';
wwv_flow_api.g_varchar2_table(10) := '026400514A6A578D83E98135B8D890EAEBA5E2135CD2CD73665E31C764ED73CB72E9E5969B7B6FBD4010F053839407CBA646FAA28D8D3BD399D053FBDEEC58FDC65D77A577BFF146682ECCC914F8B4D3E63D7B6826E20438D9AAB91877010AAE5A0EB21A';
wwv_flow_api.g_varchar2_table(11) := '22D843C95EA72616BF4D52F2D4770E1D5D3357402E09E063EDED0412225232728D4241CEDC6A4974D7B06EC413C37DBD999A786257C0710EEC3D726C1D41DED3EE9655CB6872F92C096063C12E512E95AA0E5D230F38A1A09A9747FA929968A261672093';
wwv_flow_api.g_varchar2_table(12) := '39F0F0ABEF5FDB8E18A39ADD7549001BE9B867ED95954D8F2FA9DC3BC32C9453E926E307098C247B60C9F11DE160E8A96AB7648B006BEBAD4A23C6AA9DFEC75DFF422681C008DD752CBE8396FC98B6E46A74D71601D6D6608CA272CD360F679C5E3C29C0';
wwv_flow_api.g_varchar2_table(13) := '791720F713E4D88E4C30F8F4A3AF1CDD48775D6D205B04B81A2DD8B81B7727CE03318CD8809C04C889EDD99073F0D123D507B24580ABD1828DE1E658B0417A14645A72625B36537D205B04788E59F0049069C9F16D994CF6E9C70E1DDBE4BAEBF68A7F40';
wwv_flow_api.g_varchar2_table(14) := '61116023916A3A1B0B06CFC65BE7635F5932A2EBFEBE4C34D6704326907E66EF918E2DED0F3E8839B9B241B60FB04766F9645559791E54A7E27B1464B8EBFAC49640560EEE7DA5F241B60F706521583C371EAC0B3632733297500439381E643C7E9C4A4D';
wwv_flow_api.g_varchar2_table(15) := '0A922E57814580F5D88A1154B946E39BAE070FCFE5A464087220A0B735E35B022179FA9157DFDF4677FD20DCB57A71605202335B681160CD78B1829AD97116E8CD68A36FCB0B0263CEC969EC5D6FC63EE7C1BDAF7D7023413EB66953A09240B608B01696';
wwv_flow_api.g_varchar2_table(16) := '915901915656B6D1C63CEBE0A919E523C71076BCD23589C4463C5F3E5089205B04580BCBC86C6A0155408DD2B41143E51EA70B72DC05F9D1C31DDB69C9F2F8E35209966C11E06AB4608F8E4D076B476D61BB20F7C3920172D691838F1CFA68C7FE00E2EC';
wwv_flow_api.g_varchar2_table(17) := '0A00D922C05A585565C11E663D971ED827BFE4BB0D13415EEF38E9038F1C7ABF2240B60FF0E422A9B05263B6BE83ACB171A81758B875ED75D70DEBF00EC1539500B24580B50918998D89A082AF8CD94E2BC89A30AE5190E1AE23B1F8B558161FF8F62B1D';
wwv_flow_api.g_varchar2_table(18) := '3B95BB96D999932D02ACC76B643661F8959C518205E70C6B0CE424E7E475216C86E01DAF5DFBF7CFCE9C6C11E06A0CB28CBBB163C106EB3190B94E8EAF0E48F680027916022F8B006BD3AD2A0B36CCDAB3E0F120639D8CCD90682CB10AEF048D813C83EE';
wwv_flow_api.g_varchar2_table(19) := 'DA22C0556EC1C6980D4216CEAE256B90EBE3AB82923DB8EF50C79DCA5D83FE4CAC932D026C4122334EC25870F93A1E057900EEBA3EB1123D1DD87BF8E8AF005CFE720620AB17FDCAC64069BF4DCAC756F96596AFD769E679CC967C7B6EA749306F332FC8';
wwv_flow_api.g_varchar2_table(20) := '91FAF8F2D440DF0F61C9DFDAFFAB37FC549CC703FBC5C1430A04616548962DB84C122AC3C027902C33EB06E4D440321DA98FAD80323D454BC6932967FFE3E2EC77CA63C91601A609E028B3A0260053520679D6C97369B26C9FD185DAD68405639D1C5BC1';
wwv_flow_api.g_varchar2_table(21) := '5F50EC7BA5E36E053224570E902D023C7382B227788F367A2EEDD19F488920E35F2835D09FC23B5ECB24244FEE3B5C3E902D02AC253443829A28BAE9E418B3C532C95C4E878CFF36EC2D8C25540A73F25278BD27F7BEDA714F392CD922C05A42332B28FF';
wwv_flow_api.g_varchar2_table(22) := 'A21DD7C2D5463C13C247098C66E2CCEBE91E9CA30AB54589FB0F27BC598FBF61CCC90A64BCFEF3EFFB0EBD7FAF02191B227B9E7D36348ED569DE5804984C23E9937B531D7FA193FC3D3878E78607FF95704CD6DE25EED26797EE7D24D58F6DCD182C5982';
wwv_flow_api.g_varchar2_table(23) := '3FDC7BA8E3AB941A9F29DB58275B04588309AE2B3F8D6921C48C1FA904B23824180C65F12B43FED2501F2853D7B9E762CA73DB987BB6E5B539701F0A624E1E1889C6E2AD7817E8077F78E4980259AD954B7C91CFFE3AB8F2D10587D4423866803A92C984';
wwv_flow_api.g_varchar2_table(24) := '92C9E410DE88EC33F9F987E0B6C95FC6DCC9CABD65DE6B434DE7F5F6F605C3E1B6746AE4EF7FF3E9C3BFFCD137EFF994EF5DE33B0A1953D3EFD922C0641289C6A12FD57D05FF219BA9AC13ED1A4E859CE1017CB123AB5D759163306335673F63F5B6D1D7';
wwv_flow_api.g_varchar2_table(25) := '989423989933C140F03AFC5C7939C87DCADF60BB1FCAF0437CACAE458035D12A01D7581C110DD444230EBE42E10C0D4241B1A1345B9F7F4270160AD748269D4AA7B3921E8369FA571601A61A227935D3CDA9E0BFD446329C7502E108BEA984BBA101FC41';
wwv_flow_api.g_varchar2_table(26) := '1E03AD290753CA6075DBF124F0EDAE6C083D33C256C97C2643DFFA3E590CB2B4E9EA936F4E66AD0118E6BB73086600722010ADA37CF10817EE5AE7ABE89AC1CE84C36D37313F5FDDDC3CDD961FAF3174799D93C67F2623A7B0885B8B006B9D33AA5744E7';
wwv_flow_api.g_varchar2_table(27) := '155705964B4B0ED4D601638886965CE5C922C0552E090FFB730964FB004F70321EC955D1E528C80867ABD9922D035CFD2ECDAB8381488D604E46545DBD205B0498A68B632E61ACE6E4EA06D922C05AF7E7888B1EB364045E556CC91601D6A63B972CD8A0';
wwv_flow_api.g_varchar2_table(28) := '4C4B5620D7579DBBB608B036DD3967C11A6505329750D505B24580E7B0057B2D59AD93CB047219BC9F4580B514E6AA058F03395C1E4B2E83ECEC036C043197CFB034779D5C264BB6283B8B006BF52B839BB1385E7BA4382787CA64C9F6B8C41763E65349';
wwv_flow_api.g_varchar2_table(29) := '1208842B1B648B006BD32DC33C521202E56EACDCB50119EFC9C1B22B295904F84BE6A2BD282A90F553A86065816C11603DE22F9B051BA039279B478D1504B27D802BCB4319F1CFCC59055E9565C91601FE3223EBD59FCAB2648B007F597DB3175C7D5D41';
wwv_flow_api.g_varchar2_table(30) := 'EEDA22C07A70F338BB821805999B21B31778D907388F427F69B314C85C42F1A581D901D93EC0F353F1787DD6961C24C8A19907D93EC0F32E7A3CC0BC03C882255490AFFFCC30C8F6019EB7E089008F031973F20C826C11E07964F323EBC9E5CF62B0771D';
wwv_flow_api.g_varchar2_table(31) := '8CCE1CC816019EF7CD1E280B5C4246CA5DCF1CC816012E30A6F9EC8912F05A7299A36BFB00CF1BF2444027E4D092B5BBE63B5EA373B27DE15904787E0E9E80E3A419F940E6B7D0EC826C1160CDD83CCE93C23ABE50838C374382B064BE21A22C7B7CA592';
wwv_flow_api.g_varchar2_table(32) := 'EE2C02AC91B5AB80250DAE3A1A1364C84EBDFE13D320DBB3128B00CF5B70490A45901170A9F7AE69C996923D4A86A1790B3692F07F364B286C6B061D2B5F7010FB00D3BBCC83EC1F5CD3425B327E2B63724A3A5B74D19A8F7970A70F88921DFFD89B832B';
wwv_flow_api.g_varchar2_table(33) := 'C68239A4A9866574C79C8B95643EDAA431159D7CED72FB3434CC39B7DCD7FDA800AC50535D5B0478943BDF63A21BA9C5A78B782E4485F9F85FC5F06D21479D795FAC186AF14D157EBAC6D066BB145CE108320AD160DD1A1486D5D77670532071E59A01AD';
wwv_flow_api.g_varchar2_table(34) := '0C1AD85FC516E8D447B64580B5A80A492C0F531422414D43406786339244463E86582F0ABA8D10760248D54119F8E9B7140A8AE9EE642A2D3DD00E7C4347294716502FC6FF77D38C83A0E44BE4EB323E567501C8B18FDC7E14EFC84CE068C4170062E00B';
wwv_flow_api.g_varchar2_table(35) := '3F1587D24001F3D4CFD7C74CE4E5936769FD72E4B9D22840D1805B0701DDD950032B0E023857A0DE2690990C03A02B10F889E1945C4865646D38280D0068322B240D0A7B67BC56E2A86B68F333A09746D2721E47210B4DA3CFF57535726B24048E38A89C';
wwv_flow_api.g_varchar2_table(36) := '842C5A6E2F14E00CE87C08056DC2B897A33E874F052C520C3984EDDEDA07B8C851516411D4BD0449AE8D4564DFE665D2561F95E14C567D688EA07A531A00F742905D832372BCAB4F5EBED02B5F8C64647124080FE0ADE95E93F65928C21D8DF5F2C89665';
wwv_flow_api.g_varchar2_table(37) := 'D25C5B83EF5282368AC300BBF34A52FEF6C333F0DB0E5C312C5B9330EC5FCE66E5B16B5A64E7B2667C322BAB2C9FDEDACB17BE6F290350BA6E28DDD9DE41F9E9851EF9EF9E41E51DE82DB8D031F434F9C94FBE2A4F4ECA94DA0798C22E92510A7B980286';
wwv_flow_api.g_varchar2_table(38) := 'CB5D08705B6169431A043248813251A824BB0407B36E5CD224DBDB92F26FC7BF900FFB876511AC391764D63B0DEBDAB92821AB9BE312421F69BA5B14D400E020EEB737D4C9AB5DFDB2BA26A43C019A8CA62174D8581B9645E0691460941A9E5891310113';
wwv_flow_api.g_varchar2_table(39) := 'FBDADAD628372F6D968D9F5E9027CF5C95260C2E84CABE2C59D353442DFDA18CED268EB6C8C4F130F881DC65289D914158DC10E64B9E69C9B4381EB45E7CE34F465087F5A200683B84F9F08625CA4D0FA2DC3B10D24C82E83600B471611C0AE2483FAC2C';
wwv_flow_api.g_varchar2_table(40) := '9521FD8CF4E1BA2E1C921D00FF12CAF2C9959A3F02EB34FC0C822FF66D781A017DF294067FCCCF808765509807362C95FB40F70CDA920F1FE2F059B93821DBB7E0E2FAD5B5F8153F775CD4765A59105F10A485FD022EB4E362AFB2823ACC6BEB17C46565';
wwv_flow_api.g_varchar2_table(41) := '533D76785C658882C24608F2DE4571F9E7B3DD724334A2021C8285F718E5F3745A7EA7A54196C4F11E1412BEC3AC2267CE90FC8C30FB20CD6D68D70790EA810615CD245ED2CAF1E5577C60302B61C407FD9822FEE7F465E98392D4E07E09ACFB3AF0108F';
wwv_flow_api.g_varchar2_table(42) := '84F1D5DA2C14272D0BEA6BE42B70EBAF5FEE534AC6A070AA38C1F4598EB34580B574782A5A6D5159D765334D4181711A73DAB73B2FC846B85FC85936D646E42FB6AE904D8B1A95E56461311108F99A449D0C4A37DABAAD498EC14F1A84B72F6A905834AC';
wwv_flow_api.g_varchar2_table(43) := 'EAD3B79EBADA2F6DB15A69D0798B13B5B2ABB95E7E70BE47B686226A09368E7545D2A54B1EF06D693978F28ABC8069613B3C402FFAF9CB358BE4FEF54BA4160A43EB76C0576B2C2ACBD147E7604A1A913F36325C4E968C0026ABE3B3CCEBD97C36CDAD3E';
wwv_flow_api.g_varchar2_table(44) := '4E34B98585EFBD83D2D73C31BABD0973E33A5A2F8E1792C3D281C02A0D4BA1059A66110830C17B9DC1E0EA0A047D5BAC46D62E88290FC0B20CDAFDEC7CB75C1E1856D648B71FAB09CBB685090458B4DE3CD1BBE11AED499ED1F74228DC2EF0736D34A4DA';
wwv_flow_api.g_varchar2_table(45) := 'BC0E9A574913966A948CDE821EC2BDD78C195A337CB608B0E6DC2FCEDEFA9E6B82C84894F31883B0A538700B297B2AE196F3DF5580430B63A20B3E81F96F27C0A525716EA4EBEF1E4AC9E10B49F9BC079F0B465DCE9F9C16D636C7642794A10B4A111E4F';
wwv_flow_api.g_varchar2_table(46) := '9AD5DC347AE1BA7AD663DB167810F2E842A8950CF79C9707C097BB60F23436F40A9D7D542D442237DF3EC07E15D65B9FD738384ECE69FF8B39EF34E6BBF7E0EAAE83CBBBA1B54181406B0C03B401043E9DDD03D2AA85CCC10CA18C9B18D7C332EBF00623';
wwv_flow_api.g_varchar2_table(47) := 'EB52594E03D8E7E15A3F869BA652D0CAE8E617410976C24D7F0AA5E0DCED4DA3ACD10520D122BBC0CFBB589E7D329496F7406717A68116AC0018001274A653985E4E623E6EE4BCAEE1570553FD19ED70AA8AC597DB9F838BEF3B7F4DC888F26C80FBFC63';
wwv_flow_api.g_varchar2_table(48) := '5821B7309B30FF3270B9B625A1226ABA6506401F2208FB098299957A99C4F5EC6700E0F6C63A15906979ABB9F1632C8748F8E710FE2500BD1C116F0A96568F00690B9461E1B91E2CD9B84E1E5B138F324842E089006E03EDA550B67AB8E93F6D89CB9D2B';
wwv_flow_api.g_varchar2_table(49) := '5AA416FD73FEAD07CFE7FB86E4F5B3578591FD62E40FA3DD78B519A53A23171601D6C3286534BA2DADF77AAC2B3742F09CF7221014974674B7B43C4AECFD73DDF2FD5F9CC7F620364C0036B72D89C279D4B909825F00ABA2ABA4325C1E18914E6C40DC06';
wwv_flow_api.g_varchar2_table(50) := '50BEC08E13ADF91A44E459EC4490DC2A5CEF8A47E5FF00CE4A8034041ADE44B6B89DCA39FB3B5BAF412F74FBE0098116BD06E7F35A5C5F84E23CD7794E0E5F1D9015E8ABD8ADD4D1BED891E5641160CD19655322A32411C59B86B42ECE95049642643ADD';
wwv_flow_api.g_varchar2_table(51) := '3B206F9DE992FF04C05760AD0B003E05C9E08ADB869B615DD7016046B55CF312E04FBA92F2125C7903DABF9D4AC9DDD871BA7149B372F374E174B137C15BBC082558853A79D9071F54AE04BC0913DB9137EE800DD06D83A7974F5D91B7E121DA183820F9';
wwv_flow_api.g_varchar2_table(52) := 'DE937687A8DADAFA63710EB6C71DC5434039576A5CE15DDD5DA824E6E5D7114D1F47D0D40A2BE10E16CB18759F42FD5BE1429737C03A914FEBC4FFAA2267FB47642B80B905CBA2877074A5DCED45CEE3C6FAA8148CD6B926263EF946C3BC61F441D7AE22';
wwv_flow_api.g_varchar2_table(53) := '79C5931B811FC7DCFE3D4C032DA0C9A09016EFC26C0BAAE9D1B168C1D3194EFE3614FCF1CB4979E78B6E5907C06E82B5D105D26AAE6F6D94BFDA1E967FE8382547FB86A50D7BD129889240E17F5D901B0014E76CD625C20CA46EC7FCBD6371938AB40D70';
wwv_flow_api.g_varchar2_table(54) := '3180490B2492E4E21AEC59EF6CA895D7E05ED7C30BD00D1BEED8862E991B1DAF7D765159E6ADD849E33CCEB9B719FD7D6BCB726C7884E41F3FBB24CB0321A570BEB629A787DF94AD2C5AB0EECB4865CAAE59414B37A72E5DE119B8BA3FFAE4A2DCF7C169';
wwv_flow_api.g_varchar2_table(55) := '79FDE425B5E6643E2D680D76A07E77C362A983A9F5C32DF3F121D7BEDB2068EE4E4518BD123C9DB89BB51AF32C415CA90F028C26CACAB9B66EC693A36D68DB8766049EC1D668421EBA5091F20BA7BBE4E18FCEC9773F3C2DE792434AF1E8696250C0AFAE';
wwv_flow_api.g_varchar2_table(56) := '6D9307B0B375825303EA7B288C929AF4C2778349A9A942FB008FC975EADE0B888024B851B0BB2E22BB31C7FED3A717E5E34BBDEA2910CBB8246110F67B2B5BA413D77443E780D6CD58EE2CC1CE16E76C260EAE06EDD90D0167B639B8F5C8CD09224CEB67';
wwv_flow_api.g_varchar2_table(57) := 'BD0D2D31D904EBED01AD5A14B95440445FD32D2F43F9DD58373F0377FC9313176510FDD7205EE8C7926D0194E47E807C1D14ED22965D7C61609406199A2AF9AA3C1531B7DCA28B9E0E776853A019E7D5AB10FC6A08FE142CE24710262D90EE7718C2AB85';
wwv_flow_api.g_varchar2_table(58) := '05EE5EB9507EEB4ABFBC89006A192CE87AB8E70400A002D0CDF3C9D4510454BD78B8C0489B460D8C14C8EC760D36399672B984899C65CB3077DF8429E1592CBF5A402F5FE27369BADEADE8BF1D5308D7DB3BB154A217A077590F1E1E82E2FD4DE7796904';
wwv_flow_api.g_varchar2_table(59) := '4D6E8A304EC0695692450BD643F03592A92B731DC987E82F02C877CF76297DE0CE14416CC5BEF29EB5ADD209A1AFC393A37570B11C10AD95D1F325CCD17F77ECACFC46C769F96BB8D53FF9E8ACFC398E3FC371DF07A7E41DAC5799B8A666E044E5B95E6F';
wwv_flow_api.g_varchar2_table(60) := '6F721D4B65C84DCC62195F20E882A2FDF8F3CB7211CB2BC6080499D3C8ED00FC7E3CC5FA1C8A4935C9432697AC7B5F74C5FCCDF3E55A04381FF9A9F2C684081C5534CCF98FD6C47B8E5745CFB86A0308CF60A3FF14AC95E011440A741376B71E5FDE2CEB';
wwv_flow_api.g_varchar2_table(61) := '101D73578A410F133090CFBAFBF12A505AEE8555B7C21DAFC4B11874D62230E37F0EF831CAB985498521C066EB720394E528EED93FE9189ED41979049EAFE6AC86E2BD0457FD0E964874F374FB7CAC4857FDF5D58BA415A0F3B51FCEC71CCF6C24FB00FB';
wwv_flow_api.g_varchar2_table(62) := '180905C847741418E75CAE7DD501B74C976A1EDF71BBAF197947F136C72B08B8E8A2E3D87420203C3F84E7C25F5FD32631AC9B0956BC068F0E015027962E49001187E0093BEBD3C278B4C2771EC3038C0BB03E3E8E8C823EDBF2E5803BE0093268CFA755';
wwv_flow_api.g_varchar2_table(63) := 'DCA5E2260BCB7918819137BA5F2E8B9E3F7D454E5CED531B21E49F75B8CEFEFD350BD54ED608C0A7254F299A292B8088CF64710EF6D933AA53E87CE37118D23A8F5D205A08C1E30ED115581EFF933926642BE1AC80805FC2A3BD8DCD5794E52A6B451903';
wwv_flow_api.g_varchar2_table(64) := '243E8765E44DCBA6BB3C971C948FB071C117F5F8929D59B2508614781DF2BF800BFD80F32D77BDE00D98F83A4F0B68C540F31214EA2C22652EB9B84CEAC63D9FED72AB83AC71FA6845BDA30329A57851281895818F15C9C32A28CAD678B774621DBE00DA';
wwv_flow_api.g_varchar2_table(65) := '406F30D369D600A680B803D50CB7790E6EF2BB1F9D511B0414028C427A20FC665C0007A508148C7A720300BFF7CBF3B204BB464C0A505A1AEA266175BC6780D587CD8C8B58B7B680BE77CB90FD124A5A710BCCEAC79887DFBBD237EA8E515DFAA16477C0';
wwv_flow_api.g_varchar2_table(66) := '33FC07FA7803811471613B6E9A5C860B8E813E1586F9A4BD1A2EFFF0A53E399E3CE9BEF1C902246E78900FD6CF7DA5C8AD51FEBF1601D6A3F2C933DDE6082CE41802A21444C6BD675A5C0340AB8760BC54791D45FD1E08EDD4F0A072854AF02848A14CFD';
wwv_flow_api.g_varchar2_table(67) := 'B79238F365B77AD4E35B976AC709F7B989B4B8FB45A5E0D31FD261DF7CEF9ACF9719449D8517E984D5B24CD5C755133480CAC1C4BFC6F5D3FBFC5C8F81EED8F507220B4067EC91225BCD6CB208B03B68356A1F63A0E028B04588443877F19E9438C7D14A';
wwv_flow_api.g_varchar2_table(68) := '721305C777901B30D7B12E13EB9B6B73CF7A6A1B93190512DB506118A59BF6A66F2A49020AD6A4FB317DD062BD89F9EC8B6368C3184C3D7366FD9C26DEE6E3AFD9C872B208B01E064FD36034178CC948107C026092A99B2B48936FEAE53B131CCEA5DEC4';
wwv_flow_api.g_varchar2_table(69) := '763CA860B9AE351F4DE69104E7676FCA57D75B3EE13AA7FD84F269645804580FC7F7A8C6B8F6D3345FDD7C7963D40B5F4DD66EB2B25C8A7EEAE6B655F725139848D544FD134B7CE750FD7094410B7DB352AD0DCA203B8B0053FD7094410BAB152FDF7C97';
wwv_flow_api.g_varchar2_table(70) := '41761601D6EA57062DF42DA86A6D5006D95904584BB50C5A58AD785502DF16019E47B66440CB20428B00D3BFE028839B295970D54240C9CEAE004B02F8587BBB47E702E0CC735B2D42AD383E29C33190C7CBD83FB32501BC79CF1E57E7321970E5F098C7';
wwv_flow_api.g_varchar2_table(71) := 'D83F06632D947DB8E03A4AA62246C66395FC5D95B4D161B42BC05F5C49C87D90AB9EFDD09AE7937F0960431BFF60254EC0E17E9D8891B17F5A6E8B920016D9A3A864C372023FEBEC8CC41B370FF75CCD0614BE4A1D51AE18CE737619B0F737B79FA928FB';
wwv_flow_api.g_varchar2_table(72) := 'AD3F15BDE9968FF1E1E077AA35F186D0486F7767365C7FC2A5E8CA78BAD40D0AD36B0F8EF0B8861CCAAF3FF7D63770F14424DED03406AA0FB2E4646CACAEAB5794916FCA0A9133E5B967D63779F9DA7ACB0A5D9B76F9CA4D9E3917EACF94F36C92199BB9';
wwv_flow_api.g_varchar2_table(73) := 'D7834FF5F5F680E77D2F7FE3F6E7549147C6A3557D5C78BBF4D1CC53D5C3C0D75E7CFB964CC6B91F7EA609B0BB1FDBF0549DBF2C2001CC7030153CBB0A7487428197FEEB81DB7EA66A7A645BA0E50C659391F96457029664FAFFE190CB569144BA2F0000';
wwv_flow_api.g_varchar2_table(74) := '000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72358009088797222)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/rar.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D00001B1E494441547801ED5D6B905CC5753E771EFB9A99DDD5033D7711127A2109248140C65820500824E5608458CA65E38AAB9250155289F32892949D2A';
wwv_flow_api.g_varchar2_table(7) := '3655FE931F71AA9254C50ED8496CF4081B62E25402C258482B04B28484B1820C08BD117AA0957677665FF3BAF9BEBED3B3B3AB99D9B9333DBB33AB6D98BDF7F6ED3E7DFA7CE79C3E7DEE9D91888962DB9609321349A3BDBDDD2393601EA365E81B5DE1FA';
wwv_flow_api.g_varchar2_table(8) := '9A42B12C9BFDEEEE7CF52E5C3E628BDD6CD956523CAEA98D5B07F29714BBAED6E3B93C33D0F05CFBEDF79C6E5BB1C2DB61DB493D9F7163A68C0395667919E0AEEFDCF938207DDED7186A1201DE5669A4CB38E734E924CE1A6C5B1A93899D5E7FEDEF77AC';
wwv_flow_api.g_varchar2_table(9) := '5E7F72E31B6FF8766FDC98982C209764C16D1D1D9E0E91C486CE57E7C645DA7DD39A9A62DD3D31E0EB914AC697FE86268CFF133EEF8037147C28118B6E7FF4DDB7BFFCF2DABB4F29906D7B52806CC489C6E2C945308465F1DE308CD726B8A45BB91FC51F';
wwv_flow_api.g_varchar2_table(10) := '5D8C0D05B724198B456A9A1AD77B92F1AD6DEFED59B8FBFEFBE31B77EFF64E8635B924803BDADAD4DA6B5B10960D4951663CA7D4AAE2437E6D2F80B6A2BD61DB1F087E3E11B5B66E39B877D16401B92480E1A209A4585E2FE1C5877F14E6ACAE8E02D703';
wwv_flow_api.g_varchar2_table(11) := 'C655041D0B8713FEC6D0DD081BB7B51D7A6B31416EA327AAE2E8BA2480B5052B2415C45502EEB56CDA9607A280F7898523097F28B43E21C96D5BF6EF59D26159896A76D725013CC244534E5999F4881B1578A199D4472A273D0FE307C01CEBED4DF88381';
wwv_flow_api.g_varchar2_table(12) := '3B6DBF776BB55BB23980158E74D15558D43E1EBC3BFB790489B0E45EB86B80AC2CF95DC792DBA4A3EADCB561809529543EC2A3B550ADB123781F0639004B4E78766C79E7ADE51DD613896A03D930C0CAD1553EC0C3AED9E1555BF048CE1D9023589383C1';
wwv_flow_api.g_varchar2_table(13) := 'DBB1DDDF3E0C72F5045E8601D6921B29A98ABBD216ACD94D45C9FA32835FCA07815738E10B06D70C836C558D251B06584B2E43449578AA91C4164995542E3D07F7694B26C8B62476B41DEE5CA1DC35327995BE85320B700E095522C629600B65CDB164C7';
wwv_flow_api.g_varchar2_table(14) := '5DAF4E24AD7FDF7C70DFAA8E27B0265738C866012E545C95D2CE9D423A203319120CAE82D16FAF06908D03ACBD5FA56068980FC75D2B9003003959F1209B0558A52A0D8BB49CE48AD3468F783C2AF0C23E79151E55ECD87C78EFEAB4BBE68B0315540C33';
wwv_flow_api.g_varchar2_table(15) := '33622F5941D3CCC18A76D1B9A3E8EC1D99F122C891BEB8BF31B812CFC1776C39B867AD0279C50A4B2A0864B30043605A66D9255361B5DA825351B42BEE0032E6EA45EE3AEE0F05972399BDAD12412EE981FF3502D102BBE6468555500BC9EB286DD4D585';
wwv_flow_api.g_varchar2_table(16) := '720B127C57290D32C0DEF6D83B9D5FED5877EFE17628403B9F44B5B7F3C591092BC62D78C266E26660538A887DF4089083C1E5C07CFB6307F6DDD98E08ACFDD967F19ECBC4AEC96601362538376015D3565B6EA9FCF2DD8614C860C31B0D87E9AE978A27';
wwv_flow_api.g_varchar2_table(17) := 'B1EDB103BB2B0264B32E1AB32C5566C5E0E5BA8F665203AD822C5DE9929A7A8145F5C13328CB8B3743E235A1D0E2585F642B40FE2A2CF9E044BA6BC3003B8F0B8B14954BC91A68AE192D26C8CA3EBC023915782D8945C2DBB6BCB3F74980FCF38902D930';
wwv_flow_api.g_varchar2_table(18) := 'C055B24DA2E56A700954CA8233ABB2E357502DDE4D63E0A5DCF5E258B86FFBE6C3FB68C96F4F04C8860176025343822A489A4535D20C6A179DF1B041DF2A8AEE7027BC946B0164EC93438185B148641B40FECA44806C36C81A6116C3B3ADB8B334B029CE';
wwv_flow_api.g_varchar2_table(19) := 'DC263A0A9810140520C392990C09066FC21BD804F96E808CE81A04C629BA360CB0965C011298C826DA4C473C2E34FF3E2841C6341D90030439B9FD4B87766F68B79CBD71FB38806C16E02AC137AD5BC31130AA34EAE9BBA64E1C90FB60C981C0026FD283';
wwv_flow_api.g_varchar2_table(20) := '2DD49E7B990069C708ED7679F7C96601362592F1A2337E0A396CC9C1600BF2D82F3C7EE8CD0D0EC8CFDA0CBECA3565E384CB6607E592409A6ED9D176A26B58B22F10684DDAF6D6C70EC39211E0B523362D17C86601AEEAC785E3A29ACA92E308BC7C8186';
wwv_flow_api.g_varchar2_table(21) := '5681BBDE7C68CF03E504D92CC0A3B3F769EBA8D09311463BE2A29C0C2B4B8EF7F5C7B026CFB76CCF8F361FDA573690CD014CF98C9B8C0CC95F1BADD9444721CC71645FACAF8F20CFB3ECC40B8F1EE8DC540E4B36073059D6022B648A95D0462BA4FACE5C';
wwv_flow_api.g_varchar2_table(22) := 'E6360937B885CAFC90DFCCEBD1E7F9EEEB7BDA04D8D7919602D91708CEC5FB033FDC7C70F7830A64EC95DB5E7C11DF7A2CBD980398BC688195CED738514833ACBEFA6AA5121E4AF6DC42657EC851E6F5E8F37CF7F53D0754870EEB9C6B3F325D4886C092';
wwv_flow_api.g_varchar2_table(23) := '3DDE17361FDAFB306FF0ED1013C910B300578B0567E28A8493071643BC3C5E6FD2F2200195EB838877C4BD5CD7A3EB496F741DAF559DC7F6783CDE78FF40B426109CE5B5AC7F6D7BEF2D0532B751F01A2549D5782EBA246EA8BAE351C8244026A8B164D2';
wwv_flow_api.g_varchar2_table(24) := '1B8EF40F8A2423DAC01C57A467426DC83C278399D7FA9CF5996D475F6BADD2ED75DBD4916E3B1C89787CDED9F168F43B0FFCEF8F8FEDFACDCDC7F5CF64905A31C530C055F4B81072A6A8A3B65D1B8DC5BCF6C0802DC9247EDC01B5492DFCB144AADB8D3E';
wwv_flow_api.g_varchar2_table(25) := 'B29FAECB4523F33ECE312E30F6E31DA004BCC42D1EDB6E41CFE323BE839D8B549E7AC30057C9E3422D10C815566C494DAD1FEE5200327041A5D7ECCAA5871BEB48F3B06A7CF8CD90783C66DBF85D9BD28B3980A990283C6827A42A2AF90F19557CD376FC';
wwv_flow_api.g_varchar2_table(26) := '8AEF34C8F4DF63152A4321EDB2D1C9D297BE03DEC38BA3E5F3A7A049FD4C46361285D4990358C9A300A114C2D578B6512C239021D00419477B10968C9F492B083C02556C19D597235EE33B523F7453EC10D7D02B9690D3AF84C99636B099DE143841AEAB';
wwv_flow_api.g_varchar2_table(27) := 'C79A08D18C02C0CC2079A894613CB3005739BE8EE8271264F31ED02CC07994B3BA6EA540AE9F204B36282CE3009BD74183B375450A20FBE0AEC711E462E3B57CD3320B30B71AF946ABBA7B2990C7694D2EC3128CEFCE182D930B5E4734981303AF71B464';
wwv_flow_api.g_varchar2_table(28) := '9390980398D84E467C95B4AB1764730073F19D3C0BF0B546A4B7505566C9E600A64826AD05A7F02E3BC8E6056816E0C96CC1DAA64780CC5F2236098A79019A05184230CFA2966C051DD320D7F121B26190CDCED330C0936D9B9447D85502B261804DBAAB';
wwv_flow_api.g_varchar2_table(29) := '3CC2AD945B045925434C59B279F91906F83A71D123140CA0A87DB20990CD2F708601BE8E5C7426C815ECAE0D036CDEC564CAB1A2CF2B1464C3005F8F2E3A43EDD26B329F425546746D1CE0EBD8865348734DF6A572D7130FB26180CD070919F6513DA7CA';
wwv_flow_api.g_varchar2_table(30) := '5D1703B279F3300CB07906AB07D5519C160372191E081B06F83A5F834761ACD29874D70D5893BD63BBEB72F83FE3004FD9F0289455E09572D763806CB3ADE1621C60C3FC4D0E7204CE5B08C8E66DD838C0E6599C1C18AB67A9BE4240363B5FE3009B7732';
wwv_flow_api.g_varchar2_table(31) := '66273CA1D4F89DA7822CD91C97C60136C7DA24A4A4DC1B40CE69C9E6CDC330C0530EBA20B5A4256703B9F2B74955F6EDC282D0284323DA818BE8BA140E8C5BB0792753CAF42ABCEF6890D5F792CDF26C18E029785DC393E1AE2DDFD8C910B7F40D03EC76';
wwv_flow_api.g_varchar2_table(32) := 'F8A9F6CE979233D664C3209BFB7E700AABA930AB48A585BBB601AEC7D72012C7378563B122098DEC66DC82A79CF44801BBBA52192FB8E97ABCFEC30F4ABBFA5BFC1FE3165C3C2B533D950434C8D846B1B4ABBFC5FF316CC1530EBA7828523DD516AA642A';
wwv_flow_api.g_varchar2_table(33) := '6902862DD8DC3E98AE5EBB7BCE59AB4EB6FA6CFFB458219AEBA65FB6712945CD238F997CF29EDBA2E7989EAC5B0259DA1B06D879AB32CD6896010BA9A2B0C8582D323BA4C59D841624AFF953562C837067091C036887343EDA380A46E00652F7B2F1A2C1';
wwv_flow_api.g_varchar2_table(34) := '18D9CF022D5BF5637FDD4F8FABF9A1E224B2F0C3F60C8BF0BB5B695E71E9AA68BE5C751AA3B16180B538C61835C76DF64688A1801DC0AFDCBC99882B8139E2D6B453A2C7E10EBCD8E603B86FC4215AAE5D0A161C517727EEE1C7AF940268B0382C5B69EB';
wwv_flow_api.g_varchar2_table(35) := '3E128FCB655BC3E9F45B877E35A97E6C5F039A7E1008839F838A1FD6B29012CB30F5A5F8E19619FCF1960A2A8601CE9CAEBB5952CC35F8506C04CC8F1F147ABCAE4116D4D6C9347C7BA03E25B87E08BA1BF73F8D0EC9217C9AD1FEF7EA830A94387A13D4';
wwv_flow_api.g_varchar2_table(36) := '4822291FC5A2120378BC266D5D287E5EF3F320BEB93F030FE1F1A363CA03D0FA8EC786A41B63D07BF0D38BF3C3508419007E0BF869ADA995E9FE1A09801FF24A45ECC5FD2E8CF73EF839072598857B845DAB004E0B2AC3AA5250F3821A1906B8381635B8';
wwv_flow_api.g_varchar2_table(37) := '74B9EF40607F1C6A9607A7DF208B0221698430BD10187EA4534D288136F16442A26877F0CA67F27717CF49DBEC79725BF374E983A0EB00440F14E0FB674FC8DF86BB65A3D72F0310B516782DCE4E24E3F2B99A3AF9931B6F9696FA06194824A4018FF13E';
wwv_flow_api.g_varchar2_table(38) := '0CF7C8B7CF1E9708C698093A9DF1A8B4E2F8EDE9B3E4CEA6697263435042F816830F75F41C2C8A1F28521434BA00F0CF2E5F947FBB7A59421887BF68C625C469A99A17F0C75DEBB1081A06D8597FDCB0482DF7E343EB3987CF3FDE30577E6B6EABCC84E5';
wwv_flow_api.g_varchar2_table(39) := '924E52B9500AC9A1CA116C585D1DB6110908F5F8A76794F54C873536E29A3F49385DEA6575B0117EB55B68D574FB1434AD97FDCF629CA71A02B2B4B1199EC10B90920AB43080791DCAB11175AF01DCAFD507E4EB735A65159427042FC2427E322D935C71';
wwv_flow_api.g_varchar2_table(40) := '04FC349DB404820AE47F009D3AD4D66044AEEB8516B634FDDD10C30B861B689D69B307B5EC00ACF2E9E619F278CB02995D57078B88CB203E9C34ED6F08F787205C02A5C40090F00F5BC867A8DBDDDD25E7FBFB943585A351554FEB5F0FEBBD044BE79A4A';
wwv_flow_api.g_varchar2_table(41) := '2FC171FAD187AE7725148056D80B971C47DD85C17ED90B3AE82C27D1E71BC126F9CB854BE5F337CC9600AC9BBC0CE1430552BF6B49360847EA9A57312C0DF42C14AA033C6BDD16F732CC3782710B76C31E85DE00019D83E5DD030B7870E66C99E6AF9530';
wwv_flow_api.g_varchar2_table(42) := 'D633BA65AE9FA7FB22721882BF02F747C135C072E7602DBCB5693AA468A9406B1F7E7AF0FC403F14A35EA2143854623E5CEF5A28CA77FBC2D2420B435FAE8CDD50882FF86A64211480B5F8AD68F163AC4BE8FF1E4016DCDF541F92A7E0BE6F86120CC0A2';
wwv_flow_api.g_varchar2_table(43) := '69B3B51E9F52849391B09CEE8FA8388034EBE14D6680E759186B3E5C782DAC9FF372AC11272E8A23BBC22DBE10D2860176373147E822C720D4076A830A20BA4B160AEA645FAF7CE7F431F90184AAF646B034DA06039C271B2EC86200CDB57227ACF003AC';
wwv_flow_api.g_varchar2_table(44) := '9F2BB04E5231F01BD0320D6BECAA86900800661045374DA03E06FD47A108541206613E0473B4BA6368B7138AB2066BFED7E6B4C8A2602805AE481D2CB86B68485EB9F889FCE46A971C81029E51108ADC007EE663CC9BA1A09B303E83C079501A8E39D299';
wwv_flow_api.g_varchar2_table(45) := '7356F94B314A919FA2E3B5C66AE3E2BEA3832E3AD0232AAD08C112080E312415C808561B951FC05AE660E37B07044FF7CAA0A6179FE7004800D67D974AE9597238D22BF7C3CAB9760F22D86A4030B40C202DEDF22AABA522F4ABC1446E856506713F06CF';
wwv_flow_api.g_varchar2_table(46) := '5183FAABE8F74B2888C0053F89186025804A00282E01B5E08BDEE3FB678ECB5F5FFD0CE07914A0AD38B2D0BDF74351760F0DCA4B97CECB5ACC81FB6BBA71F7011629BA97217BE52A86D760A2E5AEA8A405E6D48F35960275D0E50395A42C0110DF9B3D5F';
wwv_flow_api.g_varchar2_table(47) := '2E4058AFC06AB8656103EE35EF83C5AC043831745981EBB7E062CF4019E8721517F8D30A97793BB63527012C7EE94AFA00C41A58E392947B26A76CFFE9609FBC028511B8DAB5003700DAF40254388EF8068023B8EBD17725EED5035CC240E1D5E29CCAB3';
wwv_flow_api.g_varchar2_table(48) := '068AB601CAC0508C3FF45C3C4C8A7B5030538CBB683713E354F86985903F860BBC8A0F5D272B097000427B6CFE02590C407662FBF1DFB0D2438998AC82E0A741B0DC8644D1F8065CEFC15AF961B8576E45A0C635350A85A135DF86487807D65646B397A0';
wwv_flow_api.g_varchar2_table(49) := '408FA06E3E22682E05DC7AB1DD312C01BF8005FE76A849E6617CCE81CA5607C0B8B6BF82A898961B04DDCB68FF2E3E8AF11C935D8AB65442B750E5205712D26601C68C38A94219A50570EF7B132CE035ACA38F605FBB006E955BA021B84F5A11D7E2CFCD';
wwv_flow_api.g_varchar2_table(50) := '98A5DCE62300702FDABCD873457E81FBB7010016BD277D170AB0094031D81A80BBAD47147D0BBCC02C046911D0BA82B6ABA12C4D70F754203FFA5F46FB77E99EC10793188D70DD6A2B86B654808B508E2370D14C5ED083B4C2829F6A9E234158B38A17D0';
wwv_flow_api.g_varchar2_table(51) := 'C629CEE469F547C0C7ABF8E00B2BC31E25D52ADFC18DECF2D1C9BC6716603DD7CC11C63877422A4BD600C8EF765D9459B5B5F26B70CB0C6C98D020107479DCAADC3E6DA6DC82BDEB86DE6ED971E113791E425C0B90E290CC6D106C27C078026E7A362268';
wwv_flow_api.g_varchar2_table(52) := '6A1ADDFF42EC4DD7015066BD16A30D0157160E0521BBE7B0BDDA8D3EFCEE1095C90BEB03D62A06206F613C78EF46450BFA9E033F7740017E636E8BCC84323038230DBA795DFCA011006FCF416916A39E4B430CCC0CB7D02DC7E768760DA60ABA2C9C38DD';
wwv_flow_api.g_varchar2_table(53) := '6C08C2A03D3EF3E969F911029AD358132960BA4902426BE65E9429CC3BA6CF943F5DB84CFE1C0988FDA863B4CA54E211B8E90F60E5B47E1FFB605F3A1B2E77352CFA22C0590D50988DA2FB75DC73528E028843A0C11F00574029249C891068064AA4CF6A';
wwv_flow_api.g_varchar2_table(54) := '9E5360DCBE657EA811EA7B45A9E3C8EF181521148C61AA9805B8483575401605F22C88F21B086AFEE2F85179E9DC29953E649283D12C018863ED64943C0F3F29F895F937C99701E07100CAE40517877760D557E0760930DB32B5C8A40641E07A3C036B30';
wwv_flow_api.g_varchar2_table(55) := '01F64051BA61D5FB91EDE29AC9428BC42D14046A38D20304316E00F7192D3357CE274954A0417C781C421FD223A8EA0865E07F458A82831B2DE6004E296A311363575A2F5314CC3A6DC01AFC7FD822FDCEF9B3F2071F1F957F397D5C3E82A571EB41CBA3';
wwv_flow_api.g_varchar2_table(56) := '6553B8F3E08A1F82DBFE1440D20DAE03183F859B66344D6A2C6CCF208D2F9ADFC2F51D6D14ABB87D16EDB6218862BE9995BDF000312813BA380575D3A1100BB13C708B3607ED4E2356D87EF6A4FCF0D431F9E7131FCA8F3F392511281CD773D2E51CF8DF';
wwv_flow_api.g_varchar2_table(57) := '70C93C1FAE1DAF337300A7E6A184E7827BB627B87C7E7B09C2E5735D064D2D10E646649C7A01E4339F9D973F3BFE81FC124906824C4B76ACD0921B017233DAF2715E33ACF614DCED51B869BA73D2E11A3E076DFE0856BC00EE99859B1C46CF47A034031C';
wwv_flow_api.g_varchar2_table(58) := '13ED16C05C3F82455F85622988301F2642E6C2EA3722BA7E1FF49AD08EE37C0B5BA63F4454FFCDCBE7E5E59E2E954665568C967B6DC956776DAB72D5980338C5A15B7D65FB215A072C6C2182216E774E704D84B0C85C0BACE7D1DA7AD905CBDC8627477D';
wwv_flow_api.g_varchar2_table(59) := '29E052C3A9C068262EF43B88B4D80374D3008B112D13238C78BF004B9F81EC96520C8079055BB2B700F01CB8DF418C452BFE9FE820B2675CFBB946C32D034CA622BF88A7558F4339768226A3FE4DE07333D6F385A03717B43987DC30162E91C25BEAD98F';
wwv_flow_api.g_varchar2_table(60) := '7D340E70EE895ECB0CDBF29911F7958B20AC675A17C93F4198D391F7ED0490BBF044E755B8C497217806416BE16A6B207882A44B04ED3E8678496710D5EB00D4CB5006E6B05928345AFD1AE4AEEBA1443A00E2FDAD68B71000F249168326A2B4ABFBB24A';
wwv_flow_api.g_varchar2_table(61) := '4B32C3C5B60CEE16C1FABFB960897C0B4A3284763F8312EE42E2E524F8C3E307E551D8D971CDC3BC29065CFC29BE67EE41CC6E93728F93F30E0319661039B965A14659376D86DC816405D7D14F102CF5C3453740D84BB0DD5983FA1A00CD608880D03A4F';
wwv_flow_api.g_varchar2_table(62) := '10485CD7023C5A22F3D43D10FEFB911E59035AB5B8C6BF2A2AB36171540C82CDF5FB3D0457EC5703651A423F5AE63DA0F1F770EF775EBE205F9A77A30AEC184CB12C6B6C92A711D87D1116DE05BE063926948DEE9F811C1581CAC4F84047DDEC97CFB69D';
wwv_flow_api.g_varchar2_table(63) := 'FBE5FD6B1C604ED24D815C9599512814FC4CA40B57344E93E5D8EF327A76D65A8F131CA131C1A51B26A0477BAECA7FC1E296430108034951C03321F8B7E17E1F06102DC85AD112F57D5A1901DA87FB8BD08FE3B2B01F9DED6DA0FD37580A1A91D0B87FD6';
wwv_flow_api.g_varchar2_table(64) := '3C3CBDF2832FE7D125EB5637CF547DA85CE483F325B88CB2E90EA980DC4F4771EE50660BE70C27798B5BD9E52596BA69D645631E854D659835C8285D9824E0F68619225637C0BAF8A09D166CC3CC551DD63CEE8B7F05709F4734BB0F4111B34C3A994077';
wwv_flow_api.g_varchar2_table(65) := 'BB14ED77E0C910BD00E9F1112305CFF5B406FF2EE10958E14B00790EEA1CFB745C396301066C7CD0F057E74EC97FE2F3D9D000FAF8F0C607325C981C83B324AD15E76CC7759A411ADF08A9C5A71BFC9C83EB67168B0AA315283DC93C276E65978754FA96';
wwv_flow_api.g_varchar2_table(66) := '590B06021978A507C97742405643A8C720F0D761396B91BC68863B0D02145A88A331DC97DAEA951C5ADFFBC864BDD4754976E17C0DD7D08C01688975AA9F2D07BAAFC08283E9448993A34ECA7ED433E665F4CE704E172E1774D7B3C0CF1500F9756CD39E';
wwv_flow_api.g_varchar2_table(67) := 'C6589BB0F62EC63ACC3D34F3E38E523870D0C37423DB751571C21964C5F6238DFA261468017850CB0F88BB9589E6C7C4B1B4B16D1B0B9C95FC5CE76BF700813D9617FFC272228E7FA3153EB2C0423151D05C033F81E52E87A5AC40BA721EB6481426A359';
wwv_flow_api.g_varchar2_table(68) := '5A01B73D17B0B61E45F4FB3A8EF3C1395D2C0122A89913E1399FC7F245BD1644BC5CAF1D57CFED912D67101CD1FAB81E672B4A494091CAB71FEF6F5161EE039D15080467E3C8A40BFB920673DE1700F04708060F81AF2ED0BF155E22A4F8CE463D771DB6';
wwv_flow_api.g_varchar2_table(69) := '59498FCFE7B1E358AB2CEBBEFDF7FEFA3EC855C93877AFFC77CC5A70FEB1B2DEA588295066A26EC22AC6B712F7F745215C5466CA3F757D1304B71EC0D6A33D83AAD1CD3808E93161C2371EDF40220331B8CA42712B45D7390FC01374F6CD56A89DA4CDD7';
wwv_flow_api.g_varchar2_table(70) := '65F9D25E048AF72B80C76DD2350382082D954FC41680B7553EE73D2C8E95C97EB671C6A3CE2CC025CC88C22628ADB43ADBC90A65AE5F24CD04058F5C6FF59B92D986641DDD28E92DC3BAC86BA508388151AAFEBC9FAD2FAA5521C8F40E7C2B8C16BCC8C2';
wwv_flow_api.g_varchar2_table(71) := '3E1DD7E489B4143D1C4943F1851395C64CDDCF471B5DC6AD980598B32EA150EBE95A291C2D201E35598A569FEBFBB986E37D5A322D315D52A7BC37567FF6D16D145FA0A3FBE97AD267517CB9A4EDF42CFF5FB300EB9917C97766770D8B3E6A92996D745D';
wwv_flow_api.g_varchar2_table(72) := 'BEA3DBF6D96865D2203FA379629FCC36D9684C545DC1C1D0980CE69AF9981DA71A945302E600A60A57AA1A975382154EDB1CC06AA24E1054E173AE58F61CFB306B258601CEBE3E55AC442B8CB16C6B7BA92C1A06B81C2C963AC56AEB6F5686E6004E0559';
wwv_flow_api.g_varchar2_table(73) := '661D4CB581531ABF4A7666F1C51EBD84D2D6D1318C271343480818E6AF04EEAAAFAB921D64A8B23129F647C8B88829950470475B9BE2C94E240834D065326018F322F8B9AEBB28D931D5464371642A5AC6C50AA62480B576793C1E267590D00173CE2B13';
wwv_flow_api.g_varchar2_table(74) := '047EEAE35606941D65887E7849419D6819B3B29862249315B5EC933549EB435F636865ACBBC749214F19B23B3C08279ECC4186DE784FCF8778A874C21D81ECAD4B83C1B6E155F8E85B647DE74FB7786CFB796F28C89FCD984A7A2821B8F8A3A488871BBD';
wwv_flow_api.g_varchar2_table(75) := 'E11E3C20FCDD9FDFFBD07FA8DE193276412DDDB4348049268381BB3B5FBD0B978FC0CF345BB6E57CD53D3DD4D4494E096081834FC65347AB1BF6F293B7EF7DF8806A9B21DB9C7DC7E50619992A66256048A6FF0F1EA38B33E929078E0000000049454E44';
wwv_flow_api.g_varchar2_table(76) := 'AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72358418911797225)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/svg.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D000018E0494441547801ED9D79AC5CD75DC7CFB977E6CD5BFCBC3B7656E7C54E9BD6899CA44D9A36D0A68B0A255100B54E01210412088A10456469404835';
wwv_flow_api.g_varchar2_table(7) := '6251FF002496B682FE83AA388B1D2A8A4015AADAA425CA46558AC8D22676E2C471E2C4BBFDF6997B2F9FEFB9F7CE9B377ECF7E3373DE2CF61CEBCEDDCE767FDFDFF7777EE777EEBB36C6434A12633D54D3D12A929D3B83C4F4FE73D40BB1656004AEB506';
wwv_flow_api.g_varchar2_table(8) := 'D91833F9D53B6EB626BA33B176B589933808EA9BEB96733A9624F4301E3403A347CCDA2BBE36F4E9BF7E2DD9BD23343BF6C4F9F3744B6F5BE9474B00CF03F7CB9FFA4C10DAAF95868AAB5D875AAAB995475A6A593A98948D29AC3395E2A6FF2C0C0E7CCE';
wwv_flow_api.g_varchar2_table(9) := 'DEF9E7AFC2E482F9E2CEE87C01B92518A4F1F6AE3DD1C43FFECCC56152F876694571DBF4E919A466BB96BB73F003615C8E83C1F55303EB368F56CA95670A95F097EC2F7F697FF21820DF767E80DC12107BF6A4E2B271701506EFDDE509B04DC155BD5DBE';
wwv_flow_api.g_varchar2_table(10) := '259611B7A027A894A3F1C2E8D0072A85CAAE64F73D63F6A33B2BE6F19DE1F9E05BB404F08E6DDBDCD86B63272C28E192763DB0E5DD3521B6DA56C6A792C2F0E0872AD6CE81FCA7BD0F724B00EF79FE7987691258018D6F9522DC4BBF8989D5DD0037D156';
wwv_flow_api.g_varchar2_table(11) := '26A7A3C248E98395C03E98ECBE7FABDD0993F7EC0E7A99C92D019C333803D4A1DC4BE0A67D4504D62641C0540015AD4CCC4430F9964A103D38BDEBDEABED5D77458FF730935B02B81ECC1E2470FA0820AB891E1648F200E429402EDD14960CE6FAFEAD1F';
wwv_flow_api.g_varchar2_table(12) := 'ED61267B05B81EF05E3967229F856A30C6CE39CC995CBAA96260F2A32993CD9E1D3D67AEFB0083689231B84621332663AE4760B2310FCF3C7AF7359A12F61AC87D8041758EC13510A7D33C1C2F8DC9A51B832478A81741EE039C33781EB6D59339260F97';
wwv_flow_api.g_varchar2_table(13) := 'AE17C8498F31B90F30583A0657313DE320053965F2F5E5D83E3CB3FBEEF7F68AB9F60AB08B7A9C219F1EB970F6CE57412E8E0C6E0F4CF048F28D7BAE9D03192FBC4B935780BBF6299722FC7377BE0A328ED7B595D83E345305F92EBCEBEE04D92BC04B91';
wwv_flow_api.g_varchar2_table(14) := '638FE7C94026E23554BAD656BA1FE43EC08D6B1C32639E4C58B3089303983CFB8D2F6C97B9DEB30726F3E240E3552E5F89AEEACCF23DE6D96B5E601E7CF6024CA118B203A65015A650D79A287A78F6D13FBCE12ECD93DFFBBCED2690BD027C763FE55C32';
wwv_flow_api.g_varchar2_table(15) := 'EBDCFD45E6C167ED106B8D8CDA4948ECBA82E3758D49820705B263721781EC15E073FB296795590FDE5C00E487EFBDD131F98BC0DF05E6DA2BC0BDCA60A7594D743E2D5203F2304C0E9287661FBEFB266B77BA75C84E83EC15E09E6670139D5791792033';
wwv_flow_api.g_varchar2_table(16) := '2617570CBECB84F64107F24E40FE626799EC15E01EB4B12979CF5C6C58F2A3CCE9C53C266FB561B0AB1B98DC0718289B71B216D6800CE4D4BBBEDA81BCFBBE9B7933A463E6BA0F3048F98D42CD07D9D8E4E1F2EE7B3ED82990FB00E70C5E98924D5E9D03';
wwv_flow_api.g_varchar2_table(17) := 'B9385C1AE36D82073B05721F60EF0CCE75A206E491D2959D02B90F3078B831B88969520EE5E2FB3A90AD7DA8BCFB0B3FD54E73ED15E06591D1E2D2EB913B35200F9736DB207EB0FCC8DD1F6E17C8EECD7E5F929A9B32F8AAB18DF5CC4D6A97A1D1399089';
wwv_flow_api.g_varchar2_table(18) := '5D5F1E4DCD3C00C8BF6A3FBBF3FB72F020469003EEBB71AF00FBEEDCF955DF7C90CB1319C8D60A64054C9605E43EC06DD5A239908BC30330797657F95FEEFB357C80C7F4C26E62767A07D9EB18DC5659F96EAC6D0E4406F2D46C391C2E5DC6DF753D50FE';
wwv_flow_api.g_varchar2_table(19) := 'C63D1FE36AC29FAD4266BFEBC95E016E9B8C3C83AB71B0BD7FDB2F904D81F564817C8989CC03E53DF77DDC816CFC82EC15E0DE74B28822EA2F1BEAB453A7E7DCC890E791CEE5C78BED5122DD4A7F6895A3426562BACCEB3F1773EBEBE547EEF98440D64A';
wwv_flow_api.g_varchar2_table(20) := '942F267B05D8F55E4FD0530911640CAEFD2B4229EB393732E479F4C8F9F1627B90D5ADF447077A69C0DA62656AB6E2981C985DE5DDF7FE6C7A07903DAC277B05D8F5DE75BCBB7FE629A2634CC87739781936601F04493BB7C0B567C378BA3C5B1819BA88';
wwv_flow_api.g_varchar2_table(21) := '058A7F4EBEF92729C82C52D42A5D3352BD20BD6829A26C7200A849653A9C387D789ABF611FCF2CA833A1699EF922CDAFE58A2C45A9BD962B4E7EADB674EDB5FC78DE9EC2F6A4192F16C28D33B3E5BF79FBEF3EFBF2C6DF7F649FFE16CA18DEF56A325D90';
wwv_flow_api.g_varchar2_table(22) := '00E7B2026263A2A95232331E8ECF9824C254F367C20EE03C4FBBF6029B5464E30330C17BF812C6651CEF332FE82B0AD9B73294A3C174C1023CC71E6B878A85A2FCACF159FEDE1F710AE47928D79EE7C78BEDEB01C8F3E97A7EBCC85E1660200CCC6C25AA';
wwv_flow_api.g_varchar2_table(23) := 'C451A5525F5533E7172CC012562E67FCE8A454D09971204719C8127835A5B7D3D3FC78B17DB5507690E7D3697EBCC09E4B31836EA8D58F42318526FF4C467D954B3DF7EA642DB5D16ECAE7E48C772B67A6145ABB6240EE96B1710C14F27ADBB82DE450D5';
wwv_flow_api.g_varchar2_table(24) := '7D26A361D15DF000D74A4C8C0564335AE25B0E208FC0DB9F72667B6AD92BC09D9087273954ABE938C89E85E81560CFCA57157ABB0F3A0AB267217A05B8DD402C677BF340464A1D31D71E1EB00FF059845805798031B95D2077B3893E8BAC7AF6564740F6';
wwv_flow_api.g_varchar2_table(25) := '282DAF0CF6AC7C1E1FB3B5AA7A1964AF007BF60F5A43C573E9B681EC59885E013E5F199CEBCA3C900142614DEFC9739D5E01F6AC7CDE65E7A3C22AC804430A48CFBB77ED59885E01F621C05EA8A30A32DE356B03FE41F628843EC04D0A53200F28AC9981';
wwv_flow_api.g_varchar2_table(26) := 'ECCD5C77B3896E52563D5BAC16E46531D71E24D367708B42AC0559E6DA1B935BEC575EBC0F702E8916F6B5208BC92D81DC77B25A4062198BD683ECDDBB6EB2EF7D063729B8858AD582DCB4B956251E531F608FC2545555909B9D27F74DB4674496A13A07';
wwv_flow_api.g_varchar2_table(27) := '32AF84E8CD90A699ECA95F7D067B12647D35B520B7EC78D557DEC0791FE00684D568D66E00B90F70A3A835983F0779652970B1EB96A6500DB6ADEC7D809B105AA345047211497702E43EC08DA2D564FE1CE4D13633B90F70938035532C35D72993C5E805';
wwv_flow_api.g_varchar2_table(28) := 'CDB532794C7D803D0A732955D532794190FBF3E0A588B1BBF3E8CBA40257F3E43340EE33B8BBC15B4AEF44D294C90A8604F341EE33782922EC8D3CF5E67A391628FA6370877561CE5C8BC9FC3163DF44771811CFCDCB22CF81AC3139FF90849F86FA0CF6';
wwv_flow_api.g_varchar2_table(29) := '23C7966AC94156CC3A77BC2AE596AAAC16BEA0FFC2BF2A852E389873BC007980CF3814FCD8EA3EC05D006E7D17C4649C6B2FC953355EFAD2AF249380B8EBC9429B2E64308FA72774F341F733F7D8B9D5729F7AE47222F7A426B9EBB5656AEEE9D0B9A879';
wwv_flow_api.g_varchar2_table(30) := '259C9F35BFFA5193571D5AACDDBA66E69D9EB58D793997E5A48B00963025C401D6B8428E7301E7D7059C0C0EDF048B67D3E3C210FB3C713FE1CB43EE5E7E2DDFAB0ECA86837320A9AD4475CDE4996AF6E4B77CB22AD467ABB2A42AE2E9F4241C715DCD6F';
wwv_flow_api.g_varchar2_table(31) := '2DBEA78D182E26EAAFFADFFED425006702D5F76DCA27D8DE46129991128B72E64848E17AE27C6B53614FFF249318E5046E41F7D62D20C5ECFED4EBE49BE23E0AA4FCE16AFE3C61E302F9B9AF7E540E65F7842E7594AE4CCF275F642FD032454CAFD6FC66';
wwv_flow_api.g_varchar2_table(32) := '60BA3E517F710DF75447FB5317002C00616D651C99ED3566789B49D6FF9C4946369864600532E41E2CB0B313C64C1E37F6F47E63A70E22EC4B4CB2F67AE42633AD3A10F62CF727B957BFCCAD3C41917A3F427DA5B48CF2974F1B3BF15A5D7EC08171C9F0';
wwv_flow_api.g_varchar2_table(33) := 'E5C60CBD3F454478A989D3AFBA83E4A24F521FE55DDB199869CEF9BF52D8E963697F75DC0116771E6099C2D9C368F9A889AEFB63135F7E8349566D3449112024442718A41BC1B82802C063A6F0C34711DA1153BEF5B7001A25A800C8C0A0090EEF3785A7';
wwv_flow_api.g_varchar2_table(34) := 'FFC1D8F1FD5C87CD328F96479C79C3C49B7FC1546EFA15588E99565DD46F4F1E328527C97F12460E905F265BA97CD44437FEAE89C76E4AF38605DA3D610ADFFD0BEADD60CA1FFE3DF2333CA89EAA75498BBADF6CEC4E8A0326DCF7AC293CFB97B48BB508';
wwv_flow_api.g_varchar2_table(35) := '5056B1BA8D40771060510270116632B2D94437FDB689365FCF1794C5307D994CCC24AA9311C4322FE44B9280BFDE241BF84F3E9FFB27A700F19A8B8D9D9900E061C327638D59718531279E06884D94CFCDFC71136FDA66E275B092664DC475015C1AC40A';
wwv_flow_api.g_varchar2_table(36) := '5C63EC916F911F53AA9852C4383BB09A36AE32F16AEA28735E447900D84EBC60E2D1DB4DBC72431DC054AA7AAB293B91920EADE29ECCB9AE9D85EDD5B27E0F64373A907858811B4D62320761CB6F98CAD65BF83F9661CAEC94B100C057B191098CADCC70';
wwv_flow_api.g_varchar2_table(37) := '5E01F34C68B0D8C9EAF4632638F432EC9F0204F24C63C2617CBCEA329E474C9482F07811F74B570124C0131E9232D83C3FF793B59BE90B7A2EF66A5F3E669295FC7FCFA561FA32C936EDCA04877E6CCCD48F80887FEAA336C04FFB2B56AA7FF9A6C3FC58';
wwv_flow_api.g_varchar2_table(38) := 'FBF6034BA32E7588C17A60B6F2214CE75D30F70680004C046F0A98B168D68407FE17005F0260CCAFBCD9A15113AF8755178DC1A801BE35480DC75F074780D1388D70C5E26435005B9823F32C133F7B8AB1F7FD807611D76953265F9FB1538942D1C46B2E';
wwv_flow_api.g_varchar2_table(39) := 'A7F8E5B429A6AE647F90BC9B4D22E6A98F6A3BAE98E0E8AB69197D6EC76DD4AD449DF6E4DB26C0DCBBF6744D98EA8767B187F7711DAFDBF90552BAF6A60E00CC83CBC171E36388F0B732DE0E39D6A6D392C4847B9F642CFD3318771C6920E444609520FB';
wwv_flow_api.g_varchar2_table(40) := '98892FF93020C07040098EBECC587C1213BFB6AA1CC90AC6D2C10CB01090A2B74CBC01C76D68A5FB0065267D7642812160741D1B66FAC473004C7E2C4BB2EA9254D19C7316187B0AE7ED38D6C22946AA1C6979AA01E0F0E073A6F0D4E769F75AEA04C4AA';
wwv_flow_api.g_varchar2_table(41) := 'F3A56745210AA329AAD5EBE9693B7E69BD1349428279302D9193246649E3B58791F6D87E3CD667F1A8B71B33721D1BFBD216187FDA04AF3C6082B79E640C1C43F02F9BE0140E9AF3680518B58C32468F5C45F5C7DDB90960F5FA2DB0552C276111CCD429';
wwv_flow_api.g_varchar2_table(42) := '0E7874BE389A0CAF32C99A77919FA999CC34D3B064D5A5580D745FF7A9DB9E38447F5EE11EF52AA54DA5C7EE9C0BD149F2A3886EC364578FA9B383A94300EB89695ACC2C33463A8949E09133C7D1D5B79978EC0F8C99780A0FF81DAE030AD31C53C2CC0E';
wwv_flow_api.g_varchar2_table(43) := '02B48E43BCD8E98328C3018AC31A2907AC4C06474DB202066ABE5B9902C06B30C332DB5222CCE9C45194823A438013A038506E1C0EF0AE99AA25C357A220CC5B9DF74E11679EF7A7D6244019735F805BD5248B54A45F054CBC36997AB7ADA21DEAED60EA';
wwv_flow_api.g_varchar2_table(44) := '80891610002290921913308E5AAD8DE160C9F45A408E378C99F2473ECF14E3032678F5BB9847D8AC8FA117F15E5D391883C936118C666C7463B71C344D5B708E92D59B8D799DFA66DF36C9C6DB53C0043E2087C70EA23878EE176396758D31361D872F45';
wwv_flow_api.g_varchar2_table(45) := '6160E9FA5F243F531AA7349867395947F6724EBFE5183AE7AD0E317C0633F943F288AD6CCE14B3C77A98A2C67E89B99EF675752CD3A9578097FE0800AC3078B8C104079FC0E4FEB489AEBC219D1AE943CD083EC6298AAFBFC3045B6E31C11BCF9960DF77';
wwv_flow_api.g_varchar2_table(46) := '4CF0CEE39441F81AD3C4308BA77B7C2FAC641AB46A93033A19C0ECAFDC481ED836F332D39D77033A4E0E758AB1560A7102A5DAF6C954A9E849B242E3F0D5384BDFA1EC650C1B23281AE0639E83F123E47F9976A923C6EBCF930C82DE7B95925CB4D544B7';
wwv_flow_api.g_varchar2_table(47) := 'EE4259B261806B4673E7A91328E8B7D9CB62607116528EBCBE65DA7B0558CFBCB42416C35A3935D36F11B8D8E540883662E604044C4C59C9B44740BFF7E3C632472EECFD90099F7B00661E253F73D470D48D8D56E3F01ACCB263098E933C6631A7FC269E';
wwv_flow_api.g_varchar2_table(48) := 'F7583A8EAA63B03138FC220C7ED3052E5C3ED826939CAC1A33C1EB40B0FA729403A0C442400A4EBC45DE575106CC6EC454AC9AD2A775CA78D155467DAF3EBF40A78EE0E45B2678F3BFF98C3C96410AE7985DADA02D07D0C05F5A3A83B33615D521C0608F';
wwv_flow_api.g_varchar2_table(49) := '3C6D0ADFFB2B53F8C97FA1ED4C6B106CC2D8A8E4E6AC9A2AE12997B7DF4EF4EA5EC659C02DE344155010A254F6D86B2023F3988A589E74525A0B33099CC06C8DBFA80D11AEA33866FB68031633B54998EE684850142C01D8040B9C8C1222758B0C99A21D';
wwv_flow_api.g_varchar2_table(50) := '019C0A0E948604437FB334EF599D356146C058EC8231D9344AC7699FE6E5CEAB68CBDE2BC0550D6EA4EB1AB74A44A34EEF358527FEC814BFFF15537809B37D2A05C045B624A6F2AC9BE64463EF33D1F65F77E3AF33D37282E47513949062B8A0C8E008E0';
wwv_flow_api.g_varchar2_table(51) := '6E32C93AC29E4C8F52C788FF63E538E3EFF41B949D7465E425BB7B44CF9295E45F73671A7952FF05CECC38267D1F27385172A4DC18AB9B75893EB8808C823228A3EBAB8229F814E958DE9464EA1A69EED4AB896EAA0B129C4CEB80568822CCE4BF9AE0C0';
wwv_flow_api.g_varchar2_table(52) := '1EA6361F33D1D64F9868EC0378B6AB011761C989625C8CAFD86E9297DE978D8DCC6F99A3DAF1E3008A7945B069C0E32A3CEE15B09290A43A26074E4107778622C04C2B0F5E8B0FA464058CDF742BD60185D0392C0C4E31FE9E7C893C9857E785CB0E90F8';
wwv_flow_api.g_varchar2_table(53) := '914D7096418EDB1B2F9AF0D5A7B0281A67491A8335759B653163FA08E5A56473EC4F33B5E7B7F300574E23286CA31C27051286B700348C384A90FED05770ACBE64CA2C120800819C9A5479CA8C79477F4039AE8FCBE4124912C0594AD6E12C0DA1340A47';
wwv_flow_api.g_varchar2_table(54) := 'EA9710657094E54579B624394E76FC9889D75E467B9A0FAF265EFD1E17DD720554E638E67F0AC62B60523F7EAA5225000E8E1F30E1FFDC4D1D38778688980353A1D331948C39B616199C83E5D443A5DA963A04300F2A73A7316BE40AB4FC2D1C9F1F61AA';
wwv_flow_api.g_varchar2_table(55) := 'AF4698B00081242378B595CD2678E17E135E729DA95C731BF935A264CC21FA65621858C0BB9D7A1193FBBA89F1C49547FF654ABC16B05939D2A28533DDCC7D53368A659A0FA3140430A41436220F4C8F59607061503190A94F7094F1373A81750138679E';
wwv_flow_api.g_varchar2_table(56) := '1D6FCF0047FE42B2EA66C0DCCCBDCCEC3BAE73EC5E409036B41F5C75B403000B208092100945C6577EDAC5980B2FFC87B1EF7C8F714F8BF84C67D4B598F9EABA9F4FBD62F5D6518BB29A4ACDE0F8A81EB75080E93C0618D3042A1492645E9D8CE245BB22';
wwv_flow_api.g_varchar2_table(57) := '1238F9151099610C1EC0DB5699E90300B89F21E0C6B4DE6C1C9669957314E0ECD96398748BB35733FE2E089353089CBE486DD29EEBA71A5F30B76EB42D7500603D9B1E9C318A40854295D116C659161282C377309E1E605AC2B885D092A13526BEF43A13';
wwv_flow_api.g_varchar2_table(58) := '6FDCEA4CB3804A6077302DE133366AEA2261B2B727980F6372656A9DF2B8B13555263940810B56A4562355307A719C71584B8D25A65B5ABD50B0454C65A8B062FCA9BD7493A1C301465DD9913B38E38767D2389DAF6F9E71BF33173A04B08425E1179DA7';
wwv_flow_api.g_varchar2_table(59) := '69F95FDC6282FEDA6CB41DE0E57D729FB9A4A62C2E42A52543ADAF0272F8CA3398DBFF838D174318F216D66072F7BA79A75B6D922C059494A4C05C7682B5DC63806553F3EC44AD39B494E23456429E7685FCEA93BA26674F8C97C75D9C33CF549072923E';
wwv_flow_api.g_varchar2_table(60) := 'B8FE51BFE6C1EE587754B6CB1236CE5F6AECF9C462E6A03289459C2C094FD3164291C900D31C2D4270EC9C2ACD8BB53E0B130B2F3E46B0E3EB0ED49489001CE238CDE210657169E55554C94DB198E3DAD387D930FDF2869504BE00661C76CB7C5224C674';
wwv_flow_api.g_varchar2_table(61) := '5746512F79DCC7F6B3675142316A37FEAA20FDD5B020738EB2A97ED706FDAB9D232B67B724AF0C1664E74ED2748094390BD7B0EE4BA487F7AFE4CD3A26E1B0CCD5C391E6B932C93844E1FE6708FD7D93F25C7791A18C75AA2BC09B3EFC025EF73E3C71CC';
wwv_flow_api.g_varchar2_table(62) := 'B4D696B38043F0264B8115BC5A3C6E3746AA7DB7B800F08728A335663151410FDA0F4E1DC243FF31FDE3053EAA4E19CA7D2C80ADF01200112AAB408C7B0E9C3ADE15333637E5E796403B737805B83106939BF8AE3DF203021CCF300DDAC2B6194F94B021';
wwv_flow_api.g_varchar2_table(63) := '0BFA5200ABB73766984B8E1F643C8481B378DB45CC7201C62AD4E9A40F02F2540736315D79D1149FF87BEA952917F832503858936F53668DABD381E2244CFBC54D267C9D37438E3C9FD5C5353954025165DCDB9B593BAA8F3736EDC9BD0463FE967C99F1';
wwv_flow_api.g_varchar2_table(64) := '93024CE3F0B9B733519C2E4B5E016EFCD9043266937793EDA91FC3D21F020C60B9E00792CB41D2DC55F906B7A44D54C1CD5B94450018CD9F4F00967B078AF37C50CC5F78CBCF5D3181C9E3EBCDCAA307B28A8416408ADD0A83BA7E902F4F3AE715207B8C';
wwv_flow_api.g_varchar2_table(65) := '299DF396B31BEA9B868979F5E7853ABBF70AB0C4D37812C808C7995C09934DE6D2098B1A657EC516E7CC281A2496D4B7A4F30CE401A62A2AE3EA50568E017E1E209CA589328A31972E259FDAE5AA2BCB7517ACD085DAC4B994C2BDD0A736F3FB28855346';
wwv_flow_api.g_varchar2_table(66) := '5DEBAEE415E0FC711B7E4431D21596806A85C445076C5E73FDFDDA96744FF9B1007976DD76C7B575D69711988CD77999B3E6CF2A7416A2BE9EC5DAA8CDD7FE63AF0037FF88B5257349D70AA3F67EEDF5858E1BC99B976FB44CA3F9F376DABFCF3C053F0D';
wwv_flow_api.g_varchar2_table(67) := '2F048D9F9AFBB5342B01AF00F78E5E372BAEDE2BE715E0DE7BFCF3BFC77D80CF738CFB00F7015EBA04FA4ED6D265B5584EDF326C89C17B9E7FBED6AFEAB285B2C544D8DDD76B05AA9ED6C9B8E1CEB704F08E6DDB9CC2F10EB1FAE556CE1AEE41BFC03C09';
wwv_flow_api.g_varchar2_table(68) := 'E40CCE646A7219CFCBD4C0494B818E5CBB92C02644FAF2E0A0FA98F7B381AEF4B34A6E4E8892253295447219372B9DD618BC236D3609E2576C607F521CD1BAAED6D05CC0B8BF6F580E492C194A9643C854D2DD91C958C7CDA47A93DF501D689B2536EF34';
wwv_flow_api.g_varchar2_table(69) := '6DF2CB9FFA4C10DAAF95868A2CC6925AAAB9A16E9C1F99339B373D593E8939FCCDE1DFF9D6A37AB05A1937F3A02DC350DB81C9AFDE71B335D19DFC9117EFA026B1D6DBFBE9DC12D08B2CBC0786514E4E8426FCB781CFFDFBB32A552BDB73D7B28C39D491';
wwv_flow_api.g_varchar2_table(70) := '65ACFE82ACDA974CFF1FFD1746BF0B04E2C30000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72358799274797228)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/swf.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D000017C2494441547801ED9D796C5CC77DC77F7B90DC5D1EA2A8FBBE2FEAB0E54BB111DB88D3D429D2A64561094D6D070DD0A2691A1470E11448D3C2325A';
wwv_flow_api.g_varchar2_table(7) := '20402C5B487DC881FF506C5DB6D400857BC08E5BDBB1A538862DC98764499649DDB744513C7697E4EEBE7EBFBFB7B3BB5C714D697748BEA5766CEE7BFBE67833BFCFFC7EF39B99B74F221682E3383E0BC58C68116BD7AEF5A30265DF8E7C2196DC20C245';
wwv_flow_api.g_varchar2_table(8) := '7058F086A77E72873FE97C5B7C4EA39392949F22F36C70524ECA17F207AA2E466A1A5E78F0878F1EDBBE7D7B60F5EA35299F4FB43D9EADFA75542C781D69AF4A9A0BF7F9753F7E00705F88446A1A1D8807D0AF4AEFB90B5AD12A49FA7CB76D796EFD0FD6';
wwv_flow_api.g_varchar2_table(9) := 'AC59D30A4D0E3AB23689DA8F0AC82501DEB163077534F98BF5FF384592CEDABABA70636757771FAEE13A015346E688D37E1670A0B8DC6BB91DC45C67193C67C82FD7A4C93DBA29B369FBE5F1A183A6824127565B577B7F5F22B975E386F57FF6BDBF79E4';
wwv_flow_api.g_varchar2_table(10) := 'A810F263803C0A34B924C0B263874A30D5E7CC8530167577C7F89DD0F167409823A372CFF3BF9BB8FC23D33198EBEEB7FEDF4D5CFE313FAD8937D745DB9F4824BBEA6AC3ABBABAA35B5E7AE18987BEFB573F3A2202C8CE6380EC0E3F991C65765212E0CF';
wwv_flow_api.g_varchar2_table(11) := '962E7508D9EF4FA1AF03B18F5CD536E7AA9F6745A295F4390168B203B8120987EE8A46635B60AE1F7AF0078FB4A2E280EC9435E49200EFDFBF5F65944AF91DBF8BD8B3300B558CC330AC3DAD8E4463F1642412B913C7AD1B9FFFD9C3DFFBFE3F1C6E6E6E';
wwv_flow_api.g_varchar2_table(12) := '660780E3559E9AAC0D2BD4F8C1AE2FA506235469424C95AEB2808395E095781FA7020290BE682C96AC8D84560552812D1B7FFEB30570BC928F3FFE3821978555CA9768491ADCBF30B4BF2C458056101E4716579353DDD15832120EDF1E95D8964DCF3EF5';
wwv_flow_api.g_varchar2_table(13) := 'E70FFFEDDF7F51AE9A5C9206F7075CB6EA0BB0AEF90565368232514D2664479C6D2F3EF3E4426A32670DE5A6C9160197ABFAA635B87F6FCD428E846E83EFF8F2C6A7D72D2E47C81601979F06676A3CB00395860CC72B1C5E190CC8B6ADBF283FC8160197';
wwv_flow_api.g_varchar2_table(14) := '9F06676A5CD881CA6872381CBE3999F4971D648B80FBDBB872F83688069B266434391CAEB9B92F29AFBCB4E18965E562AE2D0286B8321233B2F1F631A3C183573303B9361C59218E7F5BB940B6081852BA0E890D2E53CFA54843E6142AB4AC5C20DB055C';
wwv_flow_api.g_varchar2_table(15) := '661A5C4417CA68B20BD9B76DE3D34F2D77CDF51A4F4EA1EC021EDD1A6CFA430EE4F0B240C07979CBB3EB6F5EB36607E6C96BFCE907074CDA113F5A045CC6740B7BD1850019C8094CA19A1392DAF6E2862757127273F37E9F97205B045C7E4E5686DEC0F3';
wwv_flow_api.g_varchar2_table(16) := 'E04C748113CA2E80DDA7446D24BC5852B2D5407E0C115E816C113034B88C95B800C4C12E6375330B19CDDFBAE5B975B7428553CCE805C8160197B1060F86F1CBE3D390A3894828BC3825FE6D9B9F5D773BE07A02B245C090C28DA7C1063D77A360AEA389';
wwv_flow_api.g_varchar2_table(17) := '7038B42025BEAD5E816C17B0696EB91DAFDFC91AA88519C8914868BEE3F36FD9E8014DAE0026AAE29CAC2F811C4B84C2350B023ED9B6F9B927BF3292E6DA22E032B6CF7634D800574D8EC1BBC606C53C0CC45B5F7CE6893B470AB245C0E5B78C95A9B13D';
wwv_flow_api.g_varchar2_table(18) := '0DCE831C4F8443A139782A71EB8BCFAF1F11C816019BB695CF316373EC6AB011807AD7B1581CDE7568B62F95DABAE9D927EF1A6E4DB60838232ED340CF1F8750834DDB5DC871D5E4D978F474DB2F9F5977CF7042B608B8FCE6C1C3D425799B408C906B6A';
wwv_flow_api.g_varchar2_table(19) := '66FAFDBECDC309D9E2539568C63049CCA847191D5DC83175BC660036213FF4173F7CF49DF4437CDCA4D08511DB6DB20B3863F36C57735494E77AD71893B118A290373DFDC477F13CF6DBFAF0BDAC1D12C87601573478B09E68C6E43E78D733E2F1F89697';
wwv_flow_api.g_varchar2_table(20) := '36AC7FD8E77BE44DFC0E8A79AD43B60B78B0E655E22901AA4110669A90A702F22617B2EF4D3580F821BA4D736DD1C942B5CBD5440FCD3489300B056AB2420E01B2CF496DDAFCCC935F077907701D7C58E362AD20ED986566A233FDB1C0424726BE0026FC';
wwv_flow_api.g_varchar2_table(21) := 'EA4163B2E9063ACBC99C7B1F27ABC9A150CDD4A4DFD9FCD2D3EBEE476A87DB8DDB57AF0EE4E42CFAD42260342EDBBEA22B343219CD0FCBCCD1ADC560FD956AC8904D37D0995B967E5E6D2998A14A1743C2E1C998276FC26FA1BEC9B46B76EC48429B4BE6';
wwv_flow_api.g_varchar2_table(22) := '5372015A71F3916D9FB9E2F9232061E3073F70E6CF9B7D38FAFDF8A521FE7834E7E63B8FE6DCC40D7634E907CA6BE2FC81403CDED31B898427E09751BFDCFAFCCF1532C76278D82549F58676B20835954A0462D1CE38E6A35D057B23455CC83A7D591C0B';
wwv_flow_api.g_varchar2_table(23) := 'FCB27813973EA21E5D81406052A22FF1D4BFFDCB3F1DFEBB7FFED7961D6B56430977240BD66D90881B1A3065E338899A446F4FA0A7378921156F2AE0CF48F5E52C39C77E4224E934113DCD4D677A41EEB5DCCC03E46534D514F7456C15CEF14601FF1254';
wwv_flow_api.g_varchar2_table(24) := '663A625ACC5B14724BB99E738B80D9E8720C3E5F55B0AA0A4295DEDE04E40B61E375056EC0D19C669A662EA48F7AC087391A86BCA0D7321971622EA48F3C30BDB91FCE83C1A0F4259309E04EE4E62CF6DC2260D6B45C83E30403B084D54140EE73215393';
wwv_flow_api.g_varchar2_table(25) := '0D8F42CD32F1E6C874E6DC1CAF23AF8E188E83E70432A588794D46A16206BB6ED7C91AEC6E1E8DA7D2F22F809D806A2833E48BDD3D47AF99B8E13A66FB85FB620CF39A8C6245671170B66AC556C60BF902D0E4EAEA2A774C04D5910B7CDD58E9C1226008';
wwv_flow_api.g_varchar2_table(26) := '6324E551BA2C3225D05CD7780272A64A459F58048C3A8C0E2556615293470364BB804789061B753190FD9CC20CBBB976C7605397628F76018F220D36021DB931D97363B011C9E83B663499AFF31B764D2E4D9E7635789499E85CD1AA265755E109D8F282';
wwv_flow_api.g_varchar2_table(27) := '6C1130ECF32834D10341E64A57B968B245C0A3679A940B35FF5CCD353479A820DB368216014314A35C830D6C037928CCB56D11DA056C2470031CB363B27F88CCB517A7493700D8DC26BA908343E47855A649B9B21EB1F3AC26DB74BCEC8DC415136DA16B';
wwv_flow_api.g_varchar2_table(28) := '2864AC5DFBF1EF08D9F1AEED8DC415C01600B3086C3562176AA8CC75F195AC002E5E7657E574217B6B31A402F82A4CA55DF01AE40AE0D2780E98DB4B902B80074454FA45AF40AE002E9D65C11208990F0DD8F3AE0BDEAA6044057041D1D889205CD7BBB6';
wwv_flow_api.g_varchar2_table(29) := '3585BABE7A55005F9FBC8A4AED6A32A750C30FB902B82864D79F69A434B902F8FA59159D632434B902B8685CC565A426D7E88AD7F098EB0AE0E2389594CB853C3CDE75057049A88ACFCC87050A4FA12ABB49C54BD643390B43E66E5265C3DF43A88AAF4A';
wwv_flow_api.g_varchar2_table(30) := '61C8950DFFE2A5EAB19CFD20B36EBA1D5CD1608F612AAD3A59C8A06BF1E1FA8A93551A17ABB9B39089C58E89B6F80B7F7B8F9958955A99156656BC12093BBA6711B03DD7BECC98D8AD2ECCB31FEF0B0907ED00B6538ADD26DED8A5A921742C1968BCD4A5';
wwv_flow_api.g_varchar2_table(31) := '6CA449C7431B9F3714E03A6D075F43A421FD9DE7BCD22F4E13E47F207FBA68A665C894E57EC52762DC8232573227CCCC60EEEF7E2BF1D36769165C268029705FC0ED8BEE63A9AE50713523582795D44756FDC1ECFB35184FFCA924DF23960691277A9F3F';
wwv_flow_api.g_varchar2_table(32) := '20015F40D365D2A3AC5C4F9669F89A255E734BC9BB3FAEA798C783C1BB1A4CCDC0C23CC7A364A24F7A635D784FD9C0422480EA9AB0328C452FF7834530D5A10800F1DD9EF9907DD2D71397446F3CDD5118EFD3B2FCE8500A159D8BF17D4C63F2BBC93238';
wwv_flow_api.g_varchar2_table(33) := '03C16A0956D5207D9E75C9A418B9136F02065C42739C9444BBDBA5AABA469A26CE90FA314D52138EE065617C219C48A2AF47E2B16EE9EAB82C5D572E215D581A274C8134A1B929FC0373E820A96402716DAA61F900D86122F58D12AE6D40792E7CA68976';
wwv_flow_api.g_varchar2_table(34) := '5D71C1277AA52F1ED534E326CF94DAFA312E7CD48D1ACBCE11EDEE94CEF68BD28B74203C72240BDCD922604B8D4BC34D26FBA0B9BD326BE14D3267E172699A30596A42610950B3B050CF904AA6042F8503E83EF97CFF1E39FAF9C772D3AAFB64DCC4C9D2';
wwv_flow_api.g_varchar2_table(35) := '0BE1332D41EF79EF4D397260B754876BD5CC123C5E5F2841749C95777D43A6CE98ABE9D991BA3BDBE5C3775F979317F64943D36459B4E22B327DF602A96F6CD28EC6698C31D7BC7712E6BFABA35DF6EDDE29275B3F43078868C72C20EF61BF6C11B0AB01';
wwv_flow_api.g_varchar2_table(36) := 'A5B6C0681DC12C5FF57BB264C5ED12A9AB57EB98C2350DA62F69ED1D083524D3BAE6CBA7EFBF211DED9764F6BC4592ACAD57B855D5D5E820CBE444CB3E49C1D407AAAAB5086AFFD4D98B65E69C85128AD4A233D50260B55C387B52CE9D6A91B113A6C9ED';
wwv_flow_api.g_varchar2_table(37) := 'F7FE21E0CE87F985C548D119C3FD73B434E860CB2F10905AD4EFD4B1C972F4D05E1D0E8C252F551636F27B6F9A0401F6F674CB82E5AB64F9AD77016E034C618FF4F5F5D2F2223880817F731BDAA32E0FD213BCFE419B0E7EF45B397FF6949AD09E9E98F4';
wwv_flow_api.g_varchar2_table(38) := 'C4633271CA7499346D2ECAE851EDE3981E04E899F39768E7A09925BCB68BE765DF87EFEA987BDB3DDF92390B9AE10604509F1EB51434DFEC7849580C3A6EC6AC9B7BE70F013600955A86450D2EB12A30CD746C7A3096D5374E94794B6E52931C8FC5606A';
wwv_flow_api.g_varchar2_table(39) := '5D2FF6C2995372F2E8618945BBF401B61A384F63C68E93A933E72AFB705DA3B49D3F21A78FB7CAD87113A40A1029FC70A40E309BE5F4B1830A9E80C74F992553A6CF51B0AED9F7CBD95347E564CBC7B268E5BD320D652639CEA26371CC4F20CFF1D64372';
wwv_flow_api.g_varchar2_table(40) := 'FECC091D1202B8168E4464C2E419D2347EA2D65D81DB3164250A339BDD3B8059276848A22F0EF33845EAE0D0504BA8B414F0B9D3C765E7AF7F2597CF9F5461D2C9A17651D013A7CD53884178B37E7F508E1CFA48A6CF5920639B2640F3E2AA695366CC51';
wwv_flow_api.g_varchar2_table(41) := '47ADEDDC09BDCFCC794BA5AE610CBCE35EED081C475B0E7CA41EFBA469B3B45CDE9F9D8B56E3F0FEBDB2FBDDFF56C74E4D89FA0A587182833669C63C385971CF8DBF14A97700032E48002826F9D521D5507C5559D2A9EAEAEC908B678E40A08DF0A4EBD4';
wwv_flow_api.g_varchar2_table(42) := '44A76056A98D678E1F52872A581542FC18B970FA889C3C7258C6C0316227A0F6D53734428B97CA996307A0BD73D101E6EBB8EE9A550763688B9C3D76081EF3B8F4FDD1D912F4E6E189C30A5C3A7F4AA29D6DD2387E7AE61ABDF05E0C0347D1A1AA304DE2';
wwv_flow_api.g_varchar2_table(43) := '74490BA5643D12BC33069326C738FC978059A4B92373068EB993A7CF84D3F50D9CF740D0973363223B4338D2A0F3508EA30466B4B8E3CA65081D9E34CA22683A4CB5F54D326DF642691C3B5EC1D33A745E69975668AFF62700E5F4C7BDBF3BE6D2842F5E';
wwv_flow_api.g_varchar2_table(44) := '71874C9FB71C5E769BF4606A46B82CB33A542BA170BD9E7B0D2E65E719C03A740104B5E04ADB79CC2FBBA029308F88E054240CADBDE5AEAFCB57BFF91D99326B11B42A217138479CEE1818844BD34D0D572DC6784DA788531B4E691A308F9EDB7CAB4C9B';
wwv_flow_api.g_varchar2_table(45) := '355F81303DF3AAF69EF85CB59FDE75DBC5B3809FD034EC342C73021CB5BBEF5F2DB7DCFD2D6940E7E0BC378EC5175A100DA637BADF3CF36917B0522AAE6D060E579DDA2F9E8643038708508298BA100205C979EA7C385FF7FCC103F8FB8ECC59728B9AF0';
wwv_flow_api.g_varchar2_table(46) := 'DE38342A7D5B039B5A4CADECC4D84A0DA499E59466DE929B754E4D80D46E2E92B41CD883DC9CDF72152BA2F3D90BF0C4194F2D655E5A9131639BE4A63BEE91AFFDD18372C77D7F02E8B33086C7745CD6B971714D1FD25C76C7E0B4492DA5C61C838330BB';
wwv_flow_api.g_varchar2_table(47) := '07F6EC94081C98F94B56E0B73D35AA813A3D028410163C66638A33158ED3A905CB30B57907E3F3315DC860155C2DAE8516B7C2EBFE0273E9DB008FCF21A7641C164CD809701B9DDB32FEDCC9167596D889B8F811EBEE90BDEFFD2F60D7C04B9EA680E970';
wwv_flow_api.g_varchar2_table(48) := 'F5617A446B30A6719CFECD9CBB485A0E7E82BABE9B5E2809E93D4A69BFEDBC9ED160D3308E6DF486390E7FF0F6ABB2F7776F497BDB054443BBA0CDAED394D0392D3DE8B98B96CA577FFF4F75D1A21763239D220DE8089C76B57CB6070EDA156823BDE16C';
wwv_flow_api.g_varchar2_table(49) := 'A077DC09EDFD02F12CD368204D7A4D0826FED41179F7F55FC9E1CF3EC6981B556F9AD32E064E9DE8B8D1D3BFE9F6BB65D57D7F8C61A1D6D564DE9F1DC823C12E600B1A0C49AB03C38508FAD41FBFF786BCF55FDBE4D3DDBBE4C2B9D3D0A684AE3811084D';
wwv_flow_api.g_varchar2_table(50) := '381721B88CB9F2CEFBA40E9AD507AF9690098A0E103D6F6A29BF1B8F985A48B37BA2F573D572F5CAD1B14CA0A6F35A077C815DAF6F979D6FFC877C71E0133863975583B9B2C540D02C67CEC2A5B2ECB67BB53EBC0F1299A246FCE89D9AE48A4205E453AD';
wwv_flow_api.g_varchar2_table(51) := 'E13CF34ADB39F9F037AFCA5BAF6E96DDBBFE4F2E9D3BA382F6410B696EA94D4D1326C9ACF9CB5CC0B4BF081C537D188B335A9C163C35B60B9E73CB81BDD072C0CAEB98AE36730934ACDEF9F12F3E959DAFBD2C6FFFCF2B72E0E30F60C2BBD2E3339C37DC';
wwv_flow_api.g_varchar2_table(52) := '9BF7E1BCBB69D20C2CD474AB45D06120B74D23746E11709E948A6E103C61088DDE2CE8A8E9A4E315A91F2B3198E04F7EF7BABCF3DA763973F218B61201107FBA2001733D669CBBA2C43198D428645A828ECBF0CABB3A495CD3E3A0BB509D972F687C3E8C';
wwv_flow_api.g_varchar2_table(53) := '3E2CB6D073A7C6D3318B606E5D0DB37DE9EC71F9EDAF5F910F77BE81F23A1424CBA4167323A4A171BC38C84713CD7A792158046C67DC219C10B43684E5C558D76598606CC3A94F04E70AE3DC9871D3E43C36030E7EF2BE42A0B965020A94735AD799729D';
wwv_flow_api.g_varchar2_table(54) := '281531844D8F5A43BA8A7A407AC2235C83C280AE6F18476ED2DDD1A6DE33E7E6BAA930669C84EBC6CAC1BDBFC1D4AA552D8C5B2ECB80C581D7CD8CE9DBB8F71CE14FBB5E74898DA1E98C473B64EAAC8532BF79A59CC23CB615DB7CF1E815D5120A51C747';
wwv_flow_api.g_varchar2_table(55) := '8CADE3274D5733ED42E1B89D524F36E540F3A0F9D422A5843A994D89FCEA69929C8BEC241CC39B6FB91BDAD824873EFD403B933E6CA09D88261963FEC499D89B1EAB75319D8BF5EAC59C9CF765397ACF4CD7C9B9C9309F7A07701A883A4310D09419B375';
wwv_flow_api.g_varchar2_table(56) := '13813B3E97B1CBD3894D7B33171E3F79BA4C9F354F01A6303FA519E614E6129C30E6779DA8ACD3A432BD06B52218DE830F15CC5BBC42264E9D81EDC353D27E890B2FDC717260AEEB51AF793A7D4AC01CB3DAEC985C98B972E99CF0912142E7FF1EE0EBA1';
wwv_flow_api.g_varchar2_table(57) := 'B5E874CF362696C0B8CFCA9D226E1498E54B0AB30A5E2CFEE12A85C1A950B02A28A78EB7E89E6F754DAD8248179773804E8186F9533239B13C552630F99C6F73E5AB0E4F7B702A949CBB50AF319EC300174E184F2F9E73653A79470FEF07E033988B739D';
wwv_flow_api.g_varchar2_table(58) := '1C9D0B9DC50BC1AE0653022506D7B4519041BC1E101B057D5C32E48B4C42AE4600129D1A6A1BBD5C6A2CA7417B76BDA16BC47C6A83D74C3055E2F8C88E41ADE27C9673680613CF7322A1A9E5FD38156227222C76A240DADBE6C63FFD04CEA3F98000F79B';
wwv_flow_api.g_varchar2_table(59) := '3FDFB717FBD0BB9007CF65E13F96313A0197D269018C8B1C9CBBB65D380D27EA43D5DC089CADEA5008F2CAFA83D442EEE274755CC1DE6F0B162B764B148B16CC9B0B57A151934091D3A27678E3D436C2EBC29C9611EE78C9942E6CAEA21D6FF94CCD74D3';
wwv_flow_api.g_varchar2_table(60) := 'F849D8C8A8D5F42E7E371DA1F359B0CB6D17E5D8E17D72FCF0A7DA51B840C33678052E6BEB290D26386A4A3CDA297B77BD2607E14DD763EAC1B930972BE9C9527BF561373C18D78187DD625DEDAA610A979A9313581E9FCAA44671E951174F708D5069F2';
wwv_flow_api.g_varchar2_table(61) := '19189F31D78823A4F3D86EBC70FAA8D4C16BAE6BC0837E804CED6727A3F9E643095CC3E6348B5E7E15E7CBA8B7762E76280F05BB80AD34CCDDDAF3E1DF8824686E0D1A936C8A577030A35CA42058B37265E2FB1DD302EF6CBFA0A6356D88D531A2491D48';
wwv_flow_api.g_varchar2_table(62) := 'DB08995ACAF933373EB40364C0D1A8C31063F8A0990F61AB92C185ABA7563EECFCF4CCB6065BECBC74A60235D00A1A3FFDDF3D72A0E438C7FFF503DA996F960792301FA97561BA80084DC7CA8112E35A001AEB2E97A6EF8FF40C2E67DE9F15401966BCD7';
wwv_flow_api.g_varchar2_table(63) := 'FA68122B1FAE87507A517635D89541E9B54209D452FCEBDC38CB951CCE55DE30C5BC17859ED1AC2FBFADC2BC8EFA712CE5F24536B8E7AC57BA12EEB15F9A6C6AAF9CD9059C2B0F2B2DCC2F308FD035C22DAE2A83DC5B0BCD4F53DC9D863257D635B57197';
wwv_flow_api.g_varchar2_table(64) := '3CF9DB28B252466912B00BD8FB1DBA346995616EBB80CB5000A3BDCA15C0A39C7005B02701DB7366EC02B6572F4F8A7D582AA532B4E7CC940478FFFEFD5A1377D5C5D77FDA382CD2188537518966DFD161645C6C4B4B02BC74E952ED6F7E7F0AD5727CE9';
wwv_flow_api.g_varchar2_table(65) := 'C59E62EB52C94709A4ADA02B531123E3628553D24247735A835329BF8335072E3DB186FA516C856EF07C5828831805BA9282454430322E562E2569B0AC5EADF7F557F95A01F8506D2DD67BF1DCB9FBE7E3A668E5EF9A65E0CA8D32A42C2953156E5AC67A';
wwv_flow_api.g_varchar2_table(66) := '5EC44749A3397A1B76DEDC9EF6FCBA1F3FE0737C2FD4466A1AA9C3DC92AB846B9700359722EB8EC6AF383EF9CBEF3FFAD37F67EE5C195F7B69D9942553C8ADC086A77E72873FE97C1B16A6119B3C29ECE855C23548801B52D86AC6C6B5AF1D48FFF3AF7F';
wwv_flow_api.g_varchar2_table(67) := 'F4D3F7992D57B6D750CCD025614586AEF41BB3645B32FD7F4839F472DD6C3C8E0000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72359255111797231)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/sys.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D000016E9494441547801ED5DDB8F1BD77D3E33C3EB92DC5DC9726CC99675A96CD99210D76D9DC44E5D3B7502344511B4452420681FFBD4A706410B1428E0';
wwv_flow_api.g_varchar2_table(7) := '0D8ADA8E85A67F40F3503495EC7A8B3EA44051A00DECB6B0E324461D295E454A2C692DF912C9DAD5DEB85C5E66A6DF770ECFCE90CB9548CE59CE70C523913373E65C7FDFEF767E67382B8481E4FBC232D04CAC4D4CF953F67698473B112303E3FBBE85E4';
wwv_flow_api.g_varchar2_table(8) := 'B3E1372F7CFD33BE6B7D053993B8F42237DE3E5A93D796F030F69C63656E4C648A7F7FE4E05FBDEFFBAF3A429CF02C4BC8F998EC2EAEB652513A0E83FBC6F96F7CD5F7C4774A93B909B6B901DC0D19CD9EDB49192EC77BBCEE54A63D8FCDB5D7D579E1B2';
wwv_flow_api.g_varchar2_table(9) := '2DEDE1869F115E2DFDEB67664FFEA9659DB8FCDA6B5329DF9F72B70BC86192901C3D25DF3FEE58D6B4FBF6B93FDB5DB59CFF9CDC39767461AE5CF72D615BA036E9AAE9B97947BA14BB56E73E8EAABE3E06D8E9D2BA64FB9DCDEB0635D519D48EEF7BE954';
wwv_flow_api.g_varchar2_table(10) := 'AE3259D859AAD5DCB752C2FBDA2307FE7296203FF3CCF600D9EE09D1B6C2D3D32A63D5130781C9E1A5858A50E00AB4EB0364BFE5C8BC8D1F5556E5EB7AEDC7A05E6B9BBDD4D565C97C3C27EFF9D060BEA8D51B2B9393F9CF358475EAFCECC9035FF8C254';
wwv_flow_api.g_varchar2_table(11) := 'E3F5D7A79CED609339D1BED3F1E347290CA09863F9F88744C903E186E1D31CAAB01C2A8CC5C58A5F1ACF3D59F71BDB0AE448004F4FCF48CDEB3836049708F7CD2BF155F428C3021EB46F2D2DADB9A5F1FC1375DF3D3D73F585439464215E95F7E21B60B4';
wwv_flow_api.g_varchar2_table(12) := '9E2301AC25984380ED53AE74B4F10CA436546F90400130A66F2BAF41823C3E91FF9CD7B04EBF73F1AF1F84E3E5BEFEFA37A1AEC1C3439822011C9EAF54CEE18C049FB76B1A696B013A3435ED33D53525F9F1949D3E1548F2F4504AB23180C34291606C3B';
wwv_flow_api.g_varchar2_table(13) := '0E8D124C970BFF390D09F2D21241CE3D1E96642108328B0D4F3206F050CDBA0D9F0EA03541864D2EE528C9AF9CBDFCFCC354D7C366938D01CCF5E7B02629C11B07AF405EA6E395FB352CED5F0E401E1E756D0C60DAE06149EDACD84182F55402491ECFFD';
wwv_flow_api.g_varchar2_table(14) := 'AA259CA103D918C0ED44D3144AE2B18515B14CDA4482F5D025C8CB5842154B59806CBF32F3FEF347A8AEA7A54D4EB6776D0C60E59F689A0CD1B13B0AB094B5A2D4F5A3AE6BFDF3B92B278F9D180290BB9B5E5778B5C8455735622BD49FBA912033188275';
wwv_flow_api.g_varchar2_table(15) := 'F231D7F35E3EF3DEDF34413E91D8259441806383ABF78EFBE7C5C02697B2C72CDB7EF9CC15823CED4E4F2713646300F74FB3DEF1895CA33F09D6DD06208FE78F59AEF3CABB975E7CF4C40905F2D4D494319AEA0EA31C1335982813E9A96E1B37DEC28BDE';
wwv_flow_api.g_varchar2_table(16) := 'AC59826CAFACAC35C6C7734711A47DE527B32F3C46908F1C99B19204B23180A309C566741C40FEEDBDE8CD06C1F897B3BCB8D64058F361DB17A767120872A4273AC2336F138AF0ADE49D931BF580A3B13897FFCE124086E3F530C29BA7CFCCBEF4478FEE';
wwv_flow_api.g_varchar2_table(17) := 'FF8BFFF3FDA36879CA86348385E24BD1A6171AF75045B234B81C7F14F22BB5C56D70053224D9F1BD97DFBDF8C2E39635E53DF71C208ED9261B0338108910EA093D85CD0D52140A048CB20E72713CF71036C64F2705E428D30B8834646790B896D48793D5';
wwv_flow_api.g_varchar2_table(18) := '52BF79B10E72692277087B52A79200B23180DB68D6890089CDBB4DA8B29771AF835C28E51EA4249FB9FCFC67E354D7C600EE850A492B6B4882F5B424C8885D37A0AE0FD9DC859A7DFE89B8403606F05039591A8AE6D1A004EB9603904BB9037820E8F4D9';
wwv_flow_api.g_varchar2_table(19) := 'D993B1806C0CE06DBA5DA801EBE7B80E321E1AD82FF020DF4FDF7BF1C9414BB23180C38E693FD418649D167FA1FF40473743962033E24590F174F1E9994B2F3D45905999BF87EAA69128650C76304C108748669002A156C3A732E2B5029B5C2865F77996';
wwv_flow_api.g_varchar2_table(20) := '7FEAECA5177F4B0640BE894DD62D06D9E0F45AE4223CC1E49D0F9E1765C44B3A5EC5EC5E88F53FCD5C79E92915E57A0E4FE46E9D241B0B5512C5C1D3AD4FDE898717954D5EA6BACEEE85DA3E75EECA8B7F8CCCFF01C29064AC9C9BAABBCF5975AC664C82';
wwv_flow_api.g_varchar2_table(21) := '49B378E8D6715E49CD6C825C6D148AB9BDAE2737287E1B99908DA92D916463000F91FCC60DBE04B9BC52AD170BB9FBF08389EF62170A2053019A57D7C6001EB2E7C15B40361CE868697B930B283B2B05355D2F14B37B40BBEF9EB9F8AD67B742928D013C';
wwv_flow_api.g_varchar2_table(22) := 'CCEA1963A719948907F9C117F3D63FCC0F5FB79FEBFBFA18BEDFCC03A8B21BF9C51FDA0A915A59AED60B85EC1EC7F1FFF1A7EF7FEB4B9464DAE2575F3D8EB70D444FC6001ECA4816406826AA4DA2CC83F42578D2F2617E7B5EF85ADFD7C70EF7D0836A1F';
wwv_flow_api.g_varchar2_table(23) := 'F79A89DE757A198E176CF21EDFF54ECD5C7EE177788F4F8798D86A3406B0228B1E77C28F1A58FA36E04C3C3C87F7726053D7B13DDBB2F1CBF5017E6CF4653BCEEA4AB5363E3E763706F30FE7AF7E5B82CC6514A43D60873EC86A7499D447FFF15401C9A8';
wwv_flow_api.g_varchar2_table(24) := '2609AAEB379C15889027FC95780613F4BAB4B2BCE2A49C7BEAB5C6B7BFFFF69FFFE2D9DF3879717AFA3884701ABF89EA2F190338129BF537F648B5D47861F0FC4676CDAD3AAB65D7F73C0A32EF50C4C3C770579DEE75CA0BD7D1E79B956BE6FB220D85E2';
wwv_flow_api.g_varchar2_table(25) := '42833C02EEBB1FB52EAADF6037DF95A19BE9E1680CE01EFA4C4651E0D794622B9B4BA72DCB16ABAB0DE17BD08912640E53B141EB80759E3E86CB85F35A6BA92B7D5F1F751975CDF164D22951AFB90DD1F0F17681E8C918C0C3E864114712D583A54B676C';
wwv_flow_api.g_varchar2_table(26) := '31265262B55C5720F3C1580A1613E9DFE19C590A1A16EA2D6DA8AB1A8212F1E93DC3F552EDE9D764F4D67A50DA9893354CDB85C1F441494558AE5F2C806CE5C728CC960542D305531FDCEB748E7682FC1ECF37D46DF6213926C435E1D76484C7DDEDB931';
wwv_flow_api.g_varchar2_table(27) := '80C991C39E28CDE9AC2D00B2E03B3BD617C7839E9841621A0338D06183A686E1FE9202B2A169190438A4570C0D2EB66634C8859824D920290D02BC6D6458F11540CEC0F1CAC705B221EE36063099CE20E3199A5EB466E4B265C8413606F03693DF75CE18';
wwv_flow_api.g_varchar2_table(28) := '76908D010C2F7F9D28DBED44833C26D5B51D9F77DD07618D01BC7DE15554954B2806430A292CA10032225EC3908C013C8C91AC5E016A01D9D9424936C83BC600DE7E2E5667F809722A2CC9CC309D0CAA4383009B9E6582DB03A632765D84BADE4A493640';
wwv_flow_api.g_varchar2_table(29) := '0263001B643A03D3DAFA26A424A79B3639C1201B0378EB499AC01EA8AE09F2587225D918C0778293D591C54236198FFC246E09650CE061DD2EEC085AAF99B4C990E43C96504903D918C0BDD264BB95974BA804823C02D820A72511646300434B8D122890';
wwv_flow_api.g_varchar2_table(30) := '34908D017CA72D936EC5CD4902D918C0B79AF09D784F83CCD8759C8ED708E02DE43E82CC75729CDEF508E02D04984D6B49E693215D4BB241876604F016031C806CC9C77FBA02D9A04333027800008741E6430312E401ED271B03F88E0D55F6C0201E5E9E';
wwv_flow_api.g_varchar2_table(31) := '944A5B78680020A706F3D0803180EFE850659720EB9FCA0C126463007739C751315080DA7950208F008E81E5E843B5808CA5147F26B3EE5B25D18B3638A618483EF82E37800C9B4CD025C8EB48471F9731093638A6E8B31A921624C874BC52CAF1E2918E';
wwv_flow_api.g_varchar2_table(32) := '98C9640CE09104F707CBBAE305700BF0AE699B4D3E926BEC07E02309EE0F605D8B112F87929C4A0BB7E109B76A46648C01AC073A3AF64F0115BB46C4AB98168D8C195D3D02B87F3CB6A4A69464076F70C837DFE110B117633638E23846D59B14A0A923C8';
wwv_flow_api.g_varchar2_table(33) := 'A652822438EAAC3A79019BB5D9A96C98A49BD50B97E1F9EDDA692FDFDDB5C9568D01DC2D49369BA27AAD4CFF53F305DF3A44BB15B4D1A94D5F96B9DD7BC55268E576CA8DD177F6C70F671FF48B8BC4246300479B1EE0F11641943A3E246CB7ECC25E1571';
wwv_flow_api.g_varchar2_table(34) := '6DAB8037E6703A2438224338BADE028E8D26582C87689195C79BB773CD7A3874481E5E7AE7FB55DCD96C2CEC170FBB5B19B4870FFEF9E2764CD3A1A301641903B8DFB1520E282DB9F40320581657AD5278EB76555DDFF744DD9B4790600D0477641BAACD';
wwv_flow_api.g_varchar2_table(35) := '7D2D6D128886BB08665A46B9CE12CAF1649CDDC2B1C73A8F05069263F4FC3530D0223EF318227687EC6273A8BD8CFFD6B33371374680295129484A19C49910F78E7F5914B2F781606BD07621E22B01DD305729BB00D6B6B06EF4AAE2C385FF10CBD51F89';
wwv_flow_api.g_varchar2_table(36) := '8CBD5BD4DD4F44217354EC99FC5D91764A00A386FAF81355764A2C55DE131F2D4E4B4786CC10680BB688375602B85DC5A7C5E4D861B4CB7ACCD78983610D408C71D6DD6551A95F439B6745A5312B1C6B0C7739F6E4801C23C0249D844912259D1A17D9F4';
wwv_flow_api.g_varchar2_table(37) := '4EE1BA9536E90A131845656A129A00DB19C914947E81B7FFF18E0F555FCA1D16C51C5FF7C8F75D29F54966B0F287C45CF93EB1569FC59D822C2D9B6C9E511BA49D716894BB24E3040087C7A17AE1BD097118CC70445C5FFA5FB150F901182E8F963653ED';
wwv_flow_api.g_varchar2_table(38) := 'BAA7C11D6305B87D9AB464E12455A1D7FACA464A9D2D254F976C125BBE732E05C9AA00A07BA00DF601580FEA186A5B5052619301BC63E745297B58546A3F073E045833993AE37B2A29F1ACE74909663F60C5669F12666818B64DC6A1AA1FCBEC16BB279E';
wwv_flow_api.g_varchar2_table(39) := '95AA7F79ED27E8631275926193630498705295D16636C4CADA65486F19AFF7AD4940F0165891720A9278812AB520793744B53E2709CEFA361C2BAA52DA561B2A920E5229F35948E02EC92EB4C57480A82D081ECB17B30721C5250054475E2B09A87E2981';
wwv_flow_api.g_varchar2_table(40) := 'B24F8067637C756F45CC2F9F413FD02E765AE452778BF1DC41C92C1EDA68B8ABD03E3BC464FED3A25C3D176A97F38B37B5CE2EC25814617A6D8000652441AE2FFFFB7A652E6FEADE3510F109F1C0CE3F142910D5F3EA50C769B158B920AE2DFD2B885B42';
wwv_flow_api.g_varchar2_table(41) := '796DEF581560404DC3DD028087C01C792961404AAC563F90A0A49C22E0F3453EF329914F1F142BD577613727503790362A0299186DE007EFE3A05F3057FE6F516D5C6DF6EB895D852F8B7B279F960C4246E17E6E367D37EEEF8024DFC068C6256329BDD0';
wwv_flow_api.g_varchar2_table(42) := '6C338643C89B89D6BBB2A7FDB741754769901F80E461994235488BDA92904715EAD1DEEAF2389290AEB70A0FF87EA8E7FB71A5A6464DB0B87A4ED4E010512AD94FCA19837D3E8C3A54FFADEDB75EB167E650F20B006F020C3189BE5DB1B8F60E34C94DE4';
wwv_flow_api.g_varchar2_table(43) := '5303E93278339E64D8F8259723673206B06AAEFF6FAE279DE61AD5C13AD5B18A523A0209504E0E41726C101B65B89EA553C38F52C555807B4864533B240390F8B5C692585A3B039BFB4B94A159504BAB62761F80DE85725CEF060E5470D63A17DA5ADA72';
wwv_flow_api.g_varchar2_table(44) := 'F62FD7BF3C9745821A94742E9F94DADFC82AAD2D0EE62A3100534DAA68148E90107AC2D8180D5141118C00499528CBEB3A94EAAA640ADA57C7CEC93608DC6AED23A8D60F44B9F63ECAD0BED3ABF6A4975CC83C88BC32FA08C8B0111602082BEEC13FC0BA';
wwv_flow_api.g_varchar2_table(45) := 'B7EECEA10EEC7CEE98F2FA9B3E03CB546A1F433DC33F10E85FFA1701F8A1890CF4D4A00D8E3A6E4D0CA5EEA4547137BC636ACDA764B9FE121CB287A453466253E20868B93A2B5BA800E06A6351024B06221314B30FC2A6FF10F715236D049755D996837A';
wwv_flow_api.g_varchar2_table(46) := 'FBA48A4EC10BA78DBFABF89894541F5E7ECAC901DC6B5826BD03E6C1DFA8B3E9B553FDB78E93AD0D3A190338AEA928B54B80BCA67A9EE41FDA8034A71084F8045EF7871298867753AAE93C1C21DA797AD3B4D5991403237328CF25535863E0120C466648';
wwv_flow_api.g_varchar2_table(47) := 'C3A17B60E7EF036AFE81419808AEB99114A364A467FFF1E2F7A12DDE435F74FEE8B4C545118E2C48816E0AF286ECCC01606BF0B47740B2F60313ECA34AD56E61E9750520FF1C403464746BA9721E6AB68A326A1D4B5B5DC81C46FD55CC99CBA9B6243394';
wwv_flow_api.g_varchar2_table(48) := '04A7E18167F0914E1418816037B06CFA64F9C76276EE34ECFCDB00974CC2B4A125951DC3B73180E39B12031315A8D00358FEDC0BD2427A207994D29A3B8FA0C7DD52BDE652FB0108E3D0AB902DAA6FAAE92C6CE9AF0034DA4C6E4A6C2675B4C155D45165';
wwv_flow_api.g_varchar2_table(49) := '9477AFA47BB5368B65D8BB684345B092627B352F0DB98AA6578C60056C7031770812C6B87300C2CEC26308231E93806AA972B88CC13F758DC7631085CAA61E809ABD02C0F58681260F152D021DEE8AB8B1F2635967C7D8A7452E03358F7579263529EEDF';
wwv_flow_api.g_varchar2_table(50) := 'F17B12DCB9F27FA1FE784B5F412BF19D1903388E2990F81EBCDB0C4293C5EC03188252BD8C58510D339AD52E956400656B9504665313A8FB1054F92F905F42F9700223A01D1726607EF50D30C1CFE08D3F2BF6EEF803B4AD62D5DC75BA67FC37E1C05D43';
wwv_flow_api.g_varchar2_table(51) := 'E0E42C4CC54EC974648D2424632A3A9EC950166B9042A867384F747A5462548B9BF69453652F95EAA493C47C78B9B8C9E8346D6A317B00C020F2C43531006D4D94760BF727A1EEF74B10AF2FBF294D00D7BB5CFB6660CB3F557A1ADEF40E30034D00E526';
wwv_flow_api.g_varchar2_table(52) := '3EA3151EBF31091EFC74D432C882474B3BCA4D04DA4902E802A885D5CBB0B765C834B624D789CD51FA50E7FBA47453CDF20FE3E433F7E09AE0695B1A269192443A6A3C63346BA1F216FA3C24768C1D455F2A0257CAED173BC79E12D797BF873F86482F9B';
wwv_flow_api.g_varchar2_table(53) := '8C3278AA8447CE7363002B32B437BF55D72A1AE5892AECE77D58EEEC951D11480B7BBE6B6B1FC83DDF5AE3630988DA5450EA9B418ADD135FC3E719804B67CC95B69B6BE295EA19B4B3092898201D38077F3EAB814DFE1B2B6FC003DF03E99DC07515129E';
wwv_flow_api.g_varchar2_table(54) := '936BE372F522D4F84C625475BB3EDA2A44FA6C57491C74A722BC3ED2D652F542AAC6A09E556892CE165170E1D57E24779752F0A0653813CB17EE34D109B211022D572FC3712AA334B50024136BDBB1CC5E090A974C8A59759F5C1BE39C97F28B810CB671';
wwv_flow_api.g_varchar2_table(55) := '4ECC97CFCA3CDA7BAA6A8E6357F1F3B83F06C966842C7E559D5C802598B4A5FCD336191CF1C16E92B26F0406A1490036913F0ADB47EF17CA189B08DC3A645892CB1E5B64904F0BCA69127E6E0366E12C7D80CF3C00651C1B6D42AD1711F428641E81D3C6';
wwv_flow_api.g_varchar2_table(56) := '4D09B569A0FA64DF585B43DA99C8581C03EDF8FCEA9B90FA0F1108195365D0FE8EC211EC347D51329F0A78C44B62632A5ACEDED817830BD8BC87F7BAD6B821525E4E4A1AED6BF03C5503AA750F088B88153612086C0AEBDA55840C2B58F204CF77510209';
wwv_flow_api.g_varchar2_table(57) := '8EB2C4D231F2971198B800F5CA6515259FC0DB90C09D38E6B17EBE897EAFCB36096EB53107C0E8C0112C8A329F24296023E39750D53F00A3F1E13BEC2A216CE9206CC90859B6B21BED5CC738F8188F147F1C079F120830D7B6903EAB84EDB80FC5D5F969';
wwv_flow_api.g_varchar2_table(58) := '0980B4AF386B60F3DD127462B002F696C4470BFF863345402E8FB829EF420AD593930445499E0659AA7104366EAEBE8548D7CFE47D29950088CF59A5ECBB00DA6BE266F9876895D2AAC6E3B25F6891002C7AE445B1BC7616DAE0AABCA70220147646D7B8';
wwv_flow_api.g_varchar2_table(59) := 'B1C1F26DE14FE40C321903D8348F52A2A886AB50A71A4012866A935248C0F8784E05D2C6A46594F7E4F35932B7F317412398153C05C214D4A56ACEC23ECF8B9A7F0DF904978029D52E9943D6E017B58CF205AAF58F43CC206BA09D9CBCBF5E3CA6136300';
wwv_flow_api.g_varchar2_table(60) := '6B3931390F45D8F6E852D3E94147BCCF7D630591EE9904BEBDD4901118D56A4DAA6D29FD32F41880DFB94DE5CD5B1B2260DD8DA1B5EFADB932067058CACC0E55072F366BF5F66076AE4910366B3B6893A56E9D6ED5CEAD6B0EE2AE3117AF557D0D62E8A3';
wwv_flow_api.g_varchar2_table(61) := '3EBAA1803180C9C7B7E7F66E86342A639202C600A60DDE0A3B6C72B277625BC6001E496F32D9C718C02305BDCD011E3959DB1C602E93466A3A3AC8A69DD5482A7A7A7A66DDAF8204FBEB17D1E779C7B6A06818884A98C6FD102512C0C78F1F9523715D0F';
wwv_flow_api.g_varchar2_table(62) := 'DBE6BE253780FA19C5A8CE3A05140D1153074D99A969BC5EA0C79348912CCD5DD834F71DFCE343DFF847490E58B0C70125B738E9DDEFB4BAAB8BD6250D292D78524476A669DC2F5D22017CFCB8EA76CC1697AA96B8303E993FBA3057F688B076BA384A3D';
wwv_flow_api.g_varchar2_table(63) := 'BDF0B1DF016F56AFBD9FCDCAE9FC5ECBAB7A9C41BFA973DD601C886B63FB0A347416E6572F6067F2127BD23436DB6B97AD81DDB043876121BD71FE1B5F05837FA73491E3EF315B831E1A59DEE894F4DC83D9B67205EB84EF85DB885A57B7ABDB94B3C185';
wwv_flow_api.g_varchar2_table(64) := '1E73FB91E5C279BA1E8FBDD6D57DE3A84F9716D716D1FE9F7CFEE1BFFD17D96488C6E1AEBA3DD7E4E9B6FC86726190DFBCF0F5CFF8AEF3155863FEC45D19910D354619ED1468F2850D3775C172DCEF3D79F8EF7EC43261DAB6D719E8354C6F644619E880';
wwv_flow_api.g_varchar2_table(65) := '87A0335334FD7FDDFF9F72872BFA290000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72359567584797234)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/tar.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D0000149C494441547801ED5D5DAC244775AEEE9E993BF777D7ACBD8B9137892D0C066F626CC906AC081992879007A4485E4BB17948A49007DEF290874891';
wwv_flow_api.g_varchar2_table(7) := 'B828B2D708C4132F099182105E1C5FF290448A905008ACC00202C60BB284B310C02C8EBDDE35BB7BFFEFCC74E7FB4E75CD54F7CC9D3B3F67667AEE9DB2E776FD9C73AAEA7C754EFDF4CF1AA31092C4040A62262A22595D0D0F433FF24A1C1A182A25084C';
wwv_flow_api.g_varchar2_table(8) := '42C1C9F38F3F641AC147103B6E9224366198AFAF3869B6CF2455132E5F35F3BFF5F9E081BFFD65929C8D8C598B5D7F8AD3D8C15B3214C019702F3CF12814F68F66A5724C9AD394CC88E03F782B55399B0D83D43A9A76C298F8D4574D54FA7870DF5FFF3C';
wwv_flow_api.g_varchar2_table(9) := 'F9AFD5927964B5715840F67BDBB71A39E28360AD915CF8E8ED2688BF668E57EF35D7776AC03314A74D5C1DBEBDD494A7CFA7F32D74E5CCF7E33E9DCB77D7262D21ACC5A67462DB2CDFB56C6A8DEF9820F9D3E0FEBFF9C5610279381FBAE63499DC050DBF';
wwv_flow_api.g_varchar2_table(10) := 'D3DCDCA5A2092EE5B65F99D7EDB71F9FCBCFF3FAF97EDCA773F9EECA3289271C7225E941ADBE618ECDBF0F6D7F26B9F8E93B830FAED6CD3756A3C330270F07F0D97B691750590C6B80455065EEAFB55D9B53C878DA5E1360DE45FCE6766296AB0F9B46FD';
wwv_flow_api.g_varchar2_table(11) := '50813C1CC06B2F59C71B875C4773B925784FCD1F199EF22764EBCDCD9D06407E3F403E9FFCE0DCDBC592CD73585D8BB54F4DB7FC860E07B0B3604AB410FBB28B1BB77EC7FA1569259C7188C11900C875820C771D98F3C90FFFEEEE2078AC61BEF149B8EB';
wwv_flow_api.g_varchar2_table(12) := 'E904793880F3104E8B01E7DBC9E9052314FF531F74D7B4E4074D527AA665C96B5369C9BA00E7019F9674000B06AE986268DB5C843977FD20622D4B36049984D313F4009EAA6EE7007216DCCA6E81BC044B8EA36793EF3F758FB8EB299B93F50076F35A4B';
wwv_flow_api.g_varchar2_table(13) := '49D3139393B8B6116A41DEC09CBC32FF004EE5BEDC02797ADCB51EC06DFA991E7C6581D8B9B9D48F75D74B73EF994690F500A682A6CD8A5D7B650E768936A45B962C2007CF262F3CF56E71D76BC5B7643D80F7D54F9BC28A93D1F43ACDC87E6DB3964C77';
wwv_flow_api.g_varchar2_table(14) := 'BD54BD0F873AFF9C5C7CF24CF018B6500507590FE0FD5453E4FCCCA0EC03E495EA1913634E9E0290F500A67E0ED451C1D0CEB43783F67E0DB596CC13AF45805CF7417EAC90FB643D807BD2CF7E7A1B73FE706D0D65A72C275EA925BFF0F47DC1636B0D63';
wwv_flow_api.g_varchar2_table(15) := '3E19F0C18131F7A66B757A8DC95843D73A275F986F6BBF8717EE8ED9C64E1D73F21993C4CF26FF7DEEFE20588DCDBB5F2A14C87A00D32A86B38CC901DF791F7C507B384C229C5DD7B14FBE07567D3E791120D3920B04B21EC079AB38483D4528CF0CC84C';
wwv_flow_api.g_varchar2_table(16) := 'A2D7D659906F12E4EA3DA60190BFFFE40302F22730DE0BE0AEF5001E483FBDEA71D47443359E27D7D6929701324FBC7E78EE4171D70500590F6062302D56ECF0CCB43793E87744594BA6BB5EAEBE0353156E501403645D80FB55CBA4E8F358B6DF6C18A4';
wwv_flow_api.g_varchar2_table(17) := '65D692E9AE97AA6FC761C833C9F7260FF2D104380F9F1C55E633074AB7DCF5D2DCDDA604905FFCD4439374D77A00E7AD6220FD4C88492C58ADEE2CC8718367D7EF9F14C87A00BB794D4D4F631424DB24D5FA2CC8B24F9EBF138B93F39302590F6055FD8C';
wwv_flow_api.g_varchar2_table(18) := '5958BF071DBD35CF2EBCEC61C8EF4C0A643D80D99D69B362D75EBD39380F7D0E64F3E5E4C5A77F5FDC35D535867DB21EC04E59F92E16394DF54B68465C86E6D50379FEB74D9CC05D3FFD816015C79A084932DAB36B3D803555322E59994139269017ABA7';
wwv_flow_api.g_varchar2_table(19) := '01EB975A207F024FE48E0E64FBEA868642A99F91EA48A391391999F666D0CE11AA24595B64644E9E3B6D367709F247F16AE605200C4BC693D9BC59A11CF42C78E4FA51EC79C7B666D056AC2C232A5D5DEFD6CD22400E12EE933F0890D1A2D59158B21EC0';
wwv_flow_api.g_varchar2_table(20) := '997E143CD1862511EF88FA283A0290F13ED4E66E0D0F0DDC61E2F84BC9C5731FC2A3F76880BEBBD605786C3A52D6BB1C74B4A1AE5C892F8EAFC10425B8EB1A8E35DF66EA9C939FFC835158B21EC0D4CF3875E4EB6BD0B81B90DC26E1FF4C40925992ED8A';
wwv_flow_api.g_varchar2_table(21) := 'FCB41777ACEE4A5BECC40B0589244B27EF3A39906FC70B155F4C5E38F787B464CEC55A0B2F3D80D974697E464D5392805A3938FD17CC6863E9AF3970FDB417271D83BB92BE132F2A10CA261DC8C056B60B2F58B2C1FBC93F38F74756164056D827EB012C';
wwv_flow_api.g_varchar2_table(22) := 'ADE29F29089981C8575FC3183FAC71237C5724C27A76DCBF5264B6F6F6CCD2C24913855F482E7ED6828CBD32AC3D1D3E83E9556F9B3458FD93E182CAB83509006A126F473B1BAFEFC07837F48FA4FBEB5EB26E36CA51746AAF56FBECF5FFF8CB4BC7FFF8';
wwv_flow_api.g_varchar2_table(23) := '1F7E66D6CE62E4F181BEC1C2D10418BAB26681971692EDB9B0B619AD6F359246230942BC279C31F054AFA4EF94EFD4DEADDC2FF3E38E9757E6C726296339D008C2E85D4158BA03593F33F20E76F35B1924ED2BE801CC164E53407BB9D8C1CA3598AB4465';
wwv_flow_api.g_varchar2_table(24) := '5AF33A5E0B8E71D410B1AC435F0EEA62B772BFCC8FFBD560B230954A68F66A8D7A5CC35E5921E8014C8D74D28A42234725828B1D0119974A3930CB7CB46AAB611AE8075FF81F4B7758498A382E310698FD6648D942B3E63E9331A0128EE622CB5356BAA2';
wwv_flow_api.g_varchar2_table(25) := 'A55F0E0072B0341F05003780A2258FF923FD11DEB40E609D42DD6AE059FF3319ADEC9E637A00B3696319F23DF7AD7F42B47F8E963C1FC947FA68DD630D23A84F0FE011346EACCAF52A9B28C85E3B34A27A006BB4A640320E0BC87A00D345B7CD2005426C';
wwv_flow_api.g_varchar2_table(26) := '80A6CC55C6ECAE47A03F3D800F918B6E8E05F469AC963C021DEA01DCD4CAE18B8CDD921555A80BF00846A0625F0717454B86BB5E598870546CF7CE830B1B2FA71EC087700ECE4001902B25CCC929C8F1940C663D80D9E129E97406B83E1372E205904BD0';
wwv_flow_api.g_varchar2_table(27) := 'DC3480AC073015358255609FFA1F3DB967C9D300B22EC0A3576F616AA025734E2E3AC83380071D32B0E432E6E4A2833C0378508053BEA2833C03784880C9DE041937FAC67E83E280F6CF003E4041BD16973927E32E5404908BB4BA9E01DC2B8207D1714E';
wwv_flow_api.g_varchar2_table(28) := '4E41C6237485B1643D808FC216A91790B9F02A9025EB01CC430EFE66A15096AC0730819D59B11DDE9EBB9EF49CAC0BF0CC7A5B1AF040E69C3CA985D70CE01624FA310FE4722F208FC003EA023C9B83DB07493F208F407FBA008F6004B66B6C0A73005C29';
wwv_flow_api.g_varchar2_table(29) := 'DD42F564C98A5DD40558B161874E540A321FC91D27C8BA008FC0C51C2AA0A11F390CC15DA87181AC0BF0A14263449DA125A777A1C601B22EC0B339B8B7518117DCC605B22EC0BD756F464543F040AEE07546D927235FDB4666004F6AB879202F2F84F240';
wwv_flow_api.g_varchar2_table(30) := '5FA2FE952CFE53AA5A417BE869B5ABC872A033824A77BD3C1FCA7DE5A1BFD990EBAF1EC0B315744EB5BD25E5F555B7F05AC4EA1A606B1E6BEA013CB3E0DE10DD8F0A96CC1B137CEE9A20D76BFB11F697AFF7867F7FF5CEA8F31AA081D00B720B05775D9D';
wwv_flow_api.g_varchar2_table(31) := '1BF8BB2B19C97A00CF5C7446B10327A0C708ABEAF9B9F2C0227C463D17ED4B9DC587D3008DE5F0B9E851BB00B748E8B79E61F9FAC49AD53977DD276B27723D17DD497ACF79E85150C114947E51107CAE8FBC32101697271969DAC61D68FC9E492B647813';
wwv_flow_api.g_varchar2_table(32) := '9A04E7B5323E2818892C47E9CB763CB60C25C2C70D6A3B5F9EDFA5E59AECE142BEACC40CCD18120500180A48A0F8C6357C946C175DE6BFA86E83BB32E5E2EE9A92E00210F0E156CC5C88EEA6743E553A6CA2B780AE029DFF069FD0D9007D6B7672D4EE6A';
wwv_flow_api.g_varchar2_table(33) := '65039C600E64C7ADFCF806F86E66F82C1D8A5D44AE1C2E902DF5711E657A7261C20043350437AC9878EEF7AC4265D4F7A310CA8075F2C40072DA03D50F90F7FE0F006DE283587799245A411EADAB5B0048F18E096BAF817D17DFA03B6D92D22D603888CF';
wwv_flow_api.g_varchar2_table(34) := 'F629A8BD8EFAB6D0A7D640EA56DBA8CAF400A61EFB0A1CD9A83EB961E2D2DD66FB8E274CA37ACA040D58B1F739D60345D2DDD6685DDB26AE9C4CC929DB022B0A4EEA66E195674DB4FE55B373F263A676FC0CE8E942F70BF8BA30064BB4F39A99FFD5174C';
wwv_flow_api.g_varchar2_table(35) := 'B8F5BCD93BF9B8D9BDEDBDE0E307E83CF91911C8A73769EC9885CBCFA1BE6FC2926F0385CE962753558F093D80D967FEFA0A76B49BB06C1A73B700E05B01F04E3AEA9D12F323C755925E017018C2ADC7F3E0873233EF8E8006E50600275115D72D0C8263';
wwv_flow_api.g_varchar2_table(36) := 'A6317F9B1D48D2D6742034414326BC4112C13DC71C6C1C84D761C12B291FE772D736D796B4D3AC3B2C41F6160608EB236DBEFD29ED7E979CC8FDC87ACDD7039835F6D9972C3D7BE6FF986CE42C06595060D6EDA51AA1AB8F6B597A283C89380FC2AD0AF0';
wwv_flow_api.g_varchar2_table(37) := 'B076586E50DF96AB5487C1916080D9E0B4EBAE6936165846F876C0C7E900E5FC52ADB4C5EF34EAC37F76A99797E1641D70F5C51D40DA4BB12EC0BDD4D8A4414F386F6221C3115FB9F132A6BCABA2489801165C75D3A8C0AA17F89D6C58A1A001A7BEF98A';
wwv_flow_api.g_varchar2_table(38) := '09F76E802FCDA38BAE6FC09D5E8617781BDCEFEFC2E52F08D0495402FD2F4D69FDA726DCBD0CB158307154092F00C2D96058DF34E59BFF837A31409AF325DB55413D5721671BF105FCC887F994C022CE81525EFFB90C162B8F1D23F01C44BB98BBDF447D';
wwv_flow_api.g_varchar2_table(39) := 'E03B70CE26DFE8C2040166A7B8C00218F5374DF5D57F423A1DF55CEDD62E99DAAD7F6EB64E3F0A4B81D2C402633377F55BA67CED2BE9DC467AB8D3601E8BA81F9B78F143A6BEFC0EEC6896AC2C80515EBF64E67EFD19D4730A3FE633900F3F8011EEBE89';
wwv_flow_api.g_varchar2_table(40) := '79F6EF318FBF81F265E4BBF992341C440416F9523FD9003EE6E71083B2FAEABF9868F3BB587CBD15EDA33BF6030683C803FD04831EC0D0C3C081CA6BEE1B2185D612AF5B65FA420517BA62AE4EB9486206DCB8B8CA25008D79AFAD1D0029C41649B651A4';
wwv_flow_api.g_varchar2_table(41) := 'CF07D68D8593FF63FDE28651265BB036A12224E0B4006065E14580C92781F5C0AD373D429A3D818B1EC09D74D76B87A89860D12A088A4D60C141448BCB358FFAE37CC93D66945A29174421DC3CF7AC1D146AFF4115CA611D9D1AC9B9141E00D69D848B32';
wwv_flow_api.g_varchar2_table(42) := '35B480021B41749E0531912357E4725B16AEE00A2F94701E671D2C443D6D7C29D3982F390D0E51BB746C087E1EBEA6FA0FF86F572498FBE80EF381793C1011974845320D2BA5058A62DB18900D90C412F365648107A85F31A67E19209F409A96C87CC896';
wwv_flow_api.g_varchar2_table(43) := 'C30A0E1C9F2F6D24CA83060E3E6A3F01B81C043CA441201F5DB3CCBF366B927FF50066BFD3BE0FD6214F8BE2EA7840E0E55168533EF35D998BA769974DFA6648339BFC6901AD1FDB9FDDB7FE19C022B0E9C28DB2D186D2CD8B26DAFA11EAF585224E3E6C';
wwv_flow_api.g_varchar2_table(44) := 'BBF66EFDB0098F3D0C0B86F5125806C888362F6161F75D24B8287332A5F4E03FF9361ECCD195420F6056E3EBA16BB5FD16A6823BC9479ECB76575F7A26AF9940040072A5CE7DF1CEA9473C166A98C0E0961D1652D1C6B791B6F442443ECCFB0478E7B6F7';
wwv_flow_api.g_varchar2_table(45) := '797C8802E424AA98F92B550C8E0B60C39A80B20CBD4BB372C4BB841EC9BA48C814E902AC3CFA5A2D4D0577928F3C1A18F5B24F719B18C970C400CC82D022B3D2088C27D55928C9C8CB2201CFA36194DB281920247295907632411760E9F4643AD2ACB527';
wwv_flow_api.g_varchar2_table(46) := '9DA644D25E7CBB9F7BE0266A2CC3510580B2732B8166793E600EE6A187CF2762912F2B720897C193E71B6F5A17E09E943B44073B0DA0661E144BD1CDB4ADC7267D401D1157EB651C905C31D52BDFC41C8C1B0AB210739D084CB4FD5318296E4C34AE5A61';
wwv_flow_api.g_varchar2_table(47) := 'FC4B378C7D79585B07DFB7B08F7E43DC757341C8BDF5CE2B688773CF5C28E61AD59236F2981EC0ECC3C8FAD15DB0948A6B6CD797C0DEB67D7280F3146CCB94DF7CCE98BD4B5835E3D44CF6E3940360A23B0030B66F19574B5E9E7DD74CE9C60513AE7F0E';
wwv_flow_api.g_varchar2_table(48) := 'C76B8F808467E82485B587B8E911F1D48CB46EC0203A81A007F064FB013D766900CB3A8E11E647262EDF09C88EC132B10F16772C484126AD0F806578D304DC6F52BA159FA0FD135C4F58B72C00A25CB66C9DDCFAF811D60378A46DEF029EAB37C6FDD706';
wwv_flow_api.g_varchar2_table(49) := '6EE40B690B1199271B976151A701140F23F28173264EC56081F6B0C2AD7829885B9C2E41E65ADCB8107ECEC7AD7ABB708DB5684A00EEA41302800510949B04B1A99FFC2B533B7606F3210E26C48268490D535B7917F29E32956B5FC7DCF8622AA813102E';
wwv_flow_api.g_varchar2_table(50) := '2F7FED54B7CDE386A915FC782B77D2312E110B1C0022DCA4DC68A09BCDBB611E22C88956C3ECDDF21EB37BE27E39747037E5B93AAE2F9EC64DFE87F1C4C8ED985671174A024FBF527979991DB541F038A0F8A3DBB6FC586E215EECA06BC12AFD75427098';
wwv_flow_api.g_varchar2_table(51) := '0000C52279E6CBC50B4F90086AAA5852B6EC06312EB448EBB627044F0601DD2E0357C078780E67D706FF822C0F25240D29D9C7F52C75F32FE762B877910D91C2035EEB41B2AD68F21424A20B704BDB43740F42C4AA1670AF16F779B75F831E7914682D27';
wwv_flow_api.g_varchar2_table(52) := 'E43CCB3B3508788B077FE9A6F177EF1A8E15F9DC15CF849D6322C02CAF637EE61DA84513916EDBD2C96339BCE72BB21D0F25BB40F010702323ACFF26E5C37C8DF6847B78788F67E29CD77BF20256D4B8FFEA029CEA63F84E60C1826799A2CD1F99C55FFC';
wwv_flow_api.g_varchar2_table(53) := '8A1AC6CF0A0FA0687B9F1569CEB57C600040575FFF57DC2BFE1AF208BA1F2C6F50BB06BE93A672E5DF4DE5EAD741403A0E263C898987EBE409CAB6038DB443E12DD84AFD27B645DF030FF3C8874153A74CDED5721E02D182055D80353B07D71A34D67123';
wwv_flow_api.g_varchar2_table(54) := '1E16EC07EE4B65359C2A3F75C7C1DEAFAD45C960F019D23881C04146B8F7AA802A20112CCAE29D1FE7D63BB0D2CD07F537700BFA1594A6838DAE5F6E71B6A68C4EAC03E5A55D1B8837C7A40B30FBAE1652E547B8859709DC5F76D08000C8272F32C45E22';
wwv_flow_api.g_varchar2_table(55) := 'E59301E2D3918165DD02DB320FAFC2430F3FD072F7ADD027EC2F9E8EA1FE983A53EB02ACDE570AECD5FD7111D6B993D95CB8E636379EA5E89CA24BE76FC4A1A73EF4DE864E2B8BDEB9F394AA169C177E44D2CA3AD4055879F41D1148DBBBA9A8475D8095';
wwv_flow_api.g_varchar2_table(56) := '475F7BCF8F488EA21EF500566CD41181712CDDD40358D1AD8CA5E747A4123D808F88C2A6AD9BBA00CFAC58077F453D0E07F0DA4BAD9997A7F5AD944E4767528CF1753C803E8603F8ECBD76AC85B185B7C087EE03E866322CCE7AA95306A7E3015B33DC49';
wwv_flow_api.g_varchar2_table(57) := '961B5D7108EBC5F7D9E48D04B164D7CC019B7544D97883596E71E20F75CAE0743CA04A8603F8ACAB35F85F1CD6BE6C56E6EE35D77770D316F9CE5DFB7192E7D34E44D1AE07B5B35B79B7B2FDFA697962E830820E5F8602A15384A68EF763EC9EEF60E84E';
wwv_flow_api.g_varchar2_table(58) := 'B54F29C659C067CF589C5C78E251DCCEF9BC59AEF071C216C09298FD395003A24550DD94979FFF22F8C0335F218FAFE303657420180AE07C0392E71F7FC834828FA059C7D1B218DF56E850E52CAB4D03316E62047C3221B88E274DFE2D78F83C6F3C0F0D';
wwv_flow_api.g_varchar2_table(59) := '6E5B3D836670940DCA3BE3EBAC012D9DFE3F4C042A75F15781030000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72360058743797237)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/tiff.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D000014E8494441547801ED5D6B6C5CC7759EBB0FEE8B94A8F7CBB2685BB224525164C78A62A3695204458AA0C89F564491D80152B468EA16051224055AB7';
wwv_flow_api.g_varchar2_table(7) := '888C160860CB52DDCAB6DC18912D85946BE6570314FDD1186D0DB4B614DB8A22EAFDB42D55B25E14C97D90DCBDB7DF37F7CEDDBB4B2EA9DD1DEEDE4BED00DC999DE799F3CD3973E6B143213438CBB20C0DD534B58A1D3B76844040E0FB51CEC4BA3B4470';
wwv_flow_api.g_varchar2_table(8) := 'E12C56FCDAAE673E5F28585F1786D56999C20C9165BE75966999463C148EDE48C6E6FDF89B7FFEFD4B6FBDF55678FBF65ED33084EC8F6F49AF82B04815792765F582BB77E75FFD7EA160BE964AC6E75B600F409F94DF771192D0A82818C6637D2FEF7EBA';
wwv_flow_api.g_varchar2_table(9) := 'B7B7F73C243962891D05503F2740AE0BE0818101CA68E1D5DD7FBD4214AC1D1DEDC9F923A3E909C4219E009347CA47B044034E95E68DF30E1015CF3A18A62BAF57E5F1FA76CE62DE92320606A8198958D9547BEAAB13F942FFBE5776FFC1B7FFF4BB1705';
wwv_flow_api.g_varchar2_table(10) := '41FE21409E03925C17C062604072D09CB01E0433D6A7D3597E27E8F85340289F49DE70F9779556EE331F9D8AB7BF957E5769E57E795E95AEE285EC7F3E5F186D4F25B68DA6337DFB7FFCFC93DFFAE31F5C1002205B3F04C8F6F4E3960858A02E808FF7F4';
wwv_flow_api.g_varchar2_table(11) := '580439143231D601B1415CA56EF68A9F6F59228934AC3024D94A67B25632117F2293C9F6FDE4E5DD4FFEE1D3DF3D0FC201B2156890EB0278707050F2C8344356C886D8B76056228CD330B47D08401A996CAE904C261F87DFBF6FEF734F7DFB3B7F79A6BB';
wwv_flow_api.g_varchar2_table(12) := 'BB9B03008657302599EAB466D74309868BCA1AB0549AA4016BAEBAC1050D2E05840D72B60043715BD80CF7ED7BF1B97530BC0ACF3EFB2C410E84562A675C5D125C5A19FA1F4816A017048F330B2419DF4CA8EB423291D89A11D9BE032FEDFAC6537FF6BD';
wwv_flow_api.g_varchar2_table(13) := 'B34195E4BA24B814E0C08A2F80B5D52F506627C813A86B1B64CBB0FAFBF6BE282599AB86A049B24680832ABE8073B2FAF5801CDF5A30F3FFB2EF9F766EA0BA0E1AC81A010E9E04BB144F6D403920C3F04A241E0985C5C17DAF060F648D00074F825D8A27';
wwv_flow_api.g_varchar2_table(14) := '4BB09A7D5C494E25125B2285D0C1FE8081AC1160C593E0F83348B0EA882BC989446C4BBE60BCF9FA9E5D3D4151D71A0106BB5C8E29DEF8DB77257866325D90B119F2D950C87A73FF2BCF6F0A02C81A010697AAE0D8CC3CF55D0E2FC89B84153A180490F5';
wwv_flow_api.g_varchar2_table(15) := '021C3009AE610895816C7840EEF5E5124A2FC0735B82D57870414E241294E437F7BDF4DC96DEDE81C2406F6FC8B938A0F236DDD7087080D1AD6C45570248829CCDE6F25842F58444F8E01BAFBCF048EFC040A1BB7BD0F013C81A010E9E91E5A237F53AD8';
wwv_flow_api.g_varchar2_table(16) := '4DAE1020EFC2D8F1CAA792890DC214FD12644872370E61FC02B2468021C10116E20A20CE14CD1E8771C4E8827CE0D5DD8F529259D00F206B0438C0123C138CD3A7630B5B811CDF60160A6FFEF4A59D5B01AEE9079035028CEEDC7B12ACA02F829C48AE33';
wwv_flow_api.g_varchar2_table(17) := '85D1EF1790F502ACBA1B34BF7A236BAA1EF2C811EA3A934F26E36B2D23D4B7CF0792DC029850D566644D0372361F4FC4D6850DA37FFF9E7FD8D64C75AD11E000EB673D12AC0097929C85E19548C4D78A50E1E01B7B9E7FBC59206B043878DB582EC5FA24';
wwv_flow_api.g_varchar2_table(18) := 'B80CE41C417E00B712FBDFD8BBBB29206B0458F52D38BEAB73F44AB0628034BCB2196E86C4BB0CD3ECFFC94B2F3CD16849D608B0CB2ED541DFFBB328C1AAEF36C8D8F14AC4E35D1143F41F7879D7171B09B2468083B70E6ED0906433E16C4E82BCC61256';
wwv_flow_api.g_varchar2_table(19) := 'DFEB7B76FE66A340D678AB12DD6810C7947804C8B741A62427E2AB01F64F21C9DF7CEAE9EFBDE35CE2E32185DC18D1DD27BD00BB3A4F379973A2BEA2BA06C8995CAEAF6FEFCE27711FFBBF01323B382B20EB05B825C1338D4407E42C0D2F48F2583F2E0D';
wwv_flow_api.g_varchar2_table(20) := '7C0B20BF3D5B20EB0578A6EEB5D2C901806C604E1E9B80E1B52A97CB1DD8FFCAEEA7660B64BD000755457399247F33D7B011C8F622988B09F24A82FCFA9E1728C9BF2005165E1BC079A3963959A3150DFD1C3015ED8EC70A1B1D6E7A05DC6111CB9462BE';
wwv_flow_api.g_varchar2_table(21) := 'A9429EC2DE76ECB5B704390E90C321B1FFC0DE9DBF4D7C09EE5BDBB7873D256B0E6A04189D2BF6AF66829A5350FDB04CF93615338D574EA874C57C5385ECBAE4E7E40D151688667169209E88AF340B067F0BF53BCCCB336558D675E35377059270F551EC';
wwv_flow_api.g_varchar2_table(22) := '9F8AF1BD0F9070F0831F3843451B067CDC8985CF38FB8F61F5DD1BF6E6F3A697C77BD35458E571BF87C3B9B1B171DC0C59825F46BDDEBFF7450932974E30B0EBE2AADE39D8F770961248504D331FCE664672B062474B533DDFC8E24ADA69BA3456315DBA';
wwv_flow_api.g_varchar2_table(23) := '4A73FC6C7A64341C0E2FCB4FE477FDE3DFFDCD99BFF8DBBF3F37D0BB1D4268DF10F15074D7C17B1A6072C9B2F2B1FCF858786CBC8029152F15D0D8E2BAD4EB97B093483B88C8A027BF3B0ABC71DEC253946532C514ED21358A305E14086D0431F721E59C';
wwv_flow_api.g_varchar2_table(24) := '7A45C15B4B35618D00B3D3417486118D44A360AA181FCF83BF60B67CFFC9016352B75484E34B0F1FCA57183242C67979A2221C9F1EF3E37904E9108E442262A250C803EEBC1D59DFA746804969509D654560C68AB6B003322EDD50821DBE57EC954A573E';
wwv_flow_api.g_varchar2_table(25) := '33AAB0F22B1556E9CA6751CE18961546941BAB9EC9A854CD4CF17A8DAC995AF3693A85967FE150D868833093D5E0B48C53698DF25D649D8731D43319B5B24E23C045D26A25C60FE5C290E4B6B6A83D2702D5E6393E3756BFD3083098D14C7ED4CF0BB706';
wwv_flow_api.g_varchar2_table(26) := 'AAEB982F407649AA39A01160D0303784583293923C1740D60BF01C9160252E0AE41097300D57D7F6E3548A965A7DBD00CF2109560C6DDE9CECBB3958B164EEF9AE24F339BF864B727DFCD42BC1734C457B592B25391AC50DD86081AC1160E8E739A8A2A7';
wwv_flow_api.g_varchar2_table(27) := '02D90810C81A019E3BCB242FA8E561A9AE21C9B305B26E25A81160B0628E4BB0025B813C1BEA5A370BF502AC38700FF8C53939344B86971F9749F700B0DE2EDA204766C9F06A2D93BCBC6E5AB828C93AAD6B7D33714B456B181A1264EC5D87708EAC679D';
wwv_flow_api.g_varchar2_table(28) := 'AC6F266E01AC0160561106B86D6DB3A5AE6B27B20570EDBC9B54D206D95F9B212D8027C1545F84DF406E015C1F9E5396F613C82D80A784A8FE48BF80DC02B87E2C2BD640907969409F755DB1A98A092D802BB2464F02C1B5AD6B5D4BA8EAE86A015C1DBF';
wwv_flow_api.g_varchar2_table(29) := '6ACA6D4B3297508D07B905704D90555FA85992DC02B87AAC6A2ED10C496E015C335CB515A424C7E48E5763D4750BE0DA70AAAB940D7263ACEB16C07541557B615E16A8BC846A9D26D5CE591F95AC0C324F935A07FE3E82AA76522A83DC3AF0AF9DAB3E2B';
wwv_flow_api.g_varchar2_table(30) := '5902326993C7C12D09F6194CF591530419E86ABC5CDF32B2EAC3456BE922C884458F8AD6F80B7F7DD74CB4722D6095A91DAF7C5E8FEC6904589F691F304CF4920BF51CC27B2189881E80F5D4A2B78BF7766D52115A9A14341E75F11537317AA90794B257';
wwv_flow_api.g_varchar2_table(31) := '61E593561556BE378E05699FB0BC9B2E2B53353277A953B720DD324ED6F27A589FD7B9F911A9DA5279E4032EDECC55870D4DAB605F016C88109E10E2F38084D9CB402F7FBCCC74B040B25D86E8F23924B25CE6E30FB74D134FD7C8FF34E7ADC609E35F96';
wwv_flow_api.g_varchar2_table(32) := '79DB74F2CB4484BD34A87699A6C2E5BE5D299FCA2980142D6F89DA55D6F1E9130926100591CD8D4ABF28C377DB33001BB2DFEEB40A0013E04807C0C3D136116D8B4F5111DA0408D9D111E9CB87C84C3EB513C6B96D5814F2B46215845314AF18658908DA';
wwv_flow_api.g_varchar2_table(33) := '8B44DA2AE66864822F0026A309C4A2854B45381C01C3C9D8EA1C0708A5978F98D9D2038D80702E9B0688438E64AB3A6D70997FD1F23590623C3007499765E1135CC631DDAB4D54E9E97C0E945C7A04ED8EA27C51C74C576636D334025C5B672879E3D911';
wwv_flow_api.g_varchar2_table(34) := 'D1B96899D8FAA5AF89F68E4E919F1897CCB62568FAEE73304400C6D0ADEB223D72472CBFAF4B02837F1229221834776EDF10EFBEFDAF62F8F6A7A22D9E944052F74EE432E2C1EEAD62CB17BE2C2596F9A3B198F8F8FC6931313E26D63CB4416A0293C04B';
wwv_flow_api.g_varchar2_table(35) := 'A06618748EB073809E3C7A581C3BF436066DAC29B738BC1CD308F00C0CF0B6EA097358507A2831ED1DF3C5BCCE0592C1F2394187692592803839C33A692CDB168B8BF1B19CB874F6B858BEAA4B2C5CB2548CE572A8332C521D1DE2FEB53DE2E8BB57643B';
wwv_flow_api.g_varchar2_table(36) := '2100300E7013A9F9E2E14D9F138B962CC7EB766302CF19C2CF89AB9F9C174B56DC2F3A172E16F9025E13A43621C0D2834F8295232D321D11A4078E737A9C03C92773B0FF964964181D3D30D32C98006FACF8073008AA6B0131AB23C59F9C3F218E1F790F';
wwv_flow_api.g_varchar2_table(37) := 'EA3123F0DCA3C8663232AD6B6DB7E8E85C22350322A082C744D7FA2D62E9F255C893C6801A17131313E2EC89A3E2F8E15FD8D3844383A4C6F998C88F17E9004D79394F3BB42A845D9F1534DF6994E0DA3A437028BD6390AA2B1F9D13B7531D00202FD562';
wwv_flow_api.g_varchar2_table(38) := '016AB37D5EA758B068892345905DE4BF7EF5B2048673AC2C0FA9CCA487418021CE9FFC403CB87E9358BA72B5100081752C58BC54AC59F71971FCFDFF024059316FC132F1D0C6CDB2DD02243F168F8BA19B37C4E95F1F865A8D8B3B50F797CE9D9403C9C6';
wwv_flow_api.g_varchar2_table(39) := '169B0F686B21A43D9E4809933603BE67D2A3E2E6F5AB1C61367DA000CF218ADB37AF096A0A3A2635D3F900601373654CA4876F8B43FFF9739717A150047137C4E62F7C552C78FCB724E05C3C59661E73DC21716EF0B088273B24C08A8B646A66F8963875';
wwv_flow_api.g_varchar2_table(40) := 'EC7D311F2A368A7AF390BA3658B55D0FF7880BA78E88E15B57C5E66D5F91AA7902733D556A5E4AEF1171ED93B3A2BD73B13873EC9038F3EBF7242D9C2A6813C4A076BFFCBBDF10490C4073228F255D540C0FDD12EFFCDB41498332D4A466C147D8B5A29B';
wwv_flow_api.g_varchar2_table(41) := '8B70D301568852124DA855DB6A0590214B3296D24216A9A98F61AE3369E9F28FE5541988998825E7890B27DE17F775AD135DEBBA31300010F271AE5DD505C309F91F00D8D26286A6A05174199AE3F4D177319727654B34B8D41C6A9821BB2DD246715484';
wwv_flow_api.g_varchar2_table(42) := '2027BF170AA001CB2B3A9B16BC0E0C29A6C4FBC1F906601A5291B618F80770C1193289562F559EBBDA0073991E0E4761F126E47A135C957C9430636EC6D3CF22339216277FF59E58BC6C9534DC28A96DA8FB7E58C6A98E79A263FE0209BACC9B1945DE43';
wwv_flow_api.g_varchar2_table(43) := '2283A5546ADE2209A6DCFC904B243EE58C1671BD264ADA5C426CE8F83DDA9690C0527B1060E2CFC12107839DADA99FFE18660E0BB896A57164E14F4AA9921A1B43708E190125184869671E371F0D2F384A5F22354F5CB978425AD5CC8B67F225A04B56DC';
wwv_flow_api.g_varchar2_table(44) := '87B9F7B336100090607C84B9F6D29923D2AA665982467064FDAA0DC4334D3A458BFDAD2C1F6852343BE9CDF6F4025CD6F9EA3B0769A194E08FCCB73F656072554E1E26944816251AE0710E3CF9AB77C5AD1B3478C21234CEC9A9F679324CD06FDFFC549C';
wwv_flow_api.g_varchar2_table(45) := 'F8F07F50DEDEBD82AE2DB6C3FA498BA44436524CF3869C3C3227C3F2BB374373C37A01662F67DDCDD008184C4D108BA7C4D0F5CB30983E90EB6A028A7F8720259E80D3B03A337844DCB87A119671BB8CBF2B7066687ED6BB5F65037A01AE5B822B505F52';
wwv_flow_api.g_varchar2_table(46) := '6FC9970A058AD1DC5BA6B34B111DFC71AE84C79DAB10A4B7AAF9B2BAE665DBCDFCD00B704346F7F48D102C1A68B9CC8858B2EA21B1E1338F4903C974D6D6B49E399F7259B3AE7B8B58B1663DF20ECB3204BEB29B2EAD72A966A7E80578B67A333DA625AD';
wwv_flow_api.g_varchar2_table(47) := '727942438DFEA6CF7D51AE87B97142B59C1E1D16F8DF4432CCB80E6CA2743FFA84DCB3E6524A9D489554E87EA98208B74CF3031A016E0003EEA209AE7B73E93B62EDA66D62F503EB301FDB4B16027EF1CC71F1F185D3D2AAA6A41790B6F2FE0765DE3148';
wwv_flow_api.g_varchar2_table(48) := '7189B156099BBBA0A152D166C46B04B8012A6C9A265CD58C63BA85CB568BF59BB7CA43883C2495A74D23778660701D1667073F80248FC81D2C4A3177B91EDEF4A858B074B5184359AAF7BB9A930302B446801B303E2B32D5DE2BA66AA639D5FDC86F60E7';
wwv_flow_api.g_varchar2_table(49) := '6A995CFB522AB90972E1F431317CF3AAB875ED63F1D1F953525A9946D5CC3DE68D5B1EC71EB36D65CB93AC0674A7114D040BE08A1CC19A551A56C3E281F58FE26061A3CC49632A8A33E1DB373E15678FBF2F77BE98EFCCB15F8A91A1DB72D74B6E6EC0B2';
wwv_flow_api.g_varchar2_table(50) := '5EB3762376BA3643BD3B06976377576C721A6D52B14C13127C0FB0DC82C47C49B569CFA7D88C2863AEB29A3BE62F96AA399E48E26C77DC36A620D5E74E1E157720BD3CD4E025809B572F898B383BA6D54C69E5017FB2BDC32E8B038CF15C1AAABAFC6689';
wwv_flow_api.g_varchar2_table(51) := 'A2C1F11D9A9A8059554DEA05B88CF1555132456635AFF27E1381A134D2971BF960301D8D2ADB6A0EE3E4E92B62158C26EE8045B1271D8B27C48D6B57C485931FCA651197C004946528D143B76E609303FBDD7CE01B7134CA7A1EFB925C46D93739C81ED5';
wwv_flow_api.g_varchar2_table(52) := '29EC95E3E4298A57736C5AE0E3BBDF9D5E0A2BCE91D5B3017202098CC873625EBBB1E752EE35E7E5CD0BAA5AB29E870113B889B1746517CE8D978A3B4337E501BEDCB9428ED3383ACC8C0CE1E0222535002A9207157770667B6690C0475C40DBB0F1B168';
wwv_flow_api.g_varchar2_table(53) := 'E90A317FD1725CF1B98E32F64102CB70B08D0C0FC96343CEDB1C6CA3F82E9DC67E57CFA9E94BE805580DF6E9DBBCAB54AAE3180ED7AF5C3C256E5EBB4C1E4B4746732D2B6F4A224CC3887BCC3CF03FFCCEBFCB01C0DD2A0E080E8634C0E5C9932B898EE4';
wwv_flow_api.g_varchar2_table(54) := 'F374E8ECE02FC5FF7D7C1679ED8B7A2CC33055362D6F797304253905D0E2FEF07FFF03F16D126C69A04D8CC9FCD28C73EAB5A9F4CFA75E8035F78BCC1EC3F51B82A41C715697D9DC38A8DD1C8EFD4621BDE03835B1946EFABCC2CA7A5C809D423C60E000';
wwv_flow_api.g_varchar2_table(55) := 'B8F5E965196397E108A57AC7D120EA548E6072BE1E8154F3F48A79581FE769AA6BB6A9DBE9F9E999EE8BEFFAFB29D5740C73A4D7D907ECA5EA8252164BB6239BCD7CDB070CF218B134AF5D170C2CEC6EC5222CA3D2511640AAC37E6F9BAC9667BF3698F6';
wwv_flow_api.g_varchar2_table(56) := '40A898B7A4606D5F4A7B5C5B1D2CA55782159F6AA7678A9260B87363628AC49228A5524B22A7FB22C174CE79A7CBE7A449E067A58F77D1788D598A7AA8C60A4A8ACD820497D4DFFA523507F4021CB0D15D35B70258402FC02D09F6DD10D00BB0EFBAD722';
wwv_flow_api.g_varchar2_table(57) := 'A805F01C1F032D807D09B03E63462FC0FAE8F225DB1B4294E4A13E63A62E800707072525F6AE8B61DFFA6E0817E6702392A3C5373A148F6BED715D00F7F4F4C8F1160A9920CB327CBA1D5B2B6F9A53CED182364F85503CAE9598BA76B2BA1D09368C8889';
wwv_flow_api.g_varchar2_table(58) := 'DF10718F0F74D81FB512748F97C3590ACFD1202B2634229CE271AD7CA94B82C5F6EDB25DFC50EC02C839954AF1D446F0E701F8335A7F55F1C0E61B7988B38B53A1A8715E32D7E1B10CD7F051D76C8ED18683167BA4FDF373CFFC1E94F46BA964AC93322C';
wwv_flow_api.g_varchar2_table(59) := '4F606A20E85E2D42C9E5A1543A93BB6319E28FBEF3FD1FFD8CBCF0F2B816DED405703901AFEC7AE6F3A182F57568984EFE3ECC73E2560B6DF74C191E78E1441387D206CE45AD9FFFC90F7EF45E396F9BCA0C8EB2A61230071BD7C5D3FF07604E6C506FE5';
wwv_flow_api.g_varchar2_table(60) := '861E0000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72360397030797240)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/txt.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D00001D21494441547801ED5D596C5BC77A9EC345E22AC9AB6CCBF2BEC44BECC489E3D871E2EBA4B70DEE8D5D07B84E9BDE3E14452E82B6B80F05D2F6D132';
wwv_flow_api.g_varchar2_table(7) := 'D0F6A5401FFAD420415134B164587DE86D81A268939BDD59BC244EBC2F89775BB62C6B21A985CBE9F7CDE19087142971194AA4C2B1C5B3FD33F3CFFFFDDBCC1C5142E828A669E868665ADBE8E8700853D4FE38B28458FE8008AE61986C77FBD1B79F8AC7';
wwv_flow_api.g_varchar2_table(8) := 'C55EC3305A4C914838B23A13827712F8514F789E5DEC34C53ECF5757DD4FF665104B33612684C7E370F406BC8D6FFDF7965F5EDB6F1E71768BFD09359E6CCE6AF1DA5516D33670B77DFCD62F1209F1B6BBC9DF2CDB2C5F75CA62AD90CA541F1754D31537';
wwv_flow_api.g_varchar2_table(9) := '9FD8F775D79F751BAF5CFDC9071DAE0F4D333E53402E0BE0FDA2DBD12D44FC898FDF5C281C4687BB25D81CED1F8AC23C1CD2D9D1AE09B4B4EFE4390EB2D89F65D3E47AA61446B5A5DA99A86E364D26AD9130CD44DCE51A7604FC2F26A2D12E80FCEA7F3C';
wwv_flow_api.g_varchar2_table(10) := 'FE2A4016330664E52B95288A3B025D16B770AE008A6B638361824970D96EE651DDB3FC73E63345AB68F21DED74A4B1D3D9CFB3E9D4B53A5AB4845B2AB8198B851A9A834F03F0437B4E1D59FEE1EE8ED84F3EFCD02966406E5116C0DDFBCF4A7B321D7143';
wwv_flow_api.g_varchar2_table(11) := '980663310ED26629BCEAFF21BF42384D2457630321E10EFA7638E2B124C8BB01F2C19A07B92C8045F77A82288C8493F9673207CDF6A1A4A8D6425E25DB520ED1C148DC15F46F27C8FBBE3BBC9296CC3054CB965C1EC0490B868FB6E424B19598572BA259';
wwv_flow_api.g_varchar2_table(12) := '7C59BC0262D3704014384487C212E44434DEF5D2D7875623F18AD732C8E5012C0E640AAC96B0B5732E632DB493F903608E0E86E3EEA07FABC3741CDA7BE2C8AA5A06B94C80ED52AAE1F3E43C3E393562F206902300D9BB5518F1CE5A06591FC049EBAD49';
wwv_flow_api.g_varchar2_table(13) := '231E9F2DA7410E10E4D8E1BDA78EACAD454BD607B08CBFF4723558940567B26E811CA225FB9E10F1D8E13DC73B1FA93590F5015C93A69B4474BC052BA8291FCB5D077C8F6185B3ABD640D607B012492D1D31019625B705AB91A42D99203B45D7CB270EAF';
wwv_flow_api.g_varchar2_table(14) := '9396DC5DFD53287D005356B5E69FB1D05160B12C99EEDAEF7B2C2612475E3E757863F72B98425539C8FA00A6A40A96578162AD3459710A69813C14893734F936261289AE9FD700C8FA0026B810584D615C3CB3A9ECDAE5F76D74C4AA1F647D00D31A20B0';
wwv_flow_api.g_varchar2_table(15) := 'E28CA2D2265A91F61DDCE688D29283BE8D2E58F24B270F6FA6BBEEA004F8E24015157DCC146F0DD52386FC59746E1EB1E2854D1547341489B902B064337178EFB1AEC73B0C23B17F3DD6E7AB08E432013E9816004DB756CD77E22C3A3D46DB19F4992AED';
wwv_flow_api.g_varchar2_table(16) := '8425C7DC4DBE470079E7DE6FBA1E97895715815C26C007D243E670F9530B4529A23A96CEB305F26012E4B8D9B9E7F83B5BA4BB3E00D95481259709B04D321456F902B33558C153A588D6AB64E576C41D70CB9283BE470C87B36BCFD7EF6EA5BBEE00C6D3';
wwv_flow_api.g_varchar2_table(17) := '0D7259AFEC8C938C12DCB807D57A431BC396255BEE7A0DB61C3B01F21F75187F7CACC3341D1D7C93A4A323D71B8415178C3E0BAE38AB15ECA0D8242B372B9625D35D07FCAB0C6C35EEF96AFA2DB90E30C12A21C9CA8D319CB572D701DF6AC3E538B4EF9B';
wwv_flow_api.g_varchar2_table(18) := '434F75181DD3E6AEB503ACCDE9E59160456EEBB160C55A0A644CA156E355E2C32F9DECDC3E5D206B07B856F22C85863CEAB360D5AC043926E7C9FEE51072E77481AC1D6035C29A3AEAB5603574997859207B974D17C8FA00AE45DF5CD876A102AC946312';
wwv_flow_api.g_varchar2_table(19) := 'E461AC787997E1A2EBE727DE7996EE5A363605F3647D00D7D23C584155F876A1AA51CA3105B23BE05DEA341C9D7B4F1E7A4E4D9B3ACCCAAE5DEB039843AF352B9EBA8421053276A1164350EFFEFEA9AE6709728738605612647D00730810584D613CB5CC';
wwv_flow_api.g_varchar2_table(20) := 'DA40F6B69B31F390B46424789504591FC0B4060C61EA8C822EA3E64A32BB9631B91D02EBDC73A2F379CEC32B05B23E806B4ED660787AB451821C0F0F479178B5210D7867CF293BC8A6564CCA6CEC6026ACD323B04C1E8AB9522EBA32D3A48938E136872B';
wwv_flow_api.g_varchar2_table(21) := '1602C87EEF22232EDE79E964D70B96250BC4647D209709F081F420282C25B0F4DDEA3E4B4D9370028967E8272FF85C1E93C350E7A9234F50543BC94BAB0E2E149DA4E14772FBCAA2A3B45CB17044828CDF70FBB7BD5F77FE5482CC17078E1C71B246B9A5';
wwv_flow_api.g_varchar2_table(22) := '4C806DDDDB0763BB5D1BA77094FC6FB764A9B0F890C7E428D479EAC8131435DD4A5E5A7570A1E8240D3F92DF65A2E82485E18E8618937D8BA010EFEE3DD1F92229B9A7AC63AB511FC0E42ACD38AFAAB7581624F923ACF84E910431329C8E84E1E06F1ADA';
wwv_flow_api.g_varchar2_table(23) := '7E9000655C3BF0B68EBCA78ED9CF6DD779EB8226F50CBFE2E6309CF1C8F0983BE09B6F388D7F7DF9D41109B29C2BDB95AE0489EADD0F2E818169A9424504C810B2882512CE706878C41089900DF72CB69215B2EE5A97EA993A6613E5BB4F3A3CA37BA776';
wwv_flow_api.g_varchar2_table(24) := 'E1680C454286CBD91A1F8BFDE38EF7DFBC74F485D7AFF0BD6B7E4D4676AB855EFF38014ECA96A28F9A66633416758AC828BE1888AFD2E1667EA40B956BF17400D9344D37788A43F1D6390C030B22E28AFA1685E21BB46A68079842AB9962198F211ADD6E';
wwv_flow_api.g_varchar2_table(25) := '69459151CBA21C6A14445A9DE71A957AAE8E769A5CF7723D4FD3C92F4970BB84198DC5A06D313B75A9E765027C705CBF6976C73DAABE1BC48E0C27F009C10A1FCE15C8749B9395D46093B4A96B569CA47E8A364D877C20012F82EC999D2793E8EE336982';
wwv_flow_api.g_varchar2_table(26) := 'C9F8C9F1BCCC24EB408E266BEC96141F5C339319B7D310DE06C819FF1209EB5B47783FDF0F51B43F63966CBF9EE83CBB2E6813F2EB42B2F0DCBF81AA50722913605BBF597CD99ED4CE2945494BF636E235390C48CD6F6B6704E338D50730855396AE8DE3';
wwv_flow_api.g_varchar2_table(27) := '6DFA6ECC2090F5014C386682152BB59A2120EB0398E0C2826712C6A2616ADD7521799DD2BF428FFA00A67B66D82AB4E75AA0E360A6D0922B11F2F5015C0B8095CAA3B4640F122F88AB122894CA5701F5CA04F860661733CA7C6D43E3B808B28FD9756D81';
wwv_flow_api.g_varchar2_table(28) := '5C26C007D25260F09D5101383D347946CB7563F1A1C6402E13609B10A8E5FC99C985E3AB38C87A85A80F60023B932D58292EE5EFAAA425EB15A25E8095107E0CC78A5BB21E21D6012E558E15B7E45219CBAC570738531EC55F55D45D17CF4E768D3AC0D9';
wwv_flow_api.g_varchar2_table(29) := '1229E55A81EC8438AB6C9E5C07B8144073D5614CE62E5495815C07381758A5DC5353A82A03591FC07AB3FB52443CFD75AA10647D007370F5622DF65491BBD607701DDCB40494257359739A63721DE0342C7ACF08721564D7DA01AE87629B9E140972756F';
wwv_flow_api.g_varchar2_table(30) := 'F827C7550FC53680792A41E65623F6932771D79598426BB7E0ACE1D52F25C840D905517B270759B7C0EA00EB9668BEF668C96E88BB004BCED74429F7EB009722B552EB1064BAE929CCAEEB00970A5639F564763D35EEBA0E703940955A57FE6DF9A9B164';
wwv_flow_api.g_varchar2_table(31) := 'ED00D7A74905A04E214990F96648DA92EBD3A40264573324299069C904197F6C1CBF7DA6FBB5277D165C37DDE2754B81AC122FC66682ACB1E803582F5F1A8758E54D29C3E03CD98FB56B82AC71C5431FC08AD12A9767D5B297318502C8512DBFE02FBF91';
wwv_flow_api.g_varchar2_table(32) := '42CF98EB165CBE1CED2007119765395056BB5824AD97AA928002B9418F73D5D38A4D42754F6D134691A75276FCD0E80DB55B30799B08643E97DF1B28076F8DC6FA520C7963DC479A5EB5CA2FB2E0BFDCC5FA2A75C5457E5AAB5DB691A625E7B9343EBBCD';
wwv_flow_api.g_varchar2_table(33) := '7C74D91C59F5D45DAB9F5CED6752E02ADFE014611147ED004FD43787E8C16CBE01DF204390D538869135466DD7AA0D3B7D5AAD0D316226C458163D69919A083FFE0E3BFF06ACD5BE21C6403B9283B611348DA055EA26BF770574C3A0E7B78E91370B1221';
wwv_flow_api.g_varchar2_table(34) := '02A073DADAE497F244404700D518703AAE64D78B27EBA976C755A8C08D290598E2BC101F133D098890CB369C0EE0B8DEE1162D1022F346BBC008D8F7F1A8B8C9AF8C52CB3CA8B306F4731C4E2960CA44813B86679FC7477003A24FB6BF08744B40CFA200';
wwv_flow_api.g_varchar2_table(35) := '61BB77D0E6E54434A35D011E9E04AD1B750932F98DA3CD0FB2DA24DD53A0C39795C9BE4136AE701C9FC44644CCC60B79DAEA807A4F506F5C4365DE983280F12D6EF89221433CDFD82C664138095CE3520AE87A34226E03780F0447B0541905CD36B75FEC';
wwv_flow_api.g_varchar2_table(36) := '7179703FFDE4567458DC023D81602160A4A5C5FCA967B6F002540A167F1F413C04DD95D8B0AC6F59A145BB0E6DFED43D1B35F90577987EA2AD3040BF005E68F50DB8A6C2D023FCCA3B077D3924D8A41B02DD79D02540C7AF43CC55F00D7AE2554F8B68C2';
wwv_flow_api.g_varchar2_table(37) := '58633827A8E4E9FC5848847124EFE911E56A41CF3D7D00E71EA7E452C61D0CE87358CC1BB3578967662F1363101201E020FFB3E7ACF875EF39B1CBE991EE94F414502F9EFE5DEBA36253731BE8A3B06E03FBE64EF1DEFD8BE24F7ABE153B9C0DD22AA918';
wwv_flow_api.g_varchar2_table(38) := 'B4DCD77DF3C45F2C7E52CC6DF08B91784C343ADDE2FF40FBD7F7BE13ED8653F8F1CBDB7DE817362E5E6BDD28B6B62C917CD0E5363A5C621016F72FB74E8A7F18BA255E707945C8048FA0FD25685707E68951D46D403B83B151F1CF378F8B7F0ADF15CF39';
wwv_flow_api.g_varchar2_table(39) := '1BC5A80D2A7C651E3C4E546C6D088ABF6CDF265A1B83B28F06B47F29745FFCCD8D2FE0A9D01FE84AFE024AF05468D107F024EAE8C280045C73283E2A66350670059BA4E500B035FEB942F4C262708F7AD200C02E02B0DF8105AC09CE17ADDE2631128B4A';
wwv_flow_api.g_varchar2_table(40) := '974841AD0DCC17ABEFBB64BCF441E06C876E7935E8DBFD7300A41BD6861889C686D0DF3D332E56A31EC96E82879F816E339466BE272841A3B018B7E7E0FAA9E02254BA0D8F9010CD68FB53F0D10FE0E7E2591C7FC68C6E79B608882D81562142B724BFAC';
wwv_flow_api.g_varchar2_table(41) := 'AF0A2DFC2A00FE73FF3CB1024AE195BCC4B10DEC14C7FA6F882FD1DE0E28C524E252CD957D94C655762B9334C0D8C701CD82C08E0EDD15F74706C5583C2EC2B08451C4D879B0B8275D8D620842A5A069350F00CA66EF6CE1C7FD7074540CC3D50EC7C644';
wwv_flow_api.g_varchar2_table(42) := '048091FEF1860068482FA01856CC5D0C6BA11B1E840BA73BBC1DE917C7C3F7406148F74FD0FA40FB4C70A16871FB403722FB1F83B587C04B1CE0AF06303F43DB8CCF3E281ACB6FFBAF81E721698921D421D0ABA0488B0014DD2DFB64E16714D78CD1EBD1';
wwv_flow_api.g_varchar2_table(43) := '0EC71282728CA15DD67FFFE13549477ACA246FD188BE7680ADA18E679D3CB7418BCF8D0D89076311582E3253088216D10C613F0A97760D2E90B1893190425AEB8335C20DB34D5A3A69F9AFC9ED151B6085D72138D233A35D0BBA79F00C8C95A4237D2FE2';
wwv_flow_api.g_varchar2_table(44) := '1D63EA0ADC63BD2128CD2680B209003724DBA39B8C42DC2ED0304F58E86D163BE0EAEFA26DBAEE4DB0C0CF471E8ABB0088DEC3916C7F91A759FC2EF289335004BA418E8F5EAA17F59E47DEB0D43B4BC65DF6CCBEEE40A98FA29DCD682F1FB829D9A54ED0';
wwv_flow_api.g_varchar2_table(45) := '6899453BC0B9948FF7982405219CCFA0D137861F4A819077265B4DB0D2471A9B24008C4D7D10D256C4C0766F8B540299892607CAC4C68BD8BA06D6CD5629D46BA0DFE0F4CA78A7FA27DDD5C843F105FA9B07CFC169D865D0ED42BDA5FED9D28533F17930';
wwv_flow_api.g_varchar2_table(46) := '16163FC0D29D50B8289E07C0CB66B8DF668039886B7A9D6368E35CA8477A055491759BA1645BA008C3501AB6C34265BB00C07720299B0B65A3C2B030C93A3BD4234EC03D3369A3E2283E2541F223752F75627F5ADAB93E8027D03A3EA2D65AAECC141722';
wwv_flow_api.g_varchar2_table(47) := '0FE01A9964C155018806A74B2C02C0747264E82C2C791BAC633E5C2EEB329EF6D1ED26C5420B5D0CF097C36AE976A92EED70DB4D6E8F6C8F9E210C777E79B80F3A90404C764A3A7C59B0781AD6DB8C0C9A6DD21A6F4209CE0CDE413FD600F8B90AB1F345';
wwv_flow_api.g_varchar2_table(48) := 'F043EBE45C997C7F85D03204A069E974D18DE0F9910072072802E7CE0C2B9C52B16C807BF6B91A641F541C868C2F4377451346478BA62CACDE24F9F88F091F8E279FE88E3E8027D13AF5780104740682A7B008042D98426B87CB0B248545CB5C074B0B02';
wwv_flow_api.g_varchar2_table(49) := '083E67B90CA588200E135CDE5A00F0B7C015F6421948BF128004404F6B77A39D870803E746FAA5ABA7953FA4F5C22B6C082E90C225A0A43D13BA273E4752C518EC862230BB6F65B205EB647CA5526D447B1F8FF4891B5006272C9AF6470CA864FB105AAE';
wwv_flow_api.g_varchar2_table(50) := '238F6026FF9021003CAC446871818E80738CD751EF43D45F8EF659942CE445853FF4013C89D6A941E18F12886F101B1993684196B09099C202B72316DF86D5CC850B5EE59B2DAD84CFC720B85303B765B2451BE71A5210D6BA09718E5616449B0B017823';
wwv_flow_api.g_varchar2_table(51) := '04A8DCE2AD9101712A1A161BF18C205DC09467172C8BB193D64BEF318084E964E4BEF800B191FC100C5A2733DF4D508495F0109C56B5A08D5348EECE4219A814540E2ADE1CF0BC15EEF836DAF6A2EE7750C05D9E595241C8074542FAD3B0DEB378A6DC73';
wwv_flow_api.g_varchar2_table(52) := '8531CD685E1FC00AC18CE6332F187B98999EC260A9D55CBAA3B3A2B05A10D31E83155EC2A2C4F3EEA058082028202E24D01AFF377447F48C0E598B23A04FC561087733805880BACACD52A8D711E7CFA09FD929AF8055A4A636E93AA512A0DD5BC3FDE2E8';
wwv_flow_api.g_varchar2_table(53) := 'E8A0B80CBACBE15EA908EC8F7CAE4096FC1CC2C4370098D3362F5A3F06A006E06E99C051497CE8771D948609A1CC9E51EF51583E9340861EBAE7FE31B867C4DFD9A0A1AB675237892D640AADCC2B7D004FC2351F33F6C8F9308EE7861987ADB92DD69230';
wwv_flow_api.g_varchar2_table(54) := '1D6A104B009280456E00B8731BFD296BEC4106FB1EDCED4D00A25C3663D9125830FE548A580041CF233DFE313B1F82BBBD0880E9CB1943B92CB90F6DAF416C9596051009D025803A80239733CF477AE5B48D192FA74D4C929EE25C176D12BC3550944F60';
wwv_flow_api.g_varchar2_table(55) := 'E9D7237DD2D22580687B996F96D88D5071197DAE4086BE1A8AC136D83EDDF45584968F47FBC5629CB3146007924ED7873E80C9F924DC5BF68AE912047C0E00D032ADA405DFA80F012E26C010C44A00E743364B30295CC65F01377D11028E402968A9FCD7';
wwv_flow_api.g_varchar2_table(56) := '0A109E805B6FC34F9056231722B05A351A1267A11073D01615EB2A007E2EB0404EA31430FDE8FBFD811BE21EACF736E2F36F86EE20E142360DD0D82F57AC36A2CE6300ED3EFA9E65B8C469D09E8635DADD34134166CD3FC4226277638B588469962A0C2D';
wwv_flow_api.g_varchar2_table(57) := 'DF2139BB04A5E532AA4A12D5F3A938EA0398DC4E62C50AFFB910DE71C447C649C661C654372C8F0B181E08AC1D735C0A187A204258E4B8446B04DD39D0F7635E4B374A6B0D200EEFC4DA731B2C280885B05C3E56AB407714025F09A50941C8411CB76085';
wwv_flow_api.g_varchar2_table(58) := '8AF358CB03707A1411FD78F632C0F90324745E3CEBC11C9D6D3091A3052EC3746A2762EA1928880BBCF810FF8F857B2CC59456CA699547ACF7219B465B8F226F602E21AD17CFFB46C3E22B2CB4CC423D7AAE82DDB31294060DD0B7545920331C241312C6';
wwv_flow_api.g_varchar2_table(59) := 'E11FE0EE9E6869C7D0A9198604ECD77ECBD2D81CC1BF8FB87B7A6C40CCC32ECC19807B6B7840B44101A81404E5510897D32C5A1E5DF228ACF11A14E21E2C7D132CFB245CE72BC86A09169FB3C401C67C58FFDF2FDD299585F768D99C03C7509F0A442B6D';
wwv_flow_api.g_varchar2_table(60) := '69F089ADB0620150B9F1B006A07D0AE5A1DB65FD6100EF4168590E372D904DAFA0E741B81843DF5C07FF1E21E023C4F876D42B0AB3490C85FC165AF45AF024BD926F5A0817E459CE435061006D4D7DB0F60B6BE05A70C0CDB55AFE135814E947363C8229';
wwv_flow_api.g_varchar2_table(61) := '864B9C83ABBB8A29560CE05A2D18887973A560494D851802ED39CE7F4141ABE94312B6136D726952C56F2651CDB07E2652CB6175CBF0B312ED709382319AFDF24807CF69D54EF0750FED309B3E9FB0DC34DDAF0C14209E8BA5CD37826D323164764EDEB8';
wwv_flow_api.g_varchar2_table(62) := '31710AEEF99ACCF22DF76CF18C875358A614608E8BC2E340DB01C65968F703B8319595D285AE82A0BDB0020A9873D22B00EB0E841B80157851EF0C94826BD296184DD18698C73868C2E2A828BD88BF67D0EE6AD00F02840DC9B92F4300171FD9B91B4071';
wwv_flow_api.g_varchar2_table(63) := '3E4B65E30F01E7D1004FF406E48F7CD2D52EF6B58867E025CEC3B2B991E0C153AE6FDBF9F6432177362FC1B4C99772CFF7C1C7314CC15A6CEE194D4E79997217CD1152789C369C449CBC856468192C898B025C1D5A8845065A0EAD71806BC9B06016DE5B';
wwv_flow_api.g_varchar2_table(64) := '249562402E2F5AAB56B444AF54065A27FE1C20E26FBF780FAE7C3792236ED4FF5570B15C90A0C2B0634E5DAE22345C09F52226A7F79F9995D3EAE64159D662078B1930DD3563FB938185420CDEC49B24588081127E3A3A80F0F2402CF0344925F460DEBC';
wwv_flow_api.g_varchar2_table(65) := 'B1A955BA676E58384173397C5F7C8498BE148AC6D943518502D254A6056066939C0FDFC2E2C1E5709FD886FD615A0D336A6B639D1BE942707A741A425A0661534874919F621ECA38BC9C5B8C28A457EE7904B1EF7B393DE286BA15939F6E5A2441624CA5';
wwv_flow_api.g_varchar2_table(66) := '85F3F83FF72F8A37EE9FC6777C7BE516253444B402881ECCC1FFD0D72AFE76C52E2C883461078B6E58887500FCF790C8FD80D5B73680F9757C5866D35B903F5031F81778E6AA10803EC8C7B7C8B6393D5B853DEE5CAF2349E6F37DB0534D65CA5D347927';
wwv_flow_api.g_varchar2_table(67) := '58561C3630F5E993DB762A73B5D67399C59A72B1E25308B515C072CD996F597047886E9BEE5BB685FB74A54C8CFA013EA75F4CB8B802F51C62EA2A2C44D09DE38F504AAFD087EC99AEB31D82E76B37DB0CFCE0B80A7D3CE9F289F7C606E592A4B23A6EF5';
wwv_flow_api.g_varchar2_table(68) := '31046CC702C645840ABA69F27E026D70B74A4EF3D0BF15BBADA5C91E8488E378DE0CF8199399581655345AB05E800B648C6414FA1200F12D84C1F9B00F2E956F5570912080CC9482BD82D52E4E3F9875D30A181DB979780EEE91003363651DAE6A797064';
wwv_flow_api.g_varchar2_table(69) := '5CFC02EE732B003B0EEFB02FD82E1328C65F0FDCBF07749CEBBE873EDB704E05A1F5C94D0F9CB7A08D5E247D1791FD12303F782280B3105B9FC5DB1F9C5787C10FB7107F8B7EAEC2FB30AC309B67FE4057CDE365B8FFDFC0F3ACC2397792D84F51A5E80A';
wwv_flow_api.g_varchar2_table(70) := 'F95BD7EBA28B608C49CD1C08EF2A80E0624000B1340AD0184B09C45DAC0D7F87858D260895FE9AF7A9182B71CD3D652E38300326D0D24D02C433D8D2FB16003D0BE0F95E16A732BD88C7B151CBD5F29DB06383B7E48B026BD1169586964AB6D9365F13E2';
wwv_flow_api.g_varchar2_table(71) := 'FCFB2B4C8BB660DD996BCDDCF522888D503AAE955F869768057027E0868FA3AD25C81F682574FD4CDE384D3B86CD0BB6E5034FEA2D15904C4B2902921CFCF16FCDE38F2B3FFDF9DBCFC07B7D84BF7DEB4CC4E37C53A660CF4057DC024017201E72F98202';
wwv_flow_api.g_varchar2_table(72) := '6742150170371013092C2D2CE51C70124732B5002E763680A4A2106066C23D70E7FD103CDD3D07B6142ED703A0150D41609B048134390BFAA3222C063FDCDD62BB2CA4BE097007C117F77D699954A236D071AD9A7D90EF115838E9F8D202DD798A6FD9CA';
wwv_flow_api.g_varchar2_table(73) := 'C41FA04D385C4E87198BC7A12BBBBED8FEDA67702552C613D7CCFF54AF05E7EF27EF130AE12EACEE2B581A81E28A2DDF819C07A1D15294FB4CC18113BAEA0B5809BB0D4BE6B445AD102DA67B473D659527104FEF42D0EA0537BE3CCB4507AE4FE713BC5C';
wwv_flow_api.g_varchar2_table(74) := '25037827D0365F09625D5A3ADFE75E82E54A82CBF6790C4351B8464E2BA5C3E7D18FFB6D36BA14DF792590E3413EE672904E764B2FC0258C8663E1CB6D8FCB5F9BB45C259BA110ED2ED43E10D66945BCC3EB7119853BC3ACA3EA2F00CDE20C0AEB39E9F2';
wwv_flow_api.g_varchar2_table(75) := 'B1CA7E69DD4B917C2DB3D5E57D02C8BE59974AD508BA0D70DDF226AE59F89C3C28A59337A7F1432FC01C5D09850289E6A84B41E60382C2CE55143D8F9C8EE1D5F68C32519B24E473B6CCDF86C82EAA6DDEE73941E76F656497C9FAC8A61F776DEF68DCC3';
wwv_flow_api.g_varchar2_table(76) := 'E26EE805188C95C25B25EB94D236455868BD42E90A8145675BAABF8293215561C2239479BC3E4F58A3FED0268194EC5227B687259EEA05182A58092D2C716C35572D25BBD449F943D0077092298DCA57FEE86AAC854AC84E1FC095E0AEC600AA4676F501';
wwv_flow_api.g_varchar2_table(77) := '5C8DA3ABF354F88A536E591DCCBC5DB7E24C79947245196A94637916DCBDDE8ABC9C6C72554E6372508A6C66441D25433581EFEE56774A1A5E7900EF3F2B75CD74C42D78356A5E49A399099592329432E57892322E75686501BC3F69C146C209B6B84A0F';
wwv_flow_api.g_varchar2_table(78) := '23B656F3C866FDA7481948D97165CC304D4BA6C05779C912112E6F256BBFD52BDE21FCDE25462FBA9AFCEBA3FD43D6068C722C849985D73CB71F79DF5EECB4BCAFE8154DF6B5BAAF68D5B5BDEF5CE78A3E172FAA8F6C5E541D1E73D553CFD53345C7238B';
wwv_flow_api.g_varchar2_table(79) := '6AD7BA4A5FABFBD63101193A21C30B94A9244DCA58552BF6A8865F6C3D8B1E8A86ED42298A6D9FBDF50BECB3BD0D069BC70DA6B4D67F5CB59240C706C303B0E0D7BE7CE657FF2E056093712902290F60F66863E0E94FDEDC86DFC8D9832DB716ECEC262C';
wwv_flow_api.g_varchar2_table(80) := 'FF9F1505521A2EF76DD040F2A8EE2B8EA4DA2487A49EF1529E4F50372928A96429FA643BF2A0EADAEFE1DCDE071F655FDBC9F92CBBE4E3379B4ED54DD1F30D6F76E770E02D927EEC2CFFD717CFBEFEA5AC66936D7633537B4D46EA45AF0434C9F4FF0135';
wwv_flow_api.g_varchar2_table(81) := 'B3B6B58FCE28C40000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72360769488797243)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/wav.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000001B569545874584D4C3A636F6D2E61646F62652E786D7000000000003C3F787061636B657420626567696E3D22EFBBBF222069643D2257354D304D704365686948';
wwv_flow_api.g_varchar2_table(2) := '7A7265537A4E54637A6B633964223F3E0A3C783A786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E352E30223E0A203C7264663A52444620786D6C6E733A7264663D22';
wwv_flow_api.g_varchar2_table(3) := '687474703A2F2F7777772E77332E6F72672F313939392F30322F32322D7264662D73796E7461782D6E7323223E0A20203C7264663A4465736372697074696F6E207264663A61626F75743D22220A20202020786D6C6E733A786D703D22687474703A2F2F';
wwv_flow_api.g_varchar2_table(4) := '6E732E61646F62652E636F6D2F7861702F312E302F220A20202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F220A202020786D703A43726561746F72546F6F6C3D2241646F626520496D6167';
wwv_flow_api.g_varchar2_table(5) := '655265616479220A202020746966663A4F7269656E746174696F6E3D2231222F3E0A203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A3C3F787061636B657420656E643D2272223F3EAFC2E87B000001856943435073524742204945433631';
wwv_flow_api.g_varchar2_table(6) := '3936362D322E31000028917591BF4B425114C73F6A51A411914343838134844659486DA58415226206F663D1973F02ADC77B4A446343AB83433F6849A2A5B9B6E81F0882A09A22688D86829688D7791A1891E772EFFDDCEF3DE7DC7BCF056B22AF14F496';
wwv_flow_api.g_varchar2_table(7) := '6128AC17B55828E04A2C2EB9DA9EB060A79B7E1C494557A7A2D1304DEDE34EBCC56EBD66AEE67EFF9A7D35AD2B6069179E5454AD283C231CD92CAA26EF093B955C7255F84CD8A3C905851F4C3D55E71793B335B69A399D5A3C1614760ABBB2BF38F58B95';
wwv_flow_api.g_varchar2_table(8) := '9C56101E137617F225E5E73EE64B1CE9F585795397DE874E8C10015CCC324D103F234CC8E8C78B8F2159D124DE578B8FB021B18A8C2A5B68AC912547118FA825C99E9639237A5A5A5E3CC4CC3FF85B5B3D33EAAB9FE09883D667C3781F84B643F8DA358C';
wwv_flow_api.g_varchar2_table(9) := 'CF63C3F8AA824DEA725569C46F5460FC55F47243731F41D70E9C5F36B4D4095C94A1F7514D6AC99A64936ECD64E0ED143A17A1E7063A96EB75FBD9A77A0FF16D085FC3FE010C887FD7CA37D50B67246E1BC0F9000000097048597300000B1300000B1301';
wwv_flow_api.g_varchar2_table(10) := '009A9C180000129649444154789CED5D79901B557AFF7DAD96343AE6F03D1E6CC68367ECB131BE16DBD838B6095441058F815DCF54084B55086C201B2A9B93A5BC4559D49205B6C256C8565271F0563660CF381EC23AD95AB29B5D0ADB808D017B6C9719';
wwv_flow_api.g_varchar2_table(11) := 'DFE3FBB6C773683487D4FDE58F564B2DB5A4D1D1925A23FD5CED6EBDD7AFFB7BEFF7BEEF1DDFEB3780116026439E934F783C0218859F8F28649E2166021103C0F23D9B974A12D6115115439605DDCD0200397846F03AD13DA9C6C78B8BFA4D02182CB38C';
wwv_flow_api.g_varchar2_table(12) := 'B23241B8E976D8DFF970F153E79A79BBA51DCDB29A9FB10031A3D41A7297ED7E67BD2CE31D6B85AB0A80115527EB9001880C88127FA3E9D0F6EFB653CB99351F7BC49DCCD258213923829BD12EB403D237766F9A0A813CD6AAF22A7F4FBF1F0C01048081';
wwv_flow_api.g_varchar2_table(13) := 'D01988245D1B177D4FAC38D2A4D32251DAE87B22EF2599599644715070BB1E9147026D8F77B4FDE18E454F9E5DF331C60CC9996970BB72B2C27217836707FA06102457B1C12A29B1B4393A8E528C8BF5AC44EF8C1D2E0200FB035E5B957BD948AF776BD3';
wwv_flow_api.g_varchar2_table(14) := 'A1EDDFFEE58296336385E48C086E6FEE6400604122B08540042610158481064004062C0CF048DF005BCB9D2B02FDBEAD4D87B63F355648D6F7835241FB5C0200922D0C52FBA08554160C28620B60267F9F4F12CB9DCB49925AD7ED7FAF7EE7039E4033DA';
wwv_flow_api.g_varchar2_table(15) := '85421E2564467050836185524E0C148AF22A50646510932000C4E4EFF749D60AE77D20B1756DC7D686766A91D6EC7CD552A8246746303646FE2CC82240701CCF00930080FCBD0392B5DCB1446061EBBAFDDB0B5A933324788C406D63151B248040FE3E9F';
wwv_flow_api.g_varchar2_table(16) := '642D772C01F9439A5C88241B4730459C0A0B7AD2C224BB5D4B04C6B6A6AF5A1B0B9164E308E688536121762F5921D9EB93ACE5AEC524A0AD1049365C830B12F1C952DAE43E9F64753B171622C9C5DD06735071138F73C39AEC762E84806D8F1DD832B79D';
wwv_flow_api.g_varchar2_table(17) := '5AA4E676F3936CAC892E34FB4C4973A368B2D727D9DCCE05320BFFF9C4A16DF3DA5BCC4FB2B11A6CDA6CC6416A15324C7285739E2CCB6D8F1600C9C6B6C15C601CA72E6CA84D165DCE7942C0FC241B6BA2A9F0AC741A102080FCFD3EC956EE9C27CADCB6';
wwv_flow_api.g_varchar2_table(18) := 'F6C0B60521923D1E53F56B4ABD6820F515290C810982DFEB0B886EC73C81E56DEBBE6C5BD4DED22235CF9D4B66223943415E0D5F1662274B451ADEA2A0C7CCE2EFF705AC15CE4608DCBAEEA0F948366E2E9A50385ACC51E7F4A190DC172459E2D6A6AFDE';
wwv_flow_api.g_varchar2_table(19) := '5BDCDED22279366E8419482ECE6152C8F96F88C0040A6A72B9B391044B5B53C796251E22D9B311792739B3151DD128140D0EC13081B5E67A96BF7FA0B5A963CB1F79E8DB5F7A98050F20C0E389B58230EBC8BB0931058C19DE289ADCE70B58DDAE7A6261';
wwv_flow_api.g_varchar2_table(20) := '6BD317F9D7E412C1405A9DAC784F0A996BB7B3814461EBE307B72EF590276F241BFEC282B3D280D10BF743248B6E67832C63DBDA03ADCBF345B2E12F2B947E56048C5F54472058025E5F4074BBEA04A0355F24974C3490AD4F6F08504976CCC817C9C53D';
wwv_flow_api.g_varchar2_table(21) := '93959CBB301304491E0C886EC70C02DA9A0EB6AEF450B0479D03928B731CAC22797761466F419064ABDB514B325AD71DD8BA4A1D367938BB2497DC85B94158935D8EE9006D5149F660236793E492BB30B76FD3934CC4D924B9E42ECC2D82BDEB10C9AD4D';
wwv_flow_api.g_varchar2_table(22) := 'FB5B7F3F9B2417772F3A3FB59140B04803837ED1EDB88308EF351DD292CC8672629CBB10283CF50D7D929AF39518C48018F00EFA4597A38602BC65ED81B60715926128C9C5E92E54111A263183A3EA2707E3B5A3038E3E38F2393C4A5AD57DA57E470188';
wwv_flow_api.g_varchar2_table(23) := '81019F5F743BA70AE0771F3BB0F52110B187486EDEBEDD6244168B7B9814021188405A4D262538A2E252F441A1E4A1F84469117C7EC45BC81A1C27D73068EBBAFDAD8F00407B4B8B64C438B9388749A1AFFC09440293403201208B2093401C7150D46F41';
wwv_flow_api.g_varchar2_table(24) := '08860931E2924DAB8D139804B248BEA111ABDB399904FCFC89430AC9F078E44C9B0F63FDC185020220CB20BF84805FB20CF8A52102BCCCF1C679D17B42C48A8B77CF286999550BC03430E8A532DB1469447E6BC5679B4EEEB9FFF9D3CDEDCA361929E54F';
wwv_flow_api.g_varchar2_table(25) := '83E22358E5820824CBF00F0EDBFD4A39C8C8A70D62068BA28D24492281E60A324D03705ADD45215D184EB0E9AD7448E10828B3298BE74602A22278AC1D5F12E528D62E31D17149A665569A6D9B0896A4801F4220D5ACC5428604BFAA0B192D5BA64004C9';
wwv_flow_api.g_varchar2_table(26) := '76C5D930EC5702496B3647C94928B314F51B483AADE64C443264B68041216282DB64A40B63BFF02F24680BB7CC46B08904660A766AC2D7898EE8FB90449AE8B4A13393CC4C111506086F9391268ADB5DA8EDFF38EC80DD1A1EBF9A06992951691CAC25B9';
wwv_flow_api.g_varchar2_table(27) := 'CC0ED86D4A405EF3A27DB9BE194C05C5390E8E86D65C3B6C4059BE4936AE208BDB5DA88556F0322DC9B9751A1B8D92BB301A2173AD928C9C652A1BAF296E77612C9840938D4471BB0B1321A626175E068BDB5D980811BDEB7C925C1A26650F7923B9344C';
wwv_flow_api.g_varchar2_table(28) := 'CA1DF242B21987496319A631D7A9A34470B22850924B04A782982493A9492E119C2AA24976D8C22E4613A244703AD0926CB72A449B94E412C1E9A240482E6E7F70A62800928D5B93659E3CC540A6B52F41E6B48FB65B95F3D08876B5645E314657551A5D';
wwv_flow_api.g_varchar2_table(29) := 'B0DAE78D52934D467201B4C1BACF09923872254F14B262AE339B8B36E9B2D9FC9BB6E4A05D5E8B8CCD75EC3BCC34178D4C9BE2427549C5913B454D1EC30EFF4225361A99936C344C40F05820560B4D7E4C3084CA23C163456B6381C2A76449CE12EF7922';
wwv_flow_api.g_varchar2_table(30) := '78AC12AB05459C002426394B459207828B815C15E99A6BE3D439C79B911613B92AE298EB185E288A71659E355941C4AF7BC548AE8A18E6DAA6213988D8656796717042FE8A995C1531CA402519C85AEFDAF0BF3E5A428AB059952F1B293B9F8518375519';
wwv_flow_api.g_varchar2_table(31) := '57494BDA1B86B62146F88337F5B3557FDA5B71C4459635B8446E42A87C33479AEB88C2345927AB84D140B17F120051089B6AAB316FCBE230A9A4BDA982B2F07588C9BC49C582D8959FD5280375C3288229F2BAA4BD19C1402D3156834BEA6B0C0CD40FA3';
wwv_flow_api.g_varchar2_table(32) := '864945D959230075F67234BAC6C36DB1E2F2B0171786BDB834328080495656664CF0B24F7F46000BE1D9B8D8D5CF29887877C13AD4382A23C287243FFEE4E00E9C1DF6267CCF3FCC7A002B26CE880863305E3EF21B7CD2772514F6F37B1E855D88CCD6CB';
wwv_flow_api.g_varchar2_table(33) := 'C73EC2B9519E9F2C96B927E35B53E760BAB30A358E4AD82DFA229499D1E5BD89B68B87F161F7B938862D6A4C9C2518D706339048609F1CC08F4F7EA2BC94287438451B36D4AF4C68951E1D5F8B9593EA22D20944F8F5956311E40240AD6B3CEADC13220E';
wwv_flow_api.g_varchar2_table(34) := '1B659E4D2B0978A36115DE5EB016AB26CF449D7B424C72D5FCD5974FC22B731EC4B6858F63897B52C6EF4F1746119CD473BEF0DEC0FB170FEBC2E757D5E0E9298D31D38CB3D8F0E2CCE5BAF0CB83BD78EBDC57298A991E08C09BB3D660CDE4FA94D3D6BA';
wwv_flow_api.g_varchar2_table(35) := 'C6E387731EC21D3667F2894CD6C92270F0394908F6D30B1DE8F2DED2853F53B70433EC6E5DF8DFD62DC3B8A8C29199F1C689DDF0C986ECD7392AD64E98A16B1E0060449670A4F70A765D3F8D8FAF9DC2E19ECB1892F43255D91C78A3F1415847B124A4BB';
wwv_flow_api.g_varchar2_table(36) := 'C81C4674B2084A45494A2C3FCB78EDC42E6C5AF818AC4278D77A87C58A0DF52BF1FCD7BF0ED593072AEFC083531A74CFF8E0E2617CE1BD6180E8C9617DCD3C5DD86737CEE0475D7B702B301C113E5EB463C35D2BB072525D447843F9242C764DC43EEFF5';
wwv_flow_api.g_varchar2_table(37) := 'B8EF09ED656A3A0D0EFF1F7915079D833D78F7DC7E5DF8FCAA1A3C35653600C02D88F8ABFA15BA7BCE0D74E39F2E74A42D6CAA2000B5AE71116143921F6F76EDD5910B00DD81616C38B90B5706FB74718B2AAB937FA94130B893953C365F3E82233D5774';
wwv_flow_api.g_varchar2_table(38) := 'E1CFD62D45ADDD8DBFACBD1793CBCA23E202B28CBF3FB11B239CBB3FA66D218225CAB4DA0411936C8EB8694658C6CE1BA7E10D0CA37BD8872B837D3837D00D97C5A009E61460D43838DEE8282E18C00F4F7D827F5FF8389CA22D14EEB058F1E69C87745A';
wwv_flow_api.g_varchar2_table(39) := '03006DE73B70D8D79DA1A8A921C08C2EEF2DCCAE981C0A1388E099FD007E75E5283EBC7906D70343BA746F5FE8C0DB39B434F1609406733AEDC6B9612FFEB56B9F2E7C866BBCAEC69CE8BF814D97F53DF05CA0B3EF9A2E6CBAB30A2FCC5C8E1D4B9FC4BF';
wwv_flow_api.g_varchar2_table(40) := 'DDFD089E9ED28889A23D0FD225460E1CFE89B1FDC649AC987027EE9B501BF79E613980D74EECCEDBECD0A68B87B06CC29DBA491A40D1E6F95535985F55833F9BB91CC7FAAE615FF705FCF6D659740DF7E741DA28F90C7886E2E4E288DF29E147A73E43CF';
wwv_flow_api.g_varchar2_table(41) := 'C860DCF8FF38FB154E0CF5A6259C11E89146B0E1E8EFE0934612DE2710616E65359EA95B82D67B9BD1BEF0097C6FFAA2518747D98471046780EB812174F65D8D19D7EF1FC296ABC73279BC213836D88B3F3EF00B7C72A32BE9CC4E778DC393772EC2BFCC';
wwv_flow_api.g_varchar2_table(42) := '7D185516DBE80954986C9804287F9286D335D38F8EAFC58A897531E3CAAD65F88BE98BD297CC409C1F19C0DF9DD889E73B76E0FD0B87706E20B90EDF3D5553B179FEDAA8899C24770DC81046B4C19CFA20298CA95607BE577F7FC27BBE396D3EF6F65CC2';
wwv_flow_api.g_varchar2_table(43) := '6771B43CD738ECEBC6E1F3DDC0F9FD98617763D5B8E95850518DB9955374B36E2AA639ABF0D2CC15F86EE7FFE55456A33A59692D072400AFD4FF1E2AAC6509EF1388F072C32A3C7D70077A466907738DB3C35E9CBD7A14B87A140460B6A312EBABE7E091';
wwv_flow_api.g_varchar2_table(44) := 'A98D10A3DADE45E3A6A1BEAC02A786F49320D98271C32400CA7C47F2CAFCF494462C1E3F4D177EAAFFA62E6C52991B1BEED23B1DB28D464725D654D6E05B1367E23B35F3F0FDDA25700BB1F582A1B4D5AF9DF91C7FDAB1037254AF9F00CC718D1FFDA506';
wwv_flow_api.g_varchar2_table(45) := 'B6C1196BF0BE95CFF27D7B37A73CB5D450568167EB96EAC26F0C7BF1E75FFF2F7E70D70AAC9A3C33226ED5E499F8E6ED8BF8E0E6E9F4054E11AFCC5A8D99EE891161A706BAF15FA3C8D039D883A37DD77077D4F464B5DD8D511934E154654A754E24C2C6';
wwv_flow_api.g_varchar2_table(46) := '59AB75FE5406F0D6C94FD12BF9F17AD75EDC1A1ED0A57D71E672D4C6F03A650B076E5FD285FD41F5ECA438A88CD1F47427180E8660C25EB416A3FE3D9A17A72D427DB9DE09FEABCB9DD8D97B1900705B1AC14F4E7DAABBC729DAB0B161152C395AD8F769';
wwv_flow_api.g_varchar2_table(47) := 'F7055DD8DD95D5F89B3BEF4D28C10B35F7609AB34A177EDCA77795EA60B25E34A0329A84604BDC93D0327D812EFCF2602F7E12E5C0FFA8E712565D398687A7462E06985B598D17EE988F7FBE742829E19A2637A0D7AF9F2F8E87EBC303F865F75900C057';
wwv_flow_api.g_varchar2_table(48) := 'DE1B383F701B7746CD8DAF9F3E1F0BABA6E283CB9D38E5BB8DAB233E4CB13931C35181A6EA46CCAFAAD13DB7B3F72A8EF86E272D871130761BA5514C8B4B10B161D66A08515B0AC9CC783D8E03FFC767BFC082AA1A543B2A22C29FAC5D84CF7B2F61BF57';
wwv_flow_api.g_varchar2_table(49) := 'DF218B46AC0A9508477AAF840896C0D870EC236C5AD00457D45C737DF924BC347B7552CF0CB08CCD315CA4D94616E7D0F46CBF346329A646110500EF5F3C8C2FE338F007826BB9A27BE72209F8C1ACD570C5E9D11A8953437D78FDF82E5DAF385930186F';
wwv_flow_api.g_varchar2_table(50) := '9DD88D3DFD498EE34DDB06EB4C7458D287C74DD7995A0038E3BD859F8EE256DBD37F0DFF7DE96B5D788DA312DFAF5B968EA429E3773D17F14CC707D87DFD744A449FECBF81BF3EFC217E91C39EBF163933D10DAE09F8CD15FD9CF2F6AB47E14FC281FF8F';
wwv_flow_api.g_varchar2_table(51) := 'E7F6C302824DB3CC4745B5D581AB7EA577FADBAB27608F714F2AB83018DBB1717CB0172F9DDC8559170E62DDE47A4C292BC724BB0B13EC2E545A1D189446E0F58FE0B6DF87AF7BAF615FCF25ECEDBF96BA2FD5C04E56668F62164024DFB777F3FD1CC02E';
wwv_flow_api.g_varchar2_table(52) := 'B25A2C1C9064E82C43B17FCA9234C13289168103924416ACFE7CF9739FA9659CEE9B0DFF74257656CCB1CA3F3F483EEFACBBC81C86B7C1C5AEAB91488DA96C2C9B357C1396F8592A362D4E3DBFE6DE8C3429E98A816473FD8DBF3CAC25314FE68D87F9F2';
wwv_flow_api.g_varchar2_table(53) := '96A73F2F6BAE5A6E0C0CCA8FC1459319C1ED739596D70FC5159C72E7602C906C30236A19FA83E7F6F68CBA5C9911DCDCA97C342A4894FEC29D42D46646D6E40E3E920549213658C6E92223829B831A4CB28541CC60067144EE5338984DF507877460AD8C';
wwv_flow_api.g_varchar2_table(54) := '593988C1CADF776026D9C240B88CD345861AAC9CFC90BA003A2E56B800820C860C040FD6FC8E3E471F4A06658095559AE9AB8ABEF2B09620CDEF44E1CA75581EE55FFC3C708C3C47C7C5BA573D1364B1C205808EFB61EFD29671BAC874AA9240C400B06C';
wwv_flow_api.g_varchar2_table(55) := 'F73BEB21D066B1C255094EE3C98AB10FEA875ADED094BF263E64C7227341EA4C0BA9332EA46CE64AE10F205973153147CCC17BB41B938100A2D06528221BB339C1320BF40DF482F8B97DF77FE77D253C5CC6E920735135022CDFB379A924611D11553164';
wwv_flow_api.g_varchar2_table(56) := '59310F31A6A519502AB2103E53F04372A53C2D608840F02058C1B002B080208259004860B04AAAC2164102230042008C0010BA9610D2669901414BA396FDB0B5A0A0454128AD2A74ECCEA4968244DB6FA86943F1326400044160E61E8B05FFB377C5735F';
wwv_flow_api.g_varchar2_table(57) := '44976DBA30A62E1A20888A659FFE4C80C2BC008448B6060FF5B705E18FCE55526428640482C788E63AA0B94FB52FDA239413CD59D73CEC5BF96CEEFA080695E9FF03882205E543B50DE60000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72361260646797246)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/xls.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000001B569545874584D4C3A636F6D2E61646F62652E786D7000000000003C3F787061636B657420626567696E3D22EFBBBF222069643D2257354D304D704365686948';
wwv_flow_api.g_varchar2_table(2) := '7A7265537A4E54637A6B633964223F3E0A3C783A786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E352E30223E0A203C7264663A52444620786D6C6E733A7264663D22';
wwv_flow_api.g_varchar2_table(3) := '687474703A2F2F7777772E77332E6F72672F313939392F30322F32322D7264662D73796E7461782D6E7323223E0A20203C7264663A4465736372697074696F6E207264663A61626F75743D22220A20202020786D6C6E733A786D703D22687474703A2F2F';
wwv_flow_api.g_varchar2_table(4) := '6E732E61646F62652E636F6D2F7861702F312E302F220A20202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F220A202020786D703A43726561746F72546F6F6C3D2241646F626520496D6167';
wwv_flow_api.g_varchar2_table(5) := '655265616479220A202020746966663A4F7269656E746174696F6E3D2231222F3E0A203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A3C3F787061636B657420656E643D2272223F3EAFC2E87B000001856943435073524742204945433631';
wwv_flow_api.g_varchar2_table(6) := '3936362D322E31000028917591BF4B425114C73F6A51A411914343838134844659486DA58415226206F663D1973F02ADC77B4A446343AB83433F6849A2A5B9B6E81F0882A09A22688D86829688D7791A1891E772EFFDDCEF3DE7DC7BCF056B22AF14F496';
wwv_flow_api.g_varchar2_table(7) := '6128AC17B55828E04A2C2EB9DA9EB060A79B7E1C494557A7A2D1304DEDE34EBCC56EBD66AEE67EFF9A7D35AD2B6069179E5454AD283C231CD92CAA26EF093B955C7255F84CD8A3C905851F4C3D55E71793B335B69A399D5A3C1614760ABBB2BF38F58B95';
wwv_flow_api.g_varchar2_table(8) := '9C56101E137617F225E5E73EE64B1CE9F585795397DE874E8C10015CCC324D103F234CC8E8C78B8F2159D124DE578B8FB021B18A8C2A5B68AC912547118FA825C99E9639237A5A5A5E3CC4CC3FF85B5B3D33EAAB9FE09883D667C3781F84B643F8DA358C';
wwv_flow_api.g_varchar2_table(9) := 'CF63C3F8AA824DEA725569C46F5460FC55F47243731F41D70E9C5F36B4D4095C94A1F7514D6AC99A64936ECD64E0ED143A17A1E7063A96EB75FBD9A77A0FF16D085FC3FE010C887FD7CA37D50B67246E1BC0F9000000097048597300000B1300000B1301';
wwv_flow_api.g_varchar2_table(10) := '009A9C18000013C549444154789CED5D7B701C457AFF7DB3B3BBDA871EB66C49B685FC36B62CF02BC60FDE70573C620938900E7C38070726A94B8ACA5DFE49AA5261A9AB2495ABE252A94A15452C53771849C6822B82EF28C2E580239897B12CD9771863';
wwv_flow_api.g_varchar2_table(11) := '5BD89200CBB22D5B5AAD1EBB335FFE98DDD999DDD9D53E66B5BBDAFDA9A666A6BBA7F7EBFECDD7DD5F7FDD23C00C309329F964131E8F0046FE972302E917889940C400B0EDC3D61B24094D4454C19065212AB100400E9E11BC8E9726D9F8587111F72480';
wwv_flow_api.g_varchar2_table(12) := 'C132CB282911848B6E877DCF9B1B7F70AE990F583AD12C87CA331B20A6F5B486DC2DEFEF794896B1C75AE6AA0060C6AB9371C800440644893735F61CF87127B57C75DBBB1EF13D6669B6909C16C1CDE8143A0169D3FB2F2C80401E6B456985FFCAA81F0C';
wwv_flow_api.g_varchar2_table(13) := '01048001F50CE849D7C645A6318A23CD735AC47B36328D3E2DC9CCB2248AE382DB75B73C15E8B8FF68C7C3AF6F78E4EC6DEF62D6909C9E06772A272B2CCB187C6D60640C4172953638448A913647C65192714679C5FB4DE3701100D81FF0DA2ADC5BA6AE';
wwv_flow_api.g_varchar2_table(14) := '7ADB1A7B0E3C7A705DCB57B385E4B408EE6CFE9C01800589C0160211984094170D34002230606180A746C6D85AEADC1E18F5B535F61CF8C16C21397A1C940C3AEB090048B630283406CDA7BA6040115B0033F9477C9258EADC4692D4DE7464DF8AF76EF7';
wwv_flow_api.g_varchar2_table(15) := '049AD129E4B395901EC1410D86154A3D31902FCAAB409195414C820010937FD42759CB9C5B4162FB8EA36D2B3BA945BAEDBD672DF94A727A04E319FD6D5E560182763C034C0200F25F1D93ACA58ECD020B6D4D470EE4B526A749F02C41A88F55DA200104';
wwv_flow_api.g_varchar2_table(16) := 'F28FF8246BA96333C8AF6A723E926C1EC1A43BE517A2490B93EC766D1618FB1B3F6B5F9D8F249B4730EB4EF905E351B242B2D727594B5D1B4940473E926CBA06E7256293A5F4C9233EC9EA76AECF47920BBB0FE6A0E2C6B773C39AEC76AE8780FDF775BD';
wwv_flow_api.g_varchar2_table(17) := '5CDF492D527367EE936C6E139D6FED3325CC8DA2C95E9F64733BD7C92CBCF240CFFE86CE96DC27D95C0DCED962C640722F6498E43267832CCB1D7F9E07249BDB07739E719CBCB06A9F2CBA9C0D4220F74936B789A6FC6BA553800001E41FF549B6526783';
wwv_flow_api.g_varchar2_table(18) := '2873C78EAEFDEB54923D9E9C1AD71447D140F22B5218021304BFD71710DD8E0681E5FD4D873B3674B6B448CDF5F5944B24A729C8B3E1CB7C1C64859082B728E831B3F8477D016B997335046E6FEACE3D92CD9B8B26E48F1673C4397528248F044996B8BD';
wwv_flow_api.g_varchar2_table(19) := 'F1B37D1B3B5B5A24CF33CF2017482E4C334975FE9B223081829A5CEA5C4D82A5A3F1E8CB9B3D44B2E719649DE4F4567444225F34588569026B9BEB55FED1B1F6C6A32FEFF4D0A3873DCC820710E0F118AD20CC38B2DE84E404CC316F144D1EF105AC6ED7';
wwv_flow_api.g_varchar2_table(20) := '0A62A1ADF1D3EC6B72916020A54156AC9CD4E6DAED5C49A2D0767F77DB0D1EF2648D64D37F30EF5A69C0EC85FB2AC9A2DBB95296B17F4757FBB66C916CFA8FE5CB384B07F317D511089680D71710DDAEA502D09E2D928B4D3490A9AD37048448762CC916';
wwv_flow_api.g_varchar2_table(21) := 'C9853D939598BB301D04491E0F886EC712023A1ABBDB6FF25070443D032417A61D1C42E2EEC2B47E054192AD6EC76292D1DED4D5764BC86CF27066492EBA0B6706614D7639AE01E8E510C91E3CC39924B9E82E9CD95F8B269988334972D15D38B3088EAE';
wwv_flow_api.g_varchar2_table(22) := '5592DB1B8FB4DF9149920B7B149D9DB79140B04863E37ED1ED5844847D8D3D5A92D9544ECC731702F9A7BEEA96D4195F89410C8801EFB85F74391652805FDED1D571A742324C25B930DD8521A866123338E2FDE460BCD63AE0C883F5F9F034CF86DC57A1';
wwv_flow_api.g_varchar2_table(23) := '7D14801818F3F945B77381007EE9BEAEB6EF80883D4472F3810316338A58D866920A221081B49A4C4AB0EEC5A5C883D4C7D5F878CF2298BFEE57C81AB4931732A8ADE948FBDD00D0D9D22299612717A699A4EEF22710094C02C904802C824C02B1EEA088';
wwv_flow_api.g_varchar2_table(24) := '7B410886090671893EAB8D139804B248BE8929ABDB5945027EF9408F42323C1E39DDEEC35C7F70BE8000C832C82F21E0972C637E6982002F732C3B2FF29B104671B1D24CF32C73A805601A1BF75289AD5A9A929FDB7EE885531FDEF897679A3B95CF6424';
wwv_flow_api.g_varchar2_table(25) := '553E0D0A8FE01017442059867F7CD2EE57EA414636DB2066B028DA48922412A85E90A916C099D057145285E904E77C2BAD2A1C01253665F1DC5440540437FAE24BBC12197D2526322EC16799956EDB26822529E0871048B668464893E067A342A62B564E';
wwv_flow_api.g_varchar2_table(26) := '4047B25D71364CFA9540D2369BD394442D2C45DC03093FAB3913910C992D60904A4CF03319A9C2DC1DFEF9046DE596D8083691C04CC1414DF83ADE11990E093C13F9AC7A66929949F7C200E1CF64A488C276176AC73F0E3B60B786EDD79C417A4A54B483';
wwv_flow_api.g_varchar2_table(27) := 'B52497D801BB4D09C86A59B43F1EDD0D2683C2B48323A16DAE1D36A024DB249B579185ED2ED4422B788996E499751A9B8DA2BB30126A731D22193356A84CFC4C61BB0B8D90039A6C260ADB5D180F869A9C7F052C6C77613CE846D7D924B96826650E5923';
wwv_flow_api.g_varchar2_table(28) := 'B96826CD1CB242722E9A49B31939D35C278F22C189224F492E129C0C0C49A69C26B94870B28824D9610BBB187310458253819664BB55213A47492E129C2AF284E4C2F607A78B3C20D9BC3559B9532603A4FBF6C5299C366BBB55394F4C69574B6615B374';
wwv_flow_api.g_varchar2_table(29) := '55A5D915ABCD6F9A3739C748CE833E386A3B4102C74CC913818C34D7E9CD45E7E8B2D9EC376D8941BBBC166937D7C62972692E1AE976C5F9EA928A2177929A3C8B1DFEF94A6C24D227D96CE400C1B381582D34E5C901132A8B04CF16AD3502854F89929C';
wwv_flow_api.g_varchar2_table(30) := '21DEB344F06C25560BD29D00C4273943559205820B81DC10526DAECD53E719FE186921911B428CE6DAC00B450657B9B3262B88D8EF5E21921B8241736DD3901C8471DDE58A1D1C97BF42263704833A08910C646C746DFA7F1F2D2249D8ACCACE46CACCB6';
wwv_flow_api.g_varchar2_table(31) := '10F3A62A632A69517BC3D076C4086F780B6D5BF5A7FC298E98C8B00617C98D8B10DFCCFAE65A57993936C82A623A90F12D01108570536D35E7D732682615B5375950067687E49837A95060FCF27328CA44DD308B60D25F17B5372D98A825E66A70517DCD';
wwv_flow_api.g_varchar2_table(32) := '8189FA61969994D783359108EB5C9558EEA840FFC428BEF00D63589ACAB658A6206D82B77CB0970016C2B371C6AFDFF5CEB9787E7D932EFEA7C77F8B8F472F44A5750A225EDBF410CAAD0E35EC85DE8FF1ABF3270000FFB6F256D4392B00000196B1EBD8';
wwv_flow_api.g_varchar2_table(33) := 'C19464DF59B50ADFA95A81E5EE79B05BF45531E0BB825F9C3E840F470775E15612D0B9E17BA82A2955C35E1D38865FF41D31FC8DE756DD8E6DF396A8F75DC303F89B13BF43944D9C2198D70733104FE063BECB387CB91F02917AFCC535EB0DD3EEACBE16';
wwv_flow_api.g_varchar2_table(34) := '736C4E35DDF0940FAF0C7EA9C62F729463A9BB124BDD9558E29A9B92C09E65DBF1F4CA9B505F5E13452E00D43A2BF0DCF5F7E227D76CD485FB59C68181E3BA72EC58B00615165B541ED73ACAB17DFE125DDA5FF677A7246FAA308BE084F269EDEB026B5E';
wwv_flow_api.g_varchar2_table(35) := '828D736AB1C93D4F97C646021E58D4A00BEB1C388609366F96E77BF396E3EE05ABA74D4720B4D4ADC7B6D26ABD3C43A7707E7C44BD778A36FC70E1DAA8E71FAF5DA76BB18E5CEEC767DEA1E905CCB141168183F94C23D81F7DC3F8E8E2595DD863B57A2D';
wwv_flow_api.g_varchar2_table(36) := '6EA95A894ABB4BBDBF383986F6C193268819C6BDD5ABA2C2CE8F8FE0C38B67E10D4CEAC209C0D3CBB6EA3A1E3FCBE818E8D1A56B5C588F324B78766289DD8D9BE72FD3A5D9DB7734AE5C1475913ECC2158C92721B1F6F41D85ACF19C6CAEACC3BA60332B';
wwv_flow_api.g_varchar2_table(37) := '12E1A145D7E9D21F1838862936EF5FEF8A4458513A5FBDEF1F1BC65F75FF371EE87A153F3DF90EEEF9B403FF7EEAFF74CF2C7557A2CEEED685BD36741ADF8C5F55EFDDA21DBB16D4ABF78F2FBA1E160A57EF6797FBD1357631AE6C1C75913ECC2238E129';
wwv_flow_api.g_varchar2_table(38) := 'AC13E357F0C150AF2EECF1A016DF3F6F196A1C656AF8D0A417FB4DD6DE8DAE7928D1F4B96F7C7B02DD6397D43AF5B38C03174E61C07745F7DC1AA7BEAF0F30A3AD4FDF9FDEB7702D5C8288855627EEA85EA98BDBDBD795B89039A6C1803AC84A0C7BFAF5';
wwv_flow_api.g_varchar2_table(39) := '5ABC65DE123438E7E0FBB5EB74E90EF49BABBD0050AD69FE01608ECD11958601BC75FE2446FD13B830318A7363C37059A227875FBFD8AB7B11CAAC25D855B3063F5CD400AB10FE9F1A9F5EEAC3D1B14BE6152209986507C7B28E0C716A62047FB87006B7';
wwv_flow_api.g_varchar2_table(40) := '57AF083E0CFC6CF59D58A0D5DE092FF65FF832460EA9E3946F5877BF63C11A0C4F8DA3F3C229DD40AEF5DB3FA1F5DB3FC5CD4B02635FDF51FCC3EADBD5B0076A1B6017C2D5CA005EEC8FDFF7661266693027DB6FECE93F0A49A39D5A7201E095811EF84D';
wwv_flow_api.g_varchar2_table(41) := 'D65E00383D31824939FC31F5326B09FE7AC576BCFE672D78BA763D2A457B52F9BD71E92B9C1B0BBF34E556074A34DA7EF8521FBAB3A4BD4016F707F74E8EE2DDC1D386718313A378E5C22913848A46801907BFFE3C2ABCC2E6C0CEC51BF1EBCDDFC7BFAC';
wwv_flow_api.g_varchar2_table(42) := 'B8191B5C9509E5C700F6C5181D3314D3309B308360C5C9C5BAFB84B067A01B01395A4B5FE93F9611ED0DE1F9816E5C9C1C338CB30B22EEA85E89E7D7DF8797AEDB81ADA555D3E6F7DBCB67D1EB8DD6D24F2E9DC331DFE5B4E54D07E6119C02FA26BDB830';
wwv_flow_api.g_varchar2_table(43) := '39AA0B9358C66F2EF5C678C21C8CC9013C7DFC4D7C65408A16ABCAAAF0B335DFC5AA92F2B8E918C08991C1A8F07786522C478E994980F22F6938D966BAA97229163AF4956721013BABA79F654A17BD93A378FCD86FF05FBD1FA33FC224D2A2D46AC7CFEB';
wwv_flow_api.g_varchar2_table(44) := 'BF1BB76FAEB13A70A7C1E449534DBC7224F8D58034618E0627652429B080B0AB6E8361DC83B5D7E9668532850996F0E2B79FA3E5E8AFF177C7DFC4DBE74F62C43F1195AEC65186A679CB63E6F364ED3A9D6D1D4243C502DC5EBED054999385591A9CF444';
wwv_flow_api.g_varchar2_table(45) := 'F183F397A336E8118A44A9B5043F5A789D615C26C0000E8D9CC73F9D39847B0F77E09FBF78278AE8156EE34157ADCD89BB6AAE8D99F78F166FCAEAF207F3CC2400CA7CC7F4CA6C25013B233C49DA693F00685A549FB4C9321D08C03AD75CEC98BB04BB17';
wwv_flow_api.g_varchar2_table(46) := '36E091AAE86635C08C8397CE6277CF1BBAB22C8BE1B5DA5DBB5E37A93134E9D50D1C5796CEC73D73172727682EF5C19FDCF40443E98313464BD54ADD94A45F96F0B77F7C0B8313E10197D362C3EE88992D33F0F3B577E11FD7DC812796DE804763741100';
wwv_flow_api.g_varchar2_table(47) := '706ED2ABB36FAF71CE8125421797DA4B71678DFE25D977AE0BEF4498788FD56D8C78761A0673AC0F069278E76C24E09108ED7DFBFC49F44D8D617FBFDE4373CF82D55864739A23211421CF8C8647CE957697EAE830824B0CFB78FD2C418A28E6EE6BD643';
wwv_flow_api.g_varchar2_table(48) := 'D43814BE19BF8AD786CEA0B55F6FFED5B9E6E0FE797ACFD2B4829A844C2CB589FBFF681EAD598D799AF9E02959C2DE816300A2FDAC7641C453B5C68B0252C5975EBD47E7E9A55BA3341300EEAF5C86F91A0FD2C509AF2E7E5549396EAB5AA10B6BEBEB86';
wwv_flow_api.g_varchar2_table(49) := '0446DFD4187E1FA1C5BBEA36C04A0212622F07D76429524F23985310D15C7BBD2EECEDF327F18DDF0740E9FF3A067AF0939537ABF177D6ACC2AFBE3E8EDE087B39040B09786241B4B33D12FF7BF91CCE4D7A7168B81F0FD7855F9AB5E535686DB8172FF5';
wwv_flow_api.g_varchar2_table(50) := '77E3A46F18F36D25B86DEE623C1421E7A7C3FDBAFBDD751B206876060EF8AEE0F58B61BBB7B5BF1B7754AD50FBE71A47191EAE5A857D8327A695D54C98FB19A5695ECE5D356B3047D3E44E4A01B44638CE5F1B3A8D876BD7A973D3220978AA6E03FEFED4';
wwv_flow_api.g_varchar2_table(51) := 'FB86790A44D8BD6CCBB4A29D1BBF8A73935E1CF60EE1FD0B67704B55D8EC59535E8D7F2DBF2BE6B30159C6EB9A25436B9D7370D3FCA5BA346DFDDDBA26BC7F6A0CBF1F3CA55B39F2F035EBF0EAD0971897CDDF83140B195C0DA967DB2D8878B0566FFABC';
wwv_flow_api.g_varchar2_table(52) := '75FE0B9CF78FEBC202CCE88858B774CBFCE5A877189B54A9E03FCE1DC6B8E44F387D7B5F174E4D84BB8EDD751B75EEB3FEB1619DF686D03AD00DBF86CC4ABB0B8FD6D447A58B42CEF6C1514D7458D2C71736A0CC5AA2DE4F4801BCF8F531C36C5E1B3AA3';
wwv_flow_api.g_varchar2_table(53) := '339B04223CB5789369627E3DE5C38F7B0EE2F468FC15163233DAFB8EE285AF8FAB611B5C95D85AA9377BF6F5771B723230E5C3EF06F52ECFE6DAEBE11666EE0B9233D6445B050BFEE7DB2FD4FB13DE210C1ACC1A018A9FF53F7B3FC6AD1AFB91019459AC';
wwv_flow_api.g_varchar2_table(54) := '1891FCF8E0D2599CF1C6272712DF4CEA074927C6AFE0B1E307B1AB7A0DD696556191A31CD525A5189C18C569EF459C18BD88CF46CEE3CB09BD7DBED451AE2B874FF2E3E0A5AF62FEEEDE819EA841DC5AE75C7CE28D5E2EACC2C441567A59310B2092B77E';
wwv_flow_api.g_varchar2_table(55) := 'D47A2307F007B25A2C1C906444B50C85BE9525E1365726D122704092C8825B3FDEF6E4A1501DA7FACBA66F5D312E4A21EF6949BCECB9BAE82E8CE2B6B30824C754AE2E9B5510142A76910A4D8B932F6F6E7F8C3421E90A81E40CECE24E0359D815983B85';
wwv_flow_api.g_varchar2_table(56) := '371FB957B62CFD7BD9DC7ACBCD8149E531B96AD223B8B35EE979FD505CC1490F0E6603C9263312AAC3D0445B67675A43AEF4086EFE5CD9342A4894DAC21D203FB5999131B98359B22029C406EB3855A4457073508349B6308819CC20D6953E8983392B9F';
wwv_flow_api.g_varchar2_table(57) := '444F18AC953123073158F9FF0ECC245B1808D771AA48538395931F522F4027C532174090C19081E0C19AFBC873E4A11450065859A599BAAA44BF3CAC2548731F2F5CB90ECBA3FCC52E031B943932CE286DE84C90C53217003AE987BD575BC7A922DDA94A';
wwv_flow_api.g_varchar2_table(58) := '021103C096F7F73C04815AC532573938859C95C63EA81FA1FA86A6FE35F16A3BA62F0585665A2834E342CAC75C29BC01923557BAF5631C4CA3FD30190820522FD5884CCCE604EB2C30327615C44F7E72E3EE5795F0701DA782F445D508B0EDC3D61B2409';
wwv_flow_api.g_varchar2_table(59) := '4D4454C19065A5793098966640799185F099821BC995FAB4802102C1836005C30A65B5AD0866012081C1215215B6081218011002600400F55A82AACD32038296462DFBE1D682822D0AD46743421B0F26B514C4FBFC46E859355E860C802008CC7CC562C1';
wwv_flow_api.g_varchar2_table(60) := '1B1F6D7FF2D3C8BA4D15E6BC8B260812C2960FF60A5098170095646BF008DD5B10DE741E224586424620784C69AE039A74A1F6457BA825D19CA3BA87E002C399814975FAFF72408A6E7E3FA3080000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72361596826797249)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/xlsx.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000078000000780806000000396436D2000000017352474200AECE1CE9000000097048597300000B1300000B1301009A9C18000001CB69545874584D4C3A636F6D2E61646F62652E786D7000000000003C783A';
wwv_flow_api.g_varchar2_table(2) := '786D706D65746120786D6C6E733A783D2261646F62653A6E733A6D6574612F2220783A786D70746B3D22584D5020436F726520352E342E30223E0A2020203C7264663A52444620786D6C6E733A7264663D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_api.g_varchar2_table(3) := '313939392F30322F32322D7264662D73796E7461782D6E7323223E0A2020202020203C7264663A4465736372697074696F6E207264663A61626F75743D22220A202020202020202020202020786D6C6E733A786D703D22687474703A2F2F6E732E61646F';
wwv_flow_api.g_varchar2_table(4) := '62652E636F6D2F7861702F312E302F220A202020202020202020202020786D6C6E733A746966663D22687474703A2F2F6E732E61646F62652E636F6D2F746966662F312E302F223E0A2020202020202020203C786D703A43726561746F72546F6F6C3E41';
wwv_flow_api.g_varchar2_table(5) := '646F626520496D61676552656164793C2F786D703A43726561746F72546F6F6C3E0A2020202020202020203C746966663A4F7269656E746174696F6E3E313C2F746966663A4F7269656E746174696F6E3E0A2020202020203C2F7264663A446573637269';
wwv_flow_api.g_varchar2_table(6) := '7074696F6E3E0A2020203C2F7264663A5244463E0A3C2F783A786D706D6574613E0A292ECD3D00001602494441547801ED5D6B6C1CD775BEB30FBE769794A897294BB2644B7E488663A7B66559B52D3B4513F847625966D2A6ED8F26015AE44FD13FFD55';
wwv_flow_api.g_varchar2_table(7) := '20441BA0EE036E80A23F921A4183C494133A6D1AA0A9820431255B76245B711CA0696C43B223C9A42859121FCBD7BEA6DF7767EE7276B94BCEEE9C59EE52BCD2ECCCDCC7B9E79EEF9E73CFBD7766A89444B06D4B82CC8AD2181888A8D5D08E3221C6CAEE';
wwv_flow_api.g_varchar2_table(8) := '6BBFA5502CCB66C103278E3D88DB4FDBCA5E67D95641456A27D7A812E4AFA0EC8EF648E4A38D89AE7FFB8F8F1FFC6DFFDEBDD121DB2E98F6348A9730EB09A6791E70F79FF8F13380F4F95877AA4729E06D05231D66A30DED022EBA6C5BF5140A3F06CB5F';
wwv_flow_api.g_varchar2_table(9) := 'FEFE038F9C3BF4F2CBB1E14387F2AB05E4401ADC3F341419522AFFC889637D39A50662EB7B7AB2E31359082BA29A195FDA1BAA30FEE763D1D9482AF9C942363BF8D45BAFFFC10FEE3BF08106D9B65705C82246349B2BDC0A45B823373905E5B5092EE936';
wwv_flow_api.g_varchar2_table(10) := 'EFA1F9A389B1D1C12D0570D3F19EEEFD9142EE85FEB78FEF1A7EFCF1DCA1E1E1E86A189303013CD4DFAFC75EDB82B06C488A32E335A5D60A87E6D78E02682B3331A9E289E4C3F98CF5C291375EB975B5801C0860986802A9AC6894F0E2E08FC69CD1CD1F';
wwv_flow_api.g_varchar2_table(11) := 'C82A4C0F18D772C84E4DE5E3DDA903701B078FFCFCF81E82DC4F4BD4C2DE7520808D066B2435C42D02AE6153774F877B2B0251C0FA64A7D2F9782AB5DF8E475F20C84396956F65731D08E01215758DF282CC4A529BEBA69C49764E5A1EFA0F40393B3999';
wwv_flow_api.g_varchar2_table(12) := '8F27130F10E4FE33AFED6E654D960358434813DD8241CFE3C1BB3ED34924C830D70039AF0A83874FBD723B35B95F0DB59CB9160658AB42F3235CDE0BF5185BC2FB02C889C40356D47EF1C89B2FDF39647DB6E5401606581BBAE607D8986803B4D1E052CE';
wwv_flow_api.g_varchar2_table(13) := '1D90D3189393A9FB948A1D3DF2E66B2EC8ADE37809036C24572AA9A6BB2B02EB72E67AC915B8A77CE0784DE563C9E4BD58D371416E1D732D0CB0915CD3415ACA90411253241DDCB5F42ADC173539964CDC6B5BF9178FFCF2D57DDA5C6325AFD9A750B200';
wwv_flow_api.g_varchar2_table(14) := '579150A9749BE84EAFC9F8E2C7D1E4F4741E8B211FB373EAC5C36F9CBC7BE8B318939B1C6459807DC9AA8932D5D6211D90394F4E26EE86D21F6D0590C50136D6AF8960946405E6DA19931D900B4D0FB22CC07AA952529E21D3AAAF37465424A21D2F82AC';
wwv_flow_api.g_varchar2_table(15) := 'ACFC779F3A7DF2DEA2B9E683034D14849929994B365133ABB0624C74752FBA7241AE7811E4F474AE2D95DA1B89148E1E79E3F87D1AE4BD7B2DD5442007DA0F5ED47A088C32AB4F3116510B3FC230EA7AD135550890D156AE5DE7E2A9E49D380F02E4CF0F';
wwv_flow_api.g_varchar2_table(16) := '3DF0D85B03481BE026C5C0009F2958D1200BB011D88A36C947E5A617F2EC0926DA13B5E4259ACB1647BD203F75E6953F1EB0AC33CD02B22CC065025B523A2B9928D511398FC6BA357EA358BB8626A7EECCA6D3479F7EEBE41F01E4379A01645980A50417';
wwv_flow_api.g_varchar2_table(17) := '36F8465583F2CB79344006C67CD8019A0C90BB537B701E7CFAF4F0E79B01645980014C5099858DADA66F983416473B5926B2460E16164B34C81968321CAFDDD9E9F40B0079C53559D88B6EB1ED4283693D4E56E57E406576C6E444620F3CEDC1A7CFBCFA';
wwv_flow_api.g_varchar2_table(18) := '1034B930F015145801EF5A58835B649A644CB401C9D56083B789AEF30C4DC6988C29543C99DC8D33F69339261F7C7D25C66461805B649A64903426DAD5E072DCEB0498C51CC74B839CD805C76BF0F02F4E724C6E38C8E2263A80501A57B408AC5B65AD0B';
wwv_flow_api.g_varchar2_table(19) := '1D3E38451F6237329ABC134F600F3E73FAF8C3DA5CB37C83CCB530C046723E24B092598A1AECF2AB353894E74117404E2477162291A34F9F3EFEE80016400634C6E12F6BCA02DC22F816FBD682078C28837A3155EAC201799A63726287B22C78D71E90ED';
wwv_flow_api.g_varchar2_table(20) := '70419605584A248DA2D3B80EE9803CA51DAF6DF0AEBF4390B99439A0BE62D3F90AABC9E28443D383B02450A41B3ADA8E774D4D4E24B613E4C3A74F3C068DB607E09B8605B22CC03079A18BA90888C045496F2CB911205E9184A3C9D3D3D958A26BBB15B1';
wwv_flow_api.g_varchar2_table(21) := '060F9F39F9449820CB02DC5AF03A73BA220E0DEB9A0439969B9EC94293B75A76E1DB61822C0730E5D330191551097661945676A1C30F4F1AE42C34D980FCCC2F4E7C220C4D9603982C1B81F9696233E4311D92238B7E09CD308504EE14790F2679EFCBAF';
wwv_flow_api.g_varchar2_table(22) := '974A3769460558D691568C20C35C6F2D14AC6F3FF5E6F1DFD7206369B3FF7BDFC35B8FC1831CC0E4C5082C385F0DA25064981B05587E32DF1A414FE514CA7B9023EF7DF9F552E926CD01D5A1C338E73EEE2C6B26FAF0C0D7770E9F79E5534CE0D321128B';
wwv_flow_api.g_varchar2_table(23) := '21B200B78A067B7105AC11680CF18A44A305383E76D5031E6F495AB5FBF278D22C8FE3BD8E8BD89148249A9B99CDB425939BA296F5EFFD6FBFA641E6340A56239054C5D7A20371C3AEDB884026013241CD160AD1A9F4CC9C5285B45130C7149996B03778';
wwv_flow_api.g_varchar2_table(24) := 'AFC9A0F7DE5C33DE9BB7FCDEF42A93DFE475CF34DBE9741A9D6C4B2E9379EE891FFDE77B3F7BF2F059F3990C52AB270803EC4C934C13EA61A86165C024F9CCD8767B269B8DDAB3B3B6C240A822882D18E12FC78DC9577E663913578D86371DD7A81718C7';
wwv_flow_api.g_varchar2_table(25) := 'B14B918795B82B62DBDB50F26CC93BD8D5482D112F0C708B6C171A8140AED0624BB5B5C7612E1540062E888CCA8E5CA6BAE5CE540FAB2D866F86E472591BEF4F08043980D92111786A090D26B36454F34DDD893BB70664DAEFE5023B839F7C95E854284B';
wwv_flow_api.g_varchar2_table(26) := 'DB01EB11C5D98AC55D68DCCF645422E1274E0E602D0F1F42F1C35523F36896E1C81068828CB33D074DC667D27C8147A0EA0D656559E322DBE17EE8A6DE2A16D1AB9790532E406383552C539A0227C81D9D1813219A3200642A59824A08F5C902DCE2F83A';
wwv_flow_api.g_varchar2_table(27) := 'A25F4990E52DA02CC04B74CED64A7241EE5C214D16149638C0F27D50B0B5359102C83198EB06825CAFBFB654B36401E65463A9DA5A2ECD05B94163720843305E90120DAB0B5E473468131DAF066AB22424720013DBD588AF9676EB822C073007DFD53300';
wwv_flow_api.g_varchar2_table(28) := '2F562233856A314D9603982259B51AECE21D3AC8F202940578356BB0D1E91290F925624950E405280B308420CFA2916C139D8B20777013591864D9760A03BCDAA6494B08BB4540160658D25C2D21DC664922C87A31444A93E5E5270CF00D62A24B3A1840';
wwv_flow_api.g_varchar2_table(29) := 'D1F3640990E5073861806F2013ED05B989CDB530C0F226C62BC7A6BE6E52908501BE114DB4A7DB15C764EE423587772D0EF00DACC32ED21C9363EEDAF5CA832C0CB0BC93E0D18FD6B9D4E6BA1E90E5D543186079065B07D5324EEB0139840D6161806FF0';
wwv_flow_api.g_varchar2_table(30) := '31B80C63BD8C4973DD853139BABCB90EC3FE8903BCA6C365286BC7CB35D7CB806C33AF7010075898BFD5418EC045FD802CAFC3E200CBB3B83A30D67BA9313F20CBB6571C60792323DBE015A5C6779E7C69B21C97E200CBB1B60A2969F30690AB6AB2BC7A';
wwv_flow_api.g_varchar2_table(31) := '0803BC66A07D754B6A7225909B7F9AD4626F17FA4223844CD4831ABCEB201C886BB0BC9109D2BC262F5B0EB27E2F5996676180D7E0AD191E8FB9B662CB2F86D44A5F18E05AAB5FCBEFBC94EC19938541967B3FD8C56ACDCDAAB3D3C25CDB003712EB522A';
wwv_flow_api.g_varchar2_table(32) := '873785B3D93A09951613D7E035235D2AE09AEEF48A17CC74271EFFE18130A07FEBFF11D7E0FA59592BA9256040C6348A6140FFD6FF23ACC16B06BA7E28DC927A0A15984A9180B006CBCF8369F2EB35FB7E64C53C269F9F7A4CFEA204052F485B87E28589';
wwv_flow_api.g_varchar2_table(33) := 'A8FF2C0CB0F354A5207FAA0BAB3B58A207C87EC4BF20087E1D298B32E4C534D24B81F1BC9F8549E4F78A3A514FDC8DC3A92498BCCC9743A19CCB8D643B5921F991A669DA4EFA02C12BC2E0E4D8D8B7733975CDE6DF78ACB5E9B6DA800FA9E4C1D238C7B5';
wwv_flow_api.g_varchar2_table(34) := '2AE11EECD1A600EE3BF99C1A355FD6A9941DD56F030F37816612DFC2E10706E740B756AEAAB0115AB430C0B5C350AD659431617D126FD7F7E009C5BCD6467FE2A4B64721FA89425E039042792F664CE75F7AC68720D5FB998CBA8C7C87DA3B556F957A98';
wwv_flow_api.g_varchar2_table(35) := '3F830509E67B2B97551FE632EA56E4DD81630E69A4ED8FB36AAD75E2256894D7200CB00C8B982868D33983F3176EDAAEEEEC59AFE6F300CB27793E19D18E6DB95F4F5C535168DB6DA96E2CFD3A405000BC8E4113E7A1B1DF3A7F56FDEDE475F5D59BB6A9';
wwv_flow_api.g_varchar2_table(36) := 'FB7A7A514F0EF59455040473B0225348BB363FAFDE9D9E54FF357E551DCBCCAB47508FCC8C959C3194D5ED44D6FD2B0CB04C6F6613A9BD1CF3D6B7B5ABCD78E97A2E571D608EB7DE402E3A20F88FF0413382B5A5A34B6B2B81E57D01E7380146A749400B';
wwv_flow_api.g_varchar2_table(37) := 'B9F0DF8B7AB67476A93902ECD23354A9A1A4D9C7946EA53EDEBB513DB87EA3BA6BE4BCFA97A909F530CC7CC6CB409DD78E25E0AF5C1006D888A47E06CB9BE708D771402A512518D4AEAC36C7EEAB33008CE52ECDCFA183B4611CB6B566D224333F01B6A9';
wwv_flow_api.g_varchar2_table(38) := '7938338E8160CF60BCCF006064D1261C9FF9E5A573A063E40A39FD9DD218ACC2DDEB7AD51701ECD8FBEFAA9FCDCEA83B408FE63AB8048253D00D727F84010EDE40368FDA4BC6F02CA2FA3F6848060066E80021309D90F0CC8369BD6D1D6A5722893BA5C1';
wwv_flow_api.g_varchar2_table(39) := 'ECC01B7F63D0DE6357C7542FAEAF63DCBCA77BBDEAC2E201C1C53799D55998D95F4D8EABF7D00938C63344F1C5577C395AB5E1FE6A664E9DBEFE11343AAF52A0714B6742ED4CA6540C65B3363C02B8D3BB12DDEA990D5BD4E0C5736A0FB8E2A282D35D34';
wwv_flow_api.g_varchar2_table(40) := 'B99A7FD89E60141657290CF082F01757E53F46030C4192B9AF5DFE50152E9796657A02E9EF41DB6E83F0FF69E7ED7A4C25186DD0BA3968F38FC62EAAE7A6C6C190AD3E373FABFE3ED9AD92A0C8B21168203BCE9F5C7C5FED0398B743130D30CEF80C070D';
wwv_flow_api.g_varchar2_table(41) := 'CED7B3A317D5198CB377A063AC03DDBF823FF0892D5B0132BD739879D0DA05D01F8BB7AB3174A2CDA0350F4A0E50A53CFBB9331DD74F5EBF799A7E256B1E824C437BA7DD630A6782300A70C770FD179BB7AABBE184E1C3DE5A8338C6BEFED198FA9B2B97';
wwv_flow_api.g_varchar2_table(42) := 'D44310F86D0026019153E806440A879AC84F7F72C5B77C1B96F9F8D9E83E94DD8C631BF29D02D0DFBC3CA22EC132D041E320C07F4974B0DD787DF437B024FC4C6CF02042A4C886B0067B4558AC23D0450F84CBCF371BCAEC9134A8BFC48ECB3F6FEA53BF';
wwv_flow_api.g_varchar2_table(43) := '07EF972325CD661784FDEEE484FAFAA50BDA1477635CFC00F96244AB2C10F23680AC9DAEC5C9C80D0B82742E807402D083F136750596E11A80BEA5CB190E48D2C9E33048DEC8674572CCEC2B9896FACABC6C26F2241A82356E312B19886C061ACB15A739';
wwv_flow_api.g_varchar2_table(44) := 'A81AB5EDA730877F8631F7337DDB5507844FCF975EF3558CA72F8E9E573F8496DD03B3CA327990A4392D0FD43ED2D69EB5492CC9C6BA501E079DB193A8A30775F50068E398B1188783AB3836A0E1AC2B48FB8394354D283FCB6A3004441949324A5A3C48';
wwv_flow_api.g_varchar2_table(45) := 'B703DA340A61FE6EAC4D7DE1E69DAA0FD39F997C563B4574C27E3236A2FE6EFC9A7A049A4C70A9E9ECC18E81C645A550815946B1235D445D3C3472A0F287BD9BD5564CA572A88B34F98FF3E253E8583B311CB0230409D2B2232FB20057105690069BB26C';
wwv_flow_api.g_varchar2_table(46) := '381D9A598C73EF02EA67FBB6A97D5CFC80F0699EA3D0AC33572FABAF628CFC181C260A9E2B5F5CC35E36783141769A6C6A6D029DE44BF090D3D0DCF5B006BB6196F7612184D433A8B793160269A7B0E0710EE7C7D1E96651A78F1A97654932832CC05E61';
wwv_flow_api.g_varchar2_table(47) := '0972492DA4369E8697FCDCA69BD4A3187B695AF300BC331A57BF9D9952DF1839AFB5FB21009386FA71D8F5C54E1111E4C67FDED261EB6D6F579FBBF9164D83D3AA387C01D6C783D32D9AE39370E6FEF5DA15753F86076DEE11572487EB6608B20087D03A';
wwv_flow_api.g_varchar2_table(48) := '82D409B1BD0C53FCE798EA1CEEDB0150B1068C4589769C27B12EFCFD910BEAE86C5A3D81F1711AC057F0A9AACBBA422F60E7C1DF52D2F41DC8B82042878ADEB35213789CE65580FBECE805D58EBC9D30CF043884E657E7DB678A1CC0AEA0241B49921D10';
wwv_flow_api.g_varchar2_table(49) := 'DB084C22C7DD2F42A3B660F3814E15A72A14FAF0E54BEAAFA14507A1B9DCDD617059295E9BFBA57943AA9BC198E9190049678CCE16D7ADA7E1DC8D60D56A180B20FF88F5EBBB506063C0B9AF6632C41F39805DE150984B0BD25F6B4887E32EE7C1EF40C8';
wwv_flow_api.g_varchar2_table(50) := 'FFB07587DE74E0F847FA7168EFAFAE5F55CF6141E35E5CB743E39897659C80B11919D94033553040339DE3B4FEC5891DC5047AC8D4C88B33D3EA2598FD09808ABFB9A3AE6078389B9D573FC50208174F0EC04C738C0FB2B061EA0CF32C07B0CB25C52611';
wwv_flow_api.g_varchar2_table(51) := '4887027C359F515FC362C6C18D5BB460E900D1448F00806F7CF8813A9DCD68AF795C7BB6DE9AB1A384F204D50BEC420E2765D15F8E4334CD3357C59EC76ED439CC7B2300935EF51DB01ADC58309D49DA2C4BC96EA18DD25EB42BCCA08C52F41C778731BE';
wwv_flow_api.g_varchar2_table(52) := '7E39D5A33E8325423DEEC234C7A15D53187F5FC2F8F7CDE929B50FA6F90240F76A21EBA713B41107A75557518E34BD7C717F57217E060E520A69C5804CCC4B907F07637A02D73B006A9A75B00852392F272D2FBD62F90017E53C0620552C2AAEC145CA75';
wwv_flow_api.g_varchar2_table(53) := '5EB0916D10DD2500F32436E1FF74EB4E3DEE729FD6D9DBC13622B4753FA62CC33880C3828ABA122710ED58FE3A3F9D861396557BE09C750148B3E05180277C4FCF3AF583C81EF53F7096BECE6D45C32F197003811C415D1BA1B9BC76E6D4F2C09AFAC238';
wwv_flow_api.g_varchar2_table(54) := '8B035C14549DDCB23CA744BF01C07F893D576ED6732B909AC33928C1E534E5C10D9BAAD640A7A8139A9D8AC0B482E0EED43A4D23E782C4F3CE444ADD8CB9EDAFB1E9A066D21A6096A325A0176D56B8626E8378722FABD61B34210CFAB200A3F753018230';
wwv_flow_api.g_varchar2_table(55) := 'CAB2F45C49A51726B203E6117FD75745ED48C9F4472B9AFEA92256942125BD1002A2F80BAE00CF31AD04D2D911A2C3E670CB070058978D0EC4A741B82BC5942CC83839AAD423184D8EA5EB920518DC0565908DD4E3296CEF6578AD17302D8920921A4C13';
wwv_flow_api.g_varchar2_table(56) := 'C9F4E502B58F205D8283C4FC1DA0A1B512D7E44F030C0039F59984E9A79DBF8CBC176666F414AC13667D14CB8F1CB9BB91467E82B60B245624C8020C6952A04185C1679CEE0700FF8D69D0CFB13B544FE062C7343C61862E68AFB763D042D089E2583D0A';
wwv_flow_api.g_varchar2_table(57) := '2FFC7EA47FEBD245D57D65548FD35CB99A01F81328BF19D79C7E056D533D6D9028230BB004472E0DCE3D2FC08BE63E2CC13173D9E5AA3079E791711368305C7701E29D49E7F35E9C336FA36946BEFF453D63D47CC4E1AF45EBDDA1CD56543FFDB1A6C110';
wwv_flow_api.g_varchar2_table(58) := '880E82DD9C42EDC6D2E006FDC756010C90D1E40D4AA62E22E68DC33D9F5966149F8966D8EE9C8ABFBA08329026D7AAA8E75B00F456943269D4EE665D5F2E36C4C785AC06533A424103045A7A06EBA56BAECD99F599EBF2F352BCB879590F0FE7A94837D2';
wwv_flow_api.g_varchar2_table(59) := '93B61489564893059892120E2190ACC861A3EAA9587988917E87B6E55960AF777BFEF299D772344A027200530556AB1A340A8D10EA9103583367960D42E0F40620E9E887AC960803BC66A583F4C33046386180C3603188C85AB1ACAC0CE500265F38640D';
wwv_flow_api.g_varchar2_table(60) := '4C2B02543FCF5A76B2F8FA5E20AAC875FFD0D0029E5C23C08A90307F15EB5DAD915A765C7DE30A8C1B4A646C226B3807D2E0A1FE7ECD899DCF6B78C9D89A9B5583F4CBB26AD9E9253B8893324530322ECBEAFB3610C0A677613B8FC8721395BD8FA0AF1D';
wwv_flow_api.g_varchar2_table(61) := 'F5C8406F79393AA3650A411A19FB46B42CA3C84A56361639D75650EFC4BA53FBB2E313CE9B1D0BC6BBACCAB5DB8A1220AE9655800CA3B9898977629069C57C35460683814FAC5996EE72FB4FFCE448C4B69F8FA692EB340FC128D7D88C55905D4B116BEF';
wwv_flow_api.g_varchar2_table(62) := '93531378B6E14BA71EFDE44BBA551E19D7D3CAE03078183870E2D883B8FD346CF53ACBB69CF739EBE1EA462B83AD33DBB2B1856D8D435F7EF8FAA39F3A2D01AE9C1809F25A909580904CFF1F63870E1AD48ADEA90000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72362018596797252)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'img/zip.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2F2A0A415045582044726F707A6F6E65204A530A417574686F723A2044616E69656C20486F63686C6569746E65720A56657273696F6E3A20322E342E310A2A2F0A0A2F2A2A0A202A20676C6F62616C206E616D6573706163650A202A2F0A766172206170';
wwv_flow_api.g_varchar2_table(2) := '657844726F707A6F6E65203D207B0A20202F2A2A0A2020202A20706172736520737472696E6720746F20626F6F6C65616E0A2020202A2040706172616D207B737472696E677D2070537472696E670A2020202A204072657475726E207B626F6F6C65616E';
wwv_flow_api.g_varchar2_table(3) := '7D0A2020202A2F0A20207061727365426F6F6C65616E3A2066756E6374696F6E2870537472696E6729207B0A2020202076617220626F6F6C65616E3B0A202020206966202870537472696E672E746F4C6F776572436173652829203D3D20277472756527';
wwv_flow_api.g_varchar2_table(4) := '29207B0A202020202020626F6F6C65616E203D20747275653B0A202020207D0A202020206966202870537472696E672E746F4C6F776572436173652829203D3D202766616C73652729207B0A202020202020626F6F6C65616E203D2066616C73653B0A20';
wwv_flow_api.g_varchar2_table(5) := '2020207D0A2020202069662028212870537472696E672E746F4C6F776572436173652829203D3D202774727565272920262620212870537472696E672E746F4C6F776572436173652829203D3D202766616C7365272929207B0A202020202020626F6F6C';
wwv_flow_api.g_varchar2_table(6) := '65616E203D20756E646566696E65643B0A202020207D0A2020202072657475726E20626F6F6C65616E3B0A20207D2C0A20202F2A2A0A2020202A20636865636B20696620616E20696D616765202875726C29206578697374730A2020202A204070617261';
wwv_flow_api.g_varchar2_table(7) := '6D207B737472696E677D207055726C0A2020202A2040706172616D207B66756E6374696F6E7D2070476F6F640A2020202A2040706172616D207B66756E6374696F6E7D20704261640A2020202A2F0A2020696D6167654578697374733A2066756E637469';
wwv_flow_api.g_varchar2_table(8) := '6F6E287055726C2C2070476F6F642C207042616429207B0A20202020747279207B0A20202020202076617220696D67203D206E657720496D61676528293B0A202020202020696D672E6F6E6C6F6164203D2070476F6F643B0A202020202020696D672E6F';
wwv_flow_api.g_varchar2_table(9) := '6E6572726F72203D20704261643B0A202020202020696D672E737263203D207055726C3B0A202020207D206361746368202865727229207B0A202020202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E696D616765457869';
wwv_flow_api.g_varchar2_table(10) := '737473204572726F72272C20657272293B0A202020207D0A20207D2C0A20202F2A2A0A2020202A206275696C64732061206A732061727261792066726F6D206C6F6E6720737472696E670A2020202A2040706172616D207B737472696E677D2070436C6F';
wwv_flow_api.g_varchar2_table(11) := '620A2020202A2040706172616D207B6E756D6265727D207053697A650A2020202A2040706172616D207B61727261797D207041727261790A2020202A204072657475726E207B61727261797D0A2020202A2F0A2020636C6F623241727261793A2066756E';
wwv_flow_api.g_varchar2_table(12) := '6374696F6E2870436C6F622C207053697A652C2070417272617929207B0A202020206C6F6F70436F756E74203D204D6174682E666C6F6F722870436C6F622E6C656E677468202F207053697A6529202B20313B0A20202020666F7220287661722069203D';
wwv_flow_api.g_varchar2_table(13) := '20303B2069203C206C6F6F70436F756E743B20692B2B29207B0A2020202020207041727261792E707573682870436C6F622E736C696365287053697A65202A20692C207053697A65202A202869202B20312929293B0A202020207D0A2020202072657475';
wwv_flow_api.g_varchar2_table(14) := '726E207041727261793B0A20207D2C0A20202F2A2A0A2020202A20636F6E76657274732062696E617279417272617920746F2062617365363420737472696E670A2020202A2040706172616D207B61727261797D2070496E743841727261790A2020202A';
wwv_flow_api.g_varchar2_table(15) := '204072657475726E207B737472696E677D0A2020202A2F0A202062696E6172794172726179326261736536343A2066756E6374696F6E2870496E7438417272617929207B0A202020207661722064617461203D2027273B0A202020207661722062797465';
wwv_flow_api.g_varchar2_table(16) := '73203D206E65772055696E743841727261792870496E74384172726179293B0A20202020766172206C656E677468203D2062797465732E627974654C656E6774683B0A20202020666F7220287661722069203D20303B2069203C206C656E6774683B2069';
wwv_flow_api.g_varchar2_table(17) := '2B2B29207B0A20202020202064617461202B3D20537472696E672E66726F6D43686172436F64652862797465735B695D293B0A202020207D0A2020202072657475726E2062746F612864617461293B0A20207D2C0A20202F2A2A0A2020202A2053657420';
wwv_flow_api.g_varchar2_table(18) := '75706C6F61642070726F67726573732066756E6374696F6E0A2020202A2040706172616D207B6F626A6563747D20704576656E740A2020202A2040706172616D207B6F626A6563747D207044726F707A6F6E650A2020202A2040706172616D207B6F626A';
wwv_flow_api.g_varchar2_table(19) := '6563747D207046696C650A2020202A2F0A202073657455706C6F616450726F67726573733A2066756E6374696F6E28704576656E742C207044726F707A6F6E652C207046696C6529207B0A202020207661722070657263656E74436F6D706C6574653B0A';
wwv_flow_api.g_varchar2_table(20) := '2020202069662028704576656E7429207B0A20202020202070657263656E74436F6D706C657465203D2028704576656E742E6C6F61646564202F20704576656E742E746F74616C29202A203130303B0A2020202020206966202870657263656E74436F6D';
wwv_flow_api.g_varchar2_table(21) := '706C657465203E2031303029207B0A202020202020202070657263656E74436F6D706C657465203D203130303B0A2020202020207D0A2020202020207046696C652E75706C6F6164203D207B0A202020202020202070726F67726573733A207065726365';
wwv_flow_api.g_varchar2_table(22) := '6E74436F6D706C6574652C0A2020202020202020746F74616C3A20704576656E742E746F74616C2C0A2020202020202020627974657353656E743A20704576656E742E6C6F616465640A2020202020207D3B0A202020207D20656C7365207B0A20202020';
wwv_flow_api.g_varchar2_table(23) := '202070657263656E74436F6D706C657465203D203130303B0A2020202020207046696C652E75706C6F6164203D207B0A202020202020202070726F67726573733A2070657263656E74436F6D706C6574652C0A2020202020202020627974657353656E74';
wwv_flow_api.g_varchar2_table(24) := '3A207046696C652E75706C6F61642E746F74616C0A2020202020207D3B0A202020207D0A202020207044726F707A6F6E652E656D6974282775706C6F616470726F6772657373272C207046696C652C2070657263656E74436F6D706C6574652C20704669';
wwv_flow_api.g_varchar2_table(25) := '6C652E73697A65202F2028313030202F2070657263656E74436F6D706C65746529293B0A20207D2C0A20202F2A2A0A2020202A205365742075706C6F61642070726F67726573732066756E6374696F6E20666F72206368756E6B65642075706C6F61640A';
wwv_flow_api.g_varchar2_table(26) := '2020202A2040706172616D207B6F626A6563747D20704576656E740A2020202A2040706172616D207B6F626A6563747D207044726F707A6F6E650A2020202A2040706172616D207B6E756D6265727D207043757272656E744368756E6B0A2020202A2040';
wwv_flow_api.g_varchar2_table(27) := '706172616D207B6E756D6265727D20704368756E6B436F756E740A2020202A2040706172616D207B6F626A6563747D207046696C650A2020202A2F0A202073657455706C6F616450726F67726573734368756E6B65643A2066756E6374696F6E28704576';
wwv_flow_api.g_varchar2_table(28) := '656E742C207044726F707A6F6E652C207043757272656E744368756E6B2C20704368756E6B436F756E742C207046696C6529207B0A202020207661722070657263656E74436F6D706C6574653B0A2020202069662028704576656E7429207B0A20202020';
wwv_flow_api.g_varchar2_table(29) := '202070657263656E74436F6D706C657465203D20287043757272656E744368756E6B202F20704368756E6B436F756E7429202A203130303B0A20202020202070657263656E74436F6D706C657465203D2070657263656E74436F6D706C657465202B2028';
wwv_flow_api.g_varchar2_table(30) := '28704576656E742E6C6F61646564202F20704576656E742E746F74616C29202A2031303029202F20704368756E6B436F756E743B0A2020202020206966202870657263656E74436F6D706C657465203E2031303029207B0A202020202020202070657263';
wwv_flow_api.g_varchar2_table(31) := '656E74436F6D706C657465203D203130303B0A2020202020207D0A2020202020207046696C652E75706C6F6164203D207B0A202020202020202070726F67726573733A2070657263656E74436F6D706C6574652C0A2020202020202020746F74616C3A20';
wwv_flow_api.g_varchar2_table(32) := '704576656E742E746F74616C202A20287043757272656E744368756E6B202F20704368756E6B436F756E74292C0A2020202020202020627974657353656E743A20704576656E742E6C6F61646564202A20287043757272656E744368756E6B202F207043';
wwv_flow_api.g_varchar2_table(33) := '68756E6B436F756E74290A2020202020207D3B0A202020207D20656C7365207B0A20202020202070657263656E74436F6D706C657465203D20313030202A20287043757272656E744368756E6B202F20704368756E6B436F756E74293B0A202020202020';
wwv_flow_api.g_varchar2_table(34) := '6966202870657263656E74436F6D706C657465203E2031303029207B0A202020202020202070657263656E74436F6D706C657465203D203130303B0A2020202020207D0A2020202020207046696C652E75706C6F6164203D207B0A202020202020202070';
wwv_flow_api.g_varchar2_table(35) := '726F67726573733A2070657263656E74436F6D706C6574652C0A2020202020202020627974657353656E743A207046696C652E75706C6F61642E746F74616C202A20287043757272656E744368756E6B202F20704368756E6B436F756E74290A20202020';
wwv_flow_api.g_varchar2_table(36) := '20207D3B0A202020207D0A202020207044726F707A6F6E652E656D6974282775706C6F616470726F6772657373272C207046696C652C2070657263656E74436F6D706C6574652C207046696C652E73697A65202F2028313030202F2070657263656E7443';
wwv_flow_api.g_varchar2_table(37) := '6F6D706C65746529293B0A20207D2C0A20202F2A2A0A2020202A204173796E6368726F6E6F7573204C6F6F702046756E6374696F6E0A2020202A2040706172616D207B6E756D6265727D2070497465726174696F6E730A2020202A2040706172616D207B';
wwv_flow_api.g_varchar2_table(38) := '66756E6374696F6E7D207046756E6374696F6E0A2020202A2040706172616D207B66756E6374696F6E7D2063616C6C6261636B0A2020202A2F0A20206173796E634C6F6F703A2066756E6374696F6E2870497465726174696F6E732C207046756E637469';
wwv_flow_api.g_varchar2_table(39) := '6F6E2C2063616C6C6261636B29207B0A2020202076617220696E646578203D20313B0A2020202076617220646F6E65203D2066616C73653B0A20202020766172206C6F6F70203D207B0A2020202020206E6578743A2066756E6374696F6E2829207B0A20';
wwv_flow_api.g_varchar2_table(40) := '2020202020202069662028646F6E6529207B0A2020202020202020202072657475726E3B0A20202020202020207D0A202020202020202069662028696E646578203C3D2070497465726174696F6E7329207B0A20202020202020202020696E6465782B2B';
wwv_flow_api.g_varchar2_table(41) := '3B0A202020202020202020207046756E6374696F6E286C6F6F70293B0A20202020202020207D20656C7365207B0A20202020202020202020646F6E65203D20747275653B0A2020202020202020202063616C6C6261636B28293B0A20202020202020207D';
wwv_flow_api.g_varchar2_table(42) := '0A2020202020207D2C0A202020202020697465726174696F6E3A2066756E6374696F6E2829207B0A202020202020202072657475726E20696E646578202D20313B0A2020202020207D2C0A20202020202073746F703A2066756E6374696F6E2829207B0A';
wwv_flow_api.g_varchar2_table(43) := '2020202020202020646F6E65203D20747275653B0A202020202020202063616C6C6261636B28293B0A2020202020207D0A202020207D3B0A202020206C6F6F702E6E65787428293B0A2020202072657475726E206C6F6F703B0A20207D2C0A20202F2A2A';
wwv_flow_api.g_varchar2_table(44) := '0A2020202A2066696C65206D616E6970756C6174696F6E206265666F72652075706C6F6164696E672C206C696B6520696D61676520726573697A650A2020202A2040706172616D207B6F626A6563747D207044726F707A6F6E650A2020202A2040706172';
wwv_flow_api.g_varchar2_table(45) := '616D207B6F626A6563747D207046696C650A2020202A2040706172616D207B66756E6374696F6E7D2063616C6C6261636B0A2020202A2F0A202070726F6365737346696C653A2066756E6374696F6E287044726F707A6F6E652C207046696C652C206361';
wwv_flow_api.g_varchar2_table(46) := '6C6C6261636B29207B0A2020202069662028287044726F707A6F6E652E6F7074696F6E732E726573697A655769647468207C7C207044726F707A6F6E652E6F7074696F6E732E726573697A6548656967687429202626207046696C652E747970652E6D61';
wwv_flow_api.g_varchar2_table(47) := '746368282F696D6167652E2A2F2929207B0A20202020202076617220726573697A654D6574686F64203D207044726F707A6F6E652E6F7074696F6E732E726573697A654D6574686F643B0A202020202020696620287044726F707A6F6E652E6F7074696F';
wwv_flow_api.g_varchar2_table(48) := '6E732E726573697A655769647468202626207044726F707A6F6E652E6F7074696F6E732E726573697A6548656967687429207B0A2020202020202020726573697A654D6574686F64203D202763726F70273B0A2020202020207D20656C7365207B0A2020';
wwv_flow_api.g_varchar2_table(49) := '202020202020726573697A654D6574686F64203D2027636F6E7461696E273B0A2020202020207D0A2020202020207044726F707A6F6E652E726573697A65496D616765287046696C652C207044726F707A6F6E652E6F7074696F6E732E726573697A6557';
wwv_flow_api.g_varchar2_table(50) := '696474682C207044726F707A6F6E652E6F7074696F6E732E726573697A654865696768742C20726573697A654D6574686F642C2066756E6374696F6E2866696C6529207B0A202020202020202066696C652E6E616D65203D207046696C652E6E616D653B';
wwv_flow_api.g_varchar2_table(51) := '0A202020202020202066696C652E737461747573203D207046696C652E7374617475733B0A202020202020202066696C652E6163636570746564203D207046696C652E61636365707465643B0A202020202020202066696C652E70726F63657373696E67';
wwv_flow_api.g_varchar2_table(52) := '203D207046696C652E70726F63657373696E673B0A202020202020202066696C652E6C6173744D6F646966696564203D207046696C652E6C6173744D6F6469666965643B0A202020202020202066696C652E6C6173744D6F64696669656444617465203D';
wwv_flow_api.g_varchar2_table(53) := '207046696C652E6C6173744D6F646966696564446174653B0A202020202020202066696C652E70726576696577456C656D656E74203D207046696C652E70726576696577456C656D656E743B0A202020202020202066696C652E7072657669657754656D';
wwv_flow_api.g_varchar2_table(54) := '706C617465203D207046696C652E7072657669657754656D706C6174653B0A202020202020202066696C652E5F72656D6F76654C696E6B203D207046696C652E5F72656D6F76654C696E6B3B0A202020202020202063616C6C6261636B2866696C65293B';
wwv_flow_api.g_varchar2_table(55) := '0A2020202020207D293B0A202020207D20656C7365207B0A20202020202063616C6C6261636B287046696C65293B0A202020207D0A20207D2C0A20202F2A2A0A2020202A2066696C652075706C6F61642066756E6374696F6E20666F72206368756E6B65';
wwv_flow_api.g_varchar2_table(56) := '642075706C6F61640A2020202A2040706172616D207B737472696E677D2070526567696F6E49640A2020202A2040706172616D207B737472696E677D2070416A61784964656E7469666965720A2020202A2040706172616D207B6F626A6563747D207044';
wwv_flow_api.g_varchar2_table(57) := '726F707A6F6E650A2020202A2040706172616D207B61727261797D207046696C65730A2020202A2040706172616D207B6E756D6265727D20704368756E6B53697A650A2020202A2F0A202075706C6F6164447A46696C65734368756E6B65643A2066756E';
wwv_flow_api.g_varchar2_table(58) := '6374696F6E2870526567696F6E49642C2070416A61784964656E7469666965722C207044726F707A6F6E652C207046696C65732C20704368756E6B53697A6529207B0A202020202F2F20676F207468726F7567682066696C65730A20202020666F722028';
wwv_flow_api.g_varchar2_table(59) := '7661722069203D20303B2069203C207046696C65732E6C656E6774683B20692B2B29207B0A2020202020207661722066696C65203D207046696C65735B695D3B0A202020202020766172206F726746696C653B0A2020202020202F2F206173796E632072';
wwv_flow_api.g_varchar2_table(60) := '6573697A6520696D6167652066756E6374696F6E202D2D3E206F6E6C79207768656E206174747269627574657320617265207365740A2020202020206170657844726F707A6F6E652E70726F6365737346696C65287044726F707A6F6E652C207046696C';
wwv_flow_api.g_varchar2_table(61) := '65735B695D2C2066756E6374696F6E2870726F63657373656446696C6529207B0A20202020202020202F2F20726573697A6520696D6167653A2073617665206F726967696E616C2066696C65206F626A656374202F2070726F63657373656446696C6520';
wwv_flow_api.g_varchar2_table(62) := '666F722066696C655265616465720A20202020202020206966202870726F63657373656446696C6529207B0A202020202020202020206F726746696C65203D2066696C653B0A2020202020202020202066696C65203D2070726F63657373656446696C65';
wwv_flow_api.g_varchar2_table(63) := '3B0A20202020202020207D0A20202020202020202F2F2046696C65726561646572203D3E2066696C6520746F2042696E61727920746F206261736536340A202020202020202076617220726561646572203D206E65772046696C6552656164657228293B';
wwv_flow_api.g_varchar2_table(64) := '0A20202020202020207265616465722E6F6E6C6F6164203D202866756E6374696F6E287046696C6529207B0A2020202020202020202072657475726E2066756E6374696F6E286529207B0A202020202020202020202020696620287046696C6529207B0A';
wwv_flow_api.g_varchar2_table(65) := '20202020202020202020202020207661722066696C654368756E6B3B0A20202020202020202020202020207661722066696C654368756E6B4261736536343B0A20202020202020202020202020207661722063757272656E744368756E6B3B0A20202020';
wwv_flow_api.g_varchar2_table(66) := '20202020202020202020766172206368756E6B53697A65203D20704368756E6B53697A65207C7C20313034383537363B0A2020202020202020202020202020766172206368756E6B53746172743B0A202020202020202020202020202076617220636875';
wwv_flow_api.g_varchar2_table(67) := '6E6B456E643B0A20202020202020202020202020207661722066696C654368756E6B436F756E74203D204D6174682E6365696C2866696C652E73697A65202F206368756E6B53697A65293B0A0A20202020202020202020202020202F2F206C6F6F70206F';
wwv_flow_api.g_varchar2_table(68) := '76657220314D422066696C65206368756E6B730A20202020202020202020202020206170657844726F707A6F6E652E6173796E634C6F6F702866696C654368756E6B436F756E742C2066756E6374696F6E286C6F6F7029207B0A20202020202020202020';
wwv_flow_api.g_varchar2_table(69) := '20202020202063757272656E744368756E6B203D206C6F6F702E697465726174696F6E28293B0A202020202020202020202020202020206368756E6B5374617274203D206368756E6B53697A65202A202863757272656E744368756E6B202D2031293B0A';
wwv_flow_api.g_varchar2_table(70) := '202020202020202020202020202020206368756E6B456E64203D206368756E6B5374617274202B206368756E6B53697A653B0A202020202020202020202020202020202F2F204C6F6767696E670A20202020202020202020202020202020617065782E64';
wwv_flow_api.g_varchar2_table(71) := '656275672E6C6F672866696C652E6E616D65202B20272063757272656E744368756E6B272C2063757272656E744368756E6B293B0A20202020202020202020202020202020617065782E64656275672E6C6F672866696C652E6E616D65202B2027206368';
wwv_flow_api.g_varchar2_table(72) := '756E6B5374617274272C206368756E6B5374617274293B0A20202020202020202020202020202020617065782E64656275672E6C6F672866696C652E6E616D65202B2027206368756E6B456E64272C206368756E6B456E64293B0A0A2020202020202020';
wwv_flow_api.g_varchar2_table(73) := '20202020202020202F2F20736C6963652066696C6520616E64206275696C642062617365363420706572206368756E6B0A2020202020202020202020202020202066696C654368756E6B203D2066696C652E736C696365286368756E6B53746172742C20';
wwv_flow_api.g_varchar2_table(74) := '6368756E6B456E64293B0A2020202020202020202020202020202076617220726561646572203D206E65772046696C6552656164657228293B0A202020202020202020202020202020207265616465722E6F6E6C6F6164203D202866756E6374696F6E28';
wwv_flow_api.g_varchar2_table(75) := '66696C654368756E6B29207B0A20202020202020202020202020202020202072657475726E2066756E6374696F6E28654368756E6B29207B0A202020202020202020202020202020202020202066696C654368756E6B426173653634203D206170657844';
wwv_flow_api.g_varchar2_table(76) := '726F707A6F6E652E62696E61727941727261793262617365363428654368756E6B2E7461726765742E726573756C74293B0A20202020202020202020202020202020202020202F2F2073706C69742062617365363420636C6F6220737472696E6720746F';
wwv_flow_api.g_varchar2_table(77) := '20663031206172726179206C656E6774682033306B0A2020202020202020202020202020202020202020766172206630314172726179203D205B5D3B0A20202020202020202020202020202020202020206630314172726179203D206170657844726F70';
wwv_flow_api.g_varchar2_table(78) := '7A6F6E652E636C6F623241727261792866696C654368756E6B4261736536342C2033303030302C206630314172726179293B0A0A20202020202020202020202020202020202020202F2F20414A41582063616C6C20746F2075706C6F616420616E642070';
wwv_flow_api.g_varchar2_table(79) := '726F636573732066696C657320284E6F20617065782E7365727665722E706C7567696E206265636175736520352E3120646F65736EC2B47420737570706F727420786872290A202020202020202020202020202020202020202066696C652E786872203D';
wwv_flow_api.g_varchar2_table(80) := '20617065782E6A51756572792E616A6178287B0A2020202020202020202020202020202020202020202064617461547970653A202774657874272C0A20202020202020202020202020202020202020202020747970653A2027504F5354272C0A20202020';
wwv_flow_api.g_varchar2_table(81) := '20202020202020202020202020202020202075726C3A2077696E646F772E6C6F636174696F6E2E687265662E73756273747228302C2077696E646F772E6C6F636174696F6E2E687265662E696E6465784F6628272F663F703D2729202B203129202B2027';
wwv_flow_api.g_varchar2_table(82) := '7777765F666C6F772E616A6178272C0A202020202020202020202020202020202020202020206173796E633A20747275652C0A20202020202020202020202020202020202020202020747261646974696F6E616C3A20747275652C0A2020202020202020';
wwv_flow_api.g_varchar2_table(83) := '2020202020202020202020202020646174613A207B0A2020202020202020202020202020202020202020202020207830313A202755504C4F4144272C0A2020202020202020202020202020202020202020202020207830323A2066696C652E6E616D652C';
wwv_flow_api.g_varchar2_table(84) := '0A2020202020202020202020202020202020202020202020207830333A2066696C652E747970652C0A2020202020202020202020202020202020202020202020207830343A2063757272656E744368756E6B2C0A20202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(85) := '20202020202020207830353A2066696C654368756E6B436F756E742C0A2020202020202020202020202020202020202020202020206630313A2066303141727261792C0A202020202020202020202020202020202020202020202020705F726571756573';
wwv_flow_api.g_varchar2_table(86) := '743A2027504C5547494E3D27202B2070416A61784964656E7469666965722C0A202020202020202020202020202020202020202020202020705F666C6F775F69643A202476282770466C6F77496427292C0A202020202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(87) := '202020202020705F666C6F775F737465705F69643A202476282770466C6F7753746570496427292C0A202020202020202020202020202020202020202020202020705F696E7374616E63653A202476282770496E7374616E636527292C0A202020202020';
wwv_flow_api.g_varchar2_table(88) := '202020202020202020202020202020202020705F64656275673A202476282770646562756727290A202020202020202020202020202020202020202020207D2C0A202020202020202020202020202020202020202020202F2F2053554343455353206675';
wwv_flow_api.g_varchar2_table(89) := '6E6374696F6E0A20202020202020202020202020202020202020202020737563636573733A2066756E6374696F6E28704461746129207B0A2020202020202020202020202020202020202020202020202F2F20726573697A6520696D6167653A20726573';
wwv_flow_api.g_varchar2_table(90) := '746F7265206F726967696E616C2066696C65206F626A6563740A2020202020202020202020202020202020202020202020206966202870726F63657373656446696C6529207B0A202020202020202020202020202020202020202020202020202066696C';
wwv_flow_api.g_varchar2_table(91) := '65203D206F726746696C653B0A2020202020202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020202020202F2F20636865636B20736572766572207374617475730A2020202020202020202020202020';
wwv_flow_api.g_varchar2_table(92) := '2020202020202020202076617220764A736F6E52657475726E3B0A202020202020202020202020202020202020202020202020747279207B0A2020202020202020202020202020202020202020202020202020764A736F6E52657475726E203D206A5175';
wwv_flow_api.g_varchar2_table(93) := '6572792E70617273654A534F4E287044617461293B0A2020202020202020202020202020202020202020202020207D206361746368202865727229207B0A2020202020202020202020202020202020202020202020202020617065782E64656275672E6C';
wwv_flow_api.g_varchar2_table(94) := '6F6728276170657844726F707A6F6E652E75706C6F6164447A46696C65734368756E6B656420526573706F6E73652050617273654572726F72272C20657272293B0A2020202020202020202020202020202020202020202020202020764A736F6E526574';
wwv_flow_api.g_varchar2_table(95) := '75726E203D206A51756572792E70617273654A534F4E28277B2022737461747573223A20226572726F72222C20226D657373616765223A202275706C6F6164447A46696C65734368756E6B656420526573706F6E73652050617273654572726F72222C20';
wwv_flow_api.g_varchar2_table(96) := '22636F6465223A2022414A41582043616C6C6261636B20287044617461292050617273654572726F7222207D27293B0A2020202020202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020202020202F2F';
wwv_flow_api.g_varchar2_table(97) := '20726573706F6E7365206572726F720A20202020202020202020202020202020202020202020202069662028764A736F6E52657475726E2E737461747573203D3D20276572726F722729207B0A2020202020202020202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(98) := '2020202F2F2041504558206576656E740A2020202020202020202020202020202020202020202020202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E75706C6F6164447A46696C65734368756E6B6564204572726F72272C';
wwv_flow_api.g_varchar2_table(99) := '20764A736F6E52657475726E2E6D6573736167652C20764A736F6E52657475726E2E636F6465293B0A2020202020202020202020202020202020202020202020202020617065782E6576656E742E7472696767657228272327202B2070526567696F6E49';
wwv_flow_api.g_varchar2_table(100) := '642C202764726F707A6F6E652D75706C6F61642D6368756E6B2D6572726F72272C20764A736F6E52657475726E293B0A20202020202020202020202020202020202020202020202020202F2F2066696C65207374617475730A2020202020202020202020';
wwv_flow_api.g_varchar2_table(101) := '20202020202020202020202020202066696C652E737461747573203D2044726F707A6F6E652E4552524F523B0A20202020202020202020202020202020202020202020202020207044726F707A6F6E652E656D697428226572726F72222C2066696C652C';
wwv_flow_api.g_varchar2_table(102) := '20224461746162617365206572726F7220647572696E672066696C652075706C6F616422293B0A20202020202020202020202020202020202020202020202020207044726F707A6F6E652E656D69742822636F6D706C657465222C2066696C65293B0A20';
wwv_flow_api.g_varchar2_table(103) := '202020202020202020202020202020202020202020202020202F2F2070726F636573732066696C652071756575650A20202020202020202020202020202020202020202020202020207044726F707A6F6E652E70726F63657373517565756528293B0A20';
wwv_flow_api.g_varchar2_table(104) := '202020202020202020202020202020202020202020202020202F2F20726573706F6E736520737563636573730A2020202020202020202020202020202020202020202020207D20656C73652069662028764A736F6E52657475726E2E737461747573203D';
wwv_flow_api.g_varchar2_table(105) := '3D2027737563636573732729207B0A20202020202020202020202020202020202020202020202020202F2F2041504558206576656E740A2020202020202020202020202020202020202020202020202020617065782E64656275672E6C6F672827617065';
wwv_flow_api.g_varchar2_table(106) := '7844726F707A6F6E652E75706C6F6164447A46696C65734368756E6B65642053756363657373272C20764A736F6E52657475726E2E6D657373616765293B0A2020202020202020202020202020202020202020202020202020617065782E6576656E742E';
wwv_flow_api.g_varchar2_table(107) := '7472696767657228272327202B2070526567696F6E49642C202764726F707A6F6E652D75706C6F61642D6368756E6B2D73756363657373272C207044617461293B0A20202020202020202020202020202020202020202020202020202F2F2066696C6520';
wwv_flow_api.g_varchar2_table(108) := '73746174757320286F6E6C79206966206C617374206368756E6B20776173207375636365737366756C290A20202020202020202020202020202020202020202020202020206966202863757272656E744368756E6B203D3D2066696C654368756E6B436F';
wwv_flow_api.g_varchar2_table(109) := '756E7429207B0A202020202020202020202020202020202020202020202020202020202F2F207365742066696C6520696420746F2072657475726E2069640A2020202020202020202020202020202020202020202020202020202066696C652E6964203D';
wwv_flow_api.g_varchar2_table(110) := '20764A736F6E52657475726E2E69643B0A202020202020202020202020202020202020202020202020202020202F2F2066696C65207374617475730A2020202020202020202020202020202020202020202020202020202066696C652E73746174757320';
wwv_flow_api.g_varchar2_table(111) := '3D2044726F707A6F6E652E535543434553533B0A202020202020202020202020202020202020202020202020202020207044726F707A6F6E652E656D6974282273756363657373222C2066696C652C202773756363657373272C206E756C6C293B0A2020';
wwv_flow_api.g_varchar2_table(112) := '20202020202020202020202020202020202020202020202020207044726F707A6F6E652E656D69742822636F6D706C657465222C2066696C65293B0A202020202020202020202020202020202020202020202020202020202F2F2070726F636573732066';
wwv_flow_api.g_varchar2_table(113) := '696C652071756575650A202020202020202020202020202020202020202020202020202020207044726F707A6F6E652E70726F63657373517565756528293B0A20202020202020202020202020202020202020202020202020207D0A2020202020202020';
wwv_flow_api.g_varchar2_table(114) := '202020202020202020202020202020207D0A2020202020202020202020202020202020202020202020202F2F20726573697A6520696D6167653A20726573746F7265206F726967696E616C2066696C65206F626A6563740A202020202020202020202020';
wwv_flow_api.g_varchar2_table(115) := '2020202020202020202020206966202870726F63657373656446696C6529207B0A202020202020202020202020202020202020202020202020202066696C65203D2070726F63657373656446696C653B0A20202020202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(116) := '20202020207D0A2020202020202020202020202020202020202020202020202F2F206E657874206C6F6F7020697465726174696F6E0A2020202020202020202020202020202020202020202020206C6F6F702E6E65787428293B0A202020202020202020';
wwv_flow_api.g_varchar2_table(117) := '202020202020202020202020207D2C0A202020202020202020202020202020202020202020202F2F204552524F522066756E6374696F6E0A202020202020202020202020202020202020202020206572726F723A2066756E6374696F6E287868722C2070';
wwv_flow_api.g_varchar2_table(118) := '4D65737361676529207B0A2020202020202020202020202020202020202020202020202F2F20726573697A6520696D6167653A20726573746F7265206F726967696E616C2066696C65206F626A6563740A20202020202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(119) := '20202020206966202870726F63657373656446696C6529207B0A202020202020202020202020202020202020202020202020202066696C65203D206F726746696C653B0A2020202020202020202020202020202020202020202020207D0A202020202020';
wwv_flow_api.g_varchar2_table(120) := '2020202020202020202020202020202020202F2F2041504558206576656E740A202020202020202020202020202020202020202020202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E75706C6F6164447A46696C65734368';
wwv_flow_api.g_varchar2_table(121) := '756E6B6564204572726F72272C20704D657373616765293B0A202020202020202020202020202020202020202020202020617065782E6576656E742E7472696767657228272327202B2070526567696F6E49642C202764726F707A6F6E652D75706C6F61';
wwv_flow_api.g_varchar2_table(122) := '642D6368756E6B2D6572726F72272C20704D657373616765293B0A2020202020202020202020202020202020202020202020202F2F207365742066696C6520737461747573204552524F520A202020202020202020202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(123) := '66696C652E737461747573203D2044726F707A6F6E652E4552524F523B0A2020202020202020202020202020202020202020202020202F2F206275696C64206D65737361676520666F72206572726F722074656D706C6174650A20202020202020202020';
wwv_flow_api.g_varchar2_table(124) := '2020202020202020202020202020766172206D657373616765203D2022223B0A20202020202020202020202020202020202020202020202069662028704D65737361676529207B0A20202020202020202020202020202020202020202020202020206D65';
wwv_flow_api.g_varchar2_table(125) := '7373616765203D20704D6573736167653B0A2020202020202020202020202020202020202020202020207D20656C7365207B0A20202020202020202020202020202020202020202020202020206D657373616765203D20274572726F722070726F636573';
wwv_flow_api.g_varchar2_table(126) := '73696E672066696C65273B0A2020202020202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020202020207044726F707A6F6E652E656D697428226572726F72222C2066696C652C206D6573736167652C';
wwv_flow_api.g_varchar2_table(127) := '20786872293B0A2020202020202020202020202020202020202020202020207044726F707A6F6E652E656D69742822636F6D706C657465222C2066696C65293B0A2020202020202020202020202020202020202020202020202F2F2070726F6365737320';
wwv_flow_api.g_varchar2_table(128) := '66696C652071756575650A2020202020202020202020202020202020202020202020207044726F707A6F6E652E70726F63657373517565756528293B0A202020202020202020202020202020202020202020207D2C0A2020202020202020202020202020';
wwv_flow_api.g_varchar2_table(129) := '20202020202020202F2F2058485220666F722075706C6F61642070726F67726573730A202020202020202020202020202020202020202020207868723A2066756E6374696F6E2829207B0A20202020202020202020202020202020202020202020202058';
wwv_flow_api.g_varchar2_table(130) := '68724F626A203D20242E616A617853657474696E67732E78687228293B0A202020202020202020202020202020202020202020202020696620285868724F626A2E75706C6F616429207B0A20202020202020202020202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(131) := '205868724F626A2E75706C6F61642E6164644576656E744C697374656E6572282770726F6772657373272C2066756E6374696F6E286576656E7429207B0A202020202020202020202020202020202020202020202020202020206170657844726F707A6F';
wwv_flow_api.g_varchar2_table(132) := '6E652E73657455706C6F616450726F67726573734368756E6B6564286576656E742C207044726F707A6F6E652C2063757272656E744368756E6B2C2066696C654368756E6B436F756E742C206F726746696C65207C7C2066696C65293B0A202020202020';
wwv_flow_api.g_varchar2_table(133) := '20202020202020202020202020202020202020207D2C2066616C7365293B0A2020202020202020202020202020202020202020202020207D20656C7365207B0A2020202020202020202020202020202020202020202020202020617065782E6465627567';
wwv_flow_api.g_varchar2_table(134) := '2E6C6F6728276170657844726F707A6F6E652E75706C6F6164447A46696C65734368756E6B656420584852272C202755706C6F61642070726F6772657373206973206E6F7420737570706F727465642E27293B0A20202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(135) := '20202020202020207D0A20202020202020202020202020202020202020202020202072657475726E205868724F626A3B0A202020202020202020202020202020202020202020207D0A20202020202020202020202020202020202020207D293B0A202020';
wwv_flow_api.g_varchar2_table(136) := '2020202020202020202020202020207D3B0A202020202020202020202020202020207D292866696C654368756E6B293B0A202020202020202020202020202020207265616465722E72656164417341727261794275666665722866696C654368756E6B29';
wwv_flow_api.g_varchar2_table(137) := '3B0A0A20202020202020202020202020207D2C2066756E6374696F6E2829207B0A20202020202020202020202020202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E75706C6F6164447A46696C65734368756E6B6564204C';
wwv_flow_api.g_varchar2_table(138) := '6F6F7020656E64656427293B0A20202020202020202020202020207D293B0A20202020202020202020202020202F2F2069662066696C65206E6F7420666F756E643A2070726F636573732071756575650A2020202020202020202020207D20656C736520';
wwv_flow_api.g_varchar2_table(139) := '7B0A20202020202020202020202020207044726F707A6F6E652E70726F63657373517565756528293B0A2020202020202020202020207D0A202020202020202020207D3B0A20202020202020207D292866696C65293B0A20202020202020207265616465';
wwv_flow_api.g_varchar2_table(140) := '722E72656164417341727261794275666665722866696C65293B0A2020202020207D293B0A202020207D0A20207D2C0A20202F2A2A0A2020202A2066696C652075706C6F61642066756E6374696F6E207573696E6720466F726D4461746120414A41580A';
wwv_flow_api.g_varchar2_table(141) := '2020202A2040706172616D207B737472696E677D2070526567696F6E49640A2020202A2040706172616D207B737472696E677D2070416A61784964656E7469666965720A2020202A2040706172616D207B6F626A6563747D207044726F707A6F6E650A20';
wwv_flow_api.g_varchar2_table(142) := '20202A2040706172616D207B61727261797D207046696C65730A2020202A2F0A202075706C6F6164447A46696C6573466F726D446174613A2066756E6374696F6E2870526567696F6E49642C2070416A61784964656E7469666965722C207044726F707A';
wwv_flow_api.g_varchar2_table(143) := '6F6E652C207046696C657329207B0A202020202F2F20676F207468726F7567682066696C65730A20202020666F7220287661722069203D20303B2069203C207046696C65732E6C656E6774683B20692B2B29207B0A2020202020207661722066696C6520';
wwv_flow_api.g_varchar2_table(144) := '3D207046696C65735B695D3B0A202020202020766172206F726746696C653B0A2020202020202F2F206173796E6320726573697A6520696D6167652066756E6374696F6E202D2D3E206F6E6C79207768656E206174747269627574657320617265207365';
wwv_flow_api.g_varchar2_table(145) := '740A2020202020206170657844726F707A6F6E652E70726F6365737346696C65287044726F707A6F6E652C207046696C65735B695D2C2066756E6374696F6E2870726F63657373656446696C6529207B0A20202020202020202F2F20726573697A652069';
wwv_flow_api.g_varchar2_table(146) := '6D6167653A2073617665206F726967696E616C2066696C65206F626A656374202F2070726F63657373656446696C6520666F722066696C655265616465720A20202020202020206966202870726F63657373656446696C6529207B0A2020202020202020';
wwv_flow_api.g_varchar2_table(147) := '20206F726746696C65203D2066696C653B0A2020202020202020202066696C65203D2070726F63657373656446696C653B0A20202020202020207D0A20202020202020206966202866696C6529207B0A202020202020202020202F2F20666F726D446174';
wwv_flow_api.g_varchar2_table(148) := '610A2020202020202020202076617220666F726D44617461203D206E657720466F726D4461746128293B0A20202020202020202020666F726D446174612E617070656E642827705F72657175657374272C2027504C5547494E3D27202B2070416A617849';
wwv_flow_api.g_varchar2_table(149) := '64656E746966696572293B0A20202020202020202020666F726D446174612E617070656E642827705F666C6F775F6964272C202476282770466C6F7749642729293B0A20202020202020202020666F726D446174612E617070656E642827705F666C6F77';
wwv_flow_api.g_varchar2_table(150) := '5F737465705F6964272C202476282770466C6F775374657049642729293B0A20202020202020202020666F726D446174612E617070656E642827705F696E7374616E6365272C202476282770496E7374616E63652729293B0A2020202020202020202066';
wwv_flow_api.g_varchar2_table(151) := '6F726D446174612E617070656E642827705F6465627567272C20247628277064656275672729293B0A20202020202020202020666F726D446174612E617070656E642827463031272C2066696C652C2066696C652E6E616D65293B0A2020202020202020';
wwv_flow_api.g_varchar2_table(152) := '2020666F726D446174612E617070656E642827583031272C202755504C4F414427293B0A20202020202020202020666F726D446174612E617070656E642827583032272C2066696C652E6E616D65293B0A20202020202020202020666F726D446174612E';
wwv_flow_api.g_varchar2_table(153) := '617070656E642827583033272C2066696C652E74797065293B0A0A202020202020202020202F2F7365742075706C6F61642070726F6772657373203130250A202020202020202020207044726F707A6F6E652E656D6974282775706C6F616470726F6772';
wwv_flow_api.g_varchar2_table(154) := '657373272C2066696C652C2031302C2066696C652E73697A65202F203130293B0A0A202020202020202020202F2F20414A41582063616C6C20746F2075706C6F616420616E642070726F636573732066696C657320284E6F20617065782E736572766572';
wwv_flow_api.g_varchar2_table(155) := '2E706C7567696E206265636175736520352E3120646F65736EC2B47420737570706F727420786872290A2020202020202020202066696C652E786872203D20617065782E6A51756572792E616A6178287B0A202020202020202020202020646174615479';
wwv_flow_api.g_varchar2_table(156) := '70653A202774657874272C0A202020202020202020202020747970653A2027504F5354272C0A20202020202020202020202075726C3A2077696E646F772E6C6F636174696F6E2E687265662E73756273747228302C2077696E646F772E6C6F636174696F';
wwv_flow_api.g_varchar2_table(157) := '6E2E687265662E696E6465784F6628272F663F703D2729202B203129202B20277777765F666C6F772E616A6178272C0A2020202020202020202020206173796E633A20747275652C0A20202020202020202020202070726F63657373446174613A206661';
wwv_flow_api.g_varchar2_table(158) := '6C73652C0A202020202020202020202020636F6E74656E74547970653A2066616C73652C0A202020202020202020202020747261646974696F6E616C3A20747275652C0A202020202020202020202020646174613A20666F726D446174612C0A20202020';
wwv_flow_api.g_varchar2_table(159) := '20202020202020202F2F20535543434553532066756E6374696F6E0A202020202020202020202020737563636573733A2066756E6374696F6E28704461746129207B0A20202020202020202020202020202F2F20726573697A6520696D6167653A207265';
wwv_flow_api.g_varchar2_table(160) := '73746F7265206F726967696E616C2066696C65206F626A6563740A20202020202020202020202020206966202870726F63657373656446696C6529207B0A2020202020202020202020202020202066696C65203D206F726746696C653B0A202020202020';
wwv_flow_api.g_varchar2_table(161) := '20202020202020207D0A20202020202020202020202020202F2F20636865636B207374617475730A202020202020202020202020202076617220764A736F6E52657475726E3B0A2020202020202020202020202020747279207B0A202020202020202020';
wwv_flow_api.g_varchar2_table(162) := '20202020202020764A736F6E52657475726E203D206A51756572792E70617273654A534F4E287044617461293B0A20202020202020202020202020207D206361746368202865727229207B0A20202020202020202020202020202020617065782E646562';
wwv_flow_api.g_varchar2_table(163) := '75672E6C6F6728276170657844726F707A6F6E652E75706C6F6164447A46696C657320526573706F6E73652050617273654572726F72272C20657272293B0A20202020202020202020202020202020764A736F6E52657475726E203D206A51756572792E';
wwv_flow_api.g_varchar2_table(164) := '70617273654A534F4E28277B2022737461747573223A20226572726F72222C20226D657373616765223A202275706C6F6164447A46696C657320526573706F6E73652050617273654572726F72222C2022636F6465223A2022414A41582043616C6C6261';
wwv_flow_api.g_varchar2_table(165) := '636B20287044617461292050617273654572726F7222207D27293B0A20202020202020202020202020207D0A20202020202020202020202020202F2F20726573706F6E7365206572726F720A202020202020202020202020202069662028764A736F6E52';
wwv_flow_api.g_varchar2_table(166) := '657475726E2E737461747573203D3D20276572726F722729207B0A202020202020202020202020202020202F2F2041504558206576656E740A20202020202020202020202020202020617065782E64656275672E6C6F6728276170657844726F707A6F6E';
wwv_flow_api.g_varchar2_table(167) := '652E75706C6F6164447A46696C6573204572726F72272C20764A736F6E52657475726E2E6D6573736167652C20764A736F6E52657475726E2E636F6465293B0A20202020202020202020202020202020617065782E6576656E742E747269676765722827';
wwv_flow_api.g_varchar2_table(168) := '2327202B2070526567696F6E49642C202764726F707A6F6E652D75706C6F61642D6572726F72272C20764A736F6E52657475726E293B0A202020202020202020202020202020202F2F2066696C65207374617475730A2020202020202020202020202020';
wwv_flow_api.g_varchar2_table(169) := '202066696C652E737461747573203D2044726F707A6F6E652E4552524F523B0A202020202020202020202020202020207044726F707A6F6E652E656D697428226572726F72222C2066696C652C20224461746162617365206572726F7220647572696E67';
wwv_flow_api.g_varchar2_table(170) := '2066696C652075706C6F616422293B0A202020202020202020202020202020202F2F20726573706F6E736520737563636573730A20202020202020202020202020207D20656C73652069662028764A736F6E52657475726E2E737461747573203D3D2027';
wwv_flow_api.g_varchar2_table(171) := '737563636573732729207B0A202020202020202020202020202020202F2F207365742066696C6520696420746F2072657475726E2069640A2020202020202020202020202020202066696C652E6964203D20764A736F6E52657475726E2E69643B0A2020';
wwv_flow_api.g_varchar2_table(172) := '20202020202020202020202020202F2F2041504558206576656E740A20202020202020202020202020202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E75706C6F6164447A46696C65732053756363657373272C20764A73';
wwv_flow_api.g_varchar2_table(173) := '6F6E52657475726E2E6D657373616765293B0A20202020202020202020202020202020617065782E6576656E742E7472696767657228272327202B2070526567696F6E49642C202764726F707A6F6E652D75706C6F61642D73756363657373272C207044';
wwv_flow_api.g_varchar2_table(174) := '617461293B0A202020202020202020202020202020202F2F2066696C65207374617475730A2020202020202020202020202020202066696C652E737461747573203D2044726F707A6F6E652E535543434553533B0A202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(175) := '207044726F707A6F6E652E656D6974282273756363657373222C2066696C652C202773756363657373272C206E756C6C293B0A20202020202020202020202020207D0A20202020202020202020202020202F2F207365742066696C652073746174757320';
wwv_flow_api.g_varchar2_table(176) := '53554343455353202F2055504C4F414420313030250A20202020202020202020202020207044726F707A6F6E652E656D6974282775706C6F616470726F6772657373272C2066696C652C203130302C2066696C652E73697A65293B0A2020202020202020';
wwv_flow_api.g_varchar2_table(177) := '2020202020207044726F707A6F6E652E656D69742822636F6D706C657465222C2066696C65293B0A20202020202020202020202020202F2F20726573697A6520696D6167653A20726573746F7265206F726967696E616C2066696C65206F626A6563740A';
wwv_flow_api.g_varchar2_table(178) := '20202020202020202020202020206966202870726F63657373656446696C6529207B0A2020202020202020202020202020202066696C65203D2070726F63657373656446696C653B0A20202020202020202020202020207D0A2020202020202020202020';
wwv_flow_api.g_varchar2_table(179) := '2020202F2F2070726F636573732066696C652071756575650A20202020202020202020202020207044726F707A6F6E652E70726F63657373517565756528293B0A2020202020202020202020207D2C0A2020202020202020202020202F2F204552524F52';
wwv_flow_api.g_varchar2_table(180) := '2066756E6374696F6E0A2020202020202020202020206572726F723A2066756E6374696F6E287868722C20704D65737361676529207B0A20202020202020202020202020202F2F20726573697A6520696D6167653A20726573746F7265206F726967696E';
wwv_flow_api.g_varchar2_table(181) := '616C2066696C65206F626A6563740A20202020202020202020202020206966202870726F63657373656446696C6529207B0A2020202020202020202020202020202066696C65203D206F726746696C653B0A20202020202020202020202020207D0A2020';
wwv_flow_api.g_varchar2_table(182) := '2020202020202020202020202F2F2041504558206576656E740A2020202020202020202020202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E75706C6F6164447A46696C6573204572726F72272C20704D65737361676529';
wwv_flow_api.g_varchar2_table(183) := '3B0A2020202020202020202020202020617065782E6576656E742E7472696767657228272327202B2070526567696F6E49642C202764726F707A6F6E652D75706C6F61642D6572726F72272C20704D657373616765293B0A202020202020202020202020';
wwv_flow_api.g_varchar2_table(184) := '20202F2F207365742066696C6520737461747573204552524F520A202020202020202020202020202066696C652E737461747573203D2044726F707A6F6E652E4552524F523B0A20202020202020202020202020202F2F206275696C64206D6573736167';
wwv_flow_api.g_varchar2_table(185) := '6520666F72206572726F722074656D706C6174650A2020202020202020202020202020766172206D657373616765203D2022223B0A202020202020202020202020202069662028704D65737361676529207B0A202020202020202020202020202020206D';
wwv_flow_api.g_varchar2_table(186) := '657373616765203D20704D6573736167653B0A20202020202020202020202020207D20656C7365207B0A202020202020202020202020202020206D657373616765203D20274572726F722070726F63657373696E672066696C65273B0A20202020202020';
wwv_flow_api.g_varchar2_table(187) := '202020202020207D0A20202020202020202020202020207044726F707A6F6E652E656D697428226572726F72222C2066696C652C206D6573736167652C20786872293B0A20202020202020202020202020207044726F707A6F6E652E656D69742822636F';
wwv_flow_api.g_varchar2_table(188) := '6D706C657465222C2066696C65293B0A20202020202020202020202020202F2F2070726F636573732066696C652071756575650A20202020202020202020202020207044726F707A6F6E652E70726F63657373517565756528293B0A2020202020202020';
wwv_flow_api.g_varchar2_table(189) := '202020207D2C0A2020202020202020202020202F2F2058485220666F722075706C6F61642070726F67726573730A2020202020202020202020207868723A2066756E6374696F6E2829207B0A20202020202020202020202020205868724F626A203D2024';
wwv_flow_api.g_varchar2_table(190) := '2E616A617853657474696E67732E78687228293B0A2020202020202020202020202020696620285868724F626A2E75706C6F616429207B0A202020202020202020202020202020205868724F626A2E75706C6F61642E6164644576656E744C697374656E';
wwv_flow_api.g_varchar2_table(191) := '6572282770726F6772657373272C2066756E6374696F6E286576656E7429207B0A2020202020202020202020202020202020206170657844726F707A6F6E652E73657455706C6F616450726F6772657373286576656E742C207044726F707A6F6E652C20';
wwv_flow_api.g_varchar2_table(192) := '66696C65293B0A202020202020202020202020202020207D2C2066616C7365293B0A20202020202020202020202020207D20656C7365207B0A20202020202020202020202020202020617065782E64656275672E6C6F6728276170657844726F707A6F6E';
wwv_flow_api.g_varchar2_table(193) := '652E75706C6F6164447A46696C657320584852272C202755706C6F61642070726F6772657373206973206E6F7420737570706F727465642E27293B0A20202020202020202020202020207D0A202020202020202020202020202072657475726E20586872';
wwv_flow_api.g_varchar2_table(194) := '4F626A3B0A2020202020202020202020207D0A202020202020202020207D293B0A202020202020202020202F2F2069662066696C65206E6F7420666F756E643A2070726F636573732071756575650A20202020202020207D20656C7365207B0A20202020';
wwv_flow_api.g_varchar2_table(195) := '2020202020207044726F707A6F6E652E70726F63657373517565756528293B0A20202020202020207D0A2020202020207D293B0A202020207D0A20207D2C0A20202F2A2A0A2020202A2066696C652064656C6574652066756E6374696F6E0A2020202A20';
wwv_flow_api.g_varchar2_table(196) := '40706172616D207B737472696E677D2070526567696F6E49640A2020202A2040706172616D207B737472696E677D2070416A61784964656E7469666965720A2020202A2040706172616D207B6F626A6563747D207044726F707A6F6E650A2020202A2040';
wwv_flow_api.g_varchar2_table(197) := '706172616D207B6F626A6563747D207046696C650A2020202A2F0A202064656C657465447A46696C653A2066756E6374696F6E2870526567696F6E49642C2070416A61784964656E7469666965722C207044726F707A6F6E652C207046696C6529207B0A';
wwv_flow_api.g_varchar2_table(198) := '202020202F2F20414A41582063616C6C20746F2075706C6F616420616E642070726F636573732066696C657320284E6F20617065782E7365727665722E706C7567696E206265636175736520352E3120646F65736EC2B47420737570706F727420786872';
wwv_flow_api.g_varchar2_table(199) := '290A20202020617065782E6A51756572792E616A6178287B0A20202020202064617461547970653A202774657874272C0A202020202020747970653A2027504F5354272C0A20202020202075726C3A2077696E646F772E6C6F636174696F6E2E68726566';
wwv_flow_api.g_varchar2_table(200) := '2E73756273747228302C2077696E646F772E6C6F636174696F6E2E687265662E696E6465784F6628272F663F703D2729202B203129202B20277777765F666C6F772E616A6178272C0A2020202020206173796E633A20747275652C0A2020202020207472';
wwv_flow_api.g_varchar2_table(201) := '61646974696F6E616C3A20747275652C0A202020202020646174613A207B0A20202020202020207830313A202744454C455445272C0A20202020202020207830323A207046696C652E6E616D652C0A20202020202020207830333A207046696C652E6964';
wwv_flow_api.g_varchar2_table(202) := '2C0A2020202020202020705F726571756573743A2027504C5547494E3D27202B2070416A61784964656E7469666965722C0A2020202020202020705F666C6F775F69643A202476282770466C6F77496427292C0A2020202020202020705F666C6F775F73';
wwv_flow_api.g_varchar2_table(203) := '7465705F69643A202476282770466C6F7753746570496427292C0A2020202020202020705F696E7374616E63653A202476282770496E7374616E636527292C0A2020202020202020705F64656275673A202476282770646562756727290A202020202020';
wwv_flow_api.g_varchar2_table(204) := '7D2C0A2020202020202F2F20535543434553532066756E6374696F6E0A202020202020737563636573733A2066756E6374696F6E28704461746129207B0A20202020202020202F2F20636865636B207374617475730A202020202020202076617220764A';
wwv_flow_api.g_varchar2_table(205) := '736F6E52657475726E3B0A2020202020202020747279207B0A20202020202020202020764A736F6E52657475726E203D206A51756572792E70617273654A534F4E287044617461293B0A20202020202020207D206361746368202865727229207B0A2020';
wwv_flow_api.g_varchar2_table(206) := '2020202020202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E64656C657465447A46696C6520526573706F6E73652050617273654572726F72272C20657272293B0A20202020202020202020764A736F6E52657475726E20';
wwv_flow_api.g_varchar2_table(207) := '3D206A51756572792E70617273654A534F4E28277B2022737461747573223A20226572726F72222C20226D657373616765223A202264656C657465447A46696C6520526573706F6E73652050617273654572726F72222C2022636F6465223A2022414A41';
wwv_flow_api.g_varchar2_table(208) := '582043616C6C6261636B20287044617461292050617273654572726F7222207D27293B0A20202020202020207D0A20202020202020202F2F20726573706F6E7365206572726F720A202020202020202069662028764A736F6E52657475726E2E73746174';
wwv_flow_api.g_varchar2_table(209) := '7573203D3D20276572726F722729207B0A202020202020202020202F2F2041504558206576656E740A20202020202020202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E64656C657465447A46696C65204572726F72272C';
wwv_flow_api.g_varchar2_table(210) := '20764A736F6E52657475726E2E6D6573736167652C20764A736F6E52657475726E2E636F6465293B0A20202020202020202020617065782E6576656E742E7472696767657228272327202B2070526567696F6E49642C202764726F707A6F6E652D64656C';
wwv_flow_api.g_varchar2_table(211) := '6574652D6572726F72272C20764A736F6E52657475726E293B0A202020202020202020202F2F20726573706F6E736520737563636573730A20202020202020207D20656C73652069662028764A736F6E52657475726E2E737461747573203D3D20277375';
wwv_flow_api.g_varchar2_table(212) := '63636573732729207B0A202020202020202020202F2F2041504558206576656E740A20202020202020202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E64656C657465447A46696C652053756363657373272C20764A736F';
wwv_flow_api.g_varchar2_table(213) := '6E52657475726E2E6D657373616765293B0A20202020202020202020617065782E6576656E742E7472696767657228272327202B2070526567696F6E49642C202764726F707A6F6E652D64656C6574652D73756363657373272C207044617461293B0A20';
wwv_flow_api.g_varchar2_table(214) := '202020202020207D0A2020202020207D2C0A2020202020202F2F204552524F522066756E6374696F6E0A2020202020206572726F723A2066756E6374696F6E287868722C20704D65737361676529207B0A20202020202020202F2F204150455820657665';
wwv_flow_api.g_varchar2_table(215) := '6E740A2020202020202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E64656C657465447A46696C65204572726F72272C20704D657373616765293B0A2020202020202020617065782E6576656E742E747269676765722827';
wwv_flow_api.g_varchar2_table(216) := '2327202B2070526567696F6E49642C202764726F707A6F6E652D64656C6574652D6572726F72272C20704D657373616765293B0A2020202020207D0A202020207D293B0A20207D2C0A20202F2A2A0A2020202A2048616E646C6520616C6C20706C756769';
wwv_flow_api.g_varchar2_table(217) := '6E204150455820726567696F6E206576656E74730A2020202A2040706172616D207B6F626A6563747D207044726F707A6F6E650A2020202A2040706172616D207B737472696E677D2070526567696F6E49640A2020202A2F0A202068616E646C65506C75';
wwv_flow_api.g_varchar2_table(218) := '67696E4576656E74733A2066756E6374696F6E287044726F707A6F6E652C2070526567696F6E496429207B0A202020202F2F2064656C657465642066696C650A202020207044726F707A6F6E652E6F6E282772656D6F76656466696C65272C2066756E63';
wwv_flow_api.g_varchar2_table(219) := '74696F6E2866696C6529207B0A202020202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E68616E646C65506C7567696E4576656E7473202D2072656D6F76656466696C65206576656E7427293B0A20202020202061706578';
wwv_flow_api.g_varchar2_table(220) := '2E6576656E742E7472696767657228272327202B2070526567696F6E49642C202764726F707A6F6E652D64656C657465642D66696C65272C2066696C65293B0A202020207D293B0A202020202F2F2061646465642066696C650A202020207044726F707A';
wwv_flow_api.g_varchar2_table(221) := '6F6E652E6F6E2827616464656466696C65272C2066756E6374696F6E2866696C6529207B0A202020202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E68616E646C65506C7567696E4576656E7473202D2061646465646669';
wwv_flow_api.g_varchar2_table(222) := '6C65206576656E7427293B0A202020202020617065782E6576656E742E7472696767657228272327202B2070526567696F6E49642C202764726F707A6F6E652D61646465642D66696C65272C2066696C65293B0A202020207D293B0A202020202F2F206D';
wwv_flow_api.g_varchar2_table(223) := '617846696C65732065786365656465640A202020207044726F707A6F6E652E6F6E28276D617866696C65736578636565646564272C2066756E6374696F6E2866696C6529207B0A202020202020617065782E64656275672E6C6F6728276170657844726F';
wwv_flow_api.g_varchar2_table(224) := '707A6F6E652E68616E646C65506C7567696E4576656E7473202D206D617866696C65736578636565646564206576656E7427293B0A202020202020617065782E6576656E742E7472696767657228272327202B2070526567696F6E49642C202764726F70';
wwv_flow_api.g_varchar2_table(225) := '7A6F6E652D6D617866696C65732D6578636565646564272C2066696C65293B0A202020207D293B0A202020202F2F20746F74616C2075706C6F61642070726F67726573730A202020207044726F707A6F6E652E6F6E2827746F74616C75706C6F61647072';
wwv_flow_api.g_varchar2_table(226) := '6F6772657373272C2066756E6374696F6E28746F74616C50657263656E7461676529207B0A202020202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E68616E646C65506C7567696E4576656E7473202D20746F74616C7570';
wwv_flow_api.g_varchar2_table(227) := '6C6F616470726F6772657373206576656E7427293B0A202020202020617065782E6576656E742E7472696767657228272327202B2070526567696F6E49642C202764726F707A6F6E652D746F74616C75706C6F61642D70726F6772657373272C20746F74';
wwv_flow_api.g_varchar2_table(228) := '616C50657263656E74616765293B0A202020207D293B0A202020202F2F20647261672066696C65206F766572207468652064726F707A6F6E650A202020207044726F707A6F6E652E6F6E282764726167656E746572272C2066756E6374696F6E2829207B';
wwv_flow_api.g_varchar2_table(229) := '0A202020202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E68616E646C65506C7567696E4576656E7473202D2064726167656E746572206576656E7427293B0A202020202020617065782E6576656E742E74726967676572';
wwv_flow_api.g_varchar2_table(230) := '28272327202B2070526567696F6E49642C202764726F707A6F6E652D647261672D6F76657227293B0A202020207D293B0A202020202F2F2066696C65206572726F72206F6363757265640A202020207044726F707A6F6E652E6F6E28276572726F72272C';
wwv_flow_api.g_varchar2_table(231) := '2066756E6374696F6E2866696C652C206572726F724D65737361676529207B0A202020202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E68616E646C65506C7567696E4576656E7473202D206572726F72206576656E7427';
wwv_flow_api.g_varchar2_table(232) := '293B0A20202020202066696C652E6572726F724D657373616765203D206572726F724D6573736167653B0A202020202020617065782E6576656E742E7472696767657228272327202B2070526567696F6E49642C202764726F707A6F6E652D66696C652D';
wwv_flow_api.g_varchar2_table(233) := '6572726F72272C2066696C65293B0A202020207D293B0A202020202F2F2075706C6F616420636F6D706C6574650A202020207044726F707A6F6E652E6F6E2827636F6D706C657465272C2066756E6374696F6E2829207B0A202020202020696620287044';
wwv_flow_api.g_varchar2_table(234) := '726F707A6F6E652E67657451756575656446696C657328292E6C656E677468203D3D3D2030202626207044726F707A6F6E652E67657455706C6F6164696E6746696C657328292E6C656E677468203D3D3D203029207B0A2020202020202020617065782E';
wwv_flow_api.g_varchar2_table(235) := '64656275672E6C6F6728276170657844726F707A6F6E652E68616E646C65506C7567696E4576656E7473202D20636F6D706C657465206576656E7427293B0A2020202020202020617065782E6576656E742E7472696767657228272327202B2070526567';
wwv_flow_api.g_varchar2_table(236) := '696F6E49642C202764726F707A6F6E652D75706C6F61642D636F6D706C65746527293B0A2020202020207D0A202020207D293B0A20207D2C0A20202F2A2A0A2020202A20506C7567696E2048616E646C6572202D2043616C6C65642066726F6D20506C75';
wwv_flow_api.g_varchar2_table(237) := '67696E2052656E6465720A2020202A2040706172616D207B737472696E677D2070526567696F6E49640A2020202A2040706172616D207B6F626A6563747D20704F7074696F6E730A2020202A2F0A2020706C7567696E48616E646C65723A2066756E6374';
wwv_flow_api.g_varchar2_table(238) := '696F6E2870526567696F6E49642C20704F7074696F6E7329207B0A2020202076617220726567696F6E24203D206A517565727928272327202B20617065782E7574696C2E6573636170654353532870526567696F6E4964202B20275F64726F707A6F6E65';
wwv_flow_api.g_varchar2_table(239) := '27292C20617065782E6750616765436F6E7465787424293B0A2020202076617220726567696F6E203D20617065782E7574696C2E6573636170654353532870526567696F6E4964202B20275F64726F707A6F6E6527293B0A0A2020202076617220616A61';
wwv_flow_api.g_varchar2_table(240) := '784964656E746966696572203D20704F7074696F6E732E616A61784964656E7469666965723B0A20202020766172206D617846696C6553697A65203D207061727365466C6F617428704F7074696F6E732E6D617846696C6573697A65293B0A2020202076';
wwv_flow_api.g_varchar2_table(241) := '6172206D617846696C6573203D207061727365496E7428704F7074696F6E732E6D617846696C6573293B0A2020202076617220616363657074656446696C6573203D20704F7074696F6E732E616363657074656446696C65733B0A202020207661722075';
wwv_flow_api.g_varchar2_table(242) := '706C6F61644D656368616E69736D203D20704F7074696F6E732E75706C6F61644D656368616E69736D3B0A2020202076617220636C69636B61626C65203D206170657844726F707A6F6E652E7061727365426F6F6C65616E28704F7074696F6E732E636C';
wwv_flow_api.g_varchar2_table(243) := '69636B61626C65293B0A202020207661722073686F7746696C6550726576696577203D206170657844726F707A6F6E652E7061727365426F6F6C65616E28704F7074696F6E732E73686F7746696C6550726576696577293B0A2020202076617220737570';
wwv_flow_api.g_varchar2_table(244) := '706F7274436F70795061737465203D206170657844726F707A6F6E652E7061727365426F6F6C65616E28704F7074696F6E732E737570706F7274436F70795061737465293B0A202020207661722072656D6F7665416674657255706C6F6164203D206170';
wwv_flow_api.g_varchar2_table(245) := '657844726F707A6F6E652E7061727365426F6F6C65616E28704F7074696F6E732E72656D6F7665416674657255706C6F6164293B0A202020207661722064656C65746546696C6573203D206170657844726F707A6F6E652E7061727365426F6F6C65616E';
wwv_flow_api.g_varchar2_table(246) := '28704F7074696F6E732E64656C65746546696C6573293B0A2020202076617220726573697A65496D61676573203D206170657844726F707A6F6E652E7061727365426F6F6C65616E28704F7074696F6E732E726573697A65496D61676573293B0A202020';
wwv_flow_api.g_varchar2_table(247) := '2076617220726573697A655769647468203D207061727365496E7428704F7074696F6E732E726573697A655769647468293B0A2020202076617220726573697A65486569676874203D207061727365496E7428704F7074696F6E732E726573697A654865';
wwv_flow_api.g_varchar2_table(248) := '69676874293B0A2020202076617220706C7567696E507265666978203D20704F7074696F6E732E706C7567696E5072656669783B0A20202020766172206368756E6B53697A65203D207061727365496E7428704F7074696F6E732E6368756E6B53697A65';
wwv_flow_api.g_varchar2_table(249) := '293B0A2020202076617220646973706C61794D657373616765203D20704F7074696F6E732E646973706C61794D6573736167653B0A202020207661722066616C6C6261636B4D657373616765203D20704F7074696F6E732E66616C6C6261636B4D657373';
wwv_flow_api.g_varchar2_table(250) := '6167653B0A202020207661722066696C65546F6F4269674D657373616765203D20704F7074696F6E732E66696C65546F6F4269674D6573736167653B0A20202020766172206D617846696C65734D657373616765203D20704F7074696F6E732E6D617846';
wwv_flow_api.g_varchar2_table(251) := '696C65734D6573736167653B0A202020207661722072656D6F766546696C654D657373616765203D20704F7074696F6E732E72656D6F766546696C654D6573736167653B0A202020207661722063616E63656C55706C6F61644D657373616765203D2070';
wwv_flow_api.g_varchar2_table(252) := '4F7074696F6E732E63616E63656C55706C6F61644D6573736167653B0A202020207661722063616E63656C55706C6F6164436F6E6669726D4D657373616765203D20704F7074696F6E732E63616E63656C55706C6F6164436F6E6669726D4D6573736167';
wwv_flow_api.g_varchar2_table(253) := '653B0A2020202076617220696E76616C696446696C65547970654D657373616765203D20704F7074696F6E732E696E76616C696446696C65547970654D6573736167653B0A202020202F2F204C6F6767696E670A20202020617065782E64656275672E6C';
wwv_flow_api.g_varchar2_table(254) := '6F6728276170657844726F707A6F6E652E706C7567696E48616E646C6572202D2070526567696F6E4964272C2070526567696F6E4964293B0A20202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E706C7567696E48616E64';
wwv_flow_api.g_varchar2_table(255) := '6C6572202D20704F7074696F6E73272C20704F7074696F6E73293B0A20202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E706C7567696E48616E646C6572202D20726567696F6E272C20726567696F6E293B0A2020202061';
wwv_flow_api.g_varchar2_table(256) := '7065782E64656275672E6C6F6728276170657844726F707A6F6E652E706C7567696E48616E646C6572202D20726567696F6E24272C20726567696F6E24293B0A20202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E706C75';
wwv_flow_api.g_varchar2_table(257) := '67696E48616E646C6572202D20616A61784964656E746966696572272C20616A61784964656E746966696572293B0A20202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E706C7567696E48616E646C6572202D206D617846';
wwv_flow_api.g_varchar2_table(258) := '696C6553697A65272C206D617846696C6553697A65293B0A20202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E706C7567696E48616E646C6572202D206D617846696C6573272C206D617846696C6573293B0A2020202061';
wwv_flow_api.g_varchar2_table(259) := '7065782E64656275672E6C6F6728276170657844726F707A6F6E652E706C7567696E48616E646C6572202D20616363657074656446696C6573272C20616363657074656446696C6573293B0A20202020617065782E64656275672E6C6F67282761706578';
wwv_flow_api.g_varchar2_table(260) := '44726F707A6F6E652E706C7567696E48616E646C6572202D2075706C6F61644D656368616E69736D272C2075706C6F61644D656368616E69736D293B0A20202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E706C7567696E';
wwv_flow_api.g_varchar2_table(261) := '48616E646C6572202D20636C69636B61626C65272C20636C69636B61626C65293B0A20202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E706C7567696E48616E646C6572202D2073686F7746696C6550726576696577272C';
wwv_flow_api.g_varchar2_table(262) := '2073686F7746696C6550726576696577293B0A20202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E706C7567696E48616E646C6572202D20737570706F7274436F70795061737465272C20737570706F7274436F70795061';
wwv_flow_api.g_varchar2_table(263) := '737465293B0A20202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E706C7567696E48616E646C6572202D2072656D6F7665416674657255706C6F6164272C2072656D6F7665416674657255706C6F6164293B0A2020202061';
wwv_flow_api.g_varchar2_table(264) := '7065782E64656275672E6C6F6728276170657844726F707A6F6E652E706C7567696E48616E646C6572202D2064656C65746546696C6573272C2064656C65746546696C6573293B0A20202020617065782E64656275672E6C6F6728276170657844726F70';
wwv_flow_api.g_varchar2_table(265) := '7A6F6E652E706C7567696E48616E646C6572202D20726573697A65496D61676573272C20726573697A65496D61676573293B0A20202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E706C7567696E48616E646C6572202D20';
wwv_flow_api.g_varchar2_table(266) := '726573697A655769647468272C20726573697A655769647468293B0A20202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E706C7567696E48616E646C6572202D20726573697A65486569676874272C20726573697A654865';
wwv_flow_api.g_varchar2_table(267) := '69676874293B0A20202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E706C7567696E48616E646C6572202D20706C7567696E507265666978272C20706C7567696E507265666978293B0A20202020617065782E6465627567';
wwv_flow_api.g_varchar2_table(268) := '2E6C6F6728276170657844726F707A6F6E652E706C7567696E48616E646C6572202D206368756E6B53697A65272C206368756E6B53697A65293B0A20202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E706C7567696E4861';
wwv_flow_api.g_varchar2_table(269) := '6E646C6572202D20646973706C61794D657373616765272C20646973706C61794D657373616765293B0A20202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E706C7567696E48616E646C6572202D2066616C6C6261636B4D';
wwv_flow_api.g_varchar2_table(270) := '657373616765272C2066616C6C6261636B4D657373616765293B0A20202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E706C7567696E48616E646C6572202D2066696C65546F6F4269674D657373616765272C2066696C65';
wwv_flow_api.g_varchar2_table(271) := '546F6F4269674D657373616765293B0A20202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E706C7567696E48616E646C6572202D206D617846696C65734D657373616765272C206D617846696C65734D657373616765293B';
wwv_flow_api.g_varchar2_table(272) := '0A20202020617065782E64656275672E6C6F6728276170657844726F707A6F6E652E706C7567696E48616E646C6572202D2072656D6F766546696C654D657373616765272C2072656D6F766546696C654D657373616765293B0A20202020617065782E64';
wwv_flow_api.g_varchar2_table(273) := '656275672E6C6F6728276170657844726F707A6F6E652E706C7567696E48616E646C6572202D2063616E63656C55706C6F61644D657373616765272C2063616E63656C55706C6F61644D657373616765293B0A20202020617065782E64656275672E6C6F';
wwv_flow_api.g_varchar2_table(274) := '6728276170657844726F707A6F6E652E706C7567696E48616E646C6572202D2063616E63656C55706C6F6164436F6E6669726D4D657373616765272C2063616E63656C55706C6F6164436F6E6669726D4D657373616765293B0A20202020617065782E64';
wwv_flow_api.g_varchar2_table(275) := '656275672E6C6F6728276170657844726F707A6F6E652E706C7567696E48616E646C6572202D20696E76616C696446696C65547970654D657373616765272C20696E76616C696446696C65547970654D657373616765293B0A202020202F2F20696D6167';
wwv_flow_api.g_varchar2_table(276) := '65526573697A653A20726573697A655769647468202620726573697A654865696768740A20202020766172206C526573697A6557696474683B0A20202020766172206C526573697A654865696768743B0A2020202069662028726573697A65496D616765';
wwv_flow_api.g_varchar2_table(277) := '7329207B0A2020202020206C526573697A655769647468203D20726573697A655769647468207C7C206E756C6C3B0A2020202020206C526573697A65486569676874203D20726573697A65486569676874207C7C206E756C6C3B0A202020207D20656C73';
wwv_flow_api.g_varchar2_table(278) := '65207B0A2020202020206C526573697A655769647468203D206E756C6C3B0A2020202020206C526573697A65486569676874203D206E756C6C3B0A202020207D0A202020202F2F2044524F505A4F4E45204F7074696F6E730A2020202076617220647A4F';
wwv_flow_api.g_varchar2_table(279) := '7074696F6E73203D207B0A2020202020202F2F204E4F5420555345443A20726571756972656420706172616D732C206275742075706C6F6164696E672066756E6374696F6E207573657320706C7567696E2070726F636573730A20202020202075726C3A';
wwv_flow_api.g_varchar2_table(280) := '2077696E646F772E6C6F636174696F6E2E687265662E73756273747228302C2077696E646F772E6C6F636174696F6E2E687265662E696E6465784F6628272F663F703D2729202B203129202B20277777765F666C6F772E616A6178272C0A202020202020';
wwv_flow_api.g_varchar2_table(281) := '2F2F2064726F707A6F6E6520706172616D65746572730A20202020202075706C6F61644D756C7469706C653A2066616C73652C0A2020202020206175746F50726F6365737351756575653A20747275652C0A202020202020706172616C6C656C55706C6F';
wwv_flow_api.g_varchar2_table(282) := '6164733A20312C0A20202020202061646452656D6F76654C696E6B733A2064656C65746546696C65732C0A2020202020206D617846696C6573697A653A206D617846696C6553697A652C0A202020202020636C69636B61626C653A20636C69636B61626C';
wwv_flow_api.g_varchar2_table(283) := '652C0A2020202020206D617846696C65733A206D617846696C65732C0A202020202020616363657074656446696C65733A20616363657074656446696C65732C0A202020202020726573697A6557696474683A206C526573697A6557696474682C0A2020';
wwv_flow_api.g_varchar2_table(284) := '20202020726573697A654865696768743A206C526573697A654865696768742C0A2020202020206469637444656661756C744D6573736167653A20646973706C61794D6573736167652C0A2020202020206469637446616C6C6261636B4D657373616765';
wwv_flow_api.g_varchar2_table(285) := '3A2066616C6C6261636B4D6573736167652C0A2020202020206469637446696C65546F6F4269673A2066696C65546F6F4269674D6573736167652C0A202020202020646963744D617846696C657345786365656465643A206D617846696C65734D657373';
wwv_flow_api.g_varchar2_table(286) := '6167652C0A2020202020206469637452656D6F766546696C653A2072656D6F766546696C654D6573736167652C0A2020202020206469637443616E63656C55706C6F61643A2063616E63656C55706C6F61644D6573736167652C0A202020202020646963';
wwv_flow_api.g_varchar2_table(287) := '7443616E63656C55706C6F6164436F6E6669726D6174696F6E3A2063616E63656C55706C6F6164436F6E6669726D4D6573736167652C0A20202020202064696374496E76616C696446696C65547970653A20696E76616C696446696C65547970654D6573';
wwv_flow_api.g_varchar2_table(288) := '736167650A202020207D3B0A202020202F2F2044524F505A4F4E450A2020202044726F707A6F6E652E6175746F446973636F766572203D2066616C73653B0A20202020766172206D7944726F707A6F6E65203D206E65772044726F707A6F6E6528276469';
wwv_flow_api.g_varchar2_table(289) := '762327202B20726567696F6E2C20647A4F7074696F6E73293B0A0A202020202F2F2064697361626C6520636C69636B61626C6520656C656D656E740A20202020696620282128636C69636B61626C652929207B0A2020202020202428272E647A2D686964';
wwv_flow_api.g_varchar2_table(290) := '64656E2D696E70757427292E70726F70282764697361626C6564272C2074727565293B0A202020207D0A0A202020202F2F20436F707926506173746520737570706F72740A2020202069662028737570706F7274436F7079506173746529207B0A202020';
wwv_flow_api.g_varchar2_table(291) := '20202046696C655265616465724A532E7365747570436C6970626F61726428646F63756D656E742E626F64792C207B0A202020202020202072656164417344656661756C743A20224461746155524C222C0A20202020202020206163636570743A207B0A';
wwv_flow_api.g_varchar2_table(292) := '2020202020202020202027696D6167652F2A273A20274461746155524C270A20202020202020207D2C0A20202020202020206F6E3A207B0A202020202020202020206C6F61643A2066756E6374696F6E28652C2066696C6529207B0A2020202020202020';
wwv_flow_api.g_varchar2_table(293) := '202020202F2F206164642066696C6520616E642070726F63657373207175657565207768656E2070617374696E670A2020202020202020202020206D7944726F707A6F6E652E61646446696C652866696C65293B0A202020202020202020207D0A202020';
wwv_flow_api.g_varchar2_table(294) := '20202020207D0A2020202020207D293B0A202020207D0A0A202020202F2F206F76657277726974652064726F707A6F6E652064656661756C742075706C6F61642066756E6374696F6E0A202020206D7944726F707A6F6E652E75706C6F616446696C6573';
wwv_flow_api.g_varchar2_table(295) := '203D2066756E6374696F6E2866696C657329207B0A2020202020206966202875706C6F61644D656368616E69736D203D3D20274E4F524D414C2729207B0A20202020202020206170657844726F707A6F6E652E75706C6F6164447A46696C6573466F726D';
wwv_flow_api.g_varchar2_table(296) := '446174612870526567696F6E49642C20616A61784964656E7469666965722C206D7944726F707A6F6E652C2066696C6573293B0A2020202020207D20656C7365206966202875706C6F61644D656368616E69736D203D3D20274348554E4B45442729207B';
wwv_flow_api.g_varchar2_table(297) := '0A20202020202020206170657844726F707A6F6E652E75706C6F6164447A46696C65734368756E6B65642870526567696F6E49642C20616A61784964656E7469666965722C206D7944726F707A6F6E652C2066696C65732C206368756E6B53697A65293B';
wwv_flow_api.g_varchar2_table(298) := '0A2020202020207D0A202020207D3B0A0A202020202F2F2068616E646C6520706C7567696E206576656E74730A202020206170657844726F707A6F6E652E68616E646C65506C7567696E4576656E7473286D7944726F707A6F6E652C2070526567696F6E';
wwv_flow_api.g_varchar2_table(299) := '4964293B0A0A202020202F2F2044656C6574652046696C65730A202020206966202864656C65746546696C657329207B0A2020202020206D7944726F707A6F6E652E6F6E282272656D6F76656466696C65222C2066756E6374696F6E2866696C6529207B';
wwv_flow_api.g_varchar2_table(300) := '0A20202020202020202F2F2064656C6574652066696C650A20202020202020206966202866696C652E737461747573203D3D2027737563636573732729207B0A202020202020202020206170657844726F707A6F6E652E64656C657465447A46696C6528';
wwv_flow_api.g_varchar2_table(301) := '70526567696F6E49642C20616A61784964656E7469666965722C206D7944726F707A6F6E652C2066696C65293B0A20202020202020207D0A2020202020207D293B0A202020207D0A0A202020202F2F204F6E20616464656466696C653A20707265766965';
wwv_flow_api.g_varchar2_table(302) := '7720696D61676573202F2063616C6C6261636B206576656E740A202020206D7944726F707A6F6E652E6F6E2822616464656466696C65222C2066756E6374696F6E2866696C6529207B0A2020202020202F2F20616464207072657669657720696D616765';
wwv_flow_api.g_varchar2_table(303) := '7320746F20636F6D6D6F6E2066696C652074797065730A2020202020206966202873686F7746696C655072657669657729207B0A20202020202020202F2F206F6E6C79206966206E6F7420616E20696D6167650A20202020202020206966202821286669';
wwv_flow_api.g_varchar2_table(304) := '6C652E747970652E6D61746368282F696D6167652E2A2F292929207B0A2020202020202020202076617220657874203D2066696C652E6E616D652E73706C697428272E27292E706F7028293B0A202020202020202020207661722075726C203D20704F70';
wwv_flow_api.g_varchar2_table(305) := '74696F6E732E706C7567696E507265666978202B2022696D672F22202B20657874202B20222E706E67223B0A202020202020202020202F2F20636865636B20696620696D616765206578697374730A202020202020202020206170657844726F707A6F6E';
wwv_flow_api.g_varchar2_table(306) := '652E696D6167654578697374732875726C2C0A20202020202020202020202066756E6374696F6E2829207B0A2020202020202020202020202020242866696C652E70726576696577456C656D656E74292E66696E6428222E647A2D696D61676520696D67';
wwv_flow_api.g_varchar2_table(307) := '22292E617474722822737263222C20704F7074696F6E732E706C7567696E507265666978202B2022696D672F22202B20657874202B20222E706E6722293B0A2020202020202020202020207D2C0A20202020202020202020202066756E6374696F6E2829';
wwv_flow_api.g_varchar2_table(308) := '207B0A2020202020202020202020202020242866696C652E70726576696577456C656D656E74292E66696E6428222E647A2D696D61676520696D6722292E617474722822737263222C20704F7074696F6E732E706C7567696E507265666978202B202269';
wwv_flow_api.g_varchar2_table(309) := '6D672F6F746865722E706E6722293B0A2020202020202020202020207D293B0A20202020202020207D0A2020202020207D0A202020207D293B0A0A202020202F2F20416674657220636F6D706C6574653A20636C6561722064726F707A6F6E6520646174';
wwv_flow_api.g_varchar2_table(310) := '610A202020206D7944726F707A6F6E652E6F6E2822636F6D706C657465222C2066756E6374696F6E2829207B0A202020202020696620286D7944726F707A6F6E652E67657451756575656446696C657328292E6C656E677468203D3D3D2030202626206D';
wwv_flow_api.g_varchar2_table(311) := '7944726F707A6F6E652E67657455706C6F6164696E6746696C657328292E6C656E677468203D3D3D203029207B0A20202020202020202F2F2072656D6F766520616C6C2066696C65732061667465722075706C6F616420697320636F6D706C6574650A20';
wwv_flow_api.g_varchar2_table(312) := '202020202020206966202872656D6F7665416674657255706C6F616429207B0A202020202020202020202F2F2077616974203320736563730A2020202020202020202073657454696D656F75742866756E6374696F6E2829207B0A202020202020202020';
wwv_flow_api.g_varchar2_table(313) := '2020206D7944726F707A6F6E652E72656D6F7665416C6C46696C657328293B0A202020202020202020207D2C2033303030293B0A20202020202020207D0A2020202020207D0A202020207D293B0A20207D0A7D3B0A';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72362370979797256)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'js/apexdropzone.js'
,p_mime_type=>'application/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '766172206170657844726F707A6F6E653D7B7061727365426F6F6C65616E3A66756E6374696F6E2865297B766172206F3B72657475726E2274727565223D3D652E746F4C6F7765724361736528292626286F3D2130292C2266616C7365223D3D652E746F';
wwv_flow_api.g_varchar2_table(2) := '4C6F7765724361736528292626286F3D2131292C227472756522213D652E746F4C6F77657243617365282926262266616C736522213D652E746F4C6F7765724361736528292626286F3D766F69642030292C6F7D2C696D6167654578697374733A66756E';
wwv_flow_api.g_varchar2_table(3) := '6374696F6E28652C6F2C61297B7472797B76617220723D6E657720496D6167653B722E6F6E6C6F61643D6F2C722E6F6E6572726F723D612C722E7372633D657D63617463682865297B617065782E64656275672E6C6F6728226170657844726F707A6F6E';
wwv_flow_api.g_varchar2_table(4) := '652E696D616765457869737473204572726F72222C65297D7D2C636C6F623241727261793A66756E6374696F6E28652C6F2C61297B6C6F6F70436F756E743D4D6174682E666C6F6F7228652E6C656E6774682F6F292B313B666F722876617220723D303B';
wwv_flow_api.g_varchar2_table(5) := '723C6C6F6F70436F756E743B722B2B29612E7075736828652E736C696365286F2A722C6F2A28722B312929293B72657475726E20617D2C62696E6172794172726179326261736536343A66756E6374696F6E2865297B666F7228766172206F3D22222C61';
wwv_flow_api.g_varchar2_table(6) := '3D6E65772055696E743841727261792865292C723D612E627974654C656E6774682C703D303B703C723B702B2B296F2B3D537472696E672E66726F6D43686172436F646528615B705D293B72657475726E2062746F61286F297D2C73657455706C6F6164';
wwv_flow_api.g_varchar2_table(7) := '50726F67726573733A66756E6374696F6E28652C6F2C61297B76617220723B653F28723D652E6C6F616465642F652E746F74616C2A3130302C723E313030262628723D313030292C612E75706C6F61643D7B70726F67726573733A722C746F74616C3A65';
wwv_flow_api.g_varchar2_table(8) := '2E746F74616C2C627974657353656E743A652E6C6F616465647D293A28723D3130302C612E75706C6F61643D7B70726F67726573733A722C627974657353656E743A612E75706C6F61642E746F74616C7D292C6F2E656D6974282275706C6F616470726F';
wwv_flow_api.g_varchar2_table(9) := '6772657373222C612C722C612E73697A652F283130302F7229297D2C73657455706C6F616450726F67726573734368756E6B65643A66756E6374696F6E28652C6F2C612C722C70297B766172206E3B653F286E3D612F722A3130302C6E2B3D652E6C6F61';
wwv_flow_api.g_varchar2_table(10) := '6465642F652E746F74616C2A3130302F722C6E3E3130302626286E3D313030292C702E75706C6F61643D7B70726F67726573733A6E2C746F74616C3A652E746F74616C2A28612F72292C627974657353656E743A652E6C6F616465642A28612F72297D29';
wwv_flow_api.g_varchar2_table(11) := '3A286E3D3130302A28612F72292C6E3E3130302626286E3D313030292C702E75706C6F61643D7B70726F67726573733A6E2C627974657353656E743A702E75706C6F61642E746F74616C2A28612F72297D292C6F2E656D6974282275706C6F616470726F';
wwv_flow_api.g_varchar2_table(12) := '6772657373222C702C6E2C702E73697A652F283130302F6E29297D2C6173796E634C6F6F703A66756E6374696F6E28652C6F2C61297B76617220723D312C703D21312C6E3D7B6E6578743A66756E6374696F6E28297B707C7C28723C3D653F28722B2B2C';
wwv_flow_api.g_varchar2_table(13) := '6F286E29293A28703D21302C61282929297D2C697465726174696F6E3A66756E6374696F6E28297B72657475726E20722D317D2C73746F703A66756E6374696F6E28297B703D21302C6128297D7D3B72657475726E206E2E6E65787428292C6E7D2C7072';
wwv_flow_api.g_varchar2_table(14) := '6F6365737346696C653A66756E6374696F6E28652C6F2C61297B69662828652E6F7074696F6E732E726573697A6557696474687C7C652E6F7074696F6E732E726573697A654865696768742926266F2E747970652E6D61746368282F696D6167652E2A2F';
wwv_flow_api.g_varchar2_table(15) := '29297B76617220723D652E6F7074696F6E732E726573697A654D6574686F643B723D652E6F7074696F6E732E726573697A6557696474682626652E6F7074696F6E732E726573697A654865696768743F2263726F70223A22636F6E7461696E222C652E72';
wwv_flow_api.g_varchar2_table(16) := '6573697A65496D616765286F2C652E6F7074696F6E732E726573697A6557696474682C652E6F7074696F6E732E726573697A654865696768742C722C66756E6374696F6E2865297B652E6E616D653D6F2E6E616D652C652E7374617475733D6F2E737461';
wwv_flow_api.g_varchar2_table(17) := '7475732C652E61636365707465643D6F2E61636365707465642C652E70726F63657373696E673D6F2E70726F63657373696E672C652E6C6173744D6F6469666965643D6F2E6C6173744D6F6469666965642C652E6C6173744D6F64696669656444617465';
wwv_flow_api.g_varchar2_table(18) := '3D6F2E6C6173744D6F646966696564446174652C652E70726576696577456C656D656E743D6F2E70726576696577456C656D656E742C652E7072657669657754656D706C6174653D6F2E7072657669657754656D706C6174652C652E5F72656D6F76654C';
wwv_flow_api.g_varchar2_table(19) := '696E6B3D6F2E5F72656D6F76654C696E6B2C612865297D297D656C73652061286F297D2C75706C6F6164447A46696C65734368756E6B65643A66756E6374696F6E28652C6F2C612C722C70297B666F7228766172206E3D303B6E3C722E6C656E6774683B';
wwv_flow_api.g_varchar2_table(20) := '6E2B2B297B766172206C2C743D725B6E5D3B6170657844726F707A6F6E652E70726F6365737346696C6528612C725B6E5D2C66756E6374696F6E2872297B722626286C3D742C743D72293B766172206E3D6E65772046696C655265616465723B6E2E6F6E';
wwv_flow_api.g_varchar2_table(21) := '6C6F61643D66756E6374696F6E286E297B72657475726E2066756E6374696F6E2873297B6966286E297B76617220692C642C752C672C632C783D707C7C313034383537362C7A3D4D6174682E6365696C28742E73697A652F78293B6170657844726F707A';
wwv_flow_api.g_varchar2_table(22) := '6F6E652E6173796E634C6F6F70287A2C66756E6374696F6E2870297B753D702E697465726174696F6E28292C673D782A28752D31292C633D672B782C617065782E64656275672E6C6F6728742E6E616D652B222063757272656E744368756E6B222C7529';
wwv_flow_api.g_varchar2_table(23) := '2C617065782E64656275672E6C6F6728742E6E616D652B22206368756E6B5374617274222C67292C617065782E64656275672E6C6F6728742E6E616D652B22206368756E6B456E64222C63292C693D742E736C69636528672C63293B766172206E3D6E65';
wwv_flow_api.g_varchar2_table(24) := '772046696C655265616465723B6E2E6F6E6C6F61643D66756E6374696F6E286E297B72657475726E2066756E6374696F6E286E297B643D6170657844726F707A6F6E652E62696E617279417272617932626173653634286E2E7461726765742E72657375';
wwv_flow_api.g_varchar2_table(25) := '6C74293B76617220733D5B5D3B733D6170657844726F707A6F6E652E636C6F6232417272617928642C3365342C73292C742E7868723D617065782E6A51756572792E616A6178287B64617461547970653A2274657874222C747970653A22504F5354222C';
wwv_flow_api.g_varchar2_table(26) := '75726C3A77696E646F772E6C6F636174696F6E2E687265662E73756273747228302C77696E646F772E6C6F636174696F6E2E687265662E696E6465784F6628222F663F703D22292B31292B227777765F666C6F772E616A6178222C6173796E633A21302C';
wwv_flow_api.g_varchar2_table(27) := '747261646974696F6E616C3A21302C646174613A7B7830313A2255504C4F4144222C7830323A742E6E616D652C7830333A742E747970652C7830343A752C7830353A7A2C6630313A732C705F726571756573743A22504C5547494E3D222B6F2C705F666C';
wwv_flow_api.g_varchar2_table(28) := '6F775F69643A2476282270466C6F77496422292C705F666C6F775F737465705F69643A2476282270466C6F7753746570496422292C705F696E7374616E63653A2476282270496E7374616E636522292C705F64656275673A247628227064656275672229';
wwv_flow_api.g_varchar2_table(29) := '7D2C737563636573733A66756E6374696F6E286F297B72262628743D6C293B766172206E3B7472797B6E3D6A51756572792E70617273654A534F4E286F297D63617463682865297B617065782E64656275672E6C6F6728226170657844726F707A6F6E65';
wwv_flow_api.g_varchar2_table(30) := '2E75706C6F6164447A46696C65734368756E6B656420526573706F6E73652050617273654572726F72222C65292C6E3D6A51756572792E70617273654A534F4E28277B2022737461747573223A20226572726F72222C20226D657373616765223A202275';
wwv_flow_api.g_varchar2_table(31) := '706C6F6164447A46696C65734368756E6B656420526573706F6E73652050617273654572726F72222C2022636F6465223A2022414A41582043616C6C6261636B20287044617461292050617273654572726F7222207D27297D226572726F72223D3D6E2E';
wwv_flow_api.g_varchar2_table(32) := '7374617475733F28617065782E64656275672E6C6F6728226170657844726F707A6F6E652E75706C6F6164447A46696C65734368756E6B6564204572726F72222C6E2E6D6573736167652C6E2E636F6465292C617065782E6576656E742E747269676765';
wwv_flow_api.g_varchar2_table(33) := '72282223222B652C2264726F707A6F6E652D75706C6F61642D6368756E6B2D6572726F72222C6E292C742E7374617475733D44726F707A6F6E652E4552524F522C612E656D697428226572726F72222C742C224461746162617365206572726F72206475';
wwv_flow_api.g_varchar2_table(34) := '72696E672066696C652075706C6F616422292C612E656D69742822636F6D706C657465222C74292C612E70726F6365737351756575652829293A2273756363657373223D3D6E2E737461747573262628617065782E64656275672E6C6F67282261706578';
wwv_flow_api.g_varchar2_table(35) := '44726F707A6F6E652E75706C6F6164447A46696C65734368756E6B65642053756363657373222C6E2E6D657373616765292C617065782E6576656E742E74726967676572282223222B652C2264726F707A6F6E652D75706C6F61642D6368756E6B2D7375';
wwv_flow_api.g_varchar2_table(36) := '6363657373222C6F292C753D3D7A262628742E69643D6E2E69642C742E7374617475733D44726F707A6F6E652E535543434553532C612E656D6974282273756363657373222C742C2273756363657373222C6E756C6C292C612E656D69742822636F6D70';
wwv_flow_api.g_varchar2_table(37) := '6C657465222C74292C612E70726F636573735175657565282929292C72262628743D72292C702E6E65787428297D2C6572726F723A66756E6374696F6E286F2C70297B72262628743D6C292C617065782E64656275672E6C6F6728226170657844726F70';
wwv_flow_api.g_varchar2_table(38) := '7A6F6E652E75706C6F6164447A46696C65734368756E6B6564204572726F72222C70292C617065782E6576656E742E74726967676572282223222B652C2264726F707A6F6E652D75706C6F61642D6368756E6B2D6572726F72222C70292C742E73746174';
wwv_flow_api.g_varchar2_table(39) := '75733D44726F707A6F6E652E4552524F523B766172206E3D22223B6E3D703F703A224572726F722070726F63657373696E672066696C65222C612E656D697428226572726F72222C742C6E2C6F292C612E656D69742822636F6D706C657465222C74292C';
wwv_flow_api.g_varchar2_table(40) := '612E70726F63657373517565756528297D2C7868723A66756E6374696F6E28297B72657475726E205868724F626A3D242E616A617853657474696E67732E78687228292C5868724F626A2E75706C6F61643F5868724F626A2E75706C6F61642E61646445';
wwv_flow_api.g_varchar2_table(41) := '76656E744C697374656E6572282270726F6772657373222C66756E6374696F6E2865297B6170657844726F707A6F6E652E73657455706C6F616450726F67726573734368756E6B656428652C612C752C7A2C6C7C7C74297D2C2131293A617065782E6465';
wwv_flow_api.g_varchar2_table(42) := '6275672E6C6F6728226170657844726F707A6F6E652E75706C6F6164447A46696C65734368756E6B656420584852222C2255706C6F61642070726F6772657373206973206E6F7420737570706F727465642E22292C5868724F626A7D7D297D7D2869292C';
wwv_flow_api.g_varchar2_table(43) := '6E2E72656164417341727261794275666665722869297D2C66756E6374696F6E28297B617065782E64656275672E6C6F6728226170657844726F707A6F6E652E75706C6F6164447A46696C65734368756E6B6564204C6F6F7020656E64656422297D297D';
wwv_flow_api.g_varchar2_table(44) := '656C736520612E70726F63657373517565756528297D7D2874292C6E2E72656164417341727261794275666665722874297D297D7D2C75706C6F6164447A46696C6573466F726D446174613A66756E6374696F6E28652C6F2C612C72297B666F72287661';
wwv_flow_api.g_varchar2_table(45) := '7220703D303B703C722E6C656E6774683B702B2B297B766172206E2C6C3D725B705D3B6170657844726F707A6F6E652E70726F6365737346696C6528612C725B705D2C66756E6374696F6E2872297B696628722626286E3D6C2C6C3D72292C6C297B7661';
wwv_flow_api.g_varchar2_table(46) := '7220703D6E657720466F726D446174613B702E617070656E642822705F72657175657374222C22504C5547494E3D222B6F292C702E617070656E642822705F666C6F775F6964222C2476282270466C6F7749642229292C702E617070656E642822705F66';
wwv_flow_api.g_varchar2_table(47) := '6C6F775F737465705F6964222C2476282270466C6F775374657049642229292C702E617070656E642822705F696E7374616E6365222C2476282270496E7374616E63652229292C702E617070656E642822705F6465627567222C24762822706465627567';
wwv_flow_api.g_varchar2_table(48) := '2229292C702E617070656E642822463031222C6C2C6C2E6E616D65292C702E617070656E642822583031222C2255504C4F414422292C702E617070656E642822583032222C6C2E6E616D65292C702E617070656E642822583033222C6C2E74797065292C';
wwv_flow_api.g_varchar2_table(49) := '612E656D6974282275706C6F616470726F6772657373222C6C2C31302C6C2E73697A652F3130292C6C2E7868723D617065782E6A51756572792E616A6178287B64617461547970653A2274657874222C747970653A22504F5354222C75726C3A77696E64';
wwv_flow_api.g_varchar2_table(50) := '6F772E6C6F636174696F6E2E687265662E73756273747228302C77696E646F772E6C6F636174696F6E2E687265662E696E6465784F6628222F663F703D22292B31292B227777765F666C6F772E616A6178222C6173796E633A21302C70726F6365737344';
wwv_flow_api.g_varchar2_table(51) := '6174613A21312C636F6E74656E74547970653A21312C747261646974696F6E616C3A21302C646174613A702C737563636573733A66756E6374696F6E286F297B722626286C3D6E293B76617220703B7472797B703D6A51756572792E70617273654A534F';
wwv_flow_api.g_varchar2_table(52) := '4E286F297D63617463682865297B617065782E64656275672E6C6F6728226170657844726F707A6F6E652E75706C6F6164447A46696C657320526573706F6E73652050617273654572726F72222C65292C703D6A51756572792E70617273654A534F4E28';
wwv_flow_api.g_varchar2_table(53) := '277B2022737461747573223A20226572726F72222C20226D657373616765223A202275706C6F6164447A46696C657320526573706F6E73652050617273654572726F72222C2022636F6465223A2022414A41582043616C6C6261636B2028704461746129';
wwv_flow_api.g_varchar2_table(54) := '2050617273654572726F7222207D27297D226572726F72223D3D702E7374617475733F28617065782E64656275672E6C6F6728226170657844726F707A6F6E652E75706C6F6164447A46696C6573204572726F72222C702E6D6573736167652C702E636F';
wwv_flow_api.g_varchar2_table(55) := '6465292C617065782E6576656E742E74726967676572282223222B652C2264726F707A6F6E652D75706C6F61642D6572726F72222C70292C6C2E7374617475733D44726F707A6F6E652E4552524F522C612E656D697428226572726F72222C6C2C224461';
wwv_flow_api.g_varchar2_table(56) := '746162617365206572726F7220647572696E672066696C652075706C6F61642229293A2273756363657373223D3D702E7374617475732626286C2E69643D702E69642C617065782E64656275672E6C6F6728226170657844726F707A6F6E652E75706C6F';
wwv_flow_api.g_varchar2_table(57) := '6164447A46696C65732053756363657373222C702E6D657373616765292C617065782E6576656E742E74726967676572282223222B652C2264726F707A6F6E652D75706C6F61642D73756363657373222C6F292C6C2E7374617475733D44726F707A6F6E';
wwv_flow_api.g_varchar2_table(58) := '652E535543434553532C612E656D6974282273756363657373222C6C2C2273756363657373222C6E756C6C29292C612E656D6974282275706C6F616470726F6772657373222C6C2C3130302C6C2E73697A65292C612E656D69742822636F6D706C657465';
wwv_flow_api.g_varchar2_table(59) := '222C6C292C722626286C3D72292C612E70726F63657373517565756528297D2C6572726F723A66756E6374696F6E286F2C70297B722626286C3D6E292C617065782E64656275672E6C6F6728226170657844726F707A6F6E652E75706C6F6164447A4669';
wwv_flow_api.g_varchar2_table(60) := '6C6573204572726F72222C70292C617065782E6576656E742E74726967676572282223222B652C2264726F707A6F6E652D75706C6F61642D6572726F72222C70292C6C2E7374617475733D44726F707A6F6E652E4552524F523B76617220743D22223B74';
wwv_flow_api.g_varchar2_table(61) := '3D703F703A224572726F722070726F63657373696E672066696C65222C612E656D697428226572726F72222C6C2C742C6F292C612E656D69742822636F6D706C657465222C6C292C612E70726F63657373517565756528297D2C7868723A66756E637469';
wwv_flow_api.g_varchar2_table(62) := '6F6E28297B72657475726E205868724F626A3D242E616A617853657474696E67732E78687228292C5868724F626A2E75706C6F61643F5868724F626A2E75706C6F61642E6164644576656E744C697374656E6572282270726F6772657373222C66756E63';
wwv_flow_api.g_varchar2_table(63) := '74696F6E2865297B6170657844726F707A6F6E652E73657455706C6F616450726F677265737328652C612C6C297D2C2131293A617065782E64656275672E6C6F6728226170657844726F707A6F6E652E75706C6F6164447A46696C657320584852222C22';
wwv_flow_api.g_varchar2_table(64) := '55706C6F61642070726F6772657373206973206E6F7420737570706F727465642E22292C5868724F626A7D7D297D656C736520612E70726F63657373517565756528297D297D7D2C64656C657465447A46696C653A66756E6374696F6E28652C6F2C612C';
wwv_flow_api.g_varchar2_table(65) := '72297B617065782E6A51756572792E616A6178287B64617461547970653A2274657874222C747970653A22504F5354222C75726C3A77696E646F772E6C6F636174696F6E2E687265662E73756273747228302C77696E646F772E6C6F636174696F6E2E68';
wwv_flow_api.g_varchar2_table(66) := '7265662E696E6465784F6628222F663F703D22292B31292B227777765F666C6F772E616A6178222C6173796E633A21302C747261646974696F6E616C3A21302C646174613A7B7830313A2244454C455445222C7830323A722E6E616D652C7830333A722E';
wwv_flow_api.g_varchar2_table(67) := '69642C705F726571756573743A22504C5547494E3D222B6F2C705F666C6F775F69643A2476282270466C6F77496422292C705F666C6F775F737465705F69643A2476282270466C6F7753746570496422292C705F696E7374616E63653A2476282270496E';
wwv_flow_api.g_varchar2_table(68) := '7374616E636522292C705F64656275673A2476282270646562756722297D2C737563636573733A66756E6374696F6E286F297B76617220613B7472797B613D6A51756572792E70617273654A534F4E286F297D63617463682865297B617065782E646562';
wwv_flow_api.g_varchar2_table(69) := '75672E6C6F6728226170657844726F707A6F6E652E64656C657465447A46696C6520526573706F6E73652050617273654572726F72222C65292C613D6A51756572792E70617273654A534F4E28277B2022737461747573223A20226572726F72222C2022';
wwv_flow_api.g_varchar2_table(70) := '6D657373616765223A202264656C657465447A46696C6520526573706F6E73652050617273654572726F72222C2022636F6465223A2022414A41582043616C6C6261636B20287044617461292050617273654572726F7222207D27297D226572726F7222';
wwv_flow_api.g_varchar2_table(71) := '3D3D612E7374617475733F28617065782E64656275672E6C6F6728226170657844726F707A6F6E652E64656C657465447A46696C65204572726F72222C612E6D6573736167652C612E636F6465292C617065782E6576656E742E74726967676572282223';
wwv_flow_api.g_varchar2_table(72) := '222B652C2264726F707A6F6E652D64656C6574652D6572726F72222C6129293A2273756363657373223D3D612E737461747573262628617065782E64656275672E6C6F6728226170657844726F707A6F6E652E64656C657465447A46696C652053756363';
wwv_flow_api.g_varchar2_table(73) := '657373222C612E6D657373616765292C617065782E6576656E742E74726967676572282223222B652C2264726F707A6F6E652D64656C6574652D73756363657373222C6F29297D2C6572726F723A66756E6374696F6E286F2C61297B617065782E646562';
wwv_flow_api.g_varchar2_table(74) := '75672E6C6F6728226170657844726F707A6F6E652E64656C657465447A46696C65204572726F72222C61292C617065782E6576656E742E74726967676572282223222B652C2264726F707A6F6E652D64656C6574652D6572726F72222C61297D7D297D2C';
wwv_flow_api.g_varchar2_table(75) := '68616E646C65506C7567696E4576656E74733A66756E6374696F6E28652C6F297B652E6F6E282272656D6F76656466696C65222C66756E6374696F6E2865297B617065782E64656275672E6C6F6728226170657844726F707A6F6E652E68616E646C6550';
wwv_flow_api.g_varchar2_table(76) := '6C7567696E4576656E7473202D2072656D6F76656466696C65206576656E7422292C617065782E6576656E742E74726967676572282223222B6F2C2264726F707A6F6E652D64656C657465642D66696C65222C65297D292C652E6F6E2822616464656466';
wwv_flow_api.g_varchar2_table(77) := '696C65222C66756E6374696F6E2865297B617065782E64656275672E6C6F6728226170657844726F707A6F6E652E68616E646C65506C7567696E4576656E7473202D20616464656466696C65206576656E7422292C617065782E6576656E742E74726967';
wwv_flow_api.g_varchar2_table(78) := '676572282223222B6F2C2264726F707A6F6E652D61646465642D66696C65222C65297D292C652E6F6E28226D617866696C65736578636565646564222C66756E6374696F6E2865297B617065782E64656275672E6C6F6728226170657844726F707A6F6E';
wwv_flow_api.g_varchar2_table(79) := '652E68616E646C65506C7567696E4576656E7473202D206D617866696C65736578636565646564206576656E7422292C617065782E6576656E742E74726967676572282223222B6F2C2264726F707A6F6E652D6D617866696C65732D6578636565646564';
wwv_flow_api.g_varchar2_table(80) := '222C65297D292C652E6F6E2822746F74616C75706C6F616470726F6772657373222C66756E6374696F6E2865297B617065782E64656275672E6C6F6728226170657844726F707A6F6E652E68616E646C65506C7567696E4576656E7473202D20746F7461';
wwv_flow_api.g_varchar2_table(81) := '6C75706C6F616470726F6772657373206576656E7422292C617065782E6576656E742E74726967676572282223222B6F2C2264726F707A6F6E652D746F74616C75706C6F61642D70726F6772657373222C65297D292C652E6F6E282264726167656E7465';
wwv_flow_api.g_varchar2_table(82) := '72222C66756E6374696F6E28297B617065782E64656275672E6C6F6728226170657844726F707A6F6E652E68616E646C65506C7567696E4576656E7473202D2064726167656E746572206576656E7422292C617065782E6576656E742E74726967676572';
wwv_flow_api.g_varchar2_table(83) := '282223222B6F2C2264726F707A6F6E652D647261672D6F76657222297D292C652E6F6E28226572726F72222C66756E6374696F6E28652C61297B617065782E64656275672E6C6F6728226170657844726F707A6F6E652E68616E646C65506C7567696E45';
wwv_flow_api.g_varchar2_table(84) := '76656E7473202D206572726F72206576656E7422292C652E6572726F724D6573736167653D612C617065782E6576656E742E74726967676572282223222B6F2C2264726F707A6F6E652D66696C652D6572726F72222C65297D292C652E6F6E2822636F6D';
wwv_flow_api.g_varchar2_table(85) := '706C657465222C66756E6374696F6E28297B303D3D3D652E67657451756575656446696C657328292E6C656E6774682626303D3D3D652E67657455706C6F6164696E6746696C657328292E6C656E677468262628617065782E64656275672E6C6F672822';
wwv_flow_api.g_varchar2_table(86) := '6170657844726F707A6F6E652E68616E646C65506C7567696E4576656E7473202D20636F6D706C657465206576656E7422292C617065782E6576656E742E74726967676572282223222B6F2C2264726F707A6F6E652D75706C6F61642D636F6D706C6574';
wwv_flow_api.g_varchar2_table(87) := '652229297D297D2C706C7567696E48616E646C65723A66756E6374696F6E28652C6F297B76617220613D6A5175657279282223222B617065782E7574696C2E65736361706543535328652B225F64726F707A6F6E6522292C617065782E6750616765436F';
wwv_flow_api.g_varchar2_table(88) := '6E7465787424292C723D617065782E7574696C2E65736361706543535328652B225F64726F707A6F6E6522292C703D6F2E616A61784964656E7469666965722C6E3D7061727365466C6F6174286F2E6D617846696C6573697A65292C6C3D706172736549';
wwv_flow_api.g_varchar2_table(89) := '6E74286F2E6D617846696C6573292C743D6F2E616363657074656446696C65732C733D6F2E75706C6F61644D656368616E69736D2C693D6170657844726F707A6F6E652E7061727365426F6F6C65616E286F2E636C69636B61626C65292C643D61706578';
wwv_flow_api.g_varchar2_table(90) := '44726F707A6F6E652E7061727365426F6F6C65616E286F2E73686F7746696C6550726576696577292C753D6170657844726F707A6F6E652E7061727365426F6F6C65616E286F2E737570706F7274436F70795061737465292C673D6170657844726F707A';
wwv_flow_api.g_varchar2_table(91) := '6F6E652E7061727365426F6F6C65616E286F2E72656D6F7665416674657255706C6F6164292C633D6170657844726F707A6F6E652E7061727365426F6F6C65616E286F2E64656C65746546696C6573292C783D6170657844726F707A6F6E652E70617273';
wwv_flow_api.g_varchar2_table(92) := '65426F6F6C65616E286F2E726573697A65496D61676573292C7A3D7061727365496E74286F2E726573697A655769647468292C663D7061727365496E74286F2E726573697A65486569676874292C443D6F2E706C7567696E5072656669782C763D706172';
wwv_flow_api.g_varchar2_table(93) := '7365496E74286F2E6368756E6B53697A65292C6D3D6F2E646973706C61794D6573736167652C623D6F2E66616C6C6261636B4D6573736167652C683D6F2E66696C65546F6F4269674D6573736167652C463D6F2E6D617846696C65734D6573736167652C';
wwv_flow_api.g_varchar2_table(94) := '773D6F2E72656D6F766546696C654D6573736167652C793D6F2E63616E63656C55706C6F61644D6573736167652C453D6F2E63616E63656C55706C6F6164436F6E6669726D4D6573736167652C503D6F2E696E76616C696446696C65547970654D657373';
wwv_flow_api.g_varchar2_table(95) := '6167653B617065782E64656275672E6C6F6728226170657844726F707A6F6E652E706C7567696E48616E646C6572202D2070526567696F6E4964222C65292C617065782E64656275672E6C6F6728226170657844726F707A6F6E652E706C7567696E4861';
wwv_flow_api.g_varchar2_table(96) := '6E646C6572202D20704F7074696F6E73222C6F292C617065782E64656275672E6C6F6728226170657844726F707A6F6E652E706C7567696E48616E646C6572202D20726567696F6E222C72292C617065782E64656275672E6C6F6728226170657844726F';
wwv_flow_api.g_varchar2_table(97) := '707A6F6E652E706C7567696E48616E646C6572202D20726567696F6E24222C61292C617065782E64656275672E6C6F6728226170657844726F707A6F6E652E706C7567696E48616E646C6572202D20616A61784964656E746966696572222C70292C6170';
wwv_flow_api.g_varchar2_table(98) := '65782E64656275672E6C6F6728226170657844726F707A6F6E652E706C7567696E48616E646C6572202D206D617846696C6553697A65222C6E292C617065782E64656275672E6C6F6728226170657844726F707A6F6E652E706C7567696E48616E646C65';
wwv_flow_api.g_varchar2_table(99) := '72202D206D617846696C6573222C6C292C617065782E64656275672E6C6F6728226170657844726F707A6F6E652E706C7567696E48616E646C6572202D20616363657074656446696C6573222C74292C617065782E64656275672E6C6F67282261706578';
wwv_flow_api.g_varchar2_table(100) := '44726F707A6F6E652E706C7567696E48616E646C6572202D2075706C6F61644D656368616E69736D222C73292C617065782E64656275672E6C6F6728226170657844726F707A6F6E652E706C7567696E48616E646C6572202D20636C69636B61626C6522';
wwv_flow_api.g_varchar2_table(101) := '2C69292C617065782E64656275672E6C6F6728226170657844726F707A6F6E652E706C7567696E48616E646C6572202D2073686F7746696C6550726576696577222C64292C617065782E64656275672E6C6F6728226170657844726F707A6F6E652E706C';
wwv_flow_api.g_varchar2_table(102) := '7567696E48616E646C6572202D20737570706F7274436F70795061737465222C75292C617065782E64656275672E6C6F6728226170657844726F707A6F6E652E706C7567696E48616E646C6572202D2072656D6F7665416674657255706C6F6164222C67';
wwv_flow_api.g_varchar2_table(103) := '292C617065782E64656275672E6C6F6728226170657844726F707A6F6E652E706C7567696E48616E646C6572202D2064656C65746546696C6573222C63292C617065782E64656275672E6C6F6728226170657844726F707A6F6E652E706C7567696E4861';
wwv_flow_api.g_varchar2_table(104) := '6E646C6572202D20726573697A65496D61676573222C78292C617065782E64656275672E6C6F6728226170657844726F707A6F6E652E706C7567696E48616E646C6572202D20726573697A655769647468222C7A292C617065782E64656275672E6C6F67';
wwv_flow_api.g_varchar2_table(105) := '28226170657844726F707A6F6E652E706C7567696E48616E646C6572202D20726573697A65486569676874222C66292C617065782E64656275672E6C6F6728226170657844726F707A6F6E652E706C7567696E48616E646C6572202D20706C7567696E50';
wwv_flow_api.g_varchar2_table(106) := '7265666978222C44292C617065782E64656275672E6C6F6728226170657844726F707A6F6E652E706C7567696E48616E646C6572202D206368756E6B53697A65222C76292C617065782E64656275672E6C6F6728226170657844726F707A6F6E652E706C';
wwv_flow_api.g_varchar2_table(107) := '7567696E48616E646C6572202D20646973706C61794D657373616765222C6D292C617065782E64656275672E6C6F6728226170657844726F707A6F6E652E706C7567696E48616E646C6572202D2066616C6C6261636B4D657373616765222C62292C6170';
wwv_flow_api.g_varchar2_table(108) := '65782E64656275672E6C6F6728226170657844726F707A6F6E652E706C7567696E48616E646C6572202D2066696C65546F6F4269674D657373616765222C68292C617065782E64656275672E6C6F6728226170657844726F707A6F6E652E706C7567696E';
wwv_flow_api.g_varchar2_table(109) := '48616E646C6572202D206D617846696C65734D657373616765222C46292C617065782E64656275672E6C6F6728226170657844726F707A6F6E652E706C7567696E48616E646C6572202D2072656D6F766546696C654D657373616765222C77292C617065';
wwv_flow_api.g_varchar2_table(110) := '782E64656275672E6C6F6728226170657844726F707A6F6E652E706C7567696E48616E646C6572202D2063616E63656C55706C6F61644D657373616765222C79292C617065782E64656275672E6C6F6728226170657844726F707A6F6E652E706C756769';
wwv_flow_api.g_varchar2_table(111) := '6E48616E646C6572202D2063616E63656C55706C6F6164436F6E6669726D4D657373616765222C45292C617065782E64656275672E6C6F6728226170657844726F707A6F6E652E706C7567696E48616E646C6572202D20696E76616C696446696C655479';
wwv_flow_api.g_varchar2_table(112) := '70654D657373616765222C50293B76617220432C483B783F28433D7A7C7C6E756C6C2C483D667C7C6E756C6C293A28433D6E756C6C2C483D6E756C6C293B76617220533D7B75726C3A77696E646F772E6C6F636174696F6E2E687265662E737562737472';
wwv_flow_api.g_varchar2_table(113) := '28302C77696E646F772E6C6F636174696F6E2E687265662E696E6465784F6628222F663F703D22292B31292B227777765F666C6F772E616A6178222C75706C6F61644D756C7469706C653A21312C6175746F50726F6365737351756575653A21302C7061';
wwv_flow_api.g_varchar2_table(114) := '72616C6C656C55706C6F6164733A312C61646452656D6F76654C696E6B733A632C6D617846696C6573697A653A6E2C636C69636B61626C653A692C6D617846696C65733A6C2C616363657074656446696C65733A742C726573697A6557696474683A432C';
wwv_flow_api.g_varchar2_table(115) := '726573697A654865696768743A482C6469637444656661756C744D6573736167653A6D2C6469637446616C6C6261636B4D6573736167653A622C6469637446696C65546F6F4269673A682C646963744D617846696C657345786365656465643A462C6469';
wwv_flow_api.g_varchar2_table(116) := '637452656D6F766546696C653A772C6469637443616E63656C55706C6F61643A792C6469637443616E63656C55706C6F6164436F6E6669726D6174696F6E3A452C64696374496E76616C696446696C65547970653A507D3B44726F707A6F6E652E617574';
wwv_flow_api.g_varchar2_table(117) := '6F446973636F7665723D21313B766172205F3D6E65772044726F707A6F6E65282264697623222B722C53293B697C7C2428222E647A2D68696464656E2D696E70757422292E70726F70282264697361626C6564222C2130292C75262646696C6552656164';
wwv_flow_api.g_varchar2_table(118) := '65724A532E7365747570436C6970626F61726428646F63756D656E742E626F64792C7B72656164417344656661756C743A224461746155524C222C6163636570743A7B22696D6167652F2A223A224461746155524C227D2C6F6E3A7B6C6F61643A66756E';
wwv_flow_api.g_varchar2_table(119) := '6374696F6E28652C6F297B5F2E61646446696C65286F297D7D7D292C5F2E75706C6F616446696C65733D66756E6374696F6E286F297B224E4F524D414C223D3D733F6170657844726F707A6F6E652E75706C6F6164447A46696C6573466F726D44617461';
wwv_flow_api.g_varchar2_table(120) := '28652C702C5F2C6F293A224348554E4B4544223D3D7326266170657844726F707A6F6E652E75706C6F6164447A46696C65734368756E6B656428652C702C5F2C6F2C76297D2C6170657844726F707A6F6E652E68616E646C65506C7567696E4576656E74';
wwv_flow_api.g_varchar2_table(121) := '73285F2C65292C6326265F2E6F6E282272656D6F76656466696C65222C66756E6374696F6E286F297B2273756363657373223D3D6F2E73746174757326266170657844726F707A6F6E652E64656C657465447A46696C6528652C702C5F2C6F297D292C5F';
wwv_flow_api.g_varchar2_table(122) := '2E6F6E2822616464656466696C65222C66756E6374696F6E2865297B69662864262621652E747970652E6D61746368282F696D6167652E2A2F29297B76617220613D652E6E616D652E73706C697428222E22292E706F7028292C723D6F2E706C7567696E';
wwv_flow_api.g_varchar2_table(123) := '5072656669782B22696D672F222B612B222E706E67223B6170657844726F707A6F6E652E696D61676545786973747328722C66756E6374696F6E28297B2428652E70726576696577456C656D656E74292E66696E6428222E647A2D696D61676520696D67';
wwv_flow_api.g_varchar2_table(124) := '22292E617474722822737263222C6F2E706C7567696E5072656669782B22696D672F222B612B222E706E6722297D2C66756E6374696F6E28297B2428652E70726576696577456C656D656E74292E66696E6428222E647A2D696D61676520696D6722292E';
wwv_flow_api.g_varchar2_table(125) := '617474722822737263222C6F2E706C7567696E5072656669782B22696D672F6F746865722E706E6722297D297D7D292C5F2E6F6E2822636F6D706C657465222C66756E6374696F6E28297B303D3D3D5F2E67657451756575656446696C657328292E6C65';
wwv_flow_api.g_varchar2_table(126) := '6E6774682626303D3D3D5F2E67657455706C6F6164696E6746696C657328292E6C656E677468262667262673657454696D656F75742866756E6374696F6E28297B5F2E72656D6F7665416C6C46696C657328297D2C336533297D297D7D3B';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72362816319797259)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'js/apexdropzone.min.js'
,p_mime_type=>'application/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2275736520737472696374223B0A0A766172205F637265617465436C617373203D2066756E6374696F6E202829207B2066756E6374696F6E20646566696E6550726F70657274696573287461726765742C2070726F707329207B20666F72202876617220';
wwv_flow_api.g_varchar2_table(2) := '69203D20303B2069203C2070726F70732E6C656E6774683B20692B2B29207B207661722064657363726970746F72203D2070726F70735B695D3B2064657363726970746F722E656E756D657261626C65203D2064657363726970746F722E656E756D6572';
wwv_flow_api.g_varchar2_table(3) := '61626C65207C7C2066616C73653B2064657363726970746F722E636F6E666967757261626C65203D20747275653B20696620282276616C75652220696E2064657363726970746F72292064657363726970746F722E7772697461626C65203D2074727565';
wwv_flow_api.g_varchar2_table(4) := '3B204F626A6563742E646566696E6550726F7065727479287461726765742C2064657363726970746F722E6B65792C2064657363726970746F72293B207D207D2072657475726E2066756E6374696F6E2028436F6E7374727563746F722C2070726F746F';
wwv_flow_api.g_varchar2_table(5) := '50726F70732C2073746174696350726F707329207B206966202870726F746F50726F70732920646566696E6550726F7065727469657328436F6E7374727563746F722E70726F746F747970652C2070726F746F50726F7073293B20696620287374617469';
wwv_flow_api.g_varchar2_table(6) := '6350726F70732920646566696E6550726F7065727469657328436F6E7374727563746F722C2073746174696350726F7073293B2072657475726E20436F6E7374727563746F723B207D3B207D28293B0A0A66756E6374696F6E205F706F737369626C6543';
wwv_flow_api.g_varchar2_table(7) := '6F6E7374727563746F7252657475726E2873656C662C2063616C6C29207B20696620282173656C6629207B207468726F77206E6577205265666572656E63654572726F72282274686973206861736E2774206265656E20696E697469616C69736564202D';
wwv_flow_api.g_varchar2_table(8) := '2073757065722829206861736E2774206265656E2063616C6C656422293B207D2072657475726E2063616C6C2026262028747970656F662063616C6C203D3D3D20226F626A65637422207C7C20747970656F662063616C6C203D3D3D202266756E637469';
wwv_flow_api.g_varchar2_table(9) := '6F6E2229203F2063616C6C203A2073656C663B207D0A0A66756E6374696F6E205F696E68657269747328737562436C6173732C207375706572436C61737329207B2069662028747970656F66207375706572436C61737320213D3D202266756E6374696F';
wwv_flow_api.g_varchar2_table(10) := '6E22202626207375706572436C61737320213D3D206E756C6C29207B207468726F77206E657720547970654572726F72282253757065722065787072657373696F6E206D75737420656974686572206265206E756C6C206F7220612066756E6374696F6E';
wwv_flow_api.g_varchar2_table(11) := '2C206E6F742022202B20747970656F66207375706572436C617373293B207D20737562436C6173732E70726F746F74797065203D204F626A6563742E637265617465287375706572436C617373202626207375706572436C6173732E70726F746F747970';
wwv_flow_api.g_varchar2_table(12) := '652C207B20636F6E7374727563746F723A207B2076616C75653A20737562436C6173732C20656E756D657261626C653A2066616C73652C207772697461626C653A20747275652C20636F6E666967757261626C653A2074727565207D207D293B20696620';
wwv_flow_api.g_varchar2_table(13) := '287375706572436C61737329204F626A6563742E73657450726F746F747970654F66203F204F626A6563742E73657450726F746F747970654F6628737562436C6173732C207375706572436C61737329203A20737562436C6173732E5F5F70726F746F5F';
wwv_flow_api.g_varchar2_table(14) := '5F203D207375706572436C6173733B207D0A0A66756E6374696F6E205F636C61737343616C6C436865636B28696E7374616E63652C20436F6E7374727563746F7229207B20696620282128696E7374616E636520696E7374616E63656F6620436F6E7374';
wwv_flow_api.g_varchar2_table(15) := '727563746F722929207B207468726F77206E657720547970654572726F72282243616E6E6F742063616C6C206120636C61737320617320612066756E6374696F6E22293B207D207D0A0A2F2A0A202A0A202A204D6F726520696E666F206174205B777777';
wwv_flow_api.g_varchar2_table(16) := '2E64726F707A6F6E656A732E636F6D5D28687474703A2F2F7777772E64726F707A6F6E656A732E636F6D290A202A0A202A20436F707972696768742028632920323031322C204D6174696173204D656E6F0A202A0A202A205065726D697373696F6E2069';
wwv_flow_api.g_varchar2_table(17) := '7320686572656279206772616E7465642C2066726565206F66206368617267652C20746F20616E7920706572736F6E206F627461696E696E67206120636F70790A202A206F66207468697320736F66747761726520616E64206173736F63696174656420';
wwv_flow_api.g_varchar2_table(18) := '646F63756D656E746174696F6E2066696C657320287468652022536F66747761726522292C20746F206465616C0A202A20696E2074686520536F66747761726520776974686F7574207265737472696374696F6E2C20696E636C7564696E672077697468';
wwv_flow_api.g_varchar2_table(19) := '6F7574206C696D69746174696F6E20746865207269676874730A202A20746F207573652C20636F70792C206D6F646966792C206D657267652C207075626C6973682C20646973747269627574652C207375626C6963656E73652C20616E642F6F72207365';
wwv_flow_api.g_varchar2_table(20) := '6C6C0A202A20636F70696573206F662074686520536F6674776172652C20616E6420746F207065726D697420706572736F6E7320746F2077686F6D2074686520536F6674776172652069730A202A206675726E697368656420746F20646F20736F2C2073';
wwv_flow_api.g_varchar2_table(21) := '75626A65637420746F2074686520666F6C6C6F77696E6720636F6E646974696F6E733A0A202A0A202A205468652061626F766520636F70797269676874206E6F7469636520616E642074686973207065726D697373696F6E206E6F74696365207368616C';
wwv_flow_api.g_varchar2_table(22) := '6C20626520696E636C7564656420696E0A202A20616C6C20636F70696573206F72207375627374616E7469616C20706F7274696F6E73206F662074686520536F6674776172652E0A202A0A202A2054484520534F4654574152452049532050524F564944';
wwv_flow_api.g_varchar2_table(23) := '454420224153204953222C20574954484F55542057415252414E5459204F4620414E59204B494E442C2045585052455353204F520A202A20494D504C4945442C20494E434C5544494E4720425554204E4F54204C494D4954454420544F20544845205741';
wwv_flow_api.g_varchar2_table(24) := '5252414E54494553204F46204D45524348414E544142494C4954592C0A202A204649544E45535320464F52204120504152544943554C415220505552504F534520414E44204E4F4E494E4652494E47454D454E542E20494E204E4F204556454E54205348';
wwv_flow_api.g_varchar2_table(25) := '414C4C205448450A202A20415554484F5253204F5220434F5059524947485420484F4C44455253204245204C4941424C4520464F5220414E5920434C41494D2C2044414D41474553204F52204F544845520A202A204C494142494C4954592C2057484554';
wwv_flow_api.g_varchar2_table(26) := '48455220494E20414E20414354494F4E204F4620434F4E54524143542C20544F5254204F52204F54484552574953452C2041524953494E472046524F4D2C0A202A204F5554204F46204F5220494E20434F4E4E454354494F4E2057495448205448452053';
wwv_flow_api.g_varchar2_table(27) := '4F465457415245204F522054484520555345204F52204F54484552204445414C494E475320494E0A202A2054484520534F4654574152452E0A202A0A202A2F0A0A2F2F2054686520456D697474657220636C6173732070726F7669646573207468652061';
wwv_flow_api.g_varchar2_table(28) := '62696C69747920746F2063616C6C20602E6F6E282960206F6E2044726F707A6F6E6520746F206C697374656E0A2F2F20746F206576656E74732E0A2F2F204974206973207374726F6E676C79206261736564206F6E20636F6D706F6E656E74277320656D';
wwv_flow_api.g_varchar2_table(29) := '697474657220636C6173732C20616E6420492072656D6F766564207468650A2F2F2066756E6374696F6E616C6974792062656361757365206F662074686520646570656E64656E63792068656C6C207769746820646966666572656E74206672616D6577';
wwv_flow_api.g_varchar2_table(30) := '6F726B732E0A76617220456D6974746572203D2066756E6374696F6E202829207B0A202066756E6374696F6E20456D69747465722829207B0A202020205F636C61737343616C6C436865636B28746869732C20456D6974746572293B0A20207D0A0A2020';
wwv_flow_api.g_varchar2_table(31) := '5F637265617465436C61737328456D69747465722C205B7B0A202020206B65793A20226F6E222C0A0A202020202F2F2041646420616E206576656E74206C697374656E657220666F7220676976656E206576656E740A2020202076616C75653A2066756E';
wwv_flow_api.g_varchar2_table(32) := '6374696F6E206F6E286576656E742C20666E29207B0A202020202020746869732E5F63616C6C6261636B73203D20746869732E5F63616C6C6261636B73207C7C207B7D3B0A2020202020202F2F20437265617465206E616D65737061636520666F722074';
wwv_flow_api.g_varchar2_table(33) := '686973206576656E740A2020202020206966202821746869732E5F63616C6C6261636B735B6576656E745D29207B0A2020202020202020746869732E5F63616C6C6261636B735B6576656E745D203D205B5D3B0A2020202020207D0A2020202020207468';
wwv_flow_api.g_varchar2_table(34) := '69732E5F63616C6C6261636B735B6576656E745D2E7075736828666E293B0A20202020202072657475726E20746869733B0A202020207D0A20207D2C207B0A202020206B65793A2022656D6974222C0A2020202076616C75653A2066756E6374696F6E20';
wwv_flow_api.g_varchar2_table(35) := '656D6974286576656E7429207B0A202020202020746869732E5F63616C6C6261636B73203D20746869732E5F63616C6C6261636B73207C7C207B7D3B0A2020202020207661722063616C6C6261636B73203D20746869732E5F63616C6C6261636B735B65';
wwv_flow_api.g_varchar2_table(36) := '76656E745D3B0A0A2020202020206966202863616C6C6261636B7329207B0A2020202020202020666F722028766172205F6C656E203D20617267756D656E74732E6C656E6774682C2061726773203D204172726179285F6C656E203E2031203F205F6C65';
wwv_flow_api.g_varchar2_table(37) := '6E202D2031203A2030292C205F6B6579203D20313B205F6B6579203C205F6C656E3B205F6B65792B2B29207B0A20202020202020202020617267735B5F6B6579202D20315D203D20617267756D656E74735B5F6B65795D3B0A20202020202020207D0A0A';
wwv_flow_api.g_varchar2_table(38) := '2020202020202020666F722028766172205F6974657261746F72203D2063616C6C6261636B732C205F69734172726179203D20747275652C205F69203D20302C205F6974657261746F72203D205F69734172726179203F205F6974657261746F72203A20';
wwv_flow_api.g_varchar2_table(39) := '5F6974657261746F725B53796D626F6C2E6974657261746F725D28293B3B29207B0A20202020202020202020766172205F7265663B0A0A20202020202020202020696620285F6973417272617929207B0A202020202020202020202020696620285F6920';
wwv_flow_api.g_varchar2_table(40) := '3E3D205F6974657261746F722E6C656E6774682920627265616B3B0A2020202020202020202020205F726566203D205F6974657261746F725B5F692B2B5D3B0A202020202020202020207D20656C7365207B0A2020202020202020202020205F69203D20';
wwv_flow_api.g_varchar2_table(41) := '5F6974657261746F722E6E65787428293B0A202020202020202020202020696620285F692E646F6E652920627265616B3B0A2020202020202020202020205F726566203D205F692E76616C75653B0A202020202020202020207D0A0A2020202020202020';
wwv_flow_api.g_varchar2_table(42) := '20207661722063616C6C6261636B203D205F7265663B0A0A2020202020202020202063616C6C6261636B2E6170706C7928746869732C2061726773293B0A20202020202020207D0A2020202020207D0A0A20202020202072657475726E20746869733B0A';
wwv_flow_api.g_varchar2_table(43) := '202020207D0A0A202020202F2F2052656D6F7665206576656E74206C697374656E657220666F7220676976656E206576656E742E20496620666E206973206E6F742070726F76696465642C20616C6C206576656E740A202020202F2F206C697374656E65';
wwv_flow_api.g_varchar2_table(44) := '727320666F722074686174206576656E742077696C6C2062652072656D6F7665642E204966206E6569746865722069732070726F76696465642C20616C6C0A202020202F2F206576656E74206C697374656E6572732077696C6C2062652072656D6F7665';
wwv_flow_api.g_varchar2_table(45) := '642E0A0A20207D2C207B0A202020206B65793A20226F6666222C0A2020202076616C75653A2066756E6374696F6E206F6666286576656E742C20666E29207B0A2020202020206966202821746869732E5F63616C6C6261636B73207C7C20617267756D65';
wwv_flow_api.g_varchar2_table(46) := '6E74732E6C656E677468203D3D3D203029207B0A2020202020202020746869732E5F63616C6C6261636B73203D207B7D3B0A202020202020202072657475726E20746869733B0A2020202020207D0A0A2020202020202F2F207370656369666963206576';
wwv_flow_api.g_varchar2_table(47) := '656E740A2020202020207661722063616C6C6261636B73203D20746869732E5F63616C6C6261636B735B6576656E745D3B0A202020202020696620282163616C6C6261636B7329207B0A202020202020202072657475726E20746869733B0A2020202020';
wwv_flow_api.g_varchar2_table(48) := '207D0A0A2020202020202F2F2072656D6F766520616C6C2068616E646C6572730A20202020202069662028617267756D656E74732E6C656E677468203D3D3D203129207B0A202020202020202064656C65746520746869732E5F63616C6C6261636B735B';
wwv_flow_api.g_varchar2_table(49) := '6576656E745D3B0A202020202020202072657475726E20746869733B0A2020202020207D0A0A2020202020202F2F2072656D6F76652073706563696669632068616E646C65720A202020202020666F7220287661722069203D20303B2069203C2063616C';
wwv_flow_api.g_varchar2_table(50) := '6C6261636B732E6C656E6774683B20692B2B29207B0A20202020202020207661722063616C6C6261636B203D2063616C6C6261636B735B695D3B0A20202020202020206966202863616C6C6261636B203D3D3D20666E29207B0A20202020202020202020';
wwv_flow_api.g_varchar2_table(51) := '63616C6C6261636B732E73706C69636528692C2031293B0A20202020202020202020627265616B3B0A20202020202020207D0A2020202020207D0A0A20202020202072657475726E20746869733B0A202020207D0A20207D5D293B0A0A20207265747572';
wwv_flow_api.g_varchar2_table(52) := '6E20456D69747465723B0A7D28293B0A0A7661722044726F707A6F6E65203D2066756E6374696F6E20285F456D697474657229207B0A20205F696E6865726974732844726F707A6F6E652C205F456D6974746572293B0A0A20205F637265617465436C61';
wwv_flow_api.g_varchar2_table(53) := '73732844726F707A6F6E652C206E756C6C2C205B7B0A202020206B65793A2022696E6974436C617373222C0A2020202076616C75653A2066756E6374696F6E20696E6974436C6173732829207B0A0A2020202020202F2F204578706F73696E6720746865';
wwv_flow_api.g_varchar2_table(54) := '20656D697474657220636C6173732C206D61696E6C7920666F722074657374730A202020202020746869732E70726F746F747970652E456D6974746572203D20456D69747465723B0A0A2020202020202F2A0A2020202020202054686973206973206120';
wwv_flow_api.g_varchar2_table(55) := '6C697374206F6620616C6C20617661696C61626C65206576656E747320796F752063616E207265676973746572206F6E20612064726F707A6F6E65206F626A6563742E0A2020202020202020596F752063616E20726567697374657220616E206576656E';
wwv_flow_api.g_varchar2_table(56) := '742068616E646C6572206C696B6520746869733A0A202020202020202064726F707A6F6E652E6F6E282264726167456E746572222C2066756E6374696F6E2829207B207D293B0A20202020202020202A2F0A202020202020746869732E70726F746F7479';
wwv_flow_api.g_varchar2_table(57) := '70652E6576656E7473203D205B2264726F70222C2022647261677374617274222C202264726167656E64222C202264726167656E746572222C2022647261676F766572222C2022647261676C65617665222C2022616464656466696C65222C2022616464';
wwv_flow_api.g_varchar2_table(58) := '656466696C6573222C202272656D6F76656466696C65222C20227468756D626E61696C222C20226572726F72222C20226572726F726D756C7469706C65222C202270726F63657373696E67222C202270726F63657373696E676D756C7469706C65222C20';
wwv_flow_api.g_varchar2_table(59) := '2275706C6F616470726F6772657373222C2022746F74616C75706C6F616470726F6772657373222C202273656E64696E67222C202273656E64696E676D756C7469706C65222C202273756363657373222C2022737563636573736D756C7469706C65222C';
wwv_flow_api.g_varchar2_table(60) := '202263616E63656C6564222C202263616E63656C65646D756C7469706C65222C2022636F6D706C657465222C2022636F6D706C6574656D756C7469706C65222C20227265736574222C20226D617866696C65736578636565646564222C20226D61786669';
wwv_flow_api.g_varchar2_table(61) := '6C657372656163686564222C20227175657565636F6D706C657465225D3B0A0A202020202020746869732E70726F746F747970652E64656661756C744F7074696F6E73203D207B0A20202020202020202F2A2A0A2020202020202020202A204861732074';
wwv_flow_api.g_varchar2_table(62) := '6F20626520737065636966696564206F6E20656C656D656E7473206F74686572207468616E20666F726D20286F72207768656E2074686520666F726D0A2020202020202020202A20646F65736E2774206861766520616E2060616374696F6E6020617474';
wwv_flow_api.g_varchar2_table(63) := '726962757465292E20596F752063616E20616C736F0A2020202020202020202A2070726F7669646520612066756E6374696F6E20746861742077696C6C2062652063616C6C65642077697468206066696C65736020616E640A2020202020202020202A20';
wwv_flow_api.g_varchar2_table(64) := '6D7573742072657475726E207468652075726C202873696E6365206076332E31322E3060290A2020202020202020202A2F0A202020202020202075726C3A206E756C6C2C0A0A20202020202020202F2A2A0A2020202020202020202A2043616E20626520';
wwv_flow_api.g_varchar2_table(65) := '6368616E67656420746F2060227075742260206966206E65636573736172792E20596F752063616E20616C736F2070726F7669646520612066756E6374696F6E0A2020202020202020202A20746861742077696C6C2062652063616C6C65642077697468';
wwv_flow_api.g_varchar2_table(66) := '206066696C65736020616E64206D7573742072657475726E20746865206D6574686F64202873696E6365206076332E31322E3060292E0A2020202020202020202A2F0A20202020202020206D6574686F643A2022706F7374222C0A0A2020202020202020';
wwv_flow_api.g_varchar2_table(67) := '2F2A2A0A2020202020202020202A2057696C6C20626520736574206F6E20746865205848526571756573742E0A2020202020202020202A2F0A20202020202020207769746843726564656E7469616C733A2066616C73652C0A0A20202020202020202F2A';
wwv_flow_api.g_varchar2_table(68) := '2A0A2020202020202020202A205468652074696D656F757420666F72207468652058485220726571756573747320696E206D696C6C697365636F6E6473202873696E6365206076342E342E3060292E0A2020202020202020202A2F0A2020202020202020';
wwv_flow_api.g_varchar2_table(69) := '74696D656F75743A2033303030302C0A0A20202020202020202F2A2A0A2020202020202020202A20486F77206D616E792066696C652075706C6F61647320746F2070726F6365737320696E20706172616C6C656C2028536565207468650A202020202020';
wwv_flow_api.g_varchar2_table(70) := '2020202A20456E71756575696E672066696C652075706C6F6164732A20646F63756D656E746174696F6E2073656374696F6E20666F72206D6F726520696E666F290A2020202020202020202A2F0A2020202020202020706172616C6C656C55706C6F6164';
wwv_flow_api.g_varchar2_table(71) := '733A20322C0A0A20202020202020202F2A2A0A2020202020202020202A205768657468657220746F2073656E64206D756C7469706C652066696C657320696E206F6E6520726571756573742E2049660A2020202020202020202A20746869732069742073';
wwv_flow_api.g_varchar2_table(72) := '657420746F20747275652C207468656E207468652066616C6C6261636B2066696C6520696E70757420656C656D656E742077696C6C0A2020202020202020202A20686176652074686520606D756C7469706C656020617474726962757465206173207765';
wwv_flow_api.g_varchar2_table(73) := '6C6C2E2054686973206F7074696F6E2077696C6C0A2020202020202020202A20616C736F2074726967676572206164646974696F6E616C206576656E747320286C696B65206070726F63657373696E676D756C7469706C6560292E205365652074686520';
wwv_flow_api.g_varchar2_table(74) := '6576656E74730A2020202020202020202A20646F63756D656E746174696F6E2073656374696F6E20666F72206D6F726520696E666F726D6174696F6E2E0A2020202020202020202A2F0A202020202020202075706C6F61644D756C7469706C653A206661';
wwv_flow_api.g_varchar2_table(75) := '6C73652C0A0A20202020202020202F2A2A0A2020202020202020202A205768657468657220796F752077616E742066696C657320746F2062652075706C6F6164656420696E206368756E6B7320746F20796F7572207365727665722E2054686973206361';
wwv_flow_api.g_varchar2_table(76) := '6E27742062650A2020202020202020202A207573656420696E20636F6D62696E6174696F6E2077697468206075706C6F61644D756C7469706C65602E0A2020202020202020202A0A2020202020202020202A20536565205B6368756E6B7355706C6F6164';
wwv_flow_api.g_varchar2_table(77) := '65645D2823636F6E6669672D6368756E6B7355706C6F616465642920666F72207468652063616C6C6261636B20746F2066696E616C69736520616E2075706C6F61642E0A2020202020202020202A2F0A20202020202020206368756E6B696E673A206661';
wwv_flow_api.g_varchar2_table(78) := '6C73652C0A0A20202020202020202F2A2A0A2020202020202020202A20496620606368756E6B696E676020697320656E61626C65642C207468697320646566696E65732077686574686572202A2A65766572792A2A2066696C652073686F756C64206265';
wwv_flow_api.g_varchar2_table(79) := '206368756E6B65642C0A2020202020202020202A206576656E206966207468652066696C652073697A652069732062656C6F77206368756E6B53697A652E2054686973206D65616E732C207468617420746865206164646974696F6E616C206368756E6B';
wwv_flow_api.g_varchar2_table(80) := '0A2020202020202020202A20666F726D20646174612077696C6C206265207375626D697474656420616E642074686520606368756E6B7355706C6F61646564602063616C6C6261636B2077696C6C20626520696E766F6B65642E0A202020202020202020';
wwv_flow_api.g_varchar2_table(81) := '2A2F0A2020202020202020666F7263654368756E6B696E673A2066616C73652C0A0A20202020202020202F2A2A0A2020202020202020202A20496620606368756E6B696E6760206973206074727565602C207468656E207468697320646566696E657320';
wwv_flow_api.g_varchar2_table(82) := '746865206368756E6B2073697A6520696E2062797465732E0A2020202020202020202A2F0A20202020202020206368756E6B53697A653A20323030303030302C0A0A20202020202020202F2A2A0A2020202020202020202A204966206074727565602C20';
wwv_flow_api.g_varchar2_table(83) := '74686520696E646976696475616C206368756E6B73206F6620612066696C6520617265206265696E672075706C6F616465642073696D756C74616E656F75736C792E0A2020202020202020202A2F0A2020202020202020706172616C6C656C4368756E6B';
wwv_flow_api.g_varchar2_table(84) := '55706C6F6164733A2066616C73652C0A0A20202020202020202F2A2A0A2020202020202020202A20576865746865722061206368756E6B2073686F756C642062652072657472696564206966206974206661696C732E0A2020202020202020202A2F0A20';
wwv_flow_api.g_varchar2_table(85) := '2020202020202072657472794368756E6B733A2066616C73652C0A0A20202020202020202F2A2A0A2020202020202020202A204966206072657472794368756E6B736020697320747275652C20686F77206D616E792074696D65732073686F756C642069';
wwv_flow_api.g_varchar2_table(86) := '7420626520726574726965642E0A2020202020202020202A2F0A202020202020202072657472794368756E6B734C696D69743A20332C0A0A20202020202020202F2A2A0A2020202020202020202A204966206E6F7420606E756C6C6020646566696E6573';
wwv_flow_api.g_varchar2_table(87) := '20686F77206D616E792066696C657320746869732044726F707A6F6E652068616E646C65732E20496620697420657863656564732C0A2020202020202020202A20746865206576656E7420606D617866696C65736578636565646564602077696C6C2062';
wwv_flow_api.g_varchar2_table(88) := '652063616C6C65642E205468652064726F707A6F6E6520656C656D656E742067657473207468650A2020202020202020202A20636C6173732060647A2D6D61782D66696C65732D7265616368656460206163636F7264696E676C7920736F20796F752063';
wwv_flow_api.g_varchar2_table(89) := '616E2070726F766964652076697375616C20666565646261636B2E0A2020202020202020202A2F0A20202020202020206D617846696C6573697A653A203235362C0A0A20202020202020202F2A2A0A2020202020202020202A20546865206E616D65206F';
wwv_flow_api.g_varchar2_table(90) := '66207468652066696C6520706172616D20746861742067657473207472616E736665727265642E0A2020202020202020202A202A2A4E4F54452A2A3A20496620796F75206861766520746865206F7074696F6E20206075706C6F61644D756C7469706C65';
wwv_flow_api.g_varchar2_table(91) := '602073657420746F206074727565602C207468656E0A2020202020202020202A2044726F707A6F6E652077696C6C20617070656E6420605B5D6020746F20746865206E616D652E0A2020202020202020202A2F0A2020202020202020706172616D4E616D';
wwv_flow_api.g_varchar2_table(92) := '653A202266696C65222C0A0A20202020202020202F2A2A0A2020202020202020202A2057686574686572207468756D626E61696C7320666F7220696D616765732073686F756C642062652067656E6572617465640A2020202020202020202A2F0A202020';
wwv_flow_api.g_varchar2_table(93) := '2020202020637265617465496D6167655468756D626E61696C733A20747275652C0A0A20202020202020202F2A2A0A2020202020202020202A20496E204D422E205768656E207468652066696C656E616D6520657863656564732074686973206C696D69';
wwv_flow_api.g_varchar2_table(94) := '742C20746865207468756D626E61696C2077696C6C206E6F742062652067656E6572617465642E0A2020202020202020202A2F0A20202020202020206D61785468756D626E61696C46696C6573697A653A2031302C0A0A20202020202020202F2A2A0A20';
wwv_flow_api.g_varchar2_table(95) := '20202020202020202A20496620606E756C6C602C2074686520726174696F206F662074686520696D6167652077696C6C206265207573656420746F2063616C63756C6174652069742E0A2020202020202020202A2F0A20202020202020207468756D626E';
wwv_flow_api.g_varchar2_table(96) := '61696C57696474683A203132302C0A0A20202020202020202F2A2A0A2020202020202020202A205468652073616D6520617320607468756D626E61696C5769647468602E20496620626F746820617265206E756C6C2C20696D616765732077696C6C206E';
wwv_flow_api.g_varchar2_table(97) := '6F7420626520726573697A65642E0A2020202020202020202A2F0A20202020202020207468756D626E61696C4865696768743A203132302C0A0A20202020202020202F2A2A0A2020202020202020202A20486F772074686520696D616765732073686F75';
wwv_flow_api.g_varchar2_table(98) := '6C64206265207363616C656420646F776E20696E206361736520626F74682C20607468756D626E61696C57696474686020616E6420607468756D626E61696C48656967687460206172652070726F76696465642E0A2020202020202020202A2043616E20';
wwv_flow_api.g_varchar2_table(99) := '6265206569746865722060636F6E7461696E60206F72206063726F70602E0A2020202020202020202A2F0A20202020202020207468756D626E61696C4D6574686F643A202763726F70272C0A0A20202020202020202F2A2A0A2020202020202020202A20';
wwv_flow_api.g_varchar2_table(100) := '4966207365742C20696D616765732077696C6C20626520726573697A656420746F2074686573652064696D656E73696F6E73206265666F7265206265696E67202A2A75706C6F616465642A2A2E0A2020202020202020202A204966206F6E6C79206F6E65';
wwv_flow_api.g_varchar2_table(101) := '2C2060726573697A65576964746860202A2A6F722A2A2060726573697A65486569676874602069732070726F76696465642C20746865206F726967696E616C206173706563740A2020202020202020202A20726174696F206F66207468652066696C6520';
wwv_flow_api.g_varchar2_table(102) := '77696C6C206265207072657365727665642E0A2020202020202020202A0A2020202020202020202A2054686520606F7074696F6E732E7472616E73666F726D46696C65602066756E6374696F6E2075736573207468657365206F7074696F6E732C20736F';
wwv_flow_api.g_varchar2_table(103) := '2069662074686520607472616E73666F726D46696C65602066756E6374696F6E0A2020202020202020202A206973206F76657272696464656E2C207468657365206F7074696F6E7320646F6E277420646F20616E797468696E672E0A2020202020202020';
wwv_flow_api.g_varchar2_table(104) := '202A2F0A2020202020202020726573697A6557696474683A206E756C6C2C0A0A20202020202020202F2A2A0A2020202020202020202A205365652060726573697A655769647468602E0A2020202020202020202A2F0A2020202020202020726573697A65';
wwv_flow_api.g_varchar2_table(105) := '4865696768743A206E756C6C2C0A0A20202020202020202F2A2A0A2020202020202020202A20546865206D696D652074797065206F662074686520726573697A656420696D61676520286265666F726520697420676574732075706C6F6164656420746F';
wwv_flow_api.g_varchar2_table(106) := '2074686520736572766572292E0A2020202020202020202A20496620606E756C6C6020746865206F726967696E616C206D696D6520747970652077696C6C20626520757365642E20546F20666F726365206A7065672C20666F72206578616D706C652C20';
wwv_flow_api.g_varchar2_table(107) := '7573652060696D6167652F6A706567602E0A2020202020202020202A205365652060726573697A6557696474686020666F72206D6F726520696E666F726D6174696F6E2E0A2020202020202020202A2F0A2020202020202020726573697A654D696D6554';
wwv_flow_api.g_varchar2_table(108) := '7970653A206E756C6C2C0A0A20202020202020202F2A2A0A2020202020202020202A20546865207175616C697479206F662074686520726573697A656420696D616765732E205365652060726573697A655769647468602E0A2020202020202020202A2F';
wwv_flow_api.g_varchar2_table(109) := '0A2020202020202020726573697A655175616C6974793A20302E382C0A0A20202020202020202F2A2A0A2020202020202020202A20486F772074686520696D616765732073686F756C64206265207363616C656420646F776E20696E206361736520626F';
wwv_flow_api.g_varchar2_table(110) := '74682C2060726573697A6557696474686020616E642060726573697A6548656967687460206172652070726F76696465642E0A2020202020202020202A2043616E206265206569746865722060636F6E7461696E60206F72206063726F70602E0A202020';
wwv_flow_api.g_varchar2_table(111) := '2020202020202A2F0A2020202020202020726573697A654D6574686F643A2027636F6E7461696E272C0A0A20202020202020202F2A2A0A2020202020202020202A2054686520626173652074686174206973207573656420746F2063616C63756C617465';
wwv_flow_api.g_varchar2_table(112) := '207468652066696C6573697A652E20596F752063616E206368616E6765207468697320746F0A2020202020202020202A203130323420696620796F7520776F756C642072617468657220646973706C6179206B69626962797465732C206D656269627974';
wwv_flow_api.g_varchar2_table(113) := '65732C206574632E2E2E0A2020202020202020202A203130323420697320746563686E6963616C6C7920696E636F72726563742C20626563617573652060313032342062797465736020617265206031206B6962696279746560206E6F74206031206B69';
wwv_flow_api.g_varchar2_table(114) := '6C6F62797465602E0A2020202020202020202A20596F752063616E206368616E6765207468697320746F2060313032346020696620796F7520646F6E277420636172652061626F75742076616C69646974792E0A2020202020202020202A2F0A20202020';
wwv_flow_api.g_varchar2_table(115) := '2020202066696C6573697A65426173653A20313030302C0A0A20202020202020202F2A2A0A2020202020202020202A2043616E206265207573656420746F206C696D697420746865206D6178696D756D206E756D626572206F662066696C657320746861';
wwv_flow_api.g_varchar2_table(116) := '742077696C6C2062652068616E646C656420627920746869732044726F707A6F6E650A2020202020202020202A2F0A20202020202020206D617846696C65733A206E756C6C2C0A0A20202020202020202F2A2A0A2020202020202020202A20416E206F70';
wwv_flow_api.g_varchar2_table(117) := '74696F6E616C206F626A65637420746F2073656E64206164646974696F6E616C206865616465727320746F20746865207365727665722E2045673A0A2020202020202020202A20607B20224D792D417765736F6D652D486561646572223A202268656164';
wwv_flow_api.g_varchar2_table(118) := '65722076616C756522207D600A2020202020202020202A2F0A2020202020202020686561646572733A206E756C6C2C0A0A20202020202020202F2A2A0A2020202020202020202A204966206074727565602C207468652064726F707A6F6E6520656C656D';
wwv_flow_api.g_varchar2_table(119) := '656E7420697473656C662077696C6C20626520636C69636B61626C652C206966206066616C7365600A2020202020202020202A206E6F7468696E672077696C6C20626520636C69636B61626C652E0A2020202020202020202A0A2020202020202020202A';
wwv_flow_api.g_varchar2_table(120) := '20596F752063616E20616C736F207061737320616E2048544D4C20656C656D656E742C2061204353532073656C6563746F722028666F72206D756C7469706C6520656C656D656E7473290A2020202020202020202A206F7220616E206172726179206F66';
wwv_flow_api.g_varchar2_table(121) := '2074686F73652E20496E207468617420636173652C20616C6C206F662074686F736520656C656D656E74732077696C6C207472696767657220616E0A2020202020202020202A2075706C6F6164207768656E20636C69636B65642E0A2020202020202020';
wwv_flow_api.g_varchar2_table(122) := '202A2F0A2020202020202020636C69636B61626C653A20747275652C0A0A20202020202020202F2A2A0A2020202020202020202A20576865746865722068696464656E2066696C657320696E206469726563746F726965732073686F756C642062652069';
wwv_flow_api.g_varchar2_table(123) := '676E6F7265642E0A2020202020202020202A2F0A202020202020202069676E6F726548696464656E46696C65733A20747275652C0A0A20202020202020202F2A2A0A2020202020202020202A205468652064656661756C7420696D706C656D656E746174';
wwv_flow_api.g_varchar2_table(124) := '696F6E206F6620606163636570746020636865636B73207468652066696C652773206D696D652074797065206F720A2020202020202020202A20657874656E73696F6E20616761696E73742074686973206C6973742E2054686973206973206120636F6D';
wwv_flow_api.g_varchar2_table(125) := '6D6120736570617261746564206C697374206F66206D696D650A2020202020202020202A207479706573206F722066696C6520657874656E73696F6E732E0A2020202020202020202A0A2020202020202020202A2045672E3A2060696D6167652F2A2C61';
wwv_flow_api.g_varchar2_table(126) := '70706C69636174696F6E2F7064662C2E707364600A2020202020202020202A0A2020202020202020202A204966207468652044726F707A6F6E652069732060636C69636B61626C65602074686973206F7074696F6E2077696C6C20616C736F2062652075';
wwv_flow_api.g_varchar2_table(127) := '7365642061730A2020202020202020202A205B60616363657074605D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F48544D4C2F456C656D656E742F696E70757423617474722D616363657074';
wwv_flow_api.g_varchar2_table(128) := '290A2020202020202020202A20706172616D65746572206F6E207468652068696464656E2066696C6520696E7075742061732077656C6C2E0A2020202020202020202A2F0A2020202020202020616363657074656446696C65733A206E756C6C2C0A0A20';
wwv_flow_api.g_varchar2_table(129) := '202020202020202F2A2A0A2020202020202020202A202A2A44657072656361746564212A2A0A2020202020202020202A2055736520616363657074656446696C657320696E73746561642E0A2020202020202020202A2F0A202020202020202061636365';
wwv_flow_api.g_varchar2_table(130) := '707465644D696D6554797065733A206E756C6C2C0A0A20202020202020202F2A2A0A2020202020202020202A2049662066616C73652C2066696C65732077696C6C20626520616464656420746F2074686520717565756520627574207468652071756575';
wwv_flow_api.g_varchar2_table(131) := '652077696C6C206E6F742062650A2020202020202020202A2070726F636573736564206175746F6D61746963616C6C792E0A2020202020202020202A20546869732063616E2062652075736566756C20696620796F75206E65656420736F6D6520616464';
wwv_flow_api.g_varchar2_table(132) := '6974696F6E616C207573657220696E707574206265666F72652073656E64696E670A2020202020202020202A2066696C657320286F7220696620796F752077616E742077616E7420616C6C2066696C65732073656E74206174206F6E6365292E0A202020';
wwv_flow_api.g_varchar2_table(133) := '2020202020202A20496620796F7527726520726561647920746F2073656E64207468652066696C652073696D706C792063616C6C20606D7944726F707A6F6E652E70726F6365737351756575652829602E0A2020202020202020202A0A20202020202020';
wwv_flow_api.g_varchar2_table(134) := '20202A2053656520746865205B656E71756575696E672066696C652075706C6F6164735D2823656E71756575696E672D66696C652D75706C6F6164732920646F63756D656E746174696F6E0A2020202020202020202A2073656374696F6E20666F72206D';
wwv_flow_api.g_varchar2_table(135) := '6F726520696E666F726D6174696F6E2E0A2020202020202020202A2F0A20202020202020206175746F50726F6365737351756575653A20747275652C0A0A20202020202020202F2A2A0A2020202020202020202A2049662066616C73652C2066696C6573';
wwv_flow_api.g_varchar2_table(136) := '20616464656420746F207468652064726F707A6F6E652077696C6C206E6F74206265207175657565642062792064656661756C742E0A2020202020202020202A20596F75276C6C206861766520746F2063616C6C2060656E717565756546696C65286669';
wwv_flow_api.g_varchar2_table(137) := '6C652960206D616E75616C6C792E0A2020202020202020202A2F0A20202020202020206175746F51756575653A20747275652C0A0A20202020202020202F2A2A0A2020202020202020202A204966206074727565602C20746869732077696C6C20616464';
wwv_flow_api.g_varchar2_table(138) := '2061206C696E6B20746F2065766572792066696C65207072657669657720746F2072656D6F7665206F722063616E63656C202869660A2020202020202020202A20616C72656164792075706C6F6164696E6729207468652066696C652E20546865206064';
wwv_flow_api.g_varchar2_table(139) := '69637443616E63656C55706C6F6164602C20606469637443616E63656C55706C6F6164436F6E6669726D6174696F6E600A2020202020202020202A20616E6420606469637452656D6F766546696C6560206F7074696F6E7320617265207573656420666F';
wwv_flow_api.g_varchar2_table(140) := '722074686520776F7264696E672E0A2020202020202020202A2F0A202020202020202061646452656D6F76654C696E6B733A2066616C73652C0A0A20202020202020202F2A2A0A2020202020202020202A20446566696E657320776865726520746F2064';
wwv_flow_api.g_varchar2_table(141) := '6973706C6179207468652066696C6520707265766965777320E2809320696620606E756C6C60207468650A2020202020202020202A2044726F707A6F6E6520656C656D656E7420697473656C6620697320757365642E2043616E206265206120706C6169';
wwv_flow_api.g_varchar2_table(142) := '6E206048544D4C456C656D656E7460206F722061204353530A2020202020202020202A2073656C6563746F722E2054686520656C656D656E742073686F756C64206861766520746865206064726F707A6F6E652D70726576696577736020636C61737320';
wwv_flow_api.g_varchar2_table(143) := '736F0A2020202020202020202A207468652070726576696577732061726520646973706C617965642070726F7065726C792E0A2020202020202020202A2F0A20202020202020207072657669657773436F6E7461696E65723A206E756C6C2C0A0A202020';
wwv_flow_api.g_varchar2_table(144) := '20202020202F2A2A0A2020202020202020202A20546869732069732074686520656C656D656E74207468652068696464656E20696E707574206669656C64202877686963682069732075736564207768656E20636C69636B696E67206F6E207468650A20';
wwv_flow_api.g_varchar2_table(145) := '20202020202020202A2064726F707A6F6E6520746F20747269676765722066696C652073656C656374696F6E292077696C6C20626520617070656E64656420746F2E2054686973206D696768740A2020202020202020202A20626520696D706F7274616E';
wwv_flow_api.g_varchar2_table(146) := '7420696E206361736520796F7520757365206672616D65776F726B7320746F207377697463682074686520636F6E74656E74206F6620796F757220706167652E0A2020202020202020202A0A2020202020202020202A2043616E20626520612073656C65';
wwv_flow_api.g_varchar2_table(147) := '63746F7220737472696E672C206F7220616E20656C656D656E74206469726563746C792E0A2020202020202020202A2F0A202020202020202068696464656E496E707574436F6E7461696E65723A2022626F6479222C0A0A20202020202020202F2A2A0A';
wwv_flow_api.g_varchar2_table(148) := '2020202020202020202A204966206E756C6C2C206E6F206361707475726520747970652077696C6C206265207370656369666965640A2020202020202020202A2049662063616D6572612C206D6F62696C6520646576696365732077696C6C20736B6970';
wwv_flow_api.g_varchar2_table(149) := '207468652066696C652073656C656374696F6E20616E642063686F6F73652063616D6572610A2020202020202020202A204966206D6963726F70686F6E652C206D6F62696C6520646576696365732077696C6C20736B6970207468652066696C65207365';
wwv_flow_api.g_varchar2_table(150) := '6C656374696F6E20616E642063686F6F736520746865206D6963726F70686F6E650A2020202020202020202A2049662063616D636F726465722C206D6F62696C6520646576696365732077696C6C20736B6970207468652066696C652073656C65637469';
wwv_flow_api.g_varchar2_table(151) := '6F6E20616E642063686F6F7365207468652063616D65726120696E20766964656F206D6F64650A2020202020202020202A204F6E206170706C652064657669636573206D756C7469706C65206D7573742062652073657420746F2066616C73652E202041';
wwv_flow_api.g_varchar2_table(152) := '6363657074656446696C6573206D6179206E65656420746F0A2020202020202020202A2062652073657420746F20616E20617070726F707269617465206D696D6520747970652028652E672E2022696D6167652F2A222C2022617564696F2F2A222C206F';
wwv_flow_api.g_varchar2_table(153) := '722022766964656F2F2A22292E0A2020202020202020202A2F0A2020202020202020636170747572653A206E756C6C2C0A0A20202020202020202F2A2A0A2020202020202020202A202A2A446570726563617465642A2A2E20557365206072656E616D65';
wwv_flow_api.g_varchar2_table(154) := '46696C656020696E73746561642E0A2020202020202020202A2F0A202020202020202072656E616D6546696C656E616D653A206E756C6C2C0A0A20202020202020202F2A2A0A2020202020202020202A20412066756E6374696F6E207468617420697320';
wwv_flow_api.g_varchar2_table(155) := '696E766F6B6564206265666F7265207468652066696C652069732075706C6F6164656420746F207468652073657276657220616E642072656E616D6573207468652066696C652E0A2020202020202020202A20546869732066756E6374696F6E20676574';
wwv_flow_api.g_varchar2_table(156) := '7320746865206046696C656020617320617267756D656E7420616E642063616E2075736520746865206066696C652E6E616D65602E205468652061637475616C206E616D65206F66207468650A2020202020202020202A2066696C652074686174206765';
wwv_flow_api.g_varchar2_table(157) := '7473207573656420647572696E67207468652075706C6F61642063616E206265206163636573736564207468726F756768206066696C652E75706C6F61642E66696C656E616D65602E0A2020202020202020202A2F0A202020202020202072656E616D65';
wwv_flow_api.g_varchar2_table(158) := '46696C653A206E756C6C2C0A0A20202020202020202F2A2A0A2020202020202020202A20496620607472756560207468652066616C6C6261636B2077696C6C20626520666F726365642E205468697320697320766572792075736566756C20746F207465';
wwv_flow_api.g_varchar2_table(159) := '737420796F7572207365727665720A2020202020202020202A20696D706C656D656E746174696F6E7320666972737420616E64206D616B65207375726520746861742065766572797468696E6720776F726B732061730A2020202020202020202A206578';
wwv_flow_api.g_varchar2_table(160) := '70656374656420776974686F75742064726F707A6F6E6520696620796F7520657870657269656E63652070726F626C656D732C20616E6420746F20746573740A2020202020202020202A20686F7720796F75722066616C6C6261636B732077696C6C206C';
wwv_flow_api.g_varchar2_table(161) := '6F6F6B2E0A2020202020202020202A2F0A2020202020202020666F72636546616C6C6261636B3A2066616C73652C0A0A20202020202020202F2A2A0A2020202020202020202A2054686520746578742075736564206265666F726520616E792066696C65';
wwv_flow_api.g_varchar2_table(162) := '73206172652064726F707065642E0A2020202020202020202A2F0A20202020202020206469637444656661756C744D6573736167653A202244726F702066696C6573206865726520746F2075706C6F6164222C0A0A20202020202020202F2A2A0A202020';
wwv_flow_api.g_varchar2_table(163) := '2020202020202A2054686520746578742074686174207265706C61636573207468652064656661756C74206D6573736167652074657874206974207468652062726F77736572206973206E6F7420737570706F727465642E0A2020202020202020202A2F';
wwv_flow_api.g_varchar2_table(164) := '0A20202020202020206469637446616C6C6261636B4D6573736167653A2022596F75722062726F7773657220646F6573206E6F7420737570706F72742064726167276E2764726F702066696C652075706C6F6164732E222C0A0A20202020202020202F2A';
wwv_flow_api.g_varchar2_table(165) := '2A0A2020202020202020202A20546865207465787420746861742077696C6C206265206164646564206265666F7265207468652066616C6C6261636B20666F726D2E0A2020202020202020202A20496620796F752070726F766964652061202066616C6C';
wwv_flow_api.g_varchar2_table(166) := '6261636B20656C656D656E7420796F757273656C662C206F722069662074686973206F7074696F6E20697320606E756C6C6020746869732077696C6C0A2020202020202020202A2062652069676E6F7265642E0A2020202020202020202A2F0A20202020';
wwv_flow_api.g_varchar2_table(167) := '202020206469637446616C6C6261636B546578743A2022506C6561736520757365207468652066616C6C6261636B20666F726D2062656C6F7720746F2075706C6F616420796F75722066696C6573206C696B6520696E20746865206F6C64656E20646179';
wwv_flow_api.g_varchar2_table(168) := '732E222C0A0A20202020202020202F2A2A0A2020202020202020202A204966207468652066696C6573697A6520697320746F6F206269672E0A2020202020202020202A20607B7B66696C6573697A657D7D6020616E6420607B7B6D617846696C6573697A';
wwv_flow_api.g_varchar2_table(169) := '657D7D602077696C6C206265207265706C61636564207769746820746865207265737065637469766520636F6E66696775726174696F6E2076616C7565732E0A2020202020202020202A2F0A20202020202020206469637446696C65546F6F4269673A20';
wwv_flow_api.g_varchar2_table(170) := '2246696C6520697320746F6F2062696720287B7B66696C6573697A657D7D4D6942292E204D61782066696C6573697A653A207B7B6D617846696C6573697A657D7D4D69422E222C0A0A20202020202020202F2A2A0A2020202020202020202A2049662074';
wwv_flow_api.g_varchar2_table(171) := '68652066696C6520646F65736E2774206D61746368207468652066696C6520747970652E0A2020202020202020202A2F0A202020202020202064696374496E76616C696446696C65547970653A2022596F752063616E27742075706C6F61642066696C65';
wwv_flow_api.g_varchar2_table(172) := '73206F66207468697320747970652E222C0A0A20202020202020202F2A2A0A2020202020202020202A204966207468652073657276657220726573706F6E73652077617320696E76616C69642E0A2020202020202020202A20607B7B737461747573436F';
wwv_flow_api.g_varchar2_table(173) := '64657D7D602077696C6C206265207265706C6163656420776974682074686520736572766572732073746174757320636F64652E0A2020202020202020202A2F0A202020202020202064696374526573706F6E73654572726F723A202253657276657220';
wwv_flow_api.g_varchar2_table(174) := '726573706F6E6465642077697468207B7B737461747573436F64657D7D20636F64652E222C0A0A20202020202020202F2A2A0A2020202020202020202A204966206061646452656D6F76654C696E6B736020697320747275652C20746865207465787420';
wwv_flow_api.g_varchar2_table(175) := '746F206265207573656420666F72207468652063616E63656C2075706C6F6164206C696E6B2E0A2020202020202020202A2F0A20202020202020206469637443616E63656C55706C6F61643A202243616E63656C2075706C6F6164222C0A0A2020202020';
wwv_flow_api.g_varchar2_table(176) := '2020202F2A2A0A2020202020202020202A205468652074657874207468617420697320646973706C6179656420696620616E2075706C6F616420776173206D616E75616C6C792063616E63656C65640A2020202020202020202A2F0A2020202020202020';
wwv_flow_api.g_varchar2_table(177) := '6469637455706C6F616443616E63656C65643A202255706C6F61642063616E63656C65642E222C0A0A20202020202020202F2A2A0A2020202020202020202A204966206061646452656D6F76654C696E6B736020697320747275652C2074686520746578';
wwv_flow_api.g_varchar2_table(178) := '7420746F206265207573656420666F7220636F6E6669726D6174696F6E207768656E2063616E63656C6C696E672075706C6F61642E0A2020202020202020202A2F0A20202020202020206469637443616E63656C55706C6F6164436F6E6669726D617469';
wwv_flow_api.g_varchar2_table(179) := '6F6E3A202241726520796F75207375726520796F752077616E7420746F2063616E63656C20746869732075706C6F61643F222C0A0A20202020202020202F2A2A0A2020202020202020202A204966206061646452656D6F76654C696E6B73602069732074';
wwv_flow_api.g_varchar2_table(180) := '7275652C20746865207465787420746F206265207573656420746F2072656D6F766520612066696C652E0A2020202020202020202A2F0A20202020202020206469637452656D6F766546696C653A202252656D6F76652066696C65222C0A0A2020202020';
wwv_flow_api.g_varchar2_table(181) := '2020202F2A2A0A2020202020202020202A2049662074686973206973206E6F74206E756C6C2C207468656E2074686520757365722077696C6C2062652070726F6D70746564206265666F72652072656D6F76696E6720612066696C652E0A202020202020';
wwv_flow_api.g_varchar2_table(182) := '2020202A2F0A20202020202020206469637452656D6F766546696C65436F6E6669726D6174696F6E3A206E756C6C2C0A0A20202020202020202F2A2A0A2020202020202020202A20446973706C6179656420696620606D617846696C6573602069732073';
wwv_flow_api.g_varchar2_table(183) := '7420616E642065786365656465642E0A2020202020202020202A2054686520737472696E6720607B7B6D617846696C65737D7D602077696C6C206265207265706C616365642062792074686520636F6E66696775726174696F6E2076616C75652E0A2020';
wwv_flow_api.g_varchar2_table(184) := '202020202020202A2F0A2020202020202020646963744D617846696C657345786365656465643A2022596F752063616E206E6F742075706C6F616420616E79206D6F72652066696C65732E222C0A0A20202020202020202F2A2A0A202020202020202020';
wwv_flow_api.g_varchar2_table(185) := '2A20416C6C6F777320796F7520746F207472616E736C6174652074686520646966666572656E7420756E6974732E205374617274696E672077697468206074626020666F722074657261627974657320616E6420676F696E6720646F776E20746F0A2020';
wwv_flow_api.g_varchar2_table(186) := '202020202020202A2060626020666F722062797465732E0A2020202020202020202A2F0A20202020202020206469637446696C6553697A65556E6974733A207B2074623A20225442222C2067623A20224742222C206D623A20224D42222C206B623A2022';
wwv_flow_api.g_varchar2_table(187) := '4B42222C20623A20226222207D2C0A20202020202020202F2A2A0A2020202020202020202A2043616C6C6564207768656E2064726F707A6F6E6520696E697469616C697A65640A2020202020202020202A20596F752063616E20616464206576656E7420';
wwv_flow_api.g_varchar2_table(188) := '6C697374656E65727320686572650A2020202020202020202A2F0A2020202020202020696E69743A2066756E6374696F6E20696E69742829207B7D2C0A0A0A20202020202020202F2A2A0A2020202020202020202A2043616E20626520616E202A2A6F62';
wwv_flow_api.g_varchar2_table(189) := '6A6563742A2A206F66206164646974696F6E616C20706172616D657465727320746F207472616E7366657220746F20746865207365727665722C202A2A6F722A2A2061206046756E6374696F6E600A2020202020202020202A2074686174206765747320';
wwv_flow_api.g_varchar2_table(190) := '696E766F6B6564207769746820746865206066696C6573602C20607868726020616E642C20696620697427732061206368756E6B65642075706C6F61642C20606368756E6B6020617267756D656E74732E20496E20636173650A2020202020202020202A';
wwv_flow_api.g_varchar2_table(191) := '206F6620612066756E6374696F6E2C2074686973206E6565647320746F2072657475726E2061206D61702E0A2020202020202020202A0A2020202020202020202A205468652064656661756C7420696D706C656D656E746174696F6E20646F6573206E6F';
wwv_flow_api.g_varchar2_table(192) := '7468696E6720666F72206E6F726D616C2075706C6F6164732C2062757420616464732072656C6576616E7420696E666F726D6174696F6E20666F720A2020202020202020202A206368756E6B65642075706C6F6164732E0A2020202020202020202A0A20';
wwv_flow_api.g_varchar2_table(193) := '20202020202020202A2054686973206973207468652073616D6520617320616464696E672068696464656E20696E707574206669656C647320696E2074686520666F726D20656C656D656E742E0A2020202020202020202A2F0A20202020202020207061';
wwv_flow_api.g_varchar2_table(194) := '72616D733A2066756E6374696F6E20706172616D732866696C65732C207868722C206368756E6B29207B0A20202020202020202020696620286368756E6B29207B0A20202020202020202020202072657475726E207B0A20202020202020202020202020';
wwv_flow_api.g_varchar2_table(195) := '20647A757569643A206368756E6B2E66696C652E75706C6F61642E757569642C0A2020202020202020202020202020647A6368756E6B696E6465783A206368756E6B2E696E6465782C0A2020202020202020202020202020647A746F74616C66696C6573';
wwv_flow_api.g_varchar2_table(196) := '697A653A206368756E6B2E66696C652E73697A652C0A2020202020202020202020202020647A6368756E6B73697A653A20746869732E6F7074696F6E732E6368756E6B53697A652C0A2020202020202020202020202020647A746F74616C6368756E6B63';
wwv_flow_api.g_varchar2_table(197) := '6F756E743A206368756E6B2E66696C652E75706C6F61642E746F74616C4368756E6B436F756E742C0A2020202020202020202020202020647A6368756E6B627974656F66667365743A206368756E6B2E696E646578202A20746869732E6F7074696F6E73';
wwv_flow_api.g_varchar2_table(198) := '2E6368756E6B53697A650A2020202020202020202020207D3B0A202020202020202020207D0A20202020202020207D2C0A0A0A20202020202020202F2A2A0A2020202020202020202A20412066756E6374696F6E207468617420676574732061205B6669';
wwv_flow_api.g_varchar2_table(199) := '6C655D2868747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F444F4D2F46696C65290A2020202020202020202A20616E6420612060646F6E65602066756E6374696F6E20617320706172616D65746572';
wwv_flow_api.g_varchar2_table(200) := '732E0A2020202020202020202A0A2020202020202020202A2049662074686520646F6E652066756E6374696F6E20697320696E766F6B656420776974686F757420617267756D656E74732C207468652066696C6520697320226163636570746564222061';
wwv_flow_api.g_varchar2_table(201) := '6E642077696C6C0A2020202020202020202A2062652070726F6365737365642E20496620796F75207061737320616E206572726F72206D6573736167652C207468652066696C652069732072656A65637465642C20616E6420746865206572726F720A20';
wwv_flow_api.g_varchar2_table(202) := '20202020202020202A206D6573736167652077696C6C20626520646973706C617965642E0A2020202020202020202A20546869732066756E6374696F6E2077696C6C206E6F742062652063616C6C6564206966207468652066696C6520697320746F6F20';
wwv_flow_api.g_varchar2_table(203) := '626967206F7220646F65736E2774206D6174636820746865206D696D652074797065732E0A2020202020202020202A2F0A20202020202020206163636570743A2066756E6374696F6E206163636570742866696C652C20646F6E6529207B0A2020202020';
wwv_flow_api.g_varchar2_table(204) := '202020202072657475726E20646F6E6528293B0A20202020202020207D2C0A0A0A20202020202020202F2A2A0A2020202020202020202A205468652063616C6C6261636B20746861742077696C6C20626520696E766F6B6564207768656E20616C6C2063';
wwv_flow_api.g_varchar2_table(205) := '68756E6B732068617665206265656E2075706C6F6164656420666F7220612066696C652E0A2020202020202020202A2049742067657473207468652066696C6520666F7220776869636820746865206368756E6B732068617665206265656E2075706C6F';
wwv_flow_api.g_varchar2_table(206) := '616465642061732074686520666972737420706172616D657465722C0A2020202020202020202A20616E64207468652060646F6E65602066756E6374696F6E206173207365636F6E642E2060646F6E65282960206E6565647320746F20626520696E766F';
wwv_flow_api.g_varchar2_table(207) := '6B6564207768656E2065766572797468696E670A2020202020202020202A206E656564656420746F2066696E697368207468652075706C6F61642070726F6365737320697320646F6E652E0A2020202020202020202A2F0A20202020202020206368756E';
wwv_flow_api.g_varchar2_table(208) := '6B7355706C6F616465643A2066756E6374696F6E206368756E6B7355706C6F616465642866696C652C20646F6E6529207B0A20202020202020202020646F6E6528293B0A20202020202020207D2C0A0A20202020202020202F2A2A0A2020202020202020';
wwv_flow_api.g_varchar2_table(209) := '202A20476574732063616C6C6564207768656E207468652062726F77736572206973206E6F7420737570706F727465642E0A2020202020202020202A205468652064656661756C7420696D706C656D656E746174696F6E2073686F777320746865206661';
wwv_flow_api.g_varchar2_table(210) := '6C6C6261636B20696E707574206669656C6420616E6420616464730A2020202020202020202A206120746578742E0A2020202020202020202A2F0A202020202020202066616C6C6261636B3A2066756E6374696F6E2066616C6C6261636B2829207B0A20';
wwv_flow_api.g_varchar2_table(211) := '2020202020202020202F2F205468697320636F64652073686F756C64207061737320696E204945372E2E2E203A280A20202020202020202020766172206D657373616765456C656D656E74203D20766F696420303B0A2020202020202020202074686973';
wwv_flow_api.g_varchar2_table(212) := '2E656C656D656E742E636C6173734E616D65203D20746869732E656C656D656E742E636C6173734E616D65202B202220647A2D62726F777365722D6E6F742D737570706F72746564223B0A0A20202020202020202020666F722028766172205F69746572';
wwv_flow_api.g_varchar2_table(213) := '61746F7232203D20746869732E656C656D656E742E676574456C656D656E747342795461674E616D65282264697622292C205F6973417272617932203D20747275652C205F6932203D20302C205F6974657261746F7232203D205F697341727261793220';
wwv_flow_api.g_varchar2_table(214) := '3F205F6974657261746F7232203A205F6974657261746F72325B53796D626F6C2E6974657261746F725D28293B3B29207B0A202020202020202020202020766172205F726566323B0A0A202020202020202020202020696620285F697341727261793229';
wwv_flow_api.g_varchar2_table(215) := '207B0A2020202020202020202020202020696620285F6932203E3D205F6974657261746F72322E6C656E6774682920627265616B3B0A20202020202020202020202020205F72656632203D205F6974657261746F72325B5F69322B2B5D3B0A2020202020';
wwv_flow_api.g_varchar2_table(216) := '202020202020207D20656C7365207B0A20202020202020202020202020205F6932203D205F6974657261746F72322E6E65787428293B0A2020202020202020202020202020696620285F69322E646F6E652920627265616B3B0A20202020202020202020';
wwv_flow_api.g_varchar2_table(217) := '202020205F72656632203D205F69322E76616C75653B0A2020202020202020202020207D0A0A202020202020202020202020766172206368696C64203D205F726566323B0A0A202020202020202020202020696620282F285E7C2029647A2D6D65737361';
wwv_flow_api.g_varchar2_table(218) := '676528247C20292F2E74657374286368696C642E636C6173734E616D652929207B0A20202020202020202020202020206D657373616765456C656D656E74203D206368696C643B0A20202020202020202020202020206368696C642E636C6173734E616D';
wwv_flow_api.g_varchar2_table(219) := '65203D2022647A2D6D657373616765223B202F2F2052656D6F766573207468652027647A2D64656661756C742720636C6173730A2020202020202020202020202020627265616B3B0A2020202020202020202020207D0A202020202020202020207D0A20';
wwv_flow_api.g_varchar2_table(220) := '20202020202020202069662028216D657373616765456C656D656E7429207B0A2020202020202020202020206D657373616765456C656D656E74203D2044726F707A6F6E652E637265617465456C656D656E7428223C64697620636C6173733D5C22647A';
wwv_flow_api.g_varchar2_table(221) := '2D6D6573736167655C223E3C7370616E3E3C2F7370616E3E3C2F6469763E22293B0A202020202020202020202020746869732E656C656D656E742E617070656E644368696C64286D657373616765456C656D656E74293B0A202020202020202020207D0A';
wwv_flow_api.g_varchar2_table(222) := '0A20202020202020202020766172207370616E203D206D657373616765456C656D656E742E676574456C656D656E747342795461674E616D6528227370616E22295B305D3B0A20202020202020202020696620287370616E29207B0A2020202020202020';
wwv_flow_api.g_varchar2_table(223) := '20202020696620287370616E2E74657874436F6E74656E7420213D206E756C6C29207B0A20202020202020202020202020207370616E2E74657874436F6E74656E74203D20746869732E6F7074696F6E732E6469637446616C6C6261636B4D6573736167';
wwv_flow_api.g_varchar2_table(224) := '653B0A2020202020202020202020207D20656C736520696620287370616E2E696E6E65725465787420213D206E756C6C29207B0A20202020202020202020202020207370616E2E696E6E657254657874203D20746869732E6F7074696F6E732E64696374';
wwv_flow_api.g_varchar2_table(225) := '46616C6C6261636B4D6573736167653B0A2020202020202020202020207D0A202020202020202020207D0A0A2020202020202020202072657475726E20746869732E656C656D656E742E617070656E644368696C6428746869732E67657446616C6C6261';
wwv_flow_api.g_varchar2_table(226) := '636B466F726D2829293B0A20202020202020207D2C0A0A0A20202020202020202F2A2A0A2020202020202020202A20476574732063616C6C656420746F2063616C63756C61746520746865207468756D626E61696C2064696D656E73696F6E732E0A2020';
wwv_flow_api.g_varchar2_table(227) := '202020202020202A0A2020202020202020202A2049742067657473206066696C65602C206077696474686020616E642060686569676874602028626F7468206D617920626520606E756C6C602920617320706172616D657465727320616E64206D757374';
wwv_flow_api.g_varchar2_table(228) := '2072657475726E20616E206F626A65637420636F6E7461696E696E673A0A2020202020202020202A0A2020202020202020202A20202D2060737263576964746860202620607372634865696768746020287265717569726564290A202020202020202020';
wwv_flow_api.g_varchar2_table(229) := '2A20202D2060747267576964746860202620607472674865696768746020287265717569726564290A2020202020202020202A20202D2060737263586020262060737263596020286F7074696F6E616C2C2064656661756C7420603060290A2020202020';
wwv_flow_api.g_varchar2_table(230) := '202020202A20202D2060747267586020262060747267596020286F7074696F6E616C2C2064656661756C7420603060290A2020202020202020202A0A2020202020202020202A2054686F73652076616C7565732061726520676F696E6720746F20626520';
wwv_flow_api.g_varchar2_table(231) := '7573656420627920606374782E64726177496D6167652829602E0A2020202020202020202A2F0A2020202020202020726573697A653A2066756E6374696F6E20726573697A652866696C652C2077696474682C206865696768742C20726573697A654D65';
wwv_flow_api.g_varchar2_table(232) := '74686F6429207B0A2020202020202020202076617220696E666F203D207B0A202020202020202020202020737263583A20302C0A202020202020202020202020737263593A20302C0A20202020202020202020202073726357696474683A2066696C652E';
wwv_flow_api.g_varchar2_table(233) := '77696474682C0A2020202020202020202020207372634865696768743A2066696C652E6865696768740A202020202020202020207D3B0A0A2020202020202020202076617220737263526174696F203D2066696C652E7769647468202F2066696C652E68';
wwv_flow_api.g_varchar2_table(234) := '65696768743B0A0A202020202020202020202F2F204175746F6D61746963616C6C792063616C63756C6174652064696D656E73696F6E73206966206E6F74207370656369666965640A20202020202020202020696620287769647468203D3D206E756C6C';
wwv_flow_api.g_varchar2_table(235) := '20262620686569676874203D3D206E756C6C29207B0A2020202020202020202020207769647468203D20696E666F2E73726357696474683B0A202020202020202020202020686569676874203D20696E666F2E7372634865696768743B0A202020202020';
wwv_flow_api.g_varchar2_table(236) := '202020207D20656C736520696620287769647468203D3D206E756C6C29207B0A2020202020202020202020207769647468203D20686569676874202A20737263526174696F3B0A202020202020202020207D20656C73652069662028686569676874203D';
wwv_flow_api.g_varchar2_table(237) := '3D206E756C6C29207B0A202020202020202020202020686569676874203D207769647468202F20737263526174696F3B0A202020202020202020207D0A0A202020202020202020202F2F204D616B65207375726520696D61676573206172656E27742075';
wwv_flow_api.g_varchar2_table(238) := '707363616C65640A202020202020202020207769647468203D204D6174682E6D696E2877696474682C20696E666F2E7372635769647468293B0A20202020202020202020686569676874203D204D6174682E6D696E286865696768742C20696E666F2E73';
wwv_flow_api.g_varchar2_table(239) := '7263486569676874293B0A0A2020202020202020202076617220747267526174696F203D207769647468202F206865696768743B0A0A2020202020202020202069662028696E666F2E7372635769647468203E207769647468207C7C20696E666F2E7372';
wwv_flow_api.g_varchar2_table(240) := '63486569676874203E2068656967687429207B0A2020202020202020202020202F2F20496D6167652069732062696767657220616E64206E656564732072657363616C696E670A20202020202020202020202069662028726573697A654D6574686F6420';
wwv_flow_api.g_varchar2_table(241) := '3D3D3D202763726F702729207B0A202020202020202020202020202069662028737263526174696F203E20747267526174696F29207B0A20202020202020202020202020202020696E666F2E737263486569676874203D2066696C652E6865696768743B';
wwv_flow_api.g_varchar2_table(242) := '0A20202020202020202020202020202020696E666F2E7372635769647468203D20696E666F2E737263486569676874202A20747267526174696F3B0A20202020202020202020202020207D20656C7365207B0A2020202020202020202020202020202069';
wwv_flow_api.g_varchar2_table(243) := '6E666F2E7372635769647468203D2066696C652E77696474683B0A20202020202020202020202020202020696E666F2E737263486569676874203D20696E666F2E7372635769647468202F20747267526174696F3B0A2020202020202020202020202020';
wwv_flow_api.g_varchar2_table(244) := '7D0A2020202020202020202020207D20656C73652069662028726573697A654D6574686F64203D3D3D2027636F6E7461696E2729207B0A20202020202020202020202020202F2F204D6574686F642027636F6E7461696E270A2020202020202020202020';
wwv_flow_api.g_varchar2_table(245) := '20202069662028737263526174696F203E20747267526174696F29207B0A20202020202020202020202020202020686569676874203D207769647468202F20737263526174696F3B0A20202020202020202020202020207D20656C7365207B0A20202020';
wwv_flow_api.g_varchar2_table(246) := '2020202020202020202020207769647468203D20686569676874202A20737263526174696F3B0A20202020202020202020202020207D0A2020202020202020202020207D20656C7365207B0A20202020202020202020202020207468726F77206E657720';
wwv_flow_api.g_varchar2_table(247) := '4572726F722822556E6B6E6F776E20726573697A654D6574686F64202722202B20726573697A654D6574686F64202B20222722293B0A2020202020202020202020207D0A202020202020202020207D0A0A20202020202020202020696E666F2E73726358';
wwv_flow_api.g_varchar2_table(248) := '203D202866696C652E7769647468202D20696E666F2E737263576964746829202F20323B0A20202020202020202020696E666F2E73726359203D202866696C652E686569676874202D20696E666F2E73726348656967687429202F20323B0A0A20202020';
wwv_flow_api.g_varchar2_table(249) := '202020202020696E666F2E7472675769647468203D2077696474683B0A20202020202020202020696E666F2E747267486569676874203D206865696768743B0A0A2020202020202020202072657475726E20696E666F3B0A20202020202020207D2C0A0A';
wwv_flow_api.g_varchar2_table(250) := '0A20202020202020202F2A2A0A2020202020202020202A2043616E206265207573656420746F207472616E73666F726D207468652066696C652028666F72206578616D706C652C20726573697A6520616E20696D616765206966206E6563657373617279';
wwv_flow_api.g_varchar2_table(251) := '292E0A2020202020202020202A0A2020202020202020202A205468652064656661756C7420696D706C656D656E746174696F6E20757365732060726573697A6557696474686020616E642060726573697A6548656967687460202869662070726F766964';
wwv_flow_api.g_varchar2_table(252) := '65642920616E6420726573697A65730A2020202020202020202A20696D61676573206163636F7264696E6720746F2074686F73652064696D656E73696F6E732E0A2020202020202020202A0A2020202020202020202A204765747320746865206066696C';
wwv_flow_api.g_varchar2_table(253) := '65602061732074686520666972737420706172616D657465722C20616E6420612060646F6E652829602066756E6374696F6E20617320746865207365636F6E642C2074686174206E656564730A2020202020202020202A20746F20626520696E766F6B65';
wwv_flow_api.g_varchar2_table(254) := '642077697468207468652066696C65207768656E20746865207472616E73666F726D6174696F6E20697320646F6E652E0A2020202020202020202A2F0A20202020202020207472616E73666F726D46696C653A2066756E6374696F6E207472616E73666F';
wwv_flow_api.g_varchar2_table(255) := '726D46696C652866696C652C20646F6E6529207B0A202020202020202020206966202828746869732E6F7074696F6E732E726573697A655769647468207C7C20746869732E6F7074696F6E732E726573697A65486569676874292026262066696C652E74';
wwv_flow_api.g_varchar2_table(256) := '7970652E6D61746368282F696D6167652E2A2F2929207B0A20202020202020202020202072657475726E20746869732E726573697A65496D6167652866696C652C20746869732E6F7074696F6E732E726573697A6557696474682C20746869732E6F7074';
wwv_flow_api.g_varchar2_table(257) := '696F6E732E726573697A654865696768742C20746869732E6F7074696F6E732E726573697A654D6574686F642C20646F6E65293B0A202020202020202020207D20656C7365207B0A20202020202020202020202072657475726E20646F6E652866696C65';
wwv_flow_api.g_varchar2_table(258) := '293B0A202020202020202020207D0A20202020202020207D2C0A0A0A20202020202020202F2A2A0A2020202020202020202A204120737472696E67207468617420636F6E7461696E73207468652074656D706C617465207573656420666F722065616368';
wwv_flow_api.g_varchar2_table(259) := '2064726F707065640A2020202020202020202A2066696C652E204368616E676520697420746F2066756C66696C6C20796F7572206E6565647320627574206D616B65207375726520746F2070726F7065726C790A2020202020202020202A2070726F7669';
wwv_flow_api.g_varchar2_table(260) := '646520616C6C20656C656D656E74732E0A2020202020202020202A0A2020202020202020202A20496620796F752077616E7420746F2075736520616E2061637475616C2048544D4C20656C656D656E7420696E7374656164206F662070726F766964696E';
wwv_flow_api.g_varchar2_table(261) := '67206120537472696E670A2020202020202020202A206173206120636F6E666967206F7074696F6E2C20796F7520636F756C6420637265617465206120646976207769746820746865206964206074706C602C0A2020202020202020202A207075742074';
wwv_flow_api.g_varchar2_table(262) := '68652074656D706C61746520696E7369646520697420616E642070726F766964652074686520656C656D656E74206C696B6520746869733A0A2020202020202020202A0A2020202020202020202A2020202020646F63756D656E740A2020202020202020';
wwv_flow_api.g_varchar2_table(263) := '202A202020202020202E717565727953656C6563746F7228272374706C27290A2020202020202020202A202020202020202E696E6E657248544D4C0A2020202020202020202A0A2020202020202020202A2F0A2020202020202020707265766965775465';
wwv_flow_api.g_varchar2_table(264) := '6D706C6174653A20223C64697620636C6173733D5C22647A2D7072657669657720647A2D66696C652D707265766965775C223E5C6E20203C64697620636C6173733D5C22647A2D696D6167655C223E3C696D6720646174612D647A2D7468756D626E6169';
wwv_flow_api.g_varchar2_table(265) := '6C202F3E3C2F6469763E5C6E20203C64697620636C6173733D5C22647A2D64657461696C735C223E5C6E202020203C64697620636C6173733D5C22647A2D73697A655C223E3C7370616E20646174612D647A2D73697A653E3C2F7370616E3E3C2F646976';
wwv_flow_api.g_varchar2_table(266) := '3E5C6E202020203C64697620636C6173733D5C22647A2D66696C656E616D655C223E3C7370616E20646174612D647A2D6E616D653E3C2F7370616E3E3C2F6469763E5C6E20203C2F6469763E5C6E20203C64697620636C6173733D5C22647A2D70726F67';
wwv_flow_api.g_varchar2_table(267) := '726573735C223E3C7370616E20636C6173733D5C22647A2D75706C6F61645C2220646174612D647A2D75706C6F616470726F67726573733E3C2F7370616E3E3C2F6469763E5C6E20203C64697620636C6173733D5C22647A2D6572726F722D6D65737361';
wwv_flow_api.g_varchar2_table(268) := '67655C223E3C7370616E20646174612D647A2D6572726F726D6573736167653E3C2F7370616E3E3C2F6469763E5C6E20203C64697620636C6173733D5C22647A2D737563636573732D6D61726B5C223E5C6E202020203C7376672077696474683D5C2235';
wwv_flow_api.g_varchar2_table(269) := '3470785C22206865696768743D5C22353470785C222076696577426F783D5C223020302035342035345C222076657273696F6E3D5C22312E315C2220786D6C6E733D5C22687474703A2F2F7777772E77332E6F72672F323030302F7376675C2220786D6C';
wwv_flow_api.g_varchar2_table(270) := '6E733A786C696E6B3D5C22687474703A2F2F7777772E77332E6F72672F313939392F786C696E6B5C2220786D6C6E733A736B657463683D5C22687474703A2F2F7777772E626F68656D69616E636F64696E672E636F6D2F736B657463682F6E735C223E5C';
wwv_flow_api.g_varchar2_table(271) := '6E2020202020203C7469746C653E436865636B3C2F7469746C653E5C6E2020202020203C646566733E3C2F646566733E5C6E2020202020203C672069643D5C22506167652D315C22207374726F6B653D5C226E6F6E655C22207374726F6B652D77696474';
wwv_flow_api.g_varchar2_table(272) := '683D5C22315C222066696C6C3D5C226E6F6E655C222066696C6C2D72756C653D5C226576656E6F64645C2220736B657463683A747970653D5C224D53506167655C223E5C6E20202020202020203C7061746820643D5C224D32332E352C33312E38343331';
wwv_flow_api.g_varchar2_table(273) := '343538204C31372E353835323431392C32352E39323833383737204331362E303234383235332C32342E333637393731312031332E343931303239342C32342E3336363833352031312E393238393332322C32352E39323839333232204331302E333730';
wwv_flow_api.g_varchar2_table(274) := '303133362C32372E343837383530382031302E333636353931322C33302E303233343435352031312E393238333837372C33312E35383532343139204C32302E343134373538312C34302E30373136313233204332302E353133333939392C34302E3137';
wwv_flow_api.g_varchar2_table(275) := '30323534312032302E363135393331352C34302E323632363634392032302E373231383631352C34302E33343838343335204332322E323833353636392C34312E383732353635312032342E3739343233342C34312E383632363230322032362E333436';
wwv_flow_api.g_varchar2_table(276) := '313536342C34302E33313036393738204C34332E333130363937382C32332E33343631353634204334342E383737313032312C32312E373739373532312034342E383735383035372C31392E323438333838372034332E333133373038352C31372E3638';
wwv_flow_api.g_varchar2_table(277) := '3632393135204334312E373534373839392C31362E313237333732392033392E323137363033352C31362E313235353432322033372E363533383433362C31372E36383933303232204C32332E352C33312E38343331343538205A204D32372C35332043';
wwv_flow_api.g_varchar2_table(278) := '34312E333539343033352C35332035332C34312E333539343033352035332C3237204335332C31322E363430353936352034312E333539343033352C312032372C31204331322E363430353936352C3120312C31322E3634303539363520312C32372043';
wwv_flow_api.g_varchar2_table(279) := '312C34312E333539343033352031322E363430353936352C35332032372C3533205A5C222069643D5C224F76616C2D325C22207374726F6B652D6F7061636974793D5C22302E3139383739343135385C22207374726F6B653D5C22233734373437345C22';
wwv_flow_api.g_varchar2_table(280) := '2066696C6C2D6F7061636974793D5C22302E3831363531393437355C222066696C6C3D5C22234646464646465C2220736B657463683A747970653D5C224D53536861706547726F75705C223E3C2F706174683E5C6E2020202020203C2F673E5C6E202020';
wwv_flow_api.g_varchar2_table(281) := '203C2F7376673E5C6E20203C2F6469763E5C6E20203C64697620636C6173733D5C22647A2D6572726F722D6D61726B5C223E5C6E202020203C7376672077696474683D5C22353470785C22206865696768743D5C22353470785C222076696577426F783D';
wwv_flow_api.g_varchar2_table(282) := '5C223020302035342035345C222076657273696F6E3D5C22312E315C2220786D6C6E733D5C22687474703A2F2F7777772E77332E6F72672F323030302F7376675C2220786D6C6E733A786C696E6B3D5C22687474703A2F2F7777772E77332E6F72672F31';
wwv_flow_api.g_varchar2_table(283) := '3939392F786C696E6B5C2220786D6C6E733A736B657463683D5C22687474703A2F2F7777772E626F68656D69616E636F64696E672E636F6D2F736B657463682F6E735C223E5C6E2020202020203C7469746C653E4572726F723C2F7469746C653E5C6E20';
wwv_flow_api.g_varchar2_table(284) := '20202020203C646566733E3C2F646566733E5C6E2020202020203C672069643D5C22506167652D315C22207374726F6B653D5C226E6F6E655C22207374726F6B652D77696474683D5C22315C222066696C6C3D5C226E6F6E655C222066696C6C2D72756C';
wwv_flow_api.g_varchar2_table(285) := '653D5C226576656E6F64645C2220736B657463683A747970653D5C224D53506167655C223E5C6E20202020202020203C672069643D5C22436865636B2D2B2D4F76616C2D325C2220736B657463683A747970653D5C224D534C6179657247726F75705C22';
wwv_flow_api.g_varchar2_table(286) := '207374726F6B653D5C22233734373437345C22207374726F6B652D6F7061636974793D5C22302E3139383739343135385C222066696C6C3D5C22234646464646465C222066696C6C2D6F7061636974793D5C22302E3831363531393437355C223E5C6E20';
wwv_flow_api.g_varchar2_table(287) := '2020202020202020203C7061746820643D5C224D33322E363536383534322C3239204C33382E333130363937382C32332E33343631353634204333392E383737313032312C32312E373739373532312033392E383735383035372C31392E323438333838';
wwv_flow_api.g_varchar2_table(288) := '372033382E333133373038352C31372E36383632393135204333362E373534373839392C31362E313237333732392033342E323137363033352C31362E313235353432322033322E363533383433362C31372E36383933303232204C32372C32332E3334';
wwv_flow_api.g_varchar2_table(289) := '3331343538204C32312E333436313536342C31372E36383933303232204331392E373832333936352C31362E313235353432322031372E323435323130312C31362E313237333732392031352E363836323931352C31372E36383632393135204331342E';
wwv_flow_api.g_varchar2_table(290) := '313234313934332C31392E323438333838372031342E313232383937392C32312E373739373532312031352E363839333032322C32332E33343631353634204C32312E333433313435382C3239204C31352E363839333032322C33342E36353338343336';
wwv_flow_api.g_varchar2_table(291) := '204331342E313232383937392C33362E323230323437392031342E313234313934332C33382E373531363131332031352E363836323931352C34302E33313337303835204331372E323435323130312C34312E383732363237312031392E373832333936';
wwv_flow_api.g_varchar2_table(292) := '352C34312E383734343537382032312E333436313536342C34302E33313036393738204C32372C33342E36353638353432204C33322E363533383433362C34302E33313036393738204333342E323137363033352C34312E383734343537382033362E37';
wwv_flow_api.g_varchar2_table(293) := '3534373839392C34312E383732363237312033382E333133373038352C34302E33313337303835204333392E383735383035372C33382E373531363131332033392E383737313032312C33362E323230323437392033382E333130363937382C33342E36';
wwv_flow_api.g_varchar2_table(294) := '353338343336204C33322E363536383534322C3239205A204D32372C3533204334312E333539343033352C35332035332C34312E333539343033352035332C3237204335332C31322E363430353936352034312E333539343033352C312032372C312043';
wwv_flow_api.g_varchar2_table(295) := '31322E363430353936352C3120312C31322E3634303539363520312C32372043312C34312E333539343033352031322E363430353936352C35332032372C3533205A5C222069643D5C224F76616C2D325C2220736B657463683A747970653D5C224D5353';
wwv_flow_api.g_varchar2_table(296) := '6861706547726F75705C223E3C2F706174683E5C6E20202020202020203C2F673E5C6E2020202020203C2F673E5C6E202020203C2F7376673E5C6E20203C2F6469763E5C6E3C2F6469763E222C0A0A20202020202020202F2F20454E44204F5054494F4E';
wwv_flow_api.g_varchar2_table(297) := '530A20202020202020202F2F20285265717569726564206279207468652064726F707A6F6E6520646F63756D656E746174696F6E20706172736572290A0A0A20202020202020202F2A0A20202020202020202054686F73652066756E6374696F6E732072';
wwv_flow_api.g_varchar2_table(298) := '65676973746572207468656D73656C76657320746F20746865206576656E7473206F6E20696E697420616E642068616E646C6520616C6C0A202020202020202020746865207573657220696E746572666163652073706563696669632073747566662E20';
wwv_flow_api.g_varchar2_table(299) := '4F76657277726974696E67207468656D20776F6E277420627265616B207468652075706C6F61640A2020202020202020206275742063616E20627265616B2074686520776179206974277320646973706C617965642E0A202020202020202020596F7520';
wwv_flow_api.g_varchar2_table(300) := '63616E206F7665727772697465207468656D20696620796F7520646F6E2774206C696B65207468652064656661756C74206265686176696F722E20496620796F75206A7573740A20202020202020202077616E7420746F2061646420616E206164646974';
wwv_flow_api.g_varchar2_table(301) := '696F6E616C206576656E742068616E646C65722C207265676973746572206974206F6E207468652064726F707A6F6E65206F626A6563740A202020202020202020616E6420646F6E2774206F76657277726974652074686F7365206F7074696F6E732E0A';
wwv_flow_api.g_varchar2_table(302) := '2020202020202020202A2F0A0A20202020202020202F2F2054686F7365206172652073656C66206578706C616E61746F727920616E642073696D706C7920636F6E6365726E2074686520447261676E44726F702E0A202020202020202064726F703A2066';
wwv_flow_api.g_varchar2_table(303) := '756E6374696F6E2064726F70286529207B0A2020202020202020202072657475726E20746869732E656C656D656E742E636C6173734C6973742E72656D6F76652822647A2D647261672D686F76657222293B0A20202020202020207D2C0A202020202020';
wwv_flow_api.g_varchar2_table(304) := '20206472616773746172743A2066756E6374696F6E20647261677374617274286529207B7D2C0A202020202020202064726167656E643A2066756E6374696F6E2064726167656E64286529207B0A2020202020202020202072657475726E20746869732E';
wwv_flow_api.g_varchar2_table(305) := '656C656D656E742E636C6173734C6973742E72656D6F76652822647A2D647261672D686F76657222293B0A20202020202020207D2C0A202020202020202064726167656E7465723A2066756E6374696F6E2064726167656E746572286529207B0A202020';
wwv_flow_api.g_varchar2_table(306) := '2020202020202072657475726E20746869732E656C656D656E742E636C6173734C6973742E6164642822647A2D647261672D686F76657222293B0A20202020202020207D2C0A2020202020202020647261676F7665723A2066756E6374696F6E20647261';
wwv_flow_api.g_varchar2_table(307) := '676F766572286529207B0A2020202020202020202072657475726E20746869732E656C656D656E742E636C6173734C6973742E6164642822647A2D647261672D686F76657222293B0A20202020202020207D2C0A2020202020202020647261676C656176';
wwv_flow_api.g_varchar2_table(308) := '653A2066756E6374696F6E20647261676C65617665286529207B0A2020202020202020202072657475726E20746869732E656C656D656E742E636C6173734C6973742E72656D6F76652822647A2D647261672D686F76657222293B0A2020202020202020';
wwv_flow_api.g_varchar2_table(309) := '7D2C0A202020202020202070617374653A2066756E6374696F6E207061737465286529207B7D2C0A0A0A20202020202020202F2F2043616C6C6564207768656E6576657220746865726520617265206E6F2066696C6573206C65667420696E2074686520';
wwv_flow_api.g_varchar2_table(310) := '64726F707A6F6E6520616E796D6F72652C20616E64207468650A20202020202020202F2F2064726F707A6F6E652073686F756C6420626520646973706C6179656420617320696620696E2074686520696E697469616C2073746174652E0A202020202020';
wwv_flow_api.g_varchar2_table(311) := '202072657365743A2066756E6374696F6E2072657365742829207B0A2020202020202020202072657475726E20746869732E656C656D656E742E636C6173734C6973742E72656D6F76652822647A2D7374617274656422293B0A20202020202020207D2C';
wwv_flow_api.g_varchar2_table(312) := '0A0A0A20202020202020202F2F2043616C6C6564207768656E20612066696C6520697320616464656420746F207468652071756575650A20202020202020202F2F205265636569766573206066696C65600A2020202020202020616464656466696C653A';
wwv_flow_api.g_varchar2_table(313) := '2066756E6374696F6E20616464656466696C652866696C6529207B0A20202020202020202020766172205F7468697332203D20746869733B0A0A2020202020202020202069662028746869732E656C656D656E74203D3D3D20746869732E707265766965';
wwv_flow_api.g_varchar2_table(314) := '7773436F6E7461696E657229207B0A202020202020202020202020746869732E656C656D656E742E636C6173734C6973742E6164642822647A2D7374617274656422293B0A202020202020202020207D0A0A202020202020202020206966202874686973';
wwv_flow_api.g_varchar2_table(315) := '2E7072657669657773436F6E7461696E657229207B0A20202020202020202020202066696C652E70726576696577456C656D656E74203D2044726F707A6F6E652E637265617465456C656D656E7428746869732E6F7074696F6E732E7072657669657754';
wwv_flow_api.g_varchar2_table(316) := '656D706C6174652E7472696D2829293B0A20202020202020202020202066696C652E7072657669657754656D706C617465203D2066696C652E70726576696577456C656D656E743B202F2F204261636B776172647320636F6D7061746962696C6974790A';
wwv_flow_api.g_varchar2_table(317) := '0A202020202020202020202020746869732E7072657669657773436F6E7461696E65722E617070656E644368696C642866696C652E70726576696577456C656D656E74293B0A202020202020202020202020666F722028766172205F6974657261746F72';
wwv_flow_api.g_varchar2_table(318) := '33203D2066696C652E70726576696577456C656D656E742E717565727953656C6563746F72416C6C28225B646174612D647A2D6E616D655D22292C205F6973417272617933203D20747275652C205F6933203D20302C205F6974657261746F7233203D20';
wwv_flow_api.g_varchar2_table(319) := '5F6973417272617933203F205F6974657261746F7233203A205F6974657261746F72335B53796D626F6C2E6974657261746F725D28293B3B29207B0A2020202020202020202020202020766172205F726566333B0A0A2020202020202020202020202020';
wwv_flow_api.g_varchar2_table(320) := '696620285F697341727261793329207B0A20202020202020202020202020202020696620285F6933203E3D205F6974657261746F72332E6C656E6774682920627265616B3B0A202020202020202020202020202020205F72656633203D205F6974657261';
wwv_flow_api.g_varchar2_table(321) := '746F72335B5F69332B2B5D3B0A20202020202020202020202020207D20656C7365207B0A202020202020202020202020202020205F6933203D205F6974657261746F72332E6E65787428293B0A20202020202020202020202020202020696620285F6933';
wwv_flow_api.g_varchar2_table(322) := '2E646F6E652920627265616B3B0A202020202020202020202020202020205F72656633203D205F69332E76616C75653B0A20202020202020202020202020207D0A0A2020202020202020202020202020766172206E6F6465203D205F726566333B0A0A20';
wwv_flow_api.g_varchar2_table(323) := '202020202020202020202020206E6F64652E74657874436F6E74656E74203D2066696C652E6E616D653B0A2020202020202020202020207D0A202020202020202020202020666F722028766172205F6974657261746F7234203D2066696C652E70726576';
wwv_flow_api.g_varchar2_table(324) := '696577456C656D656E742E717565727953656C6563746F72416C6C28225B646174612D647A2D73697A655D22292C205F6973417272617934203D20747275652C205F6934203D20302C205F6974657261746F7234203D205F6973417272617934203F205F';
wwv_flow_api.g_varchar2_table(325) := '6974657261746F7234203A205F6974657261746F72345B53796D626F6C2E6974657261746F725D28293B3B29207B0A2020202020202020202020202020696620285F697341727261793429207B0A20202020202020202020202020202020696620285F69';
wwv_flow_api.g_varchar2_table(326) := '34203E3D205F6974657261746F72342E6C656E6774682920627265616B3B0A202020202020202020202020202020206E6F6465203D205F6974657261746F72345B5F69342B2B5D3B0A20202020202020202020202020207D20656C7365207B0A20202020';
wwv_flow_api.g_varchar2_table(327) := '2020202020202020202020205F6934203D205F6974657261746F72342E6E65787428293B0A20202020202020202020202020202020696620285F69342E646F6E652920627265616B3B0A202020202020202020202020202020206E6F6465203D205F6934';
wwv_flow_api.g_varchar2_table(328) := '2E76616C75653B0A20202020202020202020202020207D0A0A20202020202020202020202020206E6F64652E696E6E657248544D4C203D20746869732E66696C6573697A652866696C652E73697A65293B0A2020202020202020202020207D0A0A202020';
wwv_flow_api.g_varchar2_table(329) := '20202020202020202069662028746869732E6F7074696F6E732E61646452656D6F76654C696E6B7329207B0A202020202020202020202020202066696C652E5F72656D6F76654C696E6B203D2044726F707A6F6E652E637265617465456C656D656E7428';
wwv_flow_api.g_varchar2_table(330) := '223C6120636C6173733D5C22647A2D72656D6F76655C2220687265663D5C226A6176617363726970743A756E646566696E65643B5C2220646174612D647A2D72656D6F76653E22202B20746869732E6F7074696F6E732E6469637452656D6F766546696C';
wwv_flow_api.g_varchar2_table(331) := '65202B20223C2F613E22293B0A202020202020202020202020202066696C652E70726576696577456C656D656E742E617070656E644368696C642866696C652E5F72656D6F76654C696E6B293B0A2020202020202020202020207D0A0A20202020202020';
wwv_flow_api.g_varchar2_table(332) := '20202020207661722072656D6F766546696C654576656E74203D2066756E6374696F6E2072656D6F766546696C654576656E74286529207B0A2020202020202020202020202020652E70726576656E7444656661756C7428293B0A202020202020202020';
wwv_flow_api.g_varchar2_table(333) := '2020202020652E73746F7050726F7061676174696F6E28293B0A20202020202020202020202020206966202866696C652E737461747573203D3D3D2044726F707A6F6E652E55504C4F4144494E4729207B0A202020202020202020202020202020207265';
wwv_flow_api.g_varchar2_table(334) := '7475726E2044726F707A6F6E652E636F6E6669726D285F74686973322E6F7074696F6E732E6469637443616E63656C55706C6F6164436F6E6669726D6174696F6E2C2066756E6374696F6E202829207B0A20202020202020202020202020202020202072';
wwv_flow_api.g_varchar2_table(335) := '657475726E205F74686973322E72656D6F766546696C652866696C65293B0A202020202020202020202020202020207D293B0A20202020202020202020202020207D20656C7365207B0A20202020202020202020202020202020696620285F7468697332';
wwv_flow_api.g_varchar2_table(336) := '2E6F7074696F6E732E6469637452656D6F766546696C65436F6E6669726D6174696F6E29207B0A20202020202020202020202020202020202072657475726E2044726F707A6F6E652E636F6E6669726D285F74686973322E6F7074696F6E732E64696374';
wwv_flow_api.g_varchar2_table(337) := '52656D6F766546696C65436F6E6669726D6174696F6E2C2066756E6374696F6E202829207B0A202020202020202020202020202020202020202072657475726E205F74686973322E72656D6F766546696C652866696C65293B0A20202020202020202020';
wwv_flow_api.g_varchar2_table(338) := '20202020202020207D293B0A202020202020202020202020202020207D20656C7365207B0A20202020202020202020202020202020202072657475726E205F74686973322E72656D6F766546696C652866696C65293B0A20202020202020202020202020';
wwv_flow_api.g_varchar2_table(339) := '2020207D0A20202020202020202020202020207D0A2020202020202020202020207D3B0A0A202020202020202020202020666F722028766172205F6974657261746F7235203D2066696C652E70726576696577456C656D656E742E717565727953656C65';
wwv_flow_api.g_varchar2_table(340) := '63746F72416C6C28225B646174612D647A2D72656D6F76655D22292C205F6973417272617935203D20747275652C205F6935203D20302C205F6974657261746F7235203D205F6973417272617935203F205F6974657261746F7235203A205F6974657261';
wwv_flow_api.g_varchar2_table(341) := '746F72355B53796D626F6C2E6974657261746F725D28293B3B29207B0A2020202020202020202020202020766172205F726566343B0A0A2020202020202020202020202020696620285F697341727261793529207B0A2020202020202020202020202020';
wwv_flow_api.g_varchar2_table(342) := '2020696620285F6935203E3D205F6974657261746F72352E6C656E6774682920627265616B3B0A202020202020202020202020202020205F72656634203D205F6974657261746F72355B5F69352B2B5D3B0A20202020202020202020202020207D20656C';
wwv_flow_api.g_varchar2_table(343) := '7365207B0A202020202020202020202020202020205F6935203D205F6974657261746F72352E6E65787428293B0A20202020202020202020202020202020696620285F69352E646F6E652920627265616B3B0A202020202020202020202020202020205F';
wwv_flow_api.g_varchar2_table(344) := '72656634203D205F69352E76616C75653B0A20202020202020202020202020207D0A0A20202020202020202020202020207661722072656D6F76654C696E6B203D205F726566343B0A0A202020202020202020202020202072656D6F76654C696E6B2E61';
wwv_flow_api.g_varchar2_table(345) := '64644576656E744C697374656E65722822636C69636B222C2072656D6F766546696C654576656E74293B0A2020202020202020202020207D0A202020202020202020207D0A20202020202020207D2C0A0A0A20202020202020202F2F2043616C6C656420';
wwv_flow_api.g_varchar2_table(346) := '7768656E6576657220612066696C652069732072656D6F7665642E0A202020202020202072656D6F76656466696C653A2066756E6374696F6E2072656D6F76656466696C652866696C6529207B0A202020202020202020206966202866696C652E707265';
wwv_flow_api.g_varchar2_table(347) := '76696577456C656D656E7420213D206E756C6C2026262066696C652E70726576696577456C656D656E742E706172656E744E6F646520213D206E756C6C29207B0A20202020202020202020202066696C652E70726576696577456C656D656E742E706172';
wwv_flow_api.g_varchar2_table(348) := '656E744E6F64652E72656D6F76654368696C642866696C652E70726576696577456C656D656E74293B0A202020202020202020207D0A2020202020202020202072657475726E20746869732E5F7570646174654D617846696C657352656163686564436C';
wwv_flow_api.g_varchar2_table(349) := '61737328293B0A20202020202020207D2C0A0A0A20202020202020202F2F2043616C6C6564207768656E2061207468756D626E61696C20686173206265656E2067656E6572617465640A20202020202020202F2F205265636569766573206066696C6560';
wwv_flow_api.g_varchar2_table(350) := '20616E6420606461746155726C600A20202020202020207468756D626E61696C3A2066756E6374696F6E207468756D626E61696C2866696C652C206461746155726C29207B0A202020202020202020206966202866696C652E70726576696577456C656D';
wwv_flow_api.g_varchar2_table(351) := '656E7429207B0A20202020202020202020202066696C652E70726576696577456C656D656E742E636C6173734C6973742E72656D6F76652822647A2D66696C652D7072657669657722293B0A202020202020202020202020666F722028766172205F6974';
wwv_flow_api.g_varchar2_table(352) := '657261746F7236203D2066696C652E70726576696577456C656D656E742E717565727953656C6563746F72416C6C28225B646174612D647A2D7468756D626E61696C5D22292C205F6973417272617936203D20747275652C205F6936203D20302C205F69';
wwv_flow_api.g_varchar2_table(353) := '74657261746F7236203D205F6973417272617936203F205F6974657261746F7236203A205F6974657261746F72365B53796D626F6C2E6974657261746F725D28293B3B29207B0A2020202020202020202020202020766172205F726566353B0A0A202020';
wwv_flow_api.g_varchar2_table(354) := '2020202020202020202020696620285F697341727261793629207B0A20202020202020202020202020202020696620285F6936203E3D205F6974657261746F72362E6C656E6774682920627265616B3B0A202020202020202020202020202020205F7265';
wwv_flow_api.g_varchar2_table(355) := '6635203D205F6974657261746F72365B5F69362B2B5D3B0A20202020202020202020202020207D20656C7365207B0A202020202020202020202020202020205F6936203D205F6974657261746F72362E6E65787428293B0A202020202020202020202020';
wwv_flow_api.g_varchar2_table(356) := '20202020696620285F69362E646F6E652920627265616B3B0A202020202020202020202020202020205F72656635203D205F69362E76616C75653B0A20202020202020202020202020207D0A0A2020202020202020202020202020766172207468756D62';
wwv_flow_api.g_varchar2_table(357) := '6E61696C456C656D656E74203D205F726566353B0A0A20202020202020202020202020207468756D626E61696C456C656D656E742E616C74203D2066696C652E6E616D653B0A20202020202020202020202020207468756D626E61696C456C656D656E74';
wwv_flow_api.g_varchar2_table(358) := '2E737263203D206461746155726C3B0A2020202020202020202020207D0A0A20202020202020202020202072657475726E2073657454696D656F75742866756E6374696F6E202829207B0A202020202020202020202020202072657475726E2066696C65';
wwv_flow_api.g_varchar2_table(359) := '2E70726576696577456C656D656E742E636C6173734C6973742E6164642822647A2D696D6167652D7072657669657722293B0A2020202020202020202020207D2C2031293B0A202020202020202020207D0A20202020202020207D2C0A0A0A2020202020';
wwv_flow_api.g_varchar2_table(360) := '2020202F2F2043616C6C6564207768656E6576657220616E206572726F72206F63637572730A20202020202020202F2F205265636569766573206066696C656020616E6420606D657373616765600A20202020202020206572726F723A2066756E637469';
wwv_flow_api.g_varchar2_table(361) := '6F6E206572726F722866696C652C206D65737361676529207B0A202020202020202020206966202866696C652E70726576696577456C656D656E7429207B0A20202020202020202020202066696C652E70726576696577456C656D656E742E636C617373';
wwv_flow_api.g_varchar2_table(362) := '4C6973742E6164642822647A2D6572726F7222293B0A20202020202020202020202069662028747970656F66206D65737361676520213D3D2022537472696E6722202626206D6573736167652E6572726F7229207B0A2020202020202020202020202020';
wwv_flow_api.g_varchar2_table(363) := '6D657373616765203D206D6573736167652E6572726F723B0A2020202020202020202020207D0A202020202020202020202020666F722028766172205F6974657261746F7237203D2066696C652E70726576696577456C656D656E742E71756572795365';
wwv_flow_api.g_varchar2_table(364) := '6C6563746F72416C6C28225B646174612D647A2D6572726F726D6573736167655D22292C205F6973417272617937203D20747275652C205F6937203D20302C205F6974657261746F7237203D205F6973417272617937203F205F6974657261746F723720';
wwv_flow_api.g_varchar2_table(365) := '3A205F6974657261746F72375B53796D626F6C2E6974657261746F725D28293B3B29207B0A2020202020202020202020202020766172205F726566363B0A0A2020202020202020202020202020696620285F697341727261793729207B0A202020202020';
wwv_flow_api.g_varchar2_table(366) := '20202020202020202020696620285F6937203E3D205F6974657261746F72372E6C656E6774682920627265616B3B0A202020202020202020202020202020205F72656636203D205F6974657261746F72375B5F69372B2B5D3B0A20202020202020202020';
wwv_flow_api.g_varchar2_table(367) := '202020207D20656C7365207B0A202020202020202020202020202020205F6937203D205F6974657261746F72372E6E65787428293B0A20202020202020202020202020202020696620285F69372E646F6E652920627265616B3B0A202020202020202020';
wwv_flow_api.g_varchar2_table(368) := '202020202020205F72656636203D205F69372E76616C75653B0A20202020202020202020202020207D0A0A2020202020202020202020202020766172206E6F6465203D205F726566363B0A0A20202020202020202020202020206E6F64652E7465787443';
wwv_flow_api.g_varchar2_table(369) := '6F6E74656E74203D206D6573736167653B0A2020202020202020202020207D0A202020202020202020207D0A20202020202020207D2C0A20202020202020206572726F726D756C7469706C653A2066756E6374696F6E206572726F726D756C7469706C65';
wwv_flow_api.g_varchar2_table(370) := '2829207B7D2C0A0A0A20202020202020202F2F2043616C6C6564207768656E20612066696C6520676574732070726F6365737365642E2053696E63652074686572652069732061206375652C206E6F7420616C6C2061646465640A20202020202020202F';
wwv_flow_api.g_varchar2_table(371) := '2F2066696C6573206172652070726F63657373656420696D6D6564696174656C792E0A20202020202020202F2F205265636569766573206066696C65600A202020202020202070726F63657373696E673A2066756E6374696F6E2070726F63657373696E';
wwv_flow_api.g_varchar2_table(372) := '672866696C6529207B0A202020202020202020206966202866696C652E70726576696577456C656D656E7429207B0A20202020202020202020202066696C652E70726576696577456C656D656E742E636C6173734C6973742E6164642822647A2D70726F';
wwv_flow_api.g_varchar2_table(373) := '63657373696E6722293B0A2020202020202020202020206966202866696C652E5F72656D6F76654C696E6B29207B0A202020202020202020202020202072657475726E2066696C652E5F72656D6F76654C696E6B2E696E6E657248544D4C203D20746869';
wwv_flow_api.g_varchar2_table(374) := '732E6F7074696F6E732E6469637443616E63656C55706C6F61643B0A2020202020202020202020207D0A202020202020202020207D0A20202020202020207D2C0A202020202020202070726F63657373696E676D756C7469706C653A2066756E6374696F';
wwv_flow_api.g_varchar2_table(375) := '6E2070726F63657373696E676D756C7469706C652829207B7D2C0A0A0A20202020202020202F2F2043616C6C6564207768656E65766572207468652075706C6F61642070726F6772657373206765747320757064617465642E0A20202020202020202F2F';
wwv_flow_api.g_varchar2_table(376) := '205265636569766573206066696C65602C206070726F677265737360202870657263656E7461676520302D3130302920616E642060627974657353656E74602E0A20202020202020202F2F20546F206765742074686520746F74616C206E756D62657220';
wwv_flow_api.g_varchar2_table(377) := '6F66206279746573206F66207468652066696C652C20757365206066696C652E73697A65600A202020202020202075706C6F616470726F67726573733A2066756E6374696F6E2075706C6F616470726F67726573732866696C652C2070726F6772657373';
wwv_flow_api.g_varchar2_table(378) := '2C20627974657353656E7429207B0A202020202020202020206966202866696C652E70726576696577456C656D656E7429207B0A202020202020202020202020666F722028766172205F6974657261746F7238203D2066696C652E70726576696577456C';
wwv_flow_api.g_varchar2_table(379) := '656D656E742E717565727953656C6563746F72416C6C28225B646174612D647A2D75706C6F616470726F67726573735D22292C205F6973417272617938203D20747275652C205F6938203D20302C205F6974657261746F7238203D205F69734172726179';
wwv_flow_api.g_varchar2_table(380) := '38203F205F6974657261746F7238203A205F6974657261746F72385B53796D626F6C2E6974657261746F725D28293B3B29207B0A2020202020202020202020202020766172205F726566373B0A0A2020202020202020202020202020696620285F697341';
wwv_flow_api.g_varchar2_table(381) := '727261793829207B0A20202020202020202020202020202020696620285F6938203E3D205F6974657261746F72382E6C656E6774682920627265616B3B0A202020202020202020202020202020205F72656637203D205F6974657261746F72385B5F6938';
wwv_flow_api.g_varchar2_table(382) := '2B2B5D3B0A20202020202020202020202020207D20656C7365207B0A202020202020202020202020202020205F6938203D205F6974657261746F72382E6E65787428293B0A20202020202020202020202020202020696620285F69382E646F6E65292062';
wwv_flow_api.g_varchar2_table(383) := '7265616B3B0A202020202020202020202020202020205F72656637203D205F69382E76616C75653B0A20202020202020202020202020207D0A0A2020202020202020202020202020766172206E6F6465203D205F726566373B0A0A202020202020202020';
wwv_flow_api.g_varchar2_table(384) := '20202020206E6F64652E6E6F64654E616D65203D3D3D202750524F475245535327203F206E6F64652E76616C7565203D2070726F6772657373203A206E6F64652E7374796C652E7769647468203D2070726F6772657373202B202225223B0A2020202020';
wwv_flow_api.g_varchar2_table(385) := '202020202020207D0A202020202020202020207D0A20202020202020207D2C0A0A0A20202020202020202F2F2043616C6C6564207768656E657665722074686520746F74616C2075706C6F61642070726F6772657373206765747320757064617465642E';
wwv_flow_api.g_varchar2_table(386) := '0A20202020202020202F2F2043616C6C6564207769746820746F74616C55706C6F616450726F67726573732028302D313030292C20746F74616C427974657320616E6420746F74616C427974657353656E740A2020202020202020746F74616C75706C6F';
wwv_flow_api.g_varchar2_table(387) := '616470726F67726573733A2066756E6374696F6E20746F74616C75706C6F616470726F67726573732829207B7D2C0A0A0A20202020202020202F2F2043616C6C6564206A757374206265666F7265207468652066696C652069732073656E742E20476574';
wwv_flow_api.g_varchar2_table(388) := '7320746865206078687260206F626A656374206173207365636F6E640A20202020202020202F2F20706172616D657465722C20736F20796F752063616E206D6F646966792069742028666F72206578616D706C6520746F20616464206120435352462074';
wwv_flow_api.g_varchar2_table(389) := '6F6B656E2920616E6420610A20202020202020202F2F2060666F726D4461746160206F626A65637420746F20616464206164646974696F6E616C20696E666F726D6174696F6E2E0A202020202020202073656E64696E673A2066756E6374696F6E207365';
wwv_flow_api.g_varchar2_table(390) := '6E64696E672829207B7D2C0A202020202020202073656E64696E676D756C7469706C653A2066756E6374696F6E2073656E64696E676D756C7469706C652829207B7D2C0A0A0A20202020202020202F2F205768656E2074686520636F6D706C6574652075';
wwv_flow_api.g_varchar2_table(391) := '706C6F61642069732066696E697368656420616E64207375636365737366756C0A20202020202020202F2F205265636569766573206066696C65600A2020202020202020737563636573733A2066756E6374696F6E20737563636573732866696C652920';
wwv_flow_api.g_varchar2_table(392) := '7B0A202020202020202020206966202866696C652E70726576696577456C656D656E7429207B0A20202020202020202020202072657475726E2066696C652E70726576696577456C656D656E742E636C6173734C6973742E6164642822647A2D73756363';
wwv_flow_api.g_varchar2_table(393) := '65737322293B0A202020202020202020207D0A20202020202020207D2C0A2020202020202020737563636573736D756C7469706C653A2066756E6374696F6E20737563636573736D756C7469706C652829207B7D2C0A0A0A20202020202020202F2F2057';
wwv_flow_api.g_varchar2_table(394) := '68656E207468652075706C6F61642069732063616E63656C65642E0A202020202020202063616E63656C65643A2066756E6374696F6E2063616E63656C65642866696C6529207B0A2020202020202020202072657475726E20746869732E656D69742822';
wwv_flow_api.g_varchar2_table(395) := '6572726F72222C2066696C652C20746869732E6F7074696F6E732E6469637455706C6F616443616E63656C6564293B0A20202020202020207D2C0A202020202020202063616E63656C65646D756C7469706C653A2066756E6374696F6E2063616E63656C';
wwv_flow_api.g_varchar2_table(396) := '65646D756C7469706C652829207B7D2C0A0A0A20202020202020202F2F205768656E207468652075706C6F61642069732066696E69736865642C2065697468657220776974682073756363657373206F7220616E206572726F722E0A2020202020202020';
wwv_flow_api.g_varchar2_table(397) := '2F2F205265636569766573206066696C65600A2020202020202020636F6D706C6574653A2066756E6374696F6E20636F6D706C6574652866696C6529207B0A202020202020202020206966202866696C652E5F72656D6F76654C696E6B29207B0A202020';
wwv_flow_api.g_varchar2_table(398) := '20202020202020202066696C652E5F72656D6F76654C696E6B2E696E6E657248544D4C203D20746869732E6F7074696F6E732E6469637452656D6F766546696C653B0A202020202020202020207D0A202020202020202020206966202866696C652E7072';
wwv_flow_api.g_varchar2_table(399) := '6576696577456C656D656E7429207B0A20202020202020202020202072657475726E2066696C652E70726576696577456C656D656E742E636C6173734C6973742E6164642822647A2D636F6D706C65746522293B0A202020202020202020207D0A202020';
wwv_flow_api.g_varchar2_table(400) := '20202020207D2C0A2020202020202020636F6D706C6574656D756C7469706C653A2066756E6374696F6E20636F6D706C6574656D756C7469706C652829207B7D2C0A20202020202020206D617866696C657365786365656465643A2066756E6374696F6E';
wwv_flow_api.g_varchar2_table(401) := '206D617866696C657365786365656465642829207B7D2C0A20202020202020206D617866696C6573726561636865643A2066756E6374696F6E206D617866696C6573726561636865642829207B7D2C0A20202020202020207175657565636F6D706C6574';
wwv_flow_api.g_varchar2_table(402) := '653A2066756E6374696F6E207175657565636F6D706C6574652829207B7D2C0A2020202020202020616464656466696C65733A2066756E6374696F6E20616464656466696C65732829207B7D0A2020202020207D3B0A0A202020202020746869732E7072';
wwv_flow_api.g_varchar2_table(403) := '6F746F747970652E5F7468756D626E61696C5175657565203D205B5D3B0A202020202020746869732E70726F746F747970652E5F70726F63657373696E675468756D626E61696C203D2066616C73653B0A202020207D0A0A202020202F2F20676C6F6261';
wwv_flow_api.g_varchar2_table(404) := '6C207574696C6974790A0A20207D2C207B0A202020206B65793A2022657874656E64222C0A2020202076616C75653A2066756E6374696F6E20657874656E642874617267657429207B0A202020202020666F722028766172205F6C656E32203D20617267';
wwv_flow_api.g_varchar2_table(405) := '756D656E74732E6C656E6774682C206F626A65637473203D204172726179285F6C656E32203E2031203F205F6C656E32202D2031203A2030292C205F6B657932203D20313B205F6B657932203C205F6C656E323B205F6B6579322B2B29207B0A20202020';
wwv_flow_api.g_varchar2_table(406) := '202020206F626A656374735B5F6B657932202D20315D203D20617267756D656E74735B5F6B6579325D3B0A2020202020207D0A0A202020202020666F722028766172205F6974657261746F7239203D206F626A656374732C205F6973417272617939203D';
wwv_flow_api.g_varchar2_table(407) := '20747275652C205F6939203D20302C205F6974657261746F7239203D205F6973417272617939203F205F6974657261746F7239203A205F6974657261746F72395B53796D626F6C2E6974657261746F725D28293B3B29207B0A2020202020202020766172';
wwv_flow_api.g_varchar2_table(408) := '205F726566383B0A0A2020202020202020696620285F697341727261793929207B0A20202020202020202020696620285F6939203E3D205F6974657261746F72392E6C656E6774682920627265616B3B0A202020202020202020205F72656638203D205F';
wwv_flow_api.g_varchar2_table(409) := '6974657261746F72395B5F69392B2B5D3B0A20202020202020207D20656C7365207B0A202020202020202020205F6939203D205F6974657261746F72392E6E65787428293B0A20202020202020202020696620285F69392E646F6E652920627265616B3B';
wwv_flow_api.g_varchar2_table(410) := '0A202020202020202020205F72656638203D205F69392E76616C75653B0A20202020202020207D0A0A2020202020202020766172206F626A656374203D205F726566383B0A0A2020202020202020666F722028766172206B657920696E206F626A656374';
wwv_flow_api.g_varchar2_table(411) := '29207B0A202020202020202020207661722076616C203D206F626A6563745B6B65795D3B0A202020202020202020207461726765745B6B65795D203D2076616C3B0A20202020202020207D0A2020202020207D0A20202020202072657475726E20746172';
wwv_flow_api.g_varchar2_table(412) := '6765743B0A202020207D0A20207D5D293B0A0A202066756E6374696F6E2044726F707A6F6E6528656C2C206F7074696F6E7329207B0A202020205F636C61737343616C6C436865636B28746869732C2044726F707A6F6E65293B0A0A2020202076617220';
wwv_flow_api.g_varchar2_table(413) := '5F74686973203D205F706F737369626C65436F6E7374727563746F7252657475726E28746869732C202844726F707A6F6E652E5F5F70726F746F5F5F207C7C204F626A6563742E67657450726F746F747970654F662844726F707A6F6E6529292E63616C';
wwv_flow_api.g_varchar2_table(414) := '6C287468697329293B0A0A202020207661722066616C6C6261636B203D20766F696420302C0A20202020202020206C656674203D20766F696420303B0A202020205F746869732E656C656D656E74203D20656C3B0A202020202F2F20466F72206261636B';
wwv_flow_api.g_varchar2_table(415) := '776172647320636F6D7061746962696C6974792073696E6365207468652076657273696F6E2077617320696E207468652070726F746F747970652070726576696F75736C790A202020205F746869732E76657273696F6E203D2044726F707A6F6E652E76';
wwv_flow_api.g_varchar2_table(416) := '657273696F6E3B0A0A202020205F746869732E64656661756C744F7074696F6E732E7072657669657754656D706C617465203D205F746869732E64656661756C744F7074696F6E732E7072657669657754656D706C6174652E7265706C616365282F5C6E';
wwv_flow_api.g_varchar2_table(417) := '2A2F672C202222293B0A0A202020205F746869732E636C69636B61626C65456C656D656E7473203D205B5D3B0A202020205F746869732E6C697374656E657273203D205B5D3B0A202020205F746869732E66696C6573203D205B5D3B202F2F20416C6C20';
wwv_flow_api.g_varchar2_table(418) := '66696C65730A0A2020202069662028747970656F66205F746869732E656C656D656E74203D3D3D2022737472696E672229207B0A2020202020205F746869732E656C656D656E74203D20646F63756D656E742E717565727953656C6563746F72285F7468';
wwv_flow_api.g_varchar2_table(419) := '69732E656C656D656E74293B0A202020207D0A0A202020202F2F204E6F7420636865636B696E6720696620696E7374616E6365206F662048544D4C456C656D656E74206F7220456C656D656E742073696E6365204945392069732065787472656D656C79';
wwv_flow_api.g_varchar2_table(420) := '2077656972642E0A2020202069662028215F746869732E656C656D656E74207C7C205F746869732E656C656D656E742E6E6F646554797065203D3D206E756C6C29207B0A2020202020207468726F77206E6577204572726F722822496E76616C69642064';
wwv_flow_api.g_varchar2_table(421) := '726F707A6F6E6520656C656D656E742E22293B0A202020207D0A0A20202020696620285F746869732E656C656D656E742E64726F707A6F6E6529207B0A2020202020207468726F77206E6577204572726F72282244726F707A6F6E6520616C7265616479';
wwv_flow_api.g_varchar2_table(422) := '2061747461636865642E22293B0A202020207D0A0A202020202F2F204E6F772061646420746869732064726F707A6F6E6520746F2074686520696E7374616E6365732E0A2020202044726F707A6F6E652E696E7374616E6365732E70757368285F746869';
wwv_flow_api.g_varchar2_table(423) := '73293B0A0A202020202F2F20507574207468652064726F707A6F6E6520696E736964652074686520656C656D656E7420697473656C662E0A202020205F746869732E656C656D656E742E64726F707A6F6E65203D205F746869733B0A0A20202020766172';
wwv_flow_api.g_varchar2_table(424) := '20656C656D656E744F7074696F6E73203D20286C656674203D2044726F707A6F6E652E6F7074696F6E73466F72456C656D656E74285F746869732E656C656D656E74292920213D206E756C6C203F206C656674203A207B7D3B0A0A202020205F74686973';
wwv_flow_api.g_varchar2_table(425) := '2E6F7074696F6E73203D2044726F707A6F6E652E657874656E64287B7D2C205F746869732E64656661756C744F7074696F6E732C20656C656D656E744F7074696F6E732C206F7074696F6E7320213D206E756C6C203F206F7074696F6E73203A207B7D29';
wwv_flow_api.g_varchar2_table(426) := '3B0A0A202020202F2F204966207468652062726F77736572206661696C65642C206A7573742063616C6C207468652066616C6C6261636B20616E64206C656176650A20202020696620285F746869732E6F7074696F6E732E666F72636546616C6C626163';
wwv_flow_api.g_varchar2_table(427) := '6B207C7C202144726F707A6F6E652E697342726F77736572537570706F72746564282929207B0A202020202020766172205F7265743B0A0A20202020202072657475726E205F726574203D205F746869732E6F7074696F6E732E66616C6C6261636B2E63';
wwv_flow_api.g_varchar2_table(428) := '616C6C285F74686973292C205F706F737369626C65436F6E7374727563746F7252657475726E285F746869732C205F726574293B0A202020207D0A0A202020202F2F20406F7074696F6E732E75726C203D2040656C656D656E742E676574417474726962';
wwv_flow_api.g_varchar2_table(429) := '7574652022616374696F6E2220756E6C65737320406F7074696F6E732E75726C3F0A20202020696620285F746869732E6F7074696F6E732E75726C203D3D206E756C6C29207B0A2020202020205F746869732E6F7074696F6E732E75726C203D205F7468';
wwv_flow_api.g_varchar2_table(430) := '69732E656C656D656E742E6765744174747269627574652822616374696F6E22293B0A202020207D0A0A2020202069662028215F746869732E6F7074696F6E732E75726C29207B0A2020202020207468726F77206E6577204572726F7228224E6F205552';
wwv_flow_api.g_varchar2_table(431) := '4C2070726F76696465642E22293B0A202020207D0A0A20202020696620285F746869732E6F7074696F6E732E616363657074656446696C6573202626205F746869732E6F7074696F6E732E61636365707465644D696D65547970657329207B0A20202020';
wwv_flow_api.g_varchar2_table(432) := '20207468726F77206E6577204572726F722822596F752063616E27742070726F7669646520626F74682027616363657074656446696C65732720616E64202761636365707465644D696D655479706573272E202761636365707465644D696D6554797065';
wwv_flow_api.g_varchar2_table(433) := '732720697320646570726563617465642E22293B0A202020207D0A0A20202020696620285F746869732E6F7074696F6E732E75706C6F61644D756C7469706C65202626205F746869732E6F7074696F6E732E6368756E6B696E6729207B0A202020202020';
wwv_flow_api.g_varchar2_table(434) := '7468726F77206E6577204572726F722827596F752063616E6E6F742073657420626F74683A2075706C6F61644D756C7469706C6520616E64206368756E6B696E672E27293B0A202020207D0A0A202020202F2F204261636B776172647320636F6D706174';
wwv_flow_api.g_varchar2_table(435) := '6962696C6974790A20202020696620285F746869732E6F7074696F6E732E61636365707465644D696D65547970657329207B0A2020202020205F746869732E6F7074696F6E732E616363657074656446696C6573203D205F746869732E6F7074696F6E73';
wwv_flow_api.g_varchar2_table(436) := '2E61636365707465644D696D6554797065733B0A20202020202064656C657465205F746869732E6F7074696F6E732E61636365707465644D696D6554797065733B0A202020207D0A0A202020202F2F204261636B776172647320636F6D7061746962696C';
wwv_flow_api.g_varchar2_table(437) := '6974790A20202020696620285F746869732E6F7074696F6E732E72656E616D6546696C656E616D6520213D206E756C6C29207B0A2020202020205F746869732E6F7074696F6E732E72656E616D6546696C65203D2066756E6374696F6E202866696C6529';
wwv_flow_api.g_varchar2_table(438) := '207B0A202020202020202072657475726E205F746869732E6F7074696F6E732E72656E616D6546696C656E616D652E63616C6C285F746869732C2066696C652E6E616D652C2066696C65293B0A2020202020207D3B0A202020207D0A0A202020205F7468';
wwv_flow_api.g_varchar2_table(439) := '69732E6F7074696F6E732E6D6574686F64203D205F746869732E6F7074696F6E732E6D6574686F642E746F55707065724361736528293B0A0A20202020696620282866616C6C6261636B203D205F746869732E6765744578697374696E6746616C6C6261';
wwv_flow_api.g_varchar2_table(440) := '636B2829292026262066616C6C6261636B2E706172656E744E6F646529207B0A2020202020202F2F2052656D6F7665207468652066616C6C6261636B0A20202020202066616C6C6261636B2E706172656E744E6F64652E72656D6F76654368696C642866';
wwv_flow_api.g_varchar2_table(441) := '616C6C6261636B293B0A202020207D0A0A202020202F2F20446973706C617920707265766965777320696E20746865207072657669657773436F6E7461696E657220656C656D656E74206F72207468652044726F707A6F6E6520656C656D656E7420756E';
wwv_flow_api.g_varchar2_table(442) := '6C657373206578706C696369746C792073657420746F2066616C73650A20202020696620285F746869732E6F7074696F6E732E7072657669657773436F6E7461696E657220213D3D2066616C736529207B0A202020202020696620285F746869732E6F70';
wwv_flow_api.g_varchar2_table(443) := '74696F6E732E7072657669657773436F6E7461696E657229207B0A20202020202020205F746869732E7072657669657773436F6E7461696E6572203D2044726F707A6F6E652E676574456C656D656E74285F746869732E6F7074696F6E732E7072657669';
wwv_flow_api.g_varchar2_table(444) := '657773436F6E7461696E65722C20227072657669657773436F6E7461696E657222293B0A2020202020207D20656C7365207B0A20202020202020205F746869732E7072657669657773436F6E7461696E6572203D205F746869732E656C656D656E743B0A';
wwv_flow_api.g_varchar2_table(445) := '2020202020207D0A202020207D0A0A20202020696620285F746869732E6F7074696F6E732E636C69636B61626C6529207B0A202020202020696620285F746869732E6F7074696F6E732E636C69636B61626C65203D3D3D207472756529207B0A20202020';
wwv_flow_api.g_varchar2_table(446) := '202020205F746869732E636C69636B61626C65456C656D656E7473203D205B5F746869732E656C656D656E745D3B0A2020202020207D20656C7365207B0A20202020202020205F746869732E636C69636B61626C65456C656D656E7473203D2044726F70';
wwv_flow_api.g_varchar2_table(447) := '7A6F6E652E676574456C656D656E7473285F746869732E6F7074696F6E732E636C69636B61626C652C2022636C69636B61626C6522293B0A2020202020207D0A202020207D0A0A202020205F746869732E696E697428293B0A2020202072657475726E20';
wwv_flow_api.g_varchar2_table(448) := '5F746869733B0A20207D0A0A20202F2F2052657475726E7320616C6C2066696C657320746861742068617665206265656E2061636365707465640A0A0A20205F637265617465436C6173732844726F707A6F6E652C205B7B0A202020206B65793A202267';
wwv_flow_api.g_varchar2_table(449) := '6574416363657074656446696C6573222C0A2020202076616C75653A2066756E6374696F6E20676574416363657074656446696C65732829207B0A20202020202072657475726E20746869732E66696C65732E66696C7465722866756E6374696F6E2028';
wwv_flow_api.g_varchar2_table(450) := '66696C6529207B0A202020202020202072657475726E2066696C652E61636365707465643B0A2020202020207D292E6D61702866756E6374696F6E202866696C6529207B0A202020202020202072657475726E2066696C653B0A2020202020207D293B0A';
wwv_flow_api.g_varchar2_table(451) := '202020207D0A0A202020202F2F2052657475726E7320616C6C2066696C657320746861742068617665206265656E2072656A65637465640A202020202F2F204E6F742073757265207768656E2074686174277320676F696E6720746F2062652075736566';
wwv_flow_api.g_varchar2_table(452) := '756C2C2062757420616464656420666F7220636F6D706C6574656E6573732E0A0A20207D2C207B0A202020206B65793A202267657452656A656374656446696C6573222C0A2020202076616C75653A2066756E6374696F6E2067657452656A6563746564';
wwv_flow_api.g_varchar2_table(453) := '46696C65732829207B0A20202020202072657475726E20746869732E66696C65732E66696C7465722866756E6374696F6E202866696C6529207B0A202020202020202072657475726E202166696C652E61636365707465643B0A2020202020207D292E6D';
wwv_flow_api.g_varchar2_table(454) := '61702866756E6374696F6E202866696C6529207B0A202020202020202072657475726E2066696C653B0A2020202020207D293B0A202020207D0A20207D2C207B0A202020206B65793A202267657446696C657357697468537461747573222C0A20202020';
wwv_flow_api.g_varchar2_table(455) := '76616C75653A2066756E6374696F6E2067657446696C6573576974685374617475732873746174757329207B0A20202020202072657475726E20746869732E66696C65732E66696C7465722866756E6374696F6E202866696C6529207B0A202020202020';
wwv_flow_api.g_varchar2_table(456) := '202072657475726E2066696C652E737461747573203D3D3D207374617475733B0A2020202020207D292E6D61702866756E6374696F6E202866696C6529207B0A202020202020202072657475726E2066696C653B0A2020202020207D293B0A202020207D';
wwv_flow_api.g_varchar2_table(457) := '0A0A202020202F2F2052657475726E7320616C6C2066696C657320746861742061726520696E207468652071756575650A0A20207D2C207B0A202020206B65793A202267657451756575656446696C6573222C0A2020202076616C75653A2066756E6374';
wwv_flow_api.g_varchar2_table(458) := '696F6E2067657451756575656446696C65732829207B0A20202020202072657475726E20746869732E67657446696C6573576974685374617475732844726F707A6F6E652E515545554544293B0A202020207D0A20207D2C207B0A202020206B65793A20';
wwv_flow_api.g_varchar2_table(459) := '2267657455706C6F6164696E6746696C6573222C0A2020202076616C75653A2066756E6374696F6E2067657455706C6F6164696E6746696C65732829207B0A20202020202072657475726E20746869732E67657446696C65735769746853746174757328';
wwv_flow_api.g_varchar2_table(460) := '44726F707A6F6E652E55504C4F4144494E47293B0A202020207D0A20207D2C207B0A202020206B65793A2022676574416464656446696C6573222C0A2020202076616C75653A2066756E6374696F6E20676574416464656446696C65732829207B0A2020';
wwv_flow_api.g_varchar2_table(461) := '2020202072657475726E20746869732E67657446696C6573576974685374617475732844726F707A6F6E652E4144444544293B0A202020207D0A0A202020202F2F2046696C65732074686174206172652065697468657220717565756564206F72207570';
wwv_flow_api.g_varchar2_table(462) := '6C6F6164696E670A0A20207D2C207B0A202020206B65793A202267657441637469766546696C6573222C0A2020202076616C75653A2066756E6374696F6E2067657441637469766546696C65732829207B0A20202020202072657475726E20746869732E';
wwv_flow_api.g_varchar2_table(463) := '66696C65732E66696C7465722866756E6374696F6E202866696C6529207B0A202020202020202072657475726E2066696C652E737461747573203D3D3D2044726F707A6F6E652E55504C4F4144494E47207C7C2066696C652E737461747573203D3D3D20';
wwv_flow_api.g_varchar2_table(464) := '44726F707A6F6E652E5155455545443B0A2020202020207D292E6D61702866756E6374696F6E202866696C6529207B0A202020202020202072657475726E2066696C653B0A2020202020207D293B0A202020207D0A0A202020202F2F205468652066756E';
wwv_flow_api.g_varchar2_table(465) := '6374696F6E207468617420676574732063616C6C6564207768656E2044726F707A6F6E6520697320696E697469616C697A65642E20596F750A202020202F2F2063616E2028616E642073686F756C6429207365747570206576656E74206C697374656E65';
wwv_flow_api.g_varchar2_table(466) := '727320696E7369646520746869732066756E6374696F6E2E0A0A20207D2C207B0A202020206B65793A2022696E6974222C0A2020202076616C75653A2066756E6374696F6E20696E69742829207B0A202020202020766172205F7468697333203D207468';
wwv_flow_api.g_varchar2_table(467) := '69733B0A0A2020202020202F2F20496E20636173652069742069736E27742073657420616C72656164790A20202020202069662028746869732E656C656D656E742E7461674E616D65203D3D3D2022666F726D2229207B0A202020202020202074686973';
wwv_flow_api.g_varchar2_table(468) := '2E656C656D656E742E7365744174747269627574652822656E6374797065222C20226D756C7469706172742F666F726D2D6461746122293B0A2020202020207D0A0A20202020202069662028746869732E656C656D656E742E636C6173734C6973742E63';
wwv_flow_api.g_varchar2_table(469) := '6F6E7461696E73282264726F707A6F6E6522292026262021746869732E656C656D656E742E717565727953656C6563746F7228222E647A2D6D657373616765222929207B0A2020202020202020746869732E656C656D656E742E617070656E644368696C';
wwv_flow_api.g_varchar2_table(470) := '642844726F707A6F6E652E637265617465456C656D656E7428223C64697620636C6173733D5C22647A2D64656661756C7420647A2D6D6573736167655C223E3C7370616E3E22202B20746869732E6F7074696F6E732E6469637444656661756C744D6573';
wwv_flow_api.g_varchar2_table(471) := '73616765202B20223C2F7370616E3E3C2F6469763E2229293B0A2020202020207D0A0A20202020202069662028746869732E636C69636B61626C65456C656D656E74732E6C656E67746829207B0A20202020202020207661722073657475704869646465';
wwv_flow_api.g_varchar2_table(472) := '6E46696C65496E707574203D2066756E6374696F6E20736574757048696464656E46696C65496E7075742829207B0A20202020202020202020696620285F74686973332E68696464656E46696C65496E70757429207B0A2020202020202020202020205F';
wwv_flow_api.g_varchar2_table(473) := '74686973332E68696464656E46696C65496E7075742E706172656E744E6F64652E72656D6F76654368696C64285F74686973332E68696464656E46696C65496E707574293B0A202020202020202020207D0A202020202020202020205F74686973332E68';
wwv_flow_api.g_varchar2_table(474) := '696464656E46696C65496E707574203D20646F63756D656E742E637265617465456C656D656E742822696E70757422293B0A202020202020202020205F74686973332E68696464656E46696C65496E7075742E7365744174747269627574652822747970';
wwv_flow_api.g_varchar2_table(475) := '65222C202266696C6522293B0A20202020202020202020696620285F74686973332E6F7074696F6E732E6D617846696C6573203D3D3D206E756C6C207C7C205F74686973332E6F7074696F6E732E6D617846696C6573203E203129207B0A202020202020';
wwv_flow_api.g_varchar2_table(476) := '2020202020205F74686973332E68696464656E46696C65496E7075742E73657441747472696275746528226D756C7469706C65222C20226D756C7469706C6522293B0A202020202020202020207D0A202020202020202020205F74686973332E68696464';
wwv_flow_api.g_varchar2_table(477) := '656E46696C65496E7075742E636C6173734E616D65203D2022647A2D68696464656E2D696E707574223B0A0A20202020202020202020696620285F74686973332E6F7074696F6E732E616363657074656446696C657320213D3D206E756C6C29207B0A20';
wwv_flow_api.g_varchar2_table(478) := '20202020202020202020205F74686973332E68696464656E46696C65496E7075742E7365744174747269627574652822616363657074222C205F74686973332E6F7074696F6E732E616363657074656446696C6573293B0A202020202020202020207D0A';
wwv_flow_api.g_varchar2_table(479) := '20202020202020202020696620285F74686973332E6F7074696F6E732E6361707475726520213D3D206E756C6C29207B0A2020202020202020202020205F74686973332E68696464656E46696C65496E7075742E73657441747472696275746528226361';
wwv_flow_api.g_varchar2_table(480) := '7074757265222C205F74686973332E6F7074696F6E732E63617074757265293B0A202020202020202020207D0A0A202020202020202020202F2F204E6F742073657474696E672060646973706C61793D226E6F6E652260206265636175736520736F6D65';
wwv_flow_api.g_varchar2_table(481) := '2062726F777365727320646F6E27742061636365707420636C69636B730A202020202020202020202F2F206F6E20656C656D656E74732074686174206172656E277420646973706C617965642E0A202020202020202020205F74686973332E6869646465';
wwv_flow_api.g_varchar2_table(482) := '6E46696C65496E7075742E7374796C652E7669736962696C697479203D202268696464656E223B0A202020202020202020205F74686973332E68696464656E46696C65496E7075742E7374796C652E706F736974696F6E203D20226162736F6C75746522';
wwv_flow_api.g_varchar2_table(483) := '3B0A202020202020202020205F74686973332E68696464656E46696C65496E7075742E7374796C652E746F70203D202230223B0A202020202020202020205F74686973332E68696464656E46696C65496E7075742E7374796C652E6C656674203D202230';
wwv_flow_api.g_varchar2_table(484) := '223B0A202020202020202020205F74686973332E68696464656E46696C65496E7075742E7374796C652E686569676874203D202230223B0A202020202020202020205F74686973332E68696464656E46696C65496E7075742E7374796C652E7769647468';
wwv_flow_api.g_varchar2_table(485) := '203D202230223B0A2020202020202020202044726F707A6F6E652E676574456C656D656E74285F74686973332E6F7074696F6E732E68696464656E496E707574436F6E7461696E65722C202768696464656E496E707574436F6E7461696E657227292E61';
wwv_flow_api.g_varchar2_table(486) := '7070656E644368696C64285F74686973332E68696464656E46696C65496E707574293B0A2020202020202020202072657475726E205F74686973332E68696464656E46696C65496E7075742E6164644576656E744C697374656E657228226368616E6765';
wwv_flow_api.g_varchar2_table(487) := '222C2066756E6374696F6E202829207B0A2020202020202020202020207661722066696C6573203D205F74686973332E68696464656E46696C65496E7075742E66696C65733B0A0A2020202020202020202020206966202866696C65732E6C656E677468';
wwv_flow_api.g_varchar2_table(488) := '29207B0A2020202020202020202020202020666F722028766172205F6974657261746F723130203D2066696C65732C205F697341727261793130203D20747275652C205F693130203D20302C205F6974657261746F723130203D205F6973417272617931';
wwv_flow_api.g_varchar2_table(489) := '30203F205F6974657261746F723130203A205F6974657261746F7231305B53796D626F6C2E6974657261746F725D28293B3B29207B0A20202020202020202020202020202020766172205F726566393B0A0A202020202020202020202020202020206966';
wwv_flow_api.g_varchar2_table(490) := '20285F69734172726179313029207B0A202020202020202020202020202020202020696620285F693130203E3D205F6974657261746F7231302E6C656E6774682920627265616B3B0A2020202020202020202020202020202020205F72656639203D205F';
wwv_flow_api.g_varchar2_table(491) := '6974657261746F7231305B5F6931302B2B5D3B0A202020202020202020202020202020207D20656C7365207B0A2020202020202020202020202020202020205F693130203D205F6974657261746F7231302E6E65787428293B0A20202020202020202020';
wwv_flow_api.g_varchar2_table(492) := '2020202020202020696620285F6931302E646F6E652920627265616B3B0A2020202020202020202020202020202020205F72656639203D205F6931302E76616C75653B0A202020202020202020202020202020207D0A0A20202020202020202020202020';
wwv_flow_api.g_varchar2_table(493) := '2020207661722066696C65203D205F726566393B0A0A202020202020202020202020202020205F74686973332E61646446696C652866696C65293B0A20202020202020202020202020207D0A2020202020202020202020207D0A20202020202020202020';
wwv_flow_api.g_varchar2_table(494) := '20205F74686973332E656D69742822616464656466696C6573222C2066696C6573293B0A20202020202020202020202072657475726E20736574757048696464656E46696C65496E70757428293B0A202020202020202020207D293B0A20202020202020';
wwv_flow_api.g_varchar2_table(495) := '207D3B0A2020202020202020736574757048696464656E46696C65496E70757428293B0A2020202020207D0A0A202020202020746869732E55524C203D2077696E646F772E55524C20213D3D206E756C6C203F2077696E646F772E55524C203A2077696E';
wwv_flow_api.g_varchar2_table(496) := '646F772E7765626B697455524C3B0A0A2020202020202F2F20536574757020616C6C206576656E74206C697374656E657273206F6E207468652044726F707A6F6E65206F626A65637420697473656C662E0A2020202020202F2F2054686579277265206E';
wwv_flow_api.g_varchar2_table(497) := '6F7420696E204073657475704576656E744C697374656E6572732829206265636175736520746865792073686F756C646E27742062652072656D6F7665640A2020202020202F2F20616761696E207768656E207468652064726F707A6F6E652067657473';
wwv_flow_api.g_varchar2_table(498) := '2064697361626C65642E0A202020202020666F722028766172205F6974657261746F723131203D20746869732E6576656E74732C205F697341727261793131203D20747275652C205F693131203D20302C205F6974657261746F723131203D205F697341';
wwv_flow_api.g_varchar2_table(499) := '727261793131203F205F6974657261746F723131203A205F6974657261746F7231315B53796D626F6C2E6974657261746F725D28293B3B29207B0A2020202020202020766172205F72656631303B0A0A2020202020202020696620285F69734172726179';
wwv_flow_api.g_varchar2_table(500) := '313129207B0A20202020202020202020696620285F693131203E3D205F6974657261746F7231312E6C656E6774682920627265616B3B0A202020202020202020205F7265663130203D205F6974657261746F7231315B5F6931312B2B5D3B0A2020202020';
wwv_flow_api.g_varchar2_table(501) := '2020207D20656C7365207B0A202020202020202020205F693131203D205F6974657261746F7231312E6E65787428293B0A20202020202020202020696620285F6931312E646F6E652920627265616B3B0A202020202020202020205F7265663130203D20';
wwv_flow_api.g_varchar2_table(502) := '5F6931312E76616C75653B0A20202020202020207D0A0A2020202020202020766172206576656E744E616D65203D205F72656631303B0A0A2020202020202020746869732E6F6E286576656E744E616D652C20746869732E6F7074696F6E735B6576656E';
wwv_flow_api.g_varchar2_table(503) := '744E616D655D293B0A2020202020207D0A0A202020202020746869732E6F6E282275706C6F616470726F6772657373222C2066756E6374696F6E202829207B0A202020202020202072657475726E205F74686973332E757064617465546F74616C55706C';
wwv_flow_api.g_varchar2_table(504) := '6F616450726F677265737328293B0A2020202020207D293B0A0A202020202020746869732E6F6E282272656D6F76656466696C65222C2066756E6374696F6E202829207B0A202020202020202072657475726E205F74686973332E757064617465546F74';
wwv_flow_api.g_varchar2_table(505) := '616C55706C6F616450726F677265737328293B0A2020202020207D293B0A0A202020202020746869732E6F6E282263616E63656C6564222C2066756E6374696F6E202866696C6529207B0A202020202020202072657475726E205F74686973332E656D69';
wwv_flow_api.g_varchar2_table(506) := '742822636F6D706C657465222C2066696C65293B0A2020202020207D293B0A0A2020202020202F2F20456D6974206120607175657565636F6D706C65746560206576656E7420696620616C6C2066696C65732066696E69736865642075706C6F6164696E';
wwv_flow_api.g_varchar2_table(507) := '672E0A202020202020746869732E6F6E2822636F6D706C657465222C2066756E6374696F6E202866696C6529207B0A2020202020202020696620285F74686973332E676574416464656446696C657328292E6C656E677468203D3D3D2030202626205F74';
wwv_flow_api.g_varchar2_table(508) := '686973332E67657455706C6F6164696E6746696C657328292E6C656E677468203D3D3D2030202626205F74686973332E67657451756575656446696C657328292E6C656E677468203D3D3D203029207B0A202020202020202020202F2F2054686973206E';
wwv_flow_api.g_varchar2_table(509) := '6565647320746F20626520646566657272656420736F207468617420607175657565636F6D706C65746560207265616C6C792074726967676572732061667465722060636F6D706C657465600A2020202020202020202072657475726E2073657454696D';
wwv_flow_api.g_varchar2_table(510) := '656F75742866756E6374696F6E202829207B0A20202020202020202020202072657475726E205F74686973332E656D697428227175657565636F6D706C65746522293B0A202020202020202020207D2C2030293B0A20202020202020207D0A2020202020';
wwv_flow_api.g_varchar2_table(511) := '207D293B0A0A202020202020766172206E6F50726F7061676174696F6E203D2066756E6374696F6E206E6F50726F7061676174696F6E286529207B0A2020202020202020652E73746F7050726F7061676174696F6E28293B0A2020202020202020696620';
wwv_flow_api.g_varchar2_table(512) := '28652E70726576656E7444656661756C7429207B0A2020202020202020202072657475726E20652E70726576656E7444656661756C7428293B0A20202020202020207D20656C7365207B0A2020202020202020202072657475726E20652E72657475726E';
wwv_flow_api.g_varchar2_table(513) := '56616C7565203D2066616C73653B0A20202020202020207D0A2020202020207D3B0A0A2020202020202F2F2043726561746520746865206C697374656E6572730A202020202020746869732E6C697374656E657273203D205B7B0A202020202020202065';
wwv_flow_api.g_varchar2_table(514) := '6C656D656E743A20746869732E656C656D656E742C0A20202020202020206576656E74733A207B0A2020202020202020202022647261677374617274223A2066756E6374696F6E20647261677374617274286529207B0A20202020202020202020202072';
wwv_flow_api.g_varchar2_table(515) := '657475726E205F74686973332E656D69742822647261677374617274222C2065293B0A202020202020202020207D2C0A202020202020202020202264726167656E746572223A2066756E6374696F6E2064726167656E746572286529207B0A2020202020';
wwv_flow_api.g_varchar2_table(516) := '202020202020206E6F50726F7061676174696F6E2865293B0A20202020202020202020202072657475726E205F74686973332E656D6974282264726167656E746572222C2065293B0A202020202020202020207D2C0A2020202020202020202022647261';
wwv_flow_api.g_varchar2_table(517) := '676F766572223A2066756E6374696F6E20647261676F766572286529207B0A2020202020202020202020202F2F204D616B657320697420706F737369626C6520746F20647261672066696C65732066726F6D206368726F6D65277320646F776E6C6F6164';
wwv_flow_api.g_varchar2_table(518) := '206261720A2020202020202020202020202F2F20687474703A2F2F737461636B6F766572666C6F772E636F6D2F7175657374696F6E732F31393532363433302F647261672D616E642D64726F702D66696C652D75706C6F6164732D66726F6D2D6368726F';
wwv_flow_api.g_varchar2_table(519) := '6D652D646F776E6C6F6164732D6261720A2020202020202020202020202F2F2054727920697320726571756972656420746F2070726576656E742062756720696E20496E7465726E6574204578706C6F7265722031312028534352495054363535333520';
wwv_flow_api.g_varchar2_table(520) := '657863657074696F6E290A2020202020202020202020207661722065666374203D20766F696420303B0A202020202020202020202020747279207B0A202020202020202020202020202065666374203D20652E646174615472616E736665722E65666665';
wwv_flow_api.g_varchar2_table(521) := '6374416C6C6F7765643B0A2020202020202020202020207D20636174636820286572726F7229207B7D0A202020202020202020202020652E646174615472616E736665722E64726F70456666656374203D20276D6F766527203D3D3D2065666374207C7C';
wwv_flow_api.g_varchar2_table(522) := '20276C696E6B4D6F766527203D3D3D2065666374203F20276D6F766527203A2027636F7079273B0A0A2020202020202020202020206E6F50726F7061676174696F6E2865293B0A20202020202020202020202072657475726E205F74686973332E656D69';
wwv_flow_api.g_varchar2_table(523) := '742822647261676F766572222C2065293B0A202020202020202020207D2C0A2020202020202020202022647261676C65617665223A2066756E6374696F6E20647261676C65617665286529207B0A20202020202020202020202072657475726E205F7468';
wwv_flow_api.g_varchar2_table(524) := '6973332E656D69742822647261676C65617665222C2065293B0A202020202020202020207D2C0A202020202020202020202264726F70223A2066756E6374696F6E2064726F70286529207B0A2020202020202020202020206E6F50726F7061676174696F';
wwv_flow_api.g_varchar2_table(525) := '6E2865293B0A20202020202020202020202072657475726E205F74686973332E64726F702865293B0A202020202020202020207D2C0A202020202020202020202264726167656E64223A2066756E6374696F6E2064726167656E64286529207B0A202020';
wwv_flow_api.g_varchar2_table(526) := '20202020202020202072657475726E205F74686973332E656D6974282264726167656E64222C2065293B0A202020202020202020207D0A0A202020202020202020202F2F20546869732069732064697361626C6564207269676874206E6F772C20626563';
wwv_flow_api.g_varchar2_table(527) := '61757365207468652062726F777365727320646F6E277420696D706C656D656E742069742070726F7065726C792E0A202020202020202020202F2F20227061737465223A20286529203D3E0A202020202020202020202F2F2020206E6F50726F70616761';
wwv_flow_api.g_varchar2_table(528) := '74696F6E20650A202020202020202020202F2F20202040706173746520650A20202020202020207D207D5D3B0A0A202020202020746869732E636C69636B61626C65456C656D656E74732E666F72456163682866756E6374696F6E2028636C69636B6162';
wwv_flow_api.g_varchar2_table(529) := '6C65456C656D656E7429207B0A202020202020202072657475726E205F74686973332E6C697374656E6572732E70757368287B0A20202020202020202020656C656D656E743A20636C69636B61626C65456C656D656E742C0A2020202020202020202065';
wwv_flow_api.g_varchar2_table(530) := '76656E74733A207B0A20202020202020202020202022636C69636B223A2066756E6374696F6E20636C69636B2865767429207B0A20202020202020202020202020202F2F204F6E6C79207468652061637475616C2064726F707A6F6E65206F7220746865';
wwv_flow_api.g_varchar2_table(531) := '206D65737361676520656C656D656E742073686F756C6420747269676765722066696C652073656C656374696F6E0A202020202020202020202020202069662028636C69636B61626C65456C656D656E7420213D3D205F74686973332E656C656D656E74';
wwv_flow_api.g_varchar2_table(532) := '207C7C206576742E746172676574203D3D3D205F74686973332E656C656D656E74207C7C2044726F707A6F6E652E656C656D656E74496E73696465286576742E7461726765742C205F74686973332E656C656D656E742E717565727953656C6563746F72';
wwv_flow_api.g_varchar2_table(533) := '28222E647A2D6D65737361676522292929207B0A202020202020202020202020202020205F74686973332E68696464656E46696C65496E7075742E636C69636B28293B202F2F20466F72776172642074686520636C69636B0A2020202020202020202020';
wwv_flow_api.g_varchar2_table(534) := '2020207D0A202020202020202020202020202072657475726E20747275653B0A2020202020202020202020207D0A202020202020202020207D0A20202020202020207D293B0A2020202020207D293B0A0A202020202020746869732E656E61626C652829';
wwv_flow_api.g_varchar2_table(535) := '3B0A0A20202020202072657475726E20746869732E6F7074696F6E732E696E69742E63616C6C2874686973293B0A202020207D0A0A202020202F2F204E6F742066756C6C7920746573746564207965740A0A20207D2C207B0A202020206B65793A202264';
wwv_flow_api.g_varchar2_table(536) := '657374726F79222C0A2020202076616C75653A2066756E6374696F6E2064657374726F792829207B0A202020202020746869732E64697361626C6528293B0A202020202020746869732E72656D6F7665416C6C46696C65732874727565293B0A20202020';
wwv_flow_api.g_varchar2_table(537) := '202069662028746869732E68696464656E46696C65496E70757420213D206E756C6C203F20746869732E68696464656E46696C65496E7075742E706172656E744E6F6465203A20756E646566696E656429207B0A2020202020202020746869732E686964';
wwv_flow_api.g_varchar2_table(538) := '64656E46696C65496E7075742E706172656E744E6F64652E72656D6F76654368696C6428746869732E68696464656E46696C65496E707574293B0A2020202020202020746869732E68696464656E46696C65496E707574203D206E756C6C3B0A20202020';
wwv_flow_api.g_varchar2_table(539) := '20207D0A20202020202064656C65746520746869732E656C656D656E742E64726F707A6F6E653B0A20202020202072657475726E2044726F707A6F6E652E696E7374616E6365732E73706C6963652844726F707A6F6E652E696E7374616E6365732E696E';
wwv_flow_api.g_varchar2_table(540) := '6465784F662874686973292C2031293B0A202020207D0A20207D2C207B0A202020206B65793A2022757064617465546F74616C55706C6F616450726F6772657373222C0A2020202076616C75653A2066756E6374696F6E20757064617465546F74616C55';
wwv_flow_api.g_varchar2_table(541) := '706C6F616450726F67726573732829207B0A20202020202076617220746F74616C55706C6F616450726F6772657373203D20766F696420303B0A20202020202076617220746F74616C427974657353656E74203D20303B0A20202020202076617220746F';
wwv_flow_api.g_varchar2_table(542) := '74616C4279746573203D20303B0A0A2020202020207661722061637469766546696C6573203D20746869732E67657441637469766546696C657328293B0A0A2020202020206966202861637469766546696C65732E6C656E67746829207B0A2020202020';
wwv_flow_api.g_varchar2_table(543) := '202020666F722028766172205F6974657261746F723132203D20746869732E67657441637469766546696C657328292C205F697341727261793132203D20747275652C205F693132203D20302C205F6974657261746F723132203D205F69734172726179';
wwv_flow_api.g_varchar2_table(544) := '3132203F205F6974657261746F723132203A205F6974657261746F7231325B53796D626F6C2E6974657261746F725D28293B3B29207B0A20202020202020202020766172205F72656631313B0A0A20202020202020202020696620285F69734172726179';
wwv_flow_api.g_varchar2_table(545) := '313229207B0A202020202020202020202020696620285F693132203E3D205F6974657261746F7231322E6C656E6774682920627265616B3B0A2020202020202020202020205F7265663131203D205F6974657261746F7231325B5F6931322B2B5D3B0A20';
wwv_flow_api.g_varchar2_table(546) := '2020202020202020207D20656C7365207B0A2020202020202020202020205F693132203D205F6974657261746F7231322E6E65787428293B0A202020202020202020202020696620285F6931322E646F6E652920627265616B3B0A202020202020202020';
wwv_flow_api.g_varchar2_table(547) := '2020205F7265663131203D205F6931322E76616C75653B0A202020202020202020207D0A0A202020202020202020207661722066696C65203D205F72656631313B0A0A20202020202020202020746F74616C427974657353656E74202B3D2066696C652E';
wwv_flow_api.g_varchar2_table(548) := '75706C6F61642E627974657353656E743B0A20202020202020202020746F74616C4279746573202B3D2066696C652E75706C6F61642E746F74616C3B0A20202020202020207D0A2020202020202020746F74616C55706C6F616450726F6772657373203D';
wwv_flow_api.g_varchar2_table(549) := '20313030202A20746F74616C427974657353656E74202F20746F74616C42797465733B0A2020202020207D20656C7365207B0A2020202020202020746F74616C55706C6F616450726F6772657373203D203130303B0A2020202020207D0A0A2020202020';
wwv_flow_api.g_varchar2_table(550) := '2072657475726E20746869732E656D69742822746F74616C75706C6F616470726F6772657373222C20746F74616C55706C6F616450726F67726573732C20746F74616C42797465732C20746F74616C427974657353656E74293B0A202020207D0A0A2020';
wwv_flow_api.g_varchar2_table(551) := '20202F2F20406F7074696F6E732E706172616D4E616D652063616E20626520612066756E6374696F6E2074616B696E67206F6E6520706172616D6574657220726174686572207468616E206120737472696E672E0A202020202F2F204120706172616D65';
wwv_flow_api.g_varchar2_table(552) := '746572206E616D6520666F7220612066696C65206973206F627461696E65642073696D706C792062792063616C6C696E672074686973207769746820616E20696E646578206E756D6265722E0A0A20207D2C207B0A202020206B65793A20225F67657450';
wwv_flow_api.g_varchar2_table(553) := '6172616D4E616D65222C0A2020202076616C75653A2066756E6374696F6E205F676574506172616D4E616D65286E29207B0A20202020202069662028747970656F6620746869732E6F7074696F6E732E706172616D4E616D65203D3D3D202266756E6374';
wwv_flow_api.g_varchar2_table(554) := '696F6E2229207B0A202020202020202072657475726E20746869732E6F7074696F6E732E706172616D4E616D65286E293B0A2020202020207D20656C7365207B0A202020202020202072657475726E202222202B20746869732E6F7074696F6E732E7061';
wwv_flow_api.g_varchar2_table(555) := '72616D4E616D65202B2028746869732E6F7074696F6E732E75706C6F61644D756C7469706C65203F20225B22202B206E202B20225D22203A202222293B0A2020202020207D0A202020207D0A0A202020202F2F20496620406F7074696F6E732E72656E61';
wwv_flow_api.g_varchar2_table(556) := '6D6546696C6520697320612066756E6374696F6E2C0A202020202F2F207468652066756E6374696F6E2077696C6C206265207573656420746F2072656E616D65207468652066696C652E6E616D65206265666F726520617070656E64696E672069742074';
wwv_flow_api.g_varchar2_table(557) := '6F2074686520666F726D446174610A0A20207D2C207B0A202020206B65793A20225F72656E616D6546696C65222C0A2020202076616C75653A2066756E6374696F6E205F72656E616D6546696C652866696C6529207B0A20202020202069662028747970';
wwv_flow_api.g_varchar2_table(558) := '656F6620746869732E6F7074696F6E732E72656E616D6546696C6520213D3D202266756E6374696F6E2229207B0A202020202020202072657475726E2066696C652E6E616D653B0A2020202020207D0A20202020202072657475726E20746869732E6F70';
wwv_flow_api.g_varchar2_table(559) := '74696F6E732E72656E616D6546696C652866696C65293B0A202020207D0A0A202020202F2F2052657475726E73206120666F726D20746861742063616E20626520757365642061732066616C6C6261636B206966207468652062726F7773657220646F65';
wwv_flow_api.g_varchar2_table(560) := '73206E6F7420737570706F727420447261676E44726F700A202020202F2F0A202020202F2F204966207468652064726F707A6F6E6520697320616C7265616479206120666F726D2C206F6E6C792074686520696E707574206669656C6420616E64206275';
wwv_flow_api.g_varchar2_table(561) := '74746F6E206172652072657475726E65642E204F7468657277697365206120636F6D706C65746520666F726D20656C656D656E742069732070726F76696465642E0A202020202F2F205468697320636F64652068617320746F207061737320696E204945';
wwv_flow_api.g_varchar2_table(562) := '37203A280A0A20207D2C207B0A202020206B65793A202267657446616C6C6261636B466F726D222C0A2020202076616C75653A2066756E6374696F6E2067657446616C6C6261636B466F726D2829207B0A202020202020766172206578697374696E6746';
wwv_flow_api.g_varchar2_table(563) := '616C6C6261636B203D20766F696420302C0A20202020202020202020666F726D203D20766F696420303B0A202020202020696620286578697374696E6746616C6C6261636B203D20746869732E6765744578697374696E6746616C6C6261636B28292920';
wwv_flow_api.g_varchar2_table(564) := '7B0A202020202020202072657475726E206578697374696E6746616C6C6261636B3B0A2020202020207D0A0A202020202020766172206669656C6473537472696E67203D20223C64697620636C6173733D5C22647A2D66616C6C6261636B5C223E223B0A';
wwv_flow_api.g_varchar2_table(565) := '20202020202069662028746869732E6F7074696F6E732E6469637446616C6C6261636B5465787429207B0A20202020202020206669656C6473537472696E67202B3D20223C703E22202B20746869732E6F7074696F6E732E6469637446616C6C6261636B';
wwv_flow_api.g_varchar2_table(566) := '54657874202B20223C2F703E223B0A2020202020207D0A2020202020206669656C6473537472696E67202B3D20223C696E70757420747970653D5C2266696C655C22206E616D653D5C2222202B20746869732E5F676574506172616D4E616D6528302920';
wwv_flow_api.g_varchar2_table(567) := '2B20225C222022202B2028746869732E6F7074696F6E732E75706C6F61644D756C7469706C65203F20276D756C7469706C653D226D756C7469706C652227203A20756E646566696E656429202B2022202F3E3C696E70757420747970653D5C227375626D';
wwv_flow_api.g_varchar2_table(568) := '69745C222076616C75653D5C2255706C6F6164215C223E3C2F6469763E223B0A0A202020202020766172206669656C6473203D2044726F707A6F6E652E637265617465456C656D656E74286669656C6473537472696E67293B0A20202020202069662028';
wwv_flow_api.g_varchar2_table(569) := '746869732E656C656D656E742E7461674E616D6520213D3D2022464F524D2229207B0A2020202020202020666F726D203D2044726F707A6F6E652E637265617465456C656D656E7428223C666F726D20616374696F6E3D5C2222202B20746869732E6F70';
wwv_flow_api.g_varchar2_table(570) := '74696F6E732E75726C202B20225C2220656E63747970653D5C226D756C7469706172742F666F726D2D646174615C22206D6574686F643D5C2222202B20746869732E6F7074696F6E732E6D6574686F64202B20225C223E3C2F666F726D3E22293B0A2020';
wwv_flow_api.g_varchar2_table(571) := '202020202020666F726D2E617070656E644368696C64286669656C6473293B0A2020202020207D20656C7365207B0A20202020202020202F2F204D616B65207375726520746861742074686520656E637479706520616E64206D6574686F642061747472';
wwv_flow_api.g_varchar2_table(572) := '69627574657320617265207365742070726F7065726C790A2020202020202020746869732E656C656D656E742E7365744174747269627574652822656E6374797065222C20226D756C7469706172742F666F726D2D6461746122293B0A20202020202020';
wwv_flow_api.g_varchar2_table(573) := '20746869732E656C656D656E742E73657441747472696275746528226D6574686F64222C20746869732E6F7074696F6E732E6D6574686F64293B0A2020202020207D0A20202020202072657475726E20666F726D20213D206E756C6C203F20666F726D20';
wwv_flow_api.g_varchar2_table(574) := '3A206669656C64733B0A202020207D0A0A202020202F2F2052657475726E73207468652066616C6C6261636B20656C656D656E7473206966207468657920657869737420616C72656164790A202020202F2F0A202020202F2F205468697320636F646520';
wwv_flow_api.g_varchar2_table(575) := '68617320746F207061737320696E20494537203A280A0A20207D2C207B0A202020206B65793A20226765744578697374696E6746616C6C6261636B222C0A2020202076616C75653A2066756E6374696F6E206765744578697374696E6746616C6C626163';
wwv_flow_api.g_varchar2_table(576) := '6B2829207B0A2020202020207661722067657446616C6C6261636B203D2066756E6374696F6E2067657446616C6C6261636B28656C656D656E747329207B0A2020202020202020666F722028766172205F6974657261746F723133203D20656C656D656E';
wwv_flow_api.g_varchar2_table(577) := '74732C205F697341727261793133203D20747275652C205F693133203D20302C205F6974657261746F723133203D205F697341727261793133203F205F6974657261746F723133203A205F6974657261746F7231335B53796D626F6C2E6974657261746F';
wwv_flow_api.g_varchar2_table(578) := '725D28293B3B29207B0A20202020202020202020766172205F72656631323B0A0A20202020202020202020696620285F69734172726179313329207B0A202020202020202020202020696620285F693133203E3D205F6974657261746F7231332E6C656E';
wwv_flow_api.g_varchar2_table(579) := '6774682920627265616B3B0A2020202020202020202020205F7265663132203D205F6974657261746F7231335B5F6931332B2B5D3B0A202020202020202020207D20656C7365207B0A2020202020202020202020205F693133203D205F6974657261746F';
wwv_flow_api.g_varchar2_table(580) := '7231332E6E65787428293B0A202020202020202020202020696620285F6931332E646F6E652920627265616B3B0A2020202020202020202020205F7265663132203D205F6931332E76616C75653B0A202020202020202020207D0A0A2020202020202020';
wwv_flow_api.g_varchar2_table(581) := '202076617220656C203D205F72656631323B0A0A20202020202020202020696620282F285E7C202966616C6C6261636B28247C20292F2E7465737428656C2E636C6173734E616D652929207B0A20202020202020202020202072657475726E20656C3B0A';
wwv_flow_api.g_varchar2_table(582) := '202020202020202020207D0A20202020202020207D0A2020202020207D3B0A0A202020202020766172205F617272203D205B22646976222C2022666F726D225D3B0A202020202020666F722028766172205F693134203D20303B205F693134203C205F61';
wwv_flow_api.g_varchar2_table(583) := '72722E6C656E6774683B205F6931342B2B29207B0A2020202020202020766172207461674E616D65203D205F6172725B5F6931345D3B0A20202020202020207661722066616C6C6261636B3B0A20202020202020206966202866616C6C6261636B203D20';
wwv_flow_api.g_varchar2_table(584) := '67657446616C6C6261636B28746869732E656C656D656E742E676574456C656D656E747342795461674E616D65287461674E616D65292929207B0A2020202020202020202072657475726E2066616C6C6261636B3B0A20202020202020207D0A20202020';
wwv_flow_api.g_varchar2_table(585) := '20207D0A202020207D0A0A202020202F2F2041637469766174657320616C6C206C697374656E6572732073746F72656420696E20406C697374656E6572730A0A20207D2C207B0A202020206B65793A202273657475704576656E744C697374656E657273';
wwv_flow_api.g_varchar2_table(586) := '222C0A2020202076616C75653A2066756E6374696F6E2073657475704576656E744C697374656E6572732829207B0A20202020202072657475726E20746869732E6C697374656E6572732E6D61702866756E6374696F6E2028656C656D656E744C697374';
wwv_flow_api.g_varchar2_table(587) := '656E65727329207B0A202020202020202072657475726E2066756E6374696F6E202829207B0A2020202020202020202076617220726573756C74203D205B5D3B0A20202020202020202020666F722028766172206576656E7420696E20656C656D656E74';
wwv_flow_api.g_varchar2_table(588) := '4C697374656E6572732E6576656E747329207B0A202020202020202020202020766172206C697374656E6572203D20656C656D656E744C697374656E6572732E6576656E74735B6576656E745D3B0A202020202020202020202020726573756C742E7075';
wwv_flow_api.g_varchar2_table(589) := '736828656C656D656E744C697374656E6572732E656C656D656E742E6164644576656E744C697374656E6572286576656E742C206C697374656E65722C2066616C736529293B0A202020202020202020207D0A2020202020202020202072657475726E20';
wwv_flow_api.g_varchar2_table(590) := '726573756C743B0A20202020202020207D28293B0A2020202020207D293B0A202020207D0A0A202020202F2F20446561637469766174657320616C6C206C697374656E6572732073746F72656420696E20406C697374656E6572730A0A20207D2C207B0A';
wwv_flow_api.g_varchar2_table(591) := '202020206B65793A202272656D6F76654576656E744C697374656E657273222C0A2020202076616C75653A2066756E6374696F6E2072656D6F76654576656E744C697374656E6572732829207B0A20202020202072657475726E20746869732E6C697374';
wwv_flow_api.g_varchar2_table(592) := '656E6572732E6D61702866756E6374696F6E2028656C656D656E744C697374656E65727329207B0A202020202020202072657475726E2066756E6374696F6E202829207B0A2020202020202020202076617220726573756C74203D205B5D3B0A20202020';
wwv_flow_api.g_varchar2_table(593) := '202020202020666F722028766172206576656E7420696E20656C656D656E744C697374656E6572732E6576656E747329207B0A202020202020202020202020766172206C697374656E6572203D20656C656D656E744C697374656E6572732E6576656E74';
wwv_flow_api.g_varchar2_table(594) := '735B6576656E745D3B0A202020202020202020202020726573756C742E7075736828656C656D656E744C697374656E6572732E656C656D656E742E72656D6F76654576656E744C697374656E6572286576656E742C206C697374656E65722C2066616C73';
wwv_flow_api.g_varchar2_table(595) := '6529293B0A202020202020202020207D0A2020202020202020202072657475726E20726573756C743B0A20202020202020207D28293B0A2020202020207D293B0A202020207D0A0A202020202F2F2052656D6F76657320616C6C206576656E74206C6973';
wwv_flow_api.g_varchar2_table(596) := '74656E65727320616E642063616E63656C7320616C6C2066696C657320696E20746865207175657565206F72206265696E672070726F6365737365642E0A0A20207D2C207B0A202020206B65793A202264697361626C65222C0A2020202076616C75653A';
wwv_flow_api.g_varchar2_table(597) := '2066756E6374696F6E2064697361626C652829207B0A202020202020766172205F7468697334203D20746869733B0A0A202020202020746869732E636C69636B61626C65456C656D656E74732E666F72456163682866756E6374696F6E2028656C656D65';
wwv_flow_api.g_varchar2_table(598) := '6E7429207B0A202020202020202072657475726E20656C656D656E742E636C6173734C6973742E72656D6F76652822647A2D636C69636B61626C6522293B0A2020202020207D293B0A202020202020746869732E72656D6F76654576656E744C69737465';
wwv_flow_api.g_varchar2_table(599) := '6E65727328293B0A202020202020746869732E64697361626C6564203D20747275653B0A0A20202020202072657475726E20746869732E66696C65732E6D61702866756E6374696F6E202866696C6529207B0A202020202020202072657475726E205F74';
wwv_flow_api.g_varchar2_table(600) := '686973342E63616E63656C55706C6F61642866696C65293B0A2020202020207D293B0A202020207D0A20207D2C207B0A202020206B65793A2022656E61626C65222C0A2020202076616C75653A2066756E6374696F6E20656E61626C652829207B0A2020';
wwv_flow_api.g_varchar2_table(601) := '2020202064656C65746520746869732E64697361626C65643B0A202020202020746869732E636C69636B61626C65456C656D656E74732E666F72456163682866756E6374696F6E2028656C656D656E7429207B0A202020202020202072657475726E2065';
wwv_flow_api.g_varchar2_table(602) := '6C656D656E742E636C6173734C6973742E6164642822647A2D636C69636B61626C6522293B0A2020202020207D293B0A20202020202072657475726E20746869732E73657475704576656E744C697374656E65727328293B0A202020207D0A0A20202020';
wwv_flow_api.g_varchar2_table(603) := '2F2F2052657475726E732061206E6963656C7920666F726D61747465642066696C6573697A650A0A20207D2C207B0A202020206B65793A202266696C6573697A65222C0A2020202076616C75653A2066756E6374696F6E2066696C6573697A652873697A';
wwv_flow_api.g_varchar2_table(604) := '6529207B0A2020202020207661722073656C656374656453697A65203D20303B0A2020202020207661722073656C6563746564556E6974203D202262223B0A0A2020202020206966202873697A65203E203029207B0A202020202020202076617220756E';
wwv_flow_api.g_varchar2_table(605) := '697473203D205B277462272C20276762272C20276D62272C20276B62272C202762275D3B0A0A2020202020202020666F7220287661722069203D20303B2069203C20756E6974732E6C656E6774683B20692B2B29207B0A20202020202020202020766172';
wwv_flow_api.g_varchar2_table(606) := '20756E6974203D20756E6974735B695D3B0A20202020202020202020766172206375746F6666203D204D6174682E706F7728746869732E6F7074696F6E732E66696C6573697A65426173652C2034202D206929202F2031303B0A0A202020202020202020';
wwv_flow_api.g_varchar2_table(607) := '206966202873697A65203E3D206375746F666629207B0A20202020202020202020202073656C656374656453697A65203D2073697A65202F204D6174682E706F7728746869732E6F7074696F6E732E66696C6573697A65426173652C2034202D2069293B';
wwv_flow_api.g_varchar2_table(608) := '0A20202020202020202020202073656C6563746564556E6974203D20756E69743B0A202020202020202020202020627265616B3B0A202020202020202020207D0A20202020202020207D0A0A202020202020202073656C656374656453697A65203D204D';
wwv_flow_api.g_varchar2_table(609) := '6174682E726F756E64283130202A2073656C656374656453697A6529202F2031303B202F2F2043757474696E67206F66206469676974730A2020202020207D0A0A20202020202072657475726E20223C7374726F6E673E22202B2073656C656374656453';
wwv_flow_api.g_varchar2_table(610) := '697A65202B20223C2F7374726F6E673E2022202B20746869732E6F7074696F6E732E6469637446696C6553697A65556E6974735B73656C6563746564556E69745D3B0A202020207D0A0A202020202F2F2041646473206F722072656D6F76657320746865';
wwv_flow_api.g_varchar2_table(611) := '2060647A2D6D61782D66696C65732D726561636865646020636C6173732066726F6D2074686520666F726D2E0A0A20207D2C207B0A202020206B65793A20225F7570646174654D617846696C657352656163686564436C617373222C0A2020202076616C';
wwv_flow_api.g_varchar2_table(612) := '75653A2066756E6374696F6E205F7570646174654D617846696C657352656163686564436C6173732829207B0A20202020202069662028746869732E6F7074696F6E732E6D617846696C657320213D206E756C6C20262620746869732E67657441636365';
wwv_flow_api.g_varchar2_table(613) := '7074656446696C657328292E6C656E677468203E3D20746869732E6F7074696F6E732E6D617846696C657329207B0A202020202020202069662028746869732E676574416363657074656446696C657328292E6C656E677468203D3D3D20746869732E6F';
wwv_flow_api.g_varchar2_table(614) := '7074696F6E732E6D617846696C657329207B0A20202020202020202020746869732E656D697428276D617866696C657372656163686564272C20746869732E66696C6573293B0A20202020202020207D0A202020202020202072657475726E2074686973';
wwv_flow_api.g_varchar2_table(615) := '2E656C656D656E742E636C6173734C6973742E6164642822647A2D6D61782D66696C65732D7265616368656422293B0A2020202020207D20656C7365207B0A202020202020202072657475726E20746869732E656C656D656E742E636C6173734C697374';
wwv_flow_api.g_varchar2_table(616) := '2E72656D6F76652822647A2D6D61782D66696C65732D7265616368656422293B0A2020202020207D0A202020207D0A20207D2C207B0A202020206B65793A202264726F70222C0A2020202076616C75653A2066756E6374696F6E2064726F70286529207B';
wwv_flow_api.g_varchar2_table(617) := '0A2020202020206966202821652E646174615472616E7366657229207B0A202020202020202072657475726E3B0A2020202020207D0A202020202020746869732E656D6974282264726F70222C2065293B0A0A2020202020202F2F20436F6E7665727420';
wwv_flow_api.g_varchar2_table(618) := '7468652046696C654C69737420746F20616E2041727261790A2020202020202F2F2054686973206973206E656365737361727920666F7220494531310A2020202020207661722066696C6573203D205B5D3B0A202020202020666F722028766172206920';
wwv_flow_api.g_varchar2_table(619) := '3D20303B2069203C20652E646174615472616E736665722E66696C65732E6C656E6774683B20692B2B29207B0A202020202020202066696C65735B695D203D20652E646174615472616E736665722E66696C65735B695D3B0A2020202020207D0A0A2020';
wwv_flow_api.g_varchar2_table(620) := '20202020746869732E656D69742822616464656466696C6573222C2066696C6573293B0A0A2020202020202F2F204576656E2069662069742773206120666F6C6465722C2066696C65732E6C656E6774682077696C6C20636F6E7461696E207468652066';
wwv_flow_api.g_varchar2_table(621) := '6F6C646572732E0A2020202020206966202866696C65732E6C656E67746829207B0A2020202020202020766172206974656D73203D20652E646174615472616E736665722E6974656D733B0A0A2020202020202020696620286974656D73202626206974';
wwv_flow_api.g_varchar2_table(622) := '656D732E6C656E677468202626206974656D735B305D2E7765626B69744765744173456E74727920213D206E756C6C29207B0A202020202020202020202F2F205468652062726F7773657220737570706F7274732064726F7070696E67206F6620666F6C';
wwv_flow_api.g_varchar2_table(623) := '646572732C20736F2068616E646C65206974656D7320696E7374656164206F662066696C65730A20202020202020202020746869732E5F61646446696C657346726F6D4974656D73286974656D73293B0A20202020202020207D20656C7365207B0A2020';
wwv_flow_api.g_varchar2_table(624) := '2020202020202020746869732E68616E646C6546696C65732866696C6573293B0A20202020202020207D0A2020202020207D0A202020207D0A20207D2C207B0A202020206B65793A20227061737465222C0A2020202076616C75653A2066756E6374696F';
wwv_flow_api.g_varchar2_table(625) := '6E207061737465286529207B0A202020202020696620285F5F67756172645F5F286520213D206E756C6C203F20652E636C6970626F61726444617461203A20756E646566696E65642C2066756E6374696F6E20287829207B0A2020202020202020726574';
wwv_flow_api.g_varchar2_table(626) := '75726E20782E6974656D733B0A2020202020207D29203D3D206E756C6C29207B0A202020202020202072657475726E3B0A2020202020207D0A0A202020202020746869732E656D697428227061737465222C2065293B0A20202020202076617220697465';
wwv_flow_api.g_varchar2_table(627) := '6D73203D20652E636C6970626F617264446174612E6974656D733B0A0A0A202020202020696620286974656D732E6C656E67746829207B0A202020202020202072657475726E20746869732E5F61646446696C657346726F6D4974656D73286974656D73';
wwv_flow_api.g_varchar2_table(628) := '293B0A2020202020207D0A202020207D0A20207D2C207B0A202020206B65793A202268616E646C6546696C6573222C0A2020202076616C75653A2066756E6374696F6E2068616E646C6546696C65732866696C657329207B0A202020202020666F722028';
wwv_flow_api.g_varchar2_table(629) := '766172205F6974657261746F723134203D2066696C65732C205F697341727261793134203D20747275652C205F693135203D20302C205F6974657261746F723134203D205F697341727261793134203F205F6974657261746F723134203A205F69746572';
wwv_flow_api.g_varchar2_table(630) := '61746F7231345B53796D626F6C2E6974657261746F725D28293B3B29207B0A2020202020202020766172205F72656631333B0A0A2020202020202020696620285F69734172726179313429207B0A20202020202020202020696620285F693135203E3D20';
wwv_flow_api.g_varchar2_table(631) := '5F6974657261746F7231342E6C656E6774682920627265616B3B0A202020202020202020205F7265663133203D205F6974657261746F7231345B5F6931352B2B5D3B0A20202020202020207D20656C7365207B0A202020202020202020205F693135203D';
wwv_flow_api.g_varchar2_table(632) := '205F6974657261746F7231342E6E65787428293B0A20202020202020202020696620285F6931352E646F6E652920627265616B3B0A202020202020202020205F7265663133203D205F6931352E76616C75653B0A20202020202020207D0A0A2020202020';
wwv_flow_api.g_varchar2_table(633) := '2020207661722066696C65203D205F72656631333B0A0A2020202020202020746869732E61646446696C652866696C65293B0A2020202020207D0A202020207D0A0A202020202F2F205768656E206120666F6C6465722069732064726F7070656420286F';
wwv_flow_api.g_varchar2_table(634) := '722066696C65732061726520706173746564292C206974656D73206D7573742062652068616E646C65640A202020202F2F20696E7374656164206F662066696C65732E0A0A20207D2C207B0A202020206B65793A20225F61646446696C657346726F6D49';
wwv_flow_api.g_varchar2_table(635) := '74656D73222C0A2020202076616C75653A2066756E6374696F6E205F61646446696C657346726F6D4974656D73286974656D7329207B0A202020202020766172205F7468697335203D20746869733B0A0A20202020202072657475726E2066756E637469';
wwv_flow_api.g_varchar2_table(636) := '6F6E202829207B0A202020202020202076617220726573756C74203D205B5D3B0A2020202020202020666F722028766172205F6974657261746F723135203D206974656D732C205F697341727261793135203D20747275652C205F693136203D20302C20';
wwv_flow_api.g_varchar2_table(637) := '5F6974657261746F723135203D205F697341727261793135203F205F6974657261746F723135203A205F6974657261746F7231355B53796D626F6C2E6974657261746F725D28293B3B29207B0A20202020202020202020766172205F72656631343B0A0A';
wwv_flow_api.g_varchar2_table(638) := '20202020202020202020696620285F69734172726179313529207B0A202020202020202020202020696620285F693136203E3D205F6974657261746F7231352E6C656E6774682920627265616B3B0A2020202020202020202020205F7265663134203D20';
wwv_flow_api.g_varchar2_table(639) := '5F6974657261746F7231355B5F6931362B2B5D3B0A202020202020202020207D20656C7365207B0A2020202020202020202020205F693136203D205F6974657261746F7231352E6E65787428293B0A202020202020202020202020696620285F6931362E';
wwv_flow_api.g_varchar2_table(640) := '646F6E652920627265616B3B0A2020202020202020202020205F7265663134203D205F6931362E76616C75653B0A202020202020202020207D0A0A20202020202020202020766172206974656D203D205F72656631343B0A0A2020202020202020202076';
wwv_flow_api.g_varchar2_table(641) := '617220656E7472793B0A20202020202020202020696620286974656D2E7765626B69744765744173456E74727920213D206E756C6C2026262028656E747279203D206974656D2E7765626B69744765744173456E74727928292929207B0A202020202020';
wwv_flow_api.g_varchar2_table(642) := '20202020202069662028656E7472792E697346696C6529207B0A2020202020202020202020202020726573756C742E70757368285F74686973352E61646446696C65286974656D2E676574417346696C65282929293B0A2020202020202020202020207D';
wwv_flow_api.g_varchar2_table(643) := '20656C73652069662028656E7472792E69734469726563746F727929207B0A20202020202020202020202020202F2F20417070656E6420616C6C2066696C65732066726F6D2074686174206469726563746F727920746F2066696C65730A202020202020';
wwv_flow_api.g_varchar2_table(644) := '2020202020202020726573756C742E70757368285F74686973352E5F61646446696C657346726F6D4469726563746F727928656E7472792C20656E7472792E6E616D6529293B0A2020202020202020202020207D20656C7365207B0A2020202020202020';
wwv_flow_api.g_varchar2_table(645) := '202020202020726573756C742E7075736828756E646566696E6564293B0A2020202020202020202020207D0A202020202020202020207D20656C736520696620286974656D2E676574417346696C6520213D206E756C6C29207B0A202020202020202020';
wwv_flow_api.g_varchar2_table(646) := '202020696620286974656D2E6B696E64203D3D206E756C6C207C7C206974656D2E6B696E64203D3D3D202266696C652229207B0A2020202020202020202020202020726573756C742E70757368285F74686973352E61646446696C65286974656D2E6765';
wwv_flow_api.g_varchar2_table(647) := '74417346696C65282929293B0A2020202020202020202020207D20656C7365207B0A2020202020202020202020202020726573756C742E7075736828756E646566696E6564293B0A2020202020202020202020207D0A202020202020202020207D20656C';
wwv_flow_api.g_varchar2_table(648) := '7365207B0A202020202020202020202020726573756C742E7075736828756E646566696E6564293B0A202020202020202020207D0A20202020202020207D0A202020202020202072657475726E20726573756C743B0A2020202020207D28293B0A202020';
wwv_flow_api.g_varchar2_table(649) := '207D0A0A202020202F2F20476F6573207468726F75676820746865206469726563746F72792C20616E64206164647320656163682066696C652069742066696E6473207265637572736976656C790A0A20207D2C207B0A202020206B65793A20225F6164';
wwv_flow_api.g_varchar2_table(650) := '6446696C657346726F6D4469726563746F7279222C0A2020202076616C75653A2066756E6374696F6E205F61646446696C657346726F6D4469726563746F7279286469726563746F72792C207061746829207B0A202020202020766172205F7468697336';
wwv_flow_api.g_varchar2_table(651) := '203D20746869733B0A0A20202020202076617220646972526561646572203D206469726563746F72792E63726561746552656164657228293B0A0A202020202020766172206572726F7248616E646C6572203D2066756E6374696F6E206572726F724861';
wwv_flow_api.g_varchar2_table(652) := '6E646C6572286572726F7229207B0A202020202020202072657475726E205F5F67756172644D6574686F645F5F28636F6E736F6C652C20276C6F67272C2066756E6374696F6E20286F29207B0A2020202020202020202072657475726E206F2E6C6F6728';
wwv_flow_api.g_varchar2_table(653) := '6572726F72293B0A20202020202020207D293B0A2020202020207D3B0A0A2020202020207661722072656164456E7472696573203D2066756E6374696F6E2072656164456E74726965732829207B0A202020202020202072657475726E20646972526561';
wwv_flow_api.g_varchar2_table(654) := '6465722E72656164456E74726965732866756E6374696F6E2028656E747269657329207B0A2020202020202020202069662028656E74726965732E6C656E677468203E203029207B0A202020202020202020202020666F722028766172205F6974657261';
wwv_flow_api.g_varchar2_table(655) := '746F723136203D20656E74726965732C205F697341727261793136203D20747275652C205F693137203D20302C205F6974657261746F723136203D205F697341727261793136203F205F6974657261746F723136203A205F6974657261746F7231365B53';
wwv_flow_api.g_varchar2_table(656) := '796D626F6C2E6974657261746F725D28293B3B29207B0A2020202020202020202020202020766172205F72656631353B0A0A2020202020202020202020202020696620285F69734172726179313629207B0A202020202020202020202020202020206966';
wwv_flow_api.g_varchar2_table(657) := '20285F693137203E3D205F6974657261746F7231362E6C656E6774682920627265616B3B0A202020202020202020202020202020205F7265663135203D205F6974657261746F7231365B5F6931372B2B5D3B0A20202020202020202020202020207D2065';
wwv_flow_api.g_varchar2_table(658) := '6C7365207B0A202020202020202020202020202020205F693137203D205F6974657261746F7231362E6E65787428293B0A20202020202020202020202020202020696620285F6931372E646F6E652920627265616B3B0A20202020202020202020202020';
wwv_flow_api.g_varchar2_table(659) := '2020205F7265663135203D205F6931372E76616C75653B0A20202020202020202020202020207D0A0A202020202020202020202020202076617220656E747279203D205F72656631353B0A0A202020202020202020202020202069662028656E7472792E';
wwv_flow_api.g_varchar2_table(660) := '697346696C6529207B0A20202020202020202020202020202020656E7472792E66696C652866756E6374696F6E202866696C6529207B0A202020202020202020202020202020202020696620285F74686973362E6F7074696F6E732E69676E6F72654869';
wwv_flow_api.g_varchar2_table(661) := '6464656E46696C65732026262066696C652E6E616D652E737562737472696E6728302C203129203D3D3D20272E2729207B0A202020202020202020202020202020202020202072657475726E3B0A2020202020202020202020202020202020207D0A2020';
wwv_flow_api.g_varchar2_table(662) := '2020202020202020202020202020202066696C652E66756C6C50617468203D2070617468202B20222F22202B2066696C652E6E616D653B0A20202020202020202020202020202020202072657475726E205F74686973362E61646446696C652866696C65';
wwv_flow_api.g_varchar2_table(663) := '293B0A202020202020202020202020202020207D293B0A20202020202020202020202020207D20656C73652069662028656E7472792E69734469726563746F727929207B0A202020202020202020202020202020205F74686973362E5F61646446696C65';
wwv_flow_api.g_varchar2_table(664) := '7346726F6D4469726563746F727928656E7472792C2070617468202B20222F22202B20656E7472792E6E616D65293B0A20202020202020202020202020207D0A2020202020202020202020207D0A0A2020202020202020202020202F2F20526563757273';
wwv_flow_api.g_varchar2_table(665) := '6976656C792063616C6C2072656164456E7472696573282920616761696E2C2073696E63652062726F77736572206F6E6C792068616E646C650A2020202020202020202020202F2F207468652066697273742031303020656E74726965732E0A20202020';
wwv_flow_api.g_varchar2_table(666) := '20202020202020202F2F205365653A2068747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4150492F4469726563746F72795265616465722372656164456E74726965730A20202020202020';
wwv_flow_api.g_varchar2_table(667) := '202020202072656164456E747269657328293B0A202020202020202020207D0A2020202020202020202072657475726E206E756C6C3B0A20202020202020207D2C206572726F7248616E646C6572293B0A2020202020207D3B0A0A202020202020726574';
wwv_flow_api.g_varchar2_table(668) := '75726E2072656164456E747269657328293B0A202020207D0A0A202020202F2F2049662060646F6E652829602069732063616C6C656420776974686F757420617267756D656E74207468652066696C652069732061636365707465640A202020202F2F20';
wwv_flow_api.g_varchar2_table(669) := '496620796F752063616C6C206974207769746820616E206572726F72206D6573736167652C207468652066696C652069732072656A65637465640A202020202F2F20285468697320616C6C6F777320666F72206173796E6368726F6E6F75732076616C69';
wwv_flow_api.g_varchar2_table(670) := '646174696F6E290A202020202F2F0A202020202F2F20546869732066756E6374696F6E20636865636B73207468652066696C6573697A652C20616E64206966207468652066696C652E7479706520706173736573207468650A202020202F2F2060616363';
wwv_flow_api.g_varchar2_table(671) := '657074656446696C65736020636865636B2E0A0A20207D2C207B0A202020206B65793A2022616363657074222C0A2020202076616C75653A2066756E6374696F6E206163636570742866696C652C20646F6E6529207B0A20202020202069662028746869';
wwv_flow_api.g_varchar2_table(672) := '732E6F7074696F6E732E6D617846696C6573697A652026262066696C652E73697A65203E20746869732E6F7074696F6E732E6D617846696C6573697A65202A2031303234202A203130323429207B0A202020202020202072657475726E20646F6E652874';
wwv_flow_api.g_varchar2_table(673) := '6869732E6F7074696F6E732E6469637446696C65546F6F4269672E7265706C61636528227B7B66696C6573697A657D7D222C204D6174682E726F756E642866696C652E73697A65202F2031303234202F2031302E323429202F20313030292E7265706C61';
wwv_flow_api.g_varchar2_table(674) := '636528227B7B6D617846696C6573697A657D7D222C20746869732E6F7074696F6E732E6D617846696C6573697A6529293B0A2020202020207D20656C736520696620282144726F707A6F6E652E697356616C696446696C652866696C652C20746869732E';
wwv_flow_api.g_varchar2_table(675) := '6F7074696F6E732E616363657074656446696C65732929207B0A202020202020202072657475726E20646F6E6528746869732E6F7074696F6E732E64696374496E76616C696446696C6554797065293B0A2020202020207D20656C736520696620287468';
wwv_flow_api.g_varchar2_table(676) := '69732E6F7074696F6E732E6D617846696C657320213D206E756C6C20262620746869732E676574416363657074656446696C657328292E6C656E677468203E3D20746869732E6F7074696F6E732E6D617846696C657329207B0A2020202020202020646F';
wwv_flow_api.g_varchar2_table(677) := '6E6528746869732E6F7074696F6E732E646963744D617846696C657345786365656465642E7265706C61636528227B7B6D617846696C65737D7D222C20746869732E6F7074696F6E732E6D617846696C657329293B0A202020202020202072657475726E';
wwv_flow_api.g_varchar2_table(678) := '20746869732E656D697428226D617866696C65736578636565646564222C2066696C65293B0A2020202020207D20656C7365207B0A202020202020202072657475726E20746869732E6F7074696F6E732E6163636570742E63616C6C28746869732C2066';
wwv_flow_api.g_varchar2_table(679) := '696C652C20646F6E65293B0A2020202020207D0A202020207D0A20207D2C207B0A202020206B65793A202261646446696C65222C0A2020202076616C75653A2066756E6374696F6E2061646446696C652866696C6529207B0A202020202020766172205F';
wwv_flow_api.g_varchar2_table(680) := '7468697337203D20746869733B0A0A20202020202066696C652E75706C6F6164203D207B0A2020202020202020757569643A2044726F707A6F6E652E75756964763428292C0A202020202020202070726F67726573733A20302C0A20202020202020202F';
wwv_flow_api.g_varchar2_table(681) := '2F2053657474696E672074686520746F74616C2075706C6F61642073697A6520746F2066696C652E73697A6520666F722074686520626567696E6E696E670A20202020202020202F2F20497427732061637475616C20646966666572656E74207468616E';
wwv_flow_api.g_varchar2_table(682) := '207468652073697A6520746F206265207472616E736D69747465642E0A2020202020202020746F74616C3A2066696C652E73697A652C0A2020202020202020627974657353656E743A20302C0A202020202020202066696C656E616D653A20746869732E';
wwv_flow_api.g_varchar2_table(683) := '5F72656E616D6546696C652866696C65292C0A20202020202020206368756E6B65643A20746869732E6F7074696F6E732E6368756E6B696E672026262028746869732E6F7074696F6E732E666F7263654368756E6B696E67207C7C2066696C652E73697A';
wwv_flow_api.g_varchar2_table(684) := '65203E20746869732E6F7074696F6E732E6368756E6B53697A65292C0A2020202020202020746F74616C4368756E6B436F756E743A204D6174682E6365696C2866696C652E73697A65202F20746869732E6F7074696F6E732E6368756E6B53697A65290A';
wwv_flow_api.g_varchar2_table(685) := '2020202020207D3B0A202020202020746869732E66696C65732E707573682866696C65293B0A0A20202020202066696C652E737461747573203D2044726F707A6F6E652E41444445443B0A0A202020202020746869732E656D6974282261646465646669';
wwv_flow_api.g_varchar2_table(686) := '6C65222C2066696C65293B0A0A202020202020746869732E5F656E71756575655468756D626E61696C2866696C65293B0A0A20202020202072657475726E20746869732E6163636570742866696C652C2066756E6374696F6E20286572726F7229207B0A';
wwv_flow_api.g_varchar2_table(687) := '2020202020202020696620286572726F7229207B0A2020202020202020202066696C652E6163636570746564203D2066616C73653B0A202020202020202020205F74686973372E5F6572726F7250726F63657373696E67285B66696C655D2C206572726F';
wwv_flow_api.g_varchar2_table(688) := '72293B202F2F2057696C6C20736574207468652066696C652E7374617475730A20202020202020207D20656C7365207B0A2020202020202020202066696C652E6163636570746564203D20747275653B0A20202020202020202020696620285F74686973';
wwv_flow_api.g_varchar2_table(689) := '372E6F7074696F6E732E6175746F517565756529207B0A2020202020202020202020205F74686973372E656E717565756546696C652866696C65293B0A202020202020202020207D202F2F2057696C6C20736574202E6163636570746564203D20747275';
wwv_flow_api.g_varchar2_table(690) := '650A20202020202020207D0A202020202020202072657475726E205F74686973372E5F7570646174654D617846696C657352656163686564436C61737328293B0A2020202020207D293B0A202020207D0A0A202020202F2F205772617070657220666F72';
wwv_flow_api.g_varchar2_table(691) := '20656E717565756546696C650A0A20207D2C207B0A202020206B65793A2022656E717565756546696C6573222C0A2020202076616C75653A2066756E6374696F6E20656E717565756546696C65732866696C657329207B0A202020202020666F72202876';
wwv_flow_api.g_varchar2_table(692) := '6172205F6974657261746F723137203D2066696C65732C205F697341727261793137203D20747275652C205F693138203D20302C205F6974657261746F723137203D205F697341727261793137203F205F6974657261746F723137203A205F6974657261';
wwv_flow_api.g_varchar2_table(693) := '746F7231375B53796D626F6C2E6974657261746F725D28293B3B29207B0A2020202020202020766172205F72656631363B0A0A2020202020202020696620285F69734172726179313729207B0A20202020202020202020696620285F693138203E3D205F';
wwv_flow_api.g_varchar2_table(694) := '6974657261746F7231372E6C656E6774682920627265616B3B0A202020202020202020205F7265663136203D205F6974657261746F7231375B5F6931382B2B5D3B0A20202020202020207D20656C7365207B0A202020202020202020205F693138203D20';
wwv_flow_api.g_varchar2_table(695) := '5F6974657261746F7231372E6E65787428293B0A20202020202020202020696620285F6931382E646F6E652920627265616B3B0A202020202020202020205F7265663136203D205F6931382E76616C75653B0A20202020202020207D0A0A202020202020';
wwv_flow_api.g_varchar2_table(696) := '20207661722066696C65203D205F72656631363B0A0A2020202020202020746869732E656E717565756546696C652866696C65293B0A2020202020207D0A20202020202072657475726E206E756C6C3B0A202020207D0A20207D2C207B0A202020206B65';
wwv_flow_api.g_varchar2_table(697) := '793A2022656E717565756546696C65222C0A2020202076616C75653A2066756E6374696F6E20656E717565756546696C652866696C6529207B0A202020202020766172205F7468697338203D20746869733B0A0A2020202020206966202866696C652E73';
wwv_flow_api.g_varchar2_table(698) := '7461747573203D3D3D2044726F707A6F6E652E41444445442026262066696C652E6163636570746564203D3D3D207472756529207B0A202020202020202066696C652E737461747573203D2044726F707A6F6E652E5155455545443B0A20202020202020';
wwv_flow_api.g_varchar2_table(699) := '2069662028746869732E6F7074696F6E732E6175746F50726F63657373517565756529207B0A2020202020202020202072657475726E2073657454696D656F75742866756E6374696F6E202829207B0A20202020202020202020202072657475726E205F';
wwv_flow_api.g_varchar2_table(700) := '74686973382E70726F63657373517565756528293B0A202020202020202020207D2C2030293B202F2F20446566657272696E67207468652063616C6C0A20202020202020207D0A2020202020207D20656C7365207B0A20202020202020207468726F7720';
wwv_flow_api.g_varchar2_table(701) := '6E6577204572726F722822546869732066696C652063616E27742062652071756575656420626563617573652069742068617320616C7265616479206265656E2070726F636573736564206F72207761732072656A65637465642E22293B0A2020202020';
wwv_flow_api.g_varchar2_table(702) := '207D0A202020207D0A20207D2C207B0A202020206B65793A20225F656E71756575655468756D626E61696C222C0A2020202076616C75653A2066756E6374696F6E205F656E71756575655468756D626E61696C2866696C6529207B0A2020202020207661';
wwv_flow_api.g_varchar2_table(703) := '72205F7468697339203D20746869733B0A0A20202020202069662028746869732E6F7074696F6E732E637265617465496D6167655468756D626E61696C732026262066696C652E747970652E6D61746368282F696D6167652E2A2F292026262066696C65';
wwv_flow_api.g_varchar2_table(704) := '2E73697A65203C3D20746869732E6F7074696F6E732E6D61785468756D626E61696C46696C6573697A65202A2031303234202A203130323429207B0A2020202020202020746869732E5F7468756D626E61696C51756575652E707573682866696C65293B';
wwv_flow_api.g_varchar2_table(705) := '0A202020202020202072657475726E2073657454696D656F75742866756E6374696F6E202829207B0A2020202020202020202072657475726E205F74686973392E5F70726F636573735468756D626E61696C517565756528293B0A20202020202020207D';
wwv_flow_api.g_varchar2_table(706) := '2C2030293B202F2F20446566657272696E67207468652063616C6C0A2020202020207D0A202020207D0A20207D2C207B0A202020206B65793A20225F70726F636573735468756D626E61696C5175657565222C0A2020202076616C75653A2066756E6374';
wwv_flow_api.g_varchar2_table(707) := '696F6E205F70726F636573735468756D626E61696C51756575652829207B0A202020202020766172205F746869733130203D20746869733B0A0A20202020202069662028746869732E5F70726F63657373696E675468756D626E61696C207C7C20746869';
wwv_flow_api.g_varchar2_table(708) := '732E5F7468756D626E61696C51756575652E6C656E677468203D3D3D203029207B0A202020202020202072657475726E3B0A2020202020207D0A0A202020202020746869732E5F70726F63657373696E675468756D626E61696C203D20747275653B0A20';
wwv_flow_api.g_varchar2_table(709) := '20202020207661722066696C65203D20746869732E5F7468756D626E61696C51756575652E736869667428293B0A20202020202072657475726E20746869732E6372656174655468756D626E61696C2866696C652C20746869732E6F7074696F6E732E74';
wwv_flow_api.g_varchar2_table(710) := '68756D626E61696C57696474682C20746869732E6F7074696F6E732E7468756D626E61696C4865696768742C20746869732E6F7074696F6E732E7468756D626E61696C4D6574686F642C20747275652C2066756E6374696F6E20286461746155726C2920';
wwv_flow_api.g_varchar2_table(711) := '7B0A20202020202020205F7468697331302E656D697428227468756D626E61696C222C2066696C652C206461746155726C293B0A20202020202020205F7468697331302E5F70726F63657373696E675468756D626E61696C203D2066616C73653B0A2020';
wwv_flow_api.g_varchar2_table(712) := '20202020202072657475726E205F7468697331302E5F70726F636573735468756D626E61696C517565756528293B0A2020202020207D293B0A202020207D0A0A202020202F2F2043616E2062652063616C6C656420627920746865207573657220746F20';
wwv_flow_api.g_varchar2_table(713) := '72656D6F766520612066696C650A0A20207D2C207B0A202020206B65793A202272656D6F766546696C65222C0A2020202076616C75653A2066756E6374696F6E2072656D6F766546696C652866696C6529207B0A2020202020206966202866696C652E73';
wwv_flow_api.g_varchar2_table(714) := '7461747573203D3D3D2044726F707A6F6E652E55504C4F4144494E4729207B0A2020202020202020746869732E63616E63656C55706C6F61642866696C65293B0A2020202020207D0A202020202020746869732E66696C6573203D20776974686F757428';
wwv_flow_api.g_varchar2_table(715) := '746869732E66696C65732C2066696C65293B0A0A202020202020746869732E656D6974282272656D6F76656466696C65222C2066696C65293B0A20202020202069662028746869732E66696C65732E6C656E677468203D3D3D203029207B0A2020202020';
wwv_flow_api.g_varchar2_table(716) := '20202072657475726E20746869732E656D69742822726573657422293B0A2020202020207D0A202020207D0A0A202020202F2F2052656D6F76657320616C6C2066696C65732074686174206172656E27742063757272656E746C792070726F6365737365';
wwv_flow_api.g_varchar2_table(717) := '642066726F6D20746865206C6973740A0A20207D2C207B0A202020206B65793A202272656D6F7665416C6C46696C6573222C0A2020202076616C75653A2066756E6374696F6E2072656D6F7665416C6C46696C65732863616E63656C49664E6563657373';
wwv_flow_api.g_varchar2_table(718) := '61727929207B0A2020202020202F2F20437265617465206120636F7079206F662066696C65732073696E63652072656D6F766546696C652829206368616E67657320746865204066696C65732061727261792E0A2020202020206966202863616E63656C';
wwv_flow_api.g_varchar2_table(719) := '49664E6563657373617279203D3D206E756C6C29207B0A202020202020202063616E63656C49664E6563657373617279203D2066616C73653B0A2020202020207D0A202020202020666F722028766172205F6974657261746F723138203D20746869732E';
wwv_flow_api.g_varchar2_table(720) := '66696C65732E736C69636528292C205F697341727261793138203D20747275652C205F693139203D20302C205F6974657261746F723138203D205F697341727261793138203F205F6974657261746F723138203A205F6974657261746F7231385B53796D';
wwv_flow_api.g_varchar2_table(721) := '626F6C2E6974657261746F725D28293B3B29207B0A2020202020202020766172205F72656631373B0A0A2020202020202020696620285F69734172726179313829207B0A20202020202020202020696620285F693139203E3D205F6974657261746F7231';
wwv_flow_api.g_varchar2_table(722) := '382E6C656E6774682920627265616B3B0A202020202020202020205F7265663137203D205F6974657261746F7231385B5F6931392B2B5D3B0A20202020202020207D20656C7365207B0A202020202020202020205F693139203D205F6974657261746F72';
wwv_flow_api.g_varchar2_table(723) := '31382E6E65787428293B0A20202020202020202020696620285F6931392E646F6E652920627265616B3B0A202020202020202020205F7265663137203D205F6931392E76616C75653B0A20202020202020207D0A0A20202020202020207661722066696C';
wwv_flow_api.g_varchar2_table(724) := '65203D205F72656631373B0A0A20202020202020206966202866696C652E73746174757320213D3D2044726F707A6F6E652E55504C4F4144494E47207C7C2063616E63656C49664E656365737361727929207B0A20202020202020202020746869732E72';
wwv_flow_api.g_varchar2_table(725) := '656D6F766546696C652866696C65293B0A20202020202020207D0A2020202020207D0A20202020202072657475726E206E756C6C3B0A202020207D0A0A202020202F2F20526573697A657320616E20696D616765206265666F7265206974206765747320';
wwv_flow_api.g_varchar2_table(726) := '73656E7420746F20746865207365727665722E20546869732066756E6374696F6E206973207468652064656661756C74206265686176696F72206F660A202020202F2F20606F7074696F6E732E7472616E73666F726D46696C6560206966206072657369';
wwv_flow_api.g_varchar2_table(727) := '7A65576964746860206F722060726573697A654865696768746020617265207365742E205468652063616C6C6261636B20697320696E766F6B656420776974680A202020202F2F2074686520726573697A656420626C6F622E0A0A20207D2C207B0A2020';
wwv_flow_api.g_varchar2_table(728) := '20206B65793A2022726573697A65496D616765222C0A2020202076616C75653A2066756E6374696F6E20726573697A65496D6167652866696C652C2077696474682C206865696768742C20726573697A654D6574686F642C2063616C6C6261636B29207B';
wwv_flow_api.g_varchar2_table(729) := '0A202020202020766172205F746869733131203D20746869733B0A0A20202020202072657475726E20746869732E6372656174655468756D626E61696C2866696C652C2077696474682C206865696768742C20726573697A654D6574686F642C20747275';
wwv_flow_api.g_varchar2_table(730) := '652C2066756E6374696F6E20286461746155726C2C2063616E76617329207B0A20202020202020206966202863616E766173203D3D206E756C6C29207B0A202020202020202020202F2F2054686520696D61676520686173206E6F74206265656E207265';
wwv_flow_api.g_varchar2_table(731) := '73697A65640A2020202020202020202072657475726E2063616C6C6261636B2866696C65293B0A20202020202020207D20656C7365207B0A2020202020202020202076617220726573697A654D696D6554797065203D205F7468697331312E6F7074696F';
wwv_flow_api.g_varchar2_table(732) := '6E732E726573697A654D696D65547970653B0A0A2020202020202020202069662028726573697A654D696D6554797065203D3D206E756C6C29207B0A202020202020202020202020726573697A654D696D6554797065203D2066696C652E747970653B0A';
wwv_flow_api.g_varchar2_table(733) := '202020202020202020207D0A2020202020202020202076617220726573697A65644461746155524C203D2063616E7661732E746F4461746155524C28726573697A654D696D65547970652C205F7468697331312E6F7074696F6E732E726573697A655175';
wwv_flow_api.g_varchar2_table(734) := '616C697479293B0A2020202020202020202069662028726573697A654D696D6554797065203D3D3D2027696D6167652F6A70656727207C7C20726573697A654D696D6554797065203D3D3D2027696D6167652F6A70672729207B0A202020202020202020';
wwv_flow_api.g_varchar2_table(735) := '2020202F2F204E6F772061646420746865206F726967696E616C204558494620696E666F726D6174696F6E0A202020202020202020202020726573697A65644461746155524C203D2045786966526573746F72652E726573746F72652866696C652E6461';
wwv_flow_api.g_varchar2_table(736) := '746155524C2C20726573697A65644461746155524C293B0A202020202020202020207D0A2020202020202020202072657475726E2063616C6C6261636B2844726F707A6F6E652E64617461555249746F426C6F6228726573697A65644461746155524C29';
wwv_flow_api.g_varchar2_table(737) := '293B0A20202020202020207D0A2020202020207D293B0A202020207D0A20207D2C207B0A202020206B65793A20226372656174655468756D626E61696C222C0A2020202076616C75653A2066756E6374696F6E206372656174655468756D626E61696C28';
wwv_flow_api.g_varchar2_table(738) := '66696C652C2077696474682C206865696768742C20726573697A654D6574686F642C206669784F7269656E746174696F6E2C2063616C6C6261636B29207B0A202020202020766172205F746869733132203D20746869733B0A0A20202020202076617220';
wwv_flow_api.g_varchar2_table(739) := '66696C65526561646572203D206E65772046696C6552656164657228293B0A0A20202020202066696C655265616465722E6F6E6C6F6164203D2066756E6374696F6E202829207B0A0A202020202020202066696C652E6461746155524C203D2066696C65';
wwv_flow_api.g_varchar2_table(740) := '5265616465722E726573756C743B0A0A20202020202020202F2F20446F6E277420626F74686572206372656174696E672061207468756D626E61696C20666F722053564720696D616765732073696E6365207468657927726520766563746F720A202020';
wwv_flow_api.g_varchar2_table(741) := '20202020206966202866696C652E74797065203D3D3D2022696D6167652F7376672B786D6C2229207B0A202020202020202020206966202863616C6C6261636B20213D206E756C6C29207B0A20202020202020202020202063616C6C6261636B2866696C';
wwv_flow_api.g_varchar2_table(742) := '655265616465722E726573756C74293B0A202020202020202020207D0A2020202020202020202072657475726E3B0A20202020202020207D0A0A202020202020202072657475726E205F7468697331322E6372656174655468756D626E61696C46726F6D';
wwv_flow_api.g_varchar2_table(743) := '55726C2866696C652C2077696474682C206865696768742C20726573697A654D6574686F642C206669784F7269656E746174696F6E2C2063616C6C6261636B293B0A2020202020207D3B0A0A20202020202072657475726E2066696C655265616465722E';
wwv_flow_api.g_varchar2_table(744) := '7265616441734461746155524C2866696C65293B0A202020207D0A20207D2C207B0A202020206B65793A20226372656174655468756D626E61696C46726F6D55726C222C0A2020202076616C75653A2066756E6374696F6E206372656174655468756D62';
wwv_flow_api.g_varchar2_table(745) := '6E61696C46726F6D55726C2866696C652C2077696474682C206865696768742C20726573697A654D6574686F642C206669784F7269656E746174696F6E2C2063616C6C6261636B2C2063726F73734F726967696E29207B0A202020202020766172205F74';
wwv_flow_api.g_varchar2_table(746) := '6869733133203D20746869733B0A0A2020202020202F2F204E6F74207573696E6720606E657720496D6167656020686572652062656361757365206F6620612062756720696E206C6174657374204368726F6D652076657273696F6E732E0A2020202020';
wwv_flow_api.g_varchar2_table(747) := '202F2F205365652068747470733A2F2F6769746875622E636F6D2F656E796F2F64726F707A6F6E652F70756C6C2F3232360A20202020202076617220696D67203D20646F63756D656E742E637265617465456C656D656E742822696D6722293B0A0A2020';
wwv_flow_api.g_varchar2_table(748) := '202020206966202863726F73734F726967696E29207B0A2020202020202020696D672E63726F73734F726967696E203D2063726F73734F726967696E3B0A2020202020207D0A0A202020202020696D672E6F6E6C6F6164203D2066756E6374696F6E2028';
wwv_flow_api.g_varchar2_table(749) := '29207B0A2020202020202020766172206C6F616445786966203D2066756E6374696F6E206C6F6164457869662863616C6C6261636B29207B0A2020202020202020202072657475726E2063616C6C6261636B2831293B0A20202020202020207D3B0A2020';
wwv_flow_api.g_varchar2_table(750) := '20202020202069662028747970656F66204558494620213D3D2027756E646566696E656427202626204558494620213D3D206E756C6C202626206669784F7269656E746174696F6E29207B0A202020202020202020206C6F616445786966203D2066756E';
wwv_flow_api.g_varchar2_table(751) := '6374696F6E206C6F6164457869662863616C6C6261636B29207B0A20202020202020202020202072657475726E20455849462E6765744461746128696D672C2066756E6374696F6E202829207B0A202020202020202020202020202072657475726E2063';
wwv_flow_api.g_varchar2_table(752) := '616C6C6261636B28455849462E67657454616728746869732C20274F7269656E746174696F6E2729293B0A2020202020202020202020207D293B0A202020202020202020207D3B0A20202020202020207D0A0A202020202020202072657475726E206C6F';
wwv_flow_api.g_varchar2_table(753) := '6164457869662866756E6374696F6E20286F7269656E746174696F6E29207B0A2020202020202020202066696C652E7769647468203D20696D672E77696474683B0A2020202020202020202066696C652E686569676874203D20696D672E686569676874';
wwv_flow_api.g_varchar2_table(754) := '3B0A0A2020202020202020202076617220726573697A65496E666F203D205F7468697331332E6F7074696F6E732E726573697A652E63616C6C285F7468697331332C2066696C652C2077696474682C206865696768742C20726573697A654D6574686F64';
wwv_flow_api.g_varchar2_table(755) := '293B0A0A202020202020202020207661722063616E766173203D20646F63756D656E742E637265617465456C656D656E74282263616E76617322293B0A2020202020202020202076617220637478203D2063616E7661732E676574436F6E746578742822';
wwv_flow_api.g_varchar2_table(756) := '326422293B0A0A2020202020202020202063616E7661732E7769647468203D20726573697A65496E666F2E74726757696474683B0A2020202020202020202063616E7661732E686569676874203D20726573697A65496E666F2E7472674865696768743B';
wwv_flow_api.g_varchar2_table(757) := '0A0A20202020202020202020696620286F7269656E746174696F6E203E203429207B0A20202020202020202020202063616E7661732E7769647468203D20726573697A65496E666F2E7472674865696768743B0A20202020202020202020202063616E76';
wwv_flow_api.g_varchar2_table(758) := '61732E686569676874203D20726573697A65496E666F2E74726757696474683B0A202020202020202020207D0A0A2020202020202020202073776974636820286F7269656E746174696F6E29207B0A2020202020202020202020206361736520323A0A20';
wwv_flow_api.g_varchar2_table(759) := '202020202020202020202020202F2F20686F72697A6F6E74616C20666C69700A20202020202020202020202020206374782E7472616E736C6174652863616E7661732E77696474682C2030293B0A20202020202020202020202020206374782E7363616C';
wwv_flow_api.g_varchar2_table(760) := '65282D312C2031293B0A2020202020202020202020202020627265616B3B0A2020202020202020202020206361736520333A0A20202020202020202020202020202F2F20313830C2B020726F74617465206C6566740A2020202020202020202020202020';
wwv_flow_api.g_varchar2_table(761) := '6374782E7472616E736C6174652863616E7661732E77696474682C2063616E7661732E686569676874293B0A20202020202020202020202020206374782E726F74617465284D6174682E5049293B0A2020202020202020202020202020627265616B3B0A';
wwv_flow_api.g_varchar2_table(762) := '2020202020202020202020206361736520343A0A20202020202020202020202020202F2F20766572746963616C20666C69700A20202020202020202020202020206374782E7472616E736C61746528302C2063616E7661732E686569676874293B0A2020';
wwv_flow_api.g_varchar2_table(763) := '2020202020202020202020206374782E7363616C6528312C202D31293B0A2020202020202020202020202020627265616B3B0A2020202020202020202020206361736520353A0A20202020202020202020202020202F2F20766572746963616C20666C69';
wwv_flow_api.g_varchar2_table(764) := '70202B20393020726F746174652072696768740A20202020202020202020202020206374782E726F7461746528302E35202A204D6174682E5049293B0A20202020202020202020202020206374782E7363616C6528312C202D31293B0A20202020202020';
wwv_flow_api.g_varchar2_table(765) := '20202020202020627265616B3B0A2020202020202020202020206361736520363A0A20202020202020202020202020202F2F203930C2B020726F746174652072696768740A20202020202020202020202020206374782E726F7461746528302E35202A20';
wwv_flow_api.g_varchar2_table(766) := '4D6174682E5049293B0A20202020202020202020202020206374782E7472616E736C61746528302C202D63616E7661732E7769647468293B0A2020202020202020202020202020627265616B3B0A2020202020202020202020206361736520373A0A2020';
wwv_flow_api.g_varchar2_table(767) := '2020202020202020202020202F2F20686F72697A6F6E74616C20666C6970202B20393020726F746174652072696768740A20202020202020202020202020206374782E726F7461746528302E35202A204D6174682E5049293B0A20202020202020202020';
wwv_flow_api.g_varchar2_table(768) := '202020206374782E7472616E736C6174652863616E7661732E6865696768742C202D63616E7661732E7769647468293B0A20202020202020202020202020206374782E7363616C65282D312C2031293B0A2020202020202020202020202020627265616B';
wwv_flow_api.g_varchar2_table(769) := '3B0A2020202020202020202020206361736520383A0A20202020202020202020202020202F2F203930C2B020726F74617465206C6566740A20202020202020202020202020206374782E726F74617465282D302E35202A204D6174682E5049293B0A2020';
wwv_flow_api.g_varchar2_table(770) := '2020202020202020202020206374782E7472616E736C617465282D63616E7661732E6865696768742C2030293B0A2020202020202020202020202020627265616B3B0A202020202020202020207D0A0A202020202020202020202F2F2054686973206973';
wwv_flow_api.g_varchar2_table(771) := '20612062756766697820666F7220694F5327207363616C696E67206275672E0A2020202020202020202064726177496D616765494F53466978286374782C20696D672C20726573697A65496E666F2E7372635820213D206E756C6C203F20726573697A65';
wwv_flow_api.g_varchar2_table(772) := '496E666F2E73726358203A20302C20726573697A65496E666F2E7372635920213D206E756C6C203F20726573697A65496E666F2E73726359203A20302C20726573697A65496E666F2E73726357696474682C20726573697A65496E666F2E737263486569';
wwv_flow_api.g_varchar2_table(773) := '6768742C20726573697A65496E666F2E7472675820213D206E756C6C203F20726573697A65496E666F2E74726758203A20302C20726573697A65496E666F2E7472675920213D206E756C6C203F20726573697A65496E666F2E74726759203A20302C2072';
wwv_flow_api.g_varchar2_table(774) := '6573697A65496E666F2E74726757696474682C20726573697A65496E666F2E747267486569676874293B0A0A20202020202020202020766172207468756D626E61696C203D2063616E7661732E746F4461746155524C2822696D6167652F706E6722293B';
wwv_flow_api.g_varchar2_table(775) := '0A0A202020202020202020206966202863616C6C6261636B20213D206E756C6C29207B0A20202020202020202020202072657475726E2063616C6C6261636B287468756D626E61696C2C2063616E766173293B0A202020202020202020207D0A20202020';
wwv_flow_api.g_varchar2_table(776) := '202020207D293B0A2020202020207D3B0A0A2020202020206966202863616C6C6261636B20213D206E756C6C29207B0A2020202020202020696D672E6F6E6572726F72203D2063616C6C6261636B3B0A2020202020207D0A0A2020202020207265747572';
wwv_flow_api.g_varchar2_table(777) := '6E20696D672E737263203D2066696C652E6461746155524C3B0A202020207D0A0A202020202F2F20476F6573207468726F7567682074686520717565756520616E642070726F6365737365732066696C6573206966207468657265206172656E27742074';
wwv_flow_api.g_varchar2_table(778) := '6F6F206D616E7920616C72656164792E0A0A20207D2C207B0A202020206B65793A202270726F636573735175657565222C0A2020202076616C75653A2066756E6374696F6E2070726F6365737351756575652829207B0A20202020202076617220706172';
wwv_flow_api.g_varchar2_table(779) := '616C6C656C55706C6F616473203D20746869732E6F7074696F6E732E706172616C6C656C55706C6F6164733B0A0A2020202020207661722070726F63657373696E674C656E677468203D20746869732E67657455706C6F6164696E6746696C657328292E';
wwv_flow_api.g_varchar2_table(780) := '6C656E6774683B0A2020202020207661722069203D2070726F63657373696E674C656E6774683B0A0A2020202020202F2F2054686572652061726520616C7265616479206174206C65617374206173206D616E792066696C65732075706C6F6164696E67';
wwv_flow_api.g_varchar2_table(781) := '207468616E2073686F756C642062650A2020202020206966202870726F63657373696E674C656E677468203E3D20706172616C6C656C55706C6F61647329207B0A202020202020202072657475726E3B0A2020202020207D0A0A20202020202076617220';
wwv_flow_api.g_varchar2_table(782) := '71756575656446696C6573203D20746869732E67657451756575656446696C657328293B0A0A20202020202069662028212871756575656446696C65732E6C656E677468203E20302929207B0A202020202020202072657475726E3B0A2020202020207D';
wwv_flow_api.g_varchar2_table(783) := '0A0A20202020202069662028746869732E6F7074696F6E732E75706C6F61644D756C7469706C6529207B0A20202020202020202F2F205468652066696C65732073686F756C642062652075706C6F6164656420696E206F6E6520726571756573740A2020';
wwv_flow_api.g_varchar2_table(784) := '20202020202072657475726E20746869732E70726F6365737346696C65732871756575656446696C65732E736C69636528302C20706172616C6C656C55706C6F616473202D2070726F63657373696E674C656E67746829293B0A2020202020207D20656C';
wwv_flow_api.g_varchar2_table(785) := '7365207B0A20202020202020207768696C65202869203C20706172616C6C656C55706C6F61647329207B0A20202020202020202020696620282171756575656446696C65732E6C656E67746829207B0A20202020202020202020202072657475726E3B0A';
wwv_flow_api.g_varchar2_table(786) := '202020202020202020207D202F2F204E6F7468696E67206C65667420746F2070726F636573730A20202020202020202020746869732E70726F6365737346696C652871756575656446696C65732E73686966742829293B0A20202020202020202020692B';
wwv_flow_api.g_varchar2_table(787) := '2B3B0A20202020202020207D0A2020202020207D0A202020207D0A0A202020202F2F205772617070657220666F72206070726F6365737346696C6573600A0A20207D2C207B0A202020206B65793A202270726F6365737346696C65222C0A202020207661';
wwv_flow_api.g_varchar2_table(788) := '6C75653A2066756E6374696F6E2070726F6365737346696C652866696C6529207B0A20202020202072657475726E20746869732E70726F6365737346696C6573285B66696C655D293B0A202020207D0A0A202020202F2F204C6F61647320746865206669';
wwv_flow_api.g_varchar2_table(789) := '6C652C207468656E2063616C6C732066696E69736865644C6F6164696E6728290A0A20207D2C207B0A202020206B65793A202270726F6365737346696C6573222C0A2020202076616C75653A2066756E6374696F6E2070726F6365737346696C65732866';
wwv_flow_api.g_varchar2_table(790) := '696C657329207B0A202020202020666F722028766172205F6974657261746F723139203D2066696C65732C205F697341727261793139203D20747275652C205F693230203D20302C205F6974657261746F723139203D205F697341727261793139203F20';
wwv_flow_api.g_varchar2_table(791) := '5F6974657261746F723139203A205F6974657261746F7231395B53796D626F6C2E6974657261746F725D28293B3B29207B0A2020202020202020766172205F72656631383B0A0A2020202020202020696620285F69734172726179313929207B0A202020';
wwv_flow_api.g_varchar2_table(792) := '20202020202020696620285F693230203E3D205F6974657261746F7231392E6C656E6774682920627265616B3B0A202020202020202020205F7265663138203D205F6974657261746F7231395B5F6932302B2B5D3B0A20202020202020207D20656C7365';
wwv_flow_api.g_varchar2_table(793) := '207B0A202020202020202020205F693230203D205F6974657261746F7231392E6E65787428293B0A20202020202020202020696620285F6932302E646F6E652920627265616B3B0A202020202020202020205F7265663138203D205F6932302E76616C75';
wwv_flow_api.g_varchar2_table(794) := '653B0A20202020202020207D0A0A20202020202020207661722066696C65203D205F72656631383B0A0A202020202020202066696C652E70726F63657373696E67203D20747275653B202F2F204261636B776172647320636F6D7061746962696C697479';
wwv_flow_api.g_varchar2_table(795) := '0A202020202020202066696C652E737461747573203D2044726F707A6F6E652E55504C4F4144494E473B0A0A2020202020202020746869732E656D6974282270726F63657373696E67222C2066696C65293B0A2020202020207D0A0A2020202020206966';
wwv_flow_api.g_varchar2_table(796) := '2028746869732E6F7074696F6E732E75706C6F61644D756C7469706C6529207B0A2020202020202020746869732E656D6974282270726F63657373696E676D756C7469706C65222C2066696C6573293B0A2020202020207D0A0A20202020202072657475';
wwv_flow_api.g_varchar2_table(797) := '726E20746869732E75706C6F616446696C65732866696C6573293B0A202020207D0A20207D2C207B0A202020206B65793A20225F67657446696C657357697468586872222C0A2020202076616C75653A2066756E6374696F6E205F67657446696C657357';
wwv_flow_api.g_varchar2_table(798) := '6974685868722878687229207B0A2020202020207661722066696C6573203D20766F696420303B0A20202020202072657475726E2066696C6573203D20746869732E66696C65732E66696C7465722866756E6374696F6E202866696C6529207B0A202020';
wwv_flow_api.g_varchar2_table(799) := '202020202072657475726E2066696C652E786872203D3D3D207868723B0A2020202020207D292E6D61702866756E6374696F6E202866696C6529207B0A202020202020202072657475726E2066696C653B0A2020202020207D293B0A202020207D0A0A20';
wwv_flow_api.g_varchar2_table(800) := '2020202F2F2043616E63656C73207468652066696C652075706C6F616420616E642073657473207468652073746174757320746F2043414E43454C45440A202020202F2F202A2A69662A2A207468652066696C652069732061637475616C6C7920626569';
wwv_flow_api.g_varchar2_table(801) := '6E672075706C6F616465642E0A202020202F2F2049662069742773207374696C6C20696E207468652071756575652C207468652066696C65206973206265696E672072656D6F7665642066726F6D20697420616E6420746865207374617475730A202020';
wwv_flow_api.g_varchar2_table(802) := '202F2F2073657420746F2043414E43454C45442E0A0A20207D2C207B0A202020206B65793A202263616E63656C55706C6F6164222C0A2020202076616C75653A2066756E6374696F6E2063616E63656C55706C6F61642866696C6529207B0A2020202020';
wwv_flow_api.g_varchar2_table(803) := '206966202866696C652E737461747573203D3D3D2044726F707A6F6E652E55504C4F4144494E4729207B0A20202020202020207661722067726F7570656446696C6573203D20746869732E5F67657446696C6573576974685868722866696C652E786872';
wwv_flow_api.g_varchar2_table(804) := '293B0A2020202020202020666F722028766172205F6974657261746F723230203D2067726F7570656446696C65732C205F697341727261793230203D20747275652C205F693231203D20302C205F6974657261746F723230203D205F6973417272617932';
wwv_flow_api.g_varchar2_table(805) := '30203F205F6974657261746F723230203A205F6974657261746F7232305B53796D626F6C2E6974657261746F725D28293B3B29207B0A20202020202020202020766172205F72656631393B0A0A20202020202020202020696620285F6973417272617932';
wwv_flow_api.g_varchar2_table(806) := '3029207B0A202020202020202020202020696620285F693231203E3D205F6974657261746F7232302E6C656E6774682920627265616B3B0A2020202020202020202020205F7265663139203D205F6974657261746F7232305B5F6932312B2B5D3B0A2020';
wwv_flow_api.g_varchar2_table(807) := '20202020202020207D20656C7365207B0A2020202020202020202020205F693231203D205F6974657261746F7232302E6E65787428293B0A202020202020202020202020696620285F6932312E646F6E652920627265616B3B0A20202020202020202020';
wwv_flow_api.g_varchar2_table(808) := '20205F7265663139203D205F6932312E76616C75653B0A202020202020202020207D0A0A202020202020202020207661722067726F7570656446696C65203D205F72656631393B0A0A2020202020202020202067726F7570656446696C652E7374617475';
wwv_flow_api.g_varchar2_table(809) := '73203D2044726F707A6F6E652E43414E43454C45443B0A20202020202020207D0A202020202020202069662028747970656F662066696C652E78687220213D3D2027756E646566696E65642729207B0A2020202020202020202066696C652E7868722E61';
wwv_flow_api.g_varchar2_table(810) := '626F727428293B0A20202020202020207D0A2020202020202020666F722028766172205F6974657261746F723231203D2067726F7570656446696C65732C205F697341727261793231203D20747275652C205F693232203D20302C205F6974657261746F';
wwv_flow_api.g_varchar2_table(811) := '723231203D205F697341727261793231203F205F6974657261746F723231203A205F6974657261746F7232315B53796D626F6C2E6974657261746F725D28293B3B29207B0A20202020202020202020766172205F72656632303B0A0A2020202020202020';
wwv_flow_api.g_varchar2_table(812) := '2020696620285F69734172726179323129207B0A202020202020202020202020696620285F693232203E3D205F6974657261746F7232312E6C656E6774682920627265616B3B0A2020202020202020202020205F7265663230203D205F6974657261746F';
wwv_flow_api.g_varchar2_table(813) := '7232315B5F6932322B2B5D3B0A202020202020202020207D20656C7365207B0A2020202020202020202020205F693232203D205F6974657261746F7232312E6E65787428293B0A202020202020202020202020696620285F6932322E646F6E6529206272';
wwv_flow_api.g_varchar2_table(814) := '65616B3B0A2020202020202020202020205F7265663230203D205F6932322E76616C75653B0A202020202020202020207D0A0A20202020202020202020766172205F67726F7570656446696C65203D205F72656632303B0A0A2020202020202020202074';
wwv_flow_api.g_varchar2_table(815) := '6869732E656D6974282263616E63656C6564222C205F67726F7570656446696C65293B0A20202020202020207D0A202020202020202069662028746869732E6F7074696F6E732E75706C6F61644D756C7469706C6529207B0A2020202020202020202074';
wwv_flow_api.g_varchar2_table(816) := '6869732E656D6974282263616E63656C65646D756C7469706C65222C2067726F7570656446696C6573293B0A20202020202020207D0A2020202020207D20656C7365206966202866696C652E737461747573203D3D3D2044726F707A6F6E652E41444445';
wwv_flow_api.g_varchar2_table(817) := '44207C7C2066696C652E737461747573203D3D3D2044726F707A6F6E652E51554555454429207B0A202020202020202066696C652E737461747573203D2044726F707A6F6E652E43414E43454C45443B0A2020202020202020746869732E656D69742822';
wwv_flow_api.g_varchar2_table(818) := '63616E63656C6564222C2066696C65293B0A202020202020202069662028746869732E6F7074696F6E732E75706C6F61644D756C7469706C6529207B0A20202020202020202020746869732E656D6974282263616E63656C65646D756C7469706C65222C';
wwv_flow_api.g_varchar2_table(819) := '205B66696C655D293B0A20202020202020207D0A2020202020207D0A0A20202020202069662028746869732E6F7074696F6E732E6175746F50726F63657373517565756529207B0A202020202020202072657475726E20746869732E70726F6365737351';
wwv_flow_api.g_varchar2_table(820) := '7565756528293B0A2020202020207D0A202020207D0A20207D2C207B0A202020206B65793A20227265736F6C76654F7074696F6E222C0A2020202076616C75653A2066756E6374696F6E207265736F6C76654F7074696F6E286F7074696F6E29207B0A20';
wwv_flow_api.g_varchar2_table(821) := '202020202069662028747970656F66206F7074696F6E203D3D3D202766756E6374696F6E2729207B0A2020202020202020666F722028766172205F6C656E33203D20617267756D656E74732E6C656E6774682C2061726773203D204172726179285F6C65';
wwv_flow_api.g_varchar2_table(822) := '6E33203E2031203F205F6C656E33202D2031203A2030292C205F6B657933203D20313B205F6B657933203C205F6C656E333B205F6B6579332B2B29207B0A20202020202020202020617267735B5F6B657933202D20315D203D20617267756D656E74735B';
wwv_flow_api.g_varchar2_table(823) := '5F6B6579335D3B0A20202020202020207D0A0A202020202020202072657475726E206F7074696F6E2E6170706C7928746869732C2061726773293B0A2020202020207D0A20202020202072657475726E206F7074696F6E3B0A202020207D0A20207D2C20';
wwv_flow_api.g_varchar2_table(824) := '7B0A202020206B65793A202275706C6F616446696C65222C0A2020202076616C75653A2066756E6374696F6E2075706C6F616446696C652866696C6529207B0A20202020202072657475726E20746869732E75706C6F616446696C6573285B66696C655D';
wwv_flow_api.g_varchar2_table(825) := '293B0A202020207D0A20207D2C207B0A202020206B65793A202275706C6F616446696C6573222C0A2020202076616C75653A2066756E6374696F6E2075706C6F616446696C65732866696C657329207B0A202020202020766172205F746869733134203D';
wwv_flow_api.g_varchar2_table(826) := '20746869733B0A0A202020202020746869732E5F7472616E73666F726D46696C65732866696C65732C2066756E6374696F6E20287472616E73666F726D656446696C657329207B0A20202020202020206966202866696C65735B305D2E75706C6F61642E';
wwv_flow_api.g_varchar2_table(827) := '6368756E6B656429207B0A202020202020202020202F2F20546869732066696C652073686F756C642062652073656E7420696E206368756E6B73210A0A202020202020202020202F2F20496620746865206368756E6B696E67206F7074696F6E20697320';
wwv_flow_api.g_varchar2_table(828) := '7365742C207765202A2A6B6E6F772A2A20746861742074686572652063616E206F6E6C79206265202A2A6F6E652A2A2066696C652C2073696E63650A202020202020202020202F2F2075706C6F61644D756C7469706C65206973206E6F7420616C6C6F77';
wwv_flow_api.g_varchar2_table(829) := '656420776974682074686973206F7074696F6E2E0A202020202020202020207661722066696C65203D2066696C65735B305D3B0A20202020202020202020766172207472616E73666F726D656446696C65203D207472616E73666F726D656446696C6573';
wwv_flow_api.g_varchar2_table(830) := '5B305D3B0A2020202020202020202076617220737461727465644368756E6B436F756E74203D20303B0A0A2020202020202020202066696C652E75706C6F61642E6368756E6B73203D205B5D3B0A0A202020202020202020207661722068616E646C654E';
wwv_flow_api.g_varchar2_table(831) := '6578744368756E6B203D2066756E6374696F6E2068616E646C654E6578744368756E6B2829207B0A202020202020202020202020766172206368756E6B496E646578203D20303B0A0A2020202020202020202020202F2F2046696E6420746865206E6578';
wwv_flow_api.g_varchar2_table(832) := '74206974656D20696E2066696C652E75706C6F61642E6368756E6B732074686174206973206E6F7420646566696E6564207965742E0A2020202020202020202020207768696C65202866696C652E75706C6F61642E6368756E6B735B6368756E6B496E64';
wwv_flow_api.g_varchar2_table(833) := '65785D20213D3D20756E646566696E656429207B0A20202020202020202020202020206368756E6B496E6465782B2B3B0A2020202020202020202020207D0A0A2020202020202020202020202F2F2054686973206D65616E732C207468617420616C6C20';
wwv_flow_api.g_varchar2_table(834) := '6368756E6B73206861766520616C7265616479206265656E20737461727465642E0A202020202020202020202020696620286368756E6B496E646578203E3D2066696C652E75706C6F61642E746F74616C4368756E6B436F756E74292072657475726E3B';
wwv_flow_api.g_varchar2_table(835) := '0A0A202020202020202020202020737461727465644368756E6B436F756E742B2B3B0A0A202020202020202020202020766172207374617274203D206368756E6B496E646578202A205F7468697331342E6F7074696F6E732E6368756E6B53697A653B0A';
wwv_flow_api.g_varchar2_table(836) := '20202020202020202020202076617220656E64203D204D6174682E6D696E287374617274202B205F7468697331342E6F7074696F6E732E6368756E6B53697A652C2066696C652E73697A65293B0A0A202020202020202020202020766172206461746142';
wwv_flow_api.g_varchar2_table(837) := '6C6F636B203D207B0A20202020202020202020202020206E616D653A205F7468697331342E5F676574506172616D4E616D652830292C0A2020202020202020202020202020646174613A207472616E73666F726D656446696C652E7765626B6974536C69';
wwv_flow_api.g_varchar2_table(838) := '6365203F207472616E73666F726D656446696C652E7765626B6974536C6963652873746172742C20656E6429203A207472616E73666F726D656446696C652E736C6963652873746172742C20656E64292C0A202020202020202020202020202066696C65';
wwv_flow_api.g_varchar2_table(839) := '6E616D653A2066696C652E75706C6F61642E66696C656E616D652C0A20202020202020202020202020206368756E6B496E6465783A206368756E6B496E6465780A2020202020202020202020207D3B0A0A20202020202020202020202066696C652E7570';
wwv_flow_api.g_varchar2_table(840) := '6C6F61642E6368756E6B735B6368756E6B496E6465785D203D207B0A202020202020202020202020202066696C653A2066696C652C0A2020202020202020202020202020696E6465783A206368756E6B496E6465782C0A20202020202020202020202020';
wwv_flow_api.g_varchar2_table(841) := '2064617461426C6F636B3A2064617461426C6F636B2C202F2F20496E20636173652077652077616E7420746F2072657472792E0A20202020202020202020202020207374617475733A2044726F707A6F6E652E55504C4F4144494E472C0A202020202020';
wwv_flow_api.g_varchar2_table(842) := '202020202020202070726F67726573733A20302C0A2020202020202020202020202020726574726965733A2030202F2F20546865206E756D626572206F662074696D6573207468697320626C6F636B20686173206265656E20726574726965642E0A2020';
wwv_flow_api.g_varchar2_table(843) := '202020202020202020207D3B0A0A2020202020202020202020205F7468697331342E5F75706C6F6164446174612866696C65732C205B64617461426C6F636B5D293B0A202020202020202020207D3B0A0A2020202020202020202066696C652E75706C6F';
wwv_flow_api.g_varchar2_table(844) := '61642E66696E69736865644368756E6B55706C6F6164203D2066756E6374696F6E20286368756E6B29207B0A20202020202020202020202076617220616C6C46696E6973686564203D20747275653B0A2020202020202020202020206368756E6B2E7374';
wwv_flow_api.g_varchar2_table(845) := '61747573203D2044726F707A6F6E652E535543434553533B0A0A2020202020202020202020202F2F20436C6561722074686520646174612066726F6D20746865206368756E6B0A2020202020202020202020206368756E6B2E64617461426C6F636B203D';
wwv_flow_api.g_varchar2_table(846) := '206E756C6C3B0A2020202020202020202020202F2F204C656176696E672074686973207265666572656E636520746F2078687220696E7461637420686572652077696C6C206361757365206D656D6F7279206C65616B7320696E20736F6D652062726F77';
wwv_flow_api.g_varchar2_table(847) := '736572730A2020202020202020202020206368756E6B2E786872203D206E756C6C3B0A0A202020202020202020202020666F7220287661722069203D20303B2069203C2066696C652E75706C6F61642E746F74616C4368756E6B436F756E743B20692B2B';
wwv_flow_api.g_varchar2_table(848) := '29207B0A20202020202020202020202020206966202866696C652E75706C6F61642E6368756E6B735B695D203D3D3D20756E646566696E656429207B0A2020202020202020202020202020202072657475726E2068616E646C654E6578744368756E6B28';
wwv_flow_api.g_varchar2_table(849) := '293B0A20202020202020202020202020207D0A20202020202020202020202020206966202866696C652E75706C6F61642E6368756E6B735B695D2E73746174757320213D3D2044726F707A6F6E652E5355434345535329207B0A20202020202020202020';
wwv_flow_api.g_varchar2_table(850) := '202020202020616C6C46696E6973686564203D2066616C73653B0A20202020202020202020202020207D0A2020202020202020202020207D0A0A20202020202020202020202069662028616C6C46696E697368656429207B0A2020202020202020202020';
wwv_flow_api.g_varchar2_table(851) := '2020205F7468697331342E6F7074696F6E732E6368756E6B7355706C6F616465642866696C652C2066756E6374696F6E202829207B0A202020202020202020202020202020205F7468697331342E5F66696E69736865642866696C65732C2027272C206E';
wwv_flow_api.g_varchar2_table(852) := '756C6C293B0A20202020202020202020202020207D293B0A2020202020202020202020207D0A202020202020202020207D3B0A0A20202020202020202020696620285F7468697331342E6F7074696F6E732E706172616C6C656C4368756E6B55706C6F61';
wwv_flow_api.g_varchar2_table(853) := '647329207B0A202020202020202020202020666F7220287661722069203D20303B2069203C2066696C652E75706C6F61642E746F74616C4368756E6B436F756E743B20692B2B29207B0A202020202020202020202020202068616E646C654E6578744368';
wwv_flow_api.g_varchar2_table(854) := '756E6B28293B0A2020202020202020202020207D0A202020202020202020207D20656C7365207B0A20202020202020202020202068616E646C654E6578744368756E6B28293B0A202020202020202020207D0A20202020202020207D20656C7365207B0A';
wwv_flow_api.g_varchar2_table(855) := '202020202020202020207661722064617461426C6F636B73203D205B5D3B0A20202020202020202020666F722028766172205F693233203D20303B205F693233203C2066696C65732E6C656E6774683B205F6932332B2B29207B0A202020202020202020';
wwv_flow_api.g_varchar2_table(856) := '20202064617461426C6F636B735B5F6932335D203D207B0A20202020202020202020202020206E616D653A205F7468697331342E5F676574506172616D4E616D65285F693233292C0A2020202020202020202020202020646174613A207472616E73666F';
wwv_flow_api.g_varchar2_table(857) := '726D656446696C65735B5F6932335D2C0A202020202020202020202020202066696C656E616D653A2066696C65735B5F6932335D2E75706C6F61642E66696C656E616D650A2020202020202020202020207D3B0A202020202020202020207D0A20202020';
wwv_flow_api.g_varchar2_table(858) := '2020202020205F7468697331342E5F75706C6F6164446174612866696C65732C2064617461426C6F636B73293B0A20202020202020207D0A2020202020207D293B0A202020207D0A0A202020202F2F2F2052657475726E73207468652072696768742063';
wwv_flow_api.g_varchar2_table(859) := '68756E6B20666F7220676976656E2066696C6520616E64207868720A0A20207D2C207B0A202020206B65793A20225F6765744368756E6B222C0A2020202076616C75653A2066756E6374696F6E205F6765744368756E6B2866696C652C2078687229207B';
wwv_flow_api.g_varchar2_table(860) := '0A202020202020666F7220287661722069203D20303B2069203C2066696C652E75706C6F61642E746F74616C4368756E6B436F756E743B20692B2B29207B0A20202020202020206966202866696C652E75706C6F61642E6368756E6B735B695D20213D3D';
wwv_flow_api.g_varchar2_table(861) := '20756E646566696E65642026262066696C652E75706C6F61642E6368756E6B735B695D2E786872203D3D3D2078687229207B0A2020202020202020202072657475726E2066696C652E75706C6F61642E6368756E6B735B695D3B0A20202020202020207D';
wwv_flow_api.g_varchar2_table(862) := '0A2020202020207D0A202020207D0A0A202020202F2F20546869732066756E6374696F6E2061637475616C6C792075706C6F616473207468652066696C6528732920746F20746865207365727665722E0A202020202F2F2049662064617461426C6F636B';
wwv_flow_api.g_varchar2_table(863) := '7320636F6E7461696E73207468652061637475616C206461746120746F2075706C6F616420286D65616E696E672C2074686174207468697320636F756C6420656974686572206265207472616E73666F726D65640A202020202F2F2066696C65732C206F';
wwv_flow_api.g_varchar2_table(864) := '7220696E646976696475616C206368756E6B7320666F72206368756E6B65642075706C6F6164292E0A0A20207D2C207B0A202020206B65793A20225F75706C6F616444617461222C0A2020202076616C75653A2066756E6374696F6E205F75706C6F6164';
wwv_flow_api.g_varchar2_table(865) := '446174612866696C65732C2064617461426C6F636B7329207B0A202020202020766172205F746869733135203D20746869733B0A0A20202020202076617220786872203D206E657720584D4C487474705265717565737428293B0A0A2020202020202F2F';
wwv_flow_api.g_varchar2_table(866) := '205075742074686520786872206F626A65637420696E207468652066696C65206F626A6563747320746F2062652061626C6520746F207265666572656E6365206974206C617465722E0A202020202020666F722028766172205F6974657261746F723232';
wwv_flow_api.g_varchar2_table(867) := '203D2066696C65732C205F697341727261793232203D20747275652C205F693234203D20302C205F6974657261746F723232203D205F697341727261793232203F205F6974657261746F723232203A205F6974657261746F7232325B53796D626F6C2E69';
wwv_flow_api.g_varchar2_table(868) := '74657261746F725D28293B3B29207B0A2020202020202020766172205F72656632313B0A0A2020202020202020696620285F69734172726179323229207B0A20202020202020202020696620285F693234203E3D205F6974657261746F7232322E6C656E';
wwv_flow_api.g_varchar2_table(869) := '6774682920627265616B3B0A202020202020202020205F7265663231203D205F6974657261746F7232325B5F6932342B2B5D3B0A20202020202020207D20656C7365207B0A202020202020202020205F693234203D205F6974657261746F7232322E6E65';
wwv_flow_api.g_varchar2_table(870) := '787428293B0A20202020202020202020696620285F6932342E646F6E652920627265616B3B0A202020202020202020205F7265663231203D205F6932342E76616C75653B0A20202020202020207D0A0A20202020202020207661722066696C65203D205F';
wwv_flow_api.g_varchar2_table(871) := '72656632313B0A0A202020202020202066696C652E786872203D207868723B0A2020202020207D0A2020202020206966202866696C65735B305D2E75706C6F61642E6368756E6B656429207B0A20202020202020202F2F20507574207468652078687220';
wwv_flow_api.g_varchar2_table(872) := '6F626A65637420696E20746865207269676874206368756E6B206F626A6563742C20736F2069742063616E206265206173736F636961746564206C617465722C20616E6420666F756E642077697468205F6765744368756E6B0A20202020202020206669';
wwv_flow_api.g_varchar2_table(873) := '6C65735B305D2E75706C6F61642E6368756E6B735B64617461426C6F636B735B305D2E6368756E6B496E6465785D2E786872203D207868723B0A2020202020207D0A0A202020202020766172206D6574686F64203D20746869732E7265736F6C76654F70';
wwv_flow_api.g_varchar2_table(874) := '74696F6E28746869732E6F7074696F6E732E6D6574686F642C2066696C6573293B0A2020202020207661722075726C203D20746869732E7265736F6C76654F7074696F6E28746869732E6F7074696F6E732E75726C2C2066696C6573293B0A2020202020';
wwv_flow_api.g_varchar2_table(875) := '207868722E6F70656E286D6574686F642C2075726C2C2074727565293B0A0A2020202020202F2F2053657474696E67207468652074696D656F7574206166746572206F70656E2062656361757365206F6620494531312069737375653A2068747470733A';
wwv_flow_api.g_varchar2_table(876) := '2F2F6769746C61622E636F6D2F6D656E6F2F64726F707A6F6E652F6973737565732F380A2020202020207868722E74696D656F7574203D20746869732E7265736F6C76654F7074696F6E28746869732E6F7074696F6E732E74696D656F75742C2066696C';
wwv_flow_api.g_varchar2_table(877) := '6573293B0A0A2020202020202F2F2048617320746F20626520616674657220602E6F70656E2829602E205365652068747470733A2F2F6769746875622E636F6D2F656E796F2F64726F707A6F6E652F6973737565732F3137390A2020202020207868722E';
wwv_flow_api.g_varchar2_table(878) := '7769746843726564656E7469616C73203D202121746869732E6F7074696F6E732E7769746843726564656E7469616C733B0A0A2020202020207868722E6F6E6C6F6164203D2066756E6374696F6E20286529207B0A20202020202020205F746869733135';
wwv_flow_api.g_varchar2_table(879) := '2E5F66696E697368656455706C6F6164696E672866696C65732C207868722C2065293B0A2020202020207D3B0A0A2020202020207868722E6F6E6572726F72203D2066756E6374696F6E202829207B0A20202020202020205F7468697331352E5F68616E';
wwv_flow_api.g_varchar2_table(880) := '646C6555706C6F61644572726F722866696C65732C20786872293B0A2020202020207D3B0A0A2020202020202F2F20536F6D652062726F777365727320646F206E6F74206861766520746865202E75706C6F61642070726F70657274790A202020202020';
wwv_flow_api.g_varchar2_table(881) := '7661722070726F67726573734F626A203D207868722E75706C6F616420213D206E756C6C203F207868722E75706C6F6164203A207868723B0A20202020202070726F67726573734F626A2E6F6E70726F6772657373203D2066756E6374696F6E20286529';
wwv_flow_api.g_varchar2_table(882) := '207B0A202020202020202072657475726E205F7468697331352E5F75706461746546696C657355706C6F616450726F67726573732866696C65732C207868722C2065293B0A2020202020207D3B0A0A2020202020207661722068656164657273203D207B';
wwv_flow_api.g_varchar2_table(883) := '0A202020202020202022416363657074223A20226170706C69636174696F6E2F6A736F6E222C0A20202020202020202243616368652D436F6E74726F6C223A20226E6F2D6361636865222C0A202020202020202022582D5265717565737465642D576974';
wwv_flow_api.g_varchar2_table(884) := '68223A2022584D4C4874747052657175657374220A2020202020207D3B0A0A20202020202069662028746869732E6F7074696F6E732E6865616465727329207B0A202020202020202044726F707A6F6E652E657874656E6428686561646572732C207468';
wwv_flow_api.g_varchar2_table(885) := '69732E6F7074696F6E732E68656164657273293B0A2020202020207D0A0A202020202020666F722028766172206865616465724E616D6520696E206865616465727329207B0A20202020202020207661722068656164657256616C7565203D2068656164';
wwv_flow_api.g_varchar2_table(886) := '6572735B6865616465724E616D655D3B0A20202020202020206966202868656164657256616C756529207B0A202020202020202020207868722E73657452657175657374486561646572286865616465724E616D652C2068656164657256616C7565293B';
wwv_flow_api.g_varchar2_table(887) := '0A20202020202020207D0A2020202020207D0A0A20202020202076617220666F726D44617461203D206E657720466F726D4461746128293B0A0A2020202020202F2F20416464696E6720616C6C20406F7074696F6E7320706172616D65746572730A2020';
wwv_flow_api.g_varchar2_table(888) := '2020202069662028746869732E6F7074696F6E732E706172616D7329207B0A2020202020202020766172206164646974696F6E616C506172616D73203D20746869732E6F7074696F6E732E706172616D733B0A202020202020202069662028747970656F';
wwv_flow_api.g_varchar2_table(889) := '66206164646974696F6E616C506172616D73203D3D3D202766756E6374696F6E2729207B0A202020202020202020206164646974696F6E616C506172616D73203D206164646974696F6E616C506172616D732E63616C6C28746869732C2066696C65732C';
wwv_flow_api.g_varchar2_table(890) := '207868722C2066696C65735B305D2E75706C6F61642E6368756E6B6564203F20746869732E5F6765744368756E6B2866696C65735B305D2C2078687229203A206E756C6C293B0A20202020202020207D0A0A2020202020202020666F722028766172206B';
wwv_flow_api.g_varchar2_table(891) := '657920696E206164646974696F6E616C506172616D7329207B0A202020202020202020207661722076616C7565203D206164646974696F6E616C506172616D735B6B65795D3B0A20202020202020202020666F726D446174612E617070656E64286B6579';
wwv_flow_api.g_varchar2_table(892) := '2C2076616C7565293B0A20202020202020207D0A2020202020207D0A0A2020202020202F2F204C657420746865207573657220616464206164646974696F6E616C2064617461206966206E65636573736172790A202020202020666F722028766172205F';
wwv_flow_api.g_varchar2_table(893) := '6974657261746F723233203D2066696C65732C205F697341727261793233203D20747275652C205F693235203D20302C205F6974657261746F723233203D205F697341727261793233203F205F6974657261746F723233203A205F6974657261746F7232';
wwv_flow_api.g_varchar2_table(894) := '335B53796D626F6C2E6974657261746F725D28293B3B29207B0A2020202020202020766172205F72656632323B0A0A2020202020202020696620285F69734172726179323329207B0A20202020202020202020696620285F693235203E3D205F69746572';
wwv_flow_api.g_varchar2_table(895) := '61746F7232332E6C656E6774682920627265616B3B0A202020202020202020205F7265663232203D205F6974657261746F7232335B5F6932352B2B5D3B0A20202020202020207D20656C7365207B0A202020202020202020205F693235203D205F697465';
wwv_flow_api.g_varchar2_table(896) := '7261746F7232332E6E65787428293B0A20202020202020202020696620285F6932352E646F6E652920627265616B3B0A202020202020202020205F7265663232203D205F6932352E76616C75653B0A20202020202020207D0A0A20202020202020207661';
wwv_flow_api.g_varchar2_table(897) := '72205F66696C65203D205F72656632323B0A0A2020202020202020746869732E656D6974282273656E64696E67222C205F66696C652C207868722C20666F726D44617461293B0A2020202020207D0A20202020202069662028746869732E6F7074696F6E';
wwv_flow_api.g_varchar2_table(898) := '732E75706C6F61644D756C7469706C6529207B0A2020202020202020746869732E656D6974282273656E64696E676D756C7469706C65222C2066696C65732C207868722C20666F726D44617461293B0A2020202020207D0A0A202020202020746869732E';
wwv_flow_api.g_varchar2_table(899) := '5F616464466F726D456C656D656E744461746128666F726D44617461293B0A0A2020202020202F2F2046696E616C6C7920616464207468652066696C65730A2020202020202F2F2048617320746F206265206C617374206265636175736520736F6D6520';
wwv_flow_api.g_varchar2_table(900) := '73657276657273202865673A2053332920657870656374207468652066696C6520746F20626520746865206C61737420706172616D657465720A202020202020666F7220287661722069203D20303B2069203C2064617461426C6F636B732E6C656E6774';
wwv_flow_api.g_varchar2_table(901) := '683B20692B2B29207B0A20202020202020207661722064617461426C6F636B203D2064617461426C6F636B735B695D3B0A2020202020202020666F726D446174612E617070656E642864617461426C6F636B2E6E616D652C2064617461426C6F636B2E64';
wwv_flow_api.g_varchar2_table(902) := '6174612C2064617461426C6F636B2E66696C656E616D65293B0A2020202020207D0A0A202020202020746869732E7375626D697452657175657374287868722C20666F726D446174612C2066696C6573293B0A202020207D0A0A202020202F2F20547261';
wwv_flow_api.g_varchar2_table(903) := '6E73666F726D7320616C6C2066696C6573207769746820746869732E6F7074696F6E732E7472616E73666F726D46696C6520616E6420696E766F6B657320646F6E65207769746820746865207472616E73666F726D65642066696C6573207768656E2064';
wwv_flow_api.g_varchar2_table(904) := '6F6E652E0A0A20207D2C207B0A202020206B65793A20225F7472616E73666F726D46696C6573222C0A2020202076616C75653A2066756E6374696F6E205F7472616E73666F726D46696C65732866696C65732C20646F6E6529207B0A2020202020207661';
wwv_flow_api.g_varchar2_table(905) := '72205F746869733136203D20746869733B0A0A202020202020766172207472616E73666F726D656446696C6573203D205B5D3B0A2020202020202F2F20436C756D737920776179206F662068616E646C696E67206173796E6368726F6E6F75732063616C';
wwv_flow_api.g_varchar2_table(906) := '6C732C20756E74696C20492067657420746F2061646420612070726F70657220467574757265206C6962726172792E0A20202020202076617220646F6E65436F756E746572203D20303B0A0A202020202020766172205F6C6F6F70203D2066756E637469';
wwv_flow_api.g_varchar2_table(907) := '6F6E205F6C6F6F70286929207B0A20202020202020205F7468697331362E6F7074696F6E732E7472616E73666F726D46696C652E63616C6C285F7468697331362C2066696C65735B695D2C2066756E6374696F6E20287472616E73666F726D656446696C';
wwv_flow_api.g_varchar2_table(908) := '6529207B0A202020202020202020207472616E73666F726D656446696C65735B695D203D207472616E73666F726D656446696C653B0A20202020202020202020696620282B2B646F6E65436F756E746572203D3D3D2066696C65732E6C656E6774682920';
wwv_flow_api.g_varchar2_table(909) := '7B0A202020202020202020202020646F6E65287472616E73666F726D656446696C6573293B0A202020202020202020207D0A20202020202020207D293B0A2020202020207D3B0A0A202020202020666F7220287661722069203D20303B2069203C206669';
wwv_flow_api.g_varchar2_table(910) := '6C65732E6C656E6774683B20692B2B29207B0A20202020202020205F6C6F6F702869293B0A2020202020207D0A202020207D0A0A202020202F2F2054616B65732063617265206F6620616464696E67206F7468657220696E70757420656C656D656E7473';
wwv_flow_api.g_varchar2_table(911) := '206F662074686520666F726D20746F2074686520414A415820726571756573740A0A20207D2C207B0A202020206B65793A20225F616464466F726D456C656D656E7444617461222C0A2020202076616C75653A2066756E6374696F6E205F616464466F72';
wwv_flow_api.g_varchar2_table(912) := '6D456C656D656E744461746128666F726D4461746129207B0A2020202020202F2F2054616B652063617265206F66206F7468657220696E70757420656C656D656E74730A20202020202069662028746869732E656C656D656E742E7461674E616D65203D';
wwv_flow_api.g_varchar2_table(913) := '3D3D2022464F524D2229207B0A2020202020202020666F722028766172205F6974657261746F723234203D20746869732E656C656D656E742E717565727953656C6563746F72416C6C2822696E7075742C2074657874617265612C2073656C6563742C20';
wwv_flow_api.g_varchar2_table(914) := '627574746F6E22292C205F697341727261793234203D20747275652C205F693236203D20302C205F6974657261746F723234203D205F697341727261793234203F205F6974657261746F723234203A205F6974657261746F7232345B53796D626F6C2E69';
wwv_flow_api.g_varchar2_table(915) := '74657261746F725D28293B3B29207B0A20202020202020202020766172205F72656632333B0A0A20202020202020202020696620285F69734172726179323429207B0A202020202020202020202020696620285F693236203E3D205F6974657261746F72';
wwv_flow_api.g_varchar2_table(916) := '32342E6C656E6774682920627265616B3B0A2020202020202020202020205F7265663233203D205F6974657261746F7232345B5F6932362B2B5D3B0A202020202020202020207D20656C7365207B0A2020202020202020202020205F693236203D205F69';
wwv_flow_api.g_varchar2_table(917) := '74657261746F7232342E6E65787428293B0A202020202020202020202020696620285F6932362E646F6E652920627265616B3B0A2020202020202020202020205F7265663233203D205F6932362E76616C75653B0A202020202020202020207D0A0A2020';
wwv_flow_api.g_varchar2_table(918) := '202020202020202076617220696E707574203D205F72656632333B0A0A2020202020202020202076617220696E7075744E616D65203D20696E7075742E67657441747472696275746528226E616D6522293B0A2020202020202020202076617220696E70';
wwv_flow_api.g_varchar2_table(919) := '757454797065203D20696E7075742E67657441747472696275746528227479706522293B0A2020202020202020202069662028696E707574547970652920696E70757454797065203D20696E707574547970652E746F4C6F7765724361736528293B0A0A';
wwv_flow_api.g_varchar2_table(920) := '202020202020202020202F2F2049662074686520696E70757420646F65736E277420686176652061206E616D652C2077652063616E2774207573652069742E0A2020202020202020202069662028747970656F6620696E7075744E616D65203D3D3D2027';
wwv_flow_api.g_varchar2_table(921) := '756E646566696E656427207C7C20696E7075744E616D65203D3D3D206E756C6C2920636F6E74696E75653B0A0A2020202020202020202069662028696E7075742E7461674E616D65203D3D3D202253454C4543542220262620696E7075742E6861734174';
wwv_flow_api.g_varchar2_table(922) := '7472696275746528226D756C7469706C65222929207B0A2020202020202020202020202F2F20506F737369626C79206D756C7469706C652076616C7565730A202020202020202020202020666F722028766172205F6974657261746F723235203D20696E';
wwv_flow_api.g_varchar2_table(923) := '7075742E6F7074696F6E732C205F697341727261793235203D20747275652C205F693237203D20302C205F6974657261746F723235203D205F697341727261793235203F205F6974657261746F723235203A205F6974657261746F7232355B53796D626F';
wwv_flow_api.g_varchar2_table(924) := '6C2E6974657261746F725D28293B3B29207B0A2020202020202020202020202020766172205F72656632343B0A0A2020202020202020202020202020696620285F69734172726179323529207B0A20202020202020202020202020202020696620285F69';
wwv_flow_api.g_varchar2_table(925) := '3237203E3D205F6974657261746F7232352E6C656E6774682920627265616B3B0A202020202020202020202020202020205F7265663234203D205F6974657261746F7232355B5F6932372B2B5D3B0A20202020202020202020202020207D20656C736520';
wwv_flow_api.g_varchar2_table(926) := '7B0A202020202020202020202020202020205F693237203D205F6974657261746F7232352E6E65787428293B0A20202020202020202020202020202020696620285F6932372E646F6E652920627265616B3B0A202020202020202020202020202020205F';
wwv_flow_api.g_varchar2_table(927) := '7265663234203D205F6932372E76616C75653B0A20202020202020202020202020207D0A0A2020202020202020202020202020766172206F7074696F6E203D205F72656632343B0A0A2020202020202020202020202020696620286F7074696F6E2E7365';
wwv_flow_api.g_varchar2_table(928) := '6C656374656429207B0A20202020202020202020202020202020666F726D446174612E617070656E6428696E7075744E616D652C206F7074696F6E2E76616C7565293B0A20202020202020202020202020207D0A2020202020202020202020207D0A2020';
wwv_flow_api.g_varchar2_table(929) := '20202020202020207D20656C7365206966202821696E70757454797065207C7C20696E7075745479706520213D3D2022636865636B626F782220262620696E7075745479706520213D3D2022726164696F22207C7C20696E7075742E636865636B656429';
wwv_flow_api.g_varchar2_table(930) := '207B0A202020202020202020202020666F726D446174612E617070656E6428696E7075744E616D652C20696E7075742E76616C7565293B0A202020202020202020207D0A20202020202020207D0A2020202020207D0A202020207D0A0A202020202F2F20';
wwv_flow_api.g_varchar2_table(931) := '496E766F6B6564207768656E207468657265206973206E65772070726F677265737320696E666F726D6174696F6E2061626F757420676976656E2066696C65732E0A202020202F2F2049662065206973206E6F742070726F76696465642C206974206973';
wwv_flow_api.g_varchar2_table(932) := '20617373756D65642074686174207468652075706C6F61642069732066696E69736865642E0A0A20207D2C207B0A202020206B65793A20225F75706461746546696C657355706C6F616450726F6772657373222C0A2020202076616C75653A2066756E63';
wwv_flow_api.g_varchar2_table(933) := '74696F6E205F75706461746546696C657355706C6F616450726F67726573732866696C65732C207868722C206529207B0A2020202020207661722070726F6772657373203D20766F696420303B0A20202020202069662028747970656F66206520213D3D';
wwv_flow_api.g_varchar2_table(934) := '2027756E646566696E65642729207B0A202020202020202070726F6772657373203D20313030202A20652E6C6F61646564202F20652E746F74616C3B0A0A20202020202020206966202866696C65735B305D2E75706C6F61642E6368756E6B656429207B';
wwv_flow_api.g_varchar2_table(935) := '0A202020202020202020207661722066696C65203D2066696C65735B305D3B0A202020202020202020202F2F2053696E636520746869732069732061206368756E6B65642075706C6F61642C207765206E65656420746F20757064617465207468652061';
wwv_flow_api.g_varchar2_table(936) := '7070726F707269617465206368756E6B2070726F67726573732E0A20202020202020202020766172206368756E6B203D20746869732E5F6765744368756E6B2866696C652C20786872293B0A202020202020202020206368756E6B2E70726F6772657373';
wwv_flow_api.g_varchar2_table(937) := '203D2070726F67726573733B0A202020202020202020206368756E6B2E746F74616C203D20652E746F74616C3B0A202020202020202020206368756E6B2E627974657353656E74203D20652E6C6F616465643B0A20202020202020202020766172206669';
wwv_flow_api.g_varchar2_table(938) := '6C6550726F6772657373203D20302C0A202020202020202020202020202066696C65546F74616C203D20766F696420302C0A202020202020202020202020202066696C65427974657353656E74203D20766F696420303B0A202020202020202020206669';
wwv_flow_api.g_varchar2_table(939) := '6C652E75706C6F61642E70726F6772657373203D20303B0A2020202020202020202066696C652E75706C6F61642E746F74616C203D20303B0A2020202020202020202066696C652E75706C6F61642E627974657353656E74203D20303B0A202020202020';
wwv_flow_api.g_varchar2_table(940) := '20202020666F7220287661722069203D20303B2069203C2066696C652E75706C6F61642E746F74616C4368756E6B436F756E743B20692B2B29207B0A2020202020202020202020206966202866696C652E75706C6F61642E6368756E6B735B695D20213D';
wwv_flow_api.g_varchar2_table(941) := '3D20756E646566696E65642026262066696C652E75706C6F61642E6368756E6B735B695D2E70726F677265737320213D3D20756E646566696E656429207B0A202020202020202020202020202066696C652E75706C6F61642E70726F6772657373202B3D';
wwv_flow_api.g_varchar2_table(942) := '2066696C652E75706C6F61642E6368756E6B735B695D2E70726F67726573733B0A202020202020202020202020202066696C652E75706C6F61642E746F74616C202B3D2066696C652E75706C6F61642E6368756E6B735B695D2E746F74616C3B0A202020';
wwv_flow_api.g_varchar2_table(943) := '202020202020202020202066696C652E75706C6F61642E627974657353656E74202B3D2066696C652E75706C6F61642E6368756E6B735B695D2E627974657353656E743B0A2020202020202020202020207D0A202020202020202020207D0A2020202020';
wwv_flow_api.g_varchar2_table(944) := '202020202066696C652E75706C6F61642E70726F6772657373203D2066696C652E75706C6F61642E70726F6772657373202F2066696C652E75706C6F61642E746F74616C4368756E6B436F756E743B0A20202020202020207D20656C7365207B0A202020';
wwv_flow_api.g_varchar2_table(945) := '20202020202020666F722028766172205F6974657261746F723236203D2066696C65732C205F697341727261793236203D20747275652C205F693238203D20302C205F6974657261746F723236203D205F697341727261793236203F205F697465726174';
wwv_flow_api.g_varchar2_table(946) := '6F723236203A205F6974657261746F7232365B53796D626F6C2E6974657261746F725D28293B3B29207B0A202020202020202020202020766172205F72656632353B0A0A202020202020202020202020696620285F69734172726179323629207B0A2020';
wwv_flow_api.g_varchar2_table(947) := '202020202020202020202020696620285F693238203E3D205F6974657261746F7232362E6C656E6774682920627265616B3B0A20202020202020202020202020205F7265663235203D205F6974657261746F7232365B5F6932382B2B5D3B0A2020202020';
wwv_flow_api.g_varchar2_table(948) := '202020202020207D20656C7365207B0A20202020202020202020202020205F693238203D205F6974657261746F7232362E6E65787428293B0A2020202020202020202020202020696620285F6932382E646F6E652920627265616B3B0A20202020202020';
wwv_flow_api.g_varchar2_table(949) := '202020202020205F7265663235203D205F6932382E76616C75653B0A2020202020202020202020207D0A0A202020202020202020202020766172205F66696C6532203D205F72656632353B0A0A2020202020202020202020205F66696C65322E75706C6F';
wwv_flow_api.g_varchar2_table(950) := '61642E70726F6772657373203D2070726F67726573733B0A2020202020202020202020205F66696C65322E75706C6F61642E746F74616C203D20652E746F74616C3B0A2020202020202020202020205F66696C65322E75706C6F61642E62797465735365';
wwv_flow_api.g_varchar2_table(951) := '6E74203D20652E6C6F616465643B0A202020202020202020207D0A20202020202020207D0A2020202020202020666F722028766172205F6974657261746F723237203D2066696C65732C205F697341727261793237203D20747275652C205F693239203D';
wwv_flow_api.g_varchar2_table(952) := '20302C205F6974657261746F723237203D205F697341727261793237203F205F6974657261746F723237203A205F6974657261746F7232375B53796D626F6C2E6974657261746F725D28293B3B29207B0A20202020202020202020766172205F72656632';
wwv_flow_api.g_varchar2_table(953) := '363B0A0A20202020202020202020696620285F69734172726179323729207B0A202020202020202020202020696620285F693239203E3D205F6974657261746F7232372E6C656E6774682920627265616B3B0A2020202020202020202020205F72656632';
wwv_flow_api.g_varchar2_table(954) := '36203D205F6974657261746F7232375B5F6932392B2B5D3B0A202020202020202020207D20656C7365207B0A2020202020202020202020205F693239203D205F6974657261746F7232372E6E65787428293B0A202020202020202020202020696620285F';
wwv_flow_api.g_varchar2_table(955) := '6932392E646F6E652920627265616B3B0A2020202020202020202020205F7265663236203D205F6932392E76616C75653B0A202020202020202020207D0A0A20202020202020202020766172205F66696C6533203D205F72656632363B0A0A2020202020';
wwv_flow_api.g_varchar2_table(956) := '2020202020746869732E656D6974282275706C6F616470726F6772657373222C205F66696C65332C205F66696C65332E75706C6F61642E70726F67726573732C205F66696C65332E75706C6F61642E627974657353656E74293B0A20202020202020207D';
wwv_flow_api.g_varchar2_table(957) := '0A2020202020207D20656C7365207B0A20202020202020202F2F2043616C6C6564207768656E207468652066696C652066696E69736865642075706C6F6164696E670A0A202020202020202076617220616C6C46696C657346696E6973686564203D2074';
wwv_flow_api.g_varchar2_table(958) := '7275653B0A0A202020202020202070726F6772657373203D203130303B0A0A2020202020202020666F722028766172205F6974657261746F723238203D2066696C65732C205F697341727261793238203D20747275652C205F693330203D20302C205F69';
wwv_flow_api.g_varchar2_table(959) := '74657261746F723238203D205F697341727261793238203F205F6974657261746F723238203A205F6974657261746F7232385B53796D626F6C2E6974657261746F725D28293B3B29207B0A20202020202020202020766172205F72656632373B0A0A2020';
wwv_flow_api.g_varchar2_table(960) := '2020202020202020696620285F69734172726179323829207B0A202020202020202020202020696620285F693330203E3D205F6974657261746F7232382E6C656E6774682920627265616B3B0A2020202020202020202020205F7265663237203D205F69';
wwv_flow_api.g_varchar2_table(961) := '74657261746F7232385B5F6933302B2B5D3B0A202020202020202020207D20656C7365207B0A2020202020202020202020205F693330203D205F6974657261746F7232382E6E65787428293B0A202020202020202020202020696620285F6933302E646F';
wwv_flow_api.g_varchar2_table(962) := '6E652920627265616B3B0A2020202020202020202020205F7265663237203D205F6933302E76616C75653B0A202020202020202020207D0A0A20202020202020202020766172205F66696C6534203D205F72656632373B0A0A2020202020202020202069';
wwv_flow_api.g_varchar2_table(963) := '6620285F66696C65342E75706C6F61642E70726F677265737320213D3D20313030207C7C205F66696C65342E75706C6F61642E627974657353656E7420213D3D205F66696C65342E75706C6F61642E746F74616C29207B0A202020202020202020202020';
wwv_flow_api.g_varchar2_table(964) := '616C6C46696C657346696E6973686564203D2066616C73653B0A202020202020202020207D0A202020202020202020205F66696C65342E75706C6F61642E70726F6772657373203D2070726F67726573733B0A202020202020202020205F66696C65342E';
wwv_flow_api.g_varchar2_table(965) := '75706C6F61642E627974657353656E74203D205F66696C65342E75706C6F61642E746F74616C3B0A20202020202020207D0A0A20202020202020202F2F204E6F7468696E6720746F20646F2C20616C6C2066696C657320616C7265616479206174203130';
wwv_flow_api.g_varchar2_table(966) := '30250A202020202020202069662028616C6C46696C657346696E697368656429207B0A2020202020202020202072657475726E3B0A20202020202020207D0A0A2020202020202020666F722028766172205F6974657261746F723239203D2066696C6573';
wwv_flow_api.g_varchar2_table(967) := '2C205F697341727261793239203D20747275652C205F693331203D20302C205F6974657261746F723239203D205F697341727261793239203F205F6974657261746F723239203A205F6974657261746F7232395B53796D626F6C2E6974657261746F725D';
wwv_flow_api.g_varchar2_table(968) := '28293B3B29207B0A20202020202020202020766172205F72656632383B0A0A20202020202020202020696620285F69734172726179323929207B0A202020202020202020202020696620285F693331203E3D205F6974657261746F7232392E6C656E6774';
wwv_flow_api.g_varchar2_table(969) := '682920627265616B3B0A2020202020202020202020205F7265663238203D205F6974657261746F7232395B5F6933312B2B5D3B0A202020202020202020207D20656C7365207B0A2020202020202020202020205F693331203D205F6974657261746F7232';
wwv_flow_api.g_varchar2_table(970) := '392E6E65787428293B0A202020202020202020202020696620285F6933312E646F6E652920627265616B3B0A2020202020202020202020205F7265663238203D205F6933312E76616C75653B0A202020202020202020207D0A0A20202020202020202020';
wwv_flow_api.g_varchar2_table(971) := '766172205F66696C6535203D205F72656632383B0A0A20202020202020202020746869732E656D6974282275706C6F616470726F6772657373222C205F66696C65352C2070726F67726573732C205F66696C65352E75706C6F61642E627974657353656E';
wwv_flow_api.g_varchar2_table(972) := '74293B0A20202020202020207D0A2020202020207D0A202020207D0A20207D2C207B0A202020206B65793A20225F66696E697368656455706C6F6164696E67222C0A2020202076616C75653A2066756E6374696F6E205F66696E697368656455706C6F61';
wwv_flow_api.g_varchar2_table(973) := '64696E672866696C65732C207868722C206529207B0A20202020202076617220726573706F6E7365203D20766F696420303B0A0A2020202020206966202866696C65735B305D2E737461747573203D3D3D2044726F707A6F6E652E43414E43454C454429';
wwv_flow_api.g_varchar2_table(974) := '207B0A202020202020202072657475726E3B0A2020202020207D0A0A202020202020696620287868722E7265616479537461746520213D3D203429207B0A202020202020202072657475726E3B0A2020202020207D0A0A20202020202069662028786872';
wwv_flow_api.g_varchar2_table(975) := '2E726573706F6E73655479706520213D3D2027617272617962756666657227202626207868722E726573706F6E73655479706520213D3D2027626C6F622729207B0A2020202020202020726573706F6E7365203D207868722E726573706F6E7365546578';
wwv_flow_api.g_varchar2_table(976) := '743B0A0A2020202020202020696620287868722E676574526573706F6E73654865616465722822636F6E74656E742D747970652229202626207E7868722E676574526573706F6E73654865616465722822636F6E74656E742D7479706522292E696E6465';
wwv_flow_api.g_varchar2_table(977) := '784F6628226170706C69636174696F6E2F6A736F6E222929207B0A20202020202020202020747279207B0A202020202020202020202020726573706F6E7365203D204A534F4E2E706172736528726573706F6E7365293B0A202020202020202020207D20';
wwv_flow_api.g_varchar2_table(978) := '636174636820286572726F7229207B0A20202020202020202020202065203D206572726F723B0A202020202020202020202020726573706F6E7365203D2022496E76616C6964204A534F4E20726573706F6E73652066726F6D207365727665722E223B0A';
wwv_flow_api.g_varchar2_table(979) := '202020202020202020207D0A20202020202020207D0A2020202020207D0A0A202020202020746869732E5F75706461746546696C657355706C6F616450726F67726573732866696C6573293B0A0A202020202020696620282128323030203C3D20786872';
wwv_flow_api.g_varchar2_table(980) := '2E737461747573202626207868722E737461747573203C203330302929207B0A2020202020202020746869732E5F68616E646C6555706C6F61644572726F722866696C65732C207868722C20726573706F6E7365293B0A2020202020207D20656C736520';
wwv_flow_api.g_varchar2_table(981) := '7B0A20202020202020206966202866696C65735B305D2E75706C6F61642E6368756E6B656429207B0A2020202020202020202066696C65735B305D2E75706C6F61642E66696E69736865644368756E6B55706C6F616428746869732E5F6765744368756E';
wwv_flow_api.g_varchar2_table(982) := '6B2866696C65735B305D2C2078687229293B0A20202020202020207D20656C7365207B0A20202020202020202020746869732E5F66696E69736865642866696C65732C20726573706F6E73652C2065293B0A20202020202020207D0A2020202020207D0A';
wwv_flow_api.g_varchar2_table(983) := '202020207D0A20207D2C207B0A202020206B65793A20225F68616E646C6555706C6F61644572726F72222C0A2020202076616C75653A2066756E6374696F6E205F68616E646C6555706C6F61644572726F722866696C65732C207868722C20726573706F';
wwv_flow_api.g_varchar2_table(984) := '6E736529207B0A2020202020206966202866696C65735B305D2E737461747573203D3D3D2044726F707A6F6E652E43414E43454C454429207B0A202020202020202072657475726E3B0A2020202020207D0A0A2020202020206966202866696C65735B30';
wwv_flow_api.g_varchar2_table(985) := '5D2E75706C6F61642E6368756E6B656420262620746869732E6F7074696F6E732E72657472794368756E6B7329207B0A2020202020202020766172206368756E6B203D20746869732E5F6765744368756E6B2866696C65735B305D2C20786872293B0A20';
wwv_flow_api.g_varchar2_table(986) := '20202020202020696620286368756E6B2E726574726965732B2B203C20746869732E6F7074696F6E732E72657472794368756E6B734C696D697429207B0A20202020202020202020746869732E5F75706C6F6164446174612866696C65732C205B636875';
wwv_flow_api.g_varchar2_table(987) := '6E6B2E64617461426C6F636B5D293B0A2020202020202020202072657475726E3B0A20202020202020207D20656C7365207B0A20202020202020202020636F6E736F6C652E7761726E2827526574726965642074686973206368756E6B20746F6F206F66';
wwv_flow_api.g_varchar2_table(988) := '74656E2E20476976696E672075702E27293B0A20202020202020207D0A2020202020207D0A0A202020202020666F722028766172205F6974657261746F723330203D2066696C65732C205F697341727261793330203D20747275652C205F693332203D20';
wwv_flow_api.g_varchar2_table(989) := '302C205F6974657261746F723330203D205F697341727261793330203F205F6974657261746F723330203A205F6974657261746F7233305B53796D626F6C2E6974657261746F725D28293B3B29207B0A2020202020202020766172205F72656632393B0A';
wwv_flow_api.g_varchar2_table(990) := '0A2020202020202020696620285F69734172726179333029207B0A20202020202020202020696620285F693332203E3D205F6974657261746F7233302E6C656E6774682920627265616B3B0A202020202020202020205F7265663239203D205F69746572';
wwv_flow_api.g_varchar2_table(991) := '61746F7233305B5F6933322B2B5D3B0A20202020202020207D20656C7365207B0A202020202020202020205F693332203D205F6974657261746F7233302E6E65787428293B0A20202020202020202020696620285F6933322E646F6E652920627265616B';
wwv_flow_api.g_varchar2_table(992) := '3B0A202020202020202020205F7265663239203D205F6933322E76616C75653B0A20202020202020207D0A0A20202020202020207661722066696C65203D205F72656632393B0A0A2020202020202020746869732E5F6572726F7250726F63657373696E';
wwv_flow_api.g_varchar2_table(993) := '672866696C65732C20726573706F6E7365207C7C20746869732E6F7074696F6E732E64696374526573706F6E73654572726F722E7265706C61636528227B7B737461747573436F64657D7D222C207868722E737461747573292C20786872293B0A202020';
wwv_flow_api.g_varchar2_table(994) := '2020207D0A202020207D0A20207D2C207B0A202020206B65793A20227375626D697452657175657374222C0A2020202076616C75653A2066756E6374696F6E207375626D697452657175657374287868722C20666F726D446174612C2066696C65732920';
wwv_flow_api.g_varchar2_table(995) := '7B0A2020202020207868722E73656E6428666F726D44617461293B0A202020207D0A0A202020202F2F2043616C6C656420696E7465726E616C6C79207768656E2070726F63657373696E672069732066696E69736865642E0A202020202F2F20496E6469';
wwv_flow_api.g_varchar2_table(996) := '76696475616C2063616C6C6261636B73206861766520746F2062652063616C6C656420696E2074686520617070726F7072696174652073656374696F6E732E0A0A20207D2C207B0A202020206B65793A20225F66696E6973686564222C0A202020207661';
wwv_flow_api.g_varchar2_table(997) := '6C75653A2066756E6374696F6E205F66696E69736865642866696C65732C20726573706F6E7365546578742C206529207B0A202020202020666F722028766172205F6974657261746F723331203D2066696C65732C205F697341727261793331203D2074';
wwv_flow_api.g_varchar2_table(998) := '7275652C205F693333203D20302C205F6974657261746F723331203D205F697341727261793331203F205F6974657261746F723331203A205F6974657261746F7233315B53796D626F6C2E6974657261746F725D28293B3B29207B0A2020202020202020';
wwv_flow_api.g_varchar2_table(999) := '766172205F72656633303B0A0A2020202020202020696620285F69734172726179333129207B0A20202020202020202020696620285F693333203E3D205F6974657261746F7233312E6C656E6774682920627265616B3B0A202020202020202020205F72';
wwv_flow_api.g_varchar2_table(1000) := '65663330203D205F6974657261746F7233315B5F6933332B2B5D3B0A20202020202020207D20656C7365207B0A202020202020202020205F693333203D205F6974657261746F7233312E6E65787428293B0A20202020202020202020696620285F693333';
wwv_flow_api.g_varchar2_table(1001) := '2E646F6E652920627265616B3B0A202020202020202020205F7265663330203D205F6933332E76616C75653B0A20202020202020207D0A0A20202020202020207661722066696C65203D205F72656633303B0A0A202020202020202066696C652E737461';
wwv_flow_api.g_varchar2_table(1002) := '747573203D2044726F707A6F6E652E535543434553533B0A2020202020202020746869732E656D6974282273756363657373222C2066696C652C20726573706F6E7365546578742C2065293B0A2020202020202020746869732E656D69742822636F6D70';
wwv_flow_api.g_varchar2_table(1003) := '6C657465222C2066696C65293B0A2020202020207D0A20202020202069662028746869732E6F7074696F6E732E75706C6F61644D756C7469706C6529207B0A2020202020202020746869732E656D69742822737563636573736D756C7469706C65222C20';
wwv_flow_api.g_varchar2_table(1004) := '66696C65732C20726573706F6E7365546578742C2065293B0A2020202020202020746869732E656D69742822636F6D706C6574656D756C7469706C65222C2066696C6573293B0A2020202020207D0A0A20202020202069662028746869732E6F7074696F';
wwv_flow_api.g_varchar2_table(1005) := '6E732E6175746F50726F63657373517565756529207B0A202020202020202072657475726E20746869732E70726F63657373517565756528293B0A2020202020207D0A202020207D0A0A202020202F2F2043616C6C656420696E7465726E616C6C792077';
wwv_flow_api.g_varchar2_table(1006) := '68656E2070726F63657373696E672069732066696E69736865642E0A202020202F2F20496E646976696475616C2063616C6C6261636B73206861766520746F2062652063616C6C656420696E2074686520617070726F7072696174652073656374696F6E';
wwv_flow_api.g_varchar2_table(1007) := '732E0A0A20207D2C207B0A202020206B65793A20225F6572726F7250726F63657373696E67222C0A2020202076616C75653A2066756E6374696F6E205F6572726F7250726F63657373696E672866696C65732C206D6573736167652C2078687229207B0A';
wwv_flow_api.g_varchar2_table(1008) := '202020202020666F722028766172205F6974657261746F723332203D2066696C65732C205F697341727261793332203D20747275652C205F693334203D20302C205F6974657261746F723332203D205F697341727261793332203F205F6974657261746F';
wwv_flow_api.g_varchar2_table(1009) := '723332203A205F6974657261746F7233325B53796D626F6C2E6974657261746F725D28293B3B29207B0A2020202020202020766172205F72656633313B0A0A2020202020202020696620285F69734172726179333229207B0A2020202020202020202069';
wwv_flow_api.g_varchar2_table(1010) := '6620285F693334203E3D205F6974657261746F7233322E6C656E6774682920627265616B3B0A202020202020202020205F7265663331203D205F6974657261746F7233325B5F6933342B2B5D3B0A20202020202020207D20656C7365207B0A2020202020';
wwv_flow_api.g_varchar2_table(1011) := '20202020205F693334203D205F6974657261746F7233322E6E65787428293B0A20202020202020202020696620285F6933342E646F6E652920627265616B3B0A202020202020202020205F7265663331203D205F6933342E76616C75653B0A2020202020';
wwv_flow_api.g_varchar2_table(1012) := '2020207D0A0A20202020202020207661722066696C65203D205F72656633313B0A0A202020202020202066696C652E737461747573203D2044726F707A6F6E652E4552524F523B0A2020202020202020746869732E656D697428226572726F72222C2066';
wwv_flow_api.g_varchar2_table(1013) := '696C652C206D6573736167652C20786872293B0A2020202020202020746869732E656D69742822636F6D706C657465222C2066696C65293B0A2020202020207D0A20202020202069662028746869732E6F7074696F6E732E75706C6F61644D756C746970';
wwv_flow_api.g_varchar2_table(1014) := '6C6529207B0A2020202020202020746869732E656D697428226572726F726D756C7469706C65222C2066696C65732C206D6573736167652C20786872293B0A2020202020202020746869732E656D69742822636F6D706C6574656D756C7469706C65222C';
wwv_flow_api.g_varchar2_table(1015) := '2066696C6573293B0A2020202020207D0A0A20202020202069662028746869732E6F7074696F6E732E6175746F50726F63657373517565756529207B0A202020202020202072657475726E20746869732E70726F63657373517565756528293B0A202020';
wwv_flow_api.g_varchar2_table(1016) := '2020207D0A202020207D0A20207D5D2C205B7B0A202020206B65793A2022757569647634222C0A2020202076616C75653A2066756E6374696F6E207575696476342829207B0A20202020202072657475726E202778787878787878782D787878782D3478';
wwv_flow_api.g_varchar2_table(1017) := '78782D797878782D787878787878787878787878272E7265706C616365282F5B78795D2F672C2066756E6374696F6E20286329207B0A20202020202020207661722072203D204D6174682E72616E646F6D2829202A203136207C20302C0A202020202020';
wwv_flow_api.g_varchar2_table(1018) := '20202020202076203D2063203D3D3D20277827203F2072203A2072202620307833207C203078383B0A202020202020202072657475726E20762E746F537472696E67283136293B0A2020202020207D293B0A202020207D0A20207D5D293B0A0A20207265';
wwv_flow_api.g_varchar2_table(1019) := '7475726E2044726F707A6F6E653B0A7D28456D6974746572293B0A0A44726F707A6F6E652E696E6974436C61737328293B0A0A44726F707A6F6E652E76657273696F6E203D2022352E352E30223B0A0A2F2F20546869732069732061206D6170206F6620';
wwv_flow_api.g_varchar2_table(1020) := '6F7074696F6E7320666F7220796F757220646966666572656E742064726F707A6F6E65732E2041646420636F6E66696775726174696F6E730A2F2F20746F2074686973206F626A65637420666F7220796F757220646966666572656E742064726F707A6F';
wwv_flow_api.g_varchar2_table(1021) := '6E6520656C656D656E732E0A2F2F0A2F2F204578616D706C653A0A2F2F0A2F2F202020202044726F707A6F6E652E6F7074696F6E732E6D7944726F707A6F6E65456C656D656E744964203D207B206D617846696C6573697A653A2031207D3B0A2F2F0A2F';
wwv_flow_api.g_varchar2_table(1022) := '2F20546F2064697361626C65206175746F446973636F76657220666F72206120737065636966696320656C656D656E742C20796F752063616E20736574206066616C73656020617320616E206F7074696F6E3A0A2F2F0A2F2F202020202044726F707A6F';
wwv_flow_api.g_varchar2_table(1023) := '6E652E6F7074696F6E732E6D7944697361626C6564456C656D656E744964203D2066616C73653B0A2F2F0A2F2F20416E6420696E2068746D6C3A0A2F2F0A2F2F20202020203C666F726D20616374696F6E3D222F75706C6F6164222069643D226D792D64';
wwv_flow_api.g_varchar2_table(1024) := '726F707A6F6E652D656C656D656E742D69642220636C6173733D2264726F707A6F6E65223E3C2F666F726D3E0A44726F707A6F6E652E6F7074696F6E73203D207B7D3B0A0A2F2F2052657475726E7320746865206F7074696F6E7320666F7220616E2065';
wwv_flow_api.g_varchar2_table(1025) := '6C656D656E74206F7220756E646566696E6564206966206E6F6E6520617661696C61626C652E0A44726F707A6F6E652E6F7074696F6E73466F72456C656D656E74203D2066756E6374696F6E2028656C656D656E7429207B0A20202F2F20476574207468';
wwv_flow_api.g_varchar2_table(1026) := '65206044726F707A6F6E652E6F7074696F6E732E656C656D656E7449646020666F72207468697320656C656D656E74206966206974206578697374730A202069662028656C656D656E742E67657441747472696275746528226964222929207B0A202020';
wwv_flow_api.g_varchar2_table(1027) := '2072657475726E2044726F707A6F6E652E6F7074696F6E735B63616D656C697A6528656C656D656E742E676574417474726962757465282269642229295D3B0A20207D20656C7365207B0A2020202072657475726E20756E646566696E65643B0A20207D';
wwv_flow_api.g_varchar2_table(1028) := '0A7D3B0A0A2F2F20486F6C64732061206C697374206F6620616C6C2064726F707A6F6E6520696E7374616E6365730A44726F707A6F6E652E696E7374616E636573203D205B5D3B0A0A2F2F2052657475726E73207468652064726F707A6F6E6520666F72';
wwv_flow_api.g_varchar2_table(1029) := '20676976656E20656C656D656E7420696620616E790A44726F707A6F6E652E666F72456C656D656E74203D2066756E6374696F6E2028656C656D656E7429207B0A202069662028747970656F6620656C656D656E74203D3D3D2022737472696E67222920';
wwv_flow_api.g_varchar2_table(1030) := '7B0A20202020656C656D656E74203D20646F63756D656E742E717565727953656C6563746F7228656C656D656E74293B0A20207D0A20206966202828656C656D656E7420213D206E756C6C203F20656C656D656E742E64726F707A6F6E65203A20756E64';
wwv_flow_api.g_varchar2_table(1031) := '6566696E656429203D3D206E756C6C29207B0A202020207468726F77206E6577204572726F7228224E6F2044726F707A6F6E6520666F756E6420666F7220676976656E20656C656D656E742E20546869732069732070726F6261626C7920626563617573';
wwv_flow_api.g_varchar2_table(1032) := '6520796F7527726520747279696E6720746F20616363657373206974206265666F72652044726F707A6F6E6520686164207468652074696D6520746F20696E697469616C697A652E20557365207468652060696E697460206F7074696F6E20746F207365';
wwv_flow_api.g_varchar2_table(1033) := '74757020616E79206164646974696F6E616C206F6273657276657273206F6E20796F75722044726F707A6F6E652E22293B0A20207D0A202072657475726E20656C656D656E742E64726F707A6F6E653B0A7D3B0A0A2F2F2053657420746F2066616C7365';
wwv_flow_api.g_varchar2_table(1034) := '20696620796F7520646F6E27742077616E742044726F707A6F6E6520746F206175746F6D61746963616C6C792066696E6420616E642061747461636820746F202E64726F707A6F6E6520656C656D656E74732E0A44726F707A6F6E652E6175746F446973';
wwv_flow_api.g_varchar2_table(1035) := '636F766572203D2066616C73653B0A0A2F2F204C6F6F6B7320666F7220616C6C202E64726F707A6F6E6520656C656D656E747320616E64206372656174657320612064726F707A6F6E6520666F72207468656D0A44726F707A6F6E652E646973636F7665';
wwv_flow_api.g_varchar2_table(1036) := '72203D2066756E6374696F6E202829207B0A20207661722064726F707A6F6E6573203D20766F696420303B0A202069662028646F63756D656E742E717565727953656C6563746F72416C6C29207B0A2020202064726F707A6F6E6573203D20646F63756D';
wwv_flow_api.g_varchar2_table(1037) := '656E742E717565727953656C6563746F72416C6C28222E64726F707A6F6E6522293B0A20207D20656C7365207B0A2020202064726F707A6F6E6573203D205B5D3B0A202020202F2F204945203A280A2020202076617220636865636B456C656D656E7473';
wwv_flow_api.g_varchar2_table(1038) := '203D2066756E6374696F6E20636865636B456C656D656E747328656C656D656E747329207B0A20202020202072657475726E2066756E6374696F6E202829207B0A202020202020202076617220726573756C74203D205B5D3B0A2020202020202020666F';
wwv_flow_api.g_varchar2_table(1039) := '722028766172205F6974657261746F723333203D20656C656D656E74732C205F697341727261793333203D20747275652C205F693335203D20302C205F6974657261746F723333203D205F697341727261793333203F205F6974657261746F723333203A';
wwv_flow_api.g_varchar2_table(1040) := '205F6974657261746F7233335B53796D626F6C2E6974657261746F725D28293B3B29207B0A20202020202020202020766172205F72656633323B0A0A20202020202020202020696620285F69734172726179333329207B0A202020202020202020202020';
wwv_flow_api.g_varchar2_table(1041) := '696620285F693335203E3D205F6974657261746F7233332E6C656E6774682920627265616B3B0A2020202020202020202020205F7265663332203D205F6974657261746F7233335B5F6933352B2B5D3B0A202020202020202020207D20656C7365207B0A';
wwv_flow_api.g_varchar2_table(1042) := '2020202020202020202020205F693335203D205F6974657261746F7233332E6E65787428293B0A202020202020202020202020696620285F6933352E646F6E652920627265616B3B0A2020202020202020202020205F7265663332203D205F6933352E76';
wwv_flow_api.g_varchar2_table(1043) := '616C75653B0A202020202020202020207D0A0A2020202020202020202076617220656C203D205F72656633323B0A0A20202020202020202020696620282F285E7C202964726F707A6F6E6528247C20292F2E7465737428656C2E636C6173734E616D6529';
wwv_flow_api.g_varchar2_table(1044) := '29207B0A202020202020202020202020726573756C742E707573682864726F707A6F6E65732E7075736828656C29293B0A202020202020202020207D20656C7365207B0A202020202020202020202020726573756C742E7075736828756E646566696E65';
wwv_flow_api.g_varchar2_table(1045) := '64293B0A202020202020202020207D0A20202020202020207D0A202020202020202072657475726E20726573756C743B0A2020202020207D28293B0A202020207D3B0A20202020636865636B456C656D656E747328646F63756D656E742E676574456C65';
wwv_flow_api.g_varchar2_table(1046) := '6D656E747342795461674E616D6528226469762229293B0A20202020636865636B456C656D656E747328646F63756D656E742E676574456C656D656E747342795461674E616D652822666F726D2229293B0A20207D0A0A202072657475726E2066756E63';
wwv_flow_api.g_varchar2_table(1047) := '74696F6E202829207B0A2020202076617220726573756C74203D205B5D3B0A20202020666F722028766172205F6974657261746F723334203D2064726F707A6F6E65732C205F697341727261793334203D20747275652C205F693336203D20302C205F69';
wwv_flow_api.g_varchar2_table(1048) := '74657261746F723334203D205F697341727261793334203F205F6974657261746F723334203A205F6974657261746F7233345B53796D626F6C2E6974657261746F725D28293B3B29207B0A202020202020766172205F72656633333B0A0A202020202020';
wwv_flow_api.g_varchar2_table(1049) := '696620285F69734172726179333429207B0A2020202020202020696620285F693336203E3D205F6974657261746F7233342E6C656E6774682920627265616B3B0A20202020202020205F7265663333203D205F6974657261746F7233345B5F6933362B2B';
wwv_flow_api.g_varchar2_table(1050) := '5D3B0A2020202020207D20656C7365207B0A20202020202020205F693336203D205F6974657261746F7233342E6E65787428293B0A2020202020202020696620285F6933362E646F6E652920627265616B3B0A20202020202020205F7265663333203D20';
wwv_flow_api.g_varchar2_table(1051) := '5F6933362E76616C75653B0A2020202020207D0A0A2020202020207661722064726F707A6F6E65203D205F72656633333B0A0A2020202020202F2F2043726561746520612064726F707A6F6E6520756E6C657373206175746F20646973636F7665722068';
wwv_flow_api.g_varchar2_table(1052) := '6173206265656E2064697361626C656420666F7220737065636966696320656C656D656E740A2020202020206966202844726F707A6F6E652E6F7074696F6E73466F72456C656D656E742864726F707A6F6E652920213D3D2066616C736529207B0A2020';
wwv_flow_api.g_varchar2_table(1053) := '202020202020726573756C742E70757368286E65772044726F707A6F6E652864726F707A6F6E6529293B0A2020202020207D20656C7365207B0A2020202020202020726573756C742E7075736828756E646566696E6564293B0A2020202020207D0A2020';
wwv_flow_api.g_varchar2_table(1054) := '20207D0A2020202072657475726E20726573756C743B0A20207D28293B0A7D3B0A0A2F2F2053696E6365207468652077686F6C652044726167276E2744726F702041504920697320707265747479206E65772C20736F6D652062726F777365727320696D';
wwv_flow_api.g_varchar2_table(1055) := '706C656D656E742069742C0A2F2F20627574206E6F7420636F72726563746C792E0A2F2F20536F20492063726561746564206120626C61636B6C697374206F6620757365724167656E74732E205965732C207965732E2042726F7773657220736E696666';
wwv_flow_api.g_varchar2_table(1056) := '696E672C2049206B6E6F772E0A2F2F20427574207768617420746F20646F207768656E2062726F7773657273202A7468656F7265746963616C6C792A20737570706F727420616E204150492C206275742063726173680A2F2F207768656E207573696E67';
wwv_flow_api.g_varchar2_table(1057) := '2069742E0A2F2F0A2F2F20546869732069732061206C697374206F6620726567756C61722065787072657373696F6E732074657374656420616761696E7374206E6176696761746F722E757365724167656E740A2F2F0A2F2F202A2A2049742073686F75';
wwv_flow_api.g_varchar2_table(1058) := '6C64206F6E6C792062652075736564206F6E2062726F777365722074686174202A646F2A20737570706F727420746865204150492C206275740A2F2F20696E636F72726563746C79202A2A0A2F2F0A44726F707A6F6E652E626C61636B6C697374656442';
wwv_flow_api.g_varchar2_table(1059) := '726F7773657273203D205B0A2F2F20546865206D6163206F7320616E642077696E646F77732070686F6E652076657273696F6E206F66206F70657261203132207365656D7320746F206861766520612070726F626C656D2077697468207468652046696C';
wwv_flow_api.g_varchar2_table(1060) := '652064726167276E2764726F70204150492E0A2F6F706572612E2A284D6163696E746F73687C57696E646F77732050686F6E65292E2A76657273696F6E5C2F31322F695D3B0A0A2F2F20436865636B73206966207468652062726F777365722069732073';
wwv_flow_api.g_varchar2_table(1061) := '7570706F727465640A44726F707A6F6E652E697342726F77736572537570706F72746564203D2066756E6374696F6E202829207B0A20207661722063617061626C6542726F77736572203D20747275653B0A0A20206966202877696E646F772E46696C65';
wwv_flow_api.g_varchar2_table(1062) := '2026262077696E646F772E46696C655265616465722026262077696E646F772E46696C654C6973742026262077696E646F772E426C6F622026262077696E646F772E466F726D4461746120262620646F63756D656E742E717565727953656C6563746F72';
wwv_flow_api.g_varchar2_table(1063) := '29207B0A2020202069662028212822636C6173734C6973742220696E20646F63756D656E742E637265617465456C656D656E7428226122292929207B0A20202020202063617061626C6542726F77736572203D2066616C73653B0A202020207D20656C73';
wwv_flow_api.g_varchar2_table(1064) := '65207B0A2020202020202F2F205468652062726F7773657220737570706F72747320746865204150492C20627574206D617920626520626C61636B6C69737465642E0A202020202020666F722028766172205F6974657261746F723335203D2044726F70';
wwv_flow_api.g_varchar2_table(1065) := '7A6F6E652E626C61636B6C697374656442726F77736572732C205F697341727261793335203D20747275652C205F693337203D20302C205F6974657261746F723335203D205F697341727261793335203F205F6974657261746F723335203A205F697465';
wwv_flow_api.g_varchar2_table(1066) := '7261746F7233355B53796D626F6C2E6974657261746F725D28293B3B29207B0A2020202020202020766172205F72656633343B0A0A2020202020202020696620285F69734172726179333529207B0A20202020202020202020696620285F693337203E3D';
wwv_flow_api.g_varchar2_table(1067) := '205F6974657261746F7233352E6C656E6774682920627265616B3B0A202020202020202020205F7265663334203D205F6974657261746F7233355B5F6933372B2B5D3B0A20202020202020207D20656C7365207B0A202020202020202020205F69333720';
wwv_flow_api.g_varchar2_table(1068) := '3D205F6974657261746F7233352E6E65787428293B0A20202020202020202020696620285F6933372E646F6E652920627265616B3B0A202020202020202020205F7265663334203D205F6933372E76616C75653B0A20202020202020207D0A0A20202020';
wwv_flow_api.g_varchar2_table(1069) := '20202020766172207265676578203D205F72656633343B0A0A20202020202020206966202872656765782E74657374286E6176696761746F722E757365724167656E742929207B0A2020202020202020202063617061626C6542726F77736572203D2066';
wwv_flow_api.g_varchar2_table(1070) := '616C73653B0A20202020202020202020636F6E74696E75653B0A20202020202020207D0A2020202020207D0A202020207D0A20207D20656C7365207B0A2020202063617061626C6542726F77736572203D2066616C73653B0A20207D0A0A202072657475';
wwv_flow_api.g_varchar2_table(1071) := '726E2063617061626C6542726F777365723B0A7D3B0A0A44726F707A6F6E652E64617461555249746F426C6F62203D2066756E6374696F6E20286461746155524929207B0A20202F2F20636F6E766572742062617365363420746F207261772062696E61';
wwv_flow_api.g_varchar2_table(1072) := '727920646174612068656C6420696E206120737472696E670A20202F2F20646F65736E27742068616E646C652055524C456E636F646564204461746155524973202D2073656520534F20616E7377657220233638353032373620666F7220636F64652074';
wwv_flow_api.g_varchar2_table(1073) := '68617420646F657320746869730A20207661722062797465537472696E67203D2061746F6228646174615552492E73706C697428272C27295B315D293B0A0A20202F2F207365706172617465206F757420746865206D696D6520636F6D706F6E656E740A';
wwv_flow_api.g_varchar2_table(1074) := '2020766172206D696D65537472696E67203D20646174615552492E73706C697428272C27295B305D2E73706C697428273A27295B315D2E73706C697428273B27295B305D3B0A0A20202F2F20777269746520746865206279746573206F66207468652073';
wwv_flow_api.g_varchar2_table(1075) := '7472696E6720746F20616E2041727261794275666665720A2020766172206162203D206E65772041727261794275666665722862797465537472696E672E6C656E677468293B0A2020766172206961203D206E65772055696E7438417272617928616229';
wwv_flow_api.g_varchar2_table(1076) := '3B0A2020666F7220287661722069203D20302C20656E64203D2062797465537472696E672E6C656E6774682C20617363203D2030203C3D20656E643B20617363203F2069203C3D20656E64203A2069203E3D20656E643B20617363203F20692B2B203A20';
wwv_flow_api.g_varchar2_table(1077) := '692D2D29207B0A2020202069615B695D203D2062797465537472696E672E63686172436F646541742869293B0A20207D0A0A20202F2F2077726974652074686520417272617942756666657220746F206120626C6F620A202072657475726E206E657720';
wwv_flow_api.g_varchar2_table(1078) := '426C6F62285B61625D2C207B20747970653A206D696D65537472696E67207D293B0A7D3B0A0A2F2F2052657475726E7320616E20617272617920776974686F7574207468652072656A6563746564206974656D0A76617220776974686F7574203D206675';
wwv_flow_api.g_varchar2_table(1079) := '6E6374696F6E20776974686F7574286C6973742C2072656A65637465644974656D29207B0A202072657475726E206C6973742E66696C7465722866756E6374696F6E20286974656D29207B0A2020202072657475726E206974656D20213D3D2072656A65';
wwv_flow_api.g_varchar2_table(1080) := '637465644974656D3B0A20207D292E6D61702866756E6374696F6E20286974656D29207B0A2020202072657475726E206974656D3B0A20207D293B0A7D3B0A0A2F2F206162632D6465665F676869202D3E206162634465664768690A7661722063616D65';
wwv_flow_api.g_varchar2_table(1081) := '6C697A65203D2066756E6374696F6E2063616D656C697A652873747229207B0A202072657475726E207374722E7265706C616365282F5B5C2D5F5D285C77292F672C2066756E6374696F6E20286D6174636829207B0A2020202072657475726E206D6174';
wwv_flow_api.g_varchar2_table(1082) := '63682E6368617241742831292E746F55707065724361736528293B0A20207D293B0A7D3B0A0A2F2F204372656174657320616E20656C656D656E742066726F6D20737472696E670A44726F707A6F6E652E637265617465456C656D656E74203D2066756E';
wwv_flow_api.g_varchar2_table(1083) := '6374696F6E2028737472696E6729207B0A202076617220646976203D20646F63756D656E742E637265617465456C656D656E74282264697622293B0A20206469762E696E6E657248544D4C203D20737472696E673B0A202072657475726E206469762E63';
wwv_flow_api.g_varchar2_table(1084) := '68696C644E6F6465735B305D3B0A7D3B0A0A2F2F20546573747320696620676976656E20656C656D656E7420697320696E7369646520286F722073696D706C79206973292074686520636F6E7461696E65720A44726F707A6F6E652E656C656D656E7449';
wwv_flow_api.g_varchar2_table(1085) := '6E73696465203D2066756E6374696F6E2028656C656D656E742C20636F6E7461696E657229207B0A202069662028656C656D656E74203D3D3D20636F6E7461696E657229207B0A2020202072657475726E20747275653B0A20207D202F2F20436F666665';
wwv_flow_api.g_varchar2_table(1086) := '6573637269707420646F65736E277420737570706F727420646F2F7768696C65206C6F6F70730A20207768696C652028656C656D656E74203D20656C656D656E742E706172656E744E6F646529207B0A2020202069662028656C656D656E74203D3D3D20';
wwv_flow_api.g_varchar2_table(1087) := '636F6E7461696E657229207B0A20202020202072657475726E20747275653B0A202020207D0A20207D0A202072657475726E2066616C73653B0A7D3B0A0A44726F707A6F6E652E676574456C656D656E74203D2066756E6374696F6E2028656C2C206E61';
wwv_flow_api.g_varchar2_table(1088) := '6D6529207B0A202076617220656C656D656E74203D20766F696420303B0A202069662028747970656F6620656C203D3D3D2022737472696E672229207B0A20202020656C656D656E74203D20646F63756D656E742E717565727953656C6563746F722865';
wwv_flow_api.g_varchar2_table(1089) := '6C293B0A20207D20656C73652069662028656C2E6E6F64655479706520213D206E756C6C29207B0A20202020656C656D656E74203D20656C3B0A20207D0A202069662028656C656D656E74203D3D206E756C6C29207B0A202020207468726F77206E6577';
wwv_flow_api.g_varchar2_table(1090) := '204572726F722822496E76616C6964206022202B206E616D65202B202260206F7074696F6E2070726F76696465642E20506C656173652070726F766964652061204353532073656C6563746F72206F72206120706C61696E2048544D4C20656C656D656E';
wwv_flow_api.g_varchar2_table(1091) := '742E22293B0A20207D0A202072657475726E20656C656D656E743B0A7D3B0A0A44726F707A6F6E652E676574456C656D656E7473203D2066756E6374696F6E2028656C732C206E616D6529207B0A202076617220656C203D20766F696420302C0A202020';
wwv_flow_api.g_varchar2_table(1092) := '202020656C656D656E7473203D20766F696420303B0A202069662028656C7320696E7374616E63656F6620417272617929207B0A20202020656C656D656E7473203D205B5D3B0A20202020747279207B0A202020202020666F722028766172205F697465';
wwv_flow_api.g_varchar2_table(1093) := '7261746F723336203D20656C732C205F697341727261793336203D20747275652C205F693338203D20302C205F6974657261746F723336203D205F697341727261793336203F205F6974657261746F723336203A205F6974657261746F7233365B53796D';
wwv_flow_api.g_varchar2_table(1094) := '626F6C2E6974657261746F725D28293B3B29207B0A2020202020202020696620285F69734172726179333629207B0A20202020202020202020696620285F693338203E3D205F6974657261746F7233362E6C656E6774682920627265616B3B0A20202020';
wwv_flow_api.g_varchar2_table(1095) := '202020202020656C203D205F6974657261746F7233365B5F6933382B2B5D3B0A20202020202020207D20656C7365207B0A202020202020202020205F693338203D205F6974657261746F7233362E6E65787428293B0A2020202020202020202069662028';
wwv_flow_api.g_varchar2_table(1096) := '5F6933382E646F6E652920627265616B3B0A20202020202020202020656C203D205F6933382E76616C75653B0A20202020202020207D0A0A2020202020202020656C656D656E74732E7075736828746869732E676574456C656D656E7428656C2C206E61';
wwv_flow_api.g_varchar2_table(1097) := '6D6529293B0A2020202020207D0A202020207D20636174636820286529207B0A202020202020656C656D656E7473203D206E756C6C3B0A202020207D0A20207D20656C73652069662028747970656F6620656C73203D3D3D2022737472696E672229207B';
wwv_flow_api.g_varchar2_table(1098) := '0A20202020656C656D656E7473203D205B5D3B0A20202020666F722028766172205F6974657261746F723337203D20646F63756D656E742E717565727953656C6563746F72416C6C28656C73292C205F697341727261793337203D20747275652C205F69';
wwv_flow_api.g_varchar2_table(1099) := '3339203D20302C205F6974657261746F723337203D205F697341727261793337203F205F6974657261746F723337203A205F6974657261746F7233375B53796D626F6C2E6974657261746F725D28293B3B29207B0A202020202020696620285F69734172';
wwv_flow_api.g_varchar2_table(1100) := '726179333729207B0A2020202020202020696620285F693339203E3D205F6974657261746F7233372E6C656E6774682920627265616B3B0A2020202020202020656C203D205F6974657261746F7233375B5F6933392B2B5D3B0A2020202020207D20656C';
wwv_flow_api.g_varchar2_table(1101) := '7365207B0A20202020202020205F693339203D205F6974657261746F7233372E6E65787428293B0A2020202020202020696620285F6933392E646F6E652920627265616B3B0A2020202020202020656C203D205F6933392E76616C75653B0A2020202020';
wwv_flow_api.g_varchar2_table(1102) := '207D0A0A202020202020656C656D656E74732E7075736828656C293B0A202020207D0A20207D20656C73652069662028656C732E6E6F64655479706520213D206E756C6C29207B0A20202020656C656D656E7473203D205B656C735D3B0A20207D0A0A20';
wwv_flow_api.g_varchar2_table(1103) := '2069662028656C656D656E7473203D3D206E756C6C207C7C2021656C656D656E74732E6C656E67746829207B0A202020207468726F77206E6577204572726F722822496E76616C6964206022202B206E616D65202B202260206F7074696F6E2070726F76';
wwv_flow_api.g_varchar2_table(1104) := '696465642E20506C656173652070726F766964652061204353532073656C6563746F722C206120706C61696E2048544D4C20656C656D656E74206F722061206C697374206F662074686F73652E22293B0A20207D0A0A202072657475726E20656C656D65';
wwv_flow_api.g_varchar2_table(1105) := '6E74733B0A7D3B0A0A2F2F2041736B7320746865207573657220746865207175657374696F6E20616E642063616C6C73206163636570746564206F722072656A6563746564206163636F7264696E676C790A2F2F0A2F2F205468652064656661756C7420';
wwv_flow_api.g_varchar2_table(1106) := '696D706C656D656E746174696F6E206A7573742075736573206077696E646F772E636F6E6669726D6020616E64207468656E2063616C6C73207468650A2F2F20617070726F7072696174652063616C6C6261636B2E0A44726F707A6F6E652E636F6E6669';
wwv_flow_api.g_varchar2_table(1107) := '726D203D2066756E6374696F6E20287175657374696F6E2C2061636365707465642C2072656A656374656429207B0A20206966202877696E646F772E636F6E6669726D287175657374696F6E2929207B0A2020202072657475726E206163636570746564';
wwv_flow_api.g_varchar2_table(1108) := '28293B0A20207D20656C7365206966202872656A656374656420213D206E756C6C29207B0A2020202072657475726E2072656A656374656428293B0A20207D0A7D3B0A0A2F2F2056616C69646174657320746865206D696D652074797065206C696B6520';
wwv_flow_api.g_varchar2_table(1109) := '746869733A0A2F2F0A2F2F2068747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F48544D4C2F456C656D656E742F696E70757423617474722D6163636570740A44726F707A6F6E652E697356616C6964';
wwv_flow_api.g_varchar2_table(1110) := '46696C65203D2066756E6374696F6E202866696C652C20616363657074656446696C657329207B0A20206966202821616363657074656446696C657329207B0A2020202072657475726E20747275653B0A20207D202F2F20496620746865726520617265';
wwv_flow_api.g_varchar2_table(1111) := '206E6F206163636570746564206D696D652074797065732C2069742773204F4B0A2020616363657074656446696C6573203D20616363657074656446696C65732E73706C697428222C22293B0A0A2020766172206D696D6554797065203D2066696C652E';
wwv_flow_api.g_varchar2_table(1112) := '747970653B0A202076617220626173654D696D6554797065203D206D696D65547970652E7265706C616365282F5C2F2E2A242F2C202222293B0A0A2020666F722028766172205F6974657261746F723338203D20616363657074656446696C65732C205F';
wwv_flow_api.g_varchar2_table(1113) := '697341727261793338203D20747275652C205F693430203D20302C205F6974657261746F723338203D205F697341727261793338203F205F6974657261746F723338203A205F6974657261746F7233385B53796D626F6C2E6974657261746F725D28293B';
wwv_flow_api.g_varchar2_table(1114) := '3B29207B0A20202020766172205F72656633353B0A0A20202020696620285F69734172726179333829207B0A202020202020696620285F693430203E3D205F6974657261746F7233382E6C656E6774682920627265616B3B0A2020202020205F72656633';
wwv_flow_api.g_varchar2_table(1115) := '35203D205F6974657261746F7233385B5F6934302B2B5D3B0A202020207D20656C7365207B0A2020202020205F693430203D205F6974657261746F7233382E6E65787428293B0A202020202020696620285F6934302E646F6E652920627265616B3B0A20';
wwv_flow_api.g_varchar2_table(1116) := '20202020205F7265663335203D205F6934302E76616C75653B0A202020207D0A0A202020207661722076616C696454797065203D205F72656633353B0A0A2020202076616C696454797065203D2076616C6964547970652E7472696D28293B0A20202020';
wwv_flow_api.g_varchar2_table(1117) := '6966202876616C6964547970652E636861724174283029203D3D3D20222E2229207B0A2020202020206966202866696C652E6E616D652E746F4C6F7765724361736528292E696E6465784F662876616C6964547970652E746F4C6F776572436173652829';
wwv_flow_api.g_varchar2_table(1118) := '2C2066696C652E6E616D652E6C656E677468202D2076616C6964547970652E6C656E6774682920213D3D202D3129207B0A202020202020202072657475726E20747275653B0A2020202020207D0A202020207D20656C736520696620282F5C2F5C2A242F';
wwv_flow_api.g_varchar2_table(1119) := '2E746573742876616C6964547970652929207B0A2020202020202F2F205468697320697320736F6D657468696E67206C696B65206120696D6167652F2A206D696D6520747970650A20202020202069662028626173654D696D6554797065203D3D3D2076';
wwv_flow_api.g_varchar2_table(1120) := '616C6964547970652E7265706C616365282F5C2F2E2A242F2C2022222929207B0A202020202020202072657475726E20747275653B0A2020202020207D0A202020207D20656C7365207B0A202020202020696620286D696D6554797065203D3D3D207661';
wwv_flow_api.g_varchar2_table(1121) := '6C69645479706529207B0A202020202020202072657475726E20747275653B0A2020202020207D0A202020207D0A20207D0A0A202072657475726E2066616C73653B0A7D3B0A0A2F2F204175676D656E74206A51756572790A69662028747970656F6620';
wwv_flow_api.g_varchar2_table(1122) := '6A517565727920213D3D2027756E646566696E656427202626206A517565727920213D3D206E756C6C29207B0A20206A51756572792E666E2E64726F707A6F6E65203D2066756E6374696F6E20286F7074696F6E7329207B0A2020202072657475726E20';
wwv_flow_api.g_varchar2_table(1123) := '746869732E656163682866756E6374696F6E202829207B0A20202020202072657475726E206E65772044726F707A6F6E6528746869732C206F7074696F6E73293B0A202020207D293B0A20207D3B0A7D0A0A69662028747970656F66206D6F64756C6520';
wwv_flow_api.g_varchar2_table(1124) := '213D3D2027756E646566696E656427202626206D6F64756C6520213D3D206E756C6C29207B0A20206D6F64756C652E6578706F727473203D2044726F707A6F6E653B0A7D20656C7365207B0A202077696E646F772E44726F707A6F6E65203D2044726F70';
wwv_flow_api.g_varchar2_table(1125) := '7A6F6E653B0A7D0A0A2F2F2044726F707A6F6E652066696C652073746174757320636F6465730A44726F707A6F6E652E4144444544203D20226164646564223B0A0A44726F707A6F6E652E515545554544203D2022717565756564223B0A2F2F20466F72';
wwv_flow_api.g_varchar2_table(1126) := '206261636B776172647320636F6D7061746962696C6974792E204E6F772C20696620612066696C652069732061636365707465642C206974277320656974686572207175657565640A2F2F206F722075706C6F6164696E672E0A44726F707A6F6E652E41';
wwv_flow_api.g_varchar2_table(1127) := '43434550544544203D2044726F707A6F6E652E5155455545443B0A0A44726F707A6F6E652E55504C4F4144494E47203D202275706C6F6164696E67223B0A44726F707A6F6E652E50524F43455353494E47203D2044726F707A6F6E652E55504C4F414449';
wwv_flow_api.g_varchar2_table(1128) := '4E473B202F2F20616C6961730A0A44726F707A6F6E652E43414E43454C4544203D202263616E63656C6564223B0A44726F707A6F6E652E4552524F52203D20226572726F72223B0A44726F707A6F6E652E53554343455353203D20227375636365737322';
wwv_flow_api.g_varchar2_table(1129) := '3B0A0A2F2A0A0A2042756766697820666F7220694F53203620616E6420370A20536F757263653A20687474703A2F2F737461636B6F766572666C6F772E636F6D2F7175657374696F6E732F31313932393039392F68746D6C352D63616E7661732D647261';
wwv_flow_api.g_varchar2_table(1130) := '77696D6167652D726174696F2D6275672D696F730A206261736564206F6E2074686520776F726B206F662068747470733A2F2F6769746875622E636F6D2F73746F6D6974612F696F732D696D61676566696C652D6D656761706978656C0A0A202A2F0A0A';
wwv_flow_api.g_varchar2_table(1131) := '2F2F20446574656374696E6720766572746963616C2073717561736820696E206C6F6164656420696D6167652E0A2F2F2046697865732061206275672077686963682073717561736820696D61676520766572746963616C6C79207768696C6520647261';
wwv_flow_api.g_varchar2_table(1132) := '77696E6720696E746F2063616E76617320666F7220736F6D6520696D616765732E0A2F2F205468697320697320612062756720696E20694F533620646576696365732E20546869732066756E6374696F6E2066726F6D2068747470733A2F2F6769746875';
wwv_flow_api.g_varchar2_table(1133) := '622E636F6D2F73746F6D6974612F696F732D696D61676566696C652D6D656761706978656C0A76617220646574656374566572746963616C537175617368203D2066756E6374696F6E20646574656374566572746963616C53717561736828696D672920';
wwv_flow_api.g_varchar2_table(1134) := '7B0A2020766172206977203D20696D672E6E61747572616C57696474683B0A2020766172206968203D20696D672E6E61747572616C4865696768743B0A20207661722063616E766173203D20646F63756D656E742E637265617465456C656D656E742822';
wwv_flow_api.g_varchar2_table(1135) := '63616E76617322293B0A202063616E7661732E7769647468203D20313B0A202063616E7661732E686569676874203D2069683B0A202076617220637478203D2063616E7661732E676574436F6E746578742822326422293B0A20206374782E6472617749';
wwv_flow_api.g_varchar2_table(1136) := '6D61676528696D672C20302C2030293B0A0A2020766172205F63747824676574496D61676544617461203D206374782E676574496D6167654461746128312C20302C20312C206968292C0A20202020202064617461203D205F63747824676574496D6167';
wwv_flow_api.g_varchar2_table(1137) := '65446174612E646174613B0A0A20202F2F2073656172636820696D616765206564676520706978656C20706F736974696F6E20696E206361736520697420697320737175617368656420766572746963616C6C792E0A0A0A2020766172207379203D2030';
wwv_flow_api.g_varchar2_table(1138) := '3B0A2020766172206579203D2069683B0A2020766172207079203D2069683B0A20207768696C6520287079203E20737929207B0A2020202076617220616C706861203D20646174615B287079202D203129202A2034202B20335D3B0A0A20202020696620';
wwv_flow_api.g_varchar2_table(1139) := '28616C706861203D3D3D203029207B0A2020202020206579203D2070793B0A202020207D20656C7365207B0A2020202020207379203D2070793B0A202020207D0A0A202020207079203D206579202B207379203E3E20313B0A20207D0A20207661722072';
wwv_flow_api.g_varchar2_table(1140) := '6174696F203D207079202F2069683B0A0A202069662028726174696F203D3D3D203029207B0A2020202072657475726E20313B0A20207D20656C7365207B0A2020202072657475726E20726174696F3B0A20207D0A7D3B0A0A2F2F2041207265706C6163';
wwv_flow_api.g_varchar2_table(1141) := '656D656E7420666F7220636F6E746578742E64726177496D6167650A2F2F2028617267732061726520666F7220736F7572636520616E642064657374696E6174696F6E292E0A7661722064726177496D616765494F53466978203D2066756E6374696F6E';
wwv_flow_api.g_varchar2_table(1142) := '2064726177496D616765494F53466978286374782C20696D672C2073782C2073792C2073772C2073682C2064782C2064792C2064772C20646829207B0A20207661722076657274537175617368526174696F203D20646574656374566572746963616C53';
wwv_flow_api.g_varchar2_table(1143) := '717561736828696D67293B0A202072657475726E206374782E64726177496D61676528696D672C2073782C2073792C2073772C2073682C2064782C2064792C2064772C206468202F2076657274537175617368526174696F293B0A7D3B0A0A2F2F204261';
wwv_flow_api.g_varchar2_table(1144) := '736564206F6E204D696E6966794A7065670A2F2F20536F757263653A20687474703A2F2F7777772E70657272792E637A2F66696C65732F45786966526573746F7265722E6A730A2F2F20687474703A2F2F656C69636F6E2E626C6F6735372E6663322E63';
wwv_flow_api.g_varchar2_table(1145) := '6F6D2F626C6F672D656E7472792D3230362E68746D6C0A0A7661722045786966526573746F7265203D2066756E6374696F6E202829207B0A202066756E6374696F6E2045786966526573746F72652829207B0A202020205F636C61737343616C6C436865';
wwv_flow_api.g_varchar2_table(1146) := '636B28746869732C2045786966526573746F7265293B0A20207D0A0A20205F637265617465436C6173732845786966526573746F72652C206E756C6C2C205B7B0A202020206B65793A2022696E6974436C617373222C0A2020202076616C75653A206675';
wwv_flow_api.g_varchar2_table(1147) := '6E6374696F6E20696E6974436C6173732829207B0A202020202020746869732E4B45595F535452203D20274142434445464748494A4B4C4D4E4F505152535455565758595A6162636465666768696A6B6C6D6E6F707172737475767778797A3031323334';
wwv_flow_api.g_varchar2_table(1148) := '35363738392B2F3D273B0A202020207D0A20207D2C207B0A202020206B65793A2022656E636F64653634222C0A2020202076616C75653A2066756E6374696F6E20656E636F6465363428696E70757429207B0A202020202020766172206F757470757420';
wwv_flow_api.g_varchar2_table(1149) := '3D2027273B0A2020202020207661722063687231203D20756E646566696E65643B0A2020202020207661722063687232203D20756E646566696E65643B0A2020202020207661722063687233203D2027273B0A20202020202076617220656E6331203D20';
wwv_flow_api.g_varchar2_table(1150) := '756E646566696E65643B0A20202020202076617220656E6332203D20756E646566696E65643B0A20202020202076617220656E6333203D20756E646566696E65643B0A20202020202076617220656E6334203D2027273B0A202020202020766172206920';
wwv_flow_api.g_varchar2_table(1151) := '3D20303B0A2020202020207768696C6520287472756529207B0A202020202020202063687231203D20696E7075745B692B2B5D3B0A202020202020202063687232203D20696E7075745B692B2B5D3B0A202020202020202063687233203D20696E707574';
wwv_flow_api.g_varchar2_table(1152) := '5B692B2B5D3B0A2020202020202020656E6331203D2063687231203E3E20323B0A2020202020202020656E6332203D2028636872312026203329203C3C2034207C2063687232203E3E20343B0A2020202020202020656E6333203D202863687232202620';
wwv_flow_api.g_varchar2_table(1153) := '313529203C3C2032207C2063687233203E3E20363B0A2020202020202020656E6334203D206368723320262036333B0A20202020202020206966202869734E614E28636872322929207B0A20202020202020202020656E6333203D20656E6334203D2036';
wwv_flow_api.g_varchar2_table(1154) := '343B0A20202020202020207D20656C7365206966202869734E614E28636872332929207B0A20202020202020202020656E6334203D2036343B0A20202020202020207D0A20202020202020206F7574707574203D206F7574707574202B20746869732E4B';
wwv_flow_api.g_varchar2_table(1155) := '45595F5354522E63686172417428656E633129202B20746869732E4B45595F5354522E63686172417428656E633229202B20746869732E4B45595F5354522E63686172417428656E633329202B20746869732E4B45595F5354522E63686172417428656E';
wwv_flow_api.g_varchar2_table(1156) := '6334293B0A202020202020202063687231203D2063687232203D2063687233203D2027273B0A2020202020202020656E6331203D20656E6332203D20656E6333203D20656E6334203D2027273B0A202020202020202069662028212869203C20696E7075';
wwv_flow_api.g_varchar2_table(1157) := '742E6C656E6774682929207B0A20202020202020202020627265616B3B0A20202020202020207D0A2020202020207D0A20202020202072657475726E206F75747075743B0A202020207D0A20207D2C207B0A202020206B65793A2022726573746F726522';
wwv_flow_api.g_varchar2_table(1158) := '2C0A2020202076616C75653A2066756E6374696F6E20726573746F7265286F72696746696C654261736536342C20726573697A656446696C6542617365363429207B0A20202020202069662028216F72696746696C654261736536342E6D617463682827';
wwv_flow_api.g_varchar2_table(1159) := '646174613A696D6167652F6A7065673B6261736536342C272929207B0A202020202020202072657475726E20726573697A656446696C654261736536343B0A2020202020207D0A20202020202076617220726177496D616765203D20746869732E646563';
wwv_flow_api.g_varchar2_table(1160) := '6F64653634286F72696746696C654261736536342E7265706C6163652827646174613A696D6167652F6A7065673B6261736536342C272C20272729293B0A202020202020766172207365676D656E7473203D20746869732E736C696365325365676D656E';
wwv_flow_api.g_varchar2_table(1161) := '747328726177496D616765293B0A20202020202076617220696D616765203D20746869732E657869664D616E6970756C6174696F6E28726573697A656446696C654261736536342C207365676D656E7473293B0A20202020202072657475726E20226461';
wwv_flow_api.g_varchar2_table(1162) := '74613A696D6167652F6A7065673B6261736536342C22202B20746869732E656E636F6465363428696D616765293B0A202020207D0A20207D2C207B0A202020206B65793A2022657869664D616E6970756C6174696F6E222C0A2020202076616C75653A20';
wwv_flow_api.g_varchar2_table(1163) := '66756E6374696F6E20657869664D616E6970756C6174696F6E28726573697A656446696C654261736536342C207365676D656E747329207B0A20202020202076617220657869664172726179203D20746869732E67657445786966417272617928736567';
wwv_flow_api.g_varchar2_table(1164) := '6D656E7473293B0A202020202020766172206E6577496D6167654172726179203D20746869732E696E736572744578696628726573697A656446696C654261736536342C20657869664172726179293B0A2020202020207661722061427566666572203D';
wwv_flow_api.g_varchar2_table(1165) := '206E65772055696E74384172726179286E6577496D6167654172726179293B0A20202020202072657475726E20614275666665723B0A202020207D0A20207D2C207B0A202020206B65793A2022676574457869664172726179222C0A2020202076616C75';
wwv_flow_api.g_varchar2_table(1166) := '653A2066756E6374696F6E20676574457869664172726179287365676D656E747329207B0A20202020202076617220736567203D20756E646566696E65643B0A2020202020207661722078203D20303B0A2020202020207768696C65202878203C207365';
wwv_flow_api.g_varchar2_table(1167) := '676D656E74732E6C656E67746829207B0A2020202020202020736567203D207365676D656E74735B785D3B0A2020202020202020696620287365675B305D203D3D3D203235352026207365675B315D203D3D3D2032323529207B0A202020202020202020';
wwv_flow_api.g_varchar2_table(1168) := '2072657475726E207365673B0A20202020202020207D0A2020202020202020782B2B3B0A2020202020207D0A20202020202072657475726E205B5D3B0A202020207D0A20207D2C207B0A202020206B65793A2022696E7365727445786966222C0A202020';
wwv_flow_api.g_varchar2_table(1169) := '2076616C75653A2066756E6374696F6E20696E736572744578696628726573697A656446696C654261736536342C2065786966417272617929207B0A20202020202076617220696D61676544617461203D20726573697A656446696C654261736536342E';
wwv_flow_api.g_varchar2_table(1170) := '7265706C6163652827646174613A696D6167652F6A7065673B6261736536342C272C202727293B0A20202020202076617220627566203D20746869732E6465636F6465363428696D61676544617461293B0A202020202020766172207365706172617465';
wwv_flow_api.g_varchar2_table(1171) := '506F696E74203D206275662E696E6465784F66283235352C2033293B0A202020202020766172206D6165203D206275662E736C69636528302C207365706172617465506F696E74293B0A2020202020207661722061746F203D206275662E736C69636528';
wwv_flow_api.g_varchar2_table(1172) := '7365706172617465506F696E74293B0A202020202020766172206172726179203D206D61653B0A2020202020206172726179203D2061727261792E636F6E63617428657869664172726179293B0A2020202020206172726179203D2061727261792E636F';
wwv_flow_api.g_varchar2_table(1173) := '6E6361742861746F293B0A20202020202072657475726E2061727261793B0A202020207D0A20207D2C207B0A202020206B65793A2022736C696365325365676D656E7473222C0A2020202076616C75653A2066756E6374696F6E20736C69636532536567';
wwv_flow_api.g_varchar2_table(1174) := '6D656E747328726177496D616765417272617929207B0A2020202020207661722068656164203D20303B0A202020202020766172207365676D656E7473203D205B5D3B0A2020202020207768696C6520287472756529207B0A2020202020202020766172';
wwv_flow_api.g_varchar2_table(1175) := '206C656E6774683B0A202020202020202069662028726177496D61676541727261795B686561645D203D3D3D20323535202620726177496D61676541727261795B68656164202B20315D203D3D3D2032313829207B0A2020202020202020202062726561';
wwv_flow_api.g_varchar2_table(1176) := '6B3B0A20202020202020207D0A202020202020202069662028726177496D61676541727261795B686561645D203D3D3D20323535202620726177496D61676541727261795B68656164202B20315D203D3D3D2032313629207B0A20202020202020202020';
wwv_flow_api.g_varchar2_table(1177) := '68656164202B3D20323B0A20202020202020207D20656C7365207B0A202020202020202020206C656E677468203D20726177496D61676541727261795B68656164202B20325D202A20323536202B20726177496D61676541727261795B68656164202B20';
wwv_flow_api.g_varchar2_table(1178) := '335D3B0A2020202020202020202076617220656E64506F696E74203D2068656164202B206C656E677468202B20323B0A2020202020202020202076617220736567203D20726177496D61676541727261792E736C69636528686561642C20656E64506F69';
wwv_flow_api.g_varchar2_table(1179) := '6E74293B0A202020202020202020207365676D656E74732E7075736828736567293B0A2020202020202020202068656164203D20656E64506F696E743B0A20202020202020207D0A20202020202020206966202868656164203E20726177496D61676541';
wwv_flow_api.g_varchar2_table(1180) := '727261792E6C656E67746829207B0A20202020202020202020627265616B3B0A20202020202020207D0A2020202020207D0A20202020202072657475726E207365676D656E74733B0A202020207D0A20207D2C207B0A202020206B65793A20226465636F';
wwv_flow_api.g_varchar2_table(1181) := '64653634222C0A2020202076616C75653A2066756E6374696F6E206465636F6465363428696E70757429207B0A202020202020766172206F7574707574203D2027273B0A2020202020207661722063687231203D20756E646566696E65643B0A20202020';
wwv_flow_api.g_varchar2_table(1182) := '20207661722063687232203D20756E646566696E65643B0A2020202020207661722063687233203D2027273B0A20202020202076617220656E6331203D20756E646566696E65643B0A20202020202076617220656E6332203D20756E646566696E65643B';
wwv_flow_api.g_varchar2_table(1183) := '0A20202020202076617220656E6333203D20756E646566696E65643B0A20202020202076617220656E6334203D2027273B0A2020202020207661722069203D20303B0A20202020202076617220627566203D205B5D3B0A2020202020202F2F2072656D6F';
wwv_flow_api.g_varchar2_table(1184) := '766520616C6C2063686172616374657273207468617420617265206E6F7420412D5A2C20612D7A2C20302D392C202B2C202F2C206F72203D0A2020202020207661722062617365363474657374203D202F5B5E412D5A612D7A302D395C2B5C2F5C3D5D2F';
wwv_flow_api.g_varchar2_table(1185) := '673B0A20202020202069662028626173653634746573742E6578656328696E7075742929207B0A2020202020202020636F6E736F6C652E7761726E28275468657265207765726520696E76616C696420626173653634206368617261637465727320696E';
wwv_flow_api.g_varchar2_table(1186) := '2074686520696E70757420746578742E5C6E56616C69642062617365363420636861726163746572732061726520412D5A2C20612D7A2C20302D392C205C272B5C272C205C272F5C272C616E64205C273D5C275C6E457870656374206572726F72732069';
wwv_flow_api.g_varchar2_table(1187) := '6E206465636F64696E672E27293B0A2020202020207D0A202020202020696E707574203D20696E7075742E7265706C616365282F5B5E412D5A612D7A302D395C2B5C2F5C3D5D2F672C202727293B0A2020202020207768696C6520287472756529207B0A';
wwv_flow_api.g_varchar2_table(1188) := '2020202020202020656E6331203D20746869732E4B45595F5354522E696E6465784F6628696E7075742E63686172417428692B2B29293B0A2020202020202020656E6332203D20746869732E4B45595F5354522E696E6465784F6628696E7075742E6368';
wwv_flow_api.g_varchar2_table(1189) := '6172417428692B2B29293B0A2020202020202020656E6333203D20746869732E4B45595F5354522E696E6465784F6628696E7075742E63686172417428692B2B29293B0A2020202020202020656E6334203D20746869732E4B45595F5354522E696E6465';
wwv_flow_api.g_varchar2_table(1190) := '784F6628696E7075742E63686172417428692B2B29293B0A202020202020202063687231203D20656E6331203C3C2032207C20656E6332203E3E20343B0A202020202020202063687232203D2028656E6332202620313529203C3C2034207C20656E6333';
wwv_flow_api.g_varchar2_table(1191) := '203E3E20323B0A202020202020202063687233203D2028656E63332026203329203C3C2036207C20656E63343B0A20202020202020206275662E707573682863687231293B0A202020202020202069662028656E633320213D3D20363429207B0A202020';
wwv_flow_api.g_varchar2_table(1192) := '202020202020206275662E707573682863687232293B0A20202020202020207D0A202020202020202069662028656E633420213D3D20363429207B0A202020202020202020206275662E707573682863687233293B0A20202020202020207D0A20202020';
wwv_flow_api.g_varchar2_table(1193) := '2020202063687231203D2063687232203D2063687233203D2027273B0A2020202020202020656E6331203D20656E6332203D20656E6333203D20656E6334203D2027273B0A202020202020202069662028212869203C20696E7075742E6C656E67746829';
wwv_flow_api.g_varchar2_table(1194) := '29207B0A20202020202020202020627265616B3B0A20202020202020207D0A2020202020207D0A20202020202072657475726E206275663B0A202020207D0A20207D5D293B0A0A202072657475726E2045786966526573746F72653B0A7D28293B0A0A45';
wwv_flow_api.g_varchar2_table(1195) := '786966526573746F72652E696E6974436C61737328293B0A0A2F2A0A202A20636F6E74656E746C6F616465642E6A730A202A0A202A20417574686F723A20446965676F20506572696E692028646965676F2E706572696E6920617420676D61696C2E636F';
wwv_flow_api.g_varchar2_table(1196) := '6D290A202A2053756D6D6172793A2063726F73732D62726F77736572207772617070657220666F7220444F4D436F6E74656E744C6F616465640A202A20557064617465643A2032303130313032300A202A204C6963656E73653A204D49540A202A205665';
wwv_flow_api.g_varchar2_table(1197) := '7273696F6E3A20312E320A202A0A202A2055524C3A0A202A20687474703A2F2F6A6176617363726970742E6E77626F782E636F6D2F436F6E74656E744C6F616465642F0A202A20687474703A2F2F6A6176617363726970742E6E77626F782E636F6D2F43';
wwv_flow_api.g_varchar2_table(1198) := '6F6E74656E744C6F616465642F4D49542D4C4943454E53450A202A2F0A0A2F2F204077696E2077696E646F77207265666572656E63650A2F2F2040666E2066756E6374696F6E207265666572656E63650A76617220636F6E74656E744C6F61646564203D';
wwv_flow_api.g_varchar2_table(1199) := '2066756E6374696F6E20636F6E74656E744C6F616465642877696E2C20666E29207B0A202076617220646F6E65203D2066616C73653B0A202076617220746F70203D20747275653B0A202076617220646F63203D2077696E2E646F63756D656E743B0A20';
wwv_flow_api.g_varchar2_table(1200) := '2076617220726F6F74203D20646F632E646F63756D656E74456C656D656E743B0A202076617220616464203D20646F632E6164644576656E744C697374656E6572203F20226164644576656E744C697374656E657222203A20226174746163684576656E';
wwv_flow_api.g_varchar2_table(1201) := '74223B0A20207661722072656D203D20646F632E6164644576656E744C697374656E6572203F202272656D6F76654576656E744C697374656E657222203A20226465746163684576656E74223B0A202076617220707265203D20646F632E616464457665';
wwv_flow_api.g_varchar2_table(1202) := '6E744C697374656E6572203F202222203A20226F6E223B0A202076617220696E6974203D2066756E6374696F6E20696E6974286529207B0A2020202069662028652E74797065203D3D3D2022726561647973746174656368616E67652220262620646F63';
wwv_flow_api.g_varchar2_table(1203) := '2E7265616479537461746520213D3D2022636F6D706C6574652229207B0A20202020202072657475726E3B0A202020207D0A2020202028652E74797065203D3D3D20226C6F616422203F2077696E203A20646F63295B72656D5D28707265202B20652E74';
wwv_flow_api.g_varchar2_table(1204) := '7970652C20696E69742C2066616C7365293B0A202020206966202821646F6E652026262028646F6E65203D20747275652929207B0A20202020202072657475726E20666E2E63616C6C2877696E2C20652E74797065207C7C2065293B0A202020207D0A20';
wwv_flow_api.g_varchar2_table(1205) := '207D3B0A0A202076617220706F6C6C203D2066756E6374696F6E20706F6C6C2829207B0A20202020747279207B0A202020202020726F6F742E646F5363726F6C6C28226C65667422293B0A202020207D20636174636820286529207B0A20202020202073';
wwv_flow_api.g_varchar2_table(1206) := '657454696D656F757428706F6C6C2C203530293B0A20202020202072657475726E3B0A202020207D0A2020202072657475726E20696E69742822706F6C6C22293B0A20207D3B0A0A202069662028646F632E7265616479537461746520213D3D2022636F';
wwv_flow_api.g_varchar2_table(1207) := '6D706C6574652229207B0A2020202069662028646F632E6372656174654576656E744F626A65637420262620726F6F742E646F5363726F6C6C29207B0A202020202020747279207B0A2020202020202020746F70203D202177696E2E6672616D65456C65';
wwv_flow_api.g_varchar2_table(1208) := '6D656E743B0A2020202020207D20636174636820286572726F7229207B7D0A20202020202069662028746F7029207B0A2020202020202020706F6C6C28293B0A2020202020207D0A202020207D0A20202020646F635B6164645D28707265202B2022444F';
wwv_flow_api.g_varchar2_table(1209) := '4D436F6E74656E744C6F61646564222C20696E69742C2066616C7365293B0A20202020646F635B6164645D28707265202B2022726561647973746174656368616E6765222C20696E69742C2066616C7365293B0A2020202072657475726E2077696E5B61';
wwv_flow_api.g_varchar2_table(1210) := '64645D28707265202B20226C6F6164222C20696E69742C2066616C7365293B0A20207D0A7D3B0A0A2F2F20417320612073696E676C652066756E6374696F6E20746F2062652061626C6520746F2077726974652074657374732E0A44726F707A6F6E652E';
wwv_flow_api.g_varchar2_table(1211) := '5F6175746F446973636F76657246756E6374696F6E203D2066756E6374696F6E202829207B0A20206966202844726F707A6F6E652E6175746F446973636F76657229207B0A2020202072657475726E2044726F707A6F6E652E646973636F76657228293B';
wwv_flow_api.g_varchar2_table(1212) := '0A20207D0A7D3B0A636F6E74656E744C6F616465642877696E646F772C2044726F707A6F6E652E5F6175746F446973636F76657246756E6374696F6E293B0A0A66756E6374696F6E205F5F67756172645F5F2876616C75652C207472616E73666F726D29';
wwv_flow_api.g_varchar2_table(1213) := '207B0A202072657475726E20747970656F662076616C756520213D3D2027756E646566696E6564272026262076616C756520213D3D206E756C6C203F207472616E73666F726D2876616C756529203A20756E646566696E65643B0A7D0A66756E6374696F';
wwv_flow_api.g_varchar2_table(1214) := '6E205F5F67756172644D6574686F645F5F286F626A2C206D6574686F644E616D652C207472616E73666F726D29207B0A202069662028747970656F66206F626A20213D3D2027756E646566696E656427202626206F626A20213D3D206E756C6C20262620';
wwv_flow_api.g_varchar2_table(1215) := '747970656F66206F626A5B6D6574686F644E616D655D203D3D3D202766756E6374696F6E2729207B0A2020202072657475726E207472616E73666F726D286F626A2C206D6574686F644E616D65293B0A20207D20656C7365207B0A202020207265747572';
wwv_flow_api.g_varchar2_table(1216) := '6E20756E646566696E65643B0A20207D0A7D0A';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72363261882797263)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'js/dropzone.js'
,p_mime_type=>'application/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2275736520737472696374223B66756E6374696F6E205F706F737369626C65436F6E7374727563746F7252657475726E28652C74297B6966282165297468726F77206E6577205265666572656E63654572726F72282274686973206861736E2774206265';
wwv_flow_api.g_varchar2_table(2) := '656E20696E697469616C69736564202D2073757065722829206861736E2774206265656E2063616C6C656422293B72657475726E21747C7C226F626A65637422213D747970656F66207426262266756E6374696F6E22213D747970656F6620743F653A74';
wwv_flow_api.g_varchar2_table(3) := '7D66756E6374696F6E205F696E68657269747328652C74297B6966282266756E6374696F6E22213D747970656F66207426266E756C6C213D3D74297468726F77206E657720547970654572726F72282253757065722065787072657373696F6E206D7573';
wwv_flow_api.g_varchar2_table(4) := '7420656974686572206265206E756C6C206F7220612066756E6374696F6E2C206E6F7420222B747970656F662074293B652E70726F746F747970653D4F626A6563742E63726561746528742626742E70726F746F747970652C7B636F6E7374727563746F';
wwv_flow_api.g_varchar2_table(5) := '723A7B76616C75653A652C656E756D657261626C653A21312C7772697461626C653A21302C636F6E666967757261626C653A21307D7D292C742626284F626A6563742E73657450726F746F747970654F663F4F626A6563742E73657450726F746F747970';
wwv_flow_api.g_varchar2_table(6) := '654F6628652C74293A652E5F5F70726F746F5F5F3D74297D66756E6374696F6E205F636C61737343616C6C436865636B28652C74297B69662821286520696E7374616E63656F66207429297468726F77206E657720547970654572726F72282243616E6E';
wwv_flow_api.g_varchar2_table(7) := '6F742063616C6C206120636C61737320617320612066756E6374696F6E22297D66756E6374696F6E205F5F67756172645F5F28652C74297B72657475726E22756E646566696E656422213D747970656F66206526266E756C6C213D3D653F742865293A76';
wwv_flow_api.g_varchar2_table(8) := '6F696420307D66756E6374696F6E205F5F67756172644D6574686F645F5F28652C742C69297B72657475726E22756E646566696E656422213D747970656F66206526266E756C6C213D3D6526262266756E6374696F6E223D3D747970656F6620655B745D';
wwv_flow_api.g_varchar2_table(9) := '3F6928652C74293A766F696420307D766172205F637265617465436C6173733D66756E6374696F6E28297B66756E6374696F6E206528652C74297B666F722876617220693D303B693C742E6C656E6774683B692B2B297B766172206E3D745B695D3B6E2E';
wwv_flow_api.g_varchar2_table(10) := '656E756D657261626C653D6E2E656E756D657261626C657C7C21312C6E2E636F6E666967757261626C653D21302C2276616C756522696E206E2626286E2E7772697461626C653D2130292C4F626A6563742E646566696E6550726F706572747928652C6E';
wwv_flow_api.g_varchar2_table(11) := '2E6B65792C6E297D7D72657475726E2066756E6374696F6E28742C692C6E297B72657475726E206926266528742E70726F746F747970652C69292C6E26266528742C6E292C747D7D28292C456D69747465723D66756E6374696F6E28297B66756E637469';
wwv_flow_api.g_varchar2_table(12) := '6F6E206528297B5F636C61737343616C6C436865636B28746869732C65297D72657475726E205F637265617465436C61737328652C5B7B6B65793A226F6E222C76616C75653A66756E6374696F6E28652C74297B72657475726E20746869732E5F63616C';
wwv_flow_api.g_varchar2_table(13) := '6C6261636B733D746869732E5F63616C6C6261636B737C7C7B7D2C746869732E5F63616C6C6261636B735B655D7C7C28746869732E5F63616C6C6261636B735B655D3D5B5D292C746869732E5F63616C6C6261636B735B655D2E707573682874292C7468';
wwv_flow_api.g_varchar2_table(14) := '69737D7D2C7B6B65793A22656D6974222C76616C75653A66756E6374696F6E2865297B746869732E5F63616C6C6261636B733D746869732E5F63616C6C6261636B737C7C7B7D3B76617220743D746869732E5F63616C6C6261636B735B655D3B69662874';
wwv_flow_api.g_varchar2_table(15) := '297B666F722876617220693D617267756D656E74732E6C656E6774682C6E3D417272617928693E313F692D313A30292C723D313B723C693B722B2B296E5B722D315D3D617267756D656E74735B725D3B666F722876617220613D742C6F3D21302C6C3D30';
wwv_flow_api.g_varchar2_table(16) := '2C613D6F3F613A615B53796D626F6C2E6974657261746F725D28293B3B297B76617220733B6966286F297B6966286C3E3D612E6C656E67746829627265616B3B733D615B6C2B2B5D7D656C73657B6966286C3D612E6E65787428292C6C2E646F6E652962';
wwv_flow_api.g_varchar2_table(17) := '7265616B3B733D6C2E76616C75657D76617220753D733B752E6170706C7928746869732C6E297D7D72657475726E20746869737D7D2C7B6B65793A226F6666222C76616C75653A66756E6374696F6E28652C74297B69662821746869732E5F63616C6C62';
wwv_flow_api.g_varchar2_table(18) := '61636B737C7C303D3D3D617267756D656E74732E6C656E6774682972657475726E20746869732E5F63616C6C6261636B733D7B7D2C746869733B76617220693D746869732E5F63616C6C6261636B735B655D3B69662821692972657475726E2074686973';
wwv_flow_api.g_varchar2_table(19) := '3B696628313D3D3D617267756D656E74732E6C656E6774682972657475726E2064656C65746520746869732E5F63616C6C6261636B735B655D2C746869733B666F7228766172206E3D303B6E3C692E6C656E6774683B6E2B2B297B76617220723D695B6E';
wwv_flow_api.g_varchar2_table(20) := '5D3B696628723D3D3D74297B692E73706C696365286E2C31293B627265616B7D7D72657475726E20746869737D7D5D292C657D28292C44726F707A6F6E653D66756E6374696F6E2865297B66756E6374696F6E207428652C69297B5F636C61737343616C';
wwv_flow_api.g_varchar2_table(21) := '6C436865636B28746869732C74293B766172206E3D5F706F737369626C65436F6E7374727563746F7252657475726E28746869732C28742E5F5F70726F746F5F5F7C7C4F626A6563742E67657450726F746F747970654F66287429292E63616C6C287468';
wwv_flow_api.g_varchar2_table(22) := '697329292C723D766F696420302C613D766F696420303B6966286E2E656C656D656E743D652C6E2E76657273696F6E3D742E76657273696F6E2C6E2E64656661756C744F7074696F6E732E7072657669657754656D706C6174653D6E2E64656661756C74';
wwv_flow_api.g_varchar2_table(23) := '4F7074696F6E732E7072657669657754656D706C6174652E7265706C616365282F5C6E2A2F672C2222292C6E2E636C69636B61626C65456C656D656E74733D5B5D2C6E2E6C697374656E6572733D5B5D2C6E2E66696C65733D5B5D2C22737472696E6722';
wwv_flow_api.g_varchar2_table(24) := '3D3D747970656F66206E2E656C656D656E742626286E2E656C656D656E743D646F63756D656E742E717565727953656C6563746F72286E2E656C656D656E7429292C216E2E656C656D656E747C7C6E756C6C3D3D6E2E656C656D656E742E6E6F64655479';
wwv_flow_api.g_varchar2_table(25) := '7065297468726F77206E6577204572726F722822496E76616C69642064726F707A6F6E6520656C656D656E742E22293B6966286E2E656C656D656E742E64726F707A6F6E65297468726F77206E6577204572726F72282244726F707A6F6E6520616C7265';
wwv_flow_api.g_varchar2_table(26) := '6164792061747461636865642E22293B742E696E7374616E6365732E70757368286E292C6E2E656C656D656E742E64726F707A6F6E653D6E3B766172206F3D6E756C6C213D28613D742E6F7074696F6E73466F72456C656D656E74286E2E656C656D656E';
wwv_flow_api.g_varchar2_table(27) := '7429293F613A7B7D3B6966286E2E6F7074696F6E733D742E657874656E64287B7D2C6E2E64656661756C744F7074696F6E732C6F2C6E756C6C213D693F693A7B7D292C6E2E6F7074696F6E732E666F72636546616C6C6261636B7C7C21742E697342726F';
wwv_flow_api.g_varchar2_table(28) := '77736572537570706F727465642829297B766172206C3B72657475726E206C3D6E2E6F7074696F6E732E66616C6C6261636B2E63616C6C286E292C5F706F737369626C65436F6E7374727563746F7252657475726E286E2C6C297D6966286E756C6C3D3D';
wwv_flow_api.g_varchar2_table(29) := '6E2E6F7074696F6E732E75726C2626286E2E6F7074696F6E732E75726C3D6E2E656C656D656E742E6765744174747269627574652822616374696F6E2229292C216E2E6F7074696F6E732E75726C297468726F77206E6577204572726F7228224E6F2055';
wwv_flow_api.g_varchar2_table(30) := '524C2070726F76696465642E22293B6966286E2E6F7074696F6E732E616363657074656446696C657326266E2E6F7074696F6E732E61636365707465644D696D655479706573297468726F77206E6577204572726F722822596F752063616E2774207072';
wwv_flow_api.g_varchar2_table(31) := '6F7669646520626F74682027616363657074656446696C65732720616E64202761636365707465644D696D655479706573272E202761636365707465644D696D6554797065732720697320646570726563617465642E22293B6966286E2E6F7074696F6E';
wwv_flow_api.g_varchar2_table(32) := '732E75706C6F61644D756C7469706C6526266E2E6F7074696F6E732E6368756E6B696E67297468726F77206E6577204572726F722822596F752063616E6E6F742073657420626F74683A2075706C6F61644D756C7469706C6520616E64206368756E6B69';
wwv_flow_api.g_varchar2_table(33) := '6E672E22293B72657475726E206E2E6F7074696F6E732E61636365707465644D696D6554797065732626286E2E6F7074696F6E732E616363657074656446696C65733D6E2E6F7074696F6E732E61636365707465644D696D6554797065732C64656C6574';
wwv_flow_api.g_varchar2_table(34) := '65206E2E6F7074696F6E732E61636365707465644D696D655479706573292C6E756C6C213D6E2E6F7074696F6E732E72656E616D6546696C656E616D652626286E2E6F7074696F6E732E72656E616D6546696C653D66756E6374696F6E2865297B726574';
wwv_flow_api.g_varchar2_table(35) := '75726E206E2E6F7074696F6E732E72656E616D6546696C656E616D652E63616C6C286E2C652E6E616D652C65297D292C6E2E6F7074696F6E732E6D6574686F643D6E2E6F7074696F6E732E6D6574686F642E746F55707065724361736528292C28723D6E';
wwv_flow_api.g_varchar2_table(36) := '2E6765744578697374696E6746616C6C6261636B2829292626722E706172656E744E6F64652626722E706172656E744E6F64652E72656D6F76654368696C642872292C6E2E6F7074696F6E732E7072657669657773436F6E7461696E6572213D3D213126';
wwv_flow_api.g_varchar2_table(37) := '26286E2E6F7074696F6E732E7072657669657773436F6E7461696E65723F6E2E7072657669657773436F6E7461696E65723D742E676574456C656D656E74286E2E6F7074696F6E732E7072657669657773436F6E7461696E65722C227072657669657773';
wwv_flow_api.g_varchar2_table(38) := '436F6E7461696E657222293A6E2E7072657669657773436F6E7461696E65723D6E2E656C656D656E74292C6E2E6F7074696F6E732E636C69636B61626C652626286E2E6F7074696F6E732E636C69636B61626C653D3D3D21303F6E2E636C69636B61626C';
wwv_flow_api.g_varchar2_table(39) := '65456C656D656E74733D5B6E2E656C656D656E745D3A6E2E636C69636B61626C65456C656D656E74733D742E676574456C656D656E7473286E2E6F7074696F6E732E636C69636B61626C652C22636C69636B61626C652229292C6E2E696E697428292C6E';
wwv_flow_api.g_varchar2_table(40) := '7D72657475726E205F696E68657269747328742C65292C5F637265617465436C61737328742C6E756C6C2C5B7B6B65793A22696E6974436C617373222C76616C75653A66756E6374696F6E28297B746869732E70726F746F747970652E456D6974746572';
wwv_flow_api.g_varchar2_table(41) := '3D456D69747465722C746869732E70726F746F747970652E6576656E74733D5B2264726F70222C22647261677374617274222C2264726167656E64222C2264726167656E746572222C22647261676F766572222C22647261676C65617665222C22616464';
wwv_flow_api.g_varchar2_table(42) := '656466696C65222C22616464656466696C6573222C2272656D6F76656466696C65222C227468756D626E61696C222C226572726F72222C226572726F726D756C7469706C65222C2270726F63657373696E67222C2270726F63657373696E676D756C7469';
wwv_flow_api.g_varchar2_table(43) := '706C65222C2275706C6F616470726F6772657373222C22746F74616C75706C6F616470726F6772657373222C2273656E64696E67222C2273656E64696E676D756C7469706C65222C2273756363657373222C22737563636573736D756C7469706C65222C';
wwv_flow_api.g_varchar2_table(44) := '2263616E63656C6564222C2263616E63656C65646D756C7469706C65222C22636F6D706C657465222C22636F6D706C6574656D756C7469706C65222C227265736574222C226D617866696C65736578636565646564222C226D617866696C657372656163';
wwv_flow_api.g_varchar2_table(45) := '686564222C227175657565636F6D706C657465225D2C746869732E70726F746F747970652E64656661756C744F7074696F6E733D7B75726C3A6E756C6C2C6D6574686F643A22706F7374222C7769746843726564656E7469616C733A21312C74696D656F';
wwv_flow_api.g_varchar2_table(46) := '75743A3365342C706172616C6C656C55706C6F6164733A322C75706C6F61644D756C7469706C653A21312C6368756E6B696E673A21312C666F7263654368756E6B696E673A21312C6368756E6B53697A653A3265362C706172616C6C656C4368756E6B55';
wwv_flow_api.g_varchar2_table(47) := '706C6F6164733A21312C72657472794368756E6B733A21312C72657472794368756E6B734C696D69743A332C6D617846696C6573697A653A3235362C706172616D4E616D653A2266696C65222C637265617465496D6167655468756D626E61696C733A21';
wwv_flow_api.g_varchar2_table(48) := '302C6D61785468756D626E61696C46696C6573697A653A31302C7468756D626E61696C57696474683A3132302C7468756D626E61696C4865696768743A3132302C7468756D626E61696C4D6574686F643A2263726F70222C726573697A6557696474683A';
wwv_flow_api.g_varchar2_table(49) := '6E756C6C2C726573697A654865696768743A6E756C6C2C726573697A654D696D65547970653A6E756C6C2C726573697A655175616C6974793A2E382C726573697A654D6574686F643A22636F6E7461696E222C66696C6573697A65426173653A3165332C';
wwv_flow_api.g_varchar2_table(50) := '6D617846696C65733A6E756C6C2C686561646572733A6E756C6C2C636C69636B61626C653A21302C69676E6F726548696464656E46696C65733A21302C616363657074656446696C65733A6E756C6C2C61636365707465644D696D6554797065733A6E75';
wwv_flow_api.g_varchar2_table(51) := '6C6C2C6175746F50726F6365737351756575653A21302C6175746F51756575653A21302C61646452656D6F76654C696E6B733A21312C7072657669657773436F6E7461696E65723A6E756C6C2C68696464656E496E707574436F6E7461696E65723A2262';
wwv_flow_api.g_varchar2_table(52) := '6F6479222C636170747572653A6E756C6C2C72656E616D6546696C656E616D653A6E756C6C2C72656E616D6546696C653A6E756C6C2C666F72636546616C6C6261636B3A21312C6469637444656661756C744D6573736167653A2244726F702066696C65';
wwv_flow_api.g_varchar2_table(53) := '73206865726520746F2075706C6F6164222C6469637446616C6C6261636B4D6573736167653A22596F75722062726F7773657220646F6573206E6F7420737570706F72742064726167276E2764726F702066696C652075706C6F6164732E222C64696374';
wwv_flow_api.g_varchar2_table(54) := '46616C6C6261636B546578743A22506C6561736520757365207468652066616C6C6261636B20666F726D2062656C6F7720746F2075706C6F616420796F75722066696C6573206C696B6520696E20746865206F6C64656E20646179732E222C6469637446';
wwv_flow_api.g_varchar2_table(55) := '696C65546F6F4269673A2246696C6520697320746F6F2062696720287B7B66696C6573697A657D7D4D6942292E204D61782066696C6573697A653A207B7B6D617846696C6573697A657D7D4D69422E222C64696374496E76616C696446696C6554797065';
wwv_flow_api.g_varchar2_table(56) := '3A22596F752063616E27742075706C6F61642066696C6573206F66207468697320747970652E222C64696374526573706F6E73654572726F723A2253657276657220726573706F6E6465642077697468207B7B737461747573436F64657D7D20636F6465';
wwv_flow_api.g_varchar2_table(57) := '2E222C6469637443616E63656C55706C6F61643A2243616E63656C2075706C6F6164222C6469637455706C6F616443616E63656C65643A2255706C6F61642063616E63656C65642E222C6469637443616E63656C55706C6F6164436F6E6669726D617469';
wwv_flow_api.g_varchar2_table(58) := '6F6E3A2241726520796F75207375726520796F752077616E7420746F2063616E63656C20746869732075706C6F61643F222C6469637452656D6F766546696C653A2252656D6F76652066696C65222C6469637452656D6F766546696C65436F6E6669726D';
wwv_flow_api.g_varchar2_table(59) := '6174696F6E3A6E756C6C2C646963744D617846696C657345786365656465643A22596F752063616E206E6F742075706C6F616420616E79206D6F72652066696C65732E222C6469637446696C6553697A65556E6974733A7B74623A225442222C67623A22';
wwv_flow_api.g_varchar2_table(60) := '4742222C6D623A224D42222C6B623A224B42222C623A2262227D2C696E69743A66756E6374696F6E28297B7D2C706172616D733A66756E6374696F6E28652C742C69297B696628692972657475726E7B647A757569643A692E66696C652E75706C6F6164';
wwv_flow_api.g_varchar2_table(61) := '2E757569642C647A6368756E6B696E6465783A692E696E6465782C647A746F74616C66696C6573697A653A692E66696C652E73697A652C647A6368756E6B73697A653A746869732E6F7074696F6E732E6368756E6B53697A652C647A746F74616C636875';
wwv_flow_api.g_varchar2_table(62) := '6E6B636F756E743A692E66696C652E75706C6F61642E746F74616C4368756E6B436F756E742C647A6368756E6B627974656F66667365743A692E696E6465782A746869732E6F7074696F6E732E6368756E6B53697A657D7D2C6163636570743A66756E63';
wwv_flow_api.g_varchar2_table(63) := '74696F6E28652C74297B72657475726E207428297D2C6368756E6B7355706C6F616465643A66756E6374696F6E28652C74297B7428297D2C66616C6C6261636B3A66756E6374696F6E28297B76617220653D766F696420303B746869732E656C656D656E';
wwv_flow_api.g_varchar2_table(64) := '742E636C6173734E616D653D746869732E656C656D656E742E636C6173734E616D652B2220647A2D62726F777365722D6E6F742D737570706F72746564223B666F722876617220693D746869732E656C656D656E742E676574456C656D656E7473427954';
wwv_flow_api.g_varchar2_table(65) := '61674E616D65282264697622292C6E3D21302C723D302C693D6E3F693A695B53796D626F6C2E6974657261746F725D28293B3B297B76617220613B6966286E297B696628723E3D692E6C656E67746829627265616B3B613D695B722B2B5D7D656C73657B';
wwv_flow_api.g_varchar2_table(66) := '696628723D692E6E65787428292C722E646F6E6529627265616B3B613D722E76616C75657D766172206F3D613B6966282F285E7C2029647A2D6D65737361676528247C20292F2E74657374286F2E636C6173734E616D6529297B653D6F2C6F2E636C6173';
wwv_flow_api.g_varchar2_table(67) := '734E616D653D22647A2D6D657373616765223B627265616B7D7D657C7C28653D742E637265617465456C656D656E7428273C64697620636C6173733D22647A2D6D657373616765223E3C7370616E3E3C2F7370616E3E3C2F6469763E27292C746869732E';
wwv_flow_api.g_varchar2_table(68) := '656C656D656E742E617070656E644368696C64286529293B766172206C3D652E676574456C656D656E747342795461674E616D6528227370616E22295B305D3B72657475726E206C2626286E756C6C213D6C2E74657874436F6E74656E743F6C2E746578';
wwv_flow_api.g_varchar2_table(69) := '74436F6E74656E743D746869732E6F7074696F6E732E6469637446616C6C6261636B4D6573736167653A6E756C6C213D6C2E696E6E6572546578742626286C2E696E6E6572546578743D746869732E6F7074696F6E732E6469637446616C6C6261636B4D';
wwv_flow_api.g_varchar2_table(70) := '65737361676529292C746869732E656C656D656E742E617070656E644368696C6428746869732E67657446616C6C6261636B466F726D2829297D2C726573697A653A66756E6374696F6E28652C742C692C6E297B76617220723D7B737263583A302C7372';
wwv_flow_api.g_varchar2_table(71) := '63593A302C73726357696474683A652E77696474682C7372634865696768743A652E6865696768747D2C613D652E77696474682F652E6865696768743B6E756C6C3D3D7426266E756C6C3D3D693F28743D722E73726357696474682C693D722E73726348';
wwv_flow_api.g_varchar2_table(72) := '6569676874293A6E756C6C3D3D743F743D692A613A6E756C6C3D3D69262628693D742F61292C743D4D6174682E6D696E28742C722E7372635769647468292C693D4D6174682E6D696E28692C722E737263486569676874293B766172206F3D742F693B69';
wwv_flow_api.g_varchar2_table(73) := '6628722E73726357696474683E747C7C722E7372634865696768743E69296966282263726F70223D3D3D6E29613E6F3F28722E7372634865696768743D652E6865696768742C722E73726357696474683D722E7372634865696768742A6F293A28722E73';
wwv_flow_api.g_varchar2_table(74) := '726357696474683D652E77696474682C722E7372634865696768743D722E73726357696474682F6F293B656C73657B69662822636F6E7461696E22213D3D6E297468726F77206E6577204572726F722822556E6B6E6F776E20726573697A654D6574686F';
wwv_flow_api.g_varchar2_table(75) := '642027222B6E2B222722293B613E6F3F693D742F613A743D692A617D72657475726E20722E737263583D28652E77696474682D722E7372635769647468292F322C722E737263593D28652E6865696768742D722E737263486569676874292F322C722E74';
wwv_flow_api.g_varchar2_table(76) := '726757696474683D742C722E7472674865696768743D692C727D2C7472616E73666F726D46696C653A66756E6374696F6E28652C74297B72657475726E28746869732E6F7074696F6E732E726573697A6557696474687C7C746869732E6F7074696F6E73';
wwv_flow_api.g_varchar2_table(77) := '2E726573697A65486569676874292626652E747970652E6D61746368282F696D6167652E2A2F293F746869732E726573697A65496D61676528652C746869732E6F7074696F6E732E726573697A6557696474682C746869732E6F7074696F6E732E726573';
wwv_flow_api.g_varchar2_table(78) := '697A654865696768742C746869732E6F7074696F6E732E726573697A654D6574686F642C74293A742865297D2C7072657669657754656D706C6174653A273C64697620636C6173733D22647A2D7072657669657720647A2D66696C652D70726576696577';
wwv_flow_api.g_varchar2_table(79) := '223E5C6E20203C64697620636C6173733D22647A2D696D616765223E3C696D6720646174612D647A2D7468756D626E61696C202F3E3C2F6469763E5C6E20203C64697620636C6173733D22647A2D64657461696C73223E5C6E202020203C64697620636C';
wwv_flow_api.g_varchar2_table(80) := '6173733D22647A2D73697A65223E3C7370616E20646174612D647A2D73697A653E3C2F7370616E3E3C2F6469763E5C6E202020203C64697620636C6173733D22647A2D66696C656E616D65223E3C7370616E20646174612D647A2D6E616D653E3C2F7370';
wwv_flow_api.g_varchar2_table(81) := '616E3E3C2F6469763E5C6E20203C2F6469763E5C6E20203C64697620636C6173733D22647A2D70726F6772657373223E3C7370616E20636C6173733D22647A2D75706C6F61642220646174612D647A2D75706C6F616470726F67726573733E3C2F737061';
wwv_flow_api.g_varchar2_table(82) := '6E3E3C2F6469763E5C6E20203C64697620636C6173733D22647A2D6572726F722D6D657373616765223E3C7370616E20646174612D647A2D6572726F726D6573736167653E3C2F7370616E3E3C2F6469763E5C6E20203C64697620636C6173733D22647A';
wwv_flow_api.g_varchar2_table(83) := '2D737563636573732D6D61726B223E5C6E202020203C7376672077696474683D223534707822206865696768743D2235347078222076696577426F783D22302030203534203534222076657273696F6E3D22312E312220786D6C6E733D22687474703A2F';
wwv_flow_api.g_varchar2_table(84) := '2F7777772E77332E6F72672F323030302F7376672220786D6C6E733A786C696E6B3D22687474703A2F2F7777772E77332E6F72672F313939392F786C696E6B2220786D6C6E733A736B657463683D22687474703A2F2F7777772E626F68656D69616E636F';
wwv_flow_api.g_varchar2_table(85) := '64696E672E636F6D2F736B657463682F6E73223E5C6E2020202020203C7469746C653E436865636B3C2F7469746C653E5C6E2020202020203C646566733E3C2F646566733E5C6E2020202020203C672069643D22506167652D3122207374726F6B653D22';
wwv_flow_api.g_varchar2_table(86) := '6E6F6E6522207374726F6B652D77696474683D2231222066696C6C3D226E6F6E65222066696C6C2D72756C653D226576656E6F64642220736B657463683A747970653D224D5350616765223E5C6E20202020202020203C7061746820643D224D32332E35';
wwv_flow_api.g_varchar2_table(87) := '2C33312E38343331343538204C31372E353835323431392C32352E39323833383737204331362E303234383235332C32342E333637393731312031332E343931303239342C32342E3336363833352031312E393238393332322C32352E39323839333232';
wwv_flow_api.g_varchar2_table(88) := '204331302E333730303133362C32372E343837383530382031302E333636353931322C33302E303233343435352031312E393238333837372C33312E35383532343139204C32302E343134373538312C34302E30373136313233204332302E3531333339';
wwv_flow_api.g_varchar2_table(89) := '39392C34302E313730323534312032302E363135393331352C34302E323632363634392032302E373231383631352C34302E33343838343335204332322E323833353636392C34312E383732353635312032342E3739343233342C34312E383632363230';
wwv_flow_api.g_varchar2_table(90) := '322032362E333436313536342C34302E33313036393738204C34332E333130363937382C32332E33343631353634204334342E383737313032312C32312E373739373532312034342E383735383035372C31392E323438333838372034332E3331333730';
wwv_flow_api.g_varchar2_table(91) := '38352C31372E36383632393135204334312E373534373839392C31362E313237333732392033392E323137363033352C31362E313235353432322033372E363533383433362C31372E36383933303232204C32332E352C33312E38343331343538205A20';
wwv_flow_api.g_varchar2_table(92) := '4D32372C3533204334312E333539343033352C35332035332C34312E333539343033352035332C3237204335332C31322E363430353936352034312E333539343033352C312032372C31204331322E363430353936352C3120312C31322E363430353936';
wwv_flow_api.g_varchar2_table(93) := '3520312C32372043312C34312E333539343033352031322E363430353936352C35332032372C3533205A222069643D224F76616C2D3222207374726F6B652D6F7061636974793D22302E31393837393431353822207374726F6B653D2223373437343734';
wwv_flow_api.g_varchar2_table(94) := '222066696C6C2D6F7061636974793D22302E383136353139343735222066696C6C3D22234646464646462220736B657463683A747970653D224D53536861706547726F7570223E3C2F706174683E5C6E2020202020203C2F673E5C6E202020203C2F7376';
wwv_flow_api.g_varchar2_table(95) := '673E5C6E20203C2F6469763E5C6E20203C64697620636C6173733D22647A2D6572726F722D6D61726B223E5C6E202020203C7376672077696474683D223534707822206865696768743D2235347078222076696577426F783D2230203020353420353422';
wwv_flow_api.g_varchar2_table(96) := '2076657273696F6E3D22312E312220786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F7376672220786D6C6E733A786C696E6B3D22687474703A2F2F7777772E77332E6F72672F313939392F786C696E6B2220786D6C6E733A73';
wwv_flow_api.g_varchar2_table(97) := '6B657463683D22687474703A2F2F7777772E626F68656D69616E636F64696E672E636F6D2F736B657463682F6E73223E5C6E2020202020203C7469746C653E4572726F723C2F7469746C653E5C6E2020202020203C646566733E3C2F646566733E5C6E20';
wwv_flow_api.g_varchar2_table(98) := '20202020203C672069643D22506167652D3122207374726F6B653D226E6F6E6522207374726F6B652D77696474683D2231222066696C6C3D226E6F6E65222066696C6C2D72756C653D226576656E6F64642220736B657463683A747970653D224D535061';
wwv_flow_api.g_varchar2_table(99) := '6765223E5C6E20202020202020203C672069643D22436865636B2D2B2D4F76616C2D322220736B657463683A747970653D224D534C6179657247726F757022207374726F6B653D222337343734373422207374726F6B652D6F7061636974793D22302E31';
wwv_flow_api.g_varchar2_table(100) := '3938373934313538222066696C6C3D2223464646464646222066696C6C2D6F7061636974793D22302E383136353139343735223E5C6E202020202020202020203C7061746820643D224D33322E363536383534322C3239204C33382E333130363937382C';
wwv_flow_api.g_varchar2_table(101) := '32332E33343631353634204333392E383737313032312C32312E373739373532312033392E383735383035372C31392E323438333838372033382E333133373038352C31372E36383632393135204333362E373534373839392C31362E31323733373239';
wwv_flow_api.g_varchar2_table(102) := '2033342E323137363033352C31362E313235353432322033322E363533383433362C31372E36383933303232204C32372C32332E33343331343538204C32312E333436313536342C31372E36383933303232204331392E373832333936352C31362E3132';
wwv_flow_api.g_varchar2_table(103) := '35353432322031372E323435323130312C31362E313237333732392031352E363836323931352C31372E36383632393135204331342E313234313934332C31392E323438333838372031342E313232383937392C32312E373739373532312031352E3638';
wwv_flow_api.g_varchar2_table(104) := '39333032322C32332E33343631353634204C32312E333433313435382C3239204C31352E363839333032322C33342E36353338343336204331342E313232383937392C33362E323230323437392031342E313234313934332C33382E3735313631313320';
wwv_flow_api.g_varchar2_table(105) := '31352E363836323931352C34302E33313337303835204331372E323435323130312C34312E383732363237312031392E373832333936352C34312E383734343537382032312E333436313536342C34302E33313036393738204C32372C33342E36353638';
wwv_flow_api.g_varchar2_table(106) := '353432204C33322E363533383433362C34302E33313036393738204333342E323137363033352C34312E383734343537382033362E373534373839392C34312E383732363237312033382E333133373038352C34302E33313337303835204333392E3837';
wwv_flow_api.g_varchar2_table(107) := '35383035372C33382E373531363131332033392E383737313032312C33362E323230323437392033382E333130363937382C33342E36353338343336204C33322E363536383534322C3239205A204D32372C3533204334312E333539343033352C353320';
wwv_flow_api.g_varchar2_table(108) := '35332C34312E333539343033352035332C3237204335332C31322E363430353936352034312E333539343033352C312032372C31204331322E363430353936352C3120312C31322E3634303539363520312C32372043312C34312E333539343033352031';
wwv_flow_api.g_varchar2_table(109) := '322E363430353936352C35332032372C3533205A222069643D224F76616C2D322220736B657463683A747970653D224D53536861706547726F7570223E3C2F706174683E5C6E20202020202020203C2F673E5C6E2020202020203C2F673E5C6E20202020';
wwv_flow_api.g_varchar2_table(110) := '3C2F7376673E5C6E20203C2F6469763E5C6E3C2F6469763E272C64726F703A66756E6374696F6E2865297B72657475726E20746869732E656C656D656E742E636C6173734C6973742E72656D6F76652822647A2D647261672D686F76657222297D2C6472';
wwv_flow_api.g_varchar2_table(111) := '616773746172743A66756E6374696F6E2865297B7D2C64726167656E643A66756E6374696F6E2865297B72657475726E20746869732E656C656D656E742E636C6173734C6973742E72656D6F76652822647A2D647261672D686F76657222297D2C647261';
wwv_flow_api.g_varchar2_table(112) := '67656E7465723A66756E6374696F6E2865297B72657475726E20746869732E656C656D656E742E636C6173734C6973742E6164642822647A2D647261672D686F76657222297D2C647261676F7665723A66756E6374696F6E2865297B72657475726E2074';
wwv_flow_api.g_varchar2_table(113) := '6869732E656C656D656E742E636C6173734C6973742E6164642822647A2D647261672D686F76657222297D2C647261676C656176653A66756E6374696F6E2865297B72657475726E20746869732E656C656D656E742E636C6173734C6973742E72656D6F';
wwv_flow_api.g_varchar2_table(114) := '76652822647A2D647261672D686F76657222297D2C70617374653A66756E6374696F6E2865297B7D2C72657365743A66756E6374696F6E28297B72657475726E20746869732E656C656D656E742E636C6173734C6973742E72656D6F76652822647A2D73';
wwv_flow_api.g_varchar2_table(115) := '74617274656422297D2C616464656466696C653A66756E6374696F6E2865297B76617220693D746869733B696628746869732E656C656D656E743D3D3D746869732E7072657669657773436F6E7461696E65722626746869732E656C656D656E742E636C';
wwv_flow_api.g_varchar2_table(116) := '6173734C6973742E6164642822647A2D7374617274656422292C746869732E7072657669657773436F6E7461696E6572297B652E70726576696577456C656D656E743D742E637265617465456C656D656E7428746869732E6F7074696F6E732E70726576';
wwv_flow_api.g_varchar2_table(117) := '69657754656D706C6174652E7472696D2829292C652E7072657669657754656D706C6174653D652E70726576696577456C656D656E742C746869732E7072657669657773436F6E7461696E65722E617070656E644368696C6428652E7072657669657745';
wwv_flow_api.g_varchar2_table(118) := '6C656D656E74293B666F7228766172206E3D652E70726576696577456C656D656E742E717565727953656C6563746F72416C6C28225B646174612D647A2D6E616D655D22292C723D21302C613D302C6E3D723F6E3A6E5B53796D626F6C2E697465726174';
wwv_flow_api.g_varchar2_table(119) := '6F725D28293B3B297B766172206F3B69662872297B696628613E3D6E2E6C656E67746829627265616B3B6F3D6E5B612B2B5D7D656C73657B696628613D6E2E6E65787428292C612E646F6E6529627265616B3B6F3D612E76616C75657D766172206C3D6F';
wwv_flow_api.g_varchar2_table(120) := '3B6C2E74657874436F6E74656E743D652E6E616D657D666F722876617220733D652E70726576696577456C656D656E742E717565727953656C6563746F72416C6C28225B646174612D647A2D73697A655D22292C753D21302C643D302C733D753F733A73';
wwv_flow_api.g_varchar2_table(121) := '5B53796D626F6C2E6974657261746F725D28293B3B297B69662875297B696628643E3D732E6C656E67746829627265616B3B6C3D735B642B2B5D7D656C73657B696628643D732E6E65787428292C642E646F6E6529627265616B3B6C3D642E76616C7565';
wwv_flow_api.g_varchar2_table(122) := '7D6C2E696E6E657248544D4C3D746869732E66696C6573697A6528652E73697A65297D746869732E6F7074696F6E732E61646452656D6F76654C696E6B73262628652E5F72656D6F76654C696E6B3D742E637265617465456C656D656E7428273C612063';
wwv_flow_api.g_varchar2_table(123) := '6C6173733D22647A2D72656D6F76652220687265663D226A6176617363726970743A756E646566696E65643B2220646174612D647A2D72656D6F76653E272B746869732E6F7074696F6E732E6469637452656D6F766546696C652B223C2F613E22292C65';
wwv_flow_api.g_varchar2_table(124) := '2E70726576696577456C656D656E742E617070656E644368696C6428652E5F72656D6F76654C696E6B29293B666F722876617220633D66756E6374696F6E286E297B72657475726E206E2E70726576656E7444656661756C7428292C6E2E73746F705072';
wwv_flow_api.g_varchar2_table(125) := '6F7061676174696F6E28292C652E7374617475733D3D3D742E55504C4F4144494E473F742E636F6E6669726D28692E6F7074696F6E732E6469637443616E63656C55706C6F6164436F6E6669726D6174696F6E2C66756E6374696F6E28297B7265747572';
wwv_flow_api.g_varchar2_table(126) := '6E20692E72656D6F766546696C652865297D293A692E6F7074696F6E732E6469637452656D6F766546696C65436F6E6669726D6174696F6E3F742E636F6E6669726D28692E6F7074696F6E732E6469637452656D6F766546696C65436F6E6669726D6174';
wwv_flow_api.g_varchar2_table(127) := '696F6E2C66756E6374696F6E28297B72657475726E20692E72656D6F766546696C652865297D293A692E72656D6F766546696C652865297D2C703D652E70726576696577456C656D656E742E717565727953656C6563746F72416C6C28225B646174612D';
wwv_flow_api.g_varchar2_table(128) := '647A2D72656D6F76655D22292C683D21302C663D302C703D683F703A705B53796D626F6C2E6974657261746F725D28293B3B297B76617220763B69662868297B696628663E3D702E6C656E67746829627265616B3B763D705B662B2B5D7D656C73657B69';
wwv_flow_api.g_varchar2_table(129) := '6628663D702E6E65787428292C662E646F6E6529627265616B3B763D662E76616C75657D766172206D3D763B6D2E6164644576656E744C697374656E65722822636C69636B222C63297D7D7D2C72656D6F76656466696C653A66756E6374696F6E286529';
wwv_flow_api.g_varchar2_table(130) := '7B72657475726E206E756C6C213D652E70726576696577456C656D656E7426266E756C6C213D652E70726576696577456C656D656E742E706172656E744E6F64652626652E70726576696577456C656D656E742E706172656E744E6F64652E72656D6F76';
wwv_flow_api.g_varchar2_table(131) := '654368696C6428652E70726576696577456C656D656E74292C746869732E5F7570646174654D617846696C657352656163686564436C61737328297D2C7468756D626E61696C3A66756E6374696F6E28652C74297B696628652E70726576696577456C65';
wwv_flow_api.g_varchar2_table(132) := '6D656E74297B652E70726576696577456C656D656E742E636C6173734C6973742E72656D6F76652822647A2D66696C652D7072657669657722293B666F722876617220693D652E70726576696577456C656D656E742E717565727953656C6563746F7241';
wwv_flow_api.g_varchar2_table(133) := '6C6C28225B646174612D647A2D7468756D626E61696C5D22292C6E3D21302C723D302C693D6E3F693A695B53796D626F6C2E6974657261746F725D28293B3B297B76617220613B6966286E297B696628723E3D692E6C656E67746829627265616B3B613D';
wwv_flow_api.g_varchar2_table(134) := '695B722B2B5D7D656C73657B696628723D692E6E65787428292C722E646F6E6529627265616B3B613D722E76616C75657D766172206F3D613B6F2E616C743D652E6E616D652C6F2E7372633D747D72657475726E2073657454696D656F75742866756E63';
wwv_flow_api.g_varchar2_table(135) := '74696F6E28297B72657475726E20652E70726576696577456C656D656E742E636C6173734C6973742E6164642822647A2D696D6167652D7072657669657722297D2C31297D7D2C6572726F723A66756E6374696F6E28652C74297B696628652E70726576';
wwv_flow_api.g_varchar2_table(136) := '696577456C656D656E74297B652E70726576696577456C656D656E742E636C6173734C6973742E6164642822647A2D6572726F7222292C22537472696E6722213D747970656F6620742626742E6572726F72262628743D742E6572726F72293B666F7228';
wwv_flow_api.g_varchar2_table(137) := '76617220693D652E70726576696577456C656D656E742E717565727953656C6563746F72416C6C28225B646174612D647A2D6572726F726D6573736167655D22292C6E3D21302C723D302C693D6E3F693A695B53796D626F6C2E6974657261746F725D28';
wwv_flow_api.g_varchar2_table(138) := '293B3B297B76617220613B6966286E297B696628723E3D692E6C656E67746829627265616B3B613D695B722B2B5D7D656C73657B696628723D692E6E65787428292C722E646F6E6529627265616B3B613D722E76616C75657D766172206F3D613B6F2E74';
wwv_flow_api.g_varchar2_table(139) := '657874436F6E74656E743D747D7D7D2C6572726F726D756C7469706C653A66756E6374696F6E28297B7D2C70726F63657373696E673A66756E6374696F6E2865297B696628652E70726576696577456C656D656E74262628652E70726576696577456C65';
wwv_flow_api.g_varchar2_table(140) := '6D656E742E636C6173734C6973742E6164642822647A2D70726F63657373696E6722292C652E5F72656D6F76654C696E6B292972657475726E20652E5F72656D6F76654C696E6B2E696E6E657248544D4C3D746869732E6F7074696F6E732E6469637443';
wwv_flow_api.g_varchar2_table(141) := '616E63656C55706C6F61647D2C70726F63657373696E676D756C7469706C653A66756E6374696F6E28297B7D2C75706C6F616470726F67726573733A66756E6374696F6E28652C742C69297B696628652E70726576696577456C656D656E7429666F7228';
wwv_flow_api.g_varchar2_table(142) := '766172206E3D652E70726576696577456C656D656E742E717565727953656C6563746F72416C6C28225B646174612D647A2D75706C6F616470726F67726573735D22292C723D21302C613D302C6E3D723F6E3A6E5B53796D626F6C2E6974657261746F72';
wwv_flow_api.g_varchar2_table(143) := '5D28293B3B297B766172206F3B69662872297B696628613E3D6E2E6C656E67746829627265616B3B6F3D6E5B612B2B5D7D656C73657B696628613D6E2E6E65787428292C612E646F6E6529627265616B3B6F3D612E76616C75657D766172206C3D6F3B22';
wwv_flow_api.g_varchar2_table(144) := '50524F4752455353223D3D3D6C2E6E6F64654E616D653F6C2E76616C75653D743A6C2E7374796C652E77696474683D742B2225227D7D2C746F74616C75706C6F616470726F67726573733A66756E6374696F6E28297B7D2C73656E64696E673A66756E63';
wwv_flow_api.g_varchar2_table(145) := '74696F6E28297B7D2C73656E64696E676D756C7469706C653A66756E6374696F6E28297B7D2C737563636573733A66756E6374696F6E2865297B696628652E70726576696577456C656D656E742972657475726E20652E70726576696577456C656D656E';
wwv_flow_api.g_varchar2_table(146) := '742E636C6173734C6973742E6164642822647A2D7375636365737322297D2C737563636573736D756C7469706C653A66756E6374696F6E28297B7D2C63616E63656C65643A66756E6374696F6E2865297B72657475726E20746869732E656D6974282265';
wwv_flow_api.g_varchar2_table(147) := '72726F72222C652C746869732E6F7074696F6E732E6469637455706C6F616443616E63656C6564297D2C63616E63656C65646D756C7469706C653A66756E6374696F6E28297B7D2C636F6D706C6574653A66756E6374696F6E2865297B696628652E5F72';
wwv_flow_api.g_varchar2_table(148) := '656D6F76654C696E6B262628652E5F72656D6F76654C696E6B2E696E6E657248544D4C3D746869732E6F7074696F6E732E6469637452656D6F766546696C65292C652E70726576696577456C656D656E742972657475726E20652E70726576696577456C';
wwv_flow_api.g_varchar2_table(149) := '656D656E742E636C6173734C6973742E6164642822647A2D636F6D706C65746522297D2C636F6D706C6574656D756C7469706C653A66756E6374696F6E28297B7D2C6D617866696C657365786365656465643A66756E6374696F6E28297B7D2C6D617866';
wwv_flow_api.g_varchar2_table(150) := '696C6573726561636865643A66756E6374696F6E28297B7D2C7175657565636F6D706C6574653A66756E6374696F6E28297B7D2C616464656466696C65733A66756E6374696F6E28297B7D7D2C746869732E70726F746F747970652E5F7468756D626E61';
wwv_flow_api.g_varchar2_table(151) := '696C51756575653D5B5D2C746869732E70726F746F747970652E5F70726F63657373696E675468756D626E61696C3D21317D7D2C7B6B65793A22657874656E64222C76616C75653A66756E6374696F6E2865297B666F722876617220743D617267756D65';
wwv_flow_api.g_varchar2_table(152) := '6E74732E6C656E6774682C693D417272617928743E313F742D313A30292C6E3D313B6E3C743B6E2B2B29695B6E2D315D3D617267756D656E74735B6E5D3B666F722876617220723D692C613D21302C6F3D302C723D613F723A725B53796D626F6C2E6974';
wwv_flow_api.g_varchar2_table(153) := '657261746F725D28293B3B297B766172206C3B69662861297B6966286F3E3D722E6C656E67746829627265616B3B6C3D725B6F2B2B5D7D656C73657B6966286F3D722E6E65787428292C6F2E646F6E6529627265616B3B6C3D6F2E76616C75657D766172';
wwv_flow_api.g_varchar2_table(154) := '20733D6C3B666F7228766172207520696E2073297B76617220643D735B755D3B655B755D3D647D7D72657475726E20657D7D5D292C5F637265617465436C61737328742C5B7B6B65793A22676574416363657074656446696C6573222C76616C75653A66';
wwv_flow_api.g_varchar2_table(155) := '756E6374696F6E28297B72657475726E20746869732E66696C65732E66696C7465722866756E6374696F6E2865297B72657475726E20652E61636365707465647D292E6D61702866756E6374696F6E2865297B72657475726E20657D297D7D2C7B6B6579';
wwv_flow_api.g_varchar2_table(156) := '3A2267657452656A656374656446696C6573222C76616C75653A66756E6374696F6E28297B72657475726E20746869732E66696C65732E66696C7465722866756E6374696F6E2865297B72657475726E21652E61636365707465647D292E6D6170286675';
wwv_flow_api.g_varchar2_table(157) := '6E6374696F6E2865297B72657475726E20657D297D7D2C7B6B65793A2267657446696C657357697468537461747573222C76616C75653A66756E6374696F6E2865297B72657475726E20746869732E66696C65732E66696C7465722866756E6374696F6E';
wwv_flow_api.g_varchar2_table(158) := '2874297B72657475726E20742E7374617475733D3D3D657D292E6D61702866756E6374696F6E2865297B72657475726E20657D297D7D2C7B6B65793A2267657451756575656446696C6573222C76616C75653A66756E6374696F6E28297B72657475726E';
wwv_flow_api.g_varchar2_table(159) := '20746869732E67657446696C65735769746853746174757328742E515545554544297D7D2C7B6B65793A2267657455706C6F6164696E6746696C6573222C76616C75653A66756E6374696F6E28297B72657475726E20746869732E67657446696C657357';
wwv_flow_api.g_varchar2_table(160) := '69746853746174757328742E55504C4F4144494E47297D7D2C7B6B65793A22676574416464656446696C6573222C76616C75653A66756E6374696F6E28297B72657475726E20746869732E67657446696C65735769746853746174757328742E41444445';
wwv_flow_api.g_varchar2_table(161) := '44297D7D2C7B6B65793A2267657441637469766546696C6573222C76616C75653A66756E6374696F6E28297B72657475726E20746869732E66696C65732E66696C7465722866756E6374696F6E2865297B72657475726E20652E7374617475733D3D3D74';
wwv_flow_api.g_varchar2_table(162) := '2E55504C4F4144494E477C7C652E7374617475733D3D3D742E5155455545447D292E6D61702866756E6374696F6E2865297B72657475726E20657D297D7D2C7B6B65793A22696E6974222C76616C75653A66756E6374696F6E28297B76617220653D7468';
wwv_flow_api.g_varchar2_table(163) := '69733B69662822666F726D223D3D3D746869732E656C656D656E742E7461674E616D652626746869732E656C656D656E742E7365744174747269627574652822656E6374797065222C226D756C7469706172742F666F726D2D6461746122292C74686973';
wwv_flow_api.g_varchar2_table(164) := '2E656C656D656E742E636C6173734C6973742E636F6E7461696E73282264726F707A6F6E652229262621746869732E656C656D656E742E717565727953656C6563746F7228222E647A2D6D65737361676522292626746869732E656C656D656E742E6170';
wwv_flow_api.g_varchar2_table(165) := '70656E644368696C6428742E637265617465456C656D656E7428273C64697620636C6173733D22647A2D64656661756C7420647A2D6D657373616765223E3C7370616E3E272B746869732E6F7074696F6E732E6469637444656661756C744D6573736167';
wwv_flow_api.g_varchar2_table(166) := '652B223C2F7370616E3E3C2F6469763E2229292C746869732E636C69636B61626C65456C656D656E74732E6C656E677468297B76617220693D66756E6374696F6E206928297B72657475726E20652E68696464656E46696C65496E7075742626652E6869';
wwv_flow_api.g_varchar2_table(167) := '6464656E46696C65496E7075742E706172656E744E6F64652E72656D6F76654368696C6428652E68696464656E46696C65496E707574292C652E68696464656E46696C65496E7075743D646F63756D656E742E637265617465456C656D656E742822696E';
wwv_flow_api.g_varchar2_table(168) := '70757422292C652E68696464656E46696C65496E7075742E736574417474726962757465282274797065222C2266696C6522292C286E756C6C3D3D3D652E6F7074696F6E732E6D617846696C65737C7C652E6F7074696F6E732E6D617846696C65733E31';
wwv_flow_api.g_varchar2_table(169) := '292626652E68696464656E46696C65496E7075742E73657441747472696275746528226D756C7469706C65222C226D756C7469706C6522292C652E68696464656E46696C65496E7075742E636C6173734E616D653D22647A2D68696464656E2D696E7075';
wwv_flow_api.g_varchar2_table(170) := '74222C6E756C6C213D3D652E6F7074696F6E732E616363657074656446696C65732626652E68696464656E46696C65496E7075742E7365744174747269627574652822616363657074222C652E6F7074696F6E732E616363657074656446696C6573292C';
wwv_flow_api.g_varchar2_table(171) := '6E756C6C213D3D652E6F7074696F6E732E636170747572652626652E68696464656E46696C65496E7075742E736574417474726962757465282263617074757265222C652E6F7074696F6E732E63617074757265292C652E68696464656E46696C65496E';
wwv_flow_api.g_varchar2_table(172) := '7075742E7374796C652E7669736962696C6974793D2268696464656E222C652E68696464656E46696C65496E7075742E7374796C652E706F736974696F6E3D226162736F6C757465222C652E68696464656E46696C65496E7075742E7374796C652E746F';
wwv_flow_api.g_varchar2_table(173) := '703D2230222C652E68696464656E46696C65496E7075742E7374796C652E6C6566743D2230222C652E68696464656E46696C65496E7075742E7374796C652E6865696768743D2230222C652E68696464656E46696C65496E7075742E7374796C652E7769';
wwv_flow_api.g_varchar2_table(174) := '6474683D2230222C742E676574456C656D656E7428652E6F7074696F6E732E68696464656E496E707574436F6E7461696E65722C2268696464656E496E707574436F6E7461696E657222292E617070656E644368696C6428652E68696464656E46696C65';
wwv_flow_api.g_varchar2_table(175) := '496E707574292C652E68696464656E46696C65496E7075742E6164644576656E744C697374656E657228226368616E6765222C66756E6374696F6E28297B76617220743D652E68696464656E46696C65496E7075742E66696C65733B696628742E6C656E';
wwv_flow_api.g_varchar2_table(176) := '67746829666F7228766172206E3D742C723D21302C613D302C6E3D723F6E3A6E5B53796D626F6C2E6974657261746F725D28293B3B297B766172206F3B69662872297B696628613E3D6E2E6C656E67746829627265616B3B6F3D6E5B612B2B5D7D656C73';
wwv_flow_api.g_varchar2_table(177) := '657B696628613D6E2E6E65787428292C612E646F6E6529627265616B3B6F3D612E76616C75657D766172206C3D6F3B652E61646446696C65286C297D72657475726E20652E656D69742822616464656466696C6573222C74292C6928297D297D3B692829';
wwv_flow_api.g_varchar2_table(178) := '7D746869732E55524C3D6E756C6C213D3D77696E646F772E55524C3F77696E646F772E55524C3A77696E646F772E7765626B697455524C3B666F7228766172206E3D746869732E6576656E74732C723D21302C613D302C6E3D723F6E3A6E5B53796D626F';
wwv_flow_api.g_varchar2_table(179) := '6C2E6974657261746F725D28293B3B297B766172206F3B69662872297B696628613E3D6E2E6C656E67746829627265616B3B6F3D6E5B612B2B5D7D656C73657B696628613D6E2E6E65787428292C612E646F6E6529627265616B3B6F3D612E76616C7565';
wwv_flow_api.g_varchar2_table(180) := '7D766172206C3D6F3B746869732E6F6E286C2C746869732E6F7074696F6E735B6C5D297D746869732E6F6E282275706C6F616470726F6772657373222C66756E6374696F6E28297B72657475726E20652E757064617465546F74616C55706C6F61645072';
wwv_flow_api.g_varchar2_table(181) := '6F677265737328297D292C746869732E6F6E282272656D6F76656466696C65222C66756E6374696F6E28297B72657475726E20652E757064617465546F74616C55706C6F616450726F677265737328297D292C746869732E6F6E282263616E63656C6564';
wwv_flow_api.g_varchar2_table(182) := '222C66756E6374696F6E2874297B72657475726E20652E656D69742822636F6D706C657465222C74297D292C746869732E6F6E2822636F6D706C657465222C66756E6374696F6E2874297B696628303D3D3D652E676574416464656446696C657328292E';
wwv_flow_api.g_varchar2_table(183) := '6C656E6774682626303D3D3D652E67657455706C6F6164696E6746696C657328292E6C656E6774682626303D3D3D652E67657451756575656446696C657328292E6C656E6774682972657475726E2073657454696D656F75742866756E6374696F6E2829';
wwv_flow_api.g_varchar2_table(184) := '7B72657475726E20652E656D697428227175657565636F6D706C65746522297D2C30297D293B76617220733D66756E6374696F6E2865297B72657475726E20652E73746F7050726F7061676174696F6E28292C652E70726576656E7444656661756C743F';
wwv_flow_api.g_varchar2_table(185) := '652E70726576656E7444656661756C7428293A652E72657475726E56616C75653D21317D3B72657475726E20746869732E6C697374656E6572733D5B7B656C656D656E743A746869732E656C656D656E742C6576656E74733A7B6472616773746172743A';
wwv_flow_api.g_varchar2_table(186) := '66756E6374696F6E2874297B72657475726E20652E656D69742822647261677374617274222C74297D2C64726167656E7465723A66756E6374696F6E2874297B72657475726E20732874292C652E656D6974282264726167656E746572222C74297D2C64';
wwv_flow_api.g_varchar2_table(187) := '7261676F7665723A66756E6374696F6E2874297B76617220693D766F696420303B7472797B693D742E646174615472616E736665722E656666656374416C6C6F7765647D63617463682865297B7D72657475726E20742E646174615472616E736665722E';
wwv_flow_api.g_varchar2_table(188) := '64726F704566666563743D226D6F7665223D3D3D697C7C226C696E6B4D6F7665223D3D3D693F226D6F7665223A22636F7079222C732874292C652E656D69742822647261676F766572222C74297D2C647261676C656176653A66756E6374696F6E287429';
wwv_flow_api.g_varchar2_table(189) := '7B72657475726E20652E656D69742822647261676C65617665222C74297D2C64726F703A66756E6374696F6E2874297B72657475726E20732874292C652E64726F702874297D2C64726167656E643A66756E6374696F6E2874297B72657475726E20652E';
wwv_flow_api.g_varchar2_table(190) := '656D6974282264726167656E64222C74297D7D7D5D2C746869732E636C69636B61626C65456C656D656E74732E666F72456163682866756E6374696F6E2869297B72657475726E20652E6C697374656E6572732E70757368287B656C656D656E743A692C';
wwv_flow_api.g_varchar2_table(191) := '6576656E74733A7B636C69636B3A66756E6374696F6E286E297B72657475726E2869213D3D652E656C656D656E747C7C6E2E7461726765743D3D3D652E656C656D656E747C7C742E656C656D656E74496E73696465286E2E7461726765742C652E656C65';
wwv_flow_api.g_varchar2_table(192) := '6D656E742E717565727953656C6563746F7228222E647A2D6D657373616765222929292626652E68696464656E46696C65496E7075742E636C69636B28292C21307D7D7D297D292C746869732E656E61626C6528292C746869732E6F7074696F6E732E69';
wwv_flow_api.g_varchar2_table(193) := '6E69742E63616C6C2874686973297D7D2C7B6B65793A2264657374726F79222C76616C75653A66756E6374696F6E28297B72657475726E20746869732E64697361626C6528292C746869732E72656D6F7665416C6C46696C6573282130292C286E756C6C';
wwv_flow_api.g_varchar2_table(194) := '213D746869732E68696464656E46696C65496E7075743F746869732E68696464656E46696C65496E7075742E706172656E744E6F64653A766F6964203029262628746869732E68696464656E46696C65496E7075742E706172656E744E6F64652E72656D';
wwv_flow_api.g_varchar2_table(195) := '6F76654368696C6428746869732E68696464656E46696C65496E707574292C746869732E68696464656E46696C65496E7075743D6E756C6C292C64656C65746520746869732E656C656D656E742E64726F707A6F6E652C742E696E7374616E6365732E73';
wwv_flow_api.g_varchar2_table(196) := '706C69636528742E696E7374616E6365732E696E6465784F662874686973292C31297D7D2C7B6B65793A22757064617465546F74616C55706C6F616450726F6772657373222C76616C75653A66756E6374696F6E28297B76617220653D766F696420302C';
wwv_flow_api.g_varchar2_table(197) := '743D302C693D302C6E3D746869732E67657441637469766546696C657328293B6966286E2E6C656E677468297B666F722876617220723D746869732E67657441637469766546696C657328292C613D21302C6F3D302C723D613F723A725B53796D626F6C';
wwv_flow_api.g_varchar2_table(198) := '2E6974657261746F725D28293B3B297B766172206C3B69662861297B6966286F3E3D722E6C656E67746829627265616B3B6C3D725B6F2B2B5D7D656C73657B6966286F3D722E6E65787428292C6F2E646F6E6529627265616B3B6C3D6F2E76616C75657D';
wwv_flow_api.g_varchar2_table(199) := '76617220733D6C3B742B3D732E75706C6F61642E627974657353656E742C692B3D732E75706C6F61642E746F74616C7D653D3130302A742F697D656C736520653D3130303B72657475726E20746869732E656D69742822746F74616C75706C6F61647072';
wwv_flow_api.g_varchar2_table(200) := '6F6772657373222C652C692C74297D7D2C7B6B65793A225F676574506172616D4E616D65222C76616C75653A66756E6374696F6E2865297B72657475726E2266756E6374696F6E223D3D747970656F6620746869732E6F7074696F6E732E706172616D4E';
wwv_flow_api.g_varchar2_table(201) := '616D653F746869732E6F7074696F6E732E706172616D4E616D652865293A22222B746869732E6F7074696F6E732E706172616D4E616D652B28746869732E6F7074696F6E732E75706C6F61644D756C7469706C653F225B222B652B225D223A2222297D7D';
wwv_flow_api.g_varchar2_table(202) := '2C7B6B65793A225F72656E616D6546696C65222C76616C75653A66756E6374696F6E2865297B72657475726E2266756E6374696F6E22213D747970656F6620746869732E6F7074696F6E732E72656E616D6546696C653F652E6E616D653A746869732E6F';
wwv_flow_api.g_varchar2_table(203) := '7074696F6E732E72656E616D6546696C652865297D7D2C7B6B65793A2267657446616C6C6261636B466F726D222C76616C75653A66756E6374696F6E28297B76617220653D766F696420302C693D766F696420303B696628653D746869732E6765744578';
wwv_flow_api.g_varchar2_table(204) := '697374696E6746616C6C6261636B28292972657475726E20653B766172206E3D273C64697620636C6173733D22647A2D66616C6C6261636B223E273B746869732E6F7074696F6E732E6469637446616C6C6261636B546578742626286E2B3D223C703E22';
wwv_flow_api.g_varchar2_table(205) := '2B746869732E6F7074696F6E732E6469637446616C6C6261636B546578742B223C2F703E22292C6E2B3D273C696E70757420747970653D2266696C6522206E616D653D22272B746869732E5F676574506172616D4E616D652830292B272220272B287468';
wwv_flow_api.g_varchar2_table(206) := '69732E6F7074696F6E732E75706C6F61644D756C7469706C653F276D756C7469706C653D226D756C7469706C6522273A766F69642030292B27202F3E3C696E70757420747970653D227375626D6974222076616C75653D2255706C6F616421223E3C2F64';
wwv_flow_api.g_varchar2_table(207) := '69763E273B76617220723D742E637265617465456C656D656E74286E293B72657475726E22464F524D22213D3D746869732E656C656D656E742E7461674E616D653F28693D742E637265617465456C656D656E7428273C666F726D20616374696F6E3D22';
wwv_flow_api.g_varchar2_table(208) := '272B746869732E6F7074696F6E732E75726C2B272220656E63747970653D226D756C7469706172742F666F726D2D6461746122206D6574686F643D22272B746869732E6F7074696F6E732E6D6574686F642B27223E3C2F666F726D3E27292C692E617070';
wwv_flow_api.g_varchar2_table(209) := '656E644368696C64287229293A28746869732E656C656D656E742E7365744174747269627574652822656E6374797065222C226D756C7469706172742F666F726D2D6461746122292C746869732E656C656D656E742E7365744174747269627574652822';
wwv_flow_api.g_varchar2_table(210) := '6D6574686F64222C746869732E6F7074696F6E732E6D6574686F6429292C6E756C6C213D693F693A727D7D2C7B6B65793A226765744578697374696E6746616C6C6261636B222C76616C75653A66756E6374696F6E28297B666F722876617220653D6675';
wwv_flow_api.g_varchar2_table(211) := '6E6374696F6E2865297B666F722876617220743D652C693D21302C6E3D302C743D693F743A745B53796D626F6C2E6974657261746F725D28293B3B297B76617220723B69662869297B6966286E3E3D742E6C656E67746829627265616B3B723D745B6E2B';
wwv_flow_api.g_varchar2_table(212) := '2B5D7D656C73657B6966286E3D742E6E65787428292C6E2E646F6E6529627265616B3B723D6E2E76616C75657D76617220613D723B6966282F285E7C202966616C6C6261636B28247C20292F2E7465737428612E636C6173734E616D6529297265747572';
wwv_flow_api.g_varchar2_table(213) := '6E20617D7D2C743D5B22646976222C22666F726D225D2C693D303B693C742E6C656E6774683B692B2B297B766172206E2C723D745B695D3B6966286E3D6528746869732E656C656D656E742E676574456C656D656E747342795461674E616D6528722929';
wwv_flow_api.g_varchar2_table(214) := '2972657475726E206E7D7D7D2C7B6B65793A2273657475704576656E744C697374656E657273222C76616C75653A66756E6374696F6E28297B72657475726E20746869732E6C697374656E6572732E6D61702866756E6374696F6E2865297B7265747572';
wwv_flow_api.g_varchar2_table(215) := '6E2066756E6374696F6E28297B76617220743D5B5D3B666F7228766172206920696E20652E6576656E7473297B766172206E3D652E6576656E74735B695D3B742E7075736828652E656C656D656E742E6164644576656E744C697374656E657228692C6E';
wwv_flow_api.g_varchar2_table(216) := '2C213129297D72657475726E20747D28297D297D7D2C7B6B65793A2272656D6F76654576656E744C697374656E657273222C76616C75653A66756E6374696F6E28297B72657475726E20746869732E6C697374656E6572732E6D61702866756E6374696F';
wwv_flow_api.g_varchar2_table(217) := '6E2865297B72657475726E2066756E6374696F6E28297B76617220743D5B5D3B666F7228766172206920696E20652E6576656E7473297B766172206E3D652E6576656E74735B695D3B742E7075736828652E656C656D656E742E72656D6F76654576656E';
wwv_flow_api.g_varchar2_table(218) := '744C697374656E657228692C6E2C213129297D72657475726E20747D28297D297D7D2C7B6B65793A2264697361626C65222C76616C75653A66756E6374696F6E28297B76617220653D746869733B72657475726E20746869732E636C69636B61626C6545';
wwv_flow_api.g_varchar2_table(219) := '6C656D656E74732E666F72456163682866756E6374696F6E2865297B72657475726E20652E636C6173734C6973742E72656D6F76652822647A2D636C69636B61626C6522297D292C746869732E72656D6F76654576656E744C697374656E65727328292C';
wwv_flow_api.g_varchar2_table(220) := '746869732E64697361626C65643D21302C746869732E66696C65732E6D61702866756E6374696F6E2874297B72657475726E20652E63616E63656C55706C6F61642874297D297D7D2C7B6B65793A22656E61626C65222C76616C75653A66756E6374696F';
wwv_flow_api.g_varchar2_table(221) := '6E28297B72657475726E2064656C65746520746869732E64697361626C65642C746869732E636C69636B61626C65456C656D656E74732E666F72456163682866756E6374696F6E2865297B72657475726E20652E636C6173734C6973742E616464282264';
wwv_flow_api.g_varchar2_table(222) := '7A2D636C69636B61626C6522297D292C746869732E73657475704576656E744C697374656E65727328297D7D2C7B6B65793A2266696C6573697A65222C76616C75653A66756E6374696F6E2865297B76617220743D302C693D2262223B696628653E3029';
wwv_flow_api.g_varchar2_table(223) := '7B666F7228766172206E3D5B227462222C226762222C226D62222C226B62222C2262225D2C723D303B723C6E2E6C656E6774683B722B2B297B76617220613D6E5B725D2C6F3D4D6174682E706F7728746869732E6F7074696F6E732E66696C6573697A65';
wwv_flow_api.g_varchar2_table(224) := '426173652C342D72292F31303B696628653E3D6F297B743D652F4D6174682E706F7728746869732E6F7074696F6E732E66696C6573697A65426173652C342D72292C693D613B627265616B7D7D743D4D6174682E726F756E642831302A74292F31307D72';
wwv_flow_api.g_varchar2_table(225) := '657475726E223C7374726F6E673E222B742B223C2F7374726F6E673E20222B746869732E6F7074696F6E732E6469637446696C6553697A65556E6974735B695D7D7D2C7B6B65793A225F7570646174654D617846696C657352656163686564436C617373';
wwv_flow_api.g_varchar2_table(226) := '222C76616C75653A66756E6374696F6E28297B72657475726E206E756C6C213D746869732E6F7074696F6E732E6D617846696C65732626746869732E676574416363657074656446696C657328292E6C656E6774683E3D746869732E6F7074696F6E732E';
wwv_flow_api.g_varchar2_table(227) := '6D617846696C65733F28746869732E676574416363657074656446696C657328292E6C656E6774683D3D3D746869732E6F7074696F6E732E6D617846696C65732626746869732E656D697428226D617866696C657372656163686564222C746869732E66';
wwv_flow_api.g_varchar2_table(228) := '696C6573292C746869732E656C656D656E742E636C6173734C6973742E6164642822647A2D6D61782D66696C65732D726561636865642229293A746869732E656C656D656E742E636C6173734C6973742E72656D6F76652822647A2D6D61782D66696C65';
wwv_flow_api.g_varchar2_table(229) := '732D7265616368656422297D7D2C7B6B65793A2264726F70222C76616C75653A66756E6374696F6E2865297B696628652E646174615472616E73666572297B746869732E656D6974282264726F70222C65293B666F722876617220743D5B5D2C693D303B';
wwv_flow_api.g_varchar2_table(230) := '693C652E646174615472616E736665722E66696C65732E6C656E6774683B692B2B29745B695D3D652E646174615472616E736665722E66696C65735B695D3B696628746869732E656D69742822616464656466696C6573222C74292C742E6C656E677468';
wwv_flow_api.g_varchar2_table(231) := '297B766172206E3D652E646174615472616E736665722E6974656D733B6E26266E2E6C656E67746826266E756C6C213D6E5B305D2E7765626B69744765744173456E7472793F746869732E5F61646446696C657346726F6D4974656D73286E293A746869';
wwv_flow_api.g_varchar2_table(232) := '732E68616E646C6546696C65732874297D7D7D7D2C7B6B65793A227061737465222C76616C75653A66756E6374696F6E2865297B6966286E756C6C213D5F5F67756172645F5F286E756C6C213D653F652E636C6970626F617264446174613A766F696420';
wwv_flow_api.g_varchar2_table(233) := '302C66756E6374696F6E2865297B72657475726E20652E6974656D737D29297B746869732E656D697428227061737465222C65293B76617220743D652E636C6970626F617264446174612E6974656D733B72657475726E20742E6C656E6774683F746869';
wwv_flow_api.g_varchar2_table(234) := '732E5F61646446696C657346726F6D4974656D732874293A766F696420307D7D7D2C7B6B65793A2268616E646C6546696C6573222C76616C75653A66756E6374696F6E2865297B666F722876617220743D652C693D21302C6E3D302C743D693F743A745B';
wwv_flow_api.g_varchar2_table(235) := '53796D626F6C2E6974657261746F725D28293B3B297B76617220723B69662869297B6966286E3E3D742E6C656E67746829627265616B3B723D745B6E2B2B5D7D656C73657B6966286E3D742E6E65787428292C6E2E646F6E6529627265616B3B723D6E2E';
wwv_flow_api.g_varchar2_table(236) := '76616C75657D76617220613D723B746869732E61646446696C652861297D7D7D2C7B6B65793A225F61646446696C657346726F6D4974656D73222C76616C75653A66756E6374696F6E2865297B76617220743D746869733B72657475726E2066756E6374';
wwv_flow_api.g_varchar2_table(237) := '696F6E28297B666F722876617220693D5B5D2C6E3D652C723D21302C613D302C6E3D723F6E3A6E5B53796D626F6C2E6974657261746F725D28293B3B297B766172206F3B69662872297B696628613E3D6E2E6C656E67746829627265616B3B6F3D6E5B61';
wwv_flow_api.g_varchar2_table(238) := '2B2B5D7D656C73657B696628613D6E2E6E65787428292C612E646F6E6529627265616B3B6F3D612E76616C75657D766172206C2C733D6F3B6E756C6C213D732E7765626B69744765744173456E7472792626286C3D732E7765626B69744765744173456E';
wwv_flow_api.g_varchar2_table(239) := '7472792829293F6C2E697346696C653F692E7075736828742E61646446696C6528732E676574417346696C65282929293A6C2E69734469726563746F72793F692E7075736828742E5F61646446696C657346726F6D4469726563746F7279286C2C6C2E6E';
wwv_flow_api.g_varchar2_table(240) := '616D6529293A692E7075736828766F69642030293A6E756C6C213D732E676574417346696C652626286E756C6C3D3D732E6B696E647C7C2266696C65223D3D3D732E6B696E64293F692E7075736828742E61646446696C6528732E676574417346696C65';
wwv_flow_api.g_varchar2_table(241) := '282929293A692E7075736828766F69642030297D72657475726E20697D28297D7D2C7B6B65793A225F61646446696C657346726F6D4469726563746F7279222C76616C75653A66756E6374696F6E28652C74297B76617220693D746869732C6E3D652E63';
wwv_flow_api.g_varchar2_table(242) := '726561746552656164657228292C723D66756E6374696F6E2865297B72657475726E205F5F67756172644D6574686F645F5F28636F6E736F6C652C226C6F67222C66756E6374696F6E2874297B72657475726E20742E6C6F672865297D297D2C613D6675';
wwv_flow_api.g_varchar2_table(243) := '6E6374696F6E206528297B72657475726E206E2E72656164456E74726965732866756E6374696F6E286E297B6966286E2E6C656E6774683E30297B666F722876617220723D6E2C613D21302C6F3D302C723D613F723A725B53796D626F6C2E6974657261';
wwv_flow_api.g_varchar2_table(244) := '746F725D28293B3B297B766172206C3B69662861297B6966286F3E3D722E6C656E67746829627265616B3B6C3D725B6F2B2B5D7D656C73657B6966286F3D722E6E65787428292C6F2E646F6E6529627265616B3B6C3D6F2E76616C75657D76617220733D';
wwv_flow_api.g_varchar2_table(245) := '6C3B732E697346696C653F732E66696C652866756E6374696F6E2865297B69662821692E6F7074696F6E732E69676E6F726548696464656E46696C65737C7C222E22213D3D652E6E616D652E737562737472696E6728302C31292972657475726E20652E';
wwv_flow_api.g_varchar2_table(246) := '66756C6C506174683D742B222F222B652E6E616D652C692E61646446696C652865297D293A732E69734469726563746F72792626692E5F61646446696C657346726F6D4469726563746F727928732C742B222F222B732E6E616D65297D6528297D726574';
wwv_flow_api.g_varchar2_table(247) := '75726E206E756C6C7D2C72297D3B72657475726E206128297D7D2C7B6B65793A22616363657074222C76616C75653A66756E6374696F6E28652C69297B72657475726E20746869732E6F7074696F6E732E6D617846696C6573697A652626652E73697A65';
wwv_flow_api.g_varchar2_table(248) := '3E313032342A746869732E6F7074696F6E732E6D617846696C6573697A652A313032343F6928746869732E6F7074696F6E732E6469637446696C65546F6F4269672E7265706C61636528227B7B66696C6573697A657D7D222C4D6174682E726F756E6428';
wwv_flow_api.g_varchar2_table(249) := '652E73697A652F313032342F31302E3234292F313030292E7265706C61636528227B7B6D617846696C6573697A657D7D222C746869732E6F7074696F6E732E6D617846696C6573697A6529293A742E697356616C696446696C6528652C746869732E6F70';
wwv_flow_api.g_varchar2_table(250) := '74696F6E732E616363657074656446696C6573293F6E756C6C213D746869732E6F7074696F6E732E6D617846696C65732626746869732E676574416363657074656446696C657328292E6C656E6774683E3D746869732E6F7074696F6E732E6D61784669';
wwv_flow_api.g_varchar2_table(251) := '6C65733F286928746869732E6F7074696F6E732E646963744D617846696C657345786365656465642E7265706C61636528227B7B6D617846696C65737D7D222C746869732E6F7074696F6E732E6D617846696C657329292C746869732E656D697428226D';
wwv_flow_api.g_varchar2_table(252) := '617866696C65736578636565646564222C6529293A746869732E6F7074696F6E732E6163636570742E63616C6C28746869732C652C69293A6928746869732E6F7074696F6E732E64696374496E76616C696446696C6554797065297D7D2C7B6B65793A22';
wwv_flow_api.g_varchar2_table(253) := '61646446696C65222C76616C75653A66756E6374696F6E2865297B76617220693D746869733B72657475726E20652E75706C6F61643D7B757569643A742E75756964763428292C70726F67726573733A302C746F74616C3A652E73697A652C6279746573';
wwv_flow_api.g_varchar2_table(254) := '53656E743A302C66696C656E616D653A746869732E5F72656E616D6546696C652865292C6368756E6B65643A746869732E6F7074696F6E732E6368756E6B696E67262628746869732E6F7074696F6E732E666F7263654368756E6B696E677C7C652E7369';
wwv_flow_api.g_varchar2_table(255) := '7A653E746869732E6F7074696F6E732E6368756E6B53697A65292C746F74616C4368756E6B436F756E743A4D6174682E6365696C28652E73697A652F746869732E6F7074696F6E732E6368756E6B53697A65297D2C746869732E66696C65732E70757368';
wwv_flow_api.g_varchar2_table(256) := '2865292C652E7374617475733D742E41444445442C746869732E656D69742822616464656466696C65222C65292C746869732E5F656E71756575655468756D626E61696C2865292C746869732E61636365707428652C66756E6374696F6E2874297B7265';
wwv_flow_api.g_varchar2_table(257) := '7475726E20743F28652E61636365707465643D21312C692E5F6572726F7250726F63657373696E67285B655D2C7429293A28652E61636365707465643D21302C692E6F7074696F6E732E6175746F51756575652626692E656E717565756546696C652865';
wwv_flow_api.g_varchar2_table(258) := '29292C692E5F7570646174654D617846696C657352656163686564436C61737328297D297D7D2C7B6B65793A22656E717565756546696C6573222C76616C75653A66756E6374696F6E2865297B666F722876617220743D652C693D21302C6E3D302C743D';
wwv_flow_api.g_varchar2_table(259) := '693F743A745B53796D626F6C2E6974657261746F725D28293B3B297B76617220723B69662869297B6966286E3E3D742E6C656E67746829627265616B3B723D745B6E2B2B5D7D656C73657B6966286E3D742E6E65787428292C6E2E646F6E652962726561';
wwv_flow_api.g_varchar2_table(260) := '6B3B723D6E2E76616C75657D76617220613D723B746869732E656E717565756546696C652861297D72657475726E206E756C6C7D7D2C7B6B65793A22656E717565756546696C65222C76616C75653A66756E6374696F6E2865297B76617220693D746869';
wwv_flow_api.g_varchar2_table(261) := '733B696628652E737461747573213D3D742E41444445447C7C652E6163636570746564213D3D2130297468726F77206E6577204572726F722822546869732066696C652063616E2774206265207175657565642062656361757365206974206861732061';
wwv_flow_api.g_varchar2_table(262) := '6C7265616479206265656E2070726F636573736564206F72207761732072656A65637465642E22293B696628652E7374617475733D742E5155455545442C746869732E6F7074696F6E732E6175746F50726F6365737351756575652972657475726E2073';
wwv_flow_api.g_varchar2_table(263) := '657454696D656F75742866756E6374696F6E28297B72657475726E20692E70726F63657373517565756528297D2C30297D7D2C7B6B65793A225F656E71756575655468756D626E61696C222C76616C75653A66756E6374696F6E2865297B76617220743D';
wwv_flow_api.g_varchar2_table(264) := '746869733B696628746869732E6F7074696F6E732E637265617465496D6167655468756D626E61696C732626652E747970652E6D61746368282F696D6167652E2A2F292626652E73697A653C3D313032342A746869732E6F7074696F6E732E6D61785468';
wwv_flow_api.g_varchar2_table(265) := '756D626E61696C46696C6573697A652A313032342972657475726E20746869732E5F7468756D626E61696C51756575652E707573682865292C73657454696D656F75742866756E6374696F6E28297B72657475726E20742E5F70726F636573735468756D';
wwv_flow_api.g_varchar2_table(266) := '626E61696C517565756528297D2C30297D7D2C7B6B65793A225F70726F636573735468756D626E61696C5175657565222C76616C75653A66756E6374696F6E28297B76617220653D746869733B69662821746869732E5F70726F63657373696E67546875';
wwv_flow_api.g_varchar2_table(267) := '6D626E61696C262630213D3D746869732E5F7468756D626E61696C51756575652E6C656E677468297B746869732E5F70726F63657373696E675468756D626E61696C3D21303B76617220743D746869732E5F7468756D626E61696C51756575652E736869';
wwv_flow_api.g_varchar2_table(268) := '667428293B72657475726E20746869732E6372656174655468756D626E61696C28742C746869732E6F7074696F6E732E7468756D626E61696C57696474682C746869732E6F7074696F6E732E7468756D626E61696C4865696768742C746869732E6F7074';
wwv_flow_api.g_varchar2_table(269) := '696F6E732E7468756D626E61696C4D6574686F642C21302C66756E6374696F6E2869297B72657475726E20652E656D697428227468756D626E61696C222C742C69292C652E5F70726F63657373696E675468756D626E61696C3D21312C652E5F70726F63';
wwv_flow_api.g_varchar2_table(270) := '6573735468756D626E61696C517565756528297D297D7D7D2C7B6B65793A2272656D6F766546696C65222C76616C75653A66756E6374696F6E2865297B696628652E7374617475733D3D3D742E55504C4F4144494E472626746869732E63616E63656C55';
wwv_flow_api.g_varchar2_table(271) := '706C6F61642865292C746869732E66696C65733D776974686F757428746869732E66696C65732C65292C746869732E656D6974282272656D6F76656466696C65222C65292C303D3D3D746869732E66696C65732E6C656E6774682972657475726E207468';
wwv_flow_api.g_varchar2_table(272) := '69732E656D69742822726573657422297D7D2C7B6B65793A2272656D6F7665416C6C46696C6573222C76616C75653A66756E6374696F6E2865297B6E756C6C3D3D65262628653D2131293B666F722876617220693D746869732E66696C65732E736C6963';
wwv_flow_api.g_varchar2_table(273) := '6528292C6E3D21302C723D302C693D6E3F693A695B53796D626F6C2E6974657261746F725D28293B3B297B76617220613B6966286E297B696628723E3D692E6C656E67746829627265616B3B613D695B722B2B5D7D656C73657B696628723D692E6E6578';
wwv_flow_api.g_varchar2_table(274) := '7428292C722E646F6E6529627265616B3B613D722E76616C75657D766172206F3D613B286F2E737461747573213D3D742E55504C4F4144494E477C7C65292626746869732E72656D6F766546696C65286F297D72657475726E206E756C6C7D7D2C7B6B65';
wwv_flow_api.g_varchar2_table(275) := '793A22726573697A65496D616765222C76616C75653A66756E6374696F6E28652C692C6E2C722C61297B766172206F3D746869733B72657475726E20746869732E6372656174655468756D626E61696C28652C692C6E2C722C21302C66756E6374696F6E';
wwv_flow_api.g_varchar2_table(276) := '28692C6E297B6966286E756C6C3D3D6E2972657475726E20612865293B76617220723D6F2E6F7074696F6E732E726573697A654D696D65547970653B6E756C6C3D3D72262628723D652E74797065293B766172206C3D6E2E746F4461746155524C28722C';
wwv_flow_api.g_varchar2_table(277) := '6F2E6F7074696F6E732E726573697A655175616C697479293B72657475726E22696D6167652F6A70656722213D3D72262622696D6167652F6A706722213D3D727C7C286C3D45786966526573746F72652E726573746F726528652E6461746155524C2C6C';
wwv_flow_api.g_varchar2_table(278) := '29292C6128742E64617461555249746F426C6F62286C29297D297D7D2C7B6B65793A226372656174655468756D626E61696C222C76616C75653A66756E6374696F6E28652C742C692C6E2C722C61297B766172206F3D746869732C6C3D6E65772046696C';
wwv_flow_api.g_varchar2_table(279) := '655265616465723B72657475726E206C2E6F6E6C6F61643D66756E6374696F6E28297B72657475726E20652E6461746155524C3D6C2E726573756C742C22696D6167652F7376672B786D6C223D3D3D652E747970653F766F6964286E756C6C213D612626';
wwv_flow_api.g_varchar2_table(280) := '61286C2E726573756C7429293A6F2E6372656174655468756D626E61696C46726F6D55726C28652C742C692C6E2C722C61297D2C6C2E7265616441734461746155524C2865297D7D2C7B6B65793A226372656174655468756D626E61696C46726F6D5572';
wwv_flow_api.g_varchar2_table(281) := '6C222C76616C75653A66756E6374696F6E28652C742C692C6E2C722C612C6F297B766172206C3D746869732C733D646F63756D656E742E637265617465456C656D656E742822696D6722293B72657475726E206F262628732E63726F73734F726967696E';
wwv_flow_api.g_varchar2_table(282) := '3D6F292C732E6F6E6C6F61643D66756E6374696F6E28297B766172206F3D66756E6374696F6E2865297B72657475726E20652831297D3B72657475726E22756E646566696E656422213D747970656F66204558494626266E756C6C213D3D455849462626';
wwv_flow_api.g_varchar2_table(283) := '722626286F3D66756E6374696F6E2865297B72657475726E20455849462E6765744461746128732C66756E6374696F6E28297B72657475726E206528455849462E67657454616728746869732C224F7269656E746174696F6E2229297D297D292C6F2866';
wwv_flow_api.g_varchar2_table(284) := '756E6374696F6E2872297B652E77696474683D732E77696474682C652E6865696768743D732E6865696768743B766172206F3D6C2E6F7074696F6E732E726573697A652E63616C6C286C2C652C742C692C6E292C753D646F63756D656E742E6372656174';
wwv_flow_api.g_varchar2_table(285) := '65456C656D656E74282263616E76617322292C643D752E676574436F6E746578742822326422293B73776974636828752E77696474683D6F2E74726757696474682C752E6865696768743D6F2E7472674865696768742C723E34262628752E7769647468';
wwv_flow_api.g_varchar2_table(286) := '3D6F2E7472674865696768742C752E6865696768743D6F2E7472675769647468292C72297B6361736520323A642E7472616E736C61746528752E77696474682C30292C642E7363616C65282D312C31293B627265616B3B6361736520333A642E7472616E';
wwv_flow_api.g_varchar2_table(287) := '736C61746528752E77696474682C752E686569676874292C642E726F74617465284D6174682E5049293B627265616B3B6361736520343A642E7472616E736C61746528302C752E686569676874292C642E7363616C6528312C2D31293B627265616B3B63';
wwv_flow_api.g_varchar2_table(288) := '61736520353A642E726F74617465282E352A4D6174682E5049292C642E7363616C6528312C2D31293B627265616B3B6361736520363A642E726F74617465282E352A4D6174682E5049292C642E7472616E736C61746528302C2D752E7769647468293B62';
wwv_flow_api.g_varchar2_table(289) := '7265616B3B6361736520373A642E726F74617465282E352A4D6174682E5049292C642E7472616E736C61746528752E6865696768742C2D752E7769647468292C642E7363616C65282D312C31293B627265616B3B6361736520383A642E726F7461746528';
wwv_flow_api.g_varchar2_table(290) := '2D2E352A4D6174682E5049292C642E7472616E736C617465282D752E6865696768742C30297D64726177496D616765494F5346697828642C732C6E756C6C213D6F2E737263583F6F2E737263583A302C6E756C6C213D6F2E737263593F6F2E737263593A';
wwv_flow_api.g_varchar2_table(291) := '302C6F2E73726357696474682C6F2E7372634865696768742C6E756C6C213D6F2E747267583F6F2E747267583A302C6E756C6C213D6F2E747267593F6F2E747267593A302C6F2E74726757696474682C6F2E747267486569676874293B76617220633D75';
wwv_flow_api.g_varchar2_table(292) := '2E746F4461746155524C2822696D6167652F706E6722293B6966286E756C6C213D612972657475726E206128632C75297D297D2C6E756C6C213D61262628732E6F6E6572726F723D61292C732E7372633D652E6461746155524C7D7D2C7B6B65793A2270';
wwv_flow_api.g_varchar2_table(293) := '726F636573735175657565222C76616C75653A66756E6374696F6E28297B76617220653D746869732E6F7074696F6E732E706172616C6C656C55706C6F6164732C743D746869732E67657455706C6F6164696E6746696C657328292E6C656E6774682C69';
wwv_flow_api.g_varchar2_table(294) := '3D743B6966282128743E3D6529297B766172206E3D746869732E67657451756575656446696C657328293B6966286E2E6C656E6774683E30297B696628746869732E6F7074696F6E732E75706C6F61644D756C7469706C652972657475726E2074686973';
wwv_flow_api.g_varchar2_table(295) := '2E70726F6365737346696C6573286E2E736C69636528302C652D7429293B666F72283B693C653B297B696628216E2E6C656E6774682972657475726E3B746869732E70726F6365737346696C65286E2E73686966742829292C692B2B7D7D7D7D7D2C7B6B';
wwv_flow_api.g_varchar2_table(296) := '65793A2270726F6365737346696C65222C76616C75653A66756E6374696F6E2865297B72657475726E20746869732E70726F6365737346696C6573285B655D297D7D2C7B6B65793A2270726F6365737346696C6573222C76616C75653A66756E6374696F';
wwv_flow_api.g_varchar2_table(297) := '6E2865297B666F722876617220693D652C6E3D21302C723D302C693D6E3F693A695B53796D626F6C2E6974657261746F725D28293B3B297B76617220613B6966286E297B696628723E3D692E6C656E67746829627265616B3B613D695B722B2B5D7D656C';
wwv_flow_api.g_varchar2_table(298) := '73657B696628723D692E6E65787428292C722E646F6E6529627265616B3B613D722E76616C75657D766172206F3D613B6F2E70726F63657373696E673D21302C6F2E7374617475733D742E55504C4F4144494E472C746869732E656D6974282270726F63';
wwv_flow_api.g_varchar2_table(299) := '657373696E67222C6F297D72657475726E20746869732E6F7074696F6E732E75706C6F61644D756C7469706C652626746869732E656D6974282270726F63657373696E676D756C7469706C65222C65292C746869732E75706C6F616446696C6573286529';
wwv_flow_api.g_varchar2_table(300) := '7D7D2C7B6B65793A225F67657446696C657357697468586872222C76616C75653A66756E6374696F6E2865297B76617220743D766F696420303B72657475726E20743D746869732E66696C65732E66696C7465722866756E6374696F6E2874297B726574';
wwv_flow_api.g_varchar2_table(301) := '75726E20742E7868723D3D3D657D292E6D61702866756E6374696F6E2865297B72657475726E20657D297D7D2C7B6B65793A2263616E63656C55706C6F6164222C76616C75653A66756E6374696F6E2865297B696628652E7374617475733D3D3D742E55';
wwv_flow_api.g_varchar2_table(302) := '504C4F4144494E47297B666F722876617220693D746869732E5F67657446696C65735769746858687228652E786872292C6E3D692C723D21302C613D302C6E3D723F6E3A6E5B53796D626F6C2E6974657261746F725D28293B3B297B766172206F3B6966';
wwv_flow_api.g_varchar2_table(303) := '2872297B696628613E3D6E2E6C656E67746829627265616B3B6F3D6E5B612B2B5D7D656C73657B696628613D6E2E6E65787428292C612E646F6E6529627265616B3B6F3D612E76616C75657D766172206C3D6F3B6C2E7374617475733D742E43414E4345';
wwv_flow_api.g_varchar2_table(304) := '4C45447D22756E646566696E656422213D747970656F6620652E7868722626652E7868722E61626F727428293B666F722876617220733D692C753D21302C643D302C733D753F733A735B53796D626F6C2E6974657261746F725D28293B3B297B76617220';
wwv_flow_api.g_varchar2_table(305) := '633B69662875297B696628643E3D732E6C656E67746829627265616B3B633D735B642B2B5D7D656C73657B696628643D732E6E65787428292C642E646F6E6529627265616B3B633D642E76616C75657D76617220703D633B746869732E656D6974282263';
wwv_flow_api.g_varchar2_table(306) := '616E63656C6564222C70297D746869732E6F7074696F6E732E75706C6F61644D756C7469706C652626746869732E656D6974282263616E63656C65646D756C7469706C65222C69297D656C736520652E737461747573213D3D742E41444445442626652E';
wwv_flow_api.g_varchar2_table(307) := '737461747573213D3D742E5155455545447C7C28652E7374617475733D742E43414E43454C45442C746869732E656D6974282263616E63656C6564222C65292C746869732E6F7074696F6E732E75706C6F61644D756C7469706C652626746869732E656D';
wwv_flow_api.g_varchar2_table(308) := '6974282263616E63656C65646D756C7469706C65222C5B655D29293B696628746869732E6F7074696F6E732E6175746F50726F6365737351756575652972657475726E20746869732E70726F63657373517565756528297D7D2C7B6B65793A227265736F';
wwv_flow_api.g_varchar2_table(309) := '6C76654F7074696F6E222C76616C75653A66756E6374696F6E2865297B6966282266756E6374696F6E223D3D747970656F662065297B666F722876617220743D617267756D656E74732E6C656E6774682C693D417272617928743E313F742D313A30292C';
wwv_flow_api.g_varchar2_table(310) := '6E3D313B6E3C743B6E2B2B29695B6E2D315D3D617267756D656E74735B6E5D3B72657475726E20652E6170706C7928746869732C69297D72657475726E20657D7D2C7B6B65793A2275706C6F616446696C65222C76616C75653A66756E6374696F6E2865';
wwv_flow_api.g_varchar2_table(311) := '297B72657475726E20746869732E75706C6F616446696C6573285B655D297D7D2C7B6B65793A2275706C6F616446696C6573222C76616C75653A66756E6374696F6E2865297B76617220693D746869733B746869732E5F7472616E73666F726D46696C65';
wwv_flow_api.g_varchar2_table(312) := '7328652C66756E6374696F6E286E297B696628655B305D2E75706C6F61642E6368756E6B6564297B76617220723D655B305D2C613D6E5B305D2C6F3D303B722E75706C6F61642E6368756E6B733D5B5D3B766172206C3D66756E6374696F6E28297B666F';
wwv_flow_api.g_varchar2_table(313) := '7228766172206E3D303B766F69642030213D3D722E75706C6F61642E6368756E6B735B6E5D3B296E2B2B3B69662821286E3E3D722E75706C6F61642E746F74616C4368756E6B436F756E7429297B6F2B2B3B766172206C3D6E2A692E6F7074696F6E732E';
wwv_flow_api.g_varchar2_table(314) := '6368756E6B53697A652C733D4D6174682E6D696E286C2B692E6F7074696F6E732E6368756E6B53697A652C722E73697A65292C753D7B6E616D653A692E5F676574506172616D4E616D652830292C646174613A612E7765626B6974536C6963653F612E77';
wwv_flow_api.g_varchar2_table(315) := '65626B6974536C696365286C2C73293A612E736C696365286C2C73292C66696C656E616D653A722E75706C6F61642E66696C656E616D652C6368756E6B496E6465783A6E7D3B722E75706C6F61642E6368756E6B735B6E5D3D7B66696C653A722C696E64';
wwv_flow_api.g_varchar2_table(316) := '65783A6E2C64617461426C6F636B3A752C7374617475733A742E55504C4F4144494E472C70726F67726573733A302C726574726965733A307D2C692E5F75706C6F61644461746128652C5B755D297D7D3B696628722E75706C6F61642E66696E69736865';
wwv_flow_api.g_varchar2_table(317) := '644368756E6B55706C6F61643D66756E6374696F6E286E297B76617220613D21303B6E2E7374617475733D742E535543434553532C6E2E64617461426C6F636B3D6E756C6C2C6E2E7868723D6E756C6C3B666F7228766172206F3D303B6F3C722E75706C';
wwv_flow_api.g_varchar2_table(318) := '6F61642E746F74616C4368756E6B436F756E743B6F2B2B297B696628766F696420303D3D3D722E75706C6F61642E6368756E6B735B6F5D2972657475726E206C28293B722E75706C6F61642E6368756E6B735B6F5D2E737461747573213D3D742E535543';
wwv_flow_api.g_varchar2_table(319) := '43455353262628613D2131297D612626692E6F7074696F6E732E6368756E6B7355706C6F6164656428722C66756E6374696F6E28297B692E5F66696E697368656428652C22222C6E756C6C297D297D2C692E6F7074696F6E732E706172616C6C656C4368';
wwv_flow_api.g_varchar2_table(320) := '756E6B55706C6F61647329666F722876617220733D303B733C722E75706C6F61642E746F74616C4368756E6B436F756E743B732B2B296C28293B656C7365206C28297D656C73657B666F722876617220753D5B5D2C643D303B643C652E6C656E6774683B';
wwv_flow_api.g_varchar2_table(321) := '642B2B29755B645D3D7B0A6E616D653A692E5F676574506172616D4E616D652864292C646174613A6E5B645D2C66696C656E616D653A655B645D2E75706C6F61642E66696C656E616D657D3B692E5F75706C6F61644461746128652C75297D7D297D7D2C';
wwv_flow_api.g_varchar2_table(322) := '7B6B65793A225F6765744368756E6B222C76616C75653A66756E6374696F6E28652C74297B666F722876617220693D303B693C652E75706C6F61642E746F74616C4368756E6B436F756E743B692B2B29696628766F69642030213D3D652E75706C6F6164';
wwv_flow_api.g_varchar2_table(323) := '2E6368756E6B735B695D2626652E75706C6F61642E6368756E6B735B695D2E7868723D3D3D742972657475726E20652E75706C6F61642E6368756E6B735B695D7D7D2C7B6B65793A225F75706C6F616444617461222C76616C75653A66756E6374696F6E';
wwv_flow_api.g_varchar2_table(324) := '28652C69297B666F7228766172206E3D746869732C723D6E657720584D4C48747470526571756573742C613D652C6F3D21302C6C3D302C613D6F3F613A615B53796D626F6C2E6974657261746F725D28293B3B297B76617220733B6966286F297B696628';
wwv_flow_api.g_varchar2_table(325) := '6C3E3D612E6C656E67746829627265616B3B733D615B6C2B2B5D7D656C73657B6966286C3D612E6E65787428292C6C2E646F6E6529627265616B3B733D6C2E76616C75657D76617220753D733B752E7868723D727D655B305D2E75706C6F61642E636875';
wwv_flow_api.g_varchar2_table(326) := '6E6B6564262628655B305D2E75706C6F61642E6368756E6B735B695B305D2E6368756E6B496E6465785D2E7868723D72293B76617220643D746869732E7265736F6C76654F7074696F6E28746869732E6F7074696F6E732E6D6574686F642C65292C633D';
wwv_flow_api.g_varchar2_table(327) := '746869732E7265736F6C76654F7074696F6E28746869732E6F7074696F6E732E75726C2C65293B722E6F70656E28642C632C2130292C722E74696D656F75743D746869732E7265736F6C76654F7074696F6E28746869732E6F7074696F6E732E74696D65';
wwv_flow_api.g_varchar2_table(328) := '6F75742C65292C722E7769746843726564656E7469616C733D2121746869732E6F7074696F6E732E7769746843726564656E7469616C732C722E6F6E6C6F61643D66756E6374696F6E2874297B6E2E5F66696E697368656455706C6F6164696E6728652C';
wwv_flow_api.g_varchar2_table(329) := '722C74297D2C722E6F6E6572726F723D66756E6374696F6E28297B6E2E5F68616E646C6555706C6F61644572726F7228652C72297D3B76617220703D6E756C6C213D722E75706C6F61643F722E75706C6F61643A723B702E6F6E70726F67726573733D66';
wwv_flow_api.g_varchar2_table(330) := '756E6374696F6E2874297B72657475726E206E2E5F75706461746546696C657355706C6F616450726F677265737328652C722C74297D3B76617220683D7B4163636570743A226170706C69636174696F6E2F6A736F6E222C2243616368652D436F6E7472';
wwv_flow_api.g_varchar2_table(331) := '6F6C223A226E6F2D6361636865222C22582D5265717565737465642D57697468223A22584D4C4874747052657175657374227D3B746869732E6F7074696F6E732E686561646572732626742E657874656E6428682C746869732E6F7074696F6E732E6865';
wwv_flow_api.g_varchar2_table(332) := '6164657273293B666F7228766172206620696E2068297B76617220763D685B665D3B762626722E7365745265717565737448656164657228662C76297D766172206D3D6E657720466F726D446174613B696628746869732E6F7074696F6E732E70617261';
wwv_flow_api.g_varchar2_table(333) := '6D73297B76617220673D746869732E6F7074696F6E732E706172616D733B2266756E6374696F6E223D3D747970656F662067262628673D672E63616C6C28746869732C652C722C655B305D2E75706C6F61642E6368756E6B65643F746869732E5F676574';
wwv_flow_api.g_varchar2_table(334) := '4368756E6B28655B305D2C72293A6E756C6C29293B666F7228766172206B20696E2067297B76617220623D675B6B5D3B6D2E617070656E64286B2C62297D7D666F722876617220793D652C463D21302C773D302C793D463F793A795B53796D626F6C2E69';
wwv_flow_api.g_varchar2_table(335) := '74657261746F725D28293B3B297B76617220783B69662846297B696628773E3D792E6C656E67746829627265616B3B783D795B772B2B5D7D656C73657B696628773D792E6E65787428292C772E646F6E6529627265616B3B783D772E76616C75657D7661';
wwv_flow_api.g_varchar2_table(336) := '7220453D783B746869732E656D6974282273656E64696E67222C452C722C6D297D746869732E6F7074696F6E732E75706C6F61644D756C7469706C652626746869732E656D6974282273656E64696E676D756C7469706C65222C652C722C6D292C746869';
wwv_flow_api.g_varchar2_table(337) := '732E5F616464466F726D456C656D656E7444617461286D293B666F7228766172207A3D303B7A3C692E6C656E6774683B7A2B2B297B76617220433D695B7A5D3B6D2E617070656E6428432E6E616D652C432E646174612C432E66696C656E616D65297D74';
wwv_flow_api.g_varchar2_table(338) := '6869732E7375626D69745265717565737428722C6D2C65297D7D2C7B6B65793A225F7472616E73666F726D46696C6573222C76616C75653A66756E6374696F6E28652C74297B666F722876617220693D746869732C6E3D5B5D2C723D302C613D66756E63';
wwv_flow_api.g_varchar2_table(339) := '74696F6E2861297B692E6F7074696F6E732E7472616E73666F726D46696C652E63616C6C28692C655B615D2C66756E6374696F6E2869297B6E5B615D3D692C2B2B723D3D3D652E6C656E677468262674286E297D297D2C6F3D303B6F3C652E6C656E6774';
wwv_flow_api.g_varchar2_table(340) := '683B6F2B2B2961286F297D7D2C7B6B65793A225F616464466F726D456C656D656E7444617461222C76616C75653A66756E6374696F6E2865297B69662822464F524D223D3D3D746869732E656C656D656E742E7461674E616D6529666F72287661722074';
wwv_flow_api.g_varchar2_table(341) := '3D746869732E656C656D656E742E717565727953656C6563746F72416C6C2822696E7075742C2074657874617265612C2073656C6563742C20627574746F6E22292C693D21302C6E3D302C743D693F743A745B53796D626F6C2E6974657261746F725D28';
wwv_flow_api.g_varchar2_table(342) := '293B3B297B76617220723B69662869297B6966286E3E3D742E6C656E67746829627265616B3B723D745B6E2B2B5D7D656C73657B6966286E3D742E6E65787428292C6E2E646F6E6529627265616B3B723D6E2E76616C75657D76617220613D722C6F3D61';
wwv_flow_api.g_varchar2_table(343) := '2E67657441747472696275746528226E616D6522292C6C3D612E67657441747472696275746528227479706522293B6966286C2626286C3D6C2E746F4C6F776572436173652829292C22756E646566696E656422213D747970656F66206F26266E756C6C';
wwv_flow_api.g_varchar2_table(344) := '213D3D6F296966282253454C454354223D3D3D612E7461674E616D652626612E68617341747472696275746528226D756C7469706C65222929666F722876617220733D612E6F7074696F6E732C753D21302C643D302C733D753F733A735B53796D626F6C';
wwv_flow_api.g_varchar2_table(345) := '2E6974657261746F725D28293B3B297B76617220633B69662875297B696628643E3D732E6C656E67746829627265616B3B633D735B642B2B5D7D656C73657B696628643D732E6E65787428292C642E646F6E6529627265616B3B633D642E76616C75657D';
wwv_flow_api.g_varchar2_table(346) := '76617220703D633B702E73656C65637465642626652E617070656E64286F2C702E76616C7565297D656C736528216C7C7C22636865636B626F7822213D3D6C262622726164696F22213D3D6C7C7C612E636865636B6564292626652E617070656E64286F';
wwv_flow_api.g_varchar2_table(347) := '2C612E76616C7565297D7D7D2C7B6B65793A225F75706461746546696C657355706C6F616450726F6772657373222C76616C75653A66756E6374696F6E28652C742C69297B766172206E3D766F696420303B69662822756E646566696E656422213D7479';
wwv_flow_api.g_varchar2_table(348) := '70656F662069297B6966286E3D3130302A692E6C6F616465642F692E746F74616C2C655B305D2E75706C6F61642E6368756E6B6564297B76617220723D655B305D2C613D746869732E5F6765744368756E6B28722C74293B612E70726F67726573733D6E';
wwv_flow_api.g_varchar2_table(349) := '2C612E746F74616C3D692E746F74616C2C612E627974657353656E743D692E6C6F616465643B722E75706C6F61642E70726F67726573733D302C722E75706C6F61642E746F74616C3D302C722E75706C6F61642E627974657353656E743D303B666F7228';
wwv_flow_api.g_varchar2_table(350) := '766172206F3D303B6F3C722E75706C6F61642E746F74616C4368756E6B436F756E743B6F2B2B29766F69642030213D3D722E75706C6F61642E6368756E6B735B6F5D2626766F69642030213D3D722E75706C6F61642E6368756E6B735B6F5D2E70726F67';
wwv_flow_api.g_varchar2_table(351) := '72657373262628722E75706C6F61642E70726F67726573732B3D722E75706C6F61642E6368756E6B735B6F5D2E70726F67726573732C722E75706C6F61642E746F74616C2B3D722E75706C6F61642E6368756E6B735B6F5D2E746F74616C2C722E75706C';
wwv_flow_api.g_varchar2_table(352) := '6F61642E627974657353656E742B3D722E75706C6F61642E6368756E6B735B6F5D2E627974657353656E74293B722E75706C6F61642E70726F67726573733D722E75706C6F61642E70726F67726573732F722E75706C6F61642E746F74616C4368756E6B';
wwv_flow_api.g_varchar2_table(353) := '436F756E747D656C736520666F7228766172206C3D652C733D21302C753D302C6C3D733F6C3A6C5B53796D626F6C2E6974657261746F725D28293B3B297B76617220643B69662873297B696628753E3D6C2E6C656E67746829627265616B3B643D6C5B75';
wwv_flow_api.g_varchar2_table(354) := '2B2B5D7D656C73657B696628753D6C2E6E65787428292C752E646F6E6529627265616B3B643D752E76616C75657D76617220633D643B632E75706C6F61642E70726F67726573733D6E2C632E75706C6F61642E746F74616C3D692E746F74616C2C632E75';
wwv_flow_api.g_varchar2_table(355) := '706C6F61642E627974657353656E743D692E6C6F616465647D666F722876617220703D652C683D21302C663D302C703D683F703A705B53796D626F6C2E6974657261746F725D28293B3B297B76617220763B69662868297B696628663E3D702E6C656E67';
wwv_flow_api.g_varchar2_table(356) := '746829627265616B3B763D705B662B2B5D7D656C73657B696628663D702E6E65787428292C662E646F6E6529627265616B3B763D662E76616C75657D766172206D3D763B746869732E656D6974282275706C6F616470726F6772657373222C6D2C6D2E75';
wwv_flow_api.g_varchar2_table(357) := '706C6F61642E70726F67726573732C6D2E75706C6F61642E627974657353656E74297D7D656C73657B76617220673D21303B6E3D3130303B666F7228766172206B3D652C623D21302C793D302C6B3D623F6B3A6B5B53796D626F6C2E6974657261746F72';
wwv_flow_api.g_varchar2_table(358) := '5D28293B3B297B76617220463B69662862297B696628793E3D6B2E6C656E67746829627265616B3B463D6B5B792B2B5D7D656C73657B696628793D6B2E6E65787428292C792E646F6E6529627265616B3B463D792E76616C75657D76617220773D463B31';
wwv_flow_api.g_varchar2_table(359) := '30303D3D3D772E75706C6F61642E70726F67726573732626772E75706C6F61642E627974657353656E743D3D3D772E75706C6F61642E746F74616C7C7C28673D2131292C772E75706C6F61642E70726F67726573733D6E2C772E75706C6F61642E627974';
wwv_flow_api.g_varchar2_table(360) := '657353656E743D772E75706C6F61642E746F74616C7D696628672972657475726E3B666F722876617220783D652C453D21302C7A3D302C783D453F783A785B53796D626F6C2E6974657261746F725D28293B3B297B76617220433B69662845297B696628';
wwv_flow_api.g_varchar2_table(361) := '7A3E3D782E6C656E67746829627265616B3B433D785B7A2B2B5D7D656C73657B6966287A3D782E6E65787428292C7A2E646F6E6529627265616B3B433D7A2E76616C75657D76617220533D433B746869732E656D6974282275706C6F616470726F677265';
wwv_flow_api.g_varchar2_table(362) := '7373222C532C6E2C532E75706C6F61642E627974657353656E74297D7D7D7D2C7B6B65793A225F66696E697368656455706C6F6164696E67222C76616C75653A66756E6374696F6E28652C692C6E297B76617220723D766F696420303B696628655B305D';
wwv_flow_api.g_varchar2_table(363) := '2E737461747573213D3D742E43414E43454C45442626343D3D3D692E72656164795374617465297B69662822617272617962756666657222213D3D692E726573706F6E736554797065262622626C6F6222213D3D692E726573706F6E7365547970652626';
wwv_flow_api.g_varchar2_table(364) := '28723D692E726573706F6E7365546578742C692E676574526573706F6E73654865616465722822636F6E74656E742D74797065222926267E692E676574526573706F6E73654865616465722822636F6E74656E742D7479706522292E696E6465784F6628';
wwv_flow_api.g_varchar2_table(365) := '226170706C69636174696F6E2F6A736F6E222929297472797B723D4A534F4E2E70617273652872297D63617463682865297B6E3D652C723D22496E76616C6964204A534F4E20726573706F6E73652066726F6D207365727665722E227D746869732E5F75';
wwv_flow_api.g_varchar2_table(366) := '706461746546696C657355706C6F616450726F67726573732865292C3230303C3D692E7374617475732626692E7374617475733C3330303F655B305D2E75706C6F61642E6368756E6B65643F655B305D2E75706C6F61642E66696E69736865644368756E';
wwv_flow_api.g_varchar2_table(367) := '6B55706C6F616428746869732E5F6765744368756E6B28655B305D2C6929293A746869732E5F66696E697368656428652C722C6E293A746869732E5F68616E646C6555706C6F61644572726F7228652C692C72297D7D7D2C7B6B65793A225F68616E646C';
wwv_flow_api.g_varchar2_table(368) := '6555706C6F61644572726F72222C76616C75653A66756E6374696F6E28652C692C6E297B696628655B305D2E737461747573213D3D742E43414E43454C4544297B696628655B305D2E75706C6F61642E6368756E6B65642626746869732E6F7074696F6E';
wwv_flow_api.g_varchar2_table(369) := '732E72657472794368756E6B73297B76617220723D746869732E5F6765744368756E6B28655B305D2C69293B696628722E726574726965732B2B3C746869732E6F7074696F6E732E72657472794368756E6B734C696D69742972657475726E20766F6964';
wwv_flow_api.g_varchar2_table(370) := '20746869732E5F75706C6F61644461746128652C5B722E64617461426C6F636B5D293B636F6E736F6C652E7761726E2822526574726965642074686973206368756E6B20746F6F206F6674656E2E20476976696E672075702E22297D666F722876617220';
wwv_flow_api.g_varchar2_table(371) := '613D652C6F3D21302C6C3D302C613D6F3F613A615B53796D626F6C2E6974657261746F725D28293B3B297B76617220733B6966286F297B6966286C3E3D612E6C656E67746829627265616B3B733D615B6C2B2B5D7D656C73657B6966286C3D612E6E6578';
wwv_flow_api.g_varchar2_table(372) := '7428292C6C2E646F6E6529627265616B3B733D6C2E76616C75657D746869732E5F6572726F7250726F63657373696E6728652C6E7C7C746869732E6F7074696F6E732E64696374526573706F6E73654572726F722E7265706C61636528227B7B73746174';
wwv_flow_api.g_varchar2_table(373) := '7573436F64657D7D222C692E737461747573292C69297D7D7D7D2C7B6B65793A227375626D697452657175657374222C76616C75653A66756E6374696F6E28652C742C69297B652E73656E642874297D7D2C7B6B65793A225F66696E6973686564222C76';
wwv_flow_api.g_varchar2_table(374) := '616C75653A66756E6374696F6E28652C692C6E297B666F722876617220723D652C613D21302C6F3D302C723D613F723A725B53796D626F6C2E6974657261746F725D28293B3B297B766172206C3B69662861297B6966286F3E3D722E6C656E6774682962';
wwv_flow_api.g_varchar2_table(375) := '7265616B3B6C3D725B6F2B2B5D7D656C73657B6966286F3D722E6E65787428292C6F2E646F6E6529627265616B3B6C3D6F2E76616C75657D76617220733D6C3B732E7374617475733D742E535543434553532C746869732E656D69742822737563636573';
wwv_flow_api.g_varchar2_table(376) := '73222C732C692C6E292C746869732E656D69742822636F6D706C657465222C73297D696628746869732E6F7074696F6E732E75706C6F61644D756C7469706C65262628746869732E656D69742822737563636573736D756C7469706C65222C652C692C6E';
wwv_flow_api.g_varchar2_table(377) := '292C746869732E656D69742822636F6D706C6574656D756C7469706C65222C6529292C746869732E6F7074696F6E732E6175746F50726F6365737351756575652972657475726E20746869732E70726F63657373517565756528297D7D2C7B6B65793A22';
wwv_flow_api.g_varchar2_table(378) := '5F6572726F7250726F63657373696E67222C76616C75653A66756E6374696F6E28652C692C6E297B666F722876617220723D652C613D21302C6F3D302C723D613F723A725B53796D626F6C2E6974657261746F725D28293B3B297B766172206C3B696628';
wwv_flow_api.g_varchar2_table(379) := '61297B6966286F3E3D722E6C656E67746829627265616B3B6C3D725B6F2B2B5D7D656C73657B6966286F3D722E6E65787428292C6F2E646F6E6529627265616B3B6C3D6F2E76616C75657D76617220733D6C3B732E7374617475733D742E4552524F522C';
wwv_flow_api.g_varchar2_table(380) := '746869732E656D697428226572726F72222C732C692C6E292C746869732E656D69742822636F6D706C657465222C73297D696628746869732E6F7074696F6E732E75706C6F61644D756C7469706C65262628746869732E656D697428226572726F726D75';
wwv_flow_api.g_varchar2_table(381) := '6C7469706C65222C652C692C6E292C746869732E656D69742822636F6D706C6574656D756C7469706C65222C6529292C746869732E6F7074696F6E732E6175746F50726F6365737351756575652972657475726E20746869732E70726F63657373517565';
wwv_flow_api.g_varchar2_table(382) := '756528297D7D5D2C5B7B6B65793A22757569647634222C76616C75653A66756E6374696F6E28297B72657475726E2278787878787878782D787878782D347878782D797878782D787878787878787878787878222E7265706C616365282F5B78795D2F67';
wwv_flow_api.g_varchar2_table(383) := '2C66756E6374696F6E2865297B76617220743D31362A4D6174682E72616E646F6D28297C302C693D2278223D3D3D653F743A3326747C383B72657475726E20692E746F537472696E67283136297D297D7D5D292C747D28456D6974746572293B44726F70';
wwv_flow_api.g_varchar2_table(384) := '7A6F6E652E696E6974436C61737328292C44726F707A6F6E652E76657273696F6E3D22352E352E30222C44726F707A6F6E652E6F7074696F6E733D7B7D2C44726F707A6F6E652E6F7074696F6E73466F72456C656D656E743D66756E6374696F6E286529';
wwv_flow_api.g_varchar2_table(385) := '7B72657475726E20652E6765744174747269627574652822696422293F44726F707A6F6E652E6F7074696F6E735B63616D656C697A6528652E676574417474726962757465282269642229295D3A766F696420307D2C44726F707A6F6E652E696E737461';
wwv_flow_api.g_varchar2_table(386) := '6E6365733D5B5D2C44726F707A6F6E652E666F72456C656D656E743D66756E6374696F6E2865297B69662822737472696E67223D3D747970656F662065262628653D646F63756D656E742E717565727953656C6563746F72286529292C6E756C6C3D3D28';
wwv_flow_api.g_varchar2_table(387) := '6E756C6C213D653F652E64726F707A6F6E653A766F6964203029297468726F77206E6577204572726F7228224E6F2044726F707A6F6E6520666F756E6420666F7220676976656E20656C656D656E742E20546869732069732070726F6261626C79206265';
wwv_flow_api.g_varchar2_table(388) := '636175736520796F7527726520747279696E6720746F20616363657373206974206265666F72652044726F707A6F6E6520686164207468652074696D6520746F20696E697469616C697A652E20557365207468652060696E697460206F7074696F6E2074';
wwv_flow_api.g_varchar2_table(389) := '6F20736574757020616E79206164646974696F6E616C206F6273657276657273206F6E20796F75722044726F707A6F6E652E22293B72657475726E20652E64726F707A6F6E657D2C44726F707A6F6E652E6175746F446973636F7665723D21312C44726F';
wwv_flow_api.g_varchar2_table(390) := '707A6F6E652E646973636F7665723D66756E6374696F6E28297B76617220653D766F696420303B696628646F63756D656E742E717565727953656C6563746F72416C6C29653D646F63756D656E742E717565727953656C6563746F72416C6C28222E6472';
wwv_flow_api.g_varchar2_table(391) := '6F707A6F6E6522293B656C73657B653D5B5D3B76617220743D66756E6374696F6E2874297B72657475726E2066756E6374696F6E28297B666F722876617220693D5B5D2C6E3D742C723D21302C613D302C6E3D723F6E3A6E5B53796D626F6C2E69746572';
wwv_flow_api.g_varchar2_table(392) := '61746F725D28293B3B297B766172206F3B69662872297B696628613E3D6E2E6C656E67746829627265616B3B6F3D6E5B612B2B5D7D656C73657B696628613D6E2E6E65787428292C612E646F6E6529627265616B3B6F3D612E76616C75657D766172206C';
wwv_flow_api.g_varchar2_table(393) := '3D6F3B2F285E7C202964726F707A6F6E6528247C20292F2E74657374286C2E636C6173734E616D65293F692E7075736828652E70757368286C29293A692E7075736828766F69642030297D72657475726E20697D28297D3B7428646F63756D656E742E67';
wwv_flow_api.g_varchar2_table(394) := '6574456C656D656E747342795461674E616D6528226469762229292C7428646F63756D656E742E676574456C656D656E747342795461674E616D652822666F726D2229297D72657475726E2066756E6374696F6E28297B666F722876617220743D5B5D2C';
wwv_flow_api.g_varchar2_table(395) := '693D652C6E3D21302C723D302C693D6E3F693A695B53796D626F6C2E6974657261746F725D28293B3B297B76617220613B6966286E297B696628723E3D692E6C656E67746829627265616B3B613D695B722B2B5D7D656C73657B696628723D692E6E6578';
wwv_flow_api.g_varchar2_table(396) := '7428292C722E646F6E6529627265616B3B613D722E76616C75657D766172206F3D613B44726F707A6F6E652E6F7074696F6E73466F72456C656D656E74286F29213D3D21313F742E70757368286E65772044726F707A6F6E65286F29293A742E70757368';
wwv_flow_api.g_varchar2_table(397) := '28766F69642030297D72657475726E20747D28297D2C44726F707A6F6E652E626C61636B6C697374656442726F77736572733D5B2F6F706572612E2A284D6163696E746F73687C57696E646F77732050686F6E65292E2A76657273696F6E5C2F31322F69';
wwv_flow_api.g_varchar2_table(398) := '5D2C44726F707A6F6E652E697342726F77736572537570706F727465643D66756E6374696F6E28297B76617220653D21303B69662877696E646F772E46696C65262677696E646F772E46696C65526561646572262677696E646F772E46696C654C697374';
wwv_flow_api.g_varchar2_table(399) := '262677696E646F772E426C6F62262677696E646F772E466F726D446174612626646F63756D656E742E717565727953656C6563746F722969662822636C6173734C69737422696E20646F63756D656E742E637265617465456C656D656E74282261222929';
wwv_flow_api.g_varchar2_table(400) := '666F722876617220743D44726F707A6F6E652E626C61636B6C697374656442726F77736572732C693D21302C6E3D302C743D693F743A745B53796D626F6C2E6974657261746F725D28293B3B297B76617220723B69662869297B6966286E3E3D742E6C65';
wwv_flow_api.g_varchar2_table(401) := '6E67746829627265616B3B723D745B6E2B2B5D7D656C73657B6966286E3D742E6E65787428292C6E2E646F6E6529627265616B3B723D6E2E76616C75657D76617220613D723B612E74657374286E6176696761746F722E757365724167656E7429262628';
wwv_flow_api.g_varchar2_table(402) := '653D2131297D656C736520653D21313B656C736520653D21313B72657475726E20657D2C44726F707A6F6E652E64617461555249746F426C6F623D66756E6374696F6E2865297B666F722876617220743D61746F6228652E73706C697428222C22295B31';
wwv_flow_api.g_varchar2_table(403) := '5D292C693D652E73706C697428222C22295B305D2E73706C697428223A22295B315D2E73706C697428223B22295B305D2C6E3D6E657720417272617942756666657228742E6C656E677468292C723D6E65772055696E74384172726179286E292C613D30';
wwv_flow_api.g_varchar2_table(404) := '2C6F3D742E6C656E6774682C6C3D303C3D6F3B6C3F613C3D6F3A613E3D6F3B6C3F612B2B3A612D2D29725B615D3D742E63686172436F646541742861293B72657475726E206E657720426C6F62285B6E5D2C7B747970653A697D297D3B76617220776974';
wwv_flow_api.g_varchar2_table(405) := '686F75743D66756E6374696F6E28652C74297B72657475726E20652E66696C7465722866756E6374696F6E2865297B72657475726E2065213D3D747D292E6D61702866756E6374696F6E2865297B72657475726E20657D297D2C63616D656C697A653D66';
wwv_flow_api.g_varchar2_table(406) := '756E6374696F6E2865297B72657475726E20652E7265706C616365282F5B5C2D5F5D285C77292F672C66756E6374696F6E2865297B72657475726E20652E6368617241742831292E746F55707065724361736528297D297D3B44726F707A6F6E652E6372';
wwv_flow_api.g_varchar2_table(407) := '65617465456C656D656E743D66756E6374696F6E2865297B76617220743D646F63756D656E742E637265617465456C656D656E74282264697622293B72657475726E20742E696E6E657248544D4C3D652C742E6368696C644E6F6465735B305D7D2C4472';
wwv_flow_api.g_varchar2_table(408) := '6F707A6F6E652E656C656D656E74496E736964653D66756E6374696F6E28652C74297B696628653D3D3D742972657475726E21303B666F72283B653D652E706172656E744E6F64653B29696628653D3D3D742972657475726E21303B72657475726E2131';
wwv_flow_api.g_varchar2_table(409) := '7D2C44726F707A6F6E652E676574456C656D656E743D66756E6374696F6E28652C74297B76617220693D766F696420303B69662822737472696E67223D3D747970656F6620653F693D646F63756D656E742E717565727953656C6563746F722865293A6E';
wwv_flow_api.g_varchar2_table(410) := '756C6C213D652E6E6F646554797065262628693D65292C6E756C6C3D3D69297468726F77206E6577204572726F722822496E76616C69642060222B742B2260206F7074696F6E2070726F76696465642E20506C656173652070726F766964652061204353';
wwv_flow_api.g_varchar2_table(411) := '532073656C6563746F72206F72206120706C61696E2048544D4C20656C656D656E742E22293B72657475726E20697D2C44726F707A6F6E652E676574456C656D656E74733D66756E6374696F6E28652C74297B76617220693D766F696420302C6E3D766F';
wwv_flow_api.g_varchar2_table(412) := '696420303B6966286520696E7374616E63656F66204172726179297B6E3D5B5D3B7472797B666F722876617220723D652C613D21302C6F3D302C723D613F723A725B53796D626F6C2E6974657261746F725D28293B3B297B69662861297B6966286F3E3D';
wwv_flow_api.g_varchar2_table(413) := '722E6C656E67746829627265616B3B693D725B6F2B2B5D7D656C73657B6966286F3D722E6E65787428292C6F2E646F6E6529627265616B3B693D6F2E76616C75657D6E2E7075736828746869732E676574456C656D656E7428692C7429297D7D63617463';
wwv_flow_api.g_varchar2_table(414) := '682865297B6E3D6E756C6C7D7D656C73652069662822737472696E67223D3D747970656F662065297B6E3D5B5D3B666F7228766172206C3D646F63756D656E742E717565727953656C6563746F72416C6C2865292C733D21302C753D302C6C3D733F6C3A';
wwv_flow_api.g_varchar2_table(415) := '6C5B53796D626F6C2E6974657261746F725D28293B3B297B69662873297B696628753E3D6C2E6C656E67746829627265616B3B693D6C5B752B2B5D7D656C73657B696628753D6C2E6E65787428292C752E646F6E6529627265616B3B693D752E76616C75';
wwv_flow_api.g_varchar2_table(416) := '657D6E2E707573682869297D7D656C7365206E756C6C213D652E6E6F6465547970652626286E3D5B655D293B6966286E756C6C3D3D6E7C7C216E2E6C656E677468297468726F77206E6577204572726F722822496E76616C69642060222B742B2260206F';
wwv_flow_api.g_varchar2_table(417) := '7074696F6E2070726F76696465642E20506C656173652070726F766964652061204353532073656C6563746F722C206120706C61696E2048544D4C20656C656D656E74206F722061206C697374206F662074686F73652E22293B72657475726E206E7D2C';
wwv_flow_api.g_varchar2_table(418) := '44726F707A6F6E652E636F6E6669726D3D66756E6374696F6E28652C742C69297B72657475726E2077696E646F772E636F6E6669726D2865293F7428293A6E756C6C213D693F6928293A766F696420307D2C44726F707A6F6E652E697356616C69644669';
wwv_flow_api.g_varchar2_table(419) := '6C653D66756E6374696F6E28652C74297B69662821742972657475726E21303B743D742E73706C697428222C22293B666F722876617220693D652E747970652C6E3D692E7265706C616365282F5C2F2E2A242F2C2222292C723D742C613D21302C6F3D30';
wwv_flow_api.g_varchar2_table(420) := '2C723D613F723A725B53796D626F6C2E6974657261746F725D28293B3B297B766172206C3B69662861297B6966286F3E3D722E6C656E67746829627265616B3B6C3D725B6F2B2B5D7D656C73657B6966286F3D722E6E65787428292C6F2E646F6E652962';
wwv_flow_api.g_varchar2_table(421) := '7265616B3B6C3D6F2E76616C75657D76617220733D6C3B696628733D732E7472696D28292C222E223D3D3D732E636861724174283029297B696628652E6E616D652E746F4C6F7765724361736528292E696E6465784F6628732E746F4C6F776572436173';
wwv_flow_api.g_varchar2_table(422) := '6528292C652E6E616D652E6C656E6774682D732E6C656E67746829213D3D2D312972657475726E21307D656C7365206966282F5C2F5C2A242F2E74657374287329297B6966286E3D3D3D732E7265706C616365282F5C2F2E2A242F2C2222292972657475';
wwv_flow_api.g_varchar2_table(423) := '726E21307D656C736520696628693D3D3D732972657475726E21307D72657475726E21317D2C22756E646566696E656422213D747970656F66206A517565727926266E756C6C213D3D6A51756572792626286A51756572792E666E2E64726F707A6F6E65';
wwv_flow_api.g_varchar2_table(424) := '3D66756E6374696F6E2865297B72657475726E20746869732E656163682866756E6374696F6E28297B72657475726E206E65772044726F707A6F6E6528746869732C65297D297D292C22756E646566696E656422213D747970656F66206D6F64756C6526';
wwv_flow_api.g_varchar2_table(425) := '266E756C6C213D3D6D6F64756C653F6D6F64756C652E6578706F7274733D44726F707A6F6E653A77696E646F772E44726F707A6F6E653D44726F707A6F6E652C44726F707A6F6E652E41444445443D226164646564222C44726F707A6F6E652E51554555';
wwv_flow_api.g_varchar2_table(426) := '45443D22717565756564222C44726F707A6F6E652E41434345505445443D44726F707A6F6E652E5155455545442C44726F707A6F6E652E55504C4F4144494E473D2275706C6F6164696E67222C44726F707A6F6E652E50524F43455353494E473D44726F';
wwv_flow_api.g_varchar2_table(427) := '707A6F6E652E55504C4F4144494E472C44726F707A6F6E652E43414E43454C45443D2263616E63656C6564222C44726F707A6F6E652E4552524F523D226572726F72222C44726F707A6F6E652E535543434553533D2273756363657373223B7661722064';
wwv_flow_api.g_varchar2_table(428) := '6574656374566572746963616C5371756173683D66756E6374696F6E2865297B76617220743D28652E6E61747572616C57696474682C652E6E61747572616C486569676874292C693D646F63756D656E742E637265617465456C656D656E74282263616E';
wwv_flow_api.g_varchar2_table(429) := '76617322293B692E77696474683D312C692E6865696768743D743B766172206E3D692E676574436F6E746578742822326422293B6E2E64726177496D61676528652C302C30293B666F722876617220723D6E2E676574496D6167654461746128312C302C';
wwv_flow_api.g_varchar2_table(430) := '312C74292C613D722E646174612C6F3D302C6C3D742C733D743B733E6F3B297B76617220753D615B342A28732D31292B335D3B303D3D3D753F6C3D733A6F3D732C733D6C2B6F3E3E317D76617220643D732F743B72657475726E20303D3D3D643F313A64';
wwv_flow_api.g_varchar2_table(431) := '7D2C64726177496D616765494F534669783D66756E6374696F6E28652C742C692C6E2C722C612C6F2C6C2C732C75297B76617220643D646574656374566572746963616C5371756173682874293B72657475726E20652E64726177496D61676528742C69';
wwv_flow_api.g_varchar2_table(432) := '2C6E2C722C612C6F2C6C2C732C752F64297D2C45786966526573746F72653D66756E6374696F6E28297B66756E6374696F6E206528297B5F636C61737343616C6C436865636B28746869732C65297D72657475726E205F637265617465436C6173732865';
wwv_flow_api.g_varchar2_table(433) := '2C6E756C6C2C5B7B6B65793A22696E6974436C617373222C76616C75653A66756E6374696F6E28297B746869732E4B45595F5354523D224142434445464748494A4B4C4D4E4F505152535455565758595A6162636465666768696A6B6C6D6E6F70717273';
wwv_flow_api.g_varchar2_table(434) := '7475767778797A303132333435363738392B2F3D227D7D2C7B6B65793A22656E636F64653634222C76616C75653A66756E6374696F6E2865297B666F722876617220743D22222C693D766F696420302C6E3D766F696420302C723D22222C613D766F6964';
wwv_flow_api.g_varchar2_table(435) := '20302C6F3D766F696420302C6C3D766F696420302C733D22222C753D303B3B29696628693D655B752B2B5D2C6E3D655B752B2B5D2C723D655B752B2B5D2C613D693E3E322C6F3D28332669293C3C347C6E3E3E342C6C3D283135266E293C3C327C723E3E';
wwv_flow_api.g_varchar2_table(436) := '362C733D363326722C69734E614E286E293F6C3D733D36343A69734E614E287229262628733D3634292C743D742B746869732E4B45595F5354522E6368617241742861292B746869732E4B45595F5354522E636861724174286F292B746869732E4B4559';
wwv_flow_api.g_varchar2_table(437) := '5F5354522E636861724174286C292B746869732E4B45595F5354522E6368617241742873292C693D6E3D723D22222C613D6F3D6C3D733D22222C2128753C652E6C656E6774682929627265616B3B72657475726E20747D7D2C7B6B65793A22726573746F';
wwv_flow_api.g_varchar2_table(438) := '7265222C76616C75653A66756E6374696F6E28652C74297B69662821652E6D617463682822646174613A696D6167652F6A7065673B6261736536342C22292972657475726E20743B76617220693D746869732E6465636F6465363428652E7265706C6163';
wwv_flow_api.g_varchar2_table(439) := '652822646174613A696D6167652F6A7065673B6261736536342C222C222229292C6E3D746869732E736C696365325365676D656E74732869292C723D746869732E657869664D616E6970756C6174696F6E28742C6E293B72657475726E22646174613A69';
wwv_flow_api.g_varchar2_table(440) := '6D6167652F6A7065673B6261736536342C222B746869732E656E636F646536342872297D7D2C7B6B65793A22657869664D616E6970756C6174696F6E222C76616C75653A66756E6374696F6E28652C74297B76617220693D746869732E67657445786966';
wwv_flow_api.g_varchar2_table(441) := '41727261792874292C6E3D746869732E696E736572744578696628652C69292C723D6E65772055696E74384172726179286E293B72657475726E20727D7D2C7B6B65793A22676574457869664172726179222C76616C75653A66756E6374696F6E286529';
wwv_flow_api.g_varchar2_table(442) := '7B666F722876617220743D766F696420302C693D303B693C652E6C656E6774683B297B696628743D655B695D2C3235353D3D3D745B305D263232353D3D3D745B315D2972657475726E20743B692B2B7D72657475726E5B5D7D7D2C7B6B65793A22696E73';
wwv_flow_api.g_varchar2_table(443) := '65727445786966222C76616C75653A66756E6374696F6E28652C74297B76617220693D652E7265706C6163652822646174613A696D6167652F6A7065673B6261736536342C222C2222292C6E3D746869732E6465636F646536342869292C723D6E2E696E';
wwv_flow_api.g_varchar2_table(444) := '6465784F66283235352C33292C613D6E2E736C69636528302C72292C6F3D6E2E736C6963652872292C6C3D613B72657475726E206C3D6C2E636F6E6361742874292C6C3D6C2E636F6E636174286F297D7D2C7B6B65793A22736C696365325365676D656E';
wwv_flow_api.g_varchar2_table(445) := '7473222C76616C75653A66756E6374696F6E2865297B666F722876617220743D302C693D5B5D3B3B297B766172206E3B6966283235353D3D3D655B745D263231383D3D3D655B742B315D29627265616B3B6966283235353D3D3D655B745D263231363D3D';
wwv_flow_api.g_varchar2_table(446) := '3D655B742B315D29742B3D323B656C73657B6E3D3235362A655B742B325D2B655B742B335D3B76617220723D742B6E2B322C613D652E736C69636528742C72293B692E707573682861292C743D727D696628743E652E6C656E67746829627265616B7D72';
wwv_flow_api.g_varchar2_table(447) := '657475726E20697D7D2C7B6B65793A226465636F64653634222C76616C75653A66756E6374696F6E2865297B76617220743D766F696420302C693D766F696420302C6E3D22222C723D766F696420302C613D766F696420302C6F3D766F696420302C6C3D';
wwv_flow_api.g_varchar2_table(448) := '22222C733D302C753D5B5D2C643D2F5B5E412D5A612D7A302D395C2B5C2F5C3D5D2F673B666F7228642E657865632865292626636F6E736F6C652E7761726E28225468657265207765726520696E76616C69642062617365363420636861726163746572';
wwv_flow_api.g_varchar2_table(449) := '7320696E2074686520696E70757420746578742E5C6E56616C69642062617365363420636861726163746572732061726520412D5A2C20612D7A2C20302D392C20272B272C20272F272C616E6420273D275C6E457870656374206572726F727320696E20';
wwv_flow_api.g_varchar2_table(450) := '6465636F64696E672E22292C653D652E7265706C616365282F5B5E412D5A612D7A302D395C2B5C2F5C3D5D2F672C2222293B3B29696628723D746869732E4B45595F5354522E696E6465784F6628652E63686172417428732B2B29292C613D746869732E';
wwv_flow_api.g_varchar2_table(451) := '4B45595F5354522E696E6465784F6628652E63686172417428732B2B29292C6F3D746869732E4B45595F5354522E696E6465784F6628652E63686172417428732B2B29292C6C3D746869732E4B45595F5354522E696E6465784F6628652E636861724174';
wwv_flow_api.g_varchar2_table(452) := '28732B2B29292C743D723C3C327C613E3E342C693D2831352661293C3C347C6F3E3E322C6E3D2833266F293C3C367C6C2C752E707573682874292C3634213D3D6F2626752E707573682869292C3634213D3D6C2626752E70757368286E292C743D693D6E';
wwv_flow_api.g_varchar2_table(453) := '3D22222C723D613D6F3D6C3D22222C2128733C652E6C656E6774682929627265616B3B72657475726E20757D7D5D292C657D28293B45786966526573746F72652E696E6974436C61737328293B76617220636F6E74656E744C6F616465643D66756E6374';
wwv_flow_api.g_varchar2_table(454) := '696F6E28652C74297B76617220693D21312C6E3D21302C723D652E646F63756D656E742C613D722E646F63756D656E74456C656D656E742C6F3D722E6164644576656E744C697374656E65723F226164644576656E744C697374656E6572223A22617474';
wwv_flow_api.g_varchar2_table(455) := '6163684576656E74222C6C3D722E6164644576656E744C697374656E65723F2272656D6F76654576656E744C697374656E6572223A226465746163684576656E74222C733D722E6164644576656E744C697374656E65723F22223A226F6E222C753D6675';
wwv_flow_api.g_varchar2_table(456) := '6E6374696F6E206E2861297B69662822726561647973746174656368616E676522213D3D612E747970657C7C22636F6D706C657465223D3D3D722E726561647953746174652972657475726E28226C6F6164223D3D3D612E747970653F653A72295B6C5D';
wwv_flow_api.g_varchar2_table(457) := '28732B612E747970652C6E2C2131292C2169262628693D2130293F742E63616C6C28652C612E747970657C7C61293A766F696420307D2C643D66756E6374696F6E206528297B7472797B612E646F5363726F6C6C28226C65667422297D63617463682874';
wwv_flow_api.g_varchar2_table(458) := '297B72657475726E20766F69642073657454696D656F757428652C3530297D72657475726E20752822706F6C6C22297D3B69662822636F6D706C65746522213D3D722E72656164795374617465297B696628722E6372656174654576656E744F626A6563';
wwv_flow_api.g_varchar2_table(459) := '742626612E646F5363726F6C6C297B7472797B6E3D21652E6672616D65456C656D656E747D63617463682865297B7D6E26266428297D72657475726E20725B6F5D28732B22444F4D436F6E74656E744C6F61646564222C752C2131292C725B6F5D28732B';
wwv_flow_api.g_varchar2_table(460) := '22726561647973746174656368616E6765222C752C2131292C655B6F5D28732B226C6F6164222C752C2131297D7D3B44726F707A6F6E652E5F6175746F446973636F76657246756E6374696F6E3D66756E6374696F6E28297B69662844726F707A6F6E65';
wwv_flow_api.g_varchar2_table(461) := '2E6175746F446973636F7665722972657475726E2044726F707A6F6E652E646973636F76657228297D2C636F6E74656E744C6F616465642877696E646F772C44726F707A6F6E652E5F6175746F446973636F76657246756E6374696F6E293B';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72363611381797266)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'js/dropzone.min.js'
,p_mime_type=>'application/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2F2A210A46696C655265616465722E6A73202D2076302E39390A41206C69676874776569676874207772617070657220666F7220636F6D6D6F6E2046696C655265616465722075736167652E0A436F70797269676874203230313420427269616E204772';
wwv_flow_api.g_varchar2_table(2) := '696E7374656164202D204D4954204C6963656E73652E0A53656520687474703A2F2F6769746875622E636F6D2F626772696E732F66696C657265616465722E6A7320666F7220646F63756D656E746174696F6E2E0A2A2F0A0A2866756E6374696F6E2877';
wwv_flow_api.g_varchar2_table(3) := '696E646F772C20646F63756D656E7429207B0A0A20207661722046696C65526561646572203D2077696E646F772E46696C655265616465723B0A20207661722046696C6552656164657253796E63537570706F7274203D2066616C73653B0A2020766172';
wwv_flow_api.g_varchar2_table(4) := '20776F726B6572536372697074203D202273656C662E6164644576656E744C697374656E657228276D657373616765272C2066756E6374696F6E286529207B2076617220646174613D652E646174613B20747279207B2076617220726561646572203D20';
wwv_flow_api.g_varchar2_table(5) := '6E65772046696C6552656164657253796E633B20706F73744D657373616765287B20726573756C743A207265616465725B646174612E7265616441735D28646174612E66696C65292C2065787472613A20646174612E65787472612C2066696C653A2064';
wwv_flow_api.g_varchar2_table(6) := '6174612E66696C657D297D2063617463682865297B20706F73744D657373616765287B20726573756C743A276572726F72272C2065787472613A646174612E65787472612C2066696C653A646174612E66696C657D293B207D207D2C2066616C7365293B';
wwv_flow_api.g_varchar2_table(7) := '223B0A20207661722073796E63446574656374696F6E536372697074203D20226F6E6D657373616765203D2066756E6374696F6E286529207B20706F73744D65737361676528212146696C6552656164657253796E63293B207D3B223B0A202076617220';
wwv_flow_api.g_varchar2_table(8) := '66696C655265616465724576656E7473203D205B276C6F61647374617274272C202770726F6772657373272C20276C6F6164272C202761626F7274272C20276572726F72272C20276C6F6164656E64275D3B0A20207661722073796E63203D2066616C73';
wwv_flow_api.g_varchar2_table(9) := '653B0A20207661722046696C655265616465724A53203D2077696E646F772E46696C655265616465724A53203D207B0A20202020656E61626C65643A2066616C73652C0A202020207365747570496E7075743A207365747570496E7075742C0A20202020';
wwv_flow_api.g_varchar2_table(10) := '736574757044726F703A20736574757044726F702C0A202020207365747570436C6970626F6172643A207365747570436C6970626F6172642C0A2020202073657453796E633A2066756E6374696F6E2876616C756529207B0A20202020202073796E6320';
wwv_flow_api.g_varchar2_table(11) := '3D2076616C75653B0A0A2020202020206966202873796E63202626202146696C6552656164657253796E63537570706F727429207B0A2020202020202020636865636B46696C6552656164657253796E63537570706F727428293B0A2020202020207D0A';
wwv_flow_api.g_varchar2_table(12) := '202020207D2C0A2020202067657453796E633A2066756E6374696F6E2829207B0A20202020202072657475726E2073796E632026262046696C6552656164657253796E63537570706F72743B0A202020207D2C0A202020206F75747075743A205B5D2C0A';
wwv_flow_api.g_varchar2_table(13) := '202020206F7074733A207B0A20202020202064726167436C6173733A202264726167222C0A2020202020206163636570743A2066616C73652C0A20202020202072656164417344656661756C743A20274461746155524C272C0A20202020202072656164';
wwv_flow_api.g_varchar2_table(14) := '41734D61703A207B7D2C0A2020202020206F6E3A207B0A20202020202020206C6F616473746172743A206E6F6F702C0A202020202020202070726F67726573733A206E6F6F702C0A20202020202020206C6F61643A206E6F6F702C0A2020202020202020';
wwv_flow_api.g_varchar2_table(15) := '61626F72743A206E6F6F702C0A20202020202020206572726F723A206E6F6F702C0A20202020202020206C6F6164656E643A206E6F6F702C0A2020202020202020736B69703A206E6F6F702C0A202020202020202067726F757073746172743A206E6F6F';
wwv_flow_api.g_varchar2_table(16) := '702C0A202020202020202067726F7570656E643A206E6F6F702C0A20202020202020206265666F726573746172743A206E6F6F700A2020202020207D0A202020207D0A20207D3B0A0A20202F2F205365747570206A517565727920706C7567696E202869';
wwv_flow_api.g_varchar2_table(17) := '6620617661696C61626C65290A202069662028747970656F66286A51756572792920213D3D2022756E646566696E65642229207B0A202020206A51756572792E666E2E66696C655265616465724A53203D2066756E6374696F6E286F70747329207B0A20';
wwv_flow_api.g_varchar2_table(18) := '202020202072657475726E20746869732E656163682866756E6374696F6E2829207B0A2020202020202020696620286A51756572792874686973292E69732822696E707574222929207B0A202020202020202020207365747570496E7075742874686973';
wwv_flow_api.g_varchar2_table(19) := '2C206F707473293B0A20202020202020207D20656C7365207B0A20202020202020202020736574757044726F7028746869732C206F707473293B0A20202020202020207D0A2020202020207D293B0A202020207D3B0A0A202020206A51756572792E666E';
wwv_flow_api.g_varchar2_table(20) := '2E66696C65436C6970626F617264203D2066756E6374696F6E286F70747329207B0A20202020202072657475726E20746869732E656163682866756E6374696F6E2829207B0A20202020202020207365747570436C6970626F61726428746869732C206F';
wwv_flow_api.g_varchar2_table(21) := '707473293B0A2020202020207D293B0A202020207D3B0A20207D0A0A20202F2F204E6F7420616C6C2062726F777365727320737570706F7274207468652046696C6552656164657220696E746572666163652E2052657475726E20776974682074686520';
wwv_flow_api.g_varchar2_table(22) := '656E61626C656420626974203D2066616C73652E0A2020696620282146696C6552656164657229207B0A2020202072657475726E3B0A20207D0A0A0A20202F2F206D616B65576F726B65722069732061206C6974746C65207772617070657220666F7220';
wwv_flow_api.g_varchar2_table(23) := '67656E65726174696E672077656220776F726B6572732066726F6D20737472696E67730A202066756E6374696F6E206D616B65576F726B65722873637269707429207B0A202020207661722055524C203D2077696E646F772E55524C207C7C2077696E64';
wwv_flow_api.g_varchar2_table(24) := '6F772E7765626B697455524C3B0A2020202076617220426C6F62203D2077696E646F772E426C6F623B0A2020202076617220576F726B6572203D2077696E646F772E576F726B65723B0A0A20202020696620282155524C207C7C2021426C6F62207C7C20';
wwv_flow_api.g_varchar2_table(25) := '21576F726B6572207C7C202173637269707429207B0A20202020202072657475726E206E756C6C3B0A202020207D0A0A2020202076617220626C6F62203D206E657720426C6F62285B7363726970745D293B0A2020202076617220776F726B6572203D20';
wwv_flow_api.g_varchar2_table(26) := '6E657720576F726B65722855524C2E6372656174654F626A65637455524C28626C6F6229293B0A2020202072657475726E20776F726B65723B0A20207D0A0A20202F2F207365747570436C6970626F6172643A2062696E6420746F20636C6970626F6172';
wwv_flow_api.g_varchar2_table(27) := '64206576656E74732028696E74656E64656420666F7220646F63756D656E742E626F6479290A202066756E6374696F6E207365747570436C6970626F61726428656C656D656E742C206F70747329207B0A0A20202020696620282146696C655265616465';
wwv_flow_api.g_varchar2_table(28) := '724A532E656E61626C656429207B0A20202020202072657475726E3B0A202020207D0A2020202076617220696E7374616E63654F7074696F6E73203D20657874656E6428657874656E64287B7D2C2046696C655265616465724A532E6F707473292C206F';
wwv_flow_api.g_varchar2_table(29) := '707473293B0A0A20202020656C656D656E742E6164644576656E744C697374656E657228227061737465222C206F6E70617374652C2066616C7365293B0A0A2020202066756E6374696F6E206F6E7061737465286529207B0A2020202020207661722066';
wwv_flow_api.g_varchar2_table(30) := '696C6573203D205B5D3B0A20202020202076617220636C6970626F61726444617461203D20652E636C6970626F61726444617461207C7C207B7D3B0A202020202020766172206974656D73203D20636C6970626F617264446174612E6974656D73207C7C';
wwv_flow_api.g_varchar2_table(31) := '205B5D3B0A0A202020202020666F7220287661722069203D20303B2069203C206974656D732E6C656E6774683B20692B2B29207B0A20202020202020207661722066696C65203D206974656D735B695D2E676574417346696C6528293B0A0A2020202020';
wwv_flow_api.g_varchar2_table(32) := '2020206966202866696C6529207B0A0A202020202020202020202F2F2043726561746520612066616B652066696C65206E616D6520666F7220696D616765732066726F6D20636C6970626F6172642C2073696E63652074686973206461746120646F6573';
wwv_flow_api.g_varchar2_table(33) := '6E2774206765742073656E740A20202020202020202020766172206D617463686573203D206E65772052656745787028222F5C282E2A5C2922292E657865632866696C652E74797065293B0A20202020202020202020696620282166696C652E6E616D65';
wwv_flow_api.g_varchar2_table(34) := '202626206D61746368657329207B0A20202020202020202020202076617220657874656E73696F6E203D206D6174636865735B315D3B0A20202020202020202020202066696C652E6E616D65203D2022636C6970626F61726422202B2069202B20222E22';
wwv_flow_api.g_varchar2_table(35) := '202B20657874656E73696F6E3B0A202020202020202020207D0A0A2020202020202020202066696C65732E707573682866696C65293B0A20202020202020207D0A2020202020207D0A0A2020202020206966202866696C65732E6C656E67746829207B0A';
wwv_flow_api.g_varchar2_table(36) := '202020202020202070726F6365737346696C654C69737428652C2066696C65732C20696E7374616E63654F7074696F6E73293B0A2020202020202020652E70726576656E7444656661756C7428293B0A2020202020202020652E73746F7050726F706167';
wwv_flow_api.g_varchar2_table(37) := '6174696F6E28293B0A2020202020207D0A202020207D0A20207D0A0A20202F2F207365747570496E7075743A2062696E642074686520276368616E676527206576656E7420746F20616E20696E7075745B747970653D66696C655D0A202066756E637469';
wwv_flow_api.g_varchar2_table(38) := '6F6E207365747570496E70757428696E7075742C206F70747329207B0A0A20202020696620282146696C655265616465724A532E656E61626C656429207B0A20202020202072657475726E3B0A202020207D0A2020202076617220696E7374616E63654F';
wwv_flow_api.g_varchar2_table(39) := '7074696F6E73203D20657874656E6428657874656E64287B7D2C2046696C655265616465724A532E6F707473292C206F707473293B0A0A20202020696E7075742E6164644576656E744C697374656E657228226368616E6765222C20696E707574436861';
wwv_flow_api.g_varchar2_table(40) := '6E67652C2066616C7365293B0A20202020696E7075742E6164644576656E744C697374656E6572282264726F70222C20696E70757444726F702C2066616C7365293B0A0A2020202066756E6374696F6E20696E7075744368616E6765286529207B0A2020';
wwv_flow_api.g_varchar2_table(41) := '2020202070726F6365737346696C654C69737428652C20696E7075742E66696C65732C20696E7374616E63654F7074696F6E73293B0A202020207D0A0A2020202066756E6374696F6E20696E70757444726F70286529207B0A202020202020652E73746F';
wwv_flow_api.g_varchar2_table(42) := '7050726F7061676174696F6E28293B0A202020202020652E70726576656E7444656661756C7428293B0A20202020202070726F6365737346696C654C69737428652C20652E646174615472616E736665722E66696C65732C20696E7374616E63654F7074';
wwv_flow_api.g_varchar2_table(43) := '696F6E73293B0A202020207D0A20207D0A0A20202F2F20736574757044726F703A2062696E6420746865202764726F7027206576656E7420666F72206120444F4D20656C656D656E740A202066756E6374696F6E20736574757044726F702864726F7062';
wwv_flow_api.g_varchar2_table(44) := '6F782C206F70747329207B0A0A20202020696620282146696C655265616465724A532E656E61626C656429207B0A20202020202072657475726E3B0A202020207D0A2020202076617220696E7374616E63654F7074696F6E73203D20657874656E642865';
wwv_flow_api.g_varchar2_table(45) := '7874656E64287B7D2C2046696C655265616465724A532E6F707473292C206F707473293B0A202020207661722064726167436C617373203D20696E7374616E63654F7074696F6E732E64726167436C6173733B0A2020202076617220696E697469616C69';
wwv_flow_api.g_varchar2_table(46) := '7A65644F6E426F6479203D2066616C73653B0A0A202020202F2F2042696E642064726167206576656E747320746F207468652064726F70626F7820746F206164642074686520636C617373207768696C65206472616767696E672C20616E642061636365';
wwv_flow_api.g_varchar2_table(47) := '7074207468652064726F702064617461207472616E736665722E0A2020202064726F70626F782E6164644576656E744C697374656E6572282264726167656E746572222C206F6E6C795769746846696C65732864726167656E746572292C2066616C7365';
wwv_flow_api.g_varchar2_table(48) := '293B0A2020202064726F70626F782E6164644576656E744C697374656E65722822647261676C65617665222C206F6E6C795769746846696C657328647261676C65617665292C2066616C7365293B0A2020202064726F70626F782E6164644576656E744C';
wwv_flow_api.g_varchar2_table(49) := '697374656E65722822647261676F766572222C206F6E6C795769746846696C657328647261676F766572292C2066616C7365293B0A2020202064726F70626F782E6164644576656E744C697374656E6572282264726F70222C206F6E6C79576974684669';
wwv_flow_api.g_varchar2_table(50) := '6C65732864726F70292C2066616C7365293B0A0A202020202F2F2042696E6420746F20626F647920746F2070726576656E74207468652064726F70626F78206576656E74732066726F6D20666972696E67207768656E2069742077617320696E69746961';
wwv_flow_api.g_varchar2_table(51) := '6C697A6564206F6E2074686520706167652E0A20202020646F63756D656E742E626F64792E6164644576656E744C697374656E65722822647261677374617274222C20626F64796472616773746172742C2074727565293B0A20202020646F63756D656E';
wwv_flow_api.g_varchar2_table(52) := '742E626F64792E6164644576656E744C697374656E6572282264726167656E64222C20626F647964726167656E642C2074727565293B0A20202020646F63756D656E742E626F64792E6164644576656E744C697374656E6572282264726F70222C20626F';
wwv_flow_api.g_varchar2_table(53) := '647964726F702C2066616C7365293B0A0A2020202066756E6374696F6E20626F647964726167656E64286529207B0A202020202020696E697469616C697A65644F6E426F6479203D2066616C73653B0A202020207D0A0A2020202066756E6374696F6E20';
wwv_flow_api.g_varchar2_table(54) := '626F6479647261677374617274286529207B0A202020202020696E697469616C697A65644F6E426F6479203D20747275653B0A202020207D0A0A2020202066756E6374696F6E20626F647964726F70286529207B0A20202020202069662028652E646174';
wwv_flow_api.g_varchar2_table(55) := '615472616E736665722E66696C657320262620652E646174615472616E736665722E66696C65732E6C656E67746829207B0A2020202020202020652E73746F7050726F7061676174696F6E28293B0A2020202020202020652E70726576656E7444656661';
wwv_flow_api.g_varchar2_table(56) := '756C7428293B0A2020202020207D0A202020207D0A0A2020202066756E6374696F6E206F6E6C795769746846696C657328666E29207B0A20202020202072657475726E2066756E6374696F6E2829207B0A20202020202020206966202821696E69746961';
wwv_flow_api.g_varchar2_table(57) := '6C697A65644F6E426F647929207B0A20202020202020202020666E2E6170706C7928746869732C20617267756D656E7473293B0A20202020202020207D0A2020202020207D3B0A202020207D0A0A2020202066756E6374696F6E2064726F70286529207B';
wwv_flow_api.g_varchar2_table(58) := '0A202020202020652E73746F7050726F7061676174696F6E28293B0A202020202020652E70726576656E7444656661756C7428293B0A2020202020206966202864726167436C61737329207B0A202020202020202072656D6F7665436C6173732864726F';
wwv_flow_api.g_varchar2_table(59) := '70626F782C2064726167436C617373293B0A2020202020207D0A20202020202070726F6365737346696C654C69737428652C20652E646174615472616E736665722E66696C65732C20696E7374616E63654F7074696F6E73293B0A202020207D0A0A2020';
wwv_flow_api.g_varchar2_table(60) := '202066756E6374696F6E2064726167656E746572286529207B0A202020202020652E73746F7050726F7061676174696F6E28293B0A202020202020652E70726576656E7444656661756C7428293B0A2020202020206966202864726167436C6173732920';
wwv_flow_api.g_varchar2_table(61) := '7B0A2020202020202020616464436C6173732864726F70626F782C2064726167436C617373293B0A2020202020207D0A202020207D0A0A2020202066756E6374696F6E20647261676C65617665286529207B0A2020202020206966202864726167436C61';
wwv_flow_api.g_varchar2_table(62) := '737329207B0A202020202020202072656D6F7665436C6173732864726F70626F782C2064726167436C617373293B0A2020202020207D0A202020207D0A0A2020202066756E6374696F6E20647261676F766572286529207B0A202020202020652E73746F';
wwv_flow_api.g_varchar2_table(63) := '7050726F7061676174696F6E28293B0A202020202020652E70726576656E7444656661756C7428293B0A2020202020206966202864726167436C61737329207B0A2020202020202020616464436C6173732864726F70626F782C2064726167436C617373';
wwv_flow_api.g_varchar2_table(64) := '293B0A2020202020207D0A202020207D0A20207D0A0A20202F2F207365747570437573746F6D46696C6550726F706572746965733A206D6F64696679207468652066696C65206F626A65637420776974682065787472612070726F706572746965730A20';
wwv_flow_api.g_varchar2_table(65) := '2066756E6374696F6E207365747570437573746F6D46696C6550726F706572746965732866696C65732C2067726F7570494429207B0A20202020666F7220287661722069203D20303B2069203C2066696C65732E6C656E6774683B20692B2B29207B0A20';
wwv_flow_api.g_varchar2_table(66) := '20202020207661722066696C65203D2066696C65735B695D3B0A20202020202066696C652E6578747261203D207B0A20202020202020206E616D654E6F457874656E73696F6E3A2066696C652E6E616D652E737562737472696E6728302C2066696C652E';
wwv_flow_api.g_varchar2_table(67) := '6E616D652E6C617374496E6465784F6628272E2729292C0A2020202020202020657874656E73696F6E3A2066696C652E6E616D652E737562737472696E672866696C652E6E616D652E6C617374496E6465784F6628272E2729202B2031292C0A20202020';
wwv_flow_api.g_varchar2_table(68) := '2020202066696C6549443A20692C0A2020202020202020756E6971756549443A20676574556E69717565494428292C0A202020202020202067726F757049443A2067726F757049442C0A202020202020202070726574747953697A653A20707265747479';
wwv_flow_api.g_varchar2_table(69) := '53697A652866696C652E73697A65290A2020202020207D3B0A202020207D0A20207D0A0A20202F2F206765745265616441734D6574686F643A2072657475726E206D6574686F64206E616D6520666F7220277265616441732A27202D20687474703A2F2F';
wwv_flow_api.g_varchar2_table(70) := '7777772E77332E6F72672F54522F46696C654150492F2372656164696E672D612D66696C650A202066756E6374696F6E206765745265616441734D6574686F6428747970652C207265616441734D61702C2072656164417344656661756C7429207B0A20';
wwv_flow_api.g_varchar2_table(71) := '202020666F722028766172207220696E207265616441734D617029207B0A20202020202069662028747970652E6D61746368286E6577205265674578702872292929207B0A202020202020202072657475726E202772656164417327202B207265616441';
wwv_flow_api.g_varchar2_table(72) := '734D61705B725D3B0A2020202020207D0A202020207D0A2020202072657475726E202772656164417327202B2072656164417344656661756C743B0A20207D0A0A20202F2F2070726F6365737346696C654C6973743A2072656164207468652066696C65';
wwv_flow_api.g_varchar2_table(73) := '7320776974682046696C655265616465722C2073656E64206F666620637573746F6D206576656E74732E0A202066756E6374696F6E2070726F6365737346696C654C69737428652C2066696C65732C206F70747329207B0A0A202020207661722066696C';
wwv_flow_api.g_varchar2_table(74) := '65734C656674203D2066696C65732E6C656E6774683B0A202020207661722067726F7570203D207B0A20202020202067726F757049443A2067657447726F7570494428292C0A20202020202066696C65733A2066696C65732C0A20202020202073746172';
wwv_flow_api.g_varchar2_table(75) := '7465643A206E6577204461746528290A202020207D3B0A0A2020202066756E6374696F6E2067726F7570456E642829207B0A20202020202067726F75702E656E646564203D206E6577204461746528293B0A2020202020206F7074732E6F6E2E67726F75';
wwv_flow_api.g_varchar2_table(76) := '70656E642867726F7570293B0A202020207D0A0A2020202066756E6374696F6E2067726F757046696C65446F6E652829207B0A202020202020696620282D2D66696C65734C656674203D3D3D203029207B0A202020202020202067726F7570456E642829';
wwv_flow_api.g_varchar2_table(77) := '3B0A2020202020207D0A202020207D0A0A2020202046696C655265616465724A532E6F75747075742E707573682867726F7570293B0A202020207365747570437573746F6D46696C6550726F706572746965732866696C65732C2067726F75702E67726F';
wwv_flow_api.g_varchar2_table(78) := '75704944293B0A0A202020206F7074732E6F6E2E67726F757073746172742867726F7570293B0A0A202020202F2F204E6F2066696C657320696E2067726F7570202D20656E6420696D6D6564696174656C790A20202020696620282166696C65732E6C65';
wwv_flow_api.g_varchar2_table(79) := '6E67746829207B0A20202020202067726F7570456E6428293B0A20202020202072657475726E3B0A202020207D0A0A2020202076617220737570706F72747353796E63203D2073796E632026262046696C6552656164657253796E63537570706F72743B';
wwv_flow_api.g_varchar2_table(80) := '0A202020207661722073796E63576F726B65723B0A0A202020202F2F204F6E6C7920696E697469616C697A65207468652073796E6368726F6E6F757320776F726B657220696620746865206F7074696F6E20697320656E61626C6564202D20746F207072';
wwv_flow_api.g_varchar2_table(81) := '6576656E7420746865206F766572686561640A2020202069662028737570706F72747353796E6329207B0A20202020202073796E63576F726B6572203D206D616B65576F726B657228776F726B6572536372697074293B0A20202020202073796E63576F';
wwv_flow_api.g_varchar2_table(82) := '726B65722E6F6E6D657373616765203D2066756E6374696F6E286529207B0A20202020202020207661722066696C65203D20652E646174612E66696C653B0A202020202020202076617220726573756C74203D20652E646174612E726573756C743B0A0A';
wwv_flow_api.g_varchar2_table(83) := '20202020202020202F2F20576F726B657273207365656D20746F206C6F73652074686520637573746F6D2070726F7065727479206F6E207468652066696C65206F626A6563742E0A2020202020202020696620282166696C652E657874726129207B0A20';
wwv_flow_api.g_varchar2_table(84) := '20202020202020202066696C652E6578747261203D20652E646174612E65787472613B0A20202020202020207D0A0A202020202020202066696C652E65787472612E656E646564203D206E6577204461746528293B0A0A20202020202020202F2F204361';
wwv_flow_api.g_varchar2_table(85) := '6C6C206572726F72206F72206C6F6164206576656E7420646570656E64696E67206F6E2073756363657373206F662074686520726561642066726F6D2074686520776F726B65722E0A20202020202020206F7074732E6F6E5B726573756C74203D3D3D20';
wwv_flow_api.g_varchar2_table(86) := '226572726F7222203F20226572726F7222203A20226C6F6164225D287B0A202020202020202020207461726765743A207B0A202020202020202020202020726573756C743A20726573756C740A202020202020202020207D0A20202020202020207D2C20';
wwv_flow_api.g_varchar2_table(87) := '66696C65293B0A202020202020202067726F757046696C65446F6E6528293B0A2020202020207D3B0A202020207D0A0A2020202041727261792E70726F746F747970652E666F72456163682E63616C6C2866696C65732C2066756E6374696F6E2866696C';
wwv_flow_api.g_varchar2_table(88) := '6529207B0A0A20202020202066696C652E65787472612E73746172746564203D206E6577204461746528293B0A0A202020202020696620286F7074732E616363657074202626202166696C652E747970652E6D61746368286E657720526567457870286F';
wwv_flow_api.g_varchar2_table(89) := '7074732E616363657074292929207B0A20202020202020206F7074732E6F6E2E736B69702866696C65293B0A202020202020202067726F757046696C65446F6E6528293B0A202020202020202072657475726E3B0A2020202020207D0A0A202020202020';
wwv_flow_api.g_varchar2_table(90) := '696620286F7074732E6F6E2E6265666F726573746172742866696C6529203D3D3D2066616C736529207B0A20202020202020206F7074732E6F6E2E736B69702866696C65293B0A202020202020202067726F757046696C65446F6E6528293B0A20202020';
wwv_flow_api.g_varchar2_table(91) := '2020202072657475726E3B0A2020202020207D0A0A20202020202076617220726561644173203D206765745265616441734D6574686F642866696C652E747970652C206F7074732E7265616441734D61702C206F7074732E72656164417344656661756C';
wwv_flow_api.g_varchar2_table(92) := '74293B0A0A2020202020206966202873796E63576F726B657229207B0A202020202020202073796E63576F726B65722E706F73744D657373616765287B0A2020202020202020202066696C653A2066696C652C0A2020202020202020202065787472613A';
wwv_flow_api.g_varchar2_table(93) := '2066696C652E65787472612C0A202020202020202020207265616441733A207265616441730A20202020202020207D293B0A2020202020207D20656C7365207B0A0A202020202020202076617220726561646572203D206E65772046696C655265616465';
wwv_flow_api.g_varchar2_table(94) := '7228293B0A20202020202020207265616465722E6F726967696E616C4576656E74203D20653B0A0A202020202020202066696C655265616465724576656E74732E666F72456163682866756E6374696F6E286576656E744E616D6529207B0A2020202020';
wwv_flow_api.g_varchar2_table(95) := '20202020207265616465725B276F6E27202B206576656E744E616D655D203D2066756E6374696F6E286529207B0A202020202020202020202020696620286576656E744E616D65203D3D20276C6F616427207C7C206576656E744E616D65203D3D202765';
wwv_flow_api.g_varchar2_table(96) := '72726F722729207B0A202020202020202020202020202066696C652E65787472612E656E646564203D206E6577204461746528293B0A2020202020202020202020207D0A2020202020202020202020206F7074732E6F6E5B6576656E744E616D655D2865';
wwv_flow_api.g_varchar2_table(97) := '2C2066696C65293B0A202020202020202020202020696620286576656E744E616D65203D3D20276C6F6164656E642729207B0A202020202020202020202020202067726F757046696C65446F6E6528293B0A2020202020202020202020207D0A20202020';
wwv_flow_api.g_varchar2_table(98) := '2020202020207D3B0A20202020202020207D293B0A20202020202020207265616465725B7265616441735D2866696C65293B0A2020202020207D0A202020207D293B0A20207D0A0A20202F2F20636865636B46696C6552656164657253796E6353757070';
wwv_flow_api.g_varchar2_table(99) := '6F72743A2043726561746520612074656D706F7261727920776F726B657220616E64207365652069662046696C6552656164657253796E63206578697374730A202066756E6374696F6E20636865636B46696C6552656164657253796E63537570706F72';
wwv_flow_api.g_varchar2_table(100) := '742829207B0A2020202076617220776F726B6572203D206D616B65576F726B65722873796E63446574656374696F6E536372697074293B0A2020202069662028776F726B657229207B0A202020202020776F726B65722E6F6E6D657373616765203D2066';
wwv_flow_api.g_varchar2_table(101) := '756E6374696F6E286529207B0A202020202020202046696C6552656164657253796E63537570706F7274203D20652E646174613B0A2020202020207D3B0A202020202020776F726B65722E706F73744D657373616765287B7D293B0A202020207D0A2020';
wwv_flow_api.g_varchar2_table(102) := '7D0A0A20202F2F206E6F6F703A20646F206E6F7468696E670A202066756E6374696F6E206E6F6F702829207B0A0A20207D0A0A20202F2F20657874656E643A207573656420746F206D616B65206465657020636F70696573206F66206F7074696F6E7320';
wwv_flow_api.g_varchar2_table(103) := '6F626A6563740A202066756E6374696F6E20657874656E642864657374696E6174696F6E2C20736F7572636529207B0A20202020666F7220287661722070726F706572747920696E20736F7572636529207B0A20202020202069662028736F757263655B';
wwv_flow_api.g_varchar2_table(104) := '70726F70657274795D20262620736F757263655B70726F70657274795D2E636F6E7374727563746F722026260A2020202020202020736F757263655B70726F70657274795D2E636F6E7374727563746F72203D3D3D204F626A65637429207B0A20202020';
wwv_flow_api.g_varchar2_table(105) := '2020202064657374696E6174696F6E5B70726F70657274795D203D2064657374696E6174696F6E5B70726F70657274795D207C7C207B7D3B0A2020202020202020617267756D656E74732E63616C6C65652864657374696E6174696F6E5B70726F706572';
wwv_flow_api.g_varchar2_table(106) := '74795D2C20736F757263655B70726F70657274795D293B0A2020202020207D20656C7365207B0A202020202020202064657374696E6174696F6E5B70726F70657274795D203D20736F757263655B70726F70657274795D3B0A2020202020207D0A202020';
wwv_flow_api.g_varchar2_table(107) := '207D0A2020202072657475726E2064657374696E6174696F6E3B0A20207D0A0A20202F2F20686173436C6173733A20646F657320616E20656C656D656E742068617665207468652063737320636C6173733F0A202066756E6374696F6E20686173436C61';
wwv_flow_api.g_varchar2_table(108) := '737328656C2C206E616D6529207B0A2020202072657475726E206E6577205265674578702822283F3A5E7C5C5C732B2922202B206E616D65202B2022283F3A5C5C732B7C242922292E7465737428656C2E636C6173734E616D65293B0A20207D0A0A2020';
wwv_flow_api.g_varchar2_table(109) := '2F2F20616464436C6173733A20616464207468652063737320636C61737320666F722074686520656C656D656E742E0A202066756E6374696F6E20616464436C61737328656C2C206E616D6529207B0A202020206966202821686173436C61737328656C';
wwv_flow_api.g_varchar2_table(110) := '2C206E616D652929207B0A202020202020656C2E636C6173734E616D65203D20656C2E636C6173734E616D65203F205B656C2E636C6173734E616D652C206E616D655D2E6A6F696E2827202729203A206E616D653B0A202020207D0A20207D0A0A20202F';
wwv_flow_api.g_varchar2_table(111) := '2F2072656D6F7665436C6173733A2072656D6F7665207468652063737320636C6173732066726F6D2074686520656C656D656E742E0A202066756E6374696F6E2072656D6F7665436C61737328656C2C206E616D6529207B0A2020202069662028686173';
wwv_flow_api.g_varchar2_table(112) := '436C61737328656C2C206E616D652929207B0A2020202020207661722063203D20656C2E636C6173734E616D653B0A202020202020656C2E636C6173734E616D65203D20632E7265706C616365286E6577205265674578702822283F3A5E7C5C5C732B29';
wwv_flow_api.g_varchar2_table(113) := '22202B206E616D65202B2022283F3A5C5C732B7C2429222C20226722292C20222022292E7265706C616365282F5E5C735C732A2F2C202727292E7265706C616365282F5C735C732A242F2C202727293B0A202020207D0A20207D0A0A20202F2F20707265';
wwv_flow_api.g_varchar2_table(114) := '74747953697A653A20636F6E7665727420627974657320746F2061206D6F7265207265616461626C6520737472696E672E0A202066756E6374696F6E2070726574747953697A6528627974657329207B0A202020207661722073203D205B276279746573';
wwv_flow_api.g_varchar2_table(115) := '272C20276B62272C20274D42272C20274742272C20275442272C20275042275D3B0A202020207661722065203D204D6174682E666C6F6F72284D6174682E6C6F6728627974657329202F204D6174682E6C6F67283130323429293B0A2020202072657475';
wwv_flow_api.g_varchar2_table(116) := '726E20286279746573202F204D6174682E706F7728313032342C204D6174682E666C6F6F7228652929292E746F4669786564283229202B20222022202B20735B655D3B0A20207D0A0A20202F2F2067657447726F757049443A2067656E65726174652061';
wwv_flow_api.g_varchar2_table(117) := '20756E6971756520696E7420494420666F722067726F7570732E0A20207661722067657447726F75704944203D202866756E6374696F6E28696429207B0A2020202072657475726E2066756E6374696F6E2829207B0A20202020202072657475726E2069';
wwv_flow_api.g_varchar2_table(118) := '642B2B3B0A202020207D3B0A20207D292830293B0A0A20202F2F20676574556E6971756549443A2067656E6572617465206120756E6971756520696E7420494420666F722066696C65730A202076617220676574556E697175654944203D202866756E63';
wwv_flow_api.g_varchar2_table(119) := '74696F6E28696429207B0A2020202072657475726E2066756E6374696F6E2829207B0A20202020202072657475726E2069642B2B3B0A202020207D3B0A20207D292830293B0A0A20202F2F2054686520696E7465726661636520697320737570706F7274';
wwv_flow_api.g_varchar2_table(120) := '65642C2062696E64207468652046696C655265616465724A532063616C6C6261636B730A202046696C655265616465724A532E656E61626C6564203D20747275653B0A0A7D2928746869732C20646F63756D656E74293B0A';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72364064162797270)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'js/filereader.js'
,p_mime_type=>'application/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2166756E6374696F6E28652C74297B66756E6374696F6E206E2874297B766172206E3D652E55524C7C7C652E7765626B697455524C2C613D652E426C6F622C723D652E576F726B65723B69662821286E262661262672262674292972657475726E206E75';
wwv_flow_api.g_varchar2_table(2) := '6C6C3B766172206F3D6E65772061285B745D292C733D6E65772072286E2E6372656174654F626A65637455524C286F29293B72657475726E20737D66756E6374696F6E206128652C74297B66756E6374696F6E206E2865297B666F722876617220743D5B';
wwv_flow_api.g_varchar2_table(3) := '5D2C6E3D652E636C6970626F617264446174617C7C7B7D2C723D6E2E6974656D737C7C5B5D2C6F3D303B6F3C722E6C656E6774683B6F2B2B297B76617220733D725B6F5D2E676574417346696C6528293B69662873297B76617220693D6E657720526567';
wwv_flow_api.g_varchar2_table(4) := '45787028222F282E2A2922292E6578656328732E74797065293B69662821732E6E616D65262669297B76617220753D695B315D3B732E6E616D653D22636C6970626F617264222B6F2B222E222B757D742E707573682873297D7D742E6C656E6774682626';
wwv_flow_api.g_varchar2_table(5) := '286428652C742C61292C652E70726576656E7444656661756C7428292C652E73746F7050726F7061676174696F6E2829297D696628452E656E61626C6564297B76617220613D632863287B7D2C452E6F707473292C74293B652E6164644576656E744C69';
wwv_flow_api.g_varchar2_table(6) := '7374656E657228227061737465222C6E2C2131297D7D66756E6374696F6E207228652C74297B66756E6374696F6E206E2874297B6428742C652E66696C65732C72297D66756E6374696F6E20612865297B652E73746F7050726F7061676174696F6E2829';
wwv_flow_api.g_varchar2_table(7) := '2C652E70726576656E7444656661756C7428292C6428652C652E646174615472616E736665722E66696C65732C72297D696628452E656E61626C6564297B76617220723D632863287B7D2C452E6F707473292C74293B652E6164644576656E744C697374';
wwv_flow_api.g_varchar2_table(8) := '656E657228226368616E6765222C6E2C2131292C652E6164644576656E744C697374656E6572282264726F70222C612C2131297D7D66756E6374696F6E206F28652C6E297B66756E6374696F6E20612865297B623D21317D66756E6374696F6E20722865';
wwv_flow_api.g_varchar2_table(9) := '297B623D21307D66756E6374696F6E206F2865297B652E646174615472616E736665722E66696C65732626652E646174615472616E736665722E66696C65732E6C656E677468262628652E73746F7050726F7061676174696F6E28292C652E7072657665';
wwv_flow_api.g_varchar2_table(10) := '6E7444656661756C742829297D66756E6374696F6E20732865297B72657475726E2066756E6374696F6E28297B627C7C652E6170706C7928746869732C617267756D656E7473297D7D66756E6374696F6E20692874297B742E73746F7050726F70616761';
wwv_flow_api.g_varchar2_table(11) := '74696F6E28292C742E70726576656E7444656661756C7428292C6826266728652C68292C6428742C742E646174615472616E736665722E66696C65732C76297D66756E6374696F6E20752874297B742E73746F7050726F7061676174696F6E28292C742E';
wwv_flow_api.g_varchar2_table(12) := '70726576656E7444656661756C7428292C6826267028652C68297D66756E6374696F6E20662874297B6826266728652C68297D66756E6374696F6E206C2874297B742E73746F7050726F7061676174696F6E28292C742E70726576656E7444656661756C';
wwv_flow_api.g_varchar2_table(13) := '7428292C6826267028652C68297D696628452E656E61626C6564297B76617220763D632863287B7D2C452E6F707473292C6E292C683D762E64726167436C6173732C623D21313B652E6164644576656E744C697374656E6572282264726167656E746572';
wwv_flow_api.g_varchar2_table(14) := '222C732875292C2131292C652E6164644576656E744C697374656E65722822647261676C65617665222C732866292C2131292C652E6164644576656E744C697374656E65722822647261676F766572222C73286C292C2131292C652E6164644576656E74';
wwv_flow_api.g_varchar2_table(15) := '4C697374656E6572282264726F70222C732869292C2131292C742E626F64792E6164644576656E744C697374656E65722822647261677374617274222C722C2130292C742E626F64792E6164644576656E744C697374656E6572282264726167656E6422';
wwv_flow_api.g_varchar2_table(16) := '2C612C2130292C742E626F64792E6164644576656E744C697374656E6572282264726F70222C6F2C2131297D7D66756E6374696F6E207328652C74297B666F7228766172206E3D303B6E3C652E6C656E6774683B6E2B2B297B76617220613D655B6E5D3B';
wwv_flow_api.g_varchar2_table(17) := '612E65787472613D7B6E616D654E6F457874656E73696F6E3A612E6E616D652E737562737472696E6728302C612E6E616D652E6C617374496E6465784F6628222E2229292C657874656E73696F6E3A612E6E616D652E737562737472696E6728612E6E61';
wwv_flow_api.g_varchar2_table(18) := '6D652E6C617374496E6465784F6628222E22292B31292C66696C6549443A6E2C756E6971756549443A4C28292C67726F757049443A742C70726574747953697A653A7628612E73697A65297D7D7D66756E6374696F6E206928652C742C6E297B666F7228';
wwv_flow_api.g_varchar2_table(19) := '766172206120696E207429696628652E6D61746368286E657720526567457870286129292972657475726E22726561644173222B745B615D3B72657475726E22726561644173222B6E7D66756E6374696F6E206428652C742C61297B66756E6374696F6E';
wwv_flow_api.g_varchar2_table(20) := '207228297B752E656E6465643D6E657720446174652C612E6F6E2E67726F7570656E642875297D66756E6374696F6E206F28297B303D3D3D2D2D6426267228297D76617220643D742E6C656E6774682C753D7B67726F757049443A7728292C66696C6573';
wwv_flow_api.g_varchar2_table(21) := '3A742C737461727465643A6E657720446174657D3B696628452E6F75747075742E707573682875292C7328742C752E67726F75704944292C612E6F6E2E67726F757073746172742875292C21742E6C656E6774682972657475726E20766F696420722829';
wwv_flow_api.g_varchar2_table(22) := '3B76617220662C633D442626623B63262628663D6E2878292C662E6F6E6D6573736167653D66756E6374696F6E2865297B76617220743D652E646174612E66696C652C6E3D652E646174612E726573756C743B742E65787472617C7C28742E6578747261';
wwv_flow_api.g_varchar2_table(23) := '3D652E646174612E6578747261292C742E65787472612E656E6465643D6E657720446174652C612E6F6E5B226572726F72223D3D3D6E3F226572726F72223A226C6F6164225D287B7461726765743A7B726573756C743A6E7D7D2C74292C6F28297D292C';
wwv_flow_api.g_varchar2_table(24) := '41727261792E70726F746F747970652E666F72456163682E63616C6C28742C66756E6374696F6E2874297B696628742E65787472612E737461727465643D6E657720446174652C612E616363657074262621742E747970652E6D61746368286E65772052';
wwv_flow_api.g_varchar2_table(25) := '656745787028612E61636365707429292972657475726E20612E6F6E2E736B69702874292C766F6964206F28293B696628612E6F6E2E6265666F726573746172742874293D3D3D21312972657475726E20612E6F6E2E736B69702874292C766F6964206F';
wwv_flow_api.g_varchar2_table(26) := '28293B766172206E3D6928742E747970652C612E7265616441734D61702C612E72656164417344656661756C74293B6966286629662E706F73744D657373616765287B66696C653A742C65787472613A742E65787472612C7265616441733A6E7D293B65';
wwv_flow_api.g_varchar2_table(27) := '6C73657B76617220723D6E657720683B722E6F726967696E616C4576656E743D652C792E666F72456163682866756E6374696F6E2865297B725B226F6E222B655D3D66756E6374696F6E286E297B226C6F616422213D652626226572726F7222213D657C';
wwv_flow_api.g_varchar2_table(28) := '7C28742E65787472612E656E6465643D6E65772044617465292C612E6F6E5B655D286E2C74292C226C6F6164656E64223D3D6526266F28297D7D292C725B6E5D2874297D7D297D66756E6374696F6E207528297B76617220653D6E286D293B6526262865';
wwv_flow_api.g_varchar2_table(29) := '2E6F6E6D6573736167653D66756E6374696F6E2865297B623D652E646174617D2C652E706F73744D657373616765287B7D29297D66756E6374696F6E206628297B7D66756E6374696F6E206328652C74297B666F7228766172206E20696E207429745B6E';
wwv_flow_api.g_varchar2_table(30) := '5D2626745B6E5D2E636F6E7374727563746F722626745B6E5D2E636F6E7374727563746F723D3D3D4F626A6563743F28655B6E5D3D655B6E5D7C7C7B7D2C617267756D656E74732E63616C6C656528655B6E5D2C745B6E5D29293A655B6E5D3D745B6E5D';
wwv_flow_api.g_varchar2_table(31) := '3B72657475726E20657D66756E6374696F6E206C28652C74297B72657475726E206E6577205265674578702822283F3A5E7C5C5C732B29222B742B22283F3A5C5C732B7C242922292E7465737428652E636C6173734E616D65297D66756E6374696F6E20';
wwv_flow_api.g_varchar2_table(32) := '7028652C74297B6C28652C74297C7C28652E636C6173734E616D653D652E636C6173734E616D653F5B652E636C6173734E616D652C745D2E6A6F696E28222022293A74297D66756E6374696F6E206728652C74297B6966286C28652C7429297B76617220';
wwv_flow_api.g_varchar2_table(33) := '6E3D652E636C6173734E616D653B652E636C6173734E616D653D6E2E7265706C616365286E6577205265674578702822283F3A5E7C5C5C732B29222B742B22283F3A5C5C732B7C2429222C226722292C222022292E7265706C616365282F5E5C735C732A';
wwv_flow_api.g_varchar2_table(34) := '2F2C2222292E7265706C616365282F5C735C732A242F2C2222297D7D66756E6374696F6E20762865297B76617220743D5B226279746573222C226B62222C224D42222C224742222C225442222C225042225D2C6E3D4D6174682E666C6F6F72284D617468';
wwv_flow_api.g_varchar2_table(35) := '2E6C6F672865292F4D6174682E6C6F67283130323429293B72657475726E28652F4D6174682E706F7728313032342C4D6174682E666C6F6F72286E2929292E746F46697865642832292B2220222B745B6E5D7D76617220683D652E46696C655265616465';
wwv_flow_api.g_varchar2_table(36) := '722C623D21312C783D2273656C662E6164644576656E744C697374656E657228276D657373616765272C2066756E6374696F6E286529207B2076617220646174613D652E646174613B20747279207B2076617220726561646572203D206E65772046696C';
wwv_flow_api.g_varchar2_table(37) := '6552656164657253796E633B20706F73744D657373616765287B20726573756C743A207265616465725B646174612E7265616441735D28646174612E66696C65292C2065787472613A20646174612E65787472612C2066696C653A20646174612E66696C';
wwv_flow_api.g_varchar2_table(38) := '657D297D2063617463682865297B20706F73744D657373616765287B20726573756C743A276572726F72272C2065787472613A646174612E65787472612C2066696C653A646174612E66696C657D293B207D207D2C2066616C7365293B222C6D3D226F6E';
wwv_flow_api.g_varchar2_table(39) := '6D657373616765203D2066756E6374696F6E286529207B20706F73744D65737361676528212146696C6552656164657253796E63293B207D3B222C793D5B226C6F61647374617274222C2270726F6772657373222C226C6F6164222C2261626F7274222C';
wwv_flow_api.g_varchar2_table(40) := '226572726F72222C226C6F6164656E64225D2C443D21312C453D652E46696C655265616465724A533D7B656E61626C65643A21312C7365747570496E7075743A722C736574757044726F703A6F2C7365747570436C6970626F6172643A612C7365745379';
wwv_flow_api.g_varchar2_table(41) := '6E633A66756E6374696F6E2865297B443D652C442626216226267528297D2C67657453796E633A66756E6374696F6E28297B72657475726E20442626627D2C6F75747075743A5B5D2C6F7074733A7B64726167436C6173733A2264726167222C61636365';
wwv_flow_api.g_varchar2_table(42) := '70743A21312C72656164417344656661756C743A224461746155524C222C7265616441734D61703A7B7D2C6F6E3A7B6C6F616473746172743A662C70726F67726573733A662C6C6F61643A662C61626F72743A662C6572726F723A662C6C6F6164656E64';
wwv_flow_api.g_varchar2_table(43) := '3A662C736B69703A662C67726F757073746172743A662C67726F7570656E643A662C6265666F726573746172743A667D7D7D3B69662822756E646566696E656422213D747970656F66206A51756572792626286A51756572792E666E2E66696C65526561';
wwv_flow_api.g_varchar2_table(44) := '6465724A533D66756E6374696F6E2865297B72657475726E20746869732E656163682866756E6374696F6E28297B6A51756572792874686973292E69732822696E70757422293F7228746869732C65293A6F28746869732C65297D297D2C6A5175657279';
wwv_flow_api.g_varchar2_table(45) := '2E666E2E66696C65436C6970626F6172643D66756E6374696F6E2865297B72657475726E20746869732E656163682866756E6374696F6E28297B6128746869732C65297D297D292C68297B76617220773D66756E6374696F6E2865297B72657475726E20';
wwv_flow_api.g_varchar2_table(46) := '66756E6374696F6E28297B72657475726E20652B2B7D7D2830292C4C3D66756E6374696F6E2865297B72657475726E2066756E6374696F6E28297B72657475726E20652B2B7D7D2830293B452E656E61626C65643D21307D7D28746869732C646F63756D';
wwv_flow_api.g_varchar2_table(47) := '656E74293B';
null;
end;
/
begin
wwv_flow_api.create_plugin_file(
 p_id=>wwv_flow_api.id(72364425549797274)
,p_plugin_id=>wwv_flow_api.id(136310961796859786)
,p_file_name=>'js/filereader.min.js'
,p_mime_type=>'application/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
end;
/
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false), p_is_component_import => true);
commit;
end;
/
set verify on feedback on define on
prompt  ...done
